// Persistence of Vision RayTracer version 3.1 Scene description file
// File:        LIBRARY.LIB
// Description: This file contains all the parts for Lego(TM) models.
//              This file needs MATERIAL.LIB to be included first in your .POV-file!
//
//              Copyright Anton Raves.
//
//              The current number of pieces in this library: 1025
//
// Date:        2008/11/29
// Author:      Anton Raves
//
// Version:     0535
#macro air_mask(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 8.75*y, 6.1 }
      box { <-4.75, 0, 0> <4.75, 8.76, 10.5> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        #if (setting > 1)
          cylinder { 10.4*z, 11.3*z, 1.25 translate <-2.5, 3.4, 0> }
          cylinder { 10.4*z, 11.3*z, 1.25 translate <2.5, 3.4, 0> }
        #end
        sphere { <-4.75, 5.1, 7.2> 1.2 }
        cylinder { <-4.7, 3.9, 3>, <-4.7, 5.1, 7.2>, 1 }
        sphere { <4.75, 5.1, 7.2> 1.2 }
        cylinder { <4.7, 3.9, 3>, <4.7, 5.1, 7.2>, 1 }
        difference {
          cylinder { 0*y, 8.75*y, 6.1 }
          box { <-1.5, -1, -7> <1.5, 10, 0> }
        }
        difference {
          box { <-4.75, 0, 0> <4.75, 8.76, 10.5> }
          #if (setting > 1)
            box { <-5, -2, 6.5> <5, 3.1, 7.85> }
            difference {
              box { <-3.75, -2, 6.500001> <3.75, 8, 9.5> }
              box { <-10, 0, -20> <10, 10, 20> rotate 18*x translate <0, 7.75, 0> }
            }
          #end
        }
        cylinder { -1.6*x, 1.6*x, 1.5 translate <0, 0.8, -7> }
        difference {
          merge {
            torus { 6.5, 1.2 }
            #local counter = 2;
            #while (counter < 29)
              torus { 1, 0.6 rotate 90*x translate <6.5, 0, 0> rotate (90+12*counter)*y }
              #local counter = counter + 1;
            #end
          }
          cylinder { -3*y, 3*y, 6 }
          box { <-10, -10, 7> <10, 10, 10> }
          translate <0, 0, 6.5>
          rotate -19*x
          translate <0, 0.8, -7>
        }
      }
      difference {
        cylinder { -1*y, 9*y, 6.100001 }
        box { <-11, -20, -30> <11, 0, 10> rotate -19*x translate <0, 4.65, 0> }
        box { <-12, -20, 0> <12, 10, 20> rotate 10*x translate <0, 8.75, -1.5> }
      }
      box { <-10, 0, -20> <10, 10, 20> rotate 18*x translate <0, 8.75, 0> }
      cylinder { -1*y, 10*y, 5.1 }
      box { <-10, -2, 3.5> <10, 0.5, 11> }
      sphere { <-5.7, -1.25, -1> 0.7 }
      sphere { <5.7, -1.25, -1> 0.7 }
      texture { color_tex }
      bounded_by { box { <-7.2, -0.8, -8.6> <7.2, 8.85, 11.4> } }
    }
  #end
#end
#macro air_tanks(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -10.25*y, 0*y, 3 translate <-3, 0, 7> }
      cylinder { -10.25*y, 0*y, 3 translate <3, 0, 7> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          torus { 3.25, 0.75 translate <0, 0.75, 0> }
          box { <-10, -10, -10> <10, 0.75, 10> }
          box { <-5, 0, 0> <0, 2, 7> rotate 5*y }
          box { <0, 0, 0> <5, 2, 7> rotate -5*y }
        }
        difference {
          cylinder { 0*y, 0.750001*y, 4 }
          cylinder { -1*y, 1*y, 2.5 }
          box { <-5, -1, 0> <0, 1, 7> rotate 5*y }
          box { <0, -1, 0> <5, 1, 7> rotate -5*y }
        }
        cylinder { -0.000001*z, 7*z, 0.75 translate <-3.25, 0.75, 0> rotate 5*y }
        cylinder { -0.000001*z, 7*z, 0.75 translate <3.25, 0.75, 0> rotate -5*y }
        box { <-3.999999, 0, -0.000002> <-2.500001, 0.750001, 7> rotate 5*y }
        box { <2.500001, 0, -0.000002> <3.999999, 0.750001, 7> rotate -5*y }
        cylinder { -10.25*y, 0.000001*y, 3.000001 translate <-2.999999, 0, 7> }
        cylinder { -10.25*y, 0.000001*y, 3.000001 translate <2.999999, 0, 7> }
        torus { 2, 1 translate <-2.999999, 0, 7> }
        torus { 2, 1 translate <2.999999, 0, 7> }
        cylinder { 0*y, 1*y, 2.000001 translate <-3, 0, 7> }
        cylinder { 0*y, 1*y, 2.000001 translate <3, 0, 7> }
        cylinder { -5*x, 5*x, 0.75 translate <0, 3, 7> }
        box { <-5.000001, -0.5, 6.250001> <5.000001, 3.000001, 7.749999> }
        #if (setting > 1)
          cylinder { 3*y, 4.5*y, 0.749999 translate <0, 0, 7> }
          cylinder { 0*y, 1.5*y, 0.4 translate <-2.1, 0, 2> }
          cylinder { 0*y, 1.5*y, 0.4 translate <2.1, 0, 2> }
        #end
        difference {
          union {
            cone { 2.5*y, 1, -0.5*y, 1.5 translate <-3, 0, 7> }
            cone { 2.5*y, 1, -0.5*y, 1.5 translate <3, 0, 7> }
          }
          box { <-10, -10, 0> <10, 10, 7> }
        }
      }
      #if (setting > 1)
        box { <-0.2, 4.3, 6> <0.2, 4.7, 8> }
        box { <-1, 4.3, 6.8> <1, 4.7, 7.2> }
        cylinder { -11*y, 0.5*y, 1.4 translate <-3, 0, 7> }
        cylinder { -11*y, 0.5*y, 1.4 translate <3, 0, 7> }
      #end
      texture { color_tex }
      bounded_by { box { <-6.1, -10.35, -4.1> <6.1, 4.75, 10.1> } }
    }
  #end
#end
#macro antenna_1(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 38*y, 1.5 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { 0*y, 3.1*y, 3.2 }
        cylinder { 3*y, 4.9*y, 2.5 }
        cylinder { 4.8*y, 36.5*y, 1.5 }
        sphere { <0, 36.499999, 0> 1.5 }
      }
      #if (setting > 1)
        cylinder { -1*y, 2*y, 2.6 }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 38.1*y, 3.3 } }
    }
  #end
#end
#macro antenna_2(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 75*y, 1.5 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { 0*y, 3.1*y, 3.2 }
        cylinder { 3*y, 12.5*y, 1.5 }
        cone { 12.49999*y, 1.49999, 13.3*y, 0.89999 }
        cylinder { 13.29999*y, 74*y, 0.9 }
        sphere { <0, 75, 0> 1.4 }
      }
      #if (setting > 1)
        cylinder { -1*y, 2*y, 2.6 }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 76.5*y, 3.3 } }
    }
  #end
#end
#macro antenna_3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 9.5*y, 3.9 }
      cylinder { 9*y, 48*y, 1.6 }
      cylinder { -15*x, 15*x, 1.2 translate <0, 48, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 9.4*y, 11.2*y, 2.4 }
        cylinder { 2*y, 9.5*y, 3.9 }
        cylinder { 0*y, 2.5*y, 3.1 }
        cylinder { 9*y, 48*y, 1.6 }
        cylinder { -15*x, 15*x, 1.2 translate <0, 48, 0> }
        sphere { <-15, 48, 0> 1.2 }
        sphere { <15, 48, 0> 1.2 }
        cylinder { -10*z, 10*z, 0.9 translate <5, 48, 0> }
        cylinder { -10*z, 10*z, 0.9 translate <-15, 48, 0> }
        cylinder { -10*z, 10*z, 0.9 translate <-5, 48, 0> }
        cylinder { -10*z, 10*z, 0.9 translate <15, 48, 0> }
      }
      #if (setting > 1)
        cylinder { -0.4*y, 8.6*y, 2.6 }
      #end
      texture { color_tex }
      bounded_by { box { <-16.3, -0.1, -10.1> <16.3, 49.3, 10.1> } }
    }
  #end
#end
#macro arrow_engine1_1(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 9.5*y, 3.9 }
      box { <-7.9, 0.000001, -0.75> <7.9, 9.499999, 0.75> }
      box { <-0.75, 0.000002, -7.9> <0.75, 9.499998, 7.9> }
      texture { color_tex }
    }
  #else      
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
          #else
            object { open_rounded_button() translate <0, 6.4, 0> }
          #end
          cylinder { 2*y, 9.5*y, 3.9 }
          cylinder { 0*y, 2.5*y, 3 }
        }
        #if (setting > 1)
          cylinder { -0.4*y, 8.6*y, 2.5 }
          cylinder { 2*y, 12*y, 1.600001 }
        #end
      }
      difference {
        box { <3.8, 0.000001, -0.75> <7.9, 9.499999, 0.75> }
        box { <0, -50, -10> <50, 50, 10> rotate 32.5*z translate <3.9, 9.5, 0> }
      }
      difference {
        box { <-7.9, 0.000001, -0.75> <-3.8, 9.499999, 0.75> }
        box { <-50, -50, -10> <0, 50, 10> rotate -32.5*z translate <-3.9, 9.5, 0> }
      }
      difference {
        box { <-0.75, 0.000001, -7.9> <0.75, 9.499999, -3.8> }
        box { <-10, -50, -50> <10, 50, 0> rotate 32.5*x translate <0, 9.5, -3.9> }
      }
      difference {
        box { <-0.75, 0.000001, 3.8> <0.75, 9.499999, 7.9> }
        box { <-10, -50, 0> <10, 50, 50> rotate -32.5*x translate <0, 9.5, 3.9> }
      }
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 11.3*y, 8 } }
    }
  #end
#end
#macro arrow_engine2_2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 19.1*y, 7.900001 translate <4, 0, 4> }
      box { <-11.9, 0.000001, 3.25> <19.9, 19, 4.75> }
      box { <3.25, 0.000001, -11.9> <4.75, 19, 19.9> }
      texture { color_tex }
    }
  #else
    merge {
      intersection {
        cylinder { 18*y, 22*y, 7.9 translate <4, 0, 4> }
        merge {
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 }
            cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 19*y, 20.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() translate <0, 16, 0> }
            object { rounded_button() translate <8, 16, 0> }
            object { rounded_button() translate <0, 16, 8> }
            object { rounded_button() translate <8, 16, 8> }
          #end
        }
      }
      difference {
        cylinder { 0*y, 19.1*y, 7.900001 translate <4, 0, 4> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { -1*y, 18.2*y, 6.4 translate <4, 0, 4> }
          box { <3.1, 10, 1.75> <4.9, 20, 6.25> }
          box { <1.75, 10, 3.1> <6.25, 20, 4.9> }
          box { <-6.4, 17, -1> <-4.5, 20, 1> rotate 45*y translate <4, 0, 4> }
          box { <-6.4, 17, -1> <-4.5, 20, 1> rotate 135*y translate <4, 0, 4> }
          box { <-6.4, 17, -1> <-4.5, 20, 1> rotate 225*y translate <4, 0, 4> }
          box { <-6.4, 17, -1> <-4.5, 20, 1> rotate -45*y translate <4, 0, 4> }
        #end
      }
      difference {
        box { <11.8, 0.000001, 3.25> <19.9, 19, 4.75> }
        box { <0, -50, -10> <50, 50, 10> rotate 27*z translate <19.9, 3.2, 0> }
      }
      difference {
        box { <-11.9, 0.000001, 3.25> <-3.8, 19, 4.75> }
        box { <-50, -50, -10> <0, 50, 10> rotate -27*z translate <-11.9, 3, 0> }
      }
      difference {
        box { <3.25, 0.000001, -11.9> <4.75, 19, -3.8> }
        box { <-10, -50, -50> <10, 50, 0> rotate 27*x translate <0, 3.2, -11.9> }
      }
      difference {
        box { <3.25, 0.000001, 11.8> <4.75, 19, 19.9> }
        box { <-10, -50, 0> <10, 50, 50> rotate -27*x translate <0, 3, 19.9> }
      }
      object { high_ring() scale <1, 2.103448, 1> translate <4, 0, 4> }
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 20.9*y, 16 translate <4, 0, 4> } }
    }
  #end
#end
#macro axe(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 21*y, 1.5 }
      box { <-6.75, 19, -1> <2.75, 25.5, 1> }
      texture { color_tex }
    }
  #else
    merge {
      sphere { <0, 1, 0> 1 scale <1.500001, 1, 1.500001> }
      difference {
        cylinder { 0.999999*y, 21*y, 1.5 }
        box { <-10, 0, -10> <10, 20, 0> rotate 6*x translate <0, 14, -1.5> }
        box { <-10, 0, 0> <10, 20, 10> rotate -6*x translate <0, 14, 1.5> }
      }
      difference {
        box { <-6.75, 19, -1> <2.75, 25.5, 1> }
        box { <0, 0, -2> <10, 3, 2> rotate -7*z translate <-6.75, 25.5, 0> }
        box { <0, -3, -2> <10, 0, 2> rotate 7*z translate <-6.75, 19, 0> }
        box { <-10, 0, -2> <0, 3, 2> rotate -44*z translate <2.75, 23, 0> }
        box { <-10, -3, -2> <0, 0, 2> rotate 46*z translate <2.75, 21, 0> }
        box { <0, 10, -3> <4, 26, 0> rotate -10*y translate <1, 0, -1> }
        box { <0, 10, 0> <4, 26, 3> rotate 10*y translate <1, 0, 1> }
        box { <-10, 10, -3> <0, 26, 0> rotate 7*y translate <-3, 0, -1> }
        box { <-10, 10, 0> <0, 26, 3> rotate -7*y translate <-3, 0, 1> }
      }
      texture { color_tex }
      bounded_by { box { <-7, -0.1, -1.6> <3, 25.6, 1.6> } }
    }
  #end
#end
#macro backpack(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 0.9, 5> }
      box { <-6, -11.8, 3.999999> <6, 5.3, 8.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <3.9, 0.9, 5> }
        cylinder { -1*y, 2*y, 2.5 }
        difference {
          box { <-4, -1, -4> <-2.4, 2, -2.4> }
          cylinder { -2*y, 3*y, 1.5 translate <-2.4, 0, -2.4> }
        }
        difference {
          box { <2.4, -1, -4> <4, 2, -2.4> }
          cylinder { -2*y, 3*y, 1.5 translate <2.4, 0, -2.4> }
        }
      }
      box { <-6.4, 0.000001, 4> <6.4, 0.900001, 10> }
      box { <-6.400001, -4.7, 8.5> <6.400001, 0.900002, 10.000001> }
      cylinder { -5.9*x, 5.9*x, 2.1 translate <0, 3.1, 8> }
      box { <-5.900001, -0.000001, 5.900001> <5.900001, 3.100001, 9> }
      cylinder { -3.2*x, -1.8*x, 2.3 translate <0, 3.1, 8> }
      box { <-3.200001, -0.000002, 5.700001> <-1.800001, 3.100001, 8.15> }
      cylinder { 1.8*x, 3.2*x, 2.3 translate <0, 3.1, 8> }
      box { <1.800001, -0.000002, 5.700001> <3.200001, 3.100001, 8.15> }
      difference {
        box { <-3.2, -7.6, 8.5> <-1.8, -1, 10.3> }
        box { <-4, -2.3, 0> <-1, 0, 2> rotate 36*x translate <0, -4.6, 10.3> }
        box { <-4, -10, 9.2> <-1, -6.5, 15> }
      }
      difference {
        box { <1.8, -7.6, 8.5> <3.2, -1, 10.3> }
        box { <1, -2.3, 0> <4, 0, 2> rotate 36*x translate <0, -4.6, 10.3> }
        box { <1, -10, 9.2> <4, -6.5, 15> }
      }
      difference {
        box { <-6, -11.8, 3.999999> <6, -0.000001, 8.9> }
        #if (setting > 1)
          box { <-5, -10.6, 3> <5, 0, 7.9> }
          box { <-5.000001, -3.5, 3> <5.000001, -0.000001, 9.4> }
        #end
      }
      texture { color_tex }
      bounded_by { box { <-6.5, -11.9, -4> <6.5, 5.4, 10.5> } }
    }
  #end
#end
#macro bar(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 51.7*y, 1.5 texture { color_tex } }
  #else
    merge {
      cylinder { 0*y, 51.7*y, 1.35 }
      cylinder { 0.15*y, 51.55*y, 1.5 }
      torus { 1.35, 0.15 translate <0, 0.15, 0> }
      torus { 1.35, 0.15 translate <0, 51.55, 0> }
      cylinder { 4.5*y, 5.75*y, 2.3 }
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 51.8*y, 2.4 } }
    }
  #end
#end
#macro bar1_3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 4*y, 3.9 }
      cylinder { 0*y, 4*y, 3.9 translate <16, 0, 0> }
      cylinder { 0*x, 16*x, 1.5 translate <0, 4, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          cylinder { 0*y, 4*y, 3.9 }
          box { <-10, 0, -5> <0, 10, 5> rotate 20.5*z translate <3.9, 4.000005, 0> }
        }
        difference {
          cylinder { 0*y, 4*y, 3.9 }
          box { <0, 0, -5> <10, 10, 5> rotate -20.5*z translate <-3.9, 4.000005, 0> }
          translate <16, 0, 0>
        }
        difference {
          difference {
            sphere { <0, 0, 0> 1 scale <4.2, 2, 4.1> }
            box { <-5, -10, -5> <5, -0.000005, 5> }
            translate <-4.1, 0, 0> rotate 20.5*z
          }
          difference {
            box { <-5, -2, -5> <5, 11, 5> }
            cylinder { -1*y, 10*y, 3.900005 }
            translate <-3.9, -4, 0>
          }
          translate <3.9, 4, 0>
        }
        difference {
          difference {
            sphere { <0, 0, 0> 1 scale <4.2, 2, 4.1> }
            box { <-5, -10, -5> <5, -0.000005, 5> }
            translate <4.1, 0, 0> rotate -20.5*z
          }
          difference {
            box { <-5, -2, -5> <5, 11, 5> }
            cylinder { -1*y, 10*y, 3.900005 }
            translate <3.9, -4, 0>
          }
          translate <12.1, 4, 0>
        }
        cylinder { 3*x, 13*x, 1.5 translate <0, 4, 0> }
        sphere { <0, 0, 0> 1.5 scale <1.75, 1, 1> translate <3, 4, 0> }
        sphere { <0, 0, 0> 1.5 scale <1.75, 1, 1> translate <13, 4, 0> }
      }
      #if (setting > 1)
        cylinder { -1*y, 2*y, 2.4 }
        cylinder { -1*y, 2*y, 2.4 translate <16, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 5.6, 4> } }
    }
  #end
#end
#macro bar1_4(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*x, 24*x, 1.5 translate <0, 17.6, 0> }
      cylinder { 0*y, 17.6*y, 1.5 }
      cylinder { 0*y, 17.6*y, 1.5 translate <24, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 3.1*y, 3.25 }
        cylinder { 0*y, 3.1*y, 3.25 translate <24, 0, 0> }
        cylinder { 3*y, 13.600001*y, 1.5 }
        cylinder { 3*y, 13.600001*y, 1.5 translate <24, 0, 0> }
        object { open_rounded_button() translate <8, 16, 0> }
        object { open_rounded_button() translate <16, 16, 0> }
        cylinder { 16.099999*y, 19*y, 2.400001 translate <8, 0, 0> }
        cylinder { 16.099999*y, 19*y, 2.400001 translate <16, 0, 0> }
        cylinder { 3.999999*x, 20.000001*x, 1.5 translate <0, 17.6, 0> }
        cylinder { 0*x, 24*x, 1.5 translate <0, 4.5, 0> }
        difference {
          torus { 4, 1.5 rotate 90*x }
          box { <-10, -10, -10> <10, -0.000001, 10> }
          box { <-10, -10, -10> <-0.000001, 10, 10> }
          translate <20, 13.6, 0>
        }
        difference {
          torus { 4, 1.5 rotate 90*x }
          box { <-10, -10, -10> <10, -0.000001, 10> }
          box { <0.000001, -10, -10> <10, 10, 10> }
          translate <4, 13.6, 0>
        }
      }
      #if (setting > 1)
        cylinder { 15*y, 21*y, 1.600001 translate <8, 0, 0> }
        cylinder { 15*y, 21*y, 1.600001 translate <16, 0, 0> }
        cylinder { -1*y, 2*y, 2.6 }
        cylinder { -1*y, 2*y, 2.6 translate <24, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 20.9, 4> } }
    }
  #end
#end
#macro bar1_6(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*x, 40*x, 1.5 translate <0, 8, 0> }
      cylinder { 0*y, 8*y, 1.5 }
      cylinder { 0*y, 8*y, 1.5 translate <40, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 3.1*y, 3.3 }
        cylinder { 0*y, 3.1*y, 3.3 translate <40, 0, 0> }
        cylinder { 3*y, 4.00001*y, 1.5 }
        cylinder { 3*y, 4.00001*y, 1.5 translate <40, 0, 0> }
        object { open_rounded_button() translate <8, 6.4, 0> }
        object { open_rounded_button() translate <16, 6.4, 0> }
        object { open_rounded_button() translate <24, 6.4, 0> }
        object { open_rounded_button() translate <32, 6.4, 0> }
        cylinder { 6.49999*y, 9.4*y, 2.40001 translate <8, 0, 0> }
        cylinder { 6.49999*y, 9.4*y, 2.40001 translate <16, 0, 0> }
        cylinder { 6.49999*y, 9.4*y, 2.40001 translate <24, 0, 0> }
        cylinder { 6.49999*y, 9.4*y, 2.40001 translate <32, 0, 0> }
        cylinder { 3.99999*x, 36.00001*x, 1.5 translate <0, 8, 0> }
        difference {
          torus { 4, 1.5 rotate 90*x }
          box { <-10, -10, -10> <10, -0.00001, 10> }
          box { <-10, -10, -10> <-0.00001, 10, 10> }
          translate <36, 4, 0>
        }
        difference {
          torus { 4, 1.5 rotate 90*x }
          box { <-10, -10, -10> <10, -0.00001, 10> }
          box { <0.00001, -10, -10> <10, 10, 10> }
          translate <4, 4, 0>
        }
      }
      #if (setting > 1)
        cylinder { 7.2*y, 11.5*y, 1.60001 translate <8, 0, 0> }
        cylinder { 7.2*y, 11.5*y, 1.60001 translate <16, 0, 0> }
        cylinder { 7.2*y, 11.5*y, 1.60001 translate <24, 0, 0> }
        cylinder { 7.2*y, 11.5*y, 1.60001 translate <32, 0, 0> }
        cylinder { -1*y, 2*y, 2.5 }
        cylinder { -1*y, 2*y, 2.5 translate <40, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-3.4, -0.1, -3.4> <43.4, 11.3, 3.4> } }
    }
  #end
#end
#macro barblock1_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 13, 3.9> }
      box { <-10, -10, 0> <20, 20, 10> rotate -28.5*x translate <3.9, 3.1, 3.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 14, 3.9> }
        difference {
          box { <-4, 3.099999, -4> <12, 15, 4> }
          cylinder { -3.900002*x, 11.900002*x, 1.500001 translate <0, 11.5, -2.4> }
          box { <-10, -20, -10> <20, 0, 1.5> rotate -28.5*x translate <0, 11.5, -2.4> }
          box { <-10, -10, -1.500001> <20, 0, 0> translate < 0, 11.5, -2.4> }
        }
        difference {
          box { <-2.5, 3.100002, -4> <10.5, 15, 4> }
          cylinder { -3*x, 11*x, 1.5 translate <0, 11.5, -2.4> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 13.1, 4> } }
    }
  #end
#end
#macro barrel(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -0.000001*z, 24.000001*z, 1.550001 }
      cylinder { -0.000001*z, 24.000001*z, 1.550001 translate <0, 20.75, 0> }
      cylinder { 0*y, 20.750001*y, 1.550001 }
      cylinder { 0*y, 20.750001*y, 1.550001 translate <0, 0, 24> }
      texture { color_tex }
    }
  #else
    merge {
      sphere { <0, 0, 0> 1.55 }
      sphere { <0, 0, 24> 1.55 }
      sphere { <0, 20.75, 0> 1.55 }
      sphere { <0, 20.75, 24> 1.55 }
      cylinder { -0.000001*z, 24.000001*z, 1.550001 }
      cylinder { -0.000001*z, 24.000001*z, 1.550001 translate <0, 20.75, 0> }
      cylinder { 0*y, 20.750001*y, 1.550001 }
      cylinder { 0*y, 20.750001*y, 1.550001 translate <0, 0, 8> }
      cylinder { 0*y, 20.750001*y, 1.550001 translate <0, 0, 16> }
      cylinder { 0*y, 20.750001*y, 1.550001 translate <0, 0, 24> }
      #if (setting > 1)
        box { <-1, 8.8, 24> <1, 12, 26.3> }
        box { <-1, 8.8, -2.3> <1, 12, 0> }
        cylinder { -2.55*z, -2*z, 0.4 translate <0, 10.4, 0> }
        cylinder { 26*z, 26.55*z, 0.4 translate <0, 10.4, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-1.65, -1.65, -2.65> <1.65, 22.6, 26.65> } }
    }
  #end
#end
#macro base_plate_16_16(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <123.9, 1.2, 123.9> texture { color_tex } }
  #else
    merge {
      box { <-3.900001, 0, -0.000001> <123.900001, 1.2, 120.000001> }
      box { <-0.000001, 0.000001, -3.9> <120.000001, 1.200002, 123.9> }
      #local teller = 0;
      #while ( teller < 16)
        #local counter = 0;
        #while ( counter < 16)
          #if (setting < 3)
            cylinder { 1.1*y, 2.9*y, 2.4 translate <(teller*8), 0, (counter*8)> }
          #else
            object { rounded_button() translate <(teller*8), -1.9, (counter*8)> }
          #end
          #local counter = counter + 1;
        #end
        #local teller = teller + 1;
      #end
      cylinder { 0*y, 1.200001*y, 3.9 }
      cylinder { 0*y, 1.200001*y, 3.9 translate <120, 0, 0> }
      cylinder { 0*y, 1.200001*y, 3.9 translate <120, 0, 120> }
      cylinder { 0*y, 1.200001*y, 3.9 translate <0, 0, 120> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <124, 3, 124> } }
    }
  #end
#end
#macro base_plate_32_16(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <123.9, 1.2, 251.9> texture { color_tex } }
  #else
    merge {
      box { <-3.900001, 0, -0.000001> <123.900001, 1.2, 248.000001> }
      box { <-0.000001, 0.000001, -3.9> <120.000001, 1.200002, 251.9> }
      #local teller = 0;
      #while ( teller < 16)
        #local counter = 0;
        #while ( counter < 32)
          #if (setting < 3)
            cylinder { 1.1*y, 2.9*y, 2.4 translate <(teller*8), 0, (counter*8)> }
          #else
            object { rounded_button() translate <(teller*8), -1.9, (counter*8)> }
          #end
          #local counter = counter + 1;
        #end
        #local teller = teller + 1;
      #end
      cylinder { 0*y, 1.200001*y, 3.9 }
      cylinder { 0*y, 1.200001*y, 3.9 translate <120, 0, 0> }
      cylinder { 0*y, 1.200001*y, 3.9 translate <120, 0, 248> }
      cylinder { 0*y, 1.200001*y, 3.9 translate <0, 0, 248> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <124, 3, 252> } }
    }
  #end
#end
#macro base_plate_32_32(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <251.9, 1.2, 251.9> texture { color_tex } }
  #else
    merge {
      box { <-3.900001, 0, -0.000001> <251.9, 1.2, 248.000001> }
      box { <-0.000001, 0.000001, -3.900001> <248.000001, 1.200002, 251.9> }
      #local teller = 0;
      #while ( teller < 32)
        #local counter = 0;
        #while ( counter < 32)
          #if (setting < 3)
            cylinder { 1.1*y, 2.9*y, 2.4 translate <(teller*8), 0, (counter*8)> }
          #else
            object { rounded_button() translate <(teller*8), -1.9, (counter*8)> }
          #end
          #local counter = counter + 1;
        #end
        #local teller = teller + 1;
      #end
      cylinder { 0*y, 1.200001*y, 3.9 }
      cylinder { 0*y, 1.200001*y, 3.9 translate <248, 0, 0> }
      cylinder { 0*y, 1.200001*y, 3.9 translate <248, 0, 248> }
      cylinder { 0*y, 1.200001*y, 3.9 translate <0, 0, 248> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <252, 3, 252> } }
    }
  #end
#end
#macro base_plate_32_8(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 1.2, 251.9> texture { color_tex } }
  #else
    merge {
      box { <-3.900001, 0, -0.000001> <59.900001, 1.2, 248.000001> }
      box { <-0.000001, 0.000001, -3.9> <56.000001, 1.200002, 251.9> }
      #local teller = 0;
      #while ( teller < 8)
        #local counter = 0;
        #while ( counter < 32)
          #if (setting < 3)
            cylinder { 1.1*y, 2.9*y, 2.4 translate <(teller*8), 0, (counter*8)> }
          #else
            object { rounded_button() translate <(teller*8), -1.9, (counter*8)> }
          #end
          #local counter = counter + 1;
        #end
        #local teller = teller + 1;
      #end
      cylinder { 0*y, 1.200001*y, 3.9 }
      cylinder { 0*y, 1.200001*y, 3.9 translate <56, 0, 0> }
      cylinder { 0*y, 1.200001*y, 3.9 translate <56, 0, 248> }
      cylinder { 0*y, 1.200001*y, 3.9 translate <0, 0, 248> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 3, 252> } }
    }
  #end
#end
#macro base_plate_8_16(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <123.9, 1.2, 59.9> texture { color_tex } }
  #else
    merge {
      box { <-3.900001, 0, -0.000001> <123.900001, 1.2, 56.000001> }
      box { <-0.000001, 0.000001, -3.9> <120.000001, 1.200002, 59.9> }
      #local teller = 0;
      #while ( teller < 16)
        #local counter = 0;
        #while ( counter < 8)
          #if (setting < 3)
            cylinder { 1.1*y, 2.9*y, 2.4 translate <(teller*8), 0, (counter*8)> }
          #else
            object { rounded_button() translate <(teller*8), -1.9, (counter*8)> }
          #end
          #local counter = counter + 1;
        #end
        #local teller = teller + 1;
      #end
      cylinder { 0*y, 1.200001*y, 3.9 }
      cylinder { 0*y, 1.200001*y, 3.9 translate <120, 0, 0> }
      cylinder { 0*y, 1.200001*y, 3.9 translate <120, 0, 56> }
      cylinder { 0*y, 1.200001*y, 3.9 translate <0, 0, 56> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <124, 3, 60> } }
    }
  #end
#end
#macro battery_cover(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 22.3, 27.9> }
      box { <-1, -1, -4> <57, 3.2, 28> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting < 3)
        cylinder { 22.2*y, 24*y, 2.4 }
        cylinder { 22.2*y, 24*y, 2.4 translate <8, 0, 0> }
        cylinder { 22.2*y, 24*y, 2.4 translate <16, 0, 0> }
        cylinder { 22.2*y, 24*y, 2.4 translate <24, 0, 0> }
        cylinder { 22.2*y, 24*y, 2.4 translate <32, 0, 0> }
        cylinder { 22.2*y, 24*y, 2.4 translate <40, 0, 0> }
        cylinder { 22.2*y, 24*y, 2.4 translate <48, 0, 0> }
        cylinder { 22.2*y, 24*y, 2.4 translate <56, 0, 0> }
        cylinder { 22.2*y, 24*y, 2.4 translate <0, 0, 24> }
        cylinder { 22.2*y, 24*y, 2.4 translate <8, 0, 24> }
        cylinder { 22.2*y, 24*y, 2.4 translate <16, 0, 24> }
        cylinder { 22.2*y, 24*y, 2.4 translate <24, 0, 24> }
        cylinder { 22.2*y, 24*y, 2.4 translate <32, 0, 24> }
        cylinder { 22.2*y, 24*y, 2.4 translate <40, 0, 24> }
        cylinder { 22.2*y, 24*y, 2.4 translate <48, 0, 24> }
        cylinder { 22.2*y, 24*y, 2.4 translate <56, 0, 24> }
        cylinder { 22.2*y, 24*y, 2.4 translate <48, 0, 8> }
        cylinder { 22.2*y, 24*y, 2.4 translate <48, 0, 16> }
      #else
        object { rounded_button() rotate 180*y translate <0, 19.2, 0> }
        object { rounded_button() rotate 180*y translate <8, 19.2, 0> }
        object { rounded_button() rotate 180*y translate <16, 19.2, 0> }
        object { rounded_button() rotate 180*y translate <24, 19.2, 0> }
        object { rounded_button() rotate 180*y translate <32, 19.2, 0> }
        object { rounded_button() rotate 180*y translate <40, 19.2, 0> }
        object { rounded_button() rotate 180*y translate <48, 19.2, 0> }
        object { rounded_button() rotate 180*y translate <56, 19.2, 0> }
        object { rounded_button() rotate 180*y translate <0, 19.2, 24> }
        object { rounded_button() rotate 180*y translate <8, 19.2, 24> }
        object { rounded_button() rotate 180*y translate <16, 19.2, 24> }
        object { rounded_button() rotate 180*y translate <24, 19.2, 24> }
        object { rounded_button() rotate 180*y translate <32, 19.2, 24> }
        object { rounded_button() rotate 180*y translate <40, 19.2, 24> }
        object { rounded_button() rotate 180*y translate <48, 19.2, 24> }
        object { rounded_button() rotate 180*y translate <56, 19.2, 24> }
        object { rounded_button() rotate 180*y translate <48, 19.2, 8> }
        object { rounded_button() rotate 180*y translate <48, 19.2, 16> }
      #end
      object { conductive_button() rotate 90*y translate <0, 19.2, 8> }
      object { conductive_button() rotate 90*y translate <8, 19.2, 8> }
      object { conductive_button() rotate 90*y translate <16, 19.2, 8> }
      object { conductive_button() rotate 90*y translate <24, 19.2, 8> }
      object { conductive_button() rotate 90*y translate <32, 19.2, 8> }
      object { conductive_button() rotate 90*y translate <40, 19.2, 8> }
      object { conductive_button() rotate -90*y translate <0, 19.2, 16> }
      object { conductive_button() rotate -90*y translate <8, 19.2, 16> }
      object { conductive_button() rotate -90*y translate <16, 19.2, 16> }
      object { conductive_button() rotate -90*y translate <24, 19.2, 16> }
      object { conductive_button() rotate -90*y translate <32, 19.2, 16> }
      object { conductive_button() rotate -90*y translate <40, 19.2, 16> }
      difference {
        box { <-3.9, 0, -3.9> <59.9, 22.3, 27.9> }
        box { <-2.4, -1, -2.4> <58.4, 21.4, 26.4> }
        box { <-1, -1, -4> <57, 3.2, 28> }
        #if (setting > 1)
          cylinder { 20.2*y, 23.2*y, 1.2 }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <8, 0, 0> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <16, 0, 0> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <24, 0, 0> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <32, 0, 0> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <40, 0, 0> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <48, 0, 0> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <56, 0, 0> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <0, 0, 8> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <8, 0, 8> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <16, 0, 8> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <24, 0, 8> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <32, 0, 8> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <40, 0, 8> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <48, 0, 8> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <56, 0, 8> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <0, 0, 16> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <8, 0, 16> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <16, 0, 16> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <24, 0, 16> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <32, 0, 16> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <40, 0, 16> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <48, 0, 16> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <56, 0, 16> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <0, 0, 24> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <8, 0, 24> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <16, 0, 24> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <24, 0, 24> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <32, 0, 24> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <40, 0, 24> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <48, 0, 24> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <56, 0, 24> }
        #end
        box { <52.9, 19, 5.1> <58.500001, 23, 18.9> }
        box { <58.3, 19.000001, 7.1> <60, 23, 16.9> }
        box { <58.3, -1, 7.1> <60, 3.2, 16.9> }
      }
      box { <9.5, 6.4, -3> <10.5, 21.5, -1.5> }
      box { <37.5, 6.4, -3> <38.5, 21.5, -1.5> }
      box { <9.5, 6.4, 25.5> <10.5, 21.5, 27> }
      box { <37.5, 6.4, 25.5> <38.5, 21.5, 27> }
      merge {
        box { <53, 20.9, 5.2> <58.4, 24.3, 18.8> }
        box { <58.3, 20.900001, 7.2> <59.9, 24.300001, 16.8> }
        box { <53, 15, 9.2> <58.400001, 21, 14.8> }
        #if (setting < 3)
          cylinder { 24.2*y, 26*y, 2.4 translate <56, 0, 8> }
          cylinder { 24.2*y, 26*y, 2.4 translate <56, 0, 16> }
        #else
          object { rounded_button() rotate 180*y translate <56, 21.2, 8> }
          object { rounded_button() rotate 180*y translate <56, 21.2, 16> }
        #end
        texture { grey_tex }
      }
      difference {
        box { <47.1, 2.9, -2.3> <58.3, 21.5, 26.3> }
        box { <48.5, 4, -1.4> <58.5, 22, 25.4> }
        box { <46, 0, 1> <51, 4.5, 6> }
        box { <46, 0, 16> <51, 4.5, 21> }
        box { <48.5, 0, 5.75> <52, 4.5, 7.75> }
        box { <48.5, 0, 15.25> <52, 4.5, 17.25> }
        box { <51.9, 0, 7> <59, 4.5, 17> }
        box { <48.5, 0, 20> <54, 4.5, 25.5> }
        box { <-3.3, 2, -0.5> <-1, 3.2, 3.5> }
        box { <-3.3, 2, 20.5> <-1, 3.2, 24.5> }
      }
      #if (setting > 1)
        box { <45.5, 3.200001, -3> <47, 21.5, -1> }
        box { <45.5, 3.200001, 25> <47, 21.5, 27> }
        box { <45.5, 3.200001, 9.75> <47.2, 21.5, 11.25> }
        box { <45.5, 3.200001, 12.75> <47.2, 21.5, 14.25> }
        box { <45.5, 4.000001, -0.5> <47, 21.5, 1> }
        box { <45.5, 3.200001, 21> <47, 21.5, 22.5> }
        box { <45.500001, 17, -0.500001> <47.2, 21.5, 6.4> }
        box { <45.500001, 17, 12.750001> <47.2, 21.5, 22.500001> }
        box { <-2.3, 5.5, -2.3> <-1.3, 21.5, 26.3> }
        cylinder { 1.1*z, 5.9*z, 0.76 translate <47.75, 4.6, 0> texture { chrome_tex } }
        cylinder { 16.1*z, 21.9*z, 0.76 translate <47.75, 4.6, 0> texture { chrome_tex } }
        box { <46.9900001, 4.59, 1.1> <47.25, 18, 5.9> texture { chrome_tex } }
        box { <46.9900001, 4.59, 16.1> <47.25, 18, 20.9> texture { chrome_tex } }
        box { <-0.25, 0, -6.75> <0.25, 9, 6.75> texture { chrome_tex } rotate -25*z translate <-1.8, 10, 12> }
        box { <40, 20.5, -2.4> <48, 21.1, 2.5> texture { chrome_tex } }
        box { <-2.5, 20.500001, 7.25> <43.500001, 21.1, 10.500001> texture { chrome_tex } }
        box { <-2.5, 20.500002, 13.5> <48, 21.1, 16.75> texture { chrome_tex } }
        box { <40, 20.500003, -2> <43.5, 21.1, 10.500002> texture { chrome_tex } }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 26.1, 28> } }
    }
  #end
#end
#macro battery_lid(color_tex)
  #if (setting = 0)
    box { <-2.4, 2, -3.9> <58.4, 3.1, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-2.4, 2, -3.9> <58.4, 3.1, 27.9> }
        box { <-3, 1, -4> <-1.1, 4, -2.5> }
        box { <-3, 1, 26.5> <-1.1, 4, 28> }
        box { <56.9, 1, -4> <59, 4, -2.5> }
        box { <56.9, 1, 26.5> <59, 4, 28> }
        box { <45, 2.6, 5.5> <50, 4, 23.5> }
        box { <54.5, 1, 5.5> <59, 4, 18.5> }
      }
      box { <-3.3, 2.200001, -0.5> <-1, 3.099999, 3.5> }
      box { <-3.3, 2.200001, 20.5> <-1, 3.099999, 24.5> }
      #if (setting > 1)
        object { pin(1) translate <52, 0, 0> }
        object { pin(1) translate <52, 0, 24> }
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <36, 0, 4> }
        object { ring() translate <44, 0, 4> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 20> }
        object { ring() translate <28, 0, 20> }
        object { ring() translate <36, 0, 20> }
        object { ring() translate <44, 0, 20> }
      #end
      difference {
        box { <-2.400001, 0, 11.25> <56, 2.1, 12.75> }
        box { <-5, -5, 10> <0, 0, 13> rotate 45*z translate <-2.4, 2, 0> }
      }
      box { <-1.100001, 0, -3.900001> <56.900001, 2.5, -2.5> }
      box { <-1.100001, 0, 26.5> <56.900001, 2.5, 27.900001> }
      box { <5, 2.5, -2.4> <45, 6.1, -1.4> }
      box { <5, 2.5, 25.4> <45, 6.1, 26.4> }
      difference {
        merge {
          box { <58.5, 0, 7.2> <59.9, 2.9, 16.8> }
          box { <53.5, 2.899999, 7.200001> <58.5, 7.5, 16.800001> }
          cylinder { 7.200002*z, 16.800002*z, 2.5 translate <56, 7.499999, 0> }
          box { <-2.5, -1.5, 7.200003> <0, 0, 16.800003> rotate -10*z translate <59.9, 2.9, 0> }
        }
        box { <59.5, 0.75, 8.2> <60, 2.25, 15.8> }
        box { <52, 7.5, 10.5> <60, 11, 13.5> }
        cylinder { 6*z, 18*z, 1.5 translate <56, 7.5, 0> }
        box { <54.500001, 0, 6> <57.500001, 7.500002, 18> }
      }
      box { <54, 0.000001, 11.250001> <56.000001, 7.499999, 12.750001> }
      texture { color_tex }
      bounded_by { box { <-3.4, -0.1, -4> <60, 10.1, 28> } }
    }
  #end
#end
#macro bicycle_frame(color_tex)
  merge {
    difference {
      merge {
        cylinder { -3.15*z, 3.15*z, 1.5 }
        cylinder { -3.15*z, 3.15*z, 1.5 translate <-34.2, 0, 0> }
        cylinder { -3.3*z, 3.3*z, 1.5 translate <-18, -3.5, 0> }
        cylinder { -0.55*z, 0.55*z, 3 translate <-18, -3.5, 0> }
        box { <-0.4, 0, -3.30001> <0.4, 4, 3.30001> rotate -20*z translate <-18, -3.5, 0> }
        box { <-1.5, 0, -0.55001> <1.5, 10, 0.55001> rotate -20*z translate <-18, -3.5, 0> }
        merge {
          cylinder { -1.65*z, 1.65*z, 1.5 translate <0, 12, 0> }
          sphere { <0, 12, -1.65> 1.5 }
          sphere { <0, 12, 1.65> 1.5 }
          cylinder { 0*y, 12*y, 1.5 translate <0, 0, -1.65> }
          cylinder { 0*y, 12*y, 1.5 translate <0, 0, 1.65> }
          box { <-1.5, 0, -1.65> <1.5, 12, 1.65> }
          box { <0, -0.5, -1.7> <10.5, 1.5, 1.7> rotate -33*z translate <0, 12, 0> }
          merge {
            cylinder { 1.49*y, 3.14*y, 2.4 }
            cylinder { 2.49*y, 3.29*y, 2.25 }
            torus { 2.25, 0.15 translate <0, 3.14, 0> }
            translate <6.5, 0, 0> rotate -33*z translate <0, 12, 0>
          }
          rotate 33*z
        }
        merge {
          sphere { <0, 18.5, 0> 1.5 }
          cylinder { 0*y, 18.5*y, 1.5 }
          rotate 33*z
          translate <-18, -3.5, 0>
        }
        box { <-33, 11.2, -0.5> <-30, 14.4, 0.5> }
        cylinder { -32.7*x, -32.8*x, 2.40001 translate <0, 12.8, 0> }
        object { open_rounded_button() rotate 90*z translate <-29.7, 12.8, 0> }
        merge {
          cylinder { -18.4*x, 0*x, 1.5 translate <0, 0, -1.65> }
          cylinder { -18.4*x, 0*x, 1.5 translate <0, 0, 1.65> }
          box { <-18.4, -1.5, -1.65> <0, 1.5, 1.65> }
          rotate 11*z
        }
        box { <-15.1, -7.7, -1.6> <-13.9, -3, 1.6> }
        box { <-16, -8.80001, -4.5> <-13, -7.60001, 4.5> }
        cylinder { -8.8*y, -7.6*y, 1.5 translate <-14.5, 0, -4.5> }
        cylinder { -8.8*y, -7.6*y, 1.5 translate <-14.5, 0, 4.5> }
        difference {
          merge {
            cylinder { -0.55001*z, 0.55001*z, 8 }
            box { <-8, -8, -1.5> <-4.5, -3, 1.5> }
            box { <3.5, -8, -1.5> <8, 0, 1.5> }
          }
          box { <-10, 0, -1> <2, 10, 1> rotate 10.5*z }
          box { <-2, 0, -1> <10, 10, 1> rotate -5*z }
          cylinder { -2*z, 2*z, 5 }
          difference {
            box { <-10, -10, -3> <10, 0, 3> }
            cylinder { -2*z, 2*z, 8.00001 }
          }
          cylinder { -10*y, 10*y, 5 translate <-4.5, 0, -5.55> }
          cylinder { -10*y, 10*y, 5 translate <-4.5, 0, 5.55> }
          cylinder { -10*y, 10*y, 5 translate <3.5, 0, -5.55> }
          cylinder { -10*y, 10*y, 5 translate <3.5, 0, 5.55> }
          translate <0, 16.5, 0> rotate -19.5*z translate <-18, -3.5, 0>
        }
        merge {
          cylinder { 0*y, 10.3*y, 1.5 translate <0, 0, -1.85> }
          cylinder { 0*y, 10.3*y, 1.5 translate <0, 0, 1.85> }
          box { <-1.5, 0.00001, -1.85> <1.5, 10.29999, 1.85> }
          cylinder { 10.2*y, 16.7*y, 1.9 }
          cylinder { 16.6*y, 21.5*y, 1.5 }
          cylinder { -4.3*z, 4.3*z, 1.5 translate <0, 21.5, 0> }
          merge {
            cylinder { 0*x, 10.5*x, 1.5 }
            sphere { <10.5, 0, 0> 1.5 }
            rotate 9.5*z translate <0, 15, 0>
          }
          merge {
            sphere { <0, 0, 0> 1.5 }
            cylinder { -7*z, 0*z, 1.5 }
            sphere { <0, 0, -7> 1.5 }
            rotate -17.5*y
            rotate 20*z
            translate <0, 21.5, -4.3>
          }
          merge {
            sphere { <0, 0, 0> 1.5 }
            cylinder { 7*z, 0*z, 1.5 }
            sphere { <0, 0, 7> 1.5 }
            rotate 17.5*y
            rotate 20*z
            translate <0, 21.5, 4.3>
          }
          rotate -20*z
          translate <-34.2, 0, 0>
        }
      }
      box { <-1.35, 0, -1.70002> <5, 10.5, 1.70002> }
      cylinder { -1.70003*z, 1.70003*z, 5 translate <-1.35, 5.5, 0> }
      cylinder { -4*z, 4*z, 0.7 }
      cylinder { -4*z, 4*z, 0.7 translate <-34.2, 0, 0> }
      box { <-9.3, -2, -1.65> <2, 2, 1.65> rotate 11*z }
      difference {
        box { <-0.99999, -5, -3> <2, -0.5, 3> }
        cylinder { -1*x, 3*x, 1 translate <0, -0.5, -2.65> }
        cylinder { -1*x, 3*x, 1 translate <0, -0.5, 2.65> }
      }
      merge {
        cylinder { -2*x, 2*x, 0.5 translate <0, 9.3, -1.1> }
        cylinder { -2*x, 2*x, 0.5 translate <0, 9.3, 1.1> }
        box { <-2, -2, -1.6> <2, 9.8, 1.6> }
        box { <-2, -2, -1.1> <2, 9.3, 1.1> }
        rotate -20*z
        translate <-34.2, 0, 0>
      }
    }
    #if (setting > 3)
      object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <-18, -3.5, -3.3> }
      object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y rotate 90*x translate <-18, -3.5, 3.3> }
      object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x rotate 90*y translate <-32.8, 12.8, 0> }
    #end
    texture { color_tex }
    bounded_by { box { <-35.8, -8.9, -12.5> <4, 22, 12.5> } }
  }
#end
#macro bicycle_wheel(color_tex)
  #if (setting = 0)
    torus { 8.1, 0.9 texture { r_black_tex } rotate 90*x }   
  #else
    union {
      torus { 8.1, 0.9 texture { r_black_tex } rotate 90*x }
      merge {
        cylinder { -2.4*z, 2.4*z, 0.6 }
        cylinder { -1.4*z, 1.4*z, 1.35 }
        difference {
          cylinder { -0.9*z, 0.9*z, 7.4 }
          difference {
            cylinder { -1*z, -0.65*z, 6.4 }
            box { <-0.25, -7, -0.8> <0.25, 7, 0> }
            box { <-0.25, -7, -0.8> <0.25, 7, 0> rotate 30*z }
            box { <-0.25, -7, -0.8> <0.25, 7, 0> rotate 60*z }
            box { <-0.25, -7, -0.8> <0.25, 7, 0> rotate 90*z }
            box { <-0.25, -7, -0.8> <0.25, 7, 0> rotate 120*z }
            box { <-0.25, -7, -0.8> <0.25, 7, 0> rotate 150*z }
          }
          difference {
            cylinder { 1*z, 0.65*z, 6.4 }
            box { <-0.25, -7, 0.8> <0.25, 7, 0> rotate 15*z }
            box { <-0.25, -7, 0.8> <0.25, 7, 0> rotate 45*z }
            box { <-0.25, -7, 0.8> <0.25, 7, 0> rotate 75*z }
            box { <-0.25, -7, 0.8> <0.25, 7, 0> rotate 105*z }
            box { <-0.25, -7, 0.8> <0.25, 7, 0> rotate 135*z }
            box { <-0.25, -7, 0.8> <0.25, 7, 0> rotate 165*z }
          }
          difference {
            box { <-8, -8, -0.8> <8, 8, 0.8> }
            cone { -0.8*z, 7.4, 0.00001*z, 6.7 }
            cone { 0.8*z, 7.4, -0.00001*z, 6.7 }
          }
        }
        texture { color_tex }
        interior { ior 1.5 }
      }
      //bounded_by { cylinder { -2.5*z, 2.5*z, 9.1 } }
    }
  #end
#end
#macro binoculars(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -7.9*x, 3.8*x, 1.55 translate <0, 0, -2.4> }
      cylinder { -7.9*x, 3.8*x, 1.55 translate <0, 0, 2.4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -7.9*x, -3.9*x, 2.4 translate <0, 0, -2.4> }
        cylinder { -7.9*x, -3.9*x, 2.4 translate <0, 0, 2.4> }
        cylinder { -4*x, 2.8*x, 1.55 translate <0, 0, -2.4> }
        cylinder { -4*x, 2.8*x, 1.55 translate <0, 0, 2.4> }
        cylinder { 2*x, 3.5*x, 1.35 translate <0, 0, -2.4> }
        cylinder { 2*x, 3.5*x, 1.35 translate <0, 0, 2.4> }
        cylinder { 3.3*x, 3.8*x, 1.55 translate <0, 0, -2.4> }
        cylinder { 3.3*x, 3.8*x, 1.55 translate <0, 0, 2.4> }
        box { <-3.900005, -1.55, -2.4000005> <-2.7, 1.55, 2.400005> }
        box { <1.8, -1.55, -2.400005> <2.800005, 1.55, 2.400005> }
      }
      #if (setting > 1)
        cylinder { -2*y, 0*y, 2.5 }
        cylinder { -8*x, -5.9*x, 1.7 translate <0, 0, -2.4> }
        cylinder { -8*x, -5.9*x, 1.7 translate <0, 0, 2.4> }
      #end
      texture { color_tex }
      bounded_by { box { <-8, -2.5, -4.9> <3.9, 2.5, 4.9> } }
    }
  #end
#end
#macro boat_mast(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      box { <0, 17.500001, -3.000001> <8.5, 19.000001, 3.000001> rotate 12.35*y translate <-4, 0, 8> }
      box { <-8.5, 17.500001, -3.000001> <0, 19.000001, 3.000001> rotate -12.35*y translate <12, 0, 8> }
      cylinder { -1*y, 27*y, 2.500001 rotate 13.5*x translate <4, 3.1, 2> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <0, 17.500001, -3.000001> <8.5, 19.000001, 3.000001> }
          box { <-10, 17, 3> <30, 20, 10> rotate 10*y }
          rotate 12.35*y
          translate <-4, 0, 8>
        }
        difference {
          box { <-8.5, 17.500001, -3.000001> <0, 19.000001, 3.000001> }
          box { <-30, 17, 3> <10, 20, 10> rotate -10*y }
          rotate -12.35*y
          translate <12, 0, 8>
        }
        difference {
          box { <1.5, 3.099999, -2> <6.5, 28.9, 11.900002> }
          difference {
            box { <-3, -3, -15> <3, 28, 0> }
            cylinder { -3*y, 27*y, 2.500001 }
            rotate 13.5*x
            translate <4, 3.1, 2>
          }
          cylinder { 1*x, 7*x, 4 translate <0, 7.1, 11.9> }
          box { <-10, 0, -4> <10, 25, 0> rotate 6.5*x translate <0, 7.1, 11.9> }
          #if (setting > 1)
            cylinder { 10*y, 30*y, 1.600001 translate <4.000001, 0, 8.000001> }
          #end
        }
        object { open_rounded_button() translate <4, 25.8, 8> }
        object { open_rounded_button() translate <-4, 15.9, 8> }
        object { open_rounded_button() translate <12, 15.9, 8> }
        cylinder { 17.5*y, 19*y, 3 translate <-4, 0, 8> }
        cylinder { 17.5*y, 19*y, 3 translate <12, 0, 8> }
        difference {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <2.4, 2, 12> }
            box { <5.6, -1, -2.4> <10.4, 2, 12> }
          #end
        }
      }
      #if (setting > 1)
        difference {
          box { <2.5, 3.100002, -6.5> <5.5, 28, 14> }
          difference {
            box { <-2, -3, -15> <2, 30, 0> }
            cylinder { -3*y, 29*y, 1.5 }
            rotate 13.5*x
            translate <4, 3.100001, 2>
          }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-7.1, -0.1, -4> <15.1, 30.7, 12> } }
    }
  #end
#end
#macro boat_mast2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      cone { 3.05*y, 2.4, 87.2*y, 1.9 translate <4, 0, 4> }
      cylinder { 87.59999*y, 93.9*y, 2.4 translate <4, 0, 4> }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
        cone { 3.05*y, 2.4, 87.2*y, 1.9 translate <4, 0, 4> }
        cone { 87.1*y, 1.9, 87.6*y, 2.4 translate <4, 0, 4> }
        cylinder { 87.59999*y, 93.9*y, 2.4 translate <4, 0, 4> }
        difference {
          box { <-2.4, 28.75, 2.8> <10.4, 31.75001, 5.2> }
          box { <0, -10, 2> <10, 0, 6> rotate -15*z translate <-2.4, 30.25, 0> }
          box { <-10, -10, 2> <0, 0, 6> rotate 15*z translate <10.4, 30.25, 0> }
        }
        box { <-0.2, 31.75, 1.7> <8.2, 34.65, 6.30001> }
        cylinder { -2.3*z, 2.3*z, 1.45 translate <-0.2, 33.2, 4> }
        cylinder { -2.3*z, 2.3*z, 1.45 translate <8.2, 33.2, 4> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate 90*z translate <2, 17.3, 4> }
      }
      #if (setting > 1)
        box { <-4, -1, -2.4> <2.4, 2, 2.4> }
        box { <-4, -1, 5.6> <2.4, 2, 10.4> }
        box { <5.6, -1, -2.4> <12, 2, 2.4> }
        box { <5.6, -1, 5.6> <12, 2, 10.4> }
        cylinder { -4*x, 4*x, 0.35 translate <4, 90.75, 4> }
        box { <0, 90.74999, 3.65> <8, 95, 4.35> }
        box { <-2, 31.74999, 3.45> <2, 40, 4.55> }
        box { <6, 31.74999, 3.45> <10, 40, 4.55> }
        sphere { <-0.2, 33.2, 7.3> 1.5 }
        sphere { <-0.2, 33.2, 0.7> 1.5 }
        sphere { <8.2, 33.2, 0.7> 1.5 }
        sphere { <8.2, 33.2, 7.3> 1.5 }
        box { <0, 15.2, 0> <2, 19.4, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 94, 12> } }
    }
  #end
#end
#macro body(color_tex)
  #if (setting = 0)
    difference {
      box { <-7.5, 0, -3.9> <7.5, 12.4, 3.9> }
      box { <-10, -2, -5> <0, 20, 5> rotate -10*z translate <-7.5, 1, 0> }
      box { <0, -2, -5> <10, 20, 5> rotate 10*z translate <7.5, 1, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-7.5, 0, -3.9> <7.5, 12.4, 3.9> }
        #if (setting < 3)
          cylinder { 12*y, 18.4*y, 2.4 }
        #else
          object { rounded_button() rotate 180*y translate <0, 13.6, 0> }
          cylinder { 12*y, 16.600001*y, 2.4 }
        #end
      }
      box { <-10, -2, -5> <0, 20, 5> rotate -10*z translate <-7.5, 1, 0> }
      box { <0, -2, -5> <10, 20, 5> rotate 10*z translate <7.5, 1, 0> }
      #if (setting > 1)
        cylinder { 0*y, 17*y, 1.25 }
        cylinder { -8*x, -3*x, 2 rotate -10*z translate <0, 8, 0> }
        cylinder { 3*x, 8*x, 2 rotate 10*z translate <0, 8, 0> }
        box { <-1.5, -1, -2.5> <1.5, 12, 2.5> }
        difference {
          box { <-6, -1, -2.5> <-1.500001, 12, 2.5> }
          box { <-10, -2, -5> <0, 20, 5> rotate -10*z translate <-6.75, 2, 0> }
          box { <0, -2, -5> <3, 20, 5> rotate 45*y translate <-1.5, 0, -1.5> }
          box { <0, -2, -5> <3, 20, 5> rotate -45*y translate <-1.5, 0, 1.5> }
        }
        difference {
          box { <1.500001, -1, -2.5> <6, 12, 2.5> }
          box { <0, -2, -5> <10, 20, 5> rotate 10*z translate <6.75, 2, 0> }
          box { <-3, -2, -5> <0, 20, 5> rotate -45*y translate <1.5, 0, -1.5> }
          box { <-3, -2, -5> <0, 20, 5> rotate 45*y translate <1.5, 0, 1.5> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-7.6, -0.1, -4> <7.6, 18.5, 4> } }
    }
  #end
#end
#macro bottle_top(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -8*x, 2*x, 1.5 }
      cylinder { 0*y, 7.9*y, 1.5 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        object { rounded_button() rotate 90*y rotate -90*z translate <-1.5, 0, 0> }
        cylinder { -8*x, 2*x, 1.5 }
        cylinder { 0*y, 4*y, 1.5 }
        cone { 4*y, 1.5, 6.25*y, 1.25 }
        cylinder { 6.2*y, 7.9*y, 1.5 }
        cylinder { -7.9*x, -6.55*x, 3.2 }
        torus { 1.5, 1.7 rotate <-90, -90, 0> translate <-6.550001, 0, 0> }
      }
      cylinder { 6*y, 8*y, 0.7 }
      cylinder { -9*x, -6*x, 2.6 }
      box { <-10, -5, -5> <-7.900001, 5, 5> }
      texture { color_tex }
      bounded_by { box { <-8, -3.35, -3.35> <3.4, 8, 3.35> } }
    }
  #end
#end
#macro bracket1_1(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -5.2> <3.9, 1.2, 3.9> }
      box { <-3.900001, -9.5, -5.200001> <3.900001, 1.199999, -4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        object { open_rounded_button() rotate -90*x translate <0, -3.9, -2.1> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x
            translate <0, -3.9, -5.2> }
        #end
        box { <-3.9, 0, -5.2> <3.9, 1.2, 3.9> }
        box { <-3.900001, -9.5, -5.200001> <3.900001, 1.199999, -4> }
      }
      difference {
        box { <-5, -1, 2.9> <5, 2, 4> }
        cylinder { -2*y, 3*y, 1 translate <-2.9, 0, 2.9> }
        cylinder { -2*y, 3*y, 1 translate <2.9, 0, 2.9> }
        box { <-2.9, -2, 2.9> <2.9, 3, 3.900005> }
      }
      difference {
        box { <-5, -10, -6> <5, -8.5, -3> }
        cylinder { -7*z, -2*z, 1 translate <-2.9, -8.5, 0> }
        cylinder { -7*z, -2*z, 1 translate <2.9, -8.5, 0> }
        box { <-2.9, -9.500005, -7> <2.9, -8.5, -2> }
      }
      cylinder { -1*y, 2*y, 2.5 }
      texture { color_tex }
      bounded_by { box { <-4, -9.6, -7> <4, 1.3, 4> } }
    }
  #end
#end
#macro broom(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 29*y, 1.5 }
      box { <-6.75, 0, -2.75> <6.75, 4.1, 2.75> rotate -24*x translate <0, 29.25, 0> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { 0*y, 29*y, 1.5 }
      torus { 1.35, 0.15 }
      cylinder { -0.150001*y, 1*y, 1.000001 }
      merge {
        box { <-6.75, 0, -2.75> <6.75, 1.2, 2.75> }
        difference {
          box { <-6.1, 0.5, -2.1> <6.1, 4.1, 2.1> }
          box { <-5.5, 0, -1.5> <5.5, 5, 1.5> }
        }
        #local counter = 0;
        #while (counter < 12)
          box { <-0.25, 0.5, -0.25> <0.25, 4.5, 0.25> translate <-6+counter, 0, -2.15> }
          box { <-0.25, 0.5, -0.25> <0.25, 4.5, 0.25> translate <-6+counter, 0, 2.15> }
          #local counter = counter + 1;
        #end
        box { <-0.25, 0.5, -0.25> <0.25, 4.5, 0.25> translate <-6, 0, -1> }
        box { <-0.25, 0.5, -0.25> <0.25, 4.5, 0.25> translate <-6, 0, 0> }
        box { <-0.25, 0.5, -0.25> <0.25, 4.5, 0.25> translate <-6, 0, 1> }
        box { <-0.25, 0.5, -0.25> <0.25, 4.5, 0.25> translate <6, 0, -1> }
        box { <-0.25, 0.5, -0.25> <0.25, 4.5, 0.25> translate <6, 0, 0> }
        box { <-0.25, 0.5, -0.25> <0.25, 4.5, 0.25> translate <6, 0, 1> }
        rotate -24*x
        translate <0, 29.25, 0>
      }
      texture { color_tex }
      bounded_by { box { <-7, -2, -5> <7, 35.75, 2.5> } }
    }
  #end
#end
#macro brush_holder(color_tex)
  #if (setting = 0)
    difference {
      box { <-21.5, 0, -20> <-3.25, 19.1, 20> }
      box { <0, 0, -21> <20, 14, 21> rotate 46.5*z translate <-3.25, 9.75, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-21.5, 0, -20> <-3.25, 19.1, 20> }
          box { <-3.5, 0.000001, -7.9> <2.9, 2, 7.9> }
          box { <-3.5, 7.5, -7.9> <2.9, 9.5, 7.9> }
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 translate <-17, 0, -12> }
            cylinder { 19*y, 20.8*y, 2.4 translate <-17, 0, -4> }
            cylinder { 19*y, 20.8*y, 2.4 translate <-17, 0, 4> }
            cylinder { 19*y, 20.8*y, 2.4 translate <-17, 0, 12> }
          #else
            object { rounded_button() rotate 180*y translate <-17, 16, -12> }
            object { rounded_button() rotate 180*y translate <-17, 16, -4> }
            object { rounded_button() rotate 180*y translate <-17, 16, 4> }
            object { rounded_button() rotate 180*y translate <-17, 16, 12> }
          #end
        }
        difference {
          box { <-22, -1, -18.4> <-4.65, 18.1, 18.4> }
          box { <0, 0, -20> <20, 14, 20> rotate 46.5*z translate <-4.65, 7.75, 0> }
        }
        box { <-22, -1, -21> <-4.650001, 7, 21> }
        #if (setting > 1)
          cylinder { 17*y, 20*y, 1.2 translate <-17, 0, -12> }
          cylinder { 17*y, 20*y, 1.2 translate <-17, 0, -4> }
          cylinder { 17*y, 20*y, 1.2 translate <-17, 0, 4> }
          cylinder { 17*y, 20*y, 1.2 translate <-17, 0, 12> }
        #end
        cylinder { -1*y, 10*y, 1.1 }
        box { <0, -1, -7> <7, 10, 1> rotate 45*y translate <2.9, 0, -3.9> }
        box { <0, -1, -1> <7, 10, 7> rotate -45*y translate <2.9, 0, 3.9> }
        box { <0, 0, -21> <20, 14, 21> rotate 46.5*z translate <-3.25, 9.75, 0> }
        box { <-22, -1, -21> <-15, 16.100001, 21> }
        difference {
          box { <-22.5, 14, -21> <-20.5, 17.1, 21> }
          cylinder { -22*z, 22*z, 1 translate <-20.5, 17.1, 0> }
        }
        box { <-5, -7, -21> <0, 0, 21> rotate 30*z translate <-15, 16.1, 0> }
        intersection {
          cylinder { -21*z, 21*z, 2 }
          box { <0, -3, -22> <3, 0, 22> }
          translate <-13.5, 10, 0>
        }
        box { <-18, 7.999999, -23> <-13.499999, 12, 23> }
      }
      difference {
        merge {
          cylinder { -21.9*z, -19*z, 4 translate <0, 0.000001, 0> }
          cylinder { 19*z, 21.9*z, 4 translate <0, 0.000001, 0> }
          box { <-0.000001, -4.000001, -21.900001> <14.250001, 4, -20.000001> }
          box { <-0.000001, -4.000001, 20.000001> <14.250001, 4, 21.900001> }
          box { <0, -0.000001, -21> <4.000002, 3.5, -18.999999> }
          box { <0, -0.000001, 18.999999> <4.000002, 3.5, 21> }
          box { <0, 3.000001, -21> <10, 3.999998, -18.999998> }
          box { <0, 3.000001, 18.999998> <10, 3.999998, 21> }
        }
        object { axle_opening(46,1) rotate -90*y translate <0, 0, -23> }
        translate <-17.5, 4, 0>
      }
      texture { color_tex }
      bounded_by { box { <-21.6, -0.1, -22> <3, 20.9, 22> } }
    }
  #end
#end
#macro bush(color_tex)
  #if (setting = 0)
    difference {
      sphere { <0, 0, 0> 1 scale <14, 22, 14> translate <0, 15, 0> }
      box { <-30, -50, -30> <30, 0, 30> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { 0*y, 3.1*y, 7.8 }
          cone { 3.099999*y, 7.799999, 4.500001*y, 8.799999 }
          cylinder { 4.5*y, 8*y, 8.8 }
          cylinder { 7.9*y, 11*y, 7.3 }
          cylinder { 10.9*y, 14*y, 5.8 }
          cylinder { 13.9*y, 20.9*y, 3.9 }
        }
        #if (setting > 1)
          box { <-6.4, -1, -6.4> <6.4, 2, 6.4> }
          cylinder { -1*y, 7.9*y, 6.3 }
          cylinder { -1*y, 10*y, 5.8 }
          cylinder { -1*y, 30*y, 1.500002 }
        #end
      }
      #local counter = 0;
      #while (counter < 8)
        difference {
          merge {
            cylinder { 0*y, 12.5*y, 1 }
            sphere { <0, 12.499999, 0> 1.000001 }
          }
          box { <0, -2, -2> <2, 15, 2> }
          rotate -30*z
          translate <8.799998, 4.500002, 0>
          rotate (counter*45)*y
        }
        difference {
          merge {
            cylinder { 0*y, 8.5*y, 1 }
            sphere { <0, 8.499999, 0> 1.000001 }
          }
          box { <0, -2, -2> <2, 11, 2> }
          rotate -30*z
          translate <8.799998, 4.500002, 0>
          rotate ((counter*45) + 22.5)*y
        }
        difference {
          merge {
            cylinder { 0*y, 13*y, 1 }
            sphere { <0, 12.999999, 0> 1.000001 }
          }
          box { <0, -2, -2> <2, 15, 2> }
          rotate -20*z
          translate <8.799998, 8.000001, 0>
          rotate ((counter*45) + 11.25)*y
        }
        difference {
          merge {
            cylinder { 0*y, 17*y, 1 }
            sphere { <0, 16.999999, 0> 1.000001 }
          }
          box { <0, -2, -2> <2, 19, 2> }
          rotate -20*z
          translate <8.799998, 8.000002, 0>
          rotate ((counter*45) + 33.75)*y
        }
        #local counter = counter + 1;
      #end
      #local counter = 0;
      #while (counter < 7)
        difference {
          merge {
            cylinder { 0*y, 17*y, 1 }
            sphere { <0, 16.999999, 0> 1.000001 }
          }
          box { <0, -2, -2> <2, 19, 2> }
          rotate -10*z
          translate <7.3, 10.999999, 0>
          rotate (counter*51.4)*y
        }
        difference {
          merge {
            cylinder { 0*y, 22.5*y, 1 }
            sphere { <0, 22.499999, 0> 1.000001 }
          }
          box { <0, -2, -2> <2, 25, 2> }
          rotate -10*z
          translate <7.3, 10.9, 0>
          rotate ((counter*51.4) + 25.7)*y
        }
        #local counter = counter + 1;
      #end
      #local counter = 0;
      #while (counter < 4)
        difference {
          merge {
            cylinder { 0*y, 25.5*y, 1 }
            sphere { <0, 25.499999, 0> 1.000001 }
          }
          box { <0, -2, -2> <2, 28.5, 2> }
          rotate -4*z
          translate <5.8, 13.999999, 0>
          rotate ((counter*90) + 45)*y
        }
        difference {
          merge {
            cylinder { 0*y, 23*y, 1 }
            sphere { <0, 22.999999, 0> 1.000001 }
          }
          box { <0, -2, -2> <2, 25, 2> }
          rotate -6*z
          translate <5.8, 13.999999, 0>
          rotate ((counter*90) + 67.5)*y
        }
        difference {
          merge {
            cylinder { -1*y, 20*y, 1 }
            sphere { <0, 19.999999, 0> 1.000001 }
          }
          box { <0, -2, -2> <2, 22, 2> }
          rotate -5*z
          translate <5.8, 13.999999, 0>
          rotate ((counter*90) + 22.5)*y
        }
        difference {
          merge {
            cylinder { -1*y, 19*y, 1 }
            sphere { <0, 18.999999, 0> 1.000001 }
          }
          box { <0, -2, -2> <2, 21, 2> }
          rotate -6*z
          translate <5.8, 13.999999, 0>
          rotate (counter*90)*y
        }
        #local counter = counter + 1;
      #end
      #if (setting > 1)
        difference {
          cylinder { 0*y, 11*y, 3.2 }
          cylinder { -1*y, 12*y, 2.6 }
        }
      #end
      object { open_rounded_button() translate <0, 17.8, 0> }
      texture { color_tex }
      bounded_by { box { <-17, -0.1, -17> <17, 43, 17> } }
    }
  #end
#end
#macro cam(color_tex)
  #if (setting = 0)
    merge {
      box { <0, 5, 0> <24, 10, 6.5> }
      cylinder { -5*x, 0*x, 3.2 translate <0, 7.5, 3.25> }
      cylinder { 2*x, 5*x, 3.2 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, 5, 0> <24, 10, 6.5> }
        object { open_rounded_button() translate <12, 7, 3.25> }
        object { open_rounded_button() translate <20, 7, 3.25> }
        object { open_rounded_button() rotate -90*z translate <21, 7.5, 3.25> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <12, 10, 3.25> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <20, 10, 3.25> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y rotate -90*z translate <24, 7.5, 3.25> }
        #end
        cylinder { 6*z, 11.35*z, 1.5 translate <4, 7.5, 0> }
        cylinder { 6*z, 11.5*z, 1.35 translate <4, 7.5, 0> }
        torus { 1.35, 0.15 rotate 90*x translate <4, 7.5, 11.35> }
        cylinder { -0.85*z, 0*z, 1.4 translate <20, 7.5, 0> }
        cylinder { -1*z, 0*z, 1.25 translate <20, 7.5, 0> }
        torus { 1.25, 0.15 rotate 90*x translate <20, 7.5, -0.85> }
        cylinder { -0.85*z, 0*z, 1.4 translate <2, 7.5, 0> }
        cylinder { -1*z, 0*z, 1.25 translate <2, 7.5, 0> }
        torus { 1.25, 0.15 rotate 90*x translate <2, 7.5, -0.85> }
        cylinder { -0.85*z, 0*z, 1.4 translate <6, 7.5, 0> }
        cylinder { -1*z, 0*z, 1.25 translate <6, 7.5, 0> }
        torus { 1.25, 0.15 rotate 90*x translate <6, 7.5, -0.85> }
        merge {
          cylinder { 0*y, 1.000001*y, 0.5 }
          cylinder { 0*y, 1.000001*y, 0.5 translate <4, 0, 0 > }
          box { <0, 0, -0.5> <4, 1, 0.5> }
          rotate -90*x
          translate <11, 7.5, 0>
        }
        difference {
          cylinder { -5*x, 0*x, 3.2 translate <0, 7.5, 3.25> }
          cylinder { -6*x, -3*x, 2.6 translate <0, 7.5, 3.25> }
        }
        difference {
          cylinder { 2*x, 5*x, 3.2 }
          cylinder { 1*x, 4*x, 2.6 }
        }
        cylinder { 4.95*x, 8.35*x, 2.4 }
        cylinder { 6*x, 8.5*x, 2.25 }
        torus { 2.25, 0.15 rotate 90*z translate <8.35, 0, 0> }
        box { <5, 0, -4.5> <7, -7, 0> rotate 30*x translate <0, 5, 6> }
        box { <3, 0, -4.5> <5, -7, -3.5> rotate 30*x translate <0, 5, 6> }
      }
      #if (setting > 1)
        cylinder { 1*z, 7*z, 1.6 translate <12, 7.5, 0> }
        cylinder { 1*z, 7*z, 1.6 translate <16, 7.5, 0> }
        cylinder { 1*z, 7*z, 1.6 translate <20, 7.5, 0> }
        merge {
          cylinder { 0*y, 1.000001*y, 0.5 }
          cylinder { 0*y, 1.000001*y, 0.5 translate <3, 0, 0 > }
          box { <0, 0, -0.5> <3, 1, 0.5> }
          translate <2.5, 9.5, 3.25>
        }
        merge {
          cylinder { 0*y, 1.000001*y, 0.5 }
          cylinder { 0*y, 1.000001*y, 0.5 translate <3, 0, 0 > }
          box { <0, 0, -0.5> <3, 1, 0.5> }
          translate <2.5, 9.5, 1.675>
        }
        merge {
          cylinder { 0*y, 1.000001*y, 0.5 }
          cylinder { 0*y, 1.000001*y, 0.5 translate <3, 0, 0 > }
          box { <0, 0, -0.5> <3, 1, 0.5> }
          translate <2.5, 9.5, 4.925>
        }
      #end
      cylinder { -6*x, 13*x, 1.600001 translate <0, 7.5, 3.25> }
      cylinder { 1*x, 13*x, 1.600001 }
      texture { color_tex }
      bounded_by { box { <-5.1, -4, -4> <25.9, 11.9, 11.6> } }
    }
  #end
#end
#macro cannon1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.0> <11.9, 6.3, 3.9> }
      cylinder { -10.5*x, -3.5*x, 3.25 translate <0, 2.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 6.3, 3.9> }
          object { open_rounded_button() translate <0, 3.2, 0> }
          object { open_rounded_button() translate <8, 3.2, 0> }
          object { open_rounded_button() rotate -90*z translate <8.8, 2.5, 0> }
          object { open_rounded_button() rotate -90*x translate <0, 2.5, -0.8> }
          object { open_rounded_button() rotate -90*x translate <8, 2.5, -0.8> }
          object { open_rounded_button() rotate 90*x translate <0, 2.5, 0.8> }
          object { open_rounded_button() rotate 90*x translate <8, 2.5, 0.8> }
          cylinder { -10.5*x, -7.3*x, 3.25 translate <0, 2.5, 0> }
          cylinder { -7.5*x, -3.5*x, 2.45 translate <0, 2.5, 0> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 5.4, 2.4> }
          cylinder { -1*y, 9*y, 1.600001 }
          cylinder { -1*y, 9*y, 1.600001 translate <8, 0, 0> }
          cylinder { -6*z, 6*z, 1.600001 translate <0, 2.5, 0> }
          cylinder { -6*z, 6*z, 1.600001 translate <8, 2.5, 0> }
          cylinder { -12*x, 15*x, 1.600001 translate <0, 2.5, 0> }
          cylinder { -11*x, -8.5*x, 2.6 translate <0, 2.5, 0> }
        #end
        #if (setting > 3)
          box { <2.75, 6.05, -2.3> <5.25, 7, 2.3> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 5.3*y, 1.5 translate <4, 0, 0> }
        box { <10.400001, 2, -2> <11.4, 3, 2> }
      #end
      #if (setting > 3)
        object { llogo() translate <4, 6.05, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-10.6, -0.85, -5.7> <13.7, 8.1, 5.7> } }
    }
  #end
#end
#macro canopal(color_tex)
  #if (setting = 0)
    merge {
      box { <-11.9, 0, -3.9> <35.9, 1.5, 42.9> rotate -90*x translate <0, -5.5, -3.899999> }
      box { <-3.9, 0, -3.9> <27.9, 28.7, 3.9> }
      texture { color_tex }
    }
  #else
    difference {
      merge{
        difference {
          box { <-3.9, 0, -3.9> <27.9, 28.7, 3.9> }
          box { <-2.4, 3.1, -4> <26.4, 27.2, 4> }
          cylinder { -4*x, 28*x, 0.9 translate <0, 15, -1.5> }
          #if (setting > 1)
            box { <-2.4, -1, -4> <26.4, 2, 2.4> }
          #end
        }
        box { <-3.5, 3, -0.5> <27.5, 4.1, 0.5> }
        #if (setting < 3)
          cylinder { 28.6*y, 30.4*y, 2.4 }
          cylinder { 28.6*y, 30.4*y, 2.4 translate <24, 0, 0> }
        #else
          object { rounded_button() translate <0, 25.6, 0> }
          object { rounded_button() translate <24, 25.6, 0> }
        #end
        object { open_rounded_button() translate <8, 25.6, 0> }
        object { open_rounded_button() translate <16, 25.6, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 25.6, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 25.6, 0> }
        #end
        object { pin(1) translate <4, 0, 0> }
        object { pin(1) translate <12, 0, 0> }
        object { pin(1) translate <20, 0, 0> }
        box { <-0.5, 0, -3.899999> <0.5, 2.1, -2.5> }
        box { <7.5, 0, -3.899999> <8.5, 2.1, -2.5> }
        box { <15.5, 0, -3.899999> <16.5, 2.1, -2.5> }
        box { <23.5, 0, -3.899999> <24.5, 2.1, -2.5> }
        difference {
          difference {
            merge {
              box { <-11.9, 0, -3.9> <35.9, 1.5, 42.9> }
              object { open_rounded_button() translate <-8, -1.6, 16> }
              object { open_rounded_button() translate <-8, -1.6, 24> }
              object { open_rounded_button() translate <8, -1.6, 0> }
              object { open_rounded_button() translate <16, -1.6, 0> }
              object { open_rounded_button() translate <32, -1.6, 16> }
              object { open_rounded_button() translate <32, -1.6, 24> }
              #if (setting > 3)
                object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <-8, 1.5, 16> }
                object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <-8, 1.5, 24> }
                object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 1.5, 0> }
                object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 1.5, 0> }
                object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <32, 1.5, 16> }
                object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <32, 1.5, 24> }
              #end
              box { <4, 0.1, 35.1> <20, 10, 42.900001> }
            }
            box { <3, 3, 40.999999> <21, 11, 44> }
            difference {
              box { <5.5, 0.000001, 36> <18.5, 11, 41> }
              box { <11, -2, 38> <13, 8, 40> }
              box { <11.5, -1, 35> <12.5, 6, 38.5> }
            }
            box { <3, 8, 40> <11, 11, 44> }
            box { <17, 8, 40> <29, 11, 44> }
            cylinder { 3*x, 11.000001*x, 1.6 translate <0, 7.5, 40> }
            cylinder { 16.999999*x, 29*x, 1.6 translate <0, 7.5, 40> }
            box { <-50, -1, -50> <0, 2, 50> rotate -45*y translate <-11.9, 0, 11.9> }
            box { <-50, -1, -50> <0, 2, 50> rotate 45*y translate <-11.9, 0, 27.9> }
            box { <0, -1, -50> <50, 2, 50> rotate -45*y translate <35.9, 0, 27.9> }
            box { <0, -1, -50> <50, 2, 50> rotate 45*y translate <35.9, 0, 11.9> }
            rotate -90*x
            translate <0, -5.5, -3.899999>
          }
          box { <-2.4, 3.100001, -8> <26.4, 27.200001, 8> }
        }
      }
      #if (setting > 1)
        cylinder { -1*y, 40*y, 0.75 translate <-1.5, 0, -1.25> }
        cylinder { -1*y, 40*y, 0.75 translate <-1.5, 0, 1.25> }
        cylinder { -1*y, 40*y, 0.75 translate <25.5, 0, -1.25> }
        cylinder { -1*y, 40*y, 0.75 translate <25.5, 0, 1.25> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -9.5, -13.5> <36, 37.5, 4> } }
    }
  #end
#end
#macro canopy_straight(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <83.9, 105.5, 43.9> }
      box { <-50, 0, -4> <0, 75, 44> rotate -32*z translate <-3.9, 48, 0> }
      box { <-50, 0, -4> <50, 75, 44> rotate 26*z translate <60, 105.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting < 3)
        cylinder { 105.4*y, 107.2*y, 2.4 translate <64, 0, 0> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <72, 0, 0> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <80, 0, 0> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <64, 0, 8> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <72, 0, 8> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <80, 0, 8> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <64, 0, 16> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <72, 0, 16> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <80, 0, 16> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <64, 0, 24> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <72, 0, 24> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <80, 0, 24> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <64, 0, 32> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <72, 0, 32> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <80, 0, 32> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <64, 0, 40> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <72, 0, 40> }
        cylinder { 105.4*y, 107.2*y, 2.4 translate <80, 0, 40> }
      #else
        object { rounded_button() rotate 180*y translate <64, 102.4, 0> }
        object { rounded_button() rotate 180*y translate <72, 102.4, 0> }
        object { rounded_button() rotate 180*y translate <80, 102.4, 0> }
        object { rounded_button() rotate 180*y translate <64, 102.4, 8> }
        object { rounded_button() rotate 180*y translate <72, 102.4, 8> }
        object { rounded_button() rotate 180*y translate <80, 102.4, 8> }
        object { rounded_button() rotate 180*y translate <64, 102.4, 16> }
        object { rounded_button() rotate 180*y translate <72, 102.4, 16> }
        object { rounded_button() rotate 180*y translate <80, 102.4, 16> }
        object { rounded_button() rotate 180*y translate <64, 102.4, 24> }
        object { rounded_button() rotate 180*y translate <72, 102.4, 24> }
        object { rounded_button() rotate 180*y translate <80, 102.4, 24> }
        object { rounded_button() rotate 180*y translate <64, 102.4, 32> }
        object { rounded_button() rotate 180*y translate <72, 102.4, 32> }
        object { rounded_button() rotate 180*y translate <80, 102.4, 32> }
        object { rounded_button() rotate 180*y translate <64, 102.4, 40> }
        object { rounded_button() rotate 180*y translate <72, 102.4, 40> }
        object { rounded_button() rotate 180*y translate <80, 102.4, 40> }
      #end
      difference {
        box { <-3.9, 0, -3.9> <83.9, 105.5, 43.9> }
        difference {
          box { <-1.9, 3.1, -5> <84, 102.4, 45> }
          box { <-50, 0, -6> <0, 75, 46> rotate -32*z translate <-1.7, 47.5, 0> }
          box { <-50, 0, -4> <50, 75, 44> rotate 26*z translate <59, 102.4, 0> }
        }
        box { <-50, 0, -4> <0, 75, 44> rotate -32*z translate <-3.9, 48, 0> }
        box { <-50, 0, -4> <50, 75, 44> rotate 26*z translate <60, 105.5, 0> }
        box { <3.9, -1, -5> <84, 5, 44> }
        #if (setting > 1)
          box { <61.6, 100, -2.4> <82.4, 104.4, 42.4> }
          box { <-2.4, -1, -2.4> <2.4, 2, 42.4> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <64, 0, 0> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <72, 0, 0> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <80, 0, 0> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <64, 0, 8> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <72, 0, 8> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <80, 0, 8> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <64, 0, 16> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <72, 0, 16> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <80, 0, 16> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <64, 0, 24> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <72, 0, 24> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <80, 0, 24> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <64, 0, 32> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <72, 0, 32> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <80, 0, 32> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <64, 0, 40> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <72, 0, 40> }
          cylinder { 103.4*y, 106.4*y, 1.2 translate <80, 0, 40> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <0, 0, 4> }
        object { pin(1) translate <0, 0, 12> }
        object { pin(1) translate <0, 0, 20> }
        object { pin(1) translate <0, 0, 28> }
        object { pin(1) translate <0, 0, 36> }
        object { ring() translate <68, 102.4, 4> }
        object { ring() translate <76, 102.4, 4> }
        object { ring() translate <68, 102.4, 12> }
        object { ring() translate <76, 102.4, 12> }
        object { ring() translate <68, 102.4, 20> }
        object { ring() translate <76, 102.4, 20> }
        object { ring() translate <68, 102.4, 28> }
        object { ring() translate <76, 102.4, 28> }
        object { ring() translate <68, 102.4, 36> }
        object { ring() translate <76, 102.4, 36> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <84, 107.3, 44> } }
    }
  #end
#end
#macro cap(color_tex)
  #if (setting = 0)
    difference {
      sphere { <0, 2.7, 0> 5.9 }
      box { <-8, -10, -8> <8, 0.4, 8> }
      scale <1, 0.85, 1>
      rotate -10*z
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { 0*y, 0.7*y, 5.9 translate <-5.5, 0, 0> }
          cylinder { 0.000002*y, 0.700001*y, 5.9 }
          box { <-5.5, 0.000001, -5.9> <0, 0.699999, 5.9> }
          difference {
            sphere { <0, 2.7, 0> 5.9 }
            box { <-8, -10, -8> <8, 0.4, 8> }
            scale <1, 0.85, 1>
          }
          cylinder { 0.7*y, 2.7*y, 5.89999 }
          difference {
            cylinder { -5*y, -0.2*y, 5.9 rotate -20*z translate <0.25, 2.7, 0> }
            box { <-10, -10, -10> <10, 0, 10> }
          }
          bounded_by { box { <-12, -0.1, -6.25> <6.25, 8, 6.25> } }
          rotate -10*z
        }
        #if (setting > 1)
          cylinder { -1*y, 6*y, 2.25 }
          cylinder { -1*y, 2*y, 5 }
          cone { 1.999999*y, 5, 4*y, 3 }
        #end
      }
      #if (setting > 1)
        object { ring() translate <0, 3, 0> }
      #end
      texture { color_tex }
    }
  #end
#end
#macro cap_2(color_tex)
  #if (setting = 0)
    cone { 0*y, 6.1, 11*y, 5.25 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cone { 0*y, 6.1, 11*y, 5.25 }
          difference {
            cylinder { 0*y, 4*y, 5.9 translate <-2.6, 0, 0> }
            box { <-10, 0, -10> <10, 10, 10> rotate 18*z translate <-2.6, 2.5, 0> }
          }
          difference {
            merge {
              sphere { <0, 0, 0> 2 scale <0.75, 1, 1> translate <-5, 13, 0> }
              difference {
                sphere { <0, 0, 0> 2 scale <0.75, 3, 1> translate <-5, 13, 0> }
                box { <-10, 13, -5> <10, 20, 5> }
              }
            }
            box { <-4.75, 11, -10> <10, 16, 10> }
          }
        }
        #if (setting > 1)
          cylinder { -1*y, 2*y, 5 }
          cone { -1*y, 5, 10*y, 4.25 }
        #end
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 8*y, 3.2 }
          cylinder { -1*y, 9*y, 2.6 }
          translate <0, 3, 0>
        }
      #end
      texture { color_tex }
      bounded_by { box { <-10, -0.1, -6.2> <6.25, 15.1, 6.2> } }
    }
  #end
#end
#macro cap_3(color_tex)
  #if (setting = 0)
    cylinder { -0.9*y, 4.9*y, 6.6 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          difference {
            sphere { <0, 0, 0> 1 scale <6.6, 1.2, 6.7> rotate -7*x translate <0, 4.25, 0> }
            box { <-10, -10, -10> <10, 10, -0.000001> }
          }
          difference {
            sphere { <0, 0, 0> 1 scale <6.6, 1.2, 6.7> rotate 6*x translate <0, 4.25, 0> }
            box { <-10, -10, 0.000001> <10, 10, 10> }
          }
          cone { 0.5*y, 6.25, 4*y, 5.75 }
          cone { 0.5*y, 6.25, 2.3*y, 4.45 rotate -6*x translate <0, 0, -1.5> }
        }
        box { <-10, -10, -20> <10, 1, 20> rotate -6*x }
        cylinder { -5*y, 4*y, 5 }
      }
      #if (setting > 1)
        object { ring() translate <0, 3, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-6.7, -1, -8> <6.7, 6, 6.8> } }
    }
  #end
#end
#macro cargo_door(color_tex, bumped)
  #if (setting = 0)
    difference {
      box { <-14.3, -1.55, -3.9> <1.55, 27.25, 27.9> }
      box { <-40, 0, -10> <40, 50, 30> rotate -43.5*z translate <-6.55, 27.25, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { -3.900001*z, 26.750001*z, 1.55 }
          box { <-1.550001, 0, -3.9> <1.550001, 20, 27.9> }
          box { <-14.300002, 19.5, -3.900002> <1.550002, 27.25, 27.900002> }
          #if (setting < 3)
            cylinder { 27.15*y, 28.95*y, 2.4 translate <-10.5, 0, 0> }
            cylinder { 27.15*y, 28.95*y, 2.4 translate <-10.5, 0, 8> }
            cylinder { 27.15*y, 28.95*y, 2.4 translate <-10.5, 0, 16> }
            cylinder { 27.15*y, 28.95*y, 2.4 translate <-10.5, 0, 24> }
          #else
            object { rounded_button() rotate 180*y translate <-10.5, 24.15, 0> }
            object { rounded_button() rotate 180*y translate <-10.5, 24.15, 8> }
            object { rounded_button() rotate 180*y translate <-10.5, 24.15, 16> }
            object { rounded_button() rotate 180*y translate <-10.5, 24.15, 24> }
          #end
        }
        #if (bumped = 1)
          box { <0, 0, -10> <40, 50, 30> texture { color_tex normal { bumping } }
            rotate -43.5*z translate <-6.55, 27.25, 0> }
        #else
          box { <0, 0, -10> <40, 50, 30> rotate -43.5*z translate <-6.55, 27.25, 0> }
        #end
        box { <-15, 12, -4> <-6.55, 24.25, 28> }
        difference {
          box { <-15, 15, -2.399999> <1.55, 26.250003, 26.399999> }
          box { <-40, 0, -10> <40, 50, 30> rotate -43.5*z translate <-6.55, 25.25, 0> }
          box { <-40, -50, -10> <40, 0, 30> rotate -43.5*z translate <-6.55, 24.25, 0> }
          box { <0.5, -50, -50> <5, 50, 50> }
        }
        difference {
          box { <-30, 0, -4> <-1.55, 24.250001, 28> }
          box { <-40, 0, -10> <40, 50, 30> rotate -43.5*z translate <-6.55, 24.25, 0> }
        }
        difference {
          box { <-30, 3, -2.4> <0.500001, 26.250002, 26.4> }
          box { <-40, 0, -10> <40, 50, 30> rotate -43.5*z translate <-6.55, 26.25, 0> }
          box { <0.5, -50, -50> <5, 50, 50> }
        }
        #if (setting > 1)
          box { <-2, -2, -5> <2, 2, -2.45> }
          box { <-2, -2, 3.2> <2, 2, 4.8> }
          box { <-2, -2, 11.2> <2, 2, 12.8> }
          box { <-2, -2, 19.2> <2, 2, 20.8> }
          box { <-2, -2, 26.45> <2, 2, 29> }
          box { <-3, 0, -1> <0.500002, 5, 1.75> }
          box { <-3, 0, 6.25> <0.500002, 5, 9.75> }
          box { <-3, 0, 14.25> <0.500002, 5, 17.75> }
          box { <-3, 0, 22.25> <0.500002, 5, 25> }
          sphere { <0, 0, -3.95>, 2 }
          sphere { <0, 0, 27.95>, 2 }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            box { <-14.300001, 24.250001, 2.5> <1.55, 27, 3.5> }
            box { <-14.300001, 24.250001, 4.5> <1.55, 27, 5.5> }
            box { <-14.300001, 24.250001, 10.5> <1.55, 27, 11.5> }
            box { <-14.300001, 24.250001, 12.5> <1.55, 27, 13.5> }
            box { <-14.300001, 24.250001, 18.5> <1.55, 27, 19.5> }
            box { <-14.300001, 24.250001, 20.5> <1.55, 27, 21.5> }
          }
          box { <-40, 0, -10> <40, 50, 30> rotate -43.5*z translate <-6.55, 27.2, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-14.4, -1.65, -4> <2, 29.05, 28> } }
    }
  #end
#end
#macro cart_base7_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      box { <36.1, 0, -3.9> <51.9, 3.1, 11.9> }
      box { <12.1, -3.2, -11.9> <35.9, 0.000001, 19.9> }
      box { <4.1, -3.200001, -3.899999> <43.9, 0.000002, 11.899999> }
      cylinder { -10*z, 18*z, 1.5 translate <4, 0.95, 0> }
      cylinder { -10*z, 18*z, 1.5 translate <44, 0.95, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
          box { <36.1, 0, -3.9> <51.9, 3.1, 11.9> }
          box { <12.1, -3.2, -11.9> <35.9, 0.000001, 19.9> }
          box { <4.1, -3.200001, -3.899999> <43.9, 0.000002, 11.899999> }
          cylinder { 11.899999*z, 13*z, 1.9 translate <4, 0.95, 0> }
          cylinder { -3.899999*z, -5*z, 1.9 translate <4, 0.95, 0> }
          cylinder { 11.899999*z, 13*z, 1.9 translate <44, 0.95, 0> }
          cylinder { -3.899999*z, -5*z, 1.9 translate <44, 0.95, 0> }
          box { <-4, 0.000001, 0> <0, 2, 2> rotate 25*y translate <2, 0, -5> }
          box { <-4, 0.000001, -2> <0, 2, 0> rotate -25*y translate <2, 0, 13> }
          box { <0, 0.000001, 0> <4, 2, 2> rotate -25*y translate <6, 0, -5> }
          box { <0, 0.000001, -2> <4, 2, 0> rotate 25*y translate <6, 0, 13> }
          box { <-4, 0.000001, 0> <0, 2, 2> rotate 25*y translate <42, 0, -5> }
          box { <-4, 0.000001, -2> <0, 2, 0> rotate -25*y translate <42, 0, 13> }
          box { <0, 0.000001, 0> <4, 2, 2> rotate -25*y translate <46, 0, -5> }
          box { <0, 0.000001, -2> <4, 2, 0> rotate 25*y translate <46, 0, 13> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { -0.1*y, 1.7*y, 2.4 translate <16, 0, -8> }
            cylinder { -0.1*y, 1.7*y, 2.4 translate <16, 0, 0> }
            cylinder { -0.1*y, 1.7*y, 2.4 translate <16, 0, 8> }
            cylinder { -0.1*y, 1.7*y, 2.4 translate <16, 0, 16> }
            cylinder { -0.1*y, 1.7*y, 2.4 translate <24, 0, -8> }
            cylinder { -0.1*y, 1.7*y, 2.4 translate <24, 0, 0> }
            cylinder { -0.1*y, 1.7*y, 2.4 translate <24, 0, 8> }
            cylinder { -0.1*y, 1.7*y, 2.4 translate <24, 0, 16> }
            cylinder { -0.1*y, 1.7*y, 2.4 translate <32, 0, -8> }
            cylinder { -0.1*y, 1.7*y, 2.4 translate <32, 0, 0> }
            cylinder { -0.1*y, 1.7*y, 2.4 translate <32, 0, 8> }
            cylinder { -0.1*y, 1.7*y, 2.4 translate <32, 0, 16> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <40, 0, 0> }
            object { rounded_button() translate <48, 0, 0> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() translate <48, 0, 8> }
            object { rounded_button() translate <16, -3.1, -8> }
            object { rounded_button() translate <16, -3.1, 0> }
            object { rounded_button() translate <16, -3.1, 8> }
            object { rounded_button() translate <16, -3.1, 16> }
            object { rounded_button() translate <24, -3.1, -8> }
            object { rounded_button() translate <24, -3.1, 0> }
            object { rounded_button() translate <24, -3.1, 8> }
            object { rounded_button() translate <24, -3.1, 16> }
            object { rounded_button() translate <32, -3.1, -8> }
            object { rounded_button() translate <32, -3.1, 0> }
            object { rounded_button() translate <32, -3.1, 8> }
            object { rounded_button() translate <32, -3.1, 16> }
          #end
          difference {
            merge {
              cylinder { 12*z, 17.9*z, 1.5 }
              cylinder { 17.4*z, 17.999991*z, 1.75 }
            }
            cylinder { -3*y, 3*y, 0.4 translate <0, 0, 15.4> }
            box { <-0.4, -3, 15.399999> <0.4, 3, 19> }
            translate <4, 0.95, 0>
          }
          difference {
            merge {
              cylinder { 12*z, 17.9*z, 1.5 }
              cylinder { 17.4*z, 17.999991*z, 1.75 }
            }
            cylinder { -3*y, 3*y, 0.4 translate <0, 0, 15.4> }
            box { <-0.4, -3, 15.399999> <0.4, 3, 19> }
            translate <44, 0.95, 0>
          }
          difference {
            merge {
              cylinder { -4*z, -9.9*z, 1.5 }
              cylinder { -9.4*z, -9.999991*z, 1.75 }
            }
            cylinder { -3*y, 3*y, 0.4 translate <0, 0, -7.4> }
            box { <-0.4, -3, -7.399999> <0.4, 3, -11> }
            translate <4, 0.95, 0>
          }
          difference {
            merge {
              cylinder { -4*z, -9.9*z, 1.5 }
              cylinder { -9.4*z, -9.999991*z, 1.75 }
            }
            cylinder { -3*y, 3*y, 0.4 translate <0, 0, -7.4> }
            box { <-0.4, -3, -7.399999> <0.4, 3, -11> }
            translate <44, 0.95, 0>
          }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <4, 2, 10.4> }
          box { <5.6, -4, -2.4> <10.4, 2, 10.4> }
          box { <12, -4, -2.4> <36, -1.1, 10.4> }
          box { <37.6, -4, -2.4> <42.4, 2, 10.4> }
          box { <44, -1, -2.4> <50.4, 2, 10.4> }
          box { <13.6, -4, -10.4> <34.4, -1.1, -4> }
          box { <13.6, -4, 12> <34.4, -1.1, 18.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { -2.2*y, 0.8*y, 1.2 translate <16, 0, -8> }
          cylinder { -2.2*y, 0.8*y, 1.2 translate <16, 0, 0> }
          cylinder { -2.2*y, 0.8*y, 1.2 translate <16, 0, 8> }
          cylinder { -2.2*y, 0.8*y, 1.2 translate <16, 0, 16> }
          cylinder { -2.2*y, 0.8*y, 1.2 translate <24, 0, -8> }
          cylinder { -2.2*y, 0.8*y, 1.2 translate <24, 0, 0> }
          cylinder { -2.2*y, 0.8*y, 1.2 translate <24, 0, 8> }
          cylinder { -2.2*y, 0.8*y, 1.2 translate <24, 0, 16> }
          cylinder { -2.2*y, 0.8*y, 1.2 translate <32, 0, -8> }
          cylinder { -2.2*y, 0.8*y, 1.2 translate <32, 0, 0> }
          cylinder { -2.2*y, 0.8*y, 1.2 translate <32, 0, 8> }
          cylinder { -2.2*y, 0.8*y, 1.2 translate <32, 0, 16> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 2.1*y, 1.5 translate <0, 0, 4> }
        cylinder { 0*y, 2.1*y, 1.5 translate <48, 0, 4> }
        cylinder { 0*y, 2.1*y, 1.5 translate <20, -2.9, -8> }
        cylinder { 0*y, 2.1*y, 1.5 translate <28, -2.9, -8> }
        cylinder { 0*y, 2.1*y, 1.5 translate <20, -2.9, 16> }
        cylinder { 0*y, 2.1*y, 1.5 translate <28, -2.9, 16> }
        cylinder { -3.2*y, 2.1*y, 1.5 translate <8, 0, 4> }
        cylinder { -3.2*y, 2.1*y, 1.5 translate <40, 0, 4> }
        difference {
          cylinder { -3.2*y, -0.1*y, 3.2 }
          cylinder { -4*y, 1*y, 2.6 }
          translate <20, 0, 4>
        }
        difference {
          cylinder { -3.2*y, -0.1*y, 3.2 }
          cylinder { -4*y, 1*y, 2.6 }
          translate <28, 0, 4>
        }
        box { <2.5, 0.000001, -0.5> <4.2, 2.1, 0.5> }
        box { <2.5, 0.000001, 7.5> <4.2, 2.1, 8.5> }
        box { <11.8, -3.199999, -0.5> <13.5, -0.1, 0.5> }
        box { <11.8, -3.199999, 7.5> <13.5, -0.1, 8.5> }
        box { <15.5, -3.199999, -5.5> <16.5, -0.1, -3.8> }
        box { <23.5, -3.199999, -5.5> <24.5, -0.1, -3.8> }
        box { <31.5, -3.199999, -5.5> <32.5, -0.1, -3.8> }
        box { <15.5, -3.199999, 11.8> <16.5, -0.1, 13.5> }
        box { <23.5, -3.199999, 11.8> <24.5, -0.1, 13.5> }
        box { <31.5, -3.199999, 11.8> <32.5, -0.1, 13.5> }
        box { <34.5, -3.199999, -0.5> <36.2, -0.1, 0.5> }
        box { <34.5, -3.199999, 7.5> <36.2, -0.1, 8.5> }
        box { <43.8, 0.000001, -0.5> <45.5, 2.1, 0.5> }
        box { <43.8, 0.000001, 7.5> <45.5, 2.1, 8.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -3.3, -12> <52, 4.9, 20> } }
    }
  #end
#end
#macro castle_door_large(color_tex)
  #if (setting = 0)
    merge {
      box { <-1, -25.800001, -1.000001> <35.6, 20.6, 1.000001> }
      intersection {
        cylinder { -1.000005*z, 1.000005*z, 36.6 scale <1, 1.16573033708, 1> }
        box { <-40, 0, -2> <0, 50, 2> }
        translate <35.6, 20.6, 0>
      }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { -1.000007*z, 1.000007*z, 2.6 translate <32, 10, 0> }
      object { open_rounded_button() rotate -90*x translate <32, 10, 2> }
      object { open_rounded_button() rotate 90*x translate <32, 10, -2> }
      cylinder { -1.000005*z, 1.000005*z, 2 translate <3, 0, 0> }
      cylinder { -1.000005*z, 1.000005*z, 2 translate <3, 2.5, 0> }
      cylinder { -1.000005*z, 1.000005*z, 2 translate <3, 20.5, 0> }
      cylinder { -1.000005*z, 1.000005*z, 2 translate <3, 18, 0> }
      box { <2.000001, -2, -1.000004> <3, 4.5, 1.000004> }
      box { <2.000001, 16, -1.000004> <3, 22.5, 1.000004> }
      box { <4, 0, -1.000007> <30, 2.5, 1.000007> }
      box { <4, 18, -1.000007> <30, 20.5, 1.000007> }
      box { <3, 36, -1.000007> <30, 38.5, 1.000007> }
      cylinder { -1.000008*z, 1.000008*z, 1.25 translate <30, 1.25, 0> }
      cylinder { -1.000008*z, 1.000008*z, 1.25 translate <30, 19.25, 0> }
      cylinder { -1.000008*z, 1.000008*z, 1.25 translate <30, 37.25, 0> }
      #local counter = 0;
      #while (counter < 4)
        sphere { <7+(counter*7.666667), 1.25, -1> 0.4 }
        sphere { <7+(counter*7.666667), 1.25, 1> 0.4 }
        sphere { <7+(counter*7.666667), 19.25, -1> 0.4 }
        sphere { <7+(counter*7.666667), 19.25, 1> 0.4 }
        sphere { <7+(counter*7.666667), 37.25, -1> 0.4 }
        sphere { <7+(counter*7.666667), 37.25, 1> 0.4 }
        #local counter = counter + 1;
      #end
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <32, 10, -1> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y rotate 90*x translate <32, 10, 1> }
      #end
      difference {
        merge {
          cylinder { 20.6*y, -25.8*y, 1 }
          box { <0, -25.800001, -1.000001> <35.6, 20.6, 1.000001> }
          intersection {
            merge {
              cylinder { -1.000005*z, 1.000005*z, 35.6 scale <1, 1.16573033708, 1> }
              torus { 35.6, 1 rotate 90*x scale <1, 1.16573033708, 1> }
            }
            box { <-40, 0, -2> <0, 50, 2> }
            translate <35.6, 20.6, 0>
          }
        }
        box { <-2, 0, -2> <2, 2.5, 2> }
        box { <-2, 18, -2> <2, 20.5, 2> }
        difference {
          merge {
            box { <2, -22.9, -2> <32.6, 20.600001, 2> }
            intersection {
              cylinder { -2*z, 2*z, 33.6 scale <1, 1.16573033708, 1> }
              box { <-40, 0, -2> <-3, 50, 2> }
              translate <35.6, 20.6, 0>
            }
          }
          box { <1, -23, -0.7> <33, 70, 0.7> }
          #local counter = 0;
          #while (counter < 7)
            box { <5+(counter*3.9), -23, -2> <6+(counter*3.9), 70, -0.35> }
            box { <5+(counter*3.9), -23, 2> <6+(counter*3.9), 70, 0.35> }
            #local counter = counter + 1;
          #end
          texture { color_tex normal { bumping } }
        }
      }
      sphere { <0, 2.5, 0> 1 }
      sphere { <0, 18, 0> 1 }
      texture { color_tex }
      bounded_by { box { <-1.1, -25.9, -2.9> <35.7, 64, 2.9> } }
    }
  #end
#end
#macro castle_wall_window(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <19.9, 57.5, 3.9> }
      box { <-11.9, 9.6, -3.900001> <27.9, 47.9, 3.900001> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 57.5, 3.9> }
          box { <-11.9, 9.6, -3.900001> <27.9, 47.9, 3.900001> }
          box { <-3.900001, 51.1, 2> <19.900001, 54.3, 11.9> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <18.4, 2, 2.4> }
          box { <-10.4, 0, -2.4> <-3.900002, 11.6, 2.4> }
          box { <19.900002, 0, -2.4> <26.4, 11.6, 2.4> }
        #end
        box { <-3, 54.3, -3> <19, 58, 3> }
        box { <-2.4, 3.1, -2.4> <18.4, 53, 12> }
        box { <-10.4, 12.7, -2.400001> <26.4, 46.4, 12> }
        cylinder { -4*z, 4*z, 4.2 translate <8, 40.2, 0> }
        box { <3.8, 28.7, -4> <12.2, 40.2, 0> }
      }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <-8, 47.9, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 54.3, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 54.3, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <16, 54.3, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <24, 47.9, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 54.3, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 54.3, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <16, 54.3, 8> }
      #end
      object { open_rounded_button() translate <-8, 44.8, 0> }
      object { open_rounded_button() translate <24, 44.8, 0> }
      object { open_rounded_button() translate <0, 51.2, 8> }
      object { open_rounded_button() translate <8, 51.2, 8> }
      object { open_rounded_button() translate <16, 51.2, 8> }
      object { open_rounded_button() translate <0, 54.4, 0> }
      object { open_rounded_button() translate <8, 54.4, 0> }
      object { open_rounded_button() translate <16, 54.4, 0> }
      difference {
        cylinder { 54.2*y, 57.400001*y, 2.400001 }
        cylinder { 54*y, 60*y, 1.600001 }
        translate <0, 0, 0>
      }
      difference {
        cylinder { 54.2*y, 57.400001*y, 2.400001 }
        cylinder { 54*y, 60*y, 1.600001 }
        translate <8, 0, 0>
      }
      difference {
        cylinder { 54.2*y, 57.400001*y, 2.400001 }
        cylinder { 54*y, 60*y, 1.600001 }
        translate <16, 0, 0>
      }
      #if (setting > 1)
        box { <-5.6, 9.600001, -0.5> <-4, 11.7, 0.5> }
        box { <19.8, 9.600001, -0.5> <21.6, 11.7, 0.5> }
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <28, 59.3, 12> } }
    }
  #end
#end
#macro chain_saw(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 8*y, 1.5 }
      box { <-4.7, 7.9, -0.499999> <4.7, 24.000001, 0.499999> }
      cylinder { -0.5*z, 0.5*z, 4.7 translate <0, 24, 0> }
      texture { color_tex }
    }
  #else
    intersection {
      merge {
        #if (setting > -1)
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*x translate <0, 24, -0.5> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*x translate <0, 24, 0.5> }
        #end
        cylinder { 0.15*y, 8*y, 1.5 }
        cylinder { 0*y, 5*y, 1.35 }
        torus { 1.35, 0.15 }
        difference {
          merge {
            cylinder { -3.1*z, 3.1*z, 2.4 }
            cylinder { -3.25*z, 3.25*z, 2.25 }
            torus { 2.25, 0.15 rotate 90*x translate <0, 0, -3.1> }
            torus { 2.25, 0.15 rotate 90*x translate <0, 0, 3.1> }
          }
          cylinder { -4*z, 4*z, 1.6 }
          translate <0, 24, 0>
        }
        cylinder { -0.499998*z, 0.499998*z, 2.1 translate <0, 23.999999, 0> }
        box { <-2.2, 7.9, -0.499999> <2.2, 24.000001, 0.499999> }
        box { <-0.5, 7.899999, -1.600001> <0.5, 21.8, 1.600001> }
        box { <-2.300001, 7.899999, -1.600001> <-1.5, 24, 1.600001> }
        box { <1.5, 7.899999, -1.600001> <2.300001, 24, 1.600001> }
        box { <-1.5, -1.5, -0.5> <1.5, 1.5, 0.5> rotate 45*z scale <1.35, 0.85, 1>
          translate <-2.3, 24, 0> }
        box { <-1.5, -1.5, -0.500001> <1.5, 1.5, 0.500001> rotate 45*z scale <1.3, 0.85, 1>
          translate <-2.3, 21, 0> }
        box { <-1.5, -1.5, -0.500002> <1.5, 1.5, 0.500002> rotate 45*z scale <1.3, 0.85, 1>
          translate <-2.3, 17.9, 0> }
        box { <-1.5, -1.5, -0.500003> <1.5, 1.5, 0.500003> rotate 45*z scale <1.3, 0.85, 1>
          translate <-2.3, 14.8, 0> }
        box { <-1.5, -1.5, -0.500004> <1.5, 1.5, 0.500004> rotate 45*z scale <1.3, 0.85, 1>
          translate <-2.3, 11.7, 0> }
        box { <-1.5, -1.5, -0.5> <1.5, 1.5, 0.5> rotate 45*z scale <1.3, 0.85, 1>
          translate <2.3, 24, 0> }
        box { <-1.5, -1.5, -0.500001> <1.5, 1.5, 0.500001> rotate 45*z scale <1.3, 0.85, 1>
          translate <2.3, 21, 0> }
        box { <-1.5, -1.5, -0.500002> <1.5, 1.5, 0.500002> rotate 45*z scale <1.3, 0.85, 1>
          translate <2.3, 17.9, 0> }
        box { <-1.5, -1.5, -0.500003> <1.5, 1.5, 0.500003> rotate 45*z scale <1.3, 0.85, 1>
          translate <2.3, 14.8, 0> }
        box { <-1.5, -1.5, -0.500004> <1.5, 1.5, 0.500004> rotate 45*z scale <1.3, 0.85, 1>
          translate <2.3, 11.7, 0> }
        box { <-1.5, -1.5, -0.500005> <1.5, 1.5, 0.500005> rotate 45*z scale <0.85, 1.3, 1>
          translate <0, 26.3, 0> }
        box { <-1.5, -1.5, -0.500006> <1.5, 1.5, 0.500006> rotate 45*z scale <1.3, 0.85, 1>
          translate <-2.3, 0, 0> rotate -45*z translate <0, 24, 0> }
        box { <-1.5, -1.5, -0.500007> <1.5, 1.5, 0.500007> rotate 45*z scale <1.3, 0.85, 1>
          translate <2.3, 0, 0> rotate 45*z translate <0, 24, 0> }
        box { <-1.5, -1.5, -0.500006> <1.5, 1.5, 0.500006> rotate 45*z scale <1.3, 0.85, 1>
          translate <-2.3, 0, 0> rotate 30*z translate <0, 11.7, 0> }
        box { <-1.5, -1.5, -0.500007> <1.5, 1.5, 0.500007> rotate 45*z scale <1.3, 0.85, 1>
          translate <2.3, 0, 0> rotate -30*z translate <0, 11.7, 0> }
      }
      merge {
        cylinder { -3.35*z, 3.35*z, 4.7 translate <0, 24, 0> }
        box { <-4.7, -0.05, -3.35> <4.7, 24.000001, 3.35> }
      }
      texture { color_tex }
      bounded_by { box { <-4.7, -0.1, -3.35> <4.7, 29, 3.35> } }
    }
  #end
#end
#macro clawh_block1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      box { <2, 3.2, -11> <6, 6.3, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 180*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <8, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      difference {
        merge {
          box { <2, 3.200002, -9> <6, 6.299998, -3> }
          cylinder { 3.200003*y, 6.299997*y, 3 translate <4, 0, -8> }
          box { <1, 3.200001, -11> <7, 6.299999, -7.999999> }
        }
        cylinder { 3*y, 7*y, 1.6 translate <4, 0, -8> }
        box { <2.5, 3, -11.05> <5.5, 7, -8> }
        cylinder { 3*y, 7*y, 0.5 translate <4, 0, -4.4> }
        box { <3.5, 3, -10> <4.5, 7, -4.4> }
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 8.7*y, 1.5 }
          cylinder { -1*y, 2*y, 0.7 }
          translate <4, 0, 0>
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -11.1> <12, 11.3, 4> } }
    }
  #end
#end
#macro claw_f_winglet6_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 3.1, 43.9> }
      box { <30, -10, -50> <-30, 10, 0> rotate -45*y translate <28.1, 0, -3.9> }
      box { <30, -10, -50> <-30, 10, 0> rotate 45*y translate <11.9, 0, -3.9> }
      box { <30, -10, -50> <-30, 10, 0> rotate -135*y translate <28.1, 0, 43.9> }
      box { <30, -10, -50> <-30, 10, 0> rotate 135*y translate <11.9, 0, 43.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 43.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 40> }
          #else
            object { rounded_button() rotate 90*y translate <16, 0, 0> }
            object { rounded_button() rotate 90*y translate <24, 0, 0> }
            object { rounded_button() rotate 90*y translate <8, 0, 8> }
            object { rounded_button() rotate 90*y translate <16, 0, 8> }
            object { rounded_button() rotate 90*y translate <24, 0, 8> }
            object { rounded_button() rotate 90*y translate <32, 0, 8> }
            object { rounded_button() rotate 90*y translate <0, 0, 16> }
            object { rounded_button() rotate 90*y translate <8, 0, 16> }
            object { rounded_button() rotate 90*y translate <40, 0, 16> }
            object { rounded_button() rotate 90*y translate <32, 0, 16> }
            object { rounded_button() rotate 90*y translate <0, 0, 24> }
            object { rounded_button() rotate 90*y translate <8, 0, 24> }
            object { rounded_button() rotate 90*y translate <40, 0, 24> }
            object { rounded_button() rotate 90*y translate <32, 0, 24> }
            object { rounded_button() rotate 90*y translate <8, 0, 32> }
            object { rounded_button() rotate 90*y translate <16, 0, 32> }
            object { rounded_button() rotate 90*y translate <24, 0, 32> }
            object { rounded_button() rotate 90*y translate <32, 0, 32> }
            object { rounded_button() rotate 90*y translate <16, 0, 40> }
            object { rounded_button() rotate 90*y translate <24, 0, 40> }
          #end
        }
        #if (setting > 1)
          box { <16, -1, 16> <24, 5, 24> }
          difference {
            box { <-2.4, -1, -2.4> <42.4, 2, 42.4> }
            box { <30, -10, -50> <-30, 10, 0> rotate -45*y translate <27.1, 0, -2.9> }
            box { <30, -10, -50> <-30, 10, 0> rotate 45*y translate <12.9, 0, -2.9> }
            box { <30, -10, -50> <-30, 10, 0> rotate 135*y translate <12.9, 0, 42.9> }
            box { <30, -10, -50> <-30, 10, 0> rotate -135*y translate <27.1, 0, 42.9> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 40> }
        #end
        box { <30, -10, -50> <-30, 10, 0> rotate -45*y translate <28.1, 0, -3.9> }
        box { <30, -10, -50> <-30, 10, 0> rotate 45*y translate <11.9, 0, -3.9> }
        box { <30, -10, -50> <-30, 10, 0> rotate -135*y translate <28.1, 0, 43.9> }
        box { <30, -10, -50> <-30, 10, 0> rotate 135*y translate <11.9, 0, 43.9> }
        box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate 45*y translate <0, 0, 8> }
        box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate 45*y translate <8, 0, 0> }
        box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate -45*y translate <32, 0, 0> }
        box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate -45*y translate <40, 0, 8> }
        box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate 135*y translate <0, 0, 32> }
        box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate 135*y translate <8, 0, 40> }
        box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate -135*y translate <32, 0, 40> }
        box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate -135*y translate <40, 0, 32> }
      }
      #if (setting > 1)
        box { <6.5, 0, 10.2> <33.5, 2.1, 11.4> }
        box { <10.2, 0.000001, 6.5> <11.4, 2.1, 33.5> }
        box { <6.5, 0.000002, 28.6> <33.5, 2.1, 29.8> }
        box { <28.6, 0.000003, 6.5> <29.8, 2.1, 33.5> }
        difference {
          cylinder { 0*y, 2.1*y, 7 }
          cylinder { -1*y, 3*y, 5.6 }
          translate <20, 0, 20>
        }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <36, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <36, 0, 20> }
        object { ring() translate <4, 0, 28> }
        object { ring() translate <36, 0, 28> }
        object { ring() translate <12, 0, 36> }
        object { ring() translate <20, 0, 36> }
        object { ring() translate <28, 0, 36> }
        box { <0.1, 0.25, -0.5> <3, 2.1, 0.5> rotate -45*y translate <4, 0, 4> }
        box { <0.1, 0.25, -0.5> <3, 2.1, 0.5> rotate -135*y translate <36, 0, 4> }
      #end
      difference {
        merge {
          box { <48, -0.500001, 12.050001> <49.6, 5.500001, 15.150001> }
          box { <43, 0.000001, 12.049999> <48.1, 3.099999, 15.149999> }
          cylinder { -1.55*z, 1.55*z, 3 translate <48, 2.5, 13.6> }
          box { <48, -0.500001, 24.850001> <49.6, 5.500001, 27.950001> }
          box { <43, 0.000001, 24.849999> <48.1, 3.099999, 27.949999> }
          cylinder { -1.55*z, 1.55*z, 3 translate <48, 2.5, 26.4> }
          box { <-8, -0.500001, 12.050001> <-9.6, 5.500001, 15.150001> }
          box { <-3, 0.000001, 12.049999> <-8.1, 3.099999, 15.149999> }
          cylinder { -1.55*z, 1.55*z, 3 translate <-8, 2.5, 13.6> }
          box { <-8, -0.500001, 24.850001> <-9.6, 5.500001, 27.950001> }
          box { <-3, 0.000001, 24.849999> <-8.1, 3.099999, 27.949999> }
          cylinder { -1.55*z, 1.55*z, 3 translate <-8, 2.5, 26.4> }
        }
        box { <48, 1, 10> <58, 4, 30> }
        box { <49.600001, 0, 10> <55, 10, 30> }
        cylinder { -10*z, 10*z, 1.6 translate <48, 2.5, 20> }
        box { <-8, 1, 10> <-10, 4, 30> }
        box { <-9.600001, 0, 10> <-15, 10, 30> }
        cylinder { -10*z, 10*z, 1.6 translate <-8, 2.5, 20> }
        cylinder { -1*y, 1*y, 0.65 translate <-4.65, 0, 13.6> }
        cylinder { -1*y, 1*y, 0.65 translate <-4.65, 0, 26.4> }
        cylinder { -1*y, 1*y, 0.65 translate <44.65, 0, 13.6> }
        cylinder { -1*y, 1*y, 0.65 translate <44.65, 0, 26.4> }
      }
      texture { color_tex }
      bounded_by { box { <-9.7, -0.6, -4> <49.7, 5.6, 44> } }
    }
  #end
#end
#macro claw_handle(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -1.5*y, 7.5*y, 1.5 }
      cylinder { -1.6*x, 8.000001*x, 1.5 translate <0, 7.5, 0> }
      cylinder { 4*y, 11*y, 1.15 translate <-8, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      sphere { <0, 0, 0> 1.5 }
      cylinder { -0.000001*y, 7.5*y, 1.5 }
      cylinder { -1.6*x, 8.000001*x, 1.5 translate <0, 7.5, 0> }
      sphere { <8, 7.5, 0> 1.5 }
      cylinder { -2.5*x, -1.5*x, 3.4 translate <0, 7.5, 0> }
      box { <-3.3, 3.75, -3.75> <-2.4, 11.25, 3.75> }
      box { <-8, 3.750001, -2> <-3.2, 4.65, 2> }
      box { <-8, 7.05, -2> <-3.2, 7.95, 2> }
      box { <-8, 10.35, -2> <-3.2, 11.250001, 2> }
      cylinder { 3.75*y, 4.650001*y, 2 translate <-8, 0, 0> }
      cylinder { 7.050001*y, 7.950001*y, 2 translate <-8, 0, 0> }
      cylinder { 10.350001*y, 11.25*y, 2 translate <-8, 0, 0> }
      cylinder { 4*y, 11*y, 1.15 translate <-8, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-10.1, -1.6, -3.85> <9.6, 11.35, 3.85> } }
    }
  #end
#end
#macro clikit_flower(color_tex)
  difference {
    merge {
      object { ring() }
      object { open_rounded_button() }
      cylinder { 3.1*y, 2.1*y, 1.5 translate <0, 0, 3> }
      cylinder { 3.1*y, 2.1*y, 1.5 translate <0, 0, -3> }
      cylinder { 3.1*y, 2.1*y, 1.5 translate <3, 0, 0> }
      cylinder { 3.1*y, 2.1*y, 1.5 translate <-3, 0, 0> }
      cylinder { 3.10001*y, 2.10001*y, 3.2 }
    }
    cylinder { 0*y, 10*y, 0.7 }
    texture { color_tex }
    bounded_by { box { <-5.6, -0.1, -5.6> <5.6, 4.9, 5.6> } }
  }
#end
    
#macro climber_small(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 120*y, 1.5 rotate -3.8*z translate <-18.5, 0, 0> }
      cylinder { 0*y, 120*y, 1.5 rotate 3.8*z translate <18.5, 0, 0> }
      cylinder { -18.5*x, 18.5*x, 1.5 }
      cylinder { -10.5*x, 10.5*x, 1.5 translate <0, 119.2, 0> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { -1.5*z, 1.5*z, 1.5 translate <-18.5, 0, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <18.5, 0, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <-10.5, 119.2, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <0, 119.2, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <10.5, 119.2, 0> }
      cylinder { -18.5*x, 18.5*x, 1.5 }
      cylinder { -16.5*x, 16.5*x, 1.5 translate <0, 24, 0> }
      cylinder { -15*x, 15*x, 1.5 translate <0, 48, 0> }
      cylinder { -13.5*x, 13.5*x, 1.5 translate <0, 72, 0> }
      cylinder { -12*x, 12*x, 1.5 translate <0, 96, 0> }
      cylinder { -10.5*x, 10.5*x, 1.5 translate <0, 119.2, 0> }
      cylinder { 0*y, 119.2*y, 1.5 }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <0, 24, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <0, 48, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <0, 72, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <0, 96, 0> }
      cylinder { 0*y, 120*y, 1.5 rotate -3.8*z translate <-18.5, 0, 0> }
      cylinder { 0*y, 120*y, 1.5 rotate 3.8*z translate <18.5, 0, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <-16.5, 24, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <16.5, 24, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <-15, 48, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <15, 48, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <-13.5, 72, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <13.5, 72, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <-12, 96, 0> }
      cylinder { -1.5*z, 1.5*z, 1.5 translate <12, 96, 0> }
      texture { color_tex }
      bounded_by { box { <-20.1, -1.6, -1.6> <20.1, 120.8, 1.6> } }
    }
  #end
#end
#macro clipslope1_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      box { <-20, 0, -20> <20, 20, 20> rotate 43.5*z translate <4, 9.5, 0> }
      box { <-20, 0, -20> <20, 20, 20> rotate -43.5*z translate <4, 9.5, 0> }
      box { <-20, 0, -20> <20, 20, 20> rotate 43.5*x translate <0, 9.5, -4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          box { <-20, 0, -20> <20, 20, 20> texture { color_tex normal { bumping } }
            rotate 43.5*z translate <4, 9.5, 0> }
          box { <-20, 0, -20> <20, 20, 20> texture { color_tex normal { bumping } }
            rotate -43.5*z translate <4, 9.5, 0> }
          box { <-20, 0, -20> <20, 20, 20> texture { color_tex normal { bumping } }
            rotate 43.5*x translate <0, 9.5, -4> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
            box { <-20, 0, -20> <20, 20, 20> rotate 43.5*z translate <4, 7.5, 0> }
            box { <-20, 0, -20> <20, 20, 20> rotate -43.5*z translate <4, 7.5, 0> }
            box { <-20, 0, -20> <20, 20, 20> rotate 43.5*x translate <0, 7.5, -4> }
          }
        #end
      }
      difference {
        merge {
          box { <2.5, 0, -0.6> <5.5, 8.7, 0.6> }
          box { <3.65, 2, -2.5> <4.35, 8.700001, 2.5> }
        }
        box { <-20, 0, -20> <20, 20, 20> rotate 43.5*x translate <0, 7.5, -4> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 9.6, 4> } }
    }
  #end
#end
#macro connecting1swivel2_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
      cylinder { -6.6*y, 9.7*y, 1.500001 translate <35.9, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <16, 0, 0> }
            object { rounded_button() rotate 180*y translate <16, 0, 8> }
            object { rounded_button() rotate 180*y translate <24, 0, 0> }
            object { rounded_button() rotate 180*y translate <24, 0, 8> }
          #end
          box { <27.899995, -4.799999, -3.900001> <28.9, 7.900001, 11.900001> }
          box { <28.5, -4.8, 2.5> <35.900001, 7.9, 5.5> }
          cylinder { -6.6*y, 9.7*y, 1.500001 translate <35.9, 0, 4> }
        }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          box { <-2.4, -1, -2.4> <26.4, 2, 10.4> }
        #end
        box { <34.3, 0.2, 0> <40, 2.9, 10> }
        box { <27, 0, -5> <30, 10, 10> rotate -37.5*x translate <0, 3.1, -3.9> }
        box { <27, 0, -10> <30, 10, 5> rotate 37.5*x translate <0, 3.1, 11.9> }
        box { <27, -10, -5> <30, 0, 10> rotate 37.5*x translate <0, 0, -3.9> }
        box { <27, -10, -10> <30, 0, 5> rotate -37.5*x translate <0, 0, 11.9> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        box { <22.5, 0.000001, 3.5> <26.5, 2.1, 4.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -6.7, -4> <37.5, 9.8, 12> } }
    }
  #end
#end
#macro connecting2swivel2_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
      difference {
        cylinder { -6.6*y, 9.7*y, 6.35 translate <35.9, 0, 4> }
        box { <33.9, -5.1, -4> <50, 8.2, 12> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <24, 0, 8> }
          #end
          difference {
            box { <27.899995, -6.599999, -2.350001> <35.900001, 9.700001, 10.350001> }
            box { <0, 0, -4> <10, 10, 11> rotate 65*z translate <27.9, 3.1, 0> }
            box { <0, -10, -4> <10, 0, 11> rotate -65*z translate <27.9, 0, 0> }
          }
          difference {
            cylinder { -6.6*y, 9.7*y, 6.35 translate <35.9, 0, 4> }
            box { <0, -10, -10> <35.899999, 10, 20> }
          }
        }
        box { <33.9, -5.1, -4> <50, 8.2, 12> }
        difference {
          box { <28.9, -5.100001, -1.35> <40, 8.200001, 9.35> }
          box { <0, 0, -2> <10, 10, 10> rotate 65*z translate <28.9, 2, 0> }
          box { <0, -10, -2> <10, 0, 10> rotate -65*z translate <28.9, 1.1, 0> }
          box { <28, -6, 3.5> <33.899999, 10, 4.5> }
        }
        difference {
          box { <0, -9, -1.65> <11, 10, 2> }
          cylinder { -10*y, 11*y, 1 translate <5.35, 0, 2> }
          box { <0, -10, 0.999999> <5.349999, 10, 2> }
          rotate -15*y
          translate <35.9, 0, 4>
        }
        difference {
          box { <0, -9, -2> <11, 10, 1.65> }
          cylinder { -10*y, 11*y, 1 translate <5.35, 0, -2> }
          box { <0, -10, -0.999999> <5.349999, 10, -2> }
          rotate 15*y
          translate <35.9, 0, 4>
        }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          box { <-2.4, -1, -2.4> <26.4, 2, 10.4> }
        #end
        cylinder { -10*y, 10*y, 1.6 translate <35.9, 0, 4> }
      }
      cylinder { 0.2*y, 2.9*y, 1.6 translate <35.9, 0, 4> }
      box { <28.9, 0.200001, 2.400001> <35.900001, 2.899999, 5.59999> }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        box { <22.5, 0.000001, 3.5> <26.5, 2.1, 4.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -6.7, -4> <42.35, 9.8, 12> } }
    }
  #end
#end
#macro connecting3swivel2_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
      cylinder { -3.9*z, 11.9*z, 1.550001 translate <33.9, 1.55, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <16, 0, 0> }
            object { rounded_button() rotate 180*y translate <16, 0, 8> }
            object { rounded_button() rotate 180*y translate <24, 0, 0> }
            object { rounded_button() rotate 180*y translate <24, 0, 8> }
          #end
          box { <27.899995, 0.000001, -2.1> <33.9, 3.100001, 10.1> }
          cylinder { -3.9*z, 11.9*z, 1.550001 translate <33.9, 1.55, 0> }
        }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          box { <-2.4, -1, -2.4> <26.4, 2, 10.4> }
          difference {
            box { <27.9, -1, -0.3> <33.9, 2, 8.3> }
            box { <30.4, -2, 1.6> <34, 3, 6.4> }
          }
        #end
        box { <32.25, -1, 3> <38, 4, 5> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        box { <22.5, 0.000001, 3.5> <31.5, 2.1, 4.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <35.5, 4.9, 12> } }
    }
  #end
#end
#macro connecting4swivel2_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
      difference {
        cylinder { -3.900005*z, 11.900005*z, 6.35 translate <21.55, 3.1, 0> }
        box { <12, -10, -4> <28, 0.000005, 12> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <8, 0, 8> }
          #end
          difference {
            cylinder { -3.900005*z, 11.900005*z, 6.35 translate <21.55, 3.1, 0> }
            box { <12, -10, -4> <28, 3.09999, 12> }
          }
        }
        box { <12, 3.100004, -2.4> <28, 15, 10.4> }
        difference {
          box { <-1.65, 0, -5> <2, 10, 13> }
          cylinder { -4*z, 12*z, 1 translate <2, 3.65, 0> }
          box { <1, 0, -4> <2, 3.65, 12> }
          rotate -15*z
          translate <21.55, 4.65, 0>
        }
        difference {
          box { <1.65, 0, -5> <-2, 10, 13> }
          cylinder { -4*z, 12*z, 1 translate <-2, 3.65, 0> }
          box { <-1, 0, -4> <-2, 3.65, 12> }
          rotate 15*z
          translate <21.55, 4.65, 0>
        }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          box { <-2.4, -1, -2.4> <26.4, 2, 10.4> }
        #end
        cylinder { -4*z, 12*z, 1.6 translate <21.55, 4.65, 0> }
      }
      cylinder { 3.15*z, 4.85*z, 1.1 translate <21.55, 4.65, 0> }
      box { <20.45, 3, 3.150005> <22.65, 4.65, 4.850005> }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 10.55, 12> } }
    }
  #end
#end
#macro connecting_pole(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*y, 3.9*y, 3.85 }
      cylinder { -3.9*y, 3.9*y, 3.85 translate <120, 0, 0> }
      cylinder { 3.5*x, 116.5*x, 2.25 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { -3.9*y, 3.9*y, 3.85 }
        cylinder { -4*y, 4*y, 2.6 }
        cylinder { -4*y, -3.3*y, 3 }
        cylinder { 3.3*y, 4*y, 3 }
      }
      difference {
        cylinder { -3.9*y, 3.9*y, 3.85 }
        cylinder { -4*y, 4*y, 2.6 }
        cylinder { -4*y, -3.3*y, 3 }
        cylinder { 3.3*y, 4*y, 3 }
        translate <120, 0, 0>
      }
      object { axle_section(114) translate <3, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-3.95, -4, -3.95> <123.95, 4, 3.95> } }
    }
  #end
#end
#macro connect_bal(color_tex)
  #if (setting = 0)
    cylinder { 3*y, -11.5*y, 3 texture { color_tex } }
  #else
    difference {
      merge {
        sphere { <0, 0, 0> 3 }
        cylinder { 0*y, -4.1*y, 1.5 }
        cylinder { -4*y, -4.8*y, 3 }
        object { axle_ending(1) rotate 90*z translate <0, -7.6, 0> }
        object { axle_section(6.35) rotate 90*z translate <0, -10.75, 0> }
      }
      #if (setting > 1)
        cylinder { 4*y, 2*y, 1 }
      #end
      texture { color_tex }
      bounded_by { cylinder { 3.1*y, -11.6*y, 3.1 } }
    }
  #end
#end
#macro connect_turn_base_s(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, .5, -3.9> <11.9, 3.1, 11.9> }
          box { <-3.5, 0, -3.5> <11.5, .55, 11.5> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1.999999*y, 4*y, 7.5 translate <4, 0, 4> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            box { <-3, 0.5, 2.6> <11, 2, 5.4> }
            box { <2.6, 0.500001, -3> <5.4, 2.000001, 11> }
            cylinder { 2.000002*y, 0*y, 3.2 translate <4, 0, 4> }
          }
          cylinder { -1*y, 3*y, 1.5 translate <4, 0, 4> }
          cylinder { -1*y, 1.5*y, 2.6 translate <4, 0, 4> }
        }
      #end
      box { <0.099999, 0.000001, 11.5> <1.6, 3.099999, 16> }
      cylinder { -3.900002*x, -2.399999*x, 1.55 translate <4, 1.55, 16> }
      box { <3.5, 0.000001, 11.5> <4.5, 3.099999, 16> }
      cylinder { -0.500001*x, 0.499999*x, 1.55 translate <4, 1.55, 16> }
      box { <6.35, 0.000001, 11.5> <7.899999, 3.099999, 16> }
      cylinder { 2.350001*x, 3.899998*x, 1.55 translate <4, 1.55, 16> }
      difference {
        cylinder { -3.9*x, 3.9*x, 1.55 translate <4, 1.55, 11.9> }
        cylinder { -1*y, 4*y, 7.500001 translate <4, 0, 4> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 3.2, 17.65> } }
    }
  #end
#end
#macro container_door_left(color_tex)
  #if (setting = 0)
    box { <0.5, 3.2, 0.9> <12.25, 27.1, 2.4> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          merge {
            sphere { <0, 3.2, 0> 0.6 }
            sphere { <0, 27.1, 0> 0.6 }
            cylinder { 3.2*y, 27.1*y, 1 }
            box { <-1, 3.200001, -0.000001> <1, 27.100001, 2.4> }
            cylinder { 3.2*y, 27.1*y, 0.75 translate <12.25, 0, 1.65> }
            box { <0.5, 3.200005, 0.9> <12.250001, 27.100005, 2.400001> }
            box { <10.25, 25.600001, 2> <12.25, 27.100008, 3.400001> }
            cylinder { 25.6*y, 27.100007*y, 1 translate <11.25, 0, 3.4> }
            box { <10.25, 3.200001, 2> <12.25, 4.700008, 3.400001> }
            cylinder { 3.2*y, 4.700007*y, 1 translate <11.25, 0, 3.4> }
          }
          box { <1, 4.6, 0> <10.35, 25.7, 1.4> }
          box { <10, 5.099999, 0> <10.85, 25.200001, 1.400002> }
          cylinder { 0*z, 1.400001*z, 0.5 translate <10.35, 5.1, 0> }
          cylinder { 0*z, 1.400001*z, 0.5 translate <10.35, 25.2, 0> }
        }
        cylinder { -2*z, 1*z, 0.9 translate <10.9, 13.6, 0> }
        cylinder { -2*z, 1*z, 0.9 translate <10.9, 17.1, 0> }
        box { <10, 13.599999, -2.000001> <11.8, 17.100001, 1> }
      }
      #if (setting > 1)
        cylinder { -1*z, 4*z, 1 translate <10.9, 13.6, 0> }
        cylinder { -1*z, 4*z, 1 translate <10.9, 17.1, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-1.1, 2.5, -1.1> <13.1, 27.8, 4.5> } }
    }
  #end
#end
#macro container_door_right(color_tex)
  #if (setting = 0)
    box { <-0.5, 3.2, 0.9> <-12.25, 27.1, 2.4> texture { color_tex } }
  #else
  difference {
    merge {
        difference {
          merge {
            sphere { <0, 3.2, 0> 0.6 }
            sphere { <0, 27.1, 0> 0.6 }
            cylinder { 3.2*y, 27.1*y, 1 }
            box { <-1, 3.200001, -0.000001> <1, 27.100001, 2.4> }
            cylinder { 3.2*y, 27.1*y, 0.75 translate <-12.25, 0, 1.65> }
            box { <-0.5, 3.200005, 0.9> <-12.250001, 27.100005, 2.400001> }
            box { <-10.25, 25.600001, 2> <-12.25, 27.100008, 3.400001> }
            cylinder { 25.6*y, 27.100007*y, 1 translate <-11.25, 0, 3.4> }
            box { <-10.25, 3.200001, 2> <-12.25, 4.700008, 3.400001> }
            cylinder { 3.2*y, 4.700007*y, 1 translate <-11.25, 0, 3.4> }
          }
          box { <-1, 4.6, 0> <-10.35, 25.7, 1.4> }
          box { <-10, 5.099999, 0> <-10.85, 25.200001, 1.400002> }
          cylinder { 0*z, 1.400001*z, 0.5 translate <-10.35, 5.1, 0> }
          cylinder { 0*z, 1.400001*z, 0.5 translate <-10.35, 25.2, 0> }
        }
        cylinder { -2*z, 1*z, 0.9 translate <-10.9, 13.6, 0> }
        cylinder { -2*z, 1*z, 0.9 translate <-10.9, 17.1, 0> }
        box { <-10, 13.599999, -2.000001> <-11.8, 17.100001, 1> }
      }
      #if (setting > 1)
        cylinder { -1*z, 4*z, 1 translate <-10.9, 13.6, 0> }
        cylinder { -1*z, 4*z, 1 translate <-10.9, 17.1, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-13.1, 2.5, -1.1> <1.1, 27.8, 4.5> } }
    }
   #end
 #end
#macro container_grab(color_tex)
  #if (setting = 0)
    merge {
      box { <-20.5, -13.8, -15.9> <-19, -3.3, 15.9> }
      box { <-21, -3, -12.1> <0, 3, 12.1> rotate 5*z }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-20.5, -13.8, -15.9> <-19, -3.3, 15.9> }
          box { <0, -1.5, -15.900001> <4.8, 0, 15.900001> rotate 5*z translate <-20.5, -3.3, 0> }
          cylinder { -6*z, 6*z, 1.5 translate <-15.5, 9.6, 0> }
          cylinder { -6.5*z, -5*z, 2.35 translate <-15.5, 9.6, 0> }
          cylinder { 6.5*z, 5*z, 2.35 translate <-15.5, 9.6, 0> }
          difference {
            box { <-19.5, 0.6, -6.500003> <-11.5, 9.6, 6.500003> }
            box { <-5, -6.6, -7> <0, 0, 7> rotate -10*z translate <-17.85, 7.25, 0> }
            box { <0, -6.6, -7> <5, 0, 7> rotate 10*z translate <-13.15, 7.75, 0> }
            box { <-20, 0, -5.000003> <-10, 10, 5.000003> }
            box { <-20, 7.25, -7> <-17.85, 10, 7> }
            box { <-13.15, 7.25, -7> <-10, 10, 7> }
            box { <-5, 0, -14> <0, 4.5, 14> rotate -20*z translate <-20.500002, -3.3, 0> }
          }
          difference {
            merge {
              cylinder { -12.100001*z, 12.100001*z, 3 }
              box { <-21, -3, -12.1> <0, 3, 12.1> rotate 5*z }
            }
            box { <-22, -10, -5.000004> <-4.5, 10, 5.000004> }
            box { <-5, 0, -14> <0, 4.5, 14> rotate -20*z translate <-20.5, -3.3, 0> }
            box { <-30, -15, -16> <-20.500001, 0, 16> }
            box { <-30, 3, -16> <5, 10, 16> rotate 7.5*z }
            cylinder { 10.7*z, 10.1*z, 1.5 }
            box { <-3.1, -4, 10.7> <4, 4, 13> }
            box { <-3.3, -4, -3.5> <4, 4, 9.2> }
            box { <-10, -4, -3.500001> <-3.299995, 4, 5.000001> }
            box { <-3.1, -4, -10.6> <4, 4, -9.1> }
          }
        }
        box { <-15.700001, -10, -20> <-10, 10, -12.100005> }
        box { <-15.700001, -10, 20> <-10, 10, 12.100005> }
        #if (setting > 1)
          difference {
            merge {
              box { <-19.000005, -10, 6.500004> <-4.5, 5, 10.600004> }
              box { <-19.000005, -10, -6.500004> <-4.5, 5, -10.600004> }
              difference {
                box { <-4.500005, -5, -10.600008> <-3.099995, 5, -5> }
                cylinder { -5*y, 5*y, 1.5 translate <-3.1, 0, -9.1> }
                cylinder { -5*y, 5*y, 1.5 translate <-4.6, 0, -5> }
                box { <-5, -5, -11> <-3.100007, 5, -9.100004> }
              }
              box { <-3.100002, -5, -5> <1.5, 5, -7.6> }
            }
            box { <-30, 2.1, -16> <5, 10, 16> rotate 7.5*z }
            box { <-5, 0, -14> <0, 4.5, 14> rotate -20*z translate <-19, -3.3, 0> }
          }
          cylinder { -21*x, -20*x, 3 translate <0, -9.8, -12> }
          cylinder { -21*x, -20*x, 3 translate <0, -9.8, 12> }
          cylinder { -21*x, -18*x, 2.5 translate <0, -9.8, -12> }
          cylinder { -21*x, -18*x, 2.5 translate <0, -9.8, 12> }
        #end
      }
      box { <0, 2, -9.100003> <2.5, 3.000002, -3.500002> rotate 5*z }
      difference {
        box { <1.7, -3, -9.100009> <3, 4.500002, 3.000007> }
        box { <-2, -10, -10> <5, -2.999995, 4> rotate 5*z }
      }
      difference {
        box { <2, 3, -5.000001> <12.9, 4.5, 5.000001> }
        box { <0, 2, 3.000005> <5.5, 5, 6> }
      }
      difference {
        box { <2.5, -1.5, -5.00004> <12, 4, -3.500009> }
        box { <0, -10, -6> <10, 0, -3> rotate 27.5*z translate <3, -1.5, 0> }
      }
      difference {
        box { <4.3, 4, -5.000005> <12.7, 11.5, 5.500005> }
        cylinder { -6*z, 6*z, 1 translate <8.5, 9.6, 0> }
        box { <0, 0, -6> <5, 10, 6> rotate 20*z translate <12.7, 4.5, 0> }
        box { <-5, 0, -6> <0, 10, 6> rotate -20*z translate <4.3, 4.5, 0> }
        box { <4, 4.500001, -3.4> <13, 12, 3.4> }
        box { <7.7, 9.6, -6> <9.3, 12, 6> }
        box { <0, 2, 3.000006> <5.500001, 12, 6> }
      }
      #if (setting > 1)
        cylinder { -10.2*z, -10.7*z, 1.4 }
        difference {
          merge {
            box { <-20, -6.3, -12.1> <-16.8, -5, -10.600007> }
            box { <-20, -6.3, 10.600007> <-16.8, -5, 12.1> }
          }
          box { <0, -2, -13> <5, 0, 13> rotate 20*z translate <-18, -6.3, 0> }
        }
        box { <-14.9, -5.8, -6.5> <-10.1, 0, -7.5> }
        box { <-14.9, -5.8, 6.5> <-10.1, 0, 7.5> }
        box { <5.6, 4, -4> <6.6, 6.9, -2> }
        box { <10.4, 4, -4> <11.4, 6.9, -2> }
        box { <5.6, 4, 2> <6.6, 6.9, 4> }
        box { <10.4, 4, 2> <11.4, 6.9, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-20.6, -13.9, -16> <13, 12.05, 16> } }
    }
  #end
#end
#macro container_grab_grip(color_tex)
  #if (setting = 0)
    box { <-18.9, -13.8, -15.9> <-15.9, -6, 15.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-18.9, -13.8, -15.9> <-16.9, -6, 15.9> }
        box { <-17, -13.800001, -15.900005> <-15.9, -12.975, 15.900005> }
        box { <-17, -12.075, -15.900005> <-15.9, -11.25, 15.900005> }
        box { <-17, -10.35, -15.900005> <-15.9, -9.65, 15.900005> }
        box { <-17, -8.75, -15.900005> <-15.9, -7.925, 15.900005> }
        box { <-17, -6.825, -15.900005> <-15.9, -6.000005, 15.900005> }
        cylinder { -20.5*x, -18*x, 2.25 translate <0, -9.8, -12> }
        cylinder { -20.5*x, -18*x, 2.25 translate <0, -9.8, 12> }
        torus { 0.95, 0.35 rotate 90*z translate <-20.15, -8.825, -12.975> }
        torus { 0.95, 0.35 rotate 90*z translate <-20.15, -10.775, -12.975> }
        torus { 0.95, 0.35 rotate 90*z translate <-20.15, -8.825, -11.025> }
        torus { 0.95, 0.35 rotate 90*z translate <-20.15, -10.775, -11.025> }
        torus { 0.95, 0.35 rotate 90*z translate <-20.15, -8.825, 11.025> }
        torus { 0.95, 0.35 rotate 90*z translate <-20.15, -10.775, 11.025> }
        torus { 0.95, 0.35 rotate 90*z translate <-20.15, -8.825, 12.975> }
        torus { 0.95, 0.35 rotate 90*z translate <-20.15, -10.775, 12.975> }
      }
      box { <-16.900005, -14, -8> <-15, -5, 8> }
      box { <-20, -11.1, -8.000004> <-15, -8.7, 8.000004> }
      texture { color_tex }
      bounded_by { box { <-20.6, -13.9, -16> <-15.8, -5.9, 16> } }
    }
  #end
#end
#macro corner_h_arch3_4(color_tex)
  #if (setting = 0)
    difference {
      merge {
        cylinder { 0.000002*y, 57.5*y, 8 translate <-4, 0, 20> } 
        torus { 8, 16 translate <-4, 41.5, 20> }
        cylinder { 0*y, 41.500005*y, 24 translate <-4, 0, 20> }
      }
      box { <-50, -1, -50> <-3.9, 60, 50> }
      box { <-50, -1, 19.9> <50, 60, 50> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { 0.000002*y, 57.499998*y, 8 translate <-4, 0, 20> } 
          torus { 8, 16 translate <-4, 41.5, 20> }
          cylinder { 0*y, 41.500005*y, 24 translate <-4, 0, 20> }
          #if (setting < 3)
            cylinder { 57.4*y, 59.2*y, 2.4 translate <0, 0, 16> }
          #else
            object { rounded_button() rotate 180*y translate <0, 54.4, 16> }
          #end
        }
        difference {
          merge {
            torus { 8, 15 translate <-4, 41.5, 20> }
            cylinder { 3.100002*y, 57.499998*y, 8 translate <-4, 0, 20> } 
            cylinder { 3.100001*y, 41.500006*y, 23 translate <-4, 0, 20> }
          }
          box { <-50, -1, -50> <-2.9, 60, 50> }
          box { <-50, -1, 18.9> <50, 60, 50> }
          difference {
            box { <-4, 50, 0> <0, 60, 4> }
            cylinder { 50*y, 61*y, 2 translate <-1, 0, 1> }
            translate <0, 0, 16>
          }
        }
        difference {
          box { <-4, 52, 1.9> <-1.9, 58, 4> }
          cylinder { 51*y, 59*y, 2 translate <-1.9, 0, 1.9> }
          translate <0, 0, 16>
        }
        torus { 8, 14.5 translate <-4, 41.5, 20> }
        box { <-50, -1, -50> <-3.9, 60, 50> }
        box { <-50, -1, 19.9> <50, 60, 50> }
        cylinder { 3.1*y, 41.500004*y, 22.5 translate <-4, 0, 20> }
        cylinder { 20*y, 56*y, 8 translate <0, 0, 20> }
        cylinder { -1*y, 20*y, 16 translate <-4, 0, 20> }
        #if (setting > 1)
          cylinder { 55*y, 58*y, 1.2 translate <0, 0, 16> }
          cylinder { -1*y, 2.000001*y, 2.400001 }
          cylinder { -1*y, 2.000001*y, 2.400001 translate <16, 0, 16> }
          intersection {
            box { <-2.4, -1, -2.4> <18.4, 2, 18.4> }
            cylinder { -1*y, 4*y, 22.3 translate <-4, 0, 20> }
            cylinder { -1*y, 4*y, 17.5 translate <-4, 0, 20> inverse }
          }
          box { <4, -1, -2.5> <12, 2.000005, 2.5> rotate 45*y translate <0, 0, 16> }
          box { <13, -1, -2.5> <20, 2.000001, 2.5> rotate 27.5*y translate <0, 0, 16> }
          box { <13, -1, -2.5> <20, 2.000001, 2.5> rotate 62.5*y translate <0, 0, 16> }
        #end
      }
      #if (setting > 1)
        box { <-0.5, 0.000002, 2.4> <0.5, 2.1, 4> }
        box { <12, 0.000002, 15.5> <13.6, 2.1, 16.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 59.3, 20> } }
    }
  #end
#end
#macro corner_h_arch6_6(color_tex)
  #if (setting = 0)
    difference {
      merge {
        cylinder { -3.900002*x, 12.000005*x, 32 }
        sphere { <12, 0, 0> 32 }
        cylinder { -0.000005*z, 15.799999*z, 32 translate <12, 0, 0> }
        cylinder { 0*y, 54.300005*y, 32 translate <12, -54.3, 0> }
        box { <-3.900007, -54.300007, -32.000007> <12.000007, 0, 0> }
        box { <-3.900004, -54.299999, -3.899999> <43.900006, 0.000001, 15.800008> }
        box { <-3.900003, -3.1, -0.000001> <12.000006, 32.000001, 15.800004> }
      }
      box { <-50, -100, -50> <-3.9, 100, 50> }
      box { <-5, -100, 15.800007> <45, 100, 100> }
      translate <0, 54.3, 28.1>
      texture { color_tex }
    }
  #else
    difference {
      merge {
        #if (setting < 3)
          cylinder { 86.2*y, 88*y, 2.4 translate <0, 0, 32> }
          cylinder { 86.2*y, 88*y, 2.4 translate <8, 0, 32> }
          cylinder { 86.2*y, 88*y, 2.4 translate <0, 0, 40> }
          cylinder { 86.2*y, 88*y, 2.4 translate <8, 0, 40> }
        #else
          object { rounded_button() rotate -90*y translate <0, 83.2, 32> }
          object { rounded_button() rotate -90*y translate <8, 83.2, 32> }
          object { rounded_button() rotate -90*y translate <0, 83.2, 40> }
          object { rounded_button() rotate -90*y translate <8, 83.2, 40> }
        #end
        difference {
          merge {
            cylinder { -3.900002*x, 12.000005*x, 32 }
            sphere { <12, 0, 0> 32 }
            cylinder { -0.000005*z, 15.799999*z, 32 translate <12, 0, 0> }
            cylinder { 0*y, 54.300005*y, 32 translate <12, -54.3, 0> }
            box { <-3.900007, -54.300007, -32.000007> <12.000007, 0, 0> }
            box { <-3.900004, -54.299999, -3.899999> <43.900006, 0.000001, 15.800008> }
            box { <-3.900003, 25, -0.000001> <12.000006, 32.000001, 15.800004> }
          }
          box { <-50, -100, -50> <-3.9, 100, 50> }
          box { <-5, -100, 15.800007> <45, 100, 100> }
          difference {
            merge {
              cylinder { -2.900005*x, 12.000005*x, 31 }
              sphere { <12, 0, 0> 31 }
              cylinder { -0.000005*z, 14.799999*z, 31 translate <12, 0, 0> }
              cylinder { 3.1*y, 54.300005*y, 31 translate <12, -54.3, 0> }
              box { <-2.9, -51.200004, -31> <12.000007, 0, 0> }
              box { <0, -51.200003, 0> <43, 0, 14.799993> }
              difference {
                box { <-2.9, 0, 0> <12.000002, 30.999997, 14.799996> }
                difference {
                  box { <-4, 5, 0.1> <-0.1, 35, 4> }
                  cylinder { 5*y, 35*y, 2 translate <-0.1, 0, 0.1> }
                  translate <-1, 0, 12.8>
                }
              }
              box { <-5, 0, 0> <12.000002, 30.499997, 16> }
            }
          }
          cylinder { -5*x, 0*x, 30.5 }
          cylinder { 11*z, 16*z, 30.5 translate <12, 0, 0> }
          cylinder { -55.3*y, -51.199995*y, 24.2 translate <12, 0, 0> }
          box { <-5, -55.3, -24.2> <12, -51.199995, 0> }
          box { <-5, -55.3, 0> <36.2, -51.199996, 20> }
          box { <-5, -51.200002, -30.5> <0, 0.000005, 20> }
          box { <-5, -51.200001, -0.000004> <42.5, 0.000006, 20> }
          difference {
            box { <-4, 5, 1> <-1, 35, 4> }
            cylinder { 5*y, 35*y, 2 translate <-1, 0, 1> }
            translate <-1, 0, 12.8>
          }
          #if (setting > 1)
            box { <-2.4, -60, -30.5> <12.000005, -52.2, -25.7> }
            box { <37.6, -60, -0.000005> <42.4, -52.2, 14.3> }
            difference {
              cylinder { -60*y, -52.200001*y, 30.5 }
              cylinder { -61*y, -50*y, 25.7 }
              box { <-50, -61, 0> <50, -50, 50> }
              box { <-50, -61, -50> <0, -50, 50> }
              translate <12, 0, 0>
            }
            box { <28, -61, -2.5> <50, -52.200001, 2.5> rotate 21*y translate <12, 0, 0> }
            box { <28, -61, -2.5> <50, -52.200001, 2.5> rotate 69*y translate <12, 0, 0> }
            box { <0, -61, -2.5> <28, -52.200001, 2.5> rotate 30*y translate <12, 0, 0> }
            box { <0, -61, -2.5> <28, -52.200001, 2.5> rotate 60*y translate <12, 0, 0> }
          #end
          translate <0, 54.3, 28.1>
        }
        #if (setting > 1)
          object { pin(2) translate <4, 0, 0> }
          object { pin(2) translate <12, 0, 0> }
          object { pin(2) translate <40, 0, 28> }
          object { pin(2) translate <40, 0, 36> }
        #end
      }
      #if (setting > 1)
        cylinder { -1*y, 2.000003*y, 2.4 translate <16, 0, 0> }
        cylinder { -1*y, 2.000003*y, 2.4 translate <32, 0, 8> }
        cylinder { -1*y, 2.000003*y, 2.4 translate <40, 0, 24> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <0, 0, 32> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <8, 0, 32> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <0, 0, 40> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <8, 0, 40> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 88.1, 44> } }
    }
  #end
#end
#macro corner_vhslope2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 28.7, 11.9> }
      box { <-30, 0, -10> <0, 50, 20> rotate -16.75*z translate <-4, 2, 0> }
      box { <-10, 0, -30> <20, 50, 0> rotate 16.75*x translate <0, 2, -4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 28.7, 11.9> }
            box { <-30, 0, -10> <0, 50, 20> texture { color_tex normal { bumping } }
              rotate -16.75*z translate <-4, 2, 0> }
            box { <-10, 0, -30> <20, 50, 0> texture { color_tex normal { bumping } }
              rotate 16.75*x translate <0, 2, -4> }
          }
          object { open_rounded_button() translate <8, 25.6, 8> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 27.8, 10.4> }
            box { <-30, 0, -10> <0, 50, 20> rotate -16.75*z translate <-2.4, 2, 0> }
            box { <-10, 0, -30> <20, 50, 0> rotate 16.75*x translate <0, 2, -2.4> }
          }
        #end
        cylinder { 28.700001*y, 35*y, 1.600001 translate <8, 0, 8> }
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 28.6*y, 3.2 translate <4, 0, 4> }
          cylinder { -1*y, 30*y, 2.6 translate <4, 0, 4> }
          box { <-30, 0, -10> <0, 50, 20> rotate -16.75*z translate <-2.4, 2, 0> }
          box { <-10, 0, -30> <20, 50, 0> rotate 16.75*x translate <0, 2, -2.4> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 30.5, 12> } }
    }
  #end
#end
#macro corner_wall(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 57.5, 19.9> }
      box { <0, -1, 0> <30, 60, 30> rotate 45*y translate <4.5, 0, 20> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <19.9, 57.5, 19.9> }
        box { <11.9, -1, -4> <20, 9.6, 4.1> }
        box { <-4, -1, 11.9> <4.1, 9.6, 20> }
        box { <0, -1, 0> <30, 60, 30> rotate 45*y translate <4.5, 0, 20> }
        box { <-30, 47.9, -30> <30, 60, 0> rotate 45*y translate <2.6, 0, 20> }
        difference {
          box { <-4, 3.1, -4> <18.7, 47, 18.7> }
          box { <-30, 0, 0> <30, 60, 30> rotate 45*y translate <2.6, 0, 20> }
          box { <10.4, -1, -4> <20, 12.7, 20> }
          box { <-4, -1, 10.4> <20, 12.7, 20> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          difference {
            box { <5.2, -1, 5.2> <20, 11.8, 20> }
            box { <0, 0.000005, 0> <11.900005, 12, 11.900005> }
            box { <-30, 0, 0> <30, 60, 30> rotate 45*y translate <3.3, 0, 20> }
          }
          box { <-2.5, -1, -1> <2.5, 2, 2> rotate 45*y translate <8, 0, 16> }
          box { <-2.5, -1, -1> <2.5, 2, 2> rotate 45*y translate <16, 0, 8> }
          difference {
            box { <11.900005, 0, -2.4> <18.4, 11.8, 4.2> }
            box { <11, 9.600005, -0.5> <13.6, 12, 0.5> }
            box { <15.5, 9.600006, 2.4> <16.5, 12, 5> }
          }
          difference {
            box { <-2.4, 0, 11.900005> <4.100005, 11.8, 18.4> }
            box { <-0.5, 9.600005, 11> <0.5, 12, 13.6> }
            box { <2.4, 9.600006, 15.5> <4.2, 12, 16.5> }
          }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        box { <0, 46.7, -0.5> <16.5, 48, 0.5> rotate -45*y }
        box { <0, 0, 0> <0, 0, 0> }
        box { <0, 0, 0> <0, 0, 0> }
        box { <0, 0, 0> <0, 0, 0> }
        box { <0, 0, 0> <0, 0, 0> }
      #end
      object { open_rounded_button() translate <0, 44.8, 0> }
      object { open_rounded_button() translate <8, 44.8, 0> }
      object { open_rounded_button() translate <16, 44.8, 0> }
      object { open_rounded_button() translate <0, 44.8, 8> }
      object { open_rounded_button() translate <0, 44.8, 16> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <0, 47.9, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <8, 47.9, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <16, 47.9, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <0, 47.9, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <0, 47.9, 16> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 57.6, 20> } }
    }
  #end
#end
#macro cover_spotlight(color_tex)
  #if (setting = 0)
    merge {
      difference {
        sphere { <0, 7.75, 0> 8 }
        box { <-10, 4.1, -10> <10, 50, 10> }
      }
      cylinder { 4*y, 6.3*y, 7.3 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 1*y, 3.9 }
        cylinder { 4*y, 5.000001*y, 7.1 }
        cylinder { 5*y, 6.3*y, 7.3 }
        difference {
          sphere { <0, 7.75, 0> 8 }
          box { <-10, 4.1, -10> <10, 50, 10> }
        }
      }
      sphere { <0, 7.75, 0> 6.7 }
      cylinder { -1*y, 1.9*y, 2.4 translate <-4, 0, -4> }
      cylinder { -1*y, 1.9*y, 2.4 translate <4, 0, -4> }
      cylinder { -1*y, 1.9*y, 2.4 translate <-4, 0, 4> }
      cylinder { -1*y, 1.9*y, 2.4 translate <4, 0, 4> }
      cylinder { -10*y, 10*y, 2.5 }
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 6.4*y, 7.4 } }
    }
  #end
#end
#macro crane_support(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*z, 4*z, 3.75 }
      box { <-0.000001, -3.75, -0.000001> <12.000001, 3.75, 4.000001> }
      cylinder { 8*z, 12*z, 3.75 translate <120, 0, 0> }
      box { <107.999999, -3.75, 8.000001> <120.000001, 3.75, 12.000001> }
      difference {
        box { <11.999999, -3.750001, -0.000002> <108.000001, 3.750001, 12> }
        box { <-130, -4, -10> <0, 4, 0> rotate -4.765*y translate <108, 0, 8> }
        box { <0, -4, 0> <130, 4, 10> rotate -4.765*y translate <12, 0, 4> }
      }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*z, 4*z, 3.75 }
        box { <-0.000001, -3.75, -0.000001> <12.000001, 3.75, 4.000001> }
        cylinder { 8*z, 12*z, 3.75 translate <120, 0, 0> }
        box { <107.999999, -3.75, 8.000001> <120.000001, 3.75, 12.000001> }
        difference {
          box { <11.999999, -3.750001, -0.000002> <108.000001, 3.750001, 12> }
          box { <-130, -4, -10> <0, 4, 0> rotate -4.765*y translate <108, 0, 8> }
          box { <0, -4, 0> <130, 4, 10> rotate -4.765*y translate <12, 0, 4> }
        }
        box { <52.25, -3.750004, 0> <59.75, 3.750004, 5> }
        box { <100.25, -3.750004, 0> <107.75, 3.750004, 8> }
      }
      cylinder { -1*z, 0.5*z, 3.1 }
      cylinder { 3.5*z, 5*z, 3.1 }
      cylinder { -1*z, 5*z, 2.5 }
      cylinder { -1*z, 0.5*z, 3.1 translate <56, 0, 0> }
      cylinder { 7.2*z, 13*z, 3.1 translate <56, 0, 0> }
      cylinder { -1*z, 0.5*z, 3.1 translate <104, 0, 0> }
      cylinder { 7.2*z, 13*z, 3.1 translate <104, 0, 0> }
      cylinder { -1*z, 12*z, 2.5 translate <56, 0, 0> }
      cylinder { -1*z, 12*z, 2.5 translate <104, 0, 0> }
      cylinder { 5*z, 8.5*z, 3.1 translate <120, 0, 0> }
      cylinder { 11.5*z, 13*z, 3.1 translate <120, 0, 0> }
      cylinder { 5*z, 13*z, 2.4 translate <120, 0, 0> }
      #if (setting > 1)
        difference {
          box { <0, -2.4, -1> <10.5, 2.4, 3> }
          cylinder { -1*z, 4*z, 3.75 }
          box { <0, -0.5, -1> <5.6, 0.5, 4> }
        }
        difference {
          box { <107.750002, -2.4, -1> <120, 2.4, 11> }
          cylinder { -1*z, 12*z, 3.75 translate <120, 0, 0> }
        }
        difference {
          box { <12.000005, -2.4, -1> <100.250001, 2.4, 12> }
          box { <0, -4, 0> <130, 4, 10> rotate -4.765*y translate <12, 0, 3> }
          box { <52.250001, -4, -2> <59.750001, 4, 13> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-3.85, -3.85, -0.1> <123.85, 3.85, 12.1> } }
    }
  #end
#end
#macro crane_top_part(color_tex)
  #if (setting = 0)
    box { <-48, -4.3, -5.4> <32, 8, 5.4> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-50, -4.3, -5.4> <33, 6.3, 5.4> }
        difference {
          box { <-51, -5, -3.9> <34, 7, 3.9> }
          box { <-31.9, 5.3, -4> <15.9, 8, 4> }
          cylinder { -3.5*z, -4*z, 3 translate <28, 2.3, 0> }
          cylinder { 3.5*z, 4*z, 3 translate <28, 2.3, 0> }
          cylinder { -3.5*z, -4*z, 3 }
          cylinder { 3.5*z, 4*z, 3 }
          box { <-32.2, -10, -10> <0, 10, 0> rotate 4.15*y translate <-8, 0, -3.9> }
          box { <-32.2, -10, 0> <0, 10, 10> rotate -4.15*y translate <-8, 0, 3.9> }
          box { <-52, -10, -10> <-40, 10, -1.6> }
          box { <-52, -10, 10> <-40, 10, 1.6> }
          cylinder { -1*z, 5*z, 0.6 rotate 25*x translate <20, 4.3, -3.9> }
          cylinder { 1*z, -5*z, 0.6 rotate -25*x translate <20, 4.3, 3.9> }
          box { <19.4, 0, -3.9> <20.6, 2.5, 3.9> }
          cylinder { -3*z, 3*z, 0.6 translate <20, 2.75, 0> }
          box { <19.400001, -2, -1> <20.600001, 0, 5> rotate 25*x translate <0, 4.3, -3.9> }
          box { <19.400002, -2, -5> <20.600002, 0, 1> rotate -25*x translate <0, 4.3, 3.9> }
          cylinder { -1*z, 5*z, 0.6 rotate 25*x translate <-40, 4.3, -3.9> }
          cylinder { 1*z, -5*z, 0.6 rotate -25*x translate <-40, 4.3, 3.9> }
          box { <-40.6, 0, -3.9> <-39.4, 2.5, 3.9> }
          cylinder { -3*z, 3*z, 0.6 translate <-40, 2.75, 0> }
          box { <-40.600001, -2, -1> <-39.400001, 0, 5> rotate 25*x translate <0, 4.3, -3.9> }
          box { <-40.600002, -2, -5> <-39.400002, 0, 1> rotate -25*x translate <0, 4.3, 3.9> }
          cylinder { -1*z, 5*z, 0.6 rotate 25*x translate <-44, 4.3, -3.9> }
          cylinder { 1*z, -5*z, 0.6 rotate -25*x translate <-44, 4.3, 3.9> }
          box { <-44.6, 0, -3.9> <-43.4, 2.5, 3.9> }
          cylinder { -3*z, 3*z, 0.6 translate <-44, 2.75, 0> }
          box { <-44.600001, -2, -1> <-43.400001, 0, 5> rotate 25*x translate <0, 4.3, -3.9> }
          box { <-44.600002, -2, -5> <-43.400002, 0, 1> rotate -25*x translate <0, 4.3, 3.9> }
          box { <-44, 0.000007, -0.5> <-40, 2, 0.5> }
          difference {
            box { <-50, 0.3, -5> <-46.5, 4.3, -0.25> }
            box { <-5, 0, 0> <0, 5, 5> rotate -15*y translate <-47.3, 0, -0.25> }
          }
          difference {
            box { <-50, 0.3, 5> <-46.5, 4.3, 0.25> }
            box { <-5, 0, -5> <0, 5, 0> rotate 15*y translate <-47.3, 0, 0.25> }
          }
          box { <-9, -6, -3.5> <-8, 5, -4> }
          box { <-9, -6, 3.5> <-8, 5, 4> }
          box { <10, -6, -3.5> <11, 5, -4> }
          box { <10, -6, 3.5> <11, 5, 4> }
          box { <-0.75, 2.8, -3.5> <0.75, 4.5, -4> }
          box { <-0.75, 2.8, 3.5> <0.75, 4.5, 4> }
        }
        box { <0, -10, -6> <50, 0, 6> rotate 5.5*z translate <0, -4.3, 0> }
        box { <-60, -10, -6> <0, 0, 6> rotate -4.1*z translate <0, -4.3, 0> }
        difference {
          box { <28, -10, -6> <40, 10, 6> }
          cylinder { -7*z, 7*z, 4 translate <28, 2.3, 0> }
        }
        difference {
          box { <-60, -10, -6> <-44, 10, 6> }
          cylinder { -7*z, 7*z, 3.75 translate <-44.25, 2.55, 0> }
        }
        box { <-51, -10, -10> <-40, 10, -3.1> }
        box { <-51, -10, 10> <-40, 10, 3.1> }
        box { <-32.2, -10, -10> <0, 10, 0> rotate 4.15*y translate <-8, 0, -5.4> }
        box { <-32.2, -10, 0> <0, 10, 10> rotate -4.15*y translate <-8, 0, 5.4> }
        box { <-7.999999, -5, 0> <9.999999, 0, 2> rotate 21.5*x translate <0, -1.75, -3.5> }
        box { <-7.999999, -5, -2> <9.999999, 0, 0> rotate -21.5*x translate <0, -1.75, 3.5> }
      }
      object { open_rounded_button() translate <-28, 3.2, 0> }
      object { open_rounded_button() translate <-20, 3.2, 0> }
      object { open_rounded_button() translate <-12, 3.2, 0> }
      object { open_rounded_button() translate <-4, 3.2, 0> }
      object { open_rounded_button() translate <4, 3.2, 0> }
      object { open_rounded_button() translate <12, 3.2, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <-28, 7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <-20, 7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <-12, 7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <-4, 7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <4, 7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <12, 7, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-48.1, -4.4, -5.5> <32.1, 8.1, 5.5> } }
    }
  #end
#end
#macro cup_1(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 15.9*y, 3.9 texture { color_tex } }
  #else
    difference {
      merge {
        cone { 8.5*y, 2.75, 15.9*y, 3.9 }
        cylinder { 0*y, 9*y, 1.5 }
        cylinder { 1*y, 3.7*y, 2.1 }
        cylinder { 0*y, 1.6*y, 3.9 }
        torus { 2.6, 1.3 translate <0, 1.599999, 0> }
      }
      #if (setting > 1)
        cylinder { -1*y, 2*y, 2.4 }
        cylinder { -1*y, 16*y, 0.6 }
        cone { 9.3*y, 2, 16*y, 3.2 }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 16*y, 4 } }
    }
  #end
#end
#macro cup_2(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 8.5*y, 3.9 texture { color_tex } }
  #else
    merge {
      cylinder { 3*x, 8.000001*x, 1.5 translate <0, 7.4, 0> }
      sphere { <8, 7.4, 0> 1.500001 }
      cylinder { 2.15*y, 7.400001*y, 1.5 translate <8, 0, 0> }
      cylinder { 2*y, 3*y, 1.35 translate <8, 0, 0> }
      torus { 1.35, 0.15 translate <8, 2.15, 0> }
      object { ring() }
      torus { 3.4, 0.5 translate <0, 2.5, 0> }
      cylinder { 2*y, 2.499999*y, 3.4 }
      difference {
        cylinder { 8.9*y, 2.5*y, 3.9 }
        cylinder { 9*y, 2.6*y, 2.9 }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <10.1, 9, 4> } }
    }
  #end
#end
#macro curved_f_slope2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 6.3, 11.9> }
      difference {
        box { <-4, 3, -4> <4, 10, 12> }
        cylinder { -5*z, 13*z, 1 scale <24, 24, 1> translate <4, -17.7, 0> }
      }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 6.3, 11.9> }
          difference {
            box { <-4, 3, 0> <4, 10, 8> }
            cylinder { -5*z, 13*z, 1 scale <24, 24, 1> translate <4, -17.7, 0> }
          }
          difference {
            box { <-4, 2, -4> <4, 10, 0.0000001> }
            cone { -4.000001*z, 0.8825, 0*z, 1 scale <24, 24, 1> translate <4, -17.7, 0> }
          }
          box { <3, 0, -10> <12, 10, 0> rotate -35.15*x translate <0, 6.3, 0> }
          difference {
            box { <-4, 2, 7.999999> <4, 10, 12> }
            cone { 12.000001*z, 0.8825, 8*z, 1 scale <24, 24, 1> translate <4, -17.7, 0> }
          }
          box { <3, 0, 0> <12, 10, 10> rotate 35.15*x translate <0, 6.3, 8> }
          difference {
            box { <-4, -1, -2.4> <-3.6, 4, 10.4> }
            box { <-5, 0, 0> <0, 10, 10> rotate 35.15*x translate <0, 4, 8> }
            box { <-5, 0, -10> <0, 10, 0> rotate -35.15*x translate <0, 4, 0> }
          }
        }
        cylinder { 1*y, 6.300001*y, 3.9 translate <8, 0, 0> }
        cylinder { 1*y, 6.300001*y, 3.9 translate <8, 0, 8> }
        box { <4.1, 1, -0.000001> <11.900001, 6.300002, 8.000001> }
        #if (setting < 3)
          cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 0> }
          cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 8> }
        #else
          object { rounded_button() translate <8, 3.2, 0> }
          object { rounded_button() translate <8, 3.2, 8> }
        #end
      }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.7> <10.7, 5.4, 10.7> }
          box { <-0.4, 0.25, -3> <0.4, 6, -2.4> }
          box { <7.6, 0.25, -3> <8.4, 6, -2.4> }
          box { <-0.4, 0.25, 10.4> <0.4, 6, 11> }
          box { <7.6, 0.25, 10.4> <8.4, 6, 11> }
          box { <10.4, 0.25, -0.4> <11, 6, 0.4> }
          box { <10.4, 0.25, 7.6> <11, 6, 8.4> }
          difference {
            box { <-4, 3, 0> <4, 10, 8> }
            cylinder { -5*z, 13*z, 1 scale <24, 24, 1> translate <4, -18.7, 0> }
          }
          difference {
            box { <-4, 2, -4> <4, 10, 0.0000001> }
            cone { -4.000001*z, 0.8825, 0*z, 1 scale <24, 24, 1> translate <4, -18.7, 0> }
          }
          difference {
            box { <-4, 2, 7.999999> <4, 10, 12> }
            cone { 12.000001*z, 0.8825, 8*z, 1 scale <24, 24, 1> translate <4, -18.7, 0> }
          }
          box { <3, 0, -10> <12, 10, 0> rotate -35.15*x translate <0, 5.4, 0> }
          box { <3, 0, 0> <12, 10, 10> rotate 35.15*x translate <0, 5.4, 8> }
          object { high_ring() translate <4, 0.000001, 4> }
        }
        cylinder { -1*y, 5.400001*y, 2.6 translate <8, 0, 0> }
        cylinder { -1*y, 5.400001*y, 2.6 translate <8, 0, 8> }
        cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 0> }
        cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 8.1, 12> } }
    }
  #end
#end
#macro curved_f_slope2_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 6.3, 11.9> }
      difference {
        box { <-4, 3, -4> <12, 10, 12> }
        cylinder { -5*z, 13*z, 1 scale <24, 24, 1> translate <12, -17.7, 0> }
      }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-7.9, 1, -3.900005> <12, 6.3, 11.900005> }
          cylinder { -4*z, 12*z, 60 translate <12, 62, 0> }
          box { <-8, 0, -10> <9, 10, 0> rotate -45*x translate <0, 6.3, 0> }
          box { <-8, 0, 0> <9, 10, 10> rotate 45*x translate <0, 6.3, 8> }
          difference {
            box { <-8, -1, -2.4> <-3.6, 4, 10.4> }
            box { <-9, 0, 0> <-4, 10, 10> rotate 45*x translate <0, 4, 8> }
            box { <-9, 0, -10> <-4, 10, 0> rotate -45*x translate <0, 4, 0> }
            cylinder { -4*z, 12*z, 61 translate <12, 62.5, 0> }
          }
          cylinder { -4*z, 12*z, 8 translate <-10.25, -2.75, 0> }
        }
        difference {
          box { <-3.9, 0, -3.9> <19.9, 6.3, 11.9> }
          difference {
            box { <-4, 3, 0> <12, 10, 8> }
            cylinder { -5*z, 13*z, 1 scale <24, 24, 1> translate <12, -17.7, 0> }
          }
          difference {
            box { <-4, 2, -4> <12, 10, 0.0000001> }
            cone { -4.000001*z, 0.8825, 0*z, 1 scale <24, 24, 1> translate <12, -17.7, 0> }
          }
          box { <11, 0, -10> <20, 10, 0> rotate -35.15*x translate <0, 6.3, 0> }
          difference {
            box { <-4, 2, 7.999999> <12, 10, 12> }
            cone { 12.000001*z, 0.8825, 8*z, 1 scale <24, 24, 1> translate <12, -17.7, 0> }
          }
          box { <11, 0, 0> <20, 10, 10> rotate 35.15*x translate <0, 6.3, 8> }
        }
        cylinder { 1*y, 6.300001*y, 3.9 translate <16, 0, 0> }
        cylinder { 1*y, 6.300001*y, 3.9 translate <16, 0, 8> }
        box { <12.1, 1, -0.000001> <19.900001, 6.300002, 8.000001> }
        #if (setting < 3)
          cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, 0> }
          cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, 8> }
        #else
          object { rounded_button() rotate 180*y translate <16, 3.2, 0> }
          object { rounded_button() rotate 180*y translate <16, 3.2, 8> }
        #end
      }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.7> <18.7, 5.4, 10.7> }
          box { <-0.4, 0.25, -3> <0.4, 6, -2.4> }
          box { <7.6, 0.25, -3> <8.4, 6, -2.4> }
          box { <15.6, 0.25, -3> <16.4, 6, -2.4> }
          box { <-0.4, 0.25, 10.4> <0.4, 6, 11> }
          box { <7.6, 0.25, 10.4> <8.4, 6, 11> }
          box { <15.6, 0.25, 10.4> <16.4, 6, 11> }
          box { <18.4, 0.25, -0.4> <19, 6, 0.4> }
          box { <18.4, 0.25, 7.6> <19, 6, 8.4> }
          difference {
            box { <-4, 3, 0> <12, 10, 8> }
            cylinder { -5*z, 13*z, 1 scale <24, 24, 1> translate <12, -18.7, 0> }
          }
          difference {
            box { <-4, 2, -4> <12, 10, 0.0000001> }
            cone { -4.000001*z, 0.8825, 0*z, 1 scale <24, 24, 1> translate <12, -18.7, 0> }
          }
          difference {
            box { <-4, 2, 7.999999> <12, 10, 12> }
            cone { 12.000001*z, 0.8825, 8*z, 1 scale <24, 24, 1> translate <12, -18.7, 0> }
          }
          box { <3, 0, -10> <20, 10, 0> rotate -35.15*x translate <0, 5.4, 0> }
          box { <3, 0, 0> <20, 10, 10> rotate 35.15*x translate <0, 5.4, 8> }
          object { high_ring() translate <4, 0.000001, 4> }
          object { high_ring() translate <12, 0.000001, 4> }
        }
        cylinder { -1*y, 5.400001*y, 2.6 translate <16, 0, 0> }
        cylinder { -1*y, 5.400001*y, 2.6 translate <16, 0, 8> }
        cylinder { 4.2*y, 7.2*y, 1.2 translate <16, 0, 0> }
        cylinder { 4.2*y, 7.2*y, 1.2 translate <16, 0, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-8, -0.1, -4> <20, 8.1, 12> } }
    }
  #end
#end
#macro curved_f_slope4_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 6.3, 27.9> texture { color_tex } }
  #else
    difference {
      merge {
        bicubic_patch {
          type 1
          flatness 0.01
          u_steps 4
          v_steps 4
          <-3.9, 3.1, 3.4>, <4.07, 5.4, 1.315>, <12.04, 6.3, 0.109>, <20, 6.3, 0>,
          <-2.4, 3.1, 1.3>, <4.07, 4.7, -0.29>, <12.04, 5.22, -1.094>, <20, 5.22, -1.3>,
          <-0.9, 3.1, -1.3>, <4.07, 4, -2.095>, <12.04, 4.16, -2.497>, <20, 4.16, -2.6>,
          <0.6, 3.1, -3.9>, <4.07, 3.1, -3.9>, <12.04, 3.1, -3.9>, <20, 3.1, -3.9>
        }
        bicubic_patch {
          type 1
          flatness 0.01
          u_steps 4
          v_steps 4
          <-3.9, 3.1, 20.6>, <4.07, 5.4, 22.685>, <12.04, 6.3, 23.891>, <20, 6.3, 24>,
          <-2.4, 3.1, 22.7>, <4.07, 4.7, 24.29>, <12.04, 5.22, 25.094>, <20, 5.22, 25.3>,
          <-0.9, 3.1, 25.3>, <4.07, 4, 26.095>, <12.04, 4.16, 26.497>, <20, 4.16, 26.6>,
          <0.6, 3.1, 27.9>, <4.07, 3.1, 27.9>, <12.04, 3.1, 27.9>, <20, 3.1, 27.9>
        }
        difference {
          box { <-3.9, 0, -3.9> <27.9, 3.100005, 27.9> }
          box { <-10, -1, -10> <0, 7, 0> rotate -30*y translate <-4, 0, 4> }
          box { <-10, -1, 0> <0, 7, 10> rotate 30*y translate <-4, 0, 20> }
          box { <19.999995, 0, -10> <28, 10, 0> rotate -40*x translate <0, 6.299999, 0> }
          box { <19.999995, 0, 0> <28, 10, 10> rotate 40*x translate <0, 6.299999, 24> }
        }
        difference {
          box { <-3.900001, 3.099995, -3.900001> <27.900001, 6.3, 27.900001> }
          difference {
            box { <-4, 3.099999, -4> <20, 10, 28> }
            cylinder { -5*z, 29*z, 1 scale <48.1, 24, 1> translate <20, -17.7, 0> }
          }
          box { <-10, -1, -10> <0, 7, 0> rotate -30*y translate <-4, 0, 4> }
          box { <-10, -1, 0> <0, 7, 10> rotate 30*y translate <-4, 0, 20> }
          box { <19.999995, 0, -10> <28, 10, 0> rotate -40*x translate <0, 6.3, 0> }
          box { <19.999995, 0, 0> <28, 10, 10> rotate 40*x translate <0, 6.3, 24> }
          difference {
            box { <-4, 3, -4> <20.000005, 7, 28> }
            cylinder { 2*y, 8*y, 1 scale <33, 1, 12> translate <20, 0, 12> }
          }
        }
        difference {
          cone { 3.099995*y, 15.800005, 6.300005*y, 12 scale <1.8, 1, 1> translate <20, 0, 12> }
          cylinder { 2*y, 8*y, 1 scale <32.99995, 1, 11.999995> translate <20, 0, 12> }
          box { <20.000007, 0, -4> <50, 10, 28> }
          box { <-50, 0, -4> <-3.900004, 10, 48> }
          box { <-10, -1, -10> <0.000001, 7, 0> rotate -30*y translate <-4, 0, 4> }
          box { <-10, -1, 0> <0.000001, 7, 10> rotate 30*y translate <-4, 0, 20> }
          difference {
            box { <-4, 3.099999, -4> <20, 10, 28> }
            cylinder { -5*z, 29*z, 1 scale <48.1, 24, 1> translate <20, -17.699995, 0> }
          }
        }
        object { rounded_button() translate <24, 3.2, 8> }
        object { rounded_button() translate <24, 3.2, 16> }
      }
      #if (setting > 1)
        box { <-5, -1, -2.5> <2, 2, 2> rotate -30*y translate <-1.5, 0, 0> }
        box { <-5, -1, -2> <2, 2, 2.5> rotate 30*y translate <-1.5, 0, 24> }
        box { <27.4, -1, 3.9> <28, 3.8, 20.1> }
        box { <24, -1, 3.900001> <28, 3.200001, 20.100001> }
        difference {
          box { <-2.4, -1, -2.4> <26.4, 5.4, 26.4> }
          difference {
            box { <-4, 3.099999, -4> <20, 10, 28> }
            cylinder { -5*z, 29*z, 1 scale <48.1, 24, 1> translate <20, -18.6, 0> }
          }
          box { <-4, 0, -10> <28, 10, 0> rotate -40*x translate <0, 5, 1> }
          box { <-4, 0, 0> <28, 10, 10> rotate 40*x translate <0, 5, 23> }
          box { <-10, -1, -10> <0, 7, 0> rotate -30*y translate <-2.4, 0, 4> }
          box { <-10, -1, 0> <0, 7, 10> rotate 30*y translate <-2.4, 0, 20> }
          object { pin(2) scale <1, 2, 1> translate <0, 0.000002, 12> }
          object { pin(2) scale <1, 3, 1> translate <4, 0.000002, 0> }
          object { pin(2) scale <1, 3, 1> translate <12, 0.000002, 0> }
          object { pin(2) scale <1, 3, 1> translate <20, 0.000002, 0> }
          object { pin(2) scale <1, 3, 1> translate <4, 0.000002, 24> }
          object { pin(2) scale <1, 3, 1> translate <12, 0.000002, 24> }
          object { pin(2) scale <1, 3, 1> translate <20, 0.000002, 24> }
          object { pin(2) scale <1, 2, 1> translate <24, 3.200002, 12> }
          box { <-4, 0.000002, 2.4> <28, 6, 3.4> }
          box { <-4, 0.000002, 20.6> <28, 6, 21.6> }
          box { <-0.5, 0.000003, 3> <0.5, 6, 5.6> }
          box { <-0.5, 0.000003, 18.4> <0.5, 6, 21> }
          box { <7.5, 3.200002, 3> <8.5, 6, 5.6> }
          box { <7.5, 3.200002, 18.4> <8.5, 6, 21> }
          box { <15.5, 3.200002, 3> <16.5, 6, 5.6> }
          box { <15.5, 3.200002, 18.4> <16.5, 6, 21> }
          box { <23.5, 3.200002, 3> <24.5, 6, 5.6> }
          box { <23.5, 3.200002, 18.4> <24.5, 6, 21> }
          box { <2.4, 0.000003, 3> <3.4, 6, 21> }
          box { <3, 3.200005, 7.5> <5.6, 6, 8.5> }
          box { <3, 3.200005, 15.5> <5.6, 6, 16.5> }
          box { <18.4, 3.200005, 7.5> <21, 6, 8.5> }
          box { <18.4, 3.200005, 15.5> <21, 6, 16.5> }
          box { <20.6, 3.200006, 3> <21.6, 6, 21> }
        }
        cylinder { 4.2*y, 7.2*y, 1.2 translate <24, 0, 8> }
        cylinder { 4.2*y, 7.2*y, 1.2 translate <24, 0, 16> }
        cylinder { -1*y, 4.9*y, 2.5 translate <8, 0, 8> }
        cylinder { -1*y, 4.9*y, 2.5 translate <8, 0, 16> }
        box { <8, -1, 5.5> <16, 4.900005, 10.5> }
        box { <8, -1, 13.5> <16, 4.900005, 18.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 8.1, 28> } }
    }
  #end
#end
#macro curved_f_slope4_6(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 6.3, 43.9> texture { color_tex } }
  #else
    difference {
      merge {
        bicubic_patch {
          type 1
          flatness 0.01
          u_steps 4
          v_steps 4
          <-3.9, 3.1, 3.4>, <4.07, 5.4, 1.315>, <12.04, 6.3, 0.109>, <20, 6.3, 0>,
          <-2.4, 3.1, 1.3>, <4.07, 4.7, -0.29>, <12.04, 5.22, -1.094>, <20, 5.22, -1.3>,
          <-0.9, 3.1, -1.3>, <4.07, 4, -2.095>, <12.04, 4.16, -2.497>, <20, 4.16, -2.6>,
          <0.6, 3.1, -3.9>, <4.07, 3.1, -3.9>, <12.04, 3.1, -3.9>, <20, 3.1, -3.9>
        }
        bicubic_patch {
          type 1
          flatness 0.01
          u_steps 4
          v_steps 4
          <-3.9, 3.1, 36.6>, <4.07, 5.4, 38.685>, <12.04, 6.3, 39.891>, <20, 6.3, 40>,
          <-2.4, 3.1, 38.7>, <4.07, 4.7, 40.29>, <12.04, 5.22, 41.094>, <20, 5.22, 41.3>,
          <-0.9, 3.1, 41.3>, <4.07, 4, 42.095>, <12.04, 4.16, 42.497>, <20, 4.16, 42.6>,
          <0.6, 3.1, 43.9>, <4.07, 3.1, 43.9>, <12.04, 3.1, 43.9>, <20, 3.1, 43.9>
        }
        difference {
          box { <-3.9, 0, -3.9> <27.9, 3.100005, 43.9> }
          box { <-10, -1, -10> <0, 7, 0> rotate -30*y translate <-4, 0, 4> }
          box { <-10, -1, 0> <0, 7, 10> rotate 30*y translate <-4, 0, 36> }
          box { <19.999995, 0, -10> <28, 10, 0> rotate -40*x translate <0, 6.299999, 0> }
          box { <19.999995, 0, 0> <28, 10, 10> rotate 40*x translate <0, 6.299999, 40> }
        }
        difference {
          box { <-3.900001, 3.099995, -3.900001> <27.900001, 6.3, 43.900001> }
          difference {
            box { <-4, 3.099999, -4> <20, 10, 44> }
            cylinder { -5*z, 45*z, 1 scale <48.1, 24, 1> translate <20, -17.7, 0> }
          }
          box { <-10, -1, -10> <0, 7, 0> rotate -30*y translate <-4, 0, 4> }
          box { <-10, -1, 0> <0, 7, 10> rotate 30*y translate <-4, 0, 36> }
          box { <19.999995, 0, -10> <28, 10, 0> rotate -40*x translate <0, 6.3, 0> }
          box { <19.999995, 0, 0> <28, 10, 10> rotate 40*x translate <0, 6.3, 40> }
          difference {
            box { <-4, 3, -4> <20.000005, 7, 44> }
            cylinder { 2*y, 8*y, 1 scale <33, 1, 20> translate <20, 0, 20> }
          }
        }
        difference {
          merge {
            cone { 3.099995*y, 15.800005, 6.300005*y, 12 scale <1.8, 1, 1> translate <20, 0, 12> }
            cone { 3.099995*y, 15.800005, 6.300005*y, 12 scale <1.8, 1, 1> translate <20, 0, 28> }
          }
          cylinder { 2*y, 8*y, 1 scale <32.99995, 1, 11.999995> translate <20, 0, 20> }
          box { <20.000007, 0, -4> <50, 10, 44> }
          box { <-50, 0, -4> <-3.900004, 10, 44> }
          box { <-10, -1, -10> <0.000001, 7, 0> rotate -30*y translate <-4, 0, 4> }
          box { <-10, -1, 0> <0.000001, 7, 10> rotate 30*y translate <-4, 0, 36> }
          difference {
            box { <-4, 3.099999, -4> <20, 10, 44> }
            cylinder { -5*z, 45*z, 1 scale <48.1, 24, 1> translate <20, -17.699995, 0> }
          }
        }
        object { rounded_button() translate <24, 3.2, 8> }
        object { rounded_button() translate <24, 3.2, 16> }
        object { rounded_button() translate <24, 3.2, 24> }
        object { rounded_button() translate <24, 3.2, 32> }
      }
      #if (setting > 1)
        box { <-5, -1, -2.5> <2, 2, 2> rotate -30*y translate <-1.5, 0, 0> }
        box { <-5, -1, -2> <2, 2, 2.5> rotate 30*y translate <-1.5, 0, 40> }
        box { <27.4, -1, 3.9> <28, 3.8, 36.1> }
        box { <24, -1, 3.900001> <28, 3.200001, 36.100001> }
        difference {
          box { <-2.4, -1, -2.4> <26.4, 5.4, 42.4> }
          difference {
            box { <-4, 3.099999, -4> <20, 10, 44> }
            cylinder { -5*z, 45*z, 1 scale <48.1, 24, 1> translate <20, -18.6, 0> }
          }
          box { <-4, 0, -10> <28, 10, 0> rotate -40*x translate <0, 5, 1> }
          box { <-4, 0, 0> <28, 10, 10> rotate 40*x translate <0, 5, 39> }
          box { <-10, -1, -10> <0, 7, 0> rotate -30*y translate <-2.4, 0, 4> }
          box { <-10, -1, 0> <0, 7, 10> rotate 30*y translate <-2.4, 0, 40> }
          object { pin(2) scale <1, 2, 1> translate <0, 0.000002, 12> }
          object { pin(2) scale <1, 2, 1> translate <0, 0.000002, 20> }
          object { pin(2) scale <1, 2, 1> translate <0, 0.000002, 28> }
          object { pin(2) scale <1, 3, 1> translate <4, 0.000002, 0> }
          object { pin(2) scale <1, 3, 1> translate <12, 0.000002, 0> }
          object { pin(2) scale <1, 3, 1> translate <20, 0.000002, 0> }
          object { pin(2) scale <1, 3, 1> translate <4, 0.000002, 40> }
          object { pin(2) scale <1, 3, 1> translate <12, 0.000002, 40> }
          object { pin(2) scale <1, 3, 1> translate <20, 0.000002, 40> }
          object { pin(2) scale <1, 2, 1> translate <24, 3.200002, 12> }
          object { pin(2) scale <1, 2, 1> translate <24, 3.200002, 20> }
          object { pin(2) scale <1, 2, 1> translate <24, 3.200002, 28> }
          box { <-4, 0.000002, 2.4> <28, 6, 3.4> }
          box { <-4, 0.000002, 36.6> <28, 6, 37.6> }
          box { <-0.5, 0.000003, 3> <0.5, 6, 5.6> }
          box { <-0.5, 0.000003, 34.4> <0.5, 6, 37> }
          box { <7.5, 3.200002, 3> <8.5, 6, 5.6> }
          box { <7.5, 3.200002, 34.4> <8.5, 6, 37> }
          box { <15.5, 3.200002, 3> <16.5, 6, 5.6> }
          box { <15.5, 3.200002, 34.4> <16.5, 6, 37> }
          box { <23.5, 3.200002, 3> <24.5, 6, 5.6> }
          box { <23.5, 3.200002, 34.4> <24.5, 6, 37> }
          box { <2.4, 0.000003, 3> <3.4, 6, 37> }
          box { <3, 3.200005, 7.5> <5.6, 6, 8.5> }
          box { <3, 3.200005, 15.5> <5.6, 6, 16.5> }
          box { <3, 3.200005, 23.5> <5.6, 6, 24.5> }
          box { <3, 3.200005, 31.5> <5.6, 6, 32.5> }
          box { <18.4, 3.200005, 7.5> <21, 6, 8.5> }
          box { <18.4, 3.200005, 15.5> <21, 6, 16.5> }
          box { <18.4, 3.200005, 23.5> <21, 6, 24.5> }
          box { <18.4, 3.200005, 31.5> <21, 6, 32.5> }
          box { <20.6, 3.200006, 3> <21.6, 6, 37> }
        }
        cylinder { 4.2*y, 7.2*y, 1.2 translate <24, 0, 8> }
        cylinder { 4.2*y, 7.2*y, 1.2 translate <24, 0, 16> }
        cylinder { 4.2*y, 7.2*y, 1.2 translate <24, 0, 24> }
        cylinder { 4.2*y, 7.2*y, 1.2 translate <24, 0, 32> }
        cylinder { -1*y, 4.9*y, 2.5 translate <8, 0, 8> }
        cylinder { -1*y, 4.9*y, 2.5 translate <8, 0, 16> }
        cylinder { -1*y, 4.9*y, 2.5 translate <8, 0, 24> }
        cylinder { -1*y, 4.9*y, 2.5 translate <8, 0, 32> }
        box { <8, -1, 5.5> <16, 4.900005, 10.5> }
        box { <8, -1, 13.5> <16, 4.900005, 18.5> }
        box { <8, -1, 21.5> <16, 4.900005, 26.5> }
        box { <8, -1, 29.5> <16, 4.900005, 34.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 8.1, 44> } }
    }
  #end
#end
#macro curved_hrblock1_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 9.5, 3.9> }
      difference {
        box { <-4, 2, -4> <28, 20, 4> }
        cylinder { -5*z, 5*z, 1 scale <72, 72, 1> translate <28, -62.5, 0> }
      }
      texture { color_tex }
    }
  #else
    merge {
      object { rounded_button() rotate 180*y translate <32, 6.4, 0> }
      object { rounded_button() rotate 180*y translate <40, 6.4, 0> }
      difference {
        box { <-3.9, 0, -3.9> <43.9, 9.5, 3.9> }
        difference {
          box { <-4, 2, -4> <28, 20, 4> }
          cylinder { -5*z, 5*z, 1 scale <72, 72, 1> translate <28, -62.5, 0> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <42.4, 8.6, 2.4> }
            difference {
              box { <-4, 2, -4> <28, 20, 4> }
              cylinder { -5*z, 5*z, 1 scale <70.5, 70.5, 1> translate <28, -62.5, 0> }
            }
            difference {
              box { <0, -2, -3> <40, 9, 3> }
              box { <2.25, -1, -4> <5.75, 10, 4> }
              box { <10.25, -1, -4> <13.75, 10, 4> }
              box { <18.25, -1, -4> <21.75, 10, 4> }
              box { <26.25, -1, -4> <29.75, 10, 4> }
              box { <34.25, -1, -4> <37.75, 10, 4> }
              box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y }
              box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y translate <8, 0, 0> }
              box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y translate <16, 0, 0> }
              box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y translate <24, 0, 0> }
              box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y translate <32, 0, 0> }
              box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y translate <40, 0, 0> }
            }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 0> }
        #end
      }
      #if (setting > 1)
        box { <11.75, 2, -3> <12.25, 7, 3> }
        box { <27.75, 2, -3> <28.25, 8, 3> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 11.3, 4> } }
    }
  #end
#end
#macro curved_hrblock2_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 9.5, 11.9> }
      difference {
        box { <-4, 2, -4> <28, 20, 12> }
        cylinder { -5*z, 5*z, 1 scale <72, 72, 1> translate <28, -62.5, 0> }
      }
      texture { color_tex }
    }
  #else
    merge {
      object { rounded_button() rotate 180*y translate <32, 6.4, 0> }
      object { rounded_button() rotate 180*y translate <40, 6.4, 0> }
      object { rounded_button() rotate 180*y translate <32, 6.4, 8> }
      object { rounded_button() rotate 180*y translate <40, 6.4, 8> }
      difference {
        box { <-3.9, 0, -3.9> <43.9, 9.5, 11.9> }
        difference {
          box { <-4, 2, -4> <28, 20, 12> }
          cylinder { -5*z, 13*z, 1 scale <72, 72, 1> translate <28, -62.5, 0> }
        }
        cylinder { -1*y, 2.00001*y, 2.49995 }
        cylinder { -1*y, 2.00001*y, 2.49995 translate <0, 0, 8> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <42.4, 8.6, 10.4> }
            difference {
              box { <-4, -0.5, -4> <28, 20, 12> }
              cylinder { -5*z, 13*z, 1 scale <70.5, 70.5, 1> translate <28, -62.5, 0> }
            }
            object { high_ring() translate <4, 0.00001, 4> }
            object { high_ring() translate <12, 0.00001, 4> }
            object { high_ring() translate <20, 0.00001, 4> }
            object { high_ring() translate <28, 0.00001, 4> }
            object { high_ring() translate <36, 0.00001, 4> }
            box { <11.75, 2, -3> <12.25, 7, 1> }
            box { <27.75, 2, -3> <28.25, 8, 1> }
            box { <11.75, 2, 7> <12.25, 7, 11> }
            box { <27.75, 2, 7> <28.25, 8, 11> }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 8> }
        #end
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 11.3, 12> } }
    }
  #end
#end
#macro curved_inv_hrblock1_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 9.5, 3.9> }
      difference {
        box { <-4, -1, -4> <28, 10, 4> }
        cylinder { -5*z, 5*z, 1 scale <72, 72, 1> translate <28, 72, 0> }
      }
      texture { color_tex }
    }
  #else
    merge {
      object { rounded_button() rotate 180*y translate <40, 6.4, 0> }
      object { rounded_button() rotate 180*y translate <32, 6.4, 0> }
      object { rounded_button() rotate 180*y translate <24, 6.4, 0> }
      object { rounded_button() rotate 180*y translate <16, 6.4, 0> }
      difference {
        box { <-3.9, 0, -3.9> <43.9, 9.5, 3.9> }
        difference {
          box { <-4, -1, -4> <28, 10, 4> }
          cylinder { -5*z, 5*z, 1 scale <72, 72, 1> translate <28, 72, 0> }
        }
        #if (setting > 1)
          difference {
            box { <-2.9, 1, -2.9> <12, 10, 2.9> }
            difference {
              box { <-4, 0.5, -4> <28, 20, 4> }
              cylinder { -5*z, 5*z, 1 scale <70.5, 70.5, 1> translate <28, 72, 0> }
            }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          box { <29.6, -1, -2.4> <42.4, 8.6, 2.4> }
          box { <12.8, -1, -2.4> <28, 8.6, 2.4> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <36, 0, 0> }
        box { <35.75, 2, -3> <36.25, 8.7, 3> }
      #end
      difference {
        merge {
          object { high_open_rounded_button() }
          object { high_open_rounded_button() translate <8, 0, 0> }
        }
        difference {
          box { <-4, 2, -4> <28, 20, 4> }
          cylinder { -5*z, 5*z, 1 scale <71.99999, 71.99999, 1> translate <28, 72, 0> }
        }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 11.3, 4> } }
    }
  #end
#end
#macro curved_slope1_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 3.9> }
      difference {
        box { <-4, 2, -4> <20, 20, 4> }
        cylinder { -5*z, 5*z, 1 scale <42, 42, 1> translate <20, -32.5, 0> }
      }
      texture { color_tex }
    }
  #else
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 3.9> }
      box { <11.9, -1, -4> <20, 3.2, 4> }
      difference {
        box { <-4, 2, -4> <20, 20, 4> }
        cylinder { -5*z, 5*z, 1 scale <42, 42, 1> translate <20, -32.5, 0> }
      }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          difference {
            box { <-4, 2, -4> <20, 20, 4> }
            cylinder { -5*z, 5*z, 1 scale <40.5, 40.5, 1> translate <20, -32.5, 0> }
          }
          difference {
            box { <0, -2, -3> <8, 9, 3> }
            box { <2.25, -1, -4> <5.75, 10, 4> }
            box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y }
            box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y translate <8, 0, 0> }
          }
        }
        difference {
          box { <11.9000005, 0, -2.4> <18.4, 8.6, 2.4> }
          difference {
            box { <-4, 2, -4> <20, 20, 4> }
            cylinder { -5*z, 5*z, 1 scale <40.5, 40.5, 1> translate <20, -32.5, 0> }
          }
          box { <11.5, 3.200005, -0.5> <13.6, 9, 0.5> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 9.6, 4> } }
    }
  #end
#end
#macro curved_slope2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-6.9, 0, -3.9> <11.9, 9.5, 11.9> }
      difference {
        box { <-7, 3.1, -4> <12, 20, 12> }
        cylinder { -5*z, 13*z, 1 scale <32, 32, 1> translate <12, -22.5, 0> }
      }
      texture { color_tex }
    }
  #else
    difference {
      box { <-6.9, 0, -3.9> <11.9, 9.5, 11.9> }
      box { <-10, -10, -4> <0, 0, 12> rotate -45*z translate <-3.9, 0, 0> }
      difference {
        box { <-7, 3.1, -0.900001> <12, 20, 8.900001> }
        cone { 2.2*z, 0.9375, -0.9*z, 1 scale <32, 32, 1> translate <12, -22.5, 0> }
        cone { 5.8*z, 0.9375, 8.9*z, 1 scale <32, 32, 1> translate <12, -22.5, 0> }
        cylinder { -5*z, 13*z, 1 scale <36, 36, 1> translate <12, -27.5, 0> }
      }
      difference {
        box { <-7, -0.1, -4> <12, 20, -0.9> }
        cone { -4.000001*z, 0.9375, -0.9*z, 1 scale <32, 32, 1> translate <12, -22.5, 0> }
      }
      difference {
        box { <-7, -0.1, 8.9> <12, 20, 12> }
        cone { 12.000001*z, 0.9375, 8.9*z, 1 scale <32, 32, 1> translate <12, -22.5, 0> }
      }
      cylinder { -7*x, -3.900001*x, 1 translate <0, 1.3, 0.5> }
      cylinder { -7*x, -3.900001*x, 1 translate <0, 1.3, 7.5> }
      box { <-7, -1, 0.499999> <-3.900002, 2.3, 7.500001> }
      box { <-7, -1, -0.5> <-3.900003, 1.300001, 8.5> }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <10.4, 8.6, 10.4> }
          object { high_ring() translate <4, 0.000001, 4> }
          difference {
            box { <-7, 3.1, -1.400001> <12, 20, 9.400001> }
            cylinder { -5*z, 13*z, 1 scale <36, 36, 1> translate <12, -28.5, 0> }
          }
          difference {
            box { <-3, -2, -2.400001> <11, 20, -1.4> }
            cone { -4.000001*z, 0.9375, -0.9*z, 1 scale <32, 32, 1> translate <12, -23.5, 0> }
          }
          difference {
            box { <-3, -2, 9.4> <11, 20, 10.400001> }
            cone { 12.000001*z, 0.9375, 8.9*z, 1 scale <32, 32, 1> translate <12, -23.5, 0> }
          }
        }
      #end
      cylinder { 11.6*x, 12*x, 1 translate <0, 5, 1> }
      cylinder { 11.6*x, 12*x, 1 translate <0, 5, 7> }
      box { <11.600001, -1, 0.999999> <12, 6, 7.000001> }
      box { <11.600002, -20, -1> <12, 0, 1> rotate 9*x translate <0, 5, 1> }
      box { <11.600002, -20, -1> <12, 0, 1> rotate -9*x translate <0, 5, 7> }
      texture { color_tex }
      bounded_by { box { <-7, -0.1, -4> <12, 9.6, 12> } }
    }
  #end
#end
#macro curved_wheelcover2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -11.9> <11.9, 9.5, 19.9> }
      difference {
        cylinder { -13*z, 21*z, 1 scale <34.4, 34.4, 1> translate <12, -27.5, 0> }
        box { <-4, -1, -6.1> <12, 10, 14.1> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -11.9> <11.9, 9.5, 19.9> }
            box { <-4, 3.1, -4.5> <12, 10, 12.5> }
            difference {
              box { <-4, -1, -12> <12, 10, 20> }
              cylinder { -13*z, 21*z, 1 scale <36, 36, 1> translate <12, -27.5, 0> }
            }
            box { <-5, -1, -10> <15, 10, 0> rotate 45*y translate <-3.9, 0, -3.9> }
            box { <-5, -1, 0> <15, 10, 10> rotate -45*y translate <-3.9, 0, 11.9> }
            difference {
              cylinder { -13*z, 21*z, 1 scale <34.4, 34.4, 1> translate <12, -27.5, 0> }
              box { <-4, -1, -6.1> <12, 10, 14.1> }
            }
            box { <-4, -1, -5> <12, 5, 0> rotate -35*x translate <0, 0, -3.9> }
            box { <-4, -1, 0> <12, 5, 5> rotate 35*x translate <0, 0, 11.9> }
          }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.75, -1, -2.75> <10.75, 2, 10.75> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          box { <4, -1, -10> <12, 2.6, -5> }
          box { <4, -1, 13> <12, 2.6, 19> }
          cylinder { -10*z, -5.00001*z, 5 translate <4, -2.4, 0> }
          cylinder { 13.00001*z, 19*z, 5 translate <4, -2.4, 0> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        box { <-0.5, 0.1, -3> <0.5, 2.1, -2.4> }
        box { <-0.5, 0.1, 10.4> <0.5, 2.1, 11> }
        box { <-3, 0.1, -0.5> <-2.4, 2.1, 0.5> }
        box { <10.4, 0.1, -0.5> <11, 2.1, 0.5> }
        box { <7.5, 0.1, -3> <8.5, 2.1, -2.4> }
        box { <7.5, 0.1, 10.4> <8.5, 2.1, 11> }
        box { <-3, 0.1, 7.5> <-2.4, 2.1, 8.5> }
        box { <10.4, 0.1, 7.5> <11, 2.1, 8.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -12> <12, 9.6, 20> } }
    }
  #end
#end
#macro dhatch_innerhatch(color_tex)
  #if (setting = 0)
    difference {
      box { <-1, 3.3, -1> <23.7, 27.1, 1> }
      box { <1.5, 6, -2> <21.2, 24.4, 2> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 3.3*y, 27.1*y, 1 }
        box { <0, 3.30001, -1.00001> <2.5, 27.09999, 1.00001> }
        box { <-0.00001, 3.5, -1.00002> <23.7, 26.9, 1.00002> }
        sphere { <0, 0, 0> 1 scale <1, 0.5, 1> translate <0, 3.3, 0> }
        sphere { <0, 0, 0> 1 scale <1, 0.5, 1> translate <0, 27.1, 0> }
      }
      difference {
        box { <1.5, 6, -2> <21.2, 24.4, 2> }
        box { <-5, 5, -5> <0, 25, 0> rotate 45*y translate <2.5, 0, 0> }
        box { <0, 5, -5> <5, 25, 0> rotate -45*y translate <20.2, 0, 0> }
        box { <0, -5, -5> <22, 0, 0> rotate -45*x translate <0, 7, 0> }
        box { <0, 0, 0> <22, 5, 5> rotate -45*x translate <0, 23.4, 0> }
        box { <0, -0.9, -0.9> <22, 0.9, 0.9> rotate 45*x translate <0, 14.7, 0> }
        box { <-1.5, 5, -1.5> <1.5, 25, 1.5> rotate 45*y translate <11.5, 0, 0> }
      }
      box{ <2, 6.5, -2> <9.8, 13.8, 2> }
      box{ <2, 16.1, -2> <9.8, 23.4, 2> }
      box{ <13.2, 6.5, -2> <20.7, 13.8, 2> }
      box{ <13.2, 16.1, -2> <20.7, 23.4, 2> }
      texture { color_tex }
      bounded_by { box { <-1.1, 2.7, -1.1> <23.8, 27.7, 1.1> } }
    }
  #end
#end
#macro dhblock2_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 19.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 19.1, 11.9> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <26.4, 18.2, 10.4> }
            box { <3.5, 8.5, -3.8> <4.5, 19, 1> }
            box { <11.5, 2, -3.8> <12.5, 19, 1> }
            box { <19.5, 8.5, -3.8> <20.5, 19, 1> }
            box { <3.5, 8.5, 7> <4.5, 19, 11.8> }
            box { <11.5, 2, 7> <12.5, 19, 11.8> }
            box { <19.5, 8.5, 7> <20.5, 19, 11.8> }
          }
        #end
      }
      #if (setting > 1)
        object { ring() scale <1, 6.1, 1> translate <4, 0, 4> }
        object { ring() scale <1, 6.1, 1> translate <12, 0, 4> }
        object { ring() scale <1, 6.1, 1> translate <20, 0, 4> }
      #end
      object { open_rounded_button() translate <0, 16, 0> }
      object { open_rounded_button() translate <8, 16, 0> }
      object { open_rounded_button() translate <16, 16, 0> }
      object { open_rounded_button() translate <24, 16, 0> }
      object { open_rounded_button() translate <0, 16, 8> }
      object { open_rounded_button() translate <8, 16, 8> }
      object { open_rounded_button() translate <16, 16, 8> }
      object { open_rounded_button() translate <24, 16, 8> }
      object { open_rounded_button() rotate -90*x translate <0, 15.2, -0.8> }
      object { open_rounded_button() rotate -90*x translate <8, 15.2, -0.8> }
      object { open_rounded_button() rotate -90*x translate <16, 15.2, -0.8> }
      object { open_rounded_button() rotate -90*x translate <24, 15.2, -0.8> }
      object { open_rounded_button() rotate -90*x translate <0, 7.2, -0.8> }
      object { open_rounded_button() rotate -90*x translate <8, 7.2, -0.8> }
      object { open_rounded_button() rotate -90*x translate <16, 7.2, -0.8> }
      object { open_rounded_button() rotate -90*x translate <24, 7.2, -0.8> }
      object { open_rounded_button() rotate 90*x translate <0, 15.2, 8.8> }
      object { open_rounded_button() rotate 90*x translate <8, 15.2, 8.8> }
      object { open_rounded_button() rotate 90*x translate <16, 15.2, 8.8> }
      object { open_rounded_button() rotate 90*x translate <24, 15.2, 8.8> }
      object { open_rounded_button() rotate 90*x translate <0, 7.2, 8.8> }
      object { open_rounded_button() rotate 90*x translate <8, 7.2, 8.8> }
      object { open_rounded_button() rotate 90*x translate <16, 7.2, 8.8> }
      object { open_rounded_button() rotate 90*x translate <24, 7.2, 8.8> }
      #if (setting > 3)
        object { llogo() translate <0, 19.1, 0> }
        object { llogo() translate <8, 19.1, 0> }
        object { llogo() translate <16, 19.1, 0> }
        object { llogo() translate <24, 19.1, 0> }
        object { llogo() translate <0, 19.1, 8> }
        object { llogo() translate <8, 19.1, 8> }
        object { llogo() translate <16, 19.1, 8> }
        object { llogo() translate <24, 19.1, 8> }
        object { llogo() rotate -90*x translate <0, 15.2, -3.9> }
        object { llogo() rotate -90*x translate <8, 15.2, -3.9> }
        object { llogo() rotate -90*x translate <16, 15.2, -3.9> }
        object { llogo() rotate -90*x translate <24, 15.2, -3.9> }
        object { llogo() rotate -90*x translate <0, 7.2, -3.9> }
        object { llogo() rotate -90*x translate <8, 7.2, -3.9> }
        object { llogo() rotate -90*x translate <16, 7.2, -3.9> }
        object { llogo() rotate -90*x translate <24, 7.2, -3.9> }
        object { llogo() rotate 90*x translate <0, 15.2, 11.9> }
        object { llogo() rotate 90*x translate <8, 15.2, 11.9> }
        object { llogo() rotate 90*x translate <16, 15.2, 11.9> }
        object { llogo() rotate 90*x translate <24, 15.2, 11.9> }
        object { llogo() rotate 90*x translate <0, 7.2, 11.9> }
        object { llogo() rotate 90*x translate <8, 7.2, 11.9> }
        object { llogo() rotate 90*x translate <16, 7.2, 11.9> }
        object { llogo() rotate 90*x translate <24, 7.2, 11.9> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -5.7> <28, 20.9, 13.7> } }
    }
  #end
#end
#macro dhconnector1_1(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.9, 19.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <3.9, 19.1, 3.9> }
          #if (setting <3 )
            cylinder { 19*y, 20.8*y, 2.4 }
          #else
            object { rounded_button() rotate 90*y translate <0, 16, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 18.1, 2.4> }
          cylinder { 17*y, 20*y, 1.2 }
        #end
      }
      box { <3.8, 0.000001, -1.700001> <5.000001, 1.700001, 1.700001> }
      box { <3.8, 17.399999, -1.700001> <5.000001, 19.100002, 1.700001> }
      cylinder { 0.000002*y, 1.7*y, 1.7 translate <5, 0, 0> }
      cylinder { 17.4*y, 19.100001*y, 1.7 translate <5, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <6.8, 20.9, 4> } }
    }
  #end
#end
#macro dhrblock1_1(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 15.9*y, 3.9 texture { color_tex } }
  #else
    difference {
      merge {
        #if (setting < 3)
          cylinder { 15.8*y, 17.6*y, 2.3 }
        #else
          object { open_rounded_button() translate <0, 12.8, 0> }
        #end
        cylinder { 0*y, 15.9*y, 3.9 }
      }
      cylinder { -1*y, 15*y, 2.6 }
      cylinder { 2*y, 20*y, 1.600001 }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 17.7, 4> } }
    }
  #end
#end
#macro dhrblock1_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 19.1, 3.9> }
      difference {
        box { <-4, 0, -3.95> <12, 20, 3.95> }
        cylinder { -5*z, 5*z, 1 scale <15.5, 19.1, 1> translate <11.9, 0, 0> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 19.1, 3.9> }
          object { open_rounded_button() translate <16, 16, 0> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <16, 19.1, 0> }
          #end
        }
        difference {
          box { <-4, -1, -4> <12, 20, 4> }
          cylinder { -5*z, 5*z, 1 scale <15.5, 19.1, 1> translate <11.9, 0, 0> }
        }
        difference {
          box { <-2.4, -1, -2.4> <18.4, 18.2, 2.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <2, 0, -1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <6, 0, -1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <2, 0, 1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <6, 0, 1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <10, 0, -1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <14, 0, -1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <10, 0, 1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <14, 0, 1.4> }
          difference {
            box { <-4, -1, -4> <12, 20, 4> }
            cylinder { -5*z, 5*z, 1 scale <14, 17.5, 1> translate <11.900001, 0, 0> }
          }
        }
      }
      #if (setting > 1)
        box { <7.6, 2, -2.5> <8.4, 18, 2.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 20.9, 4> } }
    }
  #end
#end
#macro dhrblock1_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 10.6, 3.9> }
      box { <4.1, 10, -3.900001> <19.9, 19.1, 3.900001> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { -3.900001*z, 3.900001*z, 3.9 translate <0, 6.7, 0> }
          cylinder { -3.900001*z, 3.900001*z, 3.9 translate <24, 6.7, 0> }
          box { <-3.9, 0, -3.9> <27.9, 6.7, 3.9> }
          box { <4.1, 6, -3.900002> <19.9, 19.1, 3.900002> }
          box { <0, 2, -3.900003> <24, 8.9, 3.900003> }
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 translate <12, 0, 0> }
          #else
            object { rounded_button() rotate 90*y translate <12, 16, 0> }
          #end
        }
        difference {
          box { <-2, 0, -5> <0, 2, 5> }
          cylinder { -4*z, 4*z, 1.5 }
          translate <5.6, 17.6, 0>
        }
        difference {
          box { <0, 0, -5> <2, 2, 5> }
          cylinder { -4*z, 4*z, 1.5 }
          translate <18.4, 17.6, 0>
        }
        #if (setting > 1)
          cylinder { -2.400001*z, 2.400001*z, 2.4 translate <0, 6.7, 0> }
          cylinder { -2.400001*z, 2.400001*z, 2.4 translate <24, 6.7, 0> }
          box { <-2.4, -1, -2.4> <26.4, 6.700001, 2.4> }
          box { <5.6, -1, -2.399999> <18.4, 18.2, 2.399999> }
          cylinder { 17*y, 20*y, 1.2 translate <12, 0, 0> }
          difference {
            box { <-3, -3, -2.400002> <2.4, 0, 2.400002> }
            cylinder { -2.5*z, 2.5*z, 1.6 scale <1.5, 1, 1> }
            translate <4, 8.9, 0>
          }
          difference {
            box { <-2.4, -3, -2.400002> <3, 0, 2.400002> }
            cylinder { -2.5*z, 2.5*z, 1.6 scale <1.5, 1, 1> }
            translate <20, 8.9, 0>
          }
        #end
      }
      #if (setting > 1)
        box { <3.6, 0.2, -3> <4.4, 8, 3> }
        box { <19.6, 0.2, -3> <20.4, 8, 3> }
        box { <2.4, 0.200001, -0.5> <5.6, 8.1, 0.5> }
        box { <18.4, 0.200001, -0.5> <21.6, 8.1, 0.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 20.9, 4> } }
    }
  #end
#end
#macro dhrblock1_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 19.1, 3.9> }
      difference {
        box { <-4, 0, -3.95> <12, 20, 3.95> }
        cylinder { -5*z, 5*z, 1 scale <15.5, 19.1, 1> translate <11.9, 0, 0> }
      }
      difference {
        box { <28, 0, -3.95> <44, 20, 3.95> }
        cylinder { -5*z, 5*z, 1 scale <15.5, 19.1, 1> translate <28.1, 0, 0> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 19.1, 3.9> }
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 19*y, 20.8*y, 2.4 translate <24, 0, 0> }
          #else
            object { rounded_button() rotate 90*y translate <16, 16, 0> }
            object { rounded_button() rotate 90*y translate <24, 16, 0> }
          #end
        }
        cylinder { -4*z, 4*z, 7.9 translate <11.9, 4.8, 0> }
        cylinder { -4*z, 4*z, 7.9 translate <28.1, 4.8, 0> }
        box { <3.900001, -1, -4> <36.1, 4.900001, 4> }
        box { <11.899999, 4.9, -4> <28.100001, 12.700001, 4> }
        box { <13.6, 0, -2.4> <26.4, 18.2, 2.4> }
        difference {
          box { <-4, -1, -4> <12, 20, 4> }
          cylinder { -5*z, 5*z, 1 scale <15.5, 19.1, 1> translate <11.9, 0, 0> }
        }
        difference {
          box { <28, -1, -4> <44, 20, 4> }
          cylinder { -5*z, 5*z, 1 scale <15.5, 19.1, 1> translate <28.1, 0, 0> }
        }
        difference {
          box { <-2.4, -1, -2.4> <2.9, 20, 2.4> }
          difference {
            box { <-4, -1, -4> <12, 20, 4> }
            cylinder { -5*z, 5*z, 1 scale <14, 17.5, 1> translate <11.900001, 0, 0> }
          }
        }
        difference {
          box { <42.4, -1, -2.4> <37.1, 20, 2.4> }
          difference {
            box { <28, -1, -4> <44, 20, 4> }
            cylinder { -5*z, 5*z, 1 scale <14, 17.5, 1> translate <28.900001, 0, 0> }
          }
        }
        difference {
          box { <3.900002, -1, -2.4> <11.9, 20, 2.4> }
          difference {
            box { <-4, -1, -4> <12, 20, 4> }
            cylinder { -5*z, 5*z, 1 scale <14, 17.5, 1> translate <11.900002, 0, 0> }
          }
        }
        difference {
          box { <36.100002, -1, -2.4> <28.1, 20, 2.4> }
          difference {
            box { <28, -1, -4> <44, 20, 4> }
            cylinder { -5*z, 5*z, 1 scale <14, 17.5, 1> translate <28.100002, 0, 0> }
          }
        }
        #if (setting > 1)
          cylinder { 17*y, 20*y, 1.2 translate <16, 0, 0> }
          cylinder { 17*y, 20*y, 1.2 translate <24, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(1) scale <1, 1, 1> translate <20, 12.8, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 20.9, 4> } }
    }
  #end
#end
#macro dhrblock2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
      difference {
        box { <-4, 1.600002, -4> <12, 10, 12> }
        cylinder { -3.899999*x, 11.899999*x, 7.899999 translate <0, 1.599999, 4> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
        difference {
          box { <-4, 1.600002, -4> <12, 10, 12> }
          cylinder { -3.899999*x, 11.899999*x, 7.899999 translate <0, 1.599999, 4> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 1.600001, 10.4> }
          cylinder { -2.400001*x, 10.400001*x, 6.399999 translate <0, 1.6, 4> }
        #end
      }
      #if (setting > 1)
        difference {
          object { high_ring() translate <4, 0, 4> }
          cylinder { -2.5*x, 10.5*x, 6.399999 translate <0, 1.6, 4> inverse }
        }
      #end
      object { open_rounded_button() translate <0, 6.4, 4> }
      object { open_rounded_button() translate <8, 6.4, 4> }
      difference {
        cylinder { 8*y, 9.400001*y, 2.400001 }
        cylinder { 0*y, 12*y, 1.600001 }
        translate <0, 0, 4>
      }
      difference {
        cylinder { 8*y, 9.400001*y, 2.400001 }
        cylinder { 0*y, 12*y, 1.600001 }
        translate <8, 0, 4>
      }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 9.5, 4> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 9.5, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 12> } }
    }
  #end
#end
#macro dhwindow1_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 19.1, 3.9> }
      box { <-1, 6.5, -4> <9, 17.6, 4> }
      box { <15, 6.5, -4> <25, 17.6, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 19.1, 3.9> }
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 }
            cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 19*y, 20.8*y, 2.4 translate <24, 0, 0> }
          #else
            object { rounded_button() rotate 180*y translate <0, 16, 0> }
            object { rounded_button() rotate 180*y translate <8, 16, 0> }
            object { rounded_button() rotate 180*y translate <16, 16, 0> }
            object { rounded_button() rotate 180*y translate <24, 16, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          cylinder { -1*y, 3.100001*y, 0.85 translate <1.5, 0, -1.7> }
          cylinder { -1*y, 3.100001*y, 0.85 translate <6.5, 0, -1.7> }
          cylinder { -1*y, 3.100001*y, 0.85 translate <17.5, 0, -1.7> }
          cylinder { -1*y, 3.100001*y, 0.85 translate <22.5, 0, -1.7> }
         #end
        cylinder { -5*z, 0*z, 1.5 translate <0.5, 8, 0> }
        cylinder { -5*z, 0*z, 1.5 translate <7.5, 8, 0> }
        cylinder { -5*z, 0*z, 1.5 translate <0.5, 16.1, 0> }
        cylinder { -5*z, 0*z, 1.5 translate <7.5, 16.1, 0> }
        cylinder { -5*z, 0*z, 1.5 translate <16.5, 8, 0> }
        cylinder { -5*z, 0*z, 1.5 translate <23.5, 8, 0> }
        cylinder { -5*z, 0*z, 1.5 translate <16.5, 16.1, 0> }
        cylinder { -5*z, 0*z, 1.5 translate <23.5, 16.1, 0> }
        box { <0.499999, 6.499999, -5> <7.500001, 17.600001, 0> }
        box { <-1.000001, 7.999998, -5> <9.000001, 16.100002, 0> }
        box { <-3, 3.1, -2.4> <27, 18.600001, 0> }
        box { <-4, 3.100001, -1> <28, 18.6, 5> }
        cylinder { 16*y, 20*y, 0.85 translate <4, 0, -1.7> }
        box { <16.499999, 6.499999, -5> <23.500001, 17.600001, 0> }
        box { <14.999999, 7.999998, -5> <25.000001, 16.100002, 0> }
        cylinder { 16*y, 20*y, 0.85 translate <20, 0, -1.7> }
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
        object { pin(1) translate <12, 0, 0> }
        object { pin(1) translate <20, 0, 0> }
      #end
      box { <11.25, 3, -2.5> <11.75, 17.7, -0.5> }
      box { <12.25, 3, -2.5> <12.75, 17.7, -0.5> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 20.9, 4> } }
    }
  #end
#end
#macro dh_arch1_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 19.1, 3.9> }
      cylinder { -4*z, 4*z, 8 translate <12, 8, 0> }
      box { <4, -0.1, -4> <20, 8.00001, 4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <27.9, 19.1, 3.9> }
        #if (setting < 3)
          cylinder { 19*y, 20.8*y, 2.4 }
          cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 0> }
          cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 0> }
          cylinder { 19*y, 20.8*y, 2.4 translate <24, 0, 0> }
        #else
          object { rounded_button() rotate 90*y translate <0, 16, 0> }
          object { rounded_button() rotate 90*y translate <8, 16, 0> }
          object { rounded_button() rotate 90*y translate <16, 16, 0> }
          object { rounded_button() rotate 90*y translate <24, 16, 0> }
        #end
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 18.2, 2.4> }
        box { <21.6, -1, -2.4> <26.4, 18.2, 2.4> }
        box { <3.9, -1, -2.4> <20.1, 18.2, 2.4> }
        cylinder { 17*y, 20*y, 1.2 }
        cylinder { 17*y, 20*y, 1.2 translate <8, 0, 0> }
        cylinder { 17*y, 20*y, 1.2 translate <16, 0, 0> }
        cylinder { 17*y, 20*y, 1.2 translate <24, 0, 0> }
      #end
      cylinder { -4*z, 4*z, 8 translate <12, 8, 0> }
      box { <4, -0.1, -4> <20, 8.00001, 4> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 20.9, 4> } }
    }
  #end
#end
#macro dh_arch1_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 19.1, 3.9> }
      cylinder { -5*z, 5*z, 16 scale <1, 0.9375, 1> translate <20, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting < 3)
        cylinder { 19*y, 20.8*y, 2.4 }
        cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 0> }
        cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 0> }
        cylinder { 19*y, 20.8*y, 2.4 translate <24, 0, 0> }
        cylinder { 19*y, 20.8*y, 2.4 translate <32, 0, 0> }
        cylinder { 19*y, 20.8*y, 2.4 translate <40, 0, 0> }
      #else
        object { rounded_button() translate <0, 16, 0> }
        object { rounded_button() translate <8, 16, 0> }
        object { rounded_button() translate <16, 16, 0> }
        object { rounded_button() translate <24, 16, 0> }
        object { rounded_button() translate <32, 16, 0> }
        object { rounded_button() translate <40, 16, 0> }
      #end
      difference {
        box { <-3.9, 0, -3.9> <43.9, 19.1, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 18.2, 2.4> }
          box { <37.6, -1, -2.4> <42.4, 18.2, 2.4> }
          box { <4, -1, -2.4> <36, 18.2, 2.4> }
          cylinder { 17*y, 20*y, 1.2 }
          cylinder { 17*y, 20*y, 1.2 translate <8, 0, 0> }
          cylinder { 17*y, 20*y, 1.2 translate <16, 0, 0> }
          cylinder { 17*y, 20*y, 1.2 translate <24, 0, 0> }
          cylinder { 17*y, 20*y, 1.2 translate <32, 0, 0> }
          cylinder { 17*y, 20*y, 1.2 translate <40, 0, 0> }
        #end
        cylinder { -5*z, 5*z, 16 scale <1, 0.9375, 1> translate <20, 0, 0> }
      }
      #if (setting > 1)
        box { <19.5, 15.7, -3> <20.5, 18.5, 3> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 20.9, 4> } }
    }
  #end
#end
#macro dh_block1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 19.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 19.1, 3.9> }
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 }
            cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() translate <0, 16, 0> }
            object { rounded_button() translate <8, 16, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 18.2, 2.4> }
          cylinder { 17*y, 20*y, 1.2 }
          cylinder { 17*y, 20*y, 1.2 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        difference {
          box { <5.5, 0.25, -2.5> <7, 18.3, 2.5> }
          box { <0, -1, 0> <4, 19, 4> rotate 45*y translate <4.5, 0, 0> }
        }
        difference {
          box { <1, 0.25, -2.5> <2.5, 18.3, 2.5> }
          box { <-4, -1, 0> <0, 19, 4> rotate -45*y translate <3.5, 0, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 20.9, 4> } }
    }
  #end
#end
#macro dh_fence1_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
      box { <-3.899999, 3.099999, -1.2> <27.899999, 19.1, 1.2> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
        object { pin(1) translate <12, 0, 0> }
        object { pin(1) translate <20, 0, 0> }
      #end
      difference {
        box { <-3.899999, 3.099999, -1.2> <27.899999, 19.1, 1.2> }
        box { <-2.4, 4.6, -2> <26.4, 17.6, 2> }
      }
      intersection {
        merge {
          box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate 45*z translate <0, 11.1, -0.000001> }
          box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate 45*z translate <8, 11.1, 0.000001> }
          box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate 45*z translate <16, 11.1, 0.000002> }
          box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate 45*z translate <24, 11.1, 0.000003> }
          box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate -45*z translate <0, 11.1, 0.000004> }
          box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate -45*z translate <8, 11.1, 0.000005> }
          box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate -45*z translate <16, 11.1, 0.000006> }
          box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate -45*z translate <24, 11.1, 0.000007> }
        }
        box { <-3, 4.2, -1.35> <27, 18, 1.35> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 19.2, 4> } }
    }
  #end
#end
#macro dh_slope2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 19.1, 11.9> }
      box { <-60, 0, -10> <60, 50, 20> rotate 65.25*z translate <4, 19.1, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 19.1, 11.9> }
          box { <-60, 0, -10> <60, 50, 20> rotate 65.25*z translate <4, 19.1, 0> }
        }
        #if (setting < 3)
          cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 0> }
          cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 8> }
        #else
          object { rounded_button() translate <8, 16, 0> }
          object { rounded_button() translate <8, 16, 8> }
        #end
      }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <10.4, 18.1, 10.4> }
          box { <-60, 0, -10> <60, 50, 20> rotate 65.25*z translate <4, 17.1, 0> }
        }
        cylinder { 17*y, 20*y, 1.2 translate <8, 0, 0> }
        cylinder { 17*y, 20*y, 1.2 translate <8, 0, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 20.9, 12> } }
    }
  #end
#end
#macro dish2_2(color_tex)
  #if (setting = 0)
    difference {
      sphere { <0, 12.5, 0> 12.5 }
      box { <-45, 3.5, -45> <45, 45, 45> }
      difference {
        box { <-15, -9, -15> <15, 9, 15> }
        cylinder { -10*y, 10*y, 7.9 }
      }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          sphere { <0, 12.5, 0> 12.5 }
          #if (setting > 1)
            difference {
              sphere { <0, 12.5, 0> 11.75 }
              box { <-45, 0, -45> <45, 1.2, 45> }
            }
            cylinder { -1*y, 6*y, 1.600001 }
          #end
          box { <-45, 3.5, -45> <45, 45, 45> }
        }
        object { open_rounded_button() rotate 180*x translate <0, 3.2, 0> }
        #if (setting > 1)
          difference {
            object { ring() rotate 180*x translate <0, 3.499999, 0> }
            sphere { <0, 12.5, 0> 12.499999 inverse }
          }
        #end
      }
      difference {
        box { <-15, -9, -15> <15, 9, 15> }
        cylinder { -10*y, 10*y, 7.9 }
      }
      texture { color_tex }
      bounded_by { cylinder { -1.5*y, 3.6*y, 8 } }
    }
  #end
#end
#macro dish3_3(color_tex)
  #if (setting = 0)
    difference {
      sphere { <0, 18.5, 0> 18.5 }
      sphere { <0, 19, 0> 18 }
      box { <-37, 4.3, -37> <37, 70, 37> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        sphere { <0, 18.5, 0> 18.5 }
        sphere { <0, 19, 0> 18 }
        box { <-37, 4.3, -37> <37, 70, 37> }
        cylinder { -10*y, 10*y, 1.600005 }
      }
      #if (setting < 3)
        cylinder { -1.6*y, 1*y, 2.4 }
      #else
        object { rounded_button() rotate 180*x translate <0, 3.2, 0> }
      #end
      #if (setting > 1)
        difference {
          cylinder { 1*y, 6.3*y, 3.2 }
          cylinder { 0*y, 7*y, 2.6 }
        }
        difference {
          cylinder { 1*y, 4.3*y, 3.75 }
          cylinder { 0*y, 5*y, 2.600001 }
        }
      #end
      difference {
        cylinder { 4.299999*y, 6.3*y, 11.900001 }
        cylinder { 4.299998*y, 7*y, 10.6 }
      }
      texture { color_tex }
      bounded_by { cylinder { -1.7*y, 6.4*y, 12 } }
    }
  #end
#end
#macro dish4_4(color_tex)
  #if (setting = 0)
    difference {
      sphere { <0, 34.5, 0> 34.5 }
      sphere { <0, 41, 0> 40 }
      box { <-37, 3.9, -37> <37, 70, 37> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        sphere { <0, 34.5, 0> 34.5 }
        sphere { <0, 41, 0> 40 }
        box { <-37, 3.9, -37> <37, 70, 37> }
      }
      #if (setting < 3)
        cylinder { -1.6*y, 1*y, 2.4 }
      #else
        object { rounded_button() rotate 180*x translate <0, 3.2, 0> }
      #end
      #if (setting > 1)
        difference {
          cylinder { 1*y, 6.3*y, 3.2 }
          cylinder { 0*y, 7*y, 2.6 }
        }
        difference {
          cylinder { 1*y, 4.3*y, 3.75 }
          cylinder { 0*y, 5*y, 2.600001 }
        }
      #end
      difference {
        cylinder { 3.899999*y, 6.3*y, 15.900001 }
        cylinder { 3.899998*y, 7*y, 14.9 }
      }
      texture { color_tex }
      bounded_by { cylinder { -1.7*y, 6.4*y, 16 } }
    }
  #end
#end
#macro dish6_6(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 6.3*y, 24 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { 0*y, 2.5*y, 24 }
        cylinder { -1*y, 4*y, 22.6 }
      }
      difference {
        sphere { <0, -64.1, 0> 71 }
        sphere { <0, -64.1, 0> 70 }
        cylinder { 6.399995*y, 50*y, 50 }
        box { <-100, -200, -100> <100, 0.9, 100> }
        difference {
          box { <-50, -10, -50> <50, 10, 50> }
          cylinder { -11*y, 11*y, 24.000001 }
        }
        #if (setting > 1)
          cylinder { 7.4*y, 10.400001*y, 1.200001 translate <-4, 0, -4> }
          cylinder { 7.4*y, 10.400001*y, 1.200001 translate <4, 0, -4> }
          cylinder { 7.4*y, 10.400001*y, 1.200001 translate <-4, 0, 4> }
          cylinder { 7.4*y, 10.400001*y, 1.200001 translate <4, 0, 4> }
          cylinder { -10*y, 15*y, 2.600001 }
        #end
      }
      difference {
        merge {
          box { <-7.9, 3.2, -7.9> <7.9, 6, 7.9> }
          object { open_rounded_button() translate <-4, 3.2, -4> }
          object { open_rounded_button() translate <-4, 3.2, 4> }
          object { open_rounded_button() translate <4, 3.2, -4> }
          object { open_rounded_button() translate <4, 3.2, 4> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> translate <-4, 6.3, 4> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <4, 6.3, -4> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <4, 6.3, 4> }
          #end
        }
        #if (setting > 1)
          cylinder { -10*y, 10*y, 2.600002 }
        #end
        box { <-6.4, 0, -6.4> <6.4, 5.4, 6.4> }
      }
      #if (setting > 1)
        object { ring() translate <0, 3.2, 0> }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.3*y, 8.1*y, 24.1 } }
    }
  #end
#end
#macro dish6_6_open(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 6.3*y, 24 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { 0*y, 2.5*y, 24 }
        cylinder { -1*y, 4*y, 22.6 }
      }
      difference {
        sphere { <0, -64.1, 0> 71 }
        sphere { <0, -64.1, 0> 70 }
        cylinder { 6.399995*y, 50*y, 50 }
        box { <-100, -200, -100> <100, 0.9, 100> }
        difference {
          box { <-50, -10, -50> <50, 10, 50> }
          cylinder { -11*y, 11*y, 24.000001 }
        }
        difference {
          cylinder { -11*y, 11*y, 22.600001 }
          box { <-1.5, -12, -25> <1.5, 12, 25> }
          box { <-1.5, -12, -25> <1.5, 12, 25> rotate 45*y }
          box { <-1.5, -12, -25> <1.5, 12, 25> rotate 90*y }
          box { <-1.5, -12, -25> <1.5, 12, 25> rotate 135*y }
          difference {
            cylinder { -12*y, 12*y, 17 }
            cylinder { -13*y, 13*y, 14.5 }
          }
          cylinder { 0*y, 12*y, 9 }
        }
        #if (setting > 1)
          cylinder { 7.4*y, 10.400001*y, 1.200001 translate <-4, 0, -4> }
          cylinder { 7.4*y, 10.400001*y, 1.200001 translate <4, 0, -4> }
          cylinder { 7.4*y, 10.400001*y, 1.200001 translate <-4, 0, 4> }
          cylinder { 7.4*y, 10.400001*y, 1.200001 translate <4, 0, 4> }
          cylinder { -10*y, 15*y, 2.600001 }
        #end
      }
      difference {
        merge {
          cylinder { 3.2*y, 6.3*y, 8.999999 }
          #if (setting < 3)
            cylinder { 6.2*y, 8*y, 2.4 translate <-4, 0, -4> }
            cylinder { 6.2*y, 8*y, 2.4 translate <-4, 0, 4> }
            cylinder { 6.2*y, 8*y, 2.4 translate <4, 0, -4> }
            cylinder { 6.2*y, 8*y, 2.4 translate <4, 0, 4> }
          #else
            object { rounded_button() translate <-4, 3.2, -4> }
            object { rounded_button() translate <-4, 3.2, 4> }
            object { rounded_button() translate <4, 3.2, -4> }
            object { rounded_button() translate <4, 3.2, 4> }
          #end
        }
        #if (setting > 1)
          cylinder { -10*y, 10*y, 2.600002 }
        #end
        cylinder { 0*y, 5.4*y, 2.5 translate <-4, 0, -4> }
        cylinder { 0*y, 5.4*y, 2.5 translate <-4, 0, 4> }
        cylinder { 0*y, 5.4*y, 2.5 translate <4, 0, -4> }
        cylinder { 0*y, 5.4*y, 2.5 translate <4, 0, 4> }
        box { <-4.000001, 0, -6.500001> <4.000001, 5.400001, 6.500001> }
        box { <-6.500001, 0, -4.000001> <6.500001, 5.400002, 4.000001> }
        #if (setting > 1)
          cylinder { 4.2*y, 7.2*y, 1.2 translate <-4, 0, -4> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <4, 0, -4> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <-4, 0, 4> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <4, 0, 4> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <0, 3.2, 0> }
        cylinder { 3.199999*y, 5.6*y, 1 translate <6, 0, 0> }
        cylinder { 3.199999*y, 5.6*y, 1 translate <-6, 0, 0> }
        cylinder { 3.199999*y, 5.6*y, 1 translate <0, 0, -6> }
        cylinder { 3.199999*y, 5.6*y, 1 translate <0, 0, 6> }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.3*y, 8.1*y, 24.1 } }
    }
  #end
#end
#macro dish8_8(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 9.5*y, 32 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { 0*y, 2.8*y, 32 }
        cylinder { -1*y, 3*y, 30.6 }
      }
      difference {
        sphere { <0, -63.9, 0> 74 }
        box { <-20, 9.500001, -20> <20, 50, 20> }
        sphere { <0, -63.9, 0> 73 }
        box { <-100, -200, -100> <100, -0.000001, 100> }
        difference {
          box { <-50, -10, -50> <50, 10, 50> }
          cylinder { -11*y, 11*y, 32.000001 }
        }
        #if (setting > 1)
          cylinder { 7.4*y, 10.400001*y, 1.200001 translate <-4, 0, -4> }
          cylinder { 7.4*y, 10.400001*y, 1.200001 translate <4, 0, -4> }
          cylinder { 7.4*y, 10.400001*y, 1.200001 translate <-4, 0, 4> }
          cylinder { 7.4*y, 10.400001*y, 1.200001 translate <4, 0, 4> }
          cylinder { -10*y, 15*y, 2.600001 }
        #end
      }
      difference {
        merge {
          cylinder { 6.4*y, 9.5*y, 8.999999 }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <-4, 0, -4> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <-4, 0, 4> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <4, 0, -4> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <4, 0, 4> }
          #else
            object { rounded_button() translate <-4, 6.4, -4> }
            object { rounded_button() translate <-4, 6.4, 4> }
            object { rounded_button() translate <4, 6.4, -4> }
            object { rounded_button() translate <4, 6.4, 4> }
          #end
        }
        #if (setting > 1)
          cylinder { -10*y, 10*y, 2.600002 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <-4, 0, -4> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <4, 0, -4> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <-4, 0, 4> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <4, 0, 4> }
          cylinder { 0*y, 8.6*y, 2.5 translate <-4, 0, -4> }
          cylinder { 0*y, 8.6*y, 2.5 translate <-4, 0, 4> }
          cylinder { 0*y, 8.6*y, 2.5 translate <4, 0, -4> }
          cylinder { 0*y, 8.6*y, 2.5 translate <4, 0, 4> }
          box { <-4.000001, 0, -6.500001> <4.000001, 8.600001, 6.500001> }
          box { <-6.500001, 0, -4.000001> <6.500001, 8.600002, 4.000001> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <0, 6.4, 0> }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.3*y, 11.3*y, 32.1 } }
    }
  #end
#end
#macro diver_airtank(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -11.5*y, 0*y, 3 translate <0, 0, 7> }
      torus { 7, 1 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          torus { 3.25, 0.75 translate <0, 0.75, 0> }
          box { <-10, -10, -10> <10, 0.75, 10> }
          box { <-5, 0, 0> <0, 2, 7> rotate 5*y }
          box { <0, 0, 0> <5, 2, 7> rotate -5*y }
        }
        difference {
          cylinder { 0*y, 0.750001*y, 4 }
          cylinder { -1*y, 1*y, 2.5 }
          box { <-5, -1, 0> <0, 1, 7> rotate 5*y }
          box { <0, -1, 0> <5, 1, 7> rotate -5*y }
        }
        cylinder { -0.000001*z, 7*z, 0.75 translate <-3.25, 0.75, 0> rotate 5*y }
        cylinder { -0.000001*z, 7*z, 0.75 translate <3.25, 0.75, 0> rotate -5*y }
        box { <-3.999999, 0, -0.000002> <-2.500001, 0.7500001, 7> rotate 5*y }
        box { <2.500001, 0, -0.000002> <3.999999, 0.7500001, 7> rotate -5*y }
        torus { 2, 1 translate <0, 0, 7> }
        cylinder { -11.5*y, 0*y, 3 translate <0, 0, 7> }
        cylinder { 0*y, 1.000001*y, 2.500001 translate <0, 0, 7> }
        cylinder { 0.25*y, 1.5*y, 1.9 translate <0, 0, 7> }
        cylinder { 0*y, 3.5*y, 0.35 translate <0, 0, 7> }
        difference {
          cylinder { 1*y, 3.25*y, 1.5 }
          cylinder { 0*y, 4*y, 0.4 translate <1.5, 0, 0> rotate 0*y }
          cylinder { 0*y, 4*y, 0.4 translate <1.5, 0, 0> rotate 45*y }
          cylinder { 0*y, 4*y, 0.4 translate <1.5, 0, 0> rotate 90*y }
          cylinder { 0*y, 4*y, 0.4 translate <1.5, 0, 0> rotate 135*y }
          cylinder { 0*y, 4*y, 0.4 translate <1.5, 0, 0> rotate 180*y }
          cylinder { 0*y, 4*y, 0.4 translate <1.5, 0, 0> rotate 225*y }
          cylinder { 0*y, 4*y, 0.4 translate <1.5, 0, 0> rotate 270*y }
          cylinder { 0*y, 4*y, 0.4 translate <1.5, 0, 0> rotate 315*y }
          translate <0, 0, 7>
        }
        box { <-2.5, -2, 4.000001> <2.5, 0.000001, 7.000001> }
        cylinder { -4*x, -2*x, 1.5 translate <0, 0, 7> }
        cylinder { 2*x, 4*x, 1.5 translate <0, 0, 7> }
        cylinder { 0*y, 1.5*y, 0.4 translate <-2.1, 0, 2> }
        cylinder { 0*y, 1.5*y, 0.4 translate <2.1, 0, 2> }
        #local diving_ribs = 0;
        #while (diving_ribs < 60)
        #switch (diving_ribs)
          #range (0, 5)
            torus { 0.5, 0.5 rotate 90*z translate <0, -0.75, -7.25> rotate (diving_ribs*6)*y }
            #break
          #range (6, 6)
            torus { 0.5, 0.5 rotate 90*z translate <0, -0.625, -7> rotate (diving_ribs*6)*y }
            #break
          #range (7, 7)
            torus { 0.5, 0.5 rotate 90*z translate <0, -0.5, -7> rotate (diving_ribs*6)*y }
            #break
          #range (8, 9)
            torus { 0.5, 0.5 rotate 90*z translate <0, -0.25, -7> rotate (diving_ribs*6)*y }
            #break
          #range (10, 11)
            torus { 0.5, 0.5 rotate 90*z translate <0, 0, -7> rotate (diving_ribs*6)*y }
            #break
          #range (12, 13)
            torus { 0.5, 0.5 rotate 90*z translate <0, 0.25, -7> rotate (diving_ribs*6)*y }
            #break
          #range (14, 17)
            torus { 0.5, 0.5 rotate 90*z translate <0, 0.5, -7> rotate (diving_ribs*6)*y }
            #break
          #range (18, 19)
            torus { 0.5, 0.5 rotate 90*z translate <0, 0.25, -7.25> rotate (diving_ribs*6)*y }
            #break
          #range (20, 40)
            torus { 0.5, 0.5 rotate 90*z translate <0, 0, -7.5> rotate (diving_ribs*6)*y }
            #break
          #range (41, 42)
            torus { 0.5, 0.5 rotate 90*z translate <0, 0.25, -7.25> rotate (diving_ribs*6)*y }
            #break
          #range (43, 46)
            torus { 0.5, 0.5 rotate 90*z translate <0, 0.5, -7> rotate (diving_ribs*6)*y }
            #break
          #range (47, 48)
            torus { 0.5, 0.5 rotate 90*z translate <0, 0.25, -7> rotate (diving_ribs*6)*y }
            #break
          #range (49, 50)
            torus { 0.5, 0.5 rotate 90*z translate <0, 0, -7> rotate (diving_ribs*6)*y }
            #break
          #range (51, 52)
            torus { 0.5, 0.5 rotate 90*z translate <0, -0.25, -7> rotate (diving_ribs*6)*y }
            #break
          #range (53, 53)
            torus { 0.5, 0.5 rotate 90*z translate <0, -0.5, -7> rotate (diving_ribs*6)*y }
            #break
          #range (54, 54)
            torus { 0.5, 0.5 rotate 90*z translate <0, -0.625, -7> rotate (diving_ribs*6)*y }
            #break
          #range (55, 60)
            torus { 0.5, 0.5 rotate 90*z translate <0, -0.75, -7.25> rotate (diving_ribs*6)*y }
            #break
        #end
        #local diving_ribs = diving_ribs + 1;
        #end
        cylinder { -2*x, 2*x, 1.5 translate <0, -0.75, -7> }
        cylinder { -9*z, -6.999999*z, 1.500001 translate <0, -0.75, 0> }
      }
      #if (setting > 1)
        cylinder { -12*y, -1*y, 2 translate <0, 0, 7> }
      #end
      texture { color_tex }
      bounded_by { box { <-10, -11.75, -9.5> <10, 3.75, 10.25> } }
    }
  #end
#end
#macro diver_harpoon(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 23.4*y, 1.5 texture { color_tex } }
  #else
    merge {
      torus { 1.35, 0.15 translate <0, 0.15, 0> }
      cylinder { 1*y, 17.75*y, 1.15 }
      cylinder { 0*y, 5*y, 1.35 }
      cylinder { 0.15*y, 9.4*y, 1.5 }
      cylinder { 9.75*y, 10.1*y, 1.5 }
      cylinder { 10.45*y, 10.8*y, 1.5 }
      cylinder { 11.15*y, 11.5*y, 1.5 }
      cylinder { 11.85*y, 17.75*y, 1.5 }
      #local counter = 0;
      #while (counter < 4)
        merge {
          sphere { <0, 0, 0> 0.5 }
          cylinder { 0*y, -5.1*y, 0.5 }
          sphere { <0, -5.1, 0> 0.5 }
          cylinder { -3*x, 0*x, 0.5 rotate -22.5*z translate <0, -5.1, 0> }
          difference {
            box { <-3, -5.1, -0.5> <0, -0.5, 0.5> }
            box { <-5, -5, -1> <5, 0, 1> rotate -22.5*z translate <0, -5.6, 0> }
            box { <-5, -5, -1> <0, 5, 1> rotate -22.5*z translate <0, 0, 0> }
            box { <-5, -5, -1> <5, 0, 1> rotate -22.5*z translate <0, -5.1, 0> }
          }
          rotate 22.5*z
          translate <0, 22.9-(counter*0.000001), 0>
          rotate (counter*90)*y
          #local counter = counter + 1;
        }
      #end
      cone { 17.75*y, 1.5, 20.75*y, 0.5 }
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 23.5*y, 2.4 } }
    }
  #end
#end
#macro diver_speargun(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -2*y, 6*y, 1.5 }
      cylinder { 5.25*z, -34*z, 1.6 rotate 33*x translate <0, 7, 0> }
      texture { color_tex }
    }
  #else
    merge {
      torus { 1.35, 0.15 translate <0, -2, 0> }
      torus { 1.35, 0.15 translate <0, 6, 0> }
      cylinder { -2*y, 6*y, 1.5 }
      cylinder { -2.15*y, 6.15*y, 1.35 }
      merge {
        cone { -4.749999*z, 2, -5.25*z, 1.5 }
        cylinder { -1.25*z, -2.75*z, 2 }
        cylinder { -3.25*z, -4.75*z, 2 }
        cylinder { -0.75*z, 0.75*z, 2 }
        cylinder { 1.25*z, 2.75*z, 2 }
        cylinder { 3.25*z, 4.75*z, 2 }
        cone { 4.749999*z, 2, 5.25*z, 1.5 }
        cylinder { 5*z, -22.5*z, 1.6 }
        box { <-0.8, -0.75, -22> <0.8, 0.75, -33> }
        merge {
          cylinder { -0.800001*x, 0.800001*x, 1 }
          cylinder { -0.800002*x, 0.800002*x, 1 translate <0, 0, 2> }
          box { <-0.800004, -1, 0> <0.800004, 1, 2> }
          rotate -20*x
          translate <0, 0.25, -33>
        }
        rotate 33*x
        translate <0, 7, 0>
      }
      texture { color_tex }
      bounded_by { box { <-2.1, -2.25, -31> <2.1, 28, 7> } }
    }
  #end
#end
#macro diver_vizor(color_tex)
  #if (setting = 0)
    merge {
      difference {
        cylinder { 2*y, -5.9*y, 6.5 scale <1.07, 1, 1> }
        box { <0.000001, -11, -7> <7, 3, 7> }
      }
      cylinder { <-5.5, -2, -6> <4, 4, -6> 1.500001 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            cylinder { 2*y, -10*y, 6.5 scale <1.07, 1, 1> }
            box { <0.000001, -11, -7> <7, 3, 7> }
          }
          difference {
            cylinder { -6.499999*z, 6.499999*z, 1.999999 scale <1.07, 1, 1> }
            box { <-5, -3, -7> <0, 3, 7> }
          }
          difference {
            box { <-6.96, -8.000001, -6.500001> <0, 2.000001, 6.500001> }
            difference {
              box { <-10, -8, -10> <10, 8, 0> }
              cylinder { -11*x, 11*x, 2 scale <1, 1.625, 1.25> }
              rotate 6*y
              translate <-6.95, -1.25, -4>
              texture { color_tex normal { bumping } scale <.25, .25, .25> }
              interior { ior 1.5 }
            }
            difference {
              box { <-10, -8, 0> <10, 8, 10> }
              cylinder { -11*x, 11*x, 2 scale <1, 1.625, 1.25> }
              rotate -6*y
              translate <-6.95, -1.25, 4>
              texture { color_tex normal { bumping } scale <.25, .25, .25> }
              interior { ior 1.5 }
            }
          }
        }
        box { <-3, -5, -8> <-2.4, 3, -6> }
        box { <-1.9, -5, -8> <-1.3, 3, -6> }
        box { <-0.8, -5, -8> <-0.2, 3, -6> }
        box { <0.3, -5, -8> <0.9, 3, -6> }
        box { <-3, -5, 6> <-2.4, 3, 8> }
        box { <-1.9, -5, 6> <-1.3, 3, 8> }
        box { <-0.8, -5, 6> <-0.2, 3, 8> }
        box { <0.3, -5, 6> <0.9, 3, 8> }
        cylinder { 3*y, -11*y, 5.5 scale <1.07, 1, 1> }
        box { <-4, -11, -8> <7, -2, 8> }
        box { <-20, -10, -20> <20, 0, 20> rotate 19*z translate <0, -2, 0> }
        difference {
          box { <-8, -10, -4> <-6.5, -2.95, 4> }
          cylinder { -10*x, 6*x, 2 scale <1, 1.625, 1.25> translate <0, -1.25, -3.5> }
          cylinder { -10*x, 6*x, 2 scale <1, 1.625, 1.25> translate <0, -1.25, 3.5> }
          texture { color_tex normal { bumping } scale <.25, .25, .25> }
          interior { ior 1.5 }
        }
        cylinder { -8*x, -6.5*x, 2 scale <1, 1.175, 1> translate <0, -1.25, -3.5> }
        cylinder { -8*x, -6.5*x, 2 scale <1, 1.175, 1> translate <0, -1.25, 3.5> }
        box { <-8, -2.05, -3.500001> <-6.500001, 1.1, 3.500001> }
      }
      sphere { <0, 0, -5.7> 0.7 }
      sphere { <0, 0, 5.7> 0.7 }
      difference {
        merge {
          cylinder { <-5.5, -2, -6> <4, 4, -6> 1.500001 }
          sphere { <-5.5, -2, -6> 1.5 }
        }
        box { <-10, -10, -5.5> <10, 10, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-7, -6, -7.75> <5, 7.5, 7.5> } }
    }
  #end
#end
#macro dome_top_slots(color_tex)
  #if (setting = 0)
    cylinder { 0*y 19.1*y, 7.8 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { 0*y, 13.8*y, 7.8 }
          sphere { <0, 0, 0> 7.799999 scale <1, 0.9, 1> translate <0, 13.799999, 0> }
        }
        box { <-10, 3.1, -1> <10, 20, 1> }
        box { <-1, 3.100005, -10> <1, 20, 10> }
        cylinder { 6.3*y, 20*y, 2.9 }
        #if (setting > 1)
          box { <-6.39, -1, -6.39> <6.39, 2, 6.39> }
          object { axle_opening(7.300005,2) rotate 90*z translate <0, -1, 0> }
          difference {
            merge {
              cylinder { -1*y, 13.8*y, 6.3 }
              sphere { <0, 0, 0> 6.299999 scale <1, 0.9, 1> translate <0, 13.799999, 0> }
            }
            box { <-2.5, -2, -7> <2.5, 20, 7> }
            box { <-7, -2, -2.5> <7, 20, 2.5> }
          }
        #end
        box { <-10, 19.1, -10> <10, 30, 10> }
      }
      #if (setting > 1)
        object { ring() }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 19.2*y, 7.9 } }
    }
  #end
#end
#macro door_left_frame(color_tex)
  #if (setting = 0)
    difference {
      box { <-4, 2.1, -2> <27.9, 47.9, 0.7> }
      box { <-1, 5.1, -3> <24.9, 44.9, 1> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-4, 2.1, -2> <27.9, 47.9, 0.7> }
        box { <-1, 5.1, -3> <24.9, 44.9, 1> }
        box { <-2.4, 3, -0.8> <27, 47, 1.000001> }
        box { <-5, -1, -0.800001> <4.5, 5.2, 1.000002> }
        box { <-5, 44.6, -0.800001> <4.5, 48, 1.000003> }
        difference {
          box { <-5, -1, -5> <0, 49, 0> }
          cylinder { -1*y, 48*y, 4 }
        }
      }
      box { <-3.999999, 5.200001, -0.1> <-2.400001, 44.599999, 2.5> }
      box { <21.8, 22.4, -3.7> <26.4, 27, -1.9> }
      texture { color_tex }
      bounded_by { box { <-4.1, 1, -3.8> <28, 48, 2.6> } }
    }
  #end
#end
#macro door_left_glass(color_tex)
  #if (setting = 0)
    box { <-4.000001, 2, -0.7> <26.9, 47.9, 0.7> texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { 0*y, 2.1*y, 3.9 }
        cylinder { -1*y, 2*y, 2.5 }
      }
      difference {
        box { <-4.000001, 2, -0.7> <26.9, 47.9, 0.7> }
        box { <4.600001, 1, -1> <27, 2.9, 1> }
        box { <4.600001, 46.9, -1> <27, 48, 1> }
        box { <-5, 5.3, -1> <-2.5, 44.5, 1> }
      }
      #if (setting < 3)
        cylinder { 47.899999*y, 49.6*y, 2.4 }
      #else
        object { rounded_button() translate <0, 44.899999, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <27, 49.7, 4> } }
    }
  #end
#end
#macro door_right_barred_frame(color_tex)
  #if (setting = 0)
    difference {
      box { <-4, 2.1, 2> <27.9, 47.9, -0.7> }
      box { <0, 6.1, 3> <23.9, 21.9, -1> }
      box { <0, 28.1, 3> <23.9, 44.9, -1> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-4, 2.1, 2> <27.9, 47.9, -0.7> }
          box { <0, 6.1, 3> <23.9, 21.9, -1> }
          box { <0, 28.1, 3> <23.9, 44.9, -1> }
          box { <-2.4, 3, 0.8> <27, 47, -1.000001> }
          box { <-5, -1, 0.800001> <4.5, 5.2, -1.000002> }
          box { <-5, 44.6, 0.800001> <4.5, 48, -1.000003> }
          difference {
            box { <-5, -1, 5> <0, 49, 0> }
            cylinder { -1*y, 48*y, 4 }
          }
        }
        box { <-3.999999, 5.200001, 0.1> <-2.400001, 44.599999, -2.5> }
        box { <6.8, 4, 0.79999> <8.8, 46.2, 2.8> }
        box { <15.2, 4, 0.79999> <17.2, 46.2, 2.8> }
        box { <22.5, 24.2, 1.9> <25.6, 25.8, 3.90001> }
        cylinder { 3.9*z, 1.9*z, 0.8 translate <22.5, 25, 0> }
        cylinder { 3.9*z, 1.9*z, 0.8 translate <25.6, 25, 0> }
      }
      cylinder { 2.4*z, 0*z, 0.81 translate <22.5, 25, 0> }
      texture { color_tex }
      bounded_by { box { <-4.1, 1, 4> <28, 48, -2.6> } }
    }
  #end
#end
#macro door_right_frame(color_tex)
  #if (setting = 0)
    difference {
      box { <-4, 2.1, 2> <27.9, 47.9, -0.7> }
      box { <-1, 5.1, 3> <24.9, 44.9, -1> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-4, 2.1, 2> <27.9, 47.9, -0.7> }
        box { <-1, 5.1, 3> <24.9, 44.9, -1> }
        box { <-2.4, 3, 0.8> <27, 47, -1.000001> }
        box { <-5, -1, 0.800001> <4.5, 5.2, -1.000002> }
        box { <-5, 44.6, 0.800001> <4.5, 48, -1.000003> }
        difference {
          box { <-5, -1, 5> <0, 49, 0> }
          cylinder { -1*y, 48*y, 4 }
        }
      }
      box { <-3.999999, 5.200001, 0.1> <-2.400001, 44.599999, -2.5> }
      box { <21.8, 22.4, 3.7> <26.4, 27, 1.9> }
      texture { color_tex }
      bounded_by { box { <-4.1, 1, 3.8> <28, 48, -2.6> } }
    }
  #end
#end
#macro door_right_glass(color_tex)
  #if (setting = 0)
    box { <-4.000001, 2, -0.7> <26.9, 47.9, 0.7> texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { 0*y, 2.1*y, 3.9 }
        cylinder { -1*y, 2*y, 2.5 }
      }
      difference {
        box { <-4.000001, 2, -0.7> <26.9, 47.9, 0.7> }
        box { <4.600001, 1, -1> <27, 2.9, 1> }
        box { <4.600001, 46.9, -1> <27, 48, 1> }
        box { <-5, 5.3, -1> <-2.5, 44.5, 1> }
      }
      #if (setting < 3)
        cylinder { 47.899999*y, 49.6*y, 2.4 }
      #else
        object { rounded_button() translate <0, 44.899999, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <27, 49.7, 4> } }
    }
  #end
#end
#macro double_barrel(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 8*z, 56*z, 1.5 }
      cylinder { 8*z, 56*z, 1.5 translate <0, 21, 0> }
      cylinder { 0*y, 21*y, 1.5 translate <0, 0, 8> }
      cylinder { 0*y, 21*y, 1.5 translate <0, 0, 56> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        sphere { <0, 0, 8> 1.5 }
        sphere { <0, 0, 56> 1.5 }
        sphere { <0, 21, 8> 1.5 }
        sphere { <0, 21, 56> 1.5 }
        cylinder { 7.999999*z, 56.000001*z, 1.500001 }
        cylinder { 7.999999*z, 56.000001*z, 1.500001 translate <0, 21, 0> }
        cylinder { -0.000001*y, 21.0000001*y, 1.500001 translate <0, 0, 8> }
        cylinder { -0.000001*y, 21.000001*y, 1.500001 translate <0, 0, 16> }
        cylinder { -0.000001*y, 21.000001*y, 1.500001 translate <0, 0, 24> }
        cylinder { -0.000001*y, 21.000001*y, 1.500001 translate <0, 0, 32> }
        cylinder { -0.000001*y, 21.000001*y, 1.500001 translate <0, 0, 40> }
        cylinder { -0.000001*y, 21.000001*y, 1.500001 translate <0, 0, 48> }
        cylinder { -0.000001*y, 21.000001*y, 1.500001 translate <0, 0, 56> }
        box { <-3, 2.4, -3> <3, 5.3, 0> }
        box { <-3, 15.5, -3> <3, 18.4, 0> }
        box { <-1.500001, 2.400001, 0> <1.500001, 5.300001, 8> }
        box { <-1.500001, 15.500001, 0> <1.500001, 18.400001, 8> }
        cylinder { 2.400002*y, 5.299998*y, 3 }
        cylinder { 15.500002*y, 18.399998*y, 3 }
      }
      cylinder { 0*y, 21*y, 1.6 }
      box { <-1.5, 0, -4> <1.5, 21, 0> }
      texture { color_tex }
      bounded_by { box { <-3.1, -1.6, -3.1> <3.1, 22.6, 57.6> } }
    }
  #end
#end
#macro dswheelbase2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      cylinder { -3.900001*z, 11.900001*z, 3.75 translate <4, -0.8, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
        object { open_rounded_button() }
        object { open_rounded_button() translate <8, 0, 0> }
        object { open_rounded_button() translate <0, 0, 8> }
        object { open_rounded_button() translate <8, 0, 8> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 3.1, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 3.1, 8> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 8> }
        #end
        cylinder { -3.900001*z, 3*z, 3.75 translate <4, -0.8, 0> }
        box { <0.250001, -0.800001, -3.900002> <7.750001, 2.1, 3.000001> }
        cylinder { 11.900001*z, 5*z, 3.75 translate <4, -0.8, 0> }
        box { <0.250001, -0.800001, 5.000001> <7.750001, 2.1, 11.900002> }
      }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          box { <0.250001, -2, -3.900003> <7.750001, 2.1, 2.999998> }
          box { <0.250001, -0.7500001, 5.000003> <7.750001, 2.1, 11.900003> }
        }
      #end
      cylinder { -5*z, 13*z, 2.5 translate <4, -0.8, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <4, -0.8, 0> }
      cylinder { 11.4*z, 13*z, 3.1 translate <4, -0.8, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -4.65, -4> <12, 4.9, 12> } }
    }
  #end
#end
#macro dualslope1_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      box { <-20, 0, -20> <20, 20, 20> rotate 43.5*z translate <4, 9.5, 0> }
      box { <-20, 0, -20> <20, 20, 20> rotate -43.5*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    difference {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
        box { <-20, 0, -20> <20, 20, 20> texture { color_tex normal { bumping } }
          rotate 43.5*z translate <4, 9.5, 0> }
        box { <-20, 0, -20> <20, 20, 20> texture { color_tex normal { bumping } }
          rotate -43.5*z translate <4, 9.5, 0> }
      }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          box { <-20, 0, -20> <20, 20, 20> rotate 43.5*z translate <4, 7.5, 0> }
          box { <-20, 0, -20> <20, 20, 20> rotate -43.5*z translate <4, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 9.6, 4> } }
    }
  #end
#end
#macro dualslope2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
      box { <-20, 0, -20> <20, 20, 20> rotate 43.5*z translate <4, 9.5, 0> }
      box { <-20, 0, -20> <20, 20, 20> rotate -43.5*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
          box { <-20, 0, -20> <20, 20, 20> texture { color_tex normal { bumping } }
            rotate 43.5*z translate <4, 9.5, 0> }
          box { <-20, 0, -20> <20, 20, 20> texture { color_tex normal { bumping } }
            rotate -43.5*z translate <4, 9.5, 0> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 8.6, 10.4> }
            box { <-20, 0, -20> <20, 20, 20> rotate 43.5*z translate <4, 7.5, 0> }
            box { <-20, 0, -20> <20, 20, 20> rotate -43.5*z translate <4, 7.5, 0> }
          }
        #end
      }
      #if (setting > 1)
        difference {
          object { high_ring() translate <4, 0, 4> }
          box { <-20, 0, -20> <20, 20, 20> rotate 43.5*z translate <4, 7.6, 0> }
          box { <-20, 0, -20> <20, 20, 20> rotate -43.5*z translate <4, 7.6, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 9.6, 12> } }
    }
  #end
#end
#macro dualslope3_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 19.9> }
      box { <-20, 0, -20> <20, 20, 30> rotate 43.5*z translate <4, 9.5, 0> }
      box { <-20, 0, -20> <20, 20, 30> rotate -43.5*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 19.9> }
          box { <-20, 0, -20> <20, 20, 30> texture { color_tex normal { bumping } }
            rotate 43.5*z translate <4, 9.5, 0> }
          box { <-20, 0, -20> <20, 20, 30> texture { color_tex normal { bumping } }
            rotate -43.5*z translate <4, 9.5, 0> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 8.6, 18.4> }
            box { <-20, 0, -20> <20, 20, 30> rotate 43.5*z translate <4, 7.5, 0> }
            box { <-20, 0, -20> <20, 20, 30> rotate -43.5*z translate <4, 7.5, 0> }
          }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { high_ring() translate <4, 0, 4> }
            object { high_ring() translate <4, 0, 12> }
          }
          box { <-20, 0, -20> <20, 20, 30> rotate 43.5*z translate <4, 7.6, 0> }
          box { <-20, 0, -20> <20, 20, 30> rotate -43.5*z translate <4, 7.6, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 9.6, 20> } }
    }
  #end
#end
#macro dualslope4_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 27.9> }
      box { <-20, 0, -20> <20, 20, 30> rotate 43.5*z translate <4, 9.5, 0> }
      box { <-20, 0, -20> <20, 20, 30> rotate -43.5*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 27.9> }
          box { <-20, 0, -20> <20, 20, 30> texture { color_tex normal { bumping } }
            rotate 43.5*z translate <4, 9.5, 0> }
          box { <-20, 0, -20> <20, 20, 30> texture { color_tex normal { bumping } }
            rotate -43.5*z translate <4, 9.5, 0> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 8.6, 26.4> }
            box { <-20, 0, -20> <20, 20, 30> rotate 43.5*z translate <4, 7.5, 0> }
            box { <-20, 0, -20> <20, 20, 30> rotate -43.5*z translate <4, 7.5, 0> }
          }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { high_ring() translate <4, 0, 4> }
            object { high_ring() translate <4, 0, 12> }
            object { high_ring() translate <4, 0, 20> }
          }
          box { <-20, 0, -20> <20, 20, 30> rotate 43.5*z translate <4, 7.6, 0> }
          box { <-20, 0, -20> <20, 20, 30> rotate -43.5*z translate <4, 7.6, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 9.6, 28> } }
    }
  #end
#end
#macro dualslope4_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 9.5, 27.9> }
      box { <-20, 0, -20> <20, 20, 30> rotate 43.5*z translate <4, 9.5, 0> }
      box { <-20, 0, -20> <20, 20, 30> rotate -43.5*z translate <36, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <43.9, 9.5, 27.9> }
            box { <-20, 0, -20> <20, 20, 30> texture { color_tex normal { bumping } }
              rotate 43.5*z translate <4, 9.5, 0> }
            box { <-20, 0, -20> <20, 20, 30> texture { color_tex normal { bumping } }
              rotate -43.5*z translate <36, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 24> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 24> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 24> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 24> }
          #else
            object { rounded_button() rotate 90*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 24> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 24> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 24> }
            object { rounded_button() rotate 90*y translate <32, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <32, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <32, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <32, 6.4, 24> }
          #end
        }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 24> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 24> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 24> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 24> }
          difference {
            box { <-2.4, -1, -2.4> <42.4, 8.6, 26.4> }
            box { <-20, 0, -20> <20, 20, 30> rotate 43.5*z translate <4, 7.5, 0> }
            box { <-20, 0, -20> <20, 20, 30> rotate -43.5*z translate <36, 7.5, 0> }
          }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            box { <-4, 0.000001, 2.4> <44, 9, 3.9> }
            box { <-4, 0.000001, 20.1> <44, 9, 21.6> }
            box { <11.5, 0.000002, -3> <12.5, 9, 3> }
            box { <11.5, 0.000002, 21> <12.5, 9, 27> }
            box { <27.5, 0.000002, -3> <28.5, 9, 3> }
            box { <27.5, 0.000002, 21> <28.5, 9, 27> }
            cylinder { 0.000003*y, 9*y, 1.5 translate <4, 0, 0> }
            cylinder { 0.000003*y, 9*y, 1.5 translate <12, 0, 0> }
            cylinder { 0.000003*y, 9*y, 1.5 translate <20, 0, 0> }
            cylinder { 0.000003*y, 9*y, 1.5 translate <28, 0, 0> }
            cylinder { 0.000003*y, 9*y, 1.5 translate <36, 0, 0> }
            cylinder { 0.000003*y, 9*y, 1.5 translate <4, 0, 24> }
            cylinder { 0.000003*y, 9*y, 1.5 translate <12, 0, 24> }
            cylinder { 0.000003*y, 9*y, 1.5 translate <20, 0, 24> }
            cylinder { 0.000003*y, 9*y, 1.5 translate <28, 0, 24> }
            cylinder { 0.000003*y, 9*y, 1.5 translate <36, 0, 24> }
          }
          box { <-20, 0, -20> <20, 20, 30> rotate 43.5*z translate <4, 7.6, 0> }
          box { <-20, 0, -20> <20, 20, 30> rotate -43.5*z translate <36, 7.6, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 11.3, 28> } }
    }
  #end
#end
#macro dualslope6_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 9.5, 43.9> }
      box { <-20, 0, -10> <10, 10 ,45> rotate 24.5*z translate <12, 9.5, 0> }
      box{<-10, 0, -10> <20, 10, 45> rotate -24.5*z translate <28, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <43.9, 9.5, 43.9> }
            box { <-20, 0, -10> <10, 10 ,45> texture { color_tex normal { bumping } }
              rotate 24.5*z translate <12, 9.5, 0> }
            box{<-10, 0, -10> <20, 10, 45> texture { color_tex normal { bumping } }
              rotate -24.5*z translate <28, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 24> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 32> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 40> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0 > }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 24> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 32> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 40> }
          #else
            object { rounded_button() rotate 90*y translate <16, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 24> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 32> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 40> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 0 > }
            object { rounded_button() rotate 90*y translate <24, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 24> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 32> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 40> }
          #end
        }
        #if (setting > 1)
          box { <-4, -1, 12> <-3.4, 0.5, 28> }
          box { <43.4, -1, 12> <44, 0.5, 28> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 24> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 32> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 40> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 24> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 32> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 40> }
          difference {
            box { <-2.4, -1, -2.4> <42.4, 8.6, 42.4> }
            box { <-20, 0, -10> <10, 10, 45> rotate 24.5*z translate <12, 7.5, 0> }
            box { <-10, 0, -10> <20, 10, 45> rotate -24.5*z translate <28, 7.5, 0> }
          }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { high_ring() translate <4, 0, 4> }
            object { high_ring() translate <4, 0, 12> }
            object { high_ring() translate <4, 0, 20> }
            object { high_ring() translate <4, 0, 28> }
            object { high_ring() translate <4, 0, 36> }
            object { high_ring() translate <36, 0, 4> }
            object { high_ring() translate <36, 0, 12> }
            object { high_ring() translate <36, 0, 20> }
            object { high_ring() translate <36, 0, 28> }
            object { high_ring() translate <36, 0, 36> }
          }
          box { <-20 ,0, -10> <10, 10, 45> rotate 24.5*z translate <12, 7.5, 0> }
          box { <-10, 0, -10> <20, 10, 45> rotate -24.5*z translate <28, 7.5, 0> }
        }
        object { ring() translate <20, 6.4, 4> }
        object { ring() translate <20, 6.4, 12> }
        object { ring() translate <20, 6.4, 20> }
        object { ring() translate <20, 6.4, 28> }
        object { ring() translate <20, 6.4, 36> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 11.3, 44> } }
    }
  #end
#end
#macro dual_seats_piece(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -9.5> <35.9, 19.1, 33.5> }
      box { <4, 3.1, -8.3> <28.7, 20, 32.3> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          merge {
            box { <-3.9, 0, -3.9> <35.9, 12.7, 27.9> }
            difference {
              box { <2.4, 2.000001, -9.5> <30.6, 12.700001, 33.5> }
              box { <0, -1, -10> <20, 20, 0> rotate 22.25*y translate <2.4, 0, -5.6> }
              box { <0, -1, 0> <20, 20, 10> rotate -22.25*y translate <2.4, 0, 29.6> }
            }
            object { rounded_button() rotate -90*y translate <0, 9.6, 0> }
            object { rounded_button() rotate -90*y translate <0, 9.6, 8> }
            object { rounded_button() rotate -90*y translate <0, 9.6, 16> }
            object { rounded_button() rotate -90*y translate <0, 9.6, 24> }
            box { <30.600009, 12.6, -3.900001> <35.900001, 19.1, 27.900001> }
            object { open_rounded_button() translate <32, 16, 0> }
            object { open_rounded_button() translate <32, 16, 24> }
            box { <28.700004, 3, -6.500001> <30.600004, 19.100001, 6.500001> }
            box { <28.700003, 3, -8.500001> <30.600003, 17.100001, 8.500001> }
            cylinder { 28.7*x, 30.600005*x, 2 translate <0, 17.1, -6.5> }
            cylinder { 28.7*x, 30.600005*x, 2 translate <0, 17.1, 6.5> }
            box { <28.700004, 3, 17.500001> <30.600004, 19.100001, 30.500001> }
            box { <28.700003, 3, 15.500001> <30.600003, 17.100001, 32.500001> }
            cylinder { 28.7*x, 30.600005*x, 2 translate <0, 17.1, 17.5> }
            cylinder { 28.7*x, 30.600005*x, 2 translate <0, 17.1, 30.5> }
          }
          #if (setting > 1)
            box { <24, 9.5, 8> <32, 20, 16> }
            box { <30.599999, -1, -2.4> <34.4, 18.2, 26.4> }
            box { <30.599998, -1, 4.000001> <34.400001, 20, 20.000001> }
            difference {
              box { <-2.4, -1, -2.4> <2.4, 11.8, 26.4> }
              difference {
                box { <-2.5, 0.2, 0> <2.5, 12, 2.5> }
                box { <-2.5, 0, -2.5> <2.5, 20, 2.5> rotate 45*y }
              }
              difference {
                box { <-2.5, 0.2, -2.5> <2.5, 12, 2.5> }
                box { <-2.5, 0, -2.5> <2.5, 20, 2.5> rotate 45*y }
                translate <0, 0, 8>
              }
              difference {
                box { <-2.5, 0.2, -2.5> <2.5, 12, 2.5> }
                box { <-2.5, 0, -2.5> <2.5, 20, 2.5> rotate 45*y }
                translate <0, 0, 16>
              }
              difference {
                box { <-2.5, 0.2, -2.5> <2.5, 12, 0> }
                box { <-2.5, 0, -2.5> <2.5, 20, 2.5> rotate 45*y }
                translate <0, 0, 24>
              }
            }
          #end
          difference {
            box { <4, 3.1, -8.3> <28.700001, 15, 32.3> }
            box { <-10, 0, -10> <20, 20, 0> rotate 22.25*y translate <3.9, 0, -4.6> }
            box { <-10, 0, 0> <20, 20, 10> rotate -22.25*y translate <3.9, 0, 28.6> }
            object { open_rounded_button() translate <8, 0, 8> }
            object { open_rounded_button() translate <8, 0, 16> }
          }
          #if (setting > 1)
            cylinder { -1*y, 25*y, 1.600001 translate <32, 0, 0> }
            cylinder { -1*y, 25*y, 1.600001 translate <32, 0, 24> }
            cylinder { -1*y, 10*y, 1.600001 translate <8, 0, 8> }
            cylinder { -1*y, 10*y, 1.600001 translate <8, 0, 16> }
            difference {
              box { <4, -1, -2.4> <28, 2, 26.4> }
              box { <3.5, 0.1, -0.5> <5.6, 3, 0.5> }
              box { <3.5, 0.1, 7.5> <5.6, 3, 8.5> }
              box { <3.5, 0.1, 15.5> <5.6, 3, 16.5> }
              box { <3.5, 0.1, 23.5> <5.6, 3, 24.5> }
              box { <26.4, 0.1, -0.5> <29, 3, 0.5> }
              box { <26.4, 0.1, 7.5> <29, 3, 8.5> }
              box { <26.4, 0.1, 15.5> <29, 3, 16.5> }
              box { <26.4, 0.1, 23.5> <29, 3, 24.5> }
              object { ring() translate <12, 0.1, 4> }
              object { ring() translate <12, 0.1, 12> }
              object { ring() translate <12, 0.1, 20> }
              object { ring() translate <20, 0.1, 4> }
              object { ring() translate <20, 0.1, 12> }
              object { ring() translate <20, 0.1, 20> }
            }
          #end
        }
        object { open_rounded_button() translate <8, 0, 0> }
        object { open_rounded_button() translate <8, 0, 24> }
        object { open_rounded_button() translate <16, 0, -4> }
        object { open_rounded_button() translate <16, 0, 4> }
        object { open_rounded_button() translate <16, 0, 20> }
        object { open_rounded_button() translate <16, 0, 28> }
        object { open_rounded_button() rotate -90*x translate <24, 8.8, -6.4> }
        object { open_rounded_button() rotate 90*x translate <24, 8.8, 30.4> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <8, 3.1, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <8, 3.1, 24> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <16, 3.1, -4> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <16, 3.1, 4> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <16, 3.1, 20> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <16, 3.1, 28> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <24, 8.8, -9.5> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y rotate 90*x translate <24, 8.8, 33.5> }
        #end
        sphere { <0, 0, 0> 0.6 scale <1, 1, 2.915> translate <28.7, 17.6, -3.6> }
        sphere { <0, 0, 0> 0.6 scale <1, 1, 2.915> translate <28.7, 17.6, 0> }
        sphere { <0, 0, 0> 0.6 scale <1, 1, 2.915> translate <28.7, 17.6, 3.6> }
        sphere { <0, 0, 0> 0.6 scale <1, 1, 2.915> translate <28.7, 17.6, 20.4> }
        sphere { <0, 0, 0> 0.6 scale <1, 1, 2.915> translate <28.7, 17.6, 24> }
        sphere { <0, 0, 0> 0.6 scale <1, 1, 2.915> translate <28.7, 17.6, 27.6> }
        cylinder { 1.9*y, 17.600001*y, 0.6 scale <1, 1, 2.915> translate <28.7, 0, -3.6> }
        cylinder { 1.9*y, 17.600001*y, 0.6 scale <1, 1, 2.915> translate <28.7, 0, 0> }
        cylinder { 1.9*y, 17.600001*y, 0.6 scale <1, 1, 2.915> translate <28.7, 0, 3.6> }
        cylinder { 1.9*y, 17.600001*y, 0.6 scale <1, 1, 2.915> translate <28.7, 0, 20.4> }
        cylinder { 1.9*y, 17.600001*y, 0.6 scale <1, 1, 2.915> translate <28.7, 0, 24> }
        cylinder { 1.9*y, 17.600001*y, 0.6 scale <1, 1, 2.915> translate <28.7, 0, 27.6> }
        cylinder { 13.5*x, 17*x, 0.7 translate <0, 4.1, 12> }
        box { <13.500001, 3, 11.3> <17.000001, 4.1, 12.7> }
        cylinder { 3*y, 4.8*y, 1 translate <18, 0, 10.7> }
        cylinder { 3*y, 4.8*y, 1 translate <18, 0, 13.3> }
        cylinder { 3*y, 4.8*y, 1 translate <25.5, 0, 10.7> }
        cylinder { 3*y, 4.8*y, 1 translate <25.5, 0, 13.3> }
        box { <17, 3, 10.7> <26.5, 4.800001, 13.3> }
        box { <18, 3, 9.7> <25.5, 4.800002, 14.3> }
        box { <22.5, 1.5, 10.5> <35, 3, 13.5> }
        cylinder { 0*y, 1.6*y, 1.2 translate <32, 0, 12> }
      }
      #if (setting > 1)
        cylinder { -1*y, 10*y, 1.600001 translate <20, 0, 12> }
        cylinder { -1*y, 1.599999*y, 0.6 translate <32, 0, 12> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -11.3> <36, 20.9, 35.3> } }
    }
  #end
#end
#macro dual_tilted_frame(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 57.5, 27.9> }
      box { <-10, -50, -50> <30, 50, 0> rotate -41*x translate <0, 0, 20> }
      box { <-10, -50, -50> <30, 50, 0> rotate 41*x translate <0, 57.5, 18.2> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <27.9, 57.5, 27.9> }
          #if (setting > 1)
            box { <-2.4, -1, 21.6> <26.4, 2, 26.4> }
          #end
          box { <-10, -50, -50> <30, 50, 0> rotate -41*x translate <0, 0, 20> }
          box { <-10, -50, -50> <30, 50, 0> rotate 41*x translate <0, 57.5, 18.2> }
          difference {
            box { <-4, -1, -4> <28, 60, 28> }
            box { <-5, -2, -5> <-2.400001, 61, 29> }
            box { <26.400001, -2, -5> <29, 61, 29> }
            box { <-3, -2, 20.1> <27, 3.1, 28> }
            box { <-3, 56.2, 18.2> <27, 58, 28> }
            box { <-3, 27.5, -5> <27, 32, 3.9> }
          }
          #if (setting > 1)
            difference {
              box { <-2.400002, 20, -2.4> <26.400002, 31.5, 2.4> }
              cylinder { 27.5*y, 32*y, 1.5 translate <4, 0, 0> }
              cylinder { 27.5*y, 32*y, 1.5 translate <12, 0, 0> }
              cylinder { 27.5*y, 32*y, 1.5 translate <20, 0, 0> }
            }
          #end
          difference {
            box { <-4, 3.1, 11.9> <28, 56.5, 28> }
            box { <-10, -50, -50> <30, 50, 0> rotate -41*x translate <0, 3.1, 27.9> }
            box { <-10, -50, -50> <30, 50, 0> rotate 41*x translate <0, 56.5, 27.9> }
          }
        }
        object { open_rounded_button() translate <0, 54.4, 24> }
        object { open_rounded_button() translate <8, 54.4, 24> }
        object { open_rounded_button() translate <16, 54.4, 24> }
        object { open_rounded_button() translate <24, 54.4, 24> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 57.5, 24> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 57.5, 24> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <16, 57.5, 24> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <24, 57.5, 24> }
        #end
        #if (setting > 1)
          object { pin(1) translate <4, 0, 24> }
          object { pin(1) translate <12, 0, 24> }
          object { pin(1) translate <20, 0, 24> }
        #end
      }
      cylinder { -4*x, 28*x, 0.9 translate <0, 15, 10> }
      cylinder { -4*x, 28*x, 0.9 translate <0, 44, 10> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 59.4, 28> } }
    }
  #end
#end
#macro dumppiece_front(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <3.9, 28.7, 43.9> }
      box { <-4, 0, -30> <4, 40, 0> rotate -29.5*x translate <0, 0, 12> }
      box { <-4, 0, 0> <4, 40, 30> rotate 29.5*x translate <0, 0, 28> }
      texture { color_tex }
    }
  #else
merge {
  difference {
    merge {
      box { <-3.9, 0, -3.9> <3.9, 28.7, 43.9> }
      #if (setting < 3)
        cylinder { -5.6*x, -3.8*x, 2.4 translate <0, 24.7, 8> }
        cylinder { -5.6*x, -3.8*x, 2.4 translate <0, 24.7, 16> }
        cylinder { -5.6*x, -3.8*x, 2.4 translate <0, 24.7, 24> }
        cylinder { -5.6*x, -3.8*x, 2.4 translate <0, 24.7, 32> }
      #else
        object { rounded_button() rotate 180*y rotate 90*z translate <-0.8, 24.7, 8> }
        object { rounded_button() rotate 180*y rotate 90*z translate <-0.8, 24.7, 16> }
        object { rounded_button() rotate 180*y rotate 90*z translate <-0.8, 24.7, 24> }
        object { rounded_button() rotate 180*y rotate 90*z translate <-0.8, 24.7, 32> }
      #end
    }
    difference {
      box { <-2.7, 3.1, -3> <4, 30, 43> }
      box { <-3, 27.2, -4> <-0.7, 31, 44> }
      box { <-3, 0, -30> <4, 40, 0> rotate -29.5*x translate <0, 3.1, 11.8> }
      box { <-3, 0, 0> <4, 40, 30> rotate 29.5*x translate <0, 3.1, 28.2> }
    }
    #if (setting > 1)
      box { <-2.4, -1, 13.4> <2.4, 2, 26.6> }
      cylinder { -4.8*x, -1.8*x, 1.2 translate <0, 24.7, 8> }
      cylinder { -4.8*x, -1.8*x, 1.2 translate <0, 24.7, 16> }
      cylinder { -4.8*x, -1.8*x, 1.2 translate <0, 24.7, 24> }
      cylinder { -4.8*x, -1.8*x, 1.2 translate <0, 24.7, 32> }
    #end
    box { <-4, 0, -30> <4, 40, 0> rotate -29.5*x translate <0, 0, 12> }
    box { <-4, 0, -10> <4, 10, 0> rotate -29.5*x translate <0, 28.7, -2.4> }
    box { <-4, 0, 0> <4, 40, 30> rotate 29.5*x translate <0, 0, 28> }
    box { <-4, 0, 0> <4, 10, 10> rotate 29.5*x translate <0, 28.7, 42.4> }
  }
  object { ring() rotate 90*z translate <-0.7, 20.7, 12> }
  object { ring() rotate 90*z translate <-0.7, 20.7, 20> }
  object { ring() rotate 90*z translate <-0.7, 20.7, 28> }
  object { ring() rotate 90*z translate <-0.7, 12.7, 12> }
  object { ring() rotate 90*z translate <-0.7, 12.7, 20> }
  object { ring() rotate 90*z translate <-0.7, 12.7, 28> }
  object { open_rounded_button() rotate -90*x
    translate <0, 4, 3.1> rotate -29.5*x translate <0, 0, 12> }
  object { open_rounded_button() rotate -90*x
    translate <0, 12, 3.1> rotate -29.5*x translate <0, 0, 12> }
  object { open_rounded_button() rotate -90*x
    translate <0, 20, 3.1> rotate -29.5*x translate <0, 0, 12> }
  object { open_rounded_button() rotate -90*x
    translate <0, 28, 3.1> rotate -29.5*x translate <0, 0, 12> }
  object { open_rounded_button() rotate 90*x
    translate <0, 4, -3.1> rotate 29.5*x translate <0, 0, 28> }
  object { open_rounded_button() rotate 90*x
    translate <0, 12, -3.1> rotate 29.5*x translate <0, 0, 28> }
  object { open_rounded_button() rotate 90*x
    translate <0, 20, -3.1> rotate 29.5*x translate <0, 0, 28> }
  object { open_rounded_button() rotate 90*x
    translate <0, 28, -3.1> rotate 29.5*x translate <0, 0, 28> }
  #if (setting > 3)
    object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <0, 4, 0>
      rotate -29.5*x translate <0, 0, 12> }
    object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <0, 12, 0>
      rotate -29.5*x translate <0, 0, 12> }
    object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <0, 20, 0>
      rotate -29.5*x translate <0, 0, 12> }
    object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <0, 28, 0>
      rotate -29.5*x translate <0, 0, 12> }
    object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y rotate 90*x translate <0, 4, 0>
      rotate 29.5*x translate <0, 0, 28> }
    object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y rotate 90*x translate <0, 12, 0>
      rotate 29.5*x translate <0, 0, 28> }
    object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y rotate 90*x translate <0, 20, 0>
      rotate 29.5*x translate <0, 0, 28> }
    object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y rotate 90*x translate <0, 28, 0>
      rotate 29.5*x translate <0, 0, 28> }
  #end
  #if (setting > 1)
    object { pin(2) translate <0, 0, 20> }
  #end
  texture { color_tex }
  bounded_by { box { <-5.7, -0.1, -5> <4, 28.8, 45> } }
}
  #end
#end
#macro dumppiece_rear(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 28.7, 43.9> }
      box { <-4, 0, -30> <20, 40, 0> rotate -29.5*x translate <0, 0, 12> }
      box { <-4, 0, -10> <20, 10, 0> rotate -29.5*x translate <0, 28.7, -2.4> }
      box { <-4, 0, 0> <20, 40, 30> rotate 29.5*x translate <0, 0, 28> }
      box { <-4, 0, 0> <20, 10, 10> rotate 29.5*x translate <0, 28.7, 42.4> }
      box { <0, 0, -30> <50, 50, 50> rotate -48*z translate <4, 0, 0> }
      box { <0, 0, -30> <50, 50, 50> rotate -42*z translate <4, 28.7, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <19.9, 28.7, 43.9> }
        difference {
          box { <-4, 3.1, -3> <21, 30, 43> }
          box { <-5, 0, -30> <22, 40, 0> rotate -29.5*x translate <0, 3.1, 11.8> }
          box { <-5, 0, 0> <22, 40, 30> rotate 29.5*x translate <0, 3.1, 28.2> }
          box { <0, 0, -30> <50, 50, 50> rotate -48*z translate <5.5, 3.1, 0> }
        }
        #if (setting > 1)
          box { <-2.4, -1, 13.4> <2.4, 2, 26.6> }
        #end
        box { <-4, 0, -30> <20, 40, 0> rotate -29.5*x translate <0, 0, 12> }
        box { <-4, 0, -10> <20, 10, 0> rotate -29.5*x translate <0, 28.7, -2.4> }
        box { <-4, 0, 0> <20, 40, 30> rotate 29.5*x translate <0, 0, 28> }
        box { <-4, 0, 0> <20, 10, 10> rotate 29.5*x translate <0, 28.7, 42.4> }
        box { <0, 0, -30> <50, 50, 50> rotate -48*z translate <4, 0, 0> }
        box { <0, 0, -30> <50, 50, 50> rotate -42*z translate <4, 28.7, 0> }
      }
      object { open_rounded_button() rotate -90*x
        translate <0, 4, 3.1> rotate -29.5*x translate <0, 0, 12> }
      object { open_rounded_button() rotate -90*x
        translate <0, 12, 3.1> rotate -29.5*x translate <0, 0, 12> }
      object { open_rounded_button() rotate -90*x
        translate <0, 20, 3.1> rotate -29.5*x translate <0, 0, 12> }
      object { open_rounded_button() rotate -90*x
        translate <0, 28, 3.1> rotate -29.5*x translate <0, 0, 12> }
      object { open_rounded_button() rotate 90*x
        translate <0, 4, -3.1> rotate 29.5*x translate <0, 0, 28> }
      object { open_rounded_button() rotate 90*x
        translate <0, 12, -3.1> rotate 29.5*x translate <0, 0, 28> }
      object { open_rounded_button() rotate 90*x
        translate <0, 20, -3.1> rotate 29.5*x translate <0, 0, 28> }
      object { open_rounded_button() rotate 90*x
        translate <0, 28, -3.1> rotate 29.5*x translate <0, 0, 28> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <0, 4, 0>
          rotate -29.5*x translate <0, 0, 12> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <0, 12, 0>
          rotate -29.5*x translate <0, 0, 12> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <0, 20, 0>
          rotate -29.5*x translate <0, 0, 12> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <0, 28, 0>
          rotate -29.5*x translate <0, 0, 12> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y rotate 90*x translate <0, 4, 0>
          rotate 29.5*x translate <0, 0, 28> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y rotate 90*x translate <0, 12, 0>
          rotate 29.5*x translate <0, 0, 28> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y rotate 90*x translate <0, 20, 0>
          rotate 29.5*x translate <0, 0, 28> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y rotate 90*x translate <0, 28, 0>
          rotate 29.5*x translate <0, 0, 28> }
      #end
      #if (setting > 1)
        object { pin(1) translate <0, 0, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-5.7, -0.1, -5> <20, 28.8, 45> } }
    }
  #end
#end
#macro dustbin(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 19.1*y, 7.9 translate <4, 0, 4> texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { 2*y, 19.1*y, 7.9 translate <4, 0, 4> }
        cylinder { 3*y, 20*y, 6.9 translate <4, 0, 4> }
      }
      object { ring() translate <4, 0, 4> }
      box { <-3.5, 0, 2> <-3, 2.1, 6> }
      box { <11, 0, 2> <11.5, 2.1, 6> }
      box { <2, 0, -3.5> <6, 2.1, -3> }
      box { <2, 0, 11> <6, 2.1, 11.5> }
      box { <11.5, 15, 1.5> <12.5, 19.9, 6.5> }
      box { <-4.5, 15, 1.5> <-3.5, 19.9, 6.5> }
      #local counter = 0;
      #while (counter < 12)
        box { <-0.5, 2.000001, -8.1> <0.5, 19.099999, -7.8> rotate (counter*30)*y translate <4, 0, 4> }
        #local counter = counter + 1;
      #end
      cylinder { 1*z, 7*z, 1.55 translate <15.5, 15.05, 0> }
      cylinder { 1*z, 7*z, 1.55 translate <-7.5, 15.05, 0> }
      difference {
        box { <10.9, 14.1, -0.5> <15.5, 16, 8.5> }
        box { <0, 13, 0> <10, 17, 10> rotate 10*y translate <10.9, 0, 8.5> }
        box { <0, 13, -10> <10, 17, 0> rotate -10*y translate <10.9, 0, -0.5> }
        box { <10, 13, 1.5> <15, 17, 6.5> }
      }
      difference {
        box { <-7.5, 14.1, -0.5> <-2.9, 16, 8.5> }
        box { <-10, 13, 0> <0, 17, 10> rotate -10*y translate <-2.9, 0, 8.5> }
        box { <-10, 13, -10> <0, 17, 0> rotate 10*y translate <-2.9, 0, -0.5> }
        box { <-7, 13, 1.5> <-2, 17, 6.5> }
      }
      texture { color_tex }
      bounded_by { box { <-10, -0.1, -4> <18, 20, 12> } }
    }
  #end
#end
#macro d_connect1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      cylinder { -3.1*y, 3.1*y, 3.1 translate <-8, 0, -4> }
      cylinder { -3.1*y, 3.1*y, 3.1 translate <16, 0, -4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 4.8*y, -0.1*y, 2.4 translate <-8, 0, -4> }
            cylinder { 4.8*y, -0.1*y, 2.4 translate <16, 0, -4> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
            cylinder { 3.100001*y, -0.1*y, 2.4 translate <-8, 0, -4> }
            cylinder { 3.100001*y, -0.1*y, 2.4 translate <16, 0, -4> }
            object { open_rounded_button() translate <-8, 0, -4> }
            object { open_rounded_button() translate <16, 0, -4> }
          #end
          cylinder { -3.1*y, 0*y, 3.1 translate <-8, 0, -4> }
          cylinder { -3.1*y, 0*y, 3.1 translate <16, 0, -4> }
          box { <0, 0.000001, -2.250001> <8, 3.100001, 2.250001> rotate -35*y translate <-8, 0, -4> }
          box { <-8, 0.000001, -2.250001> <0, 3.100001, 2.250001> rotate 35*y translate <16, 0, -4> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { -4*y, -1.1*y, 2.6 translate <-8, 0, -4> }
          cylinder { -4*y, -1.1*y, 2.6 translate <16, 0, -4> }
          cylinder { -5*y, 6*y, 1.600001 translate <-8, 0, -4> }
          cylinder { -5*y, 6*y, 1.600001 translate <16, 0, -4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-11.2, -3.2, -7.2> <19.2, 4.9, 4> } }
    }
  #end
#end
#macro end_dualslope2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 10.9> }
      box { <-20, 0, -20> <20, 20, 20> rotate 43.5*z translate <4, 9.5, 0> }
      box { <-20, 0, -20> <20, 20, 20> rotate -43.5*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    difference {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 9.5, 10.9> }
        box { <-20, 0, -20> <20, 20, 20> texture { color_tex normal { bumping } }
          rotate 43.5*z translate <4, 9.5, 0> }
        box { <-20, 0, -20> <20, 20, 20> texture { color_tex normal { bumping } }
          rotate -43.5*z translate <4, 9.5, 0> }
      }
      difference {
        merge {
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          box { <-2.4, -1, 4> <10.4, 8.6, 12> }
        }
        box { <-20, 0, -20> <20, 20, 20> rotate 43.5*z translate <4, 7.5, 0> }
        box { <-20, 0, -20> <20, 20, 20> rotate -43.5*z translate <4, 7.5, 0> }
      }
      box { <-4, -10.9, 0> <12, 0, 10> rotate 46.5*x translate <0, 9.5, 11.9> }
      box { <-4, -1, 4.000001> <12, 2, 12> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 9.6, 11> } }
    }
  #end
#end
#macro engine2_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 38.3, 11.9> }
      cylinder { -2.9*z, 12*z, 13.8 translate <12, 22, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
          box { <0, -3, -3.900005> <3, 0, 11.900005> rotate -45*z translate <12, 5, 0> }
          box { <-3.900007, 3, 0.1> <-2.5, 9.5, 7.9> }
          box { <27.900007, 3, 0.1> <26.5, 9.5, 7.9> }
          box { <0, -1.4, 0.100005> <6, 0, 7.899995> rotate 40*z translate <-3.9, 9.5, 0> }
          box { <-6, -1.4, 0.100005> <0, 0, 7.899995> rotate -40*z translate <27.9, 9.5, 0> }
          box { <1.5, 3, -2> <3.000005, 12, 10> }
          box { <11.25, 3, -3.900003> <12.75, 7.5, 11.900003> }
          box { <21.000005, 3, -2> <22.5, 12, 10> }
          cylinder { -3*x, 2*x, 3.6 translate <0, 5.6, 4> }
          cylinder { 22*x, 27*x, 3.6 translate <0, 5.6, 4> }
          cylinder { -3.900003*z, 11.900003*z, 15.1 translate <12, 22, 0> }
          box { <8, 36, -3.900009> <16, 38, 11.900009> }
          cylinder { 38.3*y, 36.8*y, 3.9 }
          cylinder { 38.3*y, 36.8*y, 3.9 translate <0, 0, 8> }
          cylinder { 38.3*y, 36.8*y, 3.9 translate <24, 0, 0> }
          cylinder { 38.3*y, 36.8*y, 3.9 translate <24, 0, 8> }
          box { <0, 36.800005, -3.9> <24, 38.300005, 11.9> }
          box { <-3.9, 36.800004, 0> <27.9, 38.300004, 8> }
          cylinder { 33.6*y, 32.1*y, 3.9 }
          cylinder { 33.6*y, 32.1*y, 3.9 translate <0, 0, 8> }
          cylinder { 33.6*y, 32.1*y, 3.9 translate <24, 0, 0> }
          cylinder { 33.6*y, 32.1*y, 3.9 translate <24, 0, 8> }
          box { <0, 33.600005, -3.9> <24, 32.100005, 11.9> }
          box { <-3.9, 33.600004, 0> <27.9, 32.100004, 8> }
          cylinder { 28.9*y, 27.4*y, 2.5 translate <-1.4, 0, 1> }
          cylinder { 28.9*y, 27.4*y, 2.5 translate <-1.4, 0, 7> }
          cylinder { 28.9*y, 27.4*y, 2.5 translate <25.4, 0, 1> }
          cylinder { 28.9*y, 27.4*y, 2.5 translate <25.4, 0, 7> }
          box { <-1.4, 28.900005, -1.5> <25.4, 27.400005, 9.5> }
          box { <-3.9, 28.900004, 1> <27.9, 27.400004, 7> }
          cylinder { 24.2*y, 22.7*y, 1.25 translate <-2.65, 0, 1> }
          cylinder { 24.2*y, 22.7*y, 1.25 translate <-2.65, 0, 7> }
          cylinder { 24.2*y, 22.7*y, 1.25 translate <26.65, 0, 1> }
          cylinder { 24.2*y, 22.7*y, 1.25 translate <26.65, 0, 7> }
          box { <-2.65, 24.200005, -0.25> <26.65, 22.700005, 8.25> }
          box { <-3.9, 24.200004, 1> <27.9, 22.700004, 7> }
          intersection {
            merge {
              merge {
                cylinder { 19.5*y, 18*y, 1.25 translate <-2.45, 0, 1> }
                cylinder { 19.5*y, 18*y, 1.25 translate <-2.45, 0, 7> }
                cylinder { 19.5*y, 18*y, 1.25 translate <26.45, 0, 1> }
                cylinder { 19.5*y, 18*y, 1.25 translate <26.45, 0, 7> }
                box { <-2.45, 19.500005, -0.25> <26.45, 18.000005, 8.25> }
                box { <-3.7, 19.500004, 1> <27.7, 18.000004, 7> }
              }
              merge {
                cylinder { 14.8*y, 13.3*y, 1.25 translate <-0.95, 0, 1> }
                cylinder { 14.8*y, 13.3*y, 1.25 translate <-0.95, 0, 7> }
                cylinder { 14.8*y, 13.3*y, 1.25 translate <24.95, 0, 1> }
                cylinder { 14.8*y, 13.3*y, 1.25 translate <24.95, 0, 7> }
                box { <-0.95, 14.800005, -0.25> <24.95, 13.300005, 8.25> }
                box { <-2.2, 14.800004, 1> <26.2, 13.300004, 7> }
              }
            }
            cylinder { -3*z, 11*z, 15.9 translate <12, 22, 0> }
          }
          box { <-3.900002, 22, 3.25> <27.900002, 38, 4.75> }
          difference {
            cylinder { 3.250001*z, 4.750001*z, 15.9 translate <12, 22, 0> }
            box { <4, 0, 3> <28, 12, 5> }
          }
          object { open_rounded_button() translate <0, 35.2, 0> }
          object { open_rounded_button() translate <8, 35.2, 0> }
          object { open_rounded_button() translate <16, 35.2, 0> }
          object { open_rounded_button() translate <24, 35.2, 0> }
          object { open_rounded_button() translate <0, 35.2, 8> }
          object { open_rounded_button() translate <8, 35.2, 8> }
          object { open_rounded_button() translate <16, 35.2, 8> }
          object { open_rounded_button() translate <24, 35.2, 8> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <0, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <0, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <8, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <8, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <16, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <16, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <24, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <24, 38.3, 8> }
          #end
        }
        difference {
          cylinder { -4*z, 12*z, 10.4 }
          cylinder { -5*z, 13*z, 8.9 }
          box { <-11, -3.5, -5> <11, 3.5, 13> }
          translate <12, 22, 0>
        }
        difference {
          merge {
            box { <-2.75, 0, -2.4> <2.75, 14.799999, 12> }
            cylinder { -2.4*z, 12*z, 13.85 }
          }
          cylinder { -4*z, 3.2*z, 3.9 }
          difference {
            cone { -2.400005*z, 13.6, -0.9*z, 10.3 }
            cylinder { -2.5*z, -0.8*z 8.9 }
            box { <15, -3, -3> <-15, 3, 0> }
          }
          difference {
            cylinder { -4*z, 0.4*z, 8.899999 }
            cylinder { -5*z, 1*z, 7.8 }
            box { <-10, -1.9, -5> <10, 1.9, 1> }
          }
          box { <-15, 1.900001, -4> <-8, 3.499999, 0.400001> }
          box { <15, 1.900002, -4> <8, 3.499998, 0.400002> }
          box { <8, -1.900003, -4> <15, -3.499997, 0.400003> }
          box { <-8, -1.900004, -4> <-15, -3.499996, 0.400004> }
          translate <12, 22, 0>
        }
        cylinder { -4*z, -3.4*z, 1.4 translate <12, 2, 0> }
        cylinder { -4*z, 12*z, 2.5 translate <12, 22, 0> }
        cylinder { -4*z, -3.4*z, 3.1 translate <12, 22, 0> }
        cylinder { 3.4*z, 12*z, 3.1 translate <12, 22, 0> }
        box { <-0.15, -5, -0.15> <0.15, 1, 0.175> rotate -25*x translate <0, 13.6, -3.9> rotate -22.5*z translate <12, 22, 0> }
        box { <-0.15, -5, -0.15> <0.15, 1, 0.175> rotate -25*x translate <0, 13.6, -3.9> rotate -45*z translate <12, 22, 0> }
        box { <-0.15, -5, -0.15> <0.15, 1, 0.175> rotate -25*x translate <0, 13.6, -3.9> translate <12, 22, 0> }
        box { <-0.15, -5, -0.15> <0.15, 1, 0.175> rotate -25*x translate <0, 13.6, -3.9> rotate 22.5*z translate <12, 22, 0> }
        box { <-0.15, -5, -0.15> <0.15, 1, 0.175> rotate -25*x translate <0, 13.6, -3.9> rotate 45*z translate <12, 22, 0> }
        box { <-0.15, 5, -0.15> <0.15, -1, 0.175> rotate 25*x translate <0, -13.6, -3.9> translate <12, 22, 0> }
        box { <-0.15, 5, -0.15> <0.15, -1, 0.175> rotate 25*x translate <0, -13.6, -3.9> rotate 45*z translate <12, 22, 0> }
        box { <-0.15, 5, -0.15> <0.15, -1, 0.175> rotate 25*x translate <0, -13.6, -3.9> rotate 22.5*z translate <12, 22, 0> }
        box { <-0.15, 5, -0.15> <0.15, -1, 0.175> rotate 25*x translate <0, -13.6, -3.9> rotate -22.5*z translate <12, 22, 0> }
        box { <-0.15, 5, -0.15> <0.15, -1, 0.175> rotate 25*x translate <0, -13.6, -3.9> rotate -45*z translate <12, 22, 0> }
        difference {
          cone { -3.900005*z, 13.6, -2.4*z, 10.3 }
          box { <-14, -3.5, -3.900007> <-10.1, 3.5, 0> }
          box { <14, -3.5, -3.900007> <10.1, 3.5, 0> }
          box { <0, -3.500001, 0> <5, 3.500001, 4> rotate -10*y translate <-10.1, 0, -3.9> }
          box { <-5, -3.500001, 0> <0, 3.500001, 4> rotate 10*y translate <10.1, 0, -3.9> }
          intersection {
            sphere { <0, 0, 0> 1 scale <25, 25, 15.9> translate <0, 0, 12> }
            cylinder { -4*z, 12*z, 10.4 }
          }
          translate <12, 22, 0>
        }
        cylinder { -4*x, 4*x, 2.5 translate <0, 5.6, 4> }
        cylinder { 20*x, 28*x, 2.5 translate <0, 5.6, 4> }
        cylinder { -4*x, -3.4*x, 3.1 translate <0, 5.6, 4> }
        cylinder { 27.4*x, 28*x, 3.1 translate <0, 5.6, 4> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 10.4> }
          difference {
            box { <0, -3, -2.399995> <3, 0, 10.399995> rotate -45*z translate <12, 3.5, 0> }
            box { <10, 3, -3> <14, 10, 11> }
          }
        #end
        box { <3, 2.7, -4> <3.8, 4, 12> }
        box { <20.2, 2.7, -4> <21, 4, 12> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() scale <1, 1.4, 1> translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 40.1, 12> } }
    }
  #end
#end
#macro engine_1(color_tex)
  #if (setting = 0)
    merge {
      box { <4, 0, -3.9> <19.9, 19.1, 27.9> }
      cylinder { -2.5*x, 4.1*x, 9.55 translate <0, 9.55, 7> }
      box { <-2.500002, 0, 7> <4.1, 19.099999, 17> }
      cylinder { -2.500001*x, 4.1*x, 9.55 translate <0, 9.55, 17> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <4, 0, -3.9> <19.9, 19.1, 27.9> }
        box { <12.8, 11.7, -4> <18.3, 20, 3> }
        box { <3, 11.7, -4> <11.4, 20, 3> }
        box { <12.8, 11.7, 21> <18.3, 20, 28> }
        box { <3, 11.7, 21> <11.4, 20, 28> }
        difference {
          box { <0, -1, -8> <8, 20, 0> }
          cylinder { -2*y, 21*y, 4 translate <8, 0, 0> }
        }
        difference {
          box { <0, -1, 24> <8, 20, 32> }
          cylinder { -2*y, 21*y, 4 translate <8, 0, 24> }
        }
        cylinder { 12*y, 8*y, 1.6 translate <8, 0, 0> }
        cylinder { 12*y, 8*y, 1.6 translate <16, 0, 0> }
        cylinder { 12*y, 8*y, 1.6 translate <8, 0, 24> }
        cylinder { 12*y, 8*y, 1.6 translate <16, 0, 24> }
        difference {
          box { <10, 14.1, -5> <14, 21, 1.1> }
          cylinder { 11*x, 13*x, 5 translate <0, 14.1, 1.1> }
        }
        difference {
          box { <10, 14.1, 22.9> <14, 21, 29> }
          cylinder { 11*x, 13*x, 5 translate <0, 14.1, 22.9> }
        }
        #if (setting > 1)
          difference {
            box { <5.6, -1, -2.4> <18.4, 2, 26.4> }
            difference {
              box { <4, -0.5, -3> <8, 2.000001, 0> }
              cylinder { -1*y, 3*y, 2.4 translate <8, 0, 0> }
            }
            difference {
              box { <4, -0.5, 24> <8, 2.000002, 27> }
              cylinder { -1*y, 3*y, 2.4 translate <8, 0, 24> }
            }
          }
        #end
        difference {
          box { <4.9, 3.1, -2.4> <20, 18.1, 26.4> }
          box { <4, 10, -3> <21, 20, 3.9> }
          box { <4, 10, 20.1> <21, 20, 27> }
          box { <4, 2, 7.5> <19.75, 4.5, 8.5> }
          box { <4, 2, 15.5> <19.75, 4.5, 16.5> }
          box { <4, 17.6, 7.5> <19.75, 19, 8.5> }
          box { <4, 17.6, 15.5> <19.75, 19, 16.5> }
          box { <4, 14.5, 3> <19.75, 15.5, 5.4> }
          box { <4, 14.5, 18.6> <19.75, 15.5, 21> }
          difference {
            box { <4, -0.5, -3> <8, 19, 0> }
            cylinder { -1*y, 18*y, 2.4 translate <8, 0, 0> }
          }
          difference {
            box { <4, -0.5, 24> <8, 19, 27> }
            cylinder { -1*y, 18*y, 2.4 translate <8, 0, 24> }
          }
        }
        cylinder { -4*x, 20*x, 2.25 translate <0, 9.55, 12> }
        cylinder { 3.1*x, 21*x, 3 translate <0, 9.55, 12> }
      }
      difference {
        merge {
          cylinder { -1.5*x, 5*x, 9.550001 translate <0, 9.55, 7> }
          cylinder { -1.5*x, 5*x, 9.550001 translate <0, 9.55, 17> }
          box { <-1.499999, 0.000001, 7> <5.000001, 19.099999, 17> }
          torus { 7.55, 2 rotate 90*z translate <-1.5, 9.55, 7> }
          torus { 7.55, 2 rotate 90*z translate <-1.5, 9.55, 17> }
          cylinder { 7*z, 17*z, 2 translate <-1.5, 17.100001, 0> }
          cylinder { 7*z, 17*z, 2 translate <-1.54, 2.000001, 0> }
        }
        cylinder { -4*x, 20*x, 2.25 translate <0, 9.55, 12> }
        cylinder { 3.1*x, 21*x, 3 translate <0, 9.55, 12> }
        difference {
          merge {
            cylinder { -5*x, 3*x, 7.5 translate <0, 9.55, 7> }
            cylinder { -5*x, 3*x, 7.5 translate <0, 9.55, 17> }
            box { <-5, 2.05, 7> <3, 17.05, 17> }
          }
          cylinder { -3.5*x, 4*x, 3 translate <0, 9.55, 12> }
          cylinder { 2.5*x, 4*x, 3.75 translate <0, 9.55, 12> }
          cylinder { 4*z, 20*z, 0.75 translate <0.75, 9.55, 0> }
          sphere { <0.75, 9.55, 4> 0.75 }
          sphere { <0.75, 9.55, 20> 0.75 }
          difference {
            merge {
              box { <-2.4, 6.55, 20.75> <4, 12.55, 21.75> }
              box { <-3.4, 5.55, 18.5> <4, 13.55, 19.5> }
              box { <-3.4, 5.55, 16.25> <4, 13.55, 17.25> }
              box { <-3.4, 5.55, 14> <4, 13.55, 15> }
              box { <-3.4, 5.55, 9> <4, 13.55, 10> }
              box { <-3.4, 5.55, 6.75> <4, 13.55, 7.75> }
              box { <-3.4, 5.55, 4.5> <4, 13.55, 5.5> }
              box { <-2.4, 6.55, 2.25> <4, 12.55, 3.25> }
            }
            difference {
              box { <-4, 11.55, 3> <-1.4, 14, 21> }
              cylinder { 3*z, 21*z, 2 translate <-1.4, 11.55, 0> }
            }
            difference {
              box { <-4, 4, 3> <-1.4, 7.55, 21> }
              cylinder { 3*z, 21*z, 2 translate <-1.4, 7.55, 0> }
            }
          }
        }
      }
      #if (setting < 3)
        cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 8> }
        cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 16> }
        cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 8> }
        cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 16> }
      #else
        object { rounded_button() translate <8, 16, 8> }
        object { rounded_button() translate <8, 16, 16> }
        object { rounded_button() translate <16, 16, 8> }
        object { rounded_button() translate <16, 16, 16> }
      #end
      #if (setting > 1)
        object { ring() translate <12, 0, 4> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <12, 0, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-2.6, -0.1, -4> <20, 20.9, 28> } }
    }
  #end
#end
#macro engine_l(color_tex)
  #if (setting = 0)
    cone { 0*y, 15.9, 19.1*y, 7.9 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cone { 19.1*y, 7.9, 1.999999*y, 15.900001 }
          cylinder { 0*y, 2*y, 15.9 }
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 translate <-4, 0, -4> }
            cylinder { 19*y, 20.8*y, 2.4 translate <-4, 0, 4> }
            cylinder { 19*y, 20.8*y, 2.4 translate <4, 0, -4> }
            cylinder { 19*y, 20.8*y, 2.4 translate <4, 0, 4> }
          #else
            object { rounded_button() translate <-4, 16, -4> }
            object { rounded_button() translate <-4, 16, 4> }
            object { rounded_button() translate <4, 16, -4> }
            object { rounded_button() translate <4, 16, 4> }
          #end
        }
        #if (setting > 1)
          cylinder { -1*y, 1.999999*y, 15.4 }
          merge {
            cone { 18.2*y, 6.9, 1.999995*y, 14.400001 }
            cylinder { -1*y, 2*y, 14.4 }
          }
          box { <-0.9, 18, -2.25> <0.9, 20, 2.25> }
          box { <-2.25, 18, -0.9> <2.25, 20, 0.9> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <-4, 0, -4> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <-4, 0, 4> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <4, 0, -4> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <4, 0, 4> }
          box { <-16, -1, -2.2> <16, 2.000002, 2.2> rotate 45*y }
          box { <-16, -1, -2.2> <16, 2.000001, 2.2> rotate 135*y }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            difference {
              cylinder { 0*y, 18.3*y, 3.2 }
              cylinder { -1*y, 19*y, 2.6 }
              translate <0, 0, -8>
            }
            difference {
              cylinder { 0*y, 18.3*y, 3.2 }
              cylinder { -1*y, 19*y, 2.6 }
              translate <0, 0, 8>
            }
            difference {
              cylinder { 0*y, 18.3*y, 3.2 }
              cylinder { -1*y, 19*y, 2.6 }
              translate <-8, 0, 0>
            }
            difference {
              cylinder { 0*y, 18.3*y, 3.2 }
              cylinder { -1*y, 19*y, 2.6 }
              translate <8, 0, 0>
            }
            difference {
              cylinder { 0*y, 18.3*y, 3.2 }
              cylinder { -1*y, 19*y, 2.6 }
            }
          }
          merge {
            cone { 18.2*y, 6.9, 1.999995*y, 14.400001 }
            cylinder { -1*y, 2*y, 14.4 }
            inverse
          }
        }
        box { <2.9, 2, -0.5> <5.1, 16, 0.5> }
        box { <-0.5, 2, -5.1> <0.5, 16, -2.9> }
        box { <-5.1, 2, -0.5> <-2.9, 16, 0.5> }
        box { <-0.5, 2, 2.9> <0.5, 16, 5.1> }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 20.9*y, 16 } }
    }
  #end
#end
#macro engine_m(color_tex)
  #if (setting = 0)
    cone { 0*y, 11.9, 19.1*y, 7.9 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { 0*y, 3.100001*y, 11.900001 }
          cone { 3.1*y, 11.9, 19.1*y, 7.9 }
        }
        #if (setting > 1)
          cylinder { -1*y, 3.1*y, 10.4 }
          cone { 3.0999*y, 10.399999, 18.1*y, 6.9 }
        #end
        box { <-2.25, -1, -0.9> <2.25, 20, 0.9> }
        box { <-0.9, -1, -2.25> <0.9, 20, 2.25> }
        cylinder { -1*y, 2*y, 2.5 translate <-8, 0, -8> }
        cylinder { -1*y, 2*y, 2.5 translate <-8, 0, 8> }
        cylinder { -1*y, 2*y, 2.5 translate <8, 0, -8> }
        cylinder { -1*y, 2*y, 2.5 translate <8, 0, 8> }
      }
      intersection {
        merge {
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 translate <-4, 0, -4> }
            cylinder { 19*y, 20.8*y, 2.4 translate <-4, 0, 4> }
            cylinder { 19*y, 20.8*y, 2.4 translate <4, 0, -4> }
            cylinder { 19*y, 20.8*y, 2.4 translate <4, 0, 4> }
          #else
            object { rounded_button() translate <-4, 16, -4> }
            object { rounded_button() translate <-4, 16, 4> }
            object { rounded_button() translate <4, 16, -4> }
            object { rounded_button() translate <4, 16, 4> }
          #end
        }
        cylinder { 15*y, 21*y, 7.9 }
      }
      #if (setting > 1)
        difference {
          cylinder { 6.4*y, 18.5*y, 4.5 }
          cylinder { 6*y, 19*y, 3.4 }
          cylinder { -1*y, 19*y, 2.600001 translate <-4, 0, -4> }
          cylinder { -1*y, 19*y, 2.600001 translate <4, 0, -4> }
          cylinder { -1*y, 19*y, 2.600001 translate <-4, 0, 4> }
          cylinder { -1*y, 19*y, 2.600001 translate <4, 0, 4> }
        }
        difference {
          merge {
            difference {
              cylinder { 0*y, 18*y, 3.2 }
              cylinder { -1*y, 19*y, 2.6 }
              translate <-4, 0, -4>
            }
            difference {
              cylinder { 0*y, 18*y, 3.2 }
              cylinder { -1*y, 19*y, 2.6 }
              translate <-4, 0, 4>
            }
            difference {
              cylinder { 0*y, 18*y, 3.2 }
              cylinder { -1*y, 19*y, 2.6 }
              translate <4, 0, -4>
            }
            difference {
              cylinder { 0*y, 18*y, 3.2 }
              cylinder { -1*y, 19*y, 2.6 }
              translate <4, 0, 4>
            }
          }
          merge {
            cylinder { -1*y, 3.1*y, 10.4 }
            cone { 3.0999*y, 10.399999, 18.1*y, 6.9 }
            inverse
          }  
        }
        box { <-1, 6.5, -4.5> <1, 18, -3.5> }
        box { <-1, 6.5, 3.5> <1, 18, 4.5> }
        box { <-4.5, 6.5, -1> <-3.5, 18, 1> }
        box { <3.5, 6.5, -1> <4.5, 18, 1> }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 20.9*y, 12 } }
    }
  #end
#end
#macro exhaust_pipe_left(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 84*x, 70*x, 2 translate <0, 4.5, -7> }
      cylinder { 23*x, 48*x, 3 translate <0, -6, -7> }
      cylinder { <48, -6, -7> <70, 4.5, -7> 2 }
      cylinder { <0, 4.5, -7> <23, -6, -7> 2 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 4.5*y, 2 }
        cylinder { -2.5*z, 2.5*z, 2 translate <0, 4.5, 0> }
        cylinder { 0*y, 2*y, 2 translate <8, 0, 0> }
        cylinder { -2.5*z, 2.5*z, 2 translate <8, 2, 0> }
        cylinder { 23.15*x, 47.85*x, 3 translate <0, -6, -7> }
        torus { 2.85, 0.15 rotate 90*z translate <23.15, -6, -7> }
        torus { 2.85, 0.15 rotate 90*z translate <47.85, -6, -7> }
        cylinder { 23*x, 48*x, 2.85 translate <0, -6, -7> }
        cylinder { 18*x, 24*x, 2 translate <0, -6, -7> }
        cylinder { 47*x, 52*x, 2 translate <0, -6, -7> }
        difference {
          torus { 5, 2 rotate 90*x translate <18.00001, -1, -7> }
          box { <-10, -10, -10> <0, 10, 10> rotate -60*z translate <15.5, -3.35, 0> }
          box { <0, -10, -10> <10, 10, 10> translate <18.000001, 0, 0> }
        }
        difference {
          torus { 16, 2 rotate 90*x translate <-0.000115, -11.5, -7> }
          box { <0, -30, -30> <30, 30, 30> rotate -60*z translate <15.499885, -3.5, 0> }
          box { <-30, -30, -30> <0, 30, 30> rotate -9.5*z translate <4.249885, 0, 0> }
        }
        difference {
          torus { 5, 2 rotate 90*x translate <51.999999, -1, -7> }
          box { <0, -30, -30> <30, 30, 30> rotate 60*z translate <54.5, -3.5, 0> }
          box { <-30, -30, -30> <0, 30, 30> translate <51.999999, 0, 0> }
        }
        difference {
          torus { 16, 2 rotate 90*x translate <70, -11.5, -7> }
          box { <-30, -30, -30> <0, 30, 30> rotate 60*z translate <54.5, -3.65, 0> }
          box { <0, -30, -30> <30, 30, 30> translate <70, 0, 0> }
        }
        cylinder { 83.85*x, 69.999999*x, 2 translate <0, 4.5, -7> }
        torus { 1.85, 0.15 rotate 90*z translate <83.85, 4.5, -7> }
        cylinder { 80*x, 84*x, 1.85 translate <0, 4.5, -7> }
        difference {
          torus { 5, 2 }
          box { <0.02, -20, -20> <20, 20, 20> }
          box { <-20, -20, 0> <20, 20, 20> }
          translate <5, 0, 0> rotate -9.5*z translate <0, 4.5, -2>
        }
        difference {
          torus { 5, 2 }
          box { <0, -20, -20> <20, 20, 20> rotate 23*y }
          box { <-20, -20, 0> <20, 20, 20> }
          translate <5, 0, 0> rotate -32*z translate <8, 2, -2>
        }
        difference {
          merge {
            sphere { <0, -3, 0> 1.5 }
            sphere { <8, -3, 0> 1.5 }
          }
          box { <-2, -5, -2> <12, -4, 2> }
        }
        cylinder { -3*y, 1*y, 1.5 }
        cylinder { -3*y, 1*y, 1.5 translate <8, 0, 0> }
      }
      #if (setting > 1)
        box { <24.5, -10, -7.75> <46.5, -7, -6.25> } 
      #end
      texture { color_tex }
      bounded_by { box { <-2.6, -9.1, -10.1> <84.1, 6.6, 2.6> } }
    }
  #end
#end
#macro exhaust_pipe_right(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 84*x, 70*x, 2 translate <0, 4.5, 7> }
      cylinder { 23*x, 48*x, 3 translate <0, -6, 7> }
      cylinder { <48, -6, 7> <70, 4.5, 7> 2 }
      cylinder { <0, 4.5, 7> <23, -6, 7> 2 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 4.5*y, 2 }
        cylinder { -2.5*z, 2.5*z, 2 translate <0, 4.5, 0> }
        cylinder { 0*y, 2*y, 2 translate <8, 0, 0> }
        cylinder { -2.5*z, 2.5*z, 2 translate <8, 2, 0> }
        cylinder { 23.15*x, 47.85*x, 3 translate <0, -6, 7> }
        torus { 2.85, 0.15 rotate 90*z translate <23.15, -6, 7> }
        torus { 2.85, 0.15 rotate 90*z translate <47.85, -6, 7> }
        cylinder { 23*x, 48*x, 2.85 translate <0, -6, 7> }
        cylinder { 18*x, 24*x, 2 translate <0, -6, 7> }
        cylinder { 47*x, 52*x, 2 translate <0, -6, 7> }
        difference {
          torus { 5, 2 rotate 90*x translate <18.00001, -1, 7> }
          box { <-10, -10, -10> <0, 10, 10> rotate -60*z translate <15.5, -3.35, 0> }
          box { <0, -10, -10> <10, 10, 10> translate <18.000001, 0, 0> }
        }
        difference {
          torus { 16, 2 rotate 90*x translate <-0.000115, -11.5, 7> }
          box { <0, -30, -30> <30, 30, 30> rotate -60*z translate <15.499885, -3.5, 0> }
          box { <-30, -30, -30> <0, 30, 30> rotate -9.5*z translate <4.249885, 0, 0> }
        }
        difference {
          torus { 5, 2 rotate 90*x translate <51.999999, -1, 7> }
          box { <0, -30, -30> <30, 30, 30> rotate 60*z translate <54.5, -3.5, 0> }
          box { <-30, -30, -30> <0, 30, 30> translate <51.999999, 0, 0> }
        }
        difference {
          torus { 16, 2 rotate 90*x translate <70, -11.5, 7> }
          box { <-30, -30, -30> <0, 30, 30> rotate 60*z translate <54.5, -3.65, 0> }
          box { <0, -30, -30> <30, 30, 30> translate <70, 0, 0> }
        }
        cylinder { 83.85*x, 69.999999*x, 2 translate <0, 4.5, 7> }
        torus { 1.85, 0.15 rotate 90*z translate <83.85, 4.5, 7> }
        cylinder { 80*x, 84*x, 1.85 translate <0, 4.5, 7> }
        difference {
          torus { 5, 2 }
          box { <0, -20, -20> <20, 20, 20> }
          box { <-20, -20, -20> <20, 20, 0> }
          translate <5, 0, 0> rotate -9.5*z translate <0, 4.5, 2>
        }
        difference {
          torus { 5, 2 }
          box { <0, -20, -20> <20, 20, 20> rotate -23*y }
          box { <-20, -20, -20> <20, 20, 0> }
          translate <5, 0, 0> rotate -32*z translate <8, 2, 2>
        }
        difference {
          merge {
            sphere { <0, -3, 0> 1.5 }
            sphere { <8, -3, 0> 1.5 }
          }
          box { <-2, -5, -2> <12, -4, 2> }
        }
        cylinder { -3*y, 1*y, 1.5 }
        cylinder { -3*y, 1*y, 1.5 translate <8, 0, 0> }
      }
      #if (setting > 1)
        box { <24.5, -10, 6.25> <46.5, -7, 7.75> }
      #end
      texture { color_tex }
      bounded_by { box { <-2.6, -9.1, -2.6> <84.1, 6.6, 10.1> } }
    }
  #end
#end
#macro explorien_mainpiece(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 19.2, 51.9> <91.9, 22.3, 67.9> }
      box { <20.1, 0, -3.9> <67.9, 3.1, 11.9> }
      box { <60.1, -3.1, -45> <91.9, 0, 0> rotate -21.9*x translate <0, 19.2, 51.9> }
      box { <-3.9, -3.1, -45> <27.9, 0, 0> rotate -21.9*x translate <0, 19.2, 51.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <91.9, 22.3, 67.9> }
            box { <27.9, -1, 11.9> <60.1, 23, 51.900001> }
            box { <27.900001, 3.100001, 3.9> <60.100001, 23, 12> }
            box { <-4, 3.1, -4> <92, 23, 4> }
            box { <-4, -1, 51.899999> <92, 19.2, 68> }
            box { <-4, 0, 0> <92, 50, 60> rotate -21.9*x translate <0, 3.1, 4> }
            box { <-50, -1, 0> <0, 30, 60> rotate -26.5*y translate <20, 0, 4> }
            box { <0, -1, 0> <50, 30, 60> rotate 26.5*y translate <68, 0, 4> }
            box { <-4, -50, -60> <28.100001, 0, 0> rotate -21.9*x translate <0, 19.2, 51.9> }
            box { <59.999999, -50, -60> <92, 0, 0> rotate -21.9*x translate <0, 19.2, 51.9> }
            box { <67.9, -1, -4> <92, 23, 4> }
            box { <0, -1, -4> <20.1, 23, 4> }
            #if (setting > 1)
              box { <21.6, -1, -2.4> <66.4, 2, 2.4> }
              box { <29.6, -1, 2.3> <58.4, 2.000001, 10.4> }
              box { <-2.4, 0, 53.6> <90.4, 21.4, 66.4> }
            #end
            difference {
              box { <-2.4, -1, 4> <26.5, 24, 51.9> }
              box { <-4, 0, 0> <30, 50, 60> rotate -21.9*x translate <0, 2, 4> }
              box { <-50, -2, 0> <0, 30, 60> rotate -26.5*y translate <21.8, 0, 4> }
              difference {
                box { <23.5, 2, 2> <24.5, 10, 25> }
                box { <20, -10, 0> <30, 0, 10> rotate -43.8*x translate <0, 6, 18> }
              }
            }
            difference {
              box { <61.5, -1, 4> <90.4, 24, 51.9> }
              box { <60, 0, 0> <92, 50, 60> rotate -21.9*x translate <0, 2, 4> }
              box { <0, -2, 0> <50, 30, 60> rotate 26.5*y translate <66.2, 0, 4> }
              difference {
                box { <63.5, 2, 2> <64.5, 10, 25> }
                box { <60, -10, 0> <70, 0, 10> rotate -43.8*x translate <0, 6, 18> }
              }
            }
            cylinder { 0*y, 30*y, 8.1 translate <16, 0, 40> }
            cylinder { 0*y, 30*y, 8.1 translate <72, 0, 40> }
          }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
            cylinder { 22.2*y, 24*y, 2.4 translate <0, 0, 56> }
            cylinder { 22.2*y, 24*y, 2.4 translate <8, 0, 56> }
            cylinder { 22.2*y, 24*y, 2.4 translate <16, 0, 56> }
            cylinder { 22.2*y, 24*y, 2.4 translate <24, 0, 56> }
            cylinder { 22.2*y, 24*y, 2.4 translate <32, 0, 56> }
            cylinder { 22.2*y, 24*y, 2.4 translate <40, 0, 56> }
            cylinder { 22.2*y, 24*y, 2.4 translate <48, 0, 56> }
            cylinder { 22.2*y, 24*y, 2.4 translate <56, 0, 56> }
            cylinder { 22.2*y, 24*y, 2.4 translate <64, 0, 56> }
            cylinder { 22.2*y, 24*y, 2.4 translate <72, 0, 56> }
            cylinder { 22.2*y, 24*y, 2.4 translate <80, 0, 56> }
            cylinder { 22.2*y, 24*y, 2.4 translate <88, 0, 56> }
            cylinder { 22.2*y, 24*y, 2.4 translate <0, 0, 64> }
            cylinder { 22.2*y, 24*y, 2.4 translate <8, 0, 64> }
            cylinder { 22.2*y, 24*y, 2.4 translate <16, 0, 64> }
            cylinder { 22.2*y, 24*y, 2.4 translate <24, 0, 64> }
            cylinder { 22.2*y, 24*y, 2.4 translate <32, 0, 64> }
            cylinder { 22.2*y, 24*y, 2.4 translate <40, 0, 64> }
            cylinder { 22.2*y, 24*y, 2.4 translate <48, 0, 64> }
            cylinder { 22.2*y, 24*y, 2.4 translate <56, 0, 64> }
            cylinder { 22.2*y, 24*y, 2.4 translate <64, 0, 64> }
            cylinder { 22.2*y, 24*y, 2.4 translate <72, 0, 64> }
            cylinder { 22.2*y, 24*y, 2.4 translate <80, 0, 64> }
            cylinder { 22.2*y, 24*y, 2.4 translate <88, 0, 64> }
          #else
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <32, 0, 0> }
            object { rounded_button() translate <40, 0, 0> }
            object { rounded_button() translate <48, 0, 0> }
            object { rounded_button() translate <56, 0, 0> }
            object { rounded_button() translate <64, 0, 0> }
            object { rounded_button() translate <32, 0, 8> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() translate <48, 0, 8> }
            object { rounded_button() translate <56, 0, 8> }
            object { rounded_button() translate <0, 19.2, 56> }
            object { rounded_button() translate <8, 19.2, 56> }
            object { rounded_button() translate <16, 19.2, 56> }
            object { rounded_button() translate <24, 19.2, 56> }
            object { rounded_button() translate <32, 19.2, 56> }
            object { rounded_button() translate <40, 19.2, 56> }
            object { rounded_button() translate <48, 19.2, 56> }
            object { rounded_button() translate <56, 19.2, 56> }
            object { rounded_button() translate <64, 19.2, 56> }
            object { rounded_button() translate <72, 19.2, 56> }
            object { rounded_button() translate <80, 19.2, 56> }
            object { rounded_button() translate <88, 19.2, 56> }
            object { rounded_button() translate <0, 19.2, 64> }
            object { rounded_button() translate <8, 19.2, 64> }
            object { rounded_button() translate <16, 19.2, 64> }
            object { rounded_button() translate <24, 19.2, 64> }
            object { rounded_button() translate <32, 19.2, 64> }
            object { rounded_button() translate <40, 19.2, 64> }
            object { rounded_button() translate <48, 19.2, 64> }
            object { rounded_button() translate <56, 19.2, 64> }
            object { rounded_button() translate <64, 19.2, 64> }
            object { rounded_button() translate <72, 19.2, 64> }
            object { rounded_button() translate <80, 19.2, 64> }
            object { rounded_button() translate <88, 19.2, 64> }
          #end
        }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <0, 0, 56> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <8, 0, 56> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <16, 0, 56> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <24, 0, 56> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <32, 0, 56> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <40, 0, 56> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <48, 0, 56> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <56, 0, 56> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <64, 0, 56> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <72, 0, 56> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <80, 0, 56> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <88, 0, 56> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <0, 0, 64> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <8, 0, 64> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <16, 0, 64> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <24, 0, 64> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <32, 0, 64> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <40, 0, 64> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <48, 0, 64> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <56, 0, 64> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <64, 0, 64> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <72, 0, 64> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <80, 0, 64> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <88, 0, 64> }
        #end
      }
      difference {
        cylinder { 3.2*y, 23*y, 9.5 }
        cylinder { 0*y, 25*y, 8.100001 }
        box { <-4, 0, 0> <92, 50, 60> rotate -21.9*x translate <-16, 2.6, -36> }
        translate <16, 0, 40>
      }
      difference {
        cylinder { 3.2*y, 23*y, 9.5 }
        cylinder { 0*y, 25*y, 8.100001 }
        box { <-4, 0, 0> <92, 50, 60> rotate -21.9*x translate <-72, 2.6, -36> }
        translate <72, 0, 40>
      }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> rotate 45*y translate <16, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> rotate 90*y translate <16, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> rotate 135*y translate <16, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> rotate 180*y translate <16, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> rotate 225*y translate <16, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> rotate 270*y translate <16, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> rotate 315*y translate <16, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> translate <16, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> rotate 45*y translate <72, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> rotate 90*y translate <72, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> rotate 135*y translate <72, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> rotate 180*y translate <72, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> rotate 225*y translate <72, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> rotate 270*y translate <72, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> rotate 315*y translate <72, 0, 40> }
      box { <-0.5, 5.2, 2.3> <0.5, 9.2, 8.5> translate <72, 0, 40> }
      difference {
        cylinder { 8.3*y, 9.200001*y, 3.6 }
        cylinder { 8*y, 20*y, 1.6 }
        translate <16, 0, 40>
      }
      object { open_rounded_button() translate <16, 6.1, 40> }
      difference {
        cylinder { 0*y, 8.4*y, 3.2 }
        cylinder { 8*y, 20*y, 1.600002 }
        cylinder { -1*y, 2*y, 2.6 }
        box { <-2.25, 0, -0.9> <2.25, 8.300001, 0.9> }
        box { <-0.9, 0, -2.25> <0.9, 8.300002, 2.25> }
        translate <16, 0, 40>
      }
      difference {
        cylinder { 8.3*y, 9.200001*y, 3.6 }
        cylinder { 8*y, 20*y, 1.6 }
        translate <72, 0, 40>
      }
      object { open_rounded_button() translate <72, 6.1, 40> }
      difference {
        cylinder { 0*y, 8.4*y, 3.2 }
        cylinder { 8*y, 20*y, 1.600002 }
        cylinder { -1*y, 2*y, 2.6 }
        box { <-2.25, 0, -0.9> <2.25, 8.300001, 0.9> }
        box { <-0.9, 0, -2.25> <0.9, 8.300002, 2.25> }
        translate <72, 0, 40>
      }
      #if (setting > 1)
        object { ring() translate <4, 19.2, 60> }
        object { ring() translate <12, 19.2, 60> }
        object { ring() translate <20, 19.2, 60> }
        object { ring() translate <28, 19.2, 60> }
        object { ring() translate <36, 19.2, 60> }
        object { ring() translate <44, 19.2, 60> }
        object { ring() translate <52, 19.2, 60> }
        object { ring() translate <60, 19.2, 60> }
        object { ring() translate <68, 19.2, 60> }
        object { ring() translate <76, 19.2, 60> }
        object { ring() translate <84, 19.2, 60> }
        object { ring() translate <36, 0, 4> }
        object { ring() translate <44, 0, 4> }
        object { ring() translate <52, 0, 4> }
        object { pin(2) translate <28, 0, 0> }
        object { pin(2) translate <60, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <92, 24.1, 68> } }
    }
  #end
#end
#macro explorien_openwing8_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 6.3, 59.9> }
      box { <-20, -1, -50> <0, 7, 0> rotate 21.65*y translate <12, 0, 52> }
      box { <0, -1, -50> <20, 7, 0> rotate -21.65*y translate <28, 0, 52> }
      box { <-4, -1, 52> <12, 7, 60> }
      box { <28, -1, 52> <44, 7, 60> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 }
        #else
          object { rounded_button() }
        #end
        cylinder { 1*y, 4*y, 1.200001 }
        translate <16, 0, 56>
      }
      difference {
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 }
        #else
          object { rounded_button() }
        #end
        cylinder { 1*y, 4*y, 1.200001 }
        translate <24, 0, 56>
      }
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 6.3, 59.9> }
          #if (setting < 3)
            cylinder { 6.2*y, 8*y, 2.4 }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 0> }
            cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, 0> }
            cylinder { 6.2*y, 8*y, 2.4 translate <24, 0, 0> }
            cylinder { 6.2*y, 8*y, 2.4 translate <32, 0, 0> }
            cylinder { 6.2*y, 8*y, 2.4 translate <40, 0, 0> }
            cylinder { 6.2*y, 8*y, 2.4 translate <0, 0, 8> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 8> }
            cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, 8> }
            cylinder { 6.2*y, 8*y, 2.4 translate <24, 0, 8> }
            cylinder { 6.2*y, 8*y, 2.4 translate <32, 0, 8> }
            cylinder { 6.2*y, 8*y, 2.4 translate <40, 0, 8> }
            cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, 48> }
            cylinder { 6.2*y, 8*y, 2.4 translate <24, 0, 48> }
          #else
            object { rounded_button() translate <0, 3.2, 0> }
            object { rounded_button() translate <8, 3.2, 0> }
            object { rounded_button() translate <16, 3.2, 0> }
            object { rounded_button() translate <24, 3.2, 0> }
            object { rounded_button() translate <32, 3.2, 0> }
            object { rounded_button() translate <40, 3.2, 0> }
            object { rounded_button() translate <0, 3.2, 8> }
            object { rounded_button() translate <8, 3.2, 8> }
            object { rounded_button() translate <16, 3.2, 8> }
            object { rounded_button() translate <24, 3.2, 8> }
            object { rounded_button() translate <32, 3.2, 8> }
            object { rounded_button() translate <40, 3.2, 8> }
            object { rounded_button() translate <16, 3.2, 48> }
            object { rounded_button() translate <24, 3.2, 48> }
          #end
        }
        box { <0, 3.1, 51.9> <40, 7, 60> }
        box { <-4, -1, 52> <12, 7, 60> }
        box { <28, -1, 52> <44, 7, 60> }
        box { <-20, -1, -50> <0, 7, 0> rotate 21.65*y translate <12, 0, 52> }
        box { <0, -1, -50> <20, 7, 0> rotate -21.65*y translate <28, 0, 52> }
        box { <11.9, -1, 11.900001> <28.1, 7, 44.100001> } 
        box { <-4, -1, 11.9> <10.4, 2, 60> }
        box { <29.6, -1, 11.9> <44, 2, 60> }
        box { <-4, -1, -4> <44, 3.2, 4.1> }
        #if (setting > 1)
          difference {
            box { <11.9, -1, 45.6> <28.1, 5.4, 52> }
            difference {
              cylinder { 0.000001*y, 5.5*y, 1.5 }
              cylinder { -1*y, 6*y, 0.7 }
              translate <20, 0, 48>
            }
            box { <15.5, 0.1, 50.4> <16.5, 5.5, 53> }
            box { <23.5, 0.1, 50.4> <24.5, 5.5, 53> }
            box { <11, 2, 50.5> <29, 7, 53> }
            box { <-20, -1, -50> <0, 7, 0> rotate 21.65*y translate <13.4, 0, 52> }
            box { <0, -1, -50> <20, 7, 0> rotate -21.65*y translate <26.6, 0, 52> }
            box { <10, 0.1, 47.5> <13.6, 7, 48.5> }
            box { <26.4, 0.1, 47.5> <30, 7, 48.5> }
          }
          box { <13.6, -1, 53.6> <26.4, 2, 58.4> }
          box { <-2.4, -1, 5.6> <42.4, 5.4, 10.4> }
          box { <-2.4, -1, -2.4> <42.4, 5.4, 4.100001> }
          cylinder { 4.2*y, 7.2*y, 1.2 }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 0> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <16, 0, 0> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <24, 0, 0> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <32, 0, 0> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <40, 0, 0> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <0, 0, 8> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 8> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <16, 0, 8> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <24, 0, 8> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <32, 0, 8> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <40, 0, 8> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <16, 0, 48> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <24, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 56> }
        #end
        difference {
          box { <-1.8, -0.5, 12> <41.8, 6.5, 45> }
          box { <10.4, -1, 11.900001> <29.9, 7, 60> } 
          box { <-20, -1, -50> <0, 7, 0> rotate 21.65*y translate <13.5, 0, 52> }
          box { <0, -1, -50> <20, 7, 0> rotate -21.65*y translate <26.5, 0, 52> }
          difference {
            box { <-3, -1, 11> <0.2, 7, 14> }
            cylinder { -1*y, 7*y, 2 translate <0.2, 0, 14> }
          }
          difference {
            box { <8.4, -1, 11> <31.6, 7, 14> }
            cylinder { -1*y, 7*y, 2 translate <8.4, 0, 14> }
            cylinder { -1*y, 7*y, 2 translate <31.6, 0, 14> }
          }
          difference {
            box { <39.8, -1, 11> <42, 7, 14> }
            cylinder { -1*y, 7*y, 2 translate <39.8, 0, 14> }
          }
          difference {
            box { <8, 5.4, 40> <11, 7, 46> }
            cylinder { -1*y, 7*y, 1 translate <9.4, 0, 40> }
          }
          difference {
            box { <27, 5.4, 40> <33, 7, 46> }
            cylinder { -1*y, 7*y, 1 translate <30.6, 0, 40> }
          }
          difference {
            box { <8.9, -1, 21.8> <11, 7, 23.3> }
            cylinder { -1*y, 7*y, 1.5 translate <8.9, 0, 21.8> }
          }
          difference {
            box { <8.9, -1, 24> <11, 7, 26.2> }
            cylinder { -1*y, 7*y, 1.5 translate <8.9, 0, 26.2> }
          }
          difference {
            box { <28, -1, 21.8> <31.1, 7, 23.3> }
            cylinder { -1*y, 7*y, 1.5 translate <31.1, 0, 21.8> }
          }
          difference {
            box { <28, -1, 24> <31.1, 7, 26.2> }
            cylinder { -1*y, 7*y, 1.5 translate <31.1, 0, 26.2> }
          }
          box { <0, -1, 23.3> <11, 7, 24.7> }
          box { <27, -1, 23.3> <40, 7, 24.7> }
        }
      }
      #if (setting > 1)
        box { <-0.5, 3.100001, 2.4> <0.5, 5.5, 4.2> }
        box { <7.5, 3.100001, 2.4> <8.5, 5.5, 4.2> }
        box { <15.5, 3.100001, 2.4> <16.5, 5.5, 4.2> }
        box { <23.5, 3.100001, 2.4> <24.5, 5.5, 4.2> }
        box { <31.5, 3.100001, 2.4> <32.5, 5.5, 4.2> }
        box { <39.5, 3.100001, 2.4> <40.5, 5.5, 4.2> }
        object { pin(2) translate <20, 0, 56> }
        object { pin(2) translate <4, 3.2, 0> }
        object { pin(2) translate <12, 3.2, 0> }
        object { pin(2) translate <20, 3.2, 0> }
        object { pin(2) translate <28, 3.2, 0> }
        object { pin(2) translate <36, 3.2, 0> }
        difference {
          merge {
            cylinder { 0*y, 5.6*y, 1.5 translate <4, 0, 8> }
            cylinder { 0*y, 5.6*y, 1.5 translate <12, 0, 8> }
            cylinder { 0*y, 5.6*y, 1.5 translate <20, 0, 8> }
            cylinder { 0*y, 5.6*y, 1.5 translate <28, 0, 8> }
            cylinder { 0*y, 5.6*y, 1.5 translate <36, 0, 8> }
          }
          cylinder { -1*y, 6*y, 0.7 translate <4, 0, 8> }
          cylinder { -1*y, 6*y, 0.7 translate <12, 0, 8> }
          cylinder { -1*y, 6*y, 0.7 translate <20, 0, 8> }
          cylinder { -1*y, 6*y, 0.7 translate <28, 0, 8> }
          cylinder { -1*y, 6*y, 0.7 translate <36, 0, 8> }
        }
      #end
      box { <-0.4, 0, 6> <0.4, 3.1, 12> rotate 45*y translate <20, 0.000001, 8> }
      box { <-0.4, 0, -6> <0.4, 3.1, 12> rotate 45*y translate <20, 0.000001, 16> }
      box { <-0.4, 0, -12> <0.4, 3.1, 12> rotate 45*y translate <20, 0.000001, 24> }
      box { <-0.4, 0, -12> <0.4, 3.1, 12> rotate 45*y translate <20, 0.000001, 32> }
      box { <-0.4, 0, -12> <0.4, 3.1, 6> rotate 45*y translate <20, 0.000001, 40> }
      box { <-0.4, 0, -12> <0.4, 3.1, -6> rotate 45*y translate <20, 0.000001, 48> }
      box { <-0.4, 0, 6> <0.4, 3.1, 12> rotate -45*y translate <20, 0.000002, 8> }
      box { <-0.4, 0, -6> <0.4, 3.1, 12> rotate -45*y translate <20, 0.000002, 16> }
      box { <-0.4, 0, -12> <0.4, 3.1, 12> rotate -45*y translate <20, 0.000002, 24> }
      box { <-0.4, 0, -12> <0.4, 3.1, 12> rotate -45*y translate <20, 0.000002, 32> }
      box { <-0.4, 0, -12> <0.4, 3.1, 6> rotate -45*y translate <20, 0.000002, 40> }
      box { <-0.4, 0, -12> <0.4, 3.1, -6> rotate -45*y translate <20, 0.000002, 48> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 8.1, 60> } }
    }
  #end
#end
#macro explorien_wing(color_tex)
  #if (setting = 0)
    difference {
      box { <4, -0.5, -19.5> <27.9, 0.6, 19.5> }
      box { <-30, -10, -20> <0, 10, 0> rotate 35*y translate <19.5, 0, -19.5> }
      box { <-30, -10, 0> <0, 10, 20> rotate -35*y translate <19.5, 0, 19.5> }
      box { <-20, -10, -20> <20, 10, 0> rotate -45*y translate <19.5, 0, -19.5> }
      box { <-20, -10, 0> <20, 10, 20> rotate 45*y translate <19.5, 0, 19.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { -1.5*z, 1.5*z, 3 }
          box { <-1.8, -3.000001, -1.500001> <0.000001, 3.000001, 1.500001> }
        }
        cylinder { -2*z, 2*z, 1.6 }
        box { <-4, -4, -2> <-1.5, 4, 2> }
        box { <-4, -1.4, -2> <0, 1.4, 2> }
      }
      box { <1.6, -2.5, -1.500001> <4.1, 0.6, 1.500001> }
        difference {
          box { <4, -2.500001, -3.9> <27.9, 0.600001, 3.9> }
          #if (setting > 1)
            box { <5.6, -3, -2.4> <26.5, -0.5, 2.4> }
          #end
        }
      #if (setting > 1)
        object { pin(2) translate <12, -2.5, 0> }
        object { pin(2) translate <20, -2.5, 0> }
      #end
      difference {
        box { <3.999999, -0.500001, -19.5> <27.900001, 9, 19.5> }
        box { <-20, -10, -20> <20, 10, 0> rotate -45*y translate <19.5, 0, -19.5> }
        box { <-20, -10, 0> <20, 10, 20> rotate 45*y translate <19.5, 0, 19.5> }
        box { <-20, 0, -20> <10, 20, 20> rotate -45*z translate <27.9, 0.4, 0> }
        box { <-30, 0, -20> <0, 10, 0> rotate 35*y translate <19.5, 0, -19.5> }
        box { <-30, 0, 0> <0, 10, 20> rotate -35*y translate <19.5, 0, 19.5> }
        box { <0, -30, -30> <40, 0, 0> rotate 32*x rotate 20*y translate <4, -0.5, -3.9> }
        box { <0, -30, 0> <40, 0, 30> rotate -32*x rotate -20*y translate <4, -0.5, 3.9> }
        difference {
          box { <3, 0.599998, -20> <30, 10, 20> }
          box { <0, -30, -30> <40, 0, 0> rotate 32*x rotate 20*y translate <3.99999, 0.25, -3.15> }
          box { <0, -30, 0> <40, 0, 30> rotate -32*x rotate -20*y translate <3.999999, 0.25, 3.15> }
        }
        difference {
          box { <4.5, -5, -20> <27, 10, -4.5> }
          box { <-20, -10, -20> <20, 10, 0> rotate -45*y translate <19.5, 0, -18.75> }
          box { <-30, 0, -20> <0, 10, 0> rotate 35*y translate <19.5, 0, -18.75> }
          box { <0, 0, -30> <40, 30, 0> rotate 32*x rotate 20*y translate <3.99999, -0.35, -3.15> }
          box { <-30, -10, 0> <30, 10, 20> rotate 20*y translate <4.5, 0, -5.25> }
        }
        difference {
          box { <4.5, -5, 4.5> <27, 10, 20> }
          box { <-20, -10, 0> <20, 10, 20> rotate 45*y translate <19.5, 0, 18.75> }
          box { <-30, 0, 0> <0, 10, 20> rotate -35*y translate <19.5, 0, 18.75> }
          box { <0, 0, 0> <40, 30, 30> rotate -32*x rotate -20*y translate <3.99999, -0.35, 3.15> }
          box { <-30, -10, -20> <30, 10, 0> rotate -20*y translate <4.5, 0, 5.25> }
        }
      }
      texture { color_tex }
      bounded_by { box { <-1.6, -2.6, -19.75> <28, 9, 19.75> } }
    }
  #end
#end
#macro ext_crane(color_tex)
  #if (setting = 0)
    box { <-23.9, 1.2, -4.8> <103.9, 8.3, 4.8> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { -3.100001*z, 3.100001*z, 3.550001 translate <100, 4.75, 0> }
          box { <-17.5, 1.2, -3.1> <100.000001, 8.3, 3.1> }
          box { <-20.5, -1.35, -1.9> <-19.5, 10.85, 1.9> }
          box { <-23.85, 2.85, -1.9> <-22.6, 6.65, -0.25> }
          box { <-23.85, 2.85, 0.25> <-22.6, 6.65, 1.9> }
          box { <-23.9, 0.75, -3.100002> <-17.1, 8.75, -1.8> }
          cylinder { -3.100003*z, -1.800001*z, 3.9 translate <-20, 0.75, 0> }
          cylinder { -3.100003*z, -1.800001*z, 3.9 translate <-20, 8.75, 0> }
          box { <-23.9, 0.75, 1.8> <-17.1, 8.75, 3.100002> }
          cylinder { 3.100003*z, 1.800001*z, 3.9 translate <-20, 0.75, 0> }
          cylinder { 3.100003*z, 1.800001*z, 3.9 translate <-20, 8.75, 0> }
          #if (setting < 3)
            cylinder { -4.8*z, -3*z, 2.4 translate <-20, 0.75, 0> }
            cylinder { -4.8*z, -3*z, 2.4 translate <-20, 8.75, 0> }
            cylinder { 4.8*z, 3*z, 2.4 translate <-20, 0.75, 0> }
            cylinder { 4.8*z, 3*z, 2.4 translate <-20, 8.75, 0> }
          #else
            object { rounded_button() rotate -90*x translate <-20, 0.75, 0> }
            object { rounded_button() rotate -90*x translate <-20, 8.75, 0> }
            object { rounded_button() rotate 90*x translate <-20, 0.75, 0> }
            object { rounded_button() rotate 90*x translate <-20, 8.75, 0> }
          #end
        }
        cylinder { -4*z, -1.1*z, 3.15 translate <100, 4.75, 0> }
        cylinder { 1.1*z, 4*z, 3.15 translate <100, 4.75, 0> }
        box { <-17, 1.600001, -4> <99.999999, 7.899999, -1.100001> }
        box { <-17, 1.600001, 1.100001> <99.999999, 7.899999, 4> }
        cylinder { -3*z, 3*z, 2.4 translate <-12, 4.75, 0> }
        cylinder { -3*z, 3*z, 2.4 translate <-4, 4.75, 0> }
        cylinder { -3*z, 3*z, 2.4 translate <4, 4.75, 0> }
        cylinder { -3*z, 3*z, 2.4 translate <12, 4.75, 0> }
        cylinder { -3*z, 3*z, 2.4 translate <20, 4.75, 0> }
        cylinder { -3*z, 3*z, 2.4 translate <28, 4.75, 0> }
        cylinder { -3*z, 3*z, 2.4 translate <36, 4.75, 0> }
        cylinder { -3*z, 3*z, 2.4 translate <44, 4.75, 0> }
        cylinder { -3*z, 3*z, 2.4 translate <52, 4.75, 0> }
        cylinder { -3*z, 3*z, 2.4 translate <60, 4.75, 0> }
        cylinder { -3*z, 3*z, 2.4 translate <68, 4.75, 0> }
        cylinder { -3*z, 3*z, 2.4 translate <76, 4.75, 0> }
        cylinder { -3*z, 3*z, 2.4 translate <84, 4.75, 0> }
        cylinder { -3*z, 3*z, 2.4 translate <92, 4.75, 0> }
        cylinder { -3*z, 3*z, 2.4 translate <100, 4.75, 0> }
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <100, 4.75, 0>
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <92, 4.75, 0>
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <84, 4.75, 0>
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <76, 4.75, 0>
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <68, 4.75, 0>
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <60, 4.75, 0>
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <52, 4.75, 0>
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <44, 4.75, 0>
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <36, 4.75, 0>
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <28, 4.75, 0>
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <20, 4.75, 0>
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <12, 4.75, 0>
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <4, 4.75, 0>
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <-4, 4.75, 0>
      }
      difference {
        cylinder { -2.85*z, 2.85*z, 3.2 }
        cylinder {-3*z, 3*z, 2.400001 }
        translate <-12, 4.75, 0>
      }
      texture { color_tex }
      bounded_by { box { <-24, -3.25, -4.9> <104, 12.75, 4.9> } }
    }
  #end
#end
#macro ext_crane_housing(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -5.4> <123.899999, 9.5, 5.4> }
      box { <108.1, 0.000001, -7.9> <123.9, 9.500001, 7.9> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          merge {
            box { <-3.9, 0, -5.4> <123.899999, 9.5, 5.4> }
            box { <108.1, 0.000001, -7.9> <123.9, 9.500001, 7.9> }
          }
          box { <109.6, -1, -6.4> <122.4, 8.6, 6.4> }
        }
        #if (setting > 1)
          box { <109.4, 0.1, -0.5> <113.1, 8.7, 0.5> }
          box { <115.9, 0.1, -0.5> <122.6, 8.7, 0.5> }
          object { high_ring() translate <116, 0, 0> }
        #end
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <40, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <48, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <56, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <64, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <72, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <80, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <88, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <96, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <104, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <112, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <120, 0, 0> }
        #else
          object { rounded_button() translate <8, 6.4, 0> }
          object { rounded_button() translate <16, 6.4, 0> }
          object { rounded_button() translate <24, 6.4, 0> }
          object { rounded_button() translate <32, 6.4, 0> }
          object { rounded_button() translate <40, 6.4, 0> }
          object { rounded_button() translate <48, 6.4, 0> }
          object { rounded_button() translate <56, 6.4, 0> }
          object { rounded_button() translate <64, 6.4, 0> }
          object { rounded_button() translate <72, 6.4, 0> }
          object { rounded_button() translate <80, 6.4, 0> }
          object { rounded_button() translate <88, 6.4, 0> }
          object { rounded_button() translate <96, 6.4, 0> }
          object { rounded_button() translate <104, 6.4, 0> }
          object { rounded_button() translate <112, 6.4, 0> }
          object { rounded_button() translate <120, 6.4, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <116, 5.6, -4> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <116, 5.6, 4> }
      }
      box { <113.5, -1, -0.8> <118.5, 8.6, 0.8> }
      difference {
        box { <-4, -1, -3.9> <108, 8.6, 3.9> }
        box { <103.5, 0.25, -4> <104.5, 8.7, -2.4> }
        box { <103.5, 0.25, 2.4> <104.5, 8.7, 4> }
        box { <-4, -1, -4> <6, 0.9, -2.4> }
        box { <-4, -1, 2.4> <6, 0.9, 4> }
        box { <-4, 2, -4> <6, 2.9, -2.9> }
        box { <-4, 2, 2.9> <6, 2.9, 4> }
        box { <-4, 6.7, -4> <6, 7.6, -2.9> }
        box { <-4, 6.7, 2.9> <6, 7.6, 4> }
        box { <9.75, -1, -4> <14.25, 8.7, -2.9> }
        box { <9.75, -1, 2.9> <14.25, 8.7, 4> }
        cylinder { 1.9*x, 2.5*x, 2.3 translate <12, 4.75, 0> }
        box { <11.75, 0.25, -3> <12.25, 8.7, -1.9> }
        difference {
          box { <0, 0.25, 0> <1.5, 8.7, 2> rotate 40*y }
          box { <1.5, 0, -2> <2.5, 8.8, 2> }
          translate <18.5, 0, -3.9>
        }
        difference {
          box { <0, 0.25, 0> <1.5, 8.7, 2> rotate 40*y }
          box { <1.5, 0, -2> <2.5, 8.8, 2> }
          translate <34.5, 0, -3.9>
        }
        difference {
          box { <0, 0.25, 0> <1.5, 8.7, 2> rotate 40*y }
          box { <1.5, 0, -2> <2.5, 8.8, 2> }
          translate <50.5, 0, -3.9>
        }
        difference {
          box { <0, 0.25, 0> <1.5, 8.7, 2> rotate 40*y }
          box { <1.5, 0, -2> <2.5, 8.8, 2> }
          translate <66.5, 0, -3.9>
        }
        difference {
          box { <0, 0.25, 0> <1.5, 8.7, 2> rotate 40*y }
          box { <1.5, 0, -2> <2.5, 8.8, 2> }
          translate <82.5, 0, -3.9>
        }
        difference {
          box { <0, 0.25, -2> <1.5, 8.7, 0> rotate -40*y }
          box { <1.5, 0, -2> <2.5, 8.8, 2> }
          translate <18.5, 0, 3.9>
        }
        difference {
          box { <0, 0.25, -2> <1.5, 8.7, 0> rotate -40*y }
          box { <1.5, 0, -2> <2.5, 8.8, 2> }
          translate <34.5, 0, 3.9>
        }
        difference {
          box { <0, 0.25, -2> <1.5, 8.7, 0> rotate -40*y }
          box { <1.5, 0, -2> <2.5, 8.8, 2> }
          translate <50.5, 0, 3.9>
        }
        difference {
          box { <0, 0.25, -2> <1.5, 8.7, 0> rotate -40*y }
          box { <1.5, 0, -2> <2.5, 8.8, 2> }
          translate <66.5, 0, 3.9>
        }
        difference {
          box { <0, 0.25, -2> <1.5, 8.7, 0> rotate -40*y }
          box { <1.5, 0, -2> <2.5, 8.8, 2> }
          translate <82.5, 0, 3.9>
        }
      }
      #if (setting > 1)
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <48, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <56, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <64, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <72, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <80, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <88, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <96, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <104, 0, 0> }
      #end
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <116, 5.6, -3.9>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <116, 5.6, 3.9>
      }
      box { <10.25, -1, -6> <13.75, 10, -4.9> }
      box { <10.25, -1, 4.9> <13.75, 10, 6> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -8> <124, 11.3, 8> } }
    }
  #end
#end
#macro ext_tech_cornerblock1_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      box { <-1.5, 0, -7.9> <14.6, 9.5, -6.4> }
      merge {
        box { <-5.6, 0, -7.9> <9.5, 9.5, -6.4> }
        box { <-3.9, 0, -3.9> <11.9, 9.499999, 3.9> }
        translate <3.9, 0.000001, -3.9>
        rotate -45*y
        translate <12.65, 0, 3.9>
      }
      texture { color_tex }
    }
  #else
    merge {
      box { <0, 0.000003, 0> <5.625, 9.500002, 1.5> rotate -22.5*y translate <14.599999, 0, -7.899999> }
      difference {
        box { <11.899998, 6.3, -3.899998> <19, 12.7, 2.9> }
        box { <0, 6, -5> <10, 13, 0> rotate -22.5*y translate <13, 0, -3.900003> }
        box { <0, 0, 1.5> <10, 8.6, 10> rotate -22.5*y translate <13, 0, -3.900004> }
        box { <10, 9.500007, 2.25> <13.4, 13, 4> }
        box { <0, 9.499998, 0> <10, 13, 10> rotate -45*y translate <13.4, 0, 2.25> }
        box { <0, 5, -20> <10, 13, 20> rotate -45*y translate <18.5, 0, -1> }
        box { <-10, 0, -10> <10, 13, -3.899997> translate <3.9, 0.000001, -3.9> rotate -45*y translate <12.65, 0, 3.9> }
      }
      difference {
        merge {
          box { <11.89, 0.000002, 2.400001> <13.750001, 9.500001, 3.900001> }
          box { <-0.5, 1.5, -5.5> <0.500001, 8, -3> }
          box { <7.500001, 1.5, -5.5> <8.500001, 8, -3> }
          box { <-0.500001, 5.599999, -6.5> <7.500001, 8.000001, -5> }
          cylinder { -6.500001*z, -5.000001*z, 3.5 translate <4, 5.6, 0> }
          box { <-1.5, 0, -7.9> <14.6, 9.5, -6.4> }
          difference {
            box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
            box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          }
          object { open_rounded_button() translate <0, 6.4, 0> }
          object { open_rounded_button() translate <8, 6.4, 0> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <0, 9.5, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <8, 9.5, 0> }
          #end
          cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 5.6, 0> }
        }
        merge {
          cylinder { -9*z, 6*z, 2.5 }
          cylinder { -8*z, -7.4*z, 3.1 }
          cylinder { 3.4*z, 5*z, 3.1 }
          translate <4, 5.6, 0>
        }
        box { <3.1, 4, -4> <4.9, 10, -6.500002> }
        box { <1, 0,  -1> <7, 8, 1> }
        box { <0.5, -1, -4> <7.5, 10, -3.1> }
      }
      difference {
        merge {
          box { <-5.75, 0.000002, 2.400002> <-3.89, 9.500002, 3.900001> }
          box { <-0.5, 1.5, -5.5> <0.500001, 8, -3> }
          box { <7.500001, 1.5, -5.5> <8.500001, 8, -3> }
          box { <-0.500001, 5.599999, -6.5> <7.500001, 8.000001, -5> }
          cylinder { -6.500001*z, -5.000001*z, 3.5 translate <4, 5.6, 0> }
          box { <-5.6, 0, -7.9> <9.5, 9.5, -6.4> }
          difference {
            box { <-3.9, 0, -3.9> <11.9, 9.499999, 3.9> }
            box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          }
          object { open_rounded_button() translate <0, 6.4, 0> }
          object { open_rounded_button() translate <8, 6.4, 0> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <0, 9.5, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <8, 9.5, 0> }
          #end
          cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 5.6, 0> }
        }
        merge {
          cylinder { -9*z, 6*z, 2.5 }
          cylinder { -8*z, -7.4*z, 3.1 }
          cylinder { 3.4*z, 5*z, 3.1 }
          translate <4, 5.6, 0>
        }
        box { <3.1, 4, -4> <4.9, 10, -6.500002> }
        box { <1, 0,  -1> <7, 8, 1> }
        box { <0.5, -1, -4> <7.5, 10, -3.1> }
        translate <3.9, 0.000001, -3.9>
        rotate -45*y
        translate <12.65, 0, 3.9>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -8> <31, 11.3, 16> } }
    }
  #end
#end
#macro ext_tech_h_block1_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> }
      box { <-1.5, 0, -7.9> <25.5, 9.5, -6.4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-0.5, 1.5, -5.5> <0.500001, 8, -3> }
        box { <7.500001, 1.5, -5.5> <8.500001, 8, -3> }
        box { <15.500001, 1.5, -5.5> <16.500001, 8, -3> }
        box { <23.500001, 1.5, -5.5> <24.5, 8, -3> }
        box { <-0.500001, 5.599999, -6.5> <24.500001, 8.000001, -5> }
        cylinder { -6.500001*z, -5.000001*z, 3.5 translate <4, 5.6, 0> }
        cylinder { -6.500001*z, -5.000001*z, 3.5 translate <12, 5.6, 0> }
        cylinder { -6.500001*z, -5.000001*z, 3.5 translate <20, 5.6, 0> }
        box { <-1.5, 0, -7.9> <25.5, 9.5, -6.4> }
        difference {
          box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> }
          box { <-2.4, -1, -2.4> <26.4, 8.6, 2.4> }
        }
        object { open_rounded_button() translate <0, 6.4, 0> }
        object { open_rounded_button() translate <8, 6.4, 0> }
        object { open_rounded_button() translate <16, 6.4, 0> }
        object { open_rounded_button() translate <24, 6.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <0, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <8, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <16, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <24, 9.5, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <12, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <20, 5.6, 0> }
        box { <0.7, 2, -3.5> <1.5, 9, 3.5> }
        box { <6.5, 2, -3.5> <7.3, 9, 3.5> }
        box { <8.8, 2, -3.5> <9.5, 9, 3.5> }
        box { <14.5, 2, -3.5> <15.3, 9, 3.5> }
        box { <16.8, 2, -3.5> <17.5, 9, 3.5> }
        box { <22.5, 2, -3.5> <23.7, 9, 3.5> }
      }
      merge {
        cylinder { -9*z, 6*z, 2.5 }
        cylinder { -8*z, -7.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <4, 5.6, 0>
      }
      merge {
        cylinder { -9*z, 6*z, 2.5 }
        cylinder { -8*z, -7.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <12, 5.6, 0>
      }
      merge {
        cylinder { -9*z, 6*z, 2.5 }
        cylinder { -8*z, -7.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <20, 5.6, 0>
      }
      box { <3.1, 4, -4> <4.9, 10, -6.500002> }
      box { <11.1, 4, -4> <12.9, 10, -6.500002> }
      box { <19.1, 4, -4> <20.9, 10, -6.500002> }
      box { <1, 0,  -1> <7, 8, 1> }
      box { <9, 0,  -1> <15, 8, 1> }
      box { <17, 0,  -1> <23, 8, 1> }
      box { <0.5, -1, -4> <7.5, 10, -3.1> }
      box { <8.5, -1, -4> <15.5, 10, -3.1> }
      box { <16.5, -1, -4> <23.5, 10, -3.1> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -8> <28, 11.3, 4> } }
    }
  #end
#end
#macro eye2_2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 3.1*y, 7.8 translate <4, 0, 4> }
      box { <0, 3, 2.4> <8, 13, 5.6> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { 0*y, 3.1*y, 7.8 translate <4, 0, 4> }
          box { <0, 3, 2.4> <8, 9, 5.6> }
          cylinder { 2.400001*z, 5.599999*z, 3.999999 translate <4.000001, 8.999999, 0> }
        }
        cylinder { 2*z, 6*z, 2.5 translate <4, 9, 0> }
        #if (setting > 1)
          cylinder { -1*y, 2*y, 6.5 translate <4, 0, 4> }
          cylinder { -1*y, 2*y, 2.5 }
          cylinder { -1*y, 2*y, 2.5 translate <0, 0, 8> }
          cylinder { -1*y, 2*y, 2.5 translate <8, 0, 8> }
          cylinder { -1*y, 2*y, 2.5 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        box { <-3, 0, -0.5> <3, 2.1, 0.5> rotate 45*y translate <4, 0, 4> }
        box { <-3, 0.000001, -0.5> <3, 2.1, 0.5> rotate -45*y translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 13.1, 12> } }
    }
  #end
#end
#macro e_tool(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -1.5*y, 27*y, 1.5 }
      box { <-4.75, -2, -1> <4.75, 9, 3> rotate -23*x translate <0, 26, -1.8> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { 0*y, 21*y, 1.5 }
      sphere { <0, 0, 0> 1.499999 }
      cone { 20.999999*y, 1.5, 27*y, 0.9 }
      sphere { <0, 26.999999, 0> 0.9 }
      difference {
        merge {
          sphere { <-2.75, 0, 1> 2 }
          sphere { <2.75, 0, 1> 2 }
          cylinder { -2.750001*x, 2.750001*x, 2.000001 translate <0, 0, 1> }
          cylinder { 0*y, 9*y, 2.000002 translate <-2.750002, 0, 1> }
          cylinder { 0*y, 9*y, 2.000002 translate <2.750002, 0, 1> }
          box { <-2.750003, 0, -1.000001> <2.750003, 9.000001, 3> }
        }
        box { <-5, -5, -5> <5, 11, 1> }
        sphere { <-2.75, 0, 1> 1 }
        sphere { <2.75, 0, 1> 1 }
        cylinder { -2.750001*x, 2.750001*x, 1.000001 translate <0, 0, 1> }
        cylinder { 0*y, 10*y, 1.000002 translate <-2.750002, 0, 1> }
        cylinder { 0*y, 10*y, 1.000002 translate <2.750002, 0, 1> }
        box { <-2.750003, 0, -4> <2.750003, 10, 2.0000001> }
        rotate -23*x
        translate <0, 26, -1.8>
      }
      texture { color_tex }
      bounded_by { box { <-4.85, -1.6, -5> <4.85, 35.75, 1.6> } }
    }
  #end
#end
#macro f23connect1_6(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.1, 3.1, 43.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <3.9, 3.1, 43.9> }
          box { <-2.25, 0.000001, -8.000001> <-0.65, 3.099999, -3.5> }
          cylinder { -2.249999*x, -0.650001*x, 1.55 translate <0, 1.55, -8> }
          box { <0.65, 0.000001, -8.000001> <2.25, 3.099999, -3.5> }
          cylinder { 0.650001*x, 2.249999*x, 1.55 translate <0, 1.55, -8> }
          cylinder { -3.900001*x, 3.900001*x, 1.55 translate <0, 1.550001, -3.899999> }
          cylinder { -3.900001*x, 3.900001*x, 1.55 translate <0, 1.550001, 43.899999> }
          box { <-3.900001, 0.000001, 43.5> <-2.4, 3.099999, 48.000001> }
          cylinder { -3.900002*x, -2.399999*x, 1.55 translate <0, 1.550001, 48> }
          box { <-0.5, 0.000001, 43.5> <0.5, 3.099999, 48.000001> }
          cylinder { -0.500001*x, 0.499999*x, 1.55 translate <0, 1.550001, 48> }
          box { <2.35, 0.000001, 43.5> <3.899999, 3.099999, 48.000001> }
          cylinder { 2.350001*x, 3.899998*x, 1.55 translate <0, 1.550001, 48> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 40> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <0, 0, 8> }
            object { rounded_button() rotate 90*y translate <0, 0, 16> }
            object { rounded_button() rotate 90*y translate <0, 0, 24> }
            object { rounded_button() rotate 90*y translate <0, 0, 32> }
            object { rounded_button() rotate 90*y translate <0, 0, 40> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 2, 43.89> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 40> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <0, 0, 4> }
        object { pin(1) translate <0, 0, 12> }
        object { pin(1) translate <0, 0, 20> }
        object { pin(1) translate <0, 0, 28> }
        object { pin(1) translate <0, 0, 36> }
        box { <-0.5, 0.05, 42.5> <0.5, 2.1, 43.9> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -9.65> <4, 4.9, 49.65> } }
    }
  #end
#end
#macro f2connect2_1(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 3.1, 11.9> }
      box { <-2.25, 0.000001, 11.8> <2.25, 3.100001, 17.55> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <3.9, 3.1, 11.9> }
          box { <-2.25, 0.000001, 11.5> <-0.65, 3.099999, 16.000001> }
          cylinder { -2.249999*x, -0.650001*x, 1.55 translate <0, 1.55, 16> }
          box { <0.65, 0.000001, 11.5> <2.25, 3.099999, 16.000001> }
          cylinder { 0.650001*x, 2.249999*x, 1.55 translate <0, 1.55, 16> }
          cylinder { -3.9*x, 3.9*x, 1.55 translate <0, 1.550001, 11.899999> }
          object { open_rounded_button() }
          object { open_rounded_button() translate <0, 0, 8> }
          #if (setting > 3)
            object { llogo() rotate -90*y scale <0.65, 0.65, 0.65> translate <0, 3.1, 0> }
            object { llogo() rotate -90*y scale <0.65, 0.65, 0.65> translate <0, 3.1, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 2, 10.4> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <0, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 4.9, 17.65> } }
    }
  #end
#end
#macro f3connect2_1(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.9, 3.1, 17.55> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <3.9, 3.1, 11.9> }
          box { <-3.900001, 0.000001, 11.5> <-2.35, 3.099999, 16.000001> }
          cylinder { -3.900002*x, -2.349999*x, 1.55 translate <0, 1.55, 16> }
          box { <-0.55, 0.000001, 11.5> <0.55, 3.099999, 16.000001> }
          cylinder { -0.550001*x, 0.549999*x, 1.55 translate <0, 1.55, 16> }
          box { <2.35, 0.000001, 11.5> <3.899999, 3.099999, 16.000001> }
          cylinder { 2.350001*x, 3.899998*x, 1.55 translate <0, 1.55, 16> }
          cylinder { -3.9*x, 3.9*x, 1.55 translate <0, 1.550001, 11.899999> }
          object { open_rounded_button() }
          object { open_rounded_button() translate <0, 0, 8> }
          #if (setting > 3)
            object { llogo() rotate -90*y scale <0.65, 0.65, 0.65> translate <0, 3.1, 0> }
            object { llogo() rotate -90*y scale <0.65, 0.65, 0.65> translate <0, 3.1, 8> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <2.4, 2, 12> }
            box { <-0.75, 0.1, 10.4> <0.75, 2.1, 13> }
          }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <0, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 4.9, 17.65> } }
    }
  #end
#end
#macro fence1_4(color_tex,age)
  #if (setting = 0)
    merge {
      cylinder { 4.5*y, 17.6*y, 1.5 translate <-12, 0, 0> }
      cylinder { 4.5*y, 17.6*y, 1.5 translate <20, 0, 0> }
      cylinder { -12*x, 20*x, 1.5 translate <0, 17.6, 0> }
      cylinder { -12*x, 20*x, 1.5 translate <0, 4.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
        #end
      }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
      #end
      cylinder { 8.499999*y, 13.600001*y, 1.5 translate <-12, 0, 0> }
      cylinder { 8.499999*y, 13.600001*y, 1.5 translate <20, 0, 0> }
      cylinder { -8.000001*x, 16.000001*x, 1.5 translate <0, 17.6, 0> }
      cylinder { -8.000001*x, 16.000001*x, 1.5 translate <0, 4.5, 0> }
      difference {
        torus { 4, 1.5 rotate 90*x }
        box { <-10, -10, -10> <10, -0.000001, 10> }
        box { <-10, -10, -10> <-0.000001, 10, 10> }
        translate <16, 13.6, 0>
      }
      difference {
        torus { 4, 1.5 rotate 90*x }
        box { <-10, -10, -10> <10, -0.000001, 10> }
        box { <0.000001, -10, -10> <10, 10, 10> }
        translate <-8, 13.6, 0>
      }
      difference {
        torus { 4, 1.5 rotate 90*x }
        box { <-10, 0.000001, -10> <10, 10, 10> }
        box { <-10, -10, -10> <-0.000001, 10, 10> }
        translate <16, 8.5, 0>
      }
      difference {
        torus { 4, 1.5 rotate 90*x }
        box { <-10, 0.000001, -10> <10, 10, 10> }
        box { <0.000001, -10, -10> <10, 10, 10> }
        translate <-8, 8.5, 0>
      }
      texture { color_tex }
      bounded_by { box { <-13.6, -0.1, -4> <21.6, 19.2, 4> } }
    }
  #end
#end
#macro fence1_6(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 4.5*y, 17.6*y, 1.5 translate <-8, 0, 0> }
      cylinder { 4.5*y, 17.6*y, 1.5 translate <48, 0, 0> }
      cylinder { -8*x, 48*x, 1.5 translate <0, 17.6, 0> }
      cylinder { -8*x, 48*x, 1.5 translate <0, 4.5, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 3.1*y, 3.2 }
        cylinder { 0*y, 3.1*y, 3.2 translate <40, 0, 0> }
        cylinder { 8.499999*y, 13.600001*y, 1.5 translate <-8, 0, 0> }
        cylinder { 8.499999*y, 13.600001*y, 1.5 translate <48, 0, 0> }
        object { open_rounded_button() translate <0, 16, 0> }
        object { open_rounded_button() translate <40, 16, 0> }
        cylinder { 16.099999*y, 19.000001*y, 2.4 }
        cylinder { 16.099999*y, 19.000001*y, 2.4 translate <40, 0, 0> }
        cylinder { 4.5*y, 17.6*y, 1.5 translate <20, 0, 0> }
        cylinder { -4.000001*x, 44.000001*x, 1.5 translate <0, 17.6, 0> }
        cylinder { -4.000001*x, 44.000001*x, 1.5 translate <0, 4.5, 0> }
        difference {
          torus { 4, 1.5 rotate 90*x }
          box { <-10, -10, -10> <10, -0.000001, 10> }
          box { <-10, -10, -10> <-0.000001, 10, 10> }
          translate <44, 13.6, 0>
        }
        difference {
          torus { 4, 1.5 rotate 90*x }
          box { <-10, -10, -10> <10, -0.000001, 10> }
          box { <0.000001, -10, -10> <10, 10, 10> }
          translate <-4, 13.6, 0>
        }
        difference {
          torus { 4, 1.5 rotate 90*x }
          box { <-10, 0.000001, -10> <10, 10, 10> }
          box { <-10, -10, -10> <-0.000001, 10, 10> }
          translate <44, 8.5, 0>
        }
        difference {
          torus { 4, 1.5 rotate 90*x }
          box { <-10, 0.000001, -10> <10, 10, 10> }
          box { <0.000001, -10, -10> <10, 10, 10> }
          translate <-4, 8.5, 0>
        }
      }
      cylinder { 15*y, 21*y, 1.600001 }
      cylinder { 15*y, 21.5*y, 1.600001 translate <40, 0, 0> }
      #if (setting > 1)
        cylinder { -1*y, 2*y, 2.6 }
        cylinder { -1*y, 2*y, 2.6 translate <40, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-9.6, -0.1, -4> <49.6, 20.9, 4> } }
    }
  #end
#end
#macro fence1_6_barred(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 6.8*y, 27.2*y, 1.5 translate <-8, 0, 0> }
      cylinder { 6.8*y, 27.2*y, 1.5 translate <48, 0, 0> }
      cylinder { -8*x, 48*x, 1.5 translate <0, 27.2, 0> }
      cylinder { -8*x, 48*x, 1.5 translate <0, 7, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <3.9, 3.1, 3.9> }
        box { <36.1, 0, -3.9> <43.9, 3.1, 3.9> }
        cylinder { 3*y, 5*y, 2.4 }
        cone { 4.999999*y, 2.4, 6*y, 0 }
        cylinder { 3*y, 5*y, 2.4 translate <40, 0, 0> }
        cone { 4.999999*y, 2.4, 6*y, 0 translate <40, 0, 0> }
        cylinder { 10.799999*y, 23.200001*y, 1.5 translate <-8, 0, 0> }
        cylinder { 10.799999*y, 23.200001*y, 1.5 translate <48, 0, 0> }
        object { open_rounded_button() translate <0, 25.6, 0> }
        object { open_rounded_button() translate <40, 25.6, 0> }
        cone { 27.6*y, 0, 28.6*y, 2.4 }
        cone { 27.6*y, 0, 28.6*y, 2.4 translate <40, 0, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 28.7, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <40, 28.7, 0> }
        #end
        cylinder { 6.8*y, 27.2*y, 1 translate <0, 0, 0> }
        cylinder { 6.8*y, 27.2*y, 1 translate <8, 0, 0> }
        cylinder { 6.8*y, 27.2*y, 1 translate <16, 0, 0> }
        cylinder { 6.8*y, 27.2*y, 1 translate <24, 0, 0> }
        cylinder { 6.8*y, 27.2*y, 1 translate <32, 0, 0> }
        cylinder { 6.8*y, 27.2*y, 1 translate <40, 0, 0> }
        cylinder { -4.000001*x, 44.000001*x, 1.5 translate <0, 27.2, 0> }
        cylinder { -4.000001*x, 44.000001*x, 1.5 translate <0, 6.8, 0> }
        difference {
          torus { 4, 1.5 rotate 90*x }
          box { <-10, -10, -10> <10, -0.000001, 10> }
          box { <-10, -10, -10> <-0.000001, 10, 10> }
          translate <44, 23.2, 0>
        }
        difference {
          torus { 4, 1.5 rotate 90*x }
          box { <-10, -10, -10> <10, -0.000001, 10> }
          box { <0.000001, -10, -10> <10, 10, 10> }
          translate <-4, 23.2, 0>
        }
        difference {
          torus { 4, 1.5 rotate 90*x }
          box { <-10, 0.000001, -10> <10, 10, 10> }
          box { <-10, -10, -10> <-0.000001, 10, 10> }
          translate <44, 10.8, 0>
        }
        difference {
          torus { 4, 1.5 rotate 90*x }
          box { <-10, 0.000001, -10> <10, 10, 10> }
          box { <0.000001, -10, -10> <10, 10, 10> }
          translate <-4, 10.8, 0>
        }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
        cylinder { 1*y, 4*y, 1.6 }
        box { <37.6, -1, -2.4> <42.4, 2, 2.4> }
        cylinder { 1*y, 4*y, 1.6 translate <40, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-9.6, -0.1, -4> <49.6, 30.5, 4> } }
    }
  #end
#end
#macro fence1_8(color_tex)
  #if (setting = 0)
    merge {
      box { <-2.5, 0, -2.5> <2.5, 25.5, 2.5> }
      box { <37.5, 0, -2.5> <42.5, 25.5, 2.5> }
      box { <-11.9, 6.3, -3.9> <51.9, 12.7, -2.499999> }
      box { <-11.9, 19.1, -3.9> <51.9, 25.5, -2.499999> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <3.9, 3.1, 3.9> }
        box { <36.1, 0, -3.9> <43.9, 3.1, 3.9> }
        box { <-2.5, 3, -2.5> <2.5, 25.5, 2.5> }
        box { <37.5, 3, -2.5> <42.5, 25.5, 2.5> }
        box { <-11.9, 6.3, -3.9> <51.9, 12.7, -2.499999> }
        box { <-11.9, 19.1, -3.9> <51.9, 25.5, -2.499999> }
        object { open_rounded_button() translate <0, 22.4, 0> }
        object { open_rounded_button() translate <40, 22.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 25.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <40, 25.5, 0> }
        #end
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
        box { <37.6, -1, -2.4> <42.4, 2, 2.4> }
        cylinder { -1*y, 24.5*y, 1.6 }
        cylinder { -1*y, 24.5*y, 1.6 translate <40, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <52, 27.3, 4> } }
    }
  #end
#end
#macro ffblock1_1(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.9, 3.1, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, .5, -3.9> <3.9, 3.1, 3.9> }
        box { <-3.5, 0, -3.5> <3.5, .55, 3.5> }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 3.2, 4> } }
    }
  #end
#end
#macro ffblock1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, .5, -3.9> <11.9, 3.1, 3.9> }
        box { <-3.5, 0, -3.5> <11.5, .55, 3.5> }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 3.2, 4> } }
    }
  #end
#end
#macro ffblock1_4(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, .5, -3.9> <27.9, 3.1, 3.9> }
        box { <-3.5, 0, -3.5> <27.5, .55, 3.5> }
      }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          object { pin(age) translate <4, 0.000001, 0> }
          object { pin(age) translate <12, 0.000001, 0> }
          object { pin(age) translate <20, 0.000001, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 3.2, 4> } }
    }
  #end
#end
#macro ffblock1_6(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 3.1, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, .5, -3.9> <43.9, 3.1, 3.9> }
        box { <-3.5, 0, -3.5> <43.5, .55, 3.5> }
      }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <42.4, 2, 2.4> }
          object { pin(age) translate <4, 0.000001, 0> }
          object { pin(age) translate <12, 0.000001, 0> }
          object { pin(age) translate <20, 0.000001, 0> }
          object { pin(age) translate <28, 0.000001, 0> }
          object { pin(age) translate <36, 0.000001, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 3.2, 4> } }
    }
  #end
#end
#macro ffblock1_8(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 3.1, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, .5, -3.9> <59.9, 3.1, 3.9> }
        box { <-3.5, 0, -3.5> <59.5, .55, 3.5> }
      }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <58.4, 2, 2.4> }
          object { pin(age) translate <4, 0.000001, 0> }
          object { pin(age) translate <12, 0.000001, 0> }
          object { pin(age) translate <20, 0.000001, 0> }
          object { pin(age) translate <28, 0.000001, 0> }
          object { pin(age) translate <36, 0.000001, 0> }
          object { pin(age) translate <44, 0.000001, 0> }
          object { pin(age) translate <52, 0.000001, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 3.2, 4> } }
    }
  #end
#end
#macro ffblock2_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, .5, -3.9> <11.9, 3.1, 11.9> }
          box { <-3.5, 0, -3.5> <11.5, .55, 11.5> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0.000001, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 3.2, 12> } }
    }
  #end
#end
#macro ffblock8_16(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <123.9, 3.1, 59.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, .5, -3.9> <123.9, 3.1, 59.9> }
          box { <-3.5, 0, -3.5> <123.5, .55, 59.5> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <122.4, 2, 58.4> }
          cylinder { 3*y, 4*y, 1.9 translate <60, 0, 28> }
        #end
      }
      #if (setting > 1)
        difference {
          box { <10.4, 0.00001, 10.4> <107.6, 2.1, 43.6> }
          box { <11.5, -1, 11.5> <106.5, 3, 42.5> }
        }
        box { <10.5, 1.8, 18.6> <107.5, 2.1, 21.4> }
        box { <10.5, 1.8, 26.6> <107.5, 2.1, 29.4> }
        box { <10.5, 1.8, 34.6> <107.5, 2.1, 37.4> }
        box { <104, 1.9, 10.5> <106.8, 2.1, 43.5> }
        box { <58.6, 1.9, 20> <61.4, 2.1, 36> }
        difference {
          sphere { <0, 8.75, 0> 8 }
          box { <-10, 3, -10> <10, 50, 10> }
          translate <60, 0, 28>
        }
        object { ring() translate <4, 0.000001, 4> }
        object { ring() translate <4, 0.000001, 12> }
        object { ring() translate <4, 0.000001, 20> }
        object { ring() translate <4, 0.000001, 28> }
        object { ring() translate <4, 0.000001, 36> }
        object { ring() translate <4, 0.000001, 44> }
        object { ring() translate <4, 0.000001, 52> }
        object { ring() translate <12, 0.000001, 4> }
        object { ring() translate <20, 0.000001, 4> }
        object { ring() translate <28, 0.000001, 4> }
        object { ring() translate <36, 0.000001, 4> }
        object { ring() translate <44, 0.000001, 4> }
        object { ring() translate <52, 0.000001, 4> }
        object { ring() translate <60, 0.000001, 4> }
        object { ring() translate <68, 0.000001, 4> }
        object { ring() translate <76, 0.000001, 4> }
        object { ring() translate <84, 0.000001, 4> }
        object { ring() translate <92, 0.000001, 4> }
        object { ring() translate <100, 0.000001, 4> }
        object { ring() translate <108, 0.000001, 4> }
        object { ring() translate <116, 0.000001, 4> }
        object { ring() translate <12, 0.000001, 52> }
        object { ring() translate <20, 0.000001, 52> }
        object { ring() translate <28, 0.000001, 52> }
        object { ring() translate <36, 0.000001, 52> }
        object { ring() translate <44, 0.000001, 52> }
        object { ring() translate <52, 0.000001, 52> }
        object { ring() translate <60, 0.000001, 52> }
        object { ring() translate <68, 0.000001, 52> }
        object { ring() translate <76, 0.000001, 52> }
        object { ring() translate <84, 0.000001, 52> }
        object { ring() translate <92, 0.000001, 52> }
        object { ring() translate <100, 0.000001, 52> }
        object { ring() translate <108, 0.000001, 52> }
        object { ring() translate <116, 0.000001, 12> }
        object { ring() translate <116, 0.000001, 20> }
        object { ring() translate <116, 0.000001, 28> }
        object { ring() translate <116, 0.000001, 36> }
        object { ring() translate <116, 0.000001, 44> }
        object { ring() translate <116, 0.000001, 52> }
        box { <-0.9, 0.05, -0.3> <0.5, 2.1, 0.3> rotate -45*y translate <10.4, 0, 10.4> }
        box { <-0.9, 0.05, -0.3> <0.5, 2.1, 0.3> rotate 45*y translate <10.4, 0, 43.6> }
        box { <-0.5, 0.05, -0.3> <0.9, 2.1, 0.3> rotate 45*y translate <107.6, 0, 10.4> }
        box { <-0.5, 0.05, -0.3> <0.9, 2.1, 0.3> rotate -45*y translate <107.6, 0, 43.6> }
      #end
      texture { color_tex finish { reflection 0 } }
      bounded_by { box { <-4, -0.1, -4> <124, 3.2, 60> } }
    }
  #end
#end
#macro ffrblock2_2(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 3.1*y, 7.8 translate <4, 0, 4> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { .5*y, 3.1*y, 7.8 translate <4, 0, 4> }
          cylinder { 0*y, .55*y, 7.4 translate <4, 0, 4> }
        }
        #if (setting > 1)
          cylinder { -1*y, 2*y, 6.5 translate <4, 0.000001, 4> }
          cylinder { -1*y, 2*y, 2.5 translate <0, 0.000001, 0> }
          cylinder { -1*y, 2*y, 2.5 translate <0, 0.000001, 8> }
          cylinder { -1*y, 2*y, 2.5 translate <8, 0.000001, 8> }
          cylinder { -1*y, 2*y, 2.5 translate <8, 0.000001, 0> }
        #end
      }
      #if (setting > 1)
        box { <-3, 0, -0.5> <3, 2.1, 0.5> rotate 45*y translate <4, 0, 4> }
        box { <-3, 0.000001, -0.5> <3, 2.1, 0.5> rotate -45*y translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 3.2, 12> } }
    }
  #end
#end
#macro fhrblock2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <12, 3.1, 11.9> }
      cylinder { 0.000001*y, 3.099999*y, 7.899999 translate <12, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <12, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <8, 0, 8> }
          #end
          difference {
            cylinder { 0.000001*y, 3.099999*y, 7.899999 translate <12, 0, 4> }
            cylinder { -1*y, 4*y, 2.600001 translate <16, 0, 4> }
          }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          difference {
            cylinder { -1*y, 2*y, 6.4 translate <12, 0, 4> }
            box { <-20, -2, -4> <12, 3, 12> }
          }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <16, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 4.9, 12> } }
    }
  #end
#end
#macro fhrblock2_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <12, 3.1, 27.9> }
      cylinder { 0.000001*y, 3.099999*y, 7.899999 translate <12, 0, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <12, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <0, 0, 16> }
            object { rounded_button() translate <0, 0, 24> }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <8, 0, 16> }
            object { rounded_button() translate <8, 0, 24> }
          #end
          difference {
            cylinder { 0.000001*y, 3.099999*y, 7.899999 translate <12, 0, 12> }
            cylinder { -1*y, 4*y, 2.600001 translate <16, 0, 12> }
          }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 26.4> }
          difference {
            cylinder { -1*y, 2*y, 6.4 translate <12, 0, 12> }
            box { <-20, -2, -4> <12, 3, 28> }
          }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <16, 0, 12> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 4.9, 28> } }
    }
  #end
#end
#macro fhsconnect2_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-4.000001, 0, -3.9> <27.9, 3.1, 11.9> }
      cylinder { 0.000001*y, 3.099999*y, 7.900001 translate <-4, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-4.000001, 0, -3.9> <27.9, 3.1, 11.9> }
          cylinder { 0.000001*y, 3.099999*y, 7.900001 translate <-4, 0, 4> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <24, 0, 8> }
          #end
        }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          box { <-2.4, -1, -2.4> <26.4, 2, 10.4> }
        #end
        difference {
          cylinder { -1*y, 2*y, 6.4 translate <-4, 0, 4> }
          box { <-4, -2, -10> <20, 4, 20> }
        }
        cylinder { -1*y, 4*y, 1 translate <-8, 0, 4> }
        box { <-12, -1, 3.25> <-8, 4, 4.75> }
      }
      difference {
        cylinder { -5.5*y, 0.000001*y, 4.5 }
        cylinder { -4.5*y, -3.5*y, 3.5 }
        cylinder { -6*y, 1*y, 3 }
        cylinder { -5*x, 5*x, 1.5 translate <0, -5.5, 0> }
        box { <-12, -1, 3.250001> <-8, 4, 4.750001> }
        translate <-7.499999, 0, 4>
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -5.6, -4> <28, 4.9, 12> } }
    }
  #end
#end
#macro fh_connect1_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 3.1, 27.9> }
      cylinder { 3.899999*x, 10.5*x, 4.5 translate <0, 1.55, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <0, 0, 16> }
            object { rounded_button() translate <0, 0, 24> }
          #end
          box { <-3.9, 0, -3.9> <3.9, 3.1, 27.9> }
          box { <3.899999, 0.000001, 6.5> <4.9, 3.099999, 17.5> }
          torus { 3.5, 1 rotate 90*z translate <5, 1.55, 12> }
          torus { 3.5, 1 rotate 90*z translate <9.5, 1.55, 12> }
          cylinder { 4.999999*x, 9.500001*x, 4.5 translate <0, 1.55, 12> }
          cylinder { 3.999999*x, 10.500001*x, 4 translate <0, 1.55, 12> }
        }
        box { <6.499999, -3, 11.499999> <12, 7, 12.500001> }
        cylinder { -3*y, 7*y, 0.5 translate <6.5, 0, 12> }
        box { <6.999999, 1.05, 7> <11, 2.05, 19> }
        cylinder { 7*z, 19*z, 0.5 translate <7, 1.55, 0> }
        cylinder { 7*z, 19*z, 1.75 translate <10.5, 1.55, 0> }
        cylinder { 4.1*x, 12*x, 2.75 translate <0, 1.55, 12> }
        box { <3.9, -4, -1> <11, -2.35, 19> }
        cylinder { -1*y, 4*y, 1 translate <4.9, 0, 6.5> }
        cylinder { -1*y, 4*y, 1 translate <4.9, 0, 17.5> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 2, 26.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <0, 0, 4> }
        object { pin(1) translate <0, 0, 12> }
        object { pin(1) translate <0, 0, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -2.45, -4> <10.6, 6.15, 28> } }
    }
  #end
#end
#macro fh_connect2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      cylinder { 11.899999*x, 18.5*x, 4.5 translate <0, 1.55, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <8, 0, 8> }
          #end
          box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
          box { <11.899999, 0.000001, -1.5> <12.9, 3.099999, 9.5> }
          torus { 3.5, 1 rotate 90*z translate <13, 1.55, 4> }
          torus { 3.5, 1 rotate 90*z translate <17.5, 1.55, 4> }
          cylinder { 12.999999*x, 17.500001*x, 4.5 translate <0, 1.55, 4> }
          cylinder { 11.999999*x, 18.500001*x, 3.5 translate <0, 1.55, 4> }
        }
        box { <14.499999, -3, 3.499999> <20, 7, 4.500001> }
        cylinder { -3*y, 7*y, 0.5 translate <14.5, 0, 4> }
        box { <14.999999, 1.05, -1> <19, 2.05, 11> }
        cylinder { -1*z, 11*z, 0.5 translate <15, 1.55, 0> }
        cylinder { -1*z, 11*z, 1.75 translate <18.5, 1.55, 0> }
        cylinder { 12.1*x, 20*x, 2.75 translate <0, 1.55, 4> }
        box { <11.9, -4, -1> <19, -2.35, 11> }
        cylinder { -1*y, 4*y, 1 translate <12.9, 0, -1.5> }
        cylinder { -1*y, 4*y, 1 translate <12.9, 0, 9.5> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -2.45, -4> <18.6, 6.15, 12> } }
    }
  #end
#end
#macro fishing_rod(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 93*y, 0.8 texture { color_tex } }
  #else
    difference {
      merge {
        torus { 1.35, 0.15 }
        cylinder { -0.15*y, 2*y, 1.35 }
        cylinder { 0*y, 28.200001*y, 1.5 }
        box { <0, 16.2, -1.1> <4, 20.2, 1.1> }
        cylinder { -1.5*z, 1.5*z, 3.1 translate <6.5, 18.2, 0> }
        object { open_rounded_button() rotate -90*x translate <6.5, 18.2, 2> }
        object { open_rounded_button() rotate 90*x translate <6.5, 18.2, -2> }
        cone { 28.2*y, 1.5, 29*y, 0.9 }
        cone { 28.999995*y, 0.9, 93*y, 0.7 }
        difference {
          sphere { <0, 0, 0> 1.5 }
          cylinder { -2*y, 2*y, 0.6 }
          box { <-2, -2, -2> <2, -1, 2> }
          box { <-2, 1, -2> <2, 2, 2> }
          rotate 45*z translate <0.5, 93.5, 0>
        }
      }
      cylinder { -5*z, 5*z, 1.600005 translate <6.5, 18.2, 0> }
      cylinder { 18.2*y, 25*y, 0.6 translate <6.5, 0, 0> }
      box { <5.9, 18.2, -5> <7.1, 25, 0.000005> }
      texture { color_tex }
      bounded_by { box { <-1.6, -0.1, -2.9> <9.7, 96, 2.9> } }
    }
  #end
#end
#macro fkblock1_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 3.1, 27.9> }
      cylinder { 3.8*x, 14.5*x, 1.55 translate <0, 1.55, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <3.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <0, 0, 16> }
            object { rounded_button() translate <0, 0, 24> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 2, 26.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <0, 0, 4> }
        object { pin(2) translate <0, 0, 12> }
        object { pin(2) translate <0, 0, 20> }
      #end
      cylinder { 3.8*x, 11.5*x, 1.55 translate <0, 1.55, 12> }
      sphere { <11.5, 1.55, 12> 2.9 }
      texture { color_tex }
      bounded_by { box { <-4, -1.45, -4> <14.5, 4.9, 28> } }
    }
  #end
#end
#macro fkblock2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      cylinder { 11.8*x, 22.9*x, 1.55 translate <0, 1.55, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
      #end
      cylinder { 11.8*x, 20*x, 1.55 translate <0, 1.55, 4> }
      sphere { <20, 1.55, 4> 2.9 }
      texture { color_tex }
      bounded_by { box { <-4, -1.45, -4> <23, 4.9, 12> } }
    }
  #end
#end
#macro flame(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*x, 3.9*x, 1.5 }
      box { <3.8, 0.75, -3.9> <29.3, 0.75, 4.5> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { 0*x, 3.9*x, 1.5 }
      cylinder { 0*z, 3*z, 0.7 translate <3.1, 0, 0> }
      cylinder { -3*y, 0*y, 0.7 translate <3.1, 0, 0> }
      prism {
        bezier_spline
        -0.75, 0.75, 64,
        <3.8, 1>, <11.4, 1>, <12.9526, 3.2967>, <14.5, 4>,
        <14.5, 4>, <15.6001, 4.5>, <15.6626, 3.3012>, <15, 3>,
        <15, 3>, <13.9, 2.5>, <14.4719, 1.8355>, <15.1, 1.6>,
        <15.1, 1.6>, <15.90001, 1.3>, <17.2001, 4.1>, <24, 3.5>,
        <24, 3.5>, <24.9019, 3.4204>, <24.9, 2.5>, <24, 2.5>,
        <24, 2.5>, <22.8341, 2.5>, <21.3, 2.4>, <21.3, 1.5>,
        <21.3, 1.5>, <21.3, 0>, <26.788, 1>, <28.5, 1>,
        <28.5, 1>, <29.3001, 1>, <29.2, 0.1>, <28.5, 0>,
        <28.5, 0>, <27.6035, -0.1281>, <24.1001, -1.4>, <19.5, -0.8>,
        <19.5, -0.8>, <18.4319, -0.6607>, <18.2, -2.5>, <19.5, -2.5>,
        <19.5, -2.5>, <20.8, -2.5>, <20.8, -3.9>, <19.5, -3.9>,
        <19.5, -3.9>, <15.6, -3.9>, <13.5999, -1.4999>, <11.3, -0.2>,
        <11.3, -0.2>, <10.4787, 0.2642>, <8.9999, -1.4>, <11.1, -2.3>,
        <11.1, -2.3>, <12.6214, -2.952>, <11.5179, -3.8766>, <11, -3.5>,
        <11, -3.5>, <9.9, -2.7>, <7.4, -1>, <3.8, -1>,
        <3.8, -1>, <3.8, -1>, <3.8, 1>, <3.8, 1>
        sturm
      }
      texture { color_tex }
      bounded_by { box { <-0.1, -3.1, -4> <29.4, 1.6, 4.6> } }
    }
  #end
#end
#macro flblock1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          object { conductive_button() rotate 180*y }
          object { conductive_button() translate <8, 0, 0> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          box { <-1.9, -1, -4> <9.9, 0.5, -3.4> }
          box { <-1.9, -1, 3.4> <9.9, 0.5, 3.9> }
          cylinder { 1*y, 3*y, 2 }
          cylinder { 1*y, 3*y, 2 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        box { <1.4, 0.000001, -2.6> <2.1, 2.1, -1.9> }
        box { <5.9, 0.000001, -2.6> <6.6, 2.1, -1.9> }
        box { <1.4, 0.000001, 1.9> <2.1, 2.1, 2.6> }
        box { <5.9, 0.000001, 1.9> <6.6, 2.1, 2.6> }
        box { <-2.4, 1.9, -2.4> <-2, 2.1, 2.4> texture { chrome_tex } }
        box { <10, 1.9, -2.4> <10.4, 2.1, 2.4> texture { chrome_tex } }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 4.9, 4> } }
    }
  #end
#end
#macro flblock2_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
          object { conductive_button() rotate 90*y }
          object { conductive_button() rotate 90*y translate <8, 0, 0> }
          object { conductive_button() rotate 90*y translate <16, 0, 0> }
          object { conductive_button() rotate 90*y translate <24, 0, 0> }
          object { conductive_button() rotate -90*y translate <0, 0, 8> }
          object { conductive_button() rotate -90*y translate <8, 0, 8> }
          object { conductive_button() rotate -90*y translate <16, 0, 8> }
          object { conductive_button() rotate -90*y translate <24, 0, 8> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 10.4> }
          box { <-4, -1, -1.9> <-3.4, 0.5, 9.9> }
          box { <27.4, -1, -1.9> <28, 0.5, 9.9> }
          cylinder { 1*y, 3*y, 2 }
          cylinder { 1*y, 3*y, 2 translate <8, 0, 0> }
          cylinder { 1*y, 3*y, 2 translate <16, 0, 0> }
          cylinder { 1*y, 3*y, 2 translate <24, 0, 0> }
          cylinder { 1*y, 3*y, 2 translate <0, 0, 8> }
          cylinder { 1*y, 3*y, 2 translate <8, 0, 8> }
          cylinder { 1*y, 3*y, 2 translate <16, 0, 8> }
          cylinder { 1*y, 3*y, 2 translate <24, 0, 8> }
        #end
      }
      #if (setting > 1)
        box { <-2.6, 0.000001, 1.4> <-1.9, 2.1, 2.1> }
        box { <-2.6, 0.000001, 5.9> <-1.9, 2.1, 6.6> }
        box { <25.9, 0.000001, 1.4> <26.6, 2.1, 2.1> }
        box { <25.9, 0.000001, 5.9> <26.6, 2.1, 6.6> }
        box { <-2.4, 1.9, -2.4> <26.4, 2.1, -2> texture { chrome_tex } }
        box { <-2.4, 1.9, 10> <26.4, 2.1, 10.4> texture { chrome_tex } }
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.25, -4> <28, 4.9, 12> } }
    }
  #end
#end
#macro flipper(color_tex)
  #if (setting = 0)
    box { <-5.9, 0, -15.9> <5.9, 0.9, 3.65> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { 0*y, 0.9*y, 3.5 }
        box { <-3.500001, 0.000001, -15.75> <2, 0.899999, 0> rotate 7*y }
        box { <-2, 0.000002, -15.75> <3.500001, 0.899998, 0> rotate -7*y }
        object { open_rounded_button() translate <0, -2.2, 0> }
        merge {
          cylinder { 0.8*y, 1.6*y, 0.5 translate <0, 0, -15> }
          cylinder { 0.8*y, 1.6*y, 0.5 translate <0, 0, -6> }
          box { <-0.499999, 0.8, -15.000001> <0.499999, 1.600001, -5.999999> }
        }
        merge {
          cylinder { 0.8*y, 1.6*y, 0.5 translate <-3, 0, -14> }
          cylinder { 0.8*y, 1.6*y, 0.5 translate <-3, 0, -5.5> }
          box { <-3.499999, 0.8, -14.000001> <-2.499999, 1.600001, -5.499999> }
          rotate 7*y
        }
        merge {
          cylinder { 0.8*y, 1.6*y, 0.5 translate <3, 0, -14> }
          cylinder { 0.8*y, 1.6*y, 0.5 translate <3, 0, -5.5> }
          box { <2.499999, 0.8, -14.000001> <3.499999, 1.600001, -5.499999> }
          rotate -7*y
        }
      }
      cylinder { -1*y, 5*y, 9.5 translate <-6, 0, -23> }
      cylinder { -1*y, 5*y, 9.5 translate <6, 0, -23> }
      #if (setting > 1)
        cylinder { -1*y, 5*y, 1.600001 }
      #end
      texture { color_tex }
      bounded_by { box { <-6, -0.1, -16> <6, 2.7, 3.75> } }
    }
  #end
#end
#macro flower(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -0.000001*y, 0.5*y, 5.25 }
      cylinder { 0.4*y, 2.2*y, 2.4 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 0.5*y, 1.75 translate <3.5, 0, 0> }
        cylinder { 0.000001*y, 0.500001*y, 1.75 translate <3.5, 0, 0> rotate 60*y }
        cylinder { 0.000002*y, 0.500002*y, 1.75 translate <3.5, 0, 0> rotate 120*y }
        cylinder { 0.000003*y, 0.500003*y, 1.75 translate <3.5, 0, 0> rotate 180*y }
        cylinder { 0.000004*y, 0.500004*y, 1.75 translate <3.5, 0, 0> rotate 240*y }
        cylinder { 0.000005*y, 0.500005*y, 1.75 translate <3.5, 0, 0> rotate 300*y }
        cylinder { -0.000001*y, 0.500006*y, 2.75 }
        #if (setting < 3)
          cylinder { 0.4*y, 2.2*y, 2.4 }
        #else
          cylinder { 0.4*y, 2.05*y, 2.4 }
          cylinder { 0.5*y, 2.2*y, 2.25 }
          torus { 2.25, 0.15 translate <0, 2.05, 0> }
        #end
      }
      cylinder { -2*y, 5*y, 0.85 }
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 2.3*y, 5.35 } }
    }
  #end
#end
#macro flowerbase(color_tex)
  difference {
    merge {
      #if (setting < 3)
        cylinder { 4.8*y, 6.6*y, 2.4 }
      #else
        object { rounded_button() translate <0, 1.8, 0> }
      #end
      cylinder { 0*y, 4.9*y, 3.2 }
      cylinder { 2*y, 4.900001*y, 0.8 translate <3, 0, 0> }
      cylinder { 2*y, 4.900001*y, 0.8 translate <3, 0, 0> rotate 120*y }
      cylinder { 2*y, 4.900001*y, 0.8 translate <3, 0, 0> rotate 240*y }
      merge {
        cylinder { -0.5*y, 9*y, 0.800001 }
        sphere { <0, 8.999999, 0> 0.8 }
        rotate -15*z
        translate <3, 4.899999, 0>
      }
      merge {
        cylinder { -0.5*y, 11*y, 0.800001 }
        sphere { <0, 10.999999, 0> 0.8 }
        rotate -15*z
        translate <3, 4.899999, 0>
        rotate 240*y
      }
      merge {
        cylinder { -0.5*y, 13*y, 0.800001 }
        sphere { <0, 12.999999, 0> 0.8 }
        rotate -15*z
        translate <3, 4.899999, 0>
        rotate 120*y
      }
    }
    cylinder { -0.4*y, 4*y, 2.6 }
    texture { color_tex }
    bounded_by { box { <-10, -0.1, -10> <10, 20, 10> } }
  }
#end
#macro forklift_1(color_tex, color2_tex, dist)
  #if (dist < 0)
    #local dist = 0;
  #end
  #if (dist > 60)
    #local dist = 60;
  #end
  #if (setting = 0)
    union {
      merge {
        box { <-12.1, -1.55, -3.9> <1.55, 1.55, 11.9> }
        box { <-17.7, -14.2, -3.900007> <-12, 59.2, 11.900007> }
        texture { color_tex }
      }
      merge {
        box { <-32, 0, -14.25> <1, 1.5, -8.25> texture { color2_tex }  translate <-14.85, 57.2-dist, 4> }
        box { <-32, 0, 14.25> <1, 1.5, 8.25> texture { color2_tex }  translate <-14.85, 57.2-dist, 4> }
        rotate -2*z
        translate <-6.1, -20.5, 0>
      }
    }
  #else
    union {
      merge {
        torus { 1.6, 0.1 rotate 90*z translate <-1, 0, 4> }
        torus { 1.6, 0.1 rotate 90*z translate <-1, -18-dist, 4> }
        #local counter = 0;
        #while (counter < 52)
          difference {
            torus { 1.5, 0.1 }
            box { <-3, -1, 0.000001> <3, 1, 3> }
            rotate (2*(12*(dist+1)/61))*z
            translate <-1, -1-(counter*(0.325+0.325*(3.95858*((dist+1)/61)))), 4>
          }
          difference {
            torus { 1.5, 0.1 }
            box { <-3, -1, -0.000001> <3, 1, -3> }
            rotate -(2*(12*(dist+1)/61))*z
            translate <-1, -1-(counter*(0.325+0.325*(3.95858*((dist+1)/61)))), 4>
          }
          #local counter = counter + 1;
        #end
        translate <-14.85, 57.2, 0>
        texture { chrome_tex }
      }
      merge {
        difference {
          merge {
            cylinder { -3.9*z, 11.9*z, 1.55 translate <-3.5, 0, 0> }
            cylinder { -3.900001*z, -2.350001*z, 1.55 }
            cylinder { -0.550001*z, 0.550001*z, 1.55 }
            cylinder { 2.350001*z, 5.650001*z, 1.55 }
            cylinder { 11.900001*z, 10.350001*z, 1.55 }
            cylinder { 7.450001*z, 8.550001*z, 1.55 }
            box { <-12.1, -1.55, -3.900002> <0.000001, 1.55, -2.35> }
            box { <-3.5, -1.55, -0.55> <0.000001, 1.55, 0.55> }
            box { <-3.5, -1.55, 2.35> <0.000001, 1.55, 5.65> }
            box { <-12.1, -1.55, 10.35> <0.000001, 1.55, 11.9> }
            box { <-3.5, -1.55, 7.45> <0.000001, 1.55, 8.55> }
            box { <-12.1, -1.550002, -3> <-3.5, 1.550002, 11> }
            box { <-9, -5, -3.900005> <0, 0, -2.400005> rotate -29*z translate <-4.5, 1.55, 0> }
            box { <-9, -5, 11.900005> <0, 0, 10.400005> rotate -29*z translate <-4.5, 1.55, 0> }
          }
          cylinder { -2*y, 2*y, 0.5 translate <-1, 0, 4> }
          box { <-1.000001, -2, 3.5> <5, 2, 4.5> }
          #if (setting > 1)
            cylinder { -3*y, 0.55*y, 2 translate <-5.8, 0, -0.4> }
            cylinder { -3*y, 0.55*y, 2 translate <-5.8, 0, 8.4> }
            box { <-13, -3, -2.4> <-5.799999, 0.550001, 10.4> }
            box { <-13, -3, -0.400001> <-3.8, 0.550003, 8.400001> }
          #end
          box { <-20, -5, -4> <10, -1.550003, 12> }
          cylinder { -20*y, 20*y, 1 rotate 45*z translate <-8, 1.55, 1> }
          cylinder { -20*y, 20*y, 1 rotate 45*z translate <-8, 1.55, 7> }
          box { <-20, -20, 0.999999> <1.000001, 20, 7.000001> rotate 45*z translate <-8, 1.55, 0> }
          box { <-20, -20, -0.000001> <0.000001, 20, 8.000001> rotate 45*z translate <-8, 1.55, 0> }
        }
        difference {
          box { <-17.7, -14.2, -3.900007> <-12, 59.2, 11.900007> }
          box { <-16.5, -15, -2.6> <-13.2, 57.3, 10.6> }
          box { <-13.200001, -15, 0> <-11.9, 60, 8> }
          box { <-20, -15, -1.2> <-14, 56.2, 9.2> }
          difference {
            box { <-18, 56, 0.5> <-15.2, 60, 7.5> }
            box { <-18, 57.199999, 1.5> <-13, 61, 0.5> }
            box { <-18, 57.199999, 6.5> <-13, 61, 7.5> }
            box { <-18, 57.199998, 3.1> <-13, 58.200001, 4.9> }
            cylinder { -18*x, -13*x, 1 translate <0, 57.2, 0.5> }
            cylinder { -18*x, -13*x, 1 translate <0, 57.2, 7.5> }
            cylinder { -17.700001*x, -14*x, 0.9 translate <0, 58.2, 4> }
          }
        }
        texture { color_tex }
      }
      merge {
        difference {
          merge {
            box { <-1.4, -4.5, -6.2> <1.4, -19.5, 6.2> }
            box { <1.399999, -19.500002, -3.8> <3.2, 4.6, 3.8> }
            box { <1.399998, 3.2, -3.800001> <9.6, 4.600001, 3.800001> }
            #if (setting > 3)
              object { llogo() translate <6.05, 4.6, 0> }
            #end
            box { <8.1, 4.5, -3.800002> <9.600001, 7.5, 3.800002> }
            box { <-3.1, -4.500001, -4.65> <-1.3, -19.500001, 4.65> }
            box { <-4.5, -7.6, -15.75> <-3, -4.500002, 15.75> }
            box { <-4.5, -18.7, -15.75> <-3, -15.6, 15.75> }
            box { <-6.1, -19.7, -14.25> <-4.4, 4, -8.25> }
            box { <-6.100001, 3, -13.75> <-4.400001, 4.5, -8.75> }
            cylinder { -6.100002*x, -4.400005*x, 0.5 translate <0, 4, -13.75> }
            cylinder { -6.100002*x, -4.400005*x, 0.5 translate <0, 4, -8.75> }
            box { <-6.1, -19.7, 14.25> <-4.4, 4, 8.25> }
            box { <-6.100001, 3, 13.75> <-4.400001, 4.5, 8.75> }
            cylinder { -6.100002*x, -4.400005*x, 0.5 translate <0, 4, 13.75> }
            cylinder { -6.100002*x, -4.400005*x, 0.5 translate <0, 4, 8.75> }
            box { <-6.100005, -20.5, -14.250003> <-3.000005, -18.699999, 14.250002> }
            box { <0.600006, -4.500001, -3.800005> <1.5, -1.5, 3.800005> }
            cylinder { 0.6*x, 1.5*x, 1.5 translate <0, -1.5, -2.3> }
            cylinder { 0.6*x, 1.5*x, 1.5 translate <0, -1.5, 2.3> }
            merge {
              box { <-31, 0, -14.250001> <1, 1.5, -8.250001> }
              box { <-32, 0.000001, -13.250001> <-30, 1.500001, -9.250001> }
              cylinder { 0.000002*y, 1.500002*y, 1 translate <-31, 0, -13.25> }
              cylinder { 0.000002*y, 1.500002*y, 1 translate <-31, 0, -9.25> }
              box { <-31, 0, 14.250001> <1, 1.5, 8.250001> }
              box { <-32, 0.000001, 13.250001> <-30, 1.500001, 9.250001> }
              cylinder { 0.000002*y, 1.500002*y, 1 translate <-31, 0, 13.25> }
              cylinder { 0.000002*y, 1.500002*y, 1 translate <-31, 0, 9.25> }
              difference {
                box { <0, 0.000005, 0> <1.5, 1.500005, 1.5> }
                cylinder { -1*y, 2*y, 1.5 }
                translate <-1.499999, 0, 6.749999>
              }
              difference {
                box { <0, 0.000005, 0> <1.5, 1.500005, -1.5> }
                cylinder { -1*y, 2*y, 1.5 }
                translate <-1.499999, 0, -6.749999>
              }
              rotate -2*z
              translate <-6.1, -20.5, 0>
            }
          }
          #if (setting > 1)
            cylinder { 3*y, 5*y, 0.5 translate <4, 0, 0> }
            difference {
              box { <-3.100001, -20, -2.25> <1.5, 0, 2.25> }
              box { <-10, -21, -3> <-1.399999, -18, 3> }
              merge {
                box { <0, -1, -1> <4, 0, 1> }
                box { <-1.5, -1.5, -1.000001> <0, 0, 1.000001> rotate 25*z translate <4, 0, 0> }
                rotate -25*z translate <-3, -15.6, 0>
              }
            }
            difference {
              box { <1.499999, -20, -4> <5, -18.2, 4> }
              cylinder { 1*x, 6*x, 1.5 translate <0, -18.2, -3.8> }
              cylinder { 1*x, 6*x, 1.5 translate <0, -18.2, 3.8> }
            }
            box { <1.499999, -13, -2.300001> <5, -18.3, 2.300001> }
          #end
          difference {
            box { <8.1, 2.25, -10> <10, 7.75, -2.3> }
            cylinder { 2*y, 8*y, 1.5 translate <8.1, 0, -2.3> }
          }
          difference {
            box { <8.1, 2.25, 10> <10, 7.75, 2.3> }
            cylinder { 2*y, 8*y, 1.5 translate <8.1, 0, 2.3> }
          }
        }
        texture { color2_tex }
        translate <-14.85, 57.2-dist, 4>
      }
    }
  #end
#end
#macro fpblock1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      cylinder { -11.9*z, 3.9*z, 1.5 translate <-6.5, 0.7, 0> }
      cylinder { -11.9*z, 3.9*z, 1.5 translate <14.5, 0.7, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          box { <-6, 0.1, -3.899999> <14, 1.3, 3.899999> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
          #end
          cylinder { -11.75*z, 3.9*z, 1.5 translate <-6.5, 0.7, 0> }
          cylinder { -11.75*z, 3.9*z, 1.5 translate <14.5, 0.7, 0> }
          torus { 1.35, 0.15 rotate 90*x translate <-6.5, 0.7, -11.75> }
          torus { 1.35, 0.15 rotate 90*x translate <14.5, 0.7, -11.75> }
          cylinder { -11.9*z, -10*z, 1.35 translate <-6.5, 0.7, 0> }
          cylinder { -11.9*z, -10*z, 1.35 translate <14.5, 0.7, 0> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 2.1*y, 1.5 translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-8.1, -0.9, -12> <16.1, 4.9, 4> } }
    }
  #end
#end
#macro frames_piece(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      box { <44.1, 6.4, -3.9> <51.9, 9.5, 11.9> }
      cylinder { <3.900002, 1.55, -6.500003> <47.900002, 7.950001, -6.500003> 1.5 }
      cylinder { <3.900002, 1.55, 14.500003> <47.900002, 7.950001, 14.500003> 1.5 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
          box { <44.1, 6.4, -3.9> <51.9, 9.5, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <48, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <48, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <48, 6.4, 0> }
            object { rounded_button() translate <48, 6.4, 8> }
          #end
        }
        #if (setting > 1)
          box { <45.6, 5, -2.4> <50.4, 8.6, 10.4> }
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <48, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <48, 0, 8> }
        #end
      }
      object { pin(1) translate <48, 6.4, 4> }
      object { ring() translate <4, 0, 4> }
      cylinder { 4*x, 11.9*x, 1.5 translate <0, 1.55, -6.5> }
      box { <4.000001, 1.1, -6.5> <11.900001, 2, -3.5> }
      sphere { <11.899999, 1.550001, -6.500001> 1.500001 }
      cylinder { 4*x, 11.9*x, 1.5 translate <0, 1.55, 14.5> }
      box { <4.000001, 1.1, 11.5> <11.900001, 2, 14.5> }
      sphere { <11.899999, 1.550001, 14.500001> 1.500001 }
      cylinder { 43.9*x, 59.75*x, 1.5 translate <0, 7.95, -6.5> }
      cylinder { 43.9*x, 59.75*x, 1.5 translate <0, 7.95, 14.5> }
      cylinder { 50*x, 59.9*x, 1.35 translate <0, 7.95, -6.5> }
      cylinder { 50*x, 59.9*x, 1.35 translate <0, 7.95, 14.5> }
      torus { 1.35, 0.15 rotate 90*z translate <59.75, 7.95, -6.5> }
      torus { 1.35, 0.15 rotate 90*z translate <59.75, 7.95, 14.5> }
      sphere { <43.899999, 7.950001, -6.500001> 1.500001 }
      sphere { <43.899999, 7.950001, 14.500001> 1.500001 }
      box { <43.900001, 7.5, -6.5> <59.900001, 8.4, -3.5> }
      box { <43.900001, 7.5, 11.5> <59.900001, 8.4, 14.5> }
      cylinder { <11.900002, 1.55, -6.500003> <43.900002, 7.950001, -6.500003> 1.5 }
      cylinder { <11.900002, 1.55, 14.500003> <43.900002, 7.950001, 14.500003> 1.5 }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -8.1> <60, 11.3, 16.1> } }
    }
  #end
#end
#macro frblock1_1(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 3.1*y, 3.9 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { 2.2*y, 3.1*y, 3.9 }
        cylinder { 0*y, 2.3*y, 3.15 }
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 }
        #else
          object { rounded_button() }
        #end
      }
      #if (setting > 1)
        cylinder { -1*y, 2*y, 2.5 }
        cylinder { 1*y, 4*y, 1.2 }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 4.9, 4> } }
    }
  #end
#end
#macro frblock1_5(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <35.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-0.000001, -0.000001, -3.900001> <32.000001, 3.100001, 3.900001> }
          cylinder { 0*y, 3.1*y, 3.9 }
          cylinder { 0*y, 3.1*y, 3.9 translate <32, 0, 0> }
        }
        #if (setting > 1)
          cylinder { -1*y, 2*y, 2.40001 }
          cylinder { -1*y, 2*y, 2.40001 translate <32, 0, 0> }
          difference {
            box { <0, -1, -2.4> <32, 2, 2.4> }
            box { <10.4, -2, -3> <11.6, 3, 3> }
            box { <20.4, -2, -3> <21.4, 3, 3> }
            cylinder { -2*y, 3*y, 3.5 translate <16, 0, 0> }
          }
          object { axle_opening(5,1) rotate 90*z translate <16, -1, 0> }
          box { <12.5, -1, -0.5> <19.5, 4, 0.5> }
          cylinder { -1*y, 4*y, 0.5 translate <12.5, 0, 0> }
          cylinder { -1*y, 4*y, 0.5 translate <19.5, 0, 0> }
        #end
      }
      object { open_rounded_button() translate <0, 0, 0> }
      object { open_rounded_button() translate <8, 0, 0> }
      object { open_rounded_button() translate <32, 0, 0> }
      object { open_rounded_button() translate <24, 0, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <24, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <32, 3.1, 0> }
      #end
      object { pin(2) translate <4, 0, 0> }
      object { pin(2) translate <28, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <36, 4.9, 4> } }
    }
  #end
#end
#macro frblock2_2(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 3.1*y, 7.8 translate <4, 0, 4> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          intersection {
            cylinder { 2*y, 5*y, 7.800001 translate <4, 0, 4> }
            #if (setting < 3)
              merge {
                cylinder { 3*y, 4.8*y, 2.4 }
                cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
                cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
                cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
              }
            #else
              merge {
                object { rounded_button() }
                object { rounded_button() translate <8, 0, 0> }
                object { rounded_button() translate <0, 0, 8> }
                object { rounded_button() translate <8, 0, 8> }
              }
            #end
          }
          cylinder { 0*y, 3.1*y, 7.8 translate <4, 0, 4> }
        }
        #if (setting > 0)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          object { axle_opening(6,1) rotate 90*z translate <4, -1, 4> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 4.9, 12> } }
    }
  #end
#end
#macro frblock3_3(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <19.9, 3.1, 3.9> }
      box { <-3.900001, 0.000001, 3.899999> <3.900001, 3.100002, 19.9> }
      intersection {
        cylinder { -0.000001*y, 3.100001*y, 16.000001 translate <3.9, 0, 3.899999> }
        box { <3.9, -1, 3.9> <20, 4, 20> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 3.1, 3.9> }
          box { <-3.900001, 0.000001, 3.899999> <3.900001, 3.100002, 19.9> }
          intersection {
            cylinder { -0.000001*y, 3.100001*y, 16.000001 translate <3.9, 0, 3.899999> }
            box { <3.9, -1, 3.9> <20, 4, 20> }
          }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <0, 0, 16> }
            object { rounded_button() translate <8, 0, 16> }
          #end
        }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
        #end
        box { <-2.75, -1, -4> <2.75, 2, 4> rotate 45*y translate <16, 0, 16> }
        box { <-2.4, -1, -2.4> <8.000001, 2, 18.4> }
        box { <-2.400001, -1, -2.400001> <18.4, 2.000002, 8.000001> }
        box { <8, -1, 8> <16.4, 2.000003, 16.4> }
        cylinder { -1*y, 2.000001*y, 2.400001 translate <8, 0, 16> }
        cylinder { -1*y, 2.000001*y, 2.400001 translate <16, 0, 8> }
      }
      object { ring() translate <4, 0, 4> }
      object { ring() translate <4, 0, 12> }
      object { ring() translate <12, 0, 12> }
      object { ring() translate <12, 0, 4> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 4.9, 20> } }
    }
  #end
#end
#macro frblock4_4(color_tex)
  #if (setting = 0)
    intersection {
      box { <-3.9, 0, -3.9> <27.9, 3.100001, 27.9> }
      cylinder { -1*y, 4*y, 31.8 translate <-3.9, 0, -3.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          intersection {
            box { <-3.9, 0, -3.9> <27.9, 3.100001, 27.9> }
            cylinder { -1*y, 4*y, 31.8 translate <-3.9, 0, -3.9> }
          }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
            object { rounded_button() rotate 90*y translate <16, 0, 0> }
            object { rounded_button() rotate 90*y translate <24, 0, 0> }
            object { rounded_button() rotate 90*y translate <0, 0, 8> }
            object { rounded_button() rotate 90*y translate <8, 0, 8> }
            object { rounded_button() rotate 90*y translate <16, 0, 8> }
            object { rounded_button() rotate 90*y translate <0, 0, 16> }
            object { rounded_button() rotate 90*y translate <8, 0, 16> }
            object { rounded_button() rotate 90*y translate <16, 0, 16> }
            object { rounded_button() rotate 90*y translate <0, 0, 24> }
          #end
        }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          intersection {
            box { <-2.4, -1, -2.4> <26.4, 2, 26.4> }
            cylinder { -1*y, 4*y, 30.3 translate <-3.9, 0, -3.9> }
          }
          cylinder { -1*y, 2.000001*y, 2.400001 translate <0, 0, 24> }
          cylinder { -1*y, 2.000001*y, 2.400001 translate <24, 0, 0> }
          cylinder { -1*y, 2.000001*y, 2.400001 translate <16, 0, 16> }
        #end
        box { <10, -1, -2.5> <30, 2.000001, 2.5> rotate -71*y }
        box { <10, -1, -2.5> <30, 2.000001, 2.5> rotate -19*y }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        intersection {
          object { ring() }
          box { <-3, -1, -3> <0, 3, 0> }
          translate <12, 0, 20>
        }
        intersection {
          object { ring() }
          box { <-3, -1, -3> <0, 3, 0> }
          translate <20, 0, 12>
        }
        box { <0, 0.000004, 0> <4, 2.1, 0.6> rotate -21*y translate <20, 0, 8.9> }
        box { <-0.25, 0.000004, 0> <5, 2.1, 0.6> rotate -25*y translate <12, 0, 17.1> }
        box { <-0.25, 0.000004, -0.6> <5, 2.1, 0> rotate -65*y translate <17.1, 0, 12> }
        box { <0, 0.000004, -0.6> <4, 2.1, 0> rotate -69*y translate <8.9, 0, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 4.9, 28> } }
    }
  #end
#end
#macro frblock6_6(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <43.9, 3.1, 11.9> }
      box { <-3.900001, 0.000001, 3.899999> <11.900001, 3.100002, 43.9> }
      intersection {
        cylinder { -0.000001*y, 3.100001*y, 32.000001 translate <11.9, 0, 11.899999> }
        box { <3.9, -1, 3.9> <44, 4, 44> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 11.9> }
          box { <-3.900001, 0.000001, 3.899999> <11.900001, 3.100002, 43.9> }
          intersection {
            cylinder { -0.000001*y, 3.100001*y, 32.000001 translate <11.9, 0, 11.899999> }
            box { <3.9, -1, 3.9> <44, 4, 44> }
          }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 40> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <32, 0, 0> }
            object { rounded_button() translate <40, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <24, 0, 8> }
            object { rounded_button() translate <32, 0, 8> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() translate <0, 0, 16> }
            object { rounded_button() translate <8, 0, 16> }
            object { rounded_button() translate <16, 0, 16> }
            object { rounded_button() translate <24, 0, 16> }
            object { rounded_button() translate <32, 0, 16> }
            object { rounded_button() translate <40, 0, 16> }
            object { rounded_button() translate <0, 0, 24> }
            object { rounded_button() translate <8, 0, 24> }
            object { rounded_button() translate <16, 0, 24> }
            object { rounded_button() translate <24, 0, 24> }
            object { rounded_button() translate <32, 0, 24> }
            object { rounded_button() translate <0, 0, 32> }
            object { rounded_button() translate <8, 0, 32> }
            object { rounded_button() translate <16, 0, 32> }
            object { rounded_button() translate <24, 0, 32> }
            object { rounded_button() translate <32, 0, 32> }
            object { rounded_button() translate <0, 0, 40> }
            object { rounded_button() translate <8, 0, 40> }
            object { rounded_button() translate <16, 0, 40> }
          #end
        }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 40> }
          box { <-2.4, -1, -2.4> <16.000001, 2, 42.4> }
          box { <-2.400001, -1, -2.400001> <42.4, 2.000002, 16.000001> }
          intersection {
            cylinder { -1*y, 2*y, 30.5 translate <11.9, 0, 11.9> }
            box { <2.4, -2, 2.4> <42.4, 3, 42.4> }
          }
          cylinder { -1*y, 2.000001*y, 2.500001 translate <40, 0, 16> }
          cylinder { -1*y, 2.000001*y, 2.500001 translate <32, 0, 32> }
          cylinder { -1*y, 2.000001*y, 2.500001 translate <16, 0, 40> }
        #end
        box { <-2.75, -1, -4> <2.75, 2, 4> rotate 67.5*y translate <40, 0, 24> }
        box { <-2.75, -1, -4> <2.75, 2, 4> rotate 22.5*y translate <24, 0, 40> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <36, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <28, 0, 12> }
        object { ring() translate <36, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 20> }
        object { ring() translate <28, 0, 20> }
        object { ring() translate <36, 0, 20> }
        object { ring() translate <4, 0, 28> }
        object { ring() translate <12, 0, 28> }
        object { ring() translate <20, 0, 28> }
        object { ring() translate <28, 0, 28> }
        object { ring() translate <4, 0, 36> }
        object { ring() translate <12, 0, 36> }
        object { ring() translate <20, 0, 36> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 4.9, 44> } }
    }
  #end
#end
#macro frclaw1_1(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 3.1, 3.9> }
      cylinder { -1.55*z, 1.55*z, 3 translate <8, 2.5, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <3.9, 3.1, 3.9> }
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 }
        #else
          object { rounded_button() rotate 180*y }
        #end
        box { <8, -0.500001, -1.550001> <9.6, 5.500001, 1.550001> }
        box { <3, 0.000001, -1.549999> <8.1, 3.099999, 1.549999> }
        cylinder { -1.55*z, 1.55*z, 3 translate <8, 2.5, 0> }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
        cylinder { 1*y, 4*y, 1.2 }
      #end
      box { <8, 1, -2> <10, 4, 2> }
      box { <9.600001, 0, -2> <15, 10, 2> }
      cylinder { -4*z, 4*z, 1.6 translate <8, 2.5, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.6, -4> <9.7, 5.6, 4> } }
    }
  #end
#end
#macro fsblock1_2(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          #if (setting < 3)
            difference {
              cylinder { 3*y, 4.8*y, 2.3 }
              cylinder { 2.9*y, 5*y, 1.6 }
              translate <4, 0, 0>
            }
          #else
            object { open_rounded_button() translate <4, 0, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <4, 3.1, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
        #end
      }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 4.9, 4> } }
    }
  #end
#end
#macro fswheelbase2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      cylinder { -3.900001*z, 11.900001*z, 3.75 translate <4, -0.8, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
          object { open_rounded_button() }
          object { open_rounded_button() translate <8, 0, 0> }
          object { open_rounded_button() translate <0, 0, 8> }
          object { open_rounded_button() translate <8, 0, 8> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> translate <0, 3.1, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <0, 3.1, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 8> }
          #end
          cylinder { -3.900001*z, 3*z, 3.75 translate <4, -0.8, 0> }
          box { <0.250001, -0.800001, -3.900002> <7.750001, 2.1, 3.000001> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
            box { <0.250002, -2, -3.900003> <7.750002, 2.1, 2.999999> }
          }
        #end
        cylinder { -5*z, 4*z, 2.5 translate <4, -0.8, 0> }
        cylinder { -5*z, -3.4*z, 3.1 translate <4, -0.8, 0> }
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 8> }
        cylinder { 0.1*y, 2.1*y, 0.6 translate <1, 0, 5> }
        box { <-2.6, 0.100001, 4.400001> <1.000001, 2.1, 5.600001> }
        cylinder { 0.1*y, 2.1*y, 0.6 translate <7, 0, 5> }
        box { <6.99999, 0.100001, 4.400001> <10.6, 2.1, 5.600001> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -4.65, -4> <12, 4.9, 12> } }
    }
  #end
#end
#macro fvclaw1_1(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 3.1, 3.9> }
      box { <-3.899999, 0.000001, -1.55> <3.899999, 7.2, 1.55> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <3.9, 3.1, 3.9> }
        difference {
          box { <-3.899999, 0.000001, -1.550001> <3.899999, 7.2, 1.550001> }
          box { <-10, 0, -10> <0, 10, 10> rotate -8.5*z translate <-3.9, 3.1, 0> }
          box { <0, 0, -10> <10, 10, 10> rotate 8.5*z translate <3.9, 3.1, 0> }
        }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
        cylinder { -2*z, 2*z, 1.6 translate <0, 5.6, 0> }
        box { <-1.4, 5.6, -2> <1.4, 8, 2> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 7.3, 4> } }
    }
  #end
#end
#macro f_block1_1(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.9, 3.1, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <3.9, 3.1, 3.9> }
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 }
        #else
          object { rounded_button() }
        #end
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
        cylinder { 1*y, 4*y, 1.2 }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 4.9, 4> } }
    }
  #end
#end
#macro f_block1_10(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <75.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <75.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 0> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <32, 0, 0> }
            object { rounded_button() translate <40, 0, 0> }
            object { rounded_button() translate <48, 0, 0> }
            object { rounded_button() translate <56, 0, 0> }
            object { rounded_button() translate <64, 0, 0> }
            object { rounded_button() translate <72, 0, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <74.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
        object { pin(age) translate <12, 0, 0> }
        object { pin(age) translate <20, 0, 0> }
        object { pin(age) translate <28, 0, 0> }
        object { pin(age) translate <36, 0, 0> }
        object { pin(age) translate <44, 0, 0> }
        object { pin(age) translate <52, 0, 0> }
        object { pin(age) translate <60, 0, 0> }
        object { pin(age) translate <68, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 4.9, 4> } }
    }
  #end
#end
#macro f_block1_2(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 4.9, 4> } }
    }
  #end
#end
#macro f_block1_3(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <19.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <18.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
        object { pin(age) translate <12, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 4.9, 4> } }
    }
  #end
#end
#macro f_block1_4(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
        object { pin(age) translate <12, 0, 0> }
        object { pin(age) translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 4.9, 4> } }
    }
  #end
#end
#macro f_block1_6(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <32, 0, 0> }
            object { rounded_button() translate <40, 0, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <42.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
        object { pin(age) translate <12, 0, 0> }
        object { pin(age) translate <20, 0, 0> }
        object { pin(age) translate <28, 0, 0> }
        object { pin(age) translate <36, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 4.9, 4> } }
    }
  #end
#end
#macro f_block1_8(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <32, 0, 0> }
            object { rounded_button() translate <40, 0, 0> }
            object { rounded_button() translate <48, 0, 0> }
            object { rounded_button() translate <56, 0, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <58.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
        object { pin(age) translate <12, 0, 0> }
        object { pin(age) translate <20, 0, 0> }
        object { pin(age) translate <28, 0, 0> }
        object { pin(age) translate <36, 0, 0> }
        object { pin(age) translate <44, 0, 0> }
        object { pin(age) translate <52, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 4> } }
    }
  #end
#end
#macro f_block2_10(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <75.9, 3.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <75.9, 3.1, 11.9> }
          #if (setting < 3)
            #local counter = 0;
            #while (counter < 10)
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, 8> }
              #local counter = counter + 1;
            #end
          #else
            #local counter = 0;
            #while (counter < 10)
              object { rounded_button() translate <(counter*8), 0, 0> }
              object { rounded_button() translate <(counter*8), 0, 8> }
              #local counter = counter + 1;
            #end
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <74.4, 2, 10.4> }
          #local counter = 0;
          #while (counter < 10)
            cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, 8> }
            #local counter = counter + 1;
          #end
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <36, 0, 4> }
        object { ring() translate <44, 0, 4> }
        object { ring() translate <52, 0, 4> }
        object { ring() translate <60, 0, 4> }
        object { ring() translate <68, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 4.9, 12> } }
    }
  #end
#end
#macro f_block2_12(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <91.9, 3.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <91.9, 3.1, 11.9> }
          #if (setting < 3)
            #local counter = 0;
            #while (counter < 12)
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, 8> }
              #local counter = counter + 1;
            #end
          #else
            #local counter = 0;
            #while (counter < 12)
              object { rounded_button() translate <(counter*8), 0, 0> }
              object { rounded_button() translate <(counter*8), 0, 8> }
              #local counter = counter + 1;
            #end
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <90.4, 2, 10.4> }
          #local counter = 0;
          #while (counter < 12)
            cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, 8> }
            #local counter = counter + 1;
          #end
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <36, 0, 4> }
        object { ring() translate <44, 0, 4> }
        object { ring() translate <52, 0, 4> }
        object { ring() translate <60, 0, 4> }
        object { ring() translate <68, 0, 4> }
        object { ring() translate <76, 0, 4> }
        object { ring() translate <84, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <92, 4.9, 12> } }
    }
  #end
#end
#macro f_block2_16(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <123.9, 3.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <123.9, 3.1, 11.9> }
          #if (setting < 3)
            #local counter = 0;
            #while (counter < 16)
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, 8> }
              #local counter = counter + 1;
            #end
          #else
            #local counter = 0;
            #while (counter < 16)
              object { rounded_button() translate <(counter*8), 0, 0> }
              object { rounded_button() translate <(counter*8), 0, 8> }
              #local counter = counter + 1;
            #end
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <122.4, 2, 10.4> }
          #local counter = 0;
          #while (counter < 16)
            cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, 8> }
            #local counter = counter + 1;
          #end
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <36, 0, 4> }
        object { ring() translate <44, 0, 4> }
        object { ring() translate <52, 0, 4> }
        object { ring() translate <60, 0, 4> }
        object { ring() translate <68, 0, 4> }
        object { ring() translate <76, 0, 4> }
        object { ring() translate <84, 0, 4> }
        object { ring() translate <92, 0, 4> }
        object { ring() translate <100, 0, 4> }
        object { ring() translate <108, 0, 4> }
        object { ring() translate <116, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <124, 4.9, 12> } }
    }
  #end
#end
#macro f_block2_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.3 }
            cylinder { 3*y, 4.8*y, 2.3 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.3 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.3 translate <8, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 4.9, 12> } }
    }
  #end
#end
#macro f_block2_2_up(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <15.1, 3.1, 11.9> }
      box { <12, 3, 0.2> <15.100001, 34.9, 7.8> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <15.1, 3.1, 11.9> }
          difference {
            box { <12, 3, 0.2> <15.100001, 34.9, 7.8> }
            box { <11, 3.000001, 1.4> <14, 35, 6.6> }  
          }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
          #end
          object { open_rounded_button() rotate -90*z translate <12, 7.1, 4> }
          object { open_rounded_button() rotate -90*z translate <12, 15.1, 4> }
          object { open_rounded_button() rotate -90*z translate <12, 23.1, 4> }
          object { open_rounded_button() rotate -90*z translate <12, 31.1, 4> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z translate <15.1, 7.1, 4> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z translate <15.1, 15.1, 4> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z translate <15.1, 23.1, 4> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z translate <15.1, 31.1, 4> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          box { <11.9, -1, -2.4> <15.2, 2, 10.4> }
        #end
      }
      #if (setting > 1)
        box { <11.8, 0.000001, 3.5> <15.100002, 2.1, 4.5> }
        box { <13.9, 0.000002, 2.6> <15.100003, 2.1, 5.4> }
        object { ring() translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <16.9, 35, 12> } }
    }
  #end
#end
#macro f_block2_3(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <19.9, 3.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.3 }
            cylinder { 3*y, 4.8*y, 2.3 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.3 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.3 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.3 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.3 translate <16, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <16, 0, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <18.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 4.9, 12> } }
    }
  #end
#end
#macro f_block2_3_up(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <14.9, 3.1, 19.9> }
      box { <-0.7, 3, 4.1> <2.46, 27.9, 11.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 19.9> }
          box { <5.6, 3, 5.9> <8.6, 4.8, 10.1> }
          box { <-0.7, 3, 4.1> <2.4, 27.9, 11.9> }
          object { rounded_button() rotate -90*z translate <-0.6, 8.1, 8> }
          object { rounded_button() rotate -90*z translate <-0.6, 16.1, 8> }
          object { rounded_button() rotate -90*z translate <-0.6, 24.1, 8> }
        }
        box { <-4, 3.100002, 5.600001> <4, 5.2, 10.399999> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 18.4> }
          box { <-10, 3.100001, 5.6> <1.3, 26.4, 10.4> }
          cylinder { 0.3*x, 3.3*x, 1.2 translate <0, 8.1, 8> }
          cylinder { 0.3*x, 3.3*x, 1.2 translate <0, 16.1, 8> }
          cylinder { 0.3*x, 3.3*x, 1.2 translate <0, 24.1, 8> }
          box { <7.4, 0, 6.6> <8.6, 3.5, 9.4> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { pin(1) rotate -90*z translate <-0.7, 12.1, 8> }
        object { pin(1) rotate -90*z translate <-0.7, 20.1, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <16.7, 28, 20> } }
    }
  #end
#end
#macro f_block2_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.3 }
            cylinder { 3*y, 4.8*y, 2.3 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.3 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.3 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.3 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.3 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.3 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.3 translate <24, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <24, 0, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 4.9, 12> } }
    }
  #end
#end
#macro f_block2_6(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 3.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.3 }
            cylinder { 3*y, 4.8*y, 2.3 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.3 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.3 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.3 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.3 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.3 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.3 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.3 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.3 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.3 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.3 translate <40, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <32, 0, 0> }
            object { rounded_button() translate <40, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <24, 0, 8> }
            object { rounded_button() translate <32, 0, 8> }
            object { rounded_button() translate <40, 0, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <42.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <36, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 4.9, 12> } }
    }
  #end
#end
#macro f_block2_8(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 3.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 3.1, 11.9> }
          #if (setting < 3)
            #local counter = 0;
            #while (counter < 8)
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, 8> }
              #local counter = counter + 1;
            #end
          #else
            #local counter = 0;
            #while (counter < 8)
              object { rounded_button() translate <(counter*8), 0, 0> }
              object { rounded_button() translate <(counter*8), 0, 8> }
              #local counter = counter + 1;
            #end
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <58.4, 2, 10.4> }
          #local counter = 0;
          #while (counter < 8)
            cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, 8> }
            #local counter = counter + 1;
          #end
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <36, 0, 4> }
        object { ring() translate <44, 0, 4> }
        object { ring() translate <52, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 12> } }
    }
  #end
#end
#macro f_block4_10(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <75.9, 3.1, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <75.9, 3.1, 27.9> }
          #local teller = 0;
          #while ( teller < 4)
            #local counter = 0;
            #while (counter < 10)
              #if (setting < 3)
                cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, (teller*8)> }
              #else
                object { rounded_button() translate <(counter*8), 0, (teller*8)> }
              #end
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <74.4, 2, 26.4> }
          #local teller = 0;
          #while ( teller < 4)
            #local counter = 0;
            #while (counter < 10)
              cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 3)
          #local counter = 0;
          #while (counter < 9)
            object { ring() translate <4+(counter*8), 0, 4+(teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 4.9, 28> } }
    }
  #end
#end
#macro f_block4_12(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <91.9, 3.1, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <91.9, 3.1, 27.9> }
          #local teller = 0;
          #while ( teller < 4)
            #local counter = 0;
            #while (counter < 12)
              #if (setting < 3)
                cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, (teller*8)> }
              #else
                object { rounded_button() translate <(counter*8), 0, (teller*8)> }
              #end
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <90.4, 2, 26.4> }
          #local teller = 0;
          #while ( teller < 4)
            #local counter = 0;
            #while (counter < 12)
              cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 3)
          #local counter = 0;
          #while (counter < 11)
            object { ring() translate <4+(counter*8), 0, 4+(teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <92, 4.9, 28> } }
    }
  #end
#end
#macro f_block4_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <24, 0, 8> }
            object { rounded_button() translate <0, 0, 16> }
            object { rounded_button() translate <8, 0, 16> }
            object { rounded_button() translate <16, 0, 16> }
            object { rounded_button() translate <24, 0, 16> }
            object { rounded_button() translate <0, 0, 24> }
            object { rounded_button() translate <8, 0, 24> }
            object { rounded_button() translate <16, 0, 24> }
            object { rounded_button() translate <24, 0, 24> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 26.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 4.9, 28> } }
    }
  #end
#end
#macro f_block4_4mod(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
          #else
            object { rounded_button() rotate -90*y translate <0, 0, 24> }
            object { rounded_button() rotate -90*y translate <8, 0, 24> }
            object { rounded_button() rotate -90*y translate <16, 0, 24> }
            object { rounded_button() rotate -90*y translate <24, 0, 24> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 26.4> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 4.9, 28> } }
    }
  #end
#end
#macro f_block4_6(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 3.1, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 27.9> }
          #local teller = 0;
          #while ( teller < 4)
            #local counter = 0;
            #while (counter < 6)
              #if (setting < 3)
                cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, (teller*8)> }
              #else
                object { rounded_button() translate <(counter*8), 0, (teller*8)> }
              #end
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <42.4, 2, 26.4> }
          #local teller = 0;
          #while ( teller < 4)
            #local counter = 0;
            #while (counter < 6)
              cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 3)
          #local counter = 0;
          #while (counter < 5)
            object { ring() translate <4+(counter*8), 0, 4+(teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 4.9, 28> } }
    }
  #end
#end
#macro f_block4_6mod(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 3.1, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 27.9> }
          #local counter = 0;
          #while (counter < 6)
            #if (setting < 3)
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, 24> }
            #else
              object { rounded_button() rotate 180*y translate <(counter*8), 0, 24> }
            #end
            #local counter = counter + 1;
          #end
          object { rounded_button() rotate 180*y }
          object { rounded_button() rotate 180*y translate <0, 0, 8> }
          object { rounded_button() rotate 180*y translate <0, 0, 16> }
          object { rounded_button() rotate 180*y translate <40, 0, 0> }
          object { rounded_button() rotate 180*y translate <40, 0, 8> }
          object { rounded_button() rotate 180*y translate <40, 0, 16> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <42.4, 2, 26.4> }
          #local counter = 0;
          #while (counter < 6)
            cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, 24> }
            #local counter = counter + 1;
          #end
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 3)
          #local counter = 0;
          #while (counter < 5)
            object { ring() translate <4+(counter*8), 0, 4+(teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 4.9, 28> } }
    }
  #end
#end
#macro f_block4_8(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 3.1, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 3.1, 27.9> }
          #local teller = 0;
          #while ( teller < 4)
            #local counter = 0;
            #while (counter < 8)
              #if (setting < 3)
                cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, (teller*8)> }
              #else
                object { rounded_button() translate <(counter*8), 0, (teller*8)> }
              #end
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <58.4, 2, 26.4> }
          #local teller = 0;
          #while ( teller < 4)
            #local counter = 0;
            #while (counter < 8)
              cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 3)
          #local counter = 0;
          #while (counter < 7)
            object { ring() translate <4+(counter*8), 0, 4+(teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 28> } }
    }
  #end
#end
#macro f_block4_8mod(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 3.1, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 16> }
          #else
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <24, 0, 8> }
            object { rounded_button() translate <32, 0, 8> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() translate <48, 0, 8> }
            object { rounded_button() translate <8, 0, 16> }
            object { rounded_button() translate <16, 0, 16> }
            object { rounded_button() translate <24, 0, 16> }
            object { rounded_button() translate <32, 0, 16> }
            object { rounded_button() translate <40, 0, 16> }
            object { rounded_button() translate <48, 0, 16> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <58.4, 2, 26.4> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 16> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <36, 0, 4> }
        object { ring() translate <44, 0, 4> }
        object { ring() translate <52, 0, 4> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 20> }
        object { ring() translate <28, 0, 20> }
        object { ring() translate <36, 0, 20> }
        object { ring() translate <44, 0, 20> }
        object { ring() translate <52, 0, 20> }
        box { <-2.5, 0.25, 10.4> <58.5, 2.1, 11.2> }
        box { <-2.5, 0.25, 12.8> <58.5, 2.1, 13.6> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 28> } }
    }
  #end
#end
#macro f_block6_10(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <75.9, 3.1, 43.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <75.9, 3.1, 43.9> }
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 10)
              #if (setting < 3)
                cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, (teller*8)> }
              #else
                object { rounded_button() translate <(counter*8), 0, (teller*8)> }
              #end
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <74.4, 2, 42.4> }
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 10)
              cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 5)
          #local counter = 0;
          #while (counter < 9)
            object { ring() translate <4+(counter*8), 0, 4+(teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 4.9, 44> } }
    }
  #end
#end
#macro f_block6_12(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <91.9, 3.1, 43.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <91.9, 3.1, 43.9> }
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 12)
              #if (setting < 3)
                cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, (teller*8)> }
              #else
                object { rounded_button() translate <(counter*8), 0, (teller*8)> }
              #end
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <90.4, 2, 42.4> }
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 12)
              cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 5)
          #local counter = 0;
          #while (counter < 11)
            object { ring() translate <4+(counter*8), 0, 4+(teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <92, 4.9, 44> } }
    }
  #end
#end
#macro f_block6_12mod(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <91.9, 3.1, 43.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <91.9, 3.1, 43.9> }
          #local counter = 0;
          #while (counter < 12)
            #if (setting < 3)
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, 40> }
            #else
              object { rounded_button() translate <(counter*8), 0, 40> }
            #end
            #local counter = counter + 1;
          #end
          object { rounded_button() translate <0, 0, 0> }
          object { rounded_button() translate <0, 0, 8> }
          object { rounded_button() translate <0, 0, 16> }
          object { rounded_button() translate <0, 0, 24> }
          object { rounded_button() translate <0, 0, 32> }
          object { rounded_button() translate <88, 0, 0> }
          object { rounded_button() translate <88, 0, 8> }
          object { rounded_button() translate <88, 0, 16> }
          object { rounded_button() translate <88, 0, 24> }
          object { rounded_button() translate <88, 0, 32> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <90.4, 2, 42.4> }
          #local counter = 0;
          #while (counter < 12)
            cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, 40> }
            #local counter = counter + 1;
          #end
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 5)
          #local counter = 0;
          #while (counter < 11)
            object { ring() translate <4+(counter*8), 0, 4+(teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <92, 4.9, 44> } }
    }
  #end
#end
#macro f_block6_14(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <107.9, 3.1, 43.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <107.9, 3.1, 43.9> }
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 14)
              #if (setting < 3)
                cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, (teller*8)> }
              #else
                object { rounded_button() translate <(counter*8), 0, (teller*8)> }
              #end
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <106.4, 2, 42.4> }
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 14)
              cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 5)
          #local counter = 0;
          #while (counter < 13)
            object { ring() translate <4+(counter*8), 0, 4+(teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <108, 4.9, 44> } }
    }
  #end
#end
#macro f_block6_16(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <123.9, 3.1, 43.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <123.9, 3.1, 43.9> }
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 16)
              #if (setting < 3)
                cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, (teller*8)> }
              #else
                object { rounded_button() translate <(counter*8), 0, (teller*8)> }
              #end
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <122.4, 2, 42.4> }
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 16)
              cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 5)
          #local counter = 0;
          #while (counter < 15)
            object { ring() translate <4+(counter*8), 0, 4+(teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <124, 4.9, 44> } }
    }
  #end
#end
#macro f_block6_24(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <187.9, 3.1, 43.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <187.9, 3.1, 43.9> }
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 24)
              #if (setting < 3)
                cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, (teller*8)> }
              #else
                object { rounded_button() translate <(counter*8), 0, (teller*8)> }
              #end
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <186.4, 2, 42.4> }
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 24)
              cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 5)
          #local counter = 0;
          #while (counter < 23)
            object { ring() translate <4+(counter*8), 0, 4+(teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <188, 4.9, 44> } }
    }
  #end
#end
#macro f_block6_6(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 3.1, 43.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 43.9> }
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 6)
              #if (setting < 3)
                cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, (teller*8)> }
              #else
                object { rounded_button() translate <(counter*8), 0, (teller*8)> }
              #end
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <42.4, 2, 42.4> }
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 6)
              cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 5)
          #local counter = 0;
          #while (counter < 5)
            object { ring() translate <4+(counter*8), 0, 4+(teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 4.9, 44> } }
    }
  #end
#end
#macro f_block6_8(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 3.1, 43.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 3.1, 43.9> }
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 8)
              #if (setting < 3)
                cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, (teller*8)> }
              #else
                object { rounded_button() translate <(counter*8), 0, (teller*8)> }
              #end
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <58.4, 2, 42.4> }
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 8)
              cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 5)
          #local counter = 0;
          #while (counter < 7)
            object { ring() translate <4+(counter*8), 0, 4+(teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 44> } }
    }
  #end
#end
#macro f_block8_8(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 3.1, 59.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 3.1, 59.9> }
          #local teller = 0;
          #while ( teller < 8)
            #local counter = 0;
            #while (counter < 8)
              #if (setting < 3)
                cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, (teller*8)> }
              #else
                object { rounded_button() translate <(counter*8), 0, (teller*8)> }
              #end
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <58.4, 2, 58.4> }
          #local teller = 0;
          #while ( teller < 8)
            #local counter = 0;
            #while (counter < 8)
              cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 7)
          #local counter = 0;
          #while (counter < 7)
            object { ring() translate <4+(counter*8), 0, 4+(teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 60> } }
    }
  #end
#end
#macro f_car_bottom(color_tex)
  #if (setting = 0)
    merge {
      difference {
        box { <-3.9, 0, -3.9> <75.9, 3.1, 27.9> }
        box { <3.9, -1, -4> <20.1, 4, 4.1> }
        box { <3.9, -1, 19.9> <20.1, 4, 28> }
        box { <51.9, -1, -4> <68.1, 4, 4.1> }
        box { <51.9, -1, 19.9> <68.1, 4, 28> }
      }
      box { <20.100001, -3.9, 4.100001> <51.899999, 0.1, 19.900001> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          merge {
            box { <-3.9, 0, -3.9> <75.9, 3.1, 27.9> }
            box { <20.100001, -3.9, 4.100001> <51.899999, 0.1, 19.900001> }
            #if (setting < 3)
              cylinder { 3*y, 4.8*y, 2.4 }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
              cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
              cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 24> }
              cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 24> }
              cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 24> }
            #else
              object { rounded_button() }
              object { rounded_button() translate <0, 0, 24> }
              object { rounded_button() translate <0, 0, 8> }
              object { rounded_button() translate <8, 0, 8> }
              object { rounded_button() translate <16, 0, 8> }
              object { rounded_button() translate <24, 0, 8> }
              object { rounded_button() translate <0, 0, 16> }
              object { rounded_button() translate <8, 0, 16> }
              object { rounded_button() translate <16, 0, 16> }
              object { rounded_button() translate <24, 0, 16> }
              object { rounded_button() translate <24, 0, 0> }
              object { rounded_button() translate <32, 0, 0> }
              object { rounded_button() translate <40, 0, 0> }
              object { rounded_button() translate <48, 0, 0> }
              object { rounded_button() translate <24, 0, 24> }
              object { rounded_button() translate <32, 0, 24> }
              object { rounded_button() translate <40, 0, 24> }
              object { rounded_button() translate <48, 0, 24> }
              object { rounded_button() translate <48, 0, 8> }
              object { rounded_button() translate <56, 0, 8> }
              object { rounded_button() translate <64, 0, 8> }
              object { rounded_button() translate <72, 0, 8> }
              object { rounded_button() translate <48, 0, 16> }
              object { rounded_button() translate <56, 0, 16> }
              object { rounded_button() translate <64, 0, 16> }
              object { rounded_button() translate <72, 0, 16> }
              object { rounded_button() translate <72, 0, 0> }
              object { rounded_button() translate <72, 0, 24> }
            #end
          }
          box { <3.9, -1, -4> <20.1, 4, 4.1> }
          box { <3.9, -1, 19.9> <20.1, 4, 28> }
          box { <51.9, -1, -4> <68.1, 4, 4.1> }
          box { <51.9, -1, 19.9> <68.1, 4, 28> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <2.4, 2, 26.4> }
            box { <0, -1, 5.6> <20.1, 2.000001, 18.4> }
            difference {
              box { <21.6, -1, -2.4> <50.4, 2, 26.4> }
              box { <26.6, -2, 2.4> <45.4, 3, 21.6> }
              box { <21, -2, 4.1> <51, 3, 19.9> }
              box { <23.5, -2, 2.5> <24.5, 3, 4> }
              box { <23.5, -2, 20> <24.5, 3, 21.5> }
              box { <47.5, -2, 2.5> <48.5, 3, 4> }
              box { <47.5, -2, 20> <48.5, 3, 21.5> }
            }
            box { <51.9, -1, 5.6> <74, 2.000001, 18.4> }
            box { <69.6, -1, -2.4> <74.4, 2, 26.4> }
            box { <21.6, -5, 5.6> <26.4, 2, 18.4> }
            box { <45.6, -5, 5.6> <50.4, 2, 18.4> }
            cylinder { 1*y, 4*y, 1.2 }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
            cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
            cylinder { 1*y, 4*y, 1.2 translate <40, 0, 24> }
            cylinder { 1*y, 4*y, 1.2 translate <48, 0, 24> }
            cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <64, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <72, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <48, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <56, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <64, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <72, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <72, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <72, 0, 24> }
          #end
          box { <27.9, -3.2, 3.9> <44.1, 4, 20.1> }
          box { <0, 0, 3.900001> <2, 3.5, 20.100001> rotate 22*z translate <27.9, 0, 0> }
          box { <-2, 0, 3.900001> <0, 3.5, 20.100001> rotate -22*z translate <44.1, 0, 0> }
        }
        #if (setting > 1)
          box { <15, 0.000001, 11.5> <20.2, 2.2, 12.5> }
          box { <18.6, 0.000001, 7.5> <20.2, 2.2, 8.5> }
          box { <18.6, 0.000001, 15.5> <20.2, 2.2, 16.5> }
          box { <51.8, 0.000001, 11.5> <57, 2.2, 12.5> }
          box { <51.8, 0.000001, 7.5> <53.4, 2.2, 8.5> }
          box { <51.8, 0.000001, 15.5> <53.4, 2.2, 16.5> }
          object { pin(1) translate <0, 0, 4> }
          object { pin(1) translate <0, 0, 20> }
          object { ring() translate <4, 0, 12> }
          object { ring() translate <12, 0, 12> }
          object { pin(1) translate <28, 0, 0> }
          object { pin(1) translate <36, 0, 0> }
          object { pin(1) translate <44, 0, 0> }
          object { pin(1) translate <28, 0, 24> }
          object { pin(1) translate <36, 0, 24> }
          object { pin(1) translate <44, 0, 24> }
          object { ring() translate <60, 0, 12> }
          object { ring() translate <68, 0, 12> }
          object { pin(1) translate <72, 0, 4> }
          object { pin(1) translate <72, 0, 20> }
          cylinder { -3.9*y, 2.1*y, 1.5 translate <24, 0, 12> }
          cylinder { -3.9*y, 2.1*y, 1.5 translate <48, 0, 12> }
        #end
        cylinder { -3.3*y, -1.5*y, 2.3 translate <32, 0, 8> }
        cylinder { -3.3*y, -1.5*y, 2.3 translate <32, 0, 16> }
        cylinder { -3.3*y, -1.5*y, 2.3 translate <40, 0, 8> }
        cylinder { -3.3*y, -1.5*y, 2.3 translate <40, 0, 16> }
      }
      #if (setting > 1)
        cylinder { -5.4*y, -2.4*y, 1.2 translate <32, 0, 8> }
        cylinder { -5.4*y, -2.4*y, 1.2 translate <32, 0, 16> }
        cylinder { -5.4*y, -2.4*y, 1.2 translate <40, 0, 8> }
        cylinder { -5.4*y, -2.4*y, 1.2 translate <40, 0, 16> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -4, -4> <76, 4.9, 28> } }
    }
  #end
#end
#macro f_car_bottom2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <75.9, 3.1, 27.9> }
      box { <12.100001, -4.2, 4.100001> <59.899999, 0.1, 19.900001> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          merge {
            box { <-3.9, 0, -3.9> <75.9, 3.1, 27.9> }
            box { <12.100001, -4.2, 4.100001> <59.899999, 0.1, 19.900001> }
          }
          box { <-4, -1, -4> <12.1, 4, 4.1> }
          box { <-4, -1, 19.9> <12.1, 4, 28> }
          box { <59.9, -1, -4> <80, 4, 4.1> }
          box { <59.9, -1, 19.9> <80, 4, 28> }
          #if (setting > 1)
            difference {
              box { <13.6, -1, -2.4> <58.4, 2, 26.4> }
              box { <18.4, -2, 2.4> <53.6, 4, 21.6> }
              box { <13, -2, 4.1> <59, 4, 19.9> }
              box { <15.5, -2, 2.5> <16.5, 4, 4> }
              box { <15.5, -2, 20> <16.5, 4, 21.5> }
              box { <55.5, -2, 2.5> <56.5, 4, 4> }
              box { <55.5, -2, 20> <56.5, 4, 21.5> }
            }
            box { <-2.4, -1, 5.6> <12, 2, 18.4> }
            box { <60, -1, 5.6> <74.4, 2, 18.4> }
            box { <13.6, -5, 5.6> <18.4, 2, 18.4> }
            box { <53.6, -5, 5.6> <58.4, 2, 18.4> }
          #end
          box { <19.9, -3.2, 3.9> <52.1, 4, 20.1> }
          box { <-10, -4, 3.900001> <10, 0, 20.100001> rotate -8*z translate <13.6, -3.2, 0> }
          box { <-10, -4, 3.900001> <10, 0, 20.100001> rotate 8*z translate <58.4, -3.2, 0> }
          box { <0, 0, 3.900002> <2, 4, 20.100002> rotate 20*z translate <19.9, 0, 0> }
          box { <-2, 0, 3.900002> <0, 4, 20.100002> rotate -20*z translate <52.1, 0, 0> }
        }
        box { <7, 0.000001, 11.5> <12.2, 2.1, 12.5> }
        box { <10.6, 0.000001, 7.5> <12.2, 2.1, 8.5> }
        box { <10.6, 0.000001, 15.5> <12.2, 2.1, 16.5> }
        box { <59.8, 0.000001, 11.5> <65, 2.2, 12.5> }
        box { <59.8, 0.000001, 7.5> <61.4, 2.2, 8.5> }
        box { <59.8, 0.000001, 15.5> <61.4, 2.2, 16.5> }
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 24> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <24, 0, 8> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <32, 0, 8> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <40, 0, 8> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <48, 0, 8> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <24, 0, 16> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <32, 0, 16> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <40, 0, 16> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <48, 0, 16> }
        #else
          object { rounded_button() translate <0, 0, 8> }
          object { rounded_button() translate <8, 0, 8> }
          object { rounded_button() translate <16, 0, 8> }
          object { rounded_button() translate <56, 0, 8> }
          object { rounded_button() translate <64, 0, 8> }
          object { rounded_button() translate <72, 0, 8> }
          object { rounded_button() translate <0, 0, 16> }
          object { rounded_button() translate <8, 0, 16> }
          object { rounded_button() translate <16, 0, 16> }
          object { rounded_button() translate <56, 0, 16> }
          object { rounded_button() translate <64, 0, 16> }
          object { rounded_button() translate <72, 0, 16> }
          object { rounded_button() translate <16, 0, 0> }
          object { rounded_button() translate <24, 0, 0> }
          object { rounded_button() translate <32, 0, 0> }
          object { rounded_button() translate <40, 0, 0> }
          object { rounded_button() translate <48, 0, 0> }
          object { rounded_button() translate <56, 0, 0> }
          object { rounded_button() translate <16, 0, 24> }
          object { rounded_button() translate <24, 0, 24> }
          object { rounded_button() translate <32, 0, 24> }
          object { rounded_button() translate <40, 0, 24> }
          object { rounded_button() translate <48, 0, 24> }
          object { rounded_button() translate <56, 0, 24> }
          object { rounded_button() translate <24, -6.3, 8> }
          object { rounded_button() translate <32, -6.3, 8> }
          object { rounded_button() translate <40, -6.3, 8> }
          object { rounded_button() translate <48, -6.3, 8> }
          object { rounded_button() translate <24, -6.3, 16> }
          object { rounded_button() translate <32, -6.3, 16> }
          object { rounded_button() translate <40, -6.3, 16> }
          object { rounded_button() translate <48, -6.3, 16> }
        #end
        #if (setting > 1)
          object { ring() translate <4, 0, 12> }
          object { ring() translate <68, 0, 12> }
          object { pin(2) translate <20, 0, 0> }
          object { pin(2) translate <28, 0, 0> }
          object { pin(2) translate <36, 0, 0> }
          object { pin(2) translate <44, 0, 0> }
          object { pin(2) translate <52, 0, 0> }
          object { pin(2) translate <20, 0, 24> }
          object { pin(2) translate <28, 0, 24> }
          object { pin(2) translate <36, 0, 24> }
          object { pin(2) translate <44, 0, 24> }
          object { pin(2) translate <52, 0, 24> }
        #end
      }
      #if (setting > 1)
        cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <64, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <72, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <56, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <64, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <72, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
        cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
        cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
        cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
        cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <40, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <48, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <56, 0, 24> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <24, 0, 8> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <32, 0, 8> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <40, 0, 8> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <48, 0, 8> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <24, 0, 16> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <32, 0, 16> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <40, 0, 16> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <48, 0, 16> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -4.25, -4> <76, 4.9, 28> } }
    }
  #end
#end
#macro f_car_bottom3(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <91.9, 3.1, 27.9> }
      box { <28.100001, -4.2, 4.100001> <59.899999, 0.1, 19.900001> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          merge {
            box { <-3.9, 0, -3.9> <91.9, 3.1, 27.9> }
            box { <20, -3.1, -3.90001> <68, 0.1, 27.90001> }
            box { <19.99999, -4.3, 4.10001> <68.00001, -3.09999, 19.900001> }
          }
          box { <27.90001, -5, 3.89999> <60.10001, 5, 5.4> }
          box { <27.90001, -5, 18.6> <60.10001, 5, 20.100003> }
          difference {
            box { <-4, -4, -4> <28.1, 4, 4.1> }
            box { <0, -5, 0> <10, 5, 10> rotate -20*y translate <28, 0, -3.9> }
          }
          difference {
            box { <-4, -4, 19.9> <28.1, 4, 28> }
            box { <0, -5, -10> <10, 5, 0> rotate 20*y translate <28, 0, 27.9> }
          }
          difference {
            box { <59.9, -4, -4> <92, 4, 4.1> }
            box { <-10, -5, 0> <0, 5, 10> rotate 20*y translate <60, 0, -3.9> }
          }
          difference {
            box { <59.9, -4, 19.9> <92, 4, 28> }
            box { <-10, -5, -10> <0, 5, 0> rotate -20*y translate <60, 0, 27.9> }
          }
          #if (setting > 1)
            difference {
              box { <24, -4, -2.4> <64, 2, 2.4> }
              box { <-10, -5, 0> <0, 5, 10> rotate -20*y translate <29.5, 0, -3.9> }
              box { <0, -5, 0> <10, 5, 10> rotate 20*y translate <58.5, 0, -3.9> }
              box { <28, -3.20001, -0.5> <29.6, 3, 0.5> }
              box { <58.4, -3.20001, -0.5> <60, 3, 0.5> }
              box { <43.7, -1.6, -2.5> <44.3, 3, 2.5> }
              cylinder { -3.20001*y, 3*y, 1.5 translate <36, 0, 0> }
              cylinder { -3.20001*y, 3*y, 1.5 translate <44, 0, 0> }
              cylinder { -3.20001*y, 3*y, 1.5 translate <52, 0, 0> }
            }
            difference {
              box { <24, -4, 21.6> <64, 2, 26.4> }
              box { <-10, -5, -10> <0, 5, 0> rotate 20*y translate <29.5, 0, 27.9> }
              box { <0, -5, -10> <10, 5, 0> rotate -20*y translate <58.5, 0, 27.9> }
              box { <28, -3.20001, 23.5> <29.6, 3, 24.5> }
              box { <58.4, -3.20001, 23.5> <60, 3, 24.5> }
              box { <43.7, -1.6, 21.5> <44.3, 3, 26.5> }
              cylinder { -3.20001*y, 3*y, 1.5 translate <36, 0, 24> }
              cylinder { -3.20001*y, 3*y, 1.5 translate <44, 0, 24> }
              cylinder { -3.20001*y, 3*y, 1.5 translate <52, 0, 24> }
            }
            box { <-2.4, -1, 5.6> <18.4, 2, 18.4> }
            box { <69.6, -1, 5.6> <90.4, 2, 18.4> }
            difference {
              box { <19.9, -5, 5.6> <26.7, 2, 18.4> }
              box { <0, -4, 3.90002> <2, 4, 20.10002> rotate 20*z translate <27, 0, 0> }
            }
            difference {
              box { <61.6, -5, 5.6> <68.4, 2, 18.4> }
              box { <-2, -4, 3.90002> <0, 4, 20.10002> rotate -20*z translate <61, 0, 0> }
            }
          #end
          box { <27.9, -3.2, 3.9> <60.1, 4, 20.1> }
          box { <0, -4, 3.900001> <10, 0, 20.100001> rotate -32.5*z translate <20, 0, 0> }
          box { <-10, -4, 3.900001> <0, 0, 20.100001> rotate 32.5*z translate <68, 0, 0> }
          box { <0, 0, 3.900002> <2, 4, 20.100002> rotate 20*z translate <27.9, 0, 0> }
          box { <-2, 0, 3.900002> <0, 4, 20.100002> rotate -20*z translate <60.1, 0, 0> }
        }
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 24> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <32, 0, 8> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <40, 0, 8> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <48, 0, 8> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <56, 0, 8> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <32, 0, 16> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <40, 0, 16> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <48, 0, 16> }
          cylinder { -3.3*y, -1.5*y, 2.4 translate <56, 0, 16> }
        #else
          object { rounded_button() translate <0, 0, 8> }
          object { rounded_button() translate <8, 0, 8> }
          object { rounded_button() translate <16, 0, 8> }
          object { rounded_button() translate <24, 0, 8> }
          object { rounded_button() translate <0, 0, 16> }
          object { rounded_button() translate <8, 0, 16> }
          object { rounded_button() translate <16, 0, 16> }
          object { rounded_button() translate <24, 0, 16> }
          object { rounded_button() translate <32, 0, 0> }
          object { rounded_button() translate <32, 0, 24> }
          object { rounded_button() translate <40, 0, 0> }
          object { rounded_button() translate <40, 0, 24> }
          object { rounded_button() translate <48, 0, 0> }
          object { rounded_button() translate <48, 0, 24> }
          object { rounded_button() translate <56, 0, 0> }
          object { rounded_button() translate <56, 0, 24> }
          object { rounded_button() translate <64, 0, 8> }
          object { rounded_button() translate <64, 0, 16> }
          object { rounded_button() translate <72, 0, 8> }
          object { rounded_button() translate <72, 0, 16> }
          object { rounded_button() translate <80, 0, 8> }
          object { rounded_button() translate <80, 0, 16> }
          object { rounded_button() translate <88, 0, 8> }
          object { rounded_button() translate <88, 0, 16> }
          object { rounded_button() translate <32, -6.4, 8> }
          object { rounded_button() translate <40, -6.4, 8> }
          object { rounded_button() translate <48, -6.4, 8> }
          object { rounded_button() translate <56, -6.4, 8> }
          object { rounded_button() translate <32, -6.4, 16> }
          object { rounded_button() translate <40, -6.4, 16> }
          object { rounded_button() translate <48, -6.4, 16> }
          object { rounded_button() translate <56, -6.4, 16> }
        #end
        #if (setting > 1)
          object { ring() translate <4, 0, 12> }
          object { ring() translate <12, 0, 12> }
          object { ring() translate <76, 0, 12> }
          object { ring() translate <84, 0, 12> }
          box { <15, 0.00001, 11.4> <26.9, 3, 12.6> }
          box { <61.1, 0.00001, 11.4> <73, 3, 12.6> }
        #end
      }
      #if (setting > 1)
        cylinder { -5*y, 5*y, 2.5 translate <36, 0, 12> }
        cylinder { -5*y, 5*y, 2.5 translate <52, 0, 12> }
        cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <64, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <72, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <80, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <88, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <64, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <72, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <80, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <88, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
        cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
        cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
        cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
        cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <40, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <48, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <56, 0, 24> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <32, 0, 8> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <40, 0, 8> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <48, 0, 8> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <56, 0, 8> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <32, 0, 16> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <40, 0, 16> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <48, 0, 16> }
        cylinder { -5.3*y, -2.3*y, 1.2 translate <56, 0, 16> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -4.4, -4> <92, 4.9, 28> } }
    }
  #end
#end
#macro f_claw1_1(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 3.1, 3.9> }
      cylinder { 0.000003*y, 3.099997*y, 3 translate <8, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <11, 3.1, 3.9> }
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 }
        #else
          object { rounded_button() }
        #end
      }
      difference {
        box { <3.9, -1, -4> <11.5, 4, 4> }
        cylinder { -0.5*y, 3.5*y, 3 translate <8, 0, 0> }
        box { <3, -0.5, -2> <9, 3.5, 2> }
        box { <7.99999, -0.5, -3> <12, 3.5, 3> }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
        cylinder { 1*y, 4*y, 1.2 }
      #end
      box { <8, -1, -1.5> <11.05, 4, 1.5> }
      cylinder { -1*y, 4*y, 1.6 translate <8, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <11.1, 4.9, 4> } }
    }
  #end
#end
#macro f_claw1_2(color_tex, age)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      cylinder { -3.9*x, 11.9*x, 1.5 translate <0, 2.25, 8> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
          #end
          torus { 1.35, 0.15 rotate 90*z translate <-3.75, 2.25, 8> }
          torus { 1.35, 0.15 rotate 90*z translate <11.75, 2.25, 8> }
          cylinder { -3.75*x, 11.75*x, 1.5 translate <0, 2.25, 8> }
          cylinder { -3.9*x, 11.9*x, 1.35 translate <0, 2.25, 8> }
          cylinder { -0.5*x, 1.5*x, 2.25 translate <0, 2.250001, 7.999999> }
          box { <-0.500001, 0.000001, 3> <1.500001, 3.099999, 8> }
          cylinder { 6.5*x, 8.5*x, 2.25 translate <0, 2.250002, 7.999999> }
          box { <6.500001, 0.000001, 3> <8.500001, 3.099999, 8> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        #end
        #if (setting > 3)
          box { <2.75, 2.85, -2.3> <5.25, 4, 2.3> }
        #end
      }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
      #end
      #if (setting > 3)
        object { llogo() translate <4, 2.85, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 4.9, 10.3> } }
    }
  #end
#end
#macro f_claw1_2_new(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      cylinder { -3.9*x, 11.9*x, 1.5 translate <0, 2.25, 8> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
          #end
          torus { 1.35, 0.15 rotate 90*z translate <-3.75, 2.25, 8> }
          torus { 1.35, 0.15 rotate 90*z translate <11.75, 2.25, 8> }
          cylinder { -3.75*x, 11.75*x, 1.5 translate <0, 2.25, 8> }
          cylinder { -3*x, 11*x, 1.55 translate <0, 2.25, 8> }
          cylinder { -3.900001*x, -1.7*x, 2.25 translate <0, 2.250001, 7.999999> }
          box { <-3.900002, 0.000001, 3> <-1.700001, 3.099999, 8> }
          cylinder { 9.7*x, 11.900001*x, 2.25 translate <0, 2.250002, 7.999999> }
          box { <9.700002, 0.000001, 3> <11.90000200001, 3.099999, 8> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { -1*y, 2.25*y, 0.45 translate <4.35, 0, 8> }
          cylinder { -1*y, 2.25*y, 0.45 translate <3.65, 0, 8> }
          box { <3.65, -1, 7.55> <4.35, 2.25, 8.45> }
          cylinder { -1*y, 2.25*y, 0.45 translate <-2.8, 0, 8.35> }
          cylinder { -1*y, 2.25*y, 0.45 translate <-2.8, 0, 7.65> }
          box { <-3.25, -1, 7.65> <-2.35, 2.25, 8.35> }
          cylinder { -1*y, 2.25*y, 0.45 translate <10.8, 0, 8.35> }
          cylinder { -1*y, 2.25*y, 0.45 translate <10.8, 0, 7.65> }
          box { <10.35, -1, 7.65> <11.25, 2.25, 8.35> }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 4.9, 10.3> } }
    }
  #end
#end
#macro f_connect1_2(color_tex, age)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      box { <0.1, 0.000001, 3.5> <7.9, 3.100001, 9.55> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          box { <0.100001, 0.000001, 3.5> <1.65, 3.099999, 8> }
          cylinder { 0.100002*x, 1.649999*x, 1.55 translate <0, 1.55, 8> }
          box { <3.5, 0.000001, 3.5> <4.5, 3.099999, 8> }
          cylinder { 3.500001*x, 4.499999*x, 1.55 translate <0, 1.55, 8> }
          box { <6.35, 0.000001, 3.5> <7.899999, 3.099999, 8> }
          cylinder { 6.350001*x, 7.899998*x, 1.55 translate <0, 1.55, 8> }
          cylinder { 0.1*x, 7.9*x, 1.55 translate <0, 1.55, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 4.9, 9.65> } }
    }
  #end
#end
#macro f_connect1_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 3.1, 7.55> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
          box { <-3.89998, 0.00001, 3.5> <-2.5, 3.09999, 6.00001> }
          cylinder { -3.89999*x, -2.50001*x, 1.55 translate <0, 1.55, 6> }
          box { <3.3, 0.00001, 3.5> <4.7, 3.09999, 6.00001> }
          cylinder { 3.30001*x, 4.69999*x, 1.55 translate <0, 1.55, 6> }
          box { <11.3, 0.00001, 3.5> <12.7, 3.09999, 6.00001> }
          cylinder { 11.30001*x, 12.69999*x, 1.54999 translate <0, 1.55, 6> }
          box { <19.3, 0.00001, 3.5> <20.7, 3.09999, 6.00001> }
          cylinder { 19.30001*x, 20.69999*x, 1.55 translate <0, 1.55, 6> }
          box { <26.5, 0.00001, 3.5> <27.89998, 3.09999, 6.00001> }
          cylinder { 26.50001*x, 27.89999*x, 1.55 translate <0, 1.55, 6> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
          #else
            object { rounded_button() rotate -90*y }
            object { rounded_button() rotate -90*y translate <8, 0, 0> }
            object { rounded_button() rotate -90*y translate <16, 0, 0> }
            object { rounded_button() rotate -90*y translate <24, 0, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
        object { pin(1) translate <12, 0, 0> }
        object { pin(1) translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 4.9, 7.65> } }
    }
  #end
#end
#macro f_cover4_4(color_tex)
  #if (setting = 0)
    box { <-30.4, -1.55, -3.9> <0, 1.55, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { -3.900001*z, 27.900001*z, 1.55 }
          box { <-30.4, -1.550001, -3.9> <0, 1.550001, 27.9> }
          #if (setting < 3)
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-26.5, 0, 0> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-26.5, 0, 8> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-26.5, 0, 16> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-26.5, 0, 24> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-18.5, 0, 0> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-18.5, 0, 8> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-18.5, 0, 16> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-18.5, 0, 24> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-10.5, 0, 0> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-10.5, 0, 8> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-10.5, 0, 16> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-10.5, 0, 24> }
          #else
            object { rounded_button() rotate 180*y translate <-26.5, -1.55, 0> }
            object { rounded_button() rotate 180*y translate <-26.5, -1.55, 8> }
            object { rounded_button() rotate 180*y translate <-26.5, -1.55, 16> }
            object { rounded_button() rotate 180*y translate <-26.5, -1.55, 24> }
            object { rounded_button() rotate 180*y translate <-18.5, -1.55, 0> }
            object { rounded_button() rotate 180*y translate <-18.5, -1.55, 8> }
            object { rounded_button() rotate 180*y translate <-18.5, -1.55, 16> }
            object { rounded_button() rotate 180*y translate <-18.5, -1.55, 24> }
            object { rounded_button() rotate 180*y translate <-10.5, -1.55, 0> }
            object { rounded_button() rotate 180*y translate <-10.5, -1.55, 8> }
            object { rounded_button() rotate 180*y translate <-10.5, -1.55, 16> }
            object { rounded_button() rotate 180*y translate <-10.5, -1.55, 24> }
          #end
        }
        #if (setting > 1)
          box { <-28.9, -2, -2.4> <-3, 0.450001, 26.4> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-26.5, 0, 0> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-26.5, 0, 8> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-26.5, 0, 16> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-26.5, 0, 24> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-18.5, 0, 0> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-18.5, 0, 8> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-18.5, 0, 16> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-18.5, 0, 24> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-10.5, 0, 0> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-10.5, 0, 8> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-10.5, 0, 16> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-10.5, 0, 24> }
          cylinder { -0.5*y, 0.7*y, 8 translate <-14.5, 0, 12> }
        #end
        box { <-14.5, -0.5, 4> <-4.5, 0.700001, 20> }
        box { <-2, -2, -5> <2, 2, -2.45> }
        box { <-2, -2, 3.2> <2, 2, 4.8> }
        box { <-2, -2, 11.2> <2, 2, 12.8> }
        box { <-2, -2, 19.2> <2, 2, 20.8> }
        box { <-2, -2, 26.45> <2, 2, 29> }
        box { <-5, -3, -1> <0, 0.45, 1.75> }
        box { <-5, -3, 6.25> <0, 0.45, 9.75> }
        box { <-5, -3, 14.25> <0, 0.45, 17.75> }
        box { <-5, -3, 22.25> <0, 0.45, 25> }
      }
      object { ring() translate <-22.5, -1.55, 4> }
      object { ring() translate <-22.5, -1.55, 20> }
      difference {
        object { ring() translate <-22.5, -1.55, 12> }
        box { <-23.5, -2, 8> <-18.5, 0.450002, 16> }
        cylinder { -0.5*y, 0.700001*y, 8 translate <-14.5, 0, 12> }
      }
      texture { color_tex }
      bounded_by { box { <-30.5, -1.65, -4> <2, 3.35, 28> } }
    }
  #end
#end
#macro f_dish(color_tex)
  #if (setting = 0)
    cylinder { -0.75*y, 0.75*y, 10.5 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -1.75*y, 1.75*y, 3.15 }
        difference {
          torus { 10.5, 1.5 }
          box { <-20, -2, -20> <20, -0.75, 20> }
          box { <-20, 0.75, -20> <20, 2, 20> }
        }
        cylinder { -0.750001*y, 0.750001*y, 10.500001 }
      }
      object { axle_opening(4,1) rotate 90*z translate <0, -2, 0> }
      texture { color_tex }
      bounded_by { cylinder { -1.85*y, 1.85*y, 12.1 } }
    }
  #end
#end
#macro f_fence16(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <123.9, 3.1, 3.9> }
      box { <-2.4, -1, -2.4> <122.4, 47, 2.4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <123.9, 3.1, 3.9> }
        box { <-2.4, -1, -2.4> <122.4, 47, 2.4> }
      }
      #local teller = 0;
      #while (teller < 15)
      merge {
        box { <-0.3, 0.000001, -4> <0.3, 3.100001, 4> }
        box { <-4, 0.000002, -0.3> <4, 3.099999, 0.3> }
        rotate 45*y
        translate <4+(teller*8), 0, 0>
      }
      #local teller = teller + 1;
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <124, 3.2, 4> } }
    }
  #end
#end
#macro f_hatch2_4(color_tex)
  #if (setting = 0)
    box { <-17.7, -1.55, -3.9> <1.55, 1.55, 27.9> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -3.900001*z, 27.900001*z, 1.55 }
        box { <-17.7, -1.550001, -3.9> <0, 1.550001, 27.9> }
      }
      box { <-16.2, -2, -2.4> <-3.5, 0.5, 26.4> }
      box { <-1.8, -2, -5> <2, 2, -2.45> }
      box { <-1.8, -2, 3.2> <2, 2, 4.8> }
      box { <-1.8, -2, 11.2> <2, 2, 12.8> }
      box { <-1.8, -2, 19.2> <2, 2, 20.8> }
      box { <-1.8, -2, 26.45> <2, 2, 29> }
      box { <-1.8, -3, -1> <0, 0.5, 1.75> }
      box { <-1.8, -3, 6.25> <0, 0.5, 9.75> }
      box { <-1.8, -3, 14.25> <0, 0.5, 17.75> }
      box { <-1.8, -3, 22.25> <0, 0.5, 25> }
      difference {
        box { <-16, 1.2, -2.5> <-3.5, 2, 26.5> }
        box { <-6.5, 0, -1.6> <-4.4, 3, 25.6> }
        box { <-9.4, 0, -1.6> <-7.3, 3, 25.6> }
        box { <-12.3, 0, -1.6> <-10.2, 3, 25.6> }
        box { <-15.2, 0, -1.6> <-13.1, 3, 25.6> }
      }
      texture { color_tex }
      bounded_by { box { <-17.8, -1.65, -4> <1.65, 1.65, 28> } }
    }
  #end
#end
#macro f_hull10_9(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <75.9, 3.1, 67.9> }
      box { <-30, -1, -20> <0, 4, 50> rotate 18.4*y translate <-4, 0, 12> }
      box { <-30, -1, -20> <0, 4, 50> rotate 32*y translate <4, 0, 36> }
      box { <-30, -1, -20> <0, 4, 50> rotate 42*y translate <15, 0, 53.5> }
      box { <0, -1, -20> <30, 4, 50> rotate -18.4*y translate <76, 0, 12> }
      box { <0, -1, -20> <30, 4, 50> rotate -32*y translate <68, 0, 36> }
      box { <0, -1, -20> <30, 4, 50> rotate -42*y translate <57, 0, 53.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <75.9, 3.1, 67.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 56> }
          #else
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
            object { rounded_button() rotate 90*y translate <16, 0, 0> }
            object { rounded_button() rotate 90*y translate <24, 0, 0> }
            object { rounded_button() rotate 90*y translate <32, 0, 0> }
            object { rounded_button() rotate 90*y translate <40, 0, 0> }
            object { rounded_button() rotate 90*y translate <48, 0, 0> }
            object { rounded_button() rotate 90*y translate <56, 0, 0> }
            object { rounded_button() rotate 90*y translate <64, 0, 0> }
            object { rounded_button() rotate 90*y translate <8, 0, 8> }
            object { rounded_button() rotate 90*y translate <16, 0, 8> }
            object { rounded_button() rotate 90*y translate <24, 0, 8> }
            object { rounded_button() rotate 90*y translate <32, 0, 8> }
            object { rounded_button() rotate 90*y translate <40, 0, 8> }
            object { rounded_button() rotate 90*y translate <48, 0, 8> }
            object { rounded_button() rotate 90*y translate <56, 0, 8> }
            object { rounded_button() rotate 90*y translate <64, 0, 8> }
            object { rounded_button() rotate 90*y translate <8, 0, 16> }
            object { rounded_button() rotate 90*y translate <16, 0, 16> }
            object { rounded_button() rotate 90*y translate <24, 0, 16> }
            object { rounded_button() rotate 90*y translate <32, 0, 16> }
            object { rounded_button() rotate 90*y translate <40, 0, 16> }
            object { rounded_button() rotate 90*y translate <48, 0, 16> }
            object { rounded_button() rotate 90*y translate <56, 0, 16> }
            object { rounded_button() rotate 90*y translate <64, 0, 16> }
            object { rounded_button() rotate 90*y translate <8, 0, 24> }
            object { rounded_button() rotate 90*y translate <16, 0, 24> }
            object { rounded_button() rotate 90*y translate <24, 0, 24> }
            object { rounded_button() rotate 90*y translate <32, 0, 24> }
            object { rounded_button() rotate 90*y translate <40, 0, 24> }
            object { rounded_button() rotate 90*y translate <48, 0, 24> }
            object { rounded_button() rotate 90*y translate <56, 0, 24> }
            object { rounded_button() rotate 90*y translate <64, 0, 24> }
            object { rounded_button() rotate 90*y translate <8, 0, 32> }
            object { rounded_button() rotate 90*y translate <16, 0, 32> }
            object { rounded_button() rotate 90*y translate <24, 0, 32> }
            object { rounded_button() rotate 90*y translate <32, 0, 32> }
            object { rounded_button() rotate 90*y translate <40, 0, 32> }
            object { rounded_button() rotate 90*y translate <48, 0, 32> }
            object { rounded_button() rotate 90*y translate <56, 0, 32> }
            object { rounded_button() rotate 90*y translate <64, 0, 32> }
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <72, 0, 0> }
            object { rounded_button() rotate 90*y translate <0, 0, 8> }
            object { rounded_button() rotate 90*y translate <72, 0, 8> }
            object { rounded_button() rotate 90*y translate <16, 0, 40> }
            object { rounded_button() rotate 90*y translate <32, 0, 64> }
            object { rounded_button() rotate 90*y translate <40, 0, 64> }
            object { rounded_button() rotate 90*y translate <56, 0, 40> }
            object { rounded_button() rotate 90*y translate <24, 0, 40> }
            object { rounded_button() rotate 90*y translate <32, 0, 40> }
            object { rounded_button() rotate 90*y translate <40, 0, 40> }
            object { rounded_button() rotate 90*y translate <48, 0, 40> }
            object { rounded_button() rotate 90*y translate <24, 0, 48> }
            object { rounded_button() rotate 90*y translate <32, 0, 48> }
            object { rounded_button() rotate 90*y translate <40, 0, 48> }
            object { rounded_button() rotate 90*y translate <48, 0, 48> }
            object { rounded_button() rotate 90*y translate <24, 0, 56> }
            object { rounded_button() rotate 90*y translate <32, 0, 56> }
            object { rounded_button() rotate 90*y translate <40, 0, 56> }
            object { rounded_button() rotate 90*y translate <48, 0, 56> }
          #end
        }
        box { <-30, -1, -20> <0, 4, 50> rotate 18.4*y translate <-4, 0, 12> }
        box { <-30, -1, -20> <0, 4, 50> rotate 32*y translate <4, 0, 36> }
        box { <-30, -1, -20> <0, 4, 50> rotate 42*y translate <15, 0, 53.5> }
        box { <0, -1, -20> <30, 4, 50> rotate -18.4*y translate <76, 0, 12> }
        box { <0, -1, -20> <30, 4, 50> rotate -32*y translate <68, 0, 36> }
        box { <0, -1, -20> <30, 4, 50> rotate -42*y translate <57, 0, 53.5> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <74.4, 2, 66.4> }
            box { <-30, -1, -20> <0, 4, 50> rotate 18.4*y translate <-2.25, 0, 12> }
            box { <-30, -1, -20> <0, 4, 50> rotate 32*y translate <5.75, 0, 36> }
            box { <-30, -1, -20> <0, 4, 50> rotate 42*y translate <15.75, 0, 52> }
            box { <0, -1, -20> <30, 4, 50> rotate -18.4*y translate <74.25, 0, 12> }
            box { <0, -1, -20> <30, 4, 50> rotate -32*y translate <66.25, 0, 36> }
            box { <0, -1, -20> <30, 4, 50> rotate -42*y translate <56.25, 0, 52> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 56> }
        #end
      }
      #if (setting > 1)
        object { ring() translate  <4, 0, 4> }
        object { ring() translate  <12, 0, 4> }
        object { ring() translate  <20, 0, 4> }
        object { ring() translate  <28, 0, 4> }
        object { ring() translate  <36, 0, 4> }
        object { ring() translate  <44, 0, 4> }
        object { ring() translate  <52, 0, 4> }
        object { ring() translate  <60, 0, 4> }
        object { ring() translate  <68, 0, 4> }
        object { ring() translate  <12, 0, 12> }
        object { ring() translate  <20, 0, 12> }
        object { ring() translate  <28, 0, 12> }
        object { ring() translate  <36, 0, 12> }
        object { ring() translate  <44, 0, 12> }
        object { ring() translate  <52, 0, 12> }
        object { ring() translate  <60, 0, 12> }
        object { ring() translate  <12, 0, 20> }
        object { ring() translate  <20, 0, 20> }
        object { ring() translate  <28, 0, 20> }
        object { ring() translate  <36, 0, 20> }
        object { ring() translate  <44, 0, 20> }
        object { ring() translate  <52, 0, 20> }
        object { ring() translate  <60, 0, 20> }
        object { ring() translate  <12, 0, 28> }
        object { ring() translate  <20, 0, 28> }
        object { ring() translate  <28, 0, 28> }
        object { ring() translate  <36, 0, 28> }
        object { ring() translate  <44, 0, 28> }
        object { ring() translate  <52, 0, 28> }
        object { ring() translate  <60, 0, 28> }
        object { ring() translate  <20, 0, 36> }
        object { ring() translate  <28, 0, 36> }
        object { ring() translate  <36, 0, 36> }
        object { ring() translate  <20, 0, 44> }
        object { ring() translate  <28, 0, 44> }
        object { ring() translate  <36, 0, 44> }
        object { ring() translate  <28, 0, 52> }
        object { ring() translate  <36, 0, 52> }
        object { ring() translate  <44, 0, 52> }
        object { ring() translate  <44, 0, 36> }
        object { ring() translate  <52, 0, 36> }
        object { ring() translate  <44, 0, 44> }
        object { ring() translate <52, 0, 44> }
        object { ring() translate <36, 0, 60> }
        box { <-3, 0.000001, 10.5> <5.5, 2.1, 11.5> }
        box { <66.5, 0.000001, 10.5> <75, 2.1, 11.5> }
        box { <4.5, 0.000002, 11> <5.500001, 2.1, 35> }
        box { <66.500001, 0.000002, 11> <67.5, 2.1, 35> }
        box { <5, 0.000001, 34.5> <13.5, 2.1, 35.5> }
        box { <58.5, 0.000001, 34.5> <67, 2.1, 35.5> }
        box { <12.5, 0.000002, 35> <13.500001, 2.1, 49> }
        box { <58.500001, 0.000002, 35> <59, 2.1, 49> }
        box { <14.5, 0.000001, 50.5> <21.5, 2.1, 51.5> }
        box { <50.5, 0.000001, 50.5> <57.5, 2.1, 51.5> }
        box { <20.5, 0.000002, 51> <21.500001, 2.1, 59> }
        box { <50.500001, 0.000002, 51> <51.5, 2.1, 59> }
        box { <21, 0.000001, 58.5> <29.5, 2.1, 59.5> }
        box { <42.5, 0.000001, 58.5> <51, 2.1, 59.5> }
        box { <28.5, 0.000002, 59> <29.500001, 2.1, 67> }
        box { <42.500001, 0.000002, 59> <43.5, 2.1, 67> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 4.9, 68> } }
    }
  #end
#end
#macro f_leftwinglet3_12(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <91.9, 3.1, 19.9> }
      box { <-50, -10, -50> <100, 10, 0> rotate 9.4175*y translate <-4, 0, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <91.9, 3.1, 19.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 16> }
          #else
            object { rounded_button() translate <88, 0, 0> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() translate <48, 0, 8> }
            object { rounded_button() translate <56, 0, 8> }
            object { rounded_button() translate <64, 0, 8> }
            object { rounded_button() translate <72, 0, 8> }
            object { rounded_button() translate <80, 0, 8> }
            object { rounded_button() translate <88, 0, 8> }
            object { rounded_button() translate <0, 0, 16> }
            object { rounded_button() translate <8, 0, 16> }
            object { rounded_button() translate <16, 0, 16> }
            object { rounded_button() translate <24, 0, 16> }
            object { rounded_button() translate <32, 0, 16> }
            object { rounded_button() translate <40, 0, 16> }
            object { rounded_button() translate <48, 0, 16> }
            object { rounded_button() translate <56, 0, 16> }
            object { rounded_button() translate <64, 0, 16> }
            object { rounded_button() translate <72, 0, 16> }
            object { rounded_button() translate <80, 0, 16> }
            object { rounded_button() translate <88, 0, 16> }
          #end
        }
        box { <-50, -10, -50> <100, 10, 0> rotate 9.4175*y translate <-4, 0, 12> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate 9.4175*y translate <16, 0, 8> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate 9.4175*y translate <24, 0, 8> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate 9.4175*y translate <32, 0, 8> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate 9.4175*y translate <64, 0, 0> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate 9.4175*y translate <72, 0, 0> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate 9.4175*y translate <80, 0, 0> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <90.4, 2, 18.4> }
            box { <-50, -10, -50> <100, 10, 0> rotate 9.4175*y translate <-2.5, 0, 13> }
            box { <-0.5, -20, 10> <0.5, 3, 13.6> }
            box { <-2.5, 0.000005, -0.5> <2.5, 3, 0.5> rotate 45*y translate <52, 0, 4> }
            box { <-2.5, 0.000003, -0.5> <2.5, 3, 0.5> rotate -45*y translate <52, 0, 4> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 16> }
          cylinder { -1*y, 2.000001*y, 2.5 translate <88, 0, 0> }
          cylinder { -1*y, 2.000001*y, 2.5 translate <40, 0, 8> }
          cylinder { -1*y, 2.000001*y, 2.5 translate <8, 0, 8> }
          cylinder { -1*y, 2.000001*y, 2.5 translate <56, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 16> }
        difference {
          merge {
            object { ring() translate <12, 0, 12> }
            object { ring() translate <20, 0, 12> }
            object { ring() translate <28, 0, 12> }
            object { ring() translate <36, 0, 12> }
            object { ring() translate <44, 0, 12> }
            object { ring() translate <52, 0, 12> }
            object { ring() translate <60, 0, 12> }
            object { ring() translate <68, 0, 12> }
            object { ring() translate <76, 0, 12> }
            object { ring() translate <84, 0, 12> }
            object { ring() translate <60, 0, 4> }
            object { ring() translate <68, 0, 4> }
            object { ring() translate <76, 0, 4> }
            object { ring() translate <84, 0, 4> }
          }
          box { <-50, -10, -50> <100, 10, 0> rotate 9.4175*y translate <-2.5, 0, 12.000005> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <92, 4.9, 20> } }
    }
  #end
#end
#macro f_leftwinglet3_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 3.1, 19.9> }
      box { <-50, -10, -50> <100, 10, 0> rotate 18.2*y translate <-4, 0, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.4> <43.9, 3.1, 19.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
          #else
            object { rounded_button() translate <24, 0, 8> }
            object { rounded_button() translate <32, 0, 8> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() translate <0, 0, 16> }
            object { rounded_button() translate <8, 0, 16> }
            object { rounded_button() translate <16, 0, 16> }
            object { rounded_button() translate <24, 0, 16> }
            object { rounded_button() translate <32, 0, 16> }
            object { rounded_button() translate <40, 0, 16> }
          #end
        }
        box { <-50, -10, -50> <100, 10, 0> rotate 18.2*y translate <-4, 0, 12> }
        box { <-2.5, -1, -5> <2.5, 2.00005, 5> rotate 18.2*y translate <8, 0, 8> }
        box { <-2.5, -1, -5> <2.5, 2.00005, 5> rotate 18.2*y translate <16, 0, 8> }
        box { <-2.5, -1, -5> <2.5, 2.00005, 5> rotate 18.2*y translate <32, 0, 0> }
        box { <-2.5, -1, -5> <2.5, 2.00005, 0> rotate 18.2*y translate <40, 0, 0> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <42.4, 2, 18.4> }
            box { <-50, -10, -50> <100, 10, 0> rotate 18.2*y translate <-2.5, 0, 13> }
            box { <11, 0.00001, 8> <12, 3, 9> }
            box { <35, 0.00001, 0> <36, 3, 1> }
            box { <-0.5, 0.00001, -3.5> <0.5, 0, -2.4> rotate 18.2*y translate <24, 0, 8> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { ring() translate <4, 0, 12> }
            object { ring() translate <12, 0, 12> }
            object { ring() translate <20, 0, 12> }
            object { ring() translate <28, 0, 12> }
            object { ring() translate <36, 0, 12> }
            object { ring() translate <28, 0, 4> }
            object { ring() translate <36, 0, 4> }
          }
          box { <-50, -10, -50> <100, 10, 0> rotate 18.2*y translate <-2.5, 0, 13.00005> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -3.5> <44, 4.9, 20> } }
    }
  #end
#end
#macro f_leftwinglet3_8(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 3.1, 19.9> }
      box { <-50, -10, -50> <100, 10, 0> rotate 18*y translate <-4, 0, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 3.1, 19.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 16> }
          #else
            object { rounded_button() translate <48, 0, 0> }
            object { rounded_button() translate <56, 0, 0> }
            object { rounded_button() translate <24, 0, 8> }
            object { rounded_button() translate <32, 0, 8> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() translate <48, 0, 8> }
            object { rounded_button() translate <56, 0, 8> }
            object { rounded_button() translate <0, 0, 16> }
            object { rounded_button() translate <8, 0, 16> }
            object { rounded_button() translate <16, 0, 16> }
            object { rounded_button() translate <24, 0, 16> }
            object { rounded_button() translate <32, 0, 16> }
            object { rounded_button() translate <40, 0, 16> }
            object { rounded_button() translate <48, 0, 16> }
            object { rounded_button() translate <56, 0, 16> }
          #end
        }
        box { <-50, -10, -50> <100, 10, 0> rotate 18*y translate <-4, 0, 12> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate 18*y translate <6, 0, 8> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate 18*y translate <16, 0, 8> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate 18*y translate <32, 0, 0> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate 18*y translate <40, 0, 0> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <58.4, 2, 18.4> }
            box { <-50, -10, -50> <100, 10, 0> rotate 18*y translate <-2.5, 0, 13> }
            box { <11, 0.000001, 8> <12, 3, 9> }
            box { <35, 0.000001, 0> <36, 3, 1> }
            box { <-0.5, 0.000001, -3.2> <0.5, 0, -2.4> rotate 18*y translate <24, 0, 8> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 16> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { ring() translate <4, 0, 12> }
            object { ring() translate <12, 0, 12> }
            object { ring() translate <20, 0, 12> }
            object { ring() translate <28, 0, 12> }
            object { ring() translate <36, 0, 12> }
            object { ring() translate <44, 0, 12> }
            object { ring() translate <52, 0, 12> }
            object { ring() translate <28, 0, 4> }
            object { ring() translate <36, 0, 4> }
            object { ring() translate <44, 0, 4> }
            object { ring() translate <52, 0, 4> }
          }
          box { <-50, -10, -50> <100, 10, 0> rotate 18*y translate <-2.5, 0, 13.000005> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 20> } }
    }
  #end
#end
#macro f_leftwinglet4_8(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 3.1, 27.9> }
      box { <-50, -10, -50> <70, 10, 0> rotate 23.25*y translate <-4, 0, 20> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 24> }
          #else
            object { rounded_button() translate <32, 0, 8> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() translate <48, 0, 8> }
            object { rounded_button() translate <56, 0, 8> }
            object { rounded_button() translate <32, 0, 16> }
            object { rounded_button() translate <40, 0, 16> }
            object { rounded_button() translate <48, 0, 16> }
            object { rounded_button() translate <56, 0, 16> }
            object { rounded_button() translate <16, 0, 16> }
            object { rounded_button() translate <24, 0, 16> }
            object { rounded_button() translate <0, 0, 24> }
            object { rounded_button() translate <8, 0, 24> }
            object { rounded_button() translate <16, 0, 24> }
            object { rounded_button() translate <24, 0, 24> }
            object { rounded_button() translate <32, 0, 24> }
            object { rounded_button() translate <40, 0, 24> }
            object { rounded_button() translate <48, 0, 24> }
            object { rounded_button() translate <56, 0, 24> }
          #end
        }
        box { <51.9, -1, -4> <60, 4, 4.1> }
        box { <-50, -10, -50> <70, 10, 0> rotate 23.25*y translate <-4, 0, 20> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <58.4, 2, 26.4> }
            box { <-50, -10, -50> <70, 10, 0> rotate 23.25*y translate <-2.5, 0, 20.5> }
            box { <50.5, -1, -4> <60, 3, 5.5> }
            box { <32, 0.25, 4.25> <51, 3, 5.5> }
            box { <-0.5, 0.25, 18> <0.5, 3, 21.5> }
            box { <15.5, 0.25, 10> <16.5, 3, 13.5> }
            box { <-8, 0.25, -0.5> <-2.5, 3, 0.5> rotate -45*y translate <8, 0, 24> }
            box { <-8, 0.25, -0.5> <-2.5, 3, 0.5> rotate -45*y translate <24, 0, 16> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 24> }
          cylinder { -1*y, 2.000001*y, 2.5 translate <32, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 24> }
        object { ring() translate <36, 0, 12> }
        object { ring() translate <44, 0, 12> }
        object { ring() translate <52, 0, 12> }
        object { ring() translate <29, 0, 12> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 20> }
        object { ring() translate <28, 0, 20> }
        object { ring() translate <36, 0, 20> }
        object { ring() translate <44, 0, 20> }
        object { ring() translate <52, 0, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 28> } }
    }
  #end
#end
#macro f_left_wing12_7(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -91.9> <51.9, 3.1, 3.9> }
      box { <-100, -10, -100> <0, 10, 100> rotate -26*y translate <-4, 0, -8> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -91.9> <51.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, -8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, -32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, -40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, -8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, -16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, -24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, -8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, -16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, -24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, -8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, -16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, -24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, -32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, -40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, -48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, -56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, -8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, -16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, -24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, -32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, -40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, -48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, -56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, -64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, -72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, -8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, -16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, -24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, -32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, -40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, -48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, -56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, -64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, -72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, -80> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, -88> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, -80> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, -88> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <0, 0, -8> }
            object { rounded_button() translate <16, 0, -32> }
            object { rounded_button() translate <16, 0, -40> }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <8, 0, -8> }
            object { rounded_button() translate <8, 0, -16> }
            object { rounded_button() translate <8, 0, -24> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <16, 0, -8> }
            object { rounded_button() translate <16, 0, -16> }
            object { rounded_button() translate <16, 0, -24> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <24, 0, -8> }
            object { rounded_button() translate <24, 0, -16> }
            object { rounded_button() translate <24, 0, -24> }
            object { rounded_button() translate <24, 0, -32> }
            object { rounded_button() translate <24, 0, -40> }
            object { rounded_button() translate <24, 0, -48> }
            object { rounded_button() translate <24, 0, -56> }
            object { rounded_button() translate <32, 0, 0> }
            object { rounded_button() translate <32, 0, -8> }
            object { rounded_button() translate <32, 0, -16> }
            object { rounded_button() translate <32, 0, -24> }
            object { rounded_button() translate <32, 0, -32> }
            object { rounded_button() translate <32, 0, -40> }
            object { rounded_button() translate <32, 0, -48> }
            object { rounded_button() translate <32, 0, -56> }
            object { rounded_button() translate <32, 0, -64> }
            object { rounded_button() translate <32, 0, -72> }
            object { rounded_button() translate <40, 0, 0> }
            object { rounded_button() translate <40, 0, -8> }
            object { rounded_button() translate <40, 0, -16> }
            object { rounded_button() translate <40, 0, -24> }
            object { rounded_button() translate <40, 0, -32> }
            object { rounded_button() translate <40, 0, -40> }
            object { rounded_button() translate <40, 0, -48> }
            object { rounded_button() translate <40, 0, -56> }
            object { rounded_button() translate <40, 0, -64> }
            object { rounded_button() translate <40, 0, -72> }
            object { rounded_button() translate <40, 0, -80> }
            object { rounded_button() translate <40, 0, -88> }
            object { rounded_button() translate <48, 0, -80> }
            object { rounded_button() translate <48, 0, -88> }
          #end
        }
        box { <-100, -10, -100> <0, 10, 100> rotate -26*y translate <-4, 0, -8> }
        difference {
          box { <34, -2, -93> <40, 6, -88> }
          cylinder { -1*y, 5*y, 3.9 translate <39.5, 0, -88.3> }
          box { <-50, -10, 0> <50, 10, 50> rotate -26*y translate <39.5, 0, -88.3> }
        }
        box { <43.900001, -1, -76.1> <52, 2, 4> }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, -8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, -32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, -40> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, -8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, -16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, -24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, -8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, -16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, -24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, -8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, -16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, -24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, -32> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, -40> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, -48> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, -56> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, -8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, -16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, -24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, -32> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, -40> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, -48> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, -56> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, -64> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, -72> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, -8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, -16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, -24> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, -32> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, -40> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, -48> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, -56> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, -64> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, -72> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, -80> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, -88> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, -80> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, -88> }
          difference {
            merge {
              box { <-2.4, -1, -90.4> <42.4, 2, 2.4> }
              box { <-2.4, -2, -90.400001> <50.4, 2.000001, -77.6> }
            }
            box { <-100, -10, -100> <0, 10, 100> rotate -26*y translate <-2, 0, -9> }
          }
        #end
        box { <0, -1, -80> <10, 4, 0> rotate -5.7*y translate <43.9, 0, -4> }
        box { <43.9, -1, -4> <52, 4, 4> }
      }
      #if (setting > 1)
        object { ring() translate <44, 0, -84> }
        object { ring() translate <36, 0, -76> }
        object { ring() translate <36, 0, -68> }
        object { ring() translate <36, 0, -60> }
        object { ring() translate <36, 0, -52> }
        object { ring() translate <36, 0, -44> }
        object { ring() translate <36, 0, -36> }
        object { ring() translate <36, 0, -28> }
        object { ring() translate <36, 0, -20> }
        object { ring() translate <36, 0, -12> }
        object { ring() translate <28, 0, -60> }
        object { ring() translate <28, 0, -52> }
        object { ring() translate <28, 0, -44> }
        object { ring() translate <28, 0, -36> }
        object { ring() translate <28, 0, -28> }
        object { ring() translate <28, 0, -20> }
        object { ring() translate <20, 0, -44> }
        object { ring() translate <20, 0, -36> }
        object { ring() translate <20, 0, -28> }
        object { ring() translate <20, 0, -20> }
        object { ring() translate <20, 0, -12> }
        object { ring() translate <20, 0, -4> }
        object { ring() translate <12, 0, -28> }
        object { ring() translate <12, 0, -20> }
        object { ring() translate <12, 0, -12> }
        object { ring() translate <4, 0, -4> }
        object { ring() translate <4, 0, -12> }
        object { ring() translate <12, 0, -4> }
        object { ring() translate <28, 0, -4> }
        object { ring() translate <28, 0, -12> }
        object { ring() translate <36, 0, -4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -92.3> <52, 4.9, 4> } }
    }
  #end
#end
#macro f_left_wing4_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-2.5, 0, -3.9> <27.9, 3.1, 27.9> }
      box { <-50, -10, -50> <50, 10, 0> rotate 45*y translate <20, 0, -4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-2.5, 0, -3.9> <27.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
          #else
            object { rounded_button() rotate -90*y translate <24, 0, 24> }
            object { rounded_button() rotate -90*y translate <24, 0, 16> }
            object { rounded_button() rotate -90*y translate <24, 0, 8> }
            object { rounded_button() rotate -90*y translate <24, 0, 0> }
            object { rounded_button() rotate -90*y translate <16, 0, 8> }
            object { rounded_button() rotate -90*y translate <16, 0, 16> }
            object { rounded_button() rotate -90*y translate <16, 0, 24> }
            object { rounded_button() rotate -90*y translate <8, 0, 16> }
            object { rounded_button() rotate -90*y translate <8, 0, 24> }
          #end
        }
        box { <-4, -1, 19.9> <4.1, 4, 28> }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          difference {
            merge {
              box { <-2.4, -1, 12> <4, 2, 18.4> }
              box { <5.6, -1, -2.4> <26.4, 2.000001, 26.4> }
            }
            box { <-50, -10, -50> <50, 10, 0> rotate 45*y translate <20.2, 0, -2.5> }
          }
        #end
        box { <-50, -10, -50> <50, 10, 0> rotate 45*y translate <20, 0, -4> }
      }
      #if (setting > 1)
        object { ring() translate <12, 0, 12> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <20, 0, 20> }
      #end
      box { <-0.5, 0.000001, -0.5> <1.5, 2.1, 0.5> rotate -45*y translate <13, 0, 6> }
      texture { color_tex }
      bounded_by { box { <-3, -0.1, -4> <28, 4.9, 28> } }
    }
  #end
#end
#macro f_rightwinglet3_12(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <91.9, 3.1, 19.9> }
      box { <-50, -10, 0> <100, 10, 50> rotate -9.4175*y translate <-4, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <91.9, 3.1, 19.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 0> }
          #else
            object { rounded_button() translate <88, 0, 16> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() translate <48, 0, 8> }
            object { rounded_button() translate <56, 0, 8> }
            object { rounded_button() translate <64, 0, 8> }
            object { rounded_button() translate <72, 0, 8> }
            object { rounded_button() translate <80, 0, 8> }
            object { rounded_button() translate <88, 0, 8> }
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <32, 0, 0> }
            object { rounded_button() translate <40, 0, 0> }
            object { rounded_button() translate <48, 0, 0> }
            object { rounded_button() translate <56, 0, 0> }
            object { rounded_button() translate <64, 0, 0> }
            object { rounded_button() translate <72, 0, 0> }
            object { rounded_button() translate <80, 0, 0> }
            object { rounded_button() translate <88, 0, 0> }
          #end
        }
        box { <-50, -10, 0> <100, 10, 50> rotate -9.4175*y translate <-4, 0, 4> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate -9.4175*y translate <16, 0, 8> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate -9.4175*y translate <24, 0, 8> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate -9.4175*y translate <32, 0, 8> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate -9.4175*y translate <64, 0, 16> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate -9.4175*y translate <72, 0, 16> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate -9.4175*y translate <80, 0, 16> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <90.4, 2, 18.4> }
            box { <-50, -10, 0> <100, 10, 50> rotate -9.4175*y translate <-2.5, 0, 3> }
            box { <-0.5, -20, 10> <0.5, 3, 13.6> }
            box { <-2.5, 0.000005, -0.5> <2.5, 3, 0.5> rotate 45*y translate <52, 0, 12> }
            box { <-2.5, 0.000003, -0.5> <2.5, 3, 0.5> rotate -45*y translate <52, 0, 12> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 0> }
          cylinder { -1*y, 2.000001*y, 2.5 translate <88, 0, 0> }
          cylinder { -1*y, 2.000001*y, 2.5 translate <40, 0, 8> }
          cylinder { -1*y, 2.000001*y, 2.5 translate <8, 0, 8> }
          cylinder { -1*y, 2.000001*y, 2.5 translate <56, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
        difference {
          merge {
            object { ring() translate <12, 0, 4> }
            object { ring() translate <20, 0, 4> }
            object { ring() translate <28, 0, 4> }
            object { ring() translate <36, 0, 4> }
            object { ring() translate <44, 0, 4> }
            object { ring() translate <52, 0, 4> }
            object { ring() translate <60, 0, 4> }
            object { ring() translate <68, 0, 4> }
            object { ring() translate <76, 0, 4> }
            object { ring() translate <84, 0, 4> }
            object { ring() translate <60, 0, 12> }
            object { ring() translate <68, 0, 12> }
            object { ring() translate <76, 0, 12> }
            object { ring() translate <84, 0, 12> }
          }
          box { <-50, -10, 0> <100, 10, 50> rotate -9.4175*y translate <-2.5, 0, 3.999995> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <92, 4.9, 20> } }
    }
  #end
#end
#macro f_rightwinglet3_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 3.1, 19.9> }
      box { <-50, -10, 0> <100, 10, 50> rotate -18.2*y translate <-4, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 19.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
          #else
            object { rounded_button() translate <24, 0, 8> }
            object { rounded_button() translate <32, 0, 8> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <32, 0, 0> }
            object { rounded_button() translate <40, 0, 0> }
          #end
        }
        box { <-50, -10, 0> <100, 10, 50> rotate -18.2*y translate <-4, 0, 4> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate -18.2*y translate <6, 0, 8> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate -18.2*y translate <16, 0, 8> }
        box { <-2.5, -1, -5> <2.5, 2.000005, 5> rotate -18.2*y translate <32, 0, 16> }
        box { <-2.5, -1, 0> <2.5, 2.000005, 5> rotate -18.2*y translate <40, 0, 16> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <42.4, 2, 18.4> }
            box { <-50, -10, 0> <100, 10, 50> rotate -18.2*y translate <-2.5, 0, 3> }
            box { <11, 0.000001, 8> <12, 3, 7> }
            box { <35, 0.000001, 15> <36, 3, 16> }
            box { <-0.5, 0.000001, 3.5> <0.5, 0, 2.4> rotate -18.2*y translate <24, 0, 8> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { ring() translate <4, 0, 4> }
            object { ring() translate <12, 0, 4> }
            object { ring() translate <20, 0, 4> }
            object { ring() translate <28, 0, 4> }
            object { ring() translate <36, 0, 4> }
            object { ring() translate <28, 0, 12> }
            object { ring() translate <36, 0, 12> }
          }
          box { <-50, -10, 0> <100, 10, 50> rotate -18.2*y translate <-2.5, 0, 3.00005> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 4.9, 20> } }
    }
  #end
#end
#macro f_rightwinglet3_8(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 3.1, 19.9> }
      box { <-50, -10, 0> <100, 10, 50> rotate -18*y translate <-4, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 3.1, 19.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
          #else
            object { rounded_button() translate <48, 0, 16> }
            object { rounded_button() translate <56, 0, 16> }
            object { rounded_button() translate <24, 0, 8> }
            object { rounded_button() translate <32, 0, 8> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() translate <48, 0, 8> }
            object { rounded_button() translate <56, 0, 8> }
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <32, 0, 0> }
            object { rounded_button() translate <40, 0, 0> }
            object { rounded_button() translate <48, 0, 0> }
            object { rounded_button() translate <56, 0, 0> }
          #end
        }
        box { <-50, -10, 0> <100, 10, 50> rotate -18*y translate <-4, 0, 4> }
        box { <-2.5, -1, -5> <2.5, 2.00005, 5> rotate -18*y translate <6, 0, 8> }
        box { <-2.5, -1, -5> <2.5, 2.00005, 5> rotate -18*y translate <16, 0, 8> }
        box { <-2.5, -1, -5> <2.5, 2.00005, 5> rotate -18*y translate <32, 0, 16> }
        box { <-2.5, -1, -5> <2.5, 2.00005, 5> rotate -18*y translate <40, 0, 16> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <58.4, 2, 18.4> }
            box { <-50, -10, 0> <100, 10, 50> rotate -18*y translate <-2.5, 0, 3> }
            box { <11, 0.00001, 8> <12, 3, 7> }
            box { <35, 0.00001, 15> <36, 3, 16> }
            box { <-0.5, 0.00001, -3.2> <0.5, 0, -2.4> rotate -18*y translate <24, 0, 8> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { ring() translate <4, 0, 4> }
            object { ring() translate <12, 0, 4> }
            object { ring() translate <20, 0, 4> }
            object { ring() translate <28, 0, 4> }
            object { ring() translate <36, 0, 4> }
            object { ring() translate <44, 0, 4> }
            object { ring() translate <52, 0, 4> }
            object { ring() translate <28, 0, 12> }
            object { ring() translate <36, 0, 12> }
            object { ring() translate <44, 0, 12> }
            object { ring() translate <52, 0, 12> }
          }
          box { <-50, -10, 0> <100, 10, 50> rotate -18*y translate <-2.5, 0, 3.00005> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 20> } }
    }
  #end
#end
#macro f_rightwinglet4_8(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 3.1, 27.9> }
      box { <-50, -10, 0> <70, 10, 50> rotate -23.25*y translate <-4, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
          #else
            object { rounded_button() translate <32, 0, 16> }
            object { rounded_button() translate <40, 0, 16> }
            object { rounded_button() translate <48, 0, 16> }
            object { rounded_button() translate <56, 0, 16> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <24, 0, 8> }
            object { rounded_button() translate <32, 0, 8> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() translate <48, 0, 8> }
            object { rounded_button() translate <56, 0, 8> }
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <32, 0, 0> }
            object { rounded_button() translate <40, 0, 0> }
            object { rounded_button() translate <48, 0, 0> }
            object { rounded_button() translate <56, 0, 0> }
          #end
        }
        box { <51.9, -1, 19.9> <60, 4, 28> }
        box { <-50, -10, 0> <70, 10, 50> rotate -23.25*y translate <-4, 0, 4> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <58.4, 2, 26.4> }
            box { <-50, -10, 0> <70, 10, 50> rotate -23.25*y translate <-2.5, 0, 3.5> }
            box { <50.5, -1, 18.5> <60, 3, 28> }
            box { <32, 0.25, 18.5> <51, 3, 19.75> }
            box { <-0.5, 0.25, 2.5> <0.5, 3, 6> }
            box { <15.5, 0.25, 10.5> <16.5, 3, 12> }
            box { <-8, 0.25, -0.5> <-2.5, 3, 0.5> rotate 45*y translate <8, 0, 0> }
            box { <-8, 0.25, -0.5> <-2.5, 3, 0.5> rotate 45*y translate <24, 0, 8> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
          cylinder { -1*y, 2.000001*y, 2.5 translate <32, 0, 16> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <36, 0, 4> }
        object { ring() translate <44, 0, 4> }
        object { ring() translate <52, 0, 4> }
        object { ring() translate <28, 0, 12> }
        object { ring() translate <36, 0, 12> }
        object { ring() translate <44, 0, 12> }
        object { ring() translate <52, 0, 12> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 28> } }
    }
  #end
#end
#macro f_right_wing12_7(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <51.9, 3.1, 91.9> }
      box { <-100, -10, -100> <0, 10, 100> rotate 26*y translate <-4, 0, 8> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <51.9, 3.1, 91.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 80> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 88> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 80> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 88> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <16, 0, 32> }
            object { rounded_button() translate <16, 0, 40> }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <8, 0, 16> }
            object { rounded_button() translate <8, 0, 24> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <16, 0, 16> }
            object { rounded_button() translate <16, 0, 24> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <24, 0, 8> }
            object { rounded_button() translate <24, 0, 16> }
            object { rounded_button() translate <24, 0, 24> }
            object { rounded_button() translate <24, 0, 32> }
            object { rounded_button() translate <24, 0, 40> }
            object { rounded_button() translate <24, 0, 48> }
            object { rounded_button() translate <24, 0, 56> }
            object { rounded_button() translate <32, 0, 0> }
            object { rounded_button() translate <32, 0, 8> }
            object { rounded_button() translate <32, 0, 16> }
            object { rounded_button() translate <32, 0, 24> }
            object { rounded_button() translate <32, 0, 32> }
            object { rounded_button() translate <32, 0, 40> }
            object { rounded_button() translate <32, 0, 48> }
            object { rounded_button() translate <32, 0, 56> }
            object { rounded_button() translate <32, 0, 64> }
            object { rounded_button() translate <32, 0, 72> }
            object { rounded_button() translate <40, 0, 0> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() translate <40, 0, 16> }
            object { rounded_button() translate <40, 0, 24> }
            object { rounded_button() translate <40, 0, 32> }
            object { rounded_button() translate <40, 0, 40> }
            object { rounded_button() translate <40, 0, 48> }
            object { rounded_button() translate <40, 0, 56> }
            object { rounded_button() translate <40, 0, 64> }
            object { rounded_button() translate <40, 0, 72> }
            object { rounded_button() translate <40, 0, 80> }
            object { rounded_button() translate <40, 0, 88> }
            object { rounded_button() translate <48, 0, 80> }
            object { rounded_button() translate <48, 0, 88> }
          #end
        }
        box { <-100, -10, -100> <0, 10, 100> rotate 26*y translate <-4, 0, 8> }
        difference {
          box { <34, -2, 88> <40, 6, 93> }
          cylinder { -1*y, 5*y, 3.9 translate <39.5, 0, 88.3> }
          box { <-50, -10, -50> <50, 10, 0> rotate 26*y translate <39.5, 0, 88.3> }
        }
        box { <43.900001, -1, -4> <52, 2, 76.1> }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 80> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 88> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 80> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 88> }
          difference {
            merge {
              box { <-2.4, -1, -2.4> <42.4, 2, 90.4> }
              box { <-2.4, -2, 77.6> <50.4, 2.000001, 90.400001> }
            }
            box { <-100, -10, -100> <0, 10, 100> rotate 26*y translate <-2, 0, 9> }
          }
        #end
        box { <0, -1, 0> <10, 4, 80> rotate 5.7*y translate <43.9, 0, 4> }
        box { <43.9, -1, -4> <52, 4, 4> }
      }
      #if (setting > 1)
        object { ring() translate <44, 0, 84> }
        object { ring() translate <36, 0, 76> }
        object { ring() translate <36, 0, 68> }
        object { ring() translate <36, 0, 60> }
        object { ring() translate <36, 0, 52> }
        object { ring() translate <36, 0, 44> }
        object { ring() translate <36, 0, 36> }
        object { ring() translate <36, 0, 28> }
        object { ring() translate <36, 0, 20> }
        object { ring() translate <36, 0, 12> }
        object { ring() translate <28, 0, 60> }
        object { ring() translate <28, 0, 52> }
        object { ring() translate <28, 0, 44> }
        object { ring() translate <28, 0, 36> }
        object { ring() translate <28, 0, 28> }
        object { ring() translate <28, 0, 20> }
        object { ring() translate <20, 0, 44> }
        object { ring() translate <20, 0, 36> }
        object { ring() translate <20, 0, 28> }
        object { ring() translate <20, 0, 20> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <12, 0, 28> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <4, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <28, 0, 12> }
        object { ring() translate <36, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <52, 4.9, 92.3> } }
    }
  #end
#end
#macro f_right_wing4_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-2.5, 0, -3.9> <27.9, 3.1, 27.9> }
      box { <-50, -10, 0> <50, 10, 50> rotate -45*y translate <20, 0, 28> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-2.5, 0, -3.9> <27.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() rotate 90*y translate <24, 0, 24> }
            object { rounded_button() rotate 90*y translate <24, 0, 16> }
            object { rounded_button() rotate 90*y translate <24, 0, 8> }
            object { rounded_button() rotate 90*y translate <24, 0, 0> }
            object { rounded_button() rotate 90*y translate <16, 0, 0> }
            object { rounded_button() rotate 90*y translate <16, 0, 8> }
            object { rounded_button() rotate 90*y translate <16, 0, 16> }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
            object { rounded_button() rotate 90*y translate <8, 0, 8> }
          #end
        }
        box { <-4, -1, -4> <4.1, 4, 4.1> }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          difference {
            union {
              box { <-2.4, -1, 6> <4, 2, 12> }
              box { <5.6, -1, -2.4> <26.4, 2, 26.4> }
            }
            box { <-50, -10, 0> <50, 10, 50> rotate -45*y translate <20.2, 0, 26.4> }
          }
        #end
        box { <-50, -10, 0> <50, 10, 50> rotate -45*y translate <20, 0, 28> }
      }
      #if (setting > 1)
        object { ring() translate <12, 0, 4> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <20, 0, 20> }
      #end
      box { <-0.5, 0.000001, -0.5> <1.5, 2.1, 0.5> rotate 45*y translate <13, 0, 20> }
      texture { color_tex }
      bounded_by { box { <-3, -0.1, -4> <28, 4.9, 28> } }
    }
  #end
#end
#macro f_ring1_1(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 3.1, 3.9> }
      cylinder { -1.5*z, 1.5*z, 3.1 translate <8, 2.25, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <3.9, 3.1, 3.9> }
        box { <3, 0.000001, -1.25> <6, 3.099999, 1.25> }
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 }
        #else
          object { rounded_button() }
        #end
        cylinder { -1.5*z, 1.5*z, 3.1 translate <8, 2.25, 0> }
        object { open_rounded_button() rotate 90*x translate <8, 2.25, -1.6> }
        object { open_rounded_button() rotate -90*x translate <8, 2.25, 1.6> }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
        cylinder { 1*y, 4*y, 1.2 }
      #end
      cylinder { -4*z, 4*z, 1.600001 translate <8, 2.25, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.95, -4> <11.2, 5.45, 4> } }
    }
  #end
#end
#macro f_sideleft3_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 3.1, 11.9> }
      box { <-30, -1, 0> <30, 10, 20> rotate 18.4*y translate <8, 0, 8> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
            object { rounded_button() rotate 180*y translate <16, 0, 0> }
          #end
        }
        box { <-30, -1, 0> <30, 10, 20> rotate 18.4*y translate <8, 0, 8> }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          difference {
            box { <-2.4, -1, -2.4> <18.4, 2, 12> }
            box { <-30, -1, 0> <30, 10, 20> rotate 18.4*y translate <8, 0, 6.7> }
          }
          box { <-2.5, -1, -2> <2.5, 2.000005, 5> rotate 18.4*y translate <8, 0, 8> }
          box { <-1.5, -1, -2> <2.5, 2.000005, 3> rotate 18.4*y translate <0, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        difference {
          object { ring() translate <12, 0, 4> }
          box { <-30, -1, 0> <30, 10, 20> rotate 18.4*y translate <8, 0, 7.999995> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 4.9, 12> } }
    }
  #end
#end
#macro f_sideleft4_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
      box { <0, -1, 0> <40, 10, 20> rotate 15*y translate <-3.9, 0, 11.7> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 11.7> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
            object { rounded_button() rotate 180*y translate <16, 0, 0> }
            object { rounded_button() rotate 180*y translate <24, 0, 0> }
          #end
        }
        box { <0, -1, 0> <40, 10, 20> rotate 15*y translate <-3.9, 0, 11.7> }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          difference {
            box { <-2.4, -1, -2.4> <26.4, 2, 12> }
            box { <0, -1, 0> <40, 10, 20> rotate 15*y translate <-3.9, 0, 10.2> }
          }
          box { <-1.9, -1, -1.5> <3, 2.000001, 3> rotate 15*y translate <0, 0, 8> }
          box { <-2.5, -1, -2> <2.5, 2.000002, 5> rotate 15*y translate <8, 0, 8> }
          box { <-2.5, -1, -4> <1.5, 2.000003, 5> rotate 15*y translate <16, 0, 8> }
          cylinder { -1*y, 3*y, 2.600001 translate <12, 0, 4> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { ring() translate <4, 0, 4> }
            object { ring() translate <12, 0, 4> }
            object { ring() translate <20, 0, 4> }
          }
          box { <0, -1, 0> <40, 3, 20> rotate 15*y translate <-3.9, 0, 11.699995> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 4.9, 11.8> } }
    }
  #end
#end
#macro f_sideright3_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 3.1, 11.9> }
      box { <-30, -1, -20> <30, 10, 0> rotate -18.4*y translate <8, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
          #else
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <16, 0, 8> }
          #end
        }
        box { <-30, -1, -20> <30, 10, 0> rotate -18.4*y translate <8, 0, 0> }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          difference {
            box { <-2.4, -1, -4> <18.4, 2, 10.4> }
            box { <-30, -1, -20> <30, 10, 0> rotate -18.4*y translate <8, 0, 1.3> }
          }
          box { <-2.5, -1, -5> <2.5, 2.000005, 2> rotate -18.4*y translate <8, 0, 0> }
          box { <-1.5, -1, -5> <2.5, 2.000005, 2> rotate -18.4*y }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        difference {
          object { ring() translate <12, 0, 4> }
          box { <-30, -1, -20> <30, 10, 0> rotate -18.4*y translate <8, 0, 0.000005> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 4.9, 12> } }
    }
  #end
#end
#macro f_sideright4_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
      box { <0, -1, -20> <40, 10, 0> rotate -15*y translate <-3.9, 0, -3.7> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 11.7> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
          #else
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <16, 0, 8> }
            object { rounded_button() rotate 180*y translate <24, 0, 8> }
          #end
        }
        box { <0, -1, -20> <40, 10, 0> rotate -15*y translate <-3.9, 0, -3.7> }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          difference {
            box { <-2.4, -1, -2.4> <26.4, 2, 10.4> }
            box { <0, -1, -20> <40, 10, 0> rotate -15*y translate <-3.9, 0, -2.2> }
          }
          box { <-1.9, -1, -3> <3, 2.000001, 1.5> rotate -15*y translate <0, 0, 0> }
          box { <-2.5, -1, -5> <2.5, 2.000002, 2> rotate -15*y translate <8, 0, 0> }
          box { <-2.5, -1, -5> <1.5, 2.000003, 4> rotate -15*y translate <16, 0, 0> }
          cylinder { -1*y, 3*y, 2.600001 translate <12, 0, 4> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { ring() translate <4, 0, 4> }
            object { ring() translate <12, 0, 4> }
            object { ring() translate <20, 0, 4> }
          }
          box { <0, -1, -20> <40, 3, 0> rotate -15*y translate <-3.9, 0, -3.699995> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 4.9, 11.8> } }
    }
  #end
#end
#macro f_slope2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
      box { <-20, 0, -10> <10, 10, 30> rotate 24.5*z translate <12, 9.5, 0> }
      box { <-10, 0, -10> <20, 10, 30> rotate -24.5*z translate <-4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
          box { <-20, 0, -10> <10, 10, 30> texture { color_tex normal { bumping } }
            rotate 24.5*z translate <12, 9.5, 0> }
          box { <-10, 0, -10> <20, 10, 30> texture { color_tex normal { bumping } }
            rotate -24.5*z translate <-4, 9.5, 0> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 8.6, 10.4> }
            box { <-20, 0, -10> <10, 10, 30> rotate 24.5*z translate <12, 7.5, 0> }
            box { <-10, 0, -10> <20, 10, 30> rotate -24.5*z translate <-4, 7.5, 0> }
          }
        #end
      }
      #if (setting > 1)
        difference {
          object { high_ring() translate <4, 0, 4> }
          box { <3.25, -1, 0> <4.75, 3.8, 8> }
          box { <-20, 0, -10> <10, 10, 30> rotate 24.5*z translate <12, 7.5, 0> }
          box { <-10, 0, -10> <20, 10, 30> rotate -24.5*z translate <-4, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 6.3, 12> } }
    }
  #end
#end
#macro f_slope4_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 27.9> }
      box { <-20, 0, -10> <10, 10, 30> rotate 24.5*z translate <12, 9.5, 0> }
      box { <-10, 0, -10> <20, 10, 30> rotate -24.5*z translate <-4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 27.9> }
          box { <-20, 0, -10> <10, 10, 30> texture { color_tex normal { bumping } }
            rotate 24.5*z translate <12, 9.5, 0> }
          box { <-10, 0, -10> <20, 10, 30> texture { color_tex normal { bumping } }
            rotate -24.5*z translate <-4, 9.5, 0> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 8.6, 26.4> }
            box { <-20, 0, -10> <10, 10, 30> rotate 24.5*z translate <12, 7.5, 0> }
            box { <-10, 0, -10> <20, 10, 30> rotate -24.5*z translate <-4, 7.5, 0> }
          }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { high_ring() translate <4, 0, 4> }
            object { high_ring() translate <4, 0, 12> }
            object { high_ring() translate <4, 0, 20> }
          }
          box { <3.25, -1, 0> <4.75, 3.8, 24> }
          box { <-20, 0, -10> <10, 10, 30> rotate 24.5*z translate <12, 7.5, 0> }
          box { <-10, 0, -10> <20, 10, 30> rotate -24.5*z translate <-4, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 6.3, 28> } }
    }
  #end
#end
#macro f_swivel1block1_2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -0.000001*y, 1.5*y, 3 }
      box { <0.1, 0, -7.9> <15.9, 3.1, -0.1> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { -0.000001*y, 1.5*y, 3 }
          box { <0.1, 0, -7.9> <15.9, 3.1, -0.1> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <4, 0, -4> }
            cylinder { 3*y, 4.8*y, 2.4 translate <12, 0, -4> }
          #else
            object { rounded_button() rotate 180*y translate <4, 0, -4> }
            object { rounded_button() rotate 180*y translate <12, 0, -4> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <1.6, -1, -6.4> <14.4, 2, -1.6> }
            cylinder { -1*y, 3*y, 3.000001 }
          }
          cylinder { -1*y, 3*y, 1.5 }
          cylinder { 1.500001*y, 4*y, 3.15 }
          cylinder { 1*y, 4*y, 1.2 translate <4, 0, -4> }
          cylinder { 1*y, 4*y, 1.2 translate <12, 0, -4> }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <8, 0, -4> }
      #end
      texture { color_tex }
      bounded_by { box { <-3.1, -0.1, -8> <16, 4.9, 3.1> } }
    }
  #end
#end
#macro f_swivel2block1_2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 1.6*y, 3.100001*y, 3 }
      box { <0.1, 0, 0.1> <15.9, 3.1, 7.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { 1.6*y, 3.100001*y, 3 }
          box { <0.1, 0, 0.1> <15.9, 3.1, 7.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <4, 0, 4> }
            cylinder { 3*y, 4.8*y, 2.4 translate <12, 0, 4> }
          #else
            object { rounded_button() translate <4, 0, 4> }
            object { rounded_button() translate <12, 0, 4> }
          #end
        }
        #if (setting > 1)
          box { <-3, -1, -4> <3, 1.600001, 4> rotate -45*y }
          box { <-3, -2, -1.75> <5, 1.600002, 1.75> rotate -45*y }
          box { <1.6, -1, 1.6> <14.4, 2, 6.4> }
          cylinder { 1*y, 4*y, 1.2 translate <4, 0, 4> }
          cylinder { 1*y, 4*y, 1.2 translate <12, 0, 4> }
        #end
      }
      difference {
        merge {
          cylinder { 0*y, 1.7*y, 1.3 }
          cylinder { -0.000001*y, 0.5*y, 1.4 }
        }
        box { <-1.75, -1, -0.4> <1.75, 1.599999, 0.4> rotate 45*y }
      }
      #if (setting > 1)
        object { pin(2) translate <8, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-3.1, -0.1, -3.1> <16, 4.9, 8> } }
    }
  #end
#end
#macro f_swivelbottom4_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <32.1, 3.1, 11.9> }
      cylinder { -3.900001*z, 11.900001*z, 3.5 translate <32.1, 2.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <32.1, 3.1, 11.9> }
          cylinder { -3.900001*z, 11.900001*z, 3.5 translate <32.1, 2.5, 0> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <24, 0, 0> }
            object { rounded_button() rotate 180*y translate <24, 0, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.6 translate <20, 0, 4> }
        #end
        cylinder { -4*z, 12*z, 2.4 translate <32.1, 2.5, 0> }
        box { <27.9, -1.5, 0> <37, 6.5, 8> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -1.1, -4> <36, 6.1, 12> } }
    }
  #end
#end
#macro f_swivelbottom8_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <64.1, 3.1, 11.9> }
      cylinder { -3.900001*z, 11.900001*z, 3.5 translate <64.1, 2.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <64.1, 3.1, 11.9> }
          cylinder { -3.900001*z, 11.900001*z, 3.5 translate <64.1, 2.5, 0> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <16, 0, 0> }
            object { rounded_button() rotate 180*y translate <16, 0, 8> }
            object { rounded_button() rotate 180*y translate <24, 0, 0> }
            object { rounded_button() rotate 180*y translate <24, 0, 8> }
            object { rounded_button() rotate 180*y translate <32, 0, 0> }
            object { rounded_button() rotate 180*y translate <32, 0, 8> }
            object { rounded_button() rotate 180*y translate <40, 0, 0> }
            object { rounded_button() rotate 180*y translate <40, 0, 8> }
            object { rounded_button() rotate 180*y translate <48, 0, 0> }
            object { rounded_button() rotate 180*y translate <48, 0, 8> }
            object { rounded_button() rotate 180*y translate <56, 0, 0> }
            object { rounded_button() rotate 180*y translate <56, 0, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <58.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 1*y, 4*y, 1.6 translate <52, 0, 4> }
        #end
        cylinder { -4*z, 12*z, 2.4 translate <64.1, 2.5, 0> }
        box { <59.9, -1.5, 0> <69, 6.5, 8> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <36, 0, 4> }
        object { ring() translate <44, 0, 4> }
        object { ring() translate <52, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -1.1, -4> <68, 6.1, 12> } }
    }
  #end
#end
#macro f_swiveltop4_2(color_tex)
  #if (setting = 0)
    box { <-36, 0.8, -3.9> <0, 3.9, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-36, 0.8, -3.9> <0, 3.9, 11.9> }
          #if (setting < 3)
            cylinder { 3.8*y, 5.6*y, 2.4 translate <-32.1, 0, 0> }
            cylinder { 3.8*y, 5.6*y, 2.4 translate <-24.1, 0, 0> }
            cylinder { 3.8*y, 5.6*y, 2.4 translate <-16.1, 0, 0> }
            cylinder { 3.8*y, 5.6*y, 2.4 translate <-8.1, 0, 0> }
            cylinder { 3.8*y, 5.6*y, 2.4 translate <-32.1, 0, 8> }
            cylinder { 3.8*y, 5.6*y, 2.4 translate <-24.1, 0, 8> }
            cylinder { 3.8*y, 5.6*y, 2.4 translate <-16.1, 0, 8> }
            cylinder { 3.8*y, 5.6*y, 2.4 translate <-8.1, 0, 8> }
          #else
            object { rounded_button() translate <-32.1, 0.8, 0> }
            object { rounded_button() translate <-24.1, 0.8, 0> }
            object { rounded_button() translate <-16.1, 0.8, 0> }
            object { rounded_button() translate <-8.1, 0.8, 0> }
            object { rounded_button() translate <-32.1, 0.8, 8> }
            object { rounded_button() translate <-24.1, 0.8, 8> }
            object { rounded_button() translate <-16.1, 0.8, 8> }
            object { rounded_button() translate <-8.1, 0.8, 8> }
          #end
        }
        cylinder { 0.099999*z, -4*z, 3.7 }
        cylinder { 7.799999*z, 12*z, 3.7 }
        box { <-4.3, 1.9, -2.4> <0.9, 4, 0> }
        box { <-4.3, 1.9, 8> <0.9, 4, 10.4> }
        box { <-4.3, 1.9, 2.1> <0.9, 4, 5.9> }
        #if (setting > 1)
          box { <-34.5, 0, -2.4> <-5.7, 2.9, 10.4> }
          cylinder { 1.8*y, 4.8*y, 1.2 translate <-32.1, 0, 0> }
          cylinder { 1.8*y, 4.8*y, 1.2 translate <-24.1, 0, 0> }
          cylinder { 1.8*y, 4.8*y, 1.2 translate <-16.1, 0, 0> }
          cylinder { 1.8*y, 4.8*y, 1.2 translate <-8.1, 0, 0> }
          cylinder { 1.8*y, 4.8*y, 1.2 translate <-32.1, 0, 8> }
          cylinder { 1.8*y, 4.8*y, 1.2 translate <-24.1, 0, 8> }
          cylinder { 1.8*y, 4.8*y, 1.2 translate <-16.1, 0, 8> }
          cylinder { 1.8*y, 4.8*y, 1.2 translate <-8.1, 0, 8> }
          cylinder { 1.5*y, 5.5*y, 1.6 translate <-12.1, 0, 4> }
        #end
      }
      difference {
        merge {
          cylinder { 0.1*z, 7.8*z, 3.5 }
          cylinder { -1.9*z, 9.8*z, 2.3 }
        }
        cylinder { -4*z, 3.5*z, 1.25 }
        cylinder { 12*z, 4.5*z, 1.25 }
        cylinder { 3*z, 5*z, 0.75 }
      }
      #if (setting > 1)
        object { ring() translate <-28.1, 0.8, 4> }
        object { ring() translate <-20.1, 0.8, 4> }
        object { ring() translate <-12.1, 0.8, 4> }
        box { <-34.7, 1.3, 3.5> <-31.1, 3, 4.5> }
        box { <-25.1, 1.3, 3.5> <-23.1, 3, 4.5> }
        box { <-17.1, 1.3, 3.5> <-15.1, 3, 4.5> }
        box { <-9.1, 1.3, 2.5> <-5.5, 3, 5.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-36.1, -3.6, -4> <3.9, 5.7, 12> } }
    }
  #end
#end
#macro f_triangle2_2(color_tex, age)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      box { <3.9, -1, -5> <13, 4, 4.1> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() rotate 90*y translate <0, 0, 0> }
            object { rounded_button() rotate 90*y translate <0, 0, 8> }
            object { rounded_button() rotate 90*y translate <8, 0, 8> }
          #end
          difference {
            box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
            box { <3.9, -1, -5> <13, 4, 4.1> }
          }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 2, 10.4> }
          box { <2, -1, 5.6> <10.4, 2.000001, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { pin(age) translate <0, 0, 4> }
        object { pin(age) translate <4, 0, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 4.9, 12> } }
    }
  #end
#end
#macro f_triangle4_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> }
      box { <11.9, -1, -5> <28, 4, 11.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <0, 0, 16> }
            object { rounded_button() rotate 180*y translate <0, 0, 24> }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 16> }
            object { rounded_button() rotate 180*y translate <8, 0, 24> }
            object { rounded_button() rotate 180*y translate <16, 0, 16> }
            object { rounded_button() rotate 180*y translate <24, 0, 16> }
            object { rounded_button() rotate 180*y translate <16, 0, 24> }
            object { rounded_button() rotate 180*y translate <24, 0, 24> }
          #end
          difference {
            box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> }
            box { <11.9, -1, -5> <28, 4, 11.9> }
          }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 26.4> }
          box { <10, -1, 13.6> <26.4, 2.000001, 26.400001> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 20> }
        box { <-3, 0.000001, -0.6> <0, 2.1, 0.6> rotate 45*y translate <12, 0, 12> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 4.9, 28> } }
    }
  #end
#end
#macro f_wing9_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <67.9, 3.1, 27.9> }
      box { <0, -10, -10> <70, 10, 0> rotate -5*y translate <20, 0, -4> }
      box { <0, -10, 0> <70, 10, 10> rotate 5*y translate <20, 0, 28> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <67.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 16> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
            object { rounded_button() rotate 180*y translate <16, 0, 0> }
            object { rounded_button() rotate 180*y translate <24, 0, 0> }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <16, 0, 8> }
            object { rounded_button() rotate 180*y translate <24, 0, 8> }
            object { rounded_button() rotate 180*y translate <0, 0, 16> }
            object { rounded_button() rotate 180*y translate <8, 0, 16> }
            object { rounded_button() rotate 180*y translate <16, 0, 16> }
            object { rounded_button() rotate 180*y translate <24, 0, 16> }
            object { rounded_button() rotate 180*y translate <0, 0, 24> }
            object { rounded_button() rotate 180*y translate <8, 0, 24> }
            object { rounded_button() rotate 180*y translate <16, 0, 24> }
            object { rounded_button() rotate 180*y translate <24, 0, 24> }
            object { rounded_button() rotate 180*y translate <32, 0, 8> }
            object { rounded_button() rotate 180*y translate <40, 0, 8> }
            object { rounded_button() rotate 180*y translate <48, 0, 8> }
            object { rounded_button() rotate 180*y translate <56, 0, 8> }
            object { rounded_button() rotate 180*y translate <32, 0, 16> }
            object { rounded_button() rotate 180*y translate <40, 0, 16> }
            object { rounded_button() rotate 180*y translate <48, 0, 16> }
            object { rounded_button() rotate 180*y translate <56, 0, 16> }
            object { rounded_button() rotate 180*y translate <64, 0, 8> }
            object { rounded_button() rotate 180*y translate <64, 0, 16> }
          #end
        }
        box { <0, -10, -10> <70, 10, 0> rotate -5*y translate <20, 0, -4> }
        box { <0, -10, 0> <70, 10, 10> rotate 5*y translate <20, 0, 28> }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 16> }
          box { <-2.4, -1, -2.4> <26.4, 2, 26.4> }
          box { <26.3, -1, 5.4> <66.4, 2.000001, 18.4> }
          difference {
            box { <28, -1, -2.4> <66.4, 2, 4> }
            box { <0, -10, -10> <70, 10, 0> rotate -5*y translate <20, 0, -2.8> }
          }
          difference {
            box { <28, -1, 20> <66.4, 2, 26.4> }
            box { <0, -10, 0> <70, 10, 10> rotate 5*y translate <20, 0, 26.8> }
          }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <20, 0, 20> }
        object { ring() translate <28, 0, 12> }
        object { ring() translate <36, 0, 12> }
        object { ring() translate <44, 0, 12> }
        object { ring() translate <52, 0, 12> }
        object { ring() translate <60, 0, 12> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <68, 4.9, 28> } }
    }
  #end
#end
#macro f_winglet10_10(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <75.9, 3.1, 75.9> }
      box { <-4, -1, -4> <28.1, 4, 28.1> }
      box { <-100, -10, 0> <100, 10, 100> rotate 45*y translate <76, 0, 28> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <75.9, 3.1, 75.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 32> }
          #else
            object { rounded_button() rotate 90*y translate <0, 0, 32> }
            object { rounded_button() rotate 90*y translate <8, 0, 32> }
            object { rounded_button() rotate 90*y translate <16, 0, 32> }
            object { rounded_button() rotate 90*y translate <24, 0, 32> }
            object { rounded_button() rotate 90*y translate <0, 0, 40> }
            object { rounded_button() rotate 90*y translate <8, 0, 40> }
            object { rounded_button() rotate 90*y translate <16, 0, 40> }
            object { rounded_button() rotate 90*y translate <24, 0, 40> }
            object { rounded_button() rotate 90*y translate <0, 0, 48> }
            object { rounded_button() rotate 90*y translate <8, 0, 48> }
            object { rounded_button() rotate 90*y translate <16, 0, 48> }
            object { rounded_button() rotate 90*y translate <24, 0, 48> }
            object { rounded_button() rotate 90*y translate <0, 0, 56> }
            object { rounded_button() rotate 90*y translate <8, 0, 56> }
            object { rounded_button() rotate 90*y translate <16, 0, 56> }
            object { rounded_button() rotate 90*y translate <24, 0, 56> }
            object { rounded_button() rotate 90*y translate <0, 0, 64> }
            object { rounded_button() rotate 90*y translate <8, 0, 64> }
            object { rounded_button() rotate 90*y translate <16, 0, 64> }
            object { rounded_button() rotate 90*y translate <24, 0, 64> }
            object { rounded_button() rotate 90*y translate <0, 0, 72> }
            object { rounded_button() rotate 90*y translate <8, 0, 72> }
            object { rounded_button() rotate 90*y translate <16, 0, 72> }
            object { rounded_button() rotate 90*y translate <24, 0, 72> }
            object { rounded_button() rotate 90*y translate <32, 0, 0> }
            object { rounded_button() rotate 90*y translate <32, 0, 8> }
            object { rounded_button() rotate 90*y translate <32, 0, 16> }
            object { rounded_button() rotate 90*y translate <32, 0, 24> }
            object { rounded_button() rotate 90*y translate <32, 0, 32> }
            object { rounded_button() rotate 90*y translate <32, 0, 40> }
            object { rounded_button() rotate 90*y translate <32, 0, 48> }
            object { rounded_button() rotate 90*y translate <32, 0, 56> }
            object { rounded_button() rotate 90*y translate <32, 0, 64> }
            object { rounded_button() rotate 90*y translate <40, 0, 0> }
            object { rounded_button() rotate 90*y translate <40, 0, 8> }
            object { rounded_button() rotate 90*y translate <40, 0, 16> }
            object { rounded_button() rotate 90*y translate <40, 0, 24> }
            object { rounded_button() rotate 90*y translate <40, 0, 32> }
            object { rounded_button() rotate 90*y translate <40, 0, 40> }
            object { rounded_button() rotate 90*y translate <40, 0, 48> }
            object { rounded_button() rotate 90*y translate <40, 0, 56> }
            object { rounded_button() rotate 90*y translate <48, 0, 0> }
            object { rounded_button() rotate 90*y translate <48, 0, 8> }
            object { rounded_button() rotate 90*y translate <48, 0, 16> }
            object { rounded_button() rotate 90*y translate <48, 0, 24> }
            object { rounded_button() rotate 90*y translate <56, 0, 0> }
            object { rounded_button() rotate 90*y translate <56, 0, 8> }
            object { rounded_button() rotate 90*y translate <56, 0, 16> }
            object { rounded_button() rotate 90*y translate <56, 0, 24> }
            object { rounded_button() rotate 90*y translate <64, 0, 0> }
            object { rounded_button() rotate 90*y translate <64, 0, 8> }
            object { rounded_button() rotate 90*y translate <64, 0, 16> }
            object { rounded_button() rotate 90*y translate <64, 0, 24> }
            object { rounded_button() rotate 90*y translate <72, 0, 0> }
            object { rounded_button() rotate 90*y translate <72, 0, 8> }
            object { rounded_button() rotate 90*y translate <72, 0, 16> }
            object { rounded_button() rotate 90*y translate <72, 0, 24> }
            object { rounded_button() rotate 90*y translate <48, 0, 32> }
            object { rounded_button() rotate 90*y translate <48, 0, 40> }
            object { rounded_button() rotate 90*y translate <48, 0, 48> }
            object { rounded_button() rotate 90*y translate <56, 0, 32> }
            object { rounded_button() rotate 90*y translate <56, 0, 40> }
            object { rounded_button() rotate 90*y translate <64, 0, 32> }
          #end
        }
        box { <-4, -1, -4> <28.1, 4, 28.1> }
        box { <-100, -10, 0> <100, 10, 100> rotate 45*y translate <76, 0, 28> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <74.4, 2, 74.4> }
            box { <-3, -2, -3> <29.6, 3, 29.6> }
            box { <-100, -10, 0> <100, 10, 100> rotate 45*y translate <75, 0, 27> }
            box { <19.5, -1, 29> <20.5, 3, 33.5> }
            box { <27.5, -1, 29> <28.5, 3, 33.5> }
            box { <29, -1, 19.5> <33.5, 3, 20.5> }
            box { <29, -1, 27.5> <33.5, 3, 28.5> }
            box { <39, -1, 27.5> <41, 3, 28.5> }
            box { <23, -1, 35.5> <25, 3, 36.5> }
            box { <31, -1, 35.5> <33, 3, 36.5> }
            box { <39, -1, 35.5> <41, 3, 36.5> }
            box { <47, -1, 35.5> <49, 3, 36.5> }
            box { <31, -1, 43.5> <33, 3, 44.5> }
            box { <39, -1, 43.5> <41, 3, 44.5> }
            box { <47, -1, 43.5> <49, 3, 44.5> }
            box { <39, -1, 51.5> <41, 3, 52.5> }
            box { <35.5, -1, 47> <36.5, 3, 49> }
            box { <43.5, -1, 47> <44.5, 3, 49> }
            box { <27.5, -1, 39> <28.5, 3, 41> }
            box { <35.5, -1, 39> <36.5, 3, 41> }
            box { <43.5, -1, 39> <44.5, 3, 41> }
            box { <51.5, -1, 39> <52.5, 3, 41> }
            box { <35.5, -1, 31> <36.5, 3, 33> }
            box { <43.5, -1, 31> <44.5, 3, 33> }
            box { <35.5, -1, 23> <36.5, 3, 25> }
            box { <-3, -1, -0.5> <3, 3, 0.5> rotate -45*y translate <68, 0, 36> }
            box { <-3, -1, -0.5> <3, 3, 0.5> rotate -45*y translate <60, 0, 44> }
            box { <-3, -1, -0.5> <3, 3, 0.5> rotate -45*y translate <52, 0, 52> }
            box { <-3, -1, -0.5> <3, 3, 0.5> rotate -45*y translate <44, 0, 60> }
            box { <-3, -1, -0.5> <3, 3, 0.5> rotate -45*y translate <36, 0, 68> }
          }
          box { <-2.7, -1, -5> <2.7, 1.999999, 5> rotate 45*y translate <32, 0, 72> }
          box { <-2.7, -1, -5> <2.7, 1.999999, 5> rotate 45*y translate <40, 0, 64> }
          box { <-2.7, -1, -5> <2.7, 1.999999, 5> rotate 45*y translate <48, 0, 56> }
          box { <-2.7, -1, -5> <2.7, 1.999999, 5> rotate 45*y translate <56, 0, 48> }
          box { <-2.7, -1, -5> <2.7, 1.999999, 5> rotate 45*y translate <64, 0, 40> }
          box { <-2.7, -1, -5> <2.7, 1.999999, 5> rotate 45*y translate <72, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 32> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <36, 0, 4> }
        object { ring() translate <44, 0, 4> }
        object { ring() translate <52, 0, 4> }
        object { ring() translate <36, 0, 12> }
        object { ring() translate <44, 0, 12> }
        object { ring() translate <52, 0, 12> }
        object { ring() translate <36, 0, 20> }
        object { ring() translate <44, 0, 20> }
        object { ring() translate <52, 0, 20> }
        object { ring() translate <60, 0, 4> }
        object { ring() translate <60, 0, 12> }
        object { ring() translate <60, 0, 20> }
        object { ring() translate <68, 0, 4> }
        object { ring() translate <68, 0, 12> }
        object { ring() translate <68, 0, 20> }
        object { ring() translate <36, 0, 28> }
        object { ring() translate <44, 0, 28> }
        object { ring() translate <52, 0, 28> }
        object { ring() translate <60, 0, 28> }
        object { ring() translate <68, 0, 28> }
        object { ring() translate <4, 0, 36> }
        object { ring() translate <12, 0, 36> }
        object { ring() translate <20, 0, 36> }
        object { ring() translate <28, 0, 36> }
        object { ring() translate <36, 0, 36> }
        object { ring() translate <44, 0, 36> }
        object { ring() translate <52, 0, 36> }
        object { ring() translate <60, 0, 36> }
        object { ring() translate <4, 0, 44> }
        object { ring() translate <12, 0, 44> }
        object { ring() translate <20, 0, 44> }
        object { ring() translate <28, 0, 44> }
        object { ring() translate <36, 0, 44> }
        object { ring() translate <44, 0, 44> }
        object { ring() translate <52, 0, 44> }
        object { ring() translate <4, 0, 52> }
        object { ring() translate <12, 0, 52> }
        object { ring() translate <20, 0, 52> }
        object { ring() translate <28, 0, 52> }
        object { ring() translate <36, 0, 52> }
        object { ring() translate <44, 0, 52> }
        object { ring() translate <4, 0, 60> }
        object { ring() translate <12, 0, 60> }
        object { ring() translate <20, 0, 60> }
        object { ring() translate <28, 0, 60> }
        object { ring() translate <36, 0, 60> }
        object { ring() translate <4, 0, 68> }
        object { ring() translate <12, 0, 68> }
        object { ring() translate <20, 0, 68> }
        object { ring() translate <28, 0, 68> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 4.9, 76> } }
    }
  #end
#end
#macro f_winglet2_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 27.9> }
      box { <-20, -10, -10> <20, 10, 0> rotate -18.4*y translate <0, 0, 0> }
      box { <-20, -10, 0> <20, 10, 10> rotate 18.4*y translate <0, 0, 24> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.2> <11.9, 3.1, 27.2> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
          #else
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <0, 0, 16> }
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 16> }
          #end
        }
        box { <-20, -10, -10> <20, 10, 0> rotate -26.4*y translate <12, 0, 4> }
        box { <-20, -10, 0> <20, 10, 10> rotate 26.4*y translate <12, 0, 20> }
        #if (setting > 1)
          box { <-2.5, -1, -2> <2.5, 2.000001, 0.25> rotate -26.4*y translate <0, 0, 0> }
          box { <-2.5, -1, -0.25> <2.5, 2.000001, 2> rotate 26.4*y translate <0, 0, 24> }
          cylinder { -1*y, 2*y, 2.5 translate <8, 0, 0> }
          cylinder { -1*y, 2*y, 2.5 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          difference {
            box { <-2.4, -1, -4> <10.4, 2, 28> }
            box { <-20, -10, -10> <20, 10, 0> rotate -26.4*y translate <12, 0, 5.8> }
            box { <-20, -10, 0> <20, 10, 10> rotate 26.4*y translate <12, 0, 18.2> }
          }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 12> }
        box { <-3, 0.000002, 5.6> <11, 2.1, 4.5> }
        box { <-3, 0.000002, 18.4> <11, 2.1, 19.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -3.3> <12, 4.5, 29.3> } }
    }
  #end
#end
#macro f_winglet3_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 3.1, 19.9> }
      box { <30, -10, -50> <-30, 10, 0> rotate 45*y translate <11.9, 0, -3.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 3.1, 19.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
          #else
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <0, 0, 16> }
            object { rounded_button() translate <8, 0, 16> }
            object { rounded_button() translate <16, 0, 16> }
          #end
        }
        box { <30, -10, -50> <-30, 10, 0> rotate 45*y translate <11.9, 0, -3.9> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <18.4, 2, 18.4> }
            box { <30, -10, -50> <-30, 10, 0> rotate 45*y translate <12.9, 0, -2.9> }
          }
          box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate 45*y translate <0, 0, 8> }
          box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate 45*y translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 12> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <12, 0, 12> }
        box { <11.5, 0.000001, 6.9> <12.5, 2.1, 9.1> }
        box { <6.9, 0.000001, 11.5> <9.1, 2.1, 12.5> }
        box { <0.1, 0.25, -0.5> <3, 2.1, 0.5> rotate -45*y translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 4.9, 20> } }
    }
  #end
#end
#macro f_winglet3_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 3.1, 27.9> }
      box { <-20, -10, -10> <20, 10, 0> rotate -18.4*y translate <8, 0, 0> }
      box { <-20, -10, 0> <20, 10, 10> rotate 18.4*y translate <8, 0, 24> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
          #else
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 16> }
            object { rounded_button() rotate 180*y translate <16, 0, 8> }
            object { rounded_button() rotate 180*y translate <16, 0, 16> }
          #end
        }
        box { <-5, -1, 3.9> <4.1, 4, 20.1> }
        box { <-20, -10, -10> <20, 10, 0> rotate -18.4*y translate <8, 0, 0> }
        box { <-20, -10, 0> <20, 10, 10> rotate 18.4*y translate <8, 0, 24> }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          difference {
            box { <-2.4, -1, -4> <18.4, 2, 28> }
            box { <-20, -10, -10> <20, 10, 0> rotate -18.4*y translate <8, 0, 1.3> }
            box { <-20, -10, 0> <20, 10, 10> rotate 18.4*y translate <8, 0, 22.7> }
            box { <-5, -1, 2.4> <5.4, 4, 21.6> }
          }
          box { <-5, -1, 3.4> <4.100001, 0.55, 20.6> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <12, 0, 12> }
        box { <4.4, 0.000003, 21.5> <5.400001, 2.1, 24> }
        box { <4.4, 0.000003, 0> <5.400001, 2.1, 2.5> }
        box { <5, 0.000002, 5> <16, 2.1, 6> }
        box { <15, 0.000001, 3> <16, 2.1, 6.000001> }
        box { <5, 0.000002, 18> <16.000001, 2.1, 19> }
        box { <15, 0.000001, 18.000001> <16, 2.1, 21> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 4.5, 28> } }
    }
  #end
#end
#macro f_winglet3_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 3.1, 19.9> }
      box { <30, -10, -50> <-30, 10, 0> rotate -45*y translate <28.1, 0, -3.9> }
      box { <30, -10, -50> <-30, 10, 0> rotate 45*y translate <11.9, 0, -3.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 19.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
          #else
            object { rounded_button() rotate -90*y translate <8, 0, 8> }
            object { rounded_button() rotate -90*y translate <16, 0, 8> }
            object { rounded_button() rotate -90*y translate <24, 0, 8> }
            object { rounded_button() rotate -90*y translate <32, 0, 8> }
            object { rounded_button() rotate -90*y translate <0, 0, 16> }
            object { rounded_button() rotate -90*y translate <8, 0, 16> }
            object { rounded_button() rotate -90*y translate <16, 0, 16> }
            object { rounded_button() rotate -90*y translate <24, 0, 16> }
            object { rounded_button() rotate -90*y translate <16, 0, 0> }
            object { rounded_button() rotate -90*y translate <40, 0, 16> }
            object { rounded_button() rotate -90*y translate <32, 0, 16> }
            object { rounded_button() rotate -90*y translate <24, 0, 0> }
          #end
        }
        box { <30, -10, -50> <-30, 10, 0> rotate -45*y translate <28.1, 0, -3.9> }
        box { <30, -10, -50> <-30, 10, 0> rotate 45*y translate <11.9, 0, -3.9> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <42.4, 2, 18.4> }
            box { <30, -10, -50> <-30, 10, 0> rotate -45*y translate <27.1, 0, -2.9> }
            box { <30, -10, -50> <-30, 10, 0> rotate 45*y translate <12.9, 0, -2.9> }
          }
          box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate 45*y translate <0, 0, 8> }
          box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate 45*y translate <8, 0, 0> }
          box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate -45*y translate <32, 0, 0> }
          box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate -45*y translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <28, 0, 12> }
        object { ring() translate <36, 0, 12> }
        box { <19.5, 0.000001, 14.9> <20.5, 2.1, 18.6> }
        box { <19.5, 0.000001, 6.9> <20.5, 2.1, 9.1> }
        box { <11.5, 0.000001, 6.9> <12.5, 2.1, 9.1> }
        box { <27.5, 0.000001, 6.9> <28.5, 2.1, 9.1> }
        box { <6.9, 0.000001, 11.5> <9.1, 2.1, 12.5> }
        box { <14.9, 0.000001, 11.5> <17.1, 2.1, 12.5> }
        box { <22.9, 0.000001, 11.5> <25.1, 2.1, 12.5> }
        box { <30.9, 0.000001, 11.5> <33.1, 2.1, 12.5> }
        box { <14.9, 0.000001, 3.5> <17.1, 2.1, 4.5> }
        box { <22.9, 0.000001, 3.5> <25.1, 2.1, 4.5> }
        box { <0.1, 0.25, -0.5> <3, 2.1, 0.5> rotate -45*y translate <4, 0, 4> }
        box { <0.1, 0.25, -0.5> <3, 2.1, 0.5> rotate -135*y translate <36, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 4.9, 20> } }
    }
  #end
#end
#macro f_winglet4_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> }
      box { <40, -10, -50> <-40, 10, 0> rotate 45*y translate <19.9, 0, -3.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
          #else
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <8, 0, 16> }
            object { rounded_button() translate <16, 0, 16> }
            object { rounded_button() translate <0, 0, 24> }
            object { rounded_button() translate <8, 0, 24> }
            object { rounded_button() translate <16, 0, 24> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <24, 0, 8> }
            object { rounded_button() translate <24, 0, 16> }
            object { rounded_button() translate <24, 0, 24> }
          #end
        }
        box { <40, -10, -50> <-40, 10, 0> rotate 45*y translate <19.9, 0, -3.9> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <26.4, 2, 26.4> }
            box { <40, -10, -50> <-40, 10, 0> rotate 45*y translate <20.9, 0, -2.9> }
          }
          box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate 45*y translate <0, 0, 16> }
          box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate 45*y translate <8, 0, 8> }
          box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate 45*y translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 20> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 20> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <20, 0, 4> }
        box { <0.1, 0.25, -0.5> <3, 2.1, 0.5> rotate -45*y translate <4, 0, 12> }
        box { <0.1, 0.25, -0.5> <3, 2.1, 0.5> rotate -45*y translate <12, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 4.9, 28> } }
    }
  #end
#end
#macro f_winglet6_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 3.1, 43.9> }
      box { <-100, -10, 0> <100, 10, 100> rotate 45*y translate <27.9, 0, 27.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 43.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 40> } 
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }           
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }      
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }      
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }      
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
          #else
            object { rounded_button() rotate 180*y translate <0, 0, 0> }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <0, 0, 16> }
            object { rounded_button() rotate 180*y translate <0, 0, 24> }
            object { rounded_button() rotate 180*y translate <0, 0, 32> }
            object { rounded_button() rotate 180*y translate <0, 0, 40> } 
            object { rounded_button() rotate 180*y translate <8, 0, 0> }           
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 16> }
            object { rounded_button() rotate 180*y translate <8, 0, 24> }
            object { rounded_button() rotate 180*y translate <8, 0, 32> }
            object { rounded_button() rotate 180*y translate <8, 0, 40> }
            object { rounded_button() rotate 180*y translate <16, 0, 0> }      
            object { rounded_button() rotate 180*y translate <16, 0, 8> }
            object { rounded_button() rotate 180*y translate <16, 0, 16> }
            object { rounded_button() rotate 180*y translate <16, 0, 24> }
            object { rounded_button() rotate 180*y translate <16, 0, 32> }
            object { rounded_button() rotate 180*y translate <24, 0, 0> }      
            object { rounded_button() rotate 180*y translate <24, 0, 8> }
            object { rounded_button() rotate 180*y translate <24, 0, 16> }
            object { rounded_button() rotate 180*y translate <24, 0, 24> }      
            object { rounded_button() rotate 180*y translate <32, 0, 0> }
            object { rounded_button() rotate 180*y translate <32, 0, 8> }
            object { rounded_button() rotate 180*y translate <32, 0, 16> }
            object { rounded_button() rotate 180*y translate <40, 0, 0> }
            object { rounded_button() rotate 180*y translate <40, 0, 8> }
          #end
        }
        box { <-100, -10, 0> <100, 10, 100> rotate 45*y translate <27.9, 0, 27.9> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <42.4, 2, 42.4> }
            box { <-100, -10, 0> <100, 10, 100> rotate 45*y translate <26.9, 0, 26.9> }
            box { <-3, -2, -0.6> <0, 3, 0.6> rotate -45*y translate <20, 0, 36> }
            box { <-3, -2, -0.6> <0, 3, 0.6> rotate -45*y translate <28, 0, 28> }
            box { <-3, -2, -0.6> <0, 3, 0.6> rotate -45*y translate <36, 0, 20> }
          }
        #end
        box { <-2.6, -1, -5> <2.6, 1.999999, 5> rotate 45*y translate <16, 0, 40> }
        box { <-2.6, -1, -5> <2.6, 1.999999, 5> rotate 45*y translate <24, 0, 32> }
        box { <-2.6, -1, -5> <2.6, 1.999999, 5> rotate 45*y translate <32, 0, 24> }
        box { <-2.6, -1, -5> <2.6, 1.999999, 5> rotate 45*y translate <40, 0, 16> }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <4, 0, 28> }
        object { ring() translate <4, 0, 36> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <12, 0, 28> }
        object { ring() translate <12, 0, 36> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <20, 0, 20> }
        object { ring() translate <20, 0, 28> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <28, 0, 12> }
        object { ring() translate <28, 0, 20> }
        object { ring() translate <36, 0, 4> }
        object { ring() translate <36, 0, 12> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 4.9, 44> } }
    }
  #end
#end
#macro f_winglet6_7(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 3.1, 51.9> }
      box { <-50, -10, -50> <0, 10, 50> rotate 18.4*y translate <-4, 0, 12> }
      box { <-50, -10, -50> <0, 10, 50> rotate 26.8*y translate <4, 0, 36> }
      box { <0, -10, -50> <50, 10, 50> rotate -18.4*y translate <44, 0, 12> }
      box { <0, -10, -50> <50, 10, 50> rotate -26.8*y translate <36, 0, 36> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 51.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 48> }
          #else
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
            object { rounded_button() rotate 90*y translate <16, 0, 0> }
            object { rounded_button() rotate 90*y translate <24, 0, 0> }
            object { rounded_button() rotate 90*y translate <32, 0, 0> }
            object { rounded_button() rotate 90*y translate <8, 0, 8> }
            object { rounded_button() rotate 90*y translate <16, 0, 8> }
            object { rounded_button() rotate 90*y translate <24, 0, 8> }
            object { rounded_button() rotate 90*y translate <32, 0, 8> }
            object { rounded_button() rotate 90*y translate <8, 0, 16> }
            object { rounded_button() rotate 90*y translate <16, 0, 16> }
            object { rounded_button() rotate 90*y translate <24, 0, 16> }
            object { rounded_button() rotate 90*y translate <32, 0, 16> }
            object { rounded_button() rotate 90*y translate <8, 0, 24> }
            object { rounded_button() rotate 90*y translate <16, 0, 24> }
            object { rounded_button() rotate 90*y translate <24, 0, 24> }
            object { rounded_button() rotate 90*y translate <32, 0, 24> }
            object { rounded_button() rotate 90*y translate <8, 0, 32> }
            object { rounded_button() rotate 90*y translate <16, 0, 32> }
            object { rounded_button() rotate 90*y translate <24, 0, 32> }
            object { rounded_button() rotate 90*y translate <32, 0, 32> }
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <0, 0, 8> }
            object { rounded_button() rotate 90*y translate <40, 0, 0> }
            object { rounded_button() rotate 90*y translate <40, 0, 8> }
            object { rounded_button() rotate 90*y translate <16, 0, 40> }
            object { rounded_button() rotate 90*y translate <16, 0, 48> }
            object { rounded_button() rotate 90*y translate <24, 0, 40> }
            object { rounded_button() rotate 90*y translate <24, 0, 48> }
          #end
        }
        box { <-50, -10, -50> <0, 10, 50> rotate 18.4*y translate <-4, 0, 12> }
        box { <-50, -10, -50> <0, 10, 50> rotate 26.8*y translate <4, 0, 36> }
        box { <0, -10, -50> <50, 10, 50> rotate -18.4*y translate <44, 0, 12> }
        box { <0, -10, -50> <50, 10, 50> rotate -26.8*y translate <36, 0, 36> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <42.4, 2, 10.4000001> }
          box { <5.6, -1, 10.4> <34.4, 2.000001, 34.4> }
          box { <13.6, -1, 34.399999> <26.4, 2.000002, 50.4> }
          difference {
            box { <-4, -1, 12> <4, 2, 32> }
            box { <-50, -10, -50> <0, 10, 50> rotate 18.4*y translate <-2.3, 0, 12> }
          }
          difference {
            box { <36, -1, 12> <44, 2, 32> }
            box { <0, -10, -50> <50, 10, 50> rotate -18.4*y translate <42.3, 0, 12> }
          }
          difference {
            box { <4, -1, 36> <12, 2, 50.5> }
            box { <-50, -10, -50> <0, 10, 50> rotate 26.8*y translate <5.8, 0, 36> }
          }
          difference {
            box { <28, -1, 36> <36, 2, 50.5> }
            box { <0, -10, -50> <50, 10, 50> rotate -26.8*y translate <34.2, 0, 36> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 48> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <36, 0, 4> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <28, 0, 12> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 20> }
        object { ring() translate <28, 0, 20> }
        object { ring() translate <12, 0, 28> }
        object { ring() translate <20, 0, 28> }
        object { ring() translate <28, 0, 28> }
        object { ring() translate <20, 0, 36> }
        object { ring() translate <20, 0, 44> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 4.9, 52> } }
    }
  #end
#end
#macro f_winglet8_8(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 3.1, 59.9> }
      box { <-50, -10, -50> <70, 10, 0> rotate 23.25*y translate <-4, 0, 20> }
      box { <-50, -10, 0> <70, 10, 50> rotate -23.25*y translate <-4, 0, 36> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 3.1, 59.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
          #else
            object { rounded_button() translate <32, 0, 48> }
            object { rounded_button() translate <40, 0, 48> }
            object { rounded_button() translate <48, 0, 48> }
            object { rounded_button() translate <56, 0, 48> }
            object { rounded_button() translate <16, 0, 40> }
            object { rounded_button() translate <24, 0, 40> }
            object { rounded_button() translate <32, 0, 40> }
            object { rounded_button() translate <8, 0, 32> }
            object { rounded_button() translate <16, 0, 32> }
            object { rounded_button() translate <24, 0, 32> }
            object { rounded_button() translate <8, 0, 24> }
            object { rounded_button() translate <16, 0, 24> }
            object { rounded_button() translate <24, 0, 24> }
            object { rounded_button() translate <16, 0, 16> }
            object { rounded_button() translate <24, 0, 16> }
            object { rounded_button() translate <32, 0, 16> }
            object { rounded_button() translate <32, 0, 8> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() translate <48, 0, 8> }
            object { rounded_button() translate <56, 0, 8> }
            object { rounded_button() translate <0, 0, 32> }
            object { rounded_button() translate <0, 0, 24> }
          #end
        }
        box { <35.9, -1, 11.9> <60, 4, 44.1> }
        box { <27.9, -1, 19.9> <60, 4, 36.1> }
        box { <51.9, -1, -4> <60, 4, 4.1> }
        box { <51.9, -1, 51.9> <60, 4, 60> }
        box { <-50, -10, -50> <70, 10, 0> rotate 23.25*y translate <-4, 0, 20> }
        box { <-50, -10, 0> <70, 10, 50> rotate -23.25*y translate <-4, 0, 36> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <58.4, 2, 58.4> }
            box { <-50, -10, -50> <70, 10, 0> rotate 23.25*y translate <-2.4, 0, 20.6> }
            box { <-50, -10, 0> <70, 10, 50> rotate -23.25*y translate <-2.4, 0, 35.2> }
            box { <50.4, -1, -4> <60, 3, 5.6> }
            box { <50.4, -1, 50.4> <60, 3, 60> }
            box { <34.4, -1, 10.4> <60, 3, 45.6> }
            box { <26.4, -1, 18.4> <60, 3, 37.6> }
            box { <32, 0.25, 4.25> <51, 3, 5.6> }
            box { <32, 0.25, 50.4> <51, 3, 51.75> }
            box { <-0.5, 0.25, 18> <0.5, 3, 21.6> }
            box { <-0.5, 0.25, 34.4> <0.5, 3, 38> }
            box { <-1.5, 0.25, -0.5> <0.5, 3, 0.5> rotate 45*y translate <26.5, 0, 37.5> }
            box { <-1.5, 0.25, -0.5> <0.5, 3, 0.5> rotate -45*y translate <26.5, 0, 18.5> }
            box { <15.5, 0.25, 10> <16.5, 3, 13.6> }
            box { <15.5, 0.25, 42.4> <16.5, 3, 46> }
            box { <-8, 0.25, -0.5> <-2.5, 3, 0.5> rotate -45*y translate <8, 0, 24> }
            box { <-8, 0.25, -0.5> <-2.5, 3, 0.5> rotate -45*y translate <24, 0, 16> }
            box { <-8, 0.25, -0.5> <-2.5, 3, 0.5> rotate 45*y translate <8, 0, 32> }
            box { <-8, 0.25, -0.5> <-2.5, 3, 0.5> rotate 45*y translate <24, 0, 40> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { -1*y, 2.000001*y, 2.5 translate <32, 0, 8> }
          cylinder { -1*y, 2.000001*y, 2.5 translate <32, 0, 48> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <36, 0, 8> }
        object { pin(1) translate <44, 0, 8> }
        object { pin(1) translate <52, 0, 8> }
        object { pin(1) translate <36, 0, 48> }
        object { pin(1) translate <44, 0, 48> }
        object { pin(1) translate <52, 0, 48> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 20> }
        object { ring() translate <28, 0, 12> }
        object { ring() translate <12, 0, 36> }
        object { ring() translate <20, 0, 36> }
        object { ring() translate <4, 0, 28> }
        object { ring() translate <12, 0, 28> }
        object { ring() translate <20, 0, 28> }
        object { ring() translate <28, 0, 44> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 60> } }
    }
  #end
#end
#macro glassoldwindow1_1(color_tex)
  box { <-1.59999, 2.00001, -2.79999> <-0.6, 8.49999, 2.79999> texture { color_tex } }
#end
#macro glass_oldwindow1_1(color_tex)
  box { <-2.4, 2.5, -1.6> <2.4, 18, -0.6> texture { color_tex } }
#end
#macro glass_oldwindow1_2(color_tex)
  box { <-2.4, 2.5, -1.6> <10.4, 18, -0.6> texture { color_tex } }
#end
#macro glass_oldwindow1_3(color_tex)
  box { <-2.4, 2.5, -1.6> <18.4, 18, -0.6> texture { color_tex } }
#end
#macro glass_oldwindow1_4(color_tex)
  box { <-2.4, 2.5, -1.6> <26.4, 18, -0.6> texture { color_tex } }
#end
#macro grilled_h_block2_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-11.2, 0, -3.9> <19.2, 9.5, 11.9> }
      box { <-4.1, 3.1, -4> <12.1, 10, 12> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-11.2, 0, -3.9> <19.2, 9.5, 11.9> }
          box { <-4.1, 3.1, -4> <12.1, 10, 12> }
        }
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 }
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
        #else
          object { rounded_button() rotate 90*y }
          object { rounded_button() rotate 90*y translate <8, 0, 0> }
          object { rounded_button() rotate 90*y translate <0, 0, 8> }
          object { rounded_button() rotate 90*y translate <8, 0, 8> }
        #end
      }
      difference {
        box { <-12, -1, -4> <-4, 5, 12> }
        box { <-10, 0, -5> <0, 10, 13> rotate -40*z translate <-4, 0, 0> }
        box { <-2, 0, -5> <10, 10, 13> rotate -22.5*z translate <-11.2, 4, 0> }
      }
      difference {
        box { <12, -1, -4> <20, 5, 12> }
        box { <0, 0, -5> <10, 10, 13> rotate 40*z translate <12, 0, 0> }
        box { <-10, 0, -5> <2, 10, 13> rotate 22.5*z translate <19.2, 4, 0> }
      }
      box { <-10, 0, -4> <0, 10, 12> rotate -20*z translate <-11.2, 4, 0> }
      box { <0, 0, -4> <10, 10, 12> rotate 20*z translate <19.2, 4, 0> }
      difference {
        box { <-12, 5, -4> <20, 20, 12> }
        cylinder { -5*z, 13*z, 9.5 scale <4, 1, 1> translate <4, 0, 0> }
      }
      difference {
        box { <-11.9, 5, -4> <19.9, 19, 12> }
        cylinder { -5*z, 13*z, 9.5 scale <4, 1, 1> translate <4, -0.25, 0> }
        box { <-9, 4, -5> <17, 20, 13> }
      }
      difference {
        box { <-12, 7.5, -3> <20, 10, 11> }
        box { <-5, 5, -4> <13, 11, 12> }
        box { <-13, 5, 0> <21, 11, 0.8> }
        box { <-13, 5, 3.6> <21, 11, 4.4> }
        box { <-13, 5, 7.2> <21, 11, 8> }
        box { <-20, 5, -4> <-9.1, 8.5, 12> }
        box { <17.1, 5, -4> <30, 8.5, 12> }
      }
      difference {
        box { <-12, -1, -3> <20, 10, 11> }
        box { <-5.5, 2.5, -4> <13.5, 11, 12> }
        box { <-3.9, -1, -4> <11.9, 11, 12> }
        box { <-10, 0, -4> <0, 10, 12> rotate -20*z translate <-10.2, 4, 0> }
        box { <0, 0, -4> <10, 10, 12> rotate 20*z translate <18.2, 4, 0> }
        cylinder { 0*z, 0.8*z, 9.5 scale <4, 1, 1> translate <4, 12, 0> }
        cylinder { 3.6*z, 4.4*z, 9.5 scale <4, 1, 1> translate <4, 12, 0> }
        cylinder { 7.2*z, 8*z, 9.5 scale <4, 1, 1> translate <4, 12, 0> }
        difference {
          box { <-12, 5, -4> <20, 20, 12> }
          cylinder { -5*z, 13*z, 9.5 scale <4, 1, 1> translate <4, -3.3, 0> }
        }
        difference {
          box { <-12, 5, -4> <20, 20, 12> }
          cylinder { -5*z, 13*z, 9.5 scale <4, 1, 1> translate <4, -3.05, 0> }
        }
      }
      #if (setting > 1)
        cylinder { 1*y, 4*y, 1.2 }
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        difference {
          box { <-2.4, -1, -2.4> <10.4, 2.000005, 10.4> }
          object { ring() translate <4, 0.000005, 4> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-11.3, -0.1, -4> <19.3, 9.6, 12> } }
    }
  #end
#end
#macro guiding_f_block1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -7.5> <11.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
          #end
          box { <-3.900001, 1.1, -7> <11.900001, 2.1, -3.8> }
          box { <-3.900002, 0.000001, -7.5> <11.900002, 3.100001, -6.5> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -7.6> <12, 4.9, 4> } }
    }
  #end
#end
#macro guiding_f_block1_8(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -7.5> <59.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <32, 0, 0> }
            object { rounded_button() translate <40, 0, 0> }
            object { rounded_button() translate <48, 0, 0> }
            object { rounded_button() translate <56, 0, 0> }
          #end
          box { <-3.900001, 1.1, -7> <59.900001, 2.1, -3.8> }
          box { <-3.900002, 0.000001, -7.5> <59.900002, 3.100001, -6.5> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <58.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
        object { pin(2) translate <28, 0, 0> }
        object { pin(2) translate <36, 0, 0> }
        object { pin(2) translate <44, 0, 0> }
        object { pin(2) translate <52, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -7.6> <60, 4.9, 4> } }
    }
  #end
#end
#macro guiding_h_block1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 0> }
          #end
        }
        box { <2.2, -1, -4> <5.8, 10, -1.9> }
        #if (setting > 1)
          cylinder { -1*y, 8.6*y, 2.4 }
          cylinder { -1*y, 8.6*y, 2.4 translate <8, 0, 0> }
          box { <-2.4, -1, 2.4> <10.4, 8.6, 0> }
          box { <-2.4, -1, -2.4> <0, 8.6, 0> }
          box { <8, -1, -2.4> <10.4, 8.6, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 4> } }
    }
  #end
#end
#macro guiding_h_block1_14(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <107.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <107.9, 9.5, 3.9> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <106.4, 8.6, 2.4> }
            #local counter = 0;
            #while (counter < 13)
              cylinder { -2*y, 9*y, 1.5 translate <(counter*8)+4, 0, 0> }
              #local counter = counter + 1;
            #end
            box { <4, 4, -4> <100, 10, -1> }
            difference {
              box { <0.1, -2, -2.4> <7.9, 11, 0> }
              cylinder { -1*y, 9*y, 2.4 translate <0.1, 0, 0> }
              cylinder { -1*y, 9*y, 2.4 translate <7.9, 0, 0> }
            }
            difference {
              box { <0.1, -2, -2.4> <7.9, 11, 0> }
              cylinder { -1*y, 9*y, 2.4 translate <0.1, 0, 0> }
              cylinder { -1*y, 9*y, 2.4 translate <7.9, 0, 0> }
              translate <96, 0, 0>
            }
            box { <19.5, 2.5, -2.5> <20.5, 9, 2.5> }
            box { <35.5, 2.5, -2.5> <36.5, 9, 2.5> }
            box { <51.5, 2.5, -2.5> <52.5, 9, 2.5> }
            box { <67.5, 2.5, -2.5> <68.5, 9, 2.5> }
            box { <83.5, 2.5, -2.5> <84.5, 9, 2.5> }
            cylinder { -2.5*z, 2.5*z, 0.5 translate <20, 2.5, 0> }
            cylinder { -2.5*z, 2.5*z, 0.5 translate <36, 2.5, 0> }
            cylinder { -2.5*z, 2.5*z, 0.5 translate <52, 2.5, 0> }
            cylinder { -2.5*z, 2.5*z, 0.5 translate <68, 2.5, 0> }
            cylinder { -2.5*z, 2.5*z, 0.5 translate <84, 2.5, 0> }
          }
        #end
        box { <2.2, -1, -4> <5.8, 3.50001, -1.9> }
        box { <98.2, -1, -4> <101.8, 3.50001, -1.9> }
        box { <7.19999, 4.99999, -4> <96.80001, 8.49999, -1.90001> }
        intersection {
          difference {
            cylinder { -4*z, -1.90002*z, 5 }
            cylinder { -5*z, 0*z, 1.5 }
          }
          box { <-10, 0, -5> <0, 10, 0> }
          translate <7.2, 3.5, 0>
        }
        intersection {
          difference {
            cylinder { -4*z, -1.90002*z, 5 }
            cylinder { -5*z, 0*z, 1.5 }
          }
          box { <0, 0, -5> <10, 10, 0> }
          translate <96.8, 3.5, 0>
        }
      }
      #local counter = 0;
      #while (counter < 14)
        object { open_rounded_button() translate <(counter*8), 6.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <(counter*8), 9.5, 0> }
        #end
        #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <108, 11.3, 4> } }
    }
  #end
#end
#macro half_hexagon_dome(color_tex)
  #if (setting = 0)
    merge {
      difference {
        sphere { <0, 2, 0> 15.9 }
        box { <-20, -25, -20> <20, 1.999999, 20> }
      }
      cylinder { 0*y, 2.000001*y, 15.9 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        intersection {
          #local count1 = 0;
          #local count2 = 0;
          #local count3 = 12;
          box { <-20, 1.999999, -20> <20, 20, 20> }
          #while (count1 <= 90)
            #local count4 = count2;
            #while (count4 < 360)
              box { <-1000, -1000, -1000> <1000, 15.9, 1000>
                bounded_by { sphere { <0, 15.9, 0> 1.9875 } }
                rotate <0, 0, 90 - count1>
                rotate <0, count4, 0>
              }
              #local count4 = count4 + count3;
            #end
            #if (count1 >= 30)
              #if ( count3 < 72 )
                #local count3 = 360/(360/count3-5);
              #else
                #local count3 = 360;
              #end                 
            #else
              #local count2 = count3/2 - count2;
            #end
            #local count1 = count1 + 10;
          #end
        }
        #if (setting > 1)
          sphere { <0, 0, 0> 14.3 }
        #end
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 2.000001*y, 15.9 }
          box { <-16, -1, -2.5> <16, 1.999998, 2.5> }
          box { <-2.5, -1, -16> <2.5, 1.999998, 16> }
          cylinder { -1*y, 2.000005*y, 14.3 }
        }
      #end
      texture { color_tex }
      bounded_by { sphere { <0, 0, 0> 16.1 } }
    }
  #end
#end
#macro half_hrbase4_4(color_tex)
  #if (setting = 0)
    difference {
      cylinder { 0*y, 38.3*y, 15.9 }
      box { <-20, -1, -20> <20, 40, 0.1> }
      translate <12, 0, 12>
      texture { color_tex }
    }
  #else
    difference {
      merge {
        object { open_rounded_button() translate <0, 35.2, 16> }
        object { open_rounded_button() translate <8, 35.2, 16> }
        object { open_rounded_button() translate <8, 35.2, 24> }
        object { open_rounded_button() translate <16, 35.2, 16> }
        object { open_rounded_button() translate <16, 35.2, 24> }
        object { open_rounded_button() translate <24, 35.2, 16> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 38.3, 16> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 38.3, 16> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 38.3, 24> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 38.3, 16> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 38.3, 24> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 38.3, 16> }
        #end
        difference {
          cylinder { 0*y, 38.3*y, 15.9 }
          cylinder { 3.1*y, 37.4*y, 14.9 }
          #if (setting > 1)
            difference {
              cylinder { -1*y, 2*y, 14.9 }
              box { <-20, -2, -20> <20, 3, 1.5> }
              cylinder { -2*y, 3*y, 3 }
            }
          #end
          box { <-20, -1, -20> <20, 40, 0.1> }
          translate <12, 0, 12>
        }
        #if (setting > 1)
          object { ring() translate <12, 0, 20> }
          cylinder { 0*y, 2.1*y, 3.2 translate <4, 0, 20> }
          cylinder { 0*y, 2.1*y, 3.2 translate <20, 0, 20> }
          box { <-15, 0.000001, -3.000001> <-11.999999, 2.1, 3.000001> rotate 45*y translate <12, 0, 12> }
          box { <-15, 0.000001, -3.000001> <-11.999999, 2.1, 3.000001> rotate 135*y translate <12, 0, 12> }
        #end
      }
      cylinder { -1*y, 45*y, 2.5 translate <12, 0, 12> }
      #if (setting > 1)
        cylinder { -1*y, 2.000001*y, 2.6 translate <4, 0, 20> }
        cylinder { -1*y, 2.000001*y, 2.6 translate <20, 0, 20> }
        box { <-25, -1, -2.600001> <-11.999998, 2, 2.600001> rotate 45*y translate <12, 0, 12> }
        box { <-25, -1, -2.600001> <-11.999998, 2, 2.600001> rotate 135*y translate <12, 0, 12> }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 40.1*y, 16 translate <12, 0, 12> } }
    }
  #end
#end
#macro hammer(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 21*y, 1.5 }
      box { <-5, 19, -1.5> <4.5, 24, 1.5> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { 0*y, 21*y, 1.5 }
      difference {
        box { <-5, 19, -1.5> <4.5, 24, 1.5> }
        box { <-10, 0, -2> <0, 3, 2> rotate 23*z translate <0, 24, 0> }
        box { <-10, -3, -2> <0, 0, 2> rotate -23*z translate <0, 19, 0> }
        #if (setting > 1)
          box { <1, 23.75, -0.9> <4, 25, 0.9> }
          box { <0, 0, -0.75> <6, 2, 0.75> rotate <-45, 0, -10> translate <1.25, 24, -1.5> }
          box { <0, 0, -0.75> <6, 2, 0.75> rotate <45, 0, -10> translate <1.25, 24, 1.5> }
          box { <0, -2, -0.75> <6, 0, 0.75> rotate <45, 0, 10> translate <1.25, 19, -1.5> }
          box { <0, -2, -0.75> <6, 0, 0.75> rotate <-45, 0, 10> translate <1.25, 19, 1.5> }
        #end
      }
      #if (setting > 3)
        object { llogo() rotate 90*y scale <0.65, 0.65, 0.65> translate <2.5, 23.75, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-5.1, -0.1, -1.6> <4.6, 24.1, 1.6> } }
    }
  #end
#end
#macro hand(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -0.5*y, 3*y, 2.25 rotate -15*x translate <0, -1.5, -3> }
      cylinder { 1*z, -1.75*z, 1.3 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { -0.5*y, 3*y, 2.25 }
        difference {
          box { <-3, -1, -2.5> <3, 2, 0> }
          cylinder { -4*x, 4*x, 2.5 translate <0, 2, 0> }
        }
        cylinder { -1*y, 4*y, 1.5 }
        box { <-1.35, -1, -3> <1.35, 5, 0> }
        rotate -15*x
        translate <0, -1.5, -3>
      }
      difference {
        cylinder { 1*z, -1.75*z, 1.3 }
        box { <-10, 0, -10> <10, 10, 10> rotate -15*x translate <0, 1, 0> }
        cylinder { -1*y, 4*y, 1.500001 rotate -15*x translate <0, -1.5, -3> }
      }
      texture { color_tex }
      bounded_by { box { <-2.6, -2.5, -6.5> <2.6, 3.5, 1.5> } }
    }
  #end
#end
#macro handle(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 38.2*y, 1.5 texture { color_tex } }
  #else
    merge {
      cylinder { 0*y, 0.9*y, 2 }
      cylinder { 37.3*y, 38.2*y, 2 }
      cylinder { 0.5*y, 38*y, 1.5 }
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 38.3*y, 2.1 } }
    }
  #end
#end
#macro hatch1_4(color_tex)
  #if (setting = 0)
    box { <-1, 2.1, -1> <15.25, 28.2, 1> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-1, 2.1, -1> <15.25, 28.2, 1> }
        box { <-1, 27.7, -2> <16, 29, -0.5> }
        box { <-1, 27.7, 0.5> <16, 29, 2> }
        box { <-1, 0, -2> <16, 2.6, -0.5> }
        box { <-1, 0, 0.5> <16, 2.6, 2> }
        box { <14.75, 0, -2> <16, 29, -0.500001> }
        box { <14.75, 0, 0.500001> <16, 29, 2> }
        box { <-2, 27, -2> <2, 30, 2> }
        box { <-2, 0, -2> <2, 3.3, 2> }
        #local counter = 0;
        #while (counter < 16)
          difference {
            box { <1, -0.6, -2> <13.25, 0.6, -0.35> }
            box { <0, -2, 0> <14, 0, 2> rotate -7.5*x translate <0, -0.6, -2> }
            box { <0, 0, 0> <14, 2, 2> rotate 7.5*x translate <0, 0.6, -2> }
            translate <0, 4.3+(counter*1.4), 0>
          }
          difference {
            box { <1, -0.6, 2> <13.25, 0.6, 0.35> }
            box { <0, -2, -2> <14, 0, 0> rotate 7.5*x translate <0, -0.6, 2> }
            box { <0, 0, -2> <14, 2, 0> rotate -7.5*x translate <0, 0.6, 2> }
            translate <0, 4.3+(counter*1.4), 0>
          }
          #local counter = counter + 1;
        #end
      }
      sphere { <0, 27, 0> 1 }
      sphere { <0, 3.3, 0> 1 }
      texture { color_tex }
      bounded_by { box { <-1.1, 2, -1.1> <15.35, 28.3, 1.1> } }
    }
  #end
#end
#macro hatch1_4_s(color_tex)
  #if (setting = 0)
    box { <-1, 0.1, -1> <11.9, 19, 1> texture { color_tex } }
  #else
    merge {
      difference {
        box { <0, 0.1, -1> <11.9, 19, 1> }
        box { <-1, 0, -2> <2, 1.8, 2> }
        box { <-1, 17.3, -2> <2, 20, 2> }
        #local counter = 0;
        #while (counter < 11)
          difference {
            box { <1, -0.6, -2> <10, 0.6, -0.35> }
            box { <0, -2, 0> <11, 0, 2> rotate -7.5*x translate <0, -0.6, -2> }
            box { <0, 0, 0> <11, 2, 2> rotate 7.5*x translate <0, 0.6, -2> }
            translate <0, 2.3+(counter*1.4), 0>
          }
          difference {
            box { <1, -0.6, 2> <10, 0.6, 0.35> }
            box { <0, -2, -2> <11, 0, 0> rotate 7.5*x translate <0, -0.6, 2> }
            box { <0, 0, -2> <11, 2, 0> rotate -7.5*x translate <0, 0.6, 2> }
            translate <0, 2.3+(counter*1.4), 0>
          }
          #local counter = counter + 1;
        #end
      }
      sphere { <0, 2.5, 0> 1 }
      sphere { <0, 16.63, 0> 1 }
      cylinder { 1.800001*y, 17.299999*y, 1 }
      texture { color_tex }
      bounded_by { box { <-1.1, 0, -1.1> <12, 19.1, 1.1> } }
    }
  #end
#end
#macro hatch_frame1_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 28.7, 3.9> }
      box { <-2.4, 3.1, -4> <26.4, 27.2, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 28.7, 3.9> }
          #if (setting < 3)
            cylinder { 28.6*y, 30.4*y, 2.4 }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <24, 0, 0> }
          #else
            object { rounded_button() rotate 90*y translate <0, 25.6, 0> }
            object { rounded_button() rotate 90*y translate <24, 25.6, 0> }
          #end
          object { open_rounded_button() translate <8, 25.6, 0> }
          object { open_rounded_button() translate <16, 25.6, 0> }
          #if (setting >3)
            object { llogo() rotate 90*y scale <0.65, 0.65, 0.65> translate <8, 28.7, 0> }
            object { llogo() rotate 90*y scale <0.65, 0.65, 0.65> translate <16, 28.7, 0> }
          #end
          box { <-5.650001, 27.200002, -5.650001> <-2.150001, 28.700002, -3.899999> }
          cylinder { 27.200001*y, 28.700001*y, 1.75 translate <-3.9, 0, -5.65> }
          box { <-5.650001, 1.600002, -5.650001> <-2.150001, 3.100002, -3.899999> }
          cylinder { 1.600001*y, 3.100001*y, 1.75 translate <-3.9, 0, -5.65> }
          box { <26.150001, 27.200002, -5.650001> <29.650001, 28.700002, -3.899999> }
          cylinder { 27.200001*y, 28.700001*y, 1.75 translate <27.9, 0, -5.65> }
          box { <26.150001, 1.600002, -5.650001> <29.650001, 3.100002, -3.899999> }
          cylinder { 1.600001*y, 3.100001*y, 1.75 translate <27.9, 0, -5.65> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          cylinder { -1*y, 31*y, 0.75 translate <-1.25, 0, 1.5> }
          cylinder { -1*y, 31*y, 0.75 translate <25.25, 0, 1.5> }
          cylinder { -1*y, 31*y, 0.75 translate <-1.25, 0, -1.5> }
          cylinder { -1*y, 31*y, 0.75 translate <25.25, 0, -1.5> }
          cylinder { -2.8*x, 26.8*x, 0.75 translate <0, 15, -1.5> }
          cylinder { 2.8*y, 26.9*y, 0.6 translate <-3.9, 0, -5.65> }
          cylinder { 2.8*y, 26.9*y, 0.6 translate <27.9, 0, -5.65> }
        #end
        box { <-2.4, 3.1, -4> <26.4, 27.2, 4> }
      }
      #if (setting > 1)
        box { <-3, 3, -0.5> <27, 4.1, 0.5> }
        object { pin(1) translate <4, 0, 0> }
        object { pin(1) translate <12, 0, 0> }
        object { pin(1) translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-5.75, -0.1, -7.5> <29.65, 30.5, 4> } }
    }
  #end
#end
#macro hatch_innerhatch(color_tex)
  #if (setting = 0)
    box { <-0.95, 3.2, -0.9> <12.9, 27.1, 0.9> texture { color_tex } }
  #else
    merge {
      #if (setting > 1)
        sphere { <0, 3.2, 0> 0.899999 }
        sphere { <0, 27.1, 0> 0.899999 }
      #end
      difference {
        box { <-0.95, 3.2, -0.9> <12.9, 27.1, 0.9> }
        box { <1, 16.15, -1> <10.9, 25.1, 1> }
        box { <1, 5.2, -1> <10.9, 14.15, 1> }
        difference {
          box { <-1, 2, -1> <0, 28, 1> }
          cylinder { 1*y, 30*y, 0.900001 }
        }
      }
      texture { color_tex }
      bounded_by { box { <-1, 2, -1> <13, 28.1, 1> } }
    }
  #end
#end
#macro hbblock1_1(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        object { open_rounded_button() translate <0, 6.4, 0> }
        object { open_rounded_button() rotate 90*z translate <-0.8, 5.6, 0> }
        object { open_rounded_button() rotate -90*z translate <0.8, 5.6, 0> }
        object { open_rounded_button() rotate -90*x translate <0, 5.6, -0.8> }
        object { open_rounded_button() rotate 90*x translate <0, 5.6, 0.8> }
        box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 8.6, 2.4> }
        cylinder { -1*y, 12*y, 1.600001 }
        cylinder { -6*z, 6*z, 1.600001 translate <0, 5.6, 0> }
        cylinder { -6*x, 6*x, 1.600001 translate <0, 5.6, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-5.7, -0.1, -5.7> <5.7, 11.3, 5.7> } }
    }
  #end
#end
#macro hcblock1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 180*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <8, 6.4, 0> }
          #end
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          #local counter = 0;
          #while (counter < 7)
            box { <-10, 0, 0> <10, 2, 2> rotate 45*x translate <4, (counter*1.58), 3.2> }
            #local counter = counter + 1;
          #end
          #local counter = 0;
          #while (counter < 12)
            box { <-10, -2, -2> <10, 0, 0> rotate 45*x rotate 90*z
              translate <-3.9+(counter*1.58), 0, -3.2> }
            #local counter = counter + 1;
          #end
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
        box { <3.75, 2, -3.05> <4.25, 8.7, 3.05> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 4> } }
    }
  #end
#end
#macro hdblock1_1(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        object { open_rounded_button() translate <0, 6.4, 0> }
        object { open_rounded_button() rotate -90*x translate <0, 5.6, -0.8> }
        object { open_rounded_button() rotate 90*x translate <0, 5.6, 0.8> }
        box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 8.6, 2.4> }
        cylinder { -1*y, 12*y, 1.600001 }
        cylinder { -6*z, 6*z, 1.600001 translate <0, 5.6, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-3.9, -0.1, -5.7> <3.9, 11.3, 5.7> } }
    }
  #end
#end
#macro hdrblock2_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> }
      difference {
        box { <-4, 1.599999, -4> <28, 10, 12> }
        cylinder { -3.899999*x, 27.899999*x, 7.899999 translate <0, 1.6, 4> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> }
        difference {
          box { <-4, 1.599999, -4> <28, 10, 12> }
          cylinder { -3.899999*x, 27.899999*x, 7.899999 translate <0, 1.6, 4> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 1.600001, 10.4> }
          cylinder { -2.400001*x, 26.400001*x, 6.399999 translate <0, 1.6, 4> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { high_ring() translate <4, 0, 4> }
            object { high_ring() translate <12, 0, 4> }
            object { high_ring() translate <20, 0, 4> }
          }
          cylinder { -2.5*x, 26.5*x, 6.399999 translate <0, 1.6, 4> inverse }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 9.6, 12> } }
    }
  #end
#end
#macro hdwheelbase2_2(color_tex)
  #if (setting = 0)
    merge {
      difference {
        box { <-3.9, 0, 3> <8, 8.5, 5> }
        box { <0, -10, 2> <20, 20, 6> rotate -45*z translate <0, 1, 0> }
      }
      box { <-3.9, 8.499999, -3.9> <11.9, 9.9, 11.9> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { -2*z, 10*z, 1.5 translate <-2, 0, 0> }
      cylinder { 2.25*z, 5.75*z, 2.4 translate <-2, 0, 0> }
      difference {
        box { <-3.9, 0, 3> <8, 8.5, 5> }
        box { <0, -10, 2> <20, 20, 6> rotate -45*z translate <0, 1, 0> }
      }
      difference {
        box { <-3.9, 8.499999, -3.9> <11.9, 9.9, 11.9> }
        difference {
          box { <-5, 8.25, -5> <-2.9, 10.25, -2.9> }
          cylinder { 8*y, 11*y, 1 translate <-2.9, 0, -2.9> }
        }
        difference {
          box { <-5, 8.25, 12> <-2.9, 10.25, 10.9> }
          cylinder { 8*y, 11*y, 1 translate <-2.9, 0, 10.9> }
        }
        difference {
          box { <10.9, 8.25, -5> <12, 10.25, -2.9> }
          cylinder { 8*y, 11*y, 1 translate <10.9, 0, -2.9> }
        }
        difference {
          box { <10.9, 8.25, 10.9> <12, 10.25, 12> }
          cylinder { 8*y, 11*y, 1 translate <10.9, 0, 10.9> }
        }
      }
      object { open_rounded_button() translate <0, 6.8, 0> }
      object { open_rounded_button() translate <8, 6.8, 0> }
      object { open_rounded_button() translate <8, 6.8, 8> }
      object { open_rounded_button() translate <0, 6.8, 8> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.9, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.9, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.9, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.9, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4.5, -2.5, -4> <12, 11.8, 12> } }
    }
  #end
#end
#macro head(color_tex, age)
  #if (setting = 0)
    cylinder { 0*y, 9.5*y, 5 texture { color_tex } }
  #else
    difference {
      merge {
        #if (age = 1)
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
          #end
        #end
        #if (age > 1)
          object { open_rounded_button() translate <0, 6.4, 0> }
        #end
        torus { 3, 2 translate <0, 7.5, 0> }
        cylinder { 3*y, 7.5*y, 5 }
        cylinder { 2*y, 9.5*y, 3 }
        torus { 3, 2 translate <0, 3, 0> }
        cylinder { 0*y, 1*y, 3.25 }
      }
      cylinder { -1*y, 8.6*y, 2.6 }
      #if (age = 1)
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 }
        #end
      #end
      #if (age > 1)
        #if (setting > 1)
          difference {
            cylinder { -1*y, 12*y, 1.600001 }
            box { <-0.45, 8.600002, -2.5> <0.45, 9.500002, 0> }
            box { <-0.45, 8.600003, -2.5> <0.45, 9.500003, 0> rotate 120*y }
            box { <-0.45, 8.600004, -2.5> <0.45, 9.500004, 0> rotate 240*y }
          }
        #end
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 11.3*y, 5.1 } }
    }
  #end
#end
#macro head_bp01(age)
  merge {
    object { head(yellow_tex,1) }
    difference {
      merge {
        cylinder { -10*z, 0*z, 0.5 translate <-1.4, 5.6, 0> }
        cylinder { -10*z, 0*z, 0.5 translate <1.4, 5.6, 0> }
        difference {
          cylinder { -10*z, 0*z, 3.4 }
          cylinder { -11*z, 1*z, 3 }
          box { <0, -10, -11> <10, 10, 1> rotate 25*z }
          box { <-10, -10, -11> <0, 10, 1> rotate -25*z }
          translate <0, 6.6, 0>
        }
        cylinder { -10*z, 0*z, 0.2 translate <0, -3.2, 0> rotate 25*z translate <0, 6.6, 0> }
        cylinder { -10*z, 0*z, 0.2 translate <0, -3.2, 0> rotate -25*z translate <0, 6.6, 0> }
      }
      difference {
        box { <-20, 0, -20> <20, 11, 20> }
        cylinder { 0*y, 11*y, 5.00005 }
      }
      cylinder { 0*y, 11*y, 3 }
      texture { black_tex }
    }
  }
#end
#macro helmet(color_tex)
  #if (setting = 0)
    sphere { <0, 0, 0> 6 scale <1.04, 1, 1.04> rotate -10*z texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          difference {
            sphere { <0, 0, 0> 6 scale <1.04, 1, 1.04> }
            box { <-7, -7, -7> <0, 7, 7> }
            box { <-7, -7, -7> <7, -0.000001, 7> }
          }
          difference {
            sphere { <0, 0, 0> 6.000001 scale <1.16, 1, 1.04> }
            box { <0.000001, -7, -7> <8, 7, 7> }
            box { <-8, -7, -7> <8, -0.000001, 7> }
          }
          difference {
            sphere { <0, 0, 0> 6.000002 scale <1.04, 2.25, 1.04> }
            box { <-7, -21, -7> <0, 1, 7> }
            box { <-7, 0.000001, -7> <7, 21, 7> }
          }
          difference {
            sphere { <0, 0, 0> 6.000003 scale <1.16, 2.25, 1.04> }
            box { <0.000001, -21, -7> <8, 1, 7> }
            box { <-8, 0.000001, -7> <8, 21, 7> }
          }
          bounded_by { box { <-7.5, -8, -6.25> <6.25, 7, 6.25> } }
          rotate -10*z
        }
        #if (setting > 1)
          sphere { <-1, -0.25, -5.75> 0.7 }
          sphere { <-1, -0.25, 5.75> 0.7 }
          cylinder { -1*y, 5*y, 2.600001 }
        #end
        cylinder { -7*z, 7*z, 2.25 translate <-3.75, -1.2, 0 > }
        difference {
          box { <-10, -7, -8> <-4, 1.05, 8> }
          box { <-11, -6, -9> <0, 0, 9> rotate 19*z translate <-4, -3.45, 0> }
        }
        box { <-10, -10, -10> <10, 0, 10> rotate 10*z translate <0, -5, 0> }
        cylinder { -9*y, 2*y, 5.1 }
        cone { 1.999999*y, 5, 4*y, 3 }
      }
      #if (setting > 1)
        object { ring() translate <0, 3, 0> }
      #end
      texture { color_tex }
    }
  #end
#end
#macro helmet_2(color_tex)
  #if (setting = 0)
    merge {
      sphere { <0, 1.5, 0> 6 }
      cylinder { 0.75*y, 1.5*y, 6 translate <0, 0, -2> }
      cylinder { -0.000001*y, 0.7500004*y, 6 translate <0, 0, 6> rotate 18*x translate <0, 0.75, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { -2.500001*z, 0.000001*z, 1.000001 translate <0, 8, 0> }
          box { <-1.000002, 2, -2.500002> <1.000002, 8.000001, 0.000002> }
          torus { 1.5, 1 rotate 90*z translate <0, 6.5, -2.5> }
          cylinder { -1.000003*x, 1.000003*x, 1.500001 translate <0, 6.5, -2.5> }
          cylinder { 0*y, 6.500001*y, 1.000004 translate <0, 0, -4> }
          difference {
            merge {
              torus { 6, 1.000007 rotate 90*z translate <0, 2, 0> }
              cylinder { -1.000005*x, 1.000005*x, 6 translate <0, 2, 0> }
              cylinder { 2.000001*y, -3*y, 1.000006 translate <0, 0, 6> }
            }
            box { <-10, -10, -20> <10, 10, -0.000003> }
          }
          cylinder { 0.75*y, 1.5*y, 6 translate <0, 0, -2> }
          sphere { <0, 1.5, 0> 6 }
          cylinder { -3*y, 1.500001*y, 6 }
          box { <-5.999999, 0.750001, -2.000001> <5.999999, 1.500001, 0> }
          merge {
            box { <-5.999998, 0, -0.000001> <5.999998, 0.75, 6> }
            cylinder { -0.000001*y, 0.7500004*y, 6 translate <0, 0, 6> }
            rotate 18*x translate <0, 0.75, 0>
          }
        }
        box { <-10, -10, -20> <10, 0.750002, 0> }
        cylinder { -5*y, 2*y, 5 }
        cone { 1.999999*y, 5, 4*y, 3 }
        box { <-10, -10, 0> <10, 0, 20> rotate 18*x translate <0, 0.750001, 0> }
      }
      #if (setting > 1)
        difference {
          cylinder { 3*y, 5.1*y, 3.2 }
          cylinder { 2*y, 6*y, 2.6 }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-6.1, -3.1, -8.1> <6.1, 9.1, 16.25> } }
    }
  #end
#end
#macro helmet_3(color_tex)
  #if (setting = 0)
    difference {
      sphere { <0, 1.5, 0> 6 }
      box { <-10, -10, -20> <10, 0.500002, 20> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { 3*y, 6.749999*y, 1.85 }
          torus { 6, 0.4 rotate 90*z translate <0, 1.5, 0> }
          torus { 6, 0.4 rotate 90*z rotate 45*y translate <0, 1.5, 0> }
          torus { 6, 0.4 rotate 90*z rotate 90*y translate <0, 1.5, 0> }
          torus { 6, 0.4 rotate 90*z rotate 135*y translate <0, 1.5, 0> }
          cylinder { 0.5*y, 1.5*y, 6 translate <0, 0, -2.7> }
          sphere { <0, 1.5, 0> 6 }
          cylinder { 0.5*y, 1.500001*y, 6.5 }
          difference {
            box { <-6.499999, 0.500001, -3.700001> <6.499999, 1.500001, 0.000001> }
            box { <0, 0, -20> <5, 2, 20> translate <6, 0, 0> rotate 11*y translate <0, 0, -2.7> }
            box { <-5, 0, -20> <0, 2, 20> translate <-6, 0, 0> rotate -11*y translate <0, 0, -2.7> }
          }
        }
        cylinder { 7*y, 10*y, 1.95 }
        box { <-10, -10, -20> <10, 0.500002, 20> }
        cylinder { -5*y, 2*y, 5 }
        cone { 1.999999*y, 5, 4*y, 3 }
      }
      #if (setting > 1)
        object { ring() translate <0, 3, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-6.6, 0.4, -8.8> <6.6, 8, 6.6> } }
    }
  #end
#end
#macro helmet_4(color_tex)
  #if (setting = 0)
    sphere { <0, 0, 0> 6 scale <1.04, 1, 1.04> rotate -10*z texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          difference {
            sphere { <0, 1, 0> 6.5 }
            box { <-7, -6, -7> <-1.5, 1, 7> }
          }
          difference {
            cylinder { -1.1*z, 1.1*z, 6.650001 translate <0, 1.000005, 0> }
            box { <-10, -10, -2> <0.000001, 0.999999, 2> }
          }
          difference {
            cylinder { -1.1*x, 1.1*x, 6.6 rotate 5*z translate <0, 0.95, 0> }
            box { <-10, -10, -10> <10, 0.999999, 10> }
          }
          difference {
            cylinder { 0.999998*y, 2.5*y, 6.650005 }
            box { <0, -10, -10> <10, 10, 10> }
          }
          difference {
            sphere { <0, 0, 0> 6.5 scale <1, 1.5, 1> translate <0, 1, 0> }
            cylinder { -7*z, 7*z, 2 translate <-3.5, -1, 0> }
            box { <-10, -10, -10> <-3.500001, 1.000001, 10> }
            box { <-10, -10, -10> <-1.500001, -1.000001, 10> }
            box { <-10, 2, -10> <10, 100, 10> }
            difference {
              box { <-5, -6, -9> <-0.5, -3.5, 9> }
              cylinder { -10*z, 10*z, 1.5 translate <-0.5, -3.5, 0> }
            }
            prism {
              bezier_spline
               -10, 10, 20,
              <0, -1.5>, <2.2, -1.5>, <2.2, 1>, <4.5, 1>,
              <4.5, 1>, <5, 1>, <5.8, 1>, <5.8, -0.5>,
              <5.8, -0.5>, <5.8, -0.5>, <10, -0.5>, <10, -0.5>,
              <10, -0.5>, <10, -0.5>, <10, -10>, <0, -10>,
              <0, -10>, <0, -10> <0, -1.5>, <0, -1.5>
              sturm rotate -90*x translate <0, -3.5, 0>
            }
          }
          difference {
            cylinder { -0.5*y, 1.5*y, 6.65 }
            box { <-10, -10, -10> <-1, 10, 10> }
          }
          bounded_by { box { <-7.5, -8, -7.35> <7.8, 8.7, 7.35> } }
          rotate -5*z
        }
        box { <-10, -10, -10> <10, 10, -6> }
        sphere { <0, 1, -5.7> 0.7 }
        sphere { <0, 1, 5.7> 0.7 }
        cylinder { -1*y, 5.000001*y, 2.25 }
        cylinder { -9*y, 2*y, 4.9 }
        cone { 2.000001*y, 5, 4*y, 3 }
        merge {
          box { <4, -10, -7> <10, -3.25, 7> }
          box { <-10, -10, -7> <0, 0, 7> rotate 20*z translate <4, -3.25, 0> }
        }
      }
      difference {
        merge {
          cylinder { 6*z, 7.25*z, 2.3 }
          cylinder { -7.25*z, -6*z, 2.3 }
          translate <0.5, -0.5, 0>
        }
        cylinder { -10*z, 10*z, 1.8 translate <0, 1, 0> }
        box { <-10, -1.8, -10> <0, 10, 10> rotate 7.5*z translate <0, 1, 0> }
      }
      difference {
        cylinder { 3*y, 5.1*y, 3 }
        cylinder { 2*y, 6*y, 2.25 }
      }
      texture { color_tex }
    }
  #end
#end
#macro helmet_explorien(color_tex)
  #if (setting = 0)
    sphere { <0, 0, 0> 6 scale <1.04, 1, 1.04> rotate -10*z texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          merge {
            cylinder { 1.25*y, 4*y, 1.5 translate <2.5, 0, -6.5> }
            cylinder { 1.25*y, 4*y, 1.5 translate <2.5, 0, 6.5> }
            box { <1, 1.250001, -6.5> <4, 4.000001, 6.5> }
            cylinder { -0.375*z, 0.375*z, 1.5 scale <0.6666667, 1, 1> rotate 22.5*z translate <4.35, 4, -1.9> }
            difference {
              box { <0, -2.5, -0.375001> <1, 0, 0.375001> }
              difference {
                box { <0.5, -4, -1> <3, -2, 1> }
                cylinder { -2*z, 2*z, 0.5 translate <0.5, -2, 0> }
              }
              rotate 22.5*z translate <4.35, 4, -1.9>
            }
            cylinder { -0.375*z, 0.375*z, 1.5 scale <0.6666667, 1, 1> rotate 22.5*z translate <4.35, 4, 0> }
            difference {
              box { <0, -2.5, -0.375001> <1, 0, 0.375001> }
              difference {
                box { <0.5, -4, -1> <3, -2, 1> }
                cylinder { -2*z, 2*z, 0.5 translate <0.5, -2, 0> }
              }
              rotate 22.5*z translate <4.35, 4, 0>
            }
            cylinder { -0.375*z, 0.375*z, 1.5 scale <0.6666667, 1, 1> rotate 22.5*z translate <4.35, 4, 1.9> }
            difference {
              box { <0, -2.5, -0.375001> <1, 0, 0.375001> }
              difference {
                box { <0.5, -4, -1> <3, -2, 1> }
                cylinder { -2*z, 2*z, 0.5 translate <0.5, -2, 0> }
              }
              rotate 22.5*z translate <4.35, 4, 1.9>
            }
            object { open_rounded_button() rotate -90*z translate <-3.1, -5, 0>
              rotate 22.5*z translate <4.35, 4, 0> }
            #if (setting > 3)
              object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z translate <0, -5, 0>
                rotate 22.5*z translate <4.35, 4, 0> }
            #end
            cylinder { -0.9*x, 0.000001*x, 3.500001 translate <0, -5.000001, 0> rotate 22.5*z translate <4.35, 4, 0> }
            difference {
              box { <1, -5, -6> <8.5, 4.000002, 6> }
              box { <-5, 0, -7> <2.5, 5, 7> }
              box { <-1, 0, -20> <10, 11, -5.9> rotate -10*y rotate 9*x translate <0, -6, 0> }
              box { <-1, 0, 20> <10, 11, 5.9> rotate 10*y rotate -9*x translate <0, -6, 0> }
              box { <0, -20, -10> <10, 1, 10> rotate 22.5*z translate <4.35, 4, 0> }
              difference {
                box { <-10, -20, -10> <10, -5, 10> }
                box { <-5, 0, -20> <0, 11, -4.6> rotate -10*y rotate 9*x rotate -22.5*z translate <-4.35, -10, 0> }
                box { <-5, 0, 20> <0, 11, 4.6> rotate 10*y rotate -9*x rotate -22.5*z translate <-4.35, -10, 0> }
                box { <-5, 2.75, -20> <9, 11, -4.1> rotate -10*y rotate 9*x translate <-4.35, -10, 0> }
                box { <-5, 2.75, 20> <9, 11, 4.1> rotate 10*y rotate -9*x translate <-4.35, -10, 0> }
                rotate 22.5*z
                translate <4.35, 4, 0>
              }
            }
            rotate 10*z
          }
          difference {
            sphere { <0, 0, 0> 6 scale <1.04, 1, 1.04> }
            box { <-7, -7, -7> <0, 7, 7> }
            box { <-7, -7, -7> <7, -0.000001, 7> }
            box { <0, -20, -10> <10, 1, 10> rotate 22.5*z translate <4.350001, 4, 0> }
          }
          difference {
            sphere { <0, 0, 0> 6.000001 scale <1.16, 1, 1.04> }
            box { <0.000001, -7, -7> <8, 7, 7> }
            box { <-8, -7, -7> <8, -0.000001, 7> }
          }
          difference {
            sphere { <0, 0, 0> 6.000002 scale <1.04, 2.25, 1.04> }
            box { <-7, -21, -7> <0, 1, 7> }
            box { <-7, 0.000001, -7> <7, 21, 7> }
          }
          difference {
            sphere { <0, 0, 0> 6.000003 scale <1.16, 2.25, 1.04> }
            box { <0.000001, -21, -7> <8, 1, 7> }
            box { <-8, 0.000001, -7> <8, 21, 7> }
          }
          bounded_by { box { <-7.5, -8, -8.1> <9.1, 7, 8.1> } }
          rotate -10*z
        }
        cylinder { 2*y, 5*y, 0.75 translate <2.5, 0, -6.5> }
        cylinder { 2*y, 5*y, 0.75 translate <2.5, 0, 6.5> }
        sphere { <-1, -0.25, -5.75> 0.7 }
        sphere { <-1, -0.25, 5.75> 0.7 }
        cylinder { -7*z, 7*z, 2.25 translate <-3.75, -1.2, 0 > }
        difference {
          box { <-10, -7, -8> <-4, 1.05, 8> }
          box { <-11, -6, -9> <0, 0, 9> rotate 19*z translate <-4, -3.45, 0> }
        }
        difference {
          box { <-10, -10, -10> <10, 0, 10> rotate 10*z translate <0, -5, 0> }
          cylinder { -0.900001*x, 0.000001*x, 3.500001 translate <0, -5.000001, 0> rotate 22.5*z translate <4.350001, 4.000001, 0> }
        }
        cylinder { -1*y, 5*y, 2.25 }
        cylinder { -9*y, 2*y, 5.1 }
        cone { 1.999999*y, 5, 4*y, 3 }
      }
      object { ring() translate <0, 3, 0> }
      difference {
        merge {
          torus { 1, 0.6 translate <2.5, 0.75, -6.5> }
          torus { 1, 0.6 translate <2.5, 0.75, 6.5> }
          cylinder { -6.500001*z, 6.500001*z, 0.6 translate <1.5, 0.75, 0> }
          cylinder { -6.500001*z, 6.500001*z, 0.6 translate <3.5, 0.75, 0> }
          torus { 1, 0.6 rotate -11*z translate <2.5, -0.05, -6.5> }
          torus { 1, 0.6 rotate -11*z translate <2.5, -0.05, 6.5> }
          cylinder { -6.500001*z, 6.500001*z, 0.6 translate <-1, 0, 0> rotate -11*z translate <2.5, -0.05, 0> }
          cylinder { -6.500001*z, 6.500001*z, 0.6 translate <1, 0, 0> rotate -11*z translate <2.5, -0.05, 0> }
          torus { 1, 0.6 rotate -22*z translate <2.4, -0.9, -6.5> }
          torus { 1, 0.6 rotate -22*z translate <2.4, -0.9, 6.5> }
          cylinder { -6.500001*z, 6.500001*z, 0.6 translate <-1, 0, 0> rotate -22*z translate <2.4, -0.9, 0> }
          cylinder { -6.500001*z, 6.500001*z, 0.6 translate <1, 0, 0> rotate -22*z translate <2.4, -0.9, 0> }
          torus { 1, 0.6 rotate -33*z translate <2.2, -1.55, -6.5> }
          torus { 1, 0.6 rotate -33*z translate <2.2, -1.55, 6.5> }
          cylinder { -6.500001*z, 6.500001*z, 0.6 translate <-1, 0, 0> rotate -33*z translate <2.2, -1.55, 0> }
          cylinder { -6.500001*z, 6.500001*z, 0.6 translate <1, 0, 0> rotate -33*z translate <2.2, -1.55, 0> }
          torus { 1, 0.6 rotate -44*z translate <1.75, -2.25, -6.5> }
          torus { 1, 0.6 rotate -44*z translate <1.75, -2.25, 6.5> }
          cylinder { -6.500001*z, 6.500001*z, 0.6 translate <-1, 0, 0> rotate -44*z translate <1.75, -2.25, 0> }
          cylinder { -6.500001*z, 6.500001*z, 0.6 translate <1, 0, 0> rotate -44*z translate <1.75, -2.25, 0> }
          torus { 1, 0.6 rotate -55*z translate <1, -2.75, -6.5> }
          torus { 1, 0.6 rotate -55*z translate <1, -2.75, 6.5> }
          cylinder { -6.500001*z, 6.500001*z, 0.6 translate <-1, 0, 0> rotate -55*z translate <1, -2.75, 0> }
          cylinder { -6.500001*z, 6.500001*z, 0.6 translate <1, 0, 0> rotate -55*z translate <1, -2.75, 0> }
          torus { 1, 0.6 rotate -66*z translate <0, -3.1, -6.5> }
          torus { 1, 0.6 rotate -66*z translate <0, -3.1, 6.5> }
          cylinder { -6.500001*z, 6.500001*z, 0.6 translate <-1, 0, 0> rotate -66*z translate <0, -3.1, 0> }
          cylinder { -6.500001*z, 6.500001*z, 0.6 translate <1, 0, 0> rotate -66*z translate <0, -3.1, 0> }
          #local counter = 0;
          #while (counter < 20)
          torus {
            1, 0.6 rotate 90*x translate <6.5, 0, 0>
            rotate (90+9.5*counter)*y rotate 24*z translate <-1, -3.5, 0>
          }
          #local counter = counter + 1;
          #end
          }
        cylinder { -1*y, 5*y, 2.250001 }
        cylinder { -9*y, 2*y, 5.100001 }
      }
      difference {
        merge {
          cylinder { -14.900001*x, -11*x, 2.3 }
          object { open_rounded_button() rotate 90*z translate <-11.9, 0, 0> }
          translate <0, -5, 0>
        }
        cylinder { -17*x, -15*x, 1.600001 translate <0, -5, 0> }
        box { <0, 0, -3> <20, 20, 3> rotate -20*z translate <-14.8, -7.3, 0> }
        rotate 24*z
        translate <4.35, 4, 0>
      }
      texture { color_tex }
    }
  #end
#end
#macro hexagonal(color_tex)
  #if (setting = 0)
    difference {
      box { <0, -23.7, -0.75> <43.9, 23.7, 0.75> }
      box { <0, 0, -2> <50, 30, 2> rotate -26.5*z translate <12, 23.7, 0> }
      box { <0, -30, -2> <50, 0, 2> rotate 26.5*z translate <12, -23.7, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -15.9*y, 15.9*y, 2.6 }
        box { <4, -23.700001, -0.75> <43.9, 23.700001, 0.75> }
        box { <-0.000001, -15.899999, -2.600001> <4.000001, 15.899999, 2.600001> }
      }
      box { <0, 0, -2> <20, 20, 2> rotate 45*z translate <4, 15.9, 0> }
      box { <0, -20, -2> <20, 0, 2> rotate -45*z translate <4, -15.9, 0> }
      box { <0, 0, -2> <50, 30, 2> rotate -26.5*z translate <12, 23.7, 0> }
      box { <0, -30, -2> <50, 0, 2> rotate 26.5*z translate <12, -23.7, 0> }
      cylinder { -16*y, 16*y, 1.55 }
      box { <-4, -12.8, -5> <4.000002, 12.8, 5> }
      box { <-4, -17, -1.4> <0, 17, 1.4> }
      box { <-10, -16, -10> <3.25, 16, -2.599999> rotate -27.5*y }
      box { <-10, -16, 2.599999> <3.25, 16, 10> rotate 27.5*y }
      texture { color_tex }
      bounded_by { box { <-3, -23.8, -2.7> <44, 23.8, 2.7> } }
    }
  #end
#end
#macro hhside1_2(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 19.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 19.1, 3.9> }
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 }
            cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 180*y translate <0, 16, 0> }
            object { rounded_button() rotate 180*y translate <8, 16, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
        #end
        box { <-4, 3.1, -2.4> <12, 18, 5> }
      }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 20.9, 4> } }
    }
  #end
#end
#macro hhwheelbase4_2(color_tex)
difference {
  merge {
    #if (setting < 3)
      cylinder { 3*y, 4.8*y, 2.4 }
      cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
      cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
      cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
      cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
      cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
      cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
      cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
    #else
      object { rounded_button() rotate 90*y }
      object { rounded_button() translate <8, 0, 0> }
      object { rounded_button() translate <0, 0, 8> }
      object { rounded_button() translate <8, 0, 8> }
      object { rounded_button() translate <0, 0, 16> }
      object { rounded_button() translate <8, 0, 16> }
      object { rounded_button() translate <0, 0, 24> }
      object { rounded_button() translate <8, 0, 24> }
    #end
    difference {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 27.9> }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <10.4, 2, 26.4> }
      #end
    }
    cylinder { -4.8*z, -2.4*z, 3 translate <4, -0.9, 0> }
    cylinder { 28.8*z, 26.4*z, 3 translate <4, -0.9, 0> }
    cylinder { -11*z, -11.9*z, 2.5 translate <4, -0.9, 0> }
    cylinder { -3.8*z, -11.8*z, 2.25 translate <4, -0.9, 0> }
    cylinder { 35*z, 35.9*z, 2.5 translate <4, -0.9, 0> }
    cylinder { 27.8*z, 35.8*z, 2.25 translate <4, -0.9, 0> }
    box { <0, -3, -3.900001> <5, 0, -2.400001> rotate 41*z translate <4, -0.9, 0> }
    box { <-5, -3, -3.900001> <0, 0, -2.400001> rotate -41*z translate <4, -0.9, 0> }
    box { <0, -3, 27.900001> <5, 0, 26.400001> rotate 41*z translate <4, -0.9, 0> }
    box { <-5, -3, 27.900001> <0, 0, 26.400001> rotate -41*z translate <4, -0.9, 0> }
    #if (setting > 1)
      object { ring() translate <4, 0, 12> }
      box { <-3, 0.000001, 5> <11, 2.1, 5.6> }
      box { <-3, 0.000001, 18.4> <11, 2.1, 19> }
    #end
    intersection {
      merge {
        box { <-0.3, 0, 0> <0.3, 10, 10> rotate -42.5*x translate <4, -3.75, -2.4> }
        box { <-0.3, 0, -10> <0.3, 10, 0> rotate 42.5*x translate <4, -3.75, 26.4> }
      }
      box { <-4, -20, -4> <12, 2.05, 28> }
    }
  }
  box { <3.5, -4, -13> <4.5, 4, -8.999999> }
  cylinder { -4*y, 4*y, 0.5 translate <4, 0, -9> }
  cylinder { -4*z, -12*z, 1.6 translate <4, -0.9, 0> }
  box { <3.5, -4, 37> <4.5, 4, 32.999999> }
  cylinder { -4*y, 4*y, 0.5 translate <4, 0, 33> }
  cylinder { 28*z, 36*z, 1.6 translate <4, -0.9, 0> }
  #if (setting > 1)
    cylinder { 1*y, 4*y, 1.2 }
    cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
    cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
    cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
    cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
    cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
    cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
    cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
  #end
  texture { color_tex }
  bounded_by { box { <-4, -4, -12> <12, 4.9, 36> } }
}
#end
#macro hiwing4_8(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 31.9, 27.9> }
      box { <-4, 3.1, -4> <12.000001, 32, 28> }
      box { <52, -1, -4> <60, 28.8, 28> }
      box { <0, 0, -4> <50, 50, 28> rotate 35.8*z translate <12, 3.1, 0> }
      box { <-50, -50, -4> <0, 0, 28> rotate 35.8*z translate <52.000001, 28.8, 0> }
      box { <-1, -1, -50> <40.8, 40, 0> rotate -11.25*y translate <12, 0, -4> }
      box { <-1, -1, 0> <40.8, 40, 50> rotate 11.25*y translate <12, 0, 28> }
      box { <52, -1, -4> <60, 40, 4.1> }
      box { <52, -1, 19.9> <60, 40, 28> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <59.9, 31.9, 27.9> }
            box { <-4, 3.1, -4> <12.000001, 30, 28> }
            box { <52, -1, -4> <60, 28.8, 28> }
            box { <0, 9.5, 3.9> <28.1, 30, 20.1> }
          }
          #if (setting < 3)
            cylinder { 31.8*y, 33.6*y, 2.4 translate <56, 0, 8> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <56, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
          #else
            object { rounded_button() rotate 180*y translate <56, 28.8, 8> }
            object { rounded_button() rotate 180*y translate <56, 28.8, 16> }
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <0, 0, 16> }
            object { rounded_button() rotate 180*y translate <0, 0, 24> }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 16> }
            object { rounded_button() rotate 180*y translate <8, 0, 24> }
          #end
        }
        box { <52, -1, -4> <60, 40, 4.1> }
        box { <-1, -1, -50> <40.8, 40, 0> rotate -11.25*y translate <12, 0, -4> }
        box { <52, -1, 19.9> <60, 40, 28> }
        box { <-1, -1, 0> <40.8, 40, 50> rotate 11.25*y translate <12, 0, 28> }
        box { <0, 0, -4> <50, 50, 28> rotate 35.8*z translate <12, 3.1, 0> }
        difference {
          box { <-50, -50, -4> <0, 0, 28> rotate 35.8*z translate <52.000001, 28.8, 0> }
          box { <10, 8.6, 3> <29, 30, 21> }
        }
        difference {
          box { <-50, -50, -4> <0, 0, 28> rotate 35.8*z translate <52.000001, 31, 0> }
          box { <4.000001, 8.600001, 3.000001> <29.000001, 30, 21.000001> }
          box { <-10, -1, -50> <60, 40, 0> rotate -11.25*y translate <12, 0.000001, -2.7> }
          box { <-10, -1, 0> <60, 40, 50> rotate 11.25*y translate <12, 0.000001, 26.7> }
          box { <52.1, -1, -4> <60, 40, 28> }
        }
        #if (setting > 1)
          box { <53.6, 28, 5.6> <58.4, 30.8, 18.4> }
          cylinder { 29.8*y, 32.8*y, 1.2 translate <56, 0, 8> }
          cylinder { 29.8*y, 32.8*y, 1.2 translate <56, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          box { <-2.4, -1, -2.4> <10.4, 2, 26.4> }
          cylinder { 0*y, 30*y, 1.600001 translate <24, 0, 8> }
          cylinder { 0*y, 30*y, 1.600001 translate <24, 0, 16> }
        #end
      }
      #if (setting > 1)
        difference {
          box { <20.1, 6.4, 4.1> <27.9, 8.4, 19.9> }
          box { <21.6, 1, 5.6> <26.4, 10, 18.4> }
        }
        object { ring() translate <4, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { pin(2) translate <56, 28.8, 12> }
        object { pin(2) translate <24, 6.4, 12> }
        object { open_rounded_button() translate <24, 6.4, 8> }
        object { open_rounded_button() translate <24, 6.4, 16> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 33.7, 28> } }
    }
  #end
#end
#macro hlblock1_1(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
          #else
            object { rounded_button() rotate 90*y translate <0, 6.4, 0> }
          #end
          box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 1.5, 2.4> }
          box { <-4, 1.5, -4> <-2.4, 10, 4> }
          box { <-1.4, 0, -2.400001> <2.4, 8.6, 2.400001> }
          box { <0, 3.1, -2.4> <4, 7.9, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { -5*x, 5*x, 1.6 translate <0, 5.6, 0> }
        #end
      }
      #if (setting > 0 & setting < 3)
      difference {
        cylinder { -4.1*x, -2.3*x, 2.4 }
        cylinder { -6*x, 6*x, 1.600001 }
        translate <0, 5.6, 0>
      }
      #else
        object { open_rounded_button() rotate 90*z translate <0.6, 5.6, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4.2, -0.1, -4> <4, 11.3, 4> } }
    }
  #end
#end
#macro hlblock4_1(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.9, 9.5, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <3.9, 9.5, 27.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 24> }
            cylinder { -5.6*x, -3.8*x, 2.4 translate <0, 5.6, 0> }
            cylinder { -5.6*x, -3.8*x, 2.4 translate <0, 5.6, 8> }
            cylinder { -5.6*x, -3.8*x, 2.4 translate <0, 5.6, 16> }
            cylinder { -5.6*x, -3.8*x, 2.4 translate <0, 5.6, 24> }
          #else
            object { rounded_button() rotate 90*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <0, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <0, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <0, 6.4, 24> }
            object { open_rounded_button() rotate 90*z translate <-0.8, 5.6, 0> }
            object { open_rounded_button() rotate 90*z translate <-0.8, 5.6, 8> }
            object { open_rounded_button() rotate 90*z translate <-0.8, 5.6, 16> }
            object { open_rounded_button() rotate 90*z translate <-0.8, 5.6, 24> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 8.6, 26.4> }
          cylinder { -6*x, -2*x, 1.600001 translate <0, 5.6, 0> }
          cylinder { -6*x, -2*x, 1.600001 translate <0, 5.6, 8> }
          cylinder { -6*x, -2*x, 1.600001 translate <0, 5.6, 16> }
          cylinder { -6*x, -2*x, 1.600001 translate <0, 5.6, 24> }
        #end
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 8.7*y, 1.5 }
          cylinder { -1*y, 2*y, 0.7 }
          translate <0, 0, 4>
        }
        difference {
          cylinder { 0*y, 8.7*y, 1.5 }
          cylinder { -1*y, 2*y, 0.7 }
          translate <0, 0, 12>
        }
        difference {
          cylinder { 0*y, 8.7*y, 1.5 }
          cylinder { -1*y, 2*y, 0.7 }
          translate <0, 0, 20>
        }
        box { <-3.5, 2, 3.75> <3.5, 8.7, 4.25> }
        box { <-3.5, 2, 11.75> <3.5, 8.7, 12.25> }
        box { <-3.5, 2, 19.75> <3.5, 8.7, 20.25> }
      #end
      texture { color_tex }
      bounded_by { box { <-5.7, -0.1, -4> <4, 11.3, 28> } }
    }
  #end
#end
#macro hmconnect(color_tex)
  #if (setting = 0)
    cylinder { 14.3*y, 0*y, 1.5 texture { color_tex } }
  #else
    merge {
      box { <-3.899999, 0, -1.550001> <-2.350001, 3.899999, 1.550001> }
      cylinder { -3.9*x, -2.35*x, 1.55 }
      box { <-0.600001, 0, -1.550001> <0.600001, 3.899999, 1.550001> }
      cylinder { -0.6*x, 0.6*x, 1.55 }
      box { <2.350001, 0, -1.550001> <3.899999, 3.899999, 1.550001> }
      cylinder { 2.35*x, 3.9*x, 1.55 }
      difference {
        cylinder { -3.9*x, 3.9*x, 1.55 translate <0, 3.9, 0> }
        box { <-4, 3.9, -2> <4, 6, 2> }
      }
      #if (setting < 2)
        cylinder { 3.89*y, 13.4*y, 1.5 }
      #else
        cylinder { 13.47*y, 3.89*y, 1.3 }
        cylinder { 3.89*y, 6.4*y, 1.5 } 
        cylinder { 6.8*y, 7.2*y, 1.5 } 
        cylinder { 7.6*y, 8*y, 1.5 } 
        cylinder { 8.4*y, 8.8*y, 1.5 } 
        cylinder { 9.2*y, 9.6*y, 1.5 }
        cylinder { 10*y, 13.4*y, 1.5 }
      #end
      cylinder { 14.3*y, 13.3*y, 3.1 }
      object { open_rounded_button() translate <0, 11.2, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -1.65, -3.2> <4, 16.1, 3.2> } }
    }
  #end
#end
#macro hookifblock1_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
      cylinder { 0*y, 9.5*y, 1.55 translate <12, 0, -9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
          #end
          cylinder { -3.5*z, -9.000001*z, 1.55 translate <12, 1.55, 0> }
          sphere { <12, 1.55, -9> 1.550001 }
          cylinder { 1.549999*y, -6.5*y, 1.55 translate <12, 0, -9> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -6.6, -10.65> <28, 4.9, 4> } }
    }
  #end
#end
#macro hook_1(color_tex)
  #if (setting = 0)
    merge {
      box { <-2.9, -2.25, -3> <25, 2.25, 3> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -3.000001*z, 3.000001*z, 0.750001 translate <-2.25, 0, 0> rotate -45*z }
        cylinder { -3.000002*z, 3.000001*z, 0.750001 translate <-2.25, 0, 0> rotate 45*z }
        box { <2, -2.25, -0.75> <25, 2, 0.75> }
        box { <2, -0.75, -2.5> <25, 0.5, 2.5> }
        difference {
          cylinder { -3*z, 3*z, 3 }
          cylinder { -4*z, 4*z, 1.6 }
          box { <-5, 0, -4> <0, 5, 4> rotate 45*z }
        }
        difference {
          cylinder { -0.750002*z, 0.750002*z, 5.75 translate <25, 3.5, 0> }
          cylinder { -1*z, 1*z, 2 translate <25, 4, 0> }
          box { <19, -3, -1> <25.00001, 10, 1> } 
        }
        difference {
          cylinder { -2.5*z, 2.5*z, 4.75 translate <25, 4, 0> }
          cylinder { -3*z, 3*z, 3.25 translate <25, 3.75, 0> }
          box { <19, -3, -3> <25.00001, 10, 3> } 
        }
        cylinder { -0.750004*z, 0.750004*z, 1.5 translate <23, 7.75, 0> }
        box { <23, 6, -0.75> <25, 9.25, 0.75> }
        box { <23, 7, -2.5> <25, 8.75, 2.5> }
        cylinder { -2.5*z, 2.5*z, 0.875 translate <23, 7.875, 0> }
      }
      box { <20, 0, -5> <31, 15, -2.5> rotate 10*x translate <0, 0.75, 0> }
      box { <20, 0, 2.5> <31, 15, 5> rotate -10*x translate <0, 0.75, 0> }
      texture { color_tex }
      bounded_by { box { <-3, -3.1, -3.1> <30.85, 9.35, 3.1> } }
    }
  #end
#end
#macro hook_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-23, 0, -3.75> <0, 3, 3.75> }
      box { <-23.000001, 1, -3.750001> <-20, 25.5, 3.7500001> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-23, 0, -3.75> <0, 3, 3.75> }
        box { <-23.000001, 1, -3.750001> <-20, 16.999999, 3.7500001> }
        cylinder { -1.5*z, 1.5*z, 3 translate <-23, 20, 0> }
        cylinder { -1.5*z, 1.5*z, 3 translate <-23, 22.5, 0> }
        box { <-23.000002, 16.999998, -1.500001> <-20.000001, 22.500001, 1.500001> }
      }
      box { <-5, -1, -2.25> <1, 4, -1.5> }
      box { <-5, -1, 1.5> <1, 4, 2.25> }
      box { <-21.5, 1.5, -2.250001> <1, 4, 2.250001> }
      box { <-24, 0, -10> <-19, 14.25, 0> rotate 9*x translate <0, 3, -3.75> }
      box { <-24, 0, 0> <-19, 14.25, 10> rotate -9*x translate <0, 3, 3.75> }
      cylinder { -2.5*z, 2.5*z, 1.6 translate <-23, 20, 0> }
      cylinder { -2.5*z, 2.5*z, 1.6 translate <-23, 22.5, 0> }
      box { <-24.600001, 19.999999, -2.5> <-21.399999, 22.500001, 2.5> }
      box { <-5, -5, -2.5> <0, 0, 2.5> rotate -45*z translate <-23, 21.25, 0> }
      cylinder { -24*x, 19*x, 0.75 translate <0, 11.5, 0> }
      cylinder { -4*z, 4*z, 0.9 translate <-20, 3.9, 0> }
      difference {
        box { <-21.500002, 1.500001, -2.25> <-15, 15, 2.25> }
        box { <-22, 0, -10> <-14, 17, 0> rotate 9*x translate <0, 1.5, -2.25> }
        box { <-22, 0, 0> <-14, 17, 10> rotate -9*x translate <0, 1.5, 2.25> }
      }
      texture { color_tex }
      bounded_by { box { <-26.1, -0.1, -4> <0.1, 25.6, 4> } }
    }
  #end
#end
#macro hook_2_holder(color_tex)
  #if (setting = 0)
    box { <-4.9, 0, -27.9> <4.9, 5.2, 1.55> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-4.9, 0, -27.9> <4.9, 5.2, -3.900005> }
          box { <-3.900001, 0.000001, -5> <-2.4, 3.099999, 0> }
          cylinder { -3.900002*x, -2.399999*x, 1.55 translate <0, 1.55, 0> }
          box { <-0.5, 0.000001, -5> <0.5, 3.099999, 0> }
          cylinder { -0.500001*x, 0.499999*x, 1.55 translate <0, 1.55, 0> }
          box { <2.35, 0.000001, -5> <3.899999, 3.099999, 0> }
          cylinder { 2.350001*x, 3.899998*x, 1.55 translate <0, 1.55, 0> }
          cylinder { -3.9*x, 3.9*x, 1.55 translate <0, 1.550001, -4> }
        }
        box { <-3.9, 1, -30> <3.9, 4.200001, -5> }
        box { <-2.5, 3.899999, -12> <2.5, 6, -7> }
        box { <-1.75, -1, -25> <1.75, 2, -5> }
        box { <-2.500001, 3.899998, -10> <-1.000001, 6, -1> }
        box { <1.000001, 3.899998, -10> <2.500001, 6, -1> }
      }
      box { <-0.5, 2.8, -27.75> <0.5, 4.4, -12.1> }
      box { <-1, 4.2, -10> <1, 5.199999, -4> }
      box { <-1.000001, 2.8, -9.999999> <1.000001, 4.8, -9> }
      texture { color_tex }
      bounded_by { box { <-5, -0.1, -28> <5, 5.3, 1.65> } }
      translate <0, -1.55, 0>
    }
  #end
#end
#macro hook_3(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.8, -19.7, -0.900002> <3.8, -1.2, 0.900002> }
      intersection {
        torus { 3.75, 1.25 rotate 90*x translate <3.75, -22.5, 0> }
        box { <-1.5, -28, -1.5> <9, -22.499999, 1.5> }
      }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { -2.25*z, 2.25*z, 1.2 }
      cylinder { -0.9*z, 0.9*z, 3 }
      box { <-1.8, -7, -0.900003> <1.8, -1, 0.900003> }
      cylinder { -0.900001*z, 0.900001*z, 3.8 translate <0, -8, 0> }
      box { <-3.8, -16.000001, -0.900002> <3.8, -7.999999, 0.900002> }
      cylinder { -0.900001*z, 0.900001*z, 3.8 translate <0, -16, 0> }
      object { open_rounded_button() rotate -90*x translate <0, -8, 2.2> }
      object { open_rounded_button() rotate -90*x translate <0, -16, 2.2> }
      object { open_rounded_button() rotate 90*x translate <0, -8, -2.2> }
      object { open_rounded_button() rotate 90*x translate <0, -16, -2.2> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <0, -8, -0.9> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <0, -16, -0.9> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate 90*x translate <0, -8, 0.9> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate 90*x translate <0, -16, 0.9> }
      #end
      intersection {
        torus { 3.75, 1.25 rotate 90*x translate <3.75, -22.5, 0> }
        box { <-1.5, -28, -1.5> <9, -22.499999, 1.5> }
      }
      sphere { <7.5, -22.500001, 0> 1.250001 }
      cylinder { -22.500003*y, -19.7*y, 1.250004 }
      box { <0, 0, -0.35> <2, 4, 0.35> rotate 30*z translate <-1.25, -21.5, 0> }
      box { <-2, 0, -0.35> <0, 4, 0.35> rotate -30*z translate <1.25, -21.5, 0> }
      texture { color_tex }
      bounded_by { box { <-3.9, -27.6, -3.1> <8.85, 3.1, 3.1> } }
    }
  #end
#end
#macro hook_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, -3.9, -1.55> <3.9, 11.9, 1.55> }
      intersection {
        torus { 3.75, 1.25 rotate 90*x translate <-1, -10, 0> }
        box { <-6, -28, -1.5> <6, -9.999999, 1.5> }
      }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        #if (setting < 3)
          cylinder { -1.45*z, -3.25*z, 2.4 }
          cylinder { -1.45*z, -3.25*z, 2.4 translate <0, 8, 0> }
        #else
          object { rounded_button() rotate -90*y rotate -90*x translate <0, 0, 1.55> }
          object { rounded_button() rotate -90*y rotate -90*x translate <0, 8, 1.55> }
        #end
        box { <-3.9, -3.9, -1.55> <3.9, 11.9, 1.55> }
        intersection {
          torus { 3.75, 1.25 rotate 90*x translate <-1, -10, 0> }
          box { <-6, -28, -1.5> <6, -9.999999, 1.5> }
        }
        intersection {
          cylinder { -1.55*z, 1.55*z, 5 scale <1.1, 1, 1> translate <1, -1.8, 0> }
          box { <-3.900001, -10, -0.65> <2.75, 0, 0.65> }
        }
        sphere { <-4.75, -10.000001, 0> 1.250001 }
        cylinder { -10.000003*y, -3.75*y, 1.250004 translate <2.75, 0, 0> }
        cylinder { -1*z, 1*z, 0.75 translate <0, 16, 0> }
        box { <-0.1, -5, -1.000001> <1, 0.25, 1.000001> rotate -25*z translate <-0.75, 16, 0> }
        box { <-1, -5, -1.000002> <0.1, 0.25, 1.000002> rotate 25*z translate <0.75, 16, 0> }
        box { <-1.5, 11.5, -1.000003> <1.5, 14.5, 1.000003> }
        box { <-0.5, 14, -1.000004> <0.5, 15.5, 1.000004> }
      }
      cylinder { -2*z, 2*z, 0.75 translate <0, 14.5, 0> }
      #if (setting > 1)
        cylinder { -2.45*z, 2*z, 1.2 }
        cylinder { -2.45*z, 2*z, 1.2 translate <0, 8, 0> }
        difference {
          box { <-2.4, -2.4, -0.45> <2.4, 10.4, 2> }
          cylinder { -1*z, 3*z, 1.5 translate <0, 4, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-6.1, -15.1, -3.35> <4, 16.95, 1.65> } }
    }
  #end
#end
#macro hook_5(color_tex)
  #if (setting = 0)
    box { <-4.8, -22.4, -1.5> <4.8, 2, 1.5> texture { color_tex } }
  #else
    difference {
      merge {
        sphere { <0, -0.9, 0> 2.9 }
        cylinder { -1*y, -6.5*y, 1.5 }
        cylinder { -1.5*z, 1.5*z, 3.8 translate <0, -9.6, 0> }
        cylinder { -1.500001*z, 1.500001*z, 4.8 translate <0, -17.6, 0> }
        object { open_rounded_button() rotate -90*x translate <0, -9.6, 1.6> }
        object { open_rounded_button() rotate 90*x translate <0, -9.6, -1.6> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z rotate 90*y translate <0, -9.6, -1.5> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z rotate -90*y translate <0, -9.6, 1.5> }
        #end
        box { <0, -15, -1.500005> <2.5, -11, 1.500005> }
      }
      difference {
        box { <-5, 0, -2.5> <0, 5, 2.5> }
        cylinder { -3*z, 3*z, 1 scale <1, 2.5, 1> translate <-1.5, 0, 0> }
        box { <-4, -1, -3> <-1.5, 2.5, 3> }
        translate <-1.5, 1, 0> rotate 48.15*z translate <0, -17.6, 0>
      }
      cylinder { -3*z, 3*z, 0.9 }
      box { <-0.9, -0.000001, -3> <0.9, 3, -0.9> }
      box { <-0.9, -0.000001, 3> <0.9, 3, 0.9> }
      cylinder { -2*z, 2*z, 2.5 translate <0, -17.6, 0> }
      box { <-7.5, -2.3, -2> <0, 2.3, 2> rotate -41.85*z translate <0, -17.6, 0> }
      texture { color_tex }
      bounded_by { box { <-4.9, -22.5, -3.3> <4.9, 2.1, 3.3> } }
    }
  #end
#end
#macro hook_fblock1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      cylinder { 0*y, 9.5*y, 1.55 translate <4, 0, -9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
          #end
          cylinder { -3.5*z, -9.000001*z, 1.55 translate <4, 1.550002, 0> }
          sphere { <4, 1.550001, -9> 1.55 }
          cylinder { 1.549999*y, 9.5*y, 1.55 translate <4, 0, -9> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -10.65> <12, 9.6, 4> } }
    }
  #end
#end
#macro hook_holder2_3(color_tex)
  #if (setting = 0)
    merge {
      difference {
        box { <-3.9, 0, -3.9> <19.9, 12.7, 11.9> }
        box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <4, 12.7, 0> }
        box { <-20, 0, -10> <20, 20, 20> rotate -43.5*z translate <12, 12.7, 0> }
      }
      box { <0, 0, -0.25> <23.25, 5.5, 8.25> rotate 39*z translate <19.9, 5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        difference {
          merge {
            box { <0, 0, -0.25> <20.5, 5.5, 8.25> }
            box { <-23, -2.5, -0.250001> <0, 3, 8.250001> rotate -12.75*z translate <20.5, 3, 0> }
            cylinder { -0.250002*z, 8.250002*z, 2.999999 translate <20.5, 3, 0> }
          }
          cylinder { -1*z, 11*z, 1.5 translate <20.5, 3, 0> }
          difference {
            box { <-2, 1, -0.25> <20.6, 15, 8.25> }
            box { <-40, 0, -10> <0, 30, 0> rotate -5.7*y translate <20.5, 0, 2.65> }
            box { <-40, 0, 0> <0, 30, 10> rotate 5.7*y translate <20.5, 0, 5.15> }
          }
          cylinder { -10*y, 20*y, 1.25 translate <12, 0, 4> }
          box { <12.000001, -10, 2.750001> <30, 20, 5.250001> }
          rotate 39*z translate <19.9, 5, 0>
        }
        box { <30.399995, 0, 6.3> <50, 50, 10> }
        box { <30.399995, 0, -10> <50, 50, 1.7> }
        box { <-1, 0, -10> <20, 50, 0> rotate -5.7*y translate <12, 0, -0.25> }
        box { <-1, 0, 0>, <20, 50, 10> rotate 5.7*y translate <12, 0, 8.25> }
      }
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <19.9, 12.7, 11.9> }
            box { <-20, 0, -10> <20, 20, 20> texture { color_tex normal { bumping } }
              rotate 43.5*z translate <4, 12.7, 0> }
            box { <-20, 0, -10> <20, 20, 20> texture { color_tex normal { bumping } }
              rotate -43.5*z translate <12, 12.7, 0> }
          }
          #if (setting < 3)
            cylinder { 12.6*y, 14.4*y, 2.4 translate <8, 0, 0> }
            cylinder { 12.6*y, 14.4*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() translate <8, 9.6, 0> }
            object { rounded_button() translate <8, 9.6, 8> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <18.4, 11.8, 10.4> }
            box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <4, 10.7, 0> }
            box { <-20, 0, -10> <20, 20, 20> rotate -43.5*z translate <12, 10.7, 0> }
          }
          cylinder { 10.6*y, 13.6*y, 1.2 translate <8, 0, 0> }
          cylinder { 10.6*y, 13.6*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 12*y, 3.2 }
          cylinder { -1*y, 14*y, 2.6 }
          box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <0, 10.7, -4> }
          translate <4, 0, 4>
        }
        difference {
          cylinder { 0*y, 12*y, 3.2 }
          cylinder { -1*y, 14*y, 2.6 }
          box { <-20, 0, -10> <20, 20, 20> rotate -43.5*z translate <0, 10.7, -4> }
          translate <12, 0, 4>
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.25, -4> <36.5, 24.5, 12> } }
    }
  #end
#end
#macro horn(color_tex)
  #if (setting = 0)
    merge {
      cone { 0*y, 3.9, 16.1*y, 2.4 }
      cylinder { 0*x, 8.4*x, 1.5 translate <0, 9, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cone { 7.000001*y, 2.5, 0*y, 3.9 }
        torus { 2.3, 0.7 translate <0, 7.7, 0> }
        torus { 2.3, 0.7 translate <0, 8.8, 0> }
        torus { 2.3, 0.7 translate <0, 9.9, 0> }
        torus { 2.3, 0.7 translate <0, 11, 0> }
        torus { 2.3, 0.7 translate <0, 12.1, 0> }
        torus { 2.3, 0.7 translate <0, 13.2, 0> }
        torus { 2.3, 0.7 translate <0, 14.3, 0> }
        torus { 2.3, 0.7 translate <0, 15.4, 0> }
        cylinder { 6*y, 16.100001*y, 2.300001 }
        object { open_rounded_button() translate <0, 13.1, 0> }
        #if (setting > 3)
          object { llogo() translate <0, 16.1, 0> }
        #end
        cylinder { 0*x, 8.25*x, 1.5 translate <0, 9, 0> }
        cylinder { 0*x, 8.4*x, 1.35 translate <0, 9, 0> }
        torus { 1.35, 0.15 rotate 90*z translate <8.25, 9, 0> }
      }
      cone { 7*y, 1.5, -1*y, 2.5 }
      cylinder { 16.1*y, 18*y, 1.6 }
      cylinder { 10*y, -1*y, 1.6 }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <8.5, 18, 4> } }
    }
  #end
#end
#macro horn_2(color_tex)
  #if (setting = 0)
    cylinder { -17.9*x, 2.9*x, 1.8 texture { color_tex } }
  #else
    merge {
      cylinder { -15*x, -3*x, 1.5 }
      cylinder { -4*x, 2.9*x, 1.8 }
      difference {
        cylinder { -17.9*x, -12.25*x, 4 }
        torus { 8.5, 7 rotate 90*z translate <-12.25, 0, 0> }
      }
      cylinder { 0*y, 8.5*y, 1.5 }
      cylinder { 8*y, 8.9*y, 2 }
      texture { color_tex }
      bounded_by { box { <-18, -4.1, -4.1> <3, 9, 4.1> } }
    }
  #end
#end
#macro hose_connector(color_tex)
  #if (setting = 0)
    cone { 0*y, 3.1, 9.4*y, 2 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { 0*y, 3.8*y, 3.1 }
        cone { 3.799999*y, 3.100001, 6.8*y, 2 }
        cylinder { 6.7*y, 9.4*y, 2 }
        #if (setting > 1)
          box { <-3.100002, 3.799998, -0.5> <3.100002, 8.800001, 0.5> }
          box { <-0.5, 3.799997, -3.100002> <0.5, 8.800002, 3.100002> }
        #end
      }
      #if (setting > 1)
        cylinder { -1*y, 3.5*y, 2.5 }
        cylinder { -1*y, 6*y, 1.55 }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 9.5, 4> } }
    }
  #end
#end
#macro hose_connector2(color_tex)
  #if (setting = 0)
    cone { 0*y, 3.1, 9.4*y, 2 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { 0*y, 3.8*y, 3.1 }
        cone { 3.799999*y, 3.100001, 6.8*y, 2 }
        cylinder { 6.7*y, 9.4*y, 2 }
      }
      #if (setting > 1)
        cylinder { -1*y, 3.5*y, 2.5 }
        cylinder { -1*y, 6*y, 1.55 }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 9.5, 4> } }
    }
  #end
#end
#macro hose_halfround4(color_tex)
  #if (setting = 0)
    merge {
      difference {
        torus { 12, 1.5 rotate 90*x }
        box { <-20, -20, -5> <20, 0, 5> }
      }
      cylinder { -7*y, 0.000001*y, 1.500001 translate <-12, 0, 0> }
      cylinder { -7*y, 0.000001*y, 1.500001 translate <12, 0, 0> }
      texture { color_tex }
      translate <-12, 7, 0>
    }
  #else
    merge {
      difference {
        torus { 12, 1.5 rotate 90*x }
        box { <-20, -20, -5> <20, 0, 5> }
      }
      cylinder { -7*y, 0.000001*y, 1.500001 translate <-12, 0, 0> }
      cylinder { -7*y, 0.000001*y, 1.500001 translate <12, 0, 0> }
      torus { 1.5, 0.45 translate <-12, -6.6, 0> }
      torus { 1.5, 0.45 translate <-12, -5.5, 0> }
      torus { 1.5, 0.45 translate <-12, -4.4, 0> }
      torus { 1.5, 0.45 translate <-12, -3.3, 0> }
      torus { 1.5, 0.45 translate <-12, -2.2, 0> }
      torus { 1.5, 0.45 translate <-12, -1.1, 0> }
      #local counter = 0;
      #while (counter < 39)
        torus { 1.5, 0.45 translate <12, 0, 0> rotate (counter*4.7)*z }
        #local counter = counter + 1;
      #end
      torus { 1.5, 0.45 translate <12, -6.6, 0> }
      torus { 1.5, 0.45 translate <12, -5.5, 0> }
      torus { 1.5, 0.45 translate <12, -4.4, 0> }
      torus { 1.5, 0.45 translate <12, -3.3, 0> }
      torus { 1.5, 0.45 translate <12, -2.2, 0> }
      torus { 1.5, 0.45 translate <12, -1.1, 0> }
      texture { color_tex }
      bounded_by { box { <-15, -8, -2> <15, 15, 2> } }
      translate <-12, 7, 0>
    }
  #end
#end
#macro hose_nozzle(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -4.5*y, 4*y, 1.5 }
      cylinder { -10.2*x, 5.5*x, 1.5 translate <0, 4, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        torus { 1.35, 0.15 translate <0, -4.35, 0> }
        cylinder { -4.5*y, 0*y, 1.35 }
        cylinder { -4.35*y, 4*y, 1.5 }
        cylinder { -3*x, 5.5*x, 1.5 translate <0, 4, 0> }
        cylinder { -10.2*x, -9.1*x, 1.5 translate <0, 4, 0> }
        cone { -10.25*x, 1.2, -2.999999*x, 1.5 translate <0, 4, 0> }
      }
      cylinder { -11*x, -8.2*x, 0.55 translate <0, 4, 0> }
      cylinder { 0*x, 6*x, 0.9 translate <0, 4, 0> }
      texture { color_tex }
      bounded_by { box { <-10.3, -4.6, -1.6> <5.6, 5.6, 1.6> } }
    }
  #end
#end
#macro hovercraft_base(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -14.5*y, 14*y, 47.9 translate <-80, 0, -32> }
      cylinder { -14.5*y, 14*y, 47.9 translate <-80, 0, 32> }
      box { <-80, -14.50001, -79.9> <127.9, 14.00001, 79.9> }
      box { <-127.9, -14.50002, -32> <-79, 14.00002, 32> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-127.9, -14.5, -79.6> <127.9, 14, 79.6> }
        difference {
          box { <-128, -15, -80> <128, 15, 80> }
          cone { 6.5*y, 47.9, 14.00005*y, 40.4 translate <-80, 0, -32> }
          cone { 6.5*y, 47.9, 14.00005*y, 40.4 translate <-80, 0, 32> }
          box { <0, -15, -32> <15, 0, 32> rotate -45*z translate <-120.4, 14, 0> }
          box { <-120.4, -14.50005, -32.00001> <-80, 14.00005, 32.00001> }
          box { <-80, -15, 0> <128, 1, 15> rotate 45*x translate <0, 14, -72.4> }
          box { <-80, -15, -15> <128, 1, 0> rotate -45*x translate <0, 14, 72.4> }
          box { <-80, 0, -72.1> <128, 14.00006, 72.1> }
          box { <-80, -14.50006, -71.4> <128, 0, 71.4> }
          box { <-127.89999, -6.30001, -32> <-80, 6.50001, 32> }
          cylinder { -6.3*y, 6.5*y, 47.9 translate <-80, 0, -32> }
          cylinder { -6.3*y, 6.5*y, 47.9 translate <-80, 0, 32> }
          box { <-80, -6.3, -79.59999> <127.89995, 6.5, 79.59999> }
          box { <-79.99999, 15, 0> <128, 0, 15> rotate -45*x translate <0, -14.5, -71.40001> }
          box { <-79.99999, 15, -15> <128, 0, 0> rotate 45*x translate <0, -14.5, 71.40001> }
          cone { -14.50007*y, 39.7, -6.29999*y, 47.9 translate <-80, 0, -32> }
          cone { -14.50007*y, 39.7, -6.29999*y, 47.9 translate <-80, 0, 32> }
          box { <0, -15, -32.00001> <15, 15, 32.00001> rotate 45*z translate <-119.70001, -14.5, 0> }
        }
        union {
          cylinder { 10.8*y, 15*y, 32.1 translate <-80, 0, -32> }
          cylinder { 10.8*y, 15*y, 32.1 translate <-80, 0, 32> }
          box { <-112.10001, 10.80001, -32> <-70, 15, 32> }
          box { <-80.00001, 10.80002, -64.10001> <128, 15, 64.10001> }
          box { <111.9, 7.6, -64.1> <128, 11, -47.9> }
          box { <111.9, 7.6, 64.1> <128, 11, 47.9> }
          box { <87.9, 7.6, -40.1> <104.1, 11, -23.9> }
          box { <87.9, 7.6, 40.1> <104.1, 11, 23.9> }
          box { <55.9, 7.6, -64.1> <72.1, 11, -47.9> }
          box { <55.9, 7.6, 64.1> <72.1, 11, 47.9> }
          box { <-8.1, 7.6, -64.1> <8.1, 11, -47.9> }
          box { <-8.1, 7.6, 64.1> <8.1, 11, 47.9> }
          box { <-72.1, 7.6, -64.1> <-55.9, 11, -47.9> }
          box { <-72.1, 7.6, 64.1> <-55.9, 11, 47.9> }
          box { <-87.9, 7.6, -40.1> <-104.1, 11, -23.9> }
          box { <-87.9, 7.6, 40.1> <-104.1, 11, 23.9> }
          texture { color_tex finish { reflection 0.05 } }
        }
        box { <-48.1, -15, -56.1> <-15.9, 15, -7.9> }
        box { <48.1, -15, -56.1> <15.9, 15, -7.9> }
        box { <-48.1, -15, 56.1> <-15.9, 15, 7.9> }
        box { <48.1, -15, 56.1> <15.9, 15, 7.9> }
        difference {
          box { <-126.4, -15, -78.1> <128, 9.8, 78.1> }
          box { <-9.3, 6.9, -65.3> <9.3, 10, -46.7> }
          box { <-9.3, 6.9, 65.3> <9.3, 10, 46.7> }
          box { <-73.3, 6.9, -65.3> <-54.7, 10, -46.7> }
          box { <-73.3, 6.9, 65.3> <-54.7, 10, 46.7> }
          box { <-86.7, 6.9, -41.3> <-105.3, 10, -22.7> }
          box { <-86.7, 6.9, 41.3> <-105.3, 10, 22.7> }
          box { <73.3, 6.9, -65.3> <54.7, 10, -46.7> }
          box { <73.3, 6.9, 65.3> <54.7, 10, 46.7> }
          box { <86.7, 6.9, -41.3> <105.3, 10, -22.7> }
          box { <86.7, 6.9, 41.3> <105.3, 10, 22.7> }
          box { <110.7, 6.9, -65.3> <128, 10, -46.7> }
          box { <110.7, 6.9, 65.3> <128, 10, 46.7> }
          object { high_ring() translate <0, 1.3, -56> }
          object { high_ring() translate <0, 1.3, 56> }
          object { high_ring() translate <-64, 1.3, -56> }
          object { high_ring() translate <-64, 1.3, 56> }
          object { high_ring() translate <-96, 1.3, -32> }
          object { high_ring() translate <-96, 1.3, 32> }
          object { high_ring() translate <64, 1.3, -56> }
          object { high_ring() translate <64, 1.3, 56> }
          object { high_ring() translate <96, 1.3, -32> }
          object { high_ring() translate <96, 1.3, 32> }
          object { high_ring() translate <120, 1.3, -56> }
          object { high_ring() translate <120, 1.3, 56> }
          merge {
            difference {
              cylinder { 1.3*y, 10*y, 8 }
              cylinder { 0*y, 11*y, 7 }
            }
            box { <3, 1.30001, -0.5> <7.5, 10, 0.5> }
            box { <3, 1.30001, -0.5> <7.5, 10, 0.5> rotate 120*y }
            box { <3, 1.30001, -0.5> <7.5, 10, 0.5> rotate 240*y }
            translate <-96, 0, -32>
          }
          merge {
            difference {
              cylinder { 1.3*y, 10*y, 8 }
              cylinder { 0*y, 11*y, 7 }
            }
            box { <3, 1.30001, -0.5> <7.5, 10, 0.5> }
            box { <3, 1.30001, -0.5> <7.5, 10, 0.5> rotate 120*y }
            box { <3, 1.30001, -0.5> <7.5, 10, 0.5> rotate 240*y }
            rotate 180*y translate <-96, 0, 32>
          }
          merge {
            difference {
              cylinder { 1.3*y, 10*y, 8 }
              cylinder { 0*y, 11*y, 7 }
            }
            box { <3, 1.30001, -0.5> <7.5, 10, 0.5> }
            box { <3, 1.30001, -0.5> <7.5, 10, 0.5> rotate 120*y }
            box { <3, 1.30001, -0.5> <7.5, 10, 0.5> rotate 240*y }
            translate <96, 0, -32>
          }
          merge {
            difference {
              cylinder { 1.3*y, 10*y, 8 }
              cylinder { 0*y, 11*y, 7 }
            }
            box { <3, 1.30001, -0.5> <7.5, 10, 0.5> }
            box { <3, 1.30001, -0.5> <7.5, 10, 0.5> rotate 120*y }
            box { <3, 1.30001, -0.5> <7.5, 10, 0.5> rotate 240*y }
            rotate 180*y translate <96, 0, 32>
          }
          box { <-64.5, 1.30001, -53> <-63.5, 10, 53> }
          box { <-0.5, 1.30001, -53> <0.5, 10, 53> }
          box { <63.5, 1.30001, -53> <64.5, 10, 53> }
          box { <-64.5, 1.30001, -59> <-63.5, 10, -64.5> }
          box { <-0.5, 1.30001, -59> <0.5, 10, -64.5> }
          box { <63.5, 1.30001, -59> <64.5, 10, -64.5> }
          box { <-64.5, 1.30001, 59> <-63.5, 10, 64.5> }
          box { <-0.5, 1.30001, 59> <0.5, 10, 64.5> }
          box { <63.5, 1.30001, 59> <64.5, 10, 64.5> }
          box { <-112.5, 1.30002, -0.5> <117.5, 10, 0.5> }
          box { <-15, -15, -32> <1.5, 0, 32> rotate -45*z translate <-118.9, 14, 0> }
          box { <-80, -15, -15> <128, 0, 1.5> rotate 45*x translate <0, 14, -70.6> }
          box { <-80, -15, -1.5> <128, 0, 15> rotate -45*x translate <0, 14, 70.6> }
          difference {
            merge {
              cylinder { -15*y, 8.4*y, 32.90001 translate <-80, 0, -32> }
              cylinder { -15*y, 8.4*y, 32.90001 translate <-80, 0, 32> }
            }
            box { <-79.99999, -16, -70> <0, 9, 70> }
            box { <-112.09999, -16, -32> <0, 9, 32> }
            cylinder { -16*y, 9*y, 32.1 translate <-80, 0, -32> }
            cylinder { -16*y, 9*y, 32.1 translate <-80, 0, 32> }
          }
          box { <-112.9, 8.40001, -32> <-112.1, -15, 32> }
          box { <-80, -14.49998, -65> <128, 15, -64.3> }
          box { <-80, -14.49998, 65> <128, 15, 64.3> }
          box { <-64.35, -14.49999, -80> <-63.65, 15, -64.5> }
          box { <-32.35, -14.49999, -80> <-31.65, 15, -64.5> }
          box { <-0.35, -14.49999, -80> <0.35, 15, -64.5> }
          box { <32.35, -14.49999, -80> <31.65, 15, -64.5> }
          box { <64.35, -14.49999, -80> <63.65, 15, -64.5> }
          box { <96.35, -14.49999, -80> <95.65, 15, -64.5> }
          box { <127.2, -14.49999, -80> <128, 15, -64.5> }
          box { <-0.35, -14.49999, -46.5> <0.35, 15, -32.5> rotate 22.5*y translate <-80, 0, -32> }
          box { <-0.35, -14.49999, -46.5> <0.35, 15, -32.5> rotate 67.5*y translate <-80, 0, -32> }
          box { <-64.35, -14.49999, 80> <-63.65, 15, 64.5> }
          box { <-32.35, -14.49999, 80> <-31.65, 15, 64.5> }
          box { <-0.35, -14.49999, 80> <0.35, 15, 64.5> }
          box { <32.35, -14.49999, 80> <31.65, 15, 64.5> }
          box { <64.35, -14.49999, 80> <63.65, 15, 64.5> }
          box { <96.35, -14.49999, 80> <95.65, 15, 64.5> }
          box { <127.2, -14.49999, 80> <128, 15, 64.5> }
          box { <-0.35, -14.49999, -46.5> <0.35, 15, -32.5> rotate 112.5*y translate <-80, 0, 32> }
          box { <-0.35, -14.49999, -46.5> <0.35, 15, -32.5> rotate 157.5*y translate <-80, 0, 32> }
          box { <-128, -14.49999, -16.35> <-112, 15, -15.65> }
          box { <-128, -14.49999, 16.35> <-112, 15, 15.65> }
          difference {
            merge {
              cylinder { -6.30001*y, 6.50001*y, 47.90001 translate <-80, 0, -32> }
              cylinder { -6.30001*y, 6.50001*y, 47.90001 translate <-80, 0, 32> }
              cone { -14.50008*y, 39.70001, -6.29998*y, 47.90001 translate <-80, 0, -32> }
              cone { -14.50008*y, 39.70001, -6.29998*y, 47.90001 translate <-80, 0, 32> }
            }
            cylinder { -15*y, 15*y, 46.40001 translate <-80, 0, -32> }
            cylinder { -15*y, 10*y, 46.40001 translate <-80, 0, 32> }
            box { <-79.99999, -16, -90> <0, 9, 90> }
            box { <-126.39999, -16, -32> <0, 9, 32> }
          }
          difference {
            merge {
              cone { 6.49999*y, 47.90001, 14.00006*y, 40.40001 translate <-80, 0, -32> }
              cone { 6.49999*y, 47.90001, 14.00006*y, 40.40001 translate <-80, 0, 32> }
            }
            cone { 6.4*y, 45.9, 14.00007*y, 38.4 translate <-80, 0, -32> }
            cone { 6.4*y, 45.9, 14.00007*y, 38.4 translate <-80, 0, 32> }
            box { <-79.99999, 0, -80> <0, 20, 80> }
          }
          box { <116.9, -11.4, -47.4> <117.6, 15, 47.4> }
          box { <112.20001, -11.40001, -46.70001> <117.60001, 15, -47.40001> }
          box { <112.20001, -11.40001, 46.70001> <117.60001, 15, 47.40001> }
          box { <112.2, -11.4, -46.7> <112.9, 25, -64.75> }
          box { <112.2, -11.4, 46.7> <112.9, 25, 64.75> }
          box { <115, 1.3, -46.70002> <127.90002, 15, -47.40002> }
          box { <115, 1.3, 46.70002> <127.90002, 15, 47.40002> }
          box { <127.2, 1.30001, -46.70003> <128, 15, -64.5> }
          box { <127.2, 1.30001, 46.70003> <128, 15, 64.5> }
          box { <119.6, 1.30002, -47> <120.4, 15, -53> }
          box { <119.6, 1.30002, 47> <120.4, 15, 53> }
          box { <123, 1.30003, -56.4> <128, 15, -55.6> }
          box { <123, 1.30003, 56.4> <128, 15, 55.6> }
          difference {
            merge {
              box { <117, -11.40005, -39.65> <128, 15, -40.35> }
              box { <117, -11.40005, -23.65> <128, 15, -24.35> }
              box { <117, -11.40005, -7.65> <128, 15, -8.35> }
              box { <117, -11.40005, 7.65> <128, 15, 8.35> }
              box { <117, -11.40005, 23.65> <128, 15, 24.35> }
              box { <117, -11.40005, 39.65> <128, 15, 40.35> }
            }
            box { <0, -30, -50> <10, 10, 50> rotate -20*z translate <127.9, 7.7, 0> }
          }
        }
        cylinder { -15*y, 15*y, 2.50001 translate <-96, 0, -32> }
        cylinder { -15*y, 15*y, 2.50001 translate <-96, 0, 32> }
        cylinder { -15*y, 15*y, 2.50001 translate <-64, 0, -56> }
        cylinder { -15*y, 15*y, 2.50001 translate <-64, 0, 56> }
        cylinder { -15*y, 15*y, 2.50001 translate <0, 0, -56> }
        cylinder { -15*y, 15*y, 2.50001 translate <0, 0, 56> }
        cylinder { -15*y, 15*y, 2.50001 translate <64, 0, -56> }
        cylinder { -15*y, 15*y, 2.50001 translate <64, 0, 56> }
        cylinder { -15*y, 15*y, 2.50001 translate <96, 0, -32> }
        cylinder { -15*y, 15*y, 2.50001 translate <96, 0, 32> }
        cylinder { -15*y, 15*y, 2.50001 translate <120, 0, -56> }
        cylinder { -15*y, 15*y, 2.50001 translate <120, 0, 56> }
        cylinder { 7.1*y, 15*y, 3.1 translate <-96, 0, -32> }
        cylinder { 7.1*y, 15*y, 3.1 translate <-96, 0, 32> }
        cylinder { 7.1*y, 15*y, 3.1 translate <-64, 0, -56> }
        cylinder { 7.1*y, 15*y, 3.1 translate <-64, 0, 56> }
        cylinder { 7.1*y, 15*y, 3.1 translate <0, 0, -56> }
        cylinder { 7.1*y, 15*y, 3.1 translate <0, 0, 56> }
        cylinder { 7.1*y, 15*y, 3.1 translate <64, 0, -56> }
        cylinder { 7.1*y, 15*y, 3.1 translate <64, 0, 56> }
        cylinder { 7.1*y, 15*y, 3.1 translate <96, 0, -32> }
        cylinder { 7.1*y, 15*y, 3.1 translate <96, 0, 32> }
        cylinder { 7.1*y, 15*y, 3.1 translate <120, 0, -56> }
        cylinder { 7.1*y, 15*y, 3.1 translate <120, 0, 56> }
      }
      texture { color_tex finish { reflection 0 } }
      bounded_by { box { <-128, -14.6, -79.7> <128, 14.1, 79.7> } }
    }
  #end
#end
#macro hrbase4_4(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 9.5*y, 15.9 translate <12, 0, 12> texture { color_tex } }
  #else
    difference {
      merge {
        object { open_rounded_button() translate <8, 6.4, 0> }
        object { open_rounded_button() translate <16, 6.4, 0> }
        object { open_rounded_button() translate <0, 6.4, 8> }
        object { open_rounded_button() translate <8, 6.4, 8> }
        object { open_rounded_button() translate <16, 6.4, 8> }
        object { open_rounded_button() translate <24, 6.4, 8> }
        object { open_rounded_button() translate <0, 6.4, 16> }
        object { open_rounded_button() translate <8, 6.4, 16> }
        object { open_rounded_button() translate <16, 6.4, 16> }
        object { open_rounded_button() translate <24, 6.4, 16> }
        object { open_rounded_button() translate <8, 6.4, 24> }
        object { open_rounded_button() translate <16, 6.4, 24> }
        difference {
          cylinder { 0*y, 9.5*y, 15.9 }
          #if (setting > 1)
            cylinder { -1*y, 8.6*y, 14.9 }
          #end
          translate <12, 0, 12>
        }
        #if (setting > 1)
          object { high_ring() translate <12, 0, 4> }
          object { high_ring() translate <4, 0, 12> }
          cylinder { 0*y, 8.7*y, 3.2 translate <12, 0, 12> }
          object { high_ring() translate <20, 0, 12> }
          object { high_ring() translate <12, 0, 20> }
          cylinder { 0*y, 8.7*y, 3.2 translate <4, 0, 4> }
          cylinder { 0*y, 8.7*y, 3.2 translate <20, 0, 4> }
          cylinder { 0*y, 8.7*y, 3.2 translate <4, 0, 20> }
          cylinder { 0*y, 8.7*y, 3.2 translate <20, 0, 20> }
          box { <-15, 0.000001, -3.200001> <-11.999999, 8.7, 3.200001> rotate 45*y translate <12, 0, 12> }
          box { <-15, 0.000001, -3.200001> <-11.999999, 8.7, 3.200001> rotate 135*y translate <12, 0, 12> }
          box { <-15, 0.000001, -3.200001> <-11.999999, 8.7, 3.200001> rotate 225*y translate <12, 0, 12> }
          box { <-15, 0.000001, -3.200001> <-11.999999, 8.7, 3.200001> rotate 315*y translate <12, 0, 12> }
          box { <11.5, 2, 6.9> <12.5, 8.7, 9.1> }
          box { <11.5, 2, 14.9> <12.5, 8.7, 17.1> }
          box { <6.9, 2, 11.5> <9.1, 8.7, 12.5> }
          box { <14.9, 2, 11.5> <17.1, 8.7, 12.5> }
        #end
        cylinder { -3*z, 3.5*z, 3.5 translate <12, 5.6, 0> }
        cylinder { -3*x, 3.5*x, 3.5 translate <0, 5.6, 12> }
        cylinder { 20.5*x, 27*x, 3.5 translate <0, 5.6, 12> }
        cylinder { 20.5*z, 27*z, 3.5 translate <12, 5.6, 0> }
      }
      object { axle_opening(10,1) rotate 90*z translate <12, 0, 12> }
      cylinder { -1*y, 2*y, 2.6 translate <12, 0, 12> }
      cylinder { -4*z, 4*z, 2.5 translate <12, 5.6, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <12, 5.6, 0> }
      cylinder { -4*x, 4*x, 2.5 translate <0, 5.6, 12> }
      cylinder { -5*x, -3.4*x, 3.1 translate <0, 5.6, 12> }
      cylinder { 20*z, 28*z, 2.5 translate <12, 5.6, 0> }
      cylinder { 27.4*z, 29*z, 3.1 translate <12, 5.6, 0> }
      cylinder { 20*x, 28*x, 2.5 translate <0, 5.6, 12> }
      cylinder { 27.4*x, 29*x, 3.1 translate <0, 5.6, 12> }
      #if (setting > 1)
        box { <8, -1, 3.25> <16, 8.700001, 4.75> }
        box { <8, -1, 19.25> <16, 8.700001, 20.75> }
        box { <3.25, -1, 8> <4.75, 8.700001, 16> }
        box { <19.25, -1, 8> <20.75, 8.700001, 16> }
        cylinder { -1*y, 8*y, 2.5 translate <4, 0, 4> }
        cylinder { -1*y, 8*y, 2.5 translate <20, 0, 4> }
        cylinder { -1*y, 8*y, 2.5 translate <4, 0, 20> }
        cylinder { -1*y, 8*y, 2.5 translate <20, 0, 20> }
        box { <-25, -1, -2.500001> <-11.999998, 2, 2.500001> rotate 45*y translate <12, 0, 12> }
        box { <-25, -1, -2.500001> <-11.999998, 2, 2.500001> rotate 135*y translate <12, 0, 12> }
        box { <-25, -1, -2.500001> <-11.999998, 2, 2.500001> rotate 225*y translate <12, 0, 12> }
        box { <-25, -1, -2.500001> <-11.999998, 2, 2.500001> rotate 315*y translate <12, 0, 12> }
        intersection {
          merge {
            box { <-25, 1.999998, -2.500001> <-11.999998, 8, 2.500001> rotate 45*y translate <12, 0, 12> }
            box { <-25, 1.999998, -2.500001> <-11.999998, 8, 2.500001> rotate 135*y translate <12, 0, 12> }
            box { <-25, 1.999998, -2.500001> <-11.999998, 8, 2.500001> rotate 225*y translate <12, 0, 12> }
            box { <-25, 1.999998, -2.500001> <-11.999998, 8, 2.500001> rotate 315*y translate <12, 0, 12> }
          }
          cylinder { 1*y, 9*y, 14.900002 translate <12, 0, 12> }
        }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 11.3*y, 16 translate <12, 0, 12> } }
    }
  #end
#end
#macro hrblock1_1(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 9.5*y, 3.9 texture { color_tex } }
  #else
    difference {
      merge {
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
        #else
          object { open_rounded_button() translate <0, 6.4, 0> }
        #end
        cylinder { 2*y, 9.5*y, 3.9 }
        cylinder { 0*y, 2.5*y, 3.15 }
      }
      cylinder { -0.4*y, 8.6*y, 2.5 }
      cylinder { 2*y, 12*y, 1.60001 }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 11.3, 4> } }
    }
  #end
#end
#macro hrblock1_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 12.7, 3.9> }
      difference {
        box { <-4, 0, -3.95> <3.9, 13, 3.95> }
        cylinder { -4*z, 4*z, 7.8 translate <3.9, 4.9, 0> }
      }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <3.9, 12.7, 3.9> }
          box { <-2.4, -1, -2.4> <2.4, 6.300001, 2.4> }
        }
        difference {
          box { <3, 6.4, -3.900001> <11.9, 9.5, 3.900001> }
          box { <3.900001, 4, -2.4> <10.4, 8.6, 2.4> }
        }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
        #else
          object { rounded_button() rotate 180*y translate <8, 6.4, 0> }
        #end
        #if (setting > 1)
          box { <3.8, 6.4, -0.5> <5.6, 8.7, 0.5> }
        #end
      }
      #if (setting > 1)
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
      #end
      difference {
        box { <-5, 4.899999, -4> <4, 13, 4> }
        cylinder { -4*z, 4*z, 7.8 translate <3.9, 4.9, 0> }
        cylinder { -3*z, 3*z, 6.3 translate <3.9, 4.9, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 12.8, 4> } }
    }
  #end
#end
#macro hrblock1_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 19.1, 3.9> }
      difference {
        box { <-4, 0, -3.95> <12, 20, 3.95> }
        cylinder { -5*z, 5*z, 1 scale <15.5, 19, 1> translate <11.6, 0, 0> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <19.9, 19.1, 3.9> }
        cylinder { -4*z, 4*z, 7.9 translate <11.9, 4.8, 0> }
        box { <3.900001, -1, -4> <20, 4.900001, 4> }
        box { <11.899999, 4.9, -4> <20, 12.700001, 4> }
        box { <11.9, 15.9, -4> <20, 20, 4> }
        box { <12, 0, -2.4> <18.4, 15, 2.4> }
        difference {
          box { <-4, -1, -4> <12, 20, 4> }
          cylinder { -5*z, 5*z, 1 scale <15.5, 19, 1> translate <11.9, 0, 0> }
        }
        difference {
          box { <-2.4, -1, -2.4> <2.9, 20, 2.4> }
          difference {
            box { <-4, -1, -4> <12, 20, 4> }
            cylinder { -5*z, 5*z, 1 scale <14, 17.5, 1> translate <11.900001, 0, 0> }
          }
        }
        difference {
          box { <3.900002, -1, -2.4> <10.9, 20, 2.4> }
          difference {
            box { <-4, -1, -4> <12, 20, 4> }
            cylinder { -5*z, 5*z, 1 scale <14, 17.5, 1> translate <11.900002, 0, 0> }
          }
        }
        #if (setting > 1)
          cylinder { 13.8*y, 16.8*y, 1.2 translate < 16, 0, 0> }
        #end
      }
      #if (setting < 3)
        cylinder { 15.8*y, 17.6*y, 2.4 translate <16, 0, 0> }
      #else
        object { rounded_button() rotate 180*y translate <16, 12.8, 0> }
      #end
      #if (setting > 1)
        box { <11.9, 12.8, -0.5> <13.6, 15.1, 0.5> }
        box { <2.4, 0.1, -0.5> <3, 15, 0.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 19.2, 4> } }
    }
  #end
#end
#macro hrblock1_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 31.9, 3.9> }
      difference {
        box { <-4, 0, -3.95> <44, 40, 3.95> }
        cylinder { -5*z, 5*z, 1 scale <31.9, 31.9, 1> translate <27.9, 0, 0> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <43.9, 31.9, 3.9> }
        #if (setting > 1)
          cylinder { 26.6*y, 29.600005*y, 1.200005 translate <32, 0, 0> }
          cylinder { 26.6*y, 29.600005*y, 1.200005 translate <40, 0, 0> }
        #end
        cylinder { -4*z, 4*z, 1 scale <23.9, 25.5, 1> translate <27.9, 0, 0> }
        box { <27.899999, -1, -4> <44, 25.500001, 4> }
        box { <27.9, 28.7, -4> <50, 40, 4> }
        box { <28, 0, -2.4> <42.4, 27.8, 2.4> }
        difference {
          box { <-4, -1, -4> <44, 40, 4> }
          cylinder { -5*z, 5*z, 1 scale <31.9, 31.9, 1> translate <27.9, 0, 0> }
          box { <30, 0, -5> <43.900005, 28.700005, 5> }
        }
        difference {
          box { <-2.4, -1, -2.4> <2.4, 30, 2.4> }
          difference {
            box { <-4, -1, -4> <44, 30, 4> }
            cylinder { -5*z, 5*z, 1 scale <30.4, 30.4, 1> translate <27.900001, 0, 0> }
          }
        }
        difference {
          box { <3.900002, -1, -2.4> <26.4, 30, 2.4> }
          difference {
            box { <-4, -1, -4> <44, 30, 4> }
            cylinder { -5*z, 5*z, 1 scale <30.4, 30.4, 1> translate <27.900002, 0, 0> }
          }
        }
        #if (setting > 1)
          cylinder { 26.6*y, 29.6*y, 1.2 translate <32, 0, 0> }
          cylinder { 26.6*y, 29.6*y, 1.2 translate <40, 0, 0> }
        #end
      }
      #if (setting < 3)
        cylinder { 28.6*y, 30.4*y, 2.4 translate <32, 0, 0> }
        cylinder { 28.6*y, 30.4*y, 2.4 translate <40, 0, 0> }
      #else
        object { rounded_button() rotate -90*y translate <32, 25.6, 0> }
        object { rounded_button() rotate -90*y translate <40, 25.6, 0> }
      #end
      #if (setting > 1)
        box { <27.9, 25.6, -0.5> <29.6, 27.9, 0.5> }
        object { pin(2) translate <36, 25.5, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 32, 4> } }
    }
  #end
#end
#macro hrblock2_2(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 9.5*y, 7.9 translate <4, 0, 4> texture { color_tex } }
  #else
    merge {
      intersection {
        merge {
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 0> }
            object { rounded_button() translate <0, 6.4, 8> }
            object { rounded_button() translate <8, 6.4, 8> }
          #end
        }
        cylinder { 8*y, 12*y, 7.900001 translate <4, 0, 4> }
      }
        difference {
          cylinder { 0*y, 9.5*y, 7.900001 translate <4, 0, 4> }
          #if (setting > 1)
            cylinder { -1*y, 8*y, 6.4 translate <4, 0, 4> }
            cylinder { -1*y, 2*y, 2.6 translate <0, 0, 0> }
            cylinder { -1*y, 2*y, 2.6 translate <8, 0, 0> }
            cylinder { -1*y, 2*y, 2.6 translate <0, 0, 8> }
            cylinder { -1*y, 2*y, 2.6 translate <8, 0, 8> }
            object { axle_opening(10,1) rotate 90*z translate <4, -0.25, 4> }
            box { <-6.4, 7, -1> <-4.5, 10, 1> rotate 45*y translate <4, 0, 4> }
            box { <-6.4, 7, -1> <-4.5, 10, 1> rotate 135*y translate <4, 0, 4> }
            box { <-6.4, 7, -1> <-4.5, 10, 1> rotate 225*y translate <4, 0, 4> }
            box { <-6.4, 7, -1> <-4.5, 10, 1> rotate -45*y translate <4, 0, 4> }
          #end
        }
      box { <-2.6, 3, 3.5> <1.8, 8.6, 4.5> }
      box { <6.2, 3, 3.5> <10.6, 8.6, 4.5> }
      box { <3.5, 3, 6.2> <4.5, 8.6, 10.6> }
      box { <3.5, 3, -2.6> <4.5, 8.6, 1.8> }
      object { high_ring() translate <4, 0, 4> }
      texture { color_tex }
      bounded_by { cylinder { -0*y, 11.3*y, 8 translate <4, 0, 4> } }
    }
  #end
#end
#macro hrblock2_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 11.9> }
      difference {
        box { <12, 1.5, -4> <20, 10, 12> }
        cylinder { -4*z, 12*z, 8 translate <12, 1.5, 0> }
      }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
        #else
          object { rounded_button() rotate 180*y translate <0, 6.4, 0> }
          object { rounded_button() rotate 180*y translate <0, 6.4, 8> }
          object { rounded_button() rotate 180*y translate <8, 6.4, 0> }
          object { rounded_button() rotate 180*y translate <8, 6.4, 8> }
        #end
        difference {
          box { <-3.9, 0, -3.9> <19.9, 9.5, 11.9> }
          difference {
            box { <12, 1.5, -4> <20, 10, 12> }
            cylinder { -4*z, 12*z, 8 translate <12, 1.5, 0> }
          }
        difference {
            box { <-2.4, -1, -2.4> <18.4, 8.6, 10.4> }
            difference {
              box { <12, 1.5, -2.5> <20, 10, 10.5> }
              cylinder { -4*z, 12*z, 7.1 translate <12, 1.5, 0> }
            }
          }
          box { <10, -1, -2.400001> <18.400001, 1.500001, 10.400001> }
        }
        #if (setting > 1)
          object { high_ring() translate <4, 0, 4> }
          object { high_ring() translate <12, 0, 4> }
        #end
      }
      #if (setting > 1)
        cylinder { 7.4*y, 10.4*y, 1.2 }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 12> } }
    }
  #end
#end
#macro hrblock2_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 19.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <27.9, 19.1, 11.9> }
            difference {
              box { <-5, 11.299999, -4.0> <29, 20, 12> }
              cylinder { -5*z, 13*z, 7.8 translate <3.9, 11.3, 0> }
              cylinder { -5*z, 13*z, 7.8 translate <20.1, 11.3, 0> }
              box { <3.899999, 10, -5> <20.100001, 19.099999, 13> }
            }
            cylinder { -2.4*z, 10.4*z, 6.3 translate <3.9, 11.3, 0> }
            cylinder { -2.4*z, 10.4*z, 6.3 translate <20.1, 11.3, 0> }
            box { <-2.4, -1, -2.400001> <26.4, 11.300001, 10.400001> }
            box { <3.899999, -1, -2.400002> <20.100001, 18.2, 10.400002> }
          }
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 8> }
          #else
            object { rounded_button() translate <8, 16, 0> }
            object { rounded_button() translate <8, 16, 8> }
            object { rounded_button() translate <16, 16, 0> }
            object { rounded_button() translate <16, 16, 8> }
          #end
        }
        #if (setting > 1)
          cylinder { 17*y, 20*y, 1.2 translate <8, 0, 0> }
          cylinder { 17*y, 20*y, 1.2 translate <8, 0, 8> }
          cylinder { 17*y, 20*y, 1.2 translate <16, 0, 0> }
          cylinder { 17*y, 20*y, 1.2 translate <16, 0, 8> }
        #end
      }
      #if (setting > 1)
        box { <11.7, 2.7, -3.5> <12.3, 18.7, 1.5> }
        box { <11.7, 2.7, 6.5> <12.3, 18.7, 11.5> }
        difference {
          cylinder { 0*y, 18.7*y, 3.2 }
          cylinder { -1*y, 19*y, 2.6 }
          translate <12, 0, 4>
        }
        difference {
          merge {
            difference {
              cylinder { 0*y, 18.7*y, 3.2 }
              cylinder { -1*y, 19*y, 2.6 }
              translate <4, 0, 4>
            }
            difference {
              cylinder { 0*y, 18.7*y, 3.2 }
              cylinder { -1*y, 19*y, 2.6 }
              translate <20, 0, 4>
            }
          }
          difference {
            box { <-5, 11.299999, -4.0> <29, 19, 12> }
            cylinder { -5*z, 13*z, 7.5 translate <3.9, 11.3, 0> }
            cylinder { -5*z, 13*z, 7.5 translate <20.1, 11.3, 0> }
            box { <3.899999, 10, -5> <20.100001, 18.899999, 13> }
          }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 20.9, 12> } }
    }
  #end
#end
#macro hrblock4_1(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <3.9, 12.7, 27.9> }
      difference {
        box { <-5, 4.899999, -4.0> <4, 13, 27.900001> }
        cylinder { -4*z, 28*z, 7.8 translate <3.9, 4.9, 0> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        difference {
          box { <-3.9, 0, -3.9> <3.9, 12.7, 27.9> }
          difference {
            box { <-2.4, -1, -2.4> <2.4, 6.300001, 26.4> }
            box { <-3, 0.25, 11.6> <3, 7, 12.4> }
          }
        }
        difference {
          box { <-5, 4.899999, -4.0> <4, 13, 27.900001> }
          cylinder { -4*z, 28*z, 7.8 translate <3.9, 4.9, 0> }
          cylinder { -4*z, 28*z, 6.3 translate <3.9, 4.9, 0> }
        }
      }
      #if (setting > 1)
        difference {
          box { <-2.5, 0.000001, 0> <2.5, 15, 24> }
          box { <-2.5, -1, -2.5> <2.5, 20, 2.5> rotate 45*y translate <0, 0, 0> }
          box { <-2.5, -1, -2.5> <2.5, 20, 2.5> rotate 45*y translate <0, 0, 8> }
          box { <-2.5, -1, -2.5> <2.5, 20, 2.5> rotate 45*y translate <0, 0, 16> }
          box { <-2.5, -1, -2.5> <2.5, 20, 2.5> rotate 45*y translate <0, 0, 24> }
          box { <-2.6, -1, 2.5> <2.6, 20, 5.5> }
          box { <-2.6, -1, 10.5> <2.6, 20, 13.5> }
          box { <-2.6, -1, 18.5> <2.6, 20, 21.5> }
          difference {
            box { <-5, 4.899999, -4.0> <4, 20, 27.900001> }
            cylinder { -4*z, 28*z, 7.7 translate <3.9, 4.9, 0> }
          }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 12.8, 28> } }
    }
  #end
#end
#macro hrblock4_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 12.7, 27.9> }
      difference {
        box { <-4, 0, -3.95> <3.9, 13, 27.95> }
        cylinder { -4*z, 28*z, 7.8 translate <3.9, 4.9, 0> }
      }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <3.9, 12.7, 27.9> }
          box { <-2.4, -1, -2.4> <2.4, 6.300001, 26.4> }
        }
        difference {
          box { <3, 6.4, -3.900001> <11.9, 9.5, 27.900001> }
          box { <3.900001, 4, -2.4> <10.4, 8.6, 26.4> }
        }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 16> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 24> }
        #else
          object { rounded_button() rotate 180*y translate <8, 6.4, 0> }
          object { rounded_button() rotate 180*y translate <8, 6.4, 8> }
          object { rounded_button() rotate 180*y translate <8, 6.4, 16> }
          object { rounded_button() rotate 180*y translate <8, 6.4, 24> }
        #end
        box { <3.8, 6.4, -0.5> <5.6, 8.7, 0.5> }
        box { <3.8, 6.4, 7.5> <5.6, 8.7, 8.5> }
        box { <3.8, 6.4, 15.5> <5.6, 8.7, 16.5> }
        box { <3.8, 6.4, 23.5> <5.6, 8.7, 24.5> }
        difference {
          merge {
            cylinder { 0*y, 8.7*y, 1.5 translate <0, 0, 4> }
            cylinder { 0*y, 8.7*y, 1.5 translate <0, 0, 12> }
            cylinder { 0*y, 8.7*y, 1.5 translate <0, 0, 20> }
            box { <-3.5, 0.1, 3.5> <3.5, 8.7, 4.5> }
            box { <-3.5, 0.1, 11.5> <3.5, 8.7, 12.5> }
            box { <-3.5, 0.1, 19.5> <3.5, 8.7, 20.5> }
          }
          difference {
            box { <-5, 4.899999, -4> <4, 13, 28> }
            cylinder { -4*z, 28*z, 7.7 translate <3.9, 4.9, 0> }
          }
        }
        object { pin(2) translate <8, 6.4, 4> }
        object { pin(2) translate <8, 6.4, 12> }
        object { pin(2) translate <8, 6.4, 20> }
      }
      #if (setting > 1)
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 16> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 24> }
      #end
      difference {
        box { <-5, 4.899999, -4> <4, 13, 28> }
        cylinder { -4*z, 28*z, 7.8 translate <3.9, 4.9, 0> }
        cylinder { -4*z, 28*z, 6.3 translate <3.9, 4.9, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 12.8, 28> } }
    }
  #end
#end
#macro hrblock4_4(color_tex)
  #if (setting = 0)
    intersection {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
      cylinder { -1*y, 9.6*y, 31.8 translate <-3.9, 0, -3.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          intersection {
            box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
            cylinder { -1*y, 9.6*y, 31.8 translate <-3.9, 0, -3.9> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 24> }
          #else
            object { rounded_button() rotate 90*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <0, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <0, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <0, 6.4, 24> }
          #end
        }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 24> }
          intersection {
            box { <-2.4, -1, -2.4> <26.4, 8.6, 26.4> }
            cylinder { -2*y, 9*y, 28.7 translate <-3, 0, -3> }
          }
          cylinder { -1*y, 2*y, 2.5 translate <0, 0, 24> }
          cylinder { -1*y, 2*y, 2.5 translate <24, 0, 0> }
          cylinder { -1*y, 2*y, 2.5 translate <16, 0, 16> }
          box { <-2.5, -1, -2> <2.5, 2, 2> rotate 23*y translate <8, 0, 24> }
          box { <-2.5, -1, -2> <2.5, 2, 2> rotate 67*y translate <24, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { high_ring() translate <4, 0, 4> }
        object { high_ring() translate <4, 0, 20> }
        object { high_ring() translate <12, 0, 12> }
        object { high_ring() translate <20, 0, 4> }
        box { <3.5, 0.000001, -3> <4.5, 8.7, 1.1> }
        box { <3.5, 0.000002, 6.9> <4.5, 8.7, 17.1> }
        box { <11.5, 0.000003, -3> <12.5, 8.7, 9.1> }
        box { <19.5, 0.000004, -3> <20.5, 8.7, 1.1> }
        box { <-3, 0.000005, 3.5> <1.1, 8.7, 4.5> }
        box { <6.9, 0.000006, 3.5> <17.1, 8.7, 4.5> }
        box { <-3, 0.000007, 11.5> <9.1, 8.7, 12.5> }
        box { <-3, 0.000008, 19.5> <1.1, 8.7, 20.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 28> } }
    }
  #end
#end
#macro hrblock4_4_open(color_tex)
  #if (setting = 0)
    difference {
      intersection {
        box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
        cylinder { -1*y, 10*y, 31.8 translate <-3.9, 0, -3.9> }
      }
      cylinder { -1*y, 4*y, 24.1 translate <-3.9, 0, -3.9> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        intersection {
          box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
          cylinder { -1*y, 10*y, 31.8 translate <-3.9, 0, -3.9> }
        }
        object { rounded_button() rotate -90*y translate <0, 6.4, 24> }
        object { rounded_button() rotate -90*y translate <16, 6.4, 16> }
        object { rounded_button() rotate -90*y translate <24, 6.4, 0> }
      }
      cylinder { -1*y, 10*y, 24.1 translate <-3.9, 0, -3.9> }
      #if (setting > 1)
        box { <5.2, -1, 0> <10.8, 2, 28> }
        box { <0, -1, 5.2> <28, 2, 10.8> }
        difference {
          intersection {
            box { <-2.4, -1, -2.4> <26.4, 8.6, 26.4> }
            cylinder { -1*y, 9*y, 30.3 translate <-3.9, 0, -3.9> }
            cylinder { -1*y, 9*y, 25.5 translate <-3.9, 0, -3.9> inverse }
          }
          difference {
            box { <12.4, 0.00003, 12.4> <19.6, 9, 19.6> }
            box { <13.6, -1, 13.6> <18.4, 10, 18.4> }
          }
          box { <2.4, 0.00002, 20> <3.6, 9, 28> }
          box { <0, 0.00002, 2.4> <28, 9, 3.6> }
          box { <-0.5, 0.00003, 21> <0.5, 9, 21.6> }
          box { <21, 0.00003, -0.5> <21.6, 9, 0.5> }
        }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 24> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 28> } }
    }
  #end
#end
#macro hrcone1_1(color_tex)
  #if (setting = 0)
    cone { 0*y, 3.9, 9.5*y, 2.4 texture { color_tex } }
  #else
    difference {
      merge {
        #if (setting > 2)
          object { open_rounded_button() translate <0, 6.4, 0> }
        #end
        #if (setting > 0 & setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
        #end
        cone { 2*y, 3.9, 9.5*y, 2.400001 }
        cylinder { 0*y, 2.5*y, 3.15 }
      }
      #if (setting > 1)
        cylinder { -1*y, 2*y, 2.4 }
        cylinder { -1*y, 12*y, 1.60001 }
        object { axle_opening(6,1) rotate 90*z translate <0, -1, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 11.3, 4> } }
    }
  #end
#end
#macro hrcone2_2(color_tex)
  #if (setting = 0)
    merge {
      cone { 19.1*y, 3.9, 1.999999*y, 7.9 translate <4, 0, 4> }
      cylinder { 0*y, 2*y, 7.900001 translate <4, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          object { open_rounded_button() translate <4, 16, 4> }
          cone { 19.1*y, 3.9, 1.999999*y, 7.9 translate <4, 0, 4> }
          cylinder { 0*y, 2*y, 7.900001 translate <4, 0, 4> }
        }
        #if (setting > 1)
          cylinder { -1*y, 21*y, 1.600001 translate <4, 0, 4> }
          merge { 
            cone { 18.1*y, 2.4, 1.999999*y, 6.400001 translate <4, 0, 4> }
            cylinder { -1*y, 2*y, 6.4 translate <4, 0, 4> }
          }
          box { <-2.4, -1, -2.4> <10.4, 2.000001, 10.4> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            difference {
              cylinder { 0*y, 18.2*y, 3.2 }
              cylinder { -1*y, 20*y, 2.6 }
              translate <4, 0, 4>
            }
            box { <-2.6, 2, 3.5> <1.8, 18, 4.5> }
            box { <6.2, 2, 3.5> <10.6, 18, 4.5> }
          }
          box { <-10, 0, -2> <0, 20, 2> rotate -15*z translate <-2.4, 2, 4> }
          box { <0, 0, -2> <10, 20, 2> rotate 15*z translate <10.4, 2, 4> }
        }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 20.9*y, 8 translate <4, 0, 4> } }
    }
  #end
#end
#macro hrwheelbase2_2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 4.2*y, 5.4*y, 7.9 translate <4, 0, 4> }
      box { <0.5, -3, -0.75> <7.5, 4.5, 0.75> }
      box { <0.5, -3, 7.25> <7.5, 4.5, 8.75> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { 4.2*y, 5.4*y, 7.9 translate <4, 0, 4> }
          box { <0.5, -3, -0.75> <7.5, 4.5, 8.75> }
        }
        #if (setting > 1)
          cylinder { 4*y, 6*y, 0.9 translate <2.5, 0, 4> }
          cylinder { 4*y, 6*y, 0.9 translate <5.5, 0, 4> }
        #end
        box { <0, -4, 0.75> <8, 4.199999, 7.25> }
        cylinder { -1*z, 9*z, 0.85 translate <4, 0, 0> }
        box { <-5, -10, -1> <0, 0, 9> rotate 15.1*z translate <0.5, 4.2, 0> }
        box { <0, -10, -1> <5, 0, 9> rotate -15.1*z translate <7.5, 4.2, 0> }
        box { <-0.6, -10, -1> <0.6, 0, 9> rotate -10.1*z translate <4, 0, 0> }
        box { <-0.6, -10, -1> <0.6, 0, 9> rotate 10.1*z translate <4, 0, 0> }
        difference {
          box { <0, -4, -1> <8, 0, 9> }
          cylinder { -2*z, 10*z, 2.5 translate <4, 0.5, 0> }
        }
        difference {
          box { <2.9, -3, -1> <5.1, -1.4, 9> }
          cylinder { -1*z, 9*z, 0.4 translate <5.1, -1.4, 0> }
          cylinder { -1*z, 9*z, 0.4 translate <2.9, -1.4, 0> }
        }
      }
      difference {
        merge {
          object { open_rounded_button() translate <0, 2.3, 0> }
          object { open_rounded_button() translate <8, 2.3, 0> }
          object { open_rounded_button() translate <0, 2.3, 8> }
          object { open_rounded_button() translate <8, 2.3, 8> }
        }
        difference {
          box { <-10, 0, -10> <10, 10, 10> }
          cylinder { -1*y, 11*y, 7.900001 }
          translate <4, 0, 4>
        }
      }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 5.4, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 5.4, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 5.4, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 5.4, 8> }
      #end
      texture { color_tex }
      bounded_by { cylinder { -2.1*y, 7.2*y, 8 } translate <4, 0, 4> }
    }
  #end
#end
#macro hrwindow1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 11.3, 3.9> }
      cylinder { -3.900001*z, 3.900001*z, 7.8 translate <4, 11.299999, 0> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
      #end
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 17.7, 3.9> }
          cylinder { -3.900001*z, 3.900001*z, 7.9 translate <4, 17.699999, 0> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 0*y, 4*y, 0.7 translate <4, 0, -1.3> }
          cylinder { 0*y, 4*y, 0.7 translate <4, 0, 1.3> }
        #end
        cylinder { -4*z, 4*z, 6.3 translate <4, 17.7, 0> }
        box { <-2.4, 3.1, -4> <10.4, 17.700001, 4> }
      }
      object { open_rounded_button() translate <4, 22.4, 0> }
      #if (setting > 3)
        object { llogo() scale <0.75, 0.75, 0.75> translate <4, 25.5, 0> }
      #end
      box { <-3, 3, -0.5> <11, 4.1, 0.5> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 27.3, 4> } }
    }
  #end
#end
#macro hrwindow_lattice_1_2(color_tex)
  merge {
    difference {
      merge {
        cylinder { -2.4*z, -0.6*z, 6.2 translate <4, 17.7, 0> }
        box { <-2.2, 3.2, -2.40001> <10.2, 17.70001, -0.60001> }
        sphere { <0, 0, 0> 0.5 translate <-2.2, 16.2, -1.5> }
        sphere { <0, 0, 0> 0.5 translate <10.2, 16.2, -1.5> }
        sphere { <0, 0, 0> 0.5 translate <4, 3.2, -1.5> }
      }
      cylinder { -2.5*z, -0.5*z, 5.2 translate <4, 17.7, 0> }
      box { <-1.2, 4.2, -2.5> <9.2, 17.70005, -0.5> }
    }
    box { <0, -0.4, -2.3> <7.6, 0.4, -0.7> rotate 45*z translate <4, 4.2, 0> }
    box { <-7.6, -0.4, -2.30001> <0, 0.4, -0.70001> rotate -45*z translate <4, 4.2, 0> }
    box { <-7.6, -0.4, -2.3> <7.6, 0.4, -0.7> rotate 45*z translate <4, 9.7, 0> }
    box { <-7.6, -0.4, -2.30001> <7.6, 0.4, -0.70001> rotate -45*z translate <4, 9.7, 0> }
    box { <-7.6, -0.4, -2.3> <7.6, 0.4, -0.7> rotate 45*z translate <4, 15.1, 0> }
    box { <-7.6, -0.4, -2.30001> <7.6, 0.4, -0.70001> rotate -45*z translate <4, 15.1, 0> }
    box { <-7.6, -0.4, -2.3> <3.5, 0.4, -0.7> rotate 45*z translate <4, 20.5, 0> }
    box { <-3.5, -0.4, -2.30001> <7.6, 0.4, -0.70001> rotate -45*z translate <4, 20.5, 0> }
    texture { color_tex } 
    bounded_by { box { <-2.8, 2.6, -2.5> <10.8, 24, -0.5> } }
  }
#end
#macro hsblock1_1(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> }
      box { <-4, 3.1, -2.4> <2.4, 10.4> }
      texture { color_tex }
    }
  #else
    difference {
      box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
      #end
      box { <-4, 3.1, -2.4> <2.4, 10, 4> }
      difference {
        box { <-4, 9, -4> <-3.4, 10, -2> }
        cylinder { -5*z, -1*z, 0.5 translate <-3.4, 9, 0> }
      }
      difference {
        box { <2, 9, 3.4> <4, 10, 4> }
        cylinder { 1*x, 5*x, 0.5 translate <0, 9, 3.4> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 9.6, 4> } }
    }
  #end
#end
#macro hsblock1_2(color_tex, age)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      box { <-4, 3.1, -2.5> <12, 10, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
        box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
      }
      object { pin(age) translate <4, 0, 0> }
      box { <-3.899999, 0.000001, -3.899999> <11.899999, 9.5, -2.500001> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 9.6, 4> } }
    }
  #end
#end
#macro hsblock1_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> }
      box { <-4, 3.1, -2.5> <28, 10, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
      #end
      difference {
        box { <-3.899999, 0.000001, -3.899999> <27.899999, 9.5, -2.500001> }
        difference {
          box { <-4, 9, -4> <-3.4, 10, -2> }
          cylinder { -5*z, -1*z, 0.5 translate <-3.4, 9, 0> }
        }
        difference {
          box { <27.4, 9, -4> <28, 10, -2> }
          cylinder { -5*z, -1*z, 0.5 translate <27.4, 9, 0> }
        }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 9.6, 4> } }
    }
  #end
#end
#macro hswheelbase2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 7, -3.9> <11.9, 8.4, 11.9> }
      box { <-5, 0, -0.75> <2.3, 7.000001, 8.75> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 7, -3.9> <11.9, 8.4, 11.9> }
          cylinder { -0.7500001*z, 8.7500001*z, 2.5 translate <-4, 0, 0> }
          box { <-5, 0, -0.75> <2.3, 7.000001, 8.75> }
        }
        box { <-8, -4, 0.750001> <4, 7.000002, 7.250001> }
        box { <-10, -2, 0.75> <0, 0, 7.25> rotate -13*z translate <0, 7, 0> }
        cylinder { -1*z, 9*z, 1 translate <-4, 0, 0> }
        box { <-5, -5, -1> <0, 0, 9> rotate -13*z translate <-3.900001, 7, 0> }
        box { <0, 0, -1> <5, 8, 9> rotate -31*z translate <-1.5, 0, 0> }
        box { <-4.7, -4, -1> <-3.3, 0, 9> }
        difference {
          box { <-5.1, -3, -1> <-2.9, -1.8, 9> }
          cylinder { -1*z, 9*z, 0.4 translate <-5.1, -1.8, 0> }
          cylinder { -1*z, 9*z, 0.4 translate <-2.9, -1.8, 0> }
        }
      }
      object { open_rounded_button() translate <0, 5.3, 0> }
      object { open_rounded_button() translate <8, 5.3, 0> }
      object { open_rounded_button() translate <0, 5.3, 8> }
      object { open_rounded_button() translate <8, 5.3, 8> }
      #if (setting > 3)
        object { llogo() rotate 180*y scale <0.65, 0.65, 0.65> translate <0, 8.4, 0> }
        object { llogo() rotate 180*y scale <0.65, 0.65, 0.65> translate <8, 8.4, 0> }
        object { llogo() rotate 180*y scale <0.65, 0.65, 0.65> translate <0, 8.4, 8> }
        object { llogo() rotate 180*y scale <0.65, 0.65, 0.65> translate <8, 8.4, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-6.6, -2.6, -4> <12, 10.2, 12> } }
    }
  #end
#end
#macro huge_3_propellor(color_tex)
  #if (setting = 0)
    merge {
      box { <0, -1, -3> <35.5, 1, 3> rotate -12.5*x translate <0, 2.5, 0> }
      box { <0, -1, -3> <35.5, 1, 3> rotate -12.5*x translate <0, 2.5, 0> rotate 120*y }
      box { <0, -1, -3> <35.5, 1, 3> rotate -12.5*x translate <0, 2.5, 0> rotate 240*y }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { 0*y, 5.7*y, 3.7 }
        cylinder { -1*y, 0.6*y, 2.4 translate <-4, 0, -4> }
        cylinder { -1*y, 0.6*y, 2.4 translate <-4, 0, 4> }
        cylinder { -1*y, 0.6*y, 2.4 translate <4, 0, -4> }
        cylinder { -1*y, 0.6*y, 2.4 translate <4, 0, 4> }
        cylinder { -1*y, 5.700001*y, 2.5 }
      }
      difference {
        cylinder { 5.6*y, 6.4*y, 3.1 }
        cylinder { 5*y, 7*y, 2.500001 }
      }
      difference {
        merge {
          cone { 2.5*x, 1.35, 34.5*x, 1 scale <1, 1, 3.703703703> }
          sphere { <34.499999, 0, 0> 0.999999 scale <1, 1, 3.703703703> }
        }
        box { <0, -10, 0> <10, 10, 10> rotate -20*y translate <2.5, 0, 2.5> }
        box { <0, -10, -10> <10, 10, 0> rotate 20*y translate <2.5, 0, -2.5> }
        rotate -12.5*x
        translate <0, 2.5, 0>
      }
      difference {
        merge {
          cone { 2.5*x, 1.35, 34.5*x, 1 scale <1, 1, 3.703703703> }
          sphere { <34.499999, 0, 0> 0.999999 scale <1, 1, 3.703703703> }
        }
        box { <0, -10, 0> <10, 10, 10> rotate -20*y translate <2.5, 0, 2.5> }
        box { <0, -10, -10> <10, 10, 0> rotate 20*y translate <2.5, 0, -2.5> }
        rotate -12.5*x
        translate <0, 2.5, 0>
        rotate 120*y
      }
      difference {
        merge {
          cone { 2.5*x, 1.35, 34.5*x, 1 scale <1, 1, 3.703703703> }
          sphere { <34.499999, 0, 0> 0.999999 scale <1, 1, 3.703703703> }
        }
        box { <0, -10, 0> <10, 10, 10> rotate -20*y translate <2.5, 0, 2.5> }
        box { <0, -10, -10> <10, 10, 0> rotate 20*y translate <2.5, 0, -2.5> }
        rotate -12.5*x
        translate <0, 2.5, 0>
        rotate 240*y
      }
      texture { color_tex }
      bounded_by { box { <-35.6, -0.1, -35.6> <35.6, 6.5, 35.6> } }
    }
  #end
#end
#macro huge_propellor(color_tex)
  #if (setting = 0)
    box { <-35.5, 0, -4.9> <35.5, 5.9, 4.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          cylinder { 0*y, 3.7*y, 3.7 }
          box { <-1, -1, -2.35> <1, 4, 2.35> }
          box { <-2.35, -1, -1> <2.35, 4, 1> }
        }
        difference {
          merge {
            cone { 2.5*x, 1.35, 34.5*x, 1 scale <1, 1, 3.703703703> }
            sphere { <34.499999, 0, 0> 0.999999 scale <1, 1, 3.703703703> }
          }
          box { <0, -10, 0> <10, 10, 10> rotate -20*y translate <2.5, 0, 2.5> }
          box { <0, -10, -10> <10, 10, 0> rotate 20*y translate <2.5, 0, -2.5> }
          rotate -12.5*x
          translate <0, 3.5, 0>
        }
        difference {
          merge {
            cone { -2.5*x, 1.35, -34.5*x, 1 scale <1, 1, 3.703703703> }
            sphere { <-34.499999, 0, 0> 0.999999 scale <1, 1, 3.703703703> }
          }
          box { <-10, -10, 0> <0, 10, 10> rotate 20*y translate <-2.5, 0, 2.5> }
          box { <-10, -10, -10> <0, 10, 0> rotate -20*y translate <-2.5, 0, -2.5> }
          rotate 12.5*x
          translate <0, 3.5, 0>
        }
      }
      cone { 3.7*y, 2.5, 4*y, 4 }
      cylinder { 3.999999*y, 10*y, 4.000001 }
      texture { color_tex }
      bounded_by { box { <-35.6, -0.1, -5> <35.6, 6, 5> } }
    }
  #end
#end
#macro hvconnect1_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 19.1, 3.9> }
      box { <-2.4, 3.1, -4> <26.4, 17, 4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <27.9, 19.1, 3.9> }
        box { <-3.899998, 19.000001, -3.475> <-2.55, 20.750001, -0.525> }
        cylinder { -3.899999*x, -2.550001*x, 1.55 translate <0, 20.75, -2> }
        box { <3.3, 19.000001, -3.475> <4.7, 20.750001, -0.525> }
        cylinder { 3.300001*x, 4.700001*x, 1.55 translate <0, 20.75, -2> }
        box { <11.3, 19.000001, -3.475> <12.7, 20.750001, -0.525> }
        cylinder { 11.300001*x, 12.700001*x, 1.55 translate <0, 20.75, -2> }
        box { <19.3, 19.000001, -3.475> <20.7, 20.750001, -0.525> }
        cylinder { 19.300001*x, 20.700001*x, 1.55 translate <0, 20.75, -2> }
        box { <26.55, 19.000001, -3.475> <27.899998, 20.750001, -0.525> }
        cylinder { 26.550001*x, 27.899999*x, 1.55 translate <0, 20.75, -2> }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
        box { <21.6, -1, -2.4> <26.4, 2, 2.4> }
      #end
      box { <4, -1, -2.4> <20, 2, 4> }
      box { <4.000001, -1, 0> <20.000001, 4, 4> }
      box { <-2.4, 3.100001, -2.9> <26.4, 17, 4> }
      box { <-2, 3.100002, -4> <26, 16.5, 0> }
      cylinder { 15*y, 20*y, 2 translate <-0.4, 0, 2> }
      cylinder { 15*y, 20*y, 2 translate <24.4, 0, 2> }
      box { <-2.4, 15, 2> <26.4, 20, 4> }
      box { <-0.4, 15, 0> <24.4, 20, 4> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 22.4, 8> } }
    }
  #end
#end
#macro h_arch1_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 3.9> }
      cylinder { -4*z, 4*z, 4.1 translate <8, 2.4, 0> }
      box { <4, -0.1, -4> <12, 2.40001, 4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <19.9, 9.51, 3.9> }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
        #else
          object { rounded_button() translate <0, 6.4, 0> }
          object { rounded_button() translate <8, 6.4, 0> }
          object { rounded_button() translate <16, 6.4, 0> }
        #end
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 8.6, 2.4> }
        box { <13.6, -1, -2.4> <18.4, 8.6, 2.4> }
        box { <3.9, -1, -2.4> <12.1, 8.6, 2.4> }
        cylinder { 7.4*y, 10.4*y, 1.2 }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
      #end
      cylinder { -4*z, 4*z, 4.1 translate <8, 2.4, 0> }
      box { <3.90001, -0.1, -4> <12.10001, 2.40001, 4> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 4> } }
    }
  #end
#end
#macro h_arch1_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> }
      cylinder { -5*z, 5*z, 8 scale <1, 0.8, 1> translate <12, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
        #else
          object { rounded_button() translate <0, 6.4, 0> }
          object { rounded_button() translate <8, 6.4, 0> }
          object { rounded_button() translate <16, 6.4, 0> }
          object { rounded_button() translate <24, 6.4, 0> }
        #end
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 8.6, 2.4> }
        box { <21.6, -1, -2.4> <26.4, 8.6, 2.4> }
        box { <3.9, -1, -2.4> <20.1, 8.6, 2.4> }
        cylinder { 7.4*y, 10.4*y, 1.2 }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
      #end
      cylinder { -5*z, 5*z, 8 scale <1, 0.8, 1> translate <12, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 4> } }
    }
  #end
#end
#macro h_arch1_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 9.5, 3.9> }
      cylinder { -5*z, 5*z, 25 translate <20, -19, 0> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting < 3)
        cylinder { 9.4*y, 11.2*y, 2.4 }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 0> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <40, 0, 0> }
      #else
        object { rounded_button() translate <0, 6.4, 0> }
        object { rounded_button() translate <8, 6.4, 0> }
        object { rounded_button() translate <16, 6.4, 0> }
        object { rounded_button() translate <24, 6.4, 0> }
        object { rounded_button() translate <32, 6.4, 0> }
        object { rounded_button() translate <40, 6.4, 0> }
      #end
      difference {
        box { <-3.9, 0, -3.9> <43.9, 9.5, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 8.6, 2.4> }
          box { <37.6, -1, -2.4> <42.4, 8.6, 2.4> }
          box { <4, -1, -2.4> <36, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 0> }
        #end
        cylinder { -5*z, 5*z, 25 translate <20, -19, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 11.3, 4> } }
    }
  #end
#end
#macro h_arch1_8(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 19.1, 3.9> }
      cylinder { -5*z, 5*z, 27 translate <28, -12.2, 0> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting < 3)
        cylinder { 19*y, 20.8*y, 2.4 }
        cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 0> }
        cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 0> }
        cylinder { 19*y, 20.8*y, 2.4 translate <24, 0, 0> }
        cylinder { 19*y, 20.8*y, 2.4 translate <32, 0, 0> }
        cylinder { 19*y, 20.8*y, 2.4 translate <40, 0, 0> }
        cylinder { 19*y, 20.8*y, 2.4 translate <48, 0, 0> }
        cylinder { 19*y, 20.8*y, 2.4 translate <56, 0, 0> }
      #else
        object { rounded_button() translate <0, 16, 0> }
        object { rounded_button() translate <8, 16, 0> }
        object { rounded_button() translate <16, 16, 0> }
        object { rounded_button() translate <24, 16, 0> }
        object { rounded_button() translate <32, 16, 0> }
        object { rounded_button() translate <40, 16, 0> }
        object { rounded_button() translate <48, 16, 0> }
        object { rounded_button() translate <56, 16, 0> }
      #end
      difference {
        box { <-3.9, 0, -3.9> <59.9, 19.1, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 18.2, 2.4> }
          box { <53.6, -1, -2.4> <58.4, 18.2, 2.4> }
          box { <4, -1, -2.4> <52, 18.2, 2.4> }
          cylinder { 17*y, 20*y, 1.2 }
          cylinder { 17*y, 20*y, 1.2 translate <8, 0, 0> }
          cylinder { 17*y, 20*y, 1.2 translate <16, 0, 0> }
          cylinder { 17*y, 20*y, 1.2 translate <24, 0, 0> }
          cylinder { 17*y, 20*y, 1.2 translate <32, 0, 0> }
          cylinder { 17*y, 20*y, 1.2 translate <40, 0, 0> }
          cylinder { 17*y, 20*y, 1.2 translate <48, 0, 0> }
          cylinder { 17*y, 20*y, 1.2 translate <56, 0, 0> }
        #end
        cylinder { -5*z, 5*z, 27 translate <28, -12.2, 0> }
      }
      #if (setting > 1)
        box { <27.5, 15.5, -3> <28.5, 18.3, 3> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 20.9, 4> } }
    }
  #end
#end
#macro h_arch2_10(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <75.9, 19.1, 11.9> }
      box { <-20, -30, -4> <0, 0, 12> rotate -42.5*z translate <12, 19.1, 0> }
      box { <0, -30, -4> <20, 0, 12> rotate 42.5*z translate <60, 19.1, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <75.9, 19.1, 11.9> }
          #if (setting < 3)
            cylinder { 19*y, 20.4*y, 2.4 translate <16, 0, 0> }
            cylinder { 19*y, 20.4*y, 2.4 translate <24, 0, 0> }
            cylinder { 19*y, 20.4*y, 2.4 translate <32, 0, 0> }
            cylinder { 19*y, 20.4*y, 2.4 translate <40, 0, 0> }
            cylinder { 19*y, 20.4*y, 2.4 translate <48, 0, 0> }
            cylinder { 19*y, 20.4*y, 2.4 translate <56, 0, 0> }
            cylinder { 19*y, 20.4*y, 2.4 translate <16, 0, 8> }
            cylinder { 19*y, 20.4*y, 2.4 translate <24, 0, 8> }
            cylinder { 19*y, 20.4*y, 2.4 translate <32, 0, 8> }
            cylinder { 19*y, 20.4*y, 2.4 translate <40, 0, 8> }
            cylinder { 19*y, 20.4*y, 2.4 translate <48, 0, 8> }
            cylinder { 19*y, 20.4*y, 2.4 translate <56, 0, 8> }
          #else
            object { rounded_button() translate <16, 16, 0> }
            object { rounded_button() translate <24, 16, 0> }
            object { rounded_button() translate <32, 16, 0> }
            object { rounded_button() translate <40, 16, 0> }
            object { rounded_button() translate <48, 16, 0> }
            object { rounded_button() translate <56, 16, 0> }
            object { rounded_button() translate <16, 16, 8> }
            object { rounded_button() translate <24, 16, 8> }
            object { rounded_button() translate <32, 16, 8> }
            object { rounded_button() translate <40, 16, 8> }
            object { rounded_button() translate <48, 16, 8> }
            object { rounded_button() translate <56, 16, 8> }
          #end
        }
        box { <-20, -30, -4> <0, 0, 12> rotate -42.5*z translate <12, 19.1, 0> }
        box { <0, -30, -4> <20, 0, 12> rotate 42.5*z translate <60, 19.1, 0> }
        difference {
          box { <3.9, -1, -4> <68.1, 9.6, 12> }
          box { <-20, 0, -5> <0, 20, 13> rotate -42.5*z translate <3.9, 1.7, 0> }
          box { <0, 0, -5> <20, 20, 13> rotate 42.5*z translate <68.1, 1.7, 0> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <74.4, 18.2, 10.4> }
            box { <-20, -30, -4> <0, 0, 12> rotate -42.5*z translate <12, 18.2, 0> }
            box { <0, -30, -4> <20, 0, 12> rotate 42.5*z translate <60, 18.2, 0> }
            difference {
              cylinder { 0.000001*y, 19*y, 1.5 }
              cylinder { -1*y, 2*y, 0.7 }
              translate <0, 0, 4>
            }
            box { <2.4, -2, -4> <3.9, 19, 12> }
            box { <68.1, -2, -4> <69.6, 19, 12> }
            difference {
              cylinder { 0.000001*y, 19*y, 1.5 }
              cylinder { -1*y, 2*y, 0.7 }
              translate <72, 0, 4>
            }
          }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <16, 0, 0> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <24, 0, 0> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <32, 0, 0> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <40, 0, 0> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <48, 0, 0> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <56, 0, 0> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <16, 0, 8> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <24, 0, 8> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <32, 0, 8> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <40, 0, 8> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <48, 0, 8> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <56, 0, 8> }
        #end
      }
      #if (setting > 1)
        box { <27.5, 11.6, -2.5> <28.5, 19, 1.1> }
        box { <43.5, 11.6, -2.5> <44.5, 19, 1.1> }
        box { <27.5, 11.6, 6.9> <28.5, 19, 10.5> }
        box { <43.5, 11.6, 6.9> <44.5, 19, 10.5> }
        object { high_ring() translate <20, 9.6, 4> }
        object { high_ring() translate <28, 9.6, 4> }
        object { high_ring() translate <36, 9.6, 4> }
        object { high_ring() translate <44, 9.6, 4> }
        object { high_ring() translate <52, 9.6, 4> }
        difference {
          box { <10.6, 9.600001, -3.8> <12.1, 19, 11.8> }
          box { <-20, -30, -4> <0, 0, 12> rotate -42.5*z translate <12, 19, 0> }
        }
        difference {
          box { <59.9, 9.600001, -3.8> <61.4, 17.5, 11.8> }
          box { <0, -30, -4> <20, 0, 12> rotate 42.5*z translate <60, 19, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 20.5, 12> } }
    }
  #end
#end
#macro h_arch3_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.900003, 54.4, 12.099999> <27.900003, 57.500001, 19.9> }
      box { <-3.900001, 0, -3.900001> <27.900001, 41.500001, -0.7> }
      difference {
        cylinder { -3.900002*x, 27.900002*x, 16 }
        box { <-5, -20, 0> <29, 20, 20> }
        box { <-5, -20, -20> <29, -0.000001, 20> }
        cylinder { -5*x, 29*x, 12.9 }
        translate <0, 41.5, 12.1>
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
        #end
      }
      difference {
        box { <-3.900001, 3, -3.900001> <27.900001, 41.500001, -0.7> }
        box { <-2.400005, 2, -2.400003> <26.400005, 42, 0> }
      }
      difference {
        cylinder { -3.900002*x, 27.900002*x, 16 }
        box { <-5, -20, 0> <29, 20, 20> }
        box { <-5, -20, -20> <29, -0.000001, 20> }
        cylinder { -2.400001*x, 26.400001*x, 14.5 }
        cylinder { -5*x, 29*x, 12.9 }
        translate <0, 41.5, 12.1>
      }
      difference {
        merge {
          box { <-0.5, 54.4, 0> <0.5, 57, 13.6> }
          box { <7.5, 54.4, 0> <8.5, 57, 13.6> }
          box { <15.5, 54.4, 0> <16.5, 57, 13.6> }
          box { <23.5, 54.4, 0> <24.5, 57, 13.6> }
          box { <2.4, 54.4, 0> <3.4, 57, 19.899999> }
          box { <4.6, 54.4, 0> <5.6, 57, 19.899999> }
          box { <10.4, 54.4, 0> <11.4, 57, 19.899999> }
          box { <12.6, 54.4, 0> <13.6, 57, 19.899999> }
          box { <18.4, 54.4, 0> <19.4, 57, 19.899999> }
          box { <20.6, 54.4, 0> <21.6, 57, 19.899999> }
        }
        difference {
          box { <-4, 0, -20> <28, 20, 0> }
          cylinder { -2.400001*x, 26.400001*x, 14.5 }
          translate <0, 41.499999, 12.100001>
        }
      }
      difference {
        box { <-3.900003, 54.4, 12.099999> <27.900003, 57.500001, 19.9> }
        box { <-2.4, 50, 12> <26.4, 56.000001, 20> }
      }
      object { open_rounded_button() translate <0, 54.4, 16> }
      object { open_rounded_button() translate <8, 54.4, 16> }
      object { open_rounded_button() translate <16, 54.4, 16> }
      object { open_rounded_button() translate <24, 54.4, 16> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 57.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 57.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 57.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 57.5, 16> }
      #end
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 59.3, 20> } }
    }
  #end
#end
#macro h_arch6_6(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.900003, 83.2, 28.099999> <43.900003, 86.300001, 43.9> }
      box { <-3.900001, 0, -3.900001> <43.900001, 54.300001, -0.7> }
      difference {
        cylinder { -3.900002*x, 43.900002*x, 32 }
        box { <-5, -40, 0> <49, 40, 40> }
        box { <-5, -40, -40> <49, -0.000001, 40> }
        cylinder { -5*x, 49*x, 28.9 }
        translate <0, 54.3, 28.1>
      }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        #if (setting < 3)
          cylinder { 86.2*y, 88*y, 2.4 translate <0, 0, 32> }
          cylinder { 86.2*y, 88*y, 2.4 translate <8, 0, 32> }
          cylinder { 86.2*y, 88*y, 2.4 translate <16, 0, 32> }
          cylinder { 86.2*y, 88*y, 2.4 translate <24, 0, 32> }
          cylinder { 86.2*y, 88*y, 2.4 translate <32, 0, 32> }
          cylinder { 86.2*y, 88*y, 2.4 translate <40, 0, 32> }
          cylinder { 86.2*y, 88*y, 2.4 translate <0, 0, 40> }
          cylinder { 86.2*y, 88*y, 2.4 translate <8, 0, 40> }
          cylinder { 86.2*y, 88*y, 2.4 translate <16, 0, 40> }
          cylinder { 86.2*y, 88*y, 2.4 translate <24, 0, 40> }
          cylinder { 86.2*y, 88*y, 2.4 translate <32, 0, 40> }
          cylinder { 86.2*y, 88*y, 2.4 translate <40, 0, 40> }
        #else
          object { rounded_button() rotate 90*y translate <0, 83.2, 32> }
          object { rounded_button() rotate 90*y translate <8, 83.2, 32> }
          object { rounded_button() rotate 90*y translate <16, 83.2, 32> }
          object { rounded_button() rotate 90*y translate <24, 83.2, 32> }
          object { rounded_button() rotate 90*y translate <32, 83.2, 32> }
          object { rounded_button() rotate 90*y translate <40, 83.2, 32> }
          object { rounded_button() rotate 90*y translate <0, 83.2, 40> }
          object { rounded_button() rotate 90*y translate <8, 83.2, 40> }
          object { rounded_button() rotate 90*y translate <16, 83.2, 40> }
          object { rounded_button() rotate 90*y translate <24, 83.2, 40> }
          object { rounded_button() rotate 90*y translate <32, 83.2, 40> }
          object { rounded_button() rotate 90*y translate <40, 83.2, 40> }
        #end
        difference {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 3.9> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <42.4, 2, 2.4> }
          #end
        }
        difference {
          box { <-3.900001, 3, -3.900001> <43.900001, 54.300001, -0.7> }
          box { <-2.400005, 2, -2.400003> <42.400005, 55, 0> }
        }
        difference {
          cylinder { -3.900002*x, 43.900002*x, 32 }
          box { <-5, -40, 0> <49, 40, 40> }
          box { <-5, -40, -40> <49, -0.000001, 40> }
          cylinder { -2.400001*x, 42.400001*x, 30.5 }
          cylinder { -5*x, 49*x, 28.9 }
          translate <0, 54.3, 28.1>
        }
        difference {
          box { <-3.900003, 83.2, 28.099999> <43.900003, 86.300001, 43.9> }
          #if (setting > 1)
            box { <-2.4, 80, 29.6> <42.4, 84.800001, 42.4> }
          #end
        }
        #if (setting > 1)
          object { pin(2) translate <4, 0, 0> }
          object { pin(2) translate <12, 0, 0> }
          object { pin(2) translate <20, 0, 0> }
          object { pin(2) translate <28, 0, 0> }
          object { pin(2) translate <36, 0, 0> }
          object { ring() translate <4, 83.2, 36> }
          object { ring() translate <12, 83.2, 36> }
          object { ring() translate <20, 83.2, 36> }
          object { ring() translate <28, 83.2, 36> }
          object { ring() translate <36, 83.2, 36> }
        #end
      }
      #if (setting > 1)
        cylinder { 83.8*y, 86.8*y, 1.2 translate <0, 0, 32> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <8, 0, 32> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <16, 0, 32> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <24, 0, 32> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <32, 0, 32> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <40, 0, 32> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <0, 0, 40> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <8, 0, 40> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <16, 0, 40> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <24, 0, 40> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <32, 0, 40> }
        cylinder { 83.8*y, 86.8*y, 1.2 translate <40, 0, 40> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 88.1, 44> } }
    }
  #end
#end
#macro h_block1_1(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
        #else
          object { rounded_button() translate <0, 6.4, 0> }
        #end
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 8.6, 2.4> }
        cylinder { 7.4*y, 10.4*y, 1.2 }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 11.3, 4> } }
    }
  #end
#end
#macro h_block1_10(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <75.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <75.9, 9.5, 3.9> }
          #local counter = 0;
          #while (counter < 10)
            #if (setting < 3)
              cylinder { 9.4*y, 11.2*y, 2.4 translate <(counter*8), 0, 0> }
            #else
              object { rounded_button() translate <(counter*8), 6.4, 0> }
            #end
            #local counter = counter + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <74.4, 8.6, 2.4> }
          #local counter = 0;
          #while (counter < 10)
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, 0> }
            #local counter = counter + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local counter = 0;
        #while (counter < 9)
          cylinder { 0*y, 8.7*y, 1.5 translate <4+(counter*8), 0, 0> }
          #local counter = counter + 1;
        #end
        box { <11.75, 2, -3> <12.25, 8.7, 3> }
        box { <27.75, 2, -3> <28.25, 8.7, 3> }
        box { <43.75, 2, -3> <44.25, 8.7, 3> }
        box { <59.75, 2, -3> <60.25, 8.7, 3> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 11.3, 4> } }
    }
  #end
#end
#macro h_block1_12(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <91.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <91.9, 9.5, 3.9> }
          #local counter = 0;
          #while (counter < 12)
            #if (setting < 3)
              cylinder { 9.4*y, 11.2*y, 2.4 translate <(counter*8), 0, 0> }
            #else
              object { rounded_button() translate <(counter*8), 6.4, 0> }
            #end
            #local counter = counter + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <90.4, 8.6, 2.4> }
          #local counter = 0;
          #while (counter < 12)
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, 0> }
            #local counter = counter + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local counter = 0;
        #while (counter < 11)
          cylinder { 0*y, 8.7*y, 1.5 translate <4+(counter*8), 0, 0> }
          #local counter = counter + 1;
        #end
        box { <11.75, 2, -3> <12.25, 8.7, 3> }
        box { <27.75, 2, -3> <28.25, 8.7, 3> }
        box { <43.75, 2, -3> <44.25, 8.7, 3> }
        box { <59.75, 2, -3> <60.25, 8.7, 3> }
        box { <75.75, 2, -3> <76.25, 8.7, 3> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <92, 11.3, 4> } }
    }
  #end
#end
#macro h_block1_16(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <123.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <123.9, 9.5, 3.9> }
          #local counter = 0;
          #while (counter < 16)
            #if (setting < 3)
              cylinder { 9.4*y, 11.2*y, 2.4 translate <(counter*8), 0, 0> }
            #else
              object { rounded_button() translate <(counter*8), 6.4, 0> }
            #end
            #local counter = counter + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <122.4, 8.6, 2.4> }
          #local counter = 0;
          #while (counter < 16)
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, 0> }
            #local counter = counter + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local counter = 0;
        #while (counter < 15)
          cylinder { 0*y, 8.7*y, 1.5 translate <4+(counter*8), 0, 0> }
          #local counter = counter + 1;
        #end
        box { <11.75, 2, -3> <12.25, 8.7, 3> }
        box { <27.75, 2, -3> <28.25, 8.7, 3> }
        box { <43.75, 2, -3> <44.25, 8.7, 3> }
        box { <59.75, 2, -3> <60.25, 8.7, 3> }
        box { <75.75, 2, -3> <76.25, 8.7, 3> }
        box { <91.75, 2, -3> <92.25, 8.7, 3> }
        box { <107.75, 2, -3> <108.25, 8.7, 3> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <124, 11.3, 4> } }
    }
  #end
#end
#macro h_block1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 4> } }
    }
  #end
#end
#macro h_block1_2_buttoned(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          object { open_rounded_button() rotate -90*x translate <0, 5.6, -0.8> }
          object { open_rounded_button() rotate -90*x translate <8, 5.6, -0.8> }
          object { open_rounded_button() rotate 90*x translate <0, 5.6, 0.8> }
          object { open_rounded_button() rotate 90*x translate <8, 5.6, 0.8> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          cylinder { -6*z, 6*z, 1.600005 translate <0, 5.6, 0> }
          cylinder { -6*z, 6*z, 1.600005 translate <8, 5.6, 0> }
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
        box { <3.75, 2, -2.5> <4.25, 8.7, 2.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -5.7> <12, 11.3, 5.7> } }
    }
  #end
#end
#macro h_block1_2_cutout(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
        #else
          object { rounded_button() translate <0, 6.4, 0> }
          object { rounded_button() translate <8, 6.4, 0> }
        #end
      }
      box { <2.5, -0.1, -4> <5.5, 1.7, 4> }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
        cylinder { 7.4*y, 10.4*y, 1.2 }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 4> } }
    }
  #end
#end
#macro h_block1_3(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <19.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 9.5, 3.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 0> }
            object { rounded_button() translate <16, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <18.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
        cylinder { 0*y, 8.7*y, 1.5 translate <12, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 4> } }
    }
  #end
#end

#macro h_block1_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 0> }
            object { rounded_button() translate <16, 6.4, 0> }
            object { rounded_button() translate <24, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
        cylinder { 0*y, 8.7*y, 1.5 translate <12, 0, 0> }
        cylinder { 0*y, 8.7*y, 1.5 translate <20, 0, 0> }
        box { <11.75, 0.1, -3> <12.25, 8.7, 3> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 4> } }
    }
  #end
#end
#macro h_block1_6(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 9.5, 3.9> }
          #local counter = 0;
          #while (counter < 6)
            #if (setting < 3)
              cylinder { 9.4*y, 11.2*y, 2.4 translate <(counter*8), 0, 0> }
            #else
              object { rounded_button() translate <(counter*8), 6.4, 0> }
            #end
            #local counter = counter + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <42.4, 8.6, 2.4> }
          #local counter = 0;
          #while (counter < 6)
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, 0> }
            #local counter = counter + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local counter = 0;
        #while (counter < 5)
          cylinder { 0*y, 8.7*y, 1.5 translate <4+(counter*8), 0, 0> }
          #local counter = counter + 1;
        #end
        box { <11.75, 2, -3> <12.25, 8.7, 3> }
        box { <27.75, 2, -3> <28.25, 8.7, 3> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 11.3, 4> } }
    }
  #end
#end
#macro h_block1_8(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 9.5, 3.9> }
          #local counter = 0;
          #while (counter < 8)
            #if (setting < 3)
              cylinder { 9.4*y, 11.2*y, 2.4 translate <(counter*8), 0, 0> }
            #else
              object { rounded_button() translate <(counter*8), 6.4, 0> }
            #end
            #local counter = counter + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <58.4, 8.6, 2.4> }
          #local counter = 0;
          #while (counter < 8)
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, 0> }
            #local counter = counter + 1;
          #end
        #end
      }
      #if (setting > 1)
        #local counter = 0;
        #while (counter < 7)
          cylinder { 0*y, 8.7*y, 1.5 translate <4+(counter*8), 0, 0> }
          #local counter = counter + 1;
        #end
        box { <11.75, 2, -3> <12.25, 8.7, 3> }
        box { <27.75, 2, -3> <28.25, 8.7, 3> }
        box { <43.75, 2, -3> <44.25, 8.7, 3> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 11.3, 4> } }
    }
  #end
#end
#macro h_block2_10(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <75.9, 9.5, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            #local counter = 0;
            #while (counter < 10)
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 6.4, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 6.4, 8> }
              #local counter = counter + 1;
            #end
          #else
            #local counter = 0;
            #while (counter < 10)
              object { rounded_button() translate <(counter*8), 6.4, 0> }
              object { rounded_button() translate <(counter*8), 6.4, 8> }
              #local counter = counter + 1;
            #end
          #end
          box { <-3.9, 0, -3.9> <75.9, 9.5, 11.9> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <74.4, 8.6, 10.4> }
          #local counter = 0;
          #while (counter < 10)
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, 0> }
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, 8> }
            #local counter = counter + 1;
          #end
        #end
      }
      #if (setting > 1)
        object { high_ring() translate <4, 0, 4> }
        object { high_ring() translate <12, 0, 4> }
        object { high_ring() translate <20, 0, 4> }
        object { high_ring() translate <28, 0, 4> }
        object { high_ring() translate <36, 0, 4> }
        object { high_ring() translate <44, 0, 4> }
        object { high_ring() translate <52, 0, 4> }
        object { high_ring() translate <60, 0, 4> }
        object { high_ring() translate <68, 0, 4> }
        box { <11.75, 2, -3> <12.25, 8.7, 1.1> }
        box { <11.75, 2, 6.9> <12.25, 8.7, 11> }
        box { <27.75, 2, -3> <28.25, 8.7, 1.1> }
        box { <27.75, 2, 6.9> <28.25, 8.7, 11> }
        box { <43.75, 2, -3> <44.25, 8.7, 1.1> }
        box { <43.75, 2, 6.9> <44.25, 8.7, 11> }
        box { <59.75, 2, -3> <60.25, 8.7, 1.1> }
        box { <59.75, 2, 6.9> <60.25, 8.7, 11> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 11.3, 12> } }
    }
  #end
#end
#macro h_block2_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 0> }
            object { rounded_button() translate <0, 6.4, 8> }
            object { rounded_button() translate <8, 6.4, 8> }
          #end
          //box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
          box { <-4, 0, -4> <12, 9.5, 12> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 10.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { high_ring() translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 12> } }
    }
  #end
#end
#macro h_block2_3(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <19.9, 9.5, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 0> }
            object { rounded_button() translate <16, 6.4, 0> }
            object { rounded_button() translate <0, 6.4, 8> }
            object { rounded_button() translate <8, 6.4, 8> }
            object { rounded_button() translate <16, 6.4, 8> }
          #end
          box { <-3.9, 0, -3.9> <19.9, 9.5, 11.9> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <18.4, 8.6, 10.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { high_ring() translate <4, 0, 4> }
        object { high_ring() translate <12, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 12> } }
    }
  #end
#end
#macro h_block2_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 8> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 0> }
            object { rounded_button() translate <16, 6.4, 0> }
            object { rounded_button() translate <24, 6.4, 0> }
            object { rounded_button() translate <0, 6.4, 8> }
            object { rounded_button() translate <8, 6.4, 8> }
            object { rounded_button() translate <16, 6.4, 8> }
            object { rounded_button() translate <24, 6.4, 8> }
          #end
          box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 8.6, 10.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { high_ring() translate <4, 0, 4> }
        object { high_ring() translate <12, 0, 4> }
        object { high_ring() translate <20, 0, 4> }
        box { <11.75, 2, -3> <12.25, 8.7, 1.1> }
        box { <11.75, 2, 6.9> <12.25, 8.7, 11> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 12> } }
    }
  #end
#end
#macro h_block2_6(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 9.5, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            #local counter = 0;
            #while (counter < 6)
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 6.4, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 6.4, 8> }
              #local counter = counter + 1;
            #end
          #else
            #local counter = 0;
            #while (counter < 6)
              object { rounded_button() translate <(counter*8), 6.4, 0> }
              object { rounded_button() translate <(counter*8), 6.4, 8> }
              #local counter = counter + 1;
            #end
          #end
          box { <-3.9, 0, -3.9> <43.9, 9.5, 11.9> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <42.4, 8.6, 10.4> }
          #local counter = 0;
          #while (counter < 6)
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, 0> }
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, 8> }
            #local counter = counter + 1;
          #end
        #end
      }
      #if (setting > 1)
        object { high_ring() translate <4, 0, 4> }
        object { high_ring() translate <12, 0, 4> }
        object { high_ring() translate <20, 0, 4> }
        object { high_ring() translate <28, 0, 4> }
        object { high_ring() translate <36, 0, 4> }
        box { <11.75, 2, -3> <12.25, 8.7, 1.1> }
        box { <11.75, 2, 6.9> <12.25, 8.7, 11> }
        box { <27.75, 2, -3> <28.25, 8.7, 1.1> }
        box { <27.75, 2, 6.9> <28.25, 8.7, 11> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 11.3, 12> } }
    }
  #end
#end
#macro h_block2_8(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 9.5, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            #local counter = 0;
            #while (counter < 8)
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 6.4, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 6.4, 8> }
              #local counter = counter + 1;
            #end
          #else
            #local counter = 0;
            #while (counter < 8)
              object { rounded_button() translate <(counter*8), 6.4, 0> }
              object { rounded_button() translate <(counter*8), 6.4, 8> }
              #local counter = counter + 1;
            #end
          #end
          box { <-3.9, 0, -3.9> <59.9, 9.5, 11.9> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <58.4, 8.6, 10.4> }
          #local counter = 0;
          #while (counter < 8)
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, 0> }
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, 8> }
            #local counter = counter + 1;
          #end
        #end
      }
      #if (setting > 1)
        object { high_ring() translate <4, 0, 4> }
        object { high_ring() translate <12, 0, 4> }
        object { high_ring() translate <20, 0, 4> }
        object { high_ring() translate <28, 0, 4> }
        object { high_ring() translate <36, 0, 4> }
        object { high_ring() translate <44, 0, 4> }
        object { high_ring() translate <52, 0, 4> }
        box { <11.75, 2, -3> <12.25, 8.7, 1.1> }
        box { <11.75, 2, 6.9> <12.25, 8.7, 11> }
        box { <27.75, 2, -3> <28.25, 8.7, 1.1> }
        box { <27.75, 2, 6.9> <28.25, 8.7, 11> }
        box { <43.75, 2, -3> <44.25, 8.7, 1.1> }
        box { <43.75, 2, 6.9> <44.25, 8.7, 11> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 11.3, 12> } }
    }
  #end
#end
#macro h_block4_6(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 9.5, 27.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <43.9, 9.5, 27.9> }
        #local teller = 0;
        #while ( teller < 4)
          #local counter = 0;
          #while (counter < 6)
            #if (setting < 3)
              cylinder { 9.4*y, 11.2*y, 2.4 translate <(counter*8), 0, (teller*8)> }
            #else
              object { rounded_button() translate <(counter*8), 6.4, (teller*8)> }
            #end
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 4)
          #local counter = 0;
          #while (counter < 6)
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
        difference {
          box { <-2.4, -1, -2.4> <42.4, 8.6, 26.4> }
          object { high_ring() translate <4, 0.000001, 4> }
          object { high_ring() translate <4, 0.000001, 20> }
          object { high_ring() translate <20, 0.000001, 4> }
          object { high_ring() translate <20, 0.000001, 20> }
          object { high_ring() translate <36, 0.000001, 4> }
          object { high_ring() translate <36, 0.000001, 20> }
          object { high_ring() translate <12, 0.000001, 12> }
          object { high_ring() translate <28, 0.000001, 12> }
          box { <-2.5, 0.2, 11.4> <8.9, 8.7, 12.6> }
          box { <15.1, 0.2, 11.4> <24.9, 8.7, 12.6> }
          box { <31.1, 0.2, 11.4> <42.5, 8.7, 12.6> }
          box { <11.4, 0.2, -2.4> <12.6, 8.7, 8.9> }
          box { <27.4, 0.2, -2.4> <28.6, 8.7, 8.9> }
          box { <11.4, 0.2, 15.1> <12.6, 8.7, 42.5> }
          box { <27.4, 0.2, 15.1> <28.6, 8.7, 42.5> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 11.3, 28> } }
    }
  #end
#end
#macro h_block4_10(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <75.9, 9.5, 27.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <75.9, 9.5, 27.9> }
        #local teller = 0;
        #while ( teller < 4)
          #local counter = 0;
          #while (counter < 10)
            #if (setting < 3)
              cylinder { 9.4*y, 11.2*y, 2.4 translate <(counter*8), 0, (teller*8)> }
            #else
              object { rounded_button() translate <(counter*8), 6.4, (teller*8)> }
            #end
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 4)
          #local counter = 0;
          #while (counter < 10)
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
        difference {
          box { <-2.4, -1, -2.4> <74.4, 8.6, 26.4> }
          object { high_ring() translate <4, 0.000001, 4> }
          object { high_ring() translate <4, 0.000001, 20> }
          object { high_ring() translate <20, 0.000001, 4> }
          object { high_ring() translate <20, 0.000001, 20> }
          object { high_ring() translate <36, 0.000001, 4> }
          object { high_ring() translate <36, 0.000001, 20> }
          object { high_ring() translate <52, 0.000001, 4> }
          object { high_ring() translate <52, 0.000001, 20> }
          object { high_ring() translate <68, 0.000001, 4> }
          object { high_ring() translate <68, 0.000001, 20> }
          object { high_ring() translate <12, 0.000001, 12> }
          object { high_ring() translate <28, 0.000001, 12> }
          object { high_ring() translate <44, 0.000001, 12> }
          object { high_ring() translate <60, 0.000001, 12> }
          box { <-2.5, 0.2, 11.4> <8.9, 8.7, 12.6> }
          box { <15.1, 0.2, 11.4> <24.9, 8.7, 12.6> }
          box { <31.1, 0.2, 11.4> <40.9, 8.7, 12.6> }
          box { <47.1, 0.2, 11.4> <56.9, 8.7, 12.6> }
          box { <63.1, 0.2, 11.4> <72.9, 8.7, 12.6> }
          box { <11.4, 0.2, -2.4> <12.6, 8.7, 8.9> }
          box { <27.4, 0.2, -2.4> <28.6, 8.7, 8.9> }
          box { <43.4, 0.2, -2.4> <44.6, 8.7, 8.9> }
          box { <59.4, 0.2, -2.4> <60.6, 8.7, 8.9> }
          box { <75.4, 0.2, -2.4> <76.6, 8.7, 8.9> }
          box { <11.4, 0.2, 15.1> <12.6, 8.7, 42.5> }
          box { <27.4, 0.2, 15.1> <28.6, 8.7, 42.5> }
          box { <43.4, 0.2, 15.1> <44.6, 8.7, 42.5> }
          box { <59.4, 0.2, 15.1> <60.6, 8.7, 42.5> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 11.3, 28> } }
    }
  #end
#end
#macro h_block4_12(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <91.9, 9.5, 27.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <91.9, 9.5, 27.9> }
        #local teller = 0;
        #while ( teller < 4)
          #local counter = 0;
          #while (counter < 12)
            #if (setting < 3)
              cylinder { 9.4*y, 11.2*y, 2.4 translate <(counter*8), 0, (teller*8)> }
            #else
              object { rounded_button() translate <(counter*8), 6.4, (teller*8)> }
            #end
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 4)
          #local counter = 0;
          #while (counter < 12)
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
        difference {
          box { <-2.4, -1, -2.4> <90.4, 8.6, 26.4> }
          object { high_ring() translate <4, 0.000001, 4> }
          object { high_ring() translate <4, 0.000001, 20> }
          object { high_ring() translate <20, 0.000001, 4> }
          object { high_ring() translate <20, 0.000001, 20> }
          object { high_ring() translate <36, 0.000001, 4> }
          object { high_ring() translate <36, 0.000001, 20> }
          object { high_ring() translate <52, 0.000001, 4> }
          object { high_ring() translate <52, 0.000001, 20> }
          object { high_ring() translate <68, 0.000001, 4> }
          object { high_ring() translate <68, 0.000001, 20> }
          object { high_ring() translate <84, 0.000001, 4> }
          object { high_ring() translate <84, 0.000001, 20> }
          object { high_ring() translate <12, 0.000001, 12> }
          object { high_ring() translate <28, 0.000001, 12> }
          object { high_ring() translate <44, 0.000001, 12> }
          object { high_ring() translate <60, 0.000001, 12> }
          object { high_ring() translate <76, 0.000001, 12> }
          box { <-2.5, 0.2, 11.4> <8.9, 8.7, 12.6> }
          box { <15.1, 0.2, 11.4> <24.9, 8.7, 12.6> }
          box { <31.1, 0.2, 11.4> <40.9, 8.7, 12.6> }
          box { <47.1, 0.2, 11.4> <56.9, 8.7, 12.6> }
          box { <63.1, 0.2, 11.4> <72.9, 8.7, 12.6> }
          box { <79.1, 0.2, 11.4> <90.5, 8.7, 12.6> }
          box { <11.4, 0.2, -2.4> <12.6, 8.7, 8.9> }
          box { <27.4, 0.2, -2.4> <28.6, 8.7, 8.9> }
          box { <43.4, 0.2, -2.4> <44.6, 8.7, 8.9> }
          box { <59.4, 0.2, -2.4> <60.6, 8.7, 8.9> }
          box { <75.4, 0.2, -2.4> <76.6, 8.7, 8.9> }
          box { <11.4, 0.2, 15.1> <12.6, 8.7, 42.5> }
          box { <27.4, 0.2, 15.1> <28.6, 8.7, 42.5> }
          box { <43.4, 0.2, 15.1> <44.6, 8.7, 42.5> }
          box { <59.4, 0.2, 15.1> <60.6, 8.7, 42.5> }
          box { <75.4, 0.2, 15.1> <76.6, 8.7, 42.5> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <92, 11.3, 28> } }
    }
  #end
#end
#macro h_block8_16(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <123.9, 9.5, 59.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <123.9, 9.5, 59.9> }
        #local teller = 0;
        #while ( teller < 8)
          #local counter = 0;
          #while (counter < 16)
            #if (setting < 3)
              cylinder { 9.4*y, 11.2*y, 2.4 translate <(counter*8), 0, (teller*8)> }
            #else
              object { rounded_button() translate <(counter*8), 6.4, (teller*8)> }
            #end
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 8)
          #local counter = 0;
          #while (counter < 16)
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
        difference {
          box { <-2.4, -1, -2.4> <122.4, 8.6, 58.4> }
          #local teller = 0;
          #while ( teller < 4)
            #local counter = 0;
            #while (counter < 8)
              object { high_ring() translate <4+(counter*16), 0.000001, 4+(teller*16)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
          #local teller = 0;
          #while ( teller < 3)
            #local counter = 0;
            #while (counter < 7)
              object { high_ring() translate <12+(counter*16), 0.000001, 12+(teller*16)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
          #local teller = 0;
          #while ( teller < 6)
            #local counter = 0;
            #while (counter < 3)
              box { <15.1+(teller*16), 0.2, 11.4+(counter*16)> <24.9+(teller*16), 8.7, 12.6+(counter*16)> }
              box { <16.1+(teller*16), 0.200001, 10.2+(counter*16)> <17.3+(teller*16), 8.7, 13.8+(counter*16)> }
              box { <21.7+(teller*16), 0.200001, 10.2+(counter*16)> <22.9+(teller*16), 8.7, 13.8+(counter*16)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
          box { <-2.5, 0.2, 11.4> <8.9, 8.7, 12.6> }
          box { <0.1, 0.200001, 10.2> <1.3, 8.7, 13.8> }
          box { <5.7, 0.200001, 10.2> <6.9, 8.7, 13.8> }
          box { <-2.5, 0.2, 27.4> <8.9, 8.7, 28.6> }
          box { <0.1, 0.200001, 26.2> <1.3, 8.7, 29.8> }
          box { <5.7, 0.200001, 26.2> <6.9, 8.7, 29.8> }
          box { <-2.5, 0.2, 43.4> <8.9, 8.7, 44.6> }
          box { <0.1, 0.200001, 42.2> <1.3, 8.7, 45.8> }
          box { <5.7, 0.200001, 42.2> <6.9, 8.7, 45.8> }
          #local teller = 0; 
          #while ( teller < 7)
            #merge{
              box { <11.4+(teller*16), 0.2, -2.5> <12.6+(teller*16), 8.7, 8.9> }
              box { <10.2+16*teller, 0.200001, 0.1> <13.8+16*teller, 8.7, 1.3> }
              box { <10.2+16*teller, 0.200001, 5.7> <13.8+16*teller, 8.7, 6.9> }
              box { <11.4+16*teller, 0.2, 15.1> <12.6+16*teller, 8.7, 24.9> }
              box { <10.2+16*teller, 0.200001, 16.1> <13.8+16*teller, 8.7, 17.3> }
              box { <10.2+16*teller, 0.200001, 21.7> <13.8+16*teller, 8.7, 22.9> }
              box { <11.4+16*teller, 0.2, 31.1> <12.6+16*teller, 8.7, 40.9> }
              box { <10.2+16*teller, 0.200001, 32.1> <13.8+16*teller, 8.7, 33.3> }
              box { <10.2+16*teller, 0.200001, 37.7> <13.8+16*teller, 8.7, 38.9> }
              box { <11.4+16*teller, 0.2, 47.1> <12.6+16*teller, 8.7, 58.5> }
              box { <10.2+16*teller, 0.200001, 48.1> <13.8+16*teller, 8.7, 49.3> }
              box { <10.2+16*teller, 0.200001, 53.7> <13.8+16*teller, 8.7, 54.9> }
            }
            #local teller = teller + 1;
          #end 
          box { <111.1, 0.2, 11.4> <122.5, 8.7, 12.6> }
          box { <112.1, 0.200001, 10.2> <113.3, 8.7, 13.8> }
          box { <117.7, 0.200001, 10.2> <118.9, 8.7, 13.8> }
          box { <111.1, 0.2, 27.4> <122.5, 8.7, 28.6> }
          box { <112.1, 0.200001, 26.2> <113.3, 8.7, 29.8> }
          box { <117.7, 0.200001, 26.2> <118.9, 8.7, 29.8> }
          box { <111.1, 0.2, 43.4> <122.5, 8.7, 44.6> }   
          box { <112.1, 0.200001, 42.2> <113.3, 8.7, 45.8> }
          box { <117.7, 0.200001, 42.2> <118.9, 8.7, 45.8> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <124, 11.3, 60> } }
    }
  #end
#end
#macro h_block8_8(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 9.5, 59.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <59.9, 9.5, 59.9> }
        #local teller = 0;
        #while ( teller < 8)
          #local counter = 0;
          #while (counter < 8)
            #if (setting < 3)
              cylinder { 9.4*y, 11.2*y, 2.4 translate <(counter*8), 0, (teller*8)> }
            #else
              object { rounded_button() translate <(counter*8), 6.4, (teller*8)> }
            #end
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 8)
          #local counter = 0;
          #while (counter < 8)
            cylinder { 7.4*y, 10.4*y, 1.2 translate <(counter*8), 0, (teller*8)> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
        difference {
          box { <-2.4, -1, -2.4> <58.4, 8.6, 58.4> }
          object { high_ring() translate <4, 0.000001, 4> }
          object { high_ring() translate <4, 0.000001, 20> }
          object { high_ring() translate <4, 0.000001, 36> }
          object { high_ring() translate <4, 0.000001, 52> }
          object { high_ring() translate <20, 0.000001, 4> }
          object { high_ring() translate <20, 0.000001, 20> }
          object { high_ring() translate <20, 0.000001, 36> }
          object { high_ring() translate <20, 0.000001, 52> }
          object { high_ring() translate <36, 0.000001, 4> }
          object { high_ring() translate <36, 0.000001, 20> }
          object { high_ring() translate <36, 0.000001, 36> }
          object { high_ring() translate <36, 0.000001, 52> }
          object { high_ring() translate <52, 0.000001, 4> }
          object { high_ring() translate <52, 0.000001, 20> }
          object { high_ring() translate <52, 0.000001, 36> }
          object { high_ring() translate <52, 0.000001, 52> }
          object { high_ring() translate <12, 0.000001, 12> }
          object { high_ring() translate <28, 0.000001, 12> }
          object { high_ring() translate <44, 0.000001, 12> }
          object { high_ring() translate <12, 0.000001, 28> }
          object { high_ring() translate <28, 0.000001, 28> }
          object { high_ring() translate <44, 0.000001, 28> }
          object { high_ring() translate <12, 0.000001, 44> }
          object { high_ring() translate <28, 0.000001, 44> }
          object { high_ring() translate <44, 0.000001, 44> }
          box { <-2.5, 0.2, 11.4> <8.9, 8.7, 12.6> }
          box { <15.1, 0.2, 11.4> <24.9, 8.7, 12.6> }
          box { <31.1, 0.2, 11.4> <40.9, 8.7, 12.6> }
          box { <47.1, 0.2, 11.4> <58.5, 8.7, 12.6> }
          box { <-2.5, 0.2, 27.4> <8.9, 8.7, 28.6> }
          box { <15.1, 0.2, 27.4> <24.9, 8.7, 28.6> }
          box { <31.1, 0.2, 27.4> <40.9, 8.7, 28.6> }
          box { <47.1, 0.2, 27.4> <58.5, 8.7, 28.6> }
          box { <-2.5, 0.2, 43.4> <8.9, 8.7, 44.6> }
          box { <15.1, 0.2, 43.4> <24.9, 8.7, 44.6> }
          box { <31.1, 0.2, 43.4> <40.9, 8.7, 44.6> }
          box { <47.1, 0.2, 43.4> <58.5, 8.7, 44.6> }
          box { <11.4, 0.2, -2.5> <12.6, 8.7, 8.9> }
          box { <27.4, 0.2, -2.5> <28.6, 8.7, 8.9> }
          box { <43.4, 0.2, -2.5> <44.6, 8.7, 8.9> }
          box { <11.4, 0.2, 15.1> <12.6, 8.7, 24.9> }
          box { <27.4, 0.2, 15.1> <28.6, 8.7, 24.9> }
          box { <43.4, 0.2, 15.1> <44.6, 8.7, 24.9> }
          box { <11.4, 0.2, 31.1> <12.6, 8.7, 40.9> }
          box { <27.4, 0.2, 31.1> <28.6, 8.7, 40.9> }
          box { <43.4, 0.2, 31.1> <44.6, 8.7, 40.9> }
          box { <11.4, 0.2, 47.1> <12.6, 8.7, 58.5> }
          box { <27.4, 0.2, 47.1> <28.6, 8.7, 58.5> }
          box { <43.4, 0.2, 47.1> <44.6, 8.7, 58.5> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 11.3, 60> } }
    }
  #end
#end
#macro h_cage2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 47.9, 11.9> }
      box { <-4, 3.1, -2.1> <12, 44.8, 10.1> }
      box { <-2.1, 3.100001, -4> <10.1, 44.800001, 12> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting < 3)
        cylinder { 47.8*y, 49.6*y, 2.4 }
        cylinder { 47.8*y, 49.6*y, 2.4 translate <8, 0, 0> }
        cylinder { 47.8*y, 49.6*y, 2.4 translate <0, 0, 8> }
        cylinder { 47.8*y, 49.6*y, 2.4 translate <8, 0, 8> }
      #else
        object { rounded_button() translate <0, 44.8, 0> }
        object { rounded_button() translate <8, 44.8, 0> }
        object { rounded_button() translate <0, 44.8, 8> }
        object { rounded_button() translate <8, 44.8, 8> }
      #end
      difference {
        box { <-3.9, 0, -3.9> <11.9, 47.9, 11.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { -1*y, 48*y, 2.600001 translate <4, 0, 4> }
        #end
        box { <-4, 3.1, -2.1> <12, 44.8, 10.1> }
        box { <-2.1, 3.100001, -4> <10.1, 44.800001, 12> }
        box { <-1.6, 40, -1.6> <9.6, 47, 9.6> }
      }
      difference {
        box { <-2, 44.3, -2> <10, 47.5, 10> }
        box { <-1.600001, 40, -1.600001> <9.600001, 48, 9.600001> }
      }
      object { ring() translate <4, 0, 4> }
      object { ring() translate <4, 41.8, 4> }
      box { <-0.7, -1, -3.900001> <0.7, 13, -2.4> rotate 30*z translate <4, 3.1, 0> }
      box { <-0.7, -1, -3.900002> <0.7, 13, -2.400001> rotate -30*z translate <4, 3.1, 0> }
      box { <-0.7, -1, 10.400001> <0.7, 13, 11.900001> rotate 30*z translate <4, 3.1, 0> }
      box { <-0.7, -1, 10.400002> <0.7, 13, 11.900002> rotate -30*z translate <4, 3.1, 0> }
      box { <-3.900001, -1, -0.7> <-2.4, 13, 0.7> rotate 30*x translate <0, 3.1, 4> }
      box { <-3.900002, -1, -0.7> <-2.400001, 13, 0.7> rotate -30*x translate <0, 3.1, 4> }
      box { <10.400003, -1, -0.7> <11.900002, 13, 0.7> rotate 30*x translate <0, 3.1, 4> }
      box { <10.400004, -1, -0.7> <11.900003, 13, 0.7> rotate -30*x translate <0, 3.1, 4> }
      box { <-0.7, -13, -3.900001> <0.7, 1, -2.4> rotate 30*z translate <4, 44.8, 0> }
      box { <-0.7, -13, -3.900002> <0.7, 1, -2.400001> rotate -30*z translate <4, 44.8, 0> }
      box { <-0.7, -13, 10.400001> <0.7, 1, 11.900001> rotate 30*z translate <4, 44.8, 0> }
      box { <-0.7, -13, 10.400002> <0.7, 1, 11.900002> rotate -30*z translate <4, 44.8, 0> }
      box { <-3.900001, -13, -0.7> <-2.4, 1, 0.7> rotate 30*x translate <0, 44.8, 4> }
      box { <-3.900002, -13, -0.7> <-2.400001, 1, 0.7> rotate -30*x translate <0, 44.8, 4> }
      box { <10.400003, -13, -0.7> <11.900002, 1, 0.7> rotate 30*x translate <0, 44.8, 4> }
      box { <10.400004, -13, -0.7> <11.900003, 1, 0.7> rotate -30*x translate <0, 44.8, 4> }
      box { <-0.7, -13, -3.900003> <0.7, 13, -2.400003> rotate 30*z translate <4, 23.95, 0> }
      box { <-0.7, -13, -3.900004> <0.7, 13, -2.400004> rotate -30*z translate <4, 23.95, 0> }
      box { <-0.7, -13, 10.400003> <0.7, 13, 11.900003> rotate 30*z translate <4, 23.95, 0> }
      box { <-0.7, -13, 10.400004> <0.7, 13, 11.900004> rotate -30*z translate <4, 23.95, 0> }
      box { <-3.900003, -13, -0.7> <-2.400002, 13, 0.7> rotate 30*x translate <0, 23.95, 4> }
      box { <-3.900004, -13, -0.7> <-2.400003, 13, 0.7> rotate -30*x translate <0, 23.95, 4> }
      box { <10.400005, -13, -0.7> <11.900004, 13, 0.7> rotate 30*x translate <0, 23.95, 4> }
      box { <10.400006, -13, -0.7> <11.900005, 13, 0.7> rotate -30*x translate <0, 23.95, 4> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 49.7, 12> } }
    }
  #end
#end
#macro h_carbottom(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 12.7, 43.9> }
      box { <-4, -1, -4> <44, 9.6, 4.1> }
      box { <-4, -1, 35.9> <44, 9.6, 44> }
      box { <3.9, 3.1, 4.099999> <35.9, 15, 35.900001> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <43.9, 12.7, 43.9> }
          box { <-4, -1, -4> <44, 9.6, 4.1> }
          box { <-4, -1, 35.9> <44, 9.6, 44> }
          box { <3.9, 3.1, 4.099999> <35.9, 15, 35.900001> }
          #if (setting > 1)
            box { <-2.4, -1, 5.6> <2.4, 11.8, 34.4> }
            box { <37.6, -1, 5.6> <42.4, 11.8, 34.4> }
            box { <4, -1, 5.6> <36, 2, 34.4> }
            difference {
              box { <-2.4, 0, -2.4> <42.4, 11.8, 42.4> }
              box { <2.4, 0, 2.4> <37.6, 12, 37.6> }
              box { <-4, -1, 4.100001> <44, 12, 35.899999> }
            }
          #end
        }
        #if (setting > 1)
          box { <3.9, 0.000001, 7.5> <5.6, 2.1, 8.5> }
          box { <3.9, 0.000001, 15.5> <5.6, 2.1, 16.5> }
          box { <3.9, 0.000001, 23.5> <5.6, 2.1, 24.5> }
          box { <3.9, 0.000001, 31.5> <5.6, 2.1, 32.5> }
          box { <34.4, 0.000001, 7.5> <35.9, 2.1, 8.5> }
          box { <34.4, 0.000001, 15.5> <35.9, 2.1, 16.5> }
          box { <34.4, 0.000001, 23.5> <35.9, 2.1, 24.5> }
          box { <34.4, 0.000001, 31.5> <35.9, 2.1, 32.5> }
        #end
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> }
          cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
          cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 32> }
          cylinder { 12.6*y, 14.4*y, 2.4 }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <8, 0, 0> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <16, 0, 0> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <24, 0, 0> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <32, 0, 0> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <40, 0, 0> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <0, 0, 8> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <40, 0, 8> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <0, 0, 16> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <40, 0, 16> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <0, 0, 24> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <40, 0, 24> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <0, 0, 32> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <40, 0, 32> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <0, 0, 40> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <8, 0, 40> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <16, 0, 40> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <24, 0, 40> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <32, 0, 40> }
          cylinder { 12.6*y, 14.4*y, 2.4 translate <40, 0, 40> }
        #else
          object { rounded_button() translate <8, 0, 8> }
          object { rounded_button() translate <16, 0, 8> }
          object { rounded_button() translate <24, 0, 8> }
          object { rounded_button() translate <32, 0, 8> }
          object { rounded_button() translate <8, 0, 16> }
          object { rounded_button() translate <16, 0, 16> }
          object { rounded_button() translate <24, 0, 16> }
          object { rounded_button() translate <32, 0, 16> }
          object { rounded_button() translate <8, 0, 24> }
          object { rounded_button() translate <16, 0, 24> }
          object { rounded_button() translate <24, 0, 24> }
          object { rounded_button() translate <32, 0, 24> }
          object { rounded_button() translate <8, 0, 32> }
          object { rounded_button() translate <16, 0, 32> }
          object { rounded_button() translate <24, 0, 32> }
          object { rounded_button() translate <32, 0, 32> }
          object { rounded_button() translate <0, 9.6, 0> }
          object { rounded_button() translate <8, 9.6, 0> }
          object { rounded_button() translate <16, 9.6, 0> }
          object { rounded_button() translate <24, 9.6, 0> }
          object { rounded_button() translate <32, 9.6, 0> }
          object { rounded_button() translate <40, 9.6, 0> }
          object { rounded_button() translate <0, 9.6, 8> }
          object { rounded_button() translate <40, 9.6, 8> }
          object { rounded_button() translate <0, 9.6, 16> }
          object { rounded_button() translate <40, 9.6, 16> }
          object { rounded_button() translate <0, 9.6, 24> }
          object { rounded_button() translate <40, 9.6, 24> }
          object { rounded_button() translate <0, 9.6, 32> }
          object { rounded_button() translate <40, 9.6, 32> }
          object { rounded_button() translate <0, 9.6, 40> }
          object { rounded_button() translate <8, 9.6, 40> }
          object { rounded_button() translate <16, 9.6, 40> }
          object { rounded_button() translate <24, 9.6, 40> }
          object { rounded_button() translate <32, 9.6, 40> }
          object { rounded_button() translate <40, 9.6, 40> }
        #end
        #if (setting > 1)
          object { ring() translate <12, 0, 12> }
          object { ring() translate <20, 0, 12> }
          object { ring() translate <28, 0, 12> }
          object { ring() translate <12, 0, 20> }
          object { ring() translate <20, 0, 20> }
          object { ring() translate <28, 0, 20> }
          object { ring() translate <12, 0, 28> }
          object { ring() translate <20, 0, 28> }
          object { ring() translate <28, 0, 28> }
          cylinder { 0*y, 11.9*y, 1.5 translate <0, 0, 12> }
          cylinder { 0*y, 11.9*y, 1.5 translate <0, 0, 20> }
          cylinder { 0*y, 11.9*y, 1.5 translate <0, 0, 28> }
          cylinder { 0*y, 11.9*y, 1.5 translate <40, 0, 12> }
          cylinder { 0*y, 11.9*y, 1.5 translate <40, 0, 20> }
          cylinder { 0*y, 11.9*y, 1.5 translate <40, 0, 28> }
          cylinder { 9.6*y, 11.9*y, 1.5 translate <4, 0, 0> }
          cylinder { 9.6*y, 11.9*y, 1.5 translate <12, 0, 0> }
          cylinder { 9.6*y, 11.9*y, 1.5 translate <20, 0, 0> }
          cylinder { 9.6*y, 11.9*y, 1.5 translate <28, 0, 0> }
          cylinder { 9.6*y, 11.9*y, 1.5 translate <36, 0, 0> }
          cylinder { 9.6*y, 11.9*y, 1.5 translate <4, 0, 40> }
          cylinder { 9.6*y, 11.9*y, 1.5 translate <12, 0, 40> }
          cylinder { 9.6*y, 11.9*y, 1.5 translate <20, 0, 40> }
          cylinder { 9.6*y, 11.9*y, 1.5 translate <28, 0, 40> }
          cylinder { 9.6*y, 11.9*y, 1.5 translate <36, 0, 40> }
          box { <-2.5, 3, 11.5> <2.5, 11.9, 12.5> }
          box { <-2.5, 3, 19.5> <2.5, 11.9, 20.5> }
          box { <-2.5, 3, 27.5> <2.5, 11.9, 28.5> }
          box { <37.5, 3, 11.5> <42.5, 11.9, 12.5> }
          box { <37.5, 3, 19.5> <42.5, 11.9, 20.5> }
          box { <37.5, 3, 27.5> <42.5, 11.9, 28.5> }
          box { <-0.5, 9.6, 2.4> <0.5, 11.9, 4.5> }
          box { <39.5, 9.6, 2.4> <40.5, 11.9, 4.5> }
          box { <-0.5, 9.6, 35.5> <0.5, 11.9, 37.6> }
          box { <39.5, 9.6, 35.5> <40.5, 11.9, 37.6> }
        #end
      }
      cylinder { -1*y, 4*y, 2.600001 translate <20, 0, 20> }
      #if (setting > 1)
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
        cylinder { 1*y, 4*y, 1.2 translate <32, 0, 32> }
        cylinder { 10.6*y, 13.6*y, 1.2 }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <8, 0, 0> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <16, 0, 0> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <24, 0, 0> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <32, 0, 0> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <40, 0, 0> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <0, 0, 8> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <0, 0, 16> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <0, 0, 24> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <0, 0, 32> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <40, 0, 8> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <40, 0, 16> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <40, 0, 24> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <40, 0, 32> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <0, 0, 40> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <8, 0, 40> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <16, 0, 40> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <24, 0, 40> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <32, 0, 40> }
        cylinder { 10.6*y, 13.6*y, 1.2 translate <40, 0, 40> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 14.5, 44> } }
    }
  #end
#end
#macro h_claw1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      cylinder { -3.9*x, 11.9*x, 1.5 translate <0, 5.45, 8> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 90*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 0> }
          #end
          cylinder { -3.9*x, 11.9*x, 1.5 translate <0, 5.45, 8> }
          cylinder { -0.5*x, 1.5*x, 2.25 translate <0, 5.450001, 7.999999> }
          box { <-0.500001, 3.200001, 3> <1.500001, 6.299999, 8> }
          cylinder { 6.5*x, 8.5*x, 2.25 translate <0, 5.450002, 7.999999> }
          box { <6.500001, 3.200001, 3> <8.500001, 6.299999, 8> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
        box { <3.75, 2, -3> <4.25, 8.7, 3> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 10.3> } }
    }
  #end
#end
#macro h_closet2_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 38.4, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 38.3, 11.9> }
          object { open_rounded_button() translate <0, 35.2, 0> }
          object { open_rounded_button() translate <8, 35.2, 0> }
          object { open_rounded_button() translate <16, 35.2, 0> }
          object { open_rounded_button() translate <24, 35.2, 0> }
          object { open_rounded_button() translate <0, 35.2, 8> }
          object { open_rounded_button() translate <8, 35.2, 8> }
          object { open_rounded_button() translate <16, 35.2, 8> }
          object { open_rounded_button() translate <24, 35.2, 8> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 38.3, 24> }
          #end
        }
        box { <-2.7, 3.2, -4> <26.7, 19.3, 10.3> }
        box { <-2.7, 20.7, -4> <26.7, 36.9, 10.3> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 10.4> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 40.1, 12> } }
    }
  #end
#end
#macro h_closet4_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 38.4, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 38.3, 27.9> }
          object { open_rounded_button() translate <0, 35.2, 0> }
          object { open_rounded_button() translate <8, 35.2, 0> }
          object { open_rounded_button() translate <16, 35.2, 0> }
          object { open_rounded_button() translate <24, 35.2, 0> }
          object { open_rounded_button() translate <0, 35.2, 8> }
          object { open_rounded_button() translate <8, 35.2, 8> }
          object { open_rounded_button() translate <16, 35.2, 8> }
          object { open_rounded_button() translate <24, 35.2, 8> }
          object { open_rounded_button() translate <0, 35.2, 16> }
          object { open_rounded_button() translate <8, 35.2, 16> }
          object { open_rounded_button() translate <16, 35.2, 16> }
          object { open_rounded_button() translate <24, 35.2, 16> }
          object { open_rounded_button() translate <0, 35.2, 24> }
          object { open_rounded_button() translate <8, 35.2, 24> }
          object { open_rounded_button() translate <16, 35.2, 24> }
          object { open_rounded_button() translate <24, 35.2, 24> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 38.3, 16> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 38.3, 16> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 38.3, 16> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 38.3, 16> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 38.3, 24> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 38.3, 24> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 38.3, 24> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 38.3, 24> }
          #end
        }
        box { <-2.7, 3.2, -4> <26.7, 19.3, 26.3> }
        box { <-2.7, 20.7, -4> <26.7, 36.9, 26.3> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 26.4> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <20, 0, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 40.1, 28> } }
    }
  #end
#end
#macro h_closet4_4mod(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 38.4, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 38.3, 27.9> }
          object { open_rounded_button() translate <0, 35.2, 0> }
          object { open_rounded_button() translate <8, 35.2, 0> }
          object { open_rounded_button() translate <16, 35.2, 0> }
          object { open_rounded_button() translate <24, 35.2, 0> }
          object { open_rounded_button() translate <0, 35.2, 8> }
          object { open_rounded_button() translate <8, 35.2, 8> }
          object { open_rounded_button() translate <16, 35.2, 8> }
          object { open_rounded_button() translate <24, 35.2, 8> }
          object { open_rounded_button() translate <0, 35.2, 16> }
          object { open_rounded_button() translate <8, 35.2, 16> }
          object { open_rounded_button() translate <16, 35.2, 16> }
          object { open_rounded_button() translate <24, 35.2, 16> }
          object { open_rounded_button() translate <0, 35.2, 24> }
          object { open_rounded_button() translate <8, 35.2, 24> }
          object { open_rounded_button() translate <16, 35.2, 24> }
          object { open_rounded_button() translate <24, 35.2, 24> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 38.3, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 38.3, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 38.3, 16> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 38.3, 16> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 38.3, 16> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 38.3, 16> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 38.3, 24> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 38.3, 24> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 38.3, 24> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 38.3, 24> }
          #end
        }
        box { <-2.7, 3.2, -4> <26.7, 19.3, 26.3> }
        box { <-2.7, 20.7, -4> <26.7, 36.9, 26.3> }
        box { <-2.70001, 3.20001, -4> <26.70001, 36.89999, -1.5> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 26.4> }
          cylinder { -1*y, 50*y, 0.7 translate <-1.5, 0, -2.5> }
          cylinder { -1*y, 50*y, 0.7 translate <25.5, 0, -2.5> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <20, 0, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 40.1, 28> } }
    }
  #end
#end
#macro h_column1_1(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> }
      cylinder { 9.4*y, 57.5*y, 3.9 }
      texture { color_tex }
    }  
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> }
        cylinder { 9.4*y, 57.5*y, 3.9 }
        object { open_rounded_button() translate <0, 54.4, 0> }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 8.6, 2.4> }
        difference{
          cylinder { 55.4*y, 57.8*y, 1.600005 }
          box { <-1.7, 55.3, -0.8> <-0.4, 57.9, 0.8> } 
          box { <0.4, 55.3, -0.8> <1.7, 57.9, 0.8> }
        }
        cylinder { 8.5*y, 56*y, 2.4 }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 59.3, 4> } }
    }
  #end
#end
#macro h_connect1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.9, 3.1, 17.55> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <3.9, 3.1, 17.55> }
          box { <-2.25, 0.000001, 14.45> <-0.65, 4.75, 17.5500001> }
          cylinder { -2.249999*x, -0.6500001*x, 1.55 translate <0, 4.749999, 16> }
          box { <0.65, 0.000001, 14.45> <2.25, 4.75, 17.5500001> }
          cylinder { 0.6500001*x, 2.249999*x, 1.55 translate <0, 4.749999, 16> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 2, 18> }
          difference {
            box { <-2.899999, -1, 17.05> <2.899999, 2.000001, 20> }
            cylinder { -2*y, 3*y, 0.5 translate <-2.9, 0, 17.05> }
            cylinder { -2*y, 3*y, 0.5 translate <2.9, 0, 17.05> }
          }
          difference {
            merge {
              sphere { <-3.75, 4.75, 16>, 2 }
              sphere { <3.75, 4.75, 16>, 2 }
            }
            box { <-4, -5, 8> <4, 3.100002, 20> }
          }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <0, 0, 4> }
        object { pin(1) translate <0, 0, 12> }
        box { <-3, 0.000001, 3.5> <3, 2.1, 4.5> }
        box { <-3, 0.000001, 11.5> <3, 2.1, 12.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 6.4, 18> } }
    }
  #end
#end
#macro h_connect1_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
          box { <-3.899998, 3, -3.55> <-2.55, 4.75, -0.45> }
          cylinder { -3.899999*x, -2.550001*x, 1.55 translate <0, 4.749999, -2> }
          box { <3.3, 3, -3.55> <4.7, 4.75, -0.45> }
          cylinder { 3.300001*x, 4.700001*x, 1.55 translate <0, 4.749999, -2> }
          box { <11.3, 3, -3.55> <12.7, 4.75, -0.45> }
          cylinder { 11.300001*x, 12.700001*x, 1.55 translate <0, 4.749999, -2> }
          box { <19.3, 3, -3.55> <20.7, 4.75, -0.45> }
          cylinder { 19.300001*x, 20.700001*x, 1.55 translate <0, 4.749999, -2> }
          box { <26.55, 3, -3.55> <27.899998, 4.75, -0.45> }
          cylinder { 26.550001*x, 27.899999*x, 1.55 translate <0, 4.749999, -2> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
        object { pin(1) translate <12, 0, 0> }
        object { pin(1) translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 6.4, 8> } }
    }
  #end
#end
#macro h_connect2_8(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 12.7, 11.9> }
      box { <-4, -1, -4> <4.1, 9.6, 12> }
      box { <11.9, 3.1, -4> <36.1, 13, 12> }
      box { <43.9, -1, -4> <60, 9.6, 12> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting < 3)
        cylinder { 12.6*y, 14.4*y, 2.4 }
        cylinder { 12.6*y, 14.4*y, 2.4 translate <0, 0, 8> }
        cylinder { 12.6*y, 14.4*y, 2.4 translate <8, 0, 0> }
        cylinder { 12.6*y, 14.4*y, 2.4 translate <8, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
        cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
        cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
        cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
        cylinder { 12.6*y, 14.4*y, 2.4 translate <40, 0, 0> }
        cylinder { 12.6*y, 14.4*y, 2.4 translate <40, 0, 8> }
        cylinder { 12.6*y, 14.4*y, 2.4 translate <48, 0, 0> }
        cylinder { 12.6*y, 14.4*y, 2.4 translate <48, 0, 8> }
        cylinder { 12.6*y, 14.4*y, 2.4 translate <56, 0, 0> }
        cylinder { 12.6*y, 14.4*y, 2.4 translate <56, 0, 8> }
      #else
        object { rounded_button() rotate 180*y translate <0, 9.6, 0> }
        object { rounded_button() rotate 180*y translate <0, 9.6, 8> }
        object { rounded_button() rotate 180*y translate <8, 9.6, 0> }
        object { rounded_button() rotate 180*y translate <8, 9.6, 8> }
        object { rounded_button() rotate 180*y translate <16, 0, 0> }
        object { rounded_button() rotate 180*y translate <16, 0, 8> }
        object { rounded_button() rotate 180*y translate <24, 0, 0> }
        object { rounded_button() rotate 180*y translate <24, 0, 8> }
        object { rounded_button() rotate 180*y translate <32, 0, 0> }
        object { rounded_button() rotate 180*y translate <32, 0, 8> }
        object { rounded_button() rotate 180*y translate <40, 9.6, 0> }
        object { rounded_button() rotate 180*y translate <40, 9.6, 8> }
        object { rounded_button() rotate 180*y translate <48, 9.6, 0> }
        object { rounded_button() rotate 180*y translate <48, 9.6, 8> }
        object { rounded_button() rotate 180*y translate <56, 9.6, 0> }
        object { rounded_button() rotate 180*y translate <56, 9.6, 8> }
      #end
      difference {
        box { <-3.9, 0, -3.9> <59.9, 12.7, 11.9> }
        box { <-4, -1, -4> <4.1, 9.6, 12> }
        box { <11.9, 3.1, -4> <36.1, 13, 12> }
        box { <43.9, -1, -4> <60, 9.6, 12> }
        #if (setting > 1)
          box { <-2.4, 8, -2.4> <4, 11.7, 10.4> }
          box { <5.6, -1, -2.4> <10.4, 11.7, 10.4> }
          box { <12, -1, -2.4> <36, 2, 10.4> }
          box { <37.6, -1, -2.4> <42.4, 11.7, 10.4> }
          box { <44, 8, -2.4> <58.4, 11.7, 10.4> }
          cylinder { 10.6*y, 13.6*y, 1.2 }
          cylinder { 10.6*y, 13.6*y, 1.2 translate <0, 0, 8> }
          cylinder { 10.6*y, 13.6*y, 1.2 translate <8, 0, 0> }
          cylinder { 10.6*y, 13.6*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 10.6*y, 13.6*y, 1.2 translate <40, 0, 0> }
          cylinder { 10.6*y, 13.6*y, 1.2 translate <40, 0, 8> }
          cylinder { 10.6*y, 13.6*y, 1.2 translate <48, 0, 0> }
          cylinder { 10.6*y, 13.6*y, 1.2 translate <48, 0, 8> }
          cylinder { 10.6*y, 13.6*y, 1.2 translate <56, 0, 0> }
          cylinder { 10.6*y, 13.6*y, 1.2 translate <56, 0, 8> }
        #end
      }
      #if (setting > 1)
        cylinder { 9.6*y, 11.8*y, 1.5 translate <0, 0, 4> }
        box { <2.4, 9.6, -0.5> <4.1, 11.8, 0.5> }
        box { <2.4, 9.6, 7.5> <4.1, 11.8, 8.5> }
        cylinder { 0*y, 11.8*y, 1.5 translate <8, 0, 4> }
        box { <11.9, 0, -0.5> <13.6, 2.1, 0.5> }
        box { <11.9, 0, 7.5> <13.6, 2.1, 8.5> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        box { <34.45, 0, -0.5> <36.1, 2.1, 0.5> }
        box { <34.4, 0, 7.5> <36.1, 2.1, 8.5> }
        cylinder { 0*y, 11.8*y, 1.5 translate <40, 0, 4> }
        box { <43.9, 9.6, -0.5> <45.6, 11.8, 0.5> }
        box { <43.9, 9.6, 7.5> <45.6, 11.8, 8.5> }
        object { ring() translate <52, 9.6, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.25, -4> <60, 14.5, 12> } }
    }
  #end
#end
#macro h_cover4_4(color_tex)
  #if (setting = 0)
    box { <-29.7, -17.55, -3.9> <1.55, -1.55, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { -3.900001*z, 27.900001*z, 1.55 }
          box { <-29.9, -1.550001, -3.9> <0, 1.550001, 27.9> }
          #if (setting < 3)
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-18.5, 0, 0> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-18.5, 0, 8> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-18.5, 0, 16> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-18.5, 0, 24> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-10.5, 0, 0> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-10.5, 0, 8> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-10.5, 0, 16> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-10.5, 0, 24> }
          #else
            object { rounded_button() rotate 180*y translate <-18.5, -1.55, 0> }
            object { rounded_button() rotate 180*y translate <-18.5, -1.55, 8> }
            object { rounded_button() rotate 180*y translate <-18.5, -1.55, 16> }
            object { rounded_button() rotate 180*y translate <-18.5, -1.55, 24> }
            object { rounded_button() rotate 180*y translate <-10.5, -1.55, 0> }
            object { rounded_button() rotate 180*y translate <-10.5, -1.55, 8> }
            object { rounded_button() rotate 180*y translate <-10.5, -1.55, 16> }
            object { rounded_button() rotate 180*y translate <-10.5, -1.55, 24> }
          #end
          box { <-32.000001, -1.550002, -3.899998> <-29.899999, 1.550002, -2.55> }
          cylinder { -3.899999*z, -2.5500001*z, 1.55 translate <-32, 0, 0> }
          box { <-32.000001, -1.550002, 3.3 > <-29.899999, 1.550002, 4.7> }
          cylinder { 3.300001*z, 4.699999*z, 1.55 translate <-32, 0, 0> }
          box { <-32.000001, -1.550002, 11.3> <-29.899999, 1.550002, 12.7> }
          cylinder { 11.300001*z, 12.699999*z, 1.549999 translate <-32, 0, 0> }
          box { <-32.000001, -1.550002, 19.3> <-29.899999, 1.550002, 20.7> }
          cylinder { 19.300001*z, 20.699999*z, 1.55 translate <-32, 0, 0> }
          box { <-32.000001, -1.550002, 26.55> <-29.899999, 1.550002, 27.899998> }
          cylinder { 26.550001*z, 27.899999*z, 1.55 translate <-32, 0, 0> }
          difference {
            box { <-29.7, -17.55, -3.900002> <1.55, -1.550001, 27.900002> }
            box { <-30, -20, -2.4> <10, -1.549999, 26.4> }
            difference {
              box { <0.55, -20, -5> <2, -16.55, 29> }
              cylinder { -4*z, 28*z, 1 translate <0.55, -16.55, 0> }
            }
            difference {
              box { <-30, -20, -5> <-28.7, -16.55, 29> }
              cylinder { -4*z, 28*z, 1 translate <-28.7, -16.55, 0> }
            }
          }
        }
        #if (setting > 1)
          box { <-28.4, -2, -2.4> <-3, 0.450001, 26.4> }
          box { <-5, -3, -1> <0, 0.45, 1.75> }
          box { <-5, -3, 6.25> <0, 0.45, 9.75> }
          box { <-5, -3, 14.25> <0, 0.45, 17.75> }
          box { <-5, -3, 22.25> <0, 0.45, 25> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-18.5, 0, 0> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-18.5, 0, 8> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-18.5, 0, 16> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-18.5, 0, 24> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-10.5, 0, 0> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-10.5, 0, 8> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-10.5, 0, 16> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-10.5, 0, 24> }
        #end
        box { <-2, -2, -5> <2, 2, -2.45> }
        box { <-2, -2, 3.2> <2, 2, 4.8> }
        box { <-2, -2, 11.2> <2, 2, 12.8> }
        box { <-2, -2, 19.2> <2, 2, 20.8> }
        box { <-2, -2, 26.45> <2, 2, 29> }
      }
      #if (setting > 1)
        box { <-15, -2, 0> <-14, 0, 1.5> rotate 45*x translate <0, 0.45, -2> }
        box { <-15, -2, -1.5> <-14, 0, 0> rotate -45*x translate <0, 0.45, 26> }
        box { <-23, -2, 0> <-22, 0, 1.5> rotate 45*x translate <0, 0.45, -2> }
        box { <-23, -2, -1.5> <-22, 0, 0> rotate -45*x translate <0, 0.45, 26> }
      #end
      texture { color_tex }
      bounded_by { box { <-33.65, -17.65, -4> <2, 3.35, 28> } }
    }
  #end
#end
#macro h_doorleft1_3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 9.5*y, 3.9 }
      box { <0, 0.000002, -3.899998> <19.9, 9.499998, -2.4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, 0.000002, -3.899998> <19.9, 9.499998, -2.4> }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
        #else
          object { rounded_button() translate <0, 6.4, 0> }
        #end
        cylinder { 0*y, 9.5*y, 3.9 }
        box { <0, 0.000001, -3.899999> <3.9, 9.499999, 0> }
        cylinder { -4.899999*z, -3.5*z, 0.75 translate <14.000001, 4.5, 0> }
        cylinder { -4.899999*z, -3.5*z, 0.75 translate <17, 4.5, 0> }
        box { <14, 3.750001, -4.9> <17.000001, 5.250001, -3.5> }
      }
      #if (setting > 1)
        cylinder { -1*y, 8.6*y, 2.6 }
        cylinder { 7.4*y, 10.4*y, 1.2 }
      #end
      cylinder { -3.9*z, -1*z, 0.85 translate <17, 4.5, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -5> <20, 11.3, 4> } }
    }
  #end
#end
#macro h_doorright1_3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 9.5*y, 3.9 }
      box { <0, 0.000002, 3.899998> <19.9, 9.499998, 2.4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, 0.000002, 2.4> <19.9, 9.499998, 3.899998> }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
        #else
          object { rounded_button() translate <0, 6.4, 0> }
        #end
        cylinder { 0*y, 9.5*y, 3.9 }
        box { <0, 0.000001, 0> <3.9, 9.499999, 3.899999> }
        cylinder { 4.899999*z, 3.5*z, 0.75 translate <14.000001, 4.5, 0> }
        cylinder { 4.899999*z, 3.5*z, 0.75 translate <17, 4.5, 0> }
        box { <14, 3.750001, 3.5> <17.000001, 5.250001, 4.9> }
      }
      #if (setting > 1)
        cylinder { -1*y, 8.6*y, 2.6 }
        cylinder { 7.4*y, 10.4*y, 1.2 }
      #end
      cylinder { 3.9*z, 1*z, 0.85 translate <17, 4.5, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 5> } }
    }
  #end
#end
#macro h_fence1_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
      box { <-3.899999, 3.099999, 1.400001> <27.899999, 9.5, 3.899999> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 2.1*y, 1.5 translate <4, 0, 0> }
        cylinder { 0*y, 2.1*y, 1.5 translate <12, 0, 0> }
        cylinder { 0*y, 2.1*y, 1.5 translate <20, 0, 0> }
      #end
      difference {
        box { <-3.899999, 3.099999, 1.400001> <27.899999, 9.5, 3.899999> }
        box { <-2.4, 3.100001, 1> <26.4, 8.2, 4> }
      }
      difference {
        merge {
          merge {
            box { <-0.3, -4.9, 1.400002> <0.3, 4.9, 3.899998> }
            box { <-4.9, -0.3, 1.400003> <4.9, 0.3, 3.899997> }
            rotate 45*z
            translate <4, 5.65, 0>
          }
          merge {
            box { <-0.3, -4.9, 1.400002> <0.3, 4.9, 3.899998> }
            box { <-4.9, -0.3, 1.400003> <4.9, 0.3, 3.899997> }
            rotate 45*z
            translate <12, 5.65, -0.000001>
          }
          merge {
            box { <-0.3, -4.9, 1.400002> <0.3, 4.9, 3.899998> }
            box { <-4.9, -0.3, 1.400003> <4.9, 0.3, 3.899997> }
            rotate 45*z
            translate <20, 5.65, 0.000001>
          }
        }
        box { <-4, -1, 0> <28, 2, 4> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 9.6, 4> } }
    }
  #end
#end
#macro h_frame1_4(color_tex,age)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 38.3, 3.9> }
      box { <-2.4, 3.6, -4> <26.4, 36.8, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 38.3, 3.9> }
          object { open_rounded_button() translate <0, 35.2, 0> }
          object { open_rounded_button() translate <8, 35.2, 0> }
          object { open_rounded_button() translate <16, 35.2, 0> }
          object { open_rounded_button() translate <24, 35.2, 0> }
          #if (setting > 3)
            object { llogo() rotate 180*y scale <0.65, 0.65, 0.65> translate <0, 38.3, 0> }
            object { llogo() rotate 180*y scale <0.65, 0.65, 0.65> translate <8, 38.3, 0> }
            object { llogo() rotate 180*y scale <0.65, 0.65, 0.65> translate <16, 38.3, 0> }
            object { llogo() rotate 180*y scale <0.65, 0.65, 0.65> translate <24, 38.3, 0> }
          #end
        }
        #if (setting > 1)
          cylinder { 0*y, 40*y, 0.9 translate <4, 0, 1.6> }
          cylinder { 0*y, 40*y, 0.9 translate <20, 0, 1.6> }
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
        #end
        box { <-2.4, 3.6, -4> <26.4, 36.8, 2.4> }
        box { <-2.400001, 3.1, -4> <26.400001, 5, -1.9> }
        box { <-1.4, 4.5, 0> <25.4, 36, 4> }
        sphere { <26.25, 36, -2.9> 0.5 }
        sphere { <-2.25, 36, -2.9> 0.5 }
        sphere { <26.25, 34, -2.9> 0.5 }
        sphere { <-2.25, 34, -2.9> 0.5 }
        sphere { <26.25, 36, -0.9> 0.5 }
        sphere { <-2.25, 36, -0.9> 0.5 }
      }
      box { <-0.5, 0.1, -0.5> <0.5, 2.1, 0.5> rotate 45*y translate <2.25, 0, -2.5> }
      box { <-0.5, 0.1, -0.5> <0.5, 2.1, 0.5> rotate 45*y translate <18.25, 0, -2.5> }
      box { <-0.5, 0.1, -0.5> <0.5, 2.1, 0.5> rotate 45*y translate <5.75, 0, -2.5> }
      box { <-0.5, 0.1, -0.5> <0.5, 2.1, 0.5> rotate 45*y translate <21.75, 0, -2.5> }
      object { pin(age) translate <12, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 40.1, 4> } }
    }
  #end
#end
#macro h_frame2_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 28.7, 11.9> }
      box { <-0.7, 3.2, -4> <24.7, 25.5, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 28.6*y, 30.4*y, 2.4 }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <8, 0, 0> }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <16, 0, 0> }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <24, 0, 0> }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <0, 0, 8> }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <8, 0, 8> }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <16, 0, 8> }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <24, 0, 8> }
          #else
            object { rounded_button() translate <0, 25.6, 0> }
            object { rounded_button() translate <8, 25.6, 0> }
            object { rounded_button() translate <16, 25.6, 0> }
            object { rounded_button() translate <24, 25.6, 0> }
            object { rounded_button() translate <0, 25.6, 8> }
            object { rounded_button() translate <8, 25.6, 8> }
            object { rounded_button() translate <16, 25.6, 8> }
            object { rounded_button() translate <24, 25.6, 8> }
          #end
          box { <-3.9, 0, -3.9> <27.9, 28.7, 11.9> }
        }
        box { <-0.7, 3.2, -4> <24.7, 25.5, 12> }
        #if (setting > 1)
          difference {
            box { <-2.4, 3.19999, -2.4> <26.4, 27.2, 12> }
            difference {
              box { <9, 26.4, -2.5> <15, 28, 24.7> }
              box { <-2, -2, -3> <0, 0, 25> rotate -45*z translate <10, 26.4, 0> }
              box { <0, -2, -3> <2, 0, 25> rotate -45*z translate <12, 27.2, 0> }
              box { <0, -2, -3> <2, 0, 25> rotate 45*z translate <14, 26.4, 0> }
            }
            difference {
              box { <-2.5, 25.50001, -3> <3.5, 29, 1> }
              box { <-5, 25, -4> <0, 30, 0> rotate 15*y translate <-1.4, 0, 1> }
              box { <0, 25, -4> <5, 30, 0> rotate -15*y translate <2.4, 0, 1> }
            }
            difference {
              box { <20.5, 25.50001, -3> <26.5, 29, 1> }
              box { <0, 25, -4> <5, 30, 0> rotate -15*y translate <25.4, 0, 1> }
              box { <-5, 25, -4> <0, 30, 0> rotate 15*y translate <21.6, 0, 1> }
            }
          }
          box { <-2.9, -1, -2.4> <26.9, 2, 10.4> }
          box { <-0.70001, -2, -2> <1.3, 0, 0> rotate 10*x translate <0, 25.5, -2.9> }
          box { <-0.70001, 0, -2> <1.3, 2, 0> rotate -10*x translate <0, 3.2, -2.9> }
          box { <22.7, -2, -2> <24.70001, 0, 0> rotate 10*x translate <0, 25.5, -2.9> }
          box { <22.7, 0, -2> <24.70001, 2, 0> rotate -10*x translate <0, 3.2, -2.9> }
          cylinder { -1*y, 31*y, 0.85 translate <0.5, 0, -1.6> }
          cylinder { -1*y, 31*y, 0.85 translate <23.5, 0, -1.6> }
          cylinder { -1*y, 31*y, 0.85 translate <-1.2, 0, 9.6> }
          cylinder { -1*y, 31*y, 0.85 translate <25.2, 0, 9.6> }
          cylinder { 0*y, 2.00001*y, 1.2 translate <0.5, 0, -1.6> }
          cylinder { 0*y, 2.00001*y, 1.2 translate <23.5, 0, -1.6> }
          cylinder { 0*y, 2.00001*y, 1.2 translate <-1.2, 0, 9.6> }
          cylinder { 0*y, 2.00001*y, 1.2 translate <25.2, 0, 9.6> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        box { <-3, 0.1, -0.5> <-2.4, 2.1, 0.5> }
        box { <-3, 0.1, 7.5> <-2.4, 2.1, 8.5> }
        box { <26.4, 0.1, -0.5> <27, 2.1, 0.5> }
        box { <26.4, 0.1, 7.5> <27, 2.1, 8.5> }
        box { <-1.4, 2.9, -0.2> <0.6, 4.4, 1> }
        box { <0, 2.9, -4> <1.2, 4.40001, 0> rotate 15*y translate <-1.4, 0, 1> }
        box { <23.4, 2.9, -0.2> <25.4, 4.4, 1> }
        box { <-1.2, 2.9, -4> <0, 4.40001, 0> rotate -15*y translate <25.4, 0, 1> }
        box { <-1.4, 24.3, -0.2> <0.6, 25.8, 1> }
        box { <0, 24.30001, -4> <1.2, 25.8, 0> rotate 15*y translate <-1.4, 0, 1> }
        box { <23.4, 24.3, -0.2> <25.4, 25.8, 1> }
        box { <-1.2, 24.30001, -4> <0, 25.8, 0> rotate -15*y translate <25.4, 0, 1> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 30.2, 12> } }
    }
  #end
#end
#macro h_handle1_1(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> }
      cylinder { 0*y, 9.5*y, 1.5 translate <8, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
        #end
      }
      #if (setting < 3)
        cylinder { 9.4*y, 11.2*y, 2.4 }
      #else
        object { rounded_button() translate <0, 6.4, 0> }
      #end
      box { <3.5, 3.2, -1.1> <8, 6.3, 1.1> }
      cylinder { 0*y, 9.5*y, 1.5 translate <8, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <9.6, 11.3, 4> } }
    }
  #end
#end
#macro h_hatch1_4(color_tex)
  #if (setting = 0)
    box { <-2, -32.4, -3> <26, 0.6, -1.6> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-2, -32.4, -3> <26, 0.600001, -1.6> }
        cylinder { -5*z, -1.7*z, 0.9 translate <10.1, -29.5, 0> }
        cylinder { -5*z, -1.7*z, 0.9 translate <13.9, -29.5, 0> }
        box { <10.000001, -30.4000001, -5.000001> <13.899999, -28.599999, -1.75> }
        sphere { <26.25, 0, -2> 0.5 }
        sphere { <-2.25, 0, -2> 0.5 }
        sphere { <26.25, 0, 0> 0.5 }
        sphere { <-2.25, 0, 0> 0.5 }
        cylinder { -2.000001*x, -1.000001*x, 0.6 }
        box { <-2.000002, -0.599999, -1.7> <-1.000002, 0.599999, 0.000001> }
        cylinder { 25.000001*x, 26.000001*x, 0.6 }
        box { <25.000002, -0.599999, -1.7> <26.000002, 0.599999, 0.000001> }
      }
      #local counter = 0;
      #while (counter < 17)
        box { <-10, -0.5, -0.5> <30, 0.5, 0.5> rotate 45*x translate <0, -2-(counter*1.6), -3> }
        #local counter = counter + 1;
      #end
      #if (setting > 1)
        cylinder { -4*z, -1.1*z, 0.95 translate <10.1, -29.5, 0> }
        cylinder { -4*z, -1.1*z, 0.95 translate <13.9, -29.5, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-2.85, -32.5, -5.1> <26.85, 0.7, 0.7> } }
    }
  #end
#end
#macro h_hull10_8(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <75.9, 9.5, 59.9> }
      box { <-10, -20, -10> <80, 0, 50> rotate -47*x translate <0, 2, 52> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <75.9, 9.5, 59.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 24> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 32> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 40> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 40> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <40, 0, 40> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <48, 0, 40> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 48> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <40, 0, 48> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <64, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <64, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <64, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <56, 0, 24> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <56, 0, 32> }
          #else
            object { rounded_button() rotate 90*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 24> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 32> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 40> }
            object { rounded_button() rotate 90*y translate <32, 6.4, 40> }
            object { rounded_button() rotate 90*y translate <40, 6.4, 40> }
            object { rounded_button() rotate 90*y translate <48, 6.4, 40> }
            object { rounded_button() rotate 90*y translate <32, 6.4, 48> }
            object { rounded_button() rotate 90*y translate <40, 6.4, 48> }
            object { rounded_button() rotate 90*y translate <64, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <64, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <64, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <56, 6.4, 24> }
            object { rounded_button() rotate 90*y translate <56, 6.4, 32> }
          #end
        }
        difference {
          box { <-2.9, 1, -2.4> <74.9, 10, 58.4> }
          box { <4, 0, -4> <68, 11, 20> }
          box { <12, 0, 19> <60, 11, 36> }
          box { <20, 0, 35> <52, 11, 44> }
          box { <28, 0, 43> <44, 11, 52> }
          box { <-10, -20, -10> <80, 0, 50> rotate -47*x translate <0, 2, 52> }
          box { <-50, -50, -50> <0, 20, 50> rotate 16.4*z rotate 18.4*y translate <-3, 2, -4> }
          box { <-50, -50, -50> <0, 20, 50> rotate 26*z rotate 32*y translate <5, 2, 20> }
          box { <-50, -50, -40> <0, 20, 40> rotate 31.5*z rotate 42*y translate <29, 2, 52> }
          box { <0, -50, -50> <50, 20, 50> rotate -16.4*z rotate -18.4*y translate <75, 2, -4> }
          box { <0, -50, -50> <50, 20, 50> rotate -26*z rotate -32*y translate <67, 2, 20> }
          box { <0, -50, -40> <50, 20, 40> rotate -31.5*z rotate -42*y translate <43, 2, 52> }
          box { <-5, 0, -2> <5, 11, 2> rotate -45*y translate <12, 0, 20> }
          box { <-5, 0, -2> <5, 11, 2> rotate -45*y translate <20, 0, 36> }
          box { <-5, 0, -2> <5, 11, 2> rotate 45*y translate <52, 0, 36> }
          box { <-5, 0, -2> <5, 11, 2> rotate 45*y translate <60, 0, 20> }
        }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 24> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 32> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 40> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 40> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 40> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <48, 0, 40> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 48> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 48> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <64, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <64, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <64, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <56, 0, 24> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <56, 0, 32> }
          box { <5.6, -1, -2.4> <10.4, 8.6, 18.4> }
          box { <61.6, -1, -2.4> <66.4, 8.6, 18.4> }
          box { <13.6, -1, 21.6> <18.4, 8.6, 32.4> }
          box { <15.599999, -1, 30> <18.500001, 8.600001, 34.4> }
          cylinder { -1*y, 8.600001*y, 1.9 translate <15.5, 0, 32.5> }
          box { <53.6, -1, 21.6> <58.4, 8, 32.4> }
          box { <53.500001, -1, 30> <54.399999, 8.600001, 34.4> }
          cylinder { -1*y, 8.600001*y, 1.9 translate <56.5, 0, 32.5> }
          box { <21.5, -1, 37.6> <28, 8.6, 42.4> }
          box { <44, -1, 37.6> <50.5, 8.6, 42.4> }
          box { <29.6, -1, 37.6> <42.4, 8.6, 50.4> }
        #end
        box { <12, -1, -4> <60, 10, 20> }
        box { <20, -1, -4> <52, 10, 36> }
        box { <-50, -20, -10> <80, 0, 50> rotate -47*x translate <0, 0, 52> }
        box { <-50, -50, -50> <0, 20, 50> rotate 16.4*z rotate 18.4*y translate <-4, 0, -4> }
        box { <-50, -50, -50> <0, 20, 50> rotate 26*z rotate 32*y translate <4, 0, 20> }
        box { <-50, -50, -50> <0, 20, 50> rotate 31.5*z rotate 42*y translate <28, 0, 52> }
        box { <-30, -1, -20> <0, 10, 50> rotate 18.4*y translate <-4, 0, 4> }
        box { <-30, -1, -20> <0, 10, 50> rotate 32*y translate <4, 0, 28> }
        box { <-40, -1, -20> <0, 10, 50> rotate 42*y translate <15, 0, 45.5> }
        box { <0, -50, -50> <50, 20, 50> rotate -16.4*z rotate -18.4*y translate <76, 0, -4> }
        box { <0, -50, -50> <50, 20, 50> rotate -26*z rotate -32*y translate <68, 0, 20> }
        box { <0, -50, -50> <50, 20, 50> rotate -31.5*z rotate -42*y translate <44, 0, 52> }
        box { <0, -1, -20> <30, 10, 50> rotate -18.4*y translate <76, 0, 4> }
        box { <0, -1, -20> <30, 10, 50> rotate -32*y translate <68, 0, 28> }
        box { <0, -1, -20> <30, 10, 50> rotate -42*y translate <57, 0, 45.5> }
      }
      difference {
        merge {
          difference {
            cylinder { 0*y, 9.45*y, 2.4 }
            cylinder { -1*y, 12*y, 1.600001 }
          }
          difference {
            cylinder { 0*y, 9.45*y, 2.4 }
            cylinder { -1*y, 12*y, 1.600001 }
            translate <8, 0, 24>
          }
          difference {
            cylinder { 0*y, 9.45*y, 2.4 }
            cylinder { -1*y, 12*y, 1.600001 }
            translate <24, 0, 48>
          }
          difference {
            cylinder { 0*y, 9.45*y, 2.4 }
            cylinder { -1*y, 12*y, 1.600001 }
            translate <32, 0, 56>
          }
          difference {
            cylinder { 0*y, 9.45*y, 2.4 }
            cylinder { -1*y, 12*y, 1.600001 }
            translate <40, 0, 56>
          }
          difference {
            cylinder { 0*y, 9.45*y, 2.4 }
            cylinder { -1*y, 12*y, 1.600001 }
            translate <48, 0, 48>
          }
          difference {
            cylinder { 0*y, 9.45*y, 2.4 }
            cylinder { -1*y, 12*y, 1.600001 }
            translate <64, 0, 24>
          }
          difference {
            cylinder { 0*y, 9.45*y, 2.4 }
            cylinder { -1*y, 12*y, 1.600001 }
            translate <72, 0, 0>
          }
          object { open_rounded_button() translate <0, 6.4, 0> }
          object { open_rounded_button() translate <8, 6.4, 24> }
          object { open_rounded_button() translate <24, 6.4, 48> }
          object { open_rounded_button() translate <32, 6.4, 56> }
          object { open_rounded_button() translate <40, 6.4, 56> }
          object { open_rounded_button() translate <48, 6.4, 48> }
          object { open_rounded_button() translate <64, 6.4, 24> }
          object { open_rounded_button() translate <72, 6.4, 0> }
          box { <7.5, 0.9, 19> <8.5, 9.25, 22> }
          box { <23.5, 0.9, 43> <24.5, 9.25, 46> }
          box { <47.5, 0.9, 43> <48.5, 9.25, 46> }
          box { <63.5, 0.9, 19> <64.5, 9.25, 22> }
          box { <34, 0.9, 55.5> <38, 9.25, 56.5> }
        }
        box { <-50, -20, -10> <80, 0, 50> rotate -47*x translate <0, 2, 52> }
        box { <-50, -50, -50> <0, 20, 50> rotate 16.4*z rotate 18.4*y translate <-3, 2, -4> }
        box { <-50, -50, -50> <0, 20, 50> rotate 26*z rotate 32*y translate <5, 2, 20> }
        box { <-50, -50, -40> <0, 20, 40> rotate 31.5*z rotate 42*y translate <29, 2, 52> }
        box { <0, -50, -50> <50, 20, 50> rotate -16.4*z rotate -18.4*y translate <75, 2, -4> }
        box { <0, -50, -50> <50, 20, 50> rotate -26*z rotate -32*y translate <67, 2, 20> }
        box { <0, -50, -40> <50, 20, 40> rotate -31.5*z rotate -42*y translate <43, 2, 52> }
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <8, 0, 4> }
        cylinder { 0*y, 8.7*y, 1.5 translate <8, 0, 12> }
        cylinder { 0*y, 8.7*y, 1.5 translate <64, 0, 4> }
        cylinder { 0*y, 8.7*y, 1.5 translate <64, 0, 12> }
        cylinder { 0*y, 8.7*y, 1.5 translate <16, 0, 28> }
        cylinder { 0*y, 8.7*y, 1.5 translate <56, 0, 28> }
        object { high_ring() translate <36, 0, 44> }
        box { <26.5, 0.1, 39.5> <29, 8.7, 40.5> }
        box { <43, 0.1, 39.5> <45.5, 8.7, 40.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 11.2, 60> } }
    }
  #end
#end
#macro h_hull6_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 9.5, 43.9> }
      box { <-20, -20, -10> <10, 0, 50> rotate -48.5*z translate <4, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <43.9, 9.5, 43.9> }
        box { <19.9, -1, 11.9> <44, 10, 28.1> }
        #if (setting > 1)
          box { <5.6, -1, 13.6> <18.4, 8.6, 26.4> }
          box { <21.6, -1, 5.6> <42.4, 8.6, 10.4> }
          box { <21.6, -1, 29.6> <42.4, 8.6, 34.4> }
        #end
        box { <-20, -20, -10> <10, 0, 50> rotate -48.5*z translate <4, 0, 0> }
        box { <-50, -10, -50> <50, 10, 0> rotate 18.4*y translate <36, 0, -4> }
        box { <-50, -10, -50> <50, 10, 0> rotate 26.8*y translate <-4, 0, 12> }
        box { <-50, -50, -50> <50, 20, 0> rotate -15.65*x rotate 18.4*y translate <44, 0, -4> }
        box { <-50, -50, -50> <50, 20, 0> rotate -21.75*x rotate 26.8*y translate <4, 0, 12> }
        box { <-50, -10, 0> <50, 10, 50> rotate -18.4*y translate <36, 0, 44> }
        box { <-50, -10, 0> <50, 10, 50> rotate -26.8*y translate <-4, 0, 28> }
        box { <-50, -50, 0> <50, 20, 50> rotate 15.65*x rotate -18.4*y translate <44, 0, 44> }
        box { <-50, -50, 0> <50, 20, 50> rotate 21.75*x rotate -26.8*y translate <20, 0, 36> }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 24> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 24> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 32> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 32> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 32> }
        #end
        difference {
          box { <-2.4, 1, -2.4> <42.4, 11, 42.4> }
          box { <-20, -20, -10> <10, 0, 50> rotate -48.5*z translate <4, 2, 0> }
          box { <-50, -50, -50> <50, 20, 0> rotate -15.65*x rotate 18.4*y translate <44, 2, -3.3> }
          box { <-50, -50, -50> <50, 20, 0> rotate -21.75*x rotate 26.8*y translate <4, 2, 12.7> }
          box { <-50, -50, 0> <50, 20, 50> rotate 15.65*x rotate -18.4*y translate <44, 2, 43.3> }
          box { <-50, -50, 0> <50, 20, 50> rotate 21.75*x rotate -26.8*y translate <20, 2, 35.3> }
          box { <4, 0, 12> <43, 12, 28> }
          box { <20, 0, 4> <43, 12, 12> }
          box { <20, 0, 28> <43, 12, 36> }
          box { <-0.5, 0, 18> <0.5, 12, 22> }
          box { <18, 0, 7.5> <21, 12, 8.5> }
          box { <18, 0, 31.5> <21, 12, 32.5> }
          box { <0, 0, 0> <20, 12, 20> rotate 45*y translate <9.25, 0, 20> }
        }
      }
      #if (setting < 3)
        cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 16> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 24> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 24> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 8> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 8> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <40, 0, 8> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 32> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 32> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <40, 0, 32> }
      #else
        object { rounded_button() translate <8, 6.4, 16> }
        object { rounded_button() translate <8, 6.4, 24> }
        object { rounded_button() translate <16, 6.4, 16> }
        object { rounded_button() translate <16, 6.4, 24> }
        object { rounded_button() translate <24, 6.4, 8> }
        object { rounded_button() translate <32, 6.4, 8> }
        object { rounded_button() translate <40, 6.4, 8> }
        object { rounded_button() translate <24, 6.4, 32> }
        object { rounded_button() translate <32, 6.4, 32> }
        object { rounded_button() translate <40, 6.4, 32> }
      #end
      difference {
        merge {
          object { open_rounded_button() translate <0, 6.4, 16> }
          object { open_rounded_button() translate <0, 6.4, 24> }
          object { open_rounded_button() translate <16, 6.4, 8> }
          object { open_rounded_button() translate <16, 6.4, 32> }
          object { open_rounded_button() translate <40, 6.4, 0> }
          object { open_rounded_button() translate <40, 6.4, 40> }
          difference {
            cylinder { 1*y, 9.400001*y, 2.4 }
            cylinder { 0*y, 12*y, 1.600001 }
            translate <0, 0, 16>
          }
          difference {
            cylinder { 1*y, 9.400001*y, 2.4 }
            cylinder { 0*y, 12*y, 1.600001 }
            translate <0, 0, 24>
          }
          difference {
            cylinder { 1*y, 9.400001*y, 2.4 }
            cylinder { 0*y, 12*y, 1.600001 }
            translate <16, 0, 8>
          }
          difference {
            cylinder { 1*y, 9.400001*y, 2.4 }
            cylinder { 0*y, 12*y, 1.600001 }
            translate <16, 0, 32>
          }
          difference {
            cylinder { 1*y, 9.400001*y, 2.4 }
            cylinder { 0*y, 12*y, 1.600001 }
            translate <40, 0, 0>
          }
          difference {
            cylinder { 1*y, 9.400001*y, 2.4 }
            cylinder { 0*y, 12*y, 1.600001 }
            translate <40, 0, 40>
          }
        }
        box { <-20, -20, -10> <10, 0, 50> rotate -48.5*z translate <4, 2, 0> }
        box { <-50, -50, -50> <50, 20, 0> rotate -15.65*x rotate 18.4*y translate <44, 2, -4> }
        box { <-50, -50, -50> <50, 20, 0> rotate -21.75*x rotate 26.8*y translate <4, 2, 12> }
        box { <-50, -50, 0> <50, 20, 50> rotate 15.65*x rotate -18.4*y translate <44, 2, 44> }
        box { <-50, -50, 0> <50, 20, 50> rotate 21.75*x rotate -26.8*y translate <20, 2, 36> }
      }
      #if (setting > 1)
        object { high_ring() translate <12, 0, 20> }
        cylinder { 0*y, 8.7*y, 1.5 translate <28, 0, 8> }
        cylinder { 0*y, 8.7*y, 1.5 translate <36, 0, 8> }
        cylinder { 0*y, 8.7*y, 1.5 translate <28, 0, 32> }
        cylinder { 0*y, 8.7*y, 1.5 translate <36, 0, 32> }
        box { <27.5, 0.000001, 29.4> <28.5, 8.7, 34.6> }
        box { <35.5, 0.000001, 29.4> <36.5, 8.7, 34.6> }
        box { <27.5, 0.000001, 5.4> <28.5, 8.7, 10.6> }
        box { <35.5, 0.000001, 5.4> <36.5, 8.7, 10.6> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 11.3, 44> } }
    }
  #end
#end
#macro h_hulltop10_8(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <75.9, 9.5, 59.9> }
      box { <-50, -20, -10> <80, 0, 50> rotate -47*x translate <0, 0, 52> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting < 3)
        cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
        cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 0> }
        cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
        cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
        cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 24> }
        cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 24> }
        cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
        cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 32> }
        cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 40> }
        cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 40> }
        cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 40> }
        cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 40> }
        cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 48> }
        cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 48> }
      #else
        object { rounded_button() rotate 90*y translate <8, 0, 0> }
        object { rounded_button() rotate 90*y translate <8, 0, 8> }
        object { rounded_button() rotate 90*y translate <64, 0, 0> }
        object { rounded_button() rotate 90*y translate <64, 0, 8> }
        object { rounded_button() rotate 90*y translate <8, 0, 16> }
        object { rounded_button() rotate 90*y translate <16, 0, 16> }
        object { rounded_button() rotate 90*y translate <24, 0, 16> }
        object { rounded_button() rotate 90*y translate <32, 0, 16> }
        object { rounded_button() rotate 90*y translate <40, 0, 16> }
        object { rounded_button() rotate 90*y translate <48, 0, 16> }
        object { rounded_button() rotate 90*y translate <56, 0, 16> }
        object { rounded_button() rotate 90*y translate <64, 0, 16> }
        object { rounded_button() rotate 90*y translate <16, 0, 24> }
        object { rounded_button() rotate 90*y translate <24, 0, 24> }
        object { rounded_button() rotate 90*y translate <48, 0, 24> }
        object { rounded_button() rotate 90*y translate <56, 0, 24> }
        object { rounded_button() rotate 90*y translate <24, 0, 32> }
        object { rounded_button() rotate 90*y translate <48, 0, 32> }
        object { rounded_button() rotate 90*y translate <24, 0, 40> }
        object { rounded_button() rotate 90*y translate <32, 0, 40> }
        object { rounded_button() rotate 90*y translate <40, 0, 40> }
        object { rounded_button() rotate 90*y translate <48, 0, 40> }
        object { rounded_button() rotate 90*y translate <32, 0, 48> }
        object { rounded_button() rotate 90*y translate <40, 0, 48> }
      #end
      object { open_rounded_button() translate <32, 0, 24> }
      object { open_rounded_button() translate <40, 0, 24> }
      object { open_rounded_button() translate <32, 0, 32> }
      object { open_rounded_button() translate <40, 0, 32> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <32, 3.1, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <40, 3.1, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <32, 3.1, 32> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <40, 3.1, 32> }
      #end
      #if (setting > 1)
        object { pin(2) translate <8, 0, 4> }
        object { pin(2) translate <64, 0, 4> }
        object { pin(2) translate <20, 0, 16> }
        object { pin(2) translate <28, 0, 16> }
        object { pin(2) translate <36, 0, 16> }
        object { pin(2) translate <44, 0, 16> }
        object { pin(2) translate <52, 0, 16> }
        object { pin(2) translate <16, 0, 28> }
        object { pin(2) translate <56, 0, 28> }
        object { ring() translate <36, 0, 44> }
      #end
      difference {
        box { <-3.9, 0, -3.9> <75.9, 9.5, 59.9> }
        box { <12, -1, -4> <60, 10, 12> }
        box { <-50, -20, -10> <80, 0, 50> rotate -47*x translate <0, 0, 52> }
        box { <-50, -50, -50> <0, 20, 50> rotate 16.4*z rotate 18.4*y translate <-4, 0, -4> }
        box { <-50, -50, -50> <0, 20, 50> rotate 26*z rotate 32*y translate <4, 0, 20> }
        box { <-50, -50, -50> <0, 20, 50> rotate 31.5*z rotate 42*y translate <28, 0, 52> }
        box { <-30, -1, -20> <0, 10, 50> rotate 18.4*y translate <-4, 0, 4> }
        box { <-30, -1, -20> <0, 10, 50> rotate 32*y translate <4, 0, 28> }
        box { <-40, -1, -20> <0, 10, 50> rotate 42*y translate <15, 0, 45.5> }
        box { <0, -50, -50> <50, 20, 50> rotate -16.4*z rotate -18.4*y translate <76, 0, -4> }
        box { <0, -50, -50> <50, 20, 50> rotate -26*z rotate -32*y translate <68, 0, 20> }
        box { <0, -50, -50> <50, 20, 50> rotate -31.5*z rotate -42*y translate <44, 0, 52> }
        box { <0, -1, -20> <30, 10, 50> rotate -18.4*y translate <76, 0, 4> }
        box { <0, -1, -20> <30, 10, 50> rotate -32*y translate <68, 0, 28> }
        box { <0, -1, -20> <30, 10, 50> rotate -42*y translate <57, 0, 45.5> }
        difference {
          box { <-2.9, 3.1, -4> <74.9, 10, 58.4> }
          box { <-10, -20, -10> <80, 0, 50> rotate -47*x translate <0, 2, 52> }
          box { <-50, -50, -50> <0, 20, 50> rotate 16.4*z rotate 18.4*y translate <-3, 2, -4> }
          box { <-50, -50, -50> <0, 20, 50> rotate 26*z rotate 32*y translate <5, 2, 20> }
          box { <-50, -50, -40> <0, 20, 40> rotate 31.5*z rotate 42*y translate <29, 2, 52> }
          box { <0, -50, -50> <50, 20, 50> rotate -16.4*z rotate -18.4*y translate <75, 2, -4> }
          box { <0, -50, -50> <50, 20, 50> rotate -26*z rotate -32*y translate <67, 2, 20> }
          box { <0, -50, -40> <50, 20, 40> rotate -31.5*z rotate -42*y translate <43, 2, 52> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <74.4, 2, 50.4> }
            box { <-30, -1, -20> <0, 4, 50> rotate 18.4*y translate <-2, 0, -4> }
            box { <-30, -1, -20> <0, 4, 50> rotate 32*y translate <6, 0, 20> }
            box { <-30, -1, -20> <0, 4, 50> rotate 42*y translate <16, 0, 36> }
            box { <0, -1, -20> <30, 4, 50> rotate -18.4*y translate <74, 0, -4> }
            box { <0, -1, -20> <30, 4, 50> rotate -32*y translate <66, 0, 20> }
            box { <0, -1, -20> <30, 4, 50> rotate -42*y translate <56, 0, 36> }
            box { <10.5, -1, -4> <61.5, 4, 13.5> }
            box { <0, -1, 20> <75, 4, 21.5> }
            box { <7.5, -1, 18.5> <8.5, 4, 21> }
            box { <15.5, -1, 18.5> <16.5, 4, 21> }
            box { <23.5, -1, 18.5> <24.5, 4, 21> }
            box { <31.5, -1, 18.5> <32.5, 4, 21> }
            box { <39.5, -1, 18.5> <40.5, 4, 21> }
            box { <47.5, -1, 18.5> <48.5, 4, 21> }
            box { <55.5, -1, 18.5> <56.5, 4, 21> }
            box { <63.5, -1, 18.5> <64.5, 4, 21> }
            box { <4, -1, -4> <5.5, 4, 12> }
            box { <66.5, -1, -4> <68, 4, 12> }
            box { <0, -1, 11> <12, 4, 12.5> }
            box { <60, -1, 11> <72, 4, 12.5> }
            box { <7.5, -1, 10.5> <8.5, 4, 13.5> }
            box { <63.5, -1, 10.5> <64.5, 4, 13.5> }
            box { <11.5, -1, 15.5> <13.5, 4, 16.5> }
            box { <58.5, -1, 15.5> <60.5, 4, 16.5> }
            box { <10.5, -1, 12> <12, 4, 20> }
            box { <60, -1, 12> <61.5, 4, 20> }
            box { <-4, -1, -0.5> <-2.5, 4, 0.5> rotate 18.4*y translate <8, 0, 16> }
            box { <2.5, -1, -0.5> <4, 4, 0.5> rotate -18.4*y translate <64, 0, 16> }
            box { <-10, -1, -0.5> <-2.5, 4, 0.5> rotate 32*y translate <16, 0, 24> }
            box { <2.5, -1, -0.5> <10, 4, 0.5> rotate -32*y translate <56, 0, 24> }
            box { <-10, -1, -0.5> <-2.5, 4, 0.5> rotate 42*y translate <24, 0, 40> }
            box { <2.5, -1, -0.5> <10, 4, 0.5> rotate -42*y translate <48, 0, 40> }
            box { <18.5, -1, 20.5> <20, 4, 37.5> }
            box { <52, -1, 20.5> <53.5, 4, 37.5> }
            box { <18.5, -1, 36> <53.5, 4, 37.5> }
            box { <-5, -1, -0.75> <0, 4, 0.75> rotate 45*y translate <19.25, 0, 36.75> }
            box { <0, -1, -0.75> <5, 4, 0.75> rotate -45*y translate <52.75, 0, 36.75> }
            box { <28, -1, 36.5> <29.5, 4, 51> }
            box { <42.5, -1, 36.5> <44, 4, 51> }
            box { <26.5, -1, 39.5> <28.5, 4, 40.5> }
            box { <43.5, -1, 39.5> <46.5, 4, 40.5> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 48> }
        #end
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 11.3, 60> } }
    }
  #end
#end
#macro h_hulltop6_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 9.5, 43.9> }
      box { <-20, -20, -10> <10, 0, 50> rotate -48.5*z translate <4, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
          cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
          cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
          cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 32> }
          cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 32> }
        #else
          object { rounded_button() translate <8, 0, 16> }
          object { rounded_button() translate <8, 0, 24> }
          object { rounded_button() translate <16, 0, 16> }
          object { rounded_button() translate <16, 0, 24> }
          object { rounded_button() translate <24, 0, 8> }
          object { rounded_button() translate <24, 0, 16> }
          object { rounded_button() translate <24, 0, 24> }
          object { rounded_button() translate <24, 0, 32> }
          object { rounded_button() translate <32, 0, 8> }
          object { rounded_button() translate <32, 0, 32> }
          object { rounded_button() translate <40, 0, 8> }
          object { rounded_button() translate <40, 0, 32> }
        #end
        difference {
          box { <-3.9, 0, -3.9> <43.9, 9.5, 43.9> }
          box { <4, 3.100001, 11.8> <50, 10, 28.2> }
          box { <20, 3.100002, 3.8> <50, 10, 36.2> }
          box { <27.9, -1, 11.9> <44, 10, 28.1> }
          box { <-20, -20, -10> <10, 0, 50> rotate -48.5*z translate <4, 0, 0> }
          box { <-50, -10, -50> <50, 10, 0> rotate 18.4*y translate <36, 0, -4> }
          box { <-50, -10, -50> <50, 10, 0> rotate 26.8*y translate <-4, 0, 12> }
          box { <-50, -50, -50> <50, 20, 0> rotate -15.65*x rotate 18.4*y translate <44, 0, -4> }
          box { <-50, -50, -50> <50, 20, 0> rotate -21.75*x rotate 26.8*y translate <4, 0, 12> }
          box { <-50, -10, 0> <50, 10, 50> rotate -18.4*y translate <36, 0, 44> }
          box { <-50, -10, 0> <50, 10, 50> rotate -26.8*y translate <-4, 0, 28> }
          box { <-50, -50, 0> <50, 20, 50> rotate 15.65*x rotate -18.4*y translate <44, 0, 44> }
          box { <-50, -50, 0> <50, 20, 50> rotate 21.75*x rotate -26.8*y translate <20, 0, 36> }
          difference {
            box { <-2.4, 3.1, -2.4> <50, 11, 42.4> }
            box { <-20, -20, -10> <10, 0, 50> rotate -48.5*z translate <4, 2, 0> }
            box { <-50, -50, -50> <50, 20, 0> rotate -15.65*x rotate 18.4*y translate <44, 2, -3.3> }
            box { <-50, -50, -50> <50, 20, 0> rotate -21.75*x rotate 26.8*y translate <4, 2, 12.7> }
            box { <-50, -50, 0> <50, 20, 50> rotate 15.65*x rotate -18.4*y translate <44, 2, 43.3> }
            box { <-50, -50, 0> <50, 20, 50> rotate 21.75*x rotate -26.8*y translate <20, 2, 35.3> }
          }
          #if(setting > 1)
            box { <5.6, -1, 13.6> <18.4, 2, 26.4> }
            difference {
              box { <4, -1, -2.4> <42.4, 2, 42.4> }
              box { <3, -2, 12> <20, 3, 28> }
              box { <-50, -10, -50> <50, 10, 0> rotate 18.4*y translate <44, 0, -2.3> }
              box { <-50, -10, -50> <50, 10, 0> rotate 26.8*y translate <20, 0, 5.8> }
              box { <26.5, 0.000001, 10.5> <45, 2.1, 29.5> }
              box { <27.4, 0.000002, 0> <28.6, 2.1, 11.5> }
              box { <28, 0.000003, 4.1> <45, 2.1, 5.6> }
              box { <26.6, 0.250004, 7.5> <29.4, 2.1, 8.5> }
              box { <23.5, 0.250005, 0> <24.5, 2.1, 5.6> }
              box { <23.5, 0.250006, 11.5> <24.5, 2.1, 13.6> }
              box { <18.5, 0.000007, 10.500001> <27.5, 2.1, 12> }
              box { <19.5, 0.250008, 15.5> <21.6, 2.1, 16.5> }
              box { <0, 0.250009, 7.5> <21.6, 2.1, 8.5> }
              box { <-0.5, 0.250010, -10> <0.5, 2.1, 0> rotate 26.8*y translate <20, 0, 11.5> }
              box { <-0.5, 0.250010, 0> <0.5, 2.1, 10> rotate -26.8*y translate <20, 0, 28.5> }
              box { <0, 0.250009, 31.5> <21.6, 2.1, 32.5> }
              box { <19.5, 0.250008, 23.5> <21.6, 2.1, 24.5> }
              box { <18.5, 0.000007, 28> <27.5, 2.1, 29.500001> }
              box { <23.5, 0.250006, 26.4> <24.5, 2.1, 28.5> }
              box { <23.5, 0.250005, 35.9> <24.5, 2.1, 40> }
              box { <26.6, 0.250004, 31.5> <29.4, 2.1, 32.5> }
              box { <28, 0.000003, 34.4> <45, 2.1, 35.9> }
              box { <27.4, 0.000002, 28.5> <28.6, 2.1, 40> }
              object { pin(2) translate <36, 0.000001, 8> }
              object { pin(2) translate <36, 0.000001, 32> }
              box { <-50, -10, 0> <50, 10, 50> rotate -26.8*y translate <20, 0, 34.2> }
              box { <-50, -10, 0> <50, 10, 50> rotate -18.4*y translate <44, 0, 42.3> }
          }
        #end
        }
        #if (setting > 1)
          object { ring() translate <12, 0, 20> }
        #end
      }
      #if (setting > 1)
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
        cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <32, 0, 32> }
        cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <40, 0, 32> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 9.6, 44> } }
    }
  #end
#end
#macro h_hrblock2_2(color_tex)
  #if (setting = 0)
    difference {
      cylinder { 0*y, 9.5*y, 15.8 translate <-4, 0, -4> }
      cylinder { -1*y, 10*y, 8 translate <-4, 0, -4> }
      box { <-20, -1, -20> <20, 10, -3.9> }
      box { <-20, -1, -20> <-3.9, 10, 20> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 9.5*y, 15.8 translate <-4, 0, -4> }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
        #else
          object { rounded_button() rotate 90*y translate <0, 6.4, 8> }
          object { rounded_button() rotate 180*y translate <8, 6.4, 0> }
        #end
      }
      box { <-20, -1, -20> <20, 10, -3.9> }
      box { <-20, -1, -20> <-3.9, 10, 20> }
      difference {
        cylinder { -1*y, 8.6*y, 14.8 }
        cylinder { -2*y, 10*y, 10 }
        box { <-20, -1, -20> <20, 10, 1.6> }
        box { <-20, -1, -20> <1.6, 10, 20> }
        translate <-4, 0, -4>
      }
      #if (setting > 1)
        box { <-2.4, -1, -4> <2.4, 2, 4> rotate 45*y translate <7, 0, 7> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
      #end
      cylinder { -1*y, 10*y, 8 translate <-4, 0, -4> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 12> } }
    }
  #end
#end
#macro h_one_glass(color_tex)
  #if (setting = 0)
    box { <-2.3, -3.2, -2.4> <26.3, 46.3, -0.9> texture { color_tex } }
  #else
    merge {
      box { <-2.3, 3.2, -2.4> <26.3, 46.3, -0.9> }
      sphere { <4, 3.2, -1.65> 0.75 }
      sphere { <20, 3.2, -1.65> 0.75 }
      sphere { <4, 46.3, -1.65> 0.75 }
      sphere { <20, 46.3, -1.65> 0.75 }
      texture { color_tex }
    }
  #end
#end
#macro h_one_window(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 47.9, 3.9> }
      box { <-1.5, 4.3, -4> <25.5, 45.5, 4> }
      texture { color_tex }
    }
  #else
    merge {
      object { rounded_button() rotate 180*y translate <0, 44.8, 0> }
      object { rounded_button() rotate 180*y translate <8, 44.8, 0> }
      object { rounded_button() rotate 180*y translate <16, 44.8, 0> }
      object { rounded_button() rotate 180*y translate <24, 44.8, 0> }
      difference {
        box { <-3.9, 0, -3.9> <27.9, 47.9, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          cylinder { 0*y, 50*y, 0.8 translate <4, 0, -1.6> }
          cylinder { 0*y, 50*y, 0.8 translate <20, 0, -1.6> }
        #end
        box { <-2.4, 3.1, -2.4> <26.4, 46.4, 4> }
        box { <-1.5, 4.3, -4> <25.5, 45.5, 3> }
      }
      #if (setting > 1)
        difference {
          box { <-4, 0.25, -4> <4, 2.1, 4> rotate 45*y }
          box { <-1.6, 0, -10> <1.6, 3, 10> }
          box { <-10, -1, -1> <40, 3, 20> }
          translate <4, 0, 4.5>
        }
        difference {
          box { <-4, 0.25, -4> <4, 2.1, 4> rotate 45*y }
          box { <-1.6, 0, -10> <1.6, 3, 10> }
          box { <-10, -1, -1> <40, 3, 20> }
          translate <20, 0, 4.5>
        }
        object { pin(2) translate <12, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 49.7, 4> } }
    }
  #end
#end
#macro h_opentwo_block3_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 19.9> }
      box { <-10, -1, -20> <30, 20, 0> rotate 45*y translate <-3.9, 0, 11.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <19.9, 9.5, 19.9> }
            box { <3.9, -1, 11.899999> <20, 10, 20> }
            box { <11.9, -1, 3.9> <20, 10, 20> }
            #if (setting > 1)
              box { <-2.5, -1, -2.5> <2.5, 2, 1.2> rotate 45*y translate <8, 0, 0> }
              box { <-2.5, -1, -2.5> <2.5, 2, 1.2> rotate 45*y translate <0, 0, 8> }
            #end
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
          #else
            object { rounded_button() translate <0, 6.4, 16> }
            object { rounded_button() translate <8, 6.4, 8> }
            object { rounded_button() translate <16, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <18.4, 8.6, 18.4> }
            box { <-10, -20, -20> <30, 1, 0> rotate 45*y translate <-2.4, 17.9, 11.9> }
            box { <2.4, 0.000002, 10.4> <3.900001, 10, 20> }
            box { <2.400001, 0.000001, 10.400001> <11.9, 20, 11.9> }
            box { <10.4, 0.000003, 2.4> <11.900001, 10, 11.900001> }
            box { <10.4000001, 0.000004, 10.400001> <20, 10, 2.400001> }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
        #end
        box { <-10, -1, -20> <30, 20, 0> rotate 45*y translate <-3.9, 0, 11.9> }
      }
      box { <-3, 0.25, 12.6> <3, 8.7, 13.6> }
      box { <12.6, 0.25, -3> <13.6, 8.7, 3> }
      box { <4, 0.25, 5> <5, 8.7, 11> }
      box { <5, 0.25, 4> <11, 8.7, 5> }
      box { <4.5, 0.250001, 7.5> <5.6, 8.7, 8.5> }
      box { <7.5, 0.250001, 4.5> <8.5, 8.7, 5.6> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 20> } }
    }
  #end
#end
#macro h_post1_1(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.9, 47.9, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <3.9, 47.9, 3.9> }
        object { open_rounded_button() translate <0, 44.8, 0> }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 47, 2.4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 49.7, 4> } }
    }
  #end
#end
#macro h_post1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 47.9, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 47.9, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 47, 2.4> }
          cylinder { -1*y, 48*y, 1.600001 }
          cylinder { -1*y, 48*y, 1.600001 translate <8, 0, 0> }
        #end
      }
      difference {
        box { <5.5, 0.25, -2.5> <7, 47.5, 2.5> }
        box { <0, -1, 0> <3, 48, 4> rotate 45*y translate <4.5, 0, 0> }
      }
      object { open_rounded_button() translate <0, 44.8, 0> }
      object { open_rounded_button() translate <8, 44.8, 0> }
      #if (setting > 1)
        difference {
          box { <1, 0.25, -2.5> <2.5, 47.5, 2.5> }
          box { <-3, -1, 0> <0, 48, 4> rotate -45*y translate <3.5, 0, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 49.7, 4> } }
    }
  #end
#end
#macro h_post1_3(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <19.9, 47.9, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <19.9, 47.9, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <18.4, 47, 2.4> }
          cylinder { -1*y, 48*y, 1.600001 }
          cylinder { -1*y, 48*y, 1.600001 translate <8, 0, 0> }
          cylinder { -1*y, 48*y, 1.600001 translate <16, 0, 0> }
        #end
      }
      object { open_rounded_button() translate <0, 44.8, 0> }
      object { open_rounded_button() translate <8, 44.8, 0> }
      object { open_rounded_button() translate <16, 44.8, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 49.7, 4> } }
    }
  #end
#end
#macro h_post1_6(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 47.9, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <43.9, 47.9, 3.9> }
        object { open_rounded_button() translate <0, 44.8, 0> }
        object { open_rounded_button() translate <8, 44.8, 0> }
        object { open_rounded_button() translate <16, 44.8, 0> }
        object { open_rounded_button() translate <24, 44.8, 0> }
        object { open_rounded_button() translate <32, 44.8, 0> }
        object { open_rounded_button() translate <40, 44.8, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <8, 47.9, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <24, 47.9, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <40, 47.9, 0> }
        #end
      }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <42.4, 47, 2.4> }
          box { <10.2, -2, -2.5> <11.1, 48, 2.5> }
          box { <28.9, -2, -2.5> <29.8, 48, 2.5> }
        }
        cylinder { -1*y, 48*y, 1.600001 }
        cylinder { -1*y, 48*y, 1.600001 translate <16, 0, 0> }
        cylinder { -1*y, 48*y, 1.600001 translate <32, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 49.7, 4> } }
    }
  #end
#end
#macro h_side1_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 28.7, 3.9> }
      box { <-4, 3.1, -2.6> <12, 27.5, 5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 28.7, 3.9> }
          object { open_rounded_button() translate <0, 25.6, 0> }
          object { open_rounded_button() translate <8, 25.6, 0> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <0, 28.7, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <8, 28.7, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
        #end
        box { <-4, 3.1, -2.6> <12, 27.5, 5> }
      }
      #if (setting > 1)
         object { pin(2) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 30.5, 4> } }
    }
  #end
#end
#macro h_side1_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 28.7, 3.9> }
      box { <-4, 3.1, -2.6> <28, 27.5, 5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 28.7, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          sphere { <-1.25, 15, -2.5> 0.5 }
          sphere { <25.25, 15, -2.5> 0.5 }
        #end
        box { <-4, 3.1, -2.6> <28, 27.5, 5> }
      }
      cylinder { 26.5*y, 27.6*y, 0.5 translate <0, 0, 3> }
      box { <-0.5, 26.500001, -2.6> <0.5, 27.6, 3.000001> }
      cylinder { 26.5*y, 27.6*y, 0.5 translate <24, 0, 3> }
      box { <23.5, 26.500001, -2.6> <24.5, 27.6, 3.000001> }
      object { open_rounded_button() translate <0, 25.6, 0> }
      object { open_rounded_button() translate <8, 25.6, 0> }
      object { open_rounded_button() translate <16, 25.6, 0> }
      object { open_rounded_button() translate <24, 25.6, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <0, 28.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <8, 28.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <16, 28.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <24, 28.7, 0> }
      #end
      #if (setting > 1)
         object { pin(2) translate <4, 0, 0> }
         object { pin(2) translate <12, 0, 0> }
         object { pin(2) translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -8> <28, 30.5, 4> } }
    }
  #end
#end
#macro h_sideleft3_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 11.9> }
      box { <-30, -1, 0> <30, 10, 20> rotate 18.4*y translate <8, 0, 8> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 9.5, 11.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
          #else
            object { rounded_button() rotate 180*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <16, 6.4, 0> }
          #end
        }
        box { <-30, -1, 0> <30, 10, 20> rotate 18.4*y translate <8, 0, 8> }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          difference {
            box { <-2.4, -1, -2.4> <18.4, 8.6, 12> }
            box { <-30, -1, 0> <30, 10, 20> rotate 18.4*y translate <8, 0, 6.7> }
            box { <-5, -2, 2.5> <17, 9, 3.5> }
            difference {
              box { <16.749999, -2, 2.499999> <18, 9, 3.999999> }
              cylinder { -3*y, 10*y, 1 translate <18, 0, 2.5> }
            }
          }
          box { <-2.5, -1, -2> <2.5, 2, 5> rotate 18.4*y translate <8, 0, 8> }
          box { <-1.1, -1, -2> <2.5, 2, 3> rotate 18.4*y translate <0, 0, 8> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
        cylinder { 0*y, 8.7*y, 1.5 translate <12, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 12> } }
    }
  #end
#end
#macro h_sideright3_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 11.9> }
      box { <-30, -1, -20> <30, 10, 0> rotate -18.4*y translate <8, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 9.5, 11.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
          #else
            object { rounded_button() translate <0, 6.4, 8> }
            object { rounded_button() translate <8, 6.4, 8> }
            object { rounded_button() translate <16, 6.4, 8> }
          #end
        }
        box { <-30, -1, -20> <30, 10, 0> rotate -18.4*y translate <8, 0, 0> }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          difference {
            box { <-2.4, -1, -4> <18.4, 8.6, 10.4> }
            box { <-30, -1, -20> <30, 10, 0> rotate -18.4*y translate <8, 0, 1.3> }
            box { <-5, -2, 4.5> <17, 9, 5.5> }
            difference {
              box { <16.749999, -2, 3.999999> <18, 9, 5.499999> }
              cylinder { -3*y, 10*y, 1 translate <18, 0, 5.5> }
            }
          }
          box { <-2.5, -1, -5> <2.5, 2, 2> rotate -18.4*y translate <8, 0, 0> }
          box { <-1.1, -1, -5> <2.5, 2, 2> rotate -18.4*y }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 8> }
        cylinder { 0*y, 8.7*y, 1.5 translate <12, 0, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 12> } }
    }
  #end
#end
#macro h_sideleft4_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> }
      box { <0, -1, 0> <40, 10, 20> rotate 15*y translate <-3.9, 0, 11.7> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 9.5, 11.7> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
          #else
            object { rounded_button() rotate 180*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <16, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <24, 6.4, 0> }
          #end
        }
        box { <0, -1, 0> <40, 10, 20> rotate 15*y translate <-3.9, 0, 11.7> }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          difference {
            box { <-2.4, -1, -2.4> <26.4, 8.6, 12> }
            box { <0, -1, 0> <40, 10, 20> rotate 15*y translate <-3.9, 0, 10.2> }
          }
          box { <-1.9, -1, -1.5> <3, 2.000001, 3> rotate 15*y translate <0, 0, 8> }
          box { <-2.5, -1, -2> <2.5, 2.000002, 5> rotate 15*y translate <8, 0, 8> }
          box { <-2.5, -1, -4> <1.5, 2.000003, 5> rotate 15*y translate <16, 0, 8> }
          cylinder { -1*y, 9*y, 2.600001 translate <12, 0, 4> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { high_ring() translate <4, 0, 4> }
            object { high_ring() translate <12, 0.15, 4> }
            object { high_ring() translate <20, 0, 4> }
            box { <12.3, 2, -2.5> <13, 9, 1.5> }
          }
          box { <0, -1, 0> <40, 10, 20> rotate 15*y translate <-3.9, 0, 11.699995> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 11.8> } }
    }
  #end
#end
#macro h_sideright4_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> }
      box { <0, -1, -20> <40, 10, 0> rotate -15*y translate <-3.9, 0, -3.7> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 9.5, 11.7> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 8> }
          #else
            object { rounded_button() rotate 180*y translate <0, 6.4, 8> }
            object { rounded_button() rotate 180*y translate <8, 6.4, 8> }
            object { rounded_button() rotate 180*y translate <16, 6.4, 8> }
            object { rounded_button() rotate 180*y translate <24, 6.4, 8> }
          #end
        }
        box { <0, -1, -20> <40, 10, 0> rotate -15*y translate <-3.9, 0, -3.7> }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          difference {
            box { <-2.4, -1, -2.4> <26.4, 8.6, 10.4> }
            box { <0, -1, -20> <40, 10, 0> rotate -15*y translate <-3.9, 0, -2.2> }
          }
          box { <-1.9, -1, -3> <3, 2.000001, 1.5> rotate -15*y translate <0, 0, 0> }
          box { <-2.5, -1, -5> <2.5, 2.000002, 2> rotate -15*y translate <8, 0, 0> }
          box { <-2.5, -1, -5> <1.5, 2.000003, 4> rotate -15*y translate <16, 0, 0> }
          cylinder { -1*y, 3*y, 2.600001 translate <12, 0, 4> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { high_ring() translate <4, 0, 4> }
            object { high_ring() translate <12, 0.15, 4> }
            object { high_ring() translate <20, 0, 4> }
            box { <11.65, 2, 6.5> <12.35, 9, 10.5> }
          }
          box { <0, -1, -20> <40, 10, 0> rotate -15*y translate <-3.9, 0, -3.699995> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 11.8> } }
    }
  #end
#end
#macro h_single_wheelbase2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 5.2, -3.9> <11.9, 8.3, 11.9> }
      box { <0.5, -3, -0.75> <7.5, 7.4, 0.75> }
      box { <0.5, -3, 7.25> <7.5, 7.4, 8.75> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 5.2, -3.9> <11.9, 8.3, 11.9> }
        box { <-2.4, 5, -2.4> <10.4, 7.2, 10.4> }
      }
      difference {
        box { <0, -3, -0.75> <8, 7.4, 8.75> }
        box { <-1, -4, 0.75> <9, 10, 7.25> }
        cylinder { -1*z, 9*z, 0.85 translate <4, 0, 0> }
        box { <-5, -10, -1> <0, 2, 9> rotate 15.1*z translate <0.5, 4.2, 0> }
        box { <0, -10, -1> <5, 2, 9> rotate -15.1*z translate <7.5, 4.2, 0> }
        box { <-0.6, -10, -1> <0.6, 0, 9> rotate -10.1*z translate <4, 0, 0> }
        box { <-0.6, -10, -1> <0.6, 0, 9> rotate 10.1*z translate <4, 0, 0> }
        difference {
          box { <0, -4, -1> <8, 0, 9> }
          cylinder { -2*z, 10*z, 2.5 translate <4, 0.5, 0> }
        }
        difference {
          box { <2.9, -3, -1> <5.1, -1.4, 9> }
          cylinder { -1*z, 9*z, 0.4 translate <5.1, -1.4, 0> }
          cylinder { -1*z, 9*z, 0.4 translate <2.9, -1.4, 0> }
        }
      }
      object { open_rounded_button() translate <0, 5.3, 0> }
      object { open_rounded_button() translate <8, 5.3, 0> }
      object { open_rounded_button() translate <0, 5.3, 8> }
      object { open_rounded_button() translate <8, 5.3, 8> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 8.3, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 8.3, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 8.3, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 8.3, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -2.5, -4> <12, 10.2, 12> } }
    }
  #end
#end
#macro h_slide_holder1_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> }
      box { <-4, 3.2, -4> <28, 6.4, 0.1> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
        #end
        box { <-4, 3.2, -4> <28, 6.4, 0.1> }
        box { <-2.4, 7.4, -2.4> <26.4, 10, 2.4> }
        box { <-2.4, 3.200001, -1> <3.5, 6.399999, 2.4> }
        box { <4.5, 3.200001, -1> <11.5, 6.399999, 2.4> }
        box { <12.5, 3.200001, -1> <19.5, 6.399999, 2.4> }
        box { <20.5, 3.200001, -1> <26.4, 6.399999, 2.4> }
      }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 7.4, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 7.4, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 7.4, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 7.4, 0> }
      #end
      object { open_rounded_button() translate <0, 6.4, 0> }
      object { open_rounded_button() translate <8, 6.4, 0> }
      object { open_rounded_button() translate <16, 6.4, 0> }
      object { open_rounded_button() translate <24, 6.4, 0> }
      difference {
        cylinder { 7.3*y, 9.400001*y, 2.400001 }
        cylinder { 7*y, 12*y, 1.600001 }
      }
      difference {
        cylinder { 7.3*y, 9.400001*y, 2.400001 }
        cylinder { 7*y, 12*y, 1.600001 }
        translate <8, 0, 0>
      }
      difference {
        cylinder { 7.3*y, 9.400001*y, 2.400001 }
        cylinder { 7*y, 12*y, 1.600001 }
        translate <16, 0, 0>
      }
      difference {
        cylinder { 7.3*y, 9.400001*y, 2.400001 }
        cylinder { 7*y, 12*y, 1.600001 }
        translate <24, 0, 0>
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 4> } }
    }
  #end
#end
#macro h_slope1_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 47.9, 3.9> }
      box { <-50, 0, -5> <0, 75, 5> rotate -34.65*z translate <-3.9, 1.6, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <43.9, 47.9, 3.9> }
        object { open_rounded_button() translate <32, 44.8, 0> }
        object { open_rounded_button() translate <40, 44.8, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <32, 47.9, 0> }
        #end
      }
      box { <-50, 0, -5> <0, 75, 5> rotate -34.65*z translate <-3.9, 1.6, 0> }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <42.4, 47, 2.4> }
          box { <10.2, -2, -2.5> <11.1, 48, 2.5> }
          box { <-50, 0, -5> <0, 75, 5> rotate -34.65*z translate <-3.9, 0.6, 0> }
        }
        cylinder { -1*y, 50*y, 1.600001 translate <40, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 49.7, 4> } }
    }
  #end
#end
#macro h_slope2_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          difference {
//            box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
            box { <-4, 0, -4> <12, 9.5, 12> }
            difference {
              box { <-4, 0, -4> <4, 10, 4> }
              box { <-20, -20, -10> <20, 0, 20> texture { color_tex normal { bumping } }
                rotate 43.5*z translate <4, 9.5, 0> }
              box { <-20, -20, -10> <20, 0, 20> texture { color_tex normal { bumping } }
                rotate 43.5*z rotate -90*y translate <0, 9.5, 4> }
            }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
          #else
            object { rounded_button() rotate -90*y translate <8, 6.4, 0> }
            object { rounded_button() rotate -90*y translate <8, 6.4, 8> }
            object { rounded_button() rotate -90*y translate <0, 6.4, 8> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 8.6, 10.4> }
            difference {
              box { <-4, 0, -4> <4, 10, 4> }
              box { <-20, -20, -10> <20, 0, 20> rotate 43.5*z translate <4, 7.5, 0> }
              box { <-20, -20, -10> <20, 0, 20> rotate 43.5*z rotate -90*y translate <0, 7.5, 4> }
            }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
        #end
      }
      difference {
        object { high_ring() translate <4, 0, 4> }
        difference {
          box { <-4, 0, -4> <4, 10, 4> }
          box { <-20, -20, -10> <20, 0, 20> rotate 43.5*z translate <4, 7.5, 0> }
          box { <-20, -20, -10> <20, 0, 20> rotate 43.5*z rotate -90*y translate <0, 7.5, 4> }
        }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 12> } }
    }
  #end
#end
#macro h_support2_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 57.5, 19.9> }
      box { <-4, 3.1, -4> <12, 58, 4.1> }
      box { <-4, -20, -20> <12, 20, 0> rotate 43.5*x translate <0, 57.5, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 57.5, 19.9> }
            box { <-4, 3.1, -4> <12, 58, 4.1> }
            box { <-4, 54.3, 11.9> <12, 58, 20> }
            box { <-4, -20, -20> <12, 20, 0> rotate 43.5*x translate <0, 57.5, 12> }
            cylinder { -4*x, 12*x, 4.5 translate <0, 46.7, 11.5> }
            box { <-4, -1, 7.000001> <12, 46.700001, 20> }
            box { <-4, 46.7, 11.999999> <12, 51.200001, 20> }
            difference {
              box { <-2.4, -1, 5.6> <10.4, 57, 12> }
              box { <-5, 54.299999, 11.899995> <13, 59, 20> }
              box { <-4, -20, -20> <12, 20, 0> rotate 43.5*x translate <0, 55.5, 12> }
            }
          }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 54.2*y, 56*y, 2.4 translate <0, 0, 16> }
            cylinder { 54.2*y, 56*y, 2.4 translate <8, 0, 16> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
            object { rounded_button() rotate 90*y translate <0, 51.2, 16> }
            object { rounded_button() rotate 90*y translate <8, 51.2, 16> }
          #end
        }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 50*y, 55.2*y, 1.2 translate <0, 0, 16> }
          cylinder { 50*y, 55.2*y, 1.2 translate <8, 0, 16> }
          box { <-2.4, -1, -2.4> <10.4, 2, 4> }
          box { <-2.4, 45, 13.6> <10.4, 53.1, 18.4> }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(1) translate <4, 51.2, 16> }
        box { <-0.5, 0.000001, 2.4> <0.5, 2.1, 4.1> }
        box { <7.5, 0.000001, 2.4> <8.5, 2.1, 4.1> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 57.6, 20> } }
    }
  #end
#end
#macro h_swivel1block1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <0.1, 0, -7.9> <15.9, 9.5, -0.1> }
      cylinder { -0.000001*y, 6.3*y, 3.25 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { -0.000001*y, 6.3*y, 3.25 }
          box { <0.1, 0, -7.9> <15.9, 9.5, -0.1> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <4, 0, -4> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <12, 0, -4> }
          #else
            object { rounded_button() translate <4, 6.4, -4> }
            object { rounded_button() translate <12, 6.4, -4> }
          #end
        }
        cylinder { 6.300001*y, 10*y, 3.250001 }
        cylinder { -1*y, 7*y, 2.4 }
        #if (setting > 1)
          difference {
            box { <1.6, -1, -6.4> <14.4, 8.6, -1.6> }
            cylinder { -1*y, 10*y, 3.250005 }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <4, 0, -4> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <12, 0, -4> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <8, 0, -4> }
      #end
      texture { color_tex }
      bounded_by { box { <-3.35, -0.1, -8> <16, 11.3, 3.35> } }
    }
  #end
#end
#macro h_swivel2block1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <0.1, 0, 0.1> <15.9, 9.5, 7.9> }
      cylinder { 6.4*y, 9.500001*y, 3.25 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { 6.4*y, 9.500001*y, 3.25 }
          box { <0.1, 0, 0.1> <15.9, 9.5, 7.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <4, 0, 4> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <12, 0, 4> }
          #else
            object { rounded_button() rotate 180*y translate <4, 6.4, 4> }
            object { rounded_button() rotate 180*y translate <12, 6.4, 4> }
          #end
        }
        cylinder { -1*y, 6.399999*y, 3.350001 }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <4, 0, 4> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <12, 0, 4> }
          box { <1.6, -1, 1.6> <14.4, 8.6, 6.4> }
        #end
      }
      difference {
        merge {
          cylinder { 0*y, 6.5*y, 2.25 }
          cylinder { -0.000001*y, 0.9*y, 2.5 }
        }
        box { <-2.75, -1, -0.5> <2.75, 3, 0.5> rotate -45*y }
        cylinder { -2.75*x, 2.75*x, 0.500001 rotate -45*y translate <0, 2.999999, 0> }
        cylinder { -1*y, 6*y, 1.6 }
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <8, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-3.35, -0.1, -3.35> <16, 11.3, 8> } }
    }
  #end
#end
#macro h_three_glass(color_tex)
  box { <-2.3, 3.2, -2.4> <26.3, 55.9, -0.9> texture { color_tex } }
#end
#macro h_three_window(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 57.5, 3.9> }
      box { <-1.6, 4.5, -4> <25.6, 54.9, 4> }
      texture { color_tex }
    }
  #else
    merge {
      object { open_rounded_button() translate <0, 54.4, 0> }
      object { open_rounded_button() translate <8, 54.4, 0> }
      object { open_rounded_button() translate <16, 54.4, 0> }
      object { open_rounded_button() translate <24, 54.4, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <0, 57.5, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <8, 57.5, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <16, 57.5, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <24, 57.5, 0> }
      #end
      difference {
        box { <-3.9, 0, -3.9> <27.9, 57.5, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
        #end
        box { <-2.4, 3.1, -2.4> <26.4, 56, 4> }
        box { <-1.6, 4.5, -4> <25.6, 19.7, 3> }
        box { <-1.6, 22.1, -4> <25.6, 37.3, 3> }
        box { <-1.6, 39.7, -4> <25.6, 54.9, 3> }
      }
      object { pin(2) translate <4, 0, 0> }
      object { pin(2) translate <12, 0, 0> }
      object { pin(2) translate <20, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 59.3, 4> } }
    }
  #end
#end
#macro h_triangle2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
      box { <3.9, -1, -5> <13, 10, 3.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() rotate 90*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <0, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 8> }
          #end
          difference {
            box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
            box { <3.9, -1, -5> <13, 10, 3.9> }
          }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 8.6, 10.4> }
          box { <2, -1, 5.6> <10.4, 8.600001, 10.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        box { <-3, 0.1, -0.6> <0, 8.7, 0.6> rotate 45*y translate <4, 0, 4> }
        object { pin(1) scale <1, 4.142857, 1> translate <0, 0, 4> }
        object { pin(1) scale <1, 4.142857, 1> translate <4, 0, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 12> } }
    }
  #end
#end
#macro h_wheelbase2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 10, -3.9> <11.9, 11.4, 11.9> }
      box { <-3.9, 0, 3.25> <5, 10, 4.75> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -1.9*z, 9.9*z, 1.5 translate <-2.5, 0, 0> }
        cylinder { 9.999991*z, 9.4*z, 1.75 translate <-2.5, 0, 0> }
        cylinder { -1.999991*z, -1.4*z, 1.75 translate <-2.5, 0, 0> }
        cylinder { 3*z, 5*z, 2.5 translate <-2.5, 0, 0> }
        difference {
          box { <-3.9, 0, 3.25> <5, 10, 4.75> }
          box { <0, -20, -10> <20, 20, 10> rotate -22.5*z }
        }
        box { <-3.9, 9.999999, -3.9> <11.9, 11.4, 11.9> }
        object { open_rounded_button() translate <0, 8.3, 0> }
        object { open_rounded_button() translate <8, 8.3, 0> }
        object { open_rounded_button() translate <0, 8.3, 8> }
        object { open_rounded_button() translate <8, 8.3, 8> }
        #if (setting > 3)
          object { llogo() rotate 180*y scale <0.65, 0.65, 0.65> translate <0, 11.4, 0> }
          object { llogo() rotate 180*y scale <0.65, 0.65, 0.65> translate <0, 11.4, 8> }
          object { llogo() rotate 180*y scale <0.65, 0.65, 0.65> translate <8, 11.4, 0> }
          object { llogo() rotate 180*y scale <0.65, 0.65, 0.65> translate <8, 11.4, 8> }
        #end
      }
      box { <-5, -0.4, -3> <0, 0.4, 0.600001> }
      box { <-5, -0.4, 7.399999> <0, 0.4, 11> }
      cylinder { -3*x, 3*x, 0.4 translate <-2.5, 0, 7.4> }
      cylinder { -3*x, 3*x, 0.4 translate <-2.5, 0, 0.6> }
      texture { color_tex }
      bounded_by { box { <-5.1, -2.6, -4> <12, 13.2, 12> } }
    }
  #end
#end
#macro h_window1_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 19.1, 3.9> }
      box { <-1, 6.5, -4> <9, 17.6, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 19.1, 3.9> }
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 }
            cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 180*y translate <0, 16, 0> }
            object { rounded_button() rotate 180*y translate <8, 16, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { -1*y, 3.100001*y, 0.85 translate <1.5, 0, -1.7> }
          cylinder { -1*y, 3.100001*y, 0.85 translate <6.5, 0, -1.7> }
        #end
        cylinder { -5*z, 0*z, 1.5 translate <0.5, 8, 0> }
        cylinder { -5*z, 0*z, 1.5 translate <7.5, 8, 0> }
        cylinder { -5*z, 0*z, 1.5 translate <0.5, 16.1, 0> }
        cylinder { -5*z, 0*z, 1.5 translate <7.5, 16.1, 0> }
        box { <0.499999, 6.499999, -5> <7.500001, 17.600001, 0> }
        box { <-1.000001, 7.999998, -5> <9.000001, 16.100002, 0> }
        box { <-3, 3.1, -2.4> <11, 18.600001, 0> }
        box { <-4, 3.100001, -1> <12, 18.6, 5> }
        cylinder { 18.599999*y, 20*y, 0.85 translate <4, 0, -1.7> }
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 20.9, 4> } }
    }
  #end
#end
#macro h_window1_4(color_tex, age)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 28.7, 3.9> }
      box { <0, 3.1, -4> <24, 25.5, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 28.7, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
        #end
        box { <-2.4, 3.1, -2.4> <26.4, 27.2, 4> }
        cylinder { -4*z, 2*z, 1.5 translate <1.5, 4.7, 0> }
        cylinder { -4*z, 2*z, 1.5 translate <1.5, 24, 0> }
        cylinder { -4*z, 2*z, 1.5 translate <22.5, 4.7, 0> }
        cylinder { -4*z, 2*z, 1.5 translate <22.5, 24, 0> }
        box { <-0.000001, 4.399999, -4> <24.000001, 24.000001, 2> }
        box { <1.499999, 3.100001, -4> <22.500001, 25.500001, 2> }
        cylinder { -1*y, 28*y, 0.75 translate <-1.25, 0, 2.5> }
        cylinder { -1*y, 28*y, 0.75 translate <25.25, 0, 2.5> }
        cylinder { -2.8*x, 26.8*x, 0.75 translate <0, 13.5, -1.5> }
      }
      object { rounded_button() rotate 90*y translate <0, 25.6, 0> }
      object { open_rounded_button() translate <8, 25.6, 0> }
      object { open_rounded_button() translate <16, 25.6, 0> }
      object { rounded_button() rotate 90*y translate <24, 25.6, 0> }
      #if (setting > 3 )
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 28.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 28.7, 0> }
      #end
      #if (age = 1 & setting > 1)
        object { pin(1) translate <4, 0, 0> }
        object { pin(1) translate <12, 0, 0> }
        object { pin(1) translate <20, 0, 0> }
      #end
      #if (age = 2 & setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 30.5, 4> } }
    }
  #end
#end
#macro h_windowglass1_4(color_tex)
  #if (setting = 0)
    box { <-2.3, 3.2, -2.3> <26.3, 27.1, -0.8> texture { color_tex } }
  #else
    merge {
      box { <-2.3, 3.2, -2.3> <26.3, 27.1, -0.8> }
      sphere { <-2.3, 13.5, -1.55> 0.75 }
      sphere { <26.3, 13.5, -1.55> 0.75 }
      texture { color_tex }
    }
  #end
#end
#macro h_wing4_8(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 31.9, 27.9> }
      box { <-4, 3.1, -4> <4, 33, 28> }
      box { <44, -1, -4> <60, 28.8, 28> }
      box { <-4, -1, -4> <4.000001, 30, 4> }
      box { <-41, -1, -50> <0, 40, 0> rotate 11.25*y translate <44, 0, -4> }
      box { <-4, -1, 20> <4.000001, 30, 28> }
      box { <-41, -1, 0> <0, 40, 50> rotate -11.25*y translate <44, 0, 28> }
      box { <0, 0, -4> <50, 50, 28> rotate 35.8*z translate <4, 3.1, 0> }
      box { <-50, -50, -4> <0, 0, 28> rotate 35.8*z translate <44.000001, 28.8, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <59.9, 31.9, 27.9> }
            box { <-4, 3.1, -4> <4, 33, 28> }
            box { <4, 19.1, 3.9> <36.1, 30, 20.1> }
          }
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 19*y, 20.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <48, 0, 0> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <48, 0, 8> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <48, 0, 16> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <48, 0, 24> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <56, 0, 0> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <56, 0, 8> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <56, 0, 16> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <56, 0, 24> }
          #else
            object { open_rounded_button() translate <32, 16, 8> }
            object { open_rounded_button() translate <32, 16, 16> }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <0, 0, 16> }
            object { rounded_button() rotate 180*y translate <48, 28.8, 0> }
            object { rounded_button() rotate 180*y translate <48, 28.8, 8> }
            object { rounded_button() rotate 180*y translate <48, 28.8, 16> }
            object { rounded_button() rotate 180*y translate <48, 28.8, 24> }
            object { rounded_button() rotate 180*y translate <56, 28.8, 0> }
            object { rounded_button() rotate 180*y translate <56, 28.8, 8> }
            object { rounded_button() rotate 180*y translate <56, 28.8, 16> }
            object { rounded_button() rotate 180*y translate <56, 28.8, 24> }
          #end
        }
        box { <44, -1, -4> <60, 28.8, 28> }
        box { <-4, -1, -4> <4.000001, 30, 4> }
        box { <-41, -1, -50> <0, 40, 0> rotate 11.25*y translate <44, 0, -4> }
        box { <-4, -1, 20> <4.000001, 30, 28> }
        box { <-41, -1, 0> <0, 40, 50> rotate -11.25*y translate <44, 0, 28> }
        box { <0, 0, -4> <50, 50, 28> rotate 35.8*z translate <4, 3.1, 0> }
        difference {
          box { <-50, -50, -4> <0, 0, 28> rotate 35.8*z translate <44.000001, 28.8, 0> }
          box { <4, 18.2, 3> <37, 30, 21> }
        }
        difference {
          box { <-50, -50, -4> <0, 0, 28> rotate 35.8*z translate <44.000001, 31, 0> }
          box { <4.000001, 18.200001, 3.000001> <37.000001, 40, 21.000001> }
          box { <-61, -1, -50> <60, 40, 0> rotate 11.25*y translate <44, 0, -2.7> }
          box { <-61, -1, 0> <60, 40, 50> rotate -11.25*y translate <44, 0, 26.7> }
          box { <44.1, -1, -4> <60, 40, 28> }
        }
        #if (setting > 1)
          box { <45.6, 25, -2.4> <58.4, 30.8, 26.4> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 29.8*y, 32.8*y, 1.2 translate <48, 0, 0> }
          cylinder { 29.8*y, 32.8*y, 1.2 translate <48, 0, 8> }
          cylinder { 29.8*y, 32.8*y, 1.2 translate <48, 0, 16> }
          cylinder { 29.8*y, 32.8*y, 1.2 translate <48, 0, 24> }
          cylinder { 29.8*y, 32.8*y, 1.2 translate <56, 0, 0> }
          cylinder { 29.8*y, 32.8*y, 1.2 translate <56, 0, 8> }
          cylinder { 29.8*y, 32.8*y, 1.2 translate <56, 0, 16> }
          cylinder { 29.8*y, 32.8*y, 1.2 translate <56, 0, 24> }
          box { <-2.4, -1, 5.6> <2.4, 2, 18.4> }
          cylinder { -1*y, 30*y, 1.600001 translate <32, 0, 8> }
          cylinder { -1*y, 30*y, 1.600001 translate <32, 0, 16> }
        #end
      }
      #if (setting > 1)
        difference {
          box { <28.1, 16, 4.1> <35.9, 18, 19.9> }
          box { <29.6, 14, 5.6> <34.4, 19, 18.4> }
        }
        object { ring() translate <52, 28.8, 4> }
        object { ring() translate <52, 28.8, 12> }
        object { ring() translate <52, 28.8, 20> }
        object { pin(2) translate <0, 0, 12> }
        object { pin(2) translate <32, 16, 12> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 33.7, 28> } }
    }
  #end
#end
#macro h_winglet3_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 19.9> }
      box { <30, -10, -50> <-30, 10, 0> rotate 45*y translate <11.9, 0, -3.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 9.5, 19.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
          #else
            object { rounded_button() rotate 180*y translate <16, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <8, 6.4, 8> }
            object { rounded_button() rotate 180*y translate <16, 6.4, 8> }
            object { rounded_button() rotate 180*y translate <0, 6.4, 16> }
            object { rounded_button() rotate 180*y translate <8, 6.4, 16> }
            object { rounded_button() rotate 180*y translate <16, 6.4, 16> }
          #end
        }
        box { <30, -10, -50> <-30, 10, 0> rotate 45*y translate <11.9, 0, -3.9> }
        box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate 45*y translate <0, 0, 8> }
        box { <-2.5, -1, -2> <2.5, 2.000001, 2> rotate 45*y translate <8, 0, 0> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <18.4, 8.6, 18.4> }
            box { <30, -10, -50> <-30, 10, 0> rotate 45*y translate <12.9, 0, -2.9> }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
        #end
      }
      #if (setting > 1)
        object { high_ring() translate <4, 0, 12> }
        object { high_ring() translate <12, 0, 4> }
        object { high_ring() translate <12, 0, 12> }
        box { <0.1, 2.000003, -0.5> <3, 8.7, 0.5> rotate -45*y translate <0, 0, 8> }
        box { <0.1, 2.000003, -0.5> <3, 8.7, 0.5> rotate -45*y translate <8, 0, 0> }
        box { <0.1, 0.25, -0.5> <3, 8.7, 0.5> rotate -45*y translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 20> } }
    }
  #end
#end
#macro h_winglet4_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <23.9, 9.5, 27.9> }
      box { <-20, -10, -10> <30, 10, 0> rotate -18.4*y translate <4, 0, -4> }
      box { <-20, -10, 0> <30, 10, 10> rotate 18.4*y translate <4, 0, 28> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <23.9, 9.5, 27.9> }
            box { <-20, -10, -10> <30, 10, 0> rotate -18.4*y translate <4, 0, -4> }
            box { <-20, -10, 0> <30, 10, 10> rotate 18.4*y translate <4, 0, 28> }
            box { <-5, -1, 3.900001> <4.1, 10, 20.100001> }
            box { <19.9, -1, 3.900002> <24, 10, 20.100002> }
            box { <-4, 6.3, 3.9> <24, 10, 20.1> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 24> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 8> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 16> }
            cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, 8> }
            cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, 16> }
          #else
            object { rounded_button() rotate 180*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <0, 6.4, 24> }
            object { rounded_button() rotate 180*y translate <8, 3.2, 8> }
            object { rounded_button() rotate 180*y translate <8, 3.2, 16> }
            object { rounded_button() rotate 180*y translate <16, 3.2, 8> }
            object { rounded_button() rotate 180*y translate <16, 3.2, 16> }
          #end
        }
        #if (setting > 1)
          box { <5.6, -1, 4> <18.4, 5.2, 20> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 8> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <16, 0, 8> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <16, 0, 16> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 16> }
          box { <-2.4, -1, -2.4> <4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          box { <-2.4, -1, 21.6> <4, 8.6, 26.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 24> }
          difference {
            box { <5.5, -1, -2.4> <22, 8.6, 3> }
            box { <-20, -10, -10> <30, 10, 0> rotate -18.4*y translate <16, 0, 1.3> }
          }
          difference {
            box { <5.5, -1, 21> <22, 8.6, 26.4> }
            box { <-20, -10, 0> <30, 10, 10> rotate 18.4*y translate <16, 0, 22.7> }
          }
        #end
      }
      #if (setting > 1)
        object { ring() scale <1, 3, 1> translate <12, 0, 12> }
        box { <2.4, 0.100001, -0.5> <4.5, 8.7, 0.5> }
        box { <2.4, 0.100001, 23.5> <4.5, 8.7, 24.5> }
        box { <7.5, 0.100001, 3.7> <8.5, 5.6, 5.5> }
        box { <15.5, 0.100001, 3.7> <16.5, 5.6, 5.5> }
        box { <7.5, 0.100001, 18.5> <8.5, 5.6, 20.3> }
        box { <15.5, 0.100001, 18.5> <16.5, 5.6, 20.3> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <24, 11.3, 28> } }
    }
  #end
#end
#macro idslope1_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-11.9, 0, -3.9> <11.9, 9.5, 3.9> }
      box { <-20, -10, -10> <20, 0, 10> rotate 46*z translate <4, 0, 0> }
      box { <-20, -10, -10> <20, 0, 10> rotate -46*z translate <-4, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-11.9, 0, -3.9> <11.9, 9.5, 3.9> }
            box { <-20, -10, -10> <20, 0, 10> texture { color_tex normal { bumping } }
              rotate 46*z translate <4, 0, 0> }
            box { <-20, -10, -10> <20, 0, 10> texture { color_tex normal { bumping } }
              rotate -46*z translate <-4, 0, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
          #else
            object { rounded_button() rotate 90*y translate <0, 6.4, 0> }
          #end
        }
        difference {
          box { <4, 1, -3.1> <10.4, 10, 3.1> }
          box { <-20, -10, -10> <20, 0, 10> rotate 46*z translate <4, 2, 0> }
        }
        difference {
          box { <-10.4, 1, -3.1> <-4, 10, 3.1> }
          box { <-20, -10, -10> <20, 0, 10> rotate -46*z translate <-4, 2, 0> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
        #end
      }
      difference {
        difference {
          cylinder { 3*y, 11.2*y, 2.4 }
          cylinder { 2*y, 12*y, 1.6 }
          translate <8, 0, 0>
        }
        box { <-20, -10, -10> <20, 0, 10> rotate 46*z translate <4, 2, 0> }
      }
      difference {
        difference {
          cylinder { 3*y, 11.2*y, 2.4 }
          cylinder { 2*y, 12*y, 1.6 }
          translate <-8, 0, 0>
        }
        box { <-20, -10, -10> <20, 0, 10> rotate -46*z translate <-4, 2, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <12, 11.3, 4> } }
    }
  #end
#end
#macro idslope1_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-11.9, 0, -3.9> <35.9, 9.5, 3.9> }
      box { <-20, -10, -10> <20, 0, 10> rotate 46*z translate <28, 0, 0> }
      box { <-20, -10, -10> <20, 0, 10> rotate -46*z translate <-4, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-11.9, 0, -3.9> <35.9, 9.5, 3.9> }
            box { <-3.9, 3.1, -4> <28.1, 10, 4> }
            box { <-20, -10, -10> <20, 0, 10> texture { color_tex normal { bumping } }
              rotate 46*z translate <28, 0, 0> }
            box { <-20, -10, -10> <20, 0, 10> texture { color_tex normal { bumping } }
              rotate -46*z translate <-4, 0, 0> }
          }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
            object { rounded_button() rotate 90*y translate <16, 0, 0> }
            object { rounded_button() rotate 90*y translate <24, 0, 0> }
          #end
        }
        difference {
          box { <28.9, 1, -3.1> <35.1, 10, 3.1> }
          box { <-20, -10, -10> <20, 0, 10> rotate 46*z translate <28, 2, 0> }
        }
        difference {
          box { <-11.1, 1, -3.1> <-4.9, 10, 3.1> }
          box { <-20, -10, -10> <20, 0, 10> rotate -46*z translate <-4, 2, 0> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
        #end
      }
      difference {
        object { high_open_rounded_button() translate <32, 0, 0> }
        box { <-20, -10, -10> <20, 0, 10> rotate 46*z translate <28, 2, 0> }
      }
      difference {
        object { high_open_rounded_button() translate <-8, 0, 0> }
        box { <-20, -10, -10> <20, 0, 10> rotate -46*z translate <-4, 2, 0> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 0> }
        object { ring() translate <12, 0, 0> }
        object { ring() translate <20, 0, 0> }
        box { <-5.8, 3, -0.4> <-4.8, 9.5, 0.4> }
        box { <28.8, 3, -0.4> <29.8, 9.5, 0.4> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <36, 11.3, 4> } }
    }
  #end
#end
#macro idslope4_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-11.9, 0, -3.9> <19.9, 9.5, 11.9> }
      box { <-20, -10, -10> <20, 0, 30> rotate 46*z translate <12, 0, 0> }
      box { <-20, -10, -10> <20, 0, 30> rotate -46*z translate <-4, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-11.9, 0, -3.9> <19.9, 9.5, 11.9> }
            box { <-3.9, 3.1, -4> <12.1, 10, 12> }
            box { <-20, -10, -10> <20, 0, 30> texture { color_tex normal { bumping } }
              rotate 46*z translate <12, 0, 0> }
            box { <-20, -10, -10> <20, 0, 30> texture { color_tex normal { bumping } }
              rotate -46*z translate <-4, 0, 0> }
          }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 rotate 90*y }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <0, 0, 8> }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
            object { rounded_button() rotate 90*y translate <8, 0, 8> }
          #end
        }
        difference {
          box { <13.1, 1, -3.1> <18.9, 10, 11.1> }
          box { <-20, -10, -10> <20, 0, 30> rotate 46*z translate <12, 2, 0> }
        }
        difference {
          box { <-10.9, 1, -3.1> <-5.1, 10, 11.1> }
          box { <-20, -10, -10> <20, 0, 30> rotate -46*z translate <-4, 2, 0> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        #end
      }
      difference {
        merge {
          object { high_open_rounded_button() translate <16, 0, 0> }
          object { high_open_rounded_button() translate <16, 0, 8> }
        }
        box { <-20, -10, -10> <20, 0, 30> rotate 46*z translate <12, 2, 0> }
      }
      difference {
        merge {
          object { high_open_rounded_button() translate <-8, 0, 0> }
          object { high_open_rounded_button() translate <-8, 0, 8> }
        }
        box { <-20, -10, -10> <20, 0, 30> rotate -46*z translate <-4, 2, 0> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        box { <-2.500001, 0.000001, 3.5> <1.25, 2.1, 4.5> }
        box { <6.75, 0.000001, 3.5> <10.500001, 2.1, 4.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <20, 11.3, 12> } }
    }
  #end
#end
#macro idslope4_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-11.9, 0, -3.9> <19.9, 9.5, 27.9> }
      box { <-20, -10, -10> <20, 0, 30> rotate 46*z translate <12, 0, 0> }
      box { <-20, -10, -10> <20, 0, 30> rotate -46*z translate <-4, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-11.9, 0, -3.9> <19.9, 9.5, 27.9> }
            box { <-3.9, 3.1, -4> <12.1, 10, 28> }
            box { <-20, -10, -10> <20, 0, 30> texture { color_tex normal { bumping } }
              rotate 46*z translate <12, 0, 0> }
            box { <-20, -10, -10> <20, 0, 30> texture { color_tex normal { bumping } }
              rotate -46*z translate <-4, 0, 0> }
          }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 rotate 90*y }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <0, 0, 8> }
            object { rounded_button() rotate 90*y translate <0, 0, 16> }
            object { rounded_button() rotate 90*y translate <0, 0, 24> }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
            object { rounded_button() rotate 90*y translate <8, 0, 8> }
            object { rounded_button() rotate 90*y translate <8, 0, 16> }
            object { rounded_button() rotate 90*y translate <8, 0, 24> }
          #end
        }
        difference {
          box { <13.1, 1, -3.1> <18.9, 10, 27.1> }
          box { <-20, -10, -10> <20, 0, 30> rotate 46*z translate <12, 2, 0> }
        }
        difference {
          box { <-10.9, 1, -3.1> <-5.1, 10, 27.1> }
          box { <-20, -10, -10> <20, 0, 30> rotate -46*z translate <-4, 2, 0> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 26.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
        #end
      }
      difference {
        merge {
          object { high_open_rounded_button() translate <16, 0, 0> }
          object { high_open_rounded_button() translate <16, 0, 8> }
          object { high_open_rounded_button() translate <16, 0, 16> }
          object { high_open_rounded_button() translate <16, 0, 24> }
        }
        box { <-20, -10, -10> <20, 0, 30> rotate 46*z translate <12, 2, 0> }
      }
      difference {
        merge {
          object { high_open_rounded_button() translate <-8, 0, 0> }
          object { high_open_rounded_button() translate <-8, 0, 8> }
          object { high_open_rounded_button() translate <-8, 0, 16> }
          object { high_open_rounded_button() translate <-8, 0, 24> }
        }
        box { <-20, -10, -10> <20, 0, 30> rotate -46*z translate <-4, 2, 0> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <4, 0, 20> }
        box { <-2.500001, 0.000001, 3.5> <1.25, 2.1, 4.5> }
        box { <-2.500001, 0.000001, 11.5> <1.25, 2.1, 12.5> }
        box { <-2.500001, 0.000001, 19.5> <1.25, 2.1, 20.5> }
        box { <6.75, 0.000001, 3.5> <10.500001, 2.1, 4.5> }
        box { <6.75, 0.000001, 11.5> <10.500001, 2.1, 12.5> }
        box { <6.75, 0.000001, 19.5> <10.500001, 2.1, 20.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <20, 11.3, 28> } }
    }
  #end
#end
#macro idslope4_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-11.9, 0, -3.9> <35.9, 9.5, 27.9> }
      box { <-20, -10, -10> <20, 0, 30> rotate 46*z translate <28, 0, 0> }
      box { <-20, -10, -10> <20, 0, 30> rotate -46*z translate <-4, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-11.9, 0, -3.9> <35.9, 9.5, 27.9> }
            box { <-3.9, 3.1, -4> <28.1, 10, 28> }
            box { <-20, -10, -10> <20, 0, 30> texture { color_tex normal { bumping } }
              rotate 46*z translate <28, 0, 0> }
            box { <-20, -10, -10> <20, 0, 30> texture { color_tex normal { bumping } }
              rotate -46*z translate <-4, 0, 0> }
          }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <0, 0, 8> }
            object { rounded_button() rotate 90*y translate <0, 0, 16> }
            object { rounded_button() rotate 90*y translate <0, 0, 24> }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
            object { rounded_button() rotate 90*y translate <8, 0, 8> }
            object { rounded_button() rotate 90*y translate <8, 0, 16> }
            object { rounded_button() rotate 90*y translate <8, 0, 24> }
            object { rounded_button() rotate 90*y translate <16, 0, 0> }
            object { rounded_button() rotate 90*y translate <16, 0, 8> }
            object { rounded_button() rotate 90*y translate <16, 0, 16> }
            object { rounded_button() rotate 90*y translate <16, 0, 24> }
            object { rounded_button() rotate 90*y translate <24, 0, 0> }
            object { rounded_button() rotate 90*y translate <24, 0, 8> }
            object { rounded_button() rotate 90*y translate <24, 0, 16> }
            object { rounded_button() rotate 90*y translate <24, 0, 24> }
          #end
        }
        difference {
          box { <28.9, 1, -3.1> <35.1, 10, 27.1> }
          box { <-20, -10, -10> <20, 0, 30> rotate 46*z translate <28, 2, 0> }
        }
        difference {
          box { <-11.1, 1, -3.1> <-4.9, 10, 27.1> }
          box { <-20, -10, -10> <20, 0, 30> rotate -46*z translate <-4, 2, 0> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 26.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
        #end
      }
      difference {
        merge {
          object { high_open_rounded_button() translate <32, 0, 0> }
          object { high_open_rounded_button() translate <32, 0, 8> }
          object { high_open_rounded_button() translate <32, 0, 16> }
          object { high_open_rounded_button() translate <32, 0, 24> }
        }
        box { <-20, -10, -10> <20, 0, 30> rotate 46*z translate <28, 2, 0> }
      }
      difference {
        merge {
          object { high_open_rounded_button() translate <-8, 0, 0> }
          object { high_open_rounded_button() translate <-8, 0, 8> }
          object { high_open_rounded_button() translate <-8, 0, 16> }
          object { high_open_rounded_button() translate <-8, 0, 24> }
        }
        box { <-20, -10, -10> <20, 0, 30> rotate -46*z translate <-4, 2, 0> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <20, 0, 20> }
        box { <-2.500001, 0.000001, 3.5> <1.25, 2.1, 4.5> }
        box { <-2.500001, 0.000001, 11.5> <1.25, 2.1, 12.5> }
        box { <-2.500001, 0.000001, 19.5> <1.25, 2.1, 20.5> }
        box { <6.75, 0.000001, 3.5> <9.75, 2.1, 4.5> }
        box { <6.75, 0.000001, 11.5> <9.75, 2.1, 12.5> }
        box { <6.75, 0.000001, 19.5> <9.75, 2.1, 20.5> }
        box { <14.25, 0.000001, 3.5> <17.25, 2.1, 4.5> }
        box { <14.25, 0.000001, 11.5> <17.25, 2.1, 12.5> }
        box { <14.25, 0.000001, 19.5> <17.25, 2.1, 20.5> }
        box { <22.75, 0.000001, 3.5> <26.5, 2.1, 4.5> }
        box { <22.75, 0.000001, 11.5> <26.5, 2.1, 12.5> }
        box { <22.75, 0.000001, 19.5> <26.5, 2.1, 20.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <36, 11.3, 28> } }
    }
  #end
#end
#macro idslope4_6mod(color_tex)
  #if (setting = 0)
    difference {
      box { <-11.9, 0, -3.9> <35.9, 9.5, 27.9> }
      box { <-20, -10, -10> <20, 0, 30> rotate 46*z translate <28, 0, 0> }
      box { <-20, -10, -10> <20, 0, 30> rotate -46*z translate <-4, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-11.9, 0, -3.9> <35.9, 9.5, 27.9> }
            box { <3.9, 3.1, 3.9> <20.1, 10, 20.1> }
            box { <-20, -10, -10> <20, 0, 30> texture { color_tex normal { bumping } }
              rotate 46*z translate <28, 0, 0> }
            box { <-20, -10, -10> <20, 0, 30> texture { color_tex normal { bumping } }
              rotate -46*z translate <-4, 0, 0> }
            cylinder { -1*y, 10*y, 2.60001 translate <12, 0, 12> }
          }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 6.4, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 6.4, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 6.4, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 6.4, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 6.4, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 6.4, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 6.4, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 6.4, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 6.4, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 6.4, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 6.4, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 6.4, 24> }
          #else
            object { rounded_button() rotate 90*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <0, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <0, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <0, 6.4, 24> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <8, 0, 8> }
            object { rounded_button() rotate 90*y translate <8, 0, 16> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 24> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <16, 0, 8> }
            object { rounded_button() rotate 90*y translate <16, 0, 16> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 24> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 24> }
          #end
        }
        difference {
          box { <28.9, 1, -3.1> <35.1, 10, 27.1> }
          box { <-20, -10, -10> <20, 0, 30> rotate 46*z translate <28, 2, 0> }
        }
        difference {
          box { <-11.1, 1, -3.1> <-4.9, 10, 27.1> }
          box { <-20, -10, -10> <20, 0, 30> rotate -46*z translate <-4, 2, 0> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <26.4, 8.6, 26.4> }
            box { <2.4, -2, 2.4> <21.6, 9, 21.6> }
          }
          box { <3.9, -1, 3.9> <20.1, 2, 20.1> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 24> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 7.4*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 7.4*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 7.4*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 24> }
        #end
      }
      difference {
        merge {
          object { high_open_rounded_button() translate <32, 0, 0> }
          object { high_open_rounded_button() translate <32, 0, 8> }
          object { high_open_rounded_button() translate <32, 0, 16> }
          object { high_open_rounded_button() translate <32, 0, 24> }
        }
        box { <-20, -10, -10> <20, 0, 30> rotate 46*z translate <28, 2, 0> }
      }
      difference {
        merge {
          object { high_open_rounded_button() translate <-8, 0, 0> }
          object { high_open_rounded_button() translate <-8, 0, 8> }
          object { high_open_rounded_button() translate <-8, 0, 16> }
          object { high_open_rounded_button() translate <-8, 0, 24> }
        }
        box { <-20, -10, -10> <20, 0, 30> rotate -46*z translate <-4, 2, 0> }
      }
      #if (setting > 1)
        object { ring() translate <12, 0, 12> }
        difference {
          merge {
            box { <-2.4, 0.2, -2.4> <2.4, 8.7, 2.4> }
            box { <-2.4, 0.2, -2.4> <2.4, 8.7, 2.4> translate <24, 0, 0> }
            box { <-2.4, 0.2, -2.4> <2.4, 8.7, 2.4> translate <24, 0, 24> }
            box { <-2.4, 0.2, -2.4> <2.4, 8.7, 2.4> translate <0, 0, 24> }
            box { <-2.4, 0.2, -2.4> <2.4, 8.7, 2.4> translate <8, 0, 0> }
            box { <-2.4, 0.2, -2.4> <2.4, 8.7, 2.4> translate <16, 0, 0> }
            box { <-2.4, 0.2, -2.4> <2.4, 8.7, 2.4> translate <8, 0, 24> }
            box { <-2.4, 0.2, -2.4> <2.4, 8.7, 2.4> translate <16, 0, 24> }
            box { <-2.4, 0.2, -2.4> <2.4, 8.7, 2.4> translate <0, 0, 8> }
            box { <-2.4, 0.2, -2.4> <2.4, 8.7, 2.4> translate <0, 0, 16> }
            box { <-2.4, 0.2, -2.4> <2.4, 8.7, 2.4> translate <24, 0, 8> }
            box { <-2.4, 0.2, -2.4> <2.4, 8.7, 2.4> translate <24, 0, 16> }
          }
          box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y translate <8, 0, 0> }
          box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y translate <16, 0, 0> }
          box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y translate <8, 0, 24> }
          box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y translate <16, 0, 24> }
          box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y translate <0, 0, 8> }
          box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y translate <0, 0, 16> }
          box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y translate <24, 0, 8> }
          box { <-2.5, -1, -2.5> <2.5, 10, 2.5> rotate 45*y translate <24, 0, 16> }
          box { <-2.5, -1, -5> <2.5, 10, 5> rotate 45*y }
          box { <-5, -1, -2.5> <5, 10, 2.55> rotate 45*y translate <24, 0, 0> }
          box { <-2.5, -1, -5> <2.5, 10, 5> rotate 45*y translate <0, 0, 24> }
          box { <-5, -1, -2.5> <5, 10, 2.5> rotate 45*y translate <24, 0, 24> }
        }
        box { <11.65, 2, -3> <12.35, 8.7, 3> }
        box { <11.65, 2, 21> <12.35, 8.7, 27> }
        box { <-3, 2, 11.65> <3, 8.7, 12.35> }
        box { <21, 2, 11.65> <27, 8.7, 12.35> }
        box { <-1.35, 0.2, -0.5> <1, 8.7, 0.5> rotate -45*y translate <2.4, 0, 2.4> }
        box { <-1.35, 0.2, -0.5> <1, 8.7, 0.5> rotate 45*y translate <2.4, 0, 22.4> }
        box { <-1, 0.2, -0.5> <1.35, 8.7, 0.5> rotate -45*y translate <22.4, 0, 22.4> }
        box { <-1, 0.2, -0.5> <1.35, 8.7, 0.5> rotate 45*y translate <22.4, 0, 2.4> }
        box { <7.5, 0.2, 4> <8.5, 2.1, 5.6> }
        box { <15.5, 0.2, 4> <16.5, 2.1, 5.6> }
        box { <7.5, 0.2, 18.4> <8.5, 2.1, 20> }
        box { <15.5, 0.2, 18.4> <16.5, 2.1, 20> }
        box { <4, 0.2, 7.5> <5.6, 2.1, 8.5> }
        box { <4, 0.2, 15.5> <5.6, 2.1, 16.5> }
        box { <18.4, 0.2, 7.5> <20, 2.1, 8.5> }
        box { <18.4, 0.2, 15.5> <20, 2.1, 16.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <36, 11.3, 28> } }
    }
  #end
#end
#macro inlay_window_1(color_tex)
  #if (setting = 0)
    box { <0, 0.8, 0.1> <15, 1.55, 23.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { 0.1*z, 23.9*z, 1.55 }
          box { <0, 0.8, 0.100001> <15, 1.55, 23.899999> }
          box { <0.000001, 0, 0.100002> <12, 0.9, 1.1> }
          box { <0.000001, 0, 22.9> <12, 0.9, 23.899998> }
        }
        box { <0, -5, -10> <10, 0, 30> rotate -30*z translate <12, 0.800001, 0> }
        difference {
          box { <14, -3, -1> <16, 3, 1.1> }
          cylinder { -2*y, 2*y, 1 translate <14, 0, 1.1> }
        }
        difference {
          box { <14, -3, 22.9> <16, 3, 24> }
          cylinder { -2*y, 2*y, 1 translate <14, 0, 22.9> }
        }
        cylinder { 1.35*z, 22.65*z, 0.7 }
        box { <-2, -2, 1.350001> <2, 0, 22.649999> }
        box { <0, -1, 1.350002> <16, 0.799999, 22.649998> }
        sphere { <0, 0, -0.3> 0.6 }
        sphere { <0, 0, 24.3> 0.6 }
      }
      #if (setting > 1)
        cylinder { 1*z, 23*z, 0.2 translate <2.8, 0.8, 0> }
        cylinder { 1*z, 23*z, 0.2 translate <5.75, 0.8, 0> }
        cylinder { 1*z, 23*z, 0.2 translate <8.7, 0.8, 0> }
        cylinder { 1*z, 9.8*z, 0.2 translate <11.65, 0.8, 0> }
        cylinder { 14.2*z, 23*z, 0.2 translate <11.65, 0.8, 0> }
      #end
      #if (setting > 3)
        object { llogo() scale <0.95, 0.95, 0.95> translate <11.65, 1.55, 12> }
      #end
      texture { color_tex }
      bounded_by { box { <-1.65, -1.65, -1> <15.1, 1.65, 25> } }
    }
  #end
#end
#macro insectoid_batteryholder(lights_on)
  #if (setting = 0)
    merge {
      box { <12, 0, -3.9> <68, 43.1, 27.9> texture { grey2_tex } }
      box { <-3.9, 9.6, 4.1> <12.2, 19.1, 19.9> texture { grey2_tex } }
      box { <67.9, 9.6, -3.900001> <157, 31.9, 27.900001> texture { t_yellowgreen_tex } interior { ior 1.5 } }
    }
  #else
    merge {
      difference {
        box { <67.9, 9.6, -3.9> <157, 31.9, 3.9> }
        box { <60, 0, -10> <160, 20, 0> rotate -39*x translate <0, 9.6, 3> }
        box { <60, -20, -10> <160, 0, 0> rotate 39*x translate <0, 31.9, 3> }
        box { <60, 9, 2.9> <132.5, 32, 4> }
        box { <0, 9, -10> <30, 32, 0> rotate -16*y translate <133, 0, -3.9> }
        box { <0, 0, -20> <40, 20, 20> rotate -49.75*x rotate -19.65*z translate <133, 31.9, 2.9> }
        box { <0, -20, -20> <40, 0, 20> rotate 49.75*x rotate 19.65*z translate <133, 9.6, 2.9> }
        box { <0, 0, -10> <40, 20, 10> rotate -19.65*z translate <133, 31.9, -3.9> }
        box { <0, -20, -10> <40, 0, 10> rotate 19.65*z translate <133, 9.6, -3.9> }
        difference {
          box { <1, -15, -10> <20, 10, 10> }
          cylinder { -5*z, 6*z, 3.6 }
          translate <153.5, 20.75, 0>
        }
        sphere { <69.5, 20.75, 0> 1.5 }
        cylinder { 50*x, 69.5*x, 1.5 translate <0, 20.75, 0> }
        box { <50, 19.25, 0> <69.500001, 22.25, 6> }
        cylinder { 0*z, 6*z, 1.5 translate <69.5, 20.75, 0> }
        difference {
          box { <69.6, 12.5, -2.9> <157, 29, 5> }
          box { <0, 0, -10> <40, 20, 10> rotate -19.65*z translate <133, 30.4, -3.9> }
          box { <0, -20, -10> <40, 0, 10> rotate 19.65*z translate <133, 11.1, -3.9> }
          box { <0, 0, -20> <40, 20, 20> rotate -49.75*x rotate -19.65*z translate <133, 30.4, 2.9> }
          box { <0, -20, -20> <40, 0, 20> rotate 49.75*x rotate 19.65*z translate <133, 11.1, 2.9> }
          box { <60, 0, -10> <160, 20, 0> rotate -30*x translate <0, 11.1, 3> }
          box { <60, -20, -10> <160, 0, 0> rotate 30*x translate <0, 30.4, 3> }
          box { <0, 9, -10> <30, 32, 0> rotate -16*y translate <133, 0, -2.9> }
          difference {
            box { <69, 12, -5> <113.5, 29.5, 5> }
            cylinder { -4*z, 4*z, 2.5 translate <72.1, 15.75, 0> }
            cylinder { -4*z, 4*z, 2.5 translate <72.1, 25.75, 0> }
            box { <0, 2.5, -10> <40, 10, 10> rotate 9*z translate <72.1, 20.75, 0> }
            box { <0, -2.5, -10> <40, -10, 10> rotate -9*z translate <72.1, 20.75, 0> }
            box { <0, 11, -10> <72.1, 15.75, 10> }
            box { <0, 25.75, -10> <72.1, 30, 10> }
            difference {
              box { <73, 12, -6> <114, 29.5, 5> }
              box { <0, -20, -20> <40, 20, 0> rotate -39*x rotate 5*y rotate -4*z translate <72.1, 17.75, 3> }
              box { <0, -20, -20> <40, 20, 0> rotate 39*x rotate 5*y rotate 4*z translate <72.1, 23.75, 3> }
              cylinder { 0*y, 20*y, 0.35 rotate -44*x translate <77.5, 11.1, 8.85> }
              cylinder { 0*y, 20*y, 0.35 rotate -42*x translate <82, 11.1, 7.6> }
              cylinder { 0*y, 20*y, 0.35 rotate -40*x translate <86.5, 11.1, 6.6> }
              cylinder { 0*y, 20*y, 0.35 rotate -38*x translate <91, 11.1, 5.6> }
              cylinder { 0*y, 20*y, 0.35 rotate -36*x translate <95.5, 11.1, 4.6> }
              cylinder { 0*y, 20*y, 0.35 rotate -34*x translate <100, 11.1, 3.85> }
              cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <104.5, 11.1, 3.1> }
              cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <109, 11.1, 3.1> }
              cylinder { -20*y, 0*y, 0.35 rotate 44*x translate <77.5, 30.4, 8.85> }
              cylinder { -20*y, 0*y, 0.35 rotate 42*x translate <82, 30.4, 7.6> }
              cylinder { -20*y, 0*y, 0.35 rotate 40*x translate <86.5, 30.4, 6.6> }
              cylinder { -20*y, 0*y, 0.35 rotate 38*x translate <91, 30.4, 5.6> }
              cylinder { -20*y, 0*y, 0.35 rotate 36*x translate <95.5, 30.4, 4.6> }
              cylinder { -20*y, 0*y, 0.35 rotate 33*x translate <100, 30.4, 3.85> }
              cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <104.5, 30.4, 3.1> }
              cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <109, 30.4, 3.1> }
            }
          }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <113.5, 11.1, 3.1> }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <118, 11.1, 3.1> }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <122.5, 11.1, 3.1> }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <127, 11.1, 3.1> }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <131.5, 11.1, 3.1> }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <136, 11.1, 4> }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <140.5, 11.1, 5.25> }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <145, 11.1, 6.5> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <113.5, 30.4, 3.1> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <118, 30.4, 3.1> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <122.5, 30.4, 3.1> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <127, 30.4, 3.1> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <131.5, 30.4, 3.1> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <136, 30.4, 4> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <140.5, 30.4, 5.25> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <145, 30.4, 6.5> }
          difference {
            box { <1, -15, -10> <20, 10, 10> }
            cylinder { -5*z, 6*z, 2.1 }
            translate <153.5, 20.75, 0>
          }
          difference {
            cylinder { -4*z, 2.900001*z, 3.7 }
            cylinder { -2.9*z, 3*z, 2.2 }
            box { <-4, -1.5, -1.9> <0, 1.5, 4> }
            box { <-0.5, -4, -2.900002> <0.5, 4, 4> }
            translate <122.5, 20.75, 0>
          }
          box { <117.9, 22.25, -5> <120, 23.45, 2.900002> }
          box { <117.9, 18.05, -5> <120, 19.25, 2.900002> }
        }
        texture { t_yellowgreen_tex } interior { ior 1.5 }
      }
      difference {
        box { <67.9, 9.6, -3.9> <157, 31.9, 3.9> }
        box { <60, 0, -10> <160, 20, 0> rotate -39*x translate <0, 9.6, 3> }
        box { <60, -20, -10> <160, 0, 0> rotate 39*x translate <0, 31.9, 3> }
        box { <60, 9, 2.9> <132.5, 32, 4> }
        box { <0, 9, -10> <30, 32, 0> rotate -16*y translate <133, 0, -3.9> }
        box { <0, 0, -20> <40, 20, 20> rotate -49.75*x rotate -19.65*z translate <133, 31.9, 2.9> }
        box { <0, -20, -20> <40, 0, 20> rotate 49.75*x rotate 19.65*z translate <133, 9.6, 2.9> }
        box { <0, 0, -10> <40, 20, 10> rotate -19.65*z translate <133, 31.9, -3.9> }
        box { <0, -20, -10> <40, 0, 10> rotate 19.65*z translate <133, 9.6, -3.9> }
        difference {
          box { <1, -15, -10> <20, 10, 10> }
          cylinder { -5*z, 6*z, 3.6 }
          translate <153.5, 20.75, 0>
        }
        sphere { <69.5, 20.75, 0> 1.5 }
        cylinder { 50*x, 69.5*x, 1.5 translate <0, 20.75, 0> }
        box { <50, 19.25, 0> <69.500001, 22.25, 6> }
        cylinder { 0*z, 6*z, 1.5 translate <69.5, 20.75, 0> }
        difference {
          box { <69.6, 12.5, -2.9> <157, 29, 5> }
          box { <0, 0, -10> <40, 20, 10> rotate -19.65*z translate <133, 30.4, -3.9> }
          box { <0, -20, -10> <40, 0, 10> rotate 19.65*z translate <133, 11.1, -3.9> }
          box { <0, 0, -20> <40, 20, 20> rotate -49.75*x rotate -19.65*z translate <133, 30.4, 2.9> }
          box { <0, -20, -20> <40, 0, 20> rotate 49.75*x rotate 19.65*z translate <133, 11.1, 2.9> }
          box { <60, 0, -10> <160, 20, 0> rotate -30*x translate <0, 11.1, 3> }
          box { <60, -20, -10> <160, 0, 0> rotate 30*x translate <0, 30.4, 3> }
          box { <0, 9, -10> <30, 32, 0> rotate -16*y translate <133, 0, -2.9> }
          difference {
            box { <69, 12, -5> <113.5, 29.5, 5> }
            cylinder { -4*z, 4*z, 2.5 translate <72.1, 15.75, 0> }
            cylinder { -4*z, 4*z, 2.5 translate <72.1, 25.75, 0> }
            box { <0, 2.5, -10> <40, 10, 10> rotate 9*z translate <72.1, 20.75, 0> }
            box { <0, -2.5, -10> <40, -10, 10> rotate -9*z translate <72.1, 20.75, 0> }
            box { <0, 11, -10> <72.1, 15.75, 10> }
            box { <0, 25.75, -10> <72.1, 30, 10> }
            difference {
              box { <73, 12, -6> <114, 29.5, 5> }
              box { <0, -20, -20> <40, 20, 0> rotate -39*x rotate 5*y rotate -4*z translate <72.1, 17.75, 3> }
              box { <0, -20, -20> <40, 20, 0> rotate 39*x rotate 5*y rotate 4*z translate <72.1, 23.75, 3> }
              cylinder { 0*y, 20*y, 0.35 rotate -44*x translate <77.5, 11.1, 8.85> }
              cylinder { 0*y, 20*y, 0.35 rotate -42*x translate <82, 11.1, 7.6> }
              cylinder { 0*y, 20*y, 0.35 rotate -40*x translate <86.5, 11.1, 6.6> }
              cylinder { 0*y, 20*y, 0.35 rotate -38*x translate <91, 11.1, 5.6> }
              cylinder { 0*y, 20*y, 0.35 rotate -36*x translate <95.5, 11.1, 4.6> }
              cylinder { 0*y, 20*y, 0.35 rotate -34*x translate <100, 11.1, 3.85> }
              cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <104.5, 11.1, 3.1> }
              cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <109, 11.1, 3.1> }
              cylinder { -20*y, 0*y, 0.35 rotate 44*x translate <77.5, 30.4, 8.85> }
              cylinder { -20*y, 0*y, 0.35 rotate 42*x translate <82, 30.4, 7.6> }
              cylinder { -20*y, 0*y, 0.35 rotate 40*x translate <86.5, 30.4, 6.6> }
              cylinder { -20*y, 0*y, 0.35 rotate 38*x translate <91, 30.4, 5.6> }
              cylinder { -20*y, 0*y, 0.35 rotate 36*x translate <95.5, 30.4, 4.6> }
              cylinder { -20*y, 0*y, 0.35 rotate 33*x translate <100, 30.4, 3.85> }
              cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <104.5, 30.4, 3.1> }
              cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <109, 30.4, 3.1> }
            }
          }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <113.5, 11.1, 3.1> }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <118, 11.1, 3.1> }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <122.5, 11.1, 3.1> }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <127, 11.1, 3.1> }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <131.5, 11.1, 3.1> }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <136, 11.1, 4> }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <140.5, 11.1, 5.25> }
          cylinder { 0*y, 20*y, 0.35 rotate -30*x translate <145, 11.1, 6.5> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <113.5, 30.4, 3.1> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <118, 30.4, 3.1> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <122.5, 30.4, 3.1> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <127, 30.4, 3.1> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <131.5, 30.4, 3.1> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <136, 30.4, 4> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <140.5, 30.4, 5.25> }
          cylinder { -20*y, 0*y, 0.35 rotate 30*x translate <145, 30.4, 6.5> }
          difference {
            box { <1, -15, -10> <20, 10, 10> }
            cylinder { -5*z, 6*z, 2.1 }
            translate <153.5, 20.75, 0>
          }
          difference {
            cylinder { -4*z, 2.900001*z, 3.7 }
            cylinder { -2.9*z, 3*z, 2.2 }
            box { <-4, -1.5, -1.9> <0, 1.5, 4> }
            box { <-0.5, -4, -2.900002> <0.5, 4, 4> }
            translate <122.5, 20.75, 0>
          }
          box { <117.9, 22.25, -5> <120, 23.45, 2.900002> }
          box { <117.9, 18.05, -5> <120, 19.25, 2.900002> }
        }
        texture { t_yellowgreen_tex } interior { ior 1.5 }
        rotate 180*x translate <0, 41.5, 24>
      }
      difference {
        prism {
          bezier_spline
          30, 43, 24,
          <0.5, 3>, <0.5, 3>, <4.5, 6.5>, <4.5, 6.5>,
          <4.5, 6.5>, <4.5, 6.5>, <9.5, 6.5>, <9.5, 6.5>,
          <9.5, 6.5>, <10, 6.5>, <10.4, 6.2>, <9.5, 5.5>,
          <9.5, 5.5>, <9.5, 5.5>, <4.5, 2>, <4.5, 2>,
          <4.5, 2>, <4.5, 2>, <0.5, 2>, <0.5, 2>,
          <0.5, 2>, <0, 2>, <-0.4, 2.3>, <0.5, 3>
          sturm
          translate <46, 0, 12>
        }
        box { <0, 0, 0> <20, 10, 10> rotate -22*z translate <46, 43, 12> }
        texture { r_black_tex }
      }
      difference {
        prism {
          bezier_spline
          30, 43, 24,
          <0.5, -3>, <0.5, -3>, <4.5, -6.5>, <4.5, -6.5>,
          <4.5, -6.5>, <4.5, -6.5>, <9.5, -6.5>, <9.5, -6.5>,
          <9.5, -6.5>, <10, -6.5>, <10.4, -6.2>, <9.5, -5.5>,
          <9.5, -5.5>, <9.5, -5.5>, <4.5, -2>, <4.5, -2>,
          <4.5, -2>, <4.5, -2>, <0.5, -2>, <0.5, -2>,
          <0.5, -2>, <0, -2>, <-0.4, -2.3>, <0.5, -3>
          sturm
          translate <46, 0, 12>
        }
        box { <0, 0, -10> <20, 10, 0> rotate -22*z translate <46, 43, 12> }
        texture { r_black_tex }
      }
      difference {
        merge {
          cylinder { 30*y, 43*y, 0.5 translate <-2.5, 0, -2.5> }
          cylinder { 30*y, 43*y, 0.5 translate <-2.5, 0, 2.5> }
          cylinder { 30*y, 43*y, 0.5 translate <2.5, 0, -2.5> }
          cylinder { 30*y, 43*y, 0.5 translate <2.5, 0, 2.5> }
          box { <-2.5, 30, -3> <2.5, 43.000001, 3> }
          box { <-3, 30, -2.5> <3, 43.000002, 2.5> }
          rotate 45*y
          translate <58.5, 0, 12>
        }
        box { <0, 0, 0> <50, 10, 30> rotate -22*z translate <46, 43.000005, 0> }
        texture { r_black_tex }
      }
      difference {
        merge {
          box { <-3.9, 9.6, 4.1> <12.2, 19.1, 19.9> }
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 19*y, 20.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 16> }
          #else
            object { rounded_button() translate <0, 16, 8> }
            object { rounded_button() translate <8, 16, 8> }
            object { rounded_button() translate <0, 16, 16> }
            object { rounded_button() translate <8, 16, 16> }
          #end
          difference {
            box { <12.1, 0, -3.9> <67.9, 41.5, 27.9> }
            box { <-10, -40, 0> <60, 40, 40> rotate 40*x rotate 24*y rotate 5*z translate <51.999999, 0, 20> }
            box { <-10, -40, -40> <60, 40, 0> rotate -40*x rotate -24*y rotate 5*z translate <51.999999, 0, 4> }
            box { <-10, -40, -40> <60, 40, 0> rotate 43*x rotate -25*y translate <43.999999, 41.5, 4> }
            box { <-10, -40, 0> <60, 40, 40> rotate -43*x rotate 25*y translate <43.999999, 41.5, 20> }
            box { <11, -10, -10> <53, 20, 0> rotate -44*x translate <0, 0, 4> }
            box { <11, -10, 0> <53, 20, 10> rotate 44*x translate <0, 0, 20> }
            box { <11, 0, -20> <44, 20, 20> rotate -43.5*x translate <0, 41.5, 4> }
            box { <11, 0, -20> <44, 20, 20> rotate 43.5*x translate <0, 41.5, 20> }
            box { <-10, -10, -10> <20, 0, 30> rotate 31*z translate <52, 0, 0> }
            box { <-10, 0, -10> <40, 30, 30> rotate -22*z translate <44, 41.5, 0> }
            cylinder { -1*y, 42*y, 0.4 translate <67.5, 0, 2.6> }
            cylinder { -1*y, 42*y, 0.4 translate <67.5, 0, 21.4> }
            #if (setting > 1)
              cylinder { -1*y, 2*y, 2.4 translate <56, 0, 8> }
              cylinder { -1*y, 2*y, 2.4 translate <56, 0, 16> }
              box { <53.6, -1, 7.999999> <64, 2.000001, 16.000001> }
            #end
            cylinder { 30*x, 70*x, 1.5 translate <0, 20.75, 0> }
            cylinder { 30*x, 70*x, 1.5 translate <0, 20.75, 24> }
            prism {
              bezier_spline
              10, 50, 24,
              <0.5, 3>, <0.5, 3>, <4.5, 6.5>, <4.5, 6.5>,
              <4.5, 6.5>, <4.5, 6.5>, <9.5, 6.5>, <9.5, 6.5>,
              <9.5, 6.5>, <10, 6.5>, <10.4, 6.2>, <9.5, 5.5>,
              <9.5, 5.5>, <9.5, 5.5>, <4.5, 2>, <4.5, 2>,
              <4.5, 2>, <4.5, 2>, <0.5, 2>, <0.5, 2>,
              <0.5, 2>, <0, 2>, <-0.4, 2.3>, <0.5, 3>
              sturm
              translate <-5, 0, -4.25>
              scale <1.1, 1.1, 1.1>
              translate <51, 0, 16.25>
            }
            prism {
              bezier_spline
              10, 50, 24,
              <0.5, -3>, <0.5, -3>, <4.5, -6.5>, <4.5, -6.5>,
              <4.5, -6.5>, <4.5, -6.5>, <9.5, -6.5>, <9.5, -6.5>,
              <9.5, -6.5>, <10, -6.5>, <10.4, -6.2>, <9.5, -5.5>,
              <9.5, -5.5>, <9.5, -5.5>, <4.5, -2>, <4.5, -2>,
              <4.5, -2>, <4.5, -2>, <0.5, -2>, <0.5, -2>,
              <0.5, -2>, <0, -2>, <-0.4, -2.3>, <0.5, -3>
              sturm
              translate <-5, 0, 4.25>
              scale <1.1, 1.1, 1.1>
              translate <51, 0, 7.75>
            }
            merge {
              cylinder { 10*y, 50*y, 0.5 translate <-2.5, 0, -2.5> }
              cylinder { 10*y, 50*y, 0.5 translate <-2.5, 0, 2.5> }
              cylinder { 10*y, 50*y, 0.5 translate <2.5, 0, -2.5> }
              cylinder { 10*y, 50*y, 0.5 translate <2.5, 0, 2.5> }
              box { <-2.5, 10, -3> <2.5, 50.000001, 3> }
              box { <-3, 10, -2.5> <3, 50.000002, 2.5> }
              scale <1.1, 1.1, 1.1>
              rotate 45*y
              translate <58.5, 0, 12>
            }
          }
          merge {
            cylinder { 50*x, 69.5*x, 1.4 }
            sphere { <69.5, 0, 0> 1.4 }
            texture { t_white_tex } interior { ior 1.5 }
            translate <0, 20.75, 0>
          }
          merge {
            cylinder { 50*x, 69.5*x, 1.4 }
            sphere { <69.5, 0, 0> 1.4 }
            texture { t_white_tex } interior { ior 1.5 }
            translate <0, 20.75, 24>
          }
          difference {
            box { <57, 0, 7> <64, 15, 17> }
            box { <-10, -10, -10> <20, 0, 30> rotate 31*z translate <52, -0.75, 0> }
            box { <-10, 0, -10> <0, 15, 0> rotate -32.5*y translate <57, 0, 12> }
            box { <-10, 0, 0> <0, 15, 10> rotate 32.5*y translate <57, 0, 12> }
            box { <60, 0, 5> <65, 15, 9.5> }
            box { <60, 0, 14.5> <65, 15, 20> }
          }
          box { <67.8, 9.6, 3> <131.9, 31.9, 21> }
          box { <118, 19.1, 1.2> <122.5, 20.5, 22.8> }
          difference {
            merge {
              torus { 1.5, 0.75 rotate 90*x translate <0, 0, 24.25> }
              torus { 1.5, 0.75 rotate 90*x translate <0, 0, 0.75> }
              cylinder { 0*z, 25*z, 1.5 }
            }
            box { <-5, -10, -10> <5, -1, 30> }
            box { <-0.8, -10, 0.75> <0.8, 1, 24.25> }
            translate <122.5, 20.75, 0>
          }
          #if (setting < 3)
            cylinder { 31.8*y, 33.6*y, 2.4 translate <72, 0, 8> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <72, 0, 16> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <80, 0, 8> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <80, 0, 16> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <88, 0, 8> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <88, 0, 16> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <96, 0, 8> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <96, 0, 16> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <104, 0, 8> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <104, 0, 16> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <112, 0, 8> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <112, 0, 16> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <120, 0, 8> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <120, 0, 16> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <128, 0, 8> }
            cylinder { 31.8*y, 33.6*y, 2.4 translate <128, 0, 16> }
            cylinder { 25.4*y, 27.2*y, 2.4 translate <136, 0, 8> }
            cylinder { 25.4*y, 27.2*y, 2.4 translate <136, 0, 16> }
          #else
            object { rounded_button() translate <72, 28.8, 8> }
            object { rounded_button() translate <72, 28.8, 16> }
            object { rounded_button() translate <80, 28.8, 8> }
            object { rounded_button() translate <80, 28.8, 16> }
            object { rounded_button() translate <88, 28.8, 8> }
            object { rounded_button() translate <88, 28.8, 16> }
            object { rounded_button() translate <96, 28.8, 8> }
            object { rounded_button() translate <96, 28.8, 16> }
            object { rounded_button() translate <104, 28.8, 8> }
            object { rounded_button() translate <104, 28.8, 16> }
            object { rounded_button() translate <112, 28.8, 8> }
            object { rounded_button() translate <112, 28.8, 16> }
            object { rounded_button() translate <120, 28.8, 8> }
            object { rounded_button() translate <120, 28.8, 16> }
            object { rounded_button() translate <128, 28.8, 8> }
            object { rounded_button() translate <128, 28.8, 16> }
            object { rounded_button() translate <136, 22.4, 8> }
            object { rounded_button() translate <136, 22.4, 16> }
          #end
          box { <131.8, 16, 4.1> <139.9, 25.5, 19.9> }
        }
        #if (setting > 1)
          difference {
            box { <131.900001, 0, 5.6> <138.4, 24.6, 18.4> }
            box { <131, 16.000001, 7.5> <133.6, 25, 8.5> }
            box { <131, 16.000001, 15.5> <133.6, 25, 16.5> }
            cylinder { 16.000001*y, 25*y, 1.5 translate <136, 0, 12> }
          }
          difference {
            box { <69.3, 0, 4.5> <130.4, 11.6, 19.5> }
            box { <71.5, 9.600001, 4> <72.5, 12, 5.6> }
            box { <79.5, 9.600001, 4> <80.5, 12, 5.6> }
            box { <87.5, 9.600001, 4> <88.5, 12, 5.6> }
            box { <95.5, 9.600001, 4> <96.5, 12, 5.6> }
            box { <103.5, 9.600001, 4> <104.5, 12, 5.6> }
            box { <111.5, 9.600001, 4> <112.5, 12, 5.6> }
            box { <119.5, 9.600001, 4> <120.5, 12, 5.6> }
            box { <127.5, 9.600001, 4> <128.5, 12, 5.6> }
            box { <71.5, 9.600001, 18.4> <72.5, 12, 20> }
            box { <79.5, 9.600001, 18.4> <80.5, 12, 20> }
            box { <87.5, 9.600001, 18.4> <88.5, 12, 20> }
            box { <95.5, 9.600001, 18.4> <96.5, 12, 20> }
            box { <103.5, 9.600001, 18.4> <104.5, 12, 20> }
            box { <111.5, 9.600001, 18.4> <112.5, 12, 20> }
            box { <119.5, 9.600001, 18.4> <120.5, 12, 20> }
            box { <127.5, 9.600001, 18.4> <128.5, 12, 20> }
            object { ring() translate <76, 9.600002, 12> }
            object { ring() translate <84, 9.600002, 12> }
            object { ring() translate <92, 9.600002, 12> }
            object { ring() translate <100, 9.600002, 12> }
            object { ring() translate <108, 9.600002, 12> }
            object { ring() translate <116, 9.600002, 12> }
            object { ring() translate <124, 9.600002, 12> }
          }
          cylinder { 9*y, 19.1*y, 2.600003 translate <124, 0, 12> }
          box { <23.75, 13, -1.5> <24.25, 50, 1.5> }
          box { <25.75, 13, -1.5> <26.25, 50, 1.5> }
          box { <29.75, 13, -1.5> <30.25, 50, 1.5> }
          box { <31.75, 13, -1.5> <32.25, 50, 1.5> }
          box { <23.75, 13, 22.5> <24.25, 50, 25.5> }
          box { <25.75, 13, 22.5> <26.25, 50, 25.5> }
          box { <29.75, 13, 22.5> <30.25, 50, 25.5> }
          box { <31.75, 13, 22.5> <32.25, 50, 25.5> }
          box { <12, 38.3, 3.9> <44.1, 42, 19.9> }
          box { <-2.4, 9, 5.6> <10.4, 18.2, 18.4> }
          box { <11.9, 9, 0> <12.100001, 12.7, 20> }
          cylinder { 17*y, 20.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 17*y, 20.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 17*y, 20.4*y, 1.2 translate <0, 0, 16> }
          cylinder { 17*y, 20.4*y, 1.2 translate <8, 0, 16> }
          box { <13.6, -1, 5.6> <26.4, 2.000002, 18.4> }
          box { <45.6, -1, 5.6> <50.4, 2, 18.4> }
          difference {
            box { <27.9, -1, -4> <44.1, 11.6, 28> }
            box { <27, 9.6, -5> <45, 12, -2.4> }
            box { <24, 9.6, -0.5> <29.2, 12, 0.5> }
            box { <24, 9.6, 7.5> <29.2, 12, 8.5> }
            box { <24, 9.6, 15.5> <29.2, 12, 16.5> }
            box { <24, 9.6, 23.5> <29.2, 12, 24.5> }
            box { <42.8, 9.6, -0.5> <45, 12, 0.5> }
            box { <42.8, 9.6, 7.5> <45, 12, 8.5> }
            box { <42.8, 9.6, 15.5> <45, 12, 16.5> }
            box { <42.8, 9.6, 23.5> <45, 12, 24.5> }
            box { <27, 9.6, 26.4> <45, 12, 29> }
            object { ring() translate <36, 9.6, 4> }
            object { ring() translate <36, 9.6, 12> }
            object { ring() translate <36, 9.6, 20> }
          }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <48, 0, 12> }
        object { ring() translate <20, 0, 12> }
        object { high_ring() translate <4, 9.600004, 12> }
      #end
      #if (setting < 3)
        cylinder { 38.2*y, 40*y, 2.4 translate <16, 0, 8> }
        cylinder { 38.2*y, 40*y, 2.4 translate <24, 0, 8> }
        cylinder { 38.2*y, 40*y, 2.4 translate <32, 0, 8> }
        cylinder { 38.2*y, 40*y, 2.4 translate <40, 0, 8> }
        cylinder { 38.2*y, 40*y, 2.4 translate <16, 0, 16> }
        cylinder { 38.2*y, 40*y, 2.4 translate <24, 0, 16> }
        cylinder { 38.2*y, 40*y, 2.4 translate <32, 0, 16> }
        cylinder { 38.2*y, 40*y, 2.4 translate <40, 0, 16> }
      #else
        object { rounded_button() translate <16, 35.2, 8> }
        object { rounded_button() translate <24, 35.2, 8> }
        object { rounded_button() translate <32, 35.2, 8> }
        object { rounded_button() translate <40, 35.2, 8> }
        object { rounded_button() translate <16, 35.2, 16> }
        object { rounded_button() translate <24, 35.2, 16> }
        object { rounded_button() translate <32, 35.2, 16> }
        object { rounded_button() translate <40, 35.2, 16> }
      #end
      texture { grey2_tex }
      bounded_by { box { <-4, -0.1, -4> <157.1, 43.1, 28> } }
    }
  #end
#end
#macro insectoid_leg1(color_tex)
  #if (setting = 0)
    merge {
      box { <-0.000001, 3.200001, -3.900002> <13.500001, 6.300001, 3.900002> }
      difference {
        box { <13.5, 6.4, -3.9> <32, 30, 3.9> }
        box { <-40, 3.75, -5> <10, 30, 5> rotate 34*z translate <32, 26.4, 0> }
        box { <-40, -40, -15> <10, 0, 15> rotate 45*z translate <32, 23.6, 0> }
      }
        difference {
          merge {
            box { <31.999999, 0, -3.900004> <52, 31.75, 3.900004> }
            box { <52, 0.000001, -3.900001> <54, 3.100002, 3.900001> }
          }
          box { <-10, -1, -5> <0, 10, 5> rotate -58*z translate <32, 28, 0> }
          box { <-20, 3.75, -5> <40, 30, 5> rotate -58*z translate <32, 28, 0> }
          box { <-20, -40, -5> <40, 0, 5> rotate -46*z translate <32, 21.5, 0> }
        }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          merge {
            cylinder { 3.2*y, 6.3*y, 3.9 }
            box { <-0.000001, 3.200001, -3.900001> <13.500001, 6.300001, 3.900001> }
          }
          box { <0, 0, -10> <40, 40, 0> rotate -4*y translate <11.999999, 0, -3.900001> }
          box { <0, 0, 0> <40, 40, 10> rotate 4*y translate <11.999999, 0, 3.900001> }
          #if (setting > 1)
            cylinder { 3*y, 5.4*y, 2.4 }
            box { <-0.000001, 3, -2.4> <12, 5.400001, 2.4> }
          #end
        }
        difference {
          cylinder { 0*y, 3.1*y, 3.9 translate <56, 0, 0> }
          box { <-20, -40, -5> <40, 0, 5> rotate -46*z translate <32, 21.5, 0> }
          #if (setting > 1)
            cylinder { -1*y, 2*y, 2.6 translate <56, 0, 0> }
          #end
        }
        object { open_rounded_button() translate <56, 0, 0> }
        object { open_rounded_button() translate <0, 3.2, 0> }
        object { open_rounded_button() translate <8, 3.2, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <56, 3.1, 0> }
        #end
        difference {
          cylinder { 0*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <8, 0, 0>
        }
        box { <2.4, 3.200001, -0.5> <5, 5.5, 0.5> }
        cylinder { -3.1*z, 3.1*z, 3.75 translate <32, 28, 0> }
        object { open_rounded_button() rotate 90*x translate <32, 28, -0.1> }
        object { open_rounded_button() rotate -90*x translate <32, 28, 0.1> }
        difference {
          box { <12.000001, 3.2, -3.9> <32, 31.75, 3.9> }
          box { <0, -1, -5> <10, 10, 5> rotate 34*z translate <32, 28, 0> }
          box { <-40, 3.75, -5> <2.5, 30, 5> rotate 34*z translate <32, 28, 0> }
          box { <-40, -30, -5> <0, 0, 5> rotate 45*z translate <32, 21.5, 0> }
          box { <0, 0, -10> <40, 40, 0> rotate -4*y translate <11.999999, 0, -3.9> }
          box { <0, 0, 0> <40, 40, 10> rotate 4*y translate <11.999999, 0, 3.9> }
          difference {
            box { <13.5, 6.4, -10> <30.6, 30, 10> }
            box { <-40, 3.75, -15> <10, 30, 15> rotate 34*z translate <32, 26.4, 0> }
            box { <-40, -40, -15> <10, 0, 15> rotate 45*z translate <32, 23.6, 0> }
            box { <13, 6, -0.5> <31, 31, 0.5> }
            difference {
              box { <-2, -2, -15> <0, 0, 15> }
              cylinder { -14*z, 14*z, 1 }
              translate <14.5, 7.4, 0>
            }
          }
        }
        difference {
          merge {
            box { <31.999999, 0, -2.5> <52, 31.75, 2.5> }
            box { <52, 0.000001, -2.500001> <54, 3.100002, 2.500001> }
          }
          box { <-10, -1, -5> <0, 10, 5> rotate -58*z translate <32, 28, 0> }
          box { <-20, 3.75, -5> <40, 30, 5> rotate -58*z translate <32, 28, 0> }
          box { <-20, -40, -5> <40, 0, 5> rotate -46*z translate <32, 21.5, 0> }
          difference {
            box { <33, 10, -10> <46, 30, 10> }
            box { <-10, 3.75, -15> <40, 30, 15> rotate -58*z translate <32, 26, 0> }
            box { <-10, -40, -15> <40, 0, 15> rotate -46*z translate <32, 23.4, 0> }
            box { <32, 6, -0.5> <53, 31, 0.5> }
            difference {
              box { <0, -2, -15> <2, 0, 15> }
              cylinder { -14*z, 14*z, 1 }
              translate <45, 11, 0>
            }
          }
        }
        box { <52, 1.5, -2.500002> <54, 3.100005, 2.500002> }
      }
      difference {
        box { <15.5, 5, -4> <30, 30, 4> }
        box { <-40, 3.75, -15> <20, 30, 15> rotate 34*z translate <32, 23.4, 0> }
        box { <-40, -30, -15> <20, 0, 15> rotate 45*z translate <32, 26.6, 0> }
        cylinder { -5*z, 5*z, 6 translate <32, 28, 0> }
        difference {
          box { <-2, -2, -15> <0, 0, 15> }
          cylinder { -14*z, 14*z, 1 }
          translate <16.5, 11.5, 0>
        }
      }
      #if (setting > 1)
        cylinder { 0*y, 10*y, 1.600001 }
        cylinder { 0*y, 10*y, 1.600001 translate <8, 0, 0> }
        cylinder { -10*z, 10*z, 1.600001 translate <32, 28, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4.9> <60, 31.85, 4.9> } }
    }
  #end
#end
#macro insectoid_wing_large(color_tex)
  #if (setting = 0)
    difference {
      box { <4, -0.75, -10.4> <150, 0.75, 22> }
      box { <0, -1, 0> <100, 1, 20> rotate -20*y translate <0, 0, 2.5> }
      box { <0, -1, -20> <100, 1, 0> rotate -13.75*y translate <69, 0, -10.4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { -4*x, 5.5*x, 3.9 }
          sphere { <5.5, 0, 0> 3.9 }
          #if (setting < 3)
            cylinder { -2.45*y, 2.45*y, 2.4 translate <66, 0, -7> }
            cylinder { -2.45*y, 2.45*y, 2.4 translate <138, 0, 17.25> }
          #else
            object { open_rounded_button() translate <66, -2.25, -7> }
            object { open_rounded_button() translate <138, -2.25, 17.25> }
            object { open_rounded_button() rotate 180*x translate <66, 2.25, -7> }
            object { open_rounded_button() rotate 180*x translate <138, 2.25, 17.25> }
          #end
        }
        cylinder { -3*y, 3*y, 1.600001 translate <66, 0, -7> }
        cylinder { -3*y, 3*y, 1.600001 translate <138, 0, 17.25> }
        difference {
          box { <-5, -5, -5> <0, 5, 5> }
          cylinder { -6*y, 6*y, 3.900001 }
        }
        box { <-4, 2.35, -6> <4.1, 0.65, 6> rotate 90*x }
        box { <-4, -2.35, -6> <4.1, -0.65, 6> rotate 90*x }
        box { <5.5, -4, -2.35> <10, 4, 2.35> }
      }
      difference {
        box { <4, -0.75, -10.4> <150, 0.75, 22> }
        cylinder { -4*y, 4*y, 1.600001 translate <66, 0, -7> }
        cylinder { -4*y, 4*y, 1.600001 translate <138, 0, 17.25> }
        box { <0, -1, -20> <30, 1, 0> rotate 19.5*y translate <0, 0, -2.5> }
        box { <0, -1, 0> <60, 1, 20> rotate -20*y translate <0, 0, 2.5> }
        box { <0, -1, -20> <80, 1, 0> rotate -13.75*y translate <69, 0, -10.4> }
        difference {
          box { <146.75, -1, 15> <151, 1, 23> }
          cylinder { -2*y, 2*y, 2.25 translate <146.75, 0, 19.75> }
          box { <-10, -2, -2.25> <0, 2, 10> rotate -38*y translate <146.75, 0, 19.75> }
        }
        box { <-30, -2, -50> <10, 2, -2.25> rotate -38*y translate <146.75, 0, 19.75> }
      }
      cylinder { 2.1*z, 2.4*z, 0.9 }
      cylinder { -2.1*z, -2.4*z, 0.9 }
      texture { color_tex }
      bounded_by { box { <-4, -4, -10.5> <149.1, 4, 22.1> } }
    }
  #end
#end
#macro inv_ramp4_11(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <83.9, 22.3, 27.9> }
      box { <67.9, -1, -4> <84, 9.6, 28> }
      box { <-100, -50, -10> <100, 0, 30> rotate -20.75*z translate <44, 0, 0> }
      box { <-4, 19.1, -4> <44.1, 23, 28> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <83.9, 22.3, 27.9> }
          #if (setting < 3)
            cylinder { 22.2*y, 24*y, 2.4 translate <72, 0, 0> }
            cylinder { 22.2*y, 24*y, 2.4 translate <80, 0, 0> }
            cylinder { 22.2*y, 24*y, 2.4 translate <72, 0, 24> }
            cylinder { 22.2*y, 24*y, 2.4 translate <80, 0, 24> }
          #else
            object { rounded_button() translate <72, 19.2, 0> }
            object { rounded_button() translate <80, 19.2, 0> }
            object { rounded_button() translate <72, 19.2, 24> }
            object { rounded_button() translate <80, 19.2, 24> }
          #end
        }
        difference {
          box { <-2.4, 3.100001, -2.4> <66.4, 24, 26.4> }
          box { <-100, -50, -10> <20, 0, 30> rotate -20.75*z translate <44, 1, 0> }
          box { <-100, -50, -50> <100, 0, 50> rotate 46.5*x rotate -20.75*z translate <68, 1, -2.4> }
          box { <-100, -50, -50> <100, 0, 50> rotate -46.5*x rotate -20.75*z translate <68, 1, 26.4> }
          box { <-100, -10, -50> <20, 30, 0> rotate 18.4*y translate <20, 0, -2.4> }
          box { <-100, -10, 0> <20, 30, 50> rotate -18.4*y translate <20, 0, 26.4> }
          box { <43, 0, 2.5> <68, 12.8, 4> }
          box { <43, 2, -3> <43.999999, 24.99, 4.000002> }
          box { <11, 2, 3> <43.5, 24.98, 4.000001> }
          box { <8, 2, -0.5> <22, 24.98, 0.5> }
          box { <11.000001, 2, 3.000001> <12, 24.980001, 21.000001> }
          box { <19.000001, 2, 3.000001> <20, 15.900001, 21.000001> }
          box { <35.000001, 2, 3.000001> <36, 12.700001, 21.000001> }
          box { <43.000001, 2, 3.000001> <44.000001, 6.300001, 21.000001> }
          box { <-2.6, 2, 7.5> <-2, 24.98, 8.5> }
          box { <2, 2, 7.5> <6, 24.98, 8.5> }
          box { <10, 2, 7.5> <11.25, 24.980002, 8.5> }
          box { <11.5, 2, 7.5> <14, 15.900002, 8.5> }
          box { <18, 2, 7.5> <19.25, 15.900002, 8.5> }
          box { <19.5, 2, 7.5> <22, 12.700002, 8.5> }
          box { <26, 2, 7.5> <30, 12.700002, 8.5> }
          box { <34, 2, 7.5> <35.25, 12.700002, 8.5> }
          box { <35.5, 2, 7.5> <38, 6.300002, 8.5> }
          box { <42, 2, 7.5> <43.25, 6.300002, 8.5> }
          box { <43, 0, 20> <68, 12.8, 21.5> }
          box { <43, 2, 20.000002> <43.999999, 24.99, 27> }
          box { <11, 2, 20.000001> <43.5, 24.98, 21> }
          box { <8, 2, 23.5> <22, 24.98, 24.5> }
          box { <-2.6, 2, 15.5> <-2, 24.98, 16.5> }
          box { <2, 2, 15.5> <6, 24.98, 16.5> }
          box { <10, 2, 15.5> <11.25, 24.980002, 16.5> }
          box { <11.5, 2, 15.5> <14, 15.900002, 16.5> }
          box { <18, 2, 15.5> <19.25, 15.900002, 16.5> }
          box { <19.5, 2, 15.5> <22, 12.700002, 16.5> }
          box { <26, 2, 15.5> <30, 12.700002, 16.5> }
          box { <34, 2, 15.5> <35.25, 12.700002, 16.5> }
          box { <35.5, 2, 15.5> <38, 6.300002, 16.5> }
          box { <42, 2, 15.5> <43.25, 6.300002, 16.5> }
        }
        box { <-4, 19.1, -4> <44.1, 23, 28> }
        box { <44, 3.1, 4.000001> <84, 25, 19.999999> }
        box { <67.9, -1, -4> <84, 9.6, 28> }
        box { <67.900001, -1, 4> <84, 21, 20> }
        box { <-100, -10, -50> <20, 30, 0> rotate 18.4*y translate <20, 0, -4> }
        box { <-100, -10, 0> <100, 30, 50> rotate -18.4*y translate <20, 0, 28> }
        box { <-100, -50, -10> <100, 0, 30> rotate -20.75*z translate <44, 0, 0> }
        box { <-100, -50, -50> <100, 0, 50> rotate 46.5*x rotate -20.75*z translate <68, 0, -4> }
        box { <-100, -50, -50> <100, 0, 50> rotate -46.5*x rotate -20.75*z translate <68, 0, 28> }
        #if (setting > 1)
          box { <68.000001, -1, -2.4> <82.4, 21.4, 2.4> }
          box { <68.000001, -1, 21.6> <82.4, 21.4, 26.4> }
          box { <44.6, -1, 5.6> <66.4, 2, 18.4> }
          difference {
            box { <50, -1, -2.4> <66.4, 2, 26.4> }
            box { <40, -1, 4.000001> <70, 2.8, 20.000001> }
            box { <-100, -10, -50> <20, 30, 0> rotate 18.4*y translate <66.4, 0, -2> }
            box { <-100, -10, 0> <20, 30, 50> rotate -18.4*y translate <66.4, 0, 26> }
          }
          cylinder { -1*y, 1.7*y, 2.5 translate <40, 0, 8> }
          cylinder { -1*y, 1.7*y, 2.5 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 16> }
        #end
      }
      difference {
        merge {
          object { open_rounded_button() translate <0, 16, 8> }
          object { open_rounded_button() translate <0, 16, 16> }
          object { open_rounded_button() translate <8, 16, 8> }
          object { open_rounded_button() translate <8, 16, 16> }
          object { open_rounded_button() translate <24, 16, 0> }
          object { open_rounded_button() translate <24, 16, 24> }
          object { open_rounded_button() translate <32, 16, 0> }
          object { open_rounded_button() translate <32, 16, 24> }
          object { open_rounded_button() translate <40, 16, 0> }
          object { open_rounded_button() translate <40, 16, 24> }
          difference {
            cylinder { 0*y, 19.000001*y, 2.400001 }
            cylinder { -1*y, 20*y, 1.600001 }
            translate <0, 0, 8>
          }
          difference {
            cylinder { 0*y, 19.000001*y, 2.400001 }
            cylinder { -1*y, 20*y, 1.600001 }
            translate <8, 0, 8>
          }
          difference {
            cylinder { 0*y, 19.000001*y, 2.400001 }
            cylinder { -1*y, 20*y, 1.600001 }
            translate <0, 0, 16>
          }
          difference {
            cylinder { 0*y, 19.000001*y, 2.400001 }
            cylinder { -1*y, 20*y, 1.600001 }
            translate <8, 0, 16>
          }
          difference {
            cylinder { 0*y, 19.000001*y, 2.400001 }
            cylinder { -1*y, 20*y, 1.600001 }
            translate <24, 0, 0>
          }
          difference {
            cylinder { 0*y, 19.000001*y, 2.400001 }
            cylinder { -1*y, 20*y, 1.600001 }
            translate <32, 0, 0>
          }
          difference {
            cylinder { 0*y, 19.000001*y, 2.400001 }
            cylinder { -1*y, 20*y, 1.600001 }
            translate <40, 0, 0>
          }
          difference {
            cylinder { 0*y, 19.000001*y, 2.400001 }
            cylinder { -1*y, 20*y, 1.600001 }
            translate <24, 0, 24>
          }
          difference {
            cylinder { 0*y, 19.000001*y, 2.400001 }
            cylinder { -1*y, 20*y, 1.600001 }
            translate <32, 0, 24>
          }
          difference {
            cylinder { 0*y, 19.000001*y, 2.400001 }
            cylinder { -1*y, 20*y, 1.600001 }
            translate <40, 0, 24>
          }
          object { open_rounded_button() translate <16, 12.8, 8> }
          object { open_rounded_button() translate <16, 12.8, 16> }
          difference {
            cylinder { 0*y, 15.800001*y, 2.400001 }
            cylinder { -1*y, 16*y, 1.600001 }
            translate <16, 0, 8>
          }
          difference {
            cylinder { 0*y, 15.800001*y, 2.400001 }
            cylinder { -1*y, 16*y, 1.600001 }
            translate <16, 0, 16>
          }
          object { open_rounded_button() translate <24, 9.6, 8> }
          object { open_rounded_button() translate <24, 9.6, 16> }
          object { open_rounded_button() translate <32, 9.6, 8> }
          object { open_rounded_button() translate <32, 9.6, 16> }
          difference {
            cylinder { 0*y, 12.600001*y, 2.400001 }
            cylinder { -1*y, 13*y, 1.600001 }
            translate <24, 0, 8>
          }
          difference {
            cylinder { 0*y, 12.600001*y, 2.400001 }
            cylinder { -1*y, 13*y, 1.600001 }
            translate <24, 0, 16>
          }
          difference {
            cylinder { 0*y, 12.600001*y, 2.400001 }
            cylinder { -1*y, 13*y, 1.600001 }
            translate <32, 0, 8>
          }
          difference {
            cylinder { 0*y, 12.600001*y, 2.400001 }
            cylinder { -1*y, 13*y, 1.600001 }
            translate <32, 0, 16>
          }
          object { open_rounded_button() translate <40, 6.4, 8> }
          object { open_rounded_button() translate <40, 6.4, 16> }
          difference {
            cylinder { 0*y, 9.400001*y, 2.400001 }
            cylinder { -1*y, 10*y, 1.600001 }
            translate <40, 0, 8>
          }
          difference {
            cylinder { 0*y, 9.400001*y, 2.400001 }
            cylinder { -1*y, 10*y, 1.600001 }
            translate <40, 0, 16>
          }
        }
        box { <-100, -50, -10> <20, 0, 30> rotate -20.75*z translate <44, 1, 0> }
        box { <-100, -50, -50> <100, 0, 50> rotate 46.5*x rotate -20.75*z translate <68, 1, -2.4> }
        box { <-100, -50, -50> <100, 0, 50> rotate -46.5*x rotate -20.75*z translate <68, 1, 26.4> }
        box { <-100, -10, -50> <20, 30, 0> rotate 18.4*y translate <20, 0, -2.4> }
        box { <-100, -10, 0> <20, 30, 50> rotate -18.4*y translate <20, 0, 26.4> }
      }
      #if (setting < 3)
        cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 16> }
      #else
        object { rounded_button() translate <48, 0, 8> }
        object { rounded_button() translate <48, 0, 16> }
        object { rounded_button() translate <56, 0, 8> }
        object { rounded_button() translate <56, 0, 16> }
        object { rounded_button() translate <64, 0, 8> }
        object { rounded_button() translate <64, 0, 16> }
      #end
      box { <67.5, 9.600001, -0.5> <69.5, 21.5, 0.5> }
      box { <67.5, 9.600001, 23.5> <69.5, 21.5, 24.5> }
      #if (setting > 1)
        cylinder { 9.6*y, 21.5*y, 1.5 translate <76, 0, 0> }
        cylinder { 9.6*y, 21.5*y, 1.5 translate <76, 0, 24> }
        box { <44.4, 0.000001, 7.5> <45.5, 2.1, 8.5> }
        box { <44.4, 0.000001, 15.5> <45.5, 2.1, 16.5> }
        object { ring() translate <52, 0, 12> }
        object { ring() translate <60, 0, 12> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <84, 24.1, 28> } }
    }
  #end
#end
#macro inv_ramp4_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
      box { <-10, -10, -20> <30, 20, 0> rotate -44*x translate <0, 0, 4> }
      box { <-10, -10, 0> <30, 20, 20> rotate 44*x translate <0, 0, 20> }
      box { <-20, -10, -20> <30, 10, 0> rotate -18.4*y translate <4, 0, -3.9> }
      box { <-20, -10, 0> <30, 10, 20> rotate 18.4*y translate <4, 0, 27.9> }
      box { <-10, -20, -10> <40, 0, 30> rotate 19*z translate <4, 0, 0> }
      box { <-20, -20, -30> <40, 0, 30> rotate <47.5, -18.4, 0> translate <4, 0, 4> }
      box { <-20, -20, -30> <40, 0, 30> rotate <-47.5, 18.4, 0> translate <4, 0, 20> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
        box { <-10, -10, -20> <30, 20, 0> texture { color_tex normal { bumping } }
          rotate -44*x translate <0, 0, 4> }
        box { <-10, -10, 0> <30, 20, 20> texture { color_tex normal { bumping } }
          rotate 44*x translate <0, 0, 20> }
        box { <-20, -10, -20> <30, 10, 0> rotate -18.4*y translate <4, 0, -3.9> }
        box { <-20, -10, 0> <30, 10, 20> rotate 18.4*y translate <4, 0, 27.9> }
        box { <-10, -20, -10> <40, 0, 30> texture { color_tex normal { bumping } }
          rotate 19*z translate <4, 0, 0> }
        box { <-20, -20, -30> <40, 0, 30> texture { color_tex normal { bumping } }
          rotate <47.5, -18.4, 0> translate <4, 0, 4> }
        box { <-20, -20, -30> <40, 0, 30> texture { color_tex normal { bumping } }
          rotate <-47.5, 18.4, 0> translate <4, 0, 20> }
        #if (setting > 1)
          difference {
            box { <-3.1, 1, -3.1> <27.1, 10, 27.1> }
            box { <-4, 0, 3.100001> <13, 11, 20.900001> }
            box { <-10, -10, -20> <30, 20, 0> rotate -44*x translate <0, 2, 4> }
            box { <-10, -10, 0> <30, 20, 20> rotate 44*x translate <0, 2, 20> }
            box { <-10, -20, -10> <40, 0, 30> rotate 19*z translate <4, 1, 0> }
            box { <-20, -20, -30> <40, 0, 30> rotate 47.5*x rotate -18.4*y translate <4, 2, 4> }
            box { <-20, -20, -30> <40, 0, 30> rotate -47.5*x rotate 18.4*y translate <4, 2, 20> }
            box { <-20, -10, -20> <30, 10, 0.8> rotate -18.4*y translate <4, 0, -3.9> }
            box { <-20, -10, -0.8> <30, 10, 20> rotate 18.4*y translate <4, 0, 27.9> }
          }
          difference {
            box { <-4, 0, 3.9> <12.1, 11, 20.1> }
            box { <-10, -20, -10> <40, 0, 30> rotate 19*z translate <4, 1.000002, 0> }
            box { <-5, -1, 3.8> <3.9, 3.1, 20.2> }
          }
          box { <-2.4, -1, 5.6> <2.4, 2, 18.4> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
        #end
      }
      #if (setting > 0 & setting < 3)
        object { pin(1) translate <0, 0, 12> }
        cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
        difference {
          merge {
            object { high_open_rounded_button() translate <24, 0, 8> }
            object { high_open_rounded_button() translate <24, 0, 16> }
            box { <18, 0, 7.5> <22, 9.499999, 8.5> }
            box { <18, 0, 15.5> <22, 9.499999, 16.5> }
            object { high_open_rounded_button() translate <16, 0, 8> }
            object { high_open_rounded_button() translate <16, 0, 16> }
            box { <13, 0, 7.5> <14, 9.499999, 8.5> }
            box { <13, 0, 15.5> <14, 9.499999, 16.5> }
            object { high_open_rounded_button() translate <8, -3.2, 8> }
            object { high_open_rounded_button() translate <8, -3.2, 16> }
            box { <10, 0, 7.5> <12.2, 6.299999, 8.5> }
            box { <10, 0, 15.5> <12.2, 6.299999, 16.5> }
            box { <4.1, 0, 7.5> <6, 6.299999, 8.5> }
            box { <4.1, 0, 15.5> <6, 6.299999, 16.5> }
          }
          box { <-10, -20, -10> <40, 0, 30> rotate 19*z translate <4, 1.000001, 0> }
        }
        difference {
          object { high_open_rounded_button() }
          box { <-10, -10, -20> <30, 20, 0> rotate -44*x translate <0, 2, 4> }
        }
        difference {
          object { high_open_rounded_button() translate <0, 0, 24> }
          box { <-10, -10, 0> <30, 20, 20> rotate 44*x translate <0, 2, 20> }
        }
      #end
      #if (setting > 2)
        object { pin(1) translate <0, 0, 12> }
        object { rounded_button() rotate 180*y translate <0, 0, 8> }
        object { rounded_button() rotate 180*y translate <0, 0, 16> }
        difference {
          merge {
            object { high_open_rounded_button() translate <24, 0, 8> }
            object { high_open_rounded_button() translate <24, 0, 16> }
            box { <18, 0, 7.5> <22, 9.499999, 8.5> }
            box { <18, 0, 15.5> <22, 9.499999, 16.5> }
            object { high_open_rounded_button() translate <16, 0, 8> }
            object { high_open_rounded_button() translate <16, 0, 16> }
            box { <13, 0, 7.5> <14, 9.499999, 8.5> }
            box { <13, 0, 15.5> <14, 9.499999, 16.5> }
            object { high_open_rounded_button() translate <8, -3.2, 8> }
            object { high_open_rounded_button() translate <8, -3.2, 16> }
            box { <10, 0, 7.5> <12.2, 6.299999, 8.5> }
            box { <10, 0, 15.5> <12.2, 6.299999, 16.5> }
            box { <4.1, 0, 7.5> <6, 6.299999, 8.5> }
            box { <4.1, 0, 15.5> <6, 6.299999, 16.5> }
          }
          box { <-10, -20, -10> <40, 0, 30> rotate 19*z translate <4, 1.000001, 0> }
        }
        difference {
          object { high_open_rounded_button() }
          box { <-10, -10, -20> <30, 20, 0> rotate -44*x translate <0, 2, 4> }
        }
        difference {
          object { high_open_rounded_button() translate <0, 0, 24> }
          box { <-10, -10, 0> <30, 20, 20> rotate 44*x translate <0, 2, 20> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 28> } }
    }
  #end
#end
#macro inv_ramp6_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 9.5, 27.9> }
      box { <-20, -20, -10> <40, 0, 30> rotate 19*z translate <20, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <43.9, 9.5, 27.9> }
        box { <-20, -10, -20> <50, 10, 0> rotate -18.4*y translate <20, 0, -3.9> }
        box { <-20, -10, 0> <50, 10, 20> rotate 18.4*y translate <20, 0, 27.9> }
        #if (setting > 1)
          box { <-2.4, -1, 5.6> <18.4, 2, 18.4> }
          cylinder { -1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { -1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { -1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { -1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { -1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { -1*y, 4*y, 1.2 translate <16, 0, 16> }
        #end
        box { <-20, -20, -10> <40, 0, 30> texture { color_tex normal { bumping } }
          rotate 19*z translate <20, 0, 0> }
        box { <-30, -20, -20> <50, 0, 20> texture { color_tex normal { bumping } }
          rotate <47.5, -18.4, 0> translate <20, 0, 4> }
        box { <-30, -20, -20> <50, 0, 20> texture { color_tex normal { bumping } }
          rotate <-47.5, 18.4, 0> translate <20, 0, 20> }
        difference {
          box { <-3.1, 1, -3.1> <43.1, 10, 27.1> }
          box { <-5, 0, 3.100001> <28.8, 11, 20.900001> }
          box { <-20, -20, -10> <40, 0, 30> rotate 19*z translate <20, 1, 0> }
          box { <-30, -20, -20> <50, 0, 20> rotate 47.5*x rotate -18.4*y translate <20, 2, 4.5> }
          box { <-30, -20, -20> <50, 0, 20> rotate -47.5*x rotate 18.4*y translate <20, 2, 19.5> }
        }
        difference {
          box { <-4, 0, 3.9> <28.1, 10, 20.1> }
          box { <-20, -20, -10> <40, 0, 30> rotate 19*z translate <20, 1.000002, 0> }
          box { <-5, -1, 4> <19.9, 3.1, 20.2> }
        }
      }
      difference {
        merge {
          object { open_rounded_button() translate <32, 6.4, 8> }
          object { open_rounded_button() translate <32, 6.4, 16> }
          object { open_rounded_button() translate <40, 6.4, 8> }
          object { open_rounded_button() translate <40, 6.4, 16> }
          object { open_rounded_button() translate <0, 6.4, 0> }
          object { open_rounded_button() translate <0, 6.4, 24> }
          object { open_rounded_button() translate <8, 6.4, 0> }
          object { open_rounded_button() translate <8, 6.4, 24> }
          object { open_rounded_button() translate <16, 6.4, 0> }
          object { open_rounded_button() translate <16, 6.4, 24> }
          difference {
            cylinder { 3*y, 9.400001*y, 2.4 }
            cylinder { 2*y, 12*y, 1.6000001 }
            translate <32, 0, 8>
          }
          difference {
            cylinder { 3*y, 9.400001*y, 2.4 }
            cylinder { 2*y, 12*y, 1.600001 }
            translate <32, 0, 16>
          }
          difference {
            cylinder { 3*y, 9.400001*y, 2.4 }
            cylinder { 2*y, 12*y, 1.600001 }
            translate <40, 0, 8>
          }
          difference {
            cylinder { 3*y, 9.400001*y, 2.4 }
            cylinder { 2*y, 12*y, 1.600001 }
            translate <40, 0, 16>
          }
          difference {
            cylinder { 3*y, 9.400001*y, 2.4 }
            cylinder { 2*y, 12*y, 1.600001 }
          }
          difference {
            cylinder { 3*y, 9.400001*y, 2.4 }
            cylinder { 2*y, 12*y, 1.600001 }
            translate <0, 0, 24>
          }
          difference {
            cylinder { 3*y, 9.400001*y, 2.4 }
            cylinder { 2*y, 12*y, 1.600001 }
            translate <8, 0, 0>
          }
          difference {
            cylinder { 3*y, 9.400001*y, 2.4 }
            cylinder { 2*y, 12*y, 1.600001 }
            translate <8, 0, 24>
          }
          difference {
            cylinder { 3*y, 9.400001*y, 2.4 }
            cylinder { 2*y, 12*y, 1.600001 }
            translate <16, 0, 0>
          }
          difference {
            cylinder { 3*y, 9.400001*y, 2.4 }
            cylinder { 2*y, 12*y, 1.600001 }
            translate <16, 0, 24>
          }
          difference {
            cylinder { 1*y, 6.200001*y, 2.4 }
            cylinder { 2*y, 12*y, 1.600001 }
            translate <24, 0, 8>
          }
          difference {
            cylinder { 1*y, 6.200001*y, 2.4 }
            cylinder { 2*y, 12*y, 1.600001 }
            translate <24, 0, 16>
          }
          object { open_rounded_button() translate <24, 3.2, 8> }
          object { open_rounded_button() translate <24, 3.2, 16> }
          box { <29.5, 0, 7.5> <30, 9.499999, 8.5> }
          box { <29.5, 0, 15.5> <30, 9.499999, 16.5> }
          box { <34, 0, 7.5> <38, 9.499999, 8.5> }
          box { <34, 0, 15.5> <38, 9.499999, 16.5> }
          box { <19.5, 0, 7.5> <22, 6.299999, 8.5> }
          box { <19.5, 0, 15.5> <22, 6.299999, 16.5> }
          box { <26, 0, 7.5> <30, 6.299999, 8.5> }
          box { <26, 0, 15.5> <30, 6.299999, 16.5> }
          box { <2, 0, -0.5> <6, 9.499999, 0.5> }
          box { <2, 0, 23.5> <6, 9.499999, 24.5> }
          box { <10, 0, -0.5> <14, 9.499999, 0.5> }
          box { <10, 0, 23.5> <14, 9.499999, 24.5> }
        }
        box { <-20, -20, -10> <40, 0, 30> rotate 19*z translate <20, 1.000001, 0> }
        box { <-30, -20, -20> <50, 0, 20> rotate 47.5*x rotate -18.4*y translate <20, 2, 4.5> }
        box { <-30, -20, -20> <50, 0, 20> rotate -47.5*x rotate 18.4*y translate <20, 2, 19.5> }
      }
      object { ring() translate <4, 0, 12> }
      object { ring() translate <12, 0, 12> }
      #if (setting < 3)
        cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
      #else
        object { rounded_button() rotate 180*y translate <0, 0, 8> }
        object { rounded_button() rotate 180*y translate <0, 0, 16> }
        object { rounded_button() rotate 180*y translate <8, 0, 8> }
        object { rounded_button() rotate 180*y translate <8, 0, 16> }
        object { rounded_button() rotate 180*y translate <16, 0, 8> }
        object { rounded_button() rotate 180*y translate <16, 0, 16> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 11.3, 28> } }
    }
  #end
#end
#macro inv_ramp6_5(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <35.9, 19.1, 43.9> }
      box { <-10, -20, -10> <50, 0, 50> rotate 28*z translate <4, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <35.9, 19.1, 43.9> }
            box { <-10, -20, -10> <50, 0, 50> rotate 28*z translate <4, 0, 0> }
          }
        }
        difference {
          box { <-4, 3.1, -2.9> <34.8, 20, 42.9> }
          box { <-10, -20, -10> <50, 0, 50> rotate 28*z translate <4, 2, 0> }
          box { <-5, 0, -4> <28.5, 21, -2.4> }
          box { <-5, 0, 42.4> <28.5, 21, 44> }
          box { <28.1, 0, -4> <29.2, 21, 44> }
          box { <29, 0, 11.5> <35, 19, 12.5> }
          box { <29, 0, 27.5> <35, 19, 28.5> }
          box { <-4, 17.9, 36.1> <29, 21, 44> }
          box { <-4, 0, 36.100005> <29, 21, 37.6> }
          box { <-4, 17.9, -4> <29, 21, 3.9> }
          box { <-4, 0, 2.4> <29, 21, 3.900005> }
          object { high_open_rounded_button() translate <8, -3.2, 16> }
          object { high_open_rounded_button() translate <8, -3.2, 24> }
          difference {
            box { <4.1, 0, 12.1> <14, 6.3, 27.9> }
            box { <5.1, 0, 13.1> <10.9, 7, 26.9> }
          }
        }
        #if (setting > 1)
          cylinder { -1*y, 1.9*y, 2.6 translate <8, 0, 0> }
          cylinder { -1*y, 1.9*y, 2.6 translate <8, 0, 8> }
          cylinder { -1*y, 1.9*y, 2.6 translate <8, 0, 16> }
          cylinder { -1*y, 1.9*y, 2.6 translate <8, 0, 24> }
          cylinder { -1*y, 1.9*y, 2.6 translate <8, 0, 32> }
          cylinder { -1*y, 1.9*y, 2.6 translate <8, 0, 40> }
          box { <-2.4, -1, -2.4> <2.9, 2, 42.4> }
        #end
      }
      difference {
        merge {
          object { high_open_rounded_button() translate <32, 9.6, 0> }
          object { high_open_rounded_button() translate <32, 9.6, 8> }
          object { high_open_rounded_button() translate <32, 9.6, 16> }
          object { high_open_rounded_button() translate <32, 9.6, 24> }
          object { high_open_rounded_button() translate <32, 9.6, 32> }
          object { high_open_rounded_button() translate <32, 9.6, 40> }
        }
        box { <-10, -20, -10> <50, 0, 50> rotate 28*z translate <4, 2, 0> }
      }
      object { open_rounded_button() translate <0, 16, 0> }
      object { open_rounded_button() translate <8, 16, 0> }
      object { open_rounded_button() translate <16, 16, 0> }
      object { open_rounded_button() translate <24, 16, 0> }
      object { open_rounded_button() translate <0, 16, 40> }
      object { open_rounded_button() translate <8, 16, 40> }
      object { open_rounded_button() translate <16, 16, 40> }
      object { open_rounded_button() translate <24, 16, 40> }
      object { open_rounded_button() translate <0, 0, 8> }
      object { open_rounded_button() translate <0, 0, 16> }
      object { open_rounded_button() translate <0, 0, 24> }
      object { open_rounded_button() translate <0, 0, 32> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 40> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 40> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 19.1, 40> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 19.1, 40> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 0, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 0, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 0, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 0, 32> }
      #end
      #if (setting > 1)
        box { <2.4, 0.1, -0.5> <3, 2.1, 0.5> }
        box { <2.4, 0.1, 7.5> <3, 2.1, 8.5> }
        box { <2.4, 0.1, 15.5> <3, 2.1, 16.5> }
        box { <2.4, 0.1, 23.5> <3, 2.1, 24.5> }
        box { <2.4, 0.1, 31.5> <3, 2.1, 32.5> }
        box { <2.4, 0.1, 39.5> <3, 2.1, 40.5> }
        object { pin(1) translate <0, 0, 4> }
        object { pin(1) translate <0, 0, 12> }
        object { pin(1) translate <0, 0, 20> }
        object { pin(1) translate <0, 0, 28> }
        object { pin(1) translate <0, 0, 36> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <36, 20.9, 44> } }
    }
  #end
#end
#macro iron_hook()
  #if (setting = 0)
    box { <-3.9, -31.1, -4.5> <3.9, 2.2, 4.5> texture { r_black_tex finish { ambient 0.2 } } }
  #else
    difference {
      merge {
        cylinder { -0.9*z, 0.9*z, 2.2 }
        box { <-2.200001, -5, -0.900001> <2.200001, 0.000001, 0.900001> }
        box { <-3.8, -19.3, -2.4> <3.8, -3.5, 2.4> }
        difference {
          torus { 3.4, 1.2 rotate 90*z }
          box { <-2, 0, -10> <2, 10, 0> }
          box { <-2, 0, 0> <2, 10, 10> rotate -35*x }
          translate <0, -26.5, 0>
        }
        cylinder { 0*y, 7*y, 1.2 translate <0, 0, 3.5> rotate -35*x translate <0, -26.5, 0> }
        box { <-0.65, -5, 0> <0.65, 0, 1.5> rotate -40*x translate <0, -19.299999, -2.400001> }
        sphere { <0, -26.499999, -3.5> 1.2 }
      }
      cylinder { -1*z, 1*z, 0.75 }
      cylinder { -3*z, 3*z, 2.25 translate <0, -7.5, 0> }
      box { <-2.25, -17.75, -3> <2.25, -5.05, -0.6> }
      box { <-2.25, -17.75, 0.6> <2.25, -5.05, 3> }
      texture { r_black_tex finish { ambient 0.2 } }
      bounded_by { box { <-4, -31.2, -4.6> <4, 2.3, 4.6> } }
    }
  #end
#end
#macro i_opentwo_slope3_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 19.1, 19.9> }
      box { <-10, -1, -20> <30, 20, 0> rotate 45*y translate <-3.9, 0, 11.9> }
      box { <10, -20, -20> <20, 20, 0> rotate -32.5*x translate <0, 5, 3.9> }
      box { <-20, -20, 10> <0, 20, 20> rotate 32.5*z translate <3.9, 5, 0> }
      box { <10, -12.5, -20> <20, 0, 0> rotate -57*x translate <0, 5, 3.9> }
      box { <-20, -12.5, 10> <0, 0, 20> rotate 57*z translate <3.9, 5, 0> }
      box { <-30, -20, -20> <30, 20, 0> rotate -30*x rotate 45*y translate <9, 5, 9> }
      box { <-20, -150, -20> <20, 30, 0> rotate -50*x rotate 45*y translate <9, 5, 9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <19.9, 19.1, 19.9> }
            box { <3.900001, 9.5, 11.900001> <20, 20, 20> }
            box { <11.900002, 9.500001, 3.900005> <20, 20, 20> }
            cylinder { -1*y, 1.9*y, 2.3 translate <8, 0, 16> }
            cylinder { -1*y, 1.9*y, 2.3 translate <16, 0, 8> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
          #else
            object { rounded_button() rotate -90*y translate <16, 6.4, 16> }
          #end
        }
        difference {
          box { <-3, -1, -3> <19, 20, 19> }
          box { <-10, -20, -20> <30, 20, 0> rotate -30*x rotate 45*y translate <9, 6, 9> }
          box { <-20, -15, -20> <20, 30, 0> rotate -50*x rotate 45*y translate <9, 6, 9> }
          box { <-10, -20, -20> <30, 1, 0> rotate 45*y translate <-2.4, 17.9, 11.9> }
          box { <10, -20, -20> <20, 20, 0> rotate -32.5*x translate <0, 6, 3.9> }
          box { <-20, -20, 10> <0, 20, 20> rotate 32.5*z translate <3.9, 6, 0> }
          box { <10, -12.5, -20> <20, 0, 0> rotate -57*x translate <0, 6, 3.9> }
          box { <-20, -12.5, 10> <0, 0, 20> rotate 57*z translate <3.9, 6, 0> }
          box { <12, -1, 12> <20, 20, 20> }
          box { <3, 0, 11> <4.000001, 20, 20> }
          box { <3.000001, 0, 11.000001> <12, 20, 12> }
          box { <11, 0, 3> <12.000001, 20, 12.000001> }
          box { <11.000001, 0, 3.000001> <20, 20, 4.000001> }
        }
        #if (setting > 1)
          box { <13.600001, -1, 16.000002> <18.400001, 8.599999, 18.4> }
          box { <16, -1, 13.6> <18.4, 8.6, 18.400001> }
          cylinder { -1*y, 8.600001*y, 2.4 translate <16, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
        #end
        box { <-10, -1, -20> <30, 20, 0> rotate 45*y translate <-3.9, 0, 11.9> }
        box { <10, -20, -20> <20, 20, 0> rotate -32.5*x translate <0, 5, 3.9> }
        box { <-20, -20, 10> <0, 20, 20> rotate 32.5*z translate <3.9, 5, 0> }
        box { <10, -12.5, -20> <20, 0, 0> rotate -57*x translate <0, 5, 3.9> }
        box { <-20, -12.5, 10> <0, 0, 20> rotate 57*z translate <3.9, 5, 0> }
        box { <-30, -20, -20> <30, 20, 0> rotate -30*x rotate 45*y translate <9, 5, 9> }
        box { <-20, -150, -20> <20, 30, 0> rotate -50*x rotate 45*y translate <9, 5, 9> }
      }
      difference {
        merge {
          object { open_rounded_button() translate <8, 6.4, 16> }
          object { open_rounded_button() translate <16, 6.4, 8> }
          object { open_rounded_button() translate <0, 16, 16> }
          object { open_rounded_button() translate <8, 16, 8> }
          object { open_rounded_button() translate <16, 16, 0> }
          difference {
            cylinder { 0*y, 9.5*y, 2.400001 }
            cylinder { -1*y, 10*y, 1.600001 }
            translate <8, 0, 16>
          }
          difference {
            cylinder { 0*y, 9.5*y, 2.400001 }
            cylinder { -1*y, 10*y, 1.600001 }
            translate <16, 0, 8>
          }
          difference {
            cylinder { 0*y, 19.1*y, 2.400001 }
            cylinder { -1*y, 20*y, 1.600001 }
            translate <0, 0, 16>
          }
          difference {
            cylinder { 0*y, 19.1*y, 2.400001 }
            cylinder { -1*y, 20*y, 1.600001 }
            translate <8, 0, 8>
          }
          difference {
            cylinder { 0*y, 19.1*y, 2.400001 }
            cylinder { -1*y, 20*y, 1.600001 }
            translate <16, 0, 0>
          }
        }
        box { <-10, -20, -20> <30, 20, 0> rotate -30*x rotate 45*y translate <9, 6, 9> }
        box { <-20, -15, -20> <20, 30, 0> rotate -50*x rotate 45*y translate <9, 6, 9> }
        box { <-10, -20, -20> <30, 1, 0> rotate 45*y translate <-2.4, 17.9, 11.9> }
        box { <10, -20, -20> <20, 20, 0> rotate -32.5*x translate <0, 6, 3.9> }
        box { <-20, -20, 10> <0, 20, 20> rotate 32.5*z translate <3.9, 6, 0> }
        box { <10, -12.5, -20> <20, 0, 0> rotate -57*x translate <0, 6, 3.9> }
        box { <-20, -12.5, 10> <0, 0, 20> rotate 57*z translate <3.9, 6, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 20.9, 20> } }
    }
  #end
#end
#macro i_propellor2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      cylinder { -7.8*y, 0.1*y, 2.25 translate <4, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
        box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
      }
      difference {
        merge {
          cylinder { -0.5*y, 2.1*y, 3.2 }
          cylinder { -7.7*y, -0*y, 2.25 }
          cylinder { -7.8*y, -6.9*y, 2.5 }
        }
        box { <-0.5, -8, -4> <0.5, -4.9, 4> }
        cylinder { -4*z, 4*z, 0.5 translate <0, -4.9, 0> }
        cylinder { 2.000001*y, -8*y, 1.6 }
        translate <4, 0, 4>
      }
      difference {
        cylinder { 0*y, 2.1*y, 5.25 }
        cylinder { -1*y, 3*y, 4.5 }
        translate <4, 0, 4>
      }
      object { open_rounded_button() }
      object { open_rounded_button() translate <0, 0, 8> }
      object { open_rounded_button() translate <8, 0, 0> }
      object { open_rounded_button() translate <8, 0, 8> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 3.1, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -7.9, -4>, <12, 4.9, 12> } }
    }
  #end
#end
#macro i_slope1_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      box { <-20, -10, -10> <20, 0, 10> rotate 46*z translate <4, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
            box { <-20, -10, -10> <20, 0, 10> texture { color_tex normal { bumping } }
              rotate 46*z translate <4, 0, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
          #else
            object { rounded_button() rotate 180*y translate <0, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <4, 1, -3.1> <10.4, 10, 3.1> }
            box { <-20, -10, -10> <20, 0, 10> rotate 46*z translate <4, 2, 0> }
          }
          box { <-2.4, -1, -2.4> <2.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
        #end
      }
      #if (setting > 1)
        difference {
          object { high_open_rounded_button() translate <8, 0, 0> }
          box { <-20, -10, -10> <20, 0, 10> rotate 46*z translate <4, 2, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 4> } }
    }
  #end
#end
#macro i_slope1_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 3.9> }
      box { <-10, -10, -10> <20, 0, 20> rotate 25*z translate <4, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <19.9, 9.5, 3.9> }
            box { <-10, -10, -10> <20, 0, 20>
              texture { color_tex normal { bumping } } rotate 25*z translate <4, 0, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          cylinder { -1*y, 1.9*y, 2.6 translate <8, 0, 0> }
          difference {
            box { <4, 1, -2.9> <18.4, 10, 2.9> }
            box { <-10, -10, -10> <20, 0, 20> rotate 25*z translate <4, 2, 0> }
          }
          box { <-2.4, -1, -2.4> <2.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
        #end
      }
      difference {
        merge {
          object { high_open_rounded_button() translate <8, 0, 0> }
          object { high_open_rounded_button() translate <16, 0, 0> }
        }
        box { <-10, -10, -10> <20, 0, 20> rotate 25*z translate <4, 2, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 4> } }
    }
  #end
#end
#macro i_slope2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
      box { <-20, -10, -10> <20, 0, 20> rotate 46*z translate <4, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
            box { <-20, -10, -10> <20, 0, 20> texture { color_tex normal { bumping } }
              rotate 46*z translate <4, 0, 0> }
          }
          #if (setting <3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button()translate <0, 6.4, 8> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <4, 1, -2.9> <10.3, 10, 10.9> }
            box { <-20, -10, -10> <20, 0, 20> rotate 46*z translate <4, 2, 0> }
          }
          box { <-2.4, -1, -2.4> <2.4, 8.6, 10.4> }
          box { <-0.5, 7.4, -1> <0.5, 10.4, 1> }
          box { <-0.5, 7.4, 7> <0.5, 10.4, 9> }
        #end
      }
      difference {
        merge {
          object { high_open_rounded_button() translate <8, 0, 0> }
          object { high_open_rounded_button() translate <8, 0, 8> }
        }
        box { <-20, -10, -10> <20, 0, 20> rotate 46*z translate <4, 2, 0> }
      }
      box { <-0.4, 0.25, 2.9> <0.4, 8.7, 5.1> }
      cylinder { 0.25001*y, 8.7*y, 0.4 translate <0, 0, 2.9> }
      cylinder { 0.25001*y, 8.7*y, 0.4 translate <0, 0, 5.1> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 12> } }
    }
  #end
#end
#macro i_slope2_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 11.9> }
      box { <-10, -10, -10> <20, 0, 20> rotate 25*z translate <4, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <19.9, 9.5, 11.9> }
            box { <-10, -10, -10> <20, 0, 20>
              texture { color_tex normal { bumping } } rotate 25*z translate <4, 0, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <0, 6.4, 8> }
          #end
        }
        #if (setting > 1)
          cylinder { -1*y, 1.9*y, 2.6 translate <8, 0, 0> }
          cylinder { -1*y, 1.9*y, 2.6 translate <8, 0, 8> }
          difference {
            box { <4, 1, -2.9> <18.4, 10, 10.9> }
            box { <-10, -10, -10> <20, 0, 20> rotate 25*z translate <4, 2, 0> }
          }
          box { <-2.4, -1, -2.4> <2.4, 8.6, 10.4> }
          box { <-0.5, 7.4, -1> <0.5, 10.4, 1> }
          box { <-0.5, 7.4, 7> <0.5, 10.4, 9> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { high_open_rounded_button() translate <8, 0, 0> }
            object { high_open_rounded_button() translate <8, 0, 8> }
            object { high_open_rounded_button() translate <16, 0, 0> }
            object { high_open_rounded_button() translate <16, 0, 8> }
          }
          box { <-10, -10, -10> <20, 0, 20> rotate 25*z translate <4, 2, 0> }
        }
        box { <-0.4, 0.25, 2.9> <0.4, 8.7, 5.1> }
        cylinder { 0.25001*y, 8.7*y, 0.4 translate <0, 0, 2.9> }
        cylinder { 0.25001*y, 8.7*y, 0.4 translate <0, 0, 5.1> }
        box { <3.9, 2, -0.5> <5.8, 9.4, 0.5> }
        box { <3.9, 2, 7.5> <5.8, 9.4, 8.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 12> } }
    }
  #end
#end
#macro jack(color_tex, jack_angle)
  #if (setting = 0)
    union {
      merge {
        box { <-3.9, 0, -3.9> <31.9, 3.1, 3.9> }
        box { <20.75, 0.000001, -11.25> <27.25, 3.100001, 11.25> }
      }
      box { <-26, -1.000002, -3.9> <-4.6, 1.000002, 3.9>
        rotate -(jack_angle / 5.1428571429)*z translate <24, 4.5, 0> }
      merge {
        cylinder { 0*y, 14*y, 1.5 }
        cylinder { -3.8*z, 3.8*z, 1.5 translate <0, 14, 0> }
        rotate -jack_angle*z
        translate <28, 6.5, 0>
      }
      texture { color_tex }
    }
  #else
    union {
      merge {
        difference {
          merge {
            box { <-3.9, 0, -3.9> <31.9, 3.1, 3.9> }
            box { <20.75, 0.000001, -8.000001> <27.25, 3.100001, 8.000001> }
            cylinder { 0.000002*y, 3.100002*y, 3.25 translate <24, 0, -8> }
            cylinder { 0.000002*y, 3.100002*y, 3.25 translate <24, 0, 8> }
            cylinder { -3.900005*z, 3.900005*z, 3.9 translate <28, 6.5, 0> }
            cylinder { -3.900006*z, 3.900006*z, 3.9 translate <24, 4.5, 0> }
            box { <24, 3, -3.900007> <31.900001, 6.500001, 3.900007> }
            box { <0, 0, -3.900008> <5, 3.9, 3.900008> rotate 27*z translate <24, 4.5, 0> }
          }
          cylinder { -4*z, 4*z, 1.1 translate <24, 4.5, 0> }
          cylinder { -4*z, 4*z, 1.1 translate <28, 6.5, 0> }
          box { <22.900001, 4.5, -3.1> <25.100001, 20, 3.1> }
          box { <26.900001, 6.5, -3.1> <29.100001, 20, 3.1> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <32, 2, 2.4> }
            cylinder { -1*y, 2*y, 2.4 translate <24, 0, -8> }
            cylinder { -1*y, 2*y, 2.4 translate <24, 0, 8> }
            box { <21.6, -1, -8.00002> <26.4, 2.000001, -3.9> }
            box { <21.6, -1, 8.00002> <26.4, 2.000001, 3.9> }
          #end
          box { <22.5, 1, -2.400002> <30.4, 20, 2.400002> }
          box { <10, 3.100005, -2.400003> <30, 20, 2.400003> }
          box { <-4, 2.8, -4> <-2, 4, 4> }
          box { <-4, 0, -4> <0, 4, 4> rotate -45*z translate <-2, 2.8, 0> }
        }
        #if (setting > 1)
          object { pin(1) translate <4, 0, 0> }
          object { pin(1) translate <12, 0, 0> }
          object { pin(1) translate <20, 0, 0> }
          box { <19.5, 0.000003, -3> <20.5, 2.1, 3> }
          box { <23.5, 0.000003, -3.5> <24.5, 2.1, -5.6> }
          box { <23.5, 0.000003, 3.5> <24.5, 2.1, 5.6> }
        #end
        texture { color_tex }
        bounded_by { box { <-4, -0.1, -11.35> <32, 10.5, 11.35> } }
      }
      merge {
        cylinder { -2.8*z, 2.8*z, 1 }
        cylinder { -2.3*z, 2.3*z, 1 translate <5, 0, 0> }
        box { <-5, -1.000001, -2.300001> <5.000001, 1.000001, 2.300001> }
        box { <-26, -1.000002, -3.9> <-4.6, 1.000002, 3.9> }
        cylinder { -3.900001*z, 3.900001*z, 1.5 translate <-26.5, 0, 0> }
        texture { color_tex }
        bounded_by { box { <-28.1, -1.6, -4> <6.1, 1.6, 4> } }
        rotate -(jack_angle / 5.1428571429)*z
        translate <24, 4.5, 0>
      }
      merge {
        cylinder { -2.8*z, 2.8*z, 1 }
        cylinder { -2.3*z, 2.3*z, 1 translate <-1.5, 0, 0> }
        cylinder { -2.3*z, 2.3*z, 1 translate <1.5, 0, 0> }
        box { <-1.500001, -1.000001, -2.300001> <1.500001, 1.000001, 2.300001> }
        cylinder { 0*y, 14*y, 1.5 }
        torus { 1.35, 0.15 rotate 90*x translate <0, 14, -3.65> }
        torus { 1.35, 0.15 rotate 90*x translate <0, 14, 3.65> }
        cylinder { -3.8*z, 3.8*z, 1.35 translate <0, 14, 0> }
        cylinder { -3.65*z, 3.65*z, 1.5 translate <0, 14, 0> }
        texture { color_tex }
        bounded_by { box { <-2.6, -1.1, -3.9> <2.6, 15.6, 3.9> } }
        rotate -jack_angle*z
        translate <28, 6.5, 0>
      }
    }
  #end
#end
#macro jet_engine1(color_tex, age)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      cylinder { -11.5*x, 19.5*x, 4.5 translate <0, 1.5, -11.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
          #end
          torus { 3, 0.5 rotate <0, 90, 90> translate <-11, 1.5, -11.5> }
          torus { 3, 0.5 rotate <0, 90, 90> translate <19, 1.5, -11.5> }
          cone { -11.000001*x, 3.5, -2.499999*x, 4.5 translate <0, 1.5, -11.5> }
          cone { 10.499999*x, 4.5, 19.000001*x, 3.5 translate <0, 1.5, -11.5> }
          cylinder { -2.5*x, 10.5*x, 4.5 translate <0, 1.5, -11.5> }
          difference {
            box { <-3.900001, 0.5, -7.5> <11.900001, 2.6, -3.8> }
            box { <-10, 0, -10> <0, 10, 10> rotate -22.5*y translate <-3.9, 0, -3.9> }
            box { <0, 0, -10> <10, 10, 10> rotate 22.5*y translate <11.9, 0, -3.9> }
          }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        #end
        cylinder { -13*x, -4.5*x, 2.5 translate <0, 1.5, -11.5> }
        cylinder { 12.5*x, 21*x, 2.5 translate <0, 1.5, -11.5> }
        box { <-4.6, -1, -12.5> <3.5, 4, -10.5> }
        box { <-4.6, 0.5, -14> <3.5, 2.5, -9> }
        box { <4.5, -1, -12.5> <12.6, 4, -10.5> }
        box { <4.5, 0.5, -14> <12.6, 2.5, -9> }
      }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-11.6, -3.1, -16.1> <19.6, 6.1, 4> } }
    }
  #end
#end
#macro jet_engine2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, -1.5, -3.9> <11.9, -0.1, 11.9> }
      box { <-3.9, -5, 3.25> <11.9, -1, 4.75> }
      cylinder { -12*x, 20*x, 5.75 translate <0, -10.5, 4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, -1.5, -3.9> <11.9, -0.1, 11.9> }
        object { open_rounded_button() translate <0, -3.2, 0> }
        object { open_rounded_button() translate <8, -3.2, 0> }
        object { open_rounded_button() translate <0, -3.2, 8> }
        object { open_rounded_button() translate <8, -3.2, 8> }
        cone { -12*x, 3.75, -1.999999*x, 5.75 translate <0, -10.5, 4> }
        cone { 9.999999*x, 5.75, 20*x, 3.75 translate <0, -10.5, 4> }
        cylinder { -2*x, 10*x, 5.75 translate <0, -10.5, 4> }
        cylinder { -13.7*x, -11.9*x, 2.3 translate <0, -10.5, 4> }
        difference {
          box { <-3.900001, -5.000001, 3.25> <11.900001, -1, 4.75> }
          box { <-10, -10, -10> <0, 0, 10> rotate 18*z translate <-3.9, -1.5, 0> }
          box { <0, -10, -10> <10, 0, 10> rotate -18*z translate <11.9, -1.5, 0> }
        }
        difference {
          box { <3.5, -5, 2.25> <4.5, -1, 5.75> }
          box { <-10, -10, -10> <10, 10, 0> rotate 23*x translate <0, -1.5, 3.25> }
          box { <-10, -10, 0> <10, 10, 10> rotate -23*x translate <0, -1.5, 4.75> }
        }
      }
      #if (setting > 1)
        #local counter = 0;
        #while (counter < 12)
        difference {
          box { <-13, 3.5, -0.75> <21, 6, 0.75> }
          box { <-14, -5, -5> <22, 0, 0> rotate -5*x translate <0, 6, -0.75> }
          box { <-14, -5, 0> <22, 0, 5> rotate 5*x translate <0, 6, 0.75> }
          rotate (15+(counter*30))*x
          translate <0, -10.5, 4>
        }
        #local counter = counter + 1;
        #end
        cylinder { -3*x, 21*x, 2.5 translate <0, -10.5, 4> }
        cylinder { -15*x, 10*x, 1.600001 translate <0, -10.5, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-13.8, -16.35, -4> <20.1, 1.7, 12> } }
    }
  #end
#end
#macro jet_engine3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*x, 27.9*x, 15.9 translate <0, 15.3, 4> }
      cylinder { 4*x, 35.9*x, 10.5 translate <0, 15.3, 4> }
      box { <-3.9, 0, -3.9> <27.9, 28.7, 11.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 28.7, 11.9> }
          difference {
            sphere { <0, 0, 0> 1 scale <33, 17, 16.25> translate <12, 15.3, 4> }
            box { <-50, -50, -50> <-0.2, 50, 50> }
            box { <24.2, -50, -50> <50, 50, 50> }
          }
          cylinder { 24.199995*x, 27.900005*x, 1 scale <1, 15.9775, 15.075> translate <0, 15.3, 4> }
          cone { -3.900001*x, 13.3, -0.199995*x, 15.3 scale <1, 1.025, 0.9775> translate <0, 15.3, 4> }
          cylinder { -11.800005*z, 19.800005*z, 3.6 translate <4, 15.3, 0> }
          cylinder { -11.800005*z, 19.800005*z, 3.6 translate <20, 15.3, 0> }
          box { <3.999994, 11.7, -11.800004> <20.000004, 18.9, 19.800004> }
          cylinder { -11.800007*z, 19.800007*z, 4.8 scale <1.66666667, 1, 1> translate <12, 15.3, 0> }
        }
        box { <-50, 28.700001, -50> <50, 50, 50> }
        box { <-50, -50, -50> <50, 50, -11.8> }
        box { <-50, -50, 19.8> <50, 50, 50> }
        box { <-4, -50, -50> <32, 0.000005, 50> }
        #if (setting > 1)
          box { <-2.4, -10, -2.4> <26.4, 2, 10.4> }
          cylinder { 1*y, 4.5*y, 1.15 translate <12, 0, 4> }
          cylinder { 26*y, 30*y, 1.15 translate <8, 0, 0> }
          cylinder { 26*y, 30*y, 1.15 translate <8, 0, 8> }
          cylinder { 26*y, 30*y, 1.15 translate <16, 0, 0> }
          cylinder { 26*y, 30*y, 1.15 translate <16, 0, 8> }
        #end
        cylinder { -4*x, -2.399995*x, 12.2 translate <0, 15.3, 4> }
        difference {
          cylinder { -2.4*x, 36*x, 13.7 translate <0, 15.3, 4> }
          box { <-4, 27.5, -10> <28, 50, 30> }
          box { <-4, -50, -10> <28, 3.5, 30> }
        }
        cylinder { -12*z, 20*z, 2.5 translate <4, 15.3, 0> }
        cylinder { -12*z, 20*z, 2.5 translate <20, 15.3, 0> }
        cylinder { -12*z, -11.3*z, 3.1 translate <4, 15.3, 0> }
        cylinder { -12*z, -11.3*z, 3.1 translate <20, 15.3, 0> }
        cylinder { 20*z, 19.3*z, 3.1 translate <4, 15.3, 0> }
        cylinder { 20*z, 19.3*z, 3.1 translate <20, 15.3, 0> }
        cylinder { -12*z, -6*z, 0.9 translate <8.4, 17.1, 0> }
        cylinder { -12*z, -6*z, 0.9 translate <8.4, 13.5, 0> }
        cylinder { -12*z, -6*z, 0.9 translate <15.6, 17.1, 0> }
        cylinder { -12*z, -6*z, 0.9 translate <15.6, 13.5, 0> }
        cylinder { 20*z, 14*z, 0.9 translate <8.4, 17.1, 0> }
        cylinder { 20*z, 14*z, 0.9 translate <8.4, 13.5, 0> }
        cylinder { 20*z, 14*z, 0.9 translate <15.6, 17.1, 0> }
        cylinder { 20*z, 14*z, 0.9 translate <15.6, 13.5, 0> }
        box { <8.4, 16.2, -12> <15.6, 18, -6> }
        box { <8.4, 12.6, -12> <15.6, 14.4, -6> }
        box { <8.4, 16.2, 20> <15.6, 18, 14> }
        box { <8.4, 12.6, 20> <15.6, 14.4, 14> }
        cylinder { -12*z, -9.5*z, 0.9 translate <-1, 13.5, 0> }
        cylinder { -12*z, -9.5*z, 0.9 translate <-1, 17.1, 0> }
        cylinder { 17.5*z, 20*z, 0.9 translate <-1, 13.5, 0> }
        cylinder { 17.5*z, 20*z, 0.9 translate <-1, 17.1, 0> }
        box { <-4, 16.2, -12> <-1, 18, -9.5> }
        box { <-4, 12.6, -12> <-1, 14.4, -9.5> }
        box { <-4, 16.2, 17.5> <-1, 18, 20> }
        box { <-4, 12.6, 17.5> <-1, 14.4, 20> }
      }
      difference {
        cylinder { 4.1*x, 35.9*x, 10.5 }
        difference {
          cylinder { 3*x, 36*x, 9.4 }
          box { <4, -8, -12> <26, 8, -8.799995> }
          box { <4, -8, 8.799995> <26, 8, 12> }
        }
        cylinder { -16*z, 16*z, 2.500005 translate <4, 0, 0> }
        cylinder { -16*z, 16*z, 2.500005 translate <20, 0, 0> }
        translate <0, 15.3, 4>
      }
      #local counter = 0;
      #while (counter < 12)
        cylinder { 4.100001*x, 35.900001*x, 0.4 translate <0, 10.5, 0> rotate (45+(30*counter))*x translate <0, 15.3, 4> }
        #local counter = counter + 1;
      #end
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
      #end
      object { open_rounded_button() translate <0, 25.6, 0> }
      object { open_rounded_button() translate <0, 25.6, 8> }
      object { open_rounded_button() translate <8, 25.6, 0> }
      object { open_rounded_button() translate <8, 25.6, 8> }
      object { open_rounded_button() translate <16, 25.6, 0> }
      object { open_rounded_button() translate <16, 25.6, 8> }
      object { open_rounded_button() translate <24, 25.6, 0> }
      object { open_rounded_button() translate <24, 25.6, 8> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 28.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 28.7, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <24, 28.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <24, 28.7, 8> }
      #end
      difference {
        merge {
          cylinder { -11*z, 19*z, 3.600007 translate <4, 15.3, 0> }
          cylinder { -11*z, 19*z, 3.600007 translate <20, 15.3, 0> }
          box { <3.999994, 11.700004, -11.000004> <20.000004, 18.900004, 19.000004> }
        }
        box { <0, 0, -4.8> <32, 30, 12.8> }
        cylinder { -12*z, 20*z, 2.500002 translate <4, 15.3, 0> }
        cylinder { -12*z, 20*z, 2.500002 translate <20, 15.3, 0> }
      }
      difference {
        cylinder { 4.1*x, 11.9*x, 3.6 }
        cylinder { 4*x, 12*x, 2.5 }
        cylinder { 3*x, 4.6*x, 3.1 }
        cylinder { 11.4*x, 12*x, 3.1 }
        translate <0, 15.3, 4>
      }
      box { <4.5, 18.8, 3.1> <11.5, 24.8, 4.9> }
      box { <4.5, 5.8, 3.1> <11.5, 11.8, 4.9> }
      difference {
        cone { -3.8*x, 13.25, 3.9*x, 15.25 }
        box { <0, 0, -20> <10, 5, 20> rotate -10*z translate <-2.4, 5.25, 0> }
        box { <0, -5, -20> <10, 0, 20> rotate 10*z translate <-2.4, -5.25, 0> }
        cylinder { -4*x, 4*x, 12.200005 }
        cylinder { -16*z, 16*z, 2.500008 translate <4, 0, 0> }
        box { <-4, 13.400009, -20> <4, 20, 20> }
        box { <-4, -20, -20> <4, -5.25, 20> }
        box { <-4, 5.25, -20> <4, 20, 20> }
        translate <0, 15.3, 4>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -12> <36, 30.5, 20> } }
    }
  #end
#end
#macro jet_engine_cover(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -19.9*x, 3.9*x, 8 }
      cone { 3.899999*x, 8, 19.9*x, 4 }
      texture { color_tex }
      translate <0, -9.9, 0>
    }
  #else
    merge {
      object { open_rounded_button() translate <0, -2.9, 0> }
      object { open_rounded_button() translate <8, -2.9, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <8, 0, 0> }
      #end
      box { <-3.9, -1.4, -3.9> <11.9, 0, 3.9> }
      box { <-3.899999, -5, -0.9> <11.899999, -1.3, 0.9> }
      difference {
        cylinder { -19.9*x, 3.9*x, 8 }
        cylinder { -21*x, 4.1*x, 6.4 }
        translate <0, -9.9, 0>
      }
      difference {
        cone { 3.899999*x, 8.000001, 19.9*x, 4 }
        cone { 3.9*x, 6.499999, 20*x, 2.5 }
        translate <0, -9.9, 0>
      }
      difference {
        cylinder { 3*x, 15*x, 3.75 }
        object { axle_section(14) translate <2, 0, 0> }
        translate <0, -9.9, 0>
      }
      texture { color_tex }
      bounded_by { box { <-20, -18, -8.1> <20, 1.8, 8.1> } }
    }
  #end
#end
#macro jet_engine_turbine(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -17*x, -11*x, 6.2 }
      cone { -11.000001*x, 6.2, 9.9*x, 2.25 }
      translate <0, -9.9, 0>
      texture { color_tex }
    }
  #else
    merge {
      #local counter = 0;
      #while (counter < 12)
        box { <-17, 0, -0.4> <-11, 6.2, 0.4> rotate (counter*30)*x }
        #local counter = counter + 1;
      #end
      difference {
        box { <-11.000001, 0, -0.899999> <2, 6.199999, 0.899999> }
        box { <-15, 0, -1> <0, 4, 1> rotate -11*z translate <2, 4, 0> }
      }
      difference {
        box { <-11.000001, 0, -0.899999> <2, 6.199999, 0.899999> }
        box { <-15, 0, -1> <0, 4, 1> rotate -11*z translate <2, 4, 0> }
        rotate 90*x
      }
      difference {
        box { <-11.000001, 0, -0.899999> <2, 6.199999, 0.899999> }
        box { <-15, 0, -1> <0, 4, 1> rotate -11*z translate <2, 4, 0> }
        rotate 180*x
      }
      difference {
        box { <-11.000001, 0, -0.899999> <2, 6.199999, 0.899999> }
        box { <-15, 0, -1> <0, 4, 1> rotate -11*z translate <2, 4, 0> }
        rotate 270*x
      }
      object { rounded_button() rotate 90*z translate <-13.9, 0, 0> }
      cylinder { -16.900001*x, -11.000001*x, 2.400005 }
      object { axle_ending(1) rotate 180*y translate <6, 0, 0> }
      object { axle_section(20.9) translate <-11, 0, 0> }
      texture { color_tex }
      bounded_by { cylinder { -18.8*x, 10*x, 6.3 } }
      translate <0, -9.9, 0>
    }
  #end
#end
#macro jet_pack(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -4.8> <3.9, 1.2, 4.8> }
      box { <-3.900005, -5, 4> <3.900005, 1.1, 4.800005> }
      box { <-3.900005, -4.1, -4> <3.900005, 1.1, -4.800005> }
      cylinder { -5.000001*y, -1.900001*y, 3.200001 translate <-4, 0, 8.9> }
      cylinder { -5.000001*y, -1.900001*y, 3.200001 translate <4, 0, 8.9> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -4.8> <3.9, 1.2, 4.8> }
        box { <-3.900005, -5, 4> <3.900005, 1.1, 4.800005> }
        box { <-3.900005, -4.1, -4> <3.900005, 1.1, -4.800005> }
        difference {
          box { <-5.3, -11.7, -4.800007> <5.3, -4, -4.000007> }
          box { <0, 0, -5> <5, 5, -3> rotate -45*z translate <3.9, -4, 0> }
          box { <0, -5, -5> <5, 0, -3> rotate 45*z translate <3.9, -11.7, 0> }
          box { <-5, 0, -5> <0, 5, -3> rotate 45*z translate <-3.9, -4, 0> }
          box { <-5, -5, -5> <0, 0, -3> rotate -45*z translate <-3.9, -11.7, 0> }
        }
        cylinder { -5.000001*y, -1.900001*y, 3.200001 translate <-4, 0, 8.9> }
        cylinder { -5.000001*y, -1.900001*y, 3.200001 translate <4, 0, 8.9> }
        object { open_rounded_button() translate <-4, -5, 8.9> }
        object { open_rounded_button() translate <4, -5, 8.9> }
        object { open_rounded_button() rotate -90*x translate <1.5, -7.85, -1.7> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*x translate <1.5, -7.85, -4.8> }
        #end
        difference {
          box { <-3.900004, -5.000005, 4.000005> <3.900004, -1.9, 8.9> }
          box { <-2.9, -6, 4.800003> <2.9, -3.9, 8.1> }
          cylinder { -6*y, -3.900001*y, 3.200003 translate <-4, 0, 8.9> }
          cylinder { -6*y, -3.900001*y, 3.200003 translate <4, 0, 8.9> }
        }
        cylinder { -5.3*z, -4.7*z, 0.6 translate <-4, -5.65, 0> }
        cylinder { -5.3*z, -4.7*z, 0.6 translate <-4, -7.85, 0> }
        cylinder { -5.3*z, -4.7*z, 0.6 translate <-4, -10.5, 0> }
      }
      cylinder { -1*y, 2*y, 2.5 }
      cylinder { -10*y, 0*y, 1.600005 translate <-4, 0, 8.9> }
      cylinder { -10*y, 0*y, 1.600005 translate <4, 0, 8.9> }
      cylinder { -10*y, -3*y, 2.6 translate <-4, 0, 8.9> }
      cylinder { -10*y, -3*y, 2.6 translate <4, 0, 8.9> }
      box { <-2.5, -4, -5> <-1.5, 0, -4.4> }
      box { <-0.5, -4, -5> <0.5, 0, -4.4> }
      box { <1.5, -4, -5> <2.5, 0, -4.4> }
      texture { color_tex }
      bounded_by { box { <-7.3, -12, -6.6> <7.3, 1.3, 12.2> } }
    }
  #end
#end
#macro joy_base(color_tex)
  #if (setting < 2)
    difference {
      merge {
        sphere { <0, 2.599999, 0> 3.15 }
        cylinder { 0*y, 2.6*y, 3.1500001 }
      }
      box { <-4, -4, -4> <4, 0.000001, 4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          sphere { <0, 2.599999, 0> 3.15 }
          box { <-4, 3, -1> <4, 6, 1> }
        }
        cylinder { 0*y, 2.6*y, 3.1500001 }
      }
      cylinder { -1*y, 2.6000001*y, 2.6 }
      box { <-2.2, -1, -0.9> <2.2, 6, 0.9> }
      texture { color_tex }
      bounded_by { box { <-3.25, -0.1, -3.25> <3.25, 5.85, 3.25> } }
    }
  #end
#end
#macro joy_stick(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 15.25*y, 1.25 texture { color_tex } }
  #else
    merge {
      cylinder { -0.8*z, 0.8*z, 2 }
      cylinder { 1*y, 14*y, 0.8 }
      sphere { <0, 14, 0> 1.25 }
      texture { color_tex }
      bounded_by { box { <-2.9, -2.9, -1.3> <2.9, 15.3, 1.3> } }
    }
  #end
#end
#macro lamppost(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      cylinder { 1*y, 67*y, 2.55 translate <4, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { 0*y, 2.1*y, 3.9 }
          cylinder { 0*y, 2.1*y, 3.9 translate <8, 0, 0> }
          cylinder { 0*y, 2.1*y, 3.9 translate <0, 0, 8> }
          cylinder { 0*y, 2.1*y, 3.9 translate <8, 0, 8> }
          box { <-3.9, 0.000001, -0.000001> <11.9, 2.100001, 8.000001> }
          box { <-0.000001, 0.000002, -3.9> <8.000001, 2.100002, 11.9> }
          torus { 2.9, 1 translate <0, 2.1, 0> }
          torus { 2.9, 1 translate <8, 2.1, 0> }
          torus { 2.9, 1 translate <0, 2.1, 8> }
          torus { 2.9, 1 translate <8, 2.1, 8> }
          cylinder { 0*z, 8*z, 1 translate <-2.9, 2.1, 0> }
          cylinder { 0*z, 8*z, 1 translate <10.9, 2.1, 0> }
          cylinder { 0*x, 8*x, 1 translate <0, 2.1, -2.9> }
          cylinder { 0*x, 8*x, 1 translate <0, 2.1, 10.9> }
          cylinder { 1.9*y, 3.100001*y, 2.9 }
          cylinder { 1.9*y, 3.100001*y, 2.9 translate <0, 0, 8> }
          cylinder { 1.9*y, 3.100001*y, 2.9 translate <8, 0, 0> }
          cylinder { 1.9*y, 3.100001*y, 2.9 translate <8, 0, 8> }
          box { <2, 1.9, -2.9> <6, 3.100004, 10.9> }
          box { <-2.9, 1.9, 2> <10.9, 3.100005, 6> }
          cylinder { 3*y, 5.7*y, 3.9 translate <4, 0, 4> }
          difference {
            sphere { <0, 0, 0> 3.9 scale <1, 4, 1> translate <4, 16, 4> }
            box { <0, -20, 0> <8, 5.6, 8> }
            box { <0, 26, 0> <8, 100, 8> }
          }
          torus { 2.2, 0.9 translate <4, 26.9, 4> }
          torus { 3, 0.9 translate <4, 61.1, 4> }
          torus { 3, 0.9 translate <4, 66.1, 4> }
          cylinder { 65.2*y, 67*y, 3 translate <4, 0, 4> }
          cylinder { 27*y, 66*y, 2.55 translate <4, 0, 4> }
          object { open_rounded_button() translate <4, 63.9, 4> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> translate <4, 67, 4> }
          #end
        }
        #if (setting > 1)
          cylinder { -5*z, 0*z, 0.9 translate <4, 63.6, 4> }
          sphere { <0, 0, 0> 1 translate <0, 0, -2.75> translate <4, 31, 4> }
          sphere { <0, 0, 0> 1 translate <0, 0, -2.75> rotate 60*y translate <4, 31, 4> }
          sphere { <0, 0, 0> 1 translate <0, 0, -2.75> rotate 120*y translate <4, 31, 4> }
          sphere { <0, 0, 0> 1 translate <0, 0, -2.75> rotate 180*y translate <4, 31, 4> }
          sphere { <0, 0, 0> 1 translate <0, 0, -2.75> rotate 240*y translate <4, 31, 4> }
          sphere { <0, 0, 0> 1 translate <0, 0, -2.75> rotate 300*y translate <4, 31, 4> }
          sphere { <0, 0, 0> 1 translate <0, 0, -2.75> translate <4, 57.5, 4> }
          sphere { <0, 0, 0> 1 translate <0, 0, -2.75> rotate 60*y translate <4, 57.5, 4> }
          sphere { <0, 0, 0> 1 translate <0, 0, -2.75> rotate 120*y translate <4, 57.5, 4> }
          sphere { <0, 0, 0> 1 translate <0, 0, -2.75> rotate 180*y translate <4, 57.5, 4> }
          sphere { <0, 0, 0> 1 translate <0, 0, -2.75> rotate 240*y translate <4, 57.5, 4> }
          sphere { <0, 0, 0> 1 translate <0, 0, -2.75> rotate 300*y translate <4, 57.5, 4> }
          cylinder { 31*y, 57.5*y, 1 translate <0, 0, -2.75> translate <4, 0, 4> }
          cylinder { 31*y, 57.5*y, 1 translate <0, 0, -2.75> rotate 60*y translate <4, 0, 4> }
          cylinder { 31*y, 57.5*y, 1 translate <0, 0, -2.75> rotate 120*y translate <4, 0, 4> }
          cylinder { 31*y, 57.5*y, 1 translate <0, 0, -2.75> rotate 180*y translate <4, 0, 4> }
          cylinder { 31*y, 57.5*y, 1 translate <0, 0, -2.75> rotate 240*y translate <4, 0, 4> }
          cylinder { 31*y, 57.5*y, 1 translate <0, 0, -2.75> rotate 300*y translate <4, 0, 4> }
          sphere { <0, 0, 0> 1.4 scale <1, 7, 1> translate <4, 16, 0> }
          sphere { <0, 0, 0> 1.4 scale <1, 7, 1> translate <0, 0, -4> rotate 60*y translate <4, 16, 0> }
          sphere { <0, 0, 0> 1.4 scale <1, 7, 1> translate <0, 0, -4> rotate 120*y translate <4, 16, 0> }
          sphere { <0, 0, 0> 1.4 scale <1, 7, 1> translate <0, 0, -4> rotate 180*y translate <4, 16, 0> }
          sphere { <0, 0, 0> 1.4 scale <1, 7, 1> translate <0, 0, -4> rotate 240*y translate <4, 16, 0> }
          sphere { <0, 0, 0> 1.4 scale <1, 7, 1> translate <0, 0, -4> rotate 300*y translate <4, 16, 0> }
          cylinder { -1*y, 2*y, 1.5 translate <-1, 0, -1> }
          cylinder { -1*y, 2*y, 1.5 translate <-1, 0, 9> }
          cylinder { -1*y, 2*y, 1.5 translate <9, 0, -1> }
          cylinder { -1*y, 2*y, 1.5 translate <9, 0, 9> }
          box { <-2.5, -1, -1> <10.5, 2.000001, 9> }
          box { <-1, -1, -2.5> <9, 2.000002, 10.5> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 68.8, 12> } }
    }
  #end
#end
#macro lance(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3*y, 4*y, 1.5 }
      cylinder { -60.5*x, 11*x, 1.5 translate <0, 4, 0> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { -3*y, 4*y, 1.35 }
      cylinder { 0*x, 11*x, 1.35 translate <0, 4, 0> }
      cylinder { -2.85*y, 4*y, 1.5 }
      cylinder { -59*x, 10.85*x, 1.5 translate <0, 4, 0> }
      torus { 1.35, 0.15 translate <0, -2.85, 0> }
      torus { 1.35, 0.15 rotate 90*z translate <10.85, 4, 0> }
      sphere { <-58.99999, 4, 0> 1.500001 }
      cone { -5.9*x, 1.499999, -3*x, 4 translate <0, 4, 0> }
      texture { color_tex }
      bounded_by { box { <-60.6, -3.1, -4.1> <11.1, 8.1, 4.1> } }
    }
  #end
#end
#macro larger_flag(color_tex)
  #if (setting = 0)
    box { <0, -15.9, -0.75> <51.9, 15.9, 0.75> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -15.9*y, 15.9*y, 2.6 }
        box { <4, -15.900001, -0.75> <51.9, 15.900001, 0.75> }
        box { <-0.000001, -15.899999, -2.600001> <4.000001, 15.899999, 2.600001> }
      }
      cylinder { -16*y, 16*y, 1.55 }
      box { <-4, -12.8, -5> <4.000002, 12.8, 5> }
      box { <-4, -17, -1.4> <0, 17, 1.4> }
      box { <-10, -16, -10> <3.25, 16, -2.599999> rotate -27.5*y }
      box { <-10, -16, 2.599999> <3.25, 16, 10> rotate 27.5*y }
      texture { color_tex }
      bounded_by { box { <-3, -16, -2.7> <52, 16, 2.7> } }
    }
  #end
#end
#macro larger_leaves(color_tex)
difference {
  merge {
    cylinder { 0*y, 3.1*y, 3.2 }
    object { open_rounded_button() }
    cylinder { 2*y, 3.000001*y, 2.4 translate <8, 0, -8> }
    cylinder { 2*y, 3.000001*y, 2.4 translate <8, 0, 8> }
    object { open_rounded_button() translate <8, 0, -8> }
    object { open_rounded_button() translate <8, 0, 8> }
    cylinder { 2*y, 3.000001*y, 2.4 translate <16, 0, -8> }
    cylinder { 2*y, 3.000001*y, 2.4 translate <16, 0, 8> }
    object { open_rounded_button() translate <16, 0, -8> }
    object { open_rounded_button() translate <16, 0, 8> }
    object { open_rounded_button() translate <24, 0, 0> }
    object { open_rounded_button() translate <24, 0, -16> }
    object { open_rounded_button() translate <24, 0, 16> }
    cylinder { 2*y, 3.000001*y, 2.4 translate <32, 0, -16> }
    cylinder { 2*y, 3.000001*y, 2.4 translate <32, 0, 16> }
    object { open_rounded_button() translate <32, 0, -16> }
    object { open_rounded_button() translate <32, 0, 16> }
    cylinder { 2*y, 3.000001*y, 2.4 translate <40, 0, -8> }
    cylinder { 2*y, 3.000001*y, 2.4 translate <40, 0, 8> }
    object { open_rounded_button() translate <40, 0, -8> }
    object { open_rounded_button() translate <40, 0, 8> }
    cylinder { 2*y, 4.8*y, 2.4 translate <40, 0, -16> }
    cylinder { 2*y, 4.8*y, 2.4 translate <40, 0, 16> }
    cylinder { 0*y, 2.1*y, 3.2 translate <24, 0, 0> }
    cylinder { 0*y, 3.1*y, 3.2 translate <24, 0, -16> }
    cylinder { 0*y, 3.1*y, 3.2 translate <24, 0, 16> }
    cylinder { 0*y, 3.1*y, 3.2 translate <40, 0, -16> }
    cylinder { 0*y, 3.1*y, 3.2 translate <40, 0, 16> }
    cylinder { 1.999999*y, 3.100001*y, 3.9 translate <24, 0, 0> }
    box { <3, 2.000001, -1.6> <21, 3.100002, 1.6> }
    box { <2, 2.000002, -1.6> <11, 3.100010, 1.6> rotate -45*y translate <8, 0, -8> }
    box { <2, 2.000002, -1.6> <11, 3.100011, 1.6> rotate -45*y translate <16, 0, -8> }
    box { <2, 2.000002, -1.6> <11, 3.100012, 1.6> rotate 45*y translate <8, 0, 8> }
    box { <2, 2.000002, -1.6> <11, 3.100013, 1.6> rotate 45*y translate <16, 0, 8> }
    box { <22.4, 2.000003, -13> <25.6, 3.100004, 13> }
    box { <0, 2.000004, -1.6> <22, 3.100005, 1.6> rotate -45*y translate <24, 0, 0> }
    box { <0, 2.000004, -1.6> <22, 3.100005, 1.6> rotate 45*y translate <24, 0, 0> }
    box { <32, 2.000005, 6.4> <39, 3.100006, 9.6> }
    box { <32, 2.000005, -6.4> <39, 3.100008, -9.6> }
    box { <30.4, 2.000006, -15> <33.6, 3.100007, -8> }
    box { <30.4, 2.000006, 8> <33.6, 3.100009, 15> }
  }
  cylinder { -1*y, 2*y, 2.6 }
  cylinder { -1*y, 2*y, 2.6 translate <24, 0, 0> }
  cylinder { -1*y, 2*y, 2.6 translate <24, 0, -16> }
  cylinder { -1*y, 2*y, 2.6 translate <24, 0, 16> }
  cylinder { -1*y, 2*y, 2.6 translate <40, 0, -16> }
  cylinder { -1*y, 2*y, 2.6 translate <40, 0, 16> }
  cylinder { -1*y, 5*y, 1.600001 }
  cylinder { -1*y, 5*y, 1.600001 translate <8, 0, -8> }
  cylinder { -1*y, 5*y, 1.600001 translate <8, 0, 8> }
  cylinder { -1*y, 5*y, 1.600001 translate <16, 0, -8> }
  cylinder { -1*y, 5*y, 1.600001 translate <16, 0, 8> }
  cylinder { -1*y, 5*y, 1.600001 translate <24, 0, 0> }
  cylinder { -1*y, 5*y, 1.600001 translate <24, 0, -16> }
  cylinder { -1*y, 5*y, 1.600001 translate <24, 0, 16> }
  cylinder { -1*y, 5*y, 1.600001 translate <32, 0, -16> }
  cylinder { -1*y, 5*y, 1.600001 translate <32, 0, 16> }
  cylinder { -1*y, 5*y, 1.600001 translate <40, 0, -8> }
  cylinder { -1*y, 5*y, 1.600001 translate <40, 0, 8> }
  cylinder { -1*y, 5*y, 1.600001 translate <40, 0, -16> }
  cylinder { -1*y, 5*y, 1.600001 translate <40, 0, 16> }
  texture { color_tex }
  bounded_by { box { <-3.4, -0.1, -19.4> <43.4, 4.9, 19.4> } }
}
#end
#macro large_catrol(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -16*z, 15.9*z, 1.75 }
      cylinder { -19.8*z, -29.9*z, 1.5 translate <-6.4, 0, 0> }
      cylinder { -15.9*z, -19.9*z, 7.9 }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { -16*z, 15.9*z, 1.75 }
      difference {
        torus { 4.7, 1.8 rotate 90*x }
        box { <-20, -20, -10> <20, 20, 0> }
        translate <0, 0, -7.5>
      }
      cylinder { -7.500001*z, -5.700001*z, 4.700001 }
      difference {
        torus { 4.7, 1.8 rotate 90*x }
        box { <-20, -20, 0> <20, 20, 10> }
        translate <0, 0, 7.5>
      }
      cylinder { 7.500001*z, 5.700001*z, 4.700001 }
      difference {
        merge {
          cylinder { -15.9*z, -16.9*z, 7.9 }
          cylinder { -16.8*z, -19*z, 5.9 }
          cylinder { -18.9*z, -19.9*z, 7.9 }
        }
        cone { -19.91*z, 4.5, -17.9*z, 3.5 }
      }
      difference {
        cylinder { -19.8*z, -29.9*z, 1.5 }
        cylinder { -30*z, -29.4*z, 1 }
        translate <-6.4, 0, 0>
      }
      texture { color_tex }
      bounded_by { box { <-8, -8, -30> <8, 8, 16> } }
    }
  #end
#end
#macro large_catrol_holder(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 19.1, 27.9> }
      box { <-4, 8.5, 4> <12, 20, 20> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 19.1, 27.9> }
        cylinder { -4*z, 28*z, 1.85 translate <4, 12, 0> }
        box { <2.149999, 11.999999, -5> <5.850001, 13.850001, 29> }
        difference {
          box { <-4, 13.85, -6> <12, 13.950001, 29> }
          box { <-3, 13.75, -3> <11, 14.05, 27> }
        }
        box { <-4, 8.5, 4> <12, 20, 20> }
        cylinder { 4.000001*z, 19.999999*z, 7.5 translate <4, 12, 0> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 17, 26.4> }
            cylinder { -3*z, 27*z, 8.5 translate <4, 12, 0> }
          }
        #end
      }
      object { open_rounded_button() translate <0, 16, 0> }
      object { open_rounded_button() translate <8, 16, 0> }
      object { open_rounded_button() translate <0, 16, 24> }
      object { open_rounded_button() translate <8, 16, 24> }
      #if (setting > 1)
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 19.1, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 19.1, 24> }
      #end
      #if (setting > 1)
        difference {
          merge {
            difference {
              cylinder { 0*y, 10*y, 3.2 }
              cylinder { -1*y, 11*y, 2.6 }
              translate <4, 0, 4>
            }
            difference {
              cylinder { 0*y, 10*y, 3.2 }
              cylinder { -1*y, 11*y, 2.6 }
              translate <4, 0, 12>
            }
            difference {
              cylinder { 0*y, 10*y, 3.2 }
              cylinder { -1*y, 11*y, 2.6 }
              translate <4, 0, 20>
           }
          }
          cylinder { -3*z, 27*z, 8.499999 translate <4, 12, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 20.9, 28> } }
    }
  #end
#end
#macro large_support(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> }
      box { <4.1, 46.9, 4.1> <19.9, 47.9, 19.9> }
      box { <4, 3, 11.25> <19.5, 47, 12.75> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> }
          box { <4.1, 2.1, 4.1> <19.9, 4.5, 19.9> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 26.4> }
          box { <5.600001, -1, 5.600001> <18.400001, 3.3, 18.400001> }
        #end
      }
      box { <4.1, 46.9, 4.1> <19.9, 47.9, 19.9> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 47.9, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <16, 47.9, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 47.9, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <16, 47.9, 16> }
      #end
      object { open_rounded_button() translate <8, 46.6, 8> }
      object { open_rounded_button() translate <16, 46.6, 8> }
      object { open_rounded_button() translate <8, 46.6, 16> }
      object { open_rounded_button() translate <16, 46.6, 16> }
      difference {
        cylinder { 47.8*y, 49.600001*y, 2.400001 }
        cylinder { 40*y, 50*y, 1.600001 }
        translate <8, 0, 8>
      }
      difference {
        cylinder { 47.8*y, 49.600001*y, 2.400001 }
        cylinder { 40*y, 60*y, 1.600001 }
        translate <16, 0, 8>
      }
      difference {
        cylinder { 47.8*y, 49.600001*y, 2.400001 }
        cylinder { 40*y, 60*y, 1.600001 }
        translate <8, 0, 16>
      }
      difference {
        cylinder { 47.8*y, 49.600001*y, 2.400001 }
        cylinder { 40*y, 60*y, 1.600001 }
        translate <16, 0, 16>
      }
      difference {
        box { <-1.2, 0, -4> <0, 44, 4> }
        box { <-10, 0, -10> <10, 47, 0> rotate 3*x translate <0, 0, -4> }
        box { <-10, 0, 0> <10, 47, 10> rotate -3*x translate <0, 0, 4> }
        rotate -3.5*z
        translate <4.1, 3.1, 12>
      }
      difference {
        box { <0, 0, -4> <1.2, 44, 4> }
        box { <-10, 0, -10> <10, 47, 0> rotate 3*x translate <0, 0, -4> }
        box { <-10, 0, 0> <10, 47, 10> rotate -3*x translate <0, 0, 4> }
        rotate 3.5*z
        translate <19.9, 3.1, 12>
      }
      difference {
        box { <4, 4.3, 11.25> <19.5, 47, 12.75> }
        box { <-10, 0, 10> <0, 47, 20> rotate -3.5*z translate <4, 3.1, 0> }
        box { <0, 0, 10> <10, 47, 20> rotate 3.5*z translate <19.8, 3.1, 0> }
        cylinder { 10*z, 14*z, 2 translate <9.25, 7.5, 0> }
        cylinder { 10*z, 14*z, 2 translate <14.75, 7.5, 0> }
        box { <9.250001, 5.500001, 10> <14.750001, 10, 14> }
        cylinder { 10*z, 14*z, 1.75 translate <9.75, 22.5, 0> }
        cylinder { 10*z, 14*z, 1.75 translate <14.25, 22.5, 0> }
        box { <-2, 0, 10> <4, 15.25, 14> rotate -2.75*z translate <9.25, 7.5, 0> }
        box { <-4, 0, 10> <2, 15.25, 14> rotate 2.75*z translate <14.75, 7.5, 0> }
        box { <9.750001, 10, 10> <14.250001, 24.250001, 14> }
        cylinder { 10*z, 14*z, 1.5 translate <9.75, 28.75, 0> }
        cylinder { 10*z, 14*z, 1.5 translate <14.25, 28.75, 0> }
        cylinder { 10*z, 14*z, 1.25 translate <10.15, 43, 0> }
        cylinder { 10*z, 14*z, 1.25 translate <13.85, 43, 0> }
        box { <-1.5, 0, 10> <4, 14.1, 14> rotate -2.75*z translate <9.75, 28.75, 0> }
        box { <-4, 0, 10> <1.52, 14.1, 14> rotate 2.75*z translate <14.25, 28.75, 0> }
        box { <9.750001, 27.250001, 10> <14.250001, 29, 14> }
        box { <10.150001, 39, 10> <13.850001, 44.250001, 14> }
      }
      #if (setting > 1)
        box { <4, 0.000005, 6.8> <5.5, 2.1, 17.2> }
        box { <18.5, 0.00005, 6.8> <20, 2.1, 17.2> }
        box { <6.8, 0.00005, 4> <17.2, 2.1, 5.5> }
        box { <6.8, 0.00005, 18.5> <17.2, 2.1, 20> }
        object { ring() translate <4, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <20, 0, 20> }
        difference {
          cylinder { 0*y, 3.6*y, 3.2 }
          cylinder { -1*y, 4*y, 2.6 }
          translate <12, 0, 12>
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 51.5, 28> } }
    }
  #end
#end
#macro laser_mount(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*x, 7*x, 1.5 translate <0, 9.5, 0> }
      cylinder { 0*y, 20.5*y, 1.5 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 5.75*y, 3.2 }
        cylinder { 4.6*y, 4.2*y, 3.5 }
        cylinder { 3.8*y, 3.4*y, 3.5 }
        cylinder { 3*y, 2.6*y, 3.5 }
        cylinder { 2.2*y, 1.8*y, 3.5 }
        cylinder { 5.7*y, 6.2*y, 3.8 }
        cylinder { 5.8*y, 20.5*y, 1.3 }
        cylinder { 13.5*y, 5.7*y, 1.5 }
        cylinder { 13.9*y, 14.3*y, 1.5 }
        cylinder { 14.7*y, 15.1*y, 1.5 }
        cylinder { 15.5*y, 15.9*y, 1.5 }
        cylinder { 16.5*y, 20.500001*y, 1.35 }
        cylinder { 16.3*y, 20.350001*y, 1.5 }
        torus { 1.35, 0.15 translate <0, 20.35, 0> }
        cylinder { 1*x, 7*x, 1.35 translate <0, 9.5, 0> }
        cylinder { 0*x, 6.85*x, 1.5 translate <0, 9.5, 0> }
        torus { 1.35, 0.15 rotate 90*z translate <6.85, 9.5, 0> }
      }
      #if (setting > 1)
        cylinder { 2.2*y, -1*y, 2.6 }
        cylinder { 6*y, -1*y, 1.6 }
        box { <-0.9, -1, -2.399999> <0.9, 5.5, 2.399999> }
        box { <-2.399998, -1, -0.9> <2.399998, 5.500001, 0.9> }
      #end
      texture { color_tex }
      bounded_by { box { <-3.9, -0.1, -3.9> <7.1, 20.6, 3.9> } }
    }
  #end
#end
#macro left_arm(color_tex)
  #if (setting = 0)
    merge {
      cylinder { <0.5, 0, 0>, <1, -5, 0>, 1 scale <2.000001, 1, 2.5> }
      cylinder { <2, -8, -3.5>, <2, -5, 0>, 2.15 }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting > 1)
        cylinder { -1.25*x, 0*x, 1.75 }
        difference {
          sphere { <-1.25, 0, 0> 1.750001 }
          box { <-1.249999, -10, -10> <10, 10, 10> }
          box { <-10, -10, -10> <-3, 10, 10> }
          cylinder { -4*x, -1*x, 1 }
        }
      #end
      difference {
        merge {
          sphere { <0, 0, 0> 1 scale <2, 2.5, 2.5> translate <1, 0, 0> }
          cylinder { <0.5, 0, 0>, <1, -5, 0>, 1 scale <2.000001, 1, 2.5> }
          sphere { <0, 0, 0> 1 scale <2, 2.5, 2.5> translate <2, -5, 0> }
          cylinder { <2, -8, -3.5>, <2, -5, 0>, 2.15 }
        }
        box { <-10, -30, -20> <-0.300001, 10, 20> }
        #if (setting > 1)
          cylinder { <2, -11, -7>, <2, -5, 0>, 1.35 }
        #end
      }
      texture { color_tex }
      bounded_by { box { <-3.5, -10.5, -5.5> <4.5, 3.5, 3.5> } }
    }
  #end
#end
#macro right_leg(color_tex)
  #if (setting = 0)
    box { <-7.8, -11, -2> <-0.5, 0, 4.5> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -7.800001*x, -0.9*x, 3.5 }
        box { <-7.8, -11, -2> <-0.5, 0, 3.5> }
        box { <-7.800001, -11.000001, -4.3> <-0.499999, -8.1, 3.500001> }
      }
      #if (setting > 1)
        cylinder { -1*x, 1*x, 3.6 }
        cylinder { 1.5*z, 4*z, 2.45 translate <-4, 1, 0> }
        cylinder { 1.5*z, 4*z, 2.45 translate <-4, -7, 0> }
        box { <-6.5, -12, -2.8> <-1.5, -9, 2.000002> }
        box { <-6.500001, -12, -0.5> <-1.500001, -2, 2.000001> }
        cylinder { -4*x, 0*x, 1.25 }
      #end
      box { <-5.5, -1.25, -1.5> <-3, 2.5, 2> }
      box { <-10, -20, -10> <0, 20, 10> rotate -3*z translate <-7.8, -11, 0> }
      texture { color_tex }
      bounded_by { box { <-8, -11.1, -4.5> <0, 3.6, 3.6> } }
    }
  #end
#end
#macro leg_joiner(color_tex)
  #if (setting = 0)
    box { <-7, 3, -3.9> <7, 4.9, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-7, 3, -3.9> <7, 4.9, 3.9> }
        cylinder { -8*x, 8*x, 3.7 }
      }
      box { <-0.800001, 1, -2.9> <0.800001, 4, 2.9> }
      cylinder { -0.8*x, 0.8*x, 3.5 }
      cylinder { -4*x, 4*x, 1 }
      #if (setting > 1)
        cylinder { -5*x, -4*x, 1 translate <0, -0.25, 0> }
        cylinder { 4*x, 5*x, 1 translate <0, -0.25, 0> }
      #end
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 4.9, 0> }
      #end
      difference {
        box { <-6.5, 4.5, -2.5> <-1.5, 9.9, 2.5> }
        #if (setting > 1)
          cylinder { 4.900001*y, 10*y, 1 translate <-6.5, 0, -2.5> }
          cylinder { 4.900001*y, 10*y, 1 translate <-6.5, 0, 2.5> }
          cylinder { 4.900001*y, 10*y, 1 translate <-1.5, 0, -2.5> }
          cylinder { 4.900001*y, 10*y, 1 translate <-1.5, 0, 2.5> }
          cylinder { 4.900001*y, 10*y, 1.4 translate <-4, 0, 0> }
          box { <-2, 0, -3> <0, 4, 3> rotate -10*z translate <-6.5, 7, 0> }
        #end
      }
      difference {
        box { <1.5, 4.5, -2.5> <6.5, 9.9, 2.5> }
        #if (setting > 1)
          cylinder { 4.900001*y, 10*y, 1 translate <6.5, 0, -2.5> }
          cylinder { 4.900001*y, 10*y, 1 translate <6.5, 0, 2.5> }
          cylinder { 4.900001*y, 10*y, 1 translate <1.5, 0, -2.5> }
          cylinder { 4.900001*y, 10*y, 1 translate <1.5, 0, 2.5> }
          cylinder { 4.900001*y, 10*y, 1.4 translate <4, 0, 0> }
          box { <0, 0, -3> <2, 4, 3> rotate 10*z translate <6.5, 7, 0> }
        #end
      }
      texture { color_tex }
      bounded_by { box { <-7.1, -3.75, -4> <7.1, 10, 4> } }
    }
  #end
#end
#macro lhpropellor2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
      cylinder { 5*y, 17.6*y, 2.5 translate <4, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 10.4> }
        #end
      }
      difference {
        merge {
          cylinder { 9.4*y, 10.3*y, 2.9 }
          cylinder { 10.2*y, 17.5*y, 2.25 }
          torus { 2.249995, 0.3 translate <0, 17.2, 0> }
        }
        cylinder { -4*z, 4*z, 0.5 translate <0, 14.7, 0> }
        box { <-0.5, 14.7, -4> <0.5, 18, 4> }
        cylinder { 9.4*y, 18.6*y, 1.6 }
        translate <4, 0, 4>
      }
      #if (setting > 1)
        object { high_ring() translate <4, 0, 4> }
        box { <3.5, 3, -1> <4.5, 8.7, 1.1> }
        box { <3.5, 3, 6.9> <4.5, 8.7, 9> }
        box { <-1, 3, 3.5> <1.1, 8.7, 4.5> }
        box { <6.9, 3, 3.5> <9, 8.7, 4.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 17.6, 12> } }
    }
  #end
#end
#macro lhpropellor2_4(color_tex)
  #if (setting = 0)
    merge {
      box { <4.1, 0, -3.9> <19.9, 9.5, 11.9> }
      box { <-3.9, -0.00005, -3.90005> <27.9, 3.1, 11.90005> }
      cylinder { 5*y, 17.6*y, 2.5 translate <12, 0, 4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> }
          box { <-4, 3.1, -4> <4.1, 10, 12> }
          box { <19.9, 3.1, -4> <28, 10, 12> }
          #if (setting > 1)
            box { <5.6, -1, -2.4> <18.4, 8.6, 10.4> }
            box { <-2.4, -1, -2.4> <2.4, 2, 10.4> }
            box { <21.6, -1, -2.4> <26.4, 2, 10.4> }
            box { <3.5, -1, -2.4> <4.5, 2, 10.4> }
            box { <19.5, -1, -2.4> <20.5, 2, 10.4> }
          #end
        }
        difference {
          merge {
            cylinder { 9.4*y, 10.3*y, 2.9 }
            cylinder { 10.2*y, 17.5*y, 2.25 }
            torus { 2.249995, 0.3 translate <0, 17.2, 0> }
          }
          cylinder { -4*z, 4*z, 0.5 translate <0, 14.7, 0> }
          box { <-0.5, 14.7, -4> <0.5, 18, 4> }
          cylinder { 9.4*y, 18.6*y, 1.6 }
          translate <12, 0, 4>
        }
        #if (setting > 1)
          object { high_ring() translate <12, 0, 4> }
          object { pin(2) translate <0, 0, 4> }
          object { pin(2) translate <24, 0, 4> }
          difference {
            merge {
              box { <-6.5, 5.6, -0.4> <6.5, 8.7, 0.4> }
              box { <-0.4, 5.6, -6.5> <0.4, 8.7, 6.5> }
            }
            cylinder { -1*y, 10*y, 3 }
            box { <-10, -10, -1> <0, 0, 1> rotate 35*z translate <6.4, 8.4, 0> }
            box { <0, -10, -1> <10, 0, 1> rotate -35*z translate <-6.4, 8.4, 0> }
            box { <-1, -10, 0> <1, 0, 10> rotate 35*x translate <0, 8.4, -6.4> }
            box { <-1, -10, -10> <1, 0, 0> rotate -35*x translate <0, 8.4, 6.4> }
            translate <12, 0, 4>
          }
        #end
        object { rounded_button() }
        object { rounded_button() translate <0, 0, 8> }
        object { rounded_button() translate <24, 0, 0> }
        object { rounded_button() translate <24, 0, 8> }
      }
      #if (setting > 1)
        cylinder { 1*y, 4*y, 1.2 }
        cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 17.6, 12> } }
    }
  #end
#end
#macro life_vest(color_tex)
  #if (setting = 0)
    merge {
      box { <-9.25, 0, -7.15> <9.25, 2.5, 8.25> }
      box { <-7, -13, -7.150001> <7, 0.000001, -4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3, 0, -3.500001> <3, 2.5, 7> }
        box { <-8.25, -0.000001, -7> <8.25, 2.500001, 2.000001> }
        box { <-9.25, -0.000002, -6.999999> <9.25, 2.500002, -2> }
        cylinder { 0.000001*y, 2.499999*y, 5 translate <-3, 0, 2> }
        cylinder { 0.000001*y, 2.499999*y, 5 translate <3, 0, 2> }
        cylinder { -3.5*z, 2*z, 1.25 translate <8, 1.25, 0> }
        cylinder { -3.5*z, 2*z, 1.25 translate <-8, 1.25, 0> }
        intersection {
          torus { 5, 1.25 }
          box { <0, -2, 0> <7, 2, 7> }
          translate <2.999999, 1.25, 1.999999>
        }
        intersection {
          torus { 5, 1.25 }
          box { <-7, -2, 0> <0, 2, 7> }
          translate <-2.999999, 1.25, 1.999999>
        }
        cylinder { -3*x, 3*x, 1.25 translate <0, 1.25, 7> }
        box { <-6, -12, -7> <6, 0.000001, -4> }
        box { <-9.25, -3.25, -7.000001> <9.25, 0.000001, -3.999999> }
      }
      box { <-1, -13, -1> <1, 5, 1> rotate 45*y translate <0, 0, -7.6> }
      superellipsoid { <0.7, 0.7> scale <7, 2, 7> translate <0, 3, 0> }
      cylinder { -1*y, 2*y, 2.5 }
      difference {
        box { <-2.5, -1, -7> <2.5, 3, 0> }
        box { <-5, -2, -9> <-2.5, 4, 0> rotate -20*y }
        box { <2.5, -2, -9> <5, 4, 0> rotate 20*y }
      }
      difference {
        box { <-10, -2, -10> <-8, 4, 1> }
        cylinder { 2*z, -10*z, 1.250001 translate <-8, 1.25, 0> }
      }
      difference {
        box { <8, -2, -10> <10, 4, 1> }
        cylinder { 2*z, -10*z, 1.250001 translate <8, 1.25, 0> }
      }
      difference {
        box { <-10, 0, -9> <10, 6, -4.5> }
        cylinder { -10*x, 10*x, 2.5 translate <0, 0, -4.5> }
      }
      difference {
        box { <4, 0.75, -9> <-4, 6, -6> }
        cylinder { -5*x, 5*x, 1 translate <0, 1, -6> }
      }
      difference {
        box { <-10, -13, -8> <-4.25, 5, -2> }
        cylinder { -14*y, 6*y, 5 translate <-4.25, 0, -2> }
      }
      difference {
        box { <4.25, -13, -8> <10, 5, -2> }
        cylinder { -14*y, 6*y, 5 translate <4.25, 0, -2> }
      }
      difference {
        box { <-7, -13, -8> <-4, -10, -3> }
        cylinder { -8*z, -3*z, 2 translate <-4, -10, 0> }
      }
      difference {
        box { <4, -13, -8> <7, -10, -3> }
        cylinder { -8*z, -3*z, 2 translate <4, -10, 0> }
      }
      difference {
        box { <-7, -13, -8> <7, -9, -5> }
        cylinder { -7*x, 7*x, 2 scale <1, 2, 1> translate <0, -9, -5> }
      }
      cylinder { -10*z, 10*z, 3.25 translate <-9.25, -3.25, 0> }
      cylinder { -10*z, 10*z, 3.25 translate <9.25, -3.25, 0> }
      texture { color_tex }
      bounded_by { box { <-9.35, -13.1, -7.25> <9.35, 2.6, 8.35> } }
    }
  #end
#end
#macro light_cap(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 6.4*y, 10*y, 3.1 }
      sphere { <0, 9.999999, 0> 3.100001 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 6.4*y, 7.6*y, 2.8 }
        cylinder { 7.5*y, 10*y, 3.1 }
        sphere { <0, 9.999999, 0> 3.100001 }
      }
      sphere { <0, 9.999999, 0> 2.6 }
      cylinder { 5*y, 10*y, 2.600001 }
      texture { color_tex }
      bounded_by { cylinder { 6.3*y, 13.2*y, 3.25 } }
    }
  #end
#end
#macro light_element1_2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*z, -9.25*z, 2.25 translate <4, 5.6, 0> }
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          #else
            object { conductive_button() rotate 180*y translate <0, 6.4, 0> }
            object { conductive_button() translate <8, 6.4, 0> }
          #end
        }
        difference {
          box { <-4, 3, -1.75> <12, 4.3, 1.75> }
          box { <-5, 3.2, -1.55> <13, 4.1, 1.55> }
          box { <-3.3, 0, -2> <11.3, 5, 2> }
        }
        cylinder { 0*z, -4*z, 2.35 translate <4, 5.6, 0> }
        box { <2.2, -1, 4> <5.8, 10, 2.4> }
        #if (setting > 1)
          box { <-3.3, -1, -3.3> <-2.8, 8.5, 3.3> }
          box { <10.8, -1, -3.3> <11.3, 8.5, 3.3> }
          difference {
            box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
            box { <3.45, 0.2, -2.5> <4.55, 3, 2.5> }
            box { <2.5, 0.200001, -0.55> <5.5, 3, 0.55> }
            difference {
              box { <1.2, -0.5, 1.5> <6.8, 3, 4> }
              box { <-2, -1, -2> <0, 4, 0> rotate 45*y translate <2.2, 0, 1.5> }
              box { <0, -1, -2> <2, 4, 0> rotate -45*y translate <5.8, 0, 1.5> }
            }
          }
        #end
      }
      difference {
        merge {
          cylinder { -2*z, -7.5*z, 2.25 translate <4, 5.6, 0> }
          sphere { <4, 5.6, -7.5> 2.250001 }
        }
        sphere { <4, 5.6, -7.5> 1.75 }
        cylinder { -1*z, -7.5*z, 1.750001 translate <4, 5.6, 0> }
        #if (setting > 1)
          texture { t_white_tex }
          interior { ior 1.5 }
        #else
          texture { color_tex }
        #end
      }
      #if (setting > 1)
        cylinder { <2.5, 5.6, -8.7> <3.5, 5.6, -1.7> 0.25 texture { chrome_tex } }
        cylinder { <5.5, 5.6, -8.7> <4.5, 5.6, -1.7> 0.25 texture { chrome_tex } }
        cylinder { <2.5, 5.6, -7.7> <5.5, 5.6, -7.7> 0.25 texture { chrome_tex } }
        cylinder { <2.5, 4.6, -6.2> <3.5, 4.6, -1.7> 0.25 texture { brown_tex } }
        cylinder { <5.5, 4.6, -6.2> <4.5, 4.6, -1.7> 0.25 texture { brown_tex } }
        box { <-3.2, 0.2, -3.2> <-2.9, 8.5, 3.2> texture { chrome_tex } }
        box { <11.2, 0.2, -3.2> <10.9, 8.5, 3.2> texture { chrome_tex } }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -9.85> <12, 11.3, 4> } }
    }
  #end
#end
#macro light_element1_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 6.3, 3.9> }
      cylinder { 4*y, 12.25*y, 2.25 }
      cylinder { 4*y, 12.25*y, 2.25 translate <24, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 6.3, 3.9> }
          #if (setting < 3)
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 0> }
            cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, 0> }
          #else
            object { rounded_button() translate <8, 3.2, 0> }
            object { rounded_button() translate <16, 3.2, 0> }
          #end
        }
        #if (setting > 1)
          box { <-3.3, -1, -3.3> <27.3, 5.6, 3.3> }
          box { <-2.5, 1.5, -4> <0, 2.8, 4> }
          box { <10.75, 1.5, -4> <13.25, 2.8, 4> }
          box { <24, 1.5, -4> <26.5, 2.8, 4> }
        #end
        cylinder { 4*y, 7*y, 2.35 }
        cylinder { 4*y, 7*y, 2.35 translate <24, 0, 0> }
      }
      #if (setting > 1)
        cylinder { <0, 4, -0.5> <0, 11, -1.5> 0.25 texture { chrome_tex } }
        cylinder { <0, 4, 0.5> <0, 11, 1.5> 0.25 texture { chrome_tex } }
        cylinder { <0, 10, -1.5> <0, 10, 1.5> 0.25 texture { chrome_tex } }
        cylinder { <24, 4, -0.5> <24, 11, -1.5> 0.25 texture { chrome_tex } }
        cylinder { <24, 4, 0.5> <24, 11, 1.5> 0.25 texture { chrome_tex } }
        cylinder { <24, 10, -1.5> <24, 10, 1.5> 0.25 texture { chrome_tex } }
        box { <-3.2, 0.2, -3.2> <27.2, 5.7, -2.9> texture { chrome_tex } }
        box { <-3.2, 0.2, 2.9> <27.2, 5.7, 3.2> texture { chrome_tex } }
        box { <5.2, 0.2, -2.4> <5.5, 6, 2.4> texture { chrome_tex } }
        box { <18.5, 0.2, -2.4> <18.8, 6, 2.4> texture { chrome_tex } }
        cylinder { <-1, 4, -0.5> <-1, 8.5, -1.5> 0.25 texture { brown_tex } }
        cylinder { <-1, 4, 0.5> <-1, 8.5, 1.5> 0.25 texture { brown_tex } }
        cylinder { <25, 4, -0.5> <25, 8.5, -1.5> 0.25 texture { brown_tex } }
        cylinder { <25, 4, 0.5> <25, 8.5, 1.5> 0.25 texture { brown_tex } }
        cylinder { 1.4*y, 2.2*y, 2.45 translate <12, 0, 0> texture { black_tex } }
      #end
      difference {
        merge {
          cylinder { 4*y, 10*y, 2.25 }
          sphere { <0, 9.999999, 0> 2.250001 }
        }
        sphere { <0, 9.999999, 0> 1.75 }
        cylinder { 3*y, 10*y, 1.750001 }
        #if (setting > 1)
          texture { t_white_tex }
          interior { ior 1.5 }
        #else
          texture { color_tex }
        #end
      }
      difference {
        merge {
          cylinder { 4*y, 10*y, 2.25 }
          sphere { <0, 9.999999, 0> 2.250001 }
        }
        sphere { <0, 9.999999, 0> 1.75 }
        cylinder { 3*y, 10*y, 1.750001 }
        #if (setting > 1)
          texture { t_white_tex }
          interior { ior 1.5 }
        #else
          texture { color_tex }
        #end
        translate <24, 0, 0>
      }
      #if (setting > 1)
        merge {
          box { <-2.3, 1.7, -3.9> <-0.2, 2.55, 3.9> }
          box { <10.95, 1.7, -3.9> <13.05, 2.55, 3.9> }
          box { <24.2, 1.7, -3.9> <26.3, 2.55, 3.9> }
          difference {
            box { <-3.3, 0, -2.8> <27.3, 5, 2.8> }
            box { <-2.5, -1, -2.5> <2.5, 1.5, 2.5> }
            box { <5, -1, -2.5> <9.75, 1.5, 2.5> }
            box { <9, -1, -1.5> <11.5, 1.500001, 1.5> }
            box { <12.5, -1, -1.5> <15, 1.500001, 1.5> }
            box { <14.25, -1, -2.5> <19, 1.5, 2.5> }
            box { <21.5, -1, -2.5> <26.5, 1.5, 2.5> }
            box { <4, -1, -2.5> <4.2, 1.5, 2.5> }
            box { <19.8, -1, -2.5> <20, 1.5, 2.5> }
          }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 12.35, 4> } }
    }
  #end
#end
#macro lmconnect(color_tex)
  #if (setting = 0)
    cylinder { -1.55*y, 91.05*y, 1.55 texture { color_tex } }
  #else
    merge {
      box { <-3.899999, 0, -1.550001> <-2.350001, 3.899999, 1.550001> }
      cylinder { -3.9*x, -2.35*x, 1.55 }
      box { <-0.600001, 0, -1.550001> <0.600001, 3.899999, 1.550001> }
      cylinder { -0.6*x, 0.6*x, 1.55 }
      box { <2.350001, 0, -1.550001> <3.899999, 3.899999, 1.550001> }
      cylinder { 2.35*x, 3.9*x, 1.55 }
      difference {
        cylinder { -3.9*x, 3.9*x, 1.55 translate <0, 3.9, 0> }
        box { <-4, 3.9, -2> <4, 6, 2> }
      }
      difference {
        cylinder { 3.89*y, 85.3*y, 2 } 
        box { <-2, 3, -3> <2, 86, -1.55> }
        box { <-2, 3, 1.55> <2, 86, 3> }
      }
      difference {
        merge {
          cylinder { -1.45*z, -2.25*z, 2.4 translate <0, 87.85, 0> } 
          object { open_rounded_button() rotate -90*x translate <0, 87.85, 1.55> }
          cylinder { -1.550001*z, 1.550001*z, 3.2 translate <0, 87.85, 0> }
        }
        cylinder { -8*z, 8*z, 1.600001 translate <0, 87.85, 0> }
        cylinder { 8*z, -0.35*z, 2.4 translate <0, 87.85, 0> }
        box { <-0.5, 87.85, -8> <0.5, 100, 8> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -1.65, -3.35> <4, 91.15, 1.65> } }
    }
  #end
#end
#macro lmconnect_short(color_tex)
  #if (setting = 0)
    cylinder { -1.55*y, 59.05*y, 1.55 texture { color_tex } }
  #else
    merge {
      box { <-3.899999, 0, -1.550001> <-2.350001, 3.899999, 1.550001> }
      cylinder { -3.9*x, -2.35*x, 1.55 }
      box { <-0.600001, 0, -1.550001> <0.600001, 3.899999, 1.550001> }
      cylinder { -0.6*x, 0.6*x, 1.55 }
      box { <2.350001, 0, -1.550001> <3.899999, 3.899999, 1.550001> }
      cylinder { 2.35*x, 3.9*x, 1.55 }
      difference {
        cylinder { -3.9*x, 3.9*x, 1.55 translate <0, 3.9, 0> }
        box { <-4, 3.9, -2> <4, 6, 2> }
      }
      cylinder { 3.89*y, 53.3*y, 1.55 }
      box { <-1.55, 51.6, -1.55> <1.55, 53, 1.55> }
      difference {
        merge {
          cylinder { -1.45*z, -2.25*z, 2.3 translate <0, 55.85, 0> } 
          object { open_rounded_button() rotate -90*x translate <0, 55.85, 1.55> }
          cylinder { -1.550001*z, 1.550001*z, 3.2 translate <0, 55.85, 0> }
        }
        cylinder { -8*z, 8*z, 1.600001 translate <0, 55.85, 0> }
        cylinder { 8*z, -0.35*z, 2.6 translate <0, 55.85, 0> }
        box { <-0.5, 55.85, -8> <0.5, 68, 8> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -1.65, -3.35> <4, 59.15, 1.65> } }
    }
  #end
#end
#macro l_propellor2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      cylinder { 3*y, 11.1*y, 2.25 translate <4, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
      #end
      difference {
        merge {
          cylinder { 3*y, 3.85*y, 2.9 }
          cylinder { 3*y, 11.1*y, 2.25 }
          torus { 2.249995, 0.3 translate <0, 10.8, 0> }
        }
        box { <-0.5, 8.299999, -4> <0.5, 12, 4> }
        cylinder { -4*z, 4*z, 0.5 translate <0, 8.3, 0> }
        cylinder { 3*y, 12*y, 1.6 }
        translate <4, 0, 4>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.2, 12> } }
    }
  #end
#end
#macro l_propellor2_3(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <19.9, 3.1, 11.9> }
      cylinder { 3*y, 11.2*y, 2.75 translate <8, 0, 4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 }
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
        #else
          object { rounded_button() }
          object { rounded_button() translate <0, 0, 8> }
          object { rounded_button() translate <8, 0, 0> }
          object { rounded_button() translate <8, 0, 8> }
          object { rounded_button() translate <16, 0, 0> }
          object { rounded_button() translate <16, 0, 8> }
        #end
        difference {
          box { <-3.9, 0, -3.9> <19.9, 3.1, 11.9> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <18.4, 2, 10.4> }
          #end
        }
        #if (setting > 1)
          object { ring() translate <4, 0, 4> }
          object { ring() translate <12, 0, 4> }
        #end
        difference {
          merge {
            cylinder { 3*y, 5.9*y, 3.1 }
            cylinder { 5.8*y, 9.9*y, 2.75 }
            cylinder { 9.8*y, 11.2*y, 3 }
          }
          box { <-4, 7, -0.4> <0, 12, 0.4> }
          box { <-4, 7, -0.4> <0, 12, 0.4> rotate 120*y }
          box { <-4, 7, -0.4> <0, 12, 0.4> rotate -120*y }
          cylinder { 3*y, 12*y, 1.35 }
          translate <8, 0, 4>
        }
      }
      #if (setting > 1)
        cylinder { 1*y, 4*y, 1.2 }
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
        cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 12> } }
    }
  #end
#end
#macro magneet()
cylinder { -3.5*y, 3.5*y, 5
  texture {
    pigment { color rgb <0.2, 0.2, 0.2> }
    finish { ambient 0.4 specular 1 roughness 0.005 reflection 0 }
    normal { dents 0.1 scale 0.1 }
  }
  bounded_by { cylinder { -3.6*y, 3.6*y, 5.1 } }
}
#end
#macro magneet_holder(color_tex)
  #if (setting = 0)
    difference {
    box { <-7.9, 0, -3.9> <7.9, 9.5, 13.9> }
    box { <-20, -1, -20> <0, 10, 20> rotate -24*y translate <-3.9, 0, -3.9> }
    box { <0, -1, -20> <20, 10, 20> rotate 24*y translate <3.9, 0, -3.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-7.9, 0, -3.9> <7.9, 9.5, 13.9> }
        cylinder { -1*y, 2*y, 2.5 translate <-7.9, 0, 0.5> }
        cylinder { -1*y, 2*y, 2.5 translate <7.9, 0, 0.5> }
        merge {
          cylinder { -6*z, 6*z, 2.4 }
          cylinder { -5*z, -3.4*z, 3.1 }
          cylinder { 3.4*z, 5*z, 3.1 }
          translate <0, 5.6, 0>
        }
        difference {
          box { <-6.5, -1, -2.4> <6.5, 10, 2.4> }
          box { <-3.499999, -1, -4> <3.499999, 11, 4> }
          box { <-9, 5, -4> <9, 6.5, 4> }
          box { <-5, -1, -20> <0, 10, 20> rotate -24*y translate <-3.5, 0, -1.5> }
          box { <0, -1, -20> <5, 10, 20> rotate 24*y translate <3.5, 0, -1.5> }
        }
        box { <-9, -1, 4> <9, 2, 15> }
        box { <-6.5, -1, 4.000001> <6.5, 4, 15> }
        box { <-6.5, 5.5, 4.000001> <6.5, 10, 15> }
        cylinder { 3*y, 7*y, 6.5 translate <0, 0, 10.5> }
        box { <-6.500001, 3, 10.6> <6.500001, 7, 35> }
        box { <-20, -1, -20> <0, 10, 20> rotate -24*y translate <-3.9, 0, -3.9> }
        box { <0, -1, -20> <20, 10, 20> rotate 24*y translate <3.9, 0, -3.9> }
        box { <-9, 0, 0> <9, 10, 5> rotate 30*x translate <0, 9.5, 12> }
        box { <-9, -10, 0> <9, 0, 5> rotate -30*x translate <0, 2, 12> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
          cylinder { -1*y, 11*y, 1.600001 }
          cylinder { -9*x, 9*x, 0.9 translate <0, 5.6, 12.5> }
          box { <-9, 5, 12.5> <9, 6.5, 14> }
        #end
      }
      object { open_rounded_button() translate <0, 6.4, 0> }
      texture { color_tex }
      bounded_by { box { <-8, -0.1, -4> <8, 11.3, 14> } }
    }
  #end
#end
#macro magneet_ring(color_tex)
  #if (setting = 0)
    cylinder { -3.4*y, 3.4*y, 6 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { -3.4*y, 3.4*y, 6 }
        cylinder { -4*y, 4*y, 5.1 }
        box { <-3, -4, -7> <3, 4, -5.5> }
        box { <-3, -4, 5.5> <3, 4, 7> }
      }
      #if (setting > 1)
        cylinder { -7.2*z, -5.25*z, 0.8 }
        cylinder { 5.25*z, 7.2*z, 0.8 }
      #end
      texture { color_tex }
      bounded_by { box { <-6.1, -3.5, -7.3> <6.1, 3.5, 7.3> } }
    }
  #end
#end
#macro mail_box(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 19.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 19.1, 11.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          box { <-0.2, 14.4, -4> <8.2, 17.7, 12> }
        #end
        difference {
          box { <-2.4, 3.1, -4> <10.4, 18.1, 10.4> }
          box { <-0.75, 15.9, -1> <0.000001, 19, 11> }
          box { <8.000001, 15.9, -1> <8.75, 19, 11> }
          box { <0.5, 0, 0> <1.5, 10, 5> rotate 2*x translate <0, 3.1, 9.40> }
          box { <3.5, 0, 0> <4.5, 10, 5> rotate 2*x translate <0, 3.1, 9.40> }
          box { <6.5, 0, 0> <7.5, 10, 5> rotate 2*x translate <0, 3.1, 9.40> }
        }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
      #end
      #if (setting < 3)
        cylinder { 19*y, 20.8*y, 2.4 }
        cylinder { 19*y, 20.8*y, 2.4 translate <0, 0, 8> }
        cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 0> }
        cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 8> }
      #else
        object { rounded_button() rotate 90*y translate <0, 16, 0> }
        object { rounded_button() rotate 90*y translate <0, 16, 8> }
        object { rounded_button() rotate 90*y translate <8, 16, 0> }
        object { rounded_button() rotate 90*y translate <8, 16, 8> }
      #end
      box { <-2.500001, -0.000001, -6.500001> <-1.000001, 3.100001, -3.8> }
      cylinder { -2.5*x, -1*x, 1.55 translate <0, 1.55, -6.5> }
      box { <9.000001, -0.000001, -6.500001> <10.500001, 3.100001, -3.8> }
      cylinder { 9*x, 10.5*x, 1.55 translate <0, 1.55, -6.5> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -8.15> <12, 20.9, 12> } }
    }
  #end
#end
#macro mail_box_cover(color_tex)
  #if (setting = 0)
    box { <-3.9, -1.55, -2> <11.9, 17.55, 2> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { -3.9*x, 11.9*x, 1.55 translate <0, 0, -0.45> }
          cylinder { -3.9*x, 11.9*x, 1.55 translate <0, 0, 0.45> }
          box { <-3.899999, -1.550001, -0.450001> <11.899999, 0.000001, 0.450001> }
          box { <-3.900001, -0.000001, -1.999999> <11.900001, 17.55, 1.999999> }
        }
        box { <-0.2, 13.250001, -3> <8.2, 16.550001, 3> }
        #if (setting > 1)
          box { <-2.4, 1.45, -1> <10.4, 16.550001, 3> }
          box { <0, -0.55, -1> <8, 0.45, 3> }
        #end
        box { <-2.500001, -2, -3> <-0.9, 1.550001, 3> }
        box { <8.9, -2, -3> <10.500001, 1.550001, 3> }
        box { <-2, -3, 1> <10, 3, 3> }
      }
      #if (setting > 1)
        box { <-1, 13.55, -1.5> <0, 16.55, 3.9> }
        box { <8, 13.55, -1.5> <9, 16.55, 3.9> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -1.65, -2.1> <12, 17.65, 4> } }
    }
  #end
#end
#macro male_hair(color_tex)
  #if (setting = 0)
    merge {
      sphere { <0, 0, 0> 1 scale <6, 4.5, 6> }
      translate <0, 2, 0>
      texture { color_tex }
    }
  #else
    merge {
              difference {
                        merge {
                          difference {
                            sphere { <0, 0, 0> 1 scale <6, 4.5, 6> }
                            box { <-20, -10, -20> <20, 0, 20> }
                            translate <0, 2, 0>
                          }
                          difference {
                            sphere { <0, 0, 0> 1 scale <6.000001, 10, 6.000001> }
                            box { <-20, 0.000001, -20> <20, 20, 20> }
                            translate <0, 2, 0>
                          }
                          sphere { <0, 0, 0> 1 scale <5, 3.5, 5.25> translate <0, 0, -5.25> rotate 15*x rotate 10*z translate <0, 2, 6> }
                        }
                        difference {
                          box { <-10, -10, -4> <0, 4, 4> }
                          sphere { <0, 0, 0> 1 scale <5, 3.5, 6> translate <0, 0, -5> rotate 7.5*x translate <-2.5, 3.5, 6> }
                        }
                        difference {
                          box { <-5, -10, -9> <0, 4, 9> }
                          cylinder { -10*z, 10*z, 1 scale <1, 1.75, 1> }
                          sphere { <0, 0, 0> 1 scale <5, 3.5, 6> translate <0, 0, -5> rotate 5*x translate <-0.5, 3.1, 6> }
                          box { <-1, 0, -10> <5, 5, 10> }
                          translate <-2, 0.4, 0>
                        }
                        box { <-10, -20, -10> <10, 0, 10> rotate -12*z translate <0, -2, 0> }
                        #if (setting > 1)
                          cylinder { -10*y, 2.1000001*y, 5 }
                          cone { 1.999999*y, 5, 4*y, 3 }
                          cylinder { -10*z, 10*z, 1.5 translate <0.5, -1, 0,> }
                        #end
                        box { <-1.000001, -10, -10> <1.75, -0.999999, 10> }
                        difference {
                          box { <-2, -3, -10> <1, -1, 10> }
                          cylinder { -9*z, 9*z, 1 translate <-2, -1, 0> }
                        }
              }
              #if (setting > 1)
                object { ring() translate <0, 3, 0> }
              #end
              texture { color_tex }
              bounded_by { box { <-10, -9.25, -6.25> <6.25, 14.25, 6.25> } }
    }
  #end
#end
#macro mine_detector(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -19.7*x, -4*x, 1.5 translate <0, 5.1, 0> }
      box { <-4.9, 2.4, -2.5> <10.9, 8.8, 2.5> }
      cylinder { 2.1*y, 3.6*y, 5.3 translate <-5.3, -2.1, 0>
        rotate -45*z translate <-19.7, 4.8, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { -2.35*y, 10.15*y, 1.5 }
          cylinder { 8.7*y, 10.15*y, 1.5 translate <7, 0, 0> }
          torus { 1.35, 0.15 translate <0, -2.35, 0> }
          torus { 1.35, 0.15 translate <0, 10.15, 0> }
          torus { 1.35, 0.15 translate <7, 10.15, 0> }
          cylinder { -2.5*y, 10.3*y, 1.35 }
          cylinder { 10*y, 10.3*y, 1.35 translate <7, 0, 0> }
          box { <-4.9, 2.4, -2.5> <10.9, 8.8, 2.5> }
          object { open_rounded_button() rotate -90*x translate <7, 5.1, 1.2> }
          object { open_rounded_button() rotate 90*x translate <7, 5.1, -1.2> }
          object { open_rounded_button() rotate -90*z translate <7.8, 5.1, 0> }
        }
        box { <-3, 3.7, -3> <3, 7.5, -1> }
        box { <-3, 3.7, 1> <3, 7.5, 3> }
        cylinder { -10*z, 10*z, 1.600001 translate <7, 5.1, 0> }
        cylinder { 10.899999*x, 13*x, 1.600001 translate <0, 5.1, 0> }
      }
      difference {
        cylinder { -19.7*x, -4*x, 1.5 translate <0, 5.1, 0> }
        box { <0, -10, -2> <10, 0, 2> rotate -16.25*z translate <-19.7, 4.8, 0> }
      }
      difference {
        merge {
          cylinder { 0*y, 2.2*y, 3.2 }
          cylinder { 2.1*y, 3.6*y, 5.3 }
          object { open_rounded_button() translate <0, 0.5, 0> }
        }
        cylinder { -1*y, 2.100001*y, 2.6 }
        cylinder { -1*y, 6*y, 1.600001 }
        translate <-5.3, -2.1, 0>
        rotate -45*z
        translate <-19.7, 4.8, 0>
      }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z translate <10.9, 5.1, 0> }
        object { llogo() rotate -90*z rotate 90*y translate <0, 5.1, -1> }
        object { llogo() rotate -90*z rotate -90*y translate <0, 5.1, 1> }
      #end
      texture { color_tex }
      bounded_by { box { <-28, -2.6, -5.4> <12.7, 16, 5.4> } }
    }
  #end
#end
#macro minifigure_vest(color_tex)
  #if (setting = 0)
    difference {
      box { <-5.2, -12.7, -5.2> <5.2, 1.2, 5.2> }
      box { <-6, -13, -4> <6, 0, 4> }
      texture { color_tex }
    }
  #else
    difference {
      box { <-5.2, -12.7, -5.2> <5.2, 1.2, 5.2> }
      box { <-6, -13, -4> <6, 0, 4> }
      difference {
        box { <-7, -13, -6> <7, -11.7, 6> }
        cylinder { -7*z, 7*z, 1 translate <-4.2, -11.7, 0> }
        cylinder { -7*z, 7*z, 1 translate <4.2, -11.7, 0> }
        box { <-4.2, -12.700005, -7> <4.2, -11.7, 7> }
      }
      cylinder { -1*y, 2*y, 2.5 }
      texture { color_tex }
      bounded_by { box { <-5.3, -12.8, -5.3> <5.3, 1.3, 5.3> } }
    }
  #end
#end
#macro mini_closet(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 19.1, 11.9> }
      box { <-2.9, 3, -4> <18.9, 18, 10.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <19.9, 19.1, 11.9> }
        #if (setting > 1)
          box { <-2.2, -1, -2.2> <18.2, 2, 10.2> }
          cylinder { -1*y, 20*y, 0.6 translate <-2, 0, -2.5> }
          cylinder { -1*y, 20*y, 0.6 translate <18, 0, -2.5> }
        #end
        box { <-2.9, 3, -4> <18.9, 18, 10.9> }
      }
      #if (setting < 3)
        cylinder { 19*y, 20.8*y, 2.4 }
        cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 0> }
        cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 0> }
        cylinder { 19*y, 20.8*y, 2.4 translate <0, 0, 8> }
        cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 8> }
        cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 8> }
      #else
        object { rounded_button() translate <0, 16, 0> }
        object { rounded_button() translate <8, 16, 0> }
        object { rounded_button() translate <16, 16, 0> }
        object { rounded_button() translate <0, 16, 8> }
        object { rounded_button() translate <8, 16, 8> }
        object { rounded_button() translate <16, 16, 8> }
      #end
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        box { <-3, 9.5, -2> <-2.2, 10.5, 11> }
        box { <18.2, 9.5, -2> <19, 10.5, 11> }
        box { <-3, 17, -2> <-2.2, 18.1, -1> }
        box { <18.2, 17, -2> <19, 18.1, -1> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 20.9, 12> } }
    }
  #end
#end
#macro mini_closet_door(color_tex)
  #if (setting = 0)
    box { <-0.75, 3.1, -0.75> <20.75, 17.9, 0.75> texture { color_tex } }
  #else
    difference {
      merge {
        sphere { <0, 3.100001, 0> 0.750001 }
        sphere { <0, 17.899999, 0> 0.750001 }
        box { <-0.75, 3.1, -0.75> <20.75, 17.9, 0.75> }
        box { <17.2, 9, -2.75> <19, 12, -0.5> }
        cylinder { -2.750001*z, -0.5*z, 0.9 translate <18.1, 9.000001, 0> }
        cylinder { -2.750001*z, -0.5*z, 0.9 translate <18.1, 11.999999, 0> }
        #if (setting > 3)
          object { llogo() rotate -90*y rotate -90*x translate <8, 7, 0.75> }
        #end
      }
      #if (setting > 1)
        cylinder { -1.75*z, 2*z, 0.91 translate <18.1, 9.000001, 0> }
        cylinder { -1.75*z, 2*z, 0.91 translate <18.1, 11.999999, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-0.85, 2.3, -2.85> <20.85, 18.7, 0.85> } }
    }
  #end
#end
#macro mini_flag(color_tex)
  #if (setting = 0)
    box { <0, -7.9, -0.75> <19.9, 7.9, 0.75> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -7.9*y, 7.9*y, 2.6 }
        box { <4, -7.900001, -0.75> <19.9, 7.900001, 0.75> }
        box { <-0.000001, -7.899999, -2.600001> <4.000001, 7.899999, 2.600001> }
      }
      cylinder { -8*y, 8*y, 1.55 }
      box { <-4, -5, -5> <4.000002, 5, 5> }
      box { <-4, -9, -1.4> <0, 9, 1.4> }
      box { <-10, -8, -10> <3.25, 8, -2.599999> rotate -27.5*y }
      box { <-10, -8, 2.599999> <3.25, 8, 10> rotate 27.5*y }
      texture { color_tex }
      bounded_by { box { <-3, -8, -2.7> <20, 8, 2.7> } }
    }
  #end
#end
#macro mini_flag_sliced(color_tex)
  #if (setting = 0)
    box { <0, -7.9, -0.75> <19.9, 7.9, 0.75> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -7.9*y, 7.9*y, 2.6 }
        box { <4, -7.900001, -0.75> <19.9, 7.900001, 0.75> }
        box { <-0.000001, -7.899999, -2.600001> <4.000001, 7.899999, 2.600001> }
      }
      box { <0, -10, -1> <20, 0, 1> rotate 26*z translate <4, -7.9, 0> }
      cylinder { -8*y, 8*y, 1.55 }
      box { <-4, -5, -5> <4.000002, 5, 5> }
      box { <-4, -9, -1.4> <0, 9, 1.4> }
      box { <-10, -8, -10> <3.25, 8, -2.599999> rotate -27.5*y }
      box { <-10, -8, 2.599999> <3.25, 8, 10> rotate 27.5*y }
      texture { color_tex }
      bounded_by { box { <-3, -8, -2.7> <20, 8, 2.7> } }
    }
  #end
#end
#macro monorail_bogey()
  #if (setting = 0)
    merge {
      cylinder { -11.8*z, -10.6*z, 4.9 translate <-10.1, 4.9, 0> texture { black_tex } }
      cylinder { 11.8*z, 10.6*z, 4.9 translate <-10.1, 4.9, 0> texture { black_tex } }
      cylinder { -11.8*z, -10.6*z, 4.9 translate <10.1, 4.9, 0> texture { black_tex } }
      cylinder { 11.8*z, 10.6*z, 4.9 translate <10.1, 4.9, 0> texture { black_tex } }
      box { <-18.4, 0.5, -15.9> <18.4, 9.5, 15.9> }
      texture { black_tex }
    }
  #else
    union {
      cylinder { -11.8*z, -10.6*z, 4.9 translate <-10.1, 4.9, 0> texture { black_tex } }
      cylinder { 11.8*z, 10.6*z, 4.9 translate <-10.1, 4.9, 0> texture { black_tex } }
      cylinder { -11.8*z, -10.6*z, 4.9 translate <10.1, 4.9, 0> texture { black_tex } }
      cylinder { 11.8*z, 10.6*z, 4.9 translate <10.1, 4.9, 0> texture { black_tex } }
      cylinder { -13.6*z, 13.6*z, 0.9 translate <-10.1, 4.9, 0> texture { chrome_tex } }
      cylinder { -13.6*z, 13.6*z, 0.9 translate <10.1, 4.9, 0> texture { chrome_tex } }
      difference {
        merge {
          box { <-5, 8.2, -12.3> <5, 9.6, 12.3> }
          box { <-2.4, 0, -12.300001> <2.4, 8.25, -10.8> }
          box { <-2.4, 0, 12.300001> <2.4, 8.25, 10.8> }
          cylinder { -12.300002*z, -10.800001*z, 2.4 }
          cylinder { 12.300002*z, 10.800001*z, 2.4 }
          cylinder { 9.5*y, 13.6*y, 2.25 }
          torus { 2.25, 0.25 translate <0, 13.35, 0> }
        }
        cylinder { 9.600001*y, 15*y, 1.75 }
        cylinder { -5*x, 5*x, 0.5 translate <0, 12, 0> }
        box { <-5, 11.999999, -0.5> <5, 15, 0.5> }
        box { <0, 8, -15> <10, 10, 1> rotate 12*y translate <5, 0, 0> }
        box { <-10, 8, -15> <0, 10, 1> rotate -12*y translate <-5, 0, 0> }
        box { <0, 8, -1> <10, 10, 15> rotate -12*y translate <5, 0, 0> }
        box { <-10, 8, -1> <0, 10, 15> rotate 12*y translate <-5, 0, 0> }
        cylinder { -20*z, 20*z, 1.1 }
        box { <-0.9, -3, -20> <0.9, 0, 20> }
        difference {
          box { <-1.4, -3, -21> <1.4, -1.6, 21> }
          cylinder { -21*z, 21*z, 0.5 translate <-1.4, -1.6, 0> }
          cylinder { -21*z, 21*z, 0.5 translate <1.4, -1.6, 0> }
        }
        sphere { <0, 0, 0> 1 scale <2, 1, 2> translate <0, 7.7, 0> }
        texture { black_tex }
        translate <0, 3, 0>
      }
      difference {
        merge {
          box { <-18.4, 0.5, -15.9> <18.4, 9.5, 15.9> }
          cylinder { -9.999999*z, 9.999999*z, 4.5 translate <0, 6, 0> }
        }
        box { <-11.6, 4, -7.2> <-8.6, 10, -9.5> }
        box { <-11.6, 4, 7.2> <-8.6, 10, 9.5> }
        box { <11.6, 4, -7.2> <8.6, 10, -9.5> }
        box { <11.6, 4, 7.2> <8.6, 10, 9.5> }
        box { <-11.6, -1, -6.5> <-8.6, 6.4, 6.5> }
        box { <11.6, -1, -6.5> <8.6, 6.4, 6.5> }
        box { <-20, -10, -10> <20, 0, 0> rotate -22*x translate <0, 4.5, -15.9> }
        box { <-20, 0, -10> <20, 10, 0> rotate 22*x translate <0, 5.5, -15.9> }
        box { <-20, -10, 0> <20, 0, 10> rotate 22*x translate <0, 4.5, 15.9> }
        box { <-20, 0, 0> <20, 10, 10> rotate -22*x translate <0, 5.5, 15.9> }
        box { <-10, 0, -20> <0, 10, 20> rotate -22*z translate <-18.4, 5.5, 0> }
        box { <0, 0, -20> <10, 10, 20> rotate 22*z translate <18.4, 5.5, 0> }
        box { <0, -10, -20> <10, 0, 20> rotate -22*z translate <18.4, 4.5, 0> }
        box { <-10, -10, -20> <0, 0, 20> rotate 22*z translate <-18.4, 4.5, 0> }
        box { <-0.75, 0, -0.75> <0.75, 5.8, 0.75> rotate 45*y translate <-10.1, 0, -12.5> }
        box { <-0.75, 0, -0.75> <0.75, 5.8, 0.75> rotate 45*y translate <-10.1, 0, 12.5> }
        box { <-0.75, 0, -0.75> <0.75, 5.8, 0.75> rotate 45*y translate <10.1, 0, -12.5> }
        box { <-0.75, 0, -0.75> <0.75, 5.8, 0.75> rotate 45*y translate <10.1, 0, 12.5> }
        difference {
          box { <-15.5, 0, -12.6> <15.5, 10, -10> }
          cylinder { -13*z, -9*z, 0.9 translate <0, 3, 0> }
        }
        difference {
          box { <-15.5, 0, 12.6> <15.5, 10, 10> }
          cylinder { 13*z, 9*z, 0.9 translate <0, 3, 0> }
        }
        box { <-15.5, 6.5, -4.2> <15.5, 12, 4.2> }
        difference {
          box { <-18.9, 0, -9> <18.9, 4.8, 9> }
          box { <-20, -1, -10> <-17, 3.5, 10> }
          box { <20, -1, -10> <17, 3.5, 10> }
          box { <0, -1, 0> <15, 5, 6> rotate -13*y translate <6, 0, 3.3> }
          box { <-15, -1, 0> <0, 5, 6> rotate 13*y translate <-6, 0, 3.3> }
          box { <0, -1, 0> <8, 5, 6> rotate -13*y translate <-6, 0, 3.3> }
          box { <-8, -1, 0> <0, 5, 6> rotate 13*y translate <6, 0, 3.3> }
          box { <-4, -1, 4> <4, 5, 10> }
          box { <-4, -1, -4> <4, 5, -10> }
          box { <0, -1, -6> <15, 5, 0> rotate 13*y translate <6, 0, -3.3> }
          box { <-15, -1, -6> <0, 5, 0> rotate -13*y translate <-6, 0, -3.3> }
          box { <0, -1, -6> <8, 5, 0> rotate 13*y translate <-6, 0, -3.3> }
          box { <-8, -1, -6> <0, 5, 0> rotate -13*y translate <6, 0, -3.3> }
        }
        difference {
          box { <-15.500001, 0, -12.600001> <15.500001, 8, -4.6> }
          box { <0, -1, -6> <15, 5, 0> rotate 13*y translate <6, 0, 1.8> }
          box { <-15, -1, -6> <0, 5, 0> rotate -13*y translate <-6, 0, 1.8> }
          box { <0, -1, -6> <8, 5, 0> rotate 13*y translate <-6, 0, 1.8> }
          box { <-8, -1, -6> <0, 5, 0> rotate -13*y translate <6, 0, 1.8> }
          box { <-4, -1, -4> <4, 9, -10.1> }
          box { <-20, 4.8, 0> <0, 9, -5.4> }
          difference {
            box { <-12.6, 1.5, -7.2> <-7.6, 9, -9> }
            box { <-2, -2, -10> <2, 2, -7> rotate 45*z translate <-10.1, 1.5, 0> }
            box { <-11.1, 4, -10> <-9.1, 10, -7> }
            box { <-10.6, 0, -10> <-9.6, 4.5, -7> }
          }
          difference {
            box { <12.6, 1.5, -7.2> <7.6, 9, -9> }
            box { <-2, -2, -10> <2, 2, -7> rotate 45*z translate <10.1, 1.5, 0> }
            box { <11.1, 4, -10> <9.1, 10, -7> }
            box { <10.6, 0, -10> <9.6, 4.5, -7> }
          }
        }
        difference {
          box { <-15.500001, 0, 12.600001> <15.500001, 8, 4.6> }
          box { <0, -1, 0> <15, 5, 6> rotate -13*y translate <6, 0, -1.8> }
          box { <-15, -1, 0> <0, 5, 6> rotate 13*y translate <-6, 0, -1.8> }
          box { <0, -1, 0> <8, 5, 6> rotate -13*y translate <-6, 0, -1.8> }
          box { <-8, -1, 0> <0, 5, 6> rotate 13*y translate <6, 0, -1.8> }
          box { <-4, -1, 4> <4, 9, 10.1> }
          box { <-20, 4.8, 0> <0, 9, 5.4> }
          difference {
            box { <-12.6, 1.5, 7.2> <-7.6, 9, 9> }
            box { <-2, -2, 10> <2, 2, 7> rotate 45*z translate <-10.1, 0.5, 0> }
            box { <-11.1, 4, 10> <-9.1, 10, 7> }
            box { <-10.6, 0, 10> <-9.6, 4.5, 7> }
          }
          difference {
            box { <12.6, 1.5, 7.2> <7.6, 9, 9> }
            box { <-2, -2, 10> <2, 2, 7> rotate 45*z translate <10.1, 0.5, 0> }
            box { <11.1, 4, 10> <9.1, 10, 7> }
            box { <10.6, 0, 10> <9.6, 4.5, 7> }
          }
        }
        #if (setting > 1)
          box { <-2.5, -1, -8.6> <2.5, 8, -5.4> }
          box { <-2.5, -1, 8.6> <2.5, 8, 5.4> }
        #end
        texture { black_tex }
      }
    }
  #end
#end
#macro monorail_long_track(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -15.9> <251.9, 9.9, 15.9> }
      box { <-3.900001, 9.8, -3> <251.900001, 12.9, 3> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -15.9> <251.9, 9.9, 15.9> }
          box { <-4.5, 0.000001, -8.1> <-3.8, 9.900001, -10.9> }
          box { <251.8, 0.000001, 8.1> <252.5, 9.900001, 10.9> }
        }
        box { <-4, -1, 8> <-3.2, 11, 11> }
        box { <251.2, -1, -8> <252, 11, -11> }
        box { <-5, -1, -16> <252, 2.1, -9.4> }
        box { <-4, -1, 9.4> <253, 2.1, 16> }
        box { <-4, -1, -16> <12, 11, -12.8> }
        box { <-4, -1, 12.8> <12, 11, 16> }
        box { <236, -1, -16> <252, 11, -12.8> }
        box { <236, -1, 12.8> <252, 11, 16> }
        box { <11.9, -1, -16> <236.1, 2.100001, -7.9> }
        box { <11.9, -1, 16> <236.1, 2.100001, 7.9> }
        box { <11.900001, -1, -16> <116.1, 2.100002, 16> }
        box { <131.9, -1, -16> <236.1, 2.100002, 16> }
        #if (setting > 1)
          box { <13.4, -1, -14.4> <234.6, 8, 14.4> }
          box { <21.600001, -1, -6.4> <226.300001, 8.000001, 6.4> }
          box { <-2.4, -1, -8.4> <250.4, 8.000002, 8.4> }
          box { <-2.4, -1, -11.3> <12, 8, -9.400001> }
          box { <-2.4, -1, 9.400001> <12, 8, 11.3> }
          box { <236, -1, -11.3> <250.4, 8, -9.400001> }
          box { <236, -1, 9.400001> <250.4, 8, 11.3> }
          box { <0, 9.4, -20> <8, 12, -12.3> }
          box { <0, 9.4, 12.3> <8, 12, 20> }
          box { <240, 9.4, -20> <248, 12, -12.3> }
          box { <240, 9.4, 12.3> <248, 12, 20> }
          box { <-2.400002, -2, -1.1> <250.400002, 11.2, 1.1> }
        #end
      }
      #local counter = -4;
      difference {
        box { <-3.900001, 9.8, -3> <251.900001, 12.9, 3> }
        #if (setting > 1)
          box { <-2.400001, -2, -1.1> <250.100002, 11.200001, 1.1> }
          #while (counter < 257)
            difference {
              box { <-2, 9.7, -4> <2, 13, -2> }
              box { <-2, 9, -5> <0, 14, 0> rotate 20*y translate <-0.2, 0, -2> }
              box { <0, 9, -5> <2, 14, 0> rotate -20*y translate <0.2, 0, -2> }
              translate <counter, 0, 0>
            }
            difference {
              box { <-2, 9.7, 4> <2, 13, 2> }
              box { <-2, 9, 0> <0, 14, 5> rotate -20*y translate <-0.2, 0, 2> }
              box { <0, 9, 0> <2, 14, 5> rotate 20*y translate <0.2, 0, 2> }
              translate <counter, 0, 0>
            }
            #local counter = counter + 1.6;
          #end
        #end
      }
      difference {
        box { <116.100001, -0.000001, -7.900001> <131.900001, 9, 7.900001> }
        box { <117.6, -1, -6.4> <130.4, 10, 6.4> }
      }
      #if (setting > 1)
        difference {
          cylinder { -0.000002*y, 9.8*y, 3.2 }
          cylinder { -1*y, 10*y, 2.6 }
          translate <124, 0, 0>
        }
        box { <3.5, 2.1, -2.6> <117, 8.6, -1.100001> }
        box { <3.5, 2.1, 2.6> <117, 8.6, 1.100001> }
        box { <131, 2.1, -2.6> <244.5, 8.6, -1.100001> }
        box { <131, 2.1, 2.6> <244.5, 8.6, 1.100001> }
        box { <2.4, 0.000003, -9> <3.9, 8.6, 9> }
        box { <244.1, 0.000003, -9> <245.6, 8.6, 9> }
        box { <-0.5, 0.000003, -9> <0.5, 8.6, -6.4> }
        box { <-0.5, 0.000003, 9> <0.5, 8.6, 6.4> }
        box { <247.5, 0.000003, -9> <248.5, 8.6, -6.4> }
        box { <247.5, 0.000003, 9> <248.5, 8.6, 6.4> }
        box { <-2.5, 4.2, -2.1> <2.5, 8.6, -1.100002> }
        box { <-2.5, 4.2, 2.1> <2.5, 8.6, 1.100002> }
        box { <245.5, 4.2, -2.1> <250.5, 8.6, -1.100002> }
        box { <245.5, 4.2, 2.1> <250.5, 8.6, 1.100002> }
        difference {
          box { <-2.6, 0.000004, -2.6> <2.6, 8.6, 2.6> }
          box { <-2.400001, -1, -1.100005> <2.4, 9, 1.100005> }
          box { <-1, -1, -3> <1, 9, 3> }
          box { <-3, -1, -3> <3, 9, 3> rotate 45*y translate <0, 0, -4.75> }
          box { <-3, -1, -3> <3, 9, 3> rotate 45*y translate <0, 0, 4.75> }
        }
        difference {
          box { <245.4, 0.000004, -2.6> <250.6, 8.6, 2.6> }
          box { <245.6, -1, -1.100005> <250.4, 9, 1.100005> }
          box { <247, -1, -3> <249, 9, 3> }
          box { <-3, -1, -3> <3, 9, 3> rotate 45*y translate <248, 0, -4.75> }
          box { <-3, -1, -3> <3, 9, 3> rotate 45*y translate <248, 0, 4.75> }
        }
        box { <15.5, 2.100005, -15> <16.5, 8.6, -11.5> }
        box { <15.5, 2.100005, 11.5> <16.5, 8.6, 15> }
        box { <39.5, 2.100005, -15> <40.5, 8.6, -11.5> }
        box { <39.5, 2.100005, 11.5> <40.5, 8.6, 15> }
        box { <63.5, 2.100005, -15> <64.5, 8.6, -11.5> }
        box { <63.5, 2.100005, 11.5> <64.5, 8.6, 15> }
        box { <87.5, 2.100005, -15> <88.5, 8.6, -11.5> }
        box { <87.5, 2.100005, 11.5> <88.5, 8.6, 15> }
        box { <111.5, 2.100005, -15> <112.5, 8.6, -11.5> }
        box { <111.5, 2.100005, 11.5> <112.5, 8.6, 15> }
        box { <135.5, 2.100005, -15> <136.5, 8.6, -11.5> }
        box { <135.5, 2.100005, 11.5> <136.5, 8.6, 15> }
        box { <159.5, 2.100005, -15> <160.5, 8.6, -11.5> }
        box { <159.5, 2.100005, 11.5> <160.5, 8.6, 15> }
        box { <183.5, 2.100005, -15> <184.5, 8.6, -11.5> }
        box { <183.5, 2.100005, 11.5> <184.5, 8.6, 15> }
        box { <207.5, 2.100005, -15> <208.5, 8.6, -11.5> }
        box { <207.5, 2.100005, 11.5> <208.5, 8.6, 15> }
        box { <231.5, 2.100005, -15> <232.5, 8.6, -11.5> }
        box { <231.5, 2.100005, 11.5> <232.5, 8.6, 15> }
        box { <0, 2.100004, 0> <1.2, 8.6, 14> rotate 45*y translate <15.5, 0, -11.5> }
        box { <0, 2.100004, 0> <1.2, 8.6, -14> rotate -45*y translate <15.5, 0, 11.5> }
        box { <0, 2.100004, -14> <1.2, 8.6, 0> rotate 135*y translate <40.5, 0, -11.5> }
        box { <0, 2.100004, 14> <1.2, 8.6, 0> rotate -135*y translate <40.5, 0, 11.5> }
        box { <0, 2.100006, 0> <1.2, 8.6, 14> rotate 45*y translate <39.5, 0, -11.5> }
        box { <0, 2.100006, 0> <1.2, 8.6, -14> rotate -45*y translate <39.5, 0, 11.5> }
        box { <0, 2.100006, -14> <1.2, 8.6, 0> rotate 135*y translate <64.5, 0, -11.5> }
        box { <0, 2.100006, 14> <1.2, 8.6, 0> rotate -135*y translate <64.5, 0, 11.5> }
        box { <0, 2.100007, 0> <1.2, 8.6, 14> rotate 45*y translate <63.5, 0, -11.5> }
        box { <0, 2.100007, 0> <1.2, 8.6, -14> rotate -45*y translate <63.5, 0, 11.5> }
        box { <0, 2.100007, -14> <1.2, 8.6, 0> rotate 135*y translate <88.5, 0, -11.5> }
        box { <0, 2.100007, 14> <1.2, 8.6, 0> rotate -135*y translate <88.5, 0, 11.5> }
        box { <0, 2.100008, 0> <1.2, 8.6, 14> rotate 45*y translate <87.5, 0, -11.5> }
        box { <0, 2.100008, 0> <1.2, 8.6, -14> rotate -45*y translate <87.5, 0, 11.5> }
        box { <0, 2.100008, -14> <1.2, 8.6, 0> rotate 135*y translate <112.5, 0, -11.5> }
        box { <0, 2.100008, 14> <1.2, 8.6, 0> rotate -135*y translate <112.5, 0, 11.5> }
        box { <0, 2.100004, 0> <1.2, 8.6, 7> rotate 45*y translate <111.5, 0, -11.5> }
        box { <0, 2.100004, 0> <1.2, 8.6, -7> rotate -45*y translate <111.5, 0, 11.5> }
        box { <0, 2.100004, -7> <1.2, 8.6, 0> rotate 135*y translate <136.5, 0, -11.5> }
        box { <0, 2.100004, 7> <1.2, 8.6, 0> rotate -135*y translate <136.5, 0, 11.5> }
        box { <0, 2.100008, 0> <1.2, 8.6, 14> rotate 45*y translate <135.5, 0, -11.5> }
        box { <0, 2.100008, 0> <1.2, 8.6, -14> rotate -45*y translate <135.5, 0, 11.5> }
        box { <0, 2.100008, -14> <1.2, 8.6, 0> rotate 135*y translate <160.5, 0, -11.5> }
        box { <0, 2.100008, 14> <1.2, 8.6, 0> rotate -135*y translate <160.5, 0, 11.5> }
        box { <0, 2.100007, 0> <1.2, 8.6, 14> rotate 45*y translate <159.5, 0, -11.5> }
        box { <0, 2.100007, 0> <1.2, 8.6, -14> rotate -45*y translate <159.5, 0, 11.5> }
        box { <0, 2.100007, -14> <1.2, 8.6, 0> rotate 135*y translate <184.5, 0, -11.5> }
        box { <0, 2.100007, 14> <1.2, 8.6, 0> rotate -135*y translate <184.5, 0, 11.5> }
        box { <0, 2.100006, 0> <1.2, 8.6, 14> rotate 45*y translate <183.5, 0, -11.5> }
        box { <0, 2.100006, 0> <1.2, 8.6, -14> rotate -45*y translate <183.5, 0, 11.5> }
        box { <0, 2.100006, -14> <1.2, 8.6, 0> rotate 135*y translate <208.5, 0, -11.5> }
        box { <0, 2.100006, 14> <1.2, 8.6, 0> rotate -135*y translate <208.5, 0, 11.5> }
        box { <0, 2.100004, 0> <1.2, 8.6, 14> rotate 45*y translate <207.5, 0, -11.5> }
        box { <0, 2.100004, 0> <1.2, 8.6, -14> rotate -45*y translate <207.5, 0, 11.5> }
        box { <0, 2.100004, -14> <1.2, 8.6, 0> rotate 135*y translate <232.5, 0, -11.5> }
        box { <0, 2.100004, 14> <1.2, 8.6, 0> rotate -135*y translate <232.5, 0, 11.5> }
        box { <27.5, 2.100010, -2> <28.5, 8.6, 2> }
        box { <51.5, 2.100010, -2> <52.5, 8.6, 2> }
        box { <75.5, 2.100010, -2> <76.5, 8.6, 2> }
        box { <99.5, 2.100010, -2> <100.5, 8.6, 2> }
        box { <147.5, 2.100010, -2> <148.5, 8.6, 2> }
        box { <171.5, 2.100010, -2> <172.5, 8.6, 2> }
        box { <195.5, 2.100010, -2> <196.5, 8.6, 2> }
        box { <219.5, 2.100010, -2> <220.5, 8.6, 2> }
      #end
      object { open_rounded_button() rotate -90*x translate <0, 6, -9.7> }
      object { open_rounded_button() rotate -90*x translate <8, 6, -9.7> }
      object { open_rounded_button() rotate -90*x translate <240, 6, -9.7> }
      object { open_rounded_button() rotate -90*x translate <248, 6, -9.7> }
      object { open_rounded_button() rotate 90*x translate <0, 6, 9.7> }
      object { open_rounded_button() rotate 90*x translate <8, 6, 9.7> }
      object { open_rounded_button() rotate 90*x translate <240, 6, 9.7> }
      object { open_rounded_button() rotate 90*x translate <248, 6, 9.7> }
      texture { color_tex }
      bounded_by { box { <-4.6, -0.1, -16> <252.6, 13, 16> } }
    }
  #end
#end
#macro monorail_short_track(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -15.9> <59.9, 9.9, 15.9> }
      box { <-3.900001, 9.8, -3> <59.900001, 12.9, 3> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -15.9> <59.9, 9.9, 15.9> }
          box { <-4.5, 0.000001, -8.1> <-3.8, 9.900001, -10.9> }
          box { <59.8, 0.000001, 8.1> <60.5, 9.900001, 10.9> }
        }
        box { <-4, -1, 8> <-3.2, 11, 11> }
        box { <59.2, -1, -8> <60, 11, -11> }
        box { <-5, -1, -16> <60, 2.1, -9.4> }
        box { <-4, -1, 9.4> <61, 2.1, 16> }
        box { <-4, -1, -16> <12, 11, -12.8> }
        box { <-4, -1, 12.8> <12, 11, 16> }
        box { <44, -1, -16> <60, 11, -12.8> }
        box { <44, -1, 12.8> <60, 11, 16> }
        box { <11.9, -1, -16> <44.1, 2.100001, -7.9> }
        box { <11.9, -1, 16> <44.1, 2.100001, 7.9> }
        box { <11.900001, -1, -16> <20.1, 2.100002, 16> }
        box { <35.9, -1, -16> <44.1, 2.100002, 16> }
        #if (setting > 1)
          box { <13.4, -1, -14.4> <42.6, 8, 14.4> }
          box { <21.600001, -1, -6.4> <34.300001, 8.000001, 6.4> }
          box { <-2.4, -1, -8.4> <58.4, 8.000002, 8.4> }
          box { <-2.4, -1, -11.3> <12, 8, -9.400001> }
          box { <-2.4, -1, 9.400001> <12, 8, 11.3> }
          box { <44, -1, -11.3> <58.4, 8, -9.400001> }
          box { <44, -1, 9.400001> <58.4, 8, 11.3> }
          box { <0, 9.4, -20> <8, 12, -12.3> }
          box { <0, 9.4, 12.3> <8, 12, 20> }
          box { <48, 9.4, -20> <56, 12, -12.3> }
          box { <48, 9.4, 12.3> <56, 12, 20> }
          box { <-2.400002, -2, -1.1> <58.400002, 11.2, 1.1> }
        #end
      }
      #local counter = -4;
      difference {
        box { <-3.900001, 9.8, -3> <59.900001, 12.9, 3> }
        #if (setting > 1)
          box { <-2.400001, -2, -1.1> <58.100002, 11.200001, 1.1> }
          #while (counter < 65)
            difference {
              box { <-2, 9.7, -4> <2, 13, -2> }
              box { <-2, 9, -5> <0, 14, 0> rotate 20*y translate <-0.2, 0, -2> }
              box { <0, 9, -5> <2, 14, 0> rotate -20*y translate <0.2, 0, -2> }
              translate <counter, 0, 0>
            }
            difference {
              box { <-2, 9.7, 4> <2, 13, 2> }
              box { <-2, 9, 0> <0, 14, 5> rotate -20*y translate <-0.2, 0, 2> }
              box { <0, 9, 0> <2, 14, 5> rotate 20*y translate <0.2, 0, 2> }
              translate <counter, 0, 0>
            }
          #local counter = counter + 1.6;
          #end
        #end
      }
      difference {
        box { <20.100001, -0.000001, -7.900001> <35.900001, 9, 7.900001> }
        box { <21.6, -1, -6.4> <34.4, 10, 6.4> }
      }
      #if (setting > 1)
        difference {
          cylinder { -0.000002*y, 9.8*y, 3.2 }
          cylinder { -1*y, 10*y, 2.6 }
          translate <28, 0, 0>
        }
        difference {
          box { <-2.6, 0.000004, -2.6> <2.6, 8.6, 2.6> }
          box { <-2.400001, -1, -1.100005> <2.4, 9, 1.100005> }
          box { <-1, -1, -3> <1, 9, 3> }
          box { <-3, -1, -3> <3, 9, 3> rotate 45*y translate <0, 0, -4.75> }
          box { <-3, -1, -3> <3, 9, 3> rotate 45*y translate <0, 0, 4.75> }
        }
        difference {
          box { <53.4, 0.000004, -2.6> <58.6, 8.6, 2.6> }
          box { <53.6, -1, -1.100005> <58.4, 9, 1.100005> }
          box { <55, -1, -3> <57, 9, 3> }
          box { <-3, -1, -3> <3, 9, 3> rotate 45*y translate <56, 0, -4.75> }
          box { <-3, -1, -3> <3, 9, 3> rotate 45*y translate <56, 0, 4.75> }
        }
        box { <15.5, 2.100005, -15> <16.5, 8.6, -11.5> }
        box { <0, 2.100004, 0> <1.2, 8.6, 7> rotate 45*y translate <15.5, 0, -11.5> }
        box { <39.5, 2.100005, -15> <40.5, 8.6, -11.5> }
        box { <0, 2.100004, -7> <1.2, 8.6, 0> rotate 135*y translate <40.5, 0, -11.5> }
        box { <15.5, 2.100005, 11.5> <16.5, 8.6, 15> }
        box { <0, 2.100004, 0> <1.2, 8.6, -7> rotate -45*y translate <15.5, 0, 11.5> }
        box { <39.5, 2.100005, 11.5> <40.5, 8.6, 15> }
        box { <0, 2.100004, 7> <1.2, 8.6, 0> rotate -135*y translate <40.5, 0, 11.5> }
        box { <3.5, 2.1, -2.6> <21, 8.6, -1.100001> }
        box { <3.5, 2.1, 2.6> <21, 8.6, 1.100001> }
        box { <35, 2.1, -2.6> <52.5, 8.6, -1.100001> }
        box { <35, 2.1, 2.6> <52.5, 8.6, 1.100001> }
        box { <2.4, 0.000003, -9> <3.9, 8.6, 9> }
        box { <52.1, 0.000003, -9> <53.6, 8.6, 9> }
        box { <-0.5, 0.000003, -9> <0.5, 8.6, -6.4> }
        box { <-0.5, 0.000003, 9> <0.5, 8.6, 6.4> }
        box { <55.5, 0.000003, -9> <56.5, 8.6, -6.4> }
        box { <55.5, 0.000003, 9> <56.5, 8.6, 6.4> }
        box { <-2.5, 4.2, -2.1> <2.5, 8.6, -1.100002> }
        box { <-2.5, 4.2, 2.1> <2.5, 8.6, 1.100002> }
        box { <53.5, 4.2, -2.1> <58.5, 8.6, -1.100002> }
        box { <53.5, 4.2, 2.1> <58.5, 8.6, 1.100002> }
      #end
      object { open_rounded_button() rotate -90*x translate <0, 6, -9.7> }
      object { open_rounded_button() rotate -90*x translate <8, 6, -9.7> }
      object { open_rounded_button() rotate -90*x translate <48, 6, -9.7> }
      object { open_rounded_button() rotate -90*x translate <56, 6, -9.7> }
      object { open_rounded_button() rotate 90*x translate <0, 6, 9.7> }
      object { open_rounded_button() rotate 90*x translate <8, 6, 9.7> }
      object { open_rounded_button() rotate 90*x translate <48, 6, 9.7> }
      object { open_rounded_button() rotate 90*x translate <56, 6, 9.7> }
      texture { color_tex }
      bounded_by { box { <-4.6, -0.1, -16> <60.6, 13, 16> } }
    }
  #end
#end
#macro motorbike_body(color_tex)
  #if (setting = 0)
    merge {
      merge {
        box { <-5.5, -5.5, -4.9> <5.5, 22.5, 4.9> }
        cylinder { -12.4*z, 12.4*z, 1.5 translate <0, 22.5, 0> }
        rotate -22*z
        translate <-35.5, 0, 0>
      }
      difference {
        box { <-29, -4, -6.2> <7.9, 11.7, 6.2> }
        box { <-8, 0, -10> <0, 20, 10> rotate -25*z translate <-13.8, -1, 0> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-1.9, 0, -4.900001> <1.9, 22.5, 4.900001> }
            cylinder { -8*z, 8*z, 1.450005 translate <0.55, 22.5, 0> }
            cylinder { -7*z, 0*z, 1.450003 rotate -18*y translate <0.55, 22.5, -4.25> }
            cylinder { 7*z, 0*z, 1.450003 rotate 18*y translate <0.55, 22.5, 4.25> }
          }
          box { <1, 12.5, -0.9> <3, 14, 0.9> }
          cylinder { -4.9*z, 4.9*z, 2.5 }
          cylinder { -4.25*z, 4.25*z, 1.45 translate <0.55, 22.5, 0> }
          sphere { <0.55, 22.5, -4.25> 1.45 }
          sphere { <0.55, 22.5, 4.25> 1.45 }
          merge {
            cylinder { -7*z, 0*z, 1.45 }
            sphere { <0, 0, -7> 1.45 }
            rotate -18*y
            translate <0.55, 22.5, -4.25>
          }
          merge {
            cylinder { 7*z, 0*z, 1.45 }
            sphere { <0, 0, 7> 1.45 }
            rotate 18*y
            translate <0.55, 22.5, 4.25>
          }
        }
        difference {
          box { <-1.2, -3, -11> <1.2, 0, 11> }
          cylinder { -10*z, 10*z, 0.3 translate <-1.2, -1.7, 0> }
          cylinder { -10*z, 10*z, 0.3 translate <1.2, -1.7, 0> }
          box { <-2, -1.7, -10> <-0.9, 1, 10> }
          box { <0.9, -1.7, -10> <2, 1, 10> }
        }
        cylinder { -10*z, 10*z, 1.1 }
        cylinder { -2*x, 2*x, 1.5 translate <0, 8.5, -2> }
        cylinder { -2*x, 2*x, 1.5 translate <0, 8.5, 2> }
        box { <-4, -10, -3.5> <4, 8.5, 3.5> }
        box { <-2, 8, -2> <2, 10, 2> }
        difference {
          box { <-3, 12.2, -6> <-1, 22.500001, 6> }
          box { <-1.900001, 12.1, -2> <0, 16.5, 2> }
          cylinder { -1.900002*x, 0*x, 2 translate <0, 16.499999, 0> }
          cylinder { -8*z, 8*z, 1.450001 translate <0.55, 22.5, 0> }
        }
        difference {
          box { <-3, 12.2, -7> <3, 22.500002, -3.9> }
          cylinder { -8*z, 8*z, 1.450002 translate <0.55, 22.5, 0> }
          cylinder { -7*z, 0*z, 1.450003 rotate -18*y translate <0.55, 22.5, -4.25> }
        }
        difference {
          box { <-3, 12.2, 3.9> <3, 22.500003, 7> }
          cylinder { -8*z, 8*z, 1.450001 translate <0.55, 22.5, 0> }
          cylinder { 7*z, 0*z, 1.450003 rotate 18*y translate <0.55, 22.5, 4.25> }
        }
        box { <-2, -5, -3> <2, 0, 0> rotate 26*x translate <0, 12.2, -3.9> }
        box { <-2, -5, 0> <2, 0, 3> rotate -26*x translate <0, 12.2, 3.9> }
        rotate -22*z
        translate <-35.5, 0, 0>
      }
      difference {
        merge {
          object { open_rounded_button() translate <0, 3, 0> }
          cylinder { 6.1*y, 5.100001*y, 4.1 }
          cone { 5.100005*y, 4.1, 1.2*y, 2 }
          rotate 117*z
          translate <0, 17.5, 0>
        }
        cylinder { -10*x, 0*x, 1.600005 rotate 27*z translate <0, 17.5, 0> }
        box { <-1.899995, 0, -10> <10, 20, 10> }
        rotate -22*z translate <-35.5, 0, 0>
      }
      difference {
        merge {
          sphere { <-18.8, -0.25, -8> 0.65 }
          cylinder { -8*z, 8*z, 0.65 translate <-18.8, -0.25, 0> }
          sphere { <-18.8, -0.25, 8> 0.65 }
          difference {
            box { <-19.2, -2.75, -7.25> <-18.4, -0.25, 7.25> }
            box { <-19.5, -5, 0> <-18, 0, -5> rotate -25*x translate <0, -0.25, -7.25> }
            box { <-19.5, -5, 0> <-18, 0, 5> rotate 25*x translate <0, -0.25, 7.25> }
          }
          cylinder { -5.4*z, 5.4*z, 2.4 }
          cylinder { -20*x, 5.6*x, 1.5 translate <0, -2.5, -5> }
          box { <-20, -4, -5.000001> <5.600001, -1, 5.000001> }
          cylinder { -20*x, 5.6*x, 1.5 translate <0, -2.5, 5> }
          box { <-18.5, -1.000001, -5.000005> <-21, -2, 5.000005> }
          object { open_rounded_button() translate <-4, 8.7, 0> }
          object { open_rounded_button() translate <4, 8.7, 0> }
          object { open_rounded_button() rotate -90*z translate <4.9, 7.8, 0> }
          object { open_rounded_button() rotate -90*x translate <-4, 7.8, -1.8> }
          object { open_rounded_button() rotate 90*x translate <-4, 7.8, 1.8> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> translate <-4, 11.7, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <4, 11.7, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z translate <7.9, 7.8, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z rotate 90*y translate <-4, 7.8, -4.8> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z rotate -90*y translate <-4, 7.8, 4.8> }
            object { llogo() rotate 90*y rotate -90*x translate <-25, 11.5, -5> }
            object { llogo() rotate -90*y rotate 90*x translate <-25, 11.5, 5> }
          #end
          cylinder { -4.800005*z, -3.500009*z, 2.4 translate <-4, 7.8, 0> }
          cylinder { 4.800005*z, 3.500009*z, 2.4 translate <-4, 7.8, 0> }
          box { <-1.5, 0, -4.6> <1.5, 8, -3.500007> rotate 25*z } 
          box { <-1.5, 0, 4.6> <1.5, 8, 3.500007> rotate 25*z } 
          difference {
            box { <-13.8, 4.6, -6.2> <7.9, 11.7, 6.2> }
            box { <-10, 0, -10> <0, 20, 10> rotate -25*z translate <-13.8, -1, 0> }
            box { <-8.1, 4, -7> <8, 12, -4.8> }
            box { <-8.1, 4, 4.8> <8, 12, 7> }
            difference {
              box { <-10, 4, -7> <0.000005, 8.7, 7> }
              box { <-10, 0, -3.500004> <0, 20, 3.5000004> rotate -25*z translate <-12.800005, -1, 0> }
              box { <-10, 0, -8> <0, 20, -3.500006> rotate -25*z translate <-10.3, -1, 0> }
              box { <-10, 0,8> <0, 20, 3.5000006> rotate -25*z translate <-10.3, -1, 0> }
            }
            cylinder { -7*z, 7*z, 4.2 scale <1.55, 1, 1> translate <0, 4.6, 0> }
          }
          box { <0.000008, 0, -3.5> <3, 1, 3.5> rotate -25*z translate <-13.800005, -1, 0> }
          difference {
            box { <0.000009, 0, -3.750007> <3, 9, 3.750007> }
            box { <1, -1, -2.500007> <4, 10, 2.500007> }
            rotate -25*z translate <-13.800007, -1, 0>
          }
          difference {
            box { <-29, -4.000005, -3.750001> <-13.7, 10.5, 3.750001> }
            box { <-8, 0, -10> <0, 20, 10> rotate -25*z translate <-13.800003, -1, 0> }
            difference {
              box { <-50, -10, -10> <-19.999995, 10.5, 10> }
              cylinder { -9*z, 9*z, 4.5 translate <-20, 0.5, 0> }
              box { <-4.5, -0.000005, -9> <20, 20, 9> rotate 25*z translate <-20, 0.5, 0> }
            }
          }
          difference {
            cylinder { -5.000006*z, 5.000006*z, 4.5 translate <-20, 0.5, 0> }
            box { <-50, -1.999994, -10> <50, 10, 10> }
          }
          merge {
            difference {
              torus { 3, 1.5 rotate 90*x }
              box { <-10, 0.000005, -2> <10, 10, 2> rotate 25*z }
              box { <0.000005, -10, -2> <10, 10, 2> }
            }
            cylinder { -0.000005*y, 6*y, 1.5 translate <-3, 0, 0> rotate 25*z }
            box { <-4.5, -0.000004, -0.000004> <-1.5, 6, 1.5> rotate 25*z }
            sphere { <-3, 6, 0> 1.5 rotate 25*z }
            translate <0, 3, 0>
            rotate 10*x
            translate <-20, -2.5, -5>
          }
          merge {
            difference {
              torus { 3, 1.5 rotate 90*x }
              box { <-10, 0.000005, -2> <10, 10, 2> rotate 25*z }
              box { <0.000005, -10, -2> <10, 10, 2> }
            }
            cylinder { -0.000005*y, 6*y, 1.5 translate <-3, 0, 0> rotate 25*z }
            box { <-4.5, -0.000004, 0.000004> <-1.5, 6, -1.5> rotate 25*z }
            sphere { <-3, 6, 0> 1.5 rotate 25*z }
            translate <0, 3, 0>
            rotate -10*x
            translate <-20, -2.5, 5>
          }
          difference {
            box { <-21.5, -1.5, -0.5> <-6, 12, 0.5> }
            cylinder { -2*z, 2*z, 3.5 translate <-12.5, 11.2, 0> }
            box { <1.5, 0, -2> <3.5, 5, 2> rotate -30*z translate <-12.5, 11.2, 0> }
            box { <-3.5, 0, -2> <-1.5, 5, 2> rotate 25*z translate <-12.5, 11.2, 0> }
            box { <0.1, 0, -10> <10, 20, 10> rotate -25*z translate <-13.800003, -1, 0> }
            box { <-12.5, 11.699999, -2> <-5, 13, 2> }
          }
          sphere { <-27.5, 10, -3.5> 1.5 }
          sphere { <-27.5, 10, 3.5> 1.5 }
          sphere { <-19, 10, -3.5> 1.5 }
          sphere { <-19, 10, 3.5> 1.5 }
          sphere { <0, 3.5, 0> 1.5 rotate -25*z translate <-27.5, 10, -3.5> }
          sphere { <0, 3.5, 0> 1.5 rotate -25*z translate <-27.5, 10, 3.5> }
          sphere { <0, 1.5, 0> 1.5 rotate -25*z translate <-19, 10, -3.5> }
          sphere { <0, 1.5, 0> 1.5 rotate -25*z translate <-19, 10, 3.5> }
          cylinder { 0*y, 3.5*y, 1.5 rotate -25*z translate <-27.5, 10, -3.5> }
          cylinder { 0*y, 3.5*y, 1.5 rotate -25*z translate <-27.5, 10, 3.5> }
          cylinder { 0*y, 1.5*y, 1.5 rotate -25*z translate <-19, 10, -3.5> }
          cylinder { 0*y, 1.5*y, 1.5 rotate -25*z translate <-19, 10, 3.5> }
          cylinder { -27.5*x, -19*x, 1.5 translate <0, 10, -3.5> }
          cylinder { -27.5*x, -19*x, 1.5 translate <0, 10, 3.5> }
          cylinder { 0*x, 7.9*x, 1.5 rotate 11.75*z translate <0, 3.5, 0> rotate -25*z translate <-27.5, 10, -3.5> }
          cylinder { 0*x, 7.9*x, 1.5 rotate 11.75*z translate <0, 3.5, 0> rotate -25*z translate <-27.5, 10, 3.5> }
          cylinder { -3.5*z, 3.5*z, 1.5 translate <0, 1.5, 0> rotate -25*z translate <-19, 10, 0> }
          cylinder { -3.5*z, 3.5*z, 1.5 translate <-19, 10, 0> }
          cylinder { -3.5*z, 3.5*z, 1.5 translate <-27.5, 10, 0> }
          box { <-1, -0.000001, -3.500001> <1.500001, 2.000001, 3.500001> rotate -25*z translate <-19, 10, 0> }
          difference {
            box { <-27.5, 10, -5> <-18, 15, 5> }
            box { <-10, 0, -10> <0, 10, 10> rotate -25*z translate <-27.5, 10, 0> }
            box { <-10, 0, -10> <20, 10, 10> rotate 11.75*z translate <0, 3.5, 0> rotate -25*z translate <-27.5, 10, 0> }
            box { <0, 0, -10> <10, 10, 10> rotate -25*z translate <-19, 10, 0> }
          }
          difference {
            box { <-29, 10, -3.500005> <-18, 15, 3.500005> }
            box { <-10, 0, -10> <-1.5, 10, 10> rotate -25*z translate <-27.5, 10, 0> }
            box { <-10, 1.5, -10> <20, 10, 10> rotate 11.75*z translate <0, 3.5, 0> rotate -25*z translate <-27.5, 10, 0> }
            box { <1.5, 0, -10> <10, 10, 10> rotate -25*z translate <-19, 10, 0> }
            difference {
              box { <-5, 0, -6> <0, 2, 6> }
              cylinder { -5*z, 5*z, 1.500006 }
              translate <0, 3.5, 0> rotate -25*z translate <-27.5, 10, 0>
            }
          }
        }
        difference {
          box { <-12.8, -50, -3.5> <6.9, 10.7, 3.5> }
          box { <-10, 0, -6> <0, 20, 6> rotate -25*z translate <-12.8, -1, 0> }
          cylinder { -5*z, 5*z, 2.5 translate <6.2, 10.7, 0> }
          box { <-10, -2, -4> <2, 5, -2.5> rotate -25*z translate <-13.800008, -1, 0> }
          box { <-10, -2, 4> <2, 5, 2.5> rotate -25*z translate <-13.800008, -1, 0> }
        }
        #if (setting > 1)
          cylinder { -5.05*z, 5.05*z, 1.1 }
          box { <-1.1, -10, -5.050001> <1.1, 0.000005, 5.050001> }
          cylinder { -5*y, -2*y, 0.5 translate <-19.9, 0, -1.9> }
          cylinder { -5*y, -2*y, 0.5 translate <-16.1, 0, -1.9> }
          cylinder { -5*y, -2*y, 0.5 translate <-19.9, 0, 1.9> }
          cylinder { -5*y, -2*y, 0.5 translate <-16.1, 0, 1.9> }
          box { <-19.9, -5, -2.4> <-16.1, -2.000005, 2.4> }
          box { <-20.4, -5, -1.9> <-15.6, -2.000007, 1.9> }
        #end
      }
    texture { color_tex }
    bounded_by { box { <-38.1, -4.1, -12.5> <9.8, 22, 12.5> } }
  }
  #end
#end
#macro motorbike_windshield(color_tex)
  #if (setting = 0)
    box { <-7.9, -3.9, -0.4> <7.9, 19.9, 0.4> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -0.4*z, 0.4*z, 4 translate <-3.9, 0.1, 0> }
        cylinder { -0.4*z, 0.4*z, 4 translate <-3.9, 15.9, 0> }
        cylinder { -0.4*z, 0.4*z, 4 translate <3.9, 0.1, 0> }
        cylinder { -0.4*z, 0.4*z, 4 translate <3.9, 15.9, 0> }
        box { <-3.900001, -3.9, -0.400001> <3.900001, 19.9, 0.400001> }
        box { <-7.900001, 0.099999, -0.400005> <7.900001, 15.900001, 0.400005> }
      }
      box { <-2.4, -10, -0.5> <2.4, 0, 0.5> }
      cylinder { -0.5*z, 0.5*z, 2.6 }
      texture { color_tex }
      bounded_by { box { <-8, -4, -0.5> <8, 20, 0.5> } }
    }
  #end
#end
#macro mountain_top(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 67.1, 19.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <59.9, 67.1, 19.9> }
        box { <-4, -1, 4.1> <4.1, 9.6, 20> }
        box { <51.9, -1, 4.1> <60, 9.6, 20> }
        box { <-4, 19.1, -4> <4.1, 70, 20> }
        box { <-4, 9.5, -4> <4.100001, 70, 4.1> }
        box { <3, 38.3, -4> <12.1, 70, 20> }
        box { <3, 28.7, -4> <12.100001, 70, 4.1> }
        box { <11, 38.3, -4> <60, 70, 4.1> }
        box { <19.9, 9.5, -4> <28.1, 70, 4.100001> }
        box { <19.899999, 28.7, -4> <36.1, 70, 4.100002> }
        box { <10, 47.9, 3> <20.1, 70, 12.1> }
        box { <0, 57.5, 3> <20.100001, 70, 20> }
        box { <0, 57.5, -4> <60, 70, 12.1> }
        box { <43.9, 28.7, -4> <60, 70, 4.100003> }
        box { <51.9, 9.5, -4> <60, 70, 4.100004> }
        box { <51.900001, 19.1, -4> <60, 70, 20> }
        box { <43.9, 38.3, -4> <60, 70, 20> }
        box { <35.9, 47.9, -4> <60, 70, 12.1> }
        box { <35.9, 57.5, -4> <60, 70, 20> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <4.1, 8.6, 2.4> }
          box { <-2.4, -1, 5.6> <4.100001, 18.1, 18.4> }
          box { <5.6, -1, -2.4> <10.4, 2, 18.4> }
          box { <5.600001, -1, -2.400001> <50.400001, 2.000001, 2.4> }
          box { <45.6, -1, -2.4> <50.4, 2.000002, 18.4> }
          box { <51.9, -1, -2.4> <58.4, 8.6, 2.4> }
          box { <51.9, -1, 5.6> <58.4, 18.1, 18.4> }
        #end
        box { <21.6, -1, 13.6> <34.4, 66, 20> }
        box { <13.6, -1, 13.6> <42.4, 56.4, 20> }
        box { <21.6, -1, 5.6> <34.4, 56.4, 20> }
        box { <13.600001, -1, 5.600001> <42.400001, 46.8, 20> }
        box { <5.6, 3.1, 5.600002> <50.4, 37.3, 20> }
        box { <11.9, -1, 3.9> <43.9, 3.100001, 20> }
        box { <5.600001, 3.099999, -2.4> <50.400001, 8.6, 20> }
        box { <5.600002, 3.100003, -2.400001> <18.4, 27.2, 20> }
        box { <13.6, 3.100004, -2.400002> <18.400001, 37.3, 20> }
        box { <29.6, 3.100005, -2.400003> <50.400002, 27.2, 20> }
        box { <37.6, 3.100006, -2.400004> <42.4, 37.3, 20> }
      }
      object { open_rounded_button() translate <0, 6.4, 0> }
      object { open_rounded_button() translate <0, 16, 8> }
      object { open_rounded_button() translate <0, 16, 16> }
      object { open_rounded_button() translate <8, 25.6, 0> }
      object { open_rounded_button() translate <8, 35.2, 8> }
      object { open_rounded_button() translate <8, 35.2, 16> }
      object { open_rounded_button() translate <16, 35.2, 0> }
      object { open_rounded_button() translate <16, 44.8, 8> }
      object { open_rounded_button() translate <16, 54.4, 16> }
      object { open_rounded_button() translate <24, 6.4, 0> }
      object { open_rounded_button() translate <24, 54.4, 8> }
      object { open_rounded_button() translate <24, 64, 16> }
      object { open_rounded_button() translate <32, 25.6, 0> }
      object { open_rounded_button() translate <32, 54.4, 8> }
      object { open_rounded_button() translate <32, 64, 16> }
      object { open_rounded_button() translate <40, 54.4, 16> }
      object { open_rounded_button() translate <40, 44.8, 8> }
      object { open_rounded_button() translate <40, 35.2, 0> }
      object { open_rounded_button() translate <48, 35.2, 16> }
      object { open_rounded_button() translate <48, 35.2, 8> }
      object { open_rounded_button() translate <48, 25.6, 0> }
      object { open_rounded_button() translate <56, 16, 16> }
      object { open_rounded_button() translate <56, 16, 8> }
      object { open_rounded_button() translate <56, 6.4, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 9.5, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 28.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 38.3, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 38.3, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 38.3, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 47.9, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 57.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 9.5, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 57.5, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 67.1, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <32, 28.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <32, 57.5, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <32, 67.1, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <40, 57.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <40, 47.9, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <40, 38.3, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <48, 38.3, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <48, 38.3, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <48, 28.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <56, 19.1, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <56, 19.1, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <56, 9.5, 0> }
      #end
      #if (setting > 1)
        box { <2.4, 0.000001, -0.5> <4.2, 8.7, 0.5> }
        box { <2.4, 9.6, 7.5> <4.2, 18.2, 8.5> }
        box { <2.4, 9.6, 15.5> <4.2, 18.2, 16.5> }
        cylinder { 9.6*y, 18.2*y, 1.5 translate <0, 0, 12> }
        cylinder { 9.6*y, 18.2*y, 1.5 translate <56, 9, 12> }
        box { <51.8, 0.000001, -0.5> <53.6, 8.7, 0.5> }
        box { <51.8, 9.6, 7.5> <53.6, 18.2, 8.5> }
        box { <51.8, 9.6, 15.5> <53.6, 18.2, 16.5> }
        object { pin(2) translate <8, 0, 4> }
        object { pin(2) translate <8, 0, 12> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
        object { pin(2) translate <28, 0, 0> }
        object { pin(2) translate <36, 0, 0> }
        object { pin(2) translate <44, 0, 0> }
        object { pin(2) translate <48, 0, 4> }
        object { pin(2) translate <48, 0, 12> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 68.9, 20> } }
    }
  #end
#end
#macro m_propellor(color_tex)
  #if (setting = 0)
    merge {
      box { <-2.5, -4, 1.5> <2.5, 4, 18.5> rotate -22*z }
      box { <-2.5, -4, 1.5> <2.5, 4, 18.5> rotate -22*z rotate 120*x }
      box { <-2.5, -4, 1.5> <2.5, 4, 18.5> rotate -22*z rotate 240*x }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -3.25*x, 3.25*x, 3 }
        cylinder { -2.5*x, 2.5*x, 4 }
        #local counter = 0;
        #while (counter < 3)
        difference {
          cylinder { -2.500001*x, 2.500001*x, 4 scale <1, 1, 2.5> translate <0, 0, 11.5> } 
          box { <-4, -10, 8.5> <-1.1, 10, 30> rotate -22*z }
          box { <1.1, -10, 8.5> <4, 10, 30> rotate -22*z }
          cylinder { -10*y, 10*y, 7 rotate -22*z translate <-8.75, 0, 8.500001> }
          cylinder { -10*y, 10*y, 7 rotate -22*z translate <8.75, 0, 8.5000001> }
          rotate (counter*120)*x
        }
        #local counter = counter + 1;
        #end
      }
      cylinder { -4*x, 4*x, 2.5 }
      texture { color_tex }
      bounded_by { box { <-3.35, -22, -22> <3.35, 22, 22> } }
    }
  #end
#end
#macro oar(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -0.5*z, 0.5*z, 3.5 scale <1, 3.5, 1> translate <0, 40.5, 0> }
      cylinder { -1.5*y, 32.7*y, 1.5 }
      texture { color_tex }
    }
  #else
    merge {
      sphere { <0, 0, 0> 1.5 }
      sphere { <0, 31.2, 0> 1.5 }
      cylinder { -0.000001*y, 31.200001*y, 1.5 }
      cylinder { -0.499999*z, 0.499999*z, 3.5 translate <0, 51.5, 0> }
      torus { 3.5, 0.5 rotate 90*x translate <0, 51.5, 0> }
      difference {
        cylinder { -0.500001*z, 0.500001*z, 3.5 scale <1, 5.75, 1> translate <0, 51.5, 0> }
        box { <-10, 51.500001, -2> <10, 250, 2> }
      }
      difference {
        torus { 3.5, 0.5 rotate 90*x scale <1, 5.75, 1> translate <0, 51.5, 0> }
        box { <-10, 51.500001, -2> <10, 250, 2> }
      }
      texture { color_tex }
      bounded_by { box { <-4.1, -1.6, -1.6> <4.1, 55.6, 1.6> } }
    }
  #end
#end
#macro octagon_canopy(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <75.9, 38.3, 75.9> }
      box { <-20, 0, -4> <0, 40, 76> rotate -36.4*z translate <-3.9, 9.5, 0> }
      box { <-4, 0, -20> <76, 40, 0> rotate 36.4*x translate <0, 9.5, -3.9> }
      box { <0, 0, -4> <20, 40, 76> rotate 36.4*z translate <75.9, 9.5, 0> }
      box { <-4, 0, 0> <76, 40, 20> rotate -36.4*x translate <0, 9.5, 75.9> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting < 3)
        cylinder { 38.2*y, 40*y, 2.4 translate <32, 0, 32> }
        cylinder { 38.2*y, 40*y, 2.4 translate <40, 0, 32> }
        cylinder { 38.2*y, 40*y, 2.4 translate <32, 0, 40> }
        cylinder { 38.2*y, 40*y, 2.4 translate <40, 0, 40> }
      #else
        object { rounded_button() translate <32, 35.2, 32> }
        object { rounded_button() translate <40, 35.2, 32> }
        object { rounded_button() translate <32, 35.2, 40> }
        object { rounded_button() translate <40, 35.2, 40> }
      #end
      #if (setting > 1)
        difference {
          merge {
            object { ring() translate <36, 35.5, 36> }
            box { <30, 35.5, 28> <42, 37.6, 29.5> }
            box { <30, 35.5, 42.5> <42, 37.6, 44> }
            box { <28, 35.5, 30> <29.5, 37.6, 42> }
            box { <42.5, 35.5, 30> <44, 37.6, 42> }
            box { <0, 35.50001, 0> <2.82842, 37.6, 1.5> rotate 45*y translate <28, 0, 30> }
            box { <0, 35.50001, 0> <2.82842, 37.6, 1.5> rotate -45*y translate <42, 0, 28> }
            box { <0, 35.50001, -1.5> <2.82842, 37.6, 0> rotate -45*y translate <28, 0, 42> }
            box { <0, 35.50001, -1.5> <2.82842, 37.6, 0> rotate 45*y translate <42, 0, 44> }
          }
          box { <-40, 0, -10> <0, 50, 76> rotate 32.4*z rotate -45*y translate <33, 38.2, 27> }
          box { <-40, 0, -10> <0, 50, 76> rotate 32.4*z rotate -135*y translate <45, 38.2, 33> }
          box { <-40, 0, -10> <0, 50, 76> rotate 32.4*z rotate -225*y translate <39, 38.2, 45> }
          box { <-40, 0, -10> <0, 50, 76> rotate 32.4*z rotate 45*y translate <27, 38.2, 39> }
        }
      #end
      difference {
        box { <-3.9, 0, -3.9> <75.9, 38.3, 75.9> }
        box { <-20, 0, -4> <0, 40, 76> rotate -36.4*z translate <-3.9, 9.5, 0> }
        box { <-4, 0, -20> <76, 40, 0> rotate 36.4*x translate <0, 9.5, -3.9> }
        box { <0, 0, -4> <20, 40, 76> rotate 36.4*z translate <75.9, 9.5, 0> }
        box { <-4, 0, 0> <76, 40, 20> rotate -36.4*x translate <0, 9.5, 75.9> }
        box { <-30, 0, -4> <0, 40, 76> rotate 33.9*z translate <26.4, 38.3, 0> }
        box { <0, 0, -4> <30, 40, 76> rotate -33.9*z translate <45.6, 38.3, 0> }
        box { <-4, 0, -30> <76, 40, 0> rotate -33.9*x translate <0, 38.3, 26.4> }
        box { <-4, 0, 0> <76, 40, 30> rotate 33.9*x translate <0, 38.3, 45.6> }
        box { <0, -1, -40> <40, 40, 0> rotate 45*y translate <-3.9, 0, 19.9> }
        box { <0, -1, -40> <40, 40, 0> rotate -45*y translate <51.9, 0, -3.9> }
        box { <0, -1, -40> <40, 40, 0> rotate -135*y translate <75.9, 0, 51.9> }
        box { <0, -1, -40> <40, 40, 0> rotate 135*y translate <19.9, 0, 75.9> }
        box { <-20, 0, -4> <0, 40, 76> rotate -35.9*z rotate -45*y translate <19.9, 9.5, -3.9> }
        box { <-20, 0, -4> <0, 40, 76> rotate -35.9*z rotate -135*y translate <75.9, 9.5, 19.9> }
        box { <-20, 0, -4> <0, 40, 76> rotate -35.9*z rotate -225*y translate <51.9, 9.5, 75.9> }
        box { <-20, 0, -4> <0, 40, 76> rotate -35.9*z rotate 45*y translate <-3.9, 9.5, 51.9> }
        box { <-40, 0, -10> <0, 50, 76> rotate 32.4*z rotate -45*y translate <33, 38.3, 27> }
        box { <-40, 0, -10> <0, 50, 76> rotate 32.4*z rotate -135*y translate <45, 38.3, 33> }
        box { <-40, 0, -10> <0, 50, 76> rotate 32.4*z rotate -225*y translate <39, 38.3, 45> }
        box { <-40, 0, -10> <0, 50, 76> rotate 32.4*z rotate 45*y translate <27, 38.3, 39> }
        difference {
          box { <-2.5, -1, -2.5> <74.5, 37.5, 74.5> }
          box { <-20, 0, -4> <0, 40, 76> rotate -36.4*z translate <-2.5, 9.5, 0> }
          box { <-4, 0, -20> <76, 40, 0> rotate 36.4*x translate <0, 9.5, -2.5> }
          box { <0, 0, -4> <20, 40, 76> rotate 36.4*z translate <74.5, 9.5, 0> }
          box { <-4, 0, 0> <76, 40, 20> rotate -36.4*x translate <0, 9.5, 74.5> }
          box { <-30, 0, -4> <0, 40, 76> rotate 33.9*z translate <26.4, 37.5, 0> }
          box { <0, 0, -4> <30, 40, 76> rotate -33.9*z translate <45.6, 37.5, 0> }
          box { <-4, 0, -30> <76, 40, 0> rotate -33.9*x translate <0, 37.5, 26.4> }
          box { <-4, 0, 0> <76, 40, 30> rotate 33.9*x translate <0, 37.5, 45.6> }
          box { <0, -1, -40> <40, 40, 1.5> rotate 45*y translate <-3.9, 0, 19.9> }
          box { <0, -1, -40> <40, 40, 1.5> rotate -45*y translate <51.9, 0, -3.9> }
          box { <0, -1, -40> <40, 40, 1.5> rotate -135*y translate <75.9, 0, 51.9> }
          box { <0, -1, -40> <40, 40, 1.5> rotate 135*y translate <19.9, 0, 75.9> }
          box { <-20, 0, -4> <0, 40, 76> rotate -35.9*z rotate -45*y translate <19.9, 9.5, -2.5> }
          box { <-20, 0, -4> <0, 40, 76> rotate -35.9*z rotate -135*y translate <74.5, 9.5, 19.9> }
          box { <-20, 0, -4> <0, 40, 76> rotate -35.9*z rotate -225*y translate <51.9, 9.5, 74.5> }
          box { <-20, 0, -4> <0, 40, 76> rotate -35.9*z rotate 45*y translate <-2.5, 9.5, 51.9> }
          box { <-40, 0, -10> <0, 50, 76> rotate 32.4*z rotate -45*y translate <33, 37.5, 27> }
          box { <-40, 0, -10> <0, 50, 76> rotate 32.4*z rotate -135*y translate <45, 37.5, 33> }
          box { <-40, 0, -10> <0, 50, 76> rotate 32.4*z rotate -225*y translate <39, 37.5, 45> }
          box { <-40, 0, -10> <0, 50, 76> rotate 32.4*z rotate 45*y translate <27, 37.5, 39> }
          box { <70, 8.5, 0> <80, 30, 23> }
          box { <70, 8.5, 49> <80, 30, 72> }
        }
        box { <69.7, -1, -4> <76, 8.50001, 76> }
        box { <32, -1, 15.2> <76, 8.5002, 56.8> }
        #if (setting > 1)
          object { axle_opening(50,1) rotate 90*z translate <36, -1, 36> }
          box { <-2.5, -1, -2> <2.5, 2, 1.4> rotate 45*y translate <0, 0, 16> }
          box { <-2.5, -1, -2> <2.5, 2, 1.4> rotate 45*y translate <8, 0, 8> }
          box { <-2.5, -1, -2> <2.5, 2, 1.4> rotate 45*y translate <16, 0, 0> }
          box { <-2.5, -1, -2> <2.5, 2, 1.4> rotate -45*y translate <64, 0, 8> }
          box { <-2.5, -1, -2> <2.5, 2, 1.4> rotate -45*y translate <56, 0, 0> }
          box { <-2.5, -1, -2> <2.5, 2, 1.4> rotate -45*y translate <0, 0, 56> }
          box { <-2.5, -1, -2> <2.5, 2, 1.4> rotate -45*y translate <8, 0, 64> }
          box { <-2.5, -1, -2> <2.5, 2, 1.4> rotate -45*y translate <16, 0, 72> }
          box { <-2.5, -1, -2> <2.5, 2, 1.4> rotate 45*y translate <64, 0, 64> }
          box { <-2.5, -1, -2> <2.5, 2, 1.4> rotate 45*y translate <56, 0, 72> }
          cylinder { 36.2*y, 39.2*y, 1.2 translate <32, 0, 32> }
          cylinder { 36.2*y, 39.2*y, 1.2 translate <32, 0, 40> }
          cylinder { 36.2*y, 39.2*y, 1.2 translate <40, 0, 32> }
          cylinder { 36.2*y, 39.2*y, 1.2 translate <40, 0, 40> }
          difference {
            box { <70.8, 9.5, 0> <76, 30, 22> }
            box { <0, 9, 0> <10, 30, 10> rotate 22.5*y translate <70.8, 0, 22> }
          }
          difference {
            box { <70.8, 9.5, 50> <76, 30, 72> }
            box { <0, 9, -10> <10, 30, 0> rotate -22.5*y translate <70.8, 0, 50> }
          }
          difference {
            box { <68.9, 0, 34> <80, 30, 38> }
            box { <60, -20, -10> <80, 0, 0> rotate -3.5*x translate <0, 0, 34> }
            box { <60, -20, 0> <80, 0, 10> rotate 3.5*x translate <0, 0, 38> }
          }
        #end
      }
      cylinder { 21.5*z, 22.4*z, 2.10001 translate <72, 5.6, 0> }
      cylinder { 33.6*z, 34.5*z, 2.10001 translate <72, 5.6, 0> }
      cylinder { 37.5*z, 38.4*z, 2.10001 translate <72, 5.6, 0> }
      cylinder { 49.6*z, 50.5*z, 2.10001 translate <72, 5.6, 0> }
      difference {
        merge {
          difference {
            box { <71.4, 3.6, 21.49998> <72.6, 20, 34.49998> }
            #if (setting > 1)
              box { <71, 3, 27> <73, 6.6, 29> }
            #end
          }
          difference {
            box { <71.4, 3.6, 37.49998> <72.6, 20, 50.49998> }
            #if (setting > 1)
              box { <71, 3, 43> <73, 6.6, 45> }
            #end
          }
          box { <69.9, 5.6, 21.49999> <74.1, 20, 22.40001> }
          box { <-2.1, 0, -0.9> <2.1, 20, 0> rotate -3.5*x translate <72, 5.6, 34.5> }
          box { <-2.1, 0, 0> <2.1, 20, 0.9> rotate 3.5*x translate <72, 5.6, 37.5> }
        }
        difference {
          box { <68.90001, 0, 34> <80, 30, 38> }
          box { <60, -20, -10> <80, 0, 0> rotate -3.5*x translate <0, 0, 34.00001> }
          box { <60, -20, 0> <80, 0, 10> rotate 3.5*x translate <0, 0, 37.99999> }
        }
        box { <0, 0, -4> <20, 40, 76> rotate 36.4*z translate <75.89999, 9.5, 0> }
      }
      box { <70.9, 5.6, 49.60001> <74.1, 9, 50.49999> }
      #if (setting > 1)
        cylinder { 34*z, 38*z, 1.5 translate <72, 5.6, 0> }
        difference {
          cylinder { -3.9*z, -2.4*z, 1.5 translate <72, 5.6, 24> }
          cylinder { -5*z, -2*z, 0.7 translate <72, 5.6, 24> }
        }
        difference {
          cylinder { 10.4*z, 11.9*z, 1.5 translate <72, 5.6, 40> }
          cylinder { 10*z, 13*z, 0.7 translate <72, 5.6, 40> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 40.1, 76> } }
    }
  #end
#end
#macro octagon_cone(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 15.9, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 15.9, 11.9> }
        box { <0, -1, -10> <10, 35, 0> rotate 45*y translate <-3.9, 0, 1> }
        box { <0, -1, 0> <10, 35, 10> rotate -45*y translate <-3.9, 0, 7> }
        box { <0, -1, 0> <10, 35, 10> rotate -45*y translate <11.9, 0, 7> }
        box { <0, -1, -10> <10, 35, 0> rotate 45*y translate <11.9, 0, 1> }
        box { <-10, -1, -10> <10, 35, 0> rotate 16.5*x rotate 45*y translate <-3.9, 3.1, 1> }
        box { <-10, -1, -10> <10, 35, 0> rotate 16.5*x rotate 135*y translate <-3.9, 3.1, 7> }
        box { <-10, -1, -10> <10, 35, 0> rotate 16.5*x rotate 225*y translate <11.9, 3.1, 7> }
        box { <-10, -1, -10> <10, 35, 0> rotate 16.5*x rotate 315*y translate <11.9, 3.1, 1> }
        box { <-10, -1, -10> <10, 35, 0> rotate 17.15*x translate <4, 3.1, -3.9> }
        box { <-10, -1, 0> <10, 35, 10> rotate -17.15*x translate <4, 3.1, 11.9> }
        box { <-10, -1, -10> <0, 35, 10> rotate -17.15*z translate <-3.9, 3.1, 4> }
        box { <0, -1, -10> <10, 35, 10> rotate 17.15*z translate <11.9, 3.1, 4> }
        #if (setting > 1)
          cylinder { -1*y, 16*y, 1.600005 translate <4, 0, 4> }
          difference {
            box { <-2.4, -1, -2.4> <10.4, 15, 10.4> }
            box { <0, -1, -10> <10, 32, 0> rotate 45*y translate <-2.5, 0, 1.4> }
            box { <0, -1, 0> <10, 32, 10> rotate -45*y translate <-2.5, 0, 6.6> }
            box { <0, -1, 0> <10, 32, 10> rotate -45*y translate <10.5, 0, 6.6> }
            box { <0, -1, -10> <10, 32, 0> rotate 45*y translate <10.5, 0, 1.4> }
            box { <-10, -1, -10> <10, 35, 0> rotate 16.5*x rotate 45*y translate <-2.5, 3.1, 1.4> }
            box { <-10, -1, -10> <10, 35, 0> rotate 16.5*x rotate 135*y translate <-2.5, 3.1, 6.6> }
            box { <-10, -1, -10> <10, 35, 0> rotate 16.5*x rotate 225*y translate <10.5, 3.1, 6.6> }
            box { <-10, -1, -10> <10, 35, 0> rotate 16.5*x rotate 315*y translate <10.5, 3.1, 1.4> }
            box { <-10, -1, -10> <10, 35, 0> rotate 17.15*x translate <4, 3.1, -2.5> }
            box { <-10, -1, 0> <10, 35, 10> rotate -17.15*x translate <4, 3.1, 10.5> }
            box { <-10, -1, -10> <0, 35, 10> rotate -17.15*z translate <-2.5, 3.1, 4> }
            box { <0, -1, -10> <10, 35, 10> rotate 17.15*z translate <10.5, 3.1, 4> }
          }
          box { <-2.400005, -1, -2.400005> <10.400005, 2, 10.400005> }
        #end
      }
      #if (setting > 1)
        difference {
          cylinder { 0.000005*y, 15*y, 3.2 }
          object { axle_section(29) rotate 90*z translate <0, -1, 0> }
          cylinder { -1*y, 2.000005*y, 2.6 }
          translate <4, 0, 4>
        }
        difference {
          merge {
            box { <-3, 2, 3.6> <1, 15, 4.4> }
            box { <7, 2, 3.6> <11, 15, 4.4> }
          }
          box { <-10, -1, -10> <0, 35, 10> rotate -17.15*z translate <-2.6, 3.1, 4> }
          box { <0, -1, -10> <10, 35, 10> rotate 17.15*z translate <10.6, 3.1, 4> }
        }
      #end 
      object { open_rounded_button() translate <4, 12.8, 4> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 17.7, 12> } }
    }
  #end
#end
#macro octagon_cornerpiece(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 15.8, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 15.8, 11.9> }
        box { <0, -1, -10> <10, 16, 0> rotate 45*y translate <-3.9, 0, 1> }
        box { <0, -1, 0> <10, 16, 10> rotate -45*y translate <-3.9, 0, 7> }
        box { <-4, 0, -10> <28, 10, 0> rotate -45*x translate <0, 15.8, 1> }
        box { <-4, 0, 0> <28, 10, 10> rotate 45*x translate <0, 15.8, 7> }
        difference {
          box { <0, -1, -4> <28, 7, 1.000001> }
          box { <-5, 0, -10> <29, 10, 0> rotate 45*x translate <0, 0, 1> }
          box { <-20, -1, 0> <20, 10, 10> rotate -45*y translate <7, 0, -3.9> }
        }
        difference {
          box { <0, -1, 6.999999> <28, 7, 12> }
          box { <-5, 0, 0> <29, 10, 10> rotate -45*x translate <0, 0, 7> }
          box { <-20, -1, -10> <20, 10, 0> rotate 45*y translate <7, 0, 11.9> }
        }
        box { <11.9, -1, -4> <28, 0.1, 12> }
        cylinder { -1*y, 2*y, 2.5 }
        cylinder { -1*y, 2*y, 2.5 translate <8, 0, 0> }
        cylinder { -1*y, 2*y, 2.5 translate <0, 0, 8> }
        cylinder { -1*y, 2*y, 2.5 translate <8, 0, 8> }
        difference {
          box { <-2.4, -1, -2.4> <10.4, 14.4, 10.4> }
          box { <0, -1, -10> <10, 16, 0> rotate 45*y translate <-2.5, 0, 1.2> }
          box { <0, -1, 0> <10, 16, 10> rotate -45*y translate <-2.5, 0, 6.8> }
          box { <-10, -1, -10> <0, 16, 0> rotate -45*y translate <10.5, 0, 1.2> }
          box { <-10, -1, 0> <0, 16, 0> rotate 45*y translate <10.5, 0, 6.8> }
          box { <-4, 0, -10> <11, 10, 0> rotate -45*x translate <0, 14.4, 1.2> }
          box { <-4, 0, 0> <11, 10, 10> rotate 45*x translate <0, 14.4, 6.8> }
        }
        difference {
          box { <12.9, 1.4, -2.5> <28, 14.4, 10.5> }
          box { <12, 0, -10> <29, 10, 0> rotate -45*x translate <0, 14.4, 1.2> }
          box { <12, 0, 0> <29, 10, 10> rotate 45*x translate <0, 14.4, 6.8> }
          box { <12, -10, -10> <29, 0, 0> rotate 45*x translate <0, 1.4, 1.2> }
          box { <12, -10, 0> <29, 0, 10> rotate -45*x translate <0, 1.4, 6.8> }
          box { <12, 1, 3.6> <19.9, 5, 4.4> }
          box { <12, 7.5, 3.6> <19.9, 15, 4.4> }
        }
        box { <10, 5.65, 3> <30, 10.15, 5> }
        box { <10, 6.9, 1.75> <30, 8.9, 6.25> }
        cylinder { 25.9*x, 28*x, 2.5 translate <0, 3.9, 0> }
        cylinder { 25.9*x, 28*x, 2.5 translate <0, 3.9, 8> }
        cylinder { 25.9*x, 28*x, 2.5 translate <0, 11.9, 0> }
        cylinder { 25.9*x, 28*x, 2.5 translate <0, 11.9, 8> }
      }
      difference {
        cylinder { 0*y, 14.5*y, 3.2 }
        cylinder { -1*y, 2*y, 2.6 }
        object { axle_section(13) rotate 90*z translate <0, 2, 0> }
        translate <4, 0, 4>
      }
      difference {
        cylinder { 12*x, 27.9*x, 3.2 }
        cylinder { 25.9*x, 28*x, 2.6 }
        object { axle_section(14.9) translate <11, 0, 0> }
        translate <0, 7.9, 4>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 15.9, 12> } }
    }
  #end
#end
#macro octagon_piece(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 31.9, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 31.9, 11.9> }
        box { <0, -1, -10> <10, 35, 0> rotate 45*y translate <-3.9, 0, 1> }
        box { <0, -1, 0> <10, 35, 10> rotate -45*y translate <-3.9, 0, 7> }
        box { <0, -1, 0> <10, 35, 10> rotate -45*y translate <11.9, 0, 7> }
        box { <0, -1, -10> <10, 35, 0> rotate 45*y translate <11.9, 0, 1> }
        #if (setting > 1)
          object { axle_section(29) rotate 90*z translate <4, 4, 4> }
          difference {
            box { <-2.4, -1, -2.4> <10.4, 31, 10.4> }
            box { <0, -1, -10> <10, 32, 0> rotate 45*y translate <-2.5, 0, 1.4> }
            box { <0, -1, 0> <10, 32, 10> rotate -45*y translate <-2.5, 0, 6.6> }
            box { <0, -1, 0> <10, 32, 10> rotate -45*y translate <10.5, 0, 6.6> }
            box { <0, -1, -10> <10, 32, 0> rotate 45*y translate <10.5, 0, 1.4> }
          }
          cylinder { -1*y, 2.1*y, 2.5 }
          cylinder { -1*y, 2.1*y, 2.5 translate <8, 0, 0> }
          cylinder { -1*y, 2.1*y, 2.5 translate <8, 0, 8> }
          cylinder { -1*y, 2.1*y, 2.5 translate <0, 0, 8> }
        #end
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 31*y, 3.2 }
          cylinder { -1*y, 32*y, 2.6 }
          translate <4, 0, 4>
        }
        box { <-3, 2, 3.6> <1, 31, 4.4> }
        box { <7, 2, 3.6> <11, 31, 4.4> }
        box { <3.6, 2, -3> <4.4, 31, 1> }
        box { <3.6, 2, 7> <4.4, 31, 11> }
      #end 
      intersection {
        merge {
          object { rounded_button() translate <0, 28.8, 0> }
          object { rounded_button() translate <8, 28.8, 0> }
          object { rounded_button() translate <0, 28.8, 8> }
          object { rounded_button() translate <8, 28.8, 8> }
        }
        box { <-7.7, 30, -7.7> <7.7, 40, 7.7> rotate 45*y translate <4, 0, 4> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 33.7, 12> } }
    }
  #end
#end
#macro octagon_piece_side(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 31.9, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 31.9, 11.9> }
            box { <0, -1, -10> <10, 35, 0> rotate 45*y translate <-3.9, 0, 1> }
            box { <0, -1, 0> <10, 35, 10> rotate -45*y translate <-3.9, 0, 7> }
            box { <0, -1, 0> <10, 35, 10> rotate -45*y translate <11.9, 0, 7> }
            box { <0, -1, -10> <10, 35, 0> rotate 45*y translate <11.9, 0, 1> }
          }
          difference {
            box { <-3.900005, 0.000005, -3.900005> <11.900005, 31.899995, 2> }
            difference {
              box { <-4, -1, -6> <12, 33, 3> }
              merge {
                box { <-7.700005, -7.700005, -7> <7.700005, 7.700005, 4> rotate 45*z translate <4, 7.9, 0> }
                box { <-7.700005, -7.700005, -7> <7.700005, 7.700005, 4> rotate 45*z translate <4, 23.9, 0> }
              }
            }
            cylinder { -4*z, 3*z, 1.599995 translate <0, 3.9, 0> }
            cylinder { -4*z, 3*z, 1.599995 translate <8, 3.9, 0> }
            cylinder { -4*z, 3*z, 1.599995 translate <0, 11.9, 0> }
            cylinder { -4*z, 3*z, 1.599995 translate <8, 11.9, 0> }
            cylinder { -4*z, 3*z, 1.599995 translate <0, 19.9, 0> }
            cylinder { -4*z, 3*z, 1.599995 translate <8, 19.9, 0> }
            cylinder { -4*z, 3*z, 1.599995 translate <0, 27.9, 0> }
            cylinder { -4*z, 3*z, 1.599995 translate <8, 27.9, 0> }
            box { <-2.4, 4.9, -4> <10.4, 10.9, 3> }
            box { <-2.4, 20.9, -4> <10.4, 26.9, 3> }
          }
        }
        #if (setting > 1)
          object { axle_section(5) rotate 90*y translate <4, 7.9, 1> }
          object { axle_section(5) rotate 90*y translate <4, 23.9, 1> }
          difference {
            box { <2.55, 7.9, -4> <5.45, 30.6, 1> }
            cylinder { -5*z, 2*z, 3.2 translate <4, 7.9, 0> }
            cylinder { -5*z, 2*z, 3.2 translate <4, 23.9, 0> }
          }
          object { axle_section(29) scale <1.000001, 1, 1.000001> rotate 90*z translate <4, 4, 4> }
          difference {
            box { <-2.4, -1, -2.4> <10.4, 31, 10.4> }
            box { <0, -1, -10> <10, 32, 0> rotate 45*y translate <-2.5, 0, 1.4> }
            box { <0, -1, 0> <10, 32, 10> rotate -45*y translate <-2.5, 0, 6.6> }
            box { <0, -1, 0> <10, 32, 10> rotate -45*y translate <10.5, 0, 6.6> }
            box { <0, -1, -10> <10, 32, 0> rotate 45*y translate <10.5, 0, 1.4> }
            cylinder { -5*z, 4*z, 3.2 translate <4, 7.9, 0> }
            cylinder { -5*z, 4*z, 3.2 translate <4, 23.9, 0> }
            box { <0.8, 7.9, -5> <7.2, 23.9, 4> }
          }
          cylinder { -1*y, 2.1*y, 2.5 }
          cylinder { -1*y, 2.1*y, 2.5 translate <8, 0, 0> }
          cylinder { -1*y, 2.1*y, 2.5 translate <8, 0, 8> }
          cylinder { -1*y, 2.1*y, 2.5 translate <0, 0, 8> }
        #end
      }
      difference {
        merge {
          object { open_rounded_button() rotate -90*x translate <0, 3.9, -0.8> }
          object { open_rounded_button() rotate -90*x translate <8, 3.9, -0.8> }
          object { open_rounded_button() rotate -90*x translate <0, 11.9, -0.8> }
          object { open_rounded_button() rotate -90*x translate <8, 11.9, -0.8> }
          object { open_rounded_button() rotate -90*x translate <0, 19.9, -0.8> }
          object { open_rounded_button() rotate -90*x translate <8, 19.9, -0.8> }
          object { open_rounded_button() rotate -90*x translate <0, 27.9, -0.8> }
          object { open_rounded_button() rotate -90*x translate <8, 27.9, -0.8> }
          difference {
            cylinder { -3.800005*z, 0*z, 2.4 }
            cylinder { -4*z, 1*z, 1.6 }
            translate <0, 3.9, 0>
          }
          difference {
            cylinder { -3.800005*z, 0*z, 2.4 }
            cylinder { -4*z, 1*z, 1.6 }
            translate <8, 3.9, 0>
          }
          difference {
            cylinder { -3.800005*z, 0*z, 2.4 }
            cylinder { -4*z, 1*z, 1.6 }
            translate <0, 11.9, 0>
          }
          difference {
            cylinder { -3.800005*z, 0*z, 2.4 }
            cylinder { -4*z, 1*z, 1.6 }
            translate <8, 11.9, 0>
          }
          difference {
            cylinder { -3.800005*z, 0*z, 2.4 }
            cylinder { -4*z, 1*z, 1.6 }
            translate <0, 19.9, 0>
          }
          difference {
            cylinder { -3.800005*z, 0*z, 2.4 }
            cylinder { -4*z, 1*z, 1.6 }
            translate <8, 19.9, 0>
          }
          difference {
            cylinder { -3.800005*z, 0*z, 2.4 }
            cylinder { -4*z, 1*z, 1.6 }
            translate <0, 27.9, 0>
          }
          difference {
            cylinder { -3.800005*z, 0*z, 2.4 }
            cylinder { -4*z, 1*z, 1.6 }
            translate <8, 27.9, 0>
          }
        }
        difference {
          box { <-2.4, -1, -2.5> <10.4, 31, 0> }
          box { <0, -1, -10> <10, 32, 0> rotate 45*y translate <-2.5, 0, 1.300005> }
          box { <0, -1, -10> <10, 32, 0> rotate 45*y translate <10.5, 0, 1.300005> }
        }
        difference {
          box { <-4, 1, -6> <12, 31, 0> }
          merge {
            box { <-7.7, -7.7, -5.9> <7.7, 7.7, -0.1> rotate 45*z translate <4, 7.9, 0> }
            box { <-7.7, -7.7, -5.9> <7.7, 7.7, -0.1> rotate 45*z translate <4, 23.9, 0> }
          }
        }
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 31*y, 3.2 }
          cylinder { -1*y, 2.000005*y, 2.6 }
          object { axle_section(29) rotate 90*z translate <0, 2, 0> }
          translate <4, 0, 4>
        }
      #end
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 31.9, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 31.9, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 31.9, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 31.9, 8> }
      #end
      intersection {
        merge {
          object { open_rounded_button() translate <0, 28.8, 0> }
          object { open_rounded_button() translate <8, 28.8, 0> }
          object { open_rounded_button() translate <0, 28.8, 8> }
          object { open_rounded_button() translate <8, 28.8, 8> }
        }
        box { <-7.7, 30, -7.7> <7.7, 40, 7.7> rotate 45*y translate <4, 0, 4> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -5.8> <12, 33.7, 12> } }
    }
  #end
#end
#macro oldwindow1_1(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <3.9, 19.1, 3.9> }
      box { <-2.9, 3.5, -4> <2.9, 17.5, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -2.9> <3.9, 19.1, 3.9> }
          box { <-3.900001, 18.1, -3.9> <3.900001, 19.100001, -2> }
          box { <-2.9, 3.5, -3.9> <2.9, 17.5, -1> }
          box { <-3.900002, -4, 0> <3.900002, 0, 4> rotate -45*x translate <0, 0, -4.9> }
        }
        box { <-4, -5, -5> <4, -0.000001, 5> }
        box { <-1.9, 4.5, -4> <1.9, 16.5, 4> }
        box { <-2.400001, 3, -1.6> <2.400001, 18.100001, 4> }
        box { <-2.4, -1, -2.4> <2.4, 3.000001, 4> }
        box { <-4, -1, -6> <4, 2, -3.9> }
      }
      object { open_rounded_button() translate <0, 16, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -5> <4, 20.9, 4> } }
    }
  #end
#end
#macro oldwindow1_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 19.1, 3.9> }
      box { <-2.9, 3.5, -4> <10.9, 17.5, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -2.9> <11.9, 19.1, 3.9> }
          box { <-3.900001, 18.1, -3.9> <11.900001, 19.100001, -2> }
          box { <-2.9, 3.5, -3.9> <10.9, 17.5, -1> }
          box { <-3.900002, -4, 0> <11.900002, 0, 4> rotate -45*x translate <0, 0, -4.9> }
        }
        box { <-4, -5, -5> <12, -0.000001, 5> }
        box { <-1.9, 4.5, -4> <9.9, 16.5, 4> }
        box { <-2.400001, 3, -1.6> <10.400001, 18.100001, 4> }
        box { <-2.4, -1, -2.4> <10.4, 3.000001, 4> }
        cylinder { 15*y, 20*y, 0.65 translate <4, 0, -1> }
        box { <-4, -1, -6> <12, 2, -3.9> }
      }
      box { <2.4, 0.000001, -2.5> <5.6, 2.1000001, 1.000001> }
      cylinder { 0.000002*y, 2.1*y, 1.600001 translate <4, 0, 1> }
      object { open_rounded_button() translate <0, 16, 0> }
      object { open_rounded_button() translate <8, 16, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 20.9, 4> } }
    }
  #end
#end
#macro oldwindow1_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 19.1, 3.9> }
      box { <-2.9, 3.5, -4> <18.9, 17.5, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -2.9> <19.9, 19.1, 3.9> }
          box { <-3.900001, 18.1, -3.9> <19.900001, 19.100001, -2> }
          box { <-2.9, 3.5, -3.9> <18.9, 17.5, -1> }
          box { <-3.900002, -4, 0> <19.900002, 0, 4> rotate -45*x translate <0, 0, -4.9> }
        }
        box { <-4, -5, -5> <20, -0.000001, 5> }
        box { <-1.9, 4.5, -4> <17.9, 16.5, 4> }
        box { <-2.400001, 3, -1.6> <18.400001, 18.100001, 4> }
        box { <-2.4, -1, -2.4> <18.4, 3.000001, 4> }
        cylinder { 15*y, 20*y, 0.65 translate <4, 0, -1> }
        cylinder { 15*y, 20*y, 0.65 translate <12, 0, -1> }
        box { <-4, -1, -6> <20, 2, -3.9> }
      }
      box { <2.4, 0.000001, -2.5> <5.6, 2.1000001, 1.000001> }
      cylinder { 0.000002*y, 2.1*y, 1.600001 translate <4, 0, 1> }
      box { <10.4, 0.000001, -2.5> <13.6, 2.1000001, 1.000001> }
      cylinder { 0.000002*y, 2.1*y, 1.600001 translate <12, 0, 1> }
      object { open_rounded_button() translate <0, 16, 0> }
      object { open_rounded_button() translate <8, 16, 0> }
      object { open_rounded_button() translate <16, 16, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 19.1, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -5> <20, 20.9, 4> } }
    }
  #end
#end
#macro oldwindow1_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 19.1, 3.9> }
      box { <-2.9, 3.5, -4> <26.9, 17.5, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -2.9> <27.9, 19.1, 3.9> }
          box { <-3.900001, 18.1, -3.9> <27.900001, 19.100001, -2> }
          box { <-2.9, 3.5, -3.9> <26.9, 17.5, -1> }
          box { <-3.900002, -4, 0> <27.900002, 0, 4> rotate -45*x translate <0, 0, -4.9> }
        }
        box { <-4, -5, -5> <28, -0.000001, 5> }
        box { <-1.9, 4.5, -4> <25.9, 16.5, 4> }
        box { <-2.400001, 3, -1.6> <26.400001, 18.100001, 4> }
        box { <-2.4, -1, -2.4> <26.4, 3.000001, 4> }
        cylinder { 15*y, 20*y, 0.65 translate <4, 0, -1> }
        cylinder { 15*y, 20*y, 0.65 translate <12, 0, -1> }
        cylinder { 15*y, 20*y, 0.65 translate <20, 0, -1> }
        box { <-4, -1, -6> <28, 2, -3.9> }
      }
      box { <2.4, 0.000001, -2.5> <5.6, 2.1000001, 1.000001> }
      cylinder { 0.000002*y, 2.1*y, 1.600001 translate <4, 0, 1> }
      box { <10.4, 0.000001, -2.5> <13.6, 2.1000001, 1.000001> }
      cylinder { 0.000002*y, 2.1*y, 1.600001 translate <12, 0, 1> }
      box { <18.4, 0.000001, -2.5> <21.6, 2.1000001, 1.000001> }
      cylinder { 0.000002*y, 2.1*y, 1.600001 translate <20, 0, 1> }
      object { open_rounded_button() translate <0, 16, 0> }
      object { open_rounded_button() translate <8, 16, 0> }
      object { open_rounded_button() translate <16, 16, 0> }
      object { open_rounded_button() translate <24, 16, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 19.1, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -5> <28, 20.9, 4> } }
    }
  #end
#end
#macro old_boat_mast_basis(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> }
      cylinder { 3*y, 14.9*y, 7 translate <12, 0, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> }
          box { <4.1, 3, 4.1> <19.9, 6.3, 19.9> }
          cylinder { 6.2*y, 14.9*y, 7 translate <12, 0, 12> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <0, 0, 16> }
            object { rounded_button() translate <0, 0, 24> }
            object { rounded_button() translate <24, 0, 8> }
            object { rounded_button() translate <24, 0, 16> }
            object { rounded_button() translate <24, 0, 24> }
            object { rounded_button() translate <8, 0, 24> }
            object { rounded_button() translate <16, 0, 24> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
          box { <21.6, -1, -2.4> <26.4, 2, 2.4> }
          box { <-2.4, -1, 21.6> <2.4, 2, 26.4> }
          box { <21.6, -1, 21.6> <26.4, 2, 26.4> }
          box { <4, -1, -2.4> <20, 2, 2.4> }
          box { <-2.4, -1, 4> <2.4, 2, 20> }
          box { <4, -1, 21.6> <20, 2, 26.4> }
          box { <21.6, -1, 4> <26.4, 2, 20> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          box { <4, -1, 4> <20, 2, 20> }
          box { <5, -1, 5> <19, 6, 19> }
          cylinder { 0*y, 15*y, 1.600001 translate <12, 0, 12> }
        #end
        cylinder { -8*z, 8*z, 1.25 translate <12, 14.9, 12> }
        cylinder { -8*x, 8*x, 1.25 translate <12, 14.9, 12> }
        cylinder { 11.9*y, 15*y, 2.4 translate <9, 0, 9> }
        cylinder { 11.9*y, 15*y, 2.4 translate <15, 0, 9> }
        cylinder { 11.9*y, 15*y, 2.4 translate <9, 0, 15> }
        cylinder { 11.9*y, 15*y, 2.4 translate <15, 0, 15> }
        cylinder { 7.9*y, 15*y, 6 translate <12, 0, 12> }
        difference {
          cylinder { 0*y, 7.8*y, 6 }
          cylinder { -1*y, 9*y, 4.5 }
          translate <12, 0, 12>
        }
        difference {
          cylinder { 5.9*y, 12*y, 2.9 }
          cylinder { 5*y, 13*y, 2.3 }
          translate <12, 0, 12>
        }
      }
      difference {
        cylinder { 5.8*y, 11.9*y, 2.4 }
        cylinder { 0*y, 12*y, 1.600001 }
        translate <12, 0, 12>
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 6.1*y, 3.2 }
          cylinder { -1*y, 8*y, 2.6 }
          translate <12, 0, 12>
        }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <0, 0, 12> }
        object { pin(2) translate <24, 0, 12> }
        object { pin(2) translate <12, 0, 24> }
        box { <3.9, 0.000001, -0.5> <5.6, 2.1, 0.5> }
        box { <18.4, 0.000001, -0.5> <20.1, 2.1, 0.5> }
        box { <-0.5, 0.000001, 3.9> <0.5, 2.1, 5.6> }
        box { <-0.5, 0.000001, 18.4> <0.5, 2.1, 20.1> }
        box { <3.9, 0.000001, 23.5> <5.6, 2.1, 24.5> }
        box { <18.4, 0.000001, 23.5> <20.1, 2.1, 24.5> }
        box { <23.5, 0.000001, 3.9> <24.5, 2.1, 5.6> }
        box { <23.5, 0.000001, 18.4> <24.5, 2.1, 20.1> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 15, 28> } }
    }
  #end
#end
#macro old_boat_middle_hull_small(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -47.9> <59.9, 22.3, 47.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          difference {
            cylinder { -3.9*x, 59.9*x, 47.9 translate <0, 22.3, 0> }
            box { <-4, 22.3, -50> <60, 200, 50> }
            box { <-4, -200, -50> <60, 12.699999, 50> }
            box { <-4, 12.7, -32.1> <60, 30, 32.1> }
          }
          difference {
            cylinder { -3.900001*x, 59.9*x, 57.5 translate <0, 47.8, 0> }
            box { <-4, -100, -50> <60, 0, 50> }
            box { <-4, 12.699998, -60> <60, 200, 60> }
          }
        }
        difference {
          cylinder { -2.9*x, 58.9*x, 46.4 translate <0, 22.3, 0> }
          box { <-3, -200, -50> <60, 13.7, 50> }
          box { <-3, -20, -33.6> <60, 30, 33.6> }
        }
        difference {
          cylinder { -2.900001*x, 58.900001*x, 56 translate <0, 47.8, 0> }
          box { <-4, 13.700002, -60> <60, 200, 60> }
          box { <-3, -20, -33.600001> <60, 30, 33.600001> }
        }
        #if (setting > 1)
          box { <-4, -1, -7.9> <12.1, 9.6, -24.1> }
          box { <-4, -1, 7.9> <12.1, 9.6, 24.1> }
          box { <43.9, -1, -7.9> <60, 9.6, -24.1> }
          box { <43.9, -1, 7.9> <60, 9.6, 24.1> }
          box { <-2.4, -1, -7.900001> <12.100001, 11.8, -24.100001> }
          box { <-2.4, -1, 7.900001> <12.100001, 11.8, 24.100001> }
          box { <43.900001, -1, -7.900001> <58.4, 11.8, -24.100001> }
          box { <43.900001, -1, 7.900001> <58.4, 11.8, 24.100001> }
          difference {
            box { <-2.400002, -1, -31.6> <58.400002, 11.8, 31.6> }
            box { <-3, -2, -6.4> <13.6, 12, -25.6> }
            box { <-3, -2, 6.4> <13.6, 12, 25.6> }
            box { <42.4, -2, -6.4> <59, 12, -25.6> }
            box { <42.4, -2, 6.4> <59, 12, 25.6> }
            box { <27.5, -2, -32> <28.5, 12, -25> }
            box { <27.5, -2, 25> <28.5, 12, 32> }
            difference {
              box { <18.4, -2, -25.6> <37.6, 12, 25.6> }
              difference {
                box { <19.9, -3, -24.1> <36.1, 13, 24.1> }
                cylinder { 9.6*y, 13*y, 3.2 translate <28, 0, -16> }
                cylinder { 9.6*y, 13*y, 3.2 translate <28, 0, -8> }
                cylinder { 9.6*y, 13*y, 3.2 translate <28, 0, 0> }
                cylinder { 9.6*y, 13*y, 3.2 translate <28, 0, 8> }
                cylinder { 9.6*y, 13*y, 3.2 translate <28, 0, 16> }
              }
            }
          }
          cylinder { -1*y, 20*y, 2.6 translate <28, 0, -16> }
          cylinder { -1*y, 20*y, 2.6 translate <28, 0, -8> }
          cylinder { -1*y, 20*y, 2.6 translate <28, 0, 0> }
          cylinder { -1*y, 20*y, 2.6 translate <28, 0, 8> }
          cylinder { -1*y, 20*y, 2.6 translate <28, 0, 16> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 9.6, -16> }
        object { ring() translate <4, 9.6, 16> }
        object { ring() translate <52, 9.6, -16> }
        object { ring() translate <52, 9.6, 16> }
        box { <-0.5, 9.6, -24.2> <0.5, 11.9, -22.5> }
        box { <7.5, 9.6, -24.2> <8.5, 11.9, -22.5> }
        box { <23.5, 9.6, -24.2> <24.5, 11.9, -22.5> }
        box { <31.5, 9.6, -24.2> <32.5, 11.9, -22.5> }
        box { <47.5, 9.6, -24.2> <48.5, 11.9, -22.5> }
        box { <55.5, 9.6, -24.2> <56.5, 11.9, -22.5> }
        box { <-0.5, 9.6, 24.2> <0.5, 11.9, 22.5> }
        box { <7.5, 9.6, 24.2> <8.5, 11.9, 22.5> }
        box { <23.5, 9.6, 24.2> <24.5, 11.9, 22.5> }
        box { <31.5, 9.6, 24.2> <32.5, 11.9, 22.5> }
        box { <47.5, 9.6, 24.2> <48.5, 11.9, 22.5> }
        box { <55.5, 9.6, 24.2> <56.5, 11.9, 22.5> }
        box { <-0.5, 9.6, -7.8> <0.5, 11.9, -9.5> }
        box { <7.5, 9.6, -7.8> <8.5, 11.9, -9.5> }
        box { <23.5, 9.6, -7.8> <24.5, 11.9, -9.5> }
        box { <31.5, 9.6, -7.8> <32.5, 11.9, -9.5> }
        box { <47.5, 9.6, -7.8> <48.5, 11.9, -9.5> }
        box { <55.5, 9.6, -7.8> <56.5, 11.9, -9.5> }
        box { <-0.5, 9.6, 7.8> <0.5, 11.9, 9.5> }
        box { <7.5, 9.6, 7.8> <8.5, 11.9, 9.5> }
        box { <23.5, 9.6, 7.8> <24.5, 11.9, 9.5> }
        box { <31.5, 9.6, 7.8> <32.5, 11.9, 9.5> }
        box { <47.5, 9.6, 7.8> <48.5, 11.9, 9.5> }
        box { <55.5, 9.6, 7.8> <56.5, 11.9, 9.5> }
        box { <10.5, 9.6, -20.5> <12.5, 11.9, -19.5> }
        box { <10.5, 9.6, -12.5> <12.5, 11.9, -11.5> }
        box { <10.5, 9.6, 11.5> <12.5, 11.9, 12.5> }
        box { <10.5, 9.6, 19.5> <12.5, 11.9, 20.5> }
        box { <43.5, 9.6, -20.5> <45.5, 11.9, -19.5> }
        box { <43.5, 9.6, -12.5> <45.5, 11.9, -11.5> }
        box { <43.5, 9.6, 11.5> <45.5, 11.9, 12.5> }
        box { <43.5, 9.6, 19.5> <45.5, 11.9, 20.5> }
        box { <19.5, 9.6, -20.5> <21.5, 11.9, -19.5> }
        box { <19.5, 9.6, -12.5> <21.5, 11.9, -11.5> }
        box { <19.5, 9.6, -4.5> <21.5, 11.9, -3.5> }
        box { <19.5, 9.6, 3.5> <21.5, 11.9, 4.5> }
        box { <19.5, 9.6, 11.5> <21.5, 11.9, 12.5> }
        box { <19.5, 9.6, 19.5> <21.5, 11.9, 20.5> }
        box { <34.5, 9.6, -20.5> <36.5, 11.9, -19.5> }
        box { <34.5, 9.6, -12.5> <36.5, 11.9, -11.5> }
        box { <34.5, 9.6, -4.5> <36.5, 11.9, -3.5> }
        box { <34.5, 9.6, 3.5> <36.5, 11.9, 4.5> }
        box { <34.5, 9.6, 11.5> <36.5, 11.9, 12.5> }
        box { <34.5, 9.6, 19.5> <36.5, 11.9, 20.5> }
      #end
      #local counter = 0;
      #local counter2 = 0;
      #while (counter2 < 8 )
        #while (counter < 8 )
          object { open_rounded_button() translate <0+(counter*8), 9.6, -28+(counter2*8)> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> translate <0+(counter*8), 12.7, -28+(counter2*8)> }
          #end
          #local counter = counter + 1;
        #end
        #local counter = 0;
        #local counter2 = counter2 + 1;
      #end
      difference {
        union {
          #local counter = 0;
          #local counter2 = 0;
          #while (counter2 < 12)
            #while (counter < 8)
              merge {
                object { open_rounded_button() translate <0, 19.2, 0> }
                difference {
                  cylinder { 2*y, 22.200001*y, 2.400001 }
                  cylinder { 1*y, 23*y, 1.600001 }
                }
                translate <0+(counter*8), 0, -44+(counter2*8)>
              }
              #local counter = counter + 1;
            #end
            #local counter = 0;
            #local counter2 = counter2 + 1;
            #if (counter2 = 2)
              #local counter2 = 10;
            #end
          #end
        }
        box { <-4, 20, -20> <60, 0, 0> rotate -45*x translate <0, 0, -32> }
        box { <-4, 20, 0> <60, 0, 20> rotate 45*x translate <0, 0, 32> }
      }
      #local counter = 0;
      #while (counter < 8)
        difference {
          box { <-0.4, 2, -42> <0.4, 22.1, -38> }
          box { <-1, 20, -20> <1, 0, 0> rotate -45*x translate <0, 0, -32> }
          translate <0+(counter*8), 0, 0>
        }
        difference {
          box { <-0.4, 2, 42> <0.4, 22.1, 38> }
          box { <-1, 20, 0> <1, 0, 20> rotate 45*x translate <0, 0, 32> }
          translate <0+(counter*8), 0, 0>
        }
        #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -48> <60, 24.1, 48> } }
    }
  #end
#end
#macro old_boat_thick_mast(color_tex)
  #if (setting = 0)
    cone { 0*y, 7, 135*y, 5.5 texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.8, 134.9, -3.8> <3.8, 136, 3.8> }
        cylinder { -7*z, -5.8*z, 1.15 }
        cylinder { 5.8*z, 7*z, 1.15 }
        difference {
          cone { 0*y, 7, 135*y, 5.5 }
          #if (setting > 1)
            cone { 4.1*y, 4, 97*y, 3 }
            difference {
              box { <0, 4.100001, -4> <8, 96.999999, 4> }
              box { <-1, 0, -10> <10, 100, 0> rotate 0.5*x translate <0, 4.1, -4> }
              box { <-1, 0, 0> <10, 100, 10> rotate -0.5*x translate <0, 4.1, 4> }
            }
          #end
        }
        difference {
          cylinder { -5*y, 0*y, 5.9 }
          cylinder { -6*y, 1*y, 5 }
        }
        cylinder { 1*y, 4.1*y, 7.2 }
        cylinder { 97*y, 101.1*y, 6.1 }
        cylinder { 1.000001*y, 4.100001*y, 3.2 translate <-16, 0, 0> }
        cylinder { 1.000001*y, 4.100001*y, 3.2 translate <16, 0, 0> }
        cylinder { 97.000001*y, 101.100001*y, 3.2 translate <-16, 0, 0> }
        cylinder { 97.000001*y, 101.100001*y, 3.2 translate <16, 0, 0> }
        box { <-16, 1.000003, -3.2> <16, 4.100003, 3.2> }
        box { <-16, 97.000003, -3.2> <16, 101.100003, 3.2> }
        object { open_rounded_button() translate <-16, 98, 0> }
        object { open_rounded_button() translate <16, 98, 0> }
        box { <-10, -2, -2.6> <2, 0, -1.600001> rotate -10*z translate <12, 101.1, 0> }
        box { <-10, -2, 2.6> <2, 0, 1.600001> rotate -10*z translate <12, 101.1, 0> }
        box { <-2, -2, -2.6> <10, 0, -1.600001> rotate 10*z translate <-12, 101.1, 0> }
        box { <-2, -2, 2.6> <10, 0, 1.600001> rotate 10*z translate <-12, 101.1, 0> }
        box { <-10, 0, -2.6> <2, 2, -1.600001> rotate 10*z translate <12, 1, 0> }
        box { <-10, 0, 2.6> <2, 2, 1.600001> rotate 10*z translate <12, 1, 0> }
        box { <-2, 0, -2.6> <10, 2, -1.600001> rotate -10*z translate <-12, 1, 0> }
        box { <-2, 0, 2.6> <10, 2, 1.600001> rotate -10*z translate <-12, 1, 0> }
        difference {
          box { <-14.4, 1.000002, -7.2> <14.4, 4.100002, 7.2> }
          box { <-40, 0, -20> <0, 5, 0> rotate -16.75*y translate <14.4, 0, -3.2> }
          box { <0, 0, -20> <40, 5, 0> rotate 16.75*y translate <-14.4, 0, -3.2> }
          box { <-40, 0, 0> <0, 5, 20> rotate 16.75*y translate <14.4, 0, 3.2> }
          box { <0, 0, 0> <40, 5, 20> rotate -16.75*y translate <-14.4, 0, 3.2> }
        }
        difference {
          box { <-14.4, 97.000002, -6.1> <14.4, 101.100002, 6.1> }
          box { <-40, 90, -20> <0, 105, 0> rotate -12.25*y translate <14.4, 0, -3.2> }
          box { <0, 90, -20> <40, 105, 0> rotate 12.25*y translate <-14.4, 0, -3.2> }
          box { <-40, 90, 0> <0, 105, 20> rotate 12.25*y translate <14.4, 0, 3.2> }
          box { <0, 90, 0> <40, 105, 20> rotate -12.25*y translate <-14.4, 0, 3.2> }
        }
      }
      #if (setting > 1)
        box { <-13, 0, -1.6> <-7, 2.9, 1.6> }
        box { <7, 0, -1.6> <13, 2.9, 1.6> }
        box { <-13, 99.2, -1.6> <-7, 110, 1.6> }
        box { <7, 99.2, -1.6> <13, 110, 1.6> }
        cylinder { 0*y, 120*y, 1.600001 translate <-16, 0, 0> }
        cylinder { 0*y, 120*y, 1.600001 translate <16, 0, 0> }
        cylinder { 90*y, 150*y, 1.600001 }
        cylinder { 102*y, 140*y, 2 translate <-1, 0, -1> }
        cylinder { 102*y, 140*y, 2 translate <1, 0, -1> }
        cylinder { 102*y, 140*y, 2 translate <-1, 0, 1> }
        cylinder { 102*y, 140*y, 2 translate <1, 0, 1> }
        box { <-1.000001, 102.000001, -1.000001> <1.000001, 140, 1.000001> }
      #end
      texture { color_tex }
      bounded_by { box { <-19.3, -5.1, -7.1> <19.3, 136.1, 7.1> } }
    }
  #end
#end
#macro old_cannon(color_tex)
  #if (setting = 0)
    merge {
      cone { -27*x, 5, 25.45*x, 6.25 }
      cylinder { 25*x, 35.8*x, 1.5 }
      texture { color_tex }
    }
  #else
    merge {
      sphere { <0, 0, -10> 1.5 }
      sphere { <0, 0, 10> 1.5 }
      cylinder { -10.000001*z, 10.000001*z, 1.500001 }
      cylinder { -6.25*z, 6.25*z, 2.3 }
      torus { 5, 1 rotate 90*z translate <-27, 0, 0> }
      difference {
        cone { -27*x, 5, 19*x, 6.25 }
        cylinder { -30*x, -1*x, 4.3 }
        #if (setting > 1)
          cylinder { -10*z, 10*z, 1 translate <15, 0, 0> }
        #end
      }
      cylinder { -24*x, 0*x, 0.75 }
      difference {
        sphere { <19.2, 0, 0> 6.25 }
        box { <10, -10, -10> <19.2, 10, 10> }
        cylinder { 10*x, 30*x, 2.6 }
      }
      cylinder { 15*x, 20*x, 4.75 }
      cylinder { -5.5*z, 5.5*z, 0.9 translate <15, 0, 0> }
      cylinder { 20*x, 24.500001*x, 2.500001 }
      cone { 24.5*x, 2.5, 28*x, 1.500001 }
      cylinder { 27*x, 33*x, 1.5 }
      sphere { <33.5, 0, 0> 2.3 }
      box { <5.5, -1.25, -6.25> <11.5, 1.25, 6.25> }
      #if (setting > 3)
        object { llogo() scale <0.8, 0.8, 0.8> rotate -90*y rotate -90*x translate <8.5, 0, -6.25> }
        object { llogo() scale <0.8, 0.8, 0.8> rotate -90*y rotate 90*x translate <8.5, 0, 6.25> }
      #end
      texture { color_tex }
      bounded_by { box { <-28.1, -6.35, -11.6> <35.9, 6.35, 11.6> } }
    }
  #end
#end
#macro old_cannon_mount(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 15.9, 11.9> }
      box { <19.9, 6.3, -4> <28, 16, 12> }
      box { <11.9, 9.5, -4> <28, 16, 12> }
      box { <3.9, 12.7, -4> <28, 16, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 15.9, 11.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 10.4> }
        #end
        box { <19.9, 6.3, -4> <28, 16, 12> }
        box { <11.9, 9.5, -4> <28, 16, 12> }
        box { <3.9, 12.7, -4> <28, 16, 12> }
        box { <-4, 3.1, -2.4> <-0.9, 16, 10.4> }
        box { <0.9, 3.1, -2.4> <28, 16, 10.4> }
        cylinder { -1*x, 1*x, 6.25 translate <0, 11.5, 4> }
        box { <-1, 9.5, -2.400001> <1, 16, 10.400001> }
        cylinder { -4*z, 12*z, 1.6 translate <0, 14.4, 0> }
        box { <-0.75, -0.75, -4> <5, 5, 12> rotate 45*z translate <0, 14.4, 0> }
      }
      difference {
        box { <11.9, 6.3, -9.9> <19.9, 9.500001, -3.5> }
        cylinder { 5*y, 10*y, 1.6 translate <16, 0, -8> }
        box { <-10, 5, -10> <0, 10, 0> rotate -12.5*y translate <11.9, 0, -3.9> }
        box { <0, 5, -10> <10, 10, 0> rotate 12.5*y translate <19.9, 0, -3.9> }
        box { <14.75, 5, -10> <17.25, 10, -8> }
      }
      difference {
        box { <11.9, 6.3, 11.5> <19.9, 9.500001, 17.9> }
        cylinder { 5*y, 10*y, 1.6 translate <16, 0, 16> }
        box { <-10, 5, 0> <0, 10, 10> rotate 12.5*y translate <11.9, 0, 11.9> }
        box { <0, 5, 0> <10, 10, 10> rotate -12.5*y translate <19.9, 0, 11.9> }
        box { <14.75, 5, 16> <17.25, 10, 18> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
      #end
      #if (setting > 3)
        object { llogo() scale <1, 0.5, 1> rotate 90*y translate <16, 9.5, 12.4> }
        object { llogo() scale <1, 0.5, 1> rotate -90*y translate <16, 9.5, -4.4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -10> <28, 16, 18> } }
    }
  #end
#end
#macro old_helmet(color_tex)
  #if (setting = 0)
    merge {
      sphere { <0, 0, 0> 6 scale <1, 0.833333, 1> translate <0, 2.2, 0> }
      cylinder { -5.1*y, 2.200001*y, 6.000001 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          sphere { <0, 0, 0> 6 scale <1, 0.833333, 1> translate <0, 2.2, 0> }
          cylinder { -5.1*y, 2.200001*y, 6.000001 }
        }
        sphere { <0, 2.2, 0> 5.1 scale <1, 0.833333, 1> }
        cylinder { -6*y, 2.200001*y, 5.100001 }
        sphere { <0, 2.2, -6.2> 0.7 }
        sphere { <0, 2.2, 6.2> 0.7 }
        cylinder { -7*z, 7*z, 2 translate <-4.5, 1, 0> }
        box { <-8, -3.000001, -7> <-4.499999, 3.000001, 7> }
        cylinder { -7*z, 7*z, 2 translate <-4.5, -1, 0> }
        box { <-8, -1.000001, -7> <-2.499999, 1.000001, 7> }
        box { <0, -7, -7> <7, -4.1, 7> }
        cylinder { -7*z, 7*z, 11 translate <0, -15, 0> }
      }
      object { ring() translate <0, 3, 0> }
      bounded_by { cylinder { -5.2*y, 7.3*y, 6.1 } }
      texture { color_tex }
    }
  #end
#end
#macro old_h_block1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
        #else
          object { rounded_button() translate <0, 6.4, 0> }
          object { rounded_button() translate <8, 6.4, 0> }
        #end
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
        cylinder { 7.4*y, 10.4*y, 1.2 }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 4> } }
    }
  #end
#end
#macro old_h_block1_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
        #else
          object { rounded_button() translate <0, 6.4, 0> }
          object { rounded_button() translate <8, 6.4, 0> }
          object { rounded_button() translate <16, 6.4, 0> }
          object { rounded_button() translate <24, 6.4, 0> }
        #end
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <11.5, 8.6, 2.4> }
        box { <12.5, -1, -2.4> <26.4, 8.6, 2.4> }
        cylinder { 7.4*y, 10.4*y, 1.2 }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 4> } }
    }
  #end
#end
#macro old_h_block1_6(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <43.9, 9.5, 3.9> }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <40, 0, 0> }
        #else
          object { rounded_button() translate <0, 6.4, 0> }
          object { rounded_button() translate <8, 6.4, 0> }
          object { rounded_button() translate <16, 6.4, 0> }
          object { rounded_button() translate <24, 6.4, 0> }
          object { rounded_button() translate <32, 6.4, 0> }
          object { rounded_button() translate <40, 6.4, 0> }
        #end
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <11.5, 8.6, 2.4> }
        box { <12.5, -1, -2.4> <27.5, 8.6, 2.4> }
        box { <28.5, -1, -2.4> <42.4, 8.6, 2.4> }
        cylinder { 7.4*y, 10.4*y, 1.2 }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 11.3, 4> } }
    }
  #end
#end
#macro old_minifigure_body(color_tex)
  #if (setting = 0)
    difference {
      box { <-7.5, 0, -3.9> <7.5, 12.7, 3.9> }
      box { <-10, -2, -5> <0, 20, 5> rotate -11*z translate <-7.5, 1, 0> }
      box { <0, -2, -5> <10, 20, 5> rotate 11*z translate <7.5, 1, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          merge {
            box { <-7.5, 0, -3.9> <7.5, 12.7, 3.9> }
            #if (setting < 3)
              cylinder { 12.6*y, 14.4*y, 2.4 }
            #else
              object { rounded_button() translate <0, 9.6, 0> }
            #end
          }
          cylinder { 9.6*y, 13.6*y, 1.2 }
          box { <-10, -2, -5> <0, 20, 5> rotate -11*z translate <-7.5, 1, 0> }
          box { <0, -2, -5> <10, 20, 5> rotate 11*z translate <7.5, 1, 0> }
        }
        sphere { <-5, 10.2, 0> 2.5 }
        sphere { <5, 10.2, 0> 2.5 }
        cylinder { 0.000001*y, 10.200001*y, 2.500001 translate <-5, 0, 0> }
        cylinder { 0.000001*y, 10.200001*y, 2.500001 translate <5, 0, 0> }
      }
      difference {
        box { <-6, -1, -2.4> <6, 11.8, 2.4> }
        box { <-10, -2, -5> <0, 20, 5> rotate -11*z translate <-6.75, 2, 0> }
        box { <0, -2, -5> <10, 20, 5> rotate 11*z translate <6.75, 2, 0> }
      }
      cylinder { -1*y, 8.600001*y, 0.999999 translate <-5, 0, 0> }
      cylinder { -1*y, 8.600001*y, 0.999999 translate <5, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-7.6, -0.1, -4> <7.6, 14.5, 4> } }
    }
  #end
#end
#macro old_minifigure_legs(color_tex)
  #if (setting = 0)
    difference {
      box { <-7.5, 0, -3.9> <7.5, 12.7, 3.9> }
      difference {
        merge {
          box { <-10, -20, -5> <0, 2, 5> rotate 9*z translate <-7.5, 12.7, 0> }
          box { <0, -20, -5> <10, 2, 5> rotate -9*z translate <7.5, 12.7, 0> }
        }
        box { <-8, -1, -4> <8, 3.1, 4> }
      }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-7.5, 0, -3.9> <7.5, 12.7, 3.9> }
        object { open_rounded_button() translate <-4, 9.6, 0> }
        object { open_rounded_button() translate <4, 9.6, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <-4, 12.7, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <4, 12.7, 0> }
        #end
      }
      difference {
        merge {
          box { <-10, -20, -5> <0, 2, 5> rotate 9*z translate <-7.5, 12.7, 0> }
          box { <0, -20, -5> <10, 2, 5> rotate -9*z translate <7.5, 12.7, 0> }
        }
        box { <-8, -1, -4> <8, 3.1, 4> }
      }
      #if (setting > 1)
        box { <-6, -1, -2.4> <6, 2, 2.4> }
        box { <-5, -1, -2.400001> <5, 11.8, 2.400001> }
        box { <-5.5, -1, -0.75> <5.5, 11.800001, 0.75> }
      #end
      texture { color_tex }
      bounded_by { box { <-7.6, -0.1, -4> <7.6, 14.2, 4> } }
    }
  #end
#end
#macro old_propellor_s(color_tex)
  #if (setting = 0)
    box { <-4, -15.55, -6.3> <4, 15.55, -5.4> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { 0*z, -6.3*z, 4 }
        #local counter = 0;
        #while (counter < 2)
          merge {
            cylinder { -13.200001*y, -2*y, 0.9 translate <-1.45, 0, 0> }
            cylinder { -13.200001*y, -2*y, 0.9 translate <1.45, 0, 0> }
            box { <-1.450001, -13.200002, -0.900001> <1.450001, -2.000001, 0.900001> }
            cylinder { -0.900003*z, 0.900003*z, 1.449999 translate <0, -13.2, 0> }
            torus { 1.45, 0.9 rotate <-90, 0, 0> translate <0, -13.199999, 0> }
            rotate <0, -22.5, (counter*180)>
            translate <0, 0, -4.75> 
          }
          #local counter = counter + 1;
        #end
      }
      cylinder { -7*z, 1*z, 3 }
      texture { color_tex }
      bounded_by { box { <-4.1, -15.65, -6.4> <4.1, 15.65, 0.1> } }
    }
  #end
#end
#macro old_rifle(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 2.000001*x, 14*x, 1.499999 translate <0, -2, 0> }
      cylinder { <-2, 2, 0>, <2, -2, 0>, 1.499999 }
      cylinder { -28.5*x, -2.000001*x, 1.499999 translate <0, 2, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        sphere { <-2, 2, 0> 1.5 }
        sphere { <2, -2, 0> 1.5 }
        cylinder { <-2, 2, 0>, <2, -2, 0>, 1.499999 }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z rotate -90*y translate <12, -2.5, 1.5> }
        #end
        cylinder { 2.000001*x, 14*x, 1.499999 translate <0, -2, 0> }
        cylinder { 0*x, 13*x, 1.499999 rotate -14*z translate <2, -2, 0> }
        cylinder { -28.5*x, -2.000001*x, 1.499999 translate <0, 2, 0> }
        box { <-28.500001, -2, -4> <-25, 6, 4> }
        difference {
          cylinder { -1.5*z, 1.5*z, 1.5 translate <-3, 3.5, 0> }
          cylinder { -2*z, 0*z, 0.7 translate <-3, 3.5, 0> }
          sphere { <-3, 3.5, 2> 1 }
        }
        difference {
          box { <-3, 3.5, 0> <-1.500001, 6.5, 1.500001> }
          box { <-3, 0, -1> <0, 5, 2> rotate -20*z translate <-3, 3.5, 0> }
        }
        cylinder { -0.4*z, 0.4*z, 1.5 translate <-4.5, 0.5, 0> }
        difference {
          box { <0, -4, -1.500001> <12, 0, 1.500001> }
          box { <-20, -10, -10> <20, 0, 10> rotate -14*z }
          translate <2, -2, 0>
        }
      }
      box { <14.000001, -10, -2> <18, 10, 2> }
      torus { 7, 5.5 rotate 90*z translate <-25, 2, 0> }
      difference {
        box { <-30, -2, -2> <-25, 6, 2> }
        torus { 7, 6.25 rotate 90*z translate <-25, 2, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-28.75, -5.75, -2.75> <14.25, 6.75, 2.75> } }
    }
  #end
#end
#macro old_spanish_helmet(color_tex)
  #if (setting = 0)
    sphere { <0, 0, 0> 6 translate <0, 0.5, 0> texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { 0*y, 1*y, 8.75 scale <1, 1, 1.057143> translate <8.75, 0, 0>
          rotate 29*z translate <-7.5, -4, 0> }
        box { <0.000001, -10, -10> <10, 10, 10> }
        sphere { <0, 0, 0> 5.000001 scale <1, 1.316667, 1> translate <0, -1.5, 0> }
      }
      difference {
        cylinder { 0*y, 1*y, 8.75 scale <1, 1, 1.057143> translate <-8.75, 0, 0>
          rotate -29*z translate <7.5, -4, 0> }
        box { <-10, -10, -10> <-0.000001, 10, 10> }
        sphere { <0, 0, 0> 5.000002 scale <1, 1.316667, 1> translate <0, -1.5, 0> }
      }
      difference {
        merge {
          sphere { <0, 0, 0> 6 translate <0, 0.5, 0> }
          cylinder { -2.5*y, 0.500001*y, 6 }
          cylinder { -0.6*x, 0.6*x, 6 scale <1, 1.916667, 1> translate <0, -1.5, 0> }
        }
        difference {
          box { <0, -50, -10> <20, 0, 10> rotate 29*z translate <-7.5, -4.000001, 0> }
          box { <0.000005, -50, -10> <10, 10, 10> }
        }
        difference {
          box { <-20, -50, -10> <0, 0, 10> rotate -29*z translate <7.5, -4.000001, 0> }
          box { <-10, -50, -10> <-0.000005, 10, 10> }
        }
        sphere { <0, 0, 0> 5.1 translate <0, 0.5, 0> }
        cylinder { -10*y, 0.500005*y, 5.1 rotate -5*x }
      }
      difference {
        cylinder { 0*y, 6.5*y, 1.4 }
        cylinder { -1*y, 10*y, 0.7 }
        sphere { <0, 0, 0> 5.100002 translate <3, 0.5, -3> }
        cylinder { -10*y, 0.500005*y, 5.100002 rotate -5*x translate <3, 0, -3> }
        rotate -5*x
        translate <-3, 0, 3>
      }
      #if (setting > 1)
        object { ring() translate <0, 3, 0> }
      #end
      rotate 5*x
      texture { color_tex }
      bounded_by { cylinder { -4.1*y, 10.1*y, 9 } }
    }
  #end
#end
#macro old_s_propellor2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.900001> <11.9, 3.1, 11.9> }
      box { <-3.900001, 0.000001, -9.9> <11.900001, 12.7, -3.899999> }
      cylinder { -16.25*z, -9.5*z, 2.8 translate <4, 6.35, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.900001> <11.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() rotate -90*y }
            object { rounded_button() rotate -90*y translate <8, 0, 0> }
            object { rounded_button() rotate -90*y translate <0, 0, 8> }
            object { rounded_button() rotate -90*y translate <8, 0, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -4> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        box { <-0.5, 0.1, -5> <0.5, 2.1, -2.4> }
        box { <7.5, 0.1, -5> <8.5, 2.1, -2.4> }
      #end
      difference {
        box { <-3.900001, 0.000001, -9.9> <11.900001, 12.7, -3.899999> }
        box { <-10, -1, -10> <0, 13, 0> rotate -40*y translate <-3.9, 0, -5.5> }
        box { <0, -1, 0> <10, 13, -10> rotate 40*y translate <11.9, 0, -5.5> }
        box { <-10, 0, -10> <20, 10, 0> rotate -27*x translate <0, 12.7, -5.5> }
        box { <-10, -10, -10> <20, 0, 0> rotate 27*x translate <0, 0, -5.5> }
        difference {
          box { <-1.6, -1, -8.4> <9.6, 12, -5.500001> }
          box { <-10, -2, -10> <0, 10, 0> rotate -40*y translate <-1.6, 0, -5.5> }
          box { <0, -2, 0> <10, 10, -10> rotate 40*y translate <9.6, 0, -5.5> }
          box { <-10, 0, -10> <20, 10, 0> rotate -27*x translate <0, 11.7, -5.5> }
        }
      }
      difference {
        merge {
          cylinder { -11*z, -9.5*z, 3 }
          cylinder { -15.5*z, -10*z, 2.8 }
          cylinder { -16.25*z, -15*z, 3 }
        }
        cylinder { -20*z, -9.900002*z, 1.9 }
        cylinder { -10*y, 20*y, 0.5 translate <0, -6, -13> }
        box { <-0.500001, -10, -20> <0.500001, 20, -12.999999> }
        translate <4, 6.35, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -16.35> <12, 12.8, 12> } }
    }
  #end
#end
#macro old_window1_1(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          object { open_rounded_button() translate <0, 6.4, 0> }
          box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> }
        }
        #if (setting > 1)
          box { <-4, 3.8, -1.8> <4, 7.4, 1.8> }
          box { <-4, 1.9, -4> <-2.9, 10, 4> }
          box { <-5, -5, -4> <0, 0, 4> rotate -45*z translate <-2.9, 1.9, 0> }
          box { <-2.4, -1, -2.4> <4, 2.1, 2.4> }
          box { <-1.6, 2, -2.8> <4, 8.5, 2.8> }
        #end
      }
      difference {
        box { <-3.9, 2.8, -2.8> <-2.8, 8.4, 2.8> }
        box { <-4, 3.80001, -1.80001> <4, 7.40001, 1.80001> }
      }
      texture { color_tex }
      bounded_by { box { <-4.2, -0.1, -4> <4, 11.3, 4> } }
    }
  #end
#end
#macro one_window(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 57.5, 3.9> }
      box { <-1.6, 4.5, -4> <25.6, 54.9, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 57.5, 3.9> }
          merge {
            cylinder { 3*y, 4.65*y, 2.4 }
            cylinder { 4*y, 4.8*y, 2.25 }
            torus { 2.25, 0.15 translate <0, 4.65, 0> }
            translate <0, 54.4, 0>
          }
          object { open_rounded_button() translate <8, 54.4, 0> }
          object { open_rounded_button() translate <16, 54.4, 0> }
          merge {
            cylinder { 3*y, 4.65*y, 2.4 }
            cylinder { 4*y, 4.8*y, 2.25 }
            torus { 2.25, 0.15 translate <0, 4.65, 0> }
            translate <24, 54.4, 0>
          }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <8, 57.5, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <16, 57.5, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          cylinder { 57.50001*y, 60*y, 0.9 }
          cylinder { 57.50001*y, 60*y, 0.9 translate <24, 0, 0> }
          cylinder { -1*y, 60*y, 0.6 translate <-0.9, 0, -2.1> }
          cylinder { -1*y, 60*y, 0.6 translate <-0.9, 0, 2.1> }
          cylinder { -1*y, 60*y, 0.6 translate <24.9, 0, -2.1> }
          cylinder { -1*y, 60*y, 0.6 translate <24.9, 0, 2.1> }
        #end
        box { <-2.4, 3.1, -2.4> <26.4, 56, 4> }
        box { <-1.6, 4.5, -4> <25.6, 54.9, 3> }
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 59.3, 4> } }
    }
  #end
#end
#macro opencatrolblock2_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 19.1, 11.9> }
      box { <-2.4, 3.1, -4> <26.4, 17.6, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 }
            cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 19*y, 20.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 19*y, 20.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 19*y, 20.8*y, 2.4 translate <24, 0, 8> }
          #else
            object { rounded_button() translate <0, 16, 0> }
            object { rounded_button() translate <8, 16, 0> }
            object { rounded_button() translate <16, 16, 0> }
            object { rounded_button() translate <24, 16, 0> }
            object { rounded_button() translate <0, 16, 8> }
            object { rounded_button() translate <8, 16, 8> }
            object { rounded_button() translate <16, 16, 8> }
            object { rounded_button() translate <24, 16, 8> }
          #end
          box { <-3.9, 0, -3.9> <27.9, 19.1, 11.9> }
        }
        #if (setting > 1)
          box { <-2.9, -1, -2.4> <26.9, 2, 10.4> }
        #end
        box { <-2.4, 3.1, -4> <26.4, 17.6, 12> }
        cylinder { -1*y, 21*y, 0.7 translate <-1.5, 0, -2.5> }
        cylinder { -1*y, 21*y, 0.7 translate <-1.5, 0, 10.5> }
        cylinder { -1*y, 21*y, 0.7 translate <25.5, 0, -2.5> }
        cylinder { -1*y, 21*y, 0.7 translate <25.5, 0, 10.5> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        box { <-3.5, 0.000001, 3.6> <1, 2.1, 4.4> }
        box { <7, 0.000001, 3.6> <9, 2.1, 4.4> }
        box { <15, 0.000001, 3.6> <17, 2.1, 4.4> }
        box { <23, 0.000001, 3.6> <27.5, 2.1, 4.4> }
      #end
      box { <11.5, 16.6, -0.5> <12.5, 17.7, 8.5> }
      cylinder { 16.600001*y, 18*y, 0.5 translate <12, 0, -0.5> }
      cylinder { 16.600001*y, 18*y, 0.5 translate <12, 0, 8.5> }
      cylinder { -3*x, -1.5*x, 1.5 translate <0, 9.9, 8> }
      cylinder { 25.5*x, 27*x, 1.5 translate <0, 9.9, 8> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 20.9, 12> } }
    }
  #end
#end
#macro opendhblock2_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 19.1, 11.9> }
      box { <-2.4, 4.8, -4> <26.4, 17.6, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { -3.9*z, 11.9*z, 3.2 }
        cylinder { -4*z, 12*z, 2.6 }
        translate <4, 11.2, 0>
      }
      difference {
        cylinder { -3.9*z, 11.9*z, 3.2 }
        cylinder { -4*z, 12*z, 2.6 }
        translate <12, 11.2, 0>
      }
      difference {
        cylinder { -3.9*z, 11.9*z, 3.2 }
        cylinder { -4*z, 12*z, 2.6 }
        translate <20, 11.2, 0>
      }
      difference {
        box { <-2.6, 4.7, 3.6> <26.6, 17.7, 4.4> }
        box { <1.75, 10.3, 3> <6.25, 12.1, 5> }
        box { <9.75, 10.3, 3> <14.25, 12.1, 5> }
        box { <17.75, 10.3, 3> <22.25, 12.1, 5> }
        box { <3.1, 8.95, 3> <4.9, 13.45, 5> }
        box { <11.1, 8.95, 3> <12.9, 13.45, 5> }
        box { <19.1, 8.95, 3> <20.9, 13.45, 5> }
      }
      difference {
        box { <-3.9, 0, -3.9> <27.9, 19.1, 11.9> }
        box { <-2.4, 4.8, -4> <26.4, 17.6, 12> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 3.7, 10.4> }
        #end
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 3.8*y, 3.2 }
          cylinder { -1*y, 4*y, 2.6 }
          translate <4, 0, 4>
        }
        difference {
          cylinder { 0*y, 3.8*y, 3.2 }
          cylinder { -1*y, 4*y, 2.6 }
          translate <12, 0, 4>
        }
        difference {
          cylinder { 0*y, 3.8*y, 3.2 }
          cylinder { -1*y, 4*y, 2.6 }
          translate <20, 0, 4>
        }
      #end
      box { <3.5, 14.1, -3.8> <4.5, 17.7, 11.8> }
      box { <11.5, 14.1, -3.8> <12.5, 17.7, 11.8> }
      box { <19.5, 14.1, -3.8> <20.5, 17.7, 11.8> }
      box { <3.5, 3.6, -3.8> <4.5, 8.3, 11.8> }
      box { <11.5, 3.6, -3.8> <12.5, 8.3, 11.8> }
      box { <19.5, 3.6, -3.8> <20.5, 8.3, 11.8> }
      object { open_rounded_button() translate <0, 16, 0> }
      object { open_rounded_button() translate <8, 16, 0> }
      object { open_rounded_button() translate <16, 16, 0> }
      object { open_rounded_button() translate <24, 16, 0> }
      object { open_rounded_button() translate <0, 16, 8> }
      object { open_rounded_button() translate <8, 16, 8> }
      object { open_rounded_button() translate <16, 16, 8> }
      object { open_rounded_button() translate <24, 16, 8> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <16, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <24, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 19.1, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 19.1, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <16, 19.1, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <24, 19.1, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 20.9, 12> } }
    }
  #end
#end
#macro openffblock1_2(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        #if (age = 1)
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
        #else
          merge {
            box { <-3.9, 0.5, -3.9> <11.9, 3.1, 3.9> }
            box { <-3.5, 0, -3.5> <11.5, 0.55, 3.5> }
          }
        #end
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          box { <-4, 1.9, -2.400001> <12, 4, -1> }
          box { <-4, 1.9, 1 > <12, 4, 2.400001> }
        #end
      }
      #if (setting > 1)
        box { <2.5, 0, -1.000001> <5.5, 2.1, 1.000001> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 3.2, 4> } }
    }
  #end
#end
#macro openf_cover4_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-30.4, -1.55, -3.9> <0, 1.55, 27.9> }
        box { <-22.6, -2, -0.000002> <-6, 2, 24.000002> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { -3.900001*z, 27.900001*z, 1.55 }
          box { <-30.4, -1.550001, -3.9> <0, 1.550001, 27.9> }
          #if (setting  <3 )
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-26.5, 0, 0> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-26.5, 0, 8> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-26.5, 0, 16> }
            cylinder { 1.45*y, 3.25*y, 2.4 translate <-26.5, 0, 24> }
          #else
            object { rounded_button() rotate 180*y translate <-26.5, -1.55, 0> }
            object { rounded_button() rotate 180*y translate <-26.5, -1.55, 8> }
            object { rounded_button() rotate 180*y translate <-26.5, -1.55, 16> }
            object { rounded_button() rotate 180*y translate <-26.5, -1.55, 24> }
          #end
        }
        box { <-22.6, -2, -0.000002> <-6, 2, 24.000002> }
        box { <-28.9, -2, -2.4> <-3, 0.450001, 26.4> }
        box { <-2, -2, 0.000001> <0, 0, 23.999999> rotate 45*z translate <-22.6, 1.5, 0> }
        box { <-2, -2, 0.000001> <0, 0, 23.999999> rotate 45*z translate <-6, 1.5, 0> }
        #if (setting > 1)
          cylinder { -3*y, 2.55*y, 1.2 translate <-26.5, 0, 0> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-26.5, 0, 8> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-26.5, 0, 16> }
          cylinder { -3*y, 2.55*y, 1.2 translate <-26.5, 0, 24> }
        #end
        box { <-2, -2, -5> <2, 2, -2.45> }
        box { <-2, -2, 3.2> <2, 2, 4.8> }
        box { <-2, -2, 11.2> <2, 2, 12.8> }
        box { <-2, -2, 19.2> <2, 2, 20.8> }
        box { <-2, -2, 26.45> <2, 2, 29> }
        box { <-5, -3, -1> <0, 0.45, 1.75> }
        box { <-5, -3, 6.25> <0, 0.45, 9.75> }
        box { <-5, -3, 14.25> <0, 0.45, 17.75> }
        box { <-5, -3, 22.25> <0, 0.45, 25> }
      }
      box { <-24.6, -1.55, -1.05> <-2, 0.5, 0.000005> }
      box { <-24.600001, -1.550001, -1> <-23.9, 0.5, 2> }
      box { <-24.600001, -1.550001, 6> <-23.9, 0.5, 10> }
      box { <-24.6, -1.55, 24> <-2, 0.5, 25.05> }
      box { <-24.600001, -1.550001, 22> <-23.9, 0.5, 25> }
      box { <-24.600001, -1.550001, 14> <-23.9, 0.5, 18> }
      sphere { <-21.5, 0, 0> 0.5 }
      sphere { <-21.5, 0, 24> 0.5 }
      sphere { <-7, 0, 0> 0.5 }
      sphere { <-7, 0, 24> 0.5 }
      box { <-18.5, -1.550002, -0.5> <-10.5, 0, 0.5> }
      box { <-18.5, -1.550002, 23.5> <-10.5, 0, 24.5> }
      difference {
        merge {
          object { ring() translate <-22.5, -1.55, 4> }
          object { ring() translate <-22.5, -1.55, 12> }
          object { ring() translate <-22.5, -1.55, 20> }
        }
        box { <-23.9, -2, 0.000003> <-18.5, 2, 23.999997> }
      }
      texture { color_tex }
      bounded_by { box { <-30.5, -1.65, -4> <2, 3.35, 28> } }
    }
  #end
#end
#macro openf_winglet4_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 3.1, 27.9> }
      box { <-20, -10, -10> <20, 10, 0> rotate -14.8*y translate <12, 0, 0> }
      box { <-20, -10, 0> <20, 10, 10> rotate 14.8*y translate <12, 0, 24> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
          #else
            object { rounded_button() rotate 180*y translate <16, 0, 8> }
            object { rounded_button() rotate 180*y translate <16, 0, 16> }
            object { rounded_button() rotate 180*y translate <24, 0, 8> }
            object { rounded_button() rotate 180*y translate <24, 0, 16> }
          #end
        }
        box { <-5, -1, 3.9> <11.3, 4, 20.1> }
        box { <0, -1, 4.9> <12.3, 4, 19.1> }
        cylinder { -1*y, 4*y, 1 translate <11.3, 0, 4.9> }
        cylinder { -1*y, 4*y, 1 translate <11.3, 0, 19.1> }
        box { <-20, -10, -10> <30, 10, 0> rotate -14.8*y translate <12, 0, 0> }
        box { <-20, -10, 0> <30, 10, 10> rotate 14.8*y translate <12, 0, 24> }
        box { <-2.5, -1, -2> <2.5, 2.00001, 2> rotate -14.8*y translate <8, 0, 0> }
        box { <-2.5, -1, -2> <2.5, 2.00001, 2> rotate 14.8*y translate <8, 0, 24> }
        box { <-1.5, -1, -4> <2.5, 2.00001, 2> rotate -14.8*y }
        box { <-1.5, -1, -2> <2.5, 2.00001, 4> rotate 14.8*y translate <0, 0, 24> }
        box { <13.4, -1, 0> <16, 2.00002, 3.4> }
        box { <13.4, -1, 20.6> <16, 2.00002, 24> }
        box { <0, -1, -3> <2, 2.00003, 3> rotate -14.8*y translate <16, 0, 0> }
        box { <0, -1, -3> <2, 2.00003, 3> rotate 14.8*y translate <16, 0, 24> }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          difference {
            box { <-2.8, -1, -4> <26.4, 2, 28> }
            box { <-20, -10, -10> <30, 10, 0> rotate -14.8*y translate <12, 0, 1.1> }
            box { <-20, -10, 0> <30, 10, 10> rotate 14.8*y translate <12, 0, 22.9> }
            box { <-5, -1, 2.9> <13.4, 4, 21.1> }
          }
        #end
      }
      #if (setting > 1)
        object { ring() translate <20, 0, 12> }
        box { <13, 0.00002, 5> <24.60001, 2.1, 6> }
        box { <13, 0.00002, 18> <24.60001, 2.1, 19> }
        box { <23.1, 0.00001, 4> <24.6, 2.1, 5.5> }
        box { <23.1, 0.00001, 18.5> <24.6, 2.1, 20> }
        difference {
          box{ <-2, 0.00003, 0> <0, 2.1, 2> }
          cylinder { -1*y, 3*y, 1.5 }
          translate <14.9, 0, 3.4>
        }
        difference {
          box{ <-2, 0.00003, -2> <0, 2.1, 0> }
          cylinder { -1*y, 3*y, 1.5 }
          translate <14.9, 0, 20.6>
        }
        box { <12.30001, 0.00004, 1> <13.4, 2.1, 23> }
        box { <11.9, 0.00005, 1> <13, 2.1, 4> }
        box { <11.9, 0.00005, 20> <13, 2.1, 23> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 4.5, 28> } }
    }
  #end
#end
#macro openf_winglet6_6(color_tex, age)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 3.1, 43.9> }
      box { <0, -1, -30> <30, 4, 0> rotate 45*y translate <-3.9, 0, 11.9> }
      box { <0, -1, -30> <30, 4, 0> rotate -45*y translate <27.9, 0, -3.9> }
      box { <0, -1, -30> <30, 4, 0> rotate 135*y translate <11.9, 0, 43.9> }
      box { <0, -1, -30> <30, 4, 0> rotate 225*y translate <43.9, 0, 27.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 43.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 24> }
          #else
            object { rounded_button() translate <0, 0, 16> }
            object { rounded_button() translate <0, 0, 24> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <8, 0, 32> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <16, 0, 40> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <24, 0, 40> }
            object { rounded_button() translate <32, 0, 8> }
            object { rounded_button() translate <32, 0, 32> }
            object { rounded_button() translate <40, 0, 16> }
            object { rounded_button() translate <40, 0, 24> }
          #end
        }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 24> }
        #end
        box { <4, -1, 12> <36, 4, 28> }
        box { <12, -1, 4> <28, 4, 36> }
        box { <0, -1, -30> <30, 4, 0> rotate 45*y translate <-3.9, 0, 11.9> }
        box { <0, -1, -30> <30, 4, 0> rotate -45*y translate <27.9, 0, -3.9> }
        box { <0, -1, -30> <30, 4, 0> rotate 135*y translate <11.9, 0, 43.9> }
        box { <0, -1, -30> <30, 4, 0> rotate 225*y translate <43.9, 0, 27.9> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <42.4, 2, 42.4> }
            box { <2.4, -2, 10.4> <37.4, 3, 29.4> }
            box { <10.4, -2, 2.4> <29.4, 3, 37.4> }
            box { <-4, -2, 10.400001> <3.5, 3, 12.000001> }
            box { <-4, -2, 28.000001> <3.5, 3, 29.600001> }
            box { <36.400001, -2, 10.400001> <42.400001, 3, 12.000001> }
            box { <36.400001, -2, 28.000001> <42.400001, 3, 29.600001> }
            box { <10.400001, -2, -4> <12.000001, 3, 3.5> }
            box { <10.40000, -2, 36.400001> <12.000001, 3, 42.400001> }
            box { <28.000001, -2, -4> <29.600001, 3, 3.5> }
            box { <28.000001, -2, 36.400001> <29.600001, 3, 42.400001> }
            box { <-0.5, -2, 11.5> <0.5, 3, 13.6> }
            box { <-0.5, -2, 26.4> <0.5, 3, 28.5> }
            box { <39.5, -2, 11.5> <40.5, 3, 13.6> }
            box { <39.5, -2, 26.4> <40.5, 3, 28.5> }
            box { <11.5, -2, -0.5> <13.6, 3, 0.5> }
            box { <11.5, -2, 39.5> <13.6, 3, 40.5> }
            box { <26.4, -2, -0.5> <28.5, 3, 0.5> }
            box { <26.4, -2, 39.5> <28.5, 3, 40.5> }
            box { <-3, -2, -2> <3, 3, 1.4> rotate 45*y translate <4, 0, 4> }
            box { <-3, -2, -2> <3, 3, 1.4> rotate 135*y translate <4, 0, 36> }
            box { <-3, -2, -2> <3, 3, 1.4> rotate 225*y translate <36, 0, 36> }
            box { <-3, -2, -2> <3, 3, 1.4> rotate 315*y translate <36, 0, 4> }
            box { <-0.5, -2, 1.3> <0.5, 3, 2.9> rotate 45*y translate <4, 0, 4> }
            box { <-0.5, -2, 1.3> <0.5, 3, 2.9> rotate 135*y translate <4, 0, 36> }
            box { <-0.5, -2, 1.3> <0.5, 3, 2.9> rotate 225*y translate <36, 0, 36> }
            box { <-0.5, -2, 1.3> <0.5, 3, 2.9> rotate 315*y translate <36, 0, 4> }
          }
        #end
      }
      #if (setting > 1)
        object { pin(age) translate <0, 0, 20> }
        object { pin(age) translate <40, 0, 20> }
        object { pin(age) translate <20, 0, 0> }
        object { pin(age) translate <20, 0, 40> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 4.9, 44> } }
    }
  #end
#end
#macro openf_winglet8_8(color_tex, age)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 3.1, 59.9> }
      box { <-50, -10, -50> <70, 10, 0> rotate 23.25*y translate <-4, 0, 20> }
      box { <-50, -10, 0> <70, 10, 50> rotate -23.25*y translate <-4, 0, 36> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 3.1, 59.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
          #else
            object { rounded_button() translate <32, 0, 48> }
            object { rounded_button() translate <40, 0, 48> }
            object { rounded_button() translate <48, 0, 48> }
            object { rounded_button() translate <56, 0, 48> }
            object { rounded_button() translate <16, 0, 40> }
            object { rounded_button() translate <24, 0, 40> }
            object { rounded_button() translate <32, 0, 40> }
            object { rounded_button() translate <40, 0, 40> }
            object { rounded_button() translate <8, 0, 32> }
            object { rounded_button() translate <16, 0, 32> }
            object { rounded_button() translate <24, 0, 32> }
            object { rounded_button() translate <32, 0, 32> }
            object { rounded_button() translate <8, 0, 24> }
            object { rounded_button() translate <16, 0, 24> }
            object { rounded_button() translate <24, 0, 24> }
            object { rounded_button() translate <32, 0, 24> }
            object { rounded_button() translate <16, 0, 16> }
            object { rounded_button() translate <24, 0, 16> }
            object { rounded_button() translate <32, 0, 16> }
            object { rounded_button() translate <40, 0, 16> }
            object { rounded_button() translate <32, 0, 8> }
            object { rounded_button() translate <40, 0, 8> }
            object { rounded_button() translate <48, 0, 8> }
            object { rounded_button() translate <56, 0, 8> }
            object { rounded_button() translate <0, 0, 32> }
            object { rounded_button() translate <0, 0, 24> }
          #end
        }
        box { <44.9, -1, 11.9> <60, 4, 44.1> }
        cylinder { -1*y, 4*y, 1.000001 translate <44.9, 0, 43.1> }
        cylinder { -1*y, 4*y, 1.000001 translate <44.9, 0, 12.9> }
        box { <43.9, -1, 12.9> <60, 4, 43.1> }
        box { <36.9, -1, 19.9> <60, 4, 36.1> }
        cylinder { -1*y, 4*y, 1.000001 translate <36.9, 0, 35.1> }
        cylinder { -1*y, 4*y, 1.000001 translate <36.9, 0, 20.9> }
        box { <35.9, -1, 20.9> <60, 4, 35.1> }
        box { <51.9, -1, -4> <60, 4, 4.1> }
        box { <51.9, -1, 51.9> <60, 4, 60> }
        box { <-50, -10, -50> <70, 10, 0> rotate 23.25*y translate <-4, 0, 20> }
        box { <-50, -10, 0> <70, 10, 50> rotate -23.25*y translate <-4, 0, 36> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <58.4, 2, 58.4> }
            box { <-50, -10, -50> <70, 10, 0> rotate 23.25*y translate <-2.4, 0, 20.6> }
            box { <-50, -10, 0> <70, 10, 50> rotate -23.25*y translate <-2.4, 0, 35.2> }
            box { <50.4, -1, -4> <60, 3, 5.6> }
            box { <50.4, -1, 50.4> <60, 3, 60> }
            box { <42.4, -1, 10.4> <60, 3, 45.6> }
            box { <34.4, -1, 18.4> <60, 3, 37.6> }
            box { <32, 0.25, 4.25> <51, 3, 5.6> }
            box { <32, 0.25, 50.4> <51, 3, 51.75> }
            box { <-0.5, 0.25, 18> <0.5, 3, 21.6> }
            box { <-0.5, 0.25, 34.4> <0.5, 3, 38> }
            box { <-1.5, 0.25, -0.5> <0.5, 3, 0.5> rotate 45*y translate <42.5, 0, 45.5> }
            box { <-1.5, 0.25, -0.5> <0.5, 3, 0.5> rotate 45*y translate <34.5, 0, 37.5> }
            box { <-1.5, 0.25, -0.5> <0.5, 3, 0.5> rotate -45*y translate <42.5, 0, 10.5> }
            box { <-1.5, 0.25, -0.5> <0.5, 3, 0.5> rotate -45*y translate <34.5, 0, 18.5> }
            box { <15.5, 0.25, 10> <16.5, 3, 13.6> }
            box { <15.5, 0.25, 42.4> <16.5, 3, 46> }
            box { <-8, 0.25, -0.5> <-2.5, 3, 0.5> rotate -45*y translate <8, 0, 24> }
            box { <-8, 0.25, -0.5> <-2.5, 3, 0.5> rotate -45*y translate <24, 0, 16> }
            box { <-8, 0.25, -0.5> <-2.5, 3, 0.5> rotate 45*y translate <8, 0, 32> }
            box { <-8, 0.25, -0.5> <-2.5, 3, 0.5> rotate 45*y translate <24, 0, 40> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { -1*y, 2.000001*y, 2.5 translate <32, 0, 8> }
          cylinder { -1*y, 2.000001*y, 2.5 translate <32, 0, 48> }
        #end
      }
      #if (setting > 1)
        object { pin(age) translate <44, 0, 8> }
        object { pin(age) translate <52, 0, 8> }
        object { pin(age) translate <44, 0, 48> }
        object { pin(age) translate <52, 0, 48> }
        object { ring() translate <4, 0, 28> }
        object { ring() translate <28, 0, 12> }
        object { ring() translate <36, 0, 12> }
        object { ring() translate <28, 0, 44> }
        object { ring() translate <36, 0, 44> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 20> }
        object { ring() translate <28, 0, 20> }
        object { ring() translate <12, 0, 28> }
        object { ring() translate <20, 0, 28> }
        object { ring() translate <28, 0, 28> }
        object { ring() translate <12, 0, 36> }
        object { ring() translate <20, 0, 36> }
        object { ring() translate <28, 0, 36> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 60> } }
    }
  #end
#end
#macro openhglass1_4(color_tex)
  #if (setting = 0)
    box { <-1.5, 9.5, -4> <25.5, 27.2, 0> texture { color_tex } }
  #else
    difference {
      merge {
        box { <3.4, 2, -3.499998> <20.6, 3.099999, 0.5> }
        cylinder { -3.9*z, -2.500005*z, 1.5 translate <0, 11, 0> }
        cylinder { -3.9*z, -2.500005*z, 1.5 translate <24, 11, 0> }
        box { <-0.6, 27.2, -3> <24.6, 27.700001, 0.5> }
        box { <-0.000001, 9.500001, -3.900001> <23.900001, 27.199999, -2.500001> }
        box { <-1.500001, 10.999999, -3.900002> <25.500001, 25.700001, -2.500002> }
        box { <1.9, 3.100001, -3.400001> <22.1, 8.500001, -2.500004> }
        box { <-1.600001, 8.499998, -3.400004> <25.600001, 27.2, -2.499999> }
        cylinder { -3.400002*z, -2.5*z, 3.5 translate <1.9, 8.5, 0> }
        cylinder { -3.400002*z, -2.5*z, 3.5 translate <22.1, 8.5, 0> }
        cylinder { -3.9*z, -2.5*z, 1.5 translate <0, 25.7, 0> }
        cylinder { -3.9*z, -2.5*z, 1.5 translate <24, 25.7, 0> }
        cylinder { 0*y, 2.9*y, 0.6 translate <4, 0, 0> }
        cylinder { 0*y, 2.9*y, 0.6 translate <12, 0, 0> }
        cylinder { 0*y, 2.9*y, 0.6 translate <20, 0, 0> }
      }
      cylinder { -10*z, 10*z, 0.9 translate <3, 7.5, 0> }
      cylinder { -10*z, 10*z, 0.9 translate <21, 7.5, 0> }
      texture { color_tex }
      bounded_by { box { <-6, -0.1, -4> <28, 27.3, 4> } }
    }
  #end
#end
#macro openh_block1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 0> }
          #end
        }
        cylinder { -4*x, -2.3*x, 2 translate <0, 6.5, 0> }
        box { <-4, 6.499999, -2.000001> <-2.3, 10, 2.000001> }
        cylinder { 10.3*x, 12*x, 2 translate <0, 6.5, 0> }
        box { <10.3, 6.499999, -2.000001> <12, 10, 2.000001> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 4> } }
    }
  #end
#end
#macro openh_side1_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 28.7, 3.9> }
      box { <-1.5, 9.5, -4> <25.5, 27.2, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 28.7, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
        #end
        box { <-4, 3.1, -2.4> <28, 27.2, 4> }
        box { <3.4, 0, -3> <20.6, 3.2, 0.5> }
        box { <1.9, 3.100001, -3.000001> <22.1, 5, 0> }
        cylinder { -3.000002*z, 0*z, 3.5 translate <1.9, 8.5, 0> }
        cylinder { -3.000002*z, 0*z, 3.5 translate <22.1, 8.5, 0> }
        box { <1.899999, 4.999999, -3.000003> <22.100001, 8.500001, 0> }
        box { <-1.600001, 8.499998, -3.000004> <25.600001, 27.7, -2.399999> }
        box { <-0.6, 25, -3> <24.6, 27.700001, 0.5> }
        cylinder { -4*z, -2*z, 1.5 translate <0, 11, 0> }
        cylinder { -4*z, -2*z, 1.5 translate <24, 11, 0> }
        cylinder { -4*z, -2*z, 1.5 translate <0, 25.7, 0> }
        cylinder { -4*z, -2*z, 1.5 translate <24, 25.7, 0> }
        box { <-0.000001, 9.500001, -4> <23.900001, 27.199999, -2> }
        box { <-1.500001, 10.999999, -4> <25.500001, 25.700001, -2> }
      }
      #if (setting < 3)
        cylinder { 28.6*y, 30.4*y, 2.4 }
        cylinder { 28.6*y, 30.4*y, 2.4 translate <8, 0, 0> }
        cylinder { 28.6*y, 30.4*y, 2.4 translate <16, 0, 0> }
        cylinder { 28.6*y, 30.4*y, 2.4 translate <24, 0, 0> }
      #else
        object { rounded_button() rotate -90*y translate <0, 25.6, 0> }
        object { rounded_button() rotate -90*y translate <8, 25.6, 0> }
        object { rounded_button() rotate -90*y translate <16, 25.6, 0> }
        object { rounded_button() rotate -90*y translate <24, 25.6, 0> }
      #end
      #if (setting > 1)
        difference {
          merge {
            object { pin(1) translate <4, 0, 0> }
            object { pin(1) translate <12, 0, 0> }
            object { pin(1) translate <20, 0, 0> }
          }
          cylinder { -1*y, 3*y, 0.6 translate <4, 0, 0> }
          cylinder { -1*y, 3*y, 0.6 translate <12, 0, 0> }
          cylinder { -1*y, 3*y, 0.6 translate <20, 0, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-6, -0.1, -4> <28, 30.5, 4> } }
    }
  #end
#end
#macro openleftdoor(color_tex)
  #if (setting = 0)
    box { <-27.9, 0, -3.9> <3.9, 47.9, 3.9> texture { color_tex } }
  #else
    merge {
      object { open_rounded_button() translate <0, 44.8, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 47.9, 0> }
      #end
      cylinder { -5.9*z, -3*z, 0.75 translate <-24, 21.25, 0> }
      box { <-24.000001, 20.499999, -5.900001> <-20.999999, 21.999999, -3> }
      cylinder { -5.9*z, -3*z, 0.75 translate <-21, 21.25, 0> }
      difference {
        box { <-27.9, 0, -3.9> <3.9, 47.9, 3.9> }
        #if (setting > 1)
          difference {
            box { <-23.5, 5.25, -4> <-1.5, 19, -3.4> }
            box { <-21.5, 7.25, -5> <-3.5, 17, 0> }
          }
          box { <-23.5, 23.5, -4> <-1.5, 43.5, -3.4> }
        #end
        box { <-28, -1, -4> <-3.9, 2, 4> }
        difference {
          box { <0, -1, -8> <8, 51, 0> }
          cylinder { -2*y, 50*y, 3.900001 }
        }
        difference {
          box { <-28, -1, -2.5> <0, 50, 4> }
          cylinder { -2*y, 51*y, 3.900001 }
          box { <-3.9, -2, -4> <1, 51, 0.000001> }
        }
        box { <-22.5, 24.5, -5> <-13.5, 32.5, 5> }
        box { <-22.5, 34.5, -5> <-13.5, 42.5, 5> }
        box { <-11.5, 24.5, -5> <-2.5, 32.5, 5> }
        box { <-11.5, 34.5, -5> <-2.5, 42.5, 5> }
        box { <0, 3.1, -2.500001> <-10, 46, 4> }
        cylinder { 3.100001*y, 45.999999*y, 2.500001 }
        box { <-0.000001, 3.100002, 0> <4, 45.999998, 4> }
        cylinder { -1*y, 2*y, 2.6 }
        cylinder { -5.1*z, 5*z, 0.85 translate <-24, 21.25, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-28, -0.1, -6> <4, 49.7, 4> } }
    }
  #end
#end
#macro openramp4_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
      box { <-20, -10, -20> <30, 10, 0> rotate -18.4*y translate <4, 0, -3.9> }
      box { <-20, -10, 0> <30, 10, 20> rotate 18.4*y translate <4, 0, 27.9> }
      box { <-20, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
        box { <-20, -10, -20> <30, 10, 0> rotate -18.4*y translate <4, 0, -3.9> }
        box { <-20, -10, 0> <30, 10, 20> rotate 18.4*y translate <4, 0, 27.9> }
        box { <-4, -1, 3.9> <4.1, 10, 20.1> }
        box { <-5, -1, 3.900001> <12.1, 3.2, 20.100001> }
        box { <-20, 0, -10> <40, 20, 30> texture { color_tex normal { bumping } }
          rotate -17.25*z translate <4, 9.5, 0> }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 24> }
          box { <-2.4, -1, -2.4> <4, 8.6, 2.4> }
          box { <-2.4, -1, 21.6> <4, 8.6, 26.4> }
          difference {
            box { <5.6, -1, -2.4> <26.4, 8.6, 26.4> }
            box { <-20, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 7.5, 0> }
            box { <-20, -10, -20> <30, 10, 0> rotate -18.4*y translate <4, 0, -2.6> }
            box { <-20, -10, 0> <30, 10, 20> rotate 18.4*y translate <4, 0, 26.6> }
          }
        #end
      }
      #if (setting > 1)
        box { <2.4, 0.000001, -0.5> <4.1, 8.7, 0.5> }
        box { <2.4, 0.000001, 23.5> <4.1, 8.7, 24.5> }
        difference {
          merge {
            cylinder { 3.2*y, 8.7*y, 1.5 translate <8, 0, 12> }
            box { <5, 0.000001, 3.2> <13.5, 8.7, 3.9> }
            box { <5, 0.000001, 20.1> <13.5, 8.7, 20.8> }
            box { <12.1, 0.000002, 3.400001> <13.500001, 8.7, 20.100001> }
            box { <13.4, 0.000003, 4.8> <24, 8.7, 5.5> }
            box { <13.4, 0.000003, 18.5> <24, 8.7, 19.2> }
            box { <23.3, 0.000004, 3.4> <24.000001, 8.7, 5.500001> }
            box { <23.3, 0.000004, 18.5> <24.000001, 8.7, 20.1> }
            box { <7.5, 3.2, 3.9> <8.5, 8.7, 5.5> }
            box { <7.5, 3.2, 18.5> <8.5, 8.7, 20.1> }
            box { <10.5, 3.2, 7.5> <12.1, 8.7, 8.5> }
            box { <10.5, 3.2, 15.5> <12.1, 8.7, 16.5> }
            object { high_ring() translate <20, 0, 12> }
          }
          box { <-20, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 7.5, 0> }
        }
      #end
      #if (setting < 3)
        cylinder { 9.4*y, 11.2*y, 2.4 }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 24> }
      #else
        object { rounded_button() rotate 180*y translate <0, 6.4, 0> }
        object { rounded_button() rotate 180*y translate <0, 6.4, 24> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 28> } }
    }
  #end
#end
#macro openramp6_8(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 9.5, 43.9> }
      box { <-20, 0, -10> <10, 10, 50> rotate 24.5*z translate <12, 9.5, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <59.9, 9.5, 43.9> }
          box { <-20, 0, -10> <10, 10, 50> rotate 24.5*z translate <12, 9.5, 0> }
          box { <-50, -10, -50> <0, 10, 50> rotate -63.4*y translate <12, 0, -4> }
          box { <0, -10, -50> <50, 10, 50> rotate -116.6*y translate <12, 0, 44> }
          box { <27.9, -1, 3.9> <60, 10, 35.9> }
          box { <-70, 0, -20> <0, 20, 20> rotate -41*x rotate 25.5*z translate <52, 28.7, 4> }
          box { <-70, 0, -20> <0, 20, 20> rotate 41*x rotate 25.5*z translate <52, 28.7, 36> }
          cylinder { -1*y, 2*y, 2.4 }
          cylinder { -1*y, 2*y, 2.4 translate <0, 0, 40> }
          box { <-2.5, -1, -2> <2.5, 2, 1.5> rotate 26.6*y translate <8, 0, 0> }
          box { <-2.5, -1, -1.5> <2.5, 2, 2> rotate 26.6*y translate <8, 0, 40> }
        }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 24> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 32> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 8> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 16> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 24> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 32> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 40> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <40, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <40, 0, 40> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <48, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <48, 0, 40> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <56, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <56, 0, 40> }
        #else
          object { rounded_button() translate <16, 6.4, 8> }
          object { rounded_button() translate <16, 6.4, 16> }
          object { rounded_button() translate <16, 6.4, 24> }
          object { rounded_button() translate <16, 6.4, 32> }
          object { rounded_button() translate <24, 6.4, 8> }
          object { rounded_button() translate <24, 6.4, 16> }
          object { rounded_button() translate <24, 6.4, 24> }
          object { rounded_button() translate <24, 6.4, 32> }
          object { rounded_button() translate <32, 6.4, 0> }
          object { rounded_button() translate <32, 6.4, 40> }
          object { rounded_button() translate <40, 6.4, 0> }
          object { rounded_button() translate <40, 6.4, 40> }
          object { rounded_button() translate <48, 6.4, 0> }
          object { rounded_button() translate <48, 6.4, 40> }
          object { rounded_button() translate <56, 6.4, 0> }
          object { rounded_button() translate <56, 6.4, 40> }
        #end
      }
      #if (setting > 1)
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 24> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 32> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 8> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 16> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 24> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 32> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 40> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 40> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <48, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <48, 0, 40> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <56, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <56, 0, 40> }
        difference {
          box { <0, -1, -2.4> <58.4, 8.6, 2.4> }
          box { <-70, 0, -20> <0, 20, 20> rotate -41*x rotate 25.5*z translate <52, 27.2, 4> }
          box { <-50, -10, -50> <0, 10, 50> rotate -63.4*y translate <12, 0, -2.5> }
          cylinder { 2.099998*y, 9*y, 1.5 translate <12, 0, 0> }
          cylinder { 2.099998*y, 9*y, 1.5 translate <20, 0, 0> }
          cylinder { 2.099998*y, 9*y, 1.5 translate <28, 0, 0> }
          cylinder { 2.099998*y, 9*y, 1.5 translate <36, 0, 0> }
          cylinder { 2.099998*y, 9*y, 1.5 translate <44, 0, 0> }
          cylinder { 2.099998*y, 9*y, 1.5 translate <52, 0, 0> }
          object { pin(2) translate <12, 0, 0> }
          object { pin(2) translate <20, 0, 0> }
          object { pin(2) translate <28, 0, 0> }
          object { pin(2) translate <36, 0, 0> }
          object { pin(2) translate <44, 0, 0> }
          object { pin(2) translate <52, 0, 0> }
          box { <27.75, 2, -2.5> <28.25, 9, 2.5> }
          box { <35.75, 2, -2.5> <36.25, 9, 2.5> }
          box { <43.75, 2, -2.5> <44.25, 9, 2.5> }
        }
        difference {
          box { <0, -1, 37.6> <58.4, 8.6, 42.4> }
          box { <-70, 0, -20> <0, 20, 20> rotate 41*x rotate 25.5*z translate <52, 27.2, 36> }
          box { <0, -10, -50> <50, 10, 50> rotate -116.6*y translate <12, 0, 42.5> }
          cylinder { 2.099998*y, 9*y, 1.5 translate <12, 0, 40> }
          cylinder { 2.099998*y, 9*y, 1.5 translate <20, 0, 40> }
          cylinder { 2.099998*y, 9*y, 1.5 translate <28, 0, 40> }
          cylinder { 2.099998*y, 9*y, 1.5 translate <36, 0, 40> }
          cylinder { 2.099998*y, 9*y, 1.5 translate <44, 0, 40> }
          cylinder { 2.099998*y, 9*y, 1.5 translate <52, 0, 40> }
          object { pin(2) translate <12, 0, 40> }
          object { pin(2) translate <20, 0, 40> }
          object { pin(2) translate <28, 0, 40> }
          object { pin(2) translate <36, 0, 40> }
          object { pin(2) translate <44, 0, 40> }
          object { pin(2) translate <52, 0, 40> }
          box { <27.75, 2, 37.5> <28.25, 9, 42.5> }
          box { <35.75, 2, 37.5> <36.25, 9, 42.5> }
          box { <43.75, 2, 37.5> <44.25, 9, 42.5> }
        }
        difference {
          box { <-2.4, -1, 3.6> <26.4, 8.6, 36.2> }
          box { <-20, 0, 0> <10, 10, 40> rotate 24.5*z translate <12, 7.5, 0> }
          box { <-50, -10, -50> <0, 10, 50> rotate -63.4*y translate <12, 0, -2.5> }
          box { <0, -10, -50> <50, 10, 50> rotate -116.6*y translate <12, 0, 42.5> }
          box { <-4, 2, 0> <-1, 10, 40> }
          object { high_ring() translate <4, 0.000002, 12> }
          object { high_ring() translate <12, 0.000002, 12> }
          object { high_ring() translate <20, 0.000002, 12> }
          object { high_ring() translate <4, 0.000002, 20> }
          object { high_ring() translate <12, 0.000002, 20> }
          object { high_ring() translate <20, 0.000002, 20> }
          object { high_ring() translate <4, 0.000002, 28> }
          object { high_ring() translate <12, 0.000002, 28> }
          object { high_ring() translate <20, 0.000002, 28> }
          box { <-0.5, 0.000003, 3.5> <0.5, 10, 5.6> }
          box { <7.5, 0.000003, 3.5> <8.5, 10, 5.6> }
          box { <15.5, 0.000003, 3.5> <16.5, 10, 5.6> }
          box { <23.5, 0.000003, 3.5> <24.5, 10, 5.6> }
          box { <-0.5, 0.000003, 34.4> <0.5, 10, 36.5> }
          box { <7.5, 0.000003, 34.4> <8.5, 10, 36.5> }
          box { <15.5, 0.000003, 34.4> <16.5, 10, 36.5> }
          box { <23.5, 0.000003, 34.4> <24.5, 10, 36.5> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 11.3, 44> } }
    }
  #end
#end
#macro openrightdoor(color_tex)
merge {
  object { open_rounded_button() translate <0, 44.8, 0> }
  #if (setting > 3)
    object { llogo() scale <0.65, 0.65, 0.65> translate <0, 47.9, 0> }
  #end
  cylinder { -5.9*z, -3*z, 0.75 translate <24, 21.25, 0> }
  box { <20.999999, 20.499999, -5.900001> <24.000001, 21.999999, -3> }
  cylinder { -5.9*z, -3*z, 0.75 translate <21, 21.25, 0> }
  difference {
    box { <-3.9, 0, -3.9> <27.9, 47.9, 3.9> }
    #if (setting > 1)
      difference {
        box { <1.5, 5.25, -4> <23.5, 19, -3.4> }
        box { <3.5, 7.25, -5> <21.5, 17, 0> }
      }
      box { <1.5, 23.5, -4> <23.5, 43.5, -3.4> }
    #end
    box { <3.9, -1, -4> <28, 2, 4> }
    difference {
      box { <-8, -1, -8> <0, 51, 0> }
      cylinder { -2*y, 50*y, 3.900001 }
    }
    difference {
      box { <0, -1, -2.5> <28, 50, 4> }
      cylinder { -2*y, 51*y, 3.900001 }
      box { <-1, -2, -4> <3.9, 51, 0.000001> }
    }
    box { <13.5, 24.5, -5> <22.5, 32.5, 5> }
    box { <13.5, 34.5, -5> <22.5, 42.5, 5> }
    box { <2.5, 24.5, -5> <11.5, 32.5, 5> }
    box { <2.5, 34.5, -5> <11.5, 42.5, 5> }
    box { <0, 3.1, -2.500001> <10, 46, 4> }
    cylinder { 3.100001*y, 45.999999*y, 2.500001 }
    box { <-4, 3.100002, 0> <0.000001, 45.999998, 4> }
    cylinder { -1*y, 2*y, 2.6 }
    cylinder { -5.1*z, 5*z, 0.85 translate <24, 21.25, 0> }
  }
  texture { color_tex }
  bounded_by { box { <-4, -0.1, -6> <28, 49.7, 4> } }
}
#end
#macro openslope4_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 27.9> }
      box { <-20, 0, -10> <10, 10, 30> rotate 24.5*z translate <12, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <19.9, 9.5, 27.9> }
            box { <-20, 0, -10> <10, 10, 30> rotate 24.5*z translate <12, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 24> }
          #else
            object { rounded_button() rotate 90*y translate <16, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 24> }
          #end
        }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 24> }
        #end
        difference {
          box { <-8, -1, -13> <8, 4.5, -4> }
          box { <-10, -10, -20> <0, 10, 0> rotate -40*z translate <-6.4, 0, 0> }
          box { <0, -10, -20> <10, 10, 0> rotate 40*z translate <6.4, 0, 0> }
          translate <12, 0, 7>
        }
        difference {
          box { <-8, -1, -13> <8, 4.5, -4> }
          box { <-10, -10, -20> <0, 10, 0> rotate -40*z translate <-6.4, 0, 0> }
          box { <0, -10, -20> <10, 10, 0> rotate 40*z translate <6.4, 0, 0> }
          rotate 180*y translate <12, 0, 17>
        }
        difference {
          box { <-2.4, -1, -2.4> <18.4, 8.6, 26.4> }
          box { <-20, 0, -10> <10, 10, 30> rotate 24.5*z translate <12, 7.5, 0> }
        }
      }
      #if (setting > 1)
        difference {
          merge {
            cylinder { 0.25*y, 10*y, 1.5 translate <0, 0, 4> }
            box { <-3, 0.24, 3.5> <3, 9, 4.5> }
            cylinder { 0.25*y, 10*y, 1.5 translate <0, 0, 20> }
            box { <-3, 0.24, 19.5> <3, 9, 20.5> }
            object { high_ring() translate <4, 0.000001, 12> }
            object { high_ring() translate <12, 0.000001, 12> }
            box { <3.5, 0.000001, -3.5> <4.5, 9, 5.5> }
            box { <3.500001, 0.000002, 4.5> <19, 9, 5.500001> }
            box { <3.5, 0.000003, 18.5> <4.5, 9, 27.5> }
            box { <3.500001, 0.000002, 18.500001> <19, 9, 19.5> }
            box { <3.75, 2, 5> <4.25, 9, 9.25> }
            box { <11.75, 2, 5> <12.25, 9, 9.25> }
            box { <3.75, 2, 14.75> <4.25, 9, 19> }
            box { <11.75, 2, 14.75> <12.25, 9, 19> }
          }
          box { <-20, 0, -10> <10, 10, 30> rotate 24.5*z translate <12, 7.5, 0> }
          cylinder { -1*y, 2*y, 0.7 translate <0, 0, 4> }
          cylinder { -1*y, 2*y, 0.7 translate <0, 0, 20> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.2, 28> } }
    }
  #end
#end
#macro opentwo_slope3_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 19.1, 19.9> }
      box { <-10, -1, -20> <30, 20, 0> rotate 27.5*x rotate 45*y translate <-4, 2, 12> }
      box { <-10, -1, -20> <30, 20, 0> rotate 45*y translate <-4, 0, 12> }
      box { <10, 0, -20> <20, 20, 0> rotate 32.5*x translate <0, 2, -4> }
      box { <-20, 0, 10> <0, 20, 20> rotate -32.5*z translate <-4, 2, 0> }
      box { <10, -10, -20> <20, 0.5, 0> rotate 59*x translate <0, 19.1, 12> }
      box { <-20, -10, 10> <0, 0.5, 20> rotate -59*z translate <12, 19.1, 0> }
      box { <-20, -10, -20> <20, 0.5, 0> rotate 55*x rotate 45*y translate <13.5, 19.1, 13.5> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <19.9, 19.1, 19.9> }
          box { <-20, -10, -20> <20, 0.5, 0> rotate 55*x rotate 45*y translate <13.5, 19.1, 13.5> }
        }
        #if (setting < 3)
          cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 16> }
        #else
          object { rounded_button() rotate 180*y translate <16, 16, 16> }
        #end
      }
      box { <-2.5, -1, -2.5> <2.5, 2, 1.2> rotate 45*y translate <8, 0, 0> }
      box { <-2.5, -1, -2.5> <2.5, 2, 1.2> rotate 45*y translate <0, 0, 8> }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <18.4, 18.2, 18.4> }
          box { <-10, -1, -20> <30, 20, 0> rotate 27.5*x rotate 45*y translate <-2.4, 2, 12> }
          box { <-20, -10, -20> <20, 0.5, 0> rotate 55*x rotate 45*y translate <13.5, 18.2, 13.5> }
          box { <-10, -1, -20> <30, 20, 0> rotate 45*y translate <-2.4, 0, 12> }
          box { <10, 0, -20> <20, 20, 0> rotate 32.5*x translate <0, 2, -2.5> }
          box { <-20, 0, 10> <0, 20, 20> rotate -32.5*z translate <-2.5, 2, 0> }
          box { <10, -10, -20> <20, 0.5, 0> rotate 59*x translate <0, 18.2, 12> }
          box { <-20, -10, 10> <0, 1, 20> rotate -59*z translate <12, 18.2, 0> }
          box { <11.5, -2, 3> <20, 19, 4.000001> }
          box { <11, -2, -3> <12.000001, 19, 12.000001> }
          box { <-3, -2, 11> <12.000002, 19, 12.000002> }
          box { <3, -2, 11.5> <4.000001, 19, 20> }
          box { <-0.5, -2, 11.5> <0.5, 19, 13.5> }
          box { <11.5, 9.600005, 11.000001> <20, 19, 12.000003> }
          box { <11.000001, 9.600004, 11.5> <12.000002, 19, 20> }
          box { <15.5, 9.600001, 3.5> <16.5, 19, 5.5> }
          box { <11.5, 9.600001, 7.5> <13.5, 19, 8.5> }
          box { <15.5, 9.600002, 10.5> <16.5, 19, 13.5> }
          box { <15.5, 0.000002, 2.5> <16.5, 19, 3.5> }
          box { <11.5, 0.000002, -0.5> <13.5, 19, 0.5> }
          box { <10.5, 9.600002, 15.5> <13.5, 19, 16.5> }
          box { <7.5, 9.600002, 10.5> <8.5, 19, 13.5> }
          box { <3.5, 9.600002, 15.5> <5.5, 19, 16.5> }
          box { <2.5, 0.000002, 15.5> <3.5, 19, 16.5,> }
          box { <-0.5, 0.000002, 11.5> <0.5, 19, 13.5> }
          box { <7.5, 0.000002, 10.5> <8.5, 19, 11.5> }
          box { <10.5, 0.000002, 7.5> <11.5, 19, 8.5> }
          box { <0, 0.000002, -0.5> <2, 19, 0.5> rotate -45*y translate <4, 0, 4> }
        }
        cylinder { 17*y, 20*y, 1.2 translate <16, 0, 16> }
      #end
      box { <3.9, -1, 11.9> <20, 9.6, 20> }
      box { <11.9, -1, 3.9> <20, 9.600001, 20> }
      box { <-10, -1, -20> <30, 20, 0> rotate 45*y translate <-4, 0, 12> }
      box { <10, 0, -20> <20, 20, 0> rotate 32.5*x translate <0, 2, -4> }
      box { <-20, 0, 10> <0, 20, 20> rotate -32.5*z translate <-4, 2, 0> }
      box { <10, -10, -20> <20, 0.5, 0> rotate 59*x translate <0, 19.1, 12> }
      box { <-20, -10, 10> <0, 0.5, 20> rotate -59*z translate <12, 19.1, 0> }
      box { <-10, -1, -20> <30, 20, 0> rotate 27.5*x rotate 45*y translate <-4, 2, 12> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 20.9, 20> } }
    }
  #end
#end
#macro open_engine_l(color_tex)
  #if (setting = 0)
    cone { 0*y, 15.9, 19.1*y, 8.7 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cone { 19.1*y, 8.7, 1.999999*y, 15.900001 }
          cylinder { 0*y, 2*y, 15.9 }
        }
        cylinder { -1*y, 20*y, 8 }
        #if (setting > 1)
          cylinder { -1*y, 1.999999*y, 15 }
          cone { 18.2*y, 7.7, 1.999995*y, 15.000001 }
          box { <-16, -1, -2.2> <16, 2.000002, 2.2> rotate 45*y }
          box { <-16, -1, -2.2> <16, 2.000001, 2.2> rotate 135*y }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            box { <-0.5, 0.1, -17> <0.5, 19, 17> }
            box { <-17, 0.1, -0.5> <17, 19, 0.5> }
            cylinder { 0.100001*y, 20*y, 10.2 }
          }
          merge {
            cone { 18.2*y, 7.7, 1.999995*y, 15.100001 }
            cylinder { -1*y, 2*y, 15.1 }
            inverse
          }
          cylinder { -1*y, 20*y, 7.999999 }
        }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 20.9*y, 16 } }
    }
  #end
#end
#macro palm_base(color_tex)
  #if (setting = 0)
    merge {
      box { <-7.9, 0, -7.9> <7.9, 3.1, 7.9> }
      cone { 0.000001*y, 2.3, 15.7*y, 5.5 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        lathe { cubic_spline 6, <0, 2.3>, <4.25, 2.3>, <5, 9.2>, <5.5, 16.7>, <0, 16.5>, <0, 2.3> }
        lathe { cubic_spline 5, <0, 9.2>, <3.5, 9.2>, <4, 16.7>, <0, 16.7>, <0, 9.2> }
        box { <-8, 15.7, -8> <8, 20, 8> }
        cylinder { -1*y, 8*y, 2.599999 }
      }
      difference {
        box { <-7.9, 0, -7.9> <7.9, 3.1, 7.9> }
        #if (setting > 1)
          box { <-6.5, -1, -6.5> <6.5, 2, 6.5> }
        #end
        cylinder { -1*y, 4*y, 2.599998 }
      }
      #if (setting > 1)
        object { ring() }
      #end
      object { open_rounded_button() translate <0, 5.9, 0> }
      texture { color_tex }
      bounded_by { box { <-8, -0.1, -8> <8, 15.8, 8> } }
    }
  #end
#end
#macro palm_crown(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -8*y, 9*y, 3.5 }
      cylinder { 7.4*y, 17*y, 1.5 translate <5.75, 0, 0> rotate -45*y }
      cylinder { 7.4*y, 17*y, 1.5 translate <5.75, 0, 0> rotate -135*y }
      cylinder { 7.4*y, 17*y, 1.5 translate <5.75, 0, 0> rotate -225*y }
      cylinder { 7.4*y, 17*y, 1.5 translate <5.75, 0, 0> rotate -315*y }
      texture { color_tex }
    }
  #else
    merge {
      object { open_rounded_button() translate <0, 5.9, 0> }
      difference {
        cylinder { 1.5*y, 9*y, 3.5 }
        cylinder { -2*y, 9*y, 1.5 translate <-3.125, 0, -3.125> }
        cylinder { -2*y, 9*y, 1.5 translate <-3.125, 0, 3.125> }
        cylinder { -2*y, 9*y, 1.5 translate <3.125, 0, -3.125> }
        cylinder { -2*y, 9*y, 1.5 translate <3.125, 0, 3.125> }
        cylinder { 3*y, 9*y, 1.5 }
      }
      cylinder { 7.4*y, 17*y, 1.5 translate <5.75, 0, 0> rotate -45*y }
      cylinder { 7.4*y, 17*y, 1.5 translate <5.75, 0, 0> rotate -135*y }
      cylinder { 7.4*y, 17*y, 1.5 translate <5.75, 0, 0> rotate -225*y }
      cylinder { 7.4*y, 17*y, 1.5 translate <5.75, 0, 0> rotate -315*y }
      sphere { <5.75, 7.4, 0> 1.500001 rotate -45*y }
      sphere { <5.75, 7.4, 0> 1.500001 rotate -135*y }
      sphere { <5.75, 7.4, 0> 1.500001 rotate -225*y }
      sphere { <5.75, 7.4, 0> 1.500001 rotate -315*y }
      cylinder { -5.75*x, 5.75*x, 1.500002 rotate -45*y translate <0, 7.4, 0> }
      cylinder { -5.75*x, 5.75*x, 1.500002 rotate -135*y translate <0, 7.4, 0> }
      box { <-5.749999, 7.400001, -1.500003> <5.749999, 8.899999, 1.500003> rotate -45*y }
      box { <-5.749999, 7.400001, -1.500003> <5.749999, 8.899999, 1.500003> rotate -135*y }
      cylinder { -8*y, 2*y, 1.5 }
      texture { color_tex }
      bounded_by { box { <-6, -8.1, -6> <6, 17.1, 6> } }
    }
  #end
#end
#macro palm_leaves(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 2.000001, -3.899999> <17, 3.099999, 3.899999> }
      box { <-4, -0.9, -0.000001> <50, 0, 15> rotate 17*x rotate -15*z translate <16, 3.100002, 0> }
      box { <-4, -0.900001, -15> <50, 0.000001, 0.000001> rotate -17*x rotate -15*z translate <15.999998, 3.100005, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { 2*y, 3.1*y, 3.9 }
          box { <-0.000001, 2.000001, -3.899999> <17, 3.099999, 3.899999> }
          box { <-4, -0.9, -0.000001> <50, 0, 15> rotate 17*x rotate -15*z translate <16, 3.100002, 0> }
          box { <-4, -0.900001, -15> <50, 0.000001, 0.000001> rotate -17*x rotate -15*z translate <15.999998, 3.100005, 0> }
        }
        prism {
          bezier_spline
          -20, 10, 204,
          <8, 30>, <8, 30>, <8, 3.9>, <8, 3.9>,
          <8, 3.9>, <8, 3.9>, <12.5, 3.9>, <12.5, 3.9>,
          <12.5, 3.9>, <12.5, 3.9>, <12.5, 3.9>, <12.5, 3.9>,
          <12.5, 3.9>, <12.5, 3.9>, <15.4, 9>, <17, 9>,
          <17, 9>, <17.5, 9>, <17.5, 9>, <17.5, 8.5>,
          <17.5, 8.5>, <17.5, 7.5>, <16.5, 4.7>, <16.5, 4.2>,
          <16.5, 4.2>, <16.5, 3.7>, <16.5, 3.7>, <17, 3.7>,
          <17, 3.7>, <17.5, 3.7>, <22.7, 13.5>, <28, 13.5>,
          <28, 13.5>, <28.5, 13.5>, <28.5, 13.5>, <28.5, 13>,
          <28.5, 13>, <28.5, 13>, <25.5, 4.2>, <25.5, 4.2>,
          <25.5, 4.2>, <25.5, 3.7>, <25.5, 3.7>, <26, 3.7>,
          <26, 3.7>, <26.5, 3.7>, <32.7, 13.5>, <37, 13.5>,
          <37, 13.5>, <37.5, 13.5>, <37.5, 13.5>, <37.5, 13>,
          <37.5, 13>, <37.5, 13>, <34.5, 4.2>, <34.5, 4.2>,
          <34.5, 4.2>, <34.5, 3.7>, <34.5, 3.7>, <35, 3.7>,
          <35, 3.7>, <35.5, 3.7>, <41, 12.7>, <45.5, 12.7>,
          <45.5, 12.7>, <46, 12.7>, <46, 12.7>, <46, 12.2>,
          <46, 12.2>, <46, 12.2>, <42.5, 4>, <42.5, 4>,
          <42.5, 4>, <42.5, 3.5>, <42.5, 3.5>, <43, 3.5>,
          <43, 3.5>, <43.5, 3.5>, <46.5, 7>, <51.5, 7>,
          <51.5, 7>, <52, 7>, <52, 7>, <52, 6.5>,
          <52, 6.5>, <52, 6.5>, <51, 3>, <51, 3>,
          <51, 3>, <51, 2.5>, <51, 2.5>, <51.5, 2.5>,
          <51.5, 2.5>, <52, 2.5>, <59, 1.5>, <59, 0>,
          <59, 0>, <59, -1.5>, <52, -2.5>, <51.5, -2.5>,
          <51.5, -2.5>, <51, -2.5>, <51, -2.5>, <51, -3>,
          <51, -3>, <51, -3>, <52, -6.5>, <52, -6.5>,
          <52, -6.5>, <52, -7>, <52, -7>, <51.5, -7>,
          <51.5, -7>, <46.5, -7>, <43.5, -3.5>, <43, -3.5>,
          <43, -3.5>, <42.5, -3.5>, <42.5, -3.5>, <42.5, -4>,
          <42.5, -4>, <42.5, -4>, <46, -12.2>, <46, -12.2>,
          <46, -12.2>, <46, -12.7>, <46, -12.7>, <45.5, -12.7>,
          <45.5, -12.7>, <41, -12.7>, <35.5, -3.7>, <35, -3.7>,
          <35, -3.7>, <34.5, -3.7>, <34.5, -3.7>, <34.5, -4.2>,
          <34.5, -4.2>, <34.5, -4.2>, <37.5, -13>, <37.5, -13>,
          <37.5, -13>, <37.5, -13.5>, <37.5, -13.5>, <37, -13.5>,
          <37, -13.5>, <32.7, -13.5>, <26.5, -3.7>, <26, -3.7>,
          <26, -3.7>, <25.5, -3.7>, <25.5, -3.7>, <25.5, -4.2>,
          <25.5, -4.2>, <25.5, -4.2>, <28.5, -13>, <28.5, -13>,
          <28.5, -13>, <28.5, -13.5>, <28.5, -13.5>, <28, -13.5>,
          <28, -13.5>, <22.7, -13.5>, <17.5, -3.7>, <17, -3.7>,
          <17, -3.7>, <16.5, -3.7>, <16.5, -3.7>, <16.5, -4.2>,
          <16.5, -4.2>, <16.5, -4.7>, <17.5, -7.5>, <17.5, -8.5>,
          <17.5, -8.5>, <17.5, -9>, <17.5, -9>, <17, -9>,
          <17, -9>, <15.4, -9>, <12.5, -3.9>, <12.5, -3.9>,
          <12.5, -3.9>, <12.5, -3.9>, <12.5, -3.9>, <12.5, -3.9>,
          <12.5, -3.9>, <12.5, -3.9>, <8, -3.9>, <8, -3.9>,
          <8, -3.9>, <8, -3.9>, <8, -30>, <8, -30>,
          <8, -30>, <8, -30>, <72, -30>, <72, -30>,
          <72, -30>, <72, -30>, <72, 30>, <72, 30>,
          <72, 30>, <72, 30>, <8, 30>, <8, 30>
          sturm
        }
        cylinder { 1*y, 4*y, 1.600001 }
        cylinder { 1*y, 4*y, 1.600001 translate <8, 0, 0> }
        box { <-4, 0, -10> <70, 20, 30> rotate 17*x rotate -15*z translate <16, 3.100001, 0> }
        box { <-4, -0.000001, -30> <70, 20, 10> rotate -17*x rotate -15*z translate <15.999999, 3.100004, 0> }
        box { <10.5, 3.099997, -10> <30, 10, 10> }
      }
      difference {
        merge {
          difference {
            cylinder { -6.3*y, 10*y, 3.2 }
            cylinder { -7*y, 11*y, 2.6 }
            translate <24, 0, 0>
          }
          difference {
            cylinder { -6.3*y, 10*y, 3.2 }
            cylinder { -7*y, 11*y, 2.6 }
            translate <32, 0, 0>
          }
        }
        box { <-4, 0, -10> <70, 20, 30> rotate 17*x rotate -15*z translate <16, 3.000001, 0> }
        box { <-4, 0, -30> <70, 20, 10> rotate -17*x rotate -15*z translate <16, 3.000001, 0> }
      }
      object { ring() }
      object { ring() translate <8, 0, 0> }
      object { open_rounded_button() }
      object { open_rounded_button() translate <8, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -10, -16> <59.5, 4.9, 16> } }
    }
  #end
#end
#macro palm_segment(color_tex)
  #if (setting = 0)
    merge {
      cone { 0.000001*y, 2.3, 15.7*y, 5.5 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        lathe { cubic_spline 6, <0, 2.3>, <4.25, 2.3>, <5, 9.2>, <5.5, 16.7>, <0, 16.7>, <0, 2.3> }
        lathe { cubic_spline 5, <0, 9.2>, <3.5, 9.2>, <4, 16.7>, <0, 16.7>, <0, 9.2> }
        box { <-8, 15.7, -8> <8, 20, 8> }
        box { <-8, 0, -8> <8, 3, 8> }
        cylinder { -1*y, 16*y, 1.599999 }
        cylinder { -5*y, 7.5*y, 2.6 }
      }
      difference {
        sphere { <0, 2, 0> 4 }
        box { <-8, -10, -8> <8, -0.75, 8> }
        box { <-8, 3.000001, -8> <8, 8, 8> }
        cylinder { -5*y, 16*y, 1.599998 }
        cylinder { -5.000001*y, 7.500001*y, 2.600001 }
        cylinder { -2*y, 2*y, 2 translate <-3.75, 0, -3.75> }
        cylinder { -2*y, 2*y, 2 translate <-3.75, 0, 3.75> }
        cylinder { -2*y, 2*y, 2 translate <3.75, 0, -3.75> }
        cylinder { -2*y, 2*y, 2 translate <3.75, 0, 3.75> }
      }
      object { open_rounded_button() translate <0, 5.9, 0> }
      texture { color_tex }
      bounded_by { box { <-8, -1, -8> <8, 15.8, 8> } }
    }
  #end
#end
#macro pan_1(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 5.2*y, 6.25 }
      cylinder { 6.1*x, 11.9*x, 1.5 translate <0, 3.6, 0> }
      texture { color_tex }
    }
  #else
    merge {
      object { ring() }
      difference {
        cylinder { 2*y, 5.2*y, 6.25 }
        cylinder { 3.95*y, 7*y, 5.4 }
        cylinder { 2.7*y, 7*y, 4.9 }
      }
      cylinder { 6.1*x, 11.75*x, 1.5 translate <0, 3.6, 0> }
      torus { 1.35, 0.15 rotate 90*z translate <11.75, 3.6, 0> }
      cylinder { 10*x, 11.9*x, 1.35 translate <0, 3.6, 0> }
      texture { color_tex }
      bounded_by { box { <-6.35, -0.1, -6.35> <12, 5.3, 6.35> } }
    }
  #end
#end
#macro pan_2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 10*y, 5.3 }
      cylinder { 5.2*x, 11.9*x, 1.5 translate <0, 7.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      object { ring() }
      difference {
        cylinder { 2*y, 10*y, 5.3 }
        cylinder { 5*y, 11*y, 4.15 }
      }
      cylinder { 5.2*x, 11.75*x, 1.5 translate <0, 7.5, 0> }
      torus { 1.35, 0.15 rotate 90*z translate <11.75, 7.5, 0> }
      cylinder { 10*x, 11.9*x, 1.35 translate <0, 7.5, 0> }
      texture { color_tex }
      bounded_by { box { <-5.4, -0.1, -5.4> <12, 10.1, 5.4> } }
    }
  #end
#end
#macro photo_camera(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.65*y, 3.65*y, 1.5 }
      box { <0, 0, 0> <11.2, 6.3, 5> rotate -27*x translate <2.8, -5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { -2.75*y, 2.75*y, 1.5 }
      sphere { <0, -2.75, 0> 0.9 }
      sphere { <0, 2.75, 0> 0.9 }
      cylinder { -0.000001*x, 3*x, 0.899999 translate <0, -2.75, 0> }
      cylinder { -0.000001*x, 3*x, 0.899999 translate <0, 2.75, 0> }
      merge {
        difference {
          box { <0, 0, 0> <11.2, 6.3, 5> }
          cylinder { -1*z, 0.6*z, 0.5 translate <1.2, 1.2, 0> }
          cylinder { -1*z, 0.6*z, 0.5 translate <9, 1.2, 0> }
          cylinder { -1*z, 0.6*z, 0.5 translate <9, 3.2, 0> }
          cylinder { -1*z, 0.6*z, 0.5 translate <8.1, 5.2, 0> }
          cylinder { -1*z, 0.6*z, 0.5 translate <9.9, 5.2, 0> }
          box { <8.099999, 4.700001, -1> <9.900001, 5.700001, 0.600001> }
          #if (setting > 1)
            cylinder { -1*y, 6*y, 1.25 translate <2.2, 0, 2.5> }
            cylinder { -1*y, 6*y, 1.25 translate <9, 0, 2.5> }
            cylinder { -1*y, 6.000001*y, 1.5 translate <5.6, 0, 2.5> }
            box { <2.199999, -1, 1.2499999> <9.000001, 6.000002, 3.750001> }
          #end
        }
        difference {
          box { <-0.000001, 6, 2> <6, 8.75, 5.000001> }
          box { <1, 6.299999, 1> <4, 7.8, 6> }
          box { <0, 0, 1> <5, 5, 6> rotate 20*z translate <6, 6.3, 0> }
          box { <-5, 0, -5> <7, 5, 0> rotate 20*x translate <2, 6.3, 2> }
        }
        object { open_rounded_button() rotate -90*x translate <4.5, 3, 3.1> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <4.5, 3, 0> }
        #end
        cylinder { 6*y, 7.5*y, 1 translate <8.75, 0, 3> }
        rotate -27*x
        translate <2.8, -5, 0>
      }
      texture { color_tex }
      bounded_by { box { <-1.6, -5.5, -5> <14.1, 5.5, 5> } }
    }
  #end
#end
#macro pick_axe(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -0.75*y, 28*y, 1.5 }
      box { <-12.5, 27.5, -1.65> <12.5, 31.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { 0*y, 28*y, 1.5 }
        box { <-2, 0, -2> <2, 10, 0> rotate 2*x translate <0, 18.75, -1.5> }
        box { <-2, 0, 0> <2, 10, 2> rotate -2*x translate <0, 18.75, 1.5> }
      }
      sphere { <0, 0, 0> 1.499999 scale <1, 0.5, 1> }
      box { <-2.1, 26.7, -1.35> <2.1, 31.5, 1.35> }
      box { <-1.75, 31.4, -1> <1.75, 31.8, 1> }
      difference {
        merge {
          difference {
            cylinder { -3*z, 3*z, 23.5 translate <0, 8, 0> }
            box { <0, -20, -6> <100, 39, 6> }
          }
          difference {
            cylinder { -1.5*z, 1.5*z, 4 scale <3, 1, 1> translate <0, 27.5, 0> }
            box { <-20, -20, -5> <0, 39, 5> }
          }
        }
        box { <-10, -101, 0> <40, 40, 4> rotate -1.5*y translate <-12, 0, 0.6> }
        box { <-10, -101, -4> <40, 40, 0> rotate 1.5*y translate <-12, 0, -0.6> }
        box { <0, -101, 0> <40, 40, 4> rotate -2.5*y translate <0, 0, 0.6> }
        box { <0, -101, -4> <40, 40, 0> rotate 2.5*y translate <0, 0, -0.6> }
        box { <-100, -100, -4> <100, 27.5, 4> }
        box { <-100, -100, -10> <100, -2, 10> }
        difference {
          box { <-10, -0.1, -4> <0, 2, 4> }
          cylinder { -4*z, 4*z, 0.75 }
          translate <-11.75, 27.55, 0>
        }
      }
      texture { color_tex }
      bounded_by { box { <-12.6, -0.85, -1.6> <12.6, 31.9, 1.6> } }
    }
  #end
#end
#macro pirate_hand(color_tex)
merge {
  cylinder { 0*z, -1*z, 1.8 }
  cylinder { -0.1*z, -1.15*z, 1.65 }
  torus { 1.65, 0.15 rotate 90*x translate <0, 0, -0.999999> }
  cylinder { -0.5*z, -1*z, 1.65 }
  cylinder { -3*z, -1*z, 1.05 scale <1, 0.75, 1> }
  difference {
    merge {
      torus { 2, 0.75 }
      cylinder { -0.750001*y, 0.750001*y, 2.000001 }
    }
    cylinder { -1*y, 1*y, 1.5 }
    box { <-10, -1, -1.4> <0.25, 1, 1.4> rotate 17.5*y }
    box { <-10, -1, -1.4> <0.25, 1, 1.4> rotate 12.5*y }
    difference {
      box { <-2, -2, 3.5> <0, 2, 0> }
      cylinder { 0*z, 3.75*z, 1.050001 scale <1, 0.75, 1> }
    }
    translate <0, 0, -4.75>
  }
  texture { color_tex }
  bounded_by { box { <-2.85, -2.25, -7.6> <2.85, 2.25, 0.1> } }
}
#end
#macro pirate_leg(color_tex)
  #if (setting = 0)
    cylinder { -11*y, 3.5*y, 1.9 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          difference {
            cylinder { -7.800001*x, -0.9*x, 3.5 }
            difference {
              box { <-8, -1, -10> <0, 10, 10> }
              cylinder { -9*x, 1*x, 1 translate <0, -1, -2.5> }
              cylinder { -9*x, 1*x, 1 translate <0, -1, 2.5> }
              cylinder { -7.800002*x, 0.900001*x, 3.5 scale <1, 1, 0.75714285> }
            }
          }
        }
        difference {
          box { <-8, -5, -5> <-4.3, 0, 5> }
          cylinder { -6*z, 6*z, 3.5 translate <-4.3, 0, 0> }
        }
      }
      difference {
        merge {
          cylinder { -11*y, -9*y, 3.2 }
          torus { 2, 1.2 translate <0, -9, 0> }
        }
        cylinder { -12*y, -9*y, 2.6 }
        translate <-4, 0, 0>
      }
      cone { -9*y, 1.5, -3*y, 1.9 translate <-4, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-7.9, -11.1, -4.5> <0, 3.6, 3.6> } }
    }
  #end
#end
#macro pivotconnect23(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 13.5*x, 3.9 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { -4*x, 14*x, 3.9 }
        difference {
          box { <9.6, -5, -5> <14.5, 5, 5> }
          cylinder { -6*z, 6*z, 3.900001 translate <9.600001, 0, 0> }
        }
        difference {
          box { <-5, -5, -5> <0, 5, 5> }
          cylinder { -6*y, 6*y, 3.900001 }
        }
        box { <5.5, 2.35, -6> <14.5, 0.65, 6> rotate 90*x }
        box { <5.5, -2.35, -6> <14.5, -0.65, 6> rotate 90*x }
        box { <-4, 2.25, -6> <4.1, 10, 6> }
        box { <-4, -0.85, -6> <4.1, 0.85, 6> }
        box { <-4, -2.25, -6> <4.1, -10, 6> }
        box { <13.5, -1, -6> <15, 1, 6> }
        cylinder { 1.75*y, 3.25*y, 1 }
        cylinder { -1.75*y, -3.25*y, 1 }
        cylinder { 2*y, 4*y, 1.4 }
        cylinder { -2*y, -4*y, 1.4 }
        box { <-4, 1.75, -1.4> <0, 4, 1.4> }
        box { <-4, -1.75, -1.4> <0, -4, 1.4> }
      }
      cylinder { 2.1*z, 2.4*z, 0.9 translate <9.6, 0, 0> }
      cylinder { -2.1*z, -2.4*z, 0.9 translate <9.6, 0, 0> }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 13.6*x, 4 } }
    }
  #end
#end
#macro pivot_claw(color_tex)
  #if (setting = 0)
    merge {
      sphere { <0, 0, 0> 2.8 }
      cylinder { 0*x, -8*x, 1.55 }
      cylinder { -1.550001*y, 1.550001*y, 3.9 translate <-8, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        sphere { <0, 0, 0> 2.8 }
        cylinder { 0*x, -8*x, 1.55 }
        cylinder { -1.550001*y, 1.550001*y, 3.9 translate <-8, 0, 0> }
        object { open_rounded_button() translate <-8, -1.55, 0> }
      }
      cylinder { -2*y, 4*y, 1.600001 translate <-8, 0, 0> }
      cylinder { -2*y, 0.55*y, 2.5 translate <-8, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-12, -2.9, -4> <2.9, 3.35, 4> } }
    }
  #end
#end
#macro popsicle(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 7*y, 1.5 }
      box { <-3.9, 6, -1.5> <3.9, 15.1, 1.5> } 
      cylinder { -1.5*z, 1.5*z, 3.9 translate <0, 15.1, 0> }
      texture { color_tex }
    }
  #else
    merge {
      torus { 1.35, 0.15 translate <0, 0.15, 0> }
      cylinder { 0.15*y, 6.9*y, 1.500001 }
      cylinder { 0*y, 7*y, 1.35 }
      box { <-3, 6, -0.6> <3, 15.100002, 0.6> }
      box { <-3.9, 6.900001, -0.600001> <3.9, 15.100001, 0.600001> }
      box { <-3, 6.9, -1.5> <3, 15.100003, 1.5> }
      cylinder { 6.9*y, 15.1*y, 0.9 translate <-3, 0, -0.6> }
      cylinder { 6.9*y, 15.1*y, 0.9 translate <-3, 0, 0.6> }
      cylinder { 6.9*y, 15.1*y, 0.9 translate <3, 0, -0.6> }
      cylinder { 6.9*y, 15.1*y, 0.9 translate <3, 0, 0.6> }
      sphere { <-3, 6.9, -0.6> 0.9 }
      sphere { <-3, 6.9, 0.6> 0.9 }
      sphere { <3, 6.9, -0.6> 0.9 }
      sphere { <3, 6.9, 0.6> 0.9 }
      cylinder { -3*x, 3*x, 0.9 translate <0, 6.9, -0.6> }
      cylinder { -3*x, 3*x, 0.9 translate <0, 6.9, 0.6> }
      cylinder { -0.6*z, 0.6*z, 0.9 translate <-3, 6.9, 0> }
      cylinder { -0.6*z, 0.6*z, 0.9 translate <3, 6.9, 0> }
      cylinder { -1.500005*z, 1.500005*z, 3 translate <0, 15.1, 0> }
      cylinder { -0.600005*z, 0.600005*z, 3.9 translate <0, 15.1, 0> }
      torus { 3, 0.9 rotate 90*x translate <0, 15.1, -0.6> }
      torus { 3, 0.9 rotate 90*x translate <0, 15.1, 0.6> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -1.6> <4, 19, 1.6> } }
    }
  #end
#end   
#macro propellor_s(color_tex)
  #if (setting = 0)
    merge {
      box { <-1.8, -13.2, -0.6> <1.8, -1.8, 0.6> }
      box { <-1.8, -13.2, -0.6> <1.8, -1.8, 0.6> rotate 120*z }
      box { <-1.8, -13.2, -0.6> <1.8, -1.8, 0.6> rotate 240*z }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { -2*z, 2*z, 3.1 }
        cylinder { -3*z, 3*z, 1.6 }
      }
      #local counter = 0;
      #while (counter < 3)
      merge {
        cylinder { -13.200001*y, -1.8*y, 0.6 translate <-1.8, 0, 0> }
        cylinder { -13.200001*y, -1.8*y, 0.6 translate <1.8, 0, 0> }
        box { <-1.800001, -13.200002, -0.600001> <1.800001, -1.800001, 0.600001> }
        cylinder { -0.600003*z, 0.600003*z, 1.799999 translate <0, -13.2, 0> }
        torus { 1.8, 0.6 rotate <-90, 0, 0> translate <0, -13.199999, 0> }
        rotate <0, -14.5, (counter*120)>
      }
      #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { box { <-15.7, -15.7, -3.2> <15.7, 15.7, 3.2> } }
    }
  #end
#end
#macro pulley(color_tex)
  #if (setting = 0)
    cylinder { -3*z, 12*z, 3 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -3*z, 12*z, 3 }
        cylinder { -2.4*z, -1*z, 5.5 }
        cylinder { 9*z, 10.4*z, 5.5 }
      }
      cylinder { -4*y, 4*y, 1.25 translate <0, 0, 1> }
      #local counter = 0;
      #while (counter < 32)
        box { <-0.5, -0.5, -4> <0.5, 2, 13> rotate 45*z translate <0, 5.5, 0> rotate (counter*11.25)*z }
        #local counter = counter + 1;
      #end
      cylinder { 7.5*z, 13*z, 2.5 }
      cylinder { -4*z, 2.5*z, 2.5 }
      box { <-2.25, -0.9, -4> <2.25, 0.9, 13> }
      box { <-0.9, -2.25, -4> <0.9, 2.25, 13> }
      texture { color_tex }
      bounded_by { cylinder { -3.1*z, 12.1*z, 5.6 } }
    }
  #end
#end
#macro pulley_holder2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 17.25, 11.9> }
      box { <-4, 3.1, -2.5> <12, 18, 10.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
        #if (setting > 1)
          box { < -2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { -1*y, 4*y, 2.600001 translate <4, 0, 4> }
        #end
      }
      difference {
        merge {
          cylinder { -3.900002*z, 11.900002*z, 5 translate <4, 12.25, 0> }
          box { <-3.900001, 3, -3.900001> <11.900001, 14, 11.900001> }
        }
        box { <-15, -11, -4> <-5, 1, 12> rotate -16.1*z translate <4, 12.25, 0> }
        box { <5, -11, -4> <15, 1, 12> rotate 16.1*z translate <4, 12.25, 0> }
        box { <-4, 3.100001, -2.5> <12, 19, 10.5> }
        cylinder { -1*y, 4*y, 2.600001 translate <4, 0, 4> }
        cylinder { -4*z, 12*z, 3.25 translate <4, 12.25, 0> }
      }
      #if (setting > 1)
        box { <3.5, 3, -3> <4.5, 6.3, -1> }
        box { <3.5, 3, 9> <4.5, 6.3, 11> }
        object { ring() translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 17.35, 12> } }
    }
  #end
#end
#macro quay_piece(color_tex)
  #if (setting = 0)
    difference {
      box { <-2.4, -1, -2.4> <122.4, 21.4, 122.4> }
      box { <-4, 17.6, -4> <124, 24, 13.5> }
      box { <-4, 17.6, 106.5> <124, 24, 124> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <123.9, 22.3, 123.9> }
          box { <-4, 22.299999, -4> <124, 24, 124>
            texture { color_tex finish { reflection 0 } normal { bumping scale <0.5, 0.5, 0.5> } } }
          box { <-4, 19.1, -4> <124, 24, 12.1> }
          box { <-4, 19.1, 107.9> <124, 24, 124> }
          box { <27.9, -1, -4> <36.1, 24, 4.1> }
          box { <27.9, -1, 115.9> <36.1, 24, 124> }
          box { <83.9, -1, -4> <92.1, 24, 4.1> }
          box { <83.9, -1, 115.9> <92.1, 24, 124> }
          box { <-4, -1, 27.9> <4.1, 19.2, 36.1> }
          box { <-4, -1, 83.9> <4.1, 19.2, 92.1> }
          box { <115.9, -1, 27.9> <124, 19.2, 36.1> }
          box { <115.9, -1, 83.9> <124, 19.2, 92.1> }
          box { <-4, -1, -4> <12.1, 3.2, 12.1> }
          box { <-4, -1, 107.9> <12.1, 3.2, 124> }
          box { <107.9, -1, -4> <124, 3.2, 12.1> }
          box { <107.9, -1, 107.9> <124, 3.2, 124> }
          #if (setting > 1)
            difference {
              box { <-2.4, -1, -2.4> <122.4, 21.4, 122.4> }
              box { <-4, 17.6, -4> <124, 24, 13.5> }
              box { <-4, 17.6, 106.5> <124, 24, 124> }
              box { <26.4, -2, -4> <37.6, 24, 5.6> }
              box { <82.4, -2, -4> <93.6, 24, 5.6> }
              box { <26.4, -2, 114.4> <37.6, 24, 124> }
              box { <82.4, -2, 114.4> <93.6, 24, 124> }
              difference {
                box { <-4, 0, -4> <12.099999, 24, 12.099999> }
                box { <-2.4, -1, -2.4> <10.4, 25, 10.4> }
              }
              difference {
                box { <-4, 0, 107.900001> <12.099999, 24, 124> }
                box { <-2.4, -1, 109.6> <10.5, 25, 122.4> }
              }
              difference {
                box { <107.900001, 0, -4> <124, 24, 12.099999> }
                box { <109.4, -1, -2.4> <122.4, 25, 10.4> }
              }
              difference {
                box { <107.900001, 0, 107.900001> <124, 24, 124> }
                box { <109.4, -1, 109.6> <122.4, 25, 122.4> }
              }
              difference {
                box { <-4, -1, 26.6> <5.6, 24, 37.4> }
                box { <-5, -2, 27.9> <4.1, 25, 36.1> }
              }
              difference {
                box { <-4, -1, 82.6> <5.6, 24, 93.4> }
                box { <-5, -2, 83.9> <4.1, 25, 91.1> }
              }
              difference {
                box { <114.4, -1, 26.6> <124, 24, 37.4> }
                box { <115.9, -2, 27.9> <125, 25, 36.1> }
              }
              difference {
                box { <114.4, -1, 82.6> <124, 24, 93.4> }
                box { <115.9, -2, 83.9> <125, 25, 91.1> }
              }
            }
          #end
        }
        #local teller = 0;
        #while (teller < 16)
          #local counter = 0;
          #while (counter < 16)
            #if (setting < 3)
              cylinder { 19*y, 20.8*y, 2.4 translate <(teller*8), 0, (counter*8)> }
            #else
              object { rounded_button() translate <(teller*8), 16, (counter*8)> }
            #end
            #local counter = counter + 1;
            #if (counter = 2)
              #local counter = 14;
            #end
          #end
          #local teller = teller + 1;
        #end
        #if (setting > 1)
          difference {
            cylinder { 3.2*y, 17.7*y, 3.2 }
            cylinder { 3*y, 18*y, 2.6 }
            translate <4, 0, 4>
          }
          difference {
            cylinder { 3.2*y, 17.7*y, 3.2 }
            cylinder { 3*y, 18*y, 2.6 }
            translate <4, 0, 116>
          }
          difference {
            cylinder { 3.2*y, 17.7*y, 3.2 }
            cylinder { 3*y, 18*y, 2.6 }
            translate <116, 0, 4>
          }
          difference {
            cylinder { 3.2*y, 17.7*y, 3.2 }
            cylinder { 3*y, 18*y, 2.6 }
            translate <116, 0, 116>
          }
          box { <-0.5, 19.2, 27> <0.5, 22.1, 29.5> }
          box { <-0.5, 19.2, 34.5> <0.5, 22.1, 37> }
          box { <-0.5, 19.2, 83> <0.5, 22.1, 85.5> }
          box { <-0.5, 19.2, 90.5> <0.5, 22.1, 93> }
          box { <2.5, 19.2, 31.5> <5, 22.1, 32.5> }
          box { <115, 19.2, 31.5> <117.5, 22.1, 32.5> }
          box { <119.5, 19.2, 27> <120.5, 22.1, 29.5> }
          box { <119.5, 19.2, 34.5> <120.5, 22.1, 37> }
          box { <119.5, 19.2, 83> <120.5, 22.1, 85.5> }
          box { <119.5, 19.2, 90.5> <120.5, 22.1, 93> }
          box { <2.5, 19.2, 87.5> <5, 22.1, 88.5> }
          box { <115, 19.2, 87.5> <117.5, 22.1, 88.5> }
          difference {
            box { <43.9, 0, 43.9> <76.1, 21.5, 76.1> }
            box { <45.4, -1, 45.4> <74.6, 22, 74.6> }
          }
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while (teller < 16)
          #local counter = 0;
          #while (counter < 16)
            cylinder { 17*y, 20*y, 1.2 translate <(teller*8), 0, (counter*8)> }
            #local counter = counter + 1;
            #if (counter = 2)
              #local counter = 14;
            #end
          #end
          #local teller = teller + 1;
        #end
      #end
      box { <27.900001, -1, -4> <36.099999, 24, 4.100001> }
      box { <27.900001, -1, 115.9> <36.099999, 24, 123.999999> }
      box { <83.900001, -1, -4> <92.099999, 24, 4.100001> }
      box { <83.900001, -1, 115.9> <92.099999, 24, 123.999999> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <124, 22.4, 124> } }
    }
  #end
#end
#macro quay_slope_piece(color_tex)
  #if (setting = 0)
    difference {
      box { <-2.4, -1, -2.4> <122.4, 21.4, 122.4> }
      box { <-4, 17.6, -4> <124, 24, 13.5> }
      box { <-4, 17.6, 106.5> <124, 24, 124> }
      box { <-150, 0, 12.099998> <0, 30, 107.900002> rotate 9.5*z translate <109, 22.3, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <123.9, 22.3, 123.9> }
          box { <-4, 22.299999, -4> <124, 24, 124>
            texture { color_tex finish { reflection 0 } normal { bumping scale <0.5, 0.5, 0.5> } } }
          box { <-150, 0, 12.099999> <0, 1, 107.900001> rotate 9.5*z translate <109, 22.3, 0>
            texture { color_tex finish { reflection 0 } normal { bumping scale <0.5, 0.5, 0.5> } } }
          box { <-150, 0.005, 12.099998> <0, 30, 107.900002> rotate 9.5*z translate <109, 22.3, 0> }
          box { <-4, 19.1, -4> <124, 24, 12.1> }
          box { <-4, 19.1, 107.9> <124, 24, 124> }
          box { <27.9, -1, -4> <36.1, 24, 4.1> }
          box { <27.9, -1, 115.9> <36.1, 24, 124> }
          box { <83.9, -1, -4> <92.1, 24, 4.1> }
          box { <83.9, -1, 115.9> <92.1, 24, 124> }
          box { <-4, -1, -4> <12.1, 3.2, 12.1> }
          box { <-4, -1, 107.9> <12.1, 3.2, 124> }
          box { <107.9, -1, -4> <124, 3.2, 12.1> }
          box { <107.9, -1, 107.9> <124, 3.2, 124> }
          box { <115.9, -1, 27.9> <124, 19.2, 36.1> }
          box { <115.9, -1, 83.9> <124, 19.2, 92.1> }
          #if (setting > 1)
            difference {
              box { <-2.4, -1, -2.4> <122.4, 21.4, 122.4> }
              box { <-150, 0, 10.500001> <0, 30, 109.499999> rotate 9.5*z translate <109, 21.4, 0> }
              box { <-4, 17.6, -4> <124, 24, 13.5> }
              box { <-4, 17.6, 106.5> <124, 24, 124> }
              box { <26.4, -2, -4> <37.6, 24, 5.6> }
              box { <82.4, -2, -4> <93.6, 24, 5.6> }
              box { <26.4, -2, 114.4> <37.6, 24, 124> }
              box { <82.4, -2, 114.4> <93.6, 24, 124> }
              difference {
                box { <-4, 0, -4> <12.099999, 24, 12.099999> }
                box { <-2.4, -1, -2.4> <10.4, 25, 10.4> }
              }
              difference {
                box { <-4, 0, 107.900001> <12.099999, 24, 124> }
                box { <-2.4, -1, 109.6> <10.5, 25, 122.4> }
              }
              difference {
                box { <107.900001, 0, -4> <124, 24, 12.099999> }
                box { <109.4, -1, -2.4> <122.4, 25, 10.4> }
              }
              difference {
                box { <107.900001, 0, 107.900001> <124, 24, 124> }
                box { <109.4, -1, 109.6> <122.4, 25, 122.4> }
              }
              difference {
                box { <114.4, -1, 26.6> <124, 24, 37.4> }
                box { <115.9, -2, 27.9> <125, 25, 36.1> }
              }
              difference {
                box { <114.4, -1, 82.6> <124, 24, 93.4> }
                box { <115.9, -2, 83.9> <125, 25, 91.1> }
              }
            }
          #end
        }
        #local teller = 0;
        #while (teller < 16)
          #local counter = 0;
          #while (counter < 16)
            #if (setting < 3)
              cylinder { 19*y, 20.8*y, 2.4 translate <(teller*8), 0, (counter*8)> }
            #else
              object { rounded_button() translate <(teller*8), 16, (counter*8)> }
            #end
            #local counter = counter + 1;
            #if (counter = 2)
              #local counter = 14;
            #end
          #end
          #local teller = teller + 1;
        #end
        #if (setting > 1)
          difference {
            cylinder { 3.2*y, 17.7*y, 3.2 }
            cylinder { 3*y, 18*y, 2.6 }
            translate <4, 0, 4>
          }
          difference {
            cylinder { 3.2*y, 17.7*y, 3.2 }
            cylinder { 3*y, 18*y, 2.6 }
            translate <4, 0, 116>
          }
          difference {
            cylinder { 3.2*y, 17.7*y, 3.2 }
            cylinder { 3*y, 18*y, 2.6 }
            translate <116, 0, 4>
          }
          difference {
            cylinder { 3.2*y, 17.7*y, 3.2 }
            cylinder { 3*y, 18*y, 2.6 }
            translate <116, 0, 116>
          }
          difference {
            box { <43.9, 0, 43.9> <76.1, 21.5, 76.1> }
            box { <45.4, -1, 45.4> <74.6, 22, 74.6> }
            box { <-150, 0, 12.100001> <0, 30, 107.899999> rotate 9.5*z translate <109, 21.4, 0> }
          }
          box { <115, 19.2, 31.5> <117.5, 22.1, 32.5> }
          box { <119.5, 19.2, 27> <120.5, 22.1, 29.5> }
          box { <119.5, 19.2, 34.5> <120.5, 22.1, 37> }
          box { <119.5, 19.2, 83> <120.5, 22.1, 85.5> }
          box { <119.5, 19.2, 90.5> <120.5, 22.1, 93> }
          box { <115, 19.2, 87.5> <117.5, 22.1, 88.5> }
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while (teller < 16)
          #local counter = 0;
          #while (counter < 16)
            cylinder { 17*y, 20*y, 1.2 translate <(teller*8), 0, (counter*8)> }
            #local counter = counter + 1;
            #if (counter = 2)
              #local counter = 14;
            #end
          #end
          #local teller = teller + 1;
        #end
      #end
      box { <27.900001, -1, -4> <36.099999, 24, 4.100001> }
      box { <27.900001, -1, 115.9> <36.099999, 24, 123.999999> }
      box { <83.900001, -1, -4> <92.099999, 24, 4.100001> }
      box { <83.900001, -1, 115.9> <92.099999, 24, 123.999999> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <124, 22.4, 124> } }
    }
  #end
#end
#macro radiator(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 11.3, 3.9> }
      cylinder { -3.900001*z, 3.900001*z, 7.9 translate <4, 11.299999, 0> }
      cylinder { -3.900001*z, -0.8*z, 3.2 translate <-8, 8.7, 0> }
      cylinder { -3.900001*z, -0.8*z, 3.2 translate <16, 8.7, 0> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
      #end
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 11.3, 3.9> }
          cylinder { -3.900001*z, 3.900001*z, 7.9 translate <4, 11.299999, 0> }
        }
        sphere { <4, 1.55, -8.5> 5 }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
        #end
        cylinder { -2*z, 4*z, 6.3 translate <4, 11.3, 0> }
        box { <-2.4, 3.1, -2.000001> <10.4, 11.300001, 4> }
        cylinder { -4*z, -2.4*z, 6.3 translate <4, 11.3, 0> }
        box { <-2.4, 3.1, -4> <10.4, 11.300001, -2.400001> }
      }
      box { <3.25, 3, -3.4> <3.75, 18, -2.5> }
      box { <2.25, 3, -3.4> <2.75, 18, -2.5> }
      box { <1.25, 3, -3.4> <1.75, 18, -2.5> }
      box { <0.25, 3, -3.4> <0.75, 17, -2.5> }
      box { <-0.75, 3, -3.4> <-0.25, 16, -2.5> }
      box { <-1.75, 3, -3.4> <-1.25, 15, -2.5> }
      box { <4.25, 3, -3.4> <4.75, 18, -2.5> }
      box { <5.25, 3, -3.4> <5.75, 18, -2.5> }
      box { <6.25, 3, -3.4> <6.75, 18, -2.5> }
      box { <7.25, 3, -3.4> <7.75, 17, -2.5> }
      box { <8.25, 3, -3.4> <8.75, 16, -2.5> }
      box { <9.25, 3, -3.4> <9.75, 15, -2.5> }
      object { open_rounded_button() translate <4, 16, 0> }
      difference {
        cylinder { 18.7*y, 19.100001*y, 2.400001 }
        cylinder { 18*y, 20*y, 1.600001 }
        translate <4, 0, 0>
      }
      sphere { <-8, 8.7, 0> 1.55 }
      difference {
        cylinder { -3.900001*z, -0.8*z, 3.2 }
        cylinder { -4*z, -1.9*z, 2.6 }
        translate <-8, 8.7, 0>
      }
      cylinder { -8*x, -3.5*x, 1.55 translate <0, 8.7, 0> }
      box { <-5.5, 8, -3.900002> <-3.5, 9.4, 0> }
      sphere { <16, 8.7, 0> 1.55 }
      difference {
        cylinder { -3.900001*z, -0.8*z, 3.2 }
        cylinder { -4*z, -1.9*z, 2.6 }
        translate <16, 8.7, 0>
      }
      cylinder { 11.5*x, 16*x, 1.55 translate <0, 8.7, 0> }
      box { <11.5, 8, -3.900002> <13.5, 9.4, 0> }
      #if (setting > 3)
        object { llogo() scale <0.75, 0.75, 0.75> translate <4, 19.1, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-11.35, -0.1, -4> <19.35, 20.9, 4> } }
    }
  #end
#end
#macro ramp4_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 27.9> }
      box { <-20, 0, -10> <20, 10, 30> rotate 25.25*z translate <12, 9.5, 0> }
      box { <-20, -20, -20> <30, 20, 0> rotate 46.5*x translate <0, 9.5, 4> }
      box { <-20, -20, 0> <30, 20, 20>  rotate -46.5*x translate <0, 9.5, 20> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting < 3)
        cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
      #else
        object { rounded_button() rotate 180*y translate <16, 6.4, 8> }
        object { rounded_button() rotate 180*y translate <16, 6.4, 16> }
      #end
      difference {
        box { <-3.9, 0, -3.9> <19.9, 9.5, 27.9> }
        box { <-20, 0, -10> <20, 10, 30> texture { color_tex normal { bumping } }
          rotate 25.25*z translate <12, 9.5, 0> }
        box { <-20, -20, -20> <30, 20, 0> texture { color_tex normal { bumping } }
          rotate 46.5*x translate <0, 9.5, 4> }
        box { <-20, -20, 0> <30, 20, 20> texture { color_tex normal { bumping } }
          rotate -46.5*x translate <0, 9.5, 20> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <18.4, 8.6, 2.4> }
            box { <-20, 0, -20> <20, 20, 30> rotate 24.5*z translate <12, 7.5, 0> }
            box { <-20, -20, -20> <30, 20, 0> rotate 46.5*x translate <0, 7.5, 4> }
          }
          difference {
            box { <-2.4, -1, 21.6> <18.5, 8.6, 26.4> }
            box { <-20, 0, -20> <20, 20, 30> rotate 24.5*z translate <12, 7.5, 0> }
            box { <-20, -20, 0> <30, 20, 20> rotate -46.5*x translate <0, 7.5, 20> }
          }
          difference {
            box { <-2.4, -1, 3.9> <2.4, 8.6, 20.1> }
            box { <-20, 0, -20> <20, 20, 30> rotate 24.5*z translate <12, 7.5, 0> }
          }
          difference {
            box { <3.9, -1, 3.9> <20, 8.6, 20.1> }
            box { <-20, 0, -20> <20, 20, 30> rotate 24.5*z translate <12, 7.5, 0> }
            box { <12, 6.3, 3> <21, 9, 21> }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
          box { <13.6, 5, 3.9> <18.4, 8.6, 20.1> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            cylinder { 0.00001*y, 8.6*y, 1.5 translate <4, 0, 0> }
            cylinder { 0.00001*y, 8.6*y, 1.5 translate <12, 0, 0> }
          }
          box { <-20, 0, -20> <20, 20, 30> rotate 24.5*z translate <12, 7.5, 0> }
          box { <-20, -20, -20> <30, 20, 0> rotate 46.5*x translate <0, 7.5, 4> }
        }
        difference {
          merge {
            cylinder { 0.00001*y, 8.6*y, 1.5 translate <4, 0, 24> }
            cylinder { 0.00001*y, 8.6*y, 1.5 translate <12, 0, 24> }
          }
          box { <-20, 0, -20> <20, 20, 30> rotate 24.5*z translate <12, 7.5, 0> }
          box { <-20, -20, 0> <30, 20, 20> rotate -46.5*x translate <0, 7.5, 20> }
        }
        difference {
          merge {
            cylinder { 0.000001*y, 8.6*y, 1.5 translate <0, 0, 12> }
            box { <-0.5, 0.000001, 3.8> <0.5, 8.6, 5> }
            box { <-0.5, 0.000001, 19> <0.5, 8.6, 20.2> }
            cylinder { 6.300001*y, 8.6*y, 1.5 translate <16, 0, 12> }
            box { <15.5, 6.300001, 3.8> <16.5, 8.6, 5> }
            box { <15.5, 6.300001, 19> <16.5, 8.6, 20.2> }
          }
          box { <-20, 0, -20> <20, 20, 30> rotate 24.5*z translate <12, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 28> } }
    }
  #end
#end
#macro ramp4_4(color_tex, age)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
      box { <-10, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting < 3)
        cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 16> }
      #else
        object { rounded_button() translate <0, 6.4, 8> }
        object { rounded_button() translate <0, 6.4, 16> }
      #end
      difference {
        box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
        box { <-40, 0, -30> <40, 20, 30> texture { color_tex normal { bumping } }
          rotate -43.5*x translate <0, 9.5, 4> }
        box { <-40, 0, -30> <40, 20, 30> texture { color_tex normal { bumping } }
          rotate 43.5*x translate <0, 9.5, 20> }
        box { <-20, -10, -20> <40, 10, 0> rotate -18.4*y translate <16, 0, 0> }
        box { <-20, -10, 0> <40, 10, 20> rotate 18.4*y translate <16, 0, 24> }
        box { <-10, 0, -10> <40, 20, 30> texture { color_tex normal { bumping } }
          rotate -17.25*z translate <4, 9.5, 0> }
        box { <-10, 0, -20> <40, 20, 20> texture { color_tex normal { bumping } }
          rotate 41.75*x rotate -17.25*z translate <4, 9.5, 20> }
        box { <-10, 0, -20> <40, 20, 20> texture { color_tex normal { bumping } }
          rotate -41.75*x rotate -17.25*z translate <4, 9.5, 4> }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 16> }
          difference {
            box { <5.6, -1, -2.4> <26.4, 8.6, 26.4> }
            box { <5, -2, 2.9> <13.5, 9, 21.1> }
            box { <-40, 0, -30> <40, 20, 30> rotate -43.5*x translate <0, 7.5, 4> }
            box { <-40, 0, -30> <40, 20, 30> rotate 43.5*x translate <0, 7.5, 20> }
            box { <-10, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 7.5, 0> }
            box { <-10, 0, -20> <40, 20, 20> rotate 41.75*x rotate -17.25*z translate <4, 7.5, 18.5> }
            box { <-10, 0, -20> <40, 20, 20> rotate -41.75*x rotate -17.25*z translate <4, 7.5, 5.5> }
            box { <13.4, -1, 4.5> <24, 9, 5.2> }
            box { <23.3, -1, 3.5> <24, 9, 5> }
            box { <13.4, -1, 18.8> <24, 9, 19.5> }
            box { <23.3, -1, 19> <24, 9, 20.5> }
          }
          difference {
            box { <-2.4, -1, -2.4> <4, 8.6, 2.4> }
            box { <-40, 0, -30> <40, 20, 30> rotate -43.5*x translate <0, 7.5, 4> }
            box { <2.5, -2, -0.5> <4.1, 9, 0.5> }
          }
          difference {
            box { <-2.4, -1, 21.6> <4, 8.6, 26.4> }
            box { <-40, 0, -30> <40, 20, 30> rotate 43.5*x translate <0, 7.5, 20> }
            box { <2.5, -2, 23.5> <4.1, 9, 24.5> }
          }
        #end
        difference {
          box { < -5, -1, 3.9> <12.1, 8.6, 20.1> }
          box { <-10, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 7.5, 0> }
          box { <-4, 6.3, 3> <-2.4, 9, 21> }
          #if (setting > 1)
            object { pin(age) translate <0, 6.4, 12> }
            object { pin(age) translate <8, 3.2, 12> }
            box { <4.1, 3.1, 3> <5.5, 9, 21> }
            box { <-0.5, 6.3, 3> <0.5, 9, 5.5> }
            box { <-0.5, 6.3, 18.5> <0.5, 9, 21> }
            box { <7.5, 3.1, 3> <8.5, 9, 5.5> }
            box { <7.5, 3.1, 18.5> <8.5, 9, 21> }
            box { <2.4, 6.3, 7.5> <5, 9, 8.5> }
            box { <2.4, 6.3, 15.5> <5, 9, 16.5> }
            box { <10.5, 3.1, 7.5> <13, 9, 8.5> }
            box { <10.5, 3.1, 15.5> <13, 9, 16.5> }
          #end
        }
      }
      difference {
        object { high_ring() translate <20, 0, 12> }
        box { <-10, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 7.5, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 28> } }
    }
  #end
#end
#macro ramp4_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 9.5, 27.9> }
      box { <-20, 0, -10> <50, 50, 30> rotate 24.5*z translate <12, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <43.9, 9.5, 27.9> }
            box { <-20, 0, -10> <50, 50, 30> texture { color_tex normal { bumping } }
              rotate 24.5*z translate <12, 9.5, 0> }
            box { <-20, -10, -20> <50, 20, 0> rotate 18.4*y translate <8, 0, 0> }
            box { <-20, -10, 0> <50, 20, 20> rotate -18.4*y translate <8, 0, 24> }
            box { <-60, 0, -30> <50, 50, 30> texture { color_tex normal { bumping } }
              rotate -51.2*x rotate 24.5*z translate <36, 9.5, -4> }
            box { <-60, 0, -30> <50, 50, 30> texture { color_tex normal { bumping } }
              rotate 51.2*x rotate 24.5*z translate <36, 9.5, 28> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <40, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <40, 0, 24> }
          #else
            object { rounded_button() rotate 180*y translate <16, 6.4, 8> }
            object { rounded_button() rotate 180*y translate <16, 6.4, 16> }
            object { rounded_button() rotate 180*y translate <40, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <40, 6.4, 24> }
          #end
        }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 24> }
          difference {
            box { <-2.4, -1, 5.6> <10.4, 8.6, 18.4> }
            box { <-20, 0, -10> <50, 50, 30> rotate 24.5*z translate <12, 7.500002, 0> }
          }
        #end
        box { <27.9, -1, 3.9> <44, 10, 20.1> }
        box { <19.9, 3.1, 3.900001> <44, 10, 20.099999> }
        box { <11.9, -1, 4> <18.5, 8.6, 20> }
        box { <19.9, -1, 4> <26.5, 2, 20> }
        difference {
          box { <-2.4, -1, -2.4> <42.4, 8.6, 26.4> }
          box { <10.4, -2, 2.4> <43, 9, 21.6> }
          box { <-4, -2, 4> <10.400001, 9, 20> }
          box { <-20, -10, -20> <50, 20, 0> rotate 18.4*y translate <8, 0, 1.3> }
          box { <-20, -10, 0> <50, 20, 20> rotate -18.4*y translate <8, 0, 22.7> }
          box { <-20, 0, -10> <50, 50, 30> rotate 24.5*z translate <12, 7.500001, 0> }
          box { <-60, 0, -30> <50, 50, 30> rotate -51.2*x rotate 24.5*z translate <36, 7.5, -3.5> }
          box { <-60, 0, -30> <50, 50, 30> rotate 51.2*x rotate 24.5*z translate <36, 7.5, 27.5> }
        }
      }
      difference {
        object { high_ring() translate <4, 0, 12> }
        box { <-20, 0, -10> <10, 10, 20> rotate 24.5*z translate <12, 7.5, 0> }
      }
      #if (setting > 1)
        object { pin(2) translate <24, 0, 12> }
        cylinder { 0*y, 8.7*y, 1.5 translate <16, 0, 12> }
        cylinder { 0*y, 8.7*y, 1.5 translate <36, 0, 0> }
        cylinder { 0*y, 8.7*y, 1.5 translate <36, 0, 24> }
        difference {
          merge {
            cylinder { 0*y, 8.7*y, 1.5 translate <28, 0, 0> }
            cylinder { 0*y, 8.7*y, 1.5 translate <28, 0, 24> }
            box { <27.5, 2, -3> <28.5, 8.7, 3> }
            box { <27.5, 2, 21> <28.5, 8.7, 27> }
            box { <35.5, 2, -3> <36.5, 8.7, 3> }
            box { <35.5, 2, 21> <36.5, 8.7, 27> }
          }
          box { <-60, 0, -30> <50, 50, 30> rotate -51.2*x rotate 24.5*z translate <36, 7.5, -3.5> }
          box { <-60, 0, -30> <50, 50, 30> rotate 51.2*x rotate 24.5*z translate <36, 7.5, 27.5> }
        }
      #end
      box { <23.5, 0.0001, 3.5> <24.5, 2.1, 5.5> }
      box { <15.5, 0.0001, 3.5> <16.5, 8.7, 5.5> }
      box { <23.5, 0.0001, 18.5> <24.5, 2.1, 20.5> }
      box { <15.5, 0.0001, 18.5> <16.5, 8.7, 20.5> }
      box { <11.5, 0.0001, 7.5> <13.5, 8.7, 8.5> }
      box { <11.5, 0.0001, 15.5> <13.5, 8.7, 16.5> }
      box { <19.5, 0.0001, 7.5> <21.5, 2.1, 8.5> }
      box { <19.5, 0.0001, 15.5> <21.5, 2.1, 16.5> }
      #if (setting < 3)
        cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
      #else
        object { rounded_button() rotate 180*y translate <24, 0, 8> }
        object { rounded_button() rotate 180*y translate <24, 0, 16> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 11.3, 28> } }
    }
  #end
#end
#macro ramp_left2_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> }
      box { <-10, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting < 3)
        cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
      #else
        object { rounded_button() translate <0, 6.4, 8> }
      #end
      difference {
        box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> }
        box { <-40, 0, -30> <40, 20, 30> texture { color_tex normal { bumping } }
          rotate -43.5*x translate <0, 9.5, 4> }
        box { <-20, -10, -20> <40, 10, 0> rotate -18.4*y translate <16, 0, 0> }
        box { <-10, 0, -10> <40, 20, 30> texture { color_tex normal { bumping } }
          rotate -17.25*z translate <4, 9.5, 0> }
        box { <-10, 0, -20> <40, 20, 20> texture { color_tex normal { bumping } }
          rotate -41.75*x rotate -17.25*z translate <4, 9.5, 4> }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          difference {
            box { <-2.4, -1, -2.4> <26.4, 8.6, 10.4> }
            box { <-40, 0, -30> <40, 20, 30> rotate -43.5*x translate <0, 7.5, 4> }
            box { <-20, -10, -20> <40, 10, 0> rotate -18.4*y translate <16, 0, 1.1> }
            box { <-10, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 7.5, 0> }
            box { <-10, 0, -20> <40, 20, 20> rotate -41.75*x rotate -17.25*z translate <4, 7.5, 4> }
            box { <-0.5, 0.1, 0> <0.5, 3, 1.5> rotate -18.4*y translate <12, 0, 0> }
          }
          cylinder { -1*y, 2*y, 2.5 translate <24, 0, 8> }
          box { <-2.25, -1, -4> <2.25, 2, 4> rotate -18.4*y translate <8, 0, 0> }
          difference {
            box { <-2.75, -1, -4> <2.75, 2, 4> rotate -18.4*y translate <16, 0, 0> }
            object { high_ring() translate <20, 0, 4> }
          }
        #end
      }
      difference {
        merge {
          object { high_ring() translate <4, 0, 4> }
          object { high_ring() translate <12, 0, 4> }
          object { high_ring() translate <20, 0, 4> }
          box { <11.6, 2, 7.1> <12.4, 8.7, 10.5> }
        }
        box { <-10, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 7.5, 0> }
        box { <-40, 0, -30> <40, 20, 30> rotate -43.5*x translate <0, 7.5, 4> }
        box { <-10, 0, -20> <40, 20, 20> rotate -41.75*x rotate -17.25*z translate <4, 7.5, 4> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 28> } }
    }
  #end
#end
#macro ramp_right2_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> }
      box { <-10, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting < 3)
        cylinder { 9.4*y, 11.2*y, 2.4 }
      #else
        object { rounded_button() translate <0, 6.4, 0> }
      #end
      difference {
        box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> }
        box { <-40, 0, -30> <40, 20, 30> texture { color_tex normal { bumping } }
          rotate 43.5*x translate <0, 9.5, 4> }
        box { <-20, -10, 0> <40, 10, 20> rotate 18.4*y translate <16, 0, 8> }
        box { <-10, 0, -10> <40, 20, 30> texture { color_tex normal { bumping } }
          rotate -17.25*z translate <4, 9.5, 0> }
        box { <-10, 0, -20> <40, 20, 20> texture { color_tex normal { bumping } }
          rotate 41.75*x rotate -17.25*z translate <4, 9.5, 4> }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 }
          difference {
            box { <-2.4, -1, -2.4> <26.4, 8.6, 10.4> }
            box { <-40, 0, -30> <40, 20, 30> rotate 43.5*x translate <0, 7.5, 4> }
            box { <-20, -10, 0> <40, 10, 20> rotate 18.4*y translate <16, 0, 6.9> }
            box { <-10, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 7.5, 0> }
            box { <-10, 0, -20> <40, 20, 20> rotate 41.75*x rotate -17.25*z translate <4, 7.5, 4> }
            box { <-0.5, 0.1, -1.5> <0.5, 3, 0> rotate 18.4*y translate <12, 0, 8> }
          }
          cylinder { -1*y, 2*y, 2.5 translate <24, 0, 0> }
          box { <-2.25, -1, -4> <2.25, 2, 4> rotate 18.4*y translate <8, 0, 8> }
          difference {
            box { <-2.75, -1, -4> <2.75, 2, 4> rotate 18.4*y translate <16, 0, 8> }
            object { high_ring() translate <20, 0, 4> }
          }
        #end
      }
      difference {
        merge {
          object { high_ring() translate <4, 0, 4> }
          object { high_ring() translate <12, 0, 4> }
          object { high_ring() translate <20, 0, 4> }
          box { <11.6, 2, -2.5> <12.4, 8.7, 0.8> }
        }
        box { <-10, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 7.5, 0> }
        box { <-40, 0, -30> <40, 20, 30> rotate 43.5*x translate <0, 7.5, 4> }
        box { <-10, 0, -20> <40, 20, 20> rotate 41.75*x rotate -17.25*z translate <4, 7.5, 4> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 28> } }
    }
  #end
#end
#macro ray_gun(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -1.9*y, 6.1*y, 1.5 }
      cylinder { -19.7*x, -3.8*x, 1.5 translate <0, 10, 0> }
      cylinder { -3.9*x, 5.6*x, 4 translate <0, 10, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -1.8*y, 6.1*y, 1.3 }
        cylinder { -1.9*y, -0*y, 1.5 }
        cylinder { 0.4*y, 0.8*y, 1.5 }
        cylinder { 1.2*y, 1.6*y, 1.5 }
        cylinder { 2*y, 2.4*y, 1.5 }
        cylinder { 2.8*y, 6.1*y, 1.5 }
        cylinder { 4.9*z, 3*z, 1.25 translate <0, 10, 0> }
        cylinder { 4.75*z, 3*z, 1.4 translate <0, 10, 0> }
        torus { 1.25, 0.15 rotate 90*x translate <0, 10, 4.75> }
        merge {
          cylinder { 4.75*z, 3*z, 1.4 rotate 45*x translate <0, 10, 0> }
          cylinder { 4.75*z, 3*z, 1.4 rotate -45*x translate <0, 10, 0> }
          cylinder { 4.75*z, 3*z, 1.4 rotate 135*x translate <0, 10, 0> }
          cylinder { 4.9*z, 3*z, 1.25 rotate 45*x translate <0, 10, 0> }
          cylinder { 4.9*z, 3*z, 1.25 rotate -45*x translate <0, 10, 0> }
          cylinder { 4.9*z, 3*z, 1.25 rotate 135*x translate <0, 10, 0> }
          torus { 1.25, 0.15 rotate 90*x translate <0, 0, 4.75> rotate 45*x
            translate <0, 10, 0> }
          torus { 1.25, 0.15 rotate 90*x translate <0, 0, 4.75> rotate -45*x
            translate <0, 10, 0> }
          torus { 1.25, 0.15 rotate 90*x translate <0, 0, 4.75> rotate 135*x
            translate <0, 10, 0> }
        }
        cylinder { -3.900001*x, 2.4*x, 1.5 translate <0, 14, 0> }
        torus { 2.25, 0.15 rotate 90*z translate <-5.45, 10, 0> }
        cylinder { -5.45*x, -3.8*x, 2.4 translate <0, 10, 0> }
        cylinder { -5.6*x, -4*x, 2.25 translate <0, 10, 0> }
        cylinder { -18.3*x, -5.5*x, 1.5 translate <0, 10, 0> }
        sphere { <-18.3, 10, 0> 1.5 }
        difference {
          box { <-3.9, 6, -4> <5.6, 14, 4> }
          box { <-4, 0, -4> <6, 4, 0> rotate 45*x translate <0, 11.6, -4> }
          box { <-4, -4, -4> <6, 0, 0> rotate -45*x translate <0, 8.4, -4> }
          box { <-4, 0, 0> <6, 4, 4> rotate -45*x translate <0, 11.6, 4> }
          box { <-4, -4, 0> <6, 4, 4> rotate 45*x translate <0, 8.4, 4> }
        }
        object { open_rounded_button() rotate 90*z translate <2.4, 14, -8> }
        cylinder { -0.7*x, 2.5*x, 3.2 translate <0, 14, -8> }
        difference {
          box { <-0.700001, -3.1, 0> <2.500001, 3.1, 6.5> }
          box { <-1, 0, 0> <5, 5, 6> rotate -8*x translate <0, 2.2, 0> }
          box { <-1, -5, 0> <5, 0, 6> rotate 8*x translate <0, -2.2, 0> }
          box { <1.3, 0.5, 3.1> <5, 1.5, 6> }
          box { <1.30, -1.5, 3.1> <5, -0.5, 6> }
          rotate 29*x translate <0, 14, -8>
        }
      }
      difference {
        box { <-2.9, 7.5, -2.5> <6, 12.5, 2.5> }
        box { <-4, 0, -4> <6, 4, 0> rotate 45*x translate <0, 11, -2.5> }
        box { <-4, -4, -4> <6, 0, 0> rotate -45*x translate <0, 9, -2.5> }
        box { <-4, 0, 0> <6, 4, 4> rotate -45*x translate <0, 11, 2.5> }
        box { <-4, -4, 0> <6, 4, 4> rotate 45*x translate <0, 9, 2.5> }
      }
      cylinder { -4.9*x, 0*x, 1.2 translate <0, 10, 0> }
      cylinder { -5*x, 5*x, 1.600001 translate <0, 14, -8> }
      cylinder { 0*x, 5*x, 2.35 translate <0, 14, -8> }
      texture { color_tex }
      bounded_by { box { <-19.8, -2, -11.3> <5.7, 17.3, 5> } }
    }
  #end
#end
#macro revolver(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -2.5*y, 4*y, 1.6 }
      cylinder { -9.5*x, 0*x, 1.5 translate <0, 2, 0> rotate -30*z translate <-2, 2, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          torus { 1.45, 0.15 translate <0, -2.35, 0> }
          cylinder { -2.5*y, 4*y, 1.45 }
          cylinder { -2.35*y, 4*y, 1.6 }
        }
        cylinder { -2*x, 2*x, 1.5 translate <0, 4, 0> }
      }
      difference {
        torus { 2, 1.5 rotate 90*x }
        box { <-10, -10, -2> <10, 0, 2> }
        box { <-10, -10, -2> <0, 10, 2> rotate -30*z }
        translate <-2, 2, 0>
      }
      merge {
        cylinder { -9.5*x, 0*x, 1.5 }
        cylinder { -0.6*z, 0.6*z, 0.4 translate <-8.7, 2.1, 0> }
        box { <-9.100001, 1, -0.600001> <-8.699999, 2.100001, 0.600001> }
        box { <-0.4, -2, -0.600002> <0.4, 0, 0.600002> rotate 25*z translate <-8.7, 2.1, 0> }
        cylinder { -0.6*z, 0.6*z, 0.4 translate <1, 2.6, 0> }
        box { <-0.4, -3, -0.600002> <0.4, 0, 0.600002> rotate -18*z translate <1, 2.6, 0> }
        box { <1, -3, -0.600003> <1.4, 2.6, 0.600003> }
        cylinder { -0.4*z, 0.4*z, 1.25 translate <-1.25, -2, 0> }
        difference {
          cylinder { -3.5*x, 0*x, 2 }
          cylinder { -4*x, -1*x, 0.35 translate <0, 0, -2> rotate -25*x }
          cylinder { -4*x, -1*x, 0.35 translate <0, 0, -2> rotate 25*x }
          sphere { <-1, 0, -2> 0.35 rotate -25*x }
          sphere { <-1, 0, -2> 0.35 rotate 25*x }
          cylinder { -4*x, -1*x, 0.35 translate <0, 0, 2> rotate -25*x }
          cylinder { -4*x, -1*x, 0.35 translate <0, 0, 2> rotate 25*x }
          sphere { <-1, 0, 2> 0.35 rotate -25*x }
          sphere { <-1, 0, 2> 0.35 rotate 25*x }
        }
        translate <0, 2, 0>
        rotate -30*z
        translate <-2, 2, 0>
      }
      texture { color_tex }
      bounded_by { box { <-10.5, -2.6, -2.1> <1.7, 11.5, 2.1> } }
    }
  #end
#end
#macro rifle(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -2.5*y, 4*y, 1.5 }
      cylinder { -28.2*x, 0*x, 1.5 translate <0, 4, 0> }
      cylinder { 0*x, 14.5*x, 1.499999 rotate -14*z translate <0, 4, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -2.5*y, 4*y, 1.5 }
        cylinder { -1.6*z, 1.6*z, 1.6 translate <0, 4, 0> }
        box { <-3, 2.399999, -1.600001> <0.000001, 5.600001, 1.600001> }
        box { <-7, 2.399998, -1.600002> <-2.5, 4.8, 1.600002> }
        cylinder { -28.2*x, 0*x, 1.5 translate <0, 4, 0> }
        cylinder { -0.6*z, 0.6*z, 0.4 translate <-27.8, 6.2, 0> }
        box { <-28.200001, 4, -0.600001> <-27.799999, 6.200001, 0.600001> }
        box { <-0.4, -2, -0.600002> <0.4, 0, 0.600002> rotate 25*z translate <-27.8, 6.2, 0> }
        cylinder { -0.6*z, 0.6*z, 0.4 translate <2, 7.1, 0> }
        box { <-0.4, -5, -0.600002> <0.4, 0, 0.600002> rotate -18*z translate <2, 7.1, 0> }
        difference {
          box { <-2, -5, -0.600003> <0, 0, 0.600003> }
          cylinder { -1*z, 1*z, 2.5 translate <-2.9, 0, 0> }
          rotate -18*z
          translate <2, 7.1, 0>
        }
        difference {
          cylinder { -0.75*z, 0.75*z, 2.6 }
          cylinder { -1*z, 1*z, 1.9 }
          box { <0, -3, -2> <3, 3, 2> }
          translate <-3.5, 2.4, 0>
        }
        box { <-3.500001, -0.200001, -0.750001> <0, 0.500001, 0.750001> }
        sphere { <7.5, 2.8, 0> 1.500001 }
        cylinder { 0*x, 14.5*x, 1.499999 rotate -14*z translate <0, 4, 0> }
        cylinder { 0*x, 8*x, 1.499998 rotate -2*z translate <7.5, 2.8, 0> }
        difference {
          box { <7.5, -2, -1.500003> <17, 2.8, 1.500003> }
          box { <0, -5, -2> <10, 0, 2> rotate -14*z translate <7.5, 2, 0> }
          box { <0, 0, -2> <10, 5, 2> rotate -2*z translate <7.5, 2.8, 0> }
        }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x
            translate <10.5, 2.5, -1.5> }
        #end
      }
      cylinder { -5*z, 5*z, 11 translate <24.1, -1.5, 0> }
      texture { color_tex }
      bounded_by { box { <-28.3, -2.6, -1.7> <15, 7.6, 1.7> } }
    }
  #end
#end
#macro right_arm(color_tex)
  #if (setting = 0)
    merge {
      cylinder { <0.5, 0, 0>, <1, -5, 0>, 1 scale <-2.000001, 1, 2.5> }
      cylinder { <-2, -8, -3.5>, <-2, -5, 0>, 2.15 }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting > 1)
        cylinder { 1.25*x, 0*x, 1.75 }
        difference {
          sphere { <1.25, 0, 0> 1.750001 }
          box { <1.249999, -10, -10> <-10, 10, 10> }
          box { <10, -10, -10> <3, 10, 10> }
          cylinder { 4*x, 1*x, 1 }
        }
      #end
      difference {
        merge {
          sphere { <0, 0, 0> 1 scale <2, 2.5, 2.5> translate <-1, 0, 0> }
          cylinder { <-0.5, 0, 0>, <-1, -5, 0>, 1 scale <2.000001, 1, 2.5> }
          sphere { <0, 0, 0> 1 scale <2, 2.5, 2.5> translate <-2, -5, 0> }
          cylinder { <-2, -8, -3.5>, <-2, -5, 0>, 2.15 }
        }
        box { <10, -30, -20> <0.300001, 10, 20> }
        #if (setting > 1)
          cylinder { <-2, -11, -7>, <-2, -5, 0>, 1.35 }
        #end
      }
      texture { color_tex }
      bounded_by { box { <3.5, -10.5, -5.5> <-4.5, 3.5, 3.5> } }
    }
  #end
#end
#macro left_leg(color_tex)
// was right

  #if (setting = 0)
    box { <0.5, -11, -2> <7.8, 0, 4.5> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { 0.9*x, 7.800001*x, 3.5 }
        box { <0.5, -11, -2> <7.8, 0, 3.5> }
        box { <0.499999, -11.000001, -4.3> <7.800001, -8.1, 3.500001> }
      }
      #if (setting > 1)
        cylinder { -1*x, 1*x, 3.6 }
        cylinder { 1.5*z, 4*z, 2.45 translate <4, 1, 0> }
        cylinder { 1.5*z, 4*z, 2.45 translate <4, -7, 0> }
        box { <1.5, -12, -2.8> <6.5, -9, 2.000002> }
        box { <1.500001, -12, -0.5> <6.500001, -2, 2.000001> }
        cylinder { 0*x, 4*x, 1.25 }
      #end
      box { <3, -1.25, -1.5> <5.5, 2.5, 2> }
      box { <0, -20, -10> <10, 20, 10> rotate 3*z translate <7.8, -11, 0> }
      texture { color_tex }
      bounded_by { box { <0, -11.1, -4.5> <8, 3.6, 3.6> } }
    }
  #end
#end
#macro roof_slope4_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-1.9, -1.55, -3.9> <29.9, 7.95, 27.9> }
      box { <-20, 0, -10> <20, 30, 30> rotate 43.5*z translate <6, 7.95, 0> }
      box { <-20, 0, -10> <20, 30, 30> rotate -43.5*z translate <22, 7.95, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-1.9, -1.55, -3.9> <29.9, 7.95, 27.9> }
            box { <-20, 0, -10> <20, 30, 30> texture { color_tex normal { bumping } }
              rotate 43.5*z translate <6, 7.95, 0> }
            box { <-20, 0, -10> <20, 30, 30> texture { color_tex normal { bumping } }
              rotate -43.5*z translate <22, 7.95, 0> }
            box { <5.9, -2.45, -4> <22.1000001, 4.85, 28> }
            box { <-5, -5, 3.2> <2, 5, 4.8> rotate 43*z }
            box { <-5, -5, 11.2> <2, 5, 12.8> rotate 43*z }
            box { <-5, -5, 19.2> <2, 5, 20.8> rotate 43*z }
            difference {
              box { <-3, -15, -2.400005> <5, 5.000001, 26.400005> }
              box { <-0.000002, 0.000001, -3> <5, 6, 27> }
              cylinder { -3*z, 27*z, 1.550001 }
              box { <-0.000001, -1.550002, -3> <6, 1, 27> }
              rotate 43.5*z
            }
            cylinder { -4*z, -2.399999*z, 2 }
            cylinder { 26.399999*z, 28*z, 2 }
            box { <-5, 0, -4> <2.000001, 5, -2.399997> rotate 43.5*z }
            box { <-5, 0, 26.399997> <2.000001, 5, 28> rotate 43.5*z }
            box { <-5, -2, -4> <2, 0, -2.399998> }
            box { <-5, -2, 26.399998> <2, 0, 28> }
          }
          #if (setting < 3)
            cylinder { 7.85*y, 9.65*y, 2.4 translate <10, 0, 0> }
            cylinder { 7.85*y, 9.65*y, 2.4 translate <10, 0, 8> }
            cylinder { 7.85*y, 9.65*y, 2.4 translate <10, 0, 16> }
            cylinder { 7.85*y, 9.65*y, 2.4 translate <10, 0, 24> }
            cylinder { 7.85*y, 9.65*y, 2.4 translate <18, 0, 0> }
            cylinder { 7.85*y, 9.65*y, 2.4 translate <18, 0, 8> }
            cylinder { 7.85*y, 9.65*y, 2.4 translate <18, 0, 16> }
            cylinder { 7.85*y, 9.65*y, 2.4 translate <18, 0, 24> }
          #else
            object { rounded_button() rotate -90*y translate <10, 4.85, 0> }
            object { rounded_button() rotate -90*y translate <10, 4.85, 8> }
            object { rounded_button() rotate -90*y translate <10, 4.85, 16> }
            object { rounded_button() rotate -90*y translate <10, 4.85, 24> }
            object { rounded_button() rotate -90*y translate <18, 4.85, 0> }
            object { rounded_button() rotate -90*y translate <18, 4.85, 8> }
            object { rounded_button() rotate -90*y translate <18, 4.85, 16> }
            object { rounded_button() rotate -90*y translate <18, 4.85, 24> }
          #end
        }
        difference {
          box { <-0.5, -2.45, -2.4> <22.1, 7.45, 26.4> }
          box { <-1, -3.45, -3> <4, 7.85, -1> }
          box { <-1, -3.45, 1.5> <4, 7.85, 6> }
          box { <-1, -3.45, 9.5> <4, 7.85, 14.5> }
          box { <-1, -3.45, 18> <4, 7.85, 22.5> }
          box { <-1, -3.45, 25> <4, 7.85, 27> }
          box { <-20, 0, -10> <20, 30, 30> rotate 43.5*z translate <6, 7.45, 0> }
        }
        difference {
          box { <23.5, -3.45, -2.4> <28.5, 7.45, 26.4> }
          box { <-20, 0, -10> <20, 30, 30> rotate -43.5*z translate <22, 7.45, 0> }
        }
        #if (setting > 1)
          cylinder { 5.85*y, 8.85*y, 1.2 translate <10, 0, 0> }
          cylinder { 5.85*y, 8.85*y, 1.2 translate <10, 0, 8> }
          cylinder { 5.85*y, 8.85*y, 1.2 translate <10, 0, 16> }
          cylinder { 5.85*y, 8.85*y, 1.2 translate <10, 0, 24> }
          cylinder { 5.85*y, 8.85*y, 1.2 translate <18, 0, 0> }
          cylinder { 5.85*y, 8.85*y, 1.2 translate <18, 0, 8> }
          cylinder { 5.85*y, 8.85*y, 1.2 translate <18, 0, 16> }
          cylinder { 5.85*y, 8.85*y, 1.2 translate <18, 0, 24> }
        #end
      }
      difference {
        merge {
          #if (setting > 1)
            cylinder { -1.55*y, 7.45*y, 1.5 translate <26, 0, 4> }
            cylinder { -1.55*y, 7.45*y, 1.5 translate <26, 0, 12> }
            cylinder { -1.55*y, 7.45*y, 1.5 translate <26, 0, 20> }
          #end
          box { <20.5, 4.85, -0.5> <22.5, 7.950001, 0.5> }
          box { <20.5, 4.85, 7.5> <22.5, 7.950001, 8.5> }
          box { <20.5, 4.85, 15.5> <22.5, 7.950001, 16.5> }
          box { <20.5, 4.85, 23.5> <22.5, 7.950001, 24.5> }
          box { <2, 4.85, -0.5> <7.5, 7.950001, 0.5> }
          box { <2, 4.85, 7.5> <7.5, 7.950001, 8.5> }
          box { <2, 4.85, 15.5> <7.5, 7.950001, 16.5> }
          box { <2, 4.85, 23.5> <7.5, 7.950001, 24.5> }
        }
        box { <-20, 0, -10> <20, 30, 30> rotate -43.5*z translate <22, 7.5, 0> }
        box { <-20, 0, -10> <20, 30, 30> rotate 43.5*z translate <6, 7.5, 0> }
      }
      #if (setting > 1)
        object { ring() translate <14, 4.85, 4> }
        object { ring() translate <14, 4.85, 12> }
        object { ring() translate <14, 4.85, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-2, -1.7, -4> <30, 9.75, 28> } }
    }
  #end
#end
#macro roster8_8(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 3.1, 59.9> texture { color_tex } }
  #else
    merge {
      #if (setting < 3)
        cylinder { 3*y, 4.8*y, 2.4 }
        cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
        cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
        cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
        cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
        cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
        cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
        cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
        cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 56> }
        cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 56> }
        cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 56> }
        cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 56> }
        cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 56> }
        cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 56> }
        cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 56> }
        cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 56> }
        cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
        cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 32> }
        cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 40> }
        cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 48> }
        cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
        cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 24> }
        cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 32> }
        cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 40> }
        cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 48> }
        cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
        cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
        cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
        cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 32> }
      #else
        object { rounded_button() }
        object { rounded_button() translate <8, 0, 0> }
        object { rounded_button() translate <16, 0, 0> }
        object { rounded_button() translate <24, 0, 0> }
        object { rounded_button() translate <32, 0, 0> }
        object { rounded_button() translate <40, 0, 0> }
        object { rounded_button() translate <48, 0, 0> }
        object { rounded_button() translate <56, 0, 0> }
        object { rounded_button() translate <0, 0, 56> }
        object { rounded_button() translate <8, 0, 56> }
        object { rounded_button() translate <16, 0, 56> }
        object { rounded_button() translate <24, 0, 56> }
        object { rounded_button() translate <32, 0, 56> }
        object { rounded_button() translate <40, 0, 56> }
        object { rounded_button() translate <48, 0, 56> }
        object { rounded_button() translate <56, 0, 56> }
        object { rounded_button() translate <0, 0, 8> }
        object { rounded_button() translate <0, 0, 16> }
        object { rounded_button() translate <0, 0, 24> }
        object { rounded_button() translate <0, 0, 32> }
        object { rounded_button() translate <0, 0, 40> }
        object { rounded_button() translate <0, 0, 48> }
        object { rounded_button() translate <56, 0, 8> }
        object { rounded_button() translate <56, 0, 16> }
        object { rounded_button() translate <56, 0, 24> }
        object { rounded_button() translate <56, 0, 32> }
        object { rounded_button() translate <56, 0, 40> }
        object { rounded_button() translate <56, 0, 48> }
        object { rounded_button() translate <24, 0, 24> }
        object { rounded_button() translate <24, 0, 32> }
        object { rounded_button() translate <32, 0, 24> }
        object { rounded_button() translate <32, 0, 32> }
      #end
      difference {
        box { <-3.9, 0, -3.9> <59.9, 3.1, 59.9> }
        #if (setting > 1)
          box { <21.5, -1, 21.5> <34.5, 2, 34.5> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 32> }
          difference {
            box { <-2.4, -1, -2.4> <58.4, 2, 58.4> }
            box { <2.4, -2, 2.4> <53.6, 3, 53.6> }
          }
        #end
        difference {
          box { <3.9, -1, 3.9> <52.1, 4, 52.1> }
          box { <20.1, -2, 20.1> <36.1, 5, 36.1> }
        }
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <8, 0.000001, 8>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <8, 0.000002, 16>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <8, 0.000001, 24>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <8, 0.000002, 32>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <8, 0.000001, 40>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <8, 0.000002, 48>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <16, -0.000001, 8>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <16, -0.000002, 16>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <16, -0.000001, 24>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <16, -0.000002, 32>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <16, -0.000001, 40>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <16, -0.000002, 48>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <24, 0.000001, 8>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <24, 0.000002, 16>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <24, 0.000001, 40>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <24, 0.000002, 48>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <32, -0.000001, 8>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <32, -0.000002, 16>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <32, -0.000001, 40>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <32, -0.000002, 48>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <40, 0.000001, 8>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <40, 0.000002, 16>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <40, 0.000001, 24>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <40, 0.000002, 32>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <40, 0.000001, 40>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <40, 0.000002, 48>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <48, -0.000001, 8>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <48, -0.000002, 16>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <48, -0.000001, 24>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <48, -0.000002, 32>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <48, -0.000001, 40>
      }
      difference {
        box { <-3.1, 0, -3.1> <3.1, 3.1, 3.1> }
        box { <-2.5, -1, -2.5> <2.5, 4, 2.5> }
        rotate 45*y
        translate <48, -0.000002, 48>
      }
      #if (setting > 1)
        object { ring() translate <28, 0, 28> }
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
        object { pin(2) translate <28, 0, 0> }
        object { pin(2) translate <36, 0, 0> }
        object { pin(2) translate <44, 0, 0> }
        object { pin(2) translate <52, 0, 0> }
        object { pin(2) translate <4, 0, 56> }
        object { pin(2) translate <12, 0, 56> }
        object { pin(2) translate <20, 0, 56> }
        object { pin(2) translate <28, 0, 56> }
        object { pin(2) translate <36, 0, 56> }
        object { pin(2) translate <44, 0, 56> }
        object { pin(2) translate <52, 0, 56> }
        object { pin(2) translate <0, 0, 4> }
        object { pin(2) translate <0, 0, 12> }
        object { pin(2) translate <0, 0, 20> }
        object { pin(2) translate <0, 0, 28> }
        object { pin(2) translate <0, 0, 36> }
        object { pin(2) translate <0, 0, 44> }
        object { pin(2) translate <0, 0, 52> }
        object { pin(2) translate <56, 0, 4> }
        object { pin(2) translate <56, 0, 12> }
        object { pin(2) translate <56, 0, 20> }
        object { pin(2) translate <56, 0, 28> }
        object { pin(2) translate <56, 0, 36> }
        object { pin(2) translate <56, 0, 44> }
        object { pin(2) translate <56, 0, 52> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 60> } }
    }
  #end
#end
#macro rotor_piece(color_tex)
  #if (setting = 0)
    merge {
      box { <-19.9, 7.5, -3.9> <19.9, 9.5, 3.9> }
      box { <-3.9, 7.500001, -19.9> <3.9, 9.500001, 19.9> }
      cylinder { 0*y, 9.500002*y, 3.9 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        object { open_rounded_button() translate <8, 6.4, 0> }
        object { open_rounded_button() translate <16, 6.4, 0> }
        object { open_rounded_button() translate <-8, 6.4, 0> }
        object { open_rounded_button() translate <-16, 6.4, 0> }
        object { open_rounded_button() translate <0, 6.4, -8> }
        object { open_rounded_button() translate <0, 6.4, -16> }
        object { open_rounded_button() translate <0, 6.4, 8> }
        object { open_rounded_button() translate <0, 6.4, 16> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <16, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <-8, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <-16, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 9.5, -8> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 9.5, -16> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <0, 9.5, 8> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <0, 9.5, 16> }
        #end
        difference {
          merge {
            cylinder { 7.5*y, 9.5*y, 3.9 translate <16, 0, 0> }
            cylinder { 7.5*y, 9.5*y, 3.9 translate <-16, 0, 0> }
            cylinder { 7.5*y, 9.5*y, 3.9 translate <0, 0, 16> }
            cylinder { 7.5*y, 9.5*y, 3.9 translate <0, 0, -16> }
            box { <-16, 7.499999, -3.9> <16, 9.499999, 3.9> }
            box { <-3.9, 7.499998, -16> <3.9, 9.499998, 16> }
          }
          box { <0, -10, -5> <20, 0, 5> rotate 1.75*z translate <4, 7.5, 0> }
          box { <-20, -10, -5> <0, 0, 5> rotate -1.75*z translate <-4, 7.5, 0> }
          box { <-5, -10, 0> <5, 0, 20> rotate -1.75*x translate <0, 7.5, 4> }
          box { <-5, -10, -20> <5, 0, 0> rotate 1.75*x translate <0, 7.5, -4> }
        }
        cylinder { 6.25*y, 9*y, 3.9 }
        cylinder { 0*y, 9*y, 1.000001 translate <5, 0, 0> }
        cylinder { 0*y, 9*y, 1.000001 translate <-5, 0, 0> }
        cylinder { 0*y, 9*y, 1.000001 translate <0, 0, 5> }
        cylinder { 0*y, 9*y, 1.000001 translate <0, 0, -5> }
        box { <-5.000001, 0.000001, -1> <5.000001, 9, 1> }
        box { <-1, 0.000002, -5.000001> <1, 9, 5.000001> }
      }
      #if (setting > 1)
        cone { -1*y, 2.5, 10*y, 2.4 }
        cylinder { 7*y, 10*y, 3 }
        cylinder { -1*y, 0.75*y, 3.1 }
      #end
      texture { color_tex }
      bounded_by { box { <-20, -0.1, -20> <20, 11.3, 20> } }
    }
  #end
#end
#macro rotor_piece_flat(color_tex)
merge {
  difference {
    merge {
      box { <-3.9, 0, -3.9> <3.9, 6.3, 3.9> }
      box { <-19.9, 3.2, -3.900001> <19.9, 6.300001, 3.900001> }
      box { <-3.900001, 3.200001, -19.9> <3.900001, 6.300002, 19.9> }
      #if (setting < 3)
        cylinder { 6.2*y, 8*y, 2.4 translate <0, 0, -8> }
        cylinder { 6.2*y, 8*y, 2.4 translate <0, 0, -16> }
        cylinder { 6.2*y, 8*y, 2.4 translate <0, 0, 8> }
        cylinder { 6.2*y, 8*y, 2.4 translate <0, 0, 16> }
        cylinder { 6.2*y, 8*y, 2.4 translate <-16, 0, 0> }
        cylinder { 6.2*y, 8*y, 2.4 translate <-8, 0, 0> }
        cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 0> }
        cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, 0> }
      #else
        object { rounded_button() rotate 90*y translate <0, 3.2, -8> }
        object { rounded_button() rotate 90*y translate <0, 3.2, -16> }
        object { rounded_button() rotate -90*y translate <0, 3.2, 8> }
        object { rounded_button() rotate -90*y translate <0, 3.2, 16> }
        object { rounded_button() rotate 180*y translate <-16, 3.2, 0> }
        object { rounded_button() rotate 180*y translate <-8, 3.2, 0> }
        object { rounded_button() translate <8, 3.2, 0> }
        object { rounded_button() translate <16, 3.2, 0> }
      #end
    }
    #if (setting > 1)
      box { <-18.4, 0, -2.4> <-5.6, 5.7, 2.4> }
      box { <5.6, 0, -2.4> <18.4, 5.7, 2.4> }
      box { <-2.4, 0, -18.4> <2.4, 5.7, -5.6> }
      box { <-2.4, 0, 5.6> <2.4, 5.7, 18.4> }
      cylinder { 4.2*y, 7.2*y, 1.2 translate <0, 0, -8> }
      cylinder { 4.2*y, 7.2*y, 1.2 translate <0, 0, -16> }
      cylinder { 4.2*y, 7.2*y, 1.2 translate <0, 0, 8> }
      cylinder { 4.2*y, 7.2*y, 1.2 translate <0, 0, 16> }
      cylinder { 4.2*y, 7.2*y, 1.2 translate <-16, 0, 0> }
      cylinder { 4.2*y, 7.2*y, 1.2 translate <-8, 0, 0> }
      cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 0> }
      cylinder { 4.2*y, 7.2*y, 1.2 translate <16, 0, 0> }
    #end
    cylinder { -1*y, 10*y, 3 }
    cylinder { -1*y, 4.3*y, 3.2 }
  }
  #if (setting > 1)
    object { pin(1) translate <0, 3.2, -12> }
    object { pin(1) translate <0, 3.2, 12> }
    object { pin(1) translate <-12, 3.2, 0> }
    object { pin(1) translate <12, 3.2, 0> }
  #end
  texture { color_tex }
  bounded_by { box { <-20, -0.1, -20> <20, 8.1, 20> } }
}
#end
#macro round_shield(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -2*y, 6*y, 1.5 }
      cylinder { -4*x, 5.65*x, 1.5 translate <0, 6, 0> }
      cylinder { -4.6*x, -3.5*x, 9.6 translate <0, 6, 0> }
      texture { color_tex }
    }
  #else
    merge {
      torus { 1.35, 0.15 translate <0, -2, 0> }
      torus { 1.35, 0.15 rotate 90*z translate <5.5, 6, 0> }
      cylinder { -4*x, 5.5*x, 1.5 translate <0, 6, 0> }
      cylinder { 4.1*x, 5.65*x, 1.35 translate <0, 6, 0> }
      cylinder { -2*y, 6*y, 1.5 }
      cylinder { -2.15*y, 6.15*y, 1.35 }
      cylinder { -4.6*x, -3.5*x, 9.6 translate <0, 6, 0> }
      object { open_rounded_button() rotate 90*z translate <-1.5, 6, 0> }
      torus { 4, 0.45 scale <1, 0.5, 1> rotate 90*z translate <-4.6, 6, 0> }
      torus { 6, 0.45 scale <1, 0.5, 1> rotate 90*z translate <-4.6, 6, 0> }
      torus { 8, 0.45 scale <1, 0.5, 1> rotate 90*z translate <-4.6, 6, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y rotate 90*z translate <-4.6, 6, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-5.4, -3.7, -9.7> <5.75, 15.7, 9.7> } }
    }
  #end
#end
#macro rubber_skirt_piece()
  #if (setting = 0)
    difference {
      box { <-3.9, -7.75, -7.9> <27.9, 7.75, -0.1> }
      box { <-5, 0, -10> <30, 10, 0> rotate 45*x translate <0, 3.25, -7.9> }
      box { <-5, -10, -10> <30, 0, 0> rotate -45*x translate <0, -3.25, -7.9> }
      texture { color_tex }
    }
  #else
    difference {
      box { <-3.9, -7.75, -7.9> <27.9, 7.75, -0.1> }
      box { <-5, 0, -10> <30, 10, 0> rotate 45*x translate <0, 3.25, -7.9> }
      box { <-5, -10, -10> <30, 0, 0> rotate -45*x translate <0, -3.25, -7.9> }
      box { <-3.2, 5.5, -3.9> <2.7, 7, 0> }
      box { <3.2, 5.5, -3.9> <8.7, 7, 0> }
      box { <9.2, 5.5, -3.9> <14.7, 7, 0> }
      box { <15.2, 5.5, -3.9> <20.7, 7, 0> }
      box { <21.2, 5.5, -3.9> <27.2, 7, 0> }
      box { <-3.2, -5.5, -3.9> <2.7, -7, 0> }
      box { <3.2, -5.5, -3.9> <8.7, -7, 0> }
      box { <9.2, -5.5, -3.9> <14.7, -7, 0> }
      box { <15.2, -5.5, -3.9> <20.7, -7, 0> }
      box { <21.2, -5.5, -3.9> <27.2, -7, 0> }
      difference {
        box { <-3.2, -5, -6.9> <27.2, 5, 0> }
        box { <-5, 0, -10> <30, 10, 0> rotate 45*x translate <0, 3.25, -6.9> }
        box { <-5, -10, -10> <30, 0, 0> rotate -45*x translate <0, -3.25, -6.9> }
        box { <-5, -0.25, -7> <30, 0.25, -3.9> }
        box { <2.7, -6, -7> <3.2, 6, -3.900001> }
        box { <8.7, -6, -7> <9.2, 6, -3.900001> }
        box { <14.7, -6, -7> <15.2, 6, -3.900001> }
        box { <20.7, -6, -7> <21.2, 6, -3.900001> }
        box { <-4, 3.8, -7> <-2, 6, -1.9> }
        box { <-4, -3.8, -7> <-2, -6, -1.9> }
        box { <26, 3.8, -7> <28, 6, -1.9> }
        box { <26, -3.8, -7> <28, -6, -1.9> }
        box { <-0.05, -6, -2> <5.95, -3.9, -0.2> }
        box { <9.2, -6, -2> <14.7, -3.9, -0.2> }
        box { <17.95, -6, -2> <23.95, -3.9, -0.2> }
        box { <-0.05, 3.9, -2> <5.95, 6, -0.2> }
        box { <9.2, 3.9, -2> <14.7, 6, -0.2> }
        box { <17.95, 3.9, -2> <23.95, 6, -0.2> }
      }
      texture { r_black_tex }
      bounded_by { box { <-4, -7.85, -8> <28, 7.85, 0> } }
    }
  #end
#end
#macro samurai_armour(color_tex)
  #if (setting = 0)
    merge {
      box { <-9.5, 0, -5.6> <9.5, 0.9, 5.6> }
      box  { <0, -0.89999, -4.10001> <7.6, 0.00001, 4.10001> rotate -66*z translate <9.5, 0.9, 0> }
      box  { <0, -0.89999, -4.10001> <-7.6, 0.00001, 4.10001> rotate 66*z translate <-9.5, 0.9, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-9.5, 0, -5.6> <9.5, 0.9, 5.6> }
        #if (setting > 1)
          box { <-10, 0.7, -2.2> <-5.6, 1, -1.8> }
          box { <-10, 0.7, -0.2> <-5.6, 1, 0.2> }
          box { <-10, 0.7, 1.8> <-5.6, 1, 2.2> }
          box { <10, 0.7, -2.2> <5.6, 1, -1.8> }
          box { <10, 0.7, -0.2> <5.6, 1, 0.2> }
          box { <10, 0.7, 1.8> <5.6, 1, 2.2> }
        #end
        box { <-10, -1, -10> <-6, 1, -4.1> }
        box { <-10, -1, 10> <-6, 1, 4.1> }
        box { <10, -1, -10> <6, 1, -4.1> }
        box { <10, -1, 10> <6, 1, 4.1> }
        cylinder { -1*y, 1*y, 1.5 translate <-6, 0, -5.6> }
        cylinder { -1*y, 1*y, 1.5 translate <-6, 0, 5.6> }
        cylinder { -1*y, 1*y, 1.5 translate <6, 0, -5.6> }
        cylinder { -1*y, 1*y, 1.5 translate <6, 0, 5.6> }
        cylinder { -1*y, 2*y, 2.5 }
        difference {
          box { <-4, -1, -6> <4, 1, 0> }
          cylinder { -2*y, 2*y, 5.35 scale <2.5, 1, 1> }
        }
      }
      difference {
        merge {
          box  { <0, -0.89999, -4.10001> <3.5, 0.00001, 4.10001> }
          cylinder { -0.9*y, 0*y, 4.1 translate <3.5, 0, 0> }
        }
        box { <-10, -1, -5> <-0.00001, 1, 5> }
        #if (setting > 1)
          difference {
            merge {
              box { <-1, -0.2, -2.2> <8, 1, -1.8> }
              box { <-1, -0.2, -0.2> <8, 1, 0.2> }
              box { <-1, -0.2, 2.2> <8, 1, 1.8> }
              box { <1.7, -0.20001, -3.89999> <2.1, 1, 3.89999> }
              box { <3.7, -0.20001, -3.89999> <4.1, 1, 3.89999> }
              box { <5.7, -0.20001, -3.89999> <6.1, 1, 3.89999> }
            }
            difference {
              box { <3.5, -1, -4> <8, 2, 4> }
              cylinder { -1*y, 2*y, 3.9 translate <3.5, 0, 0> }
            }
          }
        #end
        rotate -66*z translate <9.5, 0.9, 0>
      }
      difference {
        merge {
          box  { <0, -0.89999, -4.10001> <-3.5, 0.00001, 4.10001> }
          cylinder { -0.9*y, 0*y, 4.1 translate <-3.5, 0, 0> }
        }
        box { <10, -1, -5> <0.00001, 1, 5> }
        #if (setting > 1)
          difference {
            merge {
              box { <1, -0.2, -2.2> <-8, 1, -1.8> }
              box { <1, -0.2, -0.2> <-8, 1, 0.2> }
              box { <1, -0.2, 2.2> <-8, 1, 1.8> }
              box { <-1.7, -0.20001, -3.89999> <-2.1, 1, 3.89999> }
              box { <-3.7, -0.20001, -3.89999> <-4.1, 1, 3.89999> }
              box { <-5.7, -0.20001, -3.89999> <-6.1, 1, 3.89999> }
            }
            difference {
              box { <-3.5, -1, -4> <-8, 2, 4> }
              cylinder { -1*y, 2*y, 3.9 translate <-3.5, 0, 0> }
            }
          }
        #end
        rotate 66*z translate <-9.5, 0.9, 0>
      }
      difference {
        box { <-7.9, -12.8, -6.5> <7.9, 0.89999, 6.5> }
        box { <-10, -10, 0> <10, 0, 10> rotate 11*x translate <0, -7.8, 6.5> }
        box { <-10, 0, 0> <10, 10, 10> rotate -12*x translate <0, -2.5, 6.5> }
        box { <-10, -10, 0> <0, 10, 10> rotate -24*y rotate -11*z translate <-3.75, -2.5, 6.5> }
        box { <0, -10, 0> <10, 10, 10> rotate 24*y rotate 11*z translate <3.75, -2.5, 6.5> }
        box { <-10, -10, -10> <10, 0, 0> rotate -11*x translate <0, -7.8, -6.5> }
        box { <-10, 0, -10> <10, 10, 0> rotate 12*x translate <0, -2.5, -6.5> }
        box { <-10, -10, -10> <0, 10, 0> rotate 15*y rotate -11*z translate <-2.75, -2.5, -6.5> }
        box { <0, -10, -10> <10, 10, 0> rotate -15*y rotate 11*z translate <2.75, -2.5, -6.5> }
        cylinder { 0*z, -10*z, 1 translate <0, -10.5, 0> }
        box { <-1, -10, -10> <1, 0, 0> rotate -30*z translate <0, -10.5, 0> }
        box { <-1, -10, -10> <1, 0, 0> rotate 30*z translate <0, -10.5, 0> }
        box { <-8, -13, -4> <8, -0.00001, 4> }
        cylinder { -1*y, 2*y, 2.50001 }
        difference {
          box { <-8.5, -13.3, -8> <8.5, -11.8, 8> }
          box { <-6.5, -12.8, 0> <6.5, -11.8, 7> }
          cylinder { 0*z, 7*z, 1 translate <-6.5, -11.8, 0> }
          cylinder { 0*z, 7*z, 1 translate <6.5, -11.8, 0> }
          box { <-6.5, -12.3, 0> <6.5, -11.3, -7> }
          cylinder { 0*z, -7*z, 1 translate <-6.5, -11.3, 0> }
          cylinder { 0*z, -7*z, 1 translate <6.5, -11.3, 0> }
        }
        box { <-10, -5, -7> <-1, 20, 7> rotate -11*z translate <-6.5, -11.8, 0> }
        box { <1, -5, -7> <10, 20, 7> rotate 11*z translate <6.5, -11.8, 0> }
        difference {
          box { <-3.5, -4.5, -10> <3.5, 1, 0> }
          box { <0, 0, -10> <10, 10, 0> rotate -5*z translate <3.1, -4, 0> }
          box { <-10, 0, -10> <0, 10, 0> rotate 5*z translate <-3.1, -4, 0> }
          box { <-2.2, -10, -10> <1, 0, 0> rotate -12*z translate <3.1, -4, 0> }
          box { <-1, -10, -10> <2.2, 0, 0> rotate 12*z translate <-3.1, -4, 0> }
          box { <0, 0, -10> <10, 1.35, 0> rotate -45*z translate <0, -4.5, 0> }
          box { <-10, 0, -10> <0, 1.35, 0> rotate 45*z translate <0, -4.5, 0> }
        }
      }
      difference {
        box { <-7.9, -4, -6.5> <7.9, 0.89998, -4> }
        box { <-10, -5, -7> <-1, 20, 7> rotate -11*z translate <-6.49999, -11.8, 0> }
        box { <1, -5, -7> <10, 20, 7> rotate 11*z translate <6.49999, -11.8, 0> }
        box { <-10, -10, -10> <0, 10, 0> rotate 15*y rotate -11*z translate <-2.75, -2.5, -6.8> }
        box { <0, -10, -10> <10, 10, 0> rotate -15*y rotate 11*z translate <2.75, -2.5, -6.8> }
        box { <-10, 0, -10> <10, 10, 0> rotate 12*x translate <0, -2.5, -6.49998> }
        difference {
          box { <-3.5, -5, -10> <3.5, 1, 0> }
          box { <0, 0, -10> <10, 10, 0> rotate -5*z translate <3.10001, -4, 0> }
          box { <-10, 0, -10> <0, 10, 0> rotate 5*z translate <-3.10001, -4, 0> }
        }
      }
      texture { color_tex }
      bounded_by { box { <-13.5, -13, -6.7> <13.5, 5.4, 6.6> } }
    }
  #end
#end
#macro satellite_solar_panel(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -11.8*z, 11.8*z, 1.5 }
      box { <3.999999, -0.65, -11.800002> <58.6, 0.65, 11.800002> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { -11.7*z, 11.7*z, 1.5 }
      cylinder { -11.8*z, -9.8*z, 2.4 }
      cylinder { 11.8*z, 9.8*z, 2.4 }
      difference {
        cylinder { -11.800001*z, 11.800001*z, 0.9 scale <4, 1, 1> translate <4, 0, 0> }
        box { <0, -2, -9.800001> <4, 2, 9.800001> }
      }
      box { <3.999999, -0.65, -11.800002> <58.6, 0.65, 11.800002> }
      cylinder { -0.650001*y, 0.650001*y, 1 translate <58.6, 0, -10.8> }
      cylinder { -0.650001*y, 0.650001*y, 1 translate <58.6, 0, 10.8> }
      box { <58.599999, -0.650002, -10.8> <59.6, 0.650002, 10.8> }
      sphere { <20, 0, -10.25> 0.85 }
      sphere { <40, 0, -10.25> 0.85 }
      sphere { <58, 0, -10.25> 0.85 }
      sphere { <20, 0, 10.25> 0.85 }
      sphere { <40, 0, 10.25> 0.85 }
      sphere { <58, 0, 10.25> 0.85 }
      texture { color_tex }
      bounded_by { box { <-2.5, -2.5, -11.9> <59.7, 2.5, 11.9> } }
    }
  #end
#end
#macro saw_engine(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 2.5, -2.5> <11.9, 9, 2.5> }
      cylinder { -11.9*z, 11.9*z 1.5 translate <8, 5.6, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -2.5*y, 10.5*y, 1.5 }
        cylinder { 4*y, 10.5*y, 1.5 translate <8, 0, 0> }
        #if (setting < 3)
          cylinder { -5.6*x, 13.6*x, 2.4 translate <0, 5.6, 0> }
        #else
          object { open_rounded_button() rotate 90*z translate <-0.8, 5.6, 0> }
          object { open_rounded_button() rotate -90*z translate <8.8, 5.6, 0> }
        #end
        difference {
          box { <-3.9, 2.5, -2.5> <11.9, 9, 2.5> }
          #if (setting > 3)
            box { <2, 8.75, -1.3> <6, 10, 1.3> }
          #end
        }
        object { open_rounded_button() rotate 180*x translate <8, 5.6, 0> }
        #if (setting > 1)
          cylinder { -3.5*z, 3.5*z, 2.25 translate <8, 5.6, 0> }
          cylinder { -11.8*z, 11.8*z, 1.3 translate <8, 5.6, 0> }
          torus { 1.35, 0.15 rotate 90*x translate <8, 5.6, -11.75> }
          cylinder { -11.9*z, -11.7*z, 1.35 translate <8, 5.6, 0> }
          cylinder { -11.75*z, -10*z, 1.5 translate <8, 5.6, 0> }
          cylinder { -9.6*z, -9.2*z, 1.5 translate <8, 5.6, 0> }
          cylinder { -8.8*z, -8.4*z, 1.5 translate <8, 5.6, 0> }
          cylinder { -8*z, -7.6*z, 1.5 translate <8, 5.6, 0> }
          cylinder { -7.2*z, -6.8*z, 1.5 translate <8, 5.6, 0> }
          cylinder { -6.4*z, -6*z, 1.5 translate <8, 5.6, 0> }
          cylinder { -5.6*z, -3.25*z, 1.5 translate <8, 5.6, 0> }
          torus { 1.35, 0.15 rotate 90*x translate <8, 5.6, 11.75> }
          cylinder { 11.9*z, 11.7*z, 1.35 translate <8, 5.6, 0> }
          cylinder { 11.75*z, 10*z, 1.5 translate <8, 5.6, 0> }
          cylinder { 9.6*z, 9.2*z, 1.5 translate <8, 5.6, 0> }
          cylinder { 8.8*z, 8.4*z, 1.5 translate <8, 5.6, 0> }
          cylinder { 8*z, 7.6*z, 1.5 translate <8, 5.6, 0> }
          cylinder { 7.2*z, 6.8*z, 1.5 translate <8, 5.6, 0> }
          cylinder { 6.4*z, 6*z, 1.5 translate <8, 5.6, 0> }
          cylinder { 5.6*z, 3.25*z, 1.5 translate <8, 5.6, 0> }
        #else
          cylinder { -11.9*z, 11.9*z, 1.5 translate <8, 5.6, 0> }
        #end
        #if (setting > 1)
          cylinder { -3*z, 3*z, 0.375 translate <0, 7.75, 0> }
          box { <-0.375001, 3.750001, -3.000001> <0.375001, 7.750001, 3.000001> }
          cylinder { -3*z, 3*z, 0.375 translate <0, 3.75, 0> }
          cylinder { -3*z, 3*z, 0.375 translate <-1.5, 7.75, 0> }
          box { <-1.875001, 3.750001, -3.000001> <-1.125001, 7.750001, 3.000001> }
          cylinder { -3*z, 3*z, 0.375 translate <-1.5, 3.75, 0> }
          cylinder { -3*z, 3*z, 0.375 translate <1.5, 7.75, 0> }
          box { <1.125001, 3.750001, -3.000001> <1.875001, 7.750001, 3.000001> }
          cylinder { -3*z, 3*z, 0.375 translate <1.5, 3.75, 0> }
        #end
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate 180*x translate <8, 2.5, 0> }
          object { llogo() rotate 90*y translate <4, 8.75, 0> }
        #end
      }
      #if (setting > 1)
        cylinder { -6*x, 14*x, 1.600001 translate <0, 5.6, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-5.7, -2.6, -12> <13.7, 10.6, 12> } }
    }
  #end
#end
#macro scala_flower_pot(color_tex)
  merge {
    difference {
      merge {
        torus { 8.1, 1.2 scale <1, 0.9, 1> translate <0, 19.9, 0> }
        torus { 8.7, 3 scale <1, 1.5, 1> translate <0, 15.3, 0> }
        cylinder { -0.00001*y, 20.98001*y, 8.1 }
        difference {
          torus { 8.7, 3 scale <1, 5.15, 1> translate <0, 15.3, 0> }
          box { <-15, 15.30001, -15> <15, 50, 15> }
          box { <-15, -50, -15> <15, 0, 15> }
        }
      }
      #if (setting > 1)
        cylinder { 10*y, 30*y, 1.60001 }
        cylinder { 16.7*y, 30*y, 8.1 }
        cylinder { -2*y, 15*y, 8.1 }
      #end
    }
    #if (setting > 1)
      object { open_rounded_button() translate <0, 16.9, 0> }
      difference {
        cylinder { 16.6*y, 20*y, 2.40001 }
        cylinder { 16*y, 21*y, 1.60002 }
      }
      object { high_ring() scale <1, 1.8, 1> }
    #end
    texture { color_tex }
    bounded_by { cylinder { -0.1*y, 20.8*y, 11.8 } }
  }
#end
#macro seat2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      difference {
        box { <11, -3, -3.89998> <13, 13, 11.89998> rotate -6*z translate <0, 7.3, 0> }
        box { <10, 19, -5> <20, 25, 13> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            cylinder { -3.89999*z, 11.89999*z, 12 translate <1, 7.3, 0> }
            cylinder { -1.4*z, 9.4*z, 10 translate <1.1, 7.3, 0> }
            cylinder { -4*z, 12*z, 7.5 translate <3.1, 7.3, 0> }
            box { <-30, -30, -5> <12, 3.100001, 13> }
            box { <-30, 3.100002, -5> <8, 30, 13> }
            box { <0, 0, -5> <15, 20, 13> rotate -6*z translate <0, 7.3, 0> }
          }
          box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
          box { <10, -0.25, -3.900001> <12, 13.25, -1.400001> rotate -7.45*z translate <0.5, 7.199999, 0> }
          box { <10, -0.25, 9.400001> <12, 13.25, 11.900001> rotate -7.45*z translate <0.5, 7.199999, 0> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
          #end
          difference {
            box { <11, 0, -3.89998> <13, 13.25, 11.89998> rotate -6*z translate <0, 7.3, 0> }
            box { <10, 19.200003, -5> <20, 25, 13> }
          }
        }
        box { <-40, -5, -10> <-3.900001, 50, 50> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
        #end
        difference {
          box { <-4.9, -1, -4.9> <-2.9, 4, -2.9> }
          cylinder { -2*y, 5*y, 1 translate <-2.9, 0, -2.9> }
        }
        difference {
          box { <-4.9, -1, 10.9> <-2.9, 4, 12.9> }
          cylinder { -2*y, 5*y, 1 translate <-2.9, 0, 10.9> }
        }
        difference {
          box { <10, 17.2, -5> <16, 20, -1.9> }
          cylinder { 9*x, 17*x, 2 translate <0, 17.2, -1.9> }
        }
        difference {
          box { <10, 17.2, 9.9> <16, 20, 13> }
          cylinder { 9*x, 17*x, 2 translate <0, 17.2, 9.9> }
        }
        box { <10, 19.200001, -5> <16, 20, 13> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <16, 19.1, 12> } }
    }
  #end
#end
#macro sextant(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -7*y, 8.6*y, 1.5 }
      cylinder { -7.9*x, 5.5*x, 2.4 translate <0, 6.5, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -7*y, 8.45*y, 1.5 }
        torus { 1.35, 0.15 translate <0, -7, 0> }
        torus { 1.35, 0.15 translate <0, 8.45, 0> }
        cylinder { 8*y, 8.6*y, 1.35 }
        cylinder { -5*x, 4*x, 1.5 translate <0, 6.5, 0> }
        cylinder { 3.5*x, 5*x, 1.3 translate <0, 6.5, 0> }
        cylinder { 4.75*x, 5.5*x, 1.5 translate <0, 6.5, 0> }
        cylinder { -4.6*x, -3.5*x, 2.2 translate <0, 6.5, 0> }
        cylinder { -7.75*x, -4.5*x, 2.4 translate <0, 6.5, 0> }
        torus { 2.25, 0.15 rotate 90*z translate <-7.75, 6.5, 0> }
        box { <-5.7, 8.8, -0.3> <-4.500005, 9.4, 0.3> }
        box { <-3.5, 4, -0.7> <2.2, 6.5, 0.7> }
        sphere { <0, -8.6, 0> 1.5 }
        cylinder { -8.6*y, -6*y, 1.2 }
        cylinder { 0*z, -3.1*z, 1.5 translate <0, 5.5, 0> }
        difference {
          cylinder { -0.8*z, 0.8*z, 10.9 }
          cylinder { -1*z, 1*z, 8.9 }
          box { <-20, 0, -1> <20, 20, 1> }
          box { <-20, -20, -1> <0, 20, 1> }
          rotate -45*z translate <0, 6.5, 0>
        }
        cylinder { -0.800005*z, 0.800005*z, 1 translate <9.9, 0, 0> 
          rotate -45*z translate <0, 6.5, 0> }
        cylinder { -0.800005*z, 0.800005*z, 1 translate <9.9, 0, 0> 
          rotate -135*z translate <0, 6.5, 0> }
        box { <-0.6, -9.9, -0.700005> <0.6, 0, 0.700005> rotate -45*z translate <0, 6.5, 0> }
        box { <-0.6, -9.9, -0.700006> <0.6, 0, 0.700006> rotate 45*z translate <0, 6.5, 0> }
      }
      cylinder { 3*x, 6*x, 0.8 translate <0, 6.5, 0> }
      cylinder { -4*z, -0.6*z, 0.65 translate <0, 5.5, 0> }
      cylinder { -8*x, -3.9*x, 1.6 translate <0, 6.5, 0> }
      #local counter = 0;
      #while (counter < 14)
        box { <-0.15, -10.7, -2> <0.15, -9.1, -0.6> rotate ((counter*7.5)-49.25)*z translate <0, 6.5, 0> }
        box { <-0.15, -10.7, 0.6> <0.15, -9.1, 2> rotate ((counter*7.5)-49.25)*z translate <0, 6.5, 0> }
        #local counter = counter + 1;
        #if (counter = 6)
          #local counter = 8;
        #end
      #end
      texture { color_tex }
      bounded_by { box { <-8.6, -10.2, -3.2> <8.6, 9.5, 2.5> } }
    }
  #end
#end
#macro ship_steering_wheel(color_tex)
  #if (setting = 0)
    merge {
      torus { 11.5, 1.5 rotate 90*z translate <9.25, 0, 0> }
      difference {
        cylinder { 6*x, 9.25*x, 13 }
        cylinder { 5*x, 10*x, 10 }
      }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        torus { 2.249995, 0.3 rotate 90*z translate <-3.600005, 0, 0> }
        cylinder { -3.9*x, 11.8*x, 2.25 }
        cylinder { 3.35*x, 4.65*x, 3 }
        cylinder { 4*x, 11.5*x, 3.6 }
        #if (setting < 3)
          cylinder { 11.4*x, 13.2*x, 2.4 }
        #else
          object { rounded_button() rotate -90*z translate <8.4, 0, 0> }
        #end
        #local counter = 0;
        #while (counter < 8)
          cylinder { 0*y, 19.5*y, 1.5 rotate (counter*45)*x translate <8, 0, 0> }
          sphere { <8, 19.499999, 0> 1.500001 rotate (counter*45)*x }
          #local counter = counter + 1;
        #end
        torus { 11.5, 1.5 rotate 90*z translate <9.249999, 0, 0> }
        difference {
          cylinder { 6*x, 9.25*x, 13 }
          cylinder { 5*x, 10*x, 10 }
        }
      }
      cylinder { -4*x, 3.35*x, 1.6 }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 13.3*x, 21.1 } }
    }
  #end
#end
#macro ship_window(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 19.1, 59.9> }
      box { <-20, -20, -10> <0, 20, 70> rotate 23.25*z translate <4, 0, 0> }
      box { <-4, 3.1, -2.75> <11, 18.1, 57.75> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 19.1, 59.9> }
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 19*y, 20.8*y, 2.4 translate <8, 0, 56> }
            cylinder { 19*y, 20.8*y, 2.4 }
            cylinder { 19*y, 20.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 19*y, 20.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 19*y, 20.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 19*y, 20.8*y, 2.4 translate <0, 0, 32> }
            cylinder { 19*y, 20.8*y, 2.4 translate <0, 0, 40> }
            cylinder { 19*y, 20.8*y, 2.4 translate <0, 0, 48> }
            cylinder { 19*y, 20.8*y, 2.4 translate <0, 0, 56> }
          #else
            object { rounded_button() rotate -90*y translate <8, 16, 0> }
            object { rounded_button() rotate -90*y translate <8, 16, 56> }
            object { rounded_button() rotate -90*y translate <0, 16, 0> }
            object { rounded_button() rotate -90*y translate <0, 16, 8> }
            object { rounded_button() rotate -90*y translate <0, 16, 16> }
            object { rounded_button() rotate -90*y translate <0, 16, 24> }
            object { rounded_button() rotate -90*y translate <0, 16, 32> }
            object { rounded_button() rotate -90*y translate <0, 16, 40> }
            object { rounded_button() rotate -90*y translate <0, 16, 48> }
            object { rounded_button() rotate -90*y translate <0, 16, 56> }
          #end
        }
        box { <4, 16, 4> <12, 20, 52> }
        box { <-20, -20, -10> <0, 20, 70> rotate 23.25*z translate <4, 0, 0> }
        difference {
          box { <-2.4, 3.1, -2.4> <12, 18.1, 58.4> }
          box { <-20, -20, -10> <1, 20, 70> rotate 23.25*z translate <5, 0, 0> }
        }
        #if (setting > 1)
          box { <5.6, -1, -2.4> <10.4, 2, 58.4> }
          cylinder { 17*y, 20*y, 1.2 translate <8, 0, 0> }
          cylinder { 17*y, 20*y, 1.2 translate <8, 0, 56> }
          cylinder { 17*y, 20*y, 1.2 }
          cylinder { 17*y, 20*y, 1.2 translate <0, 0, 8> }
          cylinder { 17*y, 20*y, 1.2 translate <0, 0, 16> }
          cylinder { 17*y, 20*y, 1.2 translate <0, 0, 24> }
          cylinder { 17*y, 20*y, 1.2 translate <0, 0, 32> }
          cylinder { 17*y, 20*y, 1.2 translate <0, 0, 40> }
          cylinder { 17*y, 20*y, 1.2 translate <0, 0, 48> }
          cylinder { 17*y, 20*y, 1.2 translate <0, 0, 56> }
        #end
        cylinder { -4*x, 12*x, 1.5 translate <0, 16.6, -1.25> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 4.6, -1.25> }
        box { <-4, 3.100001, -1.250001> <12, 18.100001, 9.750001> }
        box { <-4, 4.599999, -2.750001> <12, 16.600001, 11.250001> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 16.6, 9.75> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 4.6, 9.75> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 16.6, 15.25> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 4.6, 15.25> }
        box { <-4, 3.100001, 15.250001> <12, 18.100001, 25.250001> }
        box { <-4, 4.599999, 13.750001> <12, 16.600001, 26.750001> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 16.6, 25.25> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 4.6, 25.25> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 16.6, 30.75> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 4.6, 30.75> }
        box { <-4, 3.100001, 30.750001> <12, 18.100001, 40.750001> }
        box { <-4, 4.599999, 29.250001> <12, 16.600001, 42.250001> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 16.6, 40.75> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 4.6, 40.75> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 16.6, 46.25> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 4.6, 46.25> }
        box { <-4, 3.100001, 46.250001> <12, 18.100001, 56.250001> }
        box { <-4, 4.599999, 44.750001> <12, 16.600001, 57.750001> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 16.6, 56.25> }
        cylinder { -4*x, 12*x, 1.5 translate <0, 4.6, 56.25> }
        cylinder { -4*z, 60*z, 1.5 translate <8.5, 4.6, 0> }
        cylinder { -4*z, 60*z, 1.5 translate <8.5, 16.6, 0> }
        cylinder { -4*z, 60*z, 1.5 translate <5.5, 4.6, 0> }
        cylinder { -4*z, 60*z, 1.5 translate <0.4, 16.6, 0> }
        box { <5.499999, 3.100001, -4> <8.500001, 18.100001, 60> }
        box { <7.5, 4.600001, -4> <10.000001, 16.600001, 60> }
        box { <0.399999, 15.000001, -4> <7.5, 18.099999, 60> }
        difference {
          box { <-1, 0, -4> <4, 12.5, 60> rotate 23.25*z translate <5, 4.6, 0> }
          box { <-4, 18.099998, -5> <12, 30, 61> }
        }
        box { <3, 11, -4> <7, 16, 60> }
      }
      #if (setting > 1)
        object { pin(2) translate <8, 0, 4> }
        object { pin(2) translate <8, 0, 12> }
        object { pin(2) translate <8, 0, 20> }
        object { pin(2) translate <8, 0, 28> }
        object { pin(2) translate <8, 0, 36> }
        object { pin(2) translate <8, 0, 44> }
        object { pin(2) translate <8, 0, 52> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 20.9, 60> } }
    }
  #end
#end
#macro ship_window_glass(color_tex)
  #if (setting = 0)
    difference {
      box { <-4, 3.1, -2.75> <11, 18.1, 57.75> }
      box { <-20, -20, -10> <1, 20, 70> rotate 23.25*z translate <4, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      box { <-3.9, 3.100001, -3.899999> <11.9, 18.1, 59.899999> }
      object { ship_window(color_tex) }
      box { <-20, -20, -10> <1, 20, 70> rotate 23.25*z translate <4, 0, 0> }
      box { <4, 16, 4> <12, 19, 52> }
      difference {
        box { <-2.9, 2, -1.4> <12, 17.1, 57.4> }
        box { <-20, -20, -10> <2, 20, 60> rotate 23.25*z translate <4, 0, 0> }
      }
      box { <11.899999, 0, -10> <20, 20, 70> }
      texture { color_tex }
    }
  #end
#end
#macro shoulders(color_tex)
  #if (setting = 0)
    box { <-9.9, 0, -3> <9.9, 1.2, 3> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-6.4, 0, -3> <6.4, 1.2, 3> }
        cylinder { 0.000001*y, 1.200001*y, 3.9 }
        cylinder { 0.000001*y, 1.200001*y, 2.99999 translate <-6.4, 0, 0> }
        cylinder { 0.000001*y, 1.200001*y, 2.99999 translate <6.4, 0, 0> }
        torus { 2.25, 0.25 translate <-6.4, 1.2, 0> }
        torus { 2.25, 0.25 translate <6.4, 1.2, 0> }
        torus { 0.9, 0.25 translate <-6.4, 1.2, 0> }
        torus { 0.9, 0.25 translate <6.4, 1.2, 0> }
        sphere { <3.9, 0, 0> 0.9 scale <0.75, 1, 0.75> rotate <0, 90, 13> translate <6.4, -0.7, 0> }
        sphere { <3.9, 0, 0> 0.9 scale <0.75, 1.3, 0.75> rotate <0, 70, 13> translate <6.4, -0.9, 0> }
        sphere { <3.9, 0, 0> 0.9 scale <0.75, 1.6, 0.75> rotate <0, 50, 13> translate <6.4, -1.1, 0> }
        sphere { <3.9, 0, 0> 0.9 scale <0.75, 1.9, 0.75> rotate <0, 30, 13> translate <6.4, -1.3, 0> }
        sphere { <3.9, 0, 0> 0.9 scale <0.75, 2.1, 0.75> rotate <0, 10, 13> translate <6.4, -1.4, 0> }
        sphere { <3.9, 0, 0> 0.9 scale <0.75, 2.1, 0.75> rotate <0, -10, 13> translate <6.4, -1.4, 0> }
        sphere { <3.9, 0, 0> 0.9 scale <0.75, 1.9, 0.75> rotate <0, -30, 13> translate <6.4, -1.3, 0> }
        sphere { <3.9, 0, 0> 0.9 scale <0.75, 1.6, 0.75> rotate <0, -50, 13> translate <6.4, -1.1, 0> }
        sphere { <3.9, 0, 0> 0.9 scale <0.75, 1.3, 0.75> rotate <0, -70, 13> translate <6.4, -0.9, 0> }
        sphere { <3.9, 0, 0> 0.9 scale <0.75, 1, 0.75> rotate <0, -90, 13> translate <6.4, -0.7, 0> }
        sphere { <-3.9, 0, 0> 0.9 scale <0.75, 1.4, 0.75> rotate <0, 90, -13> translate <-6.4, -0.7, 0> }
        sphere { <-3.9, 0, 0> 0.9 scale <0.75, 1.6, 0.75> rotate <0, 70, -13> translate <-6.4, -0.9, 0> }
        sphere { <-3.9, 0, 0> 0.9 scale <0.75, 1.8, 0.75> rotate <0, 50, -13> translate <-6.4, -1.1, 0> }
        sphere { <-3.9, 0, 0> 0.9 scale <0.75, 2, 0.75> rotate <0, 30, -13> translate <-6.4, -1.3, 0> }
        sphere { <-3.9, 0, 0> 0.9 scale <0.75, 2.1, 0.75> rotate <0, 10, -13> translate <-6.4, -1.4, 0> }
        sphere { <-3.9, 0, 0> 0.9 scale <0.75, 2.1, 0.75> rotate <0, -10, -13> translate <-6.4, -1.4, 0> }
        sphere { <-3.9, 0, 0> 0.9 scale <0.75, 2, 0.75> rotate <0, -30, -13> translate <-6.4, -1.3, 0> }
        sphere { <-3.9, 0, 0> 0.9 scale <0.75, 1.8, 0.75> rotate <0, -50, -13> translate <-6.4, -1.1, 0> }
        sphere { <-3.9, 0, 0> 0.9 scale <0.75, 1.6, 0.75> rotate <0, -70, -13> translate <-6.4, -0.9, 0> }
        sphere { <-3.9, 0, 0> 0.9 scale <0.75, 1.4, 0.75> rotate <0, -90, -13> translate <-6.4, -0.7, 0> }
      }
      cylinder { -1*y, 2*y, 2.5 }
      cone { -0.000001*y, 1.9, -3*y, 2.5 translate <-6.4, 0, 0> }
      cone { -0.000001*y, 1.9, -3*y, 2.5 translate <6.4, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-10, -4, -4.5> <10, 1.55, 4.5> } }
    }
  #end
#end
#macro shovel_arms(color_tex)
  #if (setting = 0)
    merge {
      box { <-18, -3.000001, -5.500001> <3, 3.000001, -4.000001> }
      box { <-18, -3.000001, 12.000001> <3, 3.000001, 13.500001> }
      box { <-19.5, -6, -5.500002> <0, 0, -4.000002> rotate 59*z translate <-18, 2.999999, 0> }
      box { <-19.500002, -6, 12> <0, 0, 13.5> rotate 59*z translate <-18, 2.999999, 0> }
      box { <-19.500001, -6.000001, -5.499999> <-18, 0.000001, 13.499998>
        rotate 59*z translate <-18, 3, 0> }
      cylinder { -3.75*z, 11.75*z, 1.500001 translate <-26, -1.5, 0> rotate 59*z translate <-18, 3, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -4.1*z, -1.5*z, 2 }
        cone { -1.500001*z, 2, -1*z, 1.5 }
        cone { 9*z, 1.5, 9.500001*z, 2 }
        cylinder { 9.5*z, 12*z, 2 }
        cylinder { -5.5*z, -4*z, 3 }
        cylinder { 12*z, 13.5*z, 3 }
        box { <-18, -3.000001, -5.500001> <0, 3.000001, -4.000001> }
        box { <-18, -3.000001, 12.000001> <0, 3.000001, 13.500001> }
        box { <-2, 0, -6.75> <2, 8, -5.499999> }
        cylinder { -6.749999*z, -5.500001*z, 1.999999 translate <0, 8, 0> }
        box { <-2, 0, 13.499999> <2, 8, 14.75> }
        cylinder { 13.499999*z, 14.7500001*z, 1.999999 translate <0, 8, 0> }
        box { <-17, -1, -6.750001> <2.000001, 1, -5.4> }
        box { <-17, -1, 13.4> <2.000001, 1, 14.750001> }
        box { <-19.5, -6, -5.500002> <0, 0, -4.000002> rotate 59*z translate <-18, 2.999999, 0> }
        box { <-18.4, -2, -6.750003> <0, 0, -5.4> rotate 59*z translate <-17, 0.999999, 0> }
        box { <-19.500002, -6, 12> <0, 0, 13.5> rotate 59*z translate <-18, 2.999999, 0> }
        box { <-18.400002, -2, 13.250003> <0, 0, 14.750003>
          rotate 59*z translate <-17, 0.999999, 0> }
        box { <-19.500001, -6.000001, -5.499999> <-18, 0.000001, 13.499998>
          rotate 59*z translate <-18, 3, 0> }
        box { <-18.4, -3.25, -5> <-13.5, -2, 13> rotate 59*z translate <-18, 3, 0> }
        box { <-26.000001, -3, -2.25> <-19, 0, 10.25> rotate 59*z translate <-18, 3, 0> }
        cylinder { -3.75*z, 11.75*z, 1.500001 translate <-26, -1.5, 0> rotate 59*z translate <-18, 3, 0> }
        box { <-5, 0, -2.250001> <0, 3, -0.500001> rotate -45*z translate <-19.5, -6, 0>
          rotate 59*z translate <-18, 3, 0> }
        box { <-5, 0, 8.500001> <0, 3, 10.250001> rotate -45*z translate <-19.5, -6, 0>
          rotate 59*z translate <-18, 3, 0> }
      }
      box { <-2, -6, -2> <0, 0, 1> rotate -45*y translate <-19.4, 0, -5.4>
        rotate 59*z translate <-18, 3, 0> }
      box { <-2, -6, -2> <0, 0, 2> rotate 45*y translate <-19.4, 0, 13.4>
        rotate 59*z translate <-18, 3, 0> }
      box { <-3, -6, 0> <0, 0, 3> rotate 45*y translate <-13.5, 0, -4>
        rotate 59*z translate <-18, 3, 0> }
      box { <-3, -6, -3> <0, 0, 0> rotate -45*y translate <-13.5, 0, 12>
        rotate 59*z translate <-18, 3, 0> }
      box { <-15.6, -6, -1.75> <-13, 0, 10> rotate 59*z translate <-18, 3, 0> }
      box { <-30, -6, 3> <-24.5, 1, 5> rotate 59*z translate <-18, 3, 0> }
      box { <-26, -6, -0.5> <-19.500001, -1, 1.5> rotate 59*z translate <-18, 3, 0> }
      box { <-26, -6, 6.5> <-19.500001, -1, 8.500002> rotate 59*z translate <-18, 3, 0> }
      box { <-23, -6, -0.5> <-19.500002, -1.000001, 8.5> rotate 59*z translate <-18, 3, 0> }
      texture { color_tex }
      bounded_by { box { <-32, -23, -6.85> <2.1, 10.1, 14.85> } }
    }
  #end
#end
#macro shovel_piece(color_tex)
  #if (setting = 0)
    difference {
      box { <-20, -3.1, -11.9> <-1.55, 6.4, 19.9> }
      box { <-50, -50, -50> <50, 0, 50> rotate -45*z translate <-9.35, -3.1, 0> }
      box { <-50, 0, -50> <50, 50, 50> rotate 45*z translate <-17, 6.4, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-20, -3.1, -11.9> <-1.55, 6.4, 19.9> }
        box { <-50, -50, -50> <50, 0, 50> rotate -45*z translate <-9.35, -3.1, 0> }
        box { <-50, 0, -50> <50, 50, 50> rotate 45*z translate <-17, 6.4, 0> }
        difference {
          box { <-19, -2, -10.4> <-3.15, 7, 18.4> }
          box { <-50, -50, -50> <50, 0, 50> rotate -45*z translate <-9, -1.1, 0> }
        }
      }
      difference {
        merge {
          box { <0, 0, -4> <14, 12, -2.5> rotate -20*z translate <-9.35, -3.1, 0> }
          box { <0, 0, 10.5> <14, 12, 12> rotate -20*z translate <-9.35, -3.1, 0> }
        }
        box { <-5, 6.400001, -5> <0, 9, 13> }
        box { <-9.35, -2, -10.4> <-3.050001, 10, 18.4> }
        cylinder { -12*z, 20*z, 1.55 }
        difference {
          box { <-2.549999, -8, -4.5> <20, 8, 12.5> }
          cylinder { -5*z, 13*z, 6 translate <-2, 0, 0> }
        }
        box { <0, -1.2, -5> <10, 1.2, 13> rotate 7*z }
        box { <0, -1.2, -5> <10, 1.2, 13> rotate -7*z }
        difference {
          box { <3.5, -1.7, -5> <10, 0, 13> }
          cylinder { -6*z, 14*z, 0.5 translate <3.5, -1.7, 0> }
          rotate -7*z
        }
        difference {
          box { <3.5, 1.7, -5> <10, 0, 13> }
          cylinder { -6*z, 14*z, 0.5 translate <3.5, 1.7, 0> }
          rotate 7*z
        }
      }
      #if (setting > 3)
        object { llogo() translate <-6, -2, 0> }
      #end
      cylinder { 3*z, 5*z, 1.5 }
      box { <-1.6, -1.500001, 3.000001> <0.000001, 1.500001, 5.000001> }
      texture { color_tex }
      bounded_by { box { <-20.1, -6, -12> <3.6, 6.5, 20> } }
    }
  #end
#end
#macro shovel_piece_large(color_tex)
  #if (setting = 0)
    difference {
      box { <-17, 3, -23.4> <17, 20, 23.4> }
      box { <0, 0, -25> <20, 25, 25> rotate -27*z translate <5.5, 3, 0> }
      box { <-40, 3.000001, -25> <10, 20, 25> rotate -9*z translate <12, 12.75, 0> }
      box { <-40, 0, -25> <0, 30, 25> rotate 25*z translate <-7, 3, 0> }
      box { <-10, 0, -25> <10, 10, 25> rotate 9*z translate <-14, 19.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-17, 3, -23.4> <17, 20, 23.4> }
            box { <0, 0, -25> <20, 20, 25> rotate -27*z translate <5.5, 3, 0> }
          }
          box { <-30, 0, -23.9> <0, 3, 23.9> rotate -9*z translate <12, 12.75, 0> }
        }
        box { <-40, 3.000001, -25> <10, 20, 25> rotate -9*z translate <12, 12.75, 0> }
        box { <-40, 0, -25> <0, 30, 25> rotate 25*z translate <-7, 3, 0> }
        box { <-10, 0, -25> <10, 10, 25> rotate 9*z translate <-14, 19.5, 0> }
        difference {
          box { <-16, 4, -22.4> <16, 30, 22.4> }
          box { <0, 0, -25> <20, 20, 25> rotate -27*z translate <4.5, 4, 0> }
          box { <-40, 0, -25> <0, 30, 25> rotate 25*z translate <-6.5, 4, 0> }
        }
      }
      difference {
        merge {
          box { <0, 0, -22> <2, 8.75, -18.8> }
          box { <0, 0, -15.2> <2, 8.75, -12> }
          box { <0, 0, -8.4> <2, 8.75, -5.2> }
          box { <0, 0, -1.6> <2, 8.75, 1.6> }
          box { <0, 0, 5.2> <2, 8.75, 8.4> }
          box { <0, 0, 12> <2, 8.75, 15.2> }
          box { <0, 0, 18.8> <2, 8.75, 22> }
        }
        box { <0, 0, -30> <10, 10, 30> rotate 14*z translate <2, 5, 0> }
        box { <0, -10, -30> <10, 0, 30> rotate -15*z translate <2, 1.5, 0> }
        translate <-14.3735, 0, 0> rotate 25*z translate <0, 22, 0>
      }
      difference {
        merge {
          cylinder { 6.5*z, 7.8*z, 5.5 translate <0, 3, 0> }
          cylinder { -6.500002*z, -7.800002*z, 5.5 translate <0, 3, 0> }
          cylinder { 6.5*z, 7.8*z, 5.5 translate <-0.85, 3, 0> }
          cylinder { -6.5*z, -7.8*z, 5.5 translate <-0.85, 3, 0> }
          box { <0, 0, -7.800001> <5, 5, -6.500001> rotate 25*z translate <-5.5, 0, 0> }
          box { <0, 0, 6.500001> <5, 5, 7.800001> rotate 25*z translate <-5.5, 0, 0> }
        }
        cylinder { -10*z, 10*z, 1.55 }
        box { <-1.2, -10, -10> <1.2, 0, 10> rotate 8*z }
        box { <-1.2, -10, -10> <1.2, 0, 10> rotate -8*z }
        box { <-20, 3.5, -30> <20, 20, 30> }
      }
      #if (setting > 3)
        object { llogo() rotate 180*y translate <0, 4, 0> }
      #end
      box { <-2, -1.000001, -0.75> <-0.5, 3.5, 0.75> }
      box { <-1.000001, -2.000001, -0.750001> <0, 3.5, 0.750001> }
      cylinder { -0.750002*z, 0.750002*z, 1 translate <-1, -1, 0> }
      texture { color_tex }
      bounded_by { box { <-18, -2.6, -24> <12, 27, 24> } }
    }
  #end
#end
#macro shovel_piece_small(color_tex)
  #if (setting = 0)
    difference {
      box { <-7.9, -25.1, -9.9> <7.9, -1.55, -2.100001> }
      difference {
        box { <-8, -30, -10> <8, -9.35, -3.1> }
        cylinder { -9*x, 9*x, 21.5 translate <0, -9.35, 11.6> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.85, -2, -3.6> <3.85, 1.55, -2.1> }
          box { <-2.25, -1.550001, -2.2> <-0.65, 1.550001, 0.000001> }
          cylinder { -2.249999*x, -0.650001*x, 1.55 }
          box { <0.65, -1.550001, -2.2> <2.25, 1.550001, 0.000001> }
          cylinder { 0.650001*x, 2.249999*x, 1.55 }
          box { <-7.9, -25.1, -9.9> <7.9, -1.55, -2.100001> }
          object { open_rounded_button() translate <-4, -4.65, -6> }
          object { open_rounded_button() translate <4, -4.65, -6> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <-4, -1.55, -6> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <4, -1.55, -6> }
          #end
        }
        difference {
          box { <-8, -30, -10> <8, -9.35, -3.1> }
          cylinder { -9*x, 9*x, 21.5 translate <0, -9.35, 11.6> }
        }
        #if (setting > 1)
          box { <-6.4, -7.85, -10> <6.4, -3.05, -7.9> }
        #end
        difference {
          box { <-6.4, -24.1, -9> <6.4, -3.05, 0> }
          difference {
            box { <-8, -25, -10> <8, -9.35, 1> }
            cylinder { -9*x, 9*x, 20.5 translate <0, -9.35, 10.6> }
          }
          box { <-9, -9.35, -10> <9, -1, -6.7> }
        }
      }
      #if (setting > 1)
        cylinder { -9.9*z, -7.8*z, 1.5 translate <0, -5.45, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-8, -25.2, -10> <8, 1.65, 1.65> } }
    }
  #end
#end
#macro shutter(color_tex)
  #if (setting = 0)
    box { <-30, -8.7, -0.9> <30, -1.9, 0.9> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -33.9*x, -30*x, 1.5 }
        cylinder { 30*x, 33.9*x, 1.5 }
        sphere { <-30.5, 0, 0> 1 }
        sphere { <30.5, 0, 0> 1 }
        box { <-32, -6.1, -0.9> <-30, 0, 0.9> }
        box { <30, -6.1, -0.9> <32, 0, 0.9> }
        box { <-30.000001, -8.700001, -0.900001> <30.000001, -1.9, 0.900001> }
        cylinder { -30.000002*x, 30.000002*x, 0.9 translate <0, -8.7, 0> }
      }
      sphere { <-30.5, -8.7, 0> 1.1 }
      sphere { <30.5, -8.7, 0> 1.1 }
      box { <-28.8, -8.7, -1> <-15.1, -2.9, -0.3> }
      box { <-14.1, -8.7, -1> <-0.5, -2.9, -0.3> }
      box { <28.8, -8.7, -1> <15.1, -2.9, -0.3> }
      box { <14.1, -8.7, -1> <0.5, -2.9, -0.3> }
      texture { color_tex }
      bounded_by { box { <-34, -9.7, -1.6> <34, 1.6, 1.6> } }
    }
  #end
#end
#macro shutter_with_handle(color_tex)
  #if (setting = 0)
    merge {
      box { <-30, -8.7, -0.9> <30, -1.9, 0.9> }
      difference {
        cylinder { -2.4*z, 2.4*z, 2.3 }
        box { <-3, 0.9, -3> <3, 5, 3> }
        box { <-3, -5, -3> <3, -0.9, 3> }
        translate <0, -4.5, 0>
      }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -33.9*x, -30*x, 1.5 }
        cylinder { 30*x, 33.9*x, 1.5 }
        cylinder { -33.9*x, -30*x, 1.5 translate <0, -8.1, 0> }
        cylinder { 30*x, 33.9*x, 1.5 translate <0, -8.1, 0> }
        sphere { <-30.5, 0, 0> 1 }
        sphere { <30.5, 0, 0> 1 }
        box { <-32, -6.1, -0.9> <-30, 0, 0.9> }
        box { <30, -6.1, -0.9> <32, 0, 0.9> }
        box { <-32.000001, -8.700001, -0.900001> <32.000001, -1.9, 0.900001> }
        cylinder { -32.000002*x, 32.000002*x, 0.9 translate <0, -8.7, 0> }
        difference {
          cylinder { -2.4*z, 2.4*z, 2.3 }
          box { <-3, 0.9, -3> <3, 5, 3> }
          box { <-3, -5, -3> <3, -0.9, 3> }
          translate <0, -4.5, 0>
        }
      }
      box { <-28.8, -8.7, -1> <-15.1, -2.9, -0.3> }
      box { <-14.1, -8.7, -1> <-0.5, -2.9, -0.3> }
      box { <28.8, -8.7, -1> <15.1, -2.9, -0.3> }
      box { <14.1, -8.7, -1> <0.5, -2.9, -0.3> }
      texture { color_tex }
      bounded_by { box { <-34, -9.7, -2.5> <34, 1.6, 2.5> } }
    }
  #end
#end
#macro shuttle_wheel()
  #if (setting = 0)
    cylinder { -2*z, 2*z, 5.5 texture { r_black_tex } }
  #else
    merge {
      difference {
        cylinder { -2*z, 2*z, 2.8 }
        cylinder { -3*z, 3*z, 1.6 }
        texture { white_tex }
      }
      difference {
        merge {
          torus { 4.75, 0.75 rotate 90*x translate <0, 0, -1.25> }
          torus { 4.75, 0.75 rotate 90*x translate <0, 0, 1.25> }
          cylinder { -1.250001*z, 1.250001*z, 5.500001 }
          cylinder { -2.000001*z, 2.000001*z, 4.750001 }
        }
        cylinder { -3*z, 3*z, 2.799999 }
        texture { r_black_tex }
      }
      bounded_by { cylinder { -2.1*z, 2.1*z, 5.6 } }
    }
  #end
#end
#macro shuttle_wing(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <107.9, 3.1, 123.9> }
      box { <0, -1, -50> <50, 4, 0> rotate 45*y translate <60, 0, 28> }
      box { <-80, -1, -50> <0, 4, 0> rotate 13.5*y translate <60, 0, 28> }
      box { <0, -1, 0> <50, 4, 50> rotate -45*y translate <60, 0, 92> }
      box { <-80, -1, 0> <0, 4, 50> rotate -13.5*y translate <60, 0, 92> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <107.9, 3.1, 123.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 80> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 80> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 80> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 80> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 80> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 88> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 80> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 88> }
            cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 96> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 80> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 88> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 96> }
            cylinder { 3*y, 4.8*y, 2.4 translate <80, 0, 104> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 80> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 88> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 96> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 104> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 112> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 80> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 88> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 96> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 104> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 112> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 120> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 64> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 72> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 80> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 88> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 96> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 104> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 112> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 120> }
          #else
            object { rounded_button() translate <0, 0, 48> }
            object { rounded_button() translate <0, 0, 56> }
            object { rounded_button() translate <0, 0, 64> }
            object { rounded_button() translate <0, 0, 72> }
            object { rounded_button() translate <8, 0, 48> }
            object { rounded_button() translate <8, 0, 56> }
            object { rounded_button() translate <8, 0, 64> }
            object { rounded_button() translate <8, 0, 72> }
            object { rounded_button() translate <16, 0, 48> }
            object { rounded_button() translate <16, 0, 56> }
            object { rounded_button() translate <16, 0, 64> }
            object { rounded_button() translate <16, 0, 72> }
            object { rounded_button() translate <24, 0, 48> }
            object { rounded_button() translate <24, 0, 56> }
            object { rounded_button() translate <24, 0, 64> }
            object { rounded_button() translate <24, 0, 72> }
            object { rounded_button() translate <32, 0, 40> }
            object { rounded_button() translate <40, 0, 40> }
            object { rounded_button() translate <48, 0, 40> }
            object { rounded_button() translate <56, 0, 40> }
            object { rounded_button() translate <32, 0, 48> }
            object { rounded_button() translate <40, 0, 48> }
            object { rounded_button() translate <48, 0, 48> }
            object { rounded_button() translate <56, 0, 48> }
            object { rounded_button() translate <32, 0, 56> }
            object { rounded_button() translate <40, 0, 56> }
            object { rounded_button() translate <48, 0, 56> }
            object { rounded_button() translate <56, 0, 56> }
            object { rounded_button() translate <32, 0, 64> }
            object { rounded_button() translate <40, 0, 64> }
            object { rounded_button() translate <48, 0, 64> }
            object { rounded_button() translate <56, 0, 64> }
            object { rounded_button() translate <32, 0, 72> }
            object { rounded_button() translate <40, 0, 72> }
            object { rounded_button() translate <48, 0, 72> }
            object { rounded_button() translate <56, 0, 72> }
            object { rounded_button() translate <32, 0, 80> }
            object { rounded_button() translate <40, 0, 80> }
            object { rounded_button() translate <48, 0, 80> }
            object { rounded_button() translate <56, 0, 80> }
            object { rounded_button() translate <64, 0, 32> }
            object { rounded_button() translate <64, 0, 40> }
            object { rounded_button() translate <64, 0, 48> }
            object { rounded_button() translate <64, 0, 56> }
            object { rounded_button() translate <64, 0, 64> }
            object { rounded_button() translate <64, 0, 72> }
            object { rounded_button() translate <64, 0, 80> }
            object { rounded_button() translate <64, 0, 88> }
            object { rounded_button() translate <72, 0, 24> }
            object { rounded_button() translate <72, 0, 32> }
            object { rounded_button() translate <72, 0, 40> }
            object { rounded_button() translate <72, 0, 48> }
            object { rounded_button() translate <72, 0, 56> }
            object { rounded_button() translate <72, 0, 64> }
            object { rounded_button() translate <72, 0, 72> }
            object { rounded_button() translate <72, 0, 80> }
            object { rounded_button() translate <72, 0, 88> }
            object { rounded_button() translate <72, 0, 96> }
            object { rounded_button() translate <80, 0, 16> }
            object { rounded_button() translate <80, 0, 24> }
            object { rounded_button() translate <80, 0, 32> }
            object { rounded_button() translate <80, 0, 40> }
            object { rounded_button() translate <80, 0, 48> }
            object { rounded_button() translate <80, 0, 56> }
            object { rounded_button() translate <80, 0, 64> }
            object { rounded_button() translate <80, 0, 72> }
            object { rounded_button() translate <80, 0, 80> }
            object { rounded_button() translate <80, 0, 88> }
            object { rounded_button() translate <80, 0, 96> }
            object { rounded_button() translate <80, 0, 104> }
            object { rounded_button() translate <88, 0, 8> }
            object { rounded_button() translate <88, 0, 16> }
            object { rounded_button() translate <88, 0, 24> }
            object { rounded_button() translate <88, 0, 32> }
            object { rounded_button() translate <88, 0, 40> }
            object { rounded_button() translate <88, 0, 48> }
            object { rounded_button() translate <88, 0, 56> }
            object { rounded_button() translate <88, 0, 64> }
            object { rounded_button() translate <88, 0, 72> }
            object { rounded_button() translate <88, 0, 80> }
            object { rounded_button() translate <88, 0, 88> }
            object { rounded_button() translate <88, 0, 96> }
            object { rounded_button() translate <88, 0, 104> }
            object { rounded_button() translate <88, 0, 112> }
            object { rounded_button() translate <96, 0, 0> }
            object { rounded_button() translate <96, 0, 8> }
            object { rounded_button() translate <96, 0, 16> }
            object { rounded_button() translate <96, 0, 24> }
            object { rounded_button() translate <96, 0, 32> }
            object { rounded_button() translate <96, 0, 40> }
            object { rounded_button() translate <96, 0, 48> }
            object { rounded_button() translate <96, 0, 56> }
            object { rounded_button() translate <96, 0, 64> }
            object { rounded_button() translate <96, 0, 72> }
            object { rounded_button() translate <96, 0, 80> }
            object { rounded_button() translate <96, 0, 88> }
            object { rounded_button() translate <96, 0, 96> }
            object { rounded_button() translate <96, 0, 104> }
            object { rounded_button() translate <96, 0, 112> }
            object { rounded_button() translate <96, 0, 120> }
            object { rounded_button() translate <104, 0, 0> }
            object { rounded_button() translate <104, 0, 8> }
            object { rounded_button() translate <104, 0, 16> }
            object { rounded_button() translate <104, 0, 24> }
            object { rounded_button() translate <104, 0, 32> }
            object { rounded_button() translate <104, 0, 40> }
            object { rounded_button() translate <104, 0, 48> }
            object { rounded_button() translate <104, 0, 56> }
            object { rounded_button() translate <104, 0, 64> }
            object { rounded_button() translate <104, 0, 72> }
            object { rounded_button() translate <104, 0, 80> }
            object { rounded_button() translate <104, 0, 88> }
            object { rounded_button() translate <104, 0, 96> }
            object { rounded_button() translate <104, 0, 104> }
            object { rounded_button() translate <104, 0, 112> }
            object { rounded_button() translate <104, 0, 120> }
          #end
        }
        difference {
          merge {
            box { <-0.9, -4, -2.25> <0.9, 4, 2.25> }
            box { <-2.25, -4, -0.9> <2.25, 4, 0.9> }
          }
          cylinder { -5*y, 5*y, 2.6 inverse }
          translate <4, 0, 60>
        }
        difference {
          merge {
            box { <-0.9, -4, -2.25> <0.9, 4, 2.25> }
            box { <-2.25, -4, -0.9> <2.25, 4, 0.9> }
          }
          cylinder { -5*y, 5*y, 2.6 inverse }
          translate <12, 0, 60>
        }
        difference {
          merge {
            box { <-0.9, -4, -2.25> <0.9, 4, 2.25> }
            box { <-2.25, -4, -0.9> <2.25, 4, 0.9> }
          }
          cylinder { -5*y, 5*y, 2.6 inverse }
          translate <20, 0, 60>
        }
        difference {
          merge {
            box { <-0.9, -4, -2.25> <0.9, 4, 2.25> }
            box { <-2.25, -4, -0.9> <2.25, 4, 0.9> }
          }
          cylinder { -5*y, 5*y, 2.6 inverse }
          translate <28, 0, 60>
        }
        difference {
          merge {
            box { <-0.9, -4, -2.25> <0.9, 4, 2.25> }
            box { <-2.25, -4, -0.9> <2.25, 4, 0.9> }
          }
          cylinder { -5*y, 5*y, 2.6 inverse }
          translate <36, 0, 60>
        }
        difference {
          merge {
            box { <-0.9, -4, -2.25> <0.9, 4, 2.25> }
            box { <-2.25, -4, -0.9> <2.25, 4, 0.9> }
          }
          cylinder { -5*y, 5*y, 2.6 inverse }
          translate <44, 0, 60>
        }
        difference {
          merge {
            box { <-0.9, -4, -2.25> <0.9, 4, 2.25> }
            box { <-2.25, -4, -0.9> <2.25, 4, 0.9> }
          }
          cylinder { -5*y, 5*y, 2.6 inverse }
          translate <52, 0, 60>
        }
        difference {
          merge {
            box { <-0.9, -4, -2.25> <0.9, 4, 2.25> }
            box { <-2.25, -4, -0.9> <2.25, 4, 0.9> }
          }
          cylinder { -5*y, 5*y, 2.6 inverse }
          translate <60, 0, 60>
        }
        box { <0, -1, -50> <50, 4, 0> rotate 45*y translate <60, 0, 28> }
        box { <-80, -1, -50> <0, 4, 0> rotate 13.5*y translate <60, 0, 28> }
        box { <0, -1, 0> <50, 4, 50> rotate -45*y translate <60, 0, 92> }
        box { <-80, -1, 0> <0, 4, 50> rotate -13.5*y translate <60, 0, 92> }
        box { <101, -1, 11.9> <108, 2.000001, 44.1> }
        box { <101, -1, 75.9> <108, 2.000002, 108.1> }
        #if (setting > 1)
          box { <93.5, -1, -2.5> <106.5, 2.000003, 10.5> }
          box { <93.5, -1, 109.5> <106.5, 2.000004, 122.5> }
          difference {
            box { <-2.4, -1, -2.4> <106.399999, 2, 122.4> }
            box { <92, -2, -4> <108, 3, 12> }
            box { <92, -2, 108> <108, 3, 124> }
            box { <99.5, -2, 11.8> <109, 3, 45.6> }
            box { <99.5, -2, 74.4> <109, 3, 108.2> }
            box { <0, -2, -50> <50, 3, 0> rotate 45*y translate <60, 0, 29.5> }
            box { <-80, -2, -50> <0, 3, 0> rotate 13.5*y translate <60, 0, 29.3> }
            box { <0, -2, 0> <50, 3, 50> rotate -45*y translate <60, 0, 90.5> }
            box { <-80, -2, 0> <0, 3, 50> rotate -13.5*y translate <60, 0, 90.7> }
            box { <5.5, -2, 44> <108, 3, 45.5> }
            box { <5.499999, -2, 41.5> <7, 3, 45.500001> }
            box { <-0.5, -2, 0> <0.5, 3, 45.500001> }
            box { <68, -2, 0> <69.5, 3, 45> }
            box { <82.5, -2, 0> <84, 3, 45> }
            box { <71.5, -2, 42.5> <72.5, 3, 45> }
            box { <79.5, -2, 42.5> <80.5, 3, 45> }
            box { <69, -2, 28> <83, 3, 29.5> }
            box { <5.6, -2, 74.5> <108, 3, 76> }
            box { <5.599999, -2, 74.500001> <7, 3, 78.5> }
            box { <-0.5, -2, 74.500001> <0.5, 3, 100> }
            box { <68, -2, 74.5> <69.5, 3, 100> }
            box { <82.5, -2, 74.5> <84, 3, 130> }
            box { <71.5, -2, 75> <72.5, 3, 77.5> }
            box { <79.5, -2, 75> <80.5, 3, 77.5> }
            box { <69, -2, 90.5> <83, 3, 92> }
          }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 80> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 80> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 80> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 80> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 80> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 88> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 80> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 88> }
          cylinder { 1*y, 4*y, 1.2 translate <72, 0, 96> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 80> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 88> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 96> }
          cylinder { 1*y, 4*y, 1.2 translate <80, 0, 104> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 80> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 88> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 96> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 104> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 112> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 80> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 88> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 96> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 104> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 112> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 120> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 64> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 72> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 80> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 88> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 96> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 104> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 112> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 120> }
        #end
      }
      #if (setting > 1)
        #local teller = 0;
        #while (teller < 13)
          object { ring() translate <(teller*8)+4, 0, 52> }
          object { ring() translate <(teller*8)+4, 0, 60> }
          object { ring() translate <(teller*8)+4, 0, 68> }
          #local teller = teller + 1;
        #end
        object { ring() translate <100, 0, 4> }
        object { ring() translate <100, 0, 116> }
        object { ring() translate <76, 0, 36> }
        object { ring() translate <76, 0, 84> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <108, 4.9, 124> } }
    }
  #end
#end
#macro side_dish4_4(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 6.3*y, 15.9 rotate 90*x translate <4, 1.55, 5.7> }
      box { <-3.9, 0, -3.9> <11.9, 3.1, 7> }
      texture { color_tex }
    }      
  #else
    merge {
      merge {
        difference {
          sphere { <0, 34.5, 0> 34.5 }
          sphere { <0, 41, 0> 40 }
          box { <-37, 3.9, -37> <37, 70, 37> }
        }
        intersection {
          sphere { <0, 34.5, 0> 34.4 }
          merge {
            difference {
              cylinder { -5*y, 3.9*y, 3 }
              box { <-2.25, -6, -0.9> <2.25, 4, 0.9> }
              box { <-0.9, -6, -2.25> <0.9, 4, 2.25> }
              box { <-5, -6, -0.4> <5, 4, 0.4> }
            }
            box { <-3.5, -5, -10> <-4.5, 3.9, -6> }
            box { <3.5, -5, -10> <4.5, 3.9, -6> }
            box { <-3.5, -5, 10> <-4.5, 3.9, 6> }
            box { <3.5, -5, 10> <4.5, 3.9, 6> }
            box { <-10, -5, -3.5> <-6, 3.9, -4.5> }
            box { <-10, -5, 3.5> <-6, 3.9, 4.5> }
            box { <10, -5, -3.5> <6, 3.9, -4.5> }
            box { <10, -5, 3.5> <6, 3.9, 4.5> }
            object { open_rounded_button() translate <4, 3.4, 12> }
            object { open_rounded_button() translate <-4, 3.4, 12> }
            object { open_rounded_button() translate <4, 3.4, -12> }
            object { open_rounded_button() translate <-4, 3.4, -12> }
            difference {
              cylinder { -5*y, 6.5*y, 2.400001 }
              cylinder { -6*y, 7*y, 1.600001 }
              translate <4, 0, 12>
            }
            difference {
              cylinder { -5*y, 6.5*y, 2.400001 }
              cylinder { -6*y, 7*y, 1.600001 }
              translate <-4, 0, 12>
            }
            difference {
              cylinder { -5*y, 6.5*y, 2.400001 }
              cylinder { -6*y, 7*y, 1.600001 }
              translate <4, 0, -12>
            }
            difference {
              cylinder { -5*y, 6.5*y, 2.400001 }
              cylinder { -6*y, 7*y, 1.600001 }
              translate <-4, 0, -12>
            }
            object { open_rounded_button() translate <-12, 3.4, -4> }
            object { open_rounded_button() translate <4, 3.4, -4> }
            object { open_rounded_button() translate <-4, 3.4, -4> }
            object { open_rounded_button() translate <12, 3.4, -4> }
            object { open_rounded_button() translate <-12, 3.4, 4> }
            object { open_rounded_button() translate <4, 3.4, 4> }
            object { open_rounded_button() translate <-4, 3.4, 4> }
            object { open_rounded_button() translate <12, 3.4, 4> }
            difference {
              cylinder { -5*y, 6.5*y, 2.400001 }
              cylinder { -6*y, 7*y, 1.600001 }
              translate <12, 0, -4>
            }
            difference {
              cylinder { -5*y, 6.5*y, 2.400001 }
              cylinder { -6*y, 7*y, 1.600001 }
              translate <4, 0, -4>
            }
            difference {
              cylinder { -5*y, 6.5*y, 2.400001 }
              cylinder { -6*y, 7*y, 1.600001 }
              translate <-4, 0, -4>
            }
            difference {
              cylinder { -5*y, 6.5*y, 2.400001 }
              cylinder { -6*y, 7*y, 1.600001 }
              translate <-12, 0, -4>
            }
            difference {
              cylinder { -5*y, 6.5*y, 2.400001 }
              cylinder { -6*y, 7*y, 1.600001 }
              translate <12, 0, 4>
            }
            difference {
              cylinder { -5*y, 6.5*y, 2.400001 }
              cylinder { -6*y, 7*y, 1.600001 }
              translate <4, 0, 4>
            }
            difference {
              cylinder { -5*y, 6.5*y, 2.400001 }
              cylinder { -6*y, 7*y, 1.600001 }
              translate <-4, 0, 4>
            }
            difference {
              cylinder { -5*y, 6.5*y, 2.400001 }
              cylinder { -6*y, 7*y, 1.600001 }
              translate <-12, 0, 4>
            }
          }
        }
        difference {
          cylinder { 3.899999*y, 6.3*y, 15.900001 }
          cylinder { 3.899998*y, 7*y, 14.9 }
        }
        rotate 90*x
        translate <4, 1.55, 5.7>
      }
      difference {
        merge {
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
          #end
          box { <-3.9, 0, -3.9> <11.9, 3.1, 7> }
        }
        #if (setting > 1)
          box { <-2.4, -1, 3.4> <10.4, 2, 8> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          difference {
            box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
            object { pin(2) translate <4, 0, 0> }
          }
          box { <2.5, -1, -4> <5.5, 4, -3.5> }
        #end
        sphere { <0, 0, 40.9> 34.5 }
      }
      texture { color_tex }
      bounded_by { box { <-12, -14.55, -4> <20, 17.55, 14> } }
    }
  #end
#end
#macro signalling_disc(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -0.749999*z, 0.749999*z, 5.5 translate <0, 19, 0> }
      cylinder { 0*y, 15*y, 1.5 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { 0*y, 15*y, 1.5 }
        box { <-2, 0, -2> <2, 10, 0> rotate 9*x translate <0, 9, -1.5> }
        box { <-2, 0, 0> <2, 10, 2> rotate -9*x translate <0, 9, 1.5> }
      }
      torus { 5.35, 0.15 rotate 90*x translate <0, 19, -0.6> }
      torus { 5.35, 0.15 rotate 90*x translate <0, 19, 0.6> }
      cylinder { -0.75*z, 0.75*z, 5.35 translate <0, 19, 0> }
      cylinder { -0.6*z, 0.6*z, 5.5 translate <0, 19, 0> }
      object { open_rounded_button() rotate -90*x translate <0, 19, 2.35> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <0, 19, -0.75> }
      #end
      texture { color_tex }
      bounded_by { box { <-5.6, -0.1, -2.55> <5.6, 24.6, 1.6> } }
    }
  #end
#end
#macro sirens(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 9.5, 11.9> }
      cylinder { -11.9*x, 11.9*x, 3.75 translate <0, 5.6, 0> }
      cylinder { -11.9*z, 0*z, 3.75 translate <0, 5.6, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
        #else
          object { rounded_button() rotate -90*y translate <0, 6.4, 0> }
          object { rounded_button() rotate -90*y translate <0, 6.4, 8> }
        #end
        box { <-3.9, 0, -3.9> <3.9, 9.5, 11.9> }
        difference {
          cone { -11.9*z, 3.75, -3.8*z, 2.5 }
          difference {
            cone { -12*z, 2.5, -6.9*z, 2 }
            sphere { <-1.9, -1.9, -8.9> 1 }
            sphere { <1.9, -1.9, -8.9> 1 }
            sphere { <-1.9, 1.9, -8.9> 1 }
            sphere { <1.9, 1.9, -8.9> 1 }
            cylinder { -8.900001*z, 0*z, 1 translate <-1.9, -1.9, 0> }
            cylinder { -8.900001*z, 0*z, 1 translate <1.9, -1.9, 0> }
            cylinder { -8.900001*z, 0*z, 1 translate <-1.9, 1.9, 0> }
            cylinder { -8.900001*z, 0*z, 1 translate <1.9, 1.9, 0> }
          }
          cylinder { -12*z, -3.9*z, 1.5 }
          translate <0, 5.6, 0>
        }
        difference {
          cone { -11.9*z, 3.75, -3.8*z, 2.5 }
          difference {
            cone { -12*z, 2.5, -6.9*z, 2 }
            sphere { <-1.9, -1.9, -8.9> 1 }
            sphere { <1.9, -1.9, -8.9> 1 }
            sphere { <-1.9, 1.9, -8.9> 1 }
            sphere { <1.9, 1.9, -8.9> 1 }
            cylinder { -8.900001*z, 0*z, 1 translate <-1.9, -1.9, 0> }
            cylinder { -8.900001*z, 0*z, 1 translate <1.9, -1.9, 0> }
            cylinder { -8.900001*z, 0*z, 1 translate <-1.9, 1.9, 0> }
            cylinder { -8.900001*z, 0*z, 1 translate <1.9, 1.9, 0> }
          }
          cylinder { -12*z, -3.9*z, 1.5 }
          translate <0, 5.6, 0>
          rotate -90*y
        }
        difference {
          cone { -11.9*z, 3.75, -3.8*z, 2.5 }
          difference {
            cone { -12*z, 2.5, -6.9*z, 2 }
            sphere { <-1.9, -1.9, -8.9> 1 }
            sphere { <1.9, -1.9, -8.9> 1 }
            sphere { <-1.9, 1.9, -8.9> 1 }
            sphere { <1.9, 1.9, -8.9> 1 }
            cylinder { -8.900001*z, 0*z, 1 translate <-1.9, -1.9, 0> }
            cylinder { -8.900001*z, 0*z, 1 translate <1.9, -1.9, 0> }
            cylinder { -8.900001*z, 0*z, 1 translate <-1.9, 1.9, 0> }
            cylinder { -8.900001*z, 0*z, 1 translate <1.9, 1.9, 0> }
          }
          cylinder { -12*z, -3.9*z, 1.5 }
          translate <0, 5.6, 0>
          rotate 90*y
        }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 8.6, 2.4> }
        box { <-2.4, 5, 3.899999> <2.4, 8.6, 10.4> }
        cylinder { 7.4*y, 10.4*y, 1.2 }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
      #end
      box { <-4, -1, 3.9> <4, 6.4, 12> }
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -12> <12, 11.3, 12> } }
    }
  #end
#end
#macro skeleton_arm(color_tex)
  #if (setting = 0)
    cylinder { -15.15*y, 2*y, 2 texture { color_tex } }
  #else
    difference {
      merge {
        sphere { <0, 0, 0> 2 }
        cylinder { -2*y, 0.000001*y, 2.000001 }
        cylinder { -1.5*y, -9.999999*y, 1.5 }
        cylinder { -5*y, -7*y, 2.3 }
        difference {
          box { <-1.499999, -10.5, -1.5> <1.499999, -8.5, 1.5> }
          difference {
            box { <-3, 0, -3> <3, 3, 3> }
            cylinder { -2*z, 2*z, 1.5 }
            translate <0, -10, 0>
          }
          difference {
            box { <-3, 0, -3> <3, 3, 3> }
            cylinder { -2*x, 2*x, 1.5 }
            translate <0, -10, 0>
          }
        }
        cylinder { -1.5*z, 1.5*z, 2.75 translate <0, -12.5, 0> }
      }
      cylinder { -2*z, 2*z, 1.55 translate <0, -12.5, 0> }
      box { <-1.35, -15.5, -2> <1.35, -12.5, 2> }
      cylinder { -3*x, 3*x, 1 }
      box { <-3, -0.000005, -1.000001> <3, 4, 1.000001> }
      box { <-0.500001, -20, -2> <0.500001, -10.499999, 2> }
      cylinder { -2*z, 2*z, 0.5 translate <0, -10.5, 0> }
      sphere { <0, 0, 0> 1.1 }
      texture { color_tex }
      bounded_by { box { <-2.85, -15.25, -2.5> <2.85, 2.1, 2.5> } }
    }
  #end
#end
#macro skeleton_body(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -6.5*x, 6.5*x, 2 }
      cylinder { 0*y, 23.4*y, 2.3 }
      box { <-7.5, 5, -2.5> <7.5, 17.4, 2.5> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { -6.5*x, -5.7*x, 2 }
      cylinder { 5.7*x, 6.5*x, 2 }
      cylinder { -6*x, -2*x, 1.5 }
      cylinder { 2*x, 6*x, 1.5 }
      cylinder { -2.25*x, -1.25*x, 2.5 }
      cylinder { 1.25*x, 2.25*x, 2.5 }
      cylinder { -2*x, 2*x, 0.9 }
      box { <-2.250001, -0.000001, -2.500001> <-1.250001, 3.7, 2.500001> }
      box { <1.250001, -0.000001, -2.500001> <2.250001, 3.7, 2.500001> }
      box { <-6.9, 3.5, -2.500002> <6.9, 5, 2.500002> }
      difference {
        box { <-7.5, 5, -2.5> <7.5, 17.4, 2.5> }
        box { <-10, -2, -5> <0, 20, 5> rotate -10*z translate <-7.5, 6, 0> }
        box { <0, -2, -5> <10, 20, 5> rotate 10*z translate <7.5, 6, 0> }
        difference {
          box { <-9, -20, -3> <9, 0, 3> }
          cylinder { -4*z, 4*z, 4 scale <1.625, 1, 1> }
          translate <0, 11.5, 0>
        }
        difference {
          cylinder { -4*z, 4*z, 3.6 scale <1.458333333, 1, 1> }
          cylinder { -5*z, 5*z, 10 translate <0, 9, 0> }
          translate <0, 12, 0>
        }
        difference {
          cylinder { -4*z, 4*z, 9.1 translate <0, 9, 0> }
          box { <-10, -2, -5> <0, 20, 5> rotate -10*z translate <-6.5, -6, 0> }
          box { <0, -2, -5> <10, 20, 5> rotate 10*z translate <6.5, -6, 0> }
          cylinder { -5*z, 5*z, 10 translate <0, 12, 0> }
          translate <0, 12, 0>
        }
        difference {
          cylinder { -4*z, 4*z, 9.1 translate <0, 24, 0> }
          box { <-10, 16.4, -5> <10, 20, 5> }
          box { <-10, 12, -5> <-3.5, 17, 5> }
          box { <3.5, 12, -5> <10, 17, 5> }
        }
      }
      difference {
        cylinder { 17*y, 23.4*y, 2.3 }
        cylinder { 16*y, 24*y, 1.6 }
      }
      #local counter = 0;
      #while (counter < 15)
        torus { 1.2, 0.45 translate <0, 5+(counter*0.8), 0> }
        #local counter = counter + 1;
      #end
      sphere { <-8, 15, 0> 1 }
      sphere { <8, 15, 0> 1 }
      cylinder { 0*x, 2.5*x, 0.7 rotate -10*z translate <-8, 15, 0> }
      cylinder { -2.5*x, 0*x, 0.7 rotate 10*z translate <8, 15, 0> }
      texture { color_tex }
      bounded_by { box { <-9.1, -2.6, -4> <9.1, 23.5, 4> } }
    }
  #end
#end
#macro skeleton_leg(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 13.05*y, 1.5 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { -1.5*x, 1.5*x, 2.75 }
          difference {
            box { <-1.499999, -4, -1.5> <1.499999, -2, 1.5> }
            difference {
              box { <-3, -3, -3> <3, 0, 3> }
              cylinder { -2*z, 2*z, 1.5 }
              translate <0, -2.5, 0>
            }
            difference {
              box { <-3, -3, -3> <3, 0, 3> }
              cylinder { -2*x, 2*x, 1.5 }
              translate <0, -2.5, 0>
            }
          }
        }
        cylinder { -2*x, 2*x, 1.55 }
        box { <-2, 0, -1.35> <2, 3, 1.35> }
        translate <0, 11.5, 0>
      }
      cylinder { 2*y, 8*y, 1.500001 }
      cylinder { 4.5*y, 6.5*y, 2.4 }
      difference {
        merge {
          cylinder { 0*y, 3.1*y, 3.5 }
          box { <-3.500001, 0.000001, -4> <3.500001, 3.100001, 0.000002> }
        }
        cylinder { -1*y, 2*y, 2.5 }
        box { <-4, 0, -4> <4, 2, 0> rotate -20*x translate <0, 3.1, -2> }
        box { <-10, -1, -10> <-3.500001, 4, 5> rotate -12*y }
        box { <3.500001, -1, -10> <10, 4, 5> rotate 12*y }
        box { <-0.300001, -2, -5> <0.300001, 4, -3.500001> }
        cylinder { -2*y, 4*y, 0.3 translate <0, 0, -3.5> }
        cylinder { -2*y, 4*y, 0.3 translate <-1.75, 0, -3> }
        cylinder { -2*y, 4*y, 0.3 translate <1.75, 0, -3> }
        box { <-2.050001, -2, -5> <-1.450001, 4, -3.000001> }
        box { <1.450001, -2, -5> <2.050001, 4, -3.000001> }
        box { <-4, -2, -5> <-1.450002, 4, -3.000002> }
        box { <1.450002, -2, -5> <4, 4, -3.000002> }
      }
      texture { color_tex }
      bounded_by { box { <-3.6, -0.1, -4.1> <3.6, 13.15, 3.6> } }
    }
  #end
#end
#macro skewed_support(color_tex)
  #if (setting = 0)
    difference {
      box { <1, 0, 2> <36, 47, 6> }
      box { <-30, -5, 1.5> <0, 55, 6.5> rotate -25*z translate <2.5, 3.09, 0> }
      box { <0, 0, 1.5> <20, 55, 6.5> rotate -15.5*z translate <20.75, 3.09, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 10.4> }
        #end
      }
      box { <0, 0, 1.5> <1, 49, 6.5> rotate -25*z translate <2, 3.09, 0> }
      box { <0, 0, 1.5> <1, 45, 6.5> rotate -15.5*z translate <21, 3.09, 0> }
      difference {
        box { <1, 3.1, 3.25> <36, 47, 4.75> }
        box { <-30, -5, 1.5> <0, 55, 6.5> rotate -25*z translate <2.5, 3.09, 0> }
        box { <0, 0, 1.5> <20, 55, 6.5> rotate -15.5*z translate <20.75, 3.09, 0> }
        cylinder { 3*z, 5*z, 2 translate <10.5, 8, 0> }
        box { <10.499999, 6.000001, 3> <17.000001, 10, 5> }
        cylinder { 3*z, 5*z, 2 translate <17, 8, 0> }
        box { <-0.15, 0, 3> <4, 9.25, 5> rotate -25.5*z translate <8.5, 8, 0> }
        cylinder { 3*z, 5*z, 2 translate <14.3, 16, 0> }
        box { <14.299999, 14, 3> <19.000001, 18.000001, 5> }
        cylinder { 3*z, 5*z, 2 translate <19.1, 16, 0> }
        box { <-5.5, 0, 3> <0, 8, 5> rotate -15.25*z translate <19, 8, 0> }
        cylinder { 3*z, 5*z, 1.5 translate <16.55, 21.5, 0> }
        box { <16.549999, 20.000001, 3> <21.200001, 23, 5> }
        cylinder { 3*z, 5*z, 1.5 translate <21.2, 21.5, 0> }
        box { <-0.15, 0, 3> <3.5, 9.25, 5> rotate -25*z translate <15.1, 21.5, 0> }
        cylinder { 3*z, 5*z, 1.5 translate <20.25, 29.25, 0> }
        box { <20.249999, 27.25, 3> <23.350001, 30.750001, 5> }
        cylinder { 3*z, 5*z, 1.5 translate <23.35, 29.25, 0> }
        box { <-5, 0, 3> <0, 8, 5> rotate -15.5*z translate <22.75, 21.5, 0> }
        cylinder { 3*z, 5*z, 1 translate <21.9, 34, 0> }
        box { <21.899999, 33.000001, 3> <25.250001, 35, 5> }
        cylinder { 3*z, 5*z, 1 translate <25.25, 34, 0> }
        box { <-0.15, 0, 3> <2.4, 9.25, 5> rotate -25*z translate <21, 34, 0> }
        cylinder { 3*z, 5*z, 1 translate <25.7, 42, 0> }
        box { <25.699999, 41, 3> <27.500001, 43.000001, 5> }
        cylinder { 3*z, 5*z, 1 translate <27.5, 42, 0> }
        box { <-2.75, 0, 3> <0, 8, 5> rotate -15.5*z translate <26.3, 34, 0> }
      }
      box { <20.1, 46.4, -3.9> <35.9, 47.9, 11.9> }
      object { open_rounded_button() translate <24, 44.8, 0> }
      object { open_rounded_button() translate <24, 44.8, 8> }
      object { open_rounded_button() translate <32, 44.8, 0> }
      object { open_rounded_button() translate <32, 44.8, 8> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <24, 48, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <24, 48, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <32, 48, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <32, 48, 8> }
      #end
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <36, 49.7, 12> } }
    }
  #end
#end
#macro skid(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0.000001, -3.899999> <59.9, 6.3, 3.899999> }
      box { <-10, -20, -10> <100, 0, 10> rotate 3.8*z translate <12, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          #end
        }
        difference {
          box { <11.899999, 0.000001, -3.899999> <59.9, 6.3, 3.899999> }
          box { <-10, -20, -10> <100, 0, 10> rotate 3.8*z translate <12, 0, 0> }
          box { <-10, -10, -10> <10, 10, 0> rotate -9*y translate <51.9, 0, -3.9> }
          box { <-10, -10, 0> <10, 10, 10> rotate 9*y translate <51.9, 0, 3.9> }
          #if (setting > 1)
            difference {
              box { <11.9, -1, -2.4> <58.4, 5.4, 2.4> }
              box { <-10, -10, -10> <10, 10, 0> rotate -9*y translate <51.9, 0, -2.6> }
              box { <-10, -10, 0> <10, 10, 10> rotate 9*y translate <51.9, 0, 2.6> }
            }
          #end
        }
        object { open_rounded_button() translate <0, 6.4, 0> }
        object { open_rounded_button() translate <8, 6.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 5.6, 0> }
        #if (setting > 1)
          object { pin(1) scale <1, 1.285714, 1> translate <4, 0, 0> }
        #end
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <4, 5.6, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 11.3, 4> } }
    }
  #end
#end
#macro ski_l(color_tex)
  #if (setting = 0)
    box { <-56, 0, -3.9> <39.8, 1.6, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-45, 0, -3.9> <39.8, 1.6, 3.9> }
        difference {
          box { <-12.6, 1.5, -3.89999> <-8.1, 4.9, 3.89999> }
          box { <-10, 0, -5> <0, 10, 5> rotate 43*z translate <-9, 4.9, 0> }
          box { <-10, 1, -10> <0, 10, 0> rotate 33*y translate <-9, 0, -3.9> }
          box { <-10, 1, 0> <0, 10, 10> rotate -33*y translate <-9, 0, 3.9> }
        }
        difference {
          box { <-56, 0.00001, -3.90001> <-44.99999, 10, 3.90001> }
          difference {
            box { <-60, -0.5, -20> <-44.99998, 10.5, 0.00001> }
            cylinder { -1*y, 11*y, 15 rotate -10*x rotate -40*z translate <-46.5, 0, 11.1> }
          }
          difference {
            box { <-60, -0.5, -0.00001> <-44.99997, 10.5, 20> }
            cylinder { -1*y, 11*y, 15 rotate 10*x rotate -40*z translate <-46.5, 0, -11.1> }
          }
          difference {
            box { <-60, -0.5, -4> <-44.99996, 10.5, 4> }
            cylinder { -5*z, 5*z, 15 translate <-45, 15, 0> }
          }
          cylinder { -5*z, 5*z, 13.4 translate <-45, 15, 0> }
        }
        object { open_rounded_button() translate <-4, -1.5, 0> }
        object { open_rounded_button() translate <4, -1.5, 0> }
      }
      cylinder { -1*y, 2*y, 1.65 translate <-10.5, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-56, -0.1, -4> <39.9, 5.5, 4> } }
    }
  #end
#end
#macro ski_s(color_tex)
  #if (setting = 0)
    box { <-15, 0, -3.9> <10.5, 1.1, 3.9> texture { color_tex } }
  #else
    merge {
      cylinder { -2.249999*z, -0.650001*z, 1.55 translate <0, 5, 0> }
      cylinder { 0.650001*z, 2.249999*z, 1.55 translate <0, 5, 0> }
      box { <-1.550001, 0.9, -2.25> <1.550001, 5.000001, -0.65> }
      box { <-1.550001, 0.9, 0.65> <1.550001, 5.000001, 2.25> }
      difference {
        box { <-15, 0, -3.9> <10.5, 1.1, 3.9> }
        box { <0, -1, -5> <3.5, 2, 0> rotate -32.5*y translate <0, 0, -3.9> }
        box { <0, -1, 0> <3.5, 2, 5> rotate 32.5*y translate <0, 0, 3.9> }
        box { <3, -1, -4> <11, 2, -2> }
        box { <3, -1, 2> <11, 2, 4> }
        cylinder { -1*y, 5*y, 1.600001 translate <-5, 0, 0> }
      }
      difference {
        box { <-7.5, 0, -3.899999> <0, 1.1, 3.899999> }
        box { <0, -1, -5> <5, 2, 0> rotate 45*y translate <-7.5, 0, -2> }
        box { <0, -1, 0> <5, 2, 5> rotate -45*y translate <-7.5, 0, 2> }
        rotate -18*z
        translate <-14.99999, 0, 0>
      }
      difference {
        box { <-21.25, 0.9, -0.5> <-9.8, 3.099999, 0.5> }
        box { <-10, -5, -1> <0, 0, 1> rotate -18*z translate <-15, 0.5, 0> }
      }
      object { open_rounded_button() translate <-5, -2, 0> }
      box { <0, -1, -1.999999> <5, 0, -1> rotate -20*z translate <1.44, 3, 0> }
      box { <0, -1, 1> <5, 0, 1.999999> rotate -20*z translate <1.44, 3, 0> }
      difference {
        box { <-1.44, 0.9, -3.9> <1.44, 2.5, -2.24> }
        box { <-2, 0, -5> <2, 3, 0> rotate -25*x translate <0, 2.5, -2.250001> }
        box { <0, 0, -5> <5, 3, 0> rotate -32.5*y translate <-1.45, 0, -3.9> }
      }
      difference {
        box { <-1.44, 0.9, 2.24> <1.44, 2.5, 3.9> }
        box { <-2, 0, 0> <2, 3, 5> rotate 25*x translate <0, 2.5, 2.250001> }
        box { <0, 0, 0> <5, 3, 5> rotate 32.5*y translate <-1.45, 0, 3.9> }
      }
      difference {
        box { <-10.4, 0.9, -3.899999> <-9.4, 3.1, 3.899999> }
        box { <-11, 0, -5> <-9, 5, 0> rotate 15*x translate <0, 1.1, -3.9> }
        box { <-11, 0, 0> <-9, 5, 5> rotate -15*x translate <0, 1.1, 3.9> }
      }
      texture { color_tex }
      bounded_by { box { <-22, -0.1, -4> <10.6, 6.65, 4> } }
    }
  #end
#end
#macro sliding_ladder(color_tex)
  #if (setting = 0)
    box { <-11.9, 0, -6.9> <100.9, 4.9, 14.9> texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-11.5, 0, -6.5> <100, 4.9, 14.5> }
        box { <-12, 3.5, -4.7> <101, 6, 12.7> }
        box { <-12, 3, -5.7> <101, 4, 13.7> }
        box { <-12, 2, -3.5> <101, 6, 11.5> }
        box { <-12, -1, -3.7> <-5.5, 6, 11.7> }
        box { <-2.5, -1, -3.7> <2.5, 6, 11.7> }
        box { <5.5, -1, -3.7> <10.5, 6, 11.7> }
        box { <13.5, -1, -3.7> <18.5, 6, 11.7> }
        box { <21.5, -1, -3.7> <26.5, 6, 11.7> }
        box { <29.5, -1, -3.7> <34.5, 6, 11.7> }
        box { <37.5, -1, -3.7> <42.5, 6, 11.7> }
        box { <46, -1, -3.7> <51, 6, 11.7> }
        box { <54, -1, -3.7> <59, 6, 11.7> }
        box { <62, -1, -3.7> <67, 6, 11.7> }
        box { <70, -1, -3.7> <75, 6, 11.7> }
        box { <78, -1, -3.7> <83, 6, 11.7> }
        box { <86, -1, -3.7> <91, 6, 11.7> }
        box { <94, -1, -3.7> <101, 6, 11.7> }
        box { <-12, -1, -7> <101, 1.5, -5.4> }
        box { <-12, 0.9, -7> <101, 2, -4.5> }
        box { <-12, -1, 13.4> <101, 1.5, 15> }
        box { <-12, 0.9, 12.5> <101, 2, 15> }
        box { <-12, -1, 2.5> <101, 0.4, 5.5> }
      }
      #if (setting > 1)
        sphere { <-4, 2.000001, 3> 1 }
        cylinder { 2.999999*z, 5.000001*z, 1 translate <-4, 2.000002, 0> }
        sphere { <-4, 2.000001, 5> 1 }
        sphere { <92.5, 2.000001, 3> 1 }
        cylinder { 2.999999*z, 5.000001*z, 1 translate <92.5, 2.000002, 0> }
        sphere { <92.5, 2.000001, 5> 1 }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -7> <101, 5, 15> } }
    }
  #end
#end
#macro slope1_1(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <3.9, 6.1, 3.9> }
      box { <-10, 0, -10> <10, 10, 10> rotate 28.5*z translate <3.7, 6.1, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, .5, -3.9> <3.9, 6.1, 3.9> }
        box { <-3.5, 0, -3.5> <3.5, .55, 3.5> }
      }
      box { <-10, 0, -10> <10, 10, 10> rotate 28.5*z translate <3.7, 6.1, 0> }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
          box { <-10, 0, -10> <10, 10, 10> rotate 28.5*z translate <3.7, 5.1, 0> }
        }
        cylinder { -1*y, 2*y, 2.400001 }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 6.2, 4> } }
    }
  #end
#end
#macro slope1_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
            box { <-20, 0, -10> <20, 20, 20> texture { color_tex normal { bumping } }
              rotate 43.5*z translate <4, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 90*y translate <8, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.40001, -1, -2.40001> <0, 2.00005, 2.40001> }
          difference {
            box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
            box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <4, 7.5, 0> }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
          box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <4, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 4> } }
    }
  #end
#end
#macro slope1_3(color_tex, age)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 3.9> }
      box { <-20, 0, -10> <10, 10, 20> rotate 24.5*z translate <12, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <19.9, 9.5, 3.9> }
            box { <-20, 0, -10> <10, 10, 20> texture { color_tex normal { bumping } }
              rotate 24.5*z translate <12, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
          #else
            object { rounded_button() rotate 90*y translate <16, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          box { <-2.40001, -1, -2.40001> <0, 2.00005, 2.40001> }
          box { <13.6, -1, -2.4> <18.4, 8.6, 2.4> }
          difference {
            box { <-2.4, -1, -2.4> <12, 8.6, 2.4> }
            box { <-20, 0, -10> <10, 10, 20> rotate 24.5*z translate <12, 7.5, 0> }
            box { <10.4, 0.25, -0.5> <12.1, 8.7, 0.5> }
          }
        #end
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
          #if (age = 2)
            cylinder { -1*y, 2*y, 0.7 translate <4, 0, 0> }
          #end
          box { <-20, 0, -10> <20, 20, 10> rotate 24.5*z translate <12, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 12> } }
    }
  #end
#end
#macro slope2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
      box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
            box { <-20, 0, -10> <20, 20, 20> texture { color_tex normal { bumping } }
              rotate 43.5*z translate <4, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() rotate 90*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.40001, -1, -2.40001> <0, 2.00005, 10.40001> }
          difference {
            box { <-2.4, -1, -2.4> <10.4, 8.6, 10.4> }
            box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <4, 7.5, 0> }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        difference {
          object { high_ring() translate <4, 0, 4> }
          box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <4, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 12> } }
    }
  #end
#end
#macro slope2_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 11.9> }
      box { <-20, 0, -10> <10, 10, 20> rotate 24.5*z translate <12, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <19.9, 9.5, 11.9> }
            box { <-20, 0, -10> <10, 10, 20> texture { color_tex normal { bumping } }
              rotate 24.5*z translate <12, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
          #else
            object { rounded_button() rotate 90*y translate <16, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.40001, -1, -2.40001> <0, 2.00005, 10.40001> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          difference {
            box { <-2.4, -1, -2.4> <18.4, 8.6, 10.4> }
            box { <-20, 0, -10> <10, 10, 20> rotate 24.5*z translate <12, 7.5, 0> }
          }
        #end
      }
      #if (setting > 1)
        difference {
          union {
            object { high_ring() translate <4, 0, 4> }
            object { high_ring() translate <12, 0, 4> }
          }
          box { <-20, 0, -10> <10, 10, 10> rotate 24.5*z translate <12, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 12> } }
    }
  #end
#end
#macro slope2_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> }
      box { <-30, 0, -10> <10, 10, 20> rotate 17.5*z translate <20, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> }
            box { <-30, 0, -10> <10, 10, 20> texture { color_tex normal { bumping } }
              rotate 17.5*z translate <20, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 8> }
          #else
            object { rounded_button() rotate 90*y translate <24, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 8> }
          #end
        }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 8> }
          difference {
            box { <-2.4, -1, -2.4> <26.4, 8.6, 10.4> }
            box { <-30, 0, -10> <10, 10, 20> rotate 17.5*z translate <20, 7.5, 0> }
          }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { high_ring() translate <4, 0, 4> }
            object { high_ring() translate <12, 0, 4> }
            object { high_ring() translate <20, 0, 4> }
          }
          box { <-30, 0, -10> <10, 10, 10> rotate 17.5*z translate <20, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 12> } }
    }
  #end
#end
#macro slope3_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 19.9> }
      box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 9.5, 19.9> }
            box { <-20, 0, -10> <20, 20, 20> texture { color_tex normal { bumping } }
              rotate 43.5*z translate <4, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 16> }
          #else
            object { rounded_button() rotate 90*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 16> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 8.6, 18.4> }
            box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <4, 7.5, 0> }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 16> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { high_ring() translate <4, 0, 4> }
            object { high_ring() translate <4, 0, 12> }
          }
          box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <4, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 20> } }
    }
  #end
#end
#macro slope3_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 19.9> }
      box { <-20, 0, -10> <10, 10, 20> rotate 24.5*z translate <12, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <19.9, 9.5, 19.9> }
            box { <-20, 0, -10> <10, 10, 20> texture { color_tex normal { bumping } }
              rotate 24.5*z translate <12, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
          #else
            object { rounded_button() rotate 90*y translate <16, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 16> }
          #end
        }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
          difference {
            box { <-2.4, -1, -2.4> <18.4, 8.6, 18.4> }
            box { <-20, 0, -10> <10, 10, 20> rotate 24.5*z translate <12, 7.5, 0> }
          }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { high_ring() translate <4, 0, 4> }
            object { high_ring() translate <12, 0, 4> }
            object { high_ring() translate <4, 0, 12> }
            object { high_ring() translate <12, 0, 12> }
          }
          box { <-20, 0, -10> <10, 10, 20> rotate 24.5*z translate <12, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 20> } }
    }
  #end
#end
#macro slope4_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 27.9> }
      box { <-20, 0, -10> <20, 20, 30> rotate 43.5*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 9.5, 27.9> }
            box { <-20, 0, -10> <20, 20, 30> texture { color_tex normal { bumping } }
              rotate 43.5*z translate <4, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 24> }
          #else
            object { rounded_button() rotate 90*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 24> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 8.6, 26.4> }
            box { <-20, 0, -10> <20, 20, 30> rotate 43.5*z translate <4, 7.5, 0> }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 24> }
        #end
      }
      #if (setting > 1)
        difference {
          object { high_ring() translate <4, 0, 4> }
          object { high_ring() translate <4, 0, 12> }
          object { high_ring() translate <4, 0, 20> }
          box { <-20, 0, -10> <20, 20, 30> rotate 43.5*z translate <4, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 28> } }
    }
  #end
#end

#macro slope4_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 27.9> }
      box { <-20, 0, -10> <10, 10, 30> rotate 24.5*z translate <12, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <19.9, 9.5, 27.9> }
            box { <-20, 0, -10> <10, 10, 30> texture { color_tex normal { bumping } }
              rotate 24.5*z translate <12, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 24> }
          #else
            object { rounded_button() rotate 90*y translate <16, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 24> }
          #end
        }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 24> }
          difference {
            box { <-2.4, -1, -2.4> <18.4, 8.6, 26.4> }
            box { <-20, 0, -10> <10, 10, 30> rotate 24.5*z translate <12, 7.5, 0> }
          }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { high_ring() translate <4, 0, 4> }
            object { high_ring() translate <12, 0, 4> }
            object { high_ring() translate <4, 0, 12> }
            object { high_ring() translate <12, 0, 12> }
            object { high_ring() translate <4, 0, 20> }
            object { high_ring() translate <12, 0, 20> }
          }
          box { <-20, 0, -10> <10, 10, 30> rotate 24.5*z translate <12, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 28> } }
    }
  #end
#end
#macro slope4_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
      box { <-20, 0, -10> <20, 20, 30> rotate 43.5*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
            box { <-20, 0, -10> <20, 20, 30> texture { color_tex normal { bumping } }
              rotate 43.5*z translate <4, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 24> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 24> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 24> }
          #else
            object { rounded_button() rotate 180*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <8, 6.4, 8> }
            object { rounded_button() rotate 180*y translate <8, 6.4, 16> }
            object { rounded_button() rotate 180*y translate <8, 6.4, 24> }
            object { rounded_button() rotate 180*y translate <16, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <16, 6.4, 8> }
            object { rounded_button() rotate 180*y translate <16, 6.4, 16> }
            object { rounded_button() rotate 180*y translate <16, 6.4, 24> }
            object { rounded_button() rotate 180*y translate <24, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <24, 6.4, 8> }
            object { rounded_button() rotate 180*y translate <24, 6.4, 16> }
            object { rounded_button() rotate 180*y translate <24, 6.4, 24> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <26.4, 8.6, 26.4> }
            box { <-20, 0, -10> <20, 20, 30> rotate 43.5*z translate <4, 7.5, 0> }
            box { <-4, -2, 2.4> <28, 9, 4> }
            box { <-4, -2, 20> <28, 9, 21.6> }
            difference {
              box { <0, 0.2, -2.5> <2.5, 12, 2.5> }
              box { <-2.5, 0, -2.5> <2.5, 20, 2.5> rotate 45*y }
            }
            difference {
              box { <-2.5, 0.2, -2.5> <2.5, 12, 2.5> }
              box { <-2.5, 0, -2.5> <2.5, 20, 2.5> rotate 45*y }
              translate <8, 0, 0>
            }
            difference {
              box { <-2.5, 0.2, -2.5> <2.5, 12, 2.5> }
              box { <-2.5, 0, -2.5> <2.5, 20, 2.5> rotate 45*y }
              translate <16, 0, 0>
            }
            difference {
              box { <-2.5, 0.2, -2.5> <0, 12, 2.5> }
              box { <-2.5, 0, -2.5> <2.5, 20, 2.5> rotate 45*y }
              translate <24, 0, 0>
            }
            difference {
              box { <0, 0.2, -2.5> <2.5, 12, 2.5> }
              box { <-2.5, 0, -2.5> <2.5, 20, 2.5> rotate 45*y }
              translate <0, 0, 24>
            }
            difference {
              box { <-2.5, 0.2, -2.5> <2.5, 12, 2.5> }
              box { <-2.5, 0, -2.5> <2.5, 20, 2.5> rotate 45*y }
              translate <8, 0, 24>
            }
            difference {
              box { <-2.5, 0.2, -2.5> <2.5, 12, 2.5> }
              box { <-2.5, 0, -2.5> <2.5, 20, 2.5> rotate 45*y }
              translate <16, 0, 24>
            }
            difference {
              box { <-2.5, 0.2, -2.5> <0, 12, 2.5> }
              box { <-2.5, 0, -2.5> <2.5, 20, 2.5> rotate 45*y }
              translate <24, 0, 24>
            }
         }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 24> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 24> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 24> }
        #end
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 28> } }
    }
  #end
#end
#macro slope6_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 43.9> }
      box { <-20, 0, -10> <10, 10, 50> rotate 24.5*z translate <12, 9.5, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <19.9, 9.5, 43.9> }
          box { <-20, 0, -10> <10, 10, 50> rotate 24.5*z translate <12, 9.5, 0> }
        }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 40> }
        #else
          object { rounded_button() rotate 90*y translate <16, 6.4, 0> }
          object { rounded_button() rotate 90*y translate <16, 6.4, 40> }
        #end
      }
      #if (setting > 1)
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 40> }
        difference {
          merge {
            box { <-2.4, -1, -2.4> <18.4, 8, 2.4> }
            box { <-2.4, -1, 4> <20, 8, 36> }
            box { <-2.4, -1, 37.4> <18.4, 8, 42.4> }
          }
         box { <-20, 0, -10> <10, 10, 50> rotate 24.5*z translate <12, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 44> } }
    }
  #end
#end
#macro slope8_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 59.9> }
      box { <-20, 0, -10> <20, 20, 60> rotate 43.5*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 9.5, 59.9> }
            box { <-20, 0, -10> <20, 20, 60> texture { color_tex normal { bumping } }
              rotate 43.5*z translate <4, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 24> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 32> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 40> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 48> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 56> }
          #else
            object { rounded_button() rotate 90*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 24> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 32> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 40> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 48> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 56> }
          #end
        }
        #if (setting > 1)
          difference {
            merge {
              box { <-2.4, -1, -2.4> <10.4, 8.6, 11.5> }
              box { <-2.4, -1, 12.5> <10.4, 8.6, 27.5> }
              box { <-2.4, -1, 28.5> <10.4, 8.6, 43.5> }
              box { <-2.4, -1, 44.5> <10.4, 8.6, 58.4> }
              box { <-2.4, -1, -2.400001> <10.4, 1.5, 58.400001> }
            }
            box { <-20, 0, -10> <20, 20, 60> rotate 43.5*z translate <4, 7.5, 0> }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 24> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 32> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 40> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 48> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 56> }
        #end
        difference {
          merge {
            cylinder { -1*y, 7*y, 2.6 translate <4, 0, 12> }
            cylinder { -1*y, 7*y, 2.6 translate <4, 0, 28> }
            cylinder { -1*y, 7*y, 2.6 translate <4, 0, 44> }
          }
          box { <-20, 0, -10> <20, 20, 60> rotate 43.5*z translate <4, 7.5, 0> }
        }
      }
      difference {
        merge {
          object { high_ring() translate <4, 0, 4> }
          object { high_ring() translate <4, 0, 12> }
          object { high_ring() translate <4, 0, 20> }
          object { high_ring() translate <4, 0, 28> }
          object { high_ring() translate <4, 0, 36> }
          object { high_ring() translate <4, 0, 44> }
          object { high_ring() translate <4, 0, 52> }
        }
        box { <-20, 0, -10> <20, 20, 60> rotate 43.5*z translate <4, 7.5, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 60> } }
    }
  #end
#end
#macro slope8_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 9.5, 59.9> }
      box { <-50, 0, -10> <50, 50, 60> rotate 8.5*z translate <44, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        difference {
          box { <-3.9, 0, -3.9> <43.9, 9.5, 59.9> }
          box { <-50, 0, -10> <50, 50, 60> rotate 8.5*z translate <44, 9.5, 0> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <34.4, 8.6, 58.4> }
            box { <-50, 0, -10> <50, 50, 60> rotate 8.5*z translate <44, 7.5, 0> }
            box { <18.5, -2, 10.4> <35, 9, 45.6> }
          }
          difference {
            merge {
              box { <35.9, -1, -2.4> <42.4, 8.6, 58.4> }
              box { <19.9, -2, 11.9> <36, 9, 43.9> }
            }
            box { <-50, 0, -10> <50, 50, 60> rotate 8.5*z translate <44, 7.5, 0> }
          }
        #end
        box { <35.9, -1, -4> <44, 3.2, 60> }
      }
      #if (setting > 1)
        difference {
          merge {
            object { high_ring() translate <4, 0, 4> }
            object { high_ring() translate <12, 0, 4> }
            object { high_ring() translate <20, 0, 4> }
            object { high_ring() translate <28, 0, 4> }
            object { high_ring() translate <4, 0, 12> }
            object { high_ring() translate <4, 0, 20> }
            object { high_ring() translate <4, 0, 28> }
            object { high_ring() translate <12, 0, 12> }
            object { high_ring() translate <12, 0, 20> }
            object { high_ring() translate <12, 0, 28> }
            object { high_ring() translate <4, 0, 36> }
            object { high_ring() translate <4, 0, 44> }
            object { high_ring() translate <4, 0, 52> }
            object { high_ring() translate <12, 0, 36> }
            object { high_ring() translate <12, 0, 44> }
            object { high_ring() translate <12, 0, 52> }
            object { high_ring() translate <20, 0, 52> }
            object { high_ring() translate <28, 0, 52> }
            object { high_ring() translate <28, 3.2, 20> }
            object { high_ring() translate <28, 3.2, 28> }
            object { high_ring() translate <28, 3.2, 36> }
            object { high_ring() translate <36, 3.2, 20> }
            object { high_ring() translate <36, 3.2, 28> }
            object { high_ring() translate <36, 3.2, 36> }
            cylinder { 3.2*y, 8.7*y, 1.5 translate <40, 0, 4> }
            cylinder { 3.2*y, 8.7*y, 1.5 translate <40, 0, 12> }
            cylinder { 3.2*y, 8.7*y, 1.5 translate <40, 0, 44> }
            cylinder { 3.2*y, 8.7*y, 1.5 translate <40, 0, 52> }
            box { <35.8, 3.2, -0.5> <37.5, 8.7, 0.5> }
            box { <35.8, 3.2, 7.5> <37.5, 8.7, 8.5> }
            box { <35.8, 3.2, 47.5> <37.5, 8.7, 48.5> }
            box { <35.8, 3.2, 55.5> <37.5, 8.7, 56.5> }
            box { <19.8, 3.2, 15.5> <21.5, 8.7, 16.5> }
            box { <19.8, 3.2, 23.5> <21.5, 8.7, 24.5> }
            box { <19.8, 3.2, 31.5> <21.5, 8.7, 32.5> }
            box { <19.8, 3.2, 39.5> <21.5, 8.7, 40.5> }
            box { <38.8, 4.8, 19.5> <42.8, 8.7, 20.5> }
            box { <38.8, 4.8, 27.5> <42.8, 8.7, 28.5> }
            box { <38.8, 4.8, 35.5> <42.8, 8.7, 36.5> }
            box { <23.5, 3.2, 11.8> <24.5, 8.7, 13.5> }
            box { <31.5, 3.2, 11.8> <32.5, 8.7, 13.5> }
            box { <23.5, 3.2, 42.5> <24.5, 8.7, 44.2> }
            box { <31.5, 3.2, 42.5> <32.5, 8.7, 44.2> }
          }
          box { <-50, 0, -10> <50, 50, 60> rotate 8.5*z translate <44, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 9.6, 60> } }
    }
  #end
#end
#macro small_barrel(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 17.5*y, 7.5 translate <4, 0, 4> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { 15.5*y, 17.5*y, 6.5 }
          cylinder { 0*y, 3.1*y, 7.8 }
          cylinder { 8.4*y, 10.2*y, 7.9 }
          difference {
            sphere { <0, 0, 0> 1 scale <7.5, 20, 7.5> translate <0, 9.3, 0> }
            box { <-10, -100, -10> <10, 3.099999, 10> }
            box { <-10, 15.600001, -10> <10, 100, 10> }
            box { <-0.175, 2, -8> <0.175, 16, -7> rotate 0*y }
            box { <-0.175, 2, -8> <0.175, 16, -7> rotate 30*y }
            box { <-0.175, 2, -8> <0.175, 16, -7> rotate 60*y }
            box { <-0.175, 2, -8> <0.175, 16, -7> rotate 90*y }
            box { <-0.175, 2, -8> <0.175, 16, -7> rotate 120*y }
            box { <-0.175, 2, -8> <0.175, 16, -7> rotate 150*y }
            box { <-0.175, 2, -8> <0.175, 16, -7> rotate 180*y }
            box { <-0.175, 2, -8> <0.175, 16, -7> rotate 210*y }
            box { <-0.175, 2, -8> <0.175, 16, -7> rotate 240*y }
            box { <-0.175, 2, -8> <0.175, 16, -7> rotate 270*y }
            box { <-0.175, 2, -8> <0.175, 16, -7> rotate 300*y }
            box { <-0.175, 2, -8> <0.175, 16, -7> rotate 330*y }
          }
          translate <4, 0, 4>
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
        #end
        box { <1.75, -1, 3.1> <6.25, 4, 4.9> }
        box { <3.1, -1, 1.75> <4.9, 4, 6.25> }
        cylinder { 3.1*y, 18*y, 5.4 translate <4, 0, 4> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 17.6, 12> } }
    }
  #end
#end
#macro small_ladder1_2(color_tex,age)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -5.9> <11.9, 3.1, 3.9> }
      box { <9.9, -15.9, -5.899999> <11.899999, 3.099999, -3.999999> }
      box { <-3.899999, -15.9, -5.899998> <-1.9, 3.099999, -3.999998> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -5.9> <11.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
          #end
          box { <9.9, -15.9, -5.899999> <11.899999, 3.099999, -3.999999> }
          box { <-3.899999, -15.9, -5.899998> <-1.9, 3.099999, -3.999998> }
          difference {
            merge {
              box { <-3.899998, -1.5, -5> <11.899998, 0, 0> rotate -5*x translate <0, 3.099999, -3.899999> }
              box { <-3.899998, -1.5, -5> <11.899998, 0, 0> rotate -5*x translate <0, -1.800001, -3.899999> }
              box { <-3.899998, -1.5, -5> <11.899998, 0, 0> rotate -5*x translate <0, -6.600001, -3.899999> }
              box { <-3.899998, -1.5, -5> <11.899998, 0, 0> rotate -5*x translate <0, -11.400001, -3.899999> }
            }
            box { <-4, -20, -10> <12, 5, -7.7> }
            box { <-4, -20, -4> <12, -0.000001, 0> }
          }
          box { <-3.899997, -2, -4.9> <11.899997, 2.5, -3.900005> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      object { pin(age) translate <4, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -16, -7.8> <12, 4.9, 4> } }
    }
  #end
#end
#macro small_leaves(color_tex)
difference {
  merge {
    cylinder { 0*y, 3.1*y, 3.2 }
    object { open_rounded_button() }
    cylinder { 2*y, 3.000001*y, 2.4 translate <8, 0, -8> }
    cylinder { 2*y, 3.000001*y, 2.4 translate <8, 0, 8> }
    cylinder { 2*y, 3.000001*y, 2.4 translate <16, 0, -8> }
    cylinder { 2*y, 3.000001*y, 2.4 translate <16, 0, 8> }
    cylinder { 2*y, 3.000001*y, 2.4 translate <24, 0, 0> }
    object { open_rounded_button() translate <8, 0, -8> }
    object { open_rounded_button() translate <8, 0, 8> }
    object { open_rounded_button() translate <16, 0, -8> }
    object { open_rounded_button() translate <16, 0, 8> }
    object { open_rounded_button() translate <24, 0, 0> }
    cylinder { 0*y, 2.1*y, 3.2 translate <24, 0, 0> }
    cylinder { 1.999999*y, 3.100001*y, 3.9 translate <24, 0, 0> }
    box { <3, 2.000001, -1.6> <21, 3.100002, 1.6> }
    box { <2, 2.000002, -1.6> <11, 3.100003, 1.6> rotate -45*y translate <8, 0, -8> }
    box { <2, 2.000003, -1.6> <11, 3.100004, 1.6> rotate -45*y translate <16, 0, -8> }
    box { <2, 2.000004, -1.6> <11, 3.100005, 1.6> rotate 45*y translate <8, 0, 8> }
    box { <2, 2.000005, -1.6> <11, 3.100006, 1.6> rotate 45*y translate <16, 0, 8> }
  }
  cylinder { -1*y, 2*y, 2.6 }
  cylinder { -1*y, 5*y, 1.600001 }
  cylinder { -1*y, 5*y, 1.600001 translate <8, 0, -8> }
  cylinder { -1*y, 5*y, 1.600001 translate <8, 0, 8> }
  cylinder { -1*y, 5*y, 1.600001 translate <16, 0, -8> }
  cylinder { -1*y, 5*y, 1.600001 translate <16, 0, 8> }
  cylinder { -1*y, 5*y, 1.600001 translate <24, 0, 0> }
  cylinder { -1*y, 2*y, 2.6 translate <24, 0, 0> }
  texture { color_tex }
  bounded_by { box { <-3.4, -0.1, -10.4> <27.4, 4.9, 10.4> } }
}
#end
#macro socket_swivel(color_tex)
  #if (setting = 0)
    merge {
      box { <-14.9, -3.9, -7.9> <-3.9, 3.9, 7.9> }
      box { <-4, -2.500001, -3.300001> <0.000001, 2.500001, 3.300001> }
      cylinder { -3.3*z, 3.3*z, 2.5 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-14.9, -3.9, -7.9> <-3.9, 3.9, 7.9> }
          object { open_rounded_button() translate <-8, 0.8, 0> }
          object { open_rounded_button() rotate 180*x translate <-8, -0.8, 0> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> translate <-8, -3.9, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*x translate <-8, 3.9, 0> }
          #end
        }
        #if (setting > 1)
          cylinder { -4*y, 4*y, 1.5 translate <-12, 0, 0> }
          box { <-15, -2.9, -1.5> <-12, 2.9, 1.5> }
        #end
        box { <-5.4, -4, -3.9> <0, 4, -10> }
        box { <-5.4, -4, 3.9> <0, 4, 10> }
        box { <0, -4, -6> <5, 4, 0> rotate 37.5*y translate <-5.4, 0, -3.9> }
        box { <0, -4, 0> <5, 4, 6> rotate -37.5*y translate <-5.4, 0, 3.9> }
        box { <-5, -4, 0> <0, 4, 6> rotate 37.5*y translate <-14.9, 0, 3.9> }
        box { <-5, -4, 0> <0, 4, -6> rotate -37.5*y translate <-14.9, 0, -3.9> }
        difference {
          box { <-15, -2.4, -8> <-5.4, 2.4, 8> }
          box { <-8, -3, -1.5> <-5, 3, -0.9> }
          box { <-8, -3, 1.5> <-5, 3, 0.9> }
          box { <-1.1, -3, -5> <1, 3, 0> rotate 37.5*y translate <-5.4, 0, -3.9> }
          box { <-1.1, -3, 0> <1, 3, 5> rotate -37.5*y translate <-5.4, 0, 3.9> }
        }
      }
      difference {
        box { <-4, -2.500001, -3.300001> <0.000001, 2.500001, 3.300001> }
        box { <-5, -3, -1.500001> <1, 3, 1.500001> }
      }
      difference {
        cylinder { -3.3*z, 3.3*z, 2.5 }
        box { <-3, -3, -1.5> <3, 3, 1.5> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 0*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
      }
      cylinder { -3*z, -1.2*z, 1.5 }
      cylinder { 1.2*z, 3*z, 1.5 }
      texture { color_tex }
      bounded_by { box { <-15, -5.7, -8> <2.6, 5.7, 8> } }
    }
  #end
#end
#macro sound_element2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      cylinder { 3*y, 12.7*y, 7.9 translate <4, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, .5, -3.9> <11.9, 3.1, 11.9> }
          box { <-3.5, 0, -3.5> <11.5, .55, 11.5> }
          cylinder { 2*y, 3.3*y, 7.8 translate <4, 0, 4> }
          cylinder { 3.2*y, 8.5*y, 7.900001 translate <4, 0, 4> }
          cylinder { 8.6*y, 12.7*y, 7.900001 translate <4, 0, 4> }
          intersection {
            cylinder { 3*y, 20*y, 7.3 translate <4, 0, 4> }
            merge {
              #if (setting < 3)
                cylinder { 12.6*y, 14.4*y, 2.4 }
                cylinder { 12.6*y, 14.4*y, 2.4 translate <8, 0, 0> }
                cylinder { 12.6*y, 14.4*y, 2.4 translate <0, 0, 8> }
                cylinder { 12.6*y, 14.4*y, 2.4 translate <8, 0, 8> }
              #else
                object { rounded_button() translate <0, 9.6, 0> }
                object { rounded_button() translate <8, 9.6, 0> }
                object { rounded_button() translate <0, 9.6, 8> }
                object { rounded_button() translate <8, 9.6, 8> }
              #end
            }
          }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          #local counter = 0;
          #while (counter < 27)
            cylinder { 9.1*y, 13*y, 0.5 translate <0, 0, -8> rotate (counter*13.33)*y translate <4, 0, 4> }
            #local counter = counter + 1;
          #end
          cylinder { 11*y, 13*y, 0.4 translate <4, 0, 4> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        difference {
          cylinder { 0*y, 2.1*y, 1.25 }
          box { <-1.5, -1, -0.5> <1.5, 1.5, 0.5> rotate 45*y }
          translate <4, 0, 4>
        }
        box { <-1, 0, 3.5> <1, 2.1, 4.5> }
        box { <7, 0, 3.5> <9, 2.1, 4.5> }
        box { <-2.3, 0, -0.5> <-1.9, 2.1, 8.5> texture { chrome_tex } }
        box { <9.9, 0, -0.5> <10.3, 2.1, 8.5> texture { chrome_tex } }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 14.5, 12> } }
    }
  #end
#end
#macro space_cover(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 19.1, 43.9> texture { color_tex } translate <-40, -5.6, 0> }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <43.9, 19.1, 43.9> }
            box { <-50, 0, -50> <50, 50, 50> rotate 31.5*z translate <-3.9, 9.5, 0> }
            box { <-50, 0, -50> <50, 50, 50> rotate -31.5*x translate <0, 9.5, -3.9> }
            box { <-50, 0, -50> <50, 50, 50> rotate -31.5*z translate <43.9, 9.5, 0> }
            box { <-50, 0, -50> <50, 50, 50> rotate 31.5*x translate <0, 9.5, 43.9> }
            box { <-50, -10, -50> <0, 20, 50> rotate -45*y translate <-3.9, 0, 11.9> }
            box { <0, 0, -40> <30, 20, 40> rotate 35*z rotate -45*y translate <11.9, 9.5, -3.9> }
            box { <-50, -10, -50> <0, 20, 50> rotate 45*y translate <-3.9, 0, 27.9> }
            box { <0, 0, -40> <30, 20, 40> rotate 35*z rotate 45*y translate <11.9, 9.5, 43.9> }
            box { <0, -10, -50> <50, 20, 50> rotate -45*y translate <43.9, 0, 27.9> }
            box { <0, 0, -40> <30, 20, 40> rotate 35*z rotate 135*y translate <43.9, 9.5, 27.9> }
            box { <0, -10, -50> <50, 20, 50> rotate 45*y translate <43.9, 0, 11.9> }
            box { <0, 0, -40> <30, 20, 40> rotate 35*z rotate 225*y translate <43.9, 9.5, 11.9> }
            box { <37.999999, -1, 0> <44, 9.5, 40> }
            #if (age = 2)
              box { <17.75, 15, 19.1> <22.25, 20, 20.9> }
              box { <19.1, 15, 17.75> <20.9, 20, 22.25> }
            #end
          }
          #if (setting < 3)
            cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 19*y, 20.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 19*y, 20.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 19*y, 20.8*y, 2.4 translate <24, 0, 24> }
          #else
            object { rounded_button() rotate 90*y translate <16, 16, 16> }
            object { rounded_button() rotate 90*y translate <16, 16, 24> }
            object { rounded_button() rotate 90*y translate <24, 16, 16> }
            object { rounded_button() rotate 90*y translate <24, 16, 24> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <38, 18.2, 42.4> }
            box { <-50, 0, -50> <50, 50, 50> rotate 31.5*z translate <-3.9, 7.5, 0> }
            box { <-50, 0, -50> <50, 50, 50> rotate -31.5*x translate <0, 7.5, -3.9> }
            box { <-50, 0, -50> <50, 50, 50> rotate -31.50*z translate <43.9, 7.5, 0> }
            box { <-50, 0, -50> <50, 50, 50> rotate 31.5*x translate <0, 7.5, 43.9> }
            box { <-50, -10, -50> <0, 20, 50> rotate -45*y translate <-2.9, 0, 12.9> }
            box { <0, 0, -40> <30, 20, 40> rotate 35*z rotate -45*y translate <11.9, 7.5, -3.9> }
            box { <-50, -10, -50> <0, 20, 50> rotate 45*y translate <-2.9, 0, 26.9> }
            box { <0, 0, -40> <30, 20, 40> rotate 35*z rotate 45*y translate <11.9, 7.5, 43.9> }
            box { <0, -10, -50> <50, 20, 50> rotate -45*y translate <42.9, 0, 26.9> }
            box { <0, 0, -40> <30, 20, 40> rotate 35*z rotate 135*y translate <43.9, 7.5, 27.9> }
            box { <0, -10, -50> <50, 20, 50> rotate 45*y translate <42.9, 0, 12.9> }
            box { <0, 0, -40> <30, 20, 40> rotate 35*z rotate 225*y translate <43.9, 7.5, 11.9> }
          }
          box { <-2.6, -1, -3.5> <2.6, 2, 3.5> rotate 45*y translate <0, 0, 8> }
          box { <-2.6, -1, -3.5> <2.6, 2, 3.5> rotate 45*y translate <8, 0, 0> }
          box { <-2.6, -1, -3.5> <2.6, 2, 3.5> rotate -45*y translate <0, 0, 32> }
          box { <-2.6, -1, -3.5> <2.6, 2, 3.5> rotate -45*y translate <8, 0, 40> }
          box { <-2.6, -1, -3.5> <2.6, 2, 3.5> rotate -45*y translate <32, 0, 0> }
          box { <-2.6, -1, -3.5> <2.6, 2, 3.5> rotate 45*y translate <32, 0, 40> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <16, 0, 16> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <16, 0, 24> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <24, 0, 16> }
          cylinder { 16.9*y, 19.9*y, 1.2 translate <24, 0, 24> }
        #end
      }
      difference {
        box { <39.5, 3.499999, 14.499999> <40.5, 9.500001, 26.499999> }
        box { <39, -7, 19> <41, 6.8, 21> }
      }
      cylinder { -2.5*z, -1.5*z, 2 translate <40, 5.5, 16> }
      cylinder { 9.5*z, 10.5*z, 2 translate <40, 5.5, 16> }
      box { <38, 5.499999, 13.499999> <42, 9.500002, 14.500001> }
      box { <38, 5.499999, 25.500001> <42, 9.500002, 26.499999> }
      cylinder { -3.9*z, -2.499999*z, 1.5 translate <40, 5.5, 16> }
      cylinder { 10.499999*z, 11.9*z, 1.5 translate <40, 5.5, 16> }
      texture { color_tex }
      bounded_by { box { <-4, 0.1, -4> <44, 20.9, 44> } }
      translate <-40, -5.6, 0>
    }
  #end
#end
#macro space_mmu(color_tex)
merge {
  difference {
    merge {
      box { <-5.4, -7, -5.4> <5.4, 0.9, 5.4> }
      cylinder { 3.5*z, 9*z, 3.25 translate <-4, -3.5, 0> }
      cylinder { 3.5*z, 9*z, 3.25 translate <4, -3.5, 0> }
      #if (setting < 3)
        cylinder { -11*z, -5*z, 2.4 translate <-10.5, 4.15, 0> }
        cylinder { -11*z, -5*z, 2.4 translate <10.5, 4.15, 0> }
      #else
        object { open_rounded_button() rotate -90*x translate <-10.5, 4.15, -6.1> }
        object { open_rounded_button() rotate -90*x translate <10.5, 4.15, -6.1> }
      #end
      intersection {
        box { <-3.25, -3.25, -9> <3.25, 3.25, 10.000001> }
        box { <-3.25, -3.25, -10> <3.25, 3.25, 10.000002> rotate 45*z }
        rotate 17.5*z
        translate <-10.5, 4.15, 0>
      }
      intersection {
        box { <-3.25, -3.25, -9> <3.25, 3.25, 10.000001> }
        box { <-3.25, -3.25, -10> <3.25, 3.25, 10.000002> rotate 45*z }
        rotate -17.5*z
        translate <10.5, 4.15, 0>
      }
      difference {
        box { <-10.5, -4, -5.400001> <10.5, 8.5, 10> }
        box { <-11, -20, 0> <11, 0, 10> rotate 21*x translate <0, 8.5, 10> }
        cylinder { 5.5*y, 9*y, 7.5 }
        box { <-7.500001, 5.5, -5> <7.500001, 9, 0.000001> }
        box { <0, -10, -7> <10, 0, 11> rotate -45*z translate <10.5, 0.9, 0> }
        box { <-10, -10, -7> <0, 0, 11> rotate 45*z translate <-10.5, 0.9, 0> }
        difference {
          box { <-7.500002, 0.899999, -6> <7.500002, 7.000001, 10> }
          box { <-11, -20, 0> <11, 0, 10> rotate 21*x translate <0, 8.5, 9> }
          box { <-10, 0, -7> <0, 10, 11> rotate 17.5*z translate <-6.4, 0.9, 0> }
          box { <0, 0, -7> <10, 10, 11> rotate -17.5*z translate <6.4, 0.9, 0> }
        }
      }
    }
    box { <-20, -15, -4.000003> <-5.4, -3.5, 4.000003> }
    box { <5.4, -15, -4.000002> <20, -3.5, 4.000002> }
    box { <-20, -15, -4.000004> <-7.75, 0, 4.000004> }
    box { <7.75, -15, -4.000005> <20, 0, 4.000005> }
    cylinder { -10*x, 10*x, 3 translate <0, -4, 0> }
    box { <-7.500004, 1, -10> <7.500004, 10, -4.999998> }
    box { <-8, -9, -4.000001> <8, -3, 4.000001> }
    box { <0, 0, -10> <10, 10, 20> rotate -17.5*z translate <7.5, 8.5, 0> }
    box { <-10, 0, -10> <0, 10, 20> rotate 17.5*z translate <-7.5, 8.5, 0> }
    cylinder { -2*y, 2*y, 2.5 }
    box { <-6, -8, -4> <6, 0, 4> }
    box { <-2.5, -8, -6> <2.5, -1, 0> }
    cylinder { 5.41*z, 10*z, 2.6 translate <-4, -3.5, 0> }
    cylinder { 5.41*z, 10*z, 2.6 translate <4, -3.5, 0> }
    cylinder { 8*z, 11*z, 2.6 translate <-10.5, 4.15, 0> }
    cylinder { 8*z, 11*z, 2.6 translate <10.5, 4.15, 0> }
    cylinder { 0.5*z, 11*z, 1.55 translate <-10.5, 4.15, 0> }
    cylinder { 0.5*z, 11*z, 1.55 translate <10.5, 4.15, 0> }
    cylinder { -12*z, 0*z, 1.55 translate <-10.5, 4.15, 0> }
    cylinder { -12*z, 0*z, 1.55 translate <10.5, 4.15, 0> }
    box { <-5, 0, -5> <1, 10, 0> rotate 17.5*z rotate -45*y translate <7.5, 8.5, -1> }
    box { <-1, 0, -5> <5, 10, 0> rotate -17.5*z rotate 45*y translate <-7.5, 8.5, -1> }
    box { <-0.4, -6, -0.5> <0.4, -3, 5> rotate 21*x translate <-5.5, 8.5, 10> }
    box { <-0.4, -6, -0.5> <0.4, -3, 5> rotate 21*x translate <5.5, 8.5, 10> }
  }
  intersection {
    merge {
      intersection {
        sphere { <0, -4.5, 0> 1.25 }
        box { <-2, -4.500001, -2> <2, -3, 2> }
      }
      intersection {
        sphere { <0, -6.5, 0> 1.25 }
        box { <-2, -8, -2> <2, -6.499999, 2> }
      }
      cylinder { -4.5*y, -6.5*y, 0.75 }
      cylinder { -4.9*y, -5.3*y, 1.25 }
      cylinder { -5.7*y, -6.1*y, 1.25 }
    }
    box { <-2, -8, -0.1> <2, -2, 2> }
    translate <-4, 0, 0>
    rotate 15*z
    rotate 21*x
    translate <0, 8.5, 10>
  }
  intersection {
    merge {
      intersection {
        sphere { <0, -4.5, 0> 1.25 }
        box { <-2, -4.500001, -2> <2, -3, 2> }
      }
      intersection {
        sphere { <0, -6.5, 0> 1.25 }
        box { <-2, -8, -2> <2, -6.499999, 2> }
      }
      cylinder { -4.5*y, -6.5*y, 0.75 }
      cylinder { -4.9*y, -5.3*y, 1.25 }
      cylinder { -5.7*y, -6.1*y, 1.25 }
    }
    box { <-2, -8, -0.1> <2, -2, 2> }
    translate <4, 0, 0>
    rotate -15*z
    rotate 21*x
    translate <0, 8.5, 10>
  }
  cylinder { 2.5*z, 8.5*z, 1 translate <-10.5, 10, 0> }
  cylinder { 2.5*z, 8.5*z, 1 translate <10.5, 10, 0> }
  box { <-11, 7, 3.5> <-10, 10, 7.5> }
  box { <10, 7, 3.5> <11, 10, 7.5> }
  cylinder { -8*y, -2.5*y, 1.5 translate <-8.75, 0, -12> }
  cylinder { -8*y, -2.5*y, 1.5 translate <8.75, 0, -12> }
  difference {
    merge {
      cylinder { 0*y, 1.5*y, 1.5 translate <-8.75, 0, 0> }
      cylinder { 0*y, 1.5*y, 1.5 translate <8.75, 0, 0> }
      box { <-1.5, -0.000001, 0> <1.5, 1.500001, 9> rotate 35*y translate <-8.750001, 0, 0> }
      box { <-1.5, -0.000001, 0> <1.5, 1.500001, 9> rotate -35*y translate <8.750001, 0, 0> }
      box { <-5.400005, -0.000002, 3> <5.400005, 1.500002, 7.5> }
    }
    cylinder { -1*y, 2*y, 6.5 translate <0, 0, -1.25> }
    rotate -15*x
    translate <0, -3, -12>
  }
  texture { color_tex }
  bounded_by { box { <-15, -8.1, -14> <15, 11.1, 10.5> } }
}
#end
#macro space_nose(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 19.1, 11.9> }
      box { <27.9, -1, -4> <44, 3.2, 12> }
      box { <27.9, 6.3, -4> <44, 10, 12> }
      box { <19.9, 9.5, -4> <44, 20, 12> }
      box { <-30, 0, -10> <10, 10, 20> rotate 22.9*z translate <18.9, 19.1, 0> }
      box { <-30, 9.5, -10> <0, 20, 0> rotate 9.45*y translate <18.9, 0, -3.8> }
      box { <-30, 9.5, 0> <0, 20, 10> rotate -9.45*y translate <18.9, 0, 11.8> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <43.9, 19.1, 11.9> }
        box { <27.9, -1, -4> <44, 3.2, 12> }
        box { <27.9, 6.3, -4> <44, 10, 12> }
        box { <19.9, 9.5, -4> <44, 20, 12> }
        box { <-30, 0, -10> <10, 10, 20> rotate 22.9*z translate <18.9, 19.1, 0> }
        box { <-30, 9.5, -10> <0, 20, 0> rotate 9.45*y translate <18.9, 0, -3.8> }
        box { <-30, 9.5, 0> <0, 20, 10> rotate -9.45*y translate <18.9, 0, 11.8> }
        cylinder { -4*x, 0*x, 1.60001 translate <0, 5.6, 0> }
        cylinder { -4*x, 0*x, 1.60001 translate <0, 5.6, 8> }
        cylinder { -4*z, 12*z, 1.60001 translate <0, 5.6, 0> }
        cylinder { -4*z, 12*z, 1.60001 translate <8, 5.6, 0> }
        cylinder { -4*z, 12*z, 1.60001 translate <16, 5.6, 0> }
        cylinder { -4*z, 12*z, 1.60001 translate <24, 5.6, 0> }
        box { <16, 9.50001, -4> <20, 20, -3.8> }
        box { <16, 9.50001, 11.8> <20, 20, 12> }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 8> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <32, 0, 0> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <32, 0, 8> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <40, 0, 0> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <40, 0, 8> }
          difference {
            box { <27.90001, -1, -2.4> <42.4, 5.4, 10.4> }
            object { ring() translate <36, 3.20001, 4> }
            box { <27, 3.4, 3.5> <33, 6, 4.5> }
            box { <27, 3.2, -0.5> <29.6, 6, 0.5> }
            box { <27, 3.2, 7.5> <29.6, 6, 8.5> }
          }
          difference {
            box { <19.9, -1, -2.4> <26.4, 8.6, 10.4> }
            box { <19, 2.8, 3.5> <27, 9, 4.5> }
            box { <19, 0.1, -0.5> <21.6, 9, 0.5> }
            box { <19, 0.1, 7.5> <21.6, 9, 8.5> }
            cylinder { 0.00001*y, 8.7*y, 1.5 translate <24, 0, 4> }
          }
          difference {
            box { <-2.4, -1, -2.4> <18.4, 20, 10.4> }
            box { <-30, 8.6, -10> <0, 20, 0> rotate 9.45*y translate <18.9, 0, -2.4> }
            box { <-30, 8.6, 0> <0, 20, 10> rotate -9.45*y translate <18.9, 0, 10.4> }
            box { <-30, 0, -10> <10, 10, 20> rotate 22.9*z translate <18.9, 18.6, 0> }
            object { ring() scale <1, 10, 1> translate <4, 0.00001, 4> }
            object { ring() scale <1, 10, 1> translate <12, 0.00001, 4> }
            box { <-3, 5.6, 3.5> <1, 21, 4.5> }
            box { <7, 5.6, 3.5> <9, 21, 4.5> }
            box { <15, 5.6, 3.5> <19, 21, 4.5> }
          }
        #end
      }
      object { open_rounded_button() rotate 90*z translate <-0.8, 5.6, 0> }
      object { open_rounded_button() rotate 90*z translate <-0.8, 5.6, 8> }
      object { open_rounded_button() rotate -90*x translate <0, 5.6, -0.8> }
      object { open_rounded_button() rotate 90*x translate <0, 5.6, 8.8> }
      object { open_rounded_button() rotate -90*x translate <8, 5.6, -0.8> }
      object { open_rounded_button() rotate 90*x translate <8, 5.6, 8.8> }
      object { open_rounded_button() rotate -90*x translate <16, 5.6, -0.8> }
      object { open_rounded_button() rotate 90*x translate <16, 5.6, 8.8> }
      object { open_rounded_button() rotate -90*x translate <24, 5.6, -0.8> }
      object { open_rounded_button() rotate 90*x translate <24, 5.6, 8.8> }
      #if (setting < 3)
        cylinder { 11.8*z, 13.6*z, 2.4 translate <0, 5.6, 0> }
        cylinder { 11.8*z, 13.6*z, 2.4 translate <8, 5.6, 0> }
        cylinder { 11.8*z, 13.6*z, 2.4 translate <16, 5.6, 0> }
        cylinder { 11.8*z, 13.6*z, 2.4 translate <24, 5.6, 0> }
      #else
        object { rounded_button() translate <24, 6.4, 0> }
        object { rounded_button() translate <24, 6.4, 8> }
        object { rounded_button() translate <32, 3.2, 0> }
        object { rounded_button() translate <32, 3.2, 8> }
        object { rounded_button() translate <40, 3.2, 0> }
        object { rounded_button() translate <40, 3.2, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-5.7, -0.1, -5.7> <44, 19.2, 13.7> } }
    }
  #end
#end
#macro spanner(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 7.9*y, 3 }
      cylinder { 0*x, 18.5*x, 1.5 translate <0, 4.5, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        object { open_rounded_button() translate <0, 3.1, 0> }
        cylinder { 6.2*y, 2.9*y, 2.400001 }
        cylinder { 0*y, 3*y, 3 }
        cylinder { 3*y, 6*y, 2.5 translate <16, 0, 0> }
        box { <12, 3.000001, -1.500001> <16, 5.999999, 1.500001> }
        #if (setting > 1)
          cylinder { 0*x, 12.1*x, 1.3 translate <0, 4.5, 0> }
          cylinder { 0*x, 5.5*x, 1.5 translate <0, 4.5, 0> }
          cylinder { 5.9*x, 6.3*x, 1.5 translate <0, 4.5, 0> }
          cylinder { 6.7*x, 7.1*x, 1.5 translate <0, 4.5, 0> }
          cylinder { 7.5*x, 7.9*x, 1.5 translate <0, 4.5, 0> }
          cylinder { 8.3*x, 8.7*x, 1.5 translate <0, 4.5, 0> }
          cylinder { 9.1*x, 9.5*x, 1.5 translate <0, 4.5, 0> }
          cylinder { 9.9*x, 12.05*x, 1.5 translate <0, 4.5, 0> }
        #else
          cylinder { 0*x, 18.5*x, 1.5 translate <0, 4.5, 0> }
        #end
      }
      #if (setting > 1)
        cylinder { -1*y, 2*y, 2.6 }
        cylinder { -2*y, 9*y, 1.600001 }
        cylinder { 2*y, 7*y, 1.600001 translate <16, 0, 0> }
        box { <16, 1, -1.4> <20, 8, 1.4> }
      #end
      texture { color_tex }
      bounded_by { box { <-3.1, -0.1, -3.1> <18.6, 8, 3.1> } }
    }
  #end
#end
#macro spear(color_tex)
  #if (setting = 0)
    cylinder { -1.5*y, 56*y, 1.5 texture { color_tex } }
  #else
    merge {
      sphere { <0, 0, 0> 1.5 }
      difference {
        cylinder { -0.000001*y, 42*y, 1.5 }
        box { <1.3, 32.5, -2> <2, 37.3, 2> }
        box { <-2, 0, -5> <2, 10, 0> rotate 13*x translate <0, 37.5, -1.5> }
        box { <-2, 0, 0> <2, 10, 5> rotate -13*x translate <0, 37.5, 1.5> }
      }
      torus { 0.5, 0.5 rotate 90*x translate <0, 55, 0> }
      cylinder { -0.5*z, 0.5*z, 0.5 translate <0, 55, 0> }
      cylinder { 0*y, -13*y, 0.5 rotate -9*z translate <-0.5, 55, 0> }
      cylinder { 0*y, -13*y, 0.5 rotate 9*z translate <0.5, 55, 0> }
      torus { 1.5, 0.5 rotate 90*x translate <1.5, -13, 0> rotate -9*z translate <-0.5, 55, 0> }
      torus { 1.5, 0.5 rotate 90*x translate <-1.5, -13, 0> rotate 9*z translate <0.5, 55, 0> }
      difference {
        merge {
          cylinder { -1*z, 1*z, 1.5 translate <1.5, -13, 0> rotate -9*z translate <-0.5, 55, 0> }
          cylinder { -1*z, 1*z, 1.5 translate <-1.5, -13, 0> rotate 9*z translate <0.5, 55, 0> }
          box { <-1, 40, -1> <1, 42, 1> }
          difference {
            box { <-3, 42, -1> <3, 55.5, 1> }
            box { <-10, -20, -2> <0, 1, 2> rotate -9*z translate <-0.5, 55, 0> }
            box { <0, -20, -2> <10, 1, 2> rotate 9*z translate <0.5, 55, 0> }
          }
        }
        box { <-10, 0, -10> <0.5, 20, 0> rotate 9.25*y rotate 1.5*x translate <0, 39, -1> }
        box { <-0.5, 0, -10> <10, 20, 0> rotate -9.25*y rotate 1.5*x translate <0, 39, -1> }
        box { <-10, 0, 0> <0.5, 20, 10> rotate -9.25*y rotate -1.5*x translate <0, 39, 1> }
        box { <-0.5, 0, 0> <10, 20, 10> rotate 9.25*y rotate -1.5*x translate <0, 39, 1> }
      }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y rotate -90*z translate <1.3, 34.9, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-3, -1.6, -1.6> <3, 56.1, 1.6> } }
    }
  #end
#end
    
#macro specialconnect2_1(color_tex)
  #if (setting = 0)
    cylinder { -1.5*z, 20*z, 1.5 translate <0, 3, 0> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.900001, 1.500001, 19.900001> <-2.4, 4.499999, 24> }
          cylinder { -3.900002*x, -2.399999*x, 1.5 translate <0, 3, 24> }
          box { <-0.5, 1.500001, 19.900001> <0.5, 4.499999, 24> }
          cylinder { -0.500001*x, 0.499999*x, 1.5 translate <0, 3, 24> }
          box { <2.35, 1.500001, 19.900001> <3.899999, 4.499999, 24> }
          cylinder { 2.350001*x, 3.899998*x, 1.5 translate <0, 3, 24> }
          cylinder { -3.9*x, 3.9*x, 1.5 translate <0, 3, 19.9> }
          cylinder { -2.249999*x, -0.650001*x, 1.5 }
          cylinder { 0.650001*x, 2.249999*x, 1.5 }
          box { <-2.25, 0, -1.500001> <2.25, 3.5, 1.500001> }
        }
        box { <-4, 0, -2> <0, 5, 2> rotate -23*z translate <-2.25, 1.5, 0> }
        box { <0, 0, -2> <4, 5, 2> rotate 23*z translate <2.25, 1.5, 0> }
        box { <-4, -1, 10> <4, 5, 19.899999> }
        box { <-0.65, -2, -2> <0.65, 1.6, 2> }
      }
      cylinder { -1.500001*z, 20*z, 1.5 translate <0, 3, 0> }
      box { <-1.1, 1.499999, 10.5> <1.1, 4.500001, 13.5> }
      texture { color_tex }
      bounded_by { box { <-4, -1.6, -4> <4, 4.6, 25.6> } }
    }
  #end
#end
#macro spider(color_tex)
  merge {
    object { ring() scale <1, 1.5, 1> }
    difference {
      merge {
        torus { 3.65, 0.15 scale <1.0821917, 1, 1> translate <1, 3, 0> }
        cylinder { 2.85*y, 3*y, 3.65 scale <1.0821917, 1, 1> translate <1, 0, 0> }
        difference {
          sphere { <0, 0, 0> 1 scale <4.11232486, 3, 3.8> }
          box { <-20, -20, -20> <20, 0, 20> }
          translate <1, 3, 0>
        }
        cylinder { 2*y, 5.2*y, 2.5 translate <-8, 0, 0> }
        sphere { <-4.5, 3.5, 0> 1.5 }
        cylinder { -4.5*x, -1*x, 0.9 translate <0, 3.5, 0> }
        cylinder { 3.25*y, 3.75*y, 3.75 translate <-3, 0, 0> }
        torus { 3.75, 0.25 translate <-3, 3.5, 0> }
        cylinder { <-3, 3.5, -5> <-3, 3.5, 5> 0.65 }
        cylinder { <-3, 3.5, -5> <-1.75, 3.5, -8> 0.65 }
        sphere { <-3, 3.5, -5> 0.65 }
        cylinder { <-1.75, 3.5, -8> <-0.5, 3.5, -10> 0.65 }
        sphere { <-1.75, 3.5, -8> 0.65 }
        sphere { <-0.5, 3.5, -10> 0.65 }
        cylinder { <-3, 3.5, 5> <-1.75, 3.5, 8> 0.65 }
        sphere { <-3, 3.5, 5> 0.65 }
        cylinder { <-1.75, 3.5, 8> <-0.5, 3.5, 10> 0.65 }
        sphere { <-1.75, 3.5, 8> 0.65 }
        sphere { <-0.5, 3.5, 10> 0.65 }
        cylinder { <-3, 3.5, 0> <-1.25, 3.5, -4.75> 0.65 }
        sphere { <-1.25, 3.5, -4.75> 0.65 }
        cylinder { <-1.25, 3.5, -4.75> <3, 3.5, -6.25> 0.65 }
        sphere { <3, 3.5, -6.25> 0.65 }
        cylinder { <3, 3.5, -6.25> <5, 3.5, -6.25> 0.65 }
        sphere { <5, 3.5, -6.25> 0.65 }
        cylinder { <-3, 3.5, 0> <-1.25, 3.5, 4.75> 0.65 }
        sphere { <-1.25, 3.5, 4.75> 0.65 }
        cylinder { <-1.25, 3.5, 4.75> <3, 3.5, 6.25> 0.65 }
        sphere { <3, 3.5, 6.25> 0.65 }
        cylinder { <3, 3.5, 6.25> <5, 3.5, 6.25> 0.65 }
        sphere { <5, 3.5, 6.25> 0.65 }
        cylinder { <-3.5, 3.5, 0> <-4, 3.5, -4> 0.65 }
        sphere { <-4, 3.5, -4> 0.65 }
        cylinder { <-4, 3.5, -4> <-6.25, 3.5, -7.5> 0.65 }
        sphere { <-6.25, 3.5, -7.5> 0.65 }
        cylinder { <-6.25, 3.5, -7.5> <-7.25, 3.5, -8.25> 0.65 }
        sphere { <-7.25, 3.5, -8.25> 0.65 }
        cylinder { <-3.5, 3.5, 0> <-4, 3.5, 4> 0.65 }
        sphere { <-4, 3.5, 4> 0.65 }
        cylinder { <-4, 3.5, 4> <-6.25, 3.5, 7.5> 0.65 }
        sphere { <-6.25, 3.5, 7.5> 0.65 }
        cylinder { <-6.25, 3.5, 7.5> <-7.25, 3.5, 8.25> 0.65 }
        sphere { <-7.25, 3.5, 8.25> 0.65 }
        cylinder { <-4, 3.5, 0> <-6.25, 3.5, -3.5> 0.65 }
        sphere { <-6.25, 3.5, -3.5> 0.65 }
        cylinder { <-6.25, 3.5, -3.5> <-9.5, 3.5, -4> 0.65 }
        sphere { <-9.5, 3.5, -4> 0.65 }
        cylinder { <-9.5, 3.5, -4> <-10.5, 3.5, -4> 0.65 }
        sphere { <-10.5, 3.5, -4> 0.65 }
        cylinder { <-4, 3.5, 0> <-6.25, 3.5, 3.5> 0.65 }
        sphere { <-6.25, 3.5, 3.5> 0.65 }
        cylinder { <-6.25, 3.5, 3.5> <-9.5, 3.5, 4> 0.65 }
        sphere { <-9.5, 3.5, 4> 0.65 }
        cylinder { <-9.5, 3.5, 4> <-10.5, 3.5, 4> 0.65 }
        sphere { <-10.5, 3.5, 4> 0.65 }
      }
      cylinder { -1*y, 4*y, 2.600001 }
      cylinder { -1*y, 10*y, 1.600001 translate <-8, 0, 0> }
      box { <-5, 1, -1> <0, 6, 1> rotate -10*y translate <-8, 0, 0> }
      box { <-5, 1, -1> <0, 6, 1> rotate 10*y translate <-8, 0, 0> }
      difference {
        box { <-2.5, 1, 0> <1.75, 6, 1.5> }
        cylinder { 1.1*y, 5.9*y, 0.9 }
        translate <-1.6, 0, -0.2>
        rotate -55*y
        translate <-8, 0, 0>
      }
      difference {
        box { <-2.5, 1, -1.5> <1.75, 6, 0> }
        cylinder { 1.1*y, 5.9*y, 0.9 }
        translate <-1.6, 0, 0.2>
        rotate 55*y
        translate <-8, 0, 0>
      }
      #if (setting > 1)
        sphere { <0.5, 5.85, -2> 0.65 }
        sphere { <0.5, 6.2, -1.2> 0.65 }
        sphere { <0.5, 6.2, 1.2> 0.65 }
        sphere { <0.5, 5.85, 2> 0.65 }
        sphere { <-1.75, 6.1, 0> 0.65 }
        sphere { <4.75, 6.1, 0> 0.65 }
        difference {
          torus { 35, 0.65 rotate 90*x }
          box { <-100, -50, -50> <-1.75, 100, 50> }
          box { <4.75, -50, -50> <100, 100, 50> }
          translate <0, -28.8, 0>
        }
      #end
    }
    texture { color_tex }
    bounded_by { box { <-11.25, -0.1, -10.75> <5.75, 6.1, 10.75> } }
  }
#end
#macro sp_support1_2(color_tex,age)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      sphere { <4, 1.55, 36> 2.9 }
      cylinder { 3*z, 36*z, 1.55 translate <4, 1.550001, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          sphere { <4, 1.55, 36> 2.9 }
          cylinder { 27*z, 36*z, 1.55 translate <4, 1.550001, 0> }
          box { <-3.9, 0, -3.9> <11.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate -90*y }
            object { rounded_button() rotate -90*y translate <8, 0, 0> }
          #end
        }
        box { <-10, -1, 0> <0, 4, 25> rotate 12*y translate <-3.9, 0, 4> }
        box { <0, -1, 0> <10, 4, 25> rotate -12*y translate <11.9, 0, 4> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        #end
        difference {
          box { <-1.9, -1, 4> <9.9, 7, 26> }
          box { <-2, -2, 15> <10, 8, 17> }
          box { <-10, -2, 0> <0, 4, 27> rotate 12*y translate <-1.9, 0, 4> }
          box { <0, -2, 0> <10, 4, 27> rotate -12*y translate <9.9, 0, 4> }
        }
      }
      object { pin(age) translate <4, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -1.45, -4> <12, 4.55, 39> } }
    }
  #end
#end
#macro square_rig2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      cylinder { -12*x, 20*x, 1.5 translate <0, 2.4, -12> }
      cylinder { -12*x, 20*x, 1.5 translate <0, 2.4, 20> }
      cylinder { -12*z, 20*z, 1.5 translate <-12, 2.4, 0> }
      cylinder { -12*z, 20*z, 1.5 translate <20, 2.4, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <8, 0, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          object { axle_opening(4,1) rotate 90*z translate <4, 1, 4> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
      #end
      box { <3, -0.000001, -12> <5, 3.100001, -3.5> }
      box { <3, -0.000001, 11.5> <5, 3.100001, 20> }
      box { <-12, -0.000001, 3> <-3.5, 3.100001, 5> }
      box { <11.5, -0.000001, 3> <20, 3.100001, 5> }
      cylinder { 3.000001*x, 5.000001*x, 2.4 translate <0, 2.400001, -12.000001> }
      cylinder { 3.000001*x, 5.000001*x, 2.4 translate <0, 2.400001, 20.000001> }
      cylinder { 3.000001*z, 5.000001*z, 2.4 translate <-12.000001, 2.400001, 0> }
      cylinder { 3.000001*z, 5.000001*z, 2.4 translate <20.000001, 2.400001, 0> }
      cylinder { -1.000001*x, 1.000001*x, 2.4 rotate 45*y translate <-10.8, 2.400001, -10.8> }
      cylinder { -1.000001*x, 1.000001*x, 2.4 rotate 45*y translate <18.8, 2.400001, 18.8> }
      cylinder { -1.000001*x, 1.000001*x, 2.4 rotate -45*y translate <-10.8, 2.400001, 18.8> }
      cylinder { -1.000001*x, 1.000001*x, 2.4 rotate -45*y translate <18.8, 2.400001, -10.8> }
      difference {
        torus { 3, 1.5 rotate 90*x }
        box { <-10, -10, -10> <10, -0.000001, 10> }
        box { <-10, -10, -10> <-0.000001, 10, 10> }
        rotate 90*x rotate 180*y translate <-9, 2.4, -9>
      }
      difference {
        torus { 3, 1.5 rotate 90*x }
        box { <-10, -10, -10> <10, -0.000001, 10> }
        box { <-10, -10, -10> <-0.000001, 10, 10> }
        rotate 90*x rotate -90*y translate <-9, 2.4, 17>
      }
      difference {
        torus { 3, 1.5 rotate 90*x }
        box { <-10, -10, -10> <10, -0.000001, 10> }
        box { <-10, -10, -10> <-0.000001, 10, 10> }
        rotate 90*x rotate 0*y translate <17, 2.4, 17>
      }
      difference {
        torus { 3, 1.5 rotate 90*x }
        box { <-10, -10, -10> <10, -0.000001, 10> }
        box { <-10, -10, -10> <-0.000001, 10, 10> }
        rotate 90*x rotate 90*y translate <17, 2.4, -9>
      }
      cylinder { -9.000001*x, 17.000001*x, 1.5 translate <0, 2.400002, -12> }
      cylinder { -9.000001*x, 17.000001*x, 1.5 translate <0, 2.400002, 20> }
      cylinder { -9.000001*z, 17.000001*z, 1.5 translate <-12, 2.400002, 0> }
      cylinder { -9.000001*z, 17.000001*z, 1.5 translate <20, 2.400002, 0> }
      box { <0, 0.000001, -1> <12, 3.099999, 1> rotate -45*y translate <-10.8, 0, -10.8> }
      box { <0, 0.000001, -1> <12, 3.099999, 1> rotate 45*y translate <-10.8, 0, 18.8> }
      box { <0, 0.000001, -1> <12, 3.099999, 1> rotate 135*y translate <18.8, 0, 18.8> }
      box { <0, 0.000001, -1> <12, 3.099999, 1> rotate -135*y translate <18.8, 0, -10.8> }
      texture { color_tex }
      bounded_by { box { <-14.5, -0.1, -14.5> <22.5, 4.9, 22.5> } }
    }
  #end
#end
#macro square_rig2_2_small(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      torus { 12.5, 1.5 translate <4, 2.4, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <8, 0, 8> }
          #end
        }
        box { <-10, -1, -10> <0, 4, 0> rotate 45*y translate <0, 0, -3.9> }
        box { <-10, -1, 0> <0, 4, 10> rotate 45*y translate <-3.9, 0, 7.9> }
        box { <0, -1, -10> <10, 4, 0> rotate -45*y translate <7.9, 0, -3.9> }
        box { <0, -1, 0> <10, 4, 10> rotate 45*y translate <7.9, 0, 11.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          object { axle_opening(4,1) rotate 90*z translate <4, 1, 4> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
      #end
      difference {
        merge {
          cylinder { <-1, 2.4, 16> <9, 2.4, 16> 1.5 }
          cylinder { <9, 2.4, 16> <16, 2.4, 9> 1.5 }
          cylinder { <16, 2.4, 9> <16, 2.4, -1> 1.5 }
          cylinder { <16, 2.4, -1> <9, 2.4, -8> 1.5 }
          cylinder { <9, 2.4, -8> <-1, 2.4, -8> 1.5 }
          cylinder { <-1, 2.4, -8> <-8, 2.4, -1> 1.5 }
          cylinder { <-8, 2.4, -1> <-8, 2.4, 9> 1.5 }
          cylinder { <-8, 2.4, 9> <-1, 2.4, 16> 1.5 }
        }
        box { <-4.1, 3.1, -4.1> <12.1, 10, 12.1> }
      }
      merge {
        cylinder { -0.75*x, 0.75*x, 2.4 translate <0, 2.4, 12.8> }
        box { <-0.75, 0.000009, 7.5> <0.75, 3.100001, 12.8> }
        rotate -22.25*y
        translate <4, 0, 4>
      }
      merge {
        cylinder { -0.75*x, 0.75*x, 2.4 translate <0, 2.4, 12.8> }
        box { <-0.75, 0.000001, 7.> <0.75, 3.100001, 12.8> }
        rotate -67.25*y
        translate <4, 0, 4>
      }
      merge {
        cylinder { -0.75*x, 0.75*x, 2.4 translate <0, 2.4, 12.8> }
        box { <-0.75, 0.000002, 7.5> <0.75, 3.100001, 12.8> }
        rotate -112.25*y
        translate <4, 0, 4>
      }
      merge {
        cylinder { -0.75*x, 0.75*x, 2.4 translate <0, 2.4, 12.8> }
        box { <-0.75, 0.000003, 7.5> <0.75, 3.100001, 12.8> }
        rotate -157.25*y
        translate <4, 0, 4>
      }
      merge {
        cylinder { -0.75*x, 0.75*x, 2.4 translate <0, 2.4, 12.8> }
        box { <-0.75, 0.000004, 7.5> <0.75, 3.100001, 12.8> }
        rotate -202.25*y
        translate <4, 0, 4>
      }
      merge {
        cylinder { -0.75*x, 0.75*x, 2.4 translate <0, 2.4, 12.8> }
        box { <-0.75, 0.000005, 7.5> <0.75, 3.100001, 12.8> }
        rotate -247.25*y
        translate <4, 0, 4>
      }
      merge {
        cylinder { -0.75*x, 0.75*x, 2.4 translate <0, 2.4, 12.8> }
        box { <-0.75, 0.000006, 7.5> <0.75, 3.100001, 12.8> }
        rotate -292.25*y
        translate <4, 0, 4>
      }
      merge {
        cylinder { -0.75*x, 0.75*x, 2.4 translate <0, 2.4, 12.8> }
        box { <-0.75, 0.000007, 7.5> <0.75, 3.100001, 12.8> }
        rotate -337.25*y
        translate <4, 0, 4>
      }
      texture { color_tex }
      bounded_by { box { <-11, -0.1, -11> <19, 4.9, 19> } }
    }
  #end
#end
#macro srblock2_2(color_tex)
  #if (setting = 0)
    difference {
      sphere { <4, 12.5, 4> 12.5 }
      box { <-25, 2.6, -25> <33, 50, 33> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        sphere { <4, 12.5, 4> 12.5 }
        difference {
          sphere { <4, 12.5, 4> 11.75 }
          box { <-25, 0, -25> <33, 1.2, 33> }
        }
        box { <-25, 2.6, -25> <33, 50, 33> }
      }
      difference {
        cylinder { 2.2*y, 3.1*y, 7.3 }
        cylinder { 1*y, 4*y, 6.5 }
        sphere { <0, 12.5, 0> 12.399999 inverse }
        translate <4, 0, 4>
      }
      difference {
        intersection {
          merge {
            cylinder { 1*y, 3.000001*y, 2.4 }
            cylinder { 1*y, 3.000001*y, 2.4 translate <8, 0, 0> }
            cylinder { 1*y, 3.000001*y, 2.4 translate <8, 0, 8> }
            cylinder { 1*y, 3.000001*y, 2.4 translate <0, 0, 8> }
            object { open_rounded_button() }
            object { open_rounded_button() translate <8, 0, 0> }
            object { open_rounded_button() translate <8, 0, 8> }
            object { open_rounded_button() translate <0, 0, 8> }
          }
          cylinder { -1*y, 5*y, 7.7 translate <4, 0, 4> }
        }
        cylinder { 0*y, 5*y, 1.600001 }
        cylinder { 0*y, 5*y, 1.600001 translate <8, 0, 0> }
        cylinder { 0*y, 5*y, 1.600001 translate <8, 0, 8> }
        cylinder { 0*y, 5*y, 1.600001 translate <0, 0, 8> }
        sphere { <4, 12.5, 4> 12.499999 inverse }
      }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <4, 1.2, 4> }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 4.9*y, 8} translate <4, 0, 4> }
    }
  #end
#end
#macro stairs(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 6.4, -3.9> <3.9, 9.5, 27.9> }
      box { <4.1, 16, -3.9> <11.9, 19.1, 27.9> }
      box { <12.1, 25.6, -3.9> <19.9, 28.7, 27.9> }
      box { <20.1, 35.2, -3.9> <27.9, 38.3, 27.9> }
      box { <28.1, 44.8, -3.9> <35.9, 47.9, 27.9> }
      box { <36.1, 54.4, -3.9> <43.9, 57.5, 27.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, 4.1> <43.90005, 54.50001, 19.9> }
            box { <0, 0, 0> <100, 100, 30> rotate -39.5*z translate <3.9, 0, 0> }
            box { <-4, 9.50001, 0> <4.10001, 60, 30> }
            box { <-4, 19.10001, 0> <12.10001, 60, 30> }
            box { <-4, 28.70001, 0> <20.10001, 60, 30> }
            box { <-4, 38.30001, 0> <28.10001, 60, 30> }
            box { <-4, 47.90001, 0> <36.10001, 60, 30> }
            box { <3.90001, -1, 5.6> <43.90007, 60, 18.4> }
            #if (setting > 1)
              box { <-2.4, -1, 5> <2.4, 8.6, 19> }
              cylinder { 7.4*y, 10.4*y, 1.20001 translate <0, 0, 8> }
              cylinder { 7.4*y, 10.4*y, 1.20001 translate <0, 0, 16> }
            #end
          }
          difference {
            merge {
              box { <43.89999, 51.2, 4.10002> <51.9, 54.4, 19.89998> }
              #if (setting < 3)
                cylinder { 9.4*y, 11.2*y, 2.3 translate <48, 44.8, 8> }
                cylinder { 9.4*y, 11.2*y, 2.3 translate <48, 44.8, 16> }
              #else
                object { rounded_button() translate <48, 51.2, 8> }
                object { rounded_button() translate <48, 51.2, 16> }
              #end
            }
            #if (setting > 1)
              difference {
                box { <45.6, 50, 5.6> <50.4, 53.3, 18.4> }
                object { pin(2) translate <48, 51.20001, 12> }
              }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <48, 44.8, 8> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <48, 44.8, 16> }
            #end
            box { <40, 0, 5.60007> <43.89998, 54.39999, 18.40007> }
          }
          difference {
            merge {
              box { <-3.90001, 6.4, -3.9> <3.9, 9.5, 27.9> }
              box { <4.1, 16, -3.9> <11.9, 19.1, 27.9> }
              box { <12.1, 25.6, -3.9> <19.9, 28.7, 27.9> }
              box { <20.1, 35.2, -3.9> <27.9, 38.3, 27.9> }
              box { <28.1, 44.8, -3.9> <35.9, 47.9, 27.9> }
              box { <36.1, 54.4, -3.9> <43.9, 57.5, 27.9> }
            }
            #if (setting > 1)
              box { <-2.4, 6, -2.4> <2.4, 8.6, 26.4> }
              box { <5.6, 15.6, -2.4> <10.4, 18.2, 26.4> }
              box { <13.6, 25.2, -2.4> <18.4, 27.8, 26.4> }
              box { <21.6, 34.8, -2.4> <26.4, 37.4, 26.4> }
              box { <29.6, 44.4, -2.4> <34.4, 47, 26.4> }
              box { <37.6, 54, -2.4> <42.4, 56.6, 26.4> }
              box { <8, 0, 5.60005> <12, 18.20001, 18.40005> }
              box { <16, 0, 5.60005> <20, 27.80001, 18.40005> }
              box { <24, 0, 5.60005> <28, 37.40001, 18.40005> }
              box { <32, 0, 5.60005> <36, 47.00001, 18.40005> }
              cylinder { 7.4*y, 10.4*y, 1.2 }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 16> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 24> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 9.6, 0> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 9.6, 8> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 9.6, 16> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 9.6, 24> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 19.2, 0> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 19.2, 8> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 19.2, 16> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 19.2, 24> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 28.8, 0> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 28.8, 8> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 28.8, 16> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 28.8, 24> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 38.4, 0> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 38.4, 8> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 38.4, 16> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 38.4, 24> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 48, 0> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 48, 8> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 48, 16> }
              cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 48, 24> }
            #end
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.3 }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <0, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <0, 0, 24> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <8, 9.6, 0> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <8, 9.6, 8> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <8, 9.6, 16> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <8, 9.6, 24> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <16, 19.2, 0> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <16, 19.2, 8> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <16, 19.2, 16> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <16, 19.2, 24> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <24, 28.8, 0> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <24, 28.8, 8> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <24, 28.8, 16> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <24, 28.8, 24> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <32, 38.4, 0> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <32, 38.4, 8> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <32, 38.4, 16> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <32, 38.4, 24> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <40, 48, 0> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <40, 48, 8> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <40, 48, 16> }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <40, 48, 24> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <0, 6.4, 8> }
            object { rounded_button() translate <0, 6.4, 16> }
            object { rounded_button() translate <0, 6.4, 24> }
            object { rounded_button() translate <8, 16, 0> }
            object { rounded_button() translate <8, 16, 8> }
            object { rounded_button() translate <8, 16, 16> }
            object { rounded_button() translate <8, 16, 24> }
            object { rounded_button() translate <16, 25.6, 0> }
            object { rounded_button() translate <16, 25.6, 8> }
            object { rounded_button() translate <16, 25.6, 16> }
            object { rounded_button() translate <16, 25.6, 24> }
            object { rounded_button() translate <24, 35.2, 0> }
            object { rounded_button() translate <24, 35.2, 8> }
            object { rounded_button() translate <24, 35.2, 16> }
            object { rounded_button() translate <24, 35.2, 24> }
            object { rounded_button() translate <32, 44.8, 0> }
            object { rounded_button() translate <32, 44.8, 8> }
            object { rounded_button() translate <32, 44.8, 16> }
            object { rounded_button() translate <32, 44.8, 24> }
            object { rounded_button() translate <40, 54.4, 0> }
            object { rounded_button() translate <40, 54.4, 8> }
            object { rounded_button() translate <40, 54.4, 16> }
            object { rounded_button() translate <40, 54.4, 24> }
          #end
        }
      }
      #if (setting > 1)
        box { <-0.5, 6.40001, 2.4> <0.5, 9, 4.1> }
        box { <7.5, 16.00001, 2.4> <8.5, 18.6, 4.1> }
        box { <15.5, 25.60001, 2.4> <16.5, 28.2, 4.1> }
        box { <23.5, 35.20001, 2.4> <24.5, 37.8, 4.1> }
        box { <31.5, 44.80001, 2.4> <32.5, 47.4, 4.1> }
        box { <39.5, 54.40001, 2.4> <40.5, 57, 4.1> }
        box { <-0.5, 6.40001, 19.9> <0.5, 9, 21.6> }
        box { <7.5, 16.00001, 19.9> <8.5, 18.6, 21.6> }
        box { <15.5, 25.60001, 19.9> <16.5, 28.2, 21.6> }
        box { <23.5, 35.20001, 19.9> <24.5, 37.8, 21.6> }
        box { <31.5, 44.80001, 19.9> <32.5, 47.4, 21.6> }
        box { <39.5, 54.40001, 19.9> <40.5, 57, 21.6> }
        cylinder { 0.000001*y, 8.8*y, 1.5 translate <0, 0, 12> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <52, 59.3, 28> } }
    }
  #end
#end
#macro steering_base(color_tex, age)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      box { <0, 2.000001, 2.4> <8, 12.8, 3.899999> }
      texture { color_tex }
    }
  #else      
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          box { <0, 2.000001, 2.4> <8, 12.8, 3.899999> }
          cylinder { 2.000002*y, 12.800001*y, 3 translate <4, 0, 3.9> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
        #end
        box { <-10, -1, 3.900001> <20, 20, 20> }
        box { <-10, -10, -10> <10, 0, 0> rotate 40*x translate <0, 12.8, 2.9> }
      }
      cylinder { -4*z, 0*z, 1.5 translate <0, -1.5, 0> rotate 40*x
        translate <4, 12.8, 3.899999> }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 15.5, 4> } }
    }
  #end
#end
#macro steering_handlebars(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.75*z, 3.75*z, 1.55 }
      cylinder { -11.55*z, 11.55*z, 1.55 translate <5.5, 0.75, 0> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { -1.75*z, -3.75*z, 2.3 }
      cylinder { 1.75*z, 3.75*z, 2.3 }
      cylinder { -2*z, 2*z, 1.55 }
      box { <-0.000001, -0.8, -1.750001> <5.5, 2.300001, -3.750001> }
      box { <-0.000001, -0.8, 1.750001> <5.5, 2.300001, 3.750001> }
      cylinder { -4.75*z, 4.75*z, 1.55 translate <5.5, 0.75, 0> }
      box { <3.949999, -0.800001, -2> <5.500001, 2.300002, 2> }
      sphere { <5.5, 0.75, -4.75> 1.55 }
      sphere { <5.5, 0.75, 4.75> 1.55 }
      cylinder { <5.5, 0.75, -4.75> <6.5, -2, -10> 1.55 }
      cylinder { <5.5, 0.75, 4.75> <6.5, -2, 10> 1.55 }
      sphere { <6.5, -2, -10> 1.55 }
      sphere { <6.5, -2, 10> 1.55 }
      texture { color_tex }
      bounded_by { box { <-2.4, -3.65, -11.65> <8.15, 2.4, 11.65> } }
    }
  #end
#end
#macro steering_wheel(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -2*y, 1*y, 2.25 }
      torus { 4.75, 0.75 scale <1, 2.1, 1> translate <0, 1, 0> }
      translate <0, 3, 0>
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { -2*y, 1*y, 2.25 }
        cylinder { -3*y, 2*y, 1.6 }
      }
      difference {
        torus { 4.75, 0.75 scale <1, 2.1, 1> }
        box { <-6, -5, -6> <6, 0, 6> }
        translate <0, 1, 0>
      }
      #local counter = 0;
      #while (counter < 3)
      difference {
        box { <1.75, -2, -0.8> <5, 2.5, 0.8> }
        box { <-10, -10, -10> <10, 0, 10> rotate 55*z translate <2.25, -2, 0> }
        box { <-10, 0, -10> <10, 10, 10> rotate 25*z translate <2.25, 1, 0> }
        rotate (90+120*counter)*y
      }
      #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { cylinder { -2.1*y, 1.7*y, 5.6 } }
      translate <0, 3, 0>
    }
  #end
#end
#macro steering_wheel_large(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 9.5*y, 3.9 }
      torus { 10.6, 1.5 translate <0, 10, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
        #else
          object { open_rounded_button() translate <0, 6.4, 0> }
        #end
        cylinder { 2*y, 9.5*y, 3.9 }
        cylinder { 0*y, 2.5*y, 3.1 }
        torus { 10.6, 1.5 translate <0, 10, 0> }
        difference {
          box { <-2.5, -0.75, -2> <2.5, 0.75, -9.5> }
          box { <-5, -1, -8> <-1.5, 1, 0> }
          box { <5, -1, -8> <1.5, 1, 0> }
          cylinder { -1*y, 1*y, 1 translate <-2.5, 0, -8> }
          cylinder { -1*y, 1*y, 1 translate <2.5, 0, -8> }
          rotate 10*x
          translate <0, 8.1, 0>
        }
        difference {
          box { <-2.5, -0.75, -2> <2.5, 0.75, -9.5> }
          box { <-5, -1, -8> <-1.5, 1, 0> }
          box { <5, -1, -8> <1.5, 1, 0> }
          cylinder { -1*y, 1*y, 1 translate <-2.5, 0, -8> }
          cylinder { -1*y, 1*y, 1 translate <2.5, 0, -8> }
          rotate 10*x rotate 120*y
          translate <0, 8.1, 0>
        }
        difference {
          box { <-2.5, -0.75, -2> <2.5, 0.75, -9.5> }
          box { <-5, -1, -8> <-1.5, 1, 0> }
          box { <5, -1, -8> <1.5, 1, 0> }
          cylinder { -1*y, 1*y, 1 translate <-2.5, 0, -8> }
          cylinder { -1*y, 1*y, 1 translate <2.5, 0, -8> }
          rotate 10*x rotate 240*y
          translate <0, 8.1, 0>
        }
      }
      cylinder { -0.4*y, 8.6*y, 2.6 }
      cylinder { 2*y, 12*y, 1.600001 }
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 11.6*y, 12.2 } }
    }
  #end
#end
#macro steering_wheel_medium(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 5.4*y, 3.2 }
      torus { 7, 1 translate <0, 5, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 2.5*y, 3.2 }
        cylinder { 2*y, 5.4*y, 2.25 }
        torus { 7, 1 translate <0, 5, 0> }
        box { <-1.1, -0.500001, -2> <1.1, 0.500001, -6.5> translate <0, 4.9, 0> }
        box { <-1.1, -0.500002, -2> <1.1, 0.500002, -6.5> rotate 120*y translate <0, 4.9, 0> }
        box { <-1.1, -0.500003, -2> <1.1, 0.500003, -6.5> rotate 240*y translate <0, 4.9, 0> }
        intersection {
          cylinder { 4.900007*y, 2.4*y, 3.200001 }
          merge {
            box { <-1.100007, 2, -2> <1.100007, 5, -6.5> }
            box { <-1.100007, 2, -2> <1.100007, 5, -6.5> rotate 120*y }
            box { <-1.100007, 2, -2> <1.100007, 5, -6.5> rotate 240*y }
          }
        }
      }
      cylinder { -1*y, 2*y, 2.6 }
      cylinder { 0*y, 7*y, 1.600001 }
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 6.1*y, 8.1 } }
    }
  #end
#end
#macro steering_column(color1_tex, color2_tex, hoek, age)
union {
  object { steering_base(color1_tex,age) rotate -90*y }
  object { steering_wheel(color2_tex) rotate hoek*y
    translate <1.5, 0, 0> rotate -50*z translate <-3.8, 12.8, 4>
  }
}
#end
#macro stretcher(color_tex)
  #if (setting = 0)
    merge {
      box { <-7.9, 2, -3.9> <39.9, 5.1, 11.9> }
      cylinder { -15.9*x, 47.9*x, 1.5 translate <0, 5.25, -6.5> }
      cylinder { -15.9*x, 47.9*x, 1.5 translate <0, 5.25, 14.5> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { -2.25*z, -0.65*z, 1.75 }
      cylinder { 8.65*z, 10.25*z, 1.75 }
      cylinder { -2.25*z, -0.65*z, 1.75 translate <32, 0, 0> }
      cylinder { 8.65*z, 10.25*z, 1.75 translate <32, 0, 0> }
      difference {
        box { <-7.9, 2, -3.9> <39.9, 5.1, 11.9> }
        #if (setting > 1)
          box { <-6.5, 1, -2.5> <38.5, 4, 10.5> }
        #end
      }
      box { <-7.900001, 4.000001, -6.5> <1.5, 5.100001, 14.5> }
      box { <30.5, 4.000001, -6.5> <39.9, 5.100001, 14.5> }
      box { <-7.900002, 0, -3> <-6.5, 1, 0> rotate 25*x translate <0, 3, -3.9> }
      box { <0, 0, -3> <1.500001, 1, 0> rotate 25*x translate <0, 3, -3.9> }
      box { <30.500002, 0, -3> <32, 1, 0> rotate 25*x translate <0, 3, -3.9> }
      box { <38.5, 0, -3> <39.900001, 1, 0> rotate 25*x translate <0, 3, -3.9> }
      box { <-7.900002, 0, 0> <-6.5, 1, 3> rotate -25*x translate <0, 3, 11.9> }
      box { <0, 0, 0> <1.500001, 1, 3> rotate -25*x translate <0, 3, 11.9> }
      box { <30.500002, 0, 0> <32, 1, 3> rotate -25*x translate <0, 3, 11.9> }
      box { <38.5, 0, 0> <39.900001, 1, 3> rotate -25*x translate <0, 3, 11.9> }
      box { <-1.749999, -0.000001, -2.250001> <1.749999, 4.1, -0.650001> }
      box { <-1.749999, -0.000001, 8.650001> <1.749999, 4.1, 10.250001> }
      box { <30.249999, -0.000001, -2.250001> <33.749999, 4.1, -0.650001> }
      box { <30.249999, -0.000001, 8.650001> <33.749999, 4.1, 10.250001> }
      #if (setting > 1)
        object { ring() translate <4, 2, 4> }
        object { ring() translate <12, 2, 4> }
        object { ring() translate <20, 2, 4> }
        object { ring() translate <28, 2, 4> }
      #end
      cylinder { -15.9*x, 47.9*x, 1.5 translate <0, 5.25, -6.5> }
      cylinder { -15.9*x, 47.9*x, 1.5 translate <0, 5.25, 14.5> }
      object { open_rounded_button() translate <0, 2, 0> }
      object { open_rounded_button() translate <0, 2, 8> }
      object { open_rounded_button() translate <32, 2, 0> }
      object { open_rounded_button() translate <32, 2, 8> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 5.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 5.1, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <32, 5.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <32, 5.1, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-16, -1.85, -8.25> <48, 6.9, 16.25> } }
    }
  #end
#end
#macro stwa_battledroid_arm(color_tex)
  #if (setting = 0)
    merge {
      box { <-0.7, 1.7, -1.3> <0.7, 12.5, 1.3>
        translate <0, -12.5, 0> rotate 30*x translate <0, -12.5, 0> }
        box { <-0.700001, -12.5, -1.3> <0.700001, -1.7, 1.3> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -1.55*x, 1.55*x, 2.6 }
        difference {
          box { <-1.5, -5, -2.5> <1.5, 0, 2.5> }
          box { <-3, -6, -0.6> <3, 0, 0.6> }
          box { <-2, -10, -10> <2, 2, -2.6> rotate -20*x }
          box { <-2, -10, 2.6> <2, 2, 10> rotate 20*x }
          box { <0, -10, -5> <10, 0, 5> rotate -7.5*z translate <1.5, 0, 0> }
          box { <-10, -10, -5> <0, 0, 5> rotate 7.5*z translate <-1.5, 0, 0> }
        }
        box { <-0.7, -8.5, -1.3> <0.7, -1.7, 1.3> }
        cylinder { -1.1*x, 1.1*x, 1.3 translate <0, -8.5, 0> }
        merge {
          box { <-0.7, 1.7, -1.3> <0.7, 8.5, 1.3> }
          difference {
            cylinder { -1.55*x, 1.55*x, 2.6 }
            cylinder { -2*x, 2*x, 1.6 }
            box { <-2, -5, -1.4> <2, 0, 1.4> }
          }
          translate <0, -8.5, 0>
          rotate 30*x
          translate <0, -8.5, 0>
        }
      }
      cylinder { -2*x, 2*x, 1.6 }
      box { <-2, 0, -1.4> <2, 5, 1.4> }
      texture { color_tex }
      bounded_by { box { <-1.65, -19, -7> <1.65, 2.7, 2.7> } }
    }
  #end
#end
#macro stwa_battledroid_body(color_tex)
  #if (setting = 0)
    box { <-4.5, -1.5, -2.5> <4.5, 15.5, 2.5> texture { color_tex } }
  #else
    merge {
      cylinder { -3.45*x, -3.05*x, 1.5 }
      cylinder { -2.45*x, 2.45*x, 1.5 }
      cylinder { 3.05*x, 3.45*x, 1.5 }
      cylinder { -3.25*x, 3.25*x, 1.2 }
      cylinder { -7.25*x, 7.25*x, 1.5 translate <0, 13, 0> }
      cylinder { -7.5*x, 7.5*x, 1.25 translate <0, 13, 0> }
      torus { 1.25, 0.25 rotate 90*z translate <-7.25, 13, 0> }
      torus { 1.25, 0.25 rotate 90*z translate <7.25, 13, 0> }
      object { open_rounded_button() rotate 90*x translate <0, 7, -0.3> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65>
          rotate 90*y rotate -90*x rotate 180*y translate <0, 7, 2.8> }
      #end
      difference {
        merge {
          cylinder { -4.5*x, 4.5*x, 2.5 translate <0, 13, 0> }
          cylinder { -4.500003*x, 4.500003*x, 2.5 translate <0, 13, -0.5> }
          difference {
            cylinder { -4.500004*x, 4.500004*x, 1 scale <1, 10, 3> translate <0, 7.5, -0.5> }
            box { <-5, 0, -0.5> <5, 40, 10> }
            box { <-5, 13, -10> <5, 20, 10> }
            box { <-5, 5, -10> <5, -40, 10> }
          }
          box { <-4.500002, 3, -0.5> <4.500002, 15.5, 0> }
          box { <-4.500001, 3.000001, -2.500001> <4.500001, 13.00001, 2.500001> }
        }
        box { <-5, -12, -5> <5, 2, 0> rotate -40*x translate <0, 6.25, -2.5> }
        box { <-5, -12, -0> <5, 2, 5> rotate 50*x translate <0, 5.5, 2.5> }
        difference {
          box { <-3.5, 0, -10> <3.5, 8, 4> }
          box { <0, -10, -5> <10, 0, 5> rotate -10*z translate <3.3, 9.5, 0> }
          box { <-10, -10, -5> <0, 0, 5> rotate 10*z translate <-3.3, 9.5, 0> }
        }
        box { <-2.3, 9.5, -5> <2.3, 20, 5> }
        box { <0, -10, -5> <10, 0, 5> rotate -10*z translate <4.5, 9.5, 0> }
        box { <-10, -10, -5> <0, 0, 5> rotate 10*z translate <-4.5, 9.5, 0> }
      }
      box { <-2.5, 4.5, 1.3> <2.5, 9.500001, 2.8> }
      difference {
        merge {
          cylinder { 0*y, 8*y, 0.9 }
          sphere { <0, 8, 0> 0.9 }
        }
        box { <0, 0, -1> <1, 5, 1> rotate 9*z translate <0.9, 5.5, 0> }
        rotate -9*z
        rotate -10*x
        translate <2.5, 0.5, 0>
      }
      difference {
        merge {
          cylinder { 0*y, 8*y, 0.9 }
          sphere { <0, 8, 0> 0.9 }
        }
        box { <-1, 0, -1> <0, 5, 1> rotate -9*z translate <-0.9, 5.5, 0> }
        rotate 9*z
        rotate -10*x
        translate <-2.5, 0.5, 0>
      }
      texture { color_tex }
      bounded_by { box { <-7.6, -1.6, -4> <7.6, 15.6, 4.6> } }
    }
  #end
#end
#macro stwa_battledroid_head(color_tex)
  #if (setting = 0)
    merge {
      box { <-1.100007, 2.3, -1.100007> <1.100007, 10.5, 1.100007> }
      sphere { <0, 0, -1> 1 scale <3, 3, 6.5> rotate -47*x translate <0, 10.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { -1.55*x, 1.55*x, 2.6 }
        cylinder { -2*x, 2*x, 1.6 }
        box { <-2, -5, -1.4> <2, 0, 1.4> }
      }
      difference {
        cylinder { -2.75*x, 2.75*x, 1.05 }
        cylinder { -3*x, -2.5*x, 0.6 }
        cylinder { 2.5*x, 3*x, 0.6 }
        translate <0, 10.5, 0>
      }
      difference {
        box { <-1.100007, 2.3, -1.100007> <1.100007, 10.5, 1.100007> }
        box { <-2, 2.7, -0.5> <-0.5, 9.2, 0.5> }
        box { <0.5, 2.7, -0.5> <2, 9.2, 0.5> }
      }
      difference {
        cylinder { -1.1*x, 1.1*x, 2.2 translate <0, 10.5, 0> }
        box { <-2, 2.7, -0.500001> <-0.500001, 9.200001, 0.500001> }
        box { <0.500001, 2.7, -0.500001> <2, 9.200001, 0.500001> }
      }
      merge {
        difference {
          sphere { <0, 0, 0> 1 scale <3, 3, 13> }
          box { <-4, -4, 0> <4, 4, 20> }
          box { <-4, -4, -20> <4, 0, 20> }
          box { <-4, -4, -20> <4, 4, -11.2> }
          sphere { <-1.5, 2, -4.5> 0.45 }
          sphere { <1.5, 2, -4.5> 0.45 }
          cylinder { -1.1*x, -5*x, 1.6 }
          cylinder { 1.1*x, 5*x, 1.6 }
          box { <-5, -1, -4.5> <-1.100002, 1.2, 0> }
          box { <5, -1, -4.5> <1.100001, 1.2, 0> }
          box { <-5, -3, 0> <-1.100004, 0, 1> rotate 30*x translate <0, 1.2, -4.5> }
          box { <5, -3, 0> <1.100004, 0, 1> rotate 30*x translate <0, 1.2, -4.5> }
        }
        difference {
          sphere { <0, 0, 0> 3 }
          box { <-5, -1, -4.5> <-1.100003, 1.200001, 0> }
          box { <5, -1, -4.5> <1.100003, 1.200001, 0> }
          cylinder { -1.100004*x, -5*x, 1.600001 }
          cylinder { 1.100004*x, 5*x, 1.600001 }
          box { <-4, -4, -4> <4, 0, 4> rotate 22.5*x }
        }
        merge {
          cylinder { -0.5*y, -0.75*y, 0.8 translate <-1, 0, 0> }
          cylinder { -0.5*y, -0.75*y, 0.8 translate <1, 0, 0> }
          cylinder { -1.25*y, -1*y, 0.8 translate <-1, 0, 0> }
          cylinder { -1.25*y, -1*y, 0.8 translate <1, 0, 0> }
          cylinder { -4.5*y, -1.5*y, 0.8 translate <-1, 0, 0> }
          cylinder { -4.5*y, -1.5*y, 0.8 translate <1, 0, 0> }
          cylinder { -4.75*y, -0.25*y, 0.6 translate <-1, 0, 0> }
          cylinder { -4.75*y, -0.25*y, 0.6 translate <1, 0, 0> }
          box { <-1.000001, -4.75, -0.6> <1.000001, -0.25, 0.6> }
          box { <-1.000001, -4.5, -0.8> <1.000001, 0, 0.8> }
          translate <0, 0, 2.3>
          rotate 22.5*x
        }
        difference {
          cylinder { 4*z, 0*z, 1 scale <1.1, 0.75, 1> }
          box { <-3, -3, -1> <3, -0.2, 5> }
          rotate -15*x
          translate <0, -0.25, -11.7>
        }
        rotate -47*x
        translate <0, 10.5, 0>
      }
      texture { color_tex }
      bounded_by { box { <-3.1, -2.7, -9> <3.1, 13.6, 5> } }
    }
  #end
#end
#macro stwa_battledroid_legs(color_tex)
  #if (setting = 0)
    merge {
      box { <-7.6, -0.1, -3.9> <7.6, 3.1, 2.9> }
      box { <-3.6, 3, -1.65> <-1.9, 21, 2> }
      box { <3.6, 3, -1.65> <1.9, 21, 2> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { -1.6*x, 1.6*x, 2.6 translate <0, 18.4, 0> }
        cylinder { -2*x, 2*x, 1.55 translate <0, 18.4, 0> }
        box { <-2, 18.4, -1.3> <2, 25, 1.3> }
      }
      cylinder { -1.75*x, -3.75*x, 1.6 translate <0, 10.5, 0> }
      cylinder { 1.75*x, 3.75*x, 1.6 translate <0, 10.5, 0> }
      difference {
        box { <-3.5, 10.5, -1.65> <3.5, 16.5, 1.65> }
        box { <-2, 10, -2> <2, 14.9, 2> }
        box { <-4, -10, -5> <4, 5, 0> rotate -5*x translate <0, 14.9, -1.65> }
        box { <-4, -10, 0> <4, 5, 5> rotate 10*x translate <0, 13.9, 1.65> }
      }
      difference {
        box { <-3.6, 3, -1.65> <-1.9, 10.5, 2> }
        box { <-4, -20, -5> <-1, 5, 0> rotate -5*x translate <0, 14.9, -1.65> }
        box { <-4, 0, 0> <-1, 5, 5> rotate -25*x translate <0, 8, 2> }
        box { <0, 0, -5> <5, 10, 5> rotate 5*z rotate 15*y translate <-1.9, 3, -1.5> }
        box { <-5, 0, -5> <0, 10, 5> rotate -5*z rotate -15*y translate <-3.6, 3, -1.5> }
      }
      difference {
        box { <3.6, 3, -1.65> <1.9, 10.5, 2> }
        box { <4, -20, -5> <1, 5, 0> rotate -5*x translate <0, 14.9, -1.65> }
        box { <4, 0, 0> <1, 5, 5> rotate -25*x translate <0, 8, 2> }
        box { <-5, 0, -5> <0, 10, 5> rotate -5*z rotate -15*y translate <1.9, 3, -1.5> }
        box { <0, 0, -5> <5, 10, 5> rotate 5*z rotate 15*y translate <3.6, 3, -1.5> }
      }
      box { <-3.5, 0, 0> <-2, 2, 2> rotate 7*x translate <0, 3, -1> }
      box { <2, 0, 0> <3.5, 2, 2> rotate 7*x translate <0, 3, -1> }
      cylinder { 3*x, 5*x, 0.7 translate <0, 3, 0> }
      cylinder { -3*x, -5*x, 0.7 translate <0, 3, 0> }
      difference {
        box { <-7.6, 0, -3.9> <7.6, 3.1, 2.9> }
        cylinder { -1*y, 2*y, 2.5 translate <-4, 0, 0> }
        cylinder { -1*y, 2*y, 2.5 translate <4, 0, 0> }
        box { <-6.5, -1, -0.000001> <-1.5, 2.000001, 3> }
        box { <6.5, -1, -0.000001> <1.5, 2.000001, 3> }
        box { <-8, 0, 0> <8, 5, 5> rotate 25*x translate <0, 3.1, 1.5> }
        box { <-8, 0, 0> <8, 5, -5> rotate -25*x translate <0, 3.1, -1.5> }
        box { <-0.4, 2.4, -4> <0.4, 10, 3> }
        box { <-0.400001, 1, -4> <0.400001, 4, 1.9> }
        box { <-0.400002, -1, -4> <0.400002, 4, 0> }
        difference {
          box { <-4, -1, -4> <4, 4, 0> }
          cylinder { -2*y, 5*y, 3.5 }
          box { <0, -2, -3> <3.5, 5, 0> rotate 45*y }
          box { <-3.5, -2, -3> <0, 5, 0> rotate -45*y }
          translate <-4.1, 0, 0>
        }
        difference {
          box { <-4, -1, -4> <4, 4, 0> }
          cylinder { -2*y, 5*y, 3.5 }
          box { <0, -2, -3> <3.5, 5, 0> rotate 45*y }
          box { <-3.5, -2, -3> <0, 5, 0> rotate -45*y }
          translate <4.1, 0, 0>
        }
      }
      texture { color_tex }
      bounded_by { box { <-7.7, -0.1, -4> <7.7, 21.1, 3> } }
    }
  #end
#end
#macro stwa_binoculars(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -5.4*y, 8.3*y, 1.5 }
      cylinder { -5.4*y, 8.3*y, 1.5 translate <5, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { -3*y, 3*y, 1.5 }
      cylinder { -3*y, 3*y, 1.5 translate <5, 0, 0> }
      difference {
        box { <-2.4, -2.4, -2> <7.4, -5.4, 2> }
        cylinder { -3*z, 3*z, 6 translate <2.5, -9.2, 0> }
      }
      difference {
        box { <-2.4, 2.4, -2> <7.4, 8.3, 2> }
        cylinder { -3*x, 8*x, 4 translate <0, 9.3, 3> }
        box { <-1.9, 5.3, -1> <6.9, 10, 3> }
        cylinder { -3*z, 3*z, 3 translate <9.4, 2.4, 0> }
        cylinder { -3*z, 3*z, 3 translate <-4.4, 2.4, 0> }
        difference {
          box { <-2, 3.4, -1> <7, 4.3, 3> }
          cylinder { 3*z, -1*z, 4 translate <9.4, 2.4, 0> }
          cylinder { 3*z, -1*z, 4 translate <-4.4, 2.4, 0> }
        }
        box { <-5, 2, -2> <0, 4.3, 0> rotate -6.25*y translate <2.5, 0, -1.5> }
        box { <0, 2, -2> <5, 4.3, 0> rotate 6.25*y translate <2.5, 0, -1.5> }
      }
      difference {
        box { <0, 4.3, -3.5> <5, 7.3, -1.5> }
        box { <0, -10, -10> <10, 10, 0> rotate -17*x rotate -27.5*y translate <2.5, 7.3, -3.5> }
        box { <-10, -10, -10> <0, 10, 0> rotate -17*x rotate 27.5*y translate <2.5, 7.3, -3.5> }
      }
      difference {
        box { <1, 2.400001, -2.25> <4, 4.299999, -1.5> }
        box { <0, -10, -10> <10, 10, 0> rotate -17*x rotate -27.5*y translate <2.5, 4.3, -2.25> }
        box { <-10, -10, -10> <0, 10, 0> rotate -17*x rotate 27.5*y translate <2.5, 4.3, -2.25> }
      }
      texture { color_tex }
      bounded_by { box { <-2.5, -5.5, -2.1> <7.5, 8.4, 2.1> } }
    }
  #end
#end
#macro stwa_boba_fett_helmet()
  #if (setting = 0)
    sphere { <0, 0, 0> 6 scale <1.04, 1, 1.04> rotate -10*z texture { green_tex } }
  #else
    merge {
      difference {
        merge {
          sphere { <6.5, -15, -8.25> 1.5 }
          sphere { <6.5, -15, 8.25> 1.5 }
          cone { -16*y, 0.9, -19*y, 1.9 translate <6.5, 0, -8.25> }
          cone { -16*y, 0.9, -19*y, 1.9 translate <6.5, 0, 8.25> }
          cylinder { -19.4*y, -18.999999*y, 1.900001 translate <6.5, 0, -8.25> }
          cylinder { -19.4*y, -18.999999*y, 1.900001 translate <6.5, 0, 8.25> }
          box { <10, -17.5, -0.9> <10.9, -5.5, 0.9> }
          sphere { <0, 0, 0> 1.5 translate <7, -6, -6.25> }
          sphere { <0, 0, 0> 1.5 translate <7, -6, 6.25> }
          cylinder { -6*y, -18.9*y, 1.5 translate <7, 0, -6.25> }
          cylinder { -6*y, -18.9*y, 1.5 translate <7, 0, 6.25> }
          difference {
            merge {
              box { <2.5, -17.9, -8> <8.5, -4, 8> }
              cylinder { -17.900001*y, -4*y, 2.25 translate <8.5, 0, 0> }
              cylinder { -4.1*y, -2*y, 1.5 translate <8.5, 0, 0> }
              box { <5, -4.1, -1.5> <8.5, -2, 1.5> }
              cone { -2.5*y, 2, 2.5*y, 1.75 translate <8.5, 0, 0> }
              difference {
                box { <5.000002, -2.5, -2> <8.5, 2.5, 2> }
                box { <4, 0, -5> <9, 10, 0> rotate 3*x translate <0, -2.5, -2> }
                box { <4, 0, 0> <9, 10, 5> rotate -3*x translate <0, -2.5, 2> }
              }
              cylinder { 2.4*y, 6.9*y, 1.5 translate <8.5, 0, 0> }
              cylinder { 5*x, 8.5*x, 1.2 translate <0, 4, 0> }
              box { <5, -2, -1.2> <8.5, 4, 1.2> }
            }
            difference {
              box { <0, -20, -8.000001> <8.500002, -8, 8.000001> }
              cone { -16*y, 0.900001, -19*y, 1.900001 translate <6.5, 0, -8.25> }
              cone { -16*y, 0.900001, -19*y, 1.900001 translate <6.5, 0, 8.25> }
              box { <7.500003, -21, -8> <8.500003, 0, -5> }
              box { <7.500003, -21, 5> <8.500003, 0, 8> }
              cylinder { -21*y, -7*y, 2.5 translate <8.5, 0, -3.5> }
              cylinder { -21*y, -7*y, 2.5 translate <8.5, 0, 3.5> }
              box { <-8, -18, -2.5> <1, -3, 0> rotate 19*y translate <6.5, 0, -7> }
              box { <-8, -18, 0> <1, -3, 2.5> rotate -19*y translate <6.5, 0, 7> }
              box { <-1, -18, -2.5> <8, -3, 0> rotate -19*y translate <6.5, 0, -7.000001> }
              box { <-1, -18, 0> <8, -3, 2.5> rotate 19*y translate <6.5, 0, 7.000001> }
            }
            cylinder { -20*y, 1*y, 1 translate <8.5, 0, 0> }
            box { <0, -20, -1> <8.5, 1, 1> }
            cylinder { -20*y, 20*y, 1 translate <3.5, 0, -6.25> }
            cylinder { -20*y, 20*y, 1 translate <3.5, 0, 6.25> }
            box { <0, -20, -10> <3.5, 20, -5.25> }
            box { <0, -20, 5.25> <3.5, 20, 10> }
            box { <0, -20, -10> <4.500001, 20, -6.25> }
            box { <0, -20, 6.25> <4.500001, 20, 10> }
            cylinder { -10*z, 10*z, 1.5 translate <3, -6, 0> }
            box { <-10, -20, -10> <4.500005, -6, 10> }
            box { <-1, -18, -10> <4.5, -7, 10> }
            box { <-10, -18, -5> <0, -3, 0> rotate 19*y translate <6.5, 0, -8> }
            box { <-10, -18, 0> <0, -3, 5> rotate -19*y translate <6.5, 0, 8> }
            box { <0, -18, -5> <10, -3, 0> rotate -19*y translate <6.5, 0, -8> }
            box { <0, -18, 0> <10, -3, 5> rotate 19*y translate <6.5, 0, 8> }
            difference {
              box { <-7, 0, -10> <7, 7.5, 0> rotate -40*x rotate -45*y translate <4, -4, -4> }
              cylinder { -17.900001*y, 1*y, 2.250001 translate <8.5, 0, 0> }
              box { <5, -17.9, -2.250002> <10, 1, 0> }
            }
            difference {
              box { <-7, 0, 0> <7, 7.5, 10> rotate 40*x rotate 45*y translate <4, -4, 4> }
              cylinder { -17.900001*y, 1*y, 2.250002 translate <8.5, 0, 0> }
              box { <5, -17.9, 2.250002> <10, 1, 0> }
            }
            difference {
              box { <6.5, -18, -6> <10, -2, -2.25> }
              difference {
                box { <6, -20, -6> <7.999999, 0, -2> }
                cylinder { -19*y, -1*y, 0.75 translate <8, 0, -3> }
                box { <7.25, -19, -5> <9, -1, -3> }
              }
              box { <0, -19, -5> <10, -1, 0> rotate 19*y translate <6.5, 0, -4.5> }
            }
            difference {
              box { <6.5, -18, 6> <10, -2, 2.25> }
              difference {
                box { <6, -20, 6> <7.999999, 0, 2> }
                cylinder { -19*y, -1*y, 0.75 translate <8, 0, 3> }
                box { <7.25, -19, 5> <9, -1, 3> }
              }
              box { <0, -19, 0> <10, -1, 5> rotate -19*y translate <6.5, 0, 4.5> }
            }
          }
        }
        cylinder { -20*y, -17.4*y, 0.5 translate <6.5, 0, -8.25> }
        cylinder { -20*y, -17.4*y, 0.5 translate <6.5, 0, 8.25> }
        cylinder { -9*y, 2*y, 4.900001 }
      }
      difference {
        merge {
          torus { 3.1, 3 translate <0, 3.5, 0> }
          cylinder { 4*y, 6.500001*y, 3.100001 }
          cylinder { -6*y, 3.5*y, 6.100001 }
          difference {
            box { <-1, 3.5, 2.8> <1, 6.7, 5.4> }
            box { <0, 3, -5> <5, 7, 0> rotate 12*y translate <1, 0, 4.5> }
            box { <-5, 3, -5> <0, 7, 0> rotate -12*y translate <-1, 0, 4.5> }
            box { <0, 3, 0> <5, 7, 5> rotate -12*y translate <1, 0, 4.5> }
            box { <-5, 3, 0> <0, 7, 5> rotate 12*y translate <-1, 0, 4.5> }
          }
        }
        cylinder { -1*y, 5.000001*y, 2.25 }
        cylinder { -9*y, 2*y, 4.9 }
        cone { 2.000001*y, 5, 4*y, 3 }
        box { <0, -10, -10> <20, 0, 10> rotate 8*z translate <-6.5, -6, 0> }
        box { <-8, -7, -1.1> <-3, -0.5, 1.1> }
        difference {
          box { <-10, -1.5, -10> <-1.1, 0.75, 10> }
          box { <-15, -10, -11> <0, 0, 11> rotate 8*z translate <-1.1, -0.75, 0> }
          box { <-15, 0, -11> <0, 10, 11> rotate 7*z translate <-1.1, 0.75, 0> }
        }
      }
      box { <-0.5, 4, 5.3> <0.5, 6.5, 6.5> texture { silverish_tex } }
      sphere { <0, 0, 0> 1.5 scale <1, 1, 0.333333> translate <0, 3.5, 6.1> texture { silverish_tex } }
      cylinder { 1*y, 3.5*y, 1.5 scale <1, 1, 0.333333> translate <0, 0, 6.1> texture { silverish_tex } }
      difference {
        cylinder { -6*y, 1.1*y, 1.5 scale <0.95, 1, 0.333333> translate <0, 0, 5.9> }
        box { <0, -10, -10> <20, 0, 10> rotate 8*z translate <-6.5, -5.5, 0> }
        texture { silverish_tex }
      }
      difference {
        sphere { <0, 0, 0> 1.4 scale <1, 1, 0.333333> translate <0, 0.5, -6.1> }
        box { <-2, -10, -10> <2, 0.5, 10> }
        texture { silverish_tex }
      }
      difference {
        cylinder { -6*y, 1.1*y, 1.4 scale <0.95, 1, 0.333333> translate <0, 0, -5.9> }
        box { <0, -10, -10> <20, 0, 10> rotate 8*z translate <-6.5, -5.5, 0> }
        texture { silverish_tex }
      }
      difference {
        cylinder { -6*y, 1.5*y, 6.200001 }
        cylinder { -7*y, 2*y, 6.1 }
        box { <-8, -7, -1.200001> <-3, -0.5, 1.200001> }
        difference {
          box { <-10, -1.6, -10> <-1.1, 0.85, 10> }
          box { <-15, -10, -11> <0, 0, 11> rotate 8*z translate <-1.1, -0.85, 0> }
          box { <-15, 0, -11> <0, 10, 11> rotate 7*z translate <-1.1, 0.85, 0> }
        }
        box { <0, -10, -10> <20, 0, 10> rotate 8*z translate <-6.5, -5.9, 0> }
        box { <-1.4, -10, -10> <10, 10, 10> }
        cylinder { -10*z, 10*z, 3 scale <0.675, 1, 1> translate <-3.5, -5.4, 0> }
        texture { black_tex }
      }
      intersection {
        merge {
          torus { 3.1, 3.00005 translate <0, 3.5, 0> }
          cylinder { -6*y, 3.5*y, 6.100006 }
        }
        merge {
          box { <1.2, 2.7, -10> <1.6, 4.1, -5.5> }
          box { <0.4, 2.6, -10> <0.8, 4, -5.5> }
          box { <-0.4, 2.5, -10> <0, 3.9, -5.5> }
          box { <-1.2, 2.4, -10> <-0.8, 3.8, -5.5> }
          box { <-2, 2.3, -10> <-1.6, 3.7, -5.5> }
          box { <-2.8, 2.2, -10> <-2.4, 3.6, -5> }
          box { <-3.6, 2.1, -10> <-3.2, 3.5, -4.5> }
        }
        texture { yellow_tex }
      }
      intersection {
        cylinder { -6*y, 3.5*y, 6.100006 }
        difference {
          box { <-10, 2, -2> <-5, 2.6, 2> }
          box { <-11, 1, -0.7> <0, 3, 0.7> }
          box { <-11, 0, -5> <0, 1, 0> rotate -12.5*x translate <0, 2.6, -0.7> }
          box { <-11, -1, -5> <0, 0, 0> rotate 12.5*x translate <0, 2, -0.7> }
          box { <-11, 0, 0> <0, 1, 5> rotate 12.5*x translate <0, 2.6, 0.7> }
          box { <-11, -1, 0> <0, 0, 5> rotate -12.5*x translate <0, 2, 0.7> }
        }
      texture { black_tex }
      }
      difference {
        cylinder { 3*y, 5.1*y, 3 }
        cylinder { 2*y, 6*y, 2.25 }
      }
      box { <6.49, -17.2, -3> <8, -7.4, -2.24> }
      box { <6.49, -17.2, 3> <8, -7.4, 2.24> }
      texture { green_tex }
      bounded_by { box { <-6.2, -19.5, -10.25> <11, 7, 10.25> } }
    }
  #end
#end
#macro stwa_canopy()
  #if (setting = 0)
    difference {
      box { <-59.9, -15.4, -3.900002> <-4.2, 0.8, 27.900002> }
      box { <-50, 0, -4> <0, 20, 28> rotate 23.75*z translate <-28, 0.8, 0> }
      texture { black_tex }
    }
  #else
    merge {
      box { <-26, 0.799998, 1> <-6, 0.800005, 1.3> texture { black_tex } }
      box { <-26, 0.799998, 22.7> <-6, 0.800005, 23> texture { black_tex } }
      box { <-26.000001, 0.799997, 1.000001> <-25.7, 0.800004, 23.000001> texture { black_tex } }
      box { <-27.999999, 0.799997, -2.9> <-27.7, 0.800004, 26.9> texture { black_tex } }
      box { <-27.999998, 0.799998, -2.899999> <-6, 0.800005, -2.6> texture { black_tex } }
      box { <-27.999998, 0.799998, 26.6> <-6, 0.800005, 26.899999> texture { black_tex } }
      box { <-26.9, 0.799995, 0.1> <-5.999999, 0.800003, 0.999999> texture { white_tex } }
      box { <-26.9, 0.799995, 22.999999> <-5.999999, 0.800003, 23.9> texture { white_tex } }
      box { <-26.900001, 0.799994, 0.099999> <-25.999998, 0.800006, 23.900001> texture { white_tex } }
      difference {
        box { <-27.700001, 0.799999, -2.600001> <-6, 0.800007, 26.600001> }
        box { <-26.900001, 0, 0.100001> <0, 1, 23.900001> }
        texture { gradient x texture_map { 
          [ 0.0 grey_tex ] [ 0.3 white_tex ] [ 0.7 white_tex ] [ 1 grey_tex ] } translate <-0.3, 0, 0> scale <21.7, 1, 1> }
      }
      merge {
        box { <-1.8, -0.000002, 0.7> <-1.5, 0.000005, 23.3> texture { black_tex } }
        box { <-30, -0.000002, 7.2> <-29.7, 0.000005, 16.8> texture { black_tex } }
        box { <-29, -0.000003, 0> <0, 0.000004, 0.3> rotate 13*y translate <-1.8, 0, 0.7> texture { black_tex } }
        box { <-29, -0.000003, -0.3> <0, 0.000004, 0> rotate -13*y translate <-1.8, 0, 23.3> texture { black_tex } }
        box { <-34.35, -0.000003, 0> <0, 0.000004, 0.3> rotate 13*y translate <0, 0, -2.9> texture { black_tex } }
        box { <-34.35, -0.000003, -0.3> <0, 0.000004, 0> rotate -13*y translate <0, 0, 26.9> texture { black_tex } }
        box { <-33.5, -0.000004, 5> <-33.2, 0.000006, 19> texture { black_tex } }
        difference {
          box { <-30.9, -0.000005, -0.2> <-0.6, 0.000003, 24.2> }
          box { <-40, -1, -20> <0, 1, 0> rotate 13*y translate <-0.6, 0, -0.3> }
          box { <-40, -1, 0> <0, 1, 20> rotate -13*y translate <-0.6, 0, 24.3> }
          difference {
            box { <-29.8, -1, 0.5> <-1.6, 1, 23.5> }
            box { <-40, -2, -20> <0, 2, 0> rotate 13*y translate <-1.6, 0, 0.9> }
            box { <-40, -2, 0> <0, 2, 20> rotate -13*y translate <-1.6, 0, 23.1> }
          }
          texture { white_tex }
        }
        difference {
          box { <-33.4, -0.000007, -2.8> <0, 0.000001, 26.8>
            texture { gradient x texture_map { [ 0.0 grey_tex ] [ 0.3 white_tex ] [ 0.7 white_tex ] [ 1 grey_tex ] }
              scale <33.4, 1, 1> } }
          box { <-40, -1, -20> <0, 1, 0> rotate 13*y translate <0, 0, -2.8> }
          box { <-40, -1, 0> <0, 1, 20> rotate -13*y translate <0, 0, 26.8> }
          difference {
            box { <-29.8, -1, 0.5> <-1.6, 1, 23.5> }
            box { <-40, -2, -20> <0, 2, 0> rotate 13*y translate <-1.6, 0, 0.9> }
            box { <-40, -2, 0> <0, 2, 20> rotate -13*y translate <-1.6, 0, 23.1> }
          }
        }
        rotate 23.75*z
        translate <-28, 0.8, 0>
      }
      difference {
        box { <-59.9, -15.4, -3.900002> <-4.2, 0.8, 27.900002> }
        box { <-2.9, -21, -4> <2.9, -13.4, 4> rotate 18.4*y translate <-40, 0, 0> }
        box { <-2.9, -21, -4> <2.9, -13.4, 4> rotate -18.4*y translate <-40, 0, 24> }
        box { <-2.75, -21, -4> <2.75, -13.4, 4> rotate 18.4*y translate <-48, 0, -2> }
        box { <-2.75, -21, -4> <2.75, -13.4, 4> rotate -18.4*y translate <-48, 0, 26> }
        box { <-50, 0, -4> <0, 20, 28> rotate 23.75*z translate <-28, 0.8, 0> }
        box { <-75, -30, -50> <20, 10, 0> rotate 18.4*y translate <-35.9, 0, -4> }
        box { <-75, -30, 0> <20, 10, 50> rotate -18.4*y translate <-35.9, 0, 28> }
        box { <-75, -50, -50> <10, 5, 0> rotate 10.15*x rotate 18.4*y translate <-27.9, 0.8, -4> }
        box { <-75, -50, 0> <10, 5, 50> rotate -10.15*x rotate -18.4*y translate <-27.9, 0.8, 28> }
        difference {
          box { <-58.4, -21, -2.4> <-3, 0, 26.4> }
          box { <-5.7, -2.500005, -4> <0, 5, 28> }
          box { <-100, -20, -50> <20, 10, 0> rotate 18.4*y translate <-35.9, 0, -2.7> }
          box { <-100, -20, 0> <20, 10, 50> rotate -18.4*y translate <-35.9, 0, 26.7> }
          box { <-100, 0, -10> <50, 50, 30> rotate 23.75*z translate <-28, -1.2, 0> }
          box { <-100, -50, -50> <50, 5, 0> rotate 10.15*x rotate 18.4*y translate <-27.9, -1.2, -3.5> }
          box { <-100, -50, 0> <50, 5, 50> rotate -10.15*x rotate -18.4*y translate <-27.9, -1.2, 27.5> }
        }
      }
      difference {
        merge {
          box { <-4.200005, -2.500001, -3.900001> <0.000001, 2.500001, -1.500001> }
          box { <-4.200005, -2.500001, 3.500001> <0.000001, 2.500001, 1.500001> }
          box { <-4.200005, -2.500001, 27.900001> <0.000001, 2.500001, 25.500001> }
          box { <-4.200005, -2.500001, 20.500001> <0.000001, 2.500001, 22.700001> }
          cylinder { -3.9*z, 3.5*z, 2.5 }
          cylinder { 20.5*z, 27.5*z, 2.5 }
        }
        box { <-1, -10, -10> <10, 10, 0> rotate -5*y translate <-4.2, 0, -3.9> }
        box { <-1, -10, 0> <10, 10, 10> rotate 5*y translate <-4.2, 0, 27.9> }
        box { <-10, 0, -4> <0, 10, 28> rotate -45*z translate <-4.2, 0.8, 0> }
        box { <-3, -3, -1.5> <3, 3, 1.5> }
        box { <-3, -3, 22.5> <3, 3, 25.5> }
        cylinder { -4*z, 34*z, 0.3 translate <0, 2.5, 0> rotate 0*z }
        cylinder { -4*z, 34*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
        cylinder { -4*z, 34*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
        cylinder { -4*z, 34*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
        cylinder { -4*z, 34*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
        cylinder { -4*z, 34*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
        cylinder { -4*z, 34*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
        cylinder { -4*z, 34*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
        cylinder { -4*z, 34*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
        cylinder { -4*z, 34*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
      }
      cylinder { -3*z, -1.2*z, 1.5 }
      cylinder { 1.2*z, 3*z, 1.5 }
      cylinder { 27*z, 25.2*z, 1.5 }
      cylinder { 21*z, 22.8*z, 1.5 }
      texture { t_black_tex } interior { ior 1.5 }
      bounded_by { box { <-60, -15.5, -4> <18.6, 2.6, 28> } }
    }
  #end
#end
#macro stwa_canopy2(color_tex)
  #if (setting = 0)
    difference {
      merge {
        cone { -1*x, 2.5, 4.000005*x, 7.800001 translate <0, 3.2, 0> }
        cone { 4*x, 7.8, 28.000001*x, 15.900001 translate <0, 3.2, 0> }
        cylinder { 28*x, 51.9*x, 15.9 translate <0, 3.2, 0> }
      }
      box { <-0.75, -50, -15.900001> <51.899999, 0, 15.900001> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        sphere { <0, 0, 0> 1 scale <1, 2.5, 2.5> translate <-0.749999, 3.2, 0> }
        cone { -1*x, 2.415, 4.000005*x, 7.800001 translate <0, 3.2, 0> }
        cone { 4*x, 7.8, 28.000010*x, 15.900001 translate <0, 3.2, 0> }
        cylinder { 28*x, 51.9*x, 15.9 translate <0, 3.2, 0> }
        box { <-1, 0, -15.900001> <51.899999, 3.200001, 15.900001> }
        cylinder { -0.000001*y, 3.200001*y, 1 scale <1, 1, 2.5> translate <-0.750001, 0, 0> }
      }
      difference {
        merge {
          cone { -1.000005*x, 1.4, 4.000005*x, 6.700001 translate <0, 3.2, 0> }
          cone { 4*x, 6.7, 28.000010*x, 14.800001 translate <0, 3.2, 0> }
          cylinder { 28*x, 52*x, 14.8 translate <0, 3.2, 0> }
          difference {
            box { <-0.749998, -1, -14.800001> <52, 3.200001, 14.800001> }
            box { <-30, -1, -20> <10, 4, 0> rotate 18.75*y translate <28, 0, -14.6> }
            box { <-30, -1, 0> <10, 4, 20> rotate -18.75*y translate <28, 0, 14.6> }
            box { <-30, -1, -20> <10, 4, 0> rotate 47.1*y translate <4, 0, -6.4> }
            box { <-30, -1, 0> <10, 4, 20> rotate -47.1*y translate <4, 0, 6.4> }
          }
        }
        box { <-2, 2, -10> <12, 3.1, 10> }
        box { <10.5, 0.000002, -10> <12.000001, 3, 10> }
        #if (setting > 1 )
          object { ring() translate <4, 0, 0> }
          box { <-0.5, -1, -10> <0.5, 2.1, 1.5> rotate 18.75*y translate <7, 0, -8> }
          box { <-0.5, -1, -1.5> <0.5, 2.1, 10> rotate -18.75*y translate <7, 0, 8> }
        #end
      }
      box { <-30, -1, -20> <10, 4, 0> rotate 47.1*y translate <4, 0, -7.8> }
      box { <-30, -1, 0> <10, 4, 20> rotate -47.1*y translate <4, 0, 7.8> }
      box { <-30, -1, -20> <10, 4, 0> rotate 18.75*y translate <28, 0, -15.9> }
      box { <-30, -1, 0> <10, 4, 20> rotate -18.75*y translate <28, 0, 15.9> }
      #if (setting > 1)
        box { <-2.4, -1, -5> <2.4, 2, 5> rotate 18.4*y translate <16, 0, -12> }
        box { <-2.4, -1, -5> <2.4, 2, 5> rotate -18.4*y translate <16, 0, 12> }
        box { <-2.4, -1, -5> <2.4, 2, 5> rotate 18.4*y translate <24, 0, -12> }
        box { <-2.4, -1, -5> <2.4, 2, 5> rotate -18.4*y translate <24, 0, 12> }
      #end
      box { <-4, -100, -20> <52, 0.000001, 20> }
      texture { color_tex }
      bounded_by { box { <-1.85, -0.1, -16> <52, 19.2, 16> } }
    }
  #end
#end
#macro stwa_canopy3(color_tex)
  difference {
    merge {
      cylinder { 0*y, 5.8*y, 1 scale <54, 1, 23.5> }
      sphere { <0, 0, 0> 1 scale <54, 21.4, 23.5> translate <0, 5.8, 0> }
    }
    #if (setting > 1)
      box { <-2.7, -1, -4> <2.7, 2, 4> rotate 10*y translate <-28, 0, -20> }
      box { <-2.7, -1, -4> <2.7, 2, 4> rotate 9*y translate <-20, 0, -20> }
      box { <-2.7, -1, -4> <2.7, 2, 4> rotate -9*y translate <20, 0, -20> }
      box { <-2.7, -1, -4> <2.7, 2, 4> rotate -10*y translate <28, 0, -20> }
      box { <-2.7, -1, -4> <2.7, 2, 4> rotate -10*y translate <-28, 0, 20> }
      box { <-2.7, -1, -4> <2.7, 2, 4> rotate -9*y translate <-20, 0, 20> }
      box { <-2.7, -1, -4> <2.7, 2, 4> rotate 9*y translate <20, 0, 20> }
      box { <-2.7, -1, -4> <2.7, 2, 4> rotate 10*y translate <28, 0, 20> }
      difference {
        merge {
          cylinder { -1*y, 5.8*y, 1 scale <51.93, 1, 22.6> }
          sphere { <0, 0, 0> 1 scale <51.93, 20.6, 22.6> translate <0, 5.8, 0> }
        }
        box { <-100, -50, -25> <-39, 30, 25> }
        box { <39, -50, -25> <100, 30, 25> }
        box { <-36.5, 0.2, -14.4> <-35.5, 30, -25> }
        box { <-36.5, 0.2, 14.4> <-35.5, 30, 25> }
        box { <36.5, 0.2, -14.4> <35.5, 30, -25> }
        box { <36.5, 0.2, 14.4> <35.5, 30, 25> }
        box { <-40, 0.2, -8.5> <-32.6, 30, -9.4> }
        box { <-40, 0.2, 8.5> <-32.6, 30, 9.4> }
        box { <32.6, 0.2, -8.5> <40, 30, -9.4> }
        box { <32.6, 0.2, 8.5> <40, 30, 9.4> }
        box { <-33.5, 0.200005, -9.400005> <-32.600005, 30, -20> }
        box { <32.600005, 0.200005, -9.400005> <33.5, 30, -20> }
        box { <-33.5, 0.200005, 9.400005> <-32.600005, 30, 20> }
        box { <32.600005, 0.200005, 9.400005> <33.5, 30, 20> }
      }
      cylinder { 27*y, 30*y, 2 }
      cylinder { -1*y, 2.1*y, 2.5 translate <-12, 0, -20> }
      cylinder { -1*y, 2.1*y, 2.5 translate <-12, 0, 20> }
      cylinder { -1*y, 2.1*y, 2.5 translate <12, 0, -20> }
      cylinder { -1*y, 2.1*y, 2.5 translate <12, 0, 20> }
      cylinder { -100*x, 100*x, 2.5 translate <0, 5.8, 0> }
      box { <-100, -1, -2.5> <100, 5.800005, 2.5> }
    #end
    box { <-100, -50, -25> <100, -0.000005, 25> }
    box { <-100, -50, -25> <-39.9, 30, 25> }
    box { <39.9, -50, -25> <100, 30, 25> }
    texture { color_tex }
    bounded_by { box { <-40, -0.1, -23.6> <40, 27.3, 23.6> } }
  }
#end
#macro stwa_connector(color_tex)
  #if (setting = 0)
    cylinder { -2.4*x, 11.9*x, 3.5 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { 4*x, 5.2*x, 3.5 }
          cylinder { 6.2*x, 7.4*x, 3.5 }
          cylinder { 8.4*x, 9.6*x, 3.5 }
          cylinder { 10.6*x, 11.8*x, 3.5 }
          cylinder { 4*x, 11.9*x, 3.25 }
        }
        cylinder { -5*z, 5*z, 0.45 translate <6.2, 0, 0> }
        box { <6.199999, -0.450001, -5> <10.100001, 0.450001, 5> }
        cylinder { -5*z, 5*z, 0.45 translate <10.1, 0, 0> }
        object { axle_section(10.1) translate <1.900005, 0, 0> }
      }
      difference {
        cylinder { 2.1*x, 4*x, 3.500001 }
        box { <-5, 0, -4> <0, 5, 4> rotate 10*z translate <4, 1.2, 0> }
        box { <-5, -5, -4> <0, 0, 4> rotate -10*z translate <4, -1.2, 0> }
        box { <2, -0.25, -4> <2.6, 0.25, 4> }
      }
      difference {
        merge {
          cylinder { -8*x, 0*x, 0.5 rotate 7*z translate <4, 2.8, -1> }
          cylinder { -8*x, 0*x, 0.5 rotate 7*z translate <4, 2.8, 1> }
          cylinder { -8*x, 0*x, 0.5 rotate -7*z translate <4, -2.8, -1> }
          cylinder { -8*x, 0*x, 0.5 rotate -7*z translate <4, -2.8, 1> }
          difference {
            box { <-3.2, -3.3, -1.000001> <4.000005, 3.3, 1.000001> }
            box { <-20, 0, -2> <1, 10, 2> rotate 7*z translate <4, 3.3, 0> }
            box { <-20, -10, -2> <1, 0, 2> rotate -7*z translate <4, -3.3, 0> }
          }
          difference {
            box { <-3.200001, -2.8, -1.500001> <4, 2.8, 1.500001> }
            box { <-20, 0, -2> <1, 10, 2> rotate 7*z translate <4, 2.8, 0> }
            box { <-20, -10, -2> <1, 0, 2> rotate -7*z translate <4, -2.8, 0> }
          }
        }
        cylinder { -8*x, 0*x, 1.5 translate <0, 0, -2.6> }
        cylinder { -8*x, 0*x, 1.5 translate <0, 0, 2.6> }
        cylinder { -3*z, -0.5*z, 0.75 }
        cylinder { 0.5*z, 3*z, 0.75 }
        cone { -2.6*z, 1.75, -0.499995*z, 0.75 }
        cone { 0.499995*z, 1.75, 2.6*z, 0.75 }
        box { <-10, -10, -4> <-2.4, 10, 4> }
      }
      texture { color_tex }
      bounded_by { cylinder { -2.5*x, 12*x, 3.6 } }
    }
  #end
#end
#macro stwa_connector_2(color_tex)
  #if (setting = 0)
    cylinder { -2.4*x, 11.9*x, 3.5 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { -4*x, 4.1*x, 3.500001 }
        box { <-10, 2.4, -5> <4.000001, 5, 5> }
        box { <-10, -2.4, -5> <4.000002, -5, 5> }
        merge {
          box { <1.9000001, -2.250001, -0.900001> <12, 2.250001, 0.900001> }
          box { <3.9000001, -0.900001, -2.250001> <12, 0.900001, 2.250001> }
        }
        difference {
          box { <-10, -5, -5> <0, 5, 5> }
          cylinder { -4*z, 4*z, 2.4 }
        }
        box { <-10, -5, -1.5> <4, 5, 1.5> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 0*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 20*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 40*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 60*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 80*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 100*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 120*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 140*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 160*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 180*z }
      }
      cylinder { -3*z, -1.2*z, 1.5 }
      cylinder { 1.2*z, 3*z, 1.5 }
      difference {
        merge {
          cylinder { 4*x, 5.2*x, 3.5 }
          cylinder { 6.2*x, 7.4*x, 3.5 }
          cylinder { 8.4*x, 9.6*x, 3.5 }
          cylinder { 10.6*x, 11.8*x, 3.5 }
          cylinder { 4*x, 11.9*x, 3.25 }
        }
        cylinder { -5*z, 5*z, 0.45 translate <6.2, 0, 0> }
        box { <6.199999, -0.450001, -5> <10.100001, 0.450001, 5> }
        cylinder { -5*z, 5*z, 0.45 translate <10.1, 0, 0> }
        object { axle_section(10.1) translate <1.900005, 0, 0> }
      }
      texture { color_tex }
      bounded_by { cylinder { -2.5*x, 12*x, 3.6 } }
    }
  #end
#end
#macro stwa_dh_swivel1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      box { <11, 2.1, -1.5> <18.2, 8.6, 1.5> }
      box { <-10.2, 2.1, -1.5> <-3, 8.6, 1.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 0> }
          #end
        }
        box { <0, 0, -4> <3, 3, 4> rotate -45*z translate <10, 0, 0> }
        box { <-3, 0, -4> <0, 3, 4> rotate 45*z translate <-2, 0, 0> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      box { <11, 3.100001, -3.300001> <16.000001, 8.100001, -1.500001> }
      box { <11, 3.100001, 3.300001> <16.000001, 8.100001, 1.500001> }
      difference {
        cylinder { -3.3*z, 3.3*z, 2.5 }
        box { <-3, -3, -1.5> <3, 3, 1.5> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 0*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
        translate <16, 5.6, 0>
      }
      difference {
        box { <-5.9, 4.4, -3.3> <-3, 6.8, 3.3> }
        box { <-5, 0, -4> <0, 5, 4> rotate 10*z translate <-3, 6.8, 0> }
        box { <-5, -5, -4> <0, 0, 4> rotate -10*z translate <-3, 4.4, 0> }
        box { <-6, 5.35, -4> <-5, 5.985, 4> }
      }
      difference {
        merge {
          cylinder { -8*x, 1*x, 0.5 rotate 7*z translate <-3.9, 8.1, -1> }
          cylinder { -8*x, 1*x, 0.5 rotate 7*z translate <-3.9, 8.1, 1> }
          cylinder { -8*x, 1*x, 0.5 rotate -7*z translate <-3.9, 2.6, -1> }
          cylinder { -8*x, 1*x, 0.5 rotate -7*z translate <-3.9, 2.6, 1> }
          difference {
            box { <-10.2, 2.1, -1.000001> <-3, 8.6, 1.000001> }
            box { <-20, 0, -2> <1, 10, 2> rotate 7*z translate <-3.9, 8.6, 0> }
            box { <-20, -10, -2> <1, 0, 2> rotate -7*z translate <-3.9, 2.1, 0> }
          }
          difference {
            box { <-10.200001, 2.6, -1.500001> <-3, 8.1, 1.500001> }
            box { <-20, 0, -2> <1, 10, 2> rotate 7*z translate <-3.9, 8.1, 0> }
            box { <-20, -10, -2> <1, 0, 2> rotate -7*z translate <-3.9, 2.6, 0> }
          }
        }
        cylinder { -8*x, -17*x, 1.5 translate <0, 5.6, -2.6> }
        cylinder { -8*x, -17*x, 1.5 translate <0, 5.6, 2.6> }
        cylinder { -3*z, -0.5*z, 0.75 translate <-8, 5.6, 0> }
        cylinder { 0.5*z, 3*z, 0.75 translate <-8, 5.6, 0> }
        cone { -2.6*z, 1.75, -0.499995*z, 0.75 translate <-8, 5.6, 0> }
        cone { 0.499995*z, 1.75, 2.6*z, 0.75 translate <-8, 5.6, 0> }
        box { <-10.200005, 0, -4> <-40, 20, 4> }
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
        box { <3.5, 2, -3> <4.5, 8.7, 3> } 
      #end
      cylinder { -3*z, -1.2*z, 1.5 translate <16, 5.6, 0> }
      cylinder { 1.2*z, 3*z, 1.5 translate <16, 5.6, 0> }
      texture { color_tex }
      bounded_by { box { <-10.3, -0.1, -4> <18.6, 11.3, 4> } }
    }
  #end
#end
#macro stwa_dh_swivel1_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> }
      box { <27, 2.1, -1.5> <34.2, 8.6, 1.5> }
      box { <-10.2, 2.1, -1.5> <-3, 8.6, 1.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 0> }
            object { rounded_button() translate <16, 6.4, 0> }
            object { rounded_button() translate <24, 6.4, 0> }
          #end
        }
        box { <0, 0, -4> <3, 3, 4> rotate -45*z translate <26, 0, 0> }
        box { <-3, 0, -4> <0, 3, 4> rotate 45*z translate <-2, 0, 0> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
        #end
      }
      box { <27, 3.100001, -3.300001> <32.000001, 8.100001, -1.500001> }
      box { <27, 3.100001, 3.300001> <32.000001, 8.100001, 1.500001> }
      difference {
        cylinder { -3.3*z, 3.3*z, 2.5 }
        box { <-3, -3, -1.5> <3, 3, 1.5> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 0*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
        translate <32, 5.6, 0>
      }
      difference {
        box { <-5.9, 4.4, -3.3> <-3, 6.8, 3.3> }
        box { <-5, 0, -4> <0, 5, 4> rotate 10*z translate <-3, 6.8, 0> }
        box { <-5, -5, -4> <0, 0, 4> rotate -10*z translate <-3, 4.4, 0> }
        box { <-6, 5.35, -4> <-5, 5.985, 4> }
      }
      difference {
        merge {
          cylinder { -8*x, 1*x, 0.5 rotate 7*z translate <-3.9, 8.1, -1> }
          cylinder { -8*x, 1*x, 0.5 rotate 7*z translate <-3.9, 8.1, 1> }
          cylinder { -8*x, 1*x, 0.5 rotate -7*z translate <-3.9, 2.6, -1> }
          cylinder { -8*x, 1*x, 0.5 rotate -7*z translate <-3.9, 2.6, 1> }
          difference {
            box { <-10.2, 2.1, -1.000001> <-3, 8.6, 1.000001> }
            box { <-20, 0, -2> <1, 10, 2> rotate 7*z translate <-3.9, 8.6, 0> }
            box { <-20, -10, -2> <1, 0, 2> rotate -7*z translate <-3.9, 2.1, 0> }
          }
          difference {
            box { <-10.200001, 2.6, -1.500001> <-3, 8.1, 1.500001> }
            box { <-20, 0, -2> <1, 10, 2> rotate 7*z translate <-3.9, 8.1, 0> }
            box { <-20, -10, -2> <1, 0, 2> rotate -7*z translate <-3.9, 2.6, 0> }
          }
        }
        cylinder { -8*x, -17*x, 1.5 translate <0, 5.6, -2.6> }
        cylinder { -8*x, -17*x, 1.5 translate <0, 5.6, 2.6> }
        cylinder { -3*z, -0.5*z, 0.75 translate <-8, 5.6, 0> }
        cylinder { 0.5*z, 3*z, 0.75 translate <-8, 5.6, 0> }
        cone { -2.6*z, 1.75, -0.499995*z, 0.75 translate <-8, 5.6, 0> }
        cone { 0.499995*z, 1.75, 2.6*z, 0.75 translate <-8, 5.6, 0> }
        box { <-10.200005, 0, -4> <-40, 20, 4> }
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
        cylinder { 0*y, 8.7*y, 1.5 translate <12, 0, 0> }
        cylinder { 0*y, 8.7*y, 1.5 translate <20, 0, 0> }
        box { <3.5, 2, -3> <4.5, 8.7, 3> }
      #end
      cylinder { -3*z, -1.2*z, 1.5 translate <32, 5.6, 0> }
      cylinder { 1.2*z, 3*z, 1.5 translate <32, 5.6, 0> }
      texture { color_tex }
      bounded_by { box { <-10.3, -0.1, -4> <34.6, 11.3, 4> } }
    }
  #end
#end
#macro stwa_dh_swivel1_6(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <43.9, 9.5, 3.9> }
      box { <43, 2.1, -1.5> <50.2, 8.6, 1.5> }
      box { <-10.2, 2.1, -1.5> <-3, 8.6, 1.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 9.5, 3.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <40, 0, 0> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 0> }
            object { rounded_button() translate <16, 6.4, 0> }
            object { rounded_button() translate <24, 6.4, 0> }
            object { rounded_button() translate <32, 6.4, 0> }
            object { rounded_button() translate <40, 6.4, 0> }
          #end
        }
        box { <0, 0, -4> <3, 3, 4> rotate -45*z translate <42, 0, 0> }
        box { <-3, 0, -4> <0, 3, 4> rotate 45*z translate <-2, 0, 0> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <42.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 0> }
        #end
      }
      box { <43, 3.100001, -3.300001> <48.000001, 8.100001, -1.500001> }
      box { <43, 3.100001, 3.300001> <48.000001, 8.100001, 1.500001> }
      difference {
        cylinder { -3.3*z, 3.3*z, 2.5 }
        box { <-3, -3, -1.5> <3, 3, 1.5> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 0*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
        translate <48, 5.6, 0>
      }
      difference {
        box { <-5.9, 4.4, -3.3> <-3, 6.8, 3.3> }
        box { <-5, 0, -4> <0, 5, 4> rotate 10*z translate <-3, 6.8, 0> }
        box { <-5, -5, -4> <0, 0, 4> rotate -10*z translate <-3, 4.4, 0> }
        box { <-6, 5.35, -4> <-5, 5.985, 4> }
      }
      difference {
        merge {
          cylinder { -8*x, 1*x, 0.5 rotate 7*z translate <-3.9, 8.1, -1> }
          cylinder { -8*x, 1*x, 0.5 rotate 7*z translate <-3.9, 8.1, 1> }
          cylinder { -8*x, 1*x, 0.5 rotate -7*z translate <-3.9, 2.6, -1> }
          cylinder { -8*x, 1*x, 0.5 rotate -7*z translate <-3.9, 2.6, 1> }
          difference {
            box { <-10.2, 2.1, -1.000001> <-3, 8.6, 1.000001> }
            box { <-20, 0, -2> <1, 10, 2> rotate 7*z translate <-3.9, 8.6, 0> }
            box { <-20, -10, -2> <1, 0, 2> rotate -7*z translate <-3.9, 2.1, 0> }
          }
          difference {
            box { <-10.200001, 2.6, -1.500001> <-3, 8.1, 1.500001> }
            box { <-20, 0, -2> <1, 10, 2> rotate 7*z translate <-3.9, 8.1, 0> }
            box { <-20, -10, -2> <1, 0, 2> rotate -7*z translate <-3.9, 2.6, 0> }
          }
        }
        cylinder { -8*x, -17*x, 1.5 translate <0, 5.6, -2.6> }
        cylinder { -8*x, -17*x, 1.5 translate <0, 5.6, 2.6> }
        cylinder { -3*z, -0.5*z, 0.75 translate <-8, 5.6, 0> }
        cylinder { 0.5*z, 3*z, 0.75 translate <-8, 5.6, 0> }
        cone { -2.6*z, 1.75, -0.499995*z, 0.75 translate <-8, 5.6, 0> }
        cone { 0.499995*z, 1.75, 2.6*z, 0.75 translate <-8, 5.6, 0> }
        box { <-10.200005, 0, -4> <-40, 20, 4> }
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
        cylinder { 0*y, 8.7*y, 1.5 translate <12, 0, 0> }
        cylinder { 0*y, 8.7*y, 1.5 translate <20, 0, 0> }
        cylinder { 0*y, 8.7*y, 1.5 translate <28, 0, 0> }
        cylinder { 0*y, 8.7*y, 1.5 translate <36, 0, 0> }
        box { <3.5, 2, -3> <4.5, 8.7, 3> }
        box { <19.5, 2, -3> <20.5, 8.7, 3> }
      #end
      cylinder { -3*z, -1.2*z, 1.5 translate <48, 5.6, 0> }
      cylinder { 1.2*z, 3*z, 1.5 translate <48, 5.6, 0> }
      texture { color_tex }
      bounded_by { box { <-10.3, -0.1, -4> <50.6, 11.3, 4> } }
    }
  #end
#end
#macro stwa_dome_head(color_tex)
  #if (setting = 0)
    cylinder { 0*y 14.7*y, 7.8 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { 0*y, 8.4*y, 7.8 }
          sphere { <0, 8.399999, 0> 7.799999 }
        }
        #if (setting > 1)
          box { <-6.39, -1, -6.39> <6.39, 2, 6.39> }
          cylinder { -1*y, 8.4*y, 6.300001 }
          sphere { <0, 8.3999999, 0> 6.3 }
          cylinder { 0*y, 20*y, 1.600001 }
        #end
      }
      object { open_rounded_button() translate <0, 12.6, 0> }
      #if (setting > 1)
        box { <-0.5, 14.7, -1.75> <0.5, 15.700001, 0> }
        box { <-0.5, 14.7, -1.75> <0.5, 15.700002, 0> rotate 120*y }
        box { <-0.5, 14.7, -1.75> <0.5, 15.700003, 0> rotate 240*y }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 17.5*y, 7.9 } }
    }
  #end
#end
#macro stwa_droid_wingelement(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <123.9, 9.5, 11.9> }
      box { <-50, 0, -4> <1, 10, 13> rotate 10.6*z translate <36, 9.5, 0> }
      box { <-1, 0, -4> <50, 10, 13> rotate -10.6*z translate <84, 9.5, 0> }
      box { <-10, 0, -20> <130, 10, 0> rotate -43.5*x translate <0, 9.5, 4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <123.9, 9.5, 11.9> }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 translate <40, 0, 8> } 
          cylinder { 9.4*y, 11.2*y, 2.4 translate <48, 0, 8> } 
          cylinder { 9.4*y, 11.2*y, 2.4 translate <56, 0, 8> } 
          cylinder { 9.4*y, 11.2*y, 2.4 translate <64, 0, 8> } 
          cylinder { 9.4*y, 11.2*y, 2.4 translate <72, 0, 8> } 
          cylinder { 9.4*y, 11.2*y, 2.4 translate <80, 0, 8> } 
        #else
          object { rounded_button() translate <40, 6.4, 8> } 
          object { rounded_button() translate <48, 6.4, 8> } 
          object { rounded_button() translate <56, 6.4, 8> } 
          object { rounded_button() translate <64, 6.4, 8> } 
          object { rounded_button() translate <72, 6.4, 8> } 
          object { rounded_button() translate <80, 6.4, 8> } 
        #end
      }
      box { <-2, -1, -4> <2, 2, 3.5> rotate 11.25*y translate <8, 0, 0> }
      box { <-2.5, -1, -4> <2.5, 2, 2> rotate 11.25*y translate <16, 0, 0> }
      box { <-2.5, -1, -4> <2.5, 2, 2> rotate 11.25*y translate <24, 0, 0> }
      box { <-2, -1, -4> <2, 2, 3.5> rotate 11.25*y translate <32, 0, 0> }
      box { <-2, -1, -4> <2, 2, 3.5> rotate -11.25*y translate <88, 0, 0> }
      box { <-2.5, -1, -4> <2.5, 2, 2> rotate -11.25*y translate <96, 0, 0> }
      box { <-2.5, -1, -4> <2.5, 2, 2> rotate -11.25*y translate <104, 0, 0> }
      box { <-2, -1, -4> <2, 2, 3.5> rotate -11.25*y translate <112, 0, 0> }
      box { <-1, -1, -10> <50, 10, 0> rotate 11.25*y translate <-4, 0, 4> }
      box { <-50, -1, -10> <1, 10, 0> rotate -11.25*y translate <124, 0, 4> }
      box { <-50, 0, -4> <1, 10, 13> rotate 10.6*z translate <36, 9.5, 0> texture { color_tex normal { bumping } } }
      box { <-1, 0, -4> <50, 10, 13> rotate -10.6*z translate <84, 9.5, 0> texture { color_tex normal { bumping } } }
      box { <30, 0, -20> <90, 10, 0> rotate -43.5*x translate <0, 9.5, 4> texture { color_tex normal { bumping } } }
      box { <-50, 0, -20> <1, 10, 0> rotate -43.5*x rotate 11.25*y translate <36, 9.5, 4> texture { color_tex normal { bumping } } }
      box { <-1, 0, -20> <50, 10, 0> rotate -43.5*x rotate -11.25*y translate <84, 9.5, 4> texture { color_tex normal { bumping } } }
      box { <44, -1, 3.9> <76, 3.2, 12> }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <122.4, 8.6, 10.4> }
          box { <-1, -1, -10> <50, 10, 0> rotate 11.25*y translate <-4, 0, 5.4> }
          box { <-50, -1, -10> <1, 10, 0> rotate -11.25*y translate <124, 0, 5.4> }
          box { <-50, 0, -4> <1, 10, 13> rotate 10.6*z translate <36, 8.6, 0> }
          box { <-1, 0, -4> <50, 10, 13> rotate -10.6*z translate <84, 8.6, 0> }
          box { <30, 0, -20> <90, 10, 0> rotate -43.5*x translate <0, 8.6, 4> }
          box { <-50, 0, -20> <1, 10, 0> rotate -43.5*x rotate 11.25*y translate <36, 8.6, 4> }
          box { <-1, 0, -20> <50, 10, 0> rotate -43.5*x rotate -11.25*y translate <84, 8.6, 4> }
          cylinder { 3.200002*y, 9*y, 1.5 translate <52, 0, 8> }
          cylinder { 3.200002*y, 9*y, 1.5 translate <60, 0, 8> }
          cylinder { 3.200002*y, 9*y, 1.5 translate <68, 0, 8> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <52, 0, 0> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <60, 0, 0> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <68, 0, 0> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <36, 0, 0> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <84, 0, 0> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <4, 0, 8> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <12, 0, 8> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <20, 0, 8> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <28, 0, 8> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <36, 0, 8> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <84, 0, 8> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <92, 0, 8> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <100, 0, 8> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <108, 0, 8> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <116, 0, 8> }
          box { <47.5, 3.200002, 3.8> <48.5, 9, 5.6> }
          box { <55.5, 3.200002, 3.8> <56.5, 9, 5.6> }
          box { <63.5, 3.200002, 3.8> <64.5, 9, 5.6> }
          box { <71.5, 3.200002, 3.8> <72.5, 9, 5.6> }
          box { <43, 3.200002, 7.5> <45.6, 9, 8.5> }
          box { <74.4, 3.200002, 7.5> <77, 9, 8.5> }
          box { <43, 0.000002, -0.5> <45.6, 9, 0.5> }
          box { <74.4, 0.000002, -0.5> <77, 9, 0.5> }
          box { <42.900001, 0.000003, -4> <44.000001, 9, 3.8> }
          box { <76.000001, 0.000003, -4> <77.100001, 9, 3.8> }
          box { <39.5, 0.000004, 2.4> <40.5, 9, 5> }
          box { <79.5, 0.000004, 2.4> <80.5, 9, 5> }
          box { <5, 0.000005, 4.1> <43, 9, 5.6> }
          box { <77, 0.000005, 4.1> <115, 9, 5.6> }
          box { <0, 0.000006, -5> <1.5, 9, 0> rotate 11.25*y translate <5, 0, 5.6> }
          box { <-1.5, 0.000006, -5> <0, 9, 0> rotate -11.25*y translate <115, 0, 5.6> }
          box { <-0.5, 0.000007, 0> <0.5, 9, 5.6> }
          box { <118.5, 0.000007, 0> <119.5, 9, 5.6> }
          difference {
            box { <42.9, -2, 2.4> <77.1, 9, 12> }
            box { <44.000001, -1, 3.900001> <76.000001, 9, 12.000001> }
          }
          box { <11.75, 2, 5> <12.25, 9, 11> }
          box { <27.75, 2, 5> <28.25, 9, 11> }
          box { <59.75, 2, -3> <60.25, 9, 3> }
          box { <59.75, 5.2, 5> <60.25, 9, 11> }
          box { <91.75, 2, 5> <92.25, 9, 11> }
          box { <107.75, 2, 5> <108.25, 9, 11> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <124, 11.3, 12> } }
    }
  #end
#end
#macro stwa_dualpivotconnect(color_tex)
  #if (setting = 0)
    cylinder { -2.4*x, 18.5*x, 3.5 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { -12.1*x, 3*x, 3.5 }
        cylinder { -4*y, 4*y, 3 scale <1.666667, 1, 1> translate <-8, 0, -6.1> }
        cylinder { -4*y, 4*y, 3 scale <1.666667, 1, 1> translate <-8, 0, 6.1> }
        difference {
          merge {
            box { <-3, -4, -4> <-1.8, 4, 4> }
            box { <-0.6, -4, -4> <0.6, 4, 4> }
            box { <3, -4, -4> <1.8, 4, 4> }
          }
          cylinder { -5*z, 5*z, 1.5 scale <1.666667, 1, 2> }
          box { <-3.1, -5, -0.6> <3.1, 5, 0.6> }
          box { <-3.1, -0.6, -5> <3.1, 0.6, 5> }
          translate <-8, 0, 0>
        }
        difference {
          box { <0, -3, -5> <4, 3, 5> }
          cylinder { -4*z, 4*z, 2.5 }
        }
        box { <-4, -2.5, -4> <10, -4, 4> }
        box { <-4, 2.5, -4> <10, 4, 4> }
        box { <-4, -4, -1.5> <10, 4, 1.5> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 0*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
        translate <16, 0, 0>
      }
      difference {
        cylinder { 2.1*x, 4*x, 3.500001 }
        box { <-5, 0, -4> <0, 5, 4> rotate 10*z translate <4, 1.2, 0> }
        box { <-5, -5, -4> <0, 0, 4> rotate -10*z translate <4, -1.2, 0> }
        box { <2, -0.25, -4> <2.6, 0.25, 4> }
      }
      difference {
        merge {
          cylinder { -8*x, 0*x, 0.5 rotate 7*z translate <4, 2.8, -1> }
          cylinder { -8*x, 0*x, 0.5 rotate 7*z translate <4, 2.8, 1> }
          cylinder { -8*x, 0*x, 0.5 rotate -7*z translate <4, -2.8, -1> }
          cylinder { -8*x, 0*x, 0.5 rotate -7*z translate <4, -2.8, 1> }
          difference {
            box { <-3.2, -3.3, -1.000001> <4, 3.3, 1.000001> }
            box { <-20, 0, -2> <1, 10, 2> rotate 7*z translate <4, 3.3, 0> }
            box { <-20, -10, -2> <1, 0, 2> rotate -7*z translate <4, -3.3, 0> }
          }
          difference {
            box { <-3.200001, -2.8, -1.500001> <4, 2.8, 1.500001> }
            box { <-20, 0, -2> <1, 10, 2> rotate 7*z translate <4, 2.8, 0> }
            box { <-20, -10, -2> <1, 0, 2> rotate -7*z translate <4, -2.8, 0> }
          }
        }
        cylinder { -8*x, 0*x, 1.5 translate <0, 0, -2.6> }
        cylinder { -8*x, 0*x, 1.5 translate <0, 0, 2.6> }
        cylinder { -3*z, -0.5*z, 0.75 }
        cylinder { 0.5*z, 3*z, 0.75 }
        cone { -2.6*z, 1.75, -0.499995*z, 0.75 }
        cone { 0.499995*z, 1.75, 2.6*z, 0.75 }
        box { <-10, -10, -4> <-2.4, 10, 4> }
      }
      cylinder { -3*z, -1.2*z, 1.5 translate <16, 0, 0> }
      cylinder { 1.2*z, 3*z, 1.5 translate <16, 0, 0> }
      texture { color_tex }
      bounded_by { cylinder { -2.5*x, 18.6*x, 3.6 } }
    }
  #end
#end
#macro stwa_fvswivel1(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      box { <-2.9, 1, -1.5> <2.9, 8.1, 1.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() translate <8, 0, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        #end
        box { <-4, 2.8, -4> <4, 4, 4> }
      }
      difference {
        box { <-1.2, 2.5, -3.3> <1.2, 3.8, 3.3> }
        box { <-0.5, 2.9, -4> <0.5, 3.9, 4> }
        box { <-5, 0, -4> <0, 5, 4> rotate -10*z translate <-1.2, 1.4, 0> }
        box { <0, 0, -4> <5, 5, 4> rotate 10*z translate <1.2, 1.4, 0> }
      }
      difference {
        merge {
          cylinder { -1*y, 8*y, 0.5 rotate -7*z translate <-2.8, 1.9, -1> }
          cylinder { -1*y, 8*y, 0.5 rotate -7*z translate <-2.8, 1.9, 1> }
          cylinder { -1*y, 8*y, 0.5 rotate 7*z translate <2.8, 1.9, -1> }
          cylinder { -1*y, 8*y, 0.5 rotate 7*z translate <2.8, 1.9, 1> }
          difference {
            box { <-3.3, 1.899999, -1.000001> <3.31, 8.1, 1.000001> }
            box { <-10, 0, -2> <0, 10, 2> rotate -7*z translate <-3.3, 1.9, 0> }
            box { <0, 0, -2> <10, 10, 2> rotate 7*z translate <3.3, 1.9, 0> }
          }
          difference {
            box { <-2.8, 1.899999, -1.500001> <2.8, 8.100001, 1.500001> }
            box { <-10, 0, -2> <0, 10, 2> rotate -7*z translate <-2.8, 1.9, 0> }
            box { <0, 0, -2> <10, 10, 2> rotate 7*z translate <2.8, 1.9, 0> }
          }
        }
        cylinder { 5.9*y, 19*y, 1.5 translate <0, 0, -2.6> }
        cylinder { 5.9*y, 19*y, 1.5 translate <0, 0, 2.6> }
        cylinder { -3*z, -0.5*z, 0.75 translate <0, 5.9, 0> }
        cylinder { 0.5*z, 3*z, 0.75 translate <0, 5.9, 0> }
        cone { -2.6*z, 1.75, -0.499995*z, 0.75 translate <0, 5.9, 0> }
        cone { 0.499995*z, 1.75, 2.6*z, 0.75 translate <0, 5.9, 0> }
        box { <-4, 8.100005, -4> <4, 30, 4> }
        #if (setting > 1)
          box { <-2.400001, -1, -2.400001> <10.400001, 2.000001, 2.400001> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 8.2, 4> } }
    }
  #end
#end
#macro stwa_fvswivel2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <19.9, 3.1, 3.9> }
      box { <-2.9, 1, -1.5> <2.9, 8.1, 1.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <19.9, 3.1, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <18.4, 2, 2.4> }
        #end
        cylinder { -4*z, 4*z, 2.9 translate <0, 5.6, 0> }
        cylinder { 2.9*y, 4*y, 2 translate <8, 0, 0> }
      }
      difference {
        box { <-1.2, 2.5, -3.3> <1.2, 3.8, 3.3> }
        box { <-0.5, 2.9, -4> <0.5, 3.9, 4> }
        box { <-5, 0, -4> <0, 5, 4> rotate -10*z translate <-1.2, 1.4, 0> }
        box { <0, 0, -4> <5, 5, 4> rotate 10*z translate <1.2, 1.4, 0> }
      }
      difference {
        merge {
          cylinder { -1*y, 8*y, 0.5 rotate -7*z translate <-2.8, 1.9, -1> }
          cylinder { -1*y, 8*y, 0.5 rotate -7*z translate <-2.8, 1.9, 1> }
          cylinder { -1*y, 8*y, 0.5 rotate 7*z translate <2.8, 1.9, -1> }
          cylinder { -1*y, 8*y, 0.5 rotate 7*z translate <2.8, 1.9, 1> }
          difference {
            box { <-3.3, 1.899999, -1.000001> <3.31, 8.1, 1.000001> }
            box { <-10, 0, -2> <0, 10, 2> rotate -7*z translate <-3.3, 1.9, 0> }
            box { <0, 0, -2> <10, 10, 2> rotate 7*z translate <3.3, 1.9, 0> }
          }
          difference {
            box { <-2.8, 1.899999, -1.500001> <2.8, 8.100001, 1.500001> }
            box { <-10, 0, -2> <0, 10, 2> rotate -7*z translate <-2.8, 1.9, 0> }
            box { <0, 0, -2> <10, 10, 2> rotate 7*z translate <2.8, 1.9, 0> }
          }
        }
        cylinder { 5.9*y, 19*y, 1.5 translate <0, 0, -2.6> }
        cylinder { 5.9*y, 19*y, 1.5 translate <0, 0, 2.6> }
        cylinder { -3*z, -0.5*z, 0.75 translate <0, 5.9, 0> }
        cylinder { 0.5*z, 3*z, 0.75 translate <0, 5.9, 0> }
        cone { -2.6*z, 1.75, -0.499995*z, 0.75 translate <0, 5.9, 0> }
        cone { 0.499995*z, 1.75, 2.6*z, 0.75 translate <0, 5.9, 0> }
        box { <-4, 8.100005, -4> <4, 30, 4> }
        #if (setting > 1)
          box { <-2.400001, -1, -2.400001> <18.400001, 2.000001, 2.400001> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
        object { pin(1) translate <12, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 8.2, 4> } }
    }
  #end
#end
#macro stwa_fvswivel3(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
      box { <2.5, 1, -2.9> <5.5, 8.1, 2.9> }
      box { <18.5, 1, -2.9> <21.5, 8.1, 2.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          difference {
            box { <4.500001, -1, -2.400001> <19.500001, 5.900001, 2.400001> }
            box { <6, -2, -4> <18, 6, 4> }
          }
        #end
        cylinder { -4*x, 4*x, 2.9 translate <0, 5.6, 0> }
        cylinder { 20*x, 28*x, 2.9 translate <0, 5.6, 0> }
        cylinder { 2.9*y, 4*y, 2 translate <12, 0, 0> }
      }
      difference {
        box { <0.7, 2.5, -1.2> <23.3, 3.8, 1.2> }
        box { <4, 2.000007, -2> <20, 4, 2> }
        box { <0, 2.9, -0.5> <24, 3.9, 0.5> }
        box { <0, 0, -5> <24, 5, 0> rotate 10*x translate <0, 1.4, -1.2> }
        box { <0, 0, 0> <24, 5, 5> rotate -10*x translate <0, 1.4, 1.2> }
      }
      difference {
        merge {
          cylinder { -1*y, 8*y, 0.5 rotate 7*x translate <3, 1.9, -2.8> }
          cylinder { -1*y, 8*y, 0.5 rotate -7*x translate <3, 1.9, 2.8> }
          cylinder { -1*y, 8*y, 0.5 rotate 7*x translate <5, 1.9, -2.8> }
          cylinder { -1*y, 8*y, 0.5 rotate -7*x translate <5, 1.9, 2.8> }
          cylinder { -1*y, 8*y, 0.5 rotate 7*x translate <19, 1.9, -2.8> }
          cylinder { -1*y, 8*y, 0.5 rotate -7*x translate <19, 1.9, 2.8> }
          cylinder { -1*y, 8*y, 0.5 rotate 7*x translate <21, 1.9, -2.8> }
          cylinder { -1*y, 8*y, 0.5 rotate -7*x translate <21, 1.9, 2.8> }
          difference {
            merge {
              box { <3.000001, 1.899999, -3.3> <4.999999, 8.1, 3.3> }
              box { <19.000001, 1.899998, -3.3> <20.999999, 8.1, 3.3> }
            }
            box { <0, 0, -10> <24, 10, 0> rotate 7*x translate <0, 1.9, -3.3> }
            box { <0, 0, 0> <24, 10, 10> rotate -7*x translate <0, 1.9, 3.3> }
          }
          difference {
            box { <2.500001, 1.899997, -2.8> <21.500001, 8.100001, 2.8> }
            box { <5.500001, 0, -3> <18.500001, 9, 3> }
            box { <0, 0, -10> <24, 10, 0> rotate 7*x translate <0, 1.9, -2.8> }
            box { <0, 0, 0> <24, 10, 10> rotate -7*x translate <0, 1.9, 2.8> }
          }
        }
        cylinder { 5.9*y, 19*y, 1.5 translate <1.4, 0, 0> }
        cylinder { 5.9*y, 19*y, 1.5 translate <6.6, 0, 0> }
        cylinder { 5.9*y, 19*y, 1.5 translate <17.4, 0, 0> }
        cylinder { 5.9*y, 19*y, 1.5 translate <22.6, 0, 0> }
        cylinder { 1*x, 3.5*x, 0.75 translate <0, 5.9, 0> }
        cylinder { 4.5*x, 7*x, 0.75 translate <0, 5.9, 0> }
        cylinder { 17*x, 19.5*x, 0.75 translate <0, 5.9, 0> }
        cylinder { 20.5*x, 23*x, 0.75 translate <0, 5.9, 0> }
        cone { 1.4*x, 1.75, 3.500005*x, 0.75 translate <0, 5.9, 0> }
        cone { 4.499995*x, 1.75, 6.6*x, 0.75 translate <0, 5.9, 0> }
        cone { 17.4*x, 1.75, 19.500005*x, 0.75 translate <0, 5.9, 0> }
        cone { 20.499995*x, 1.75, 22.6*x, 0.75 translate <0, 5.9, 0> }
        box { <-4, 8.100005, -4> <28, 30, 4> }
        #if (setting > 1)
          box { <-2.400001, -1, -2.400001> <18.400001, 2.000001, 2.400001> }
          difference {
            box { <4.5, -1, -3.3> <19.5, 5.9, 3.3> }
            box { <6.000001, -2, -4> <18.000001, 6, 4> }
            box { <4, -10, -10> <20, 1, 0> rotate 7*x translate <0, 5.9, -1.75> }
            box { <4, -10, 0> <20, 1, 10> rotate -7*x translate <0, 5.9, 1.75> }
            box { <4, 0, -10> <20, 10, 0> rotate -45*x translate <0, 5.9, -0.75> }
            box { <4, 0, 0> <20, 10, 10> rotate 45*x translate <0, 5.9, 0.75> }
          }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <12, 0, 0> }
        box { <2.4, 0.000005, -3> <3.4, 2.1, 3> }
        box { <20.6, 0.000005, -3> <21.6, 2.1, 3> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 8.2, 4> } }
    }
  #end
#end
#macro stwa_fwinglet4_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 3.1, 27.9> }
      box { <-50, -10, -50> <0, 10, 50> rotate 26.6*y translate <-4, 0, 12> }
      box { <0, -10, -50> <50, 10, 50> rotate -26.6*y translate <44, 0, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
          #else
            object { rounded_button() rotate -90*y }
            object { rounded_button() rotate -90*y translate <8, 0, 0> }
            object { rounded_button() rotate -90*y translate <16, 0, 0> }
            object { rounded_button() rotate -90*y translate <24, 0, 0> }
            object { rounded_button() rotate -90*y translate <32, 0, 0> }
            object { rounded_button() rotate -90*y translate <40, 0, 0> }
            object { rounded_button() rotate -90*y translate <0, 0, 8> }
            object { rounded_button() rotate -90*y translate <8, 0, 8> }
            object { rounded_button() rotate -90*y translate <16, 0, 8> }
            object { rounded_button() rotate -90*y translate <24, 0, 8> }
            object { rounded_button() rotate -90*y translate <32, 0, 8> }
            object { rounded_button() rotate -90*y translate <40, 0, 8> }
            object { rounded_button() rotate -90*y translate <8, 0, 16> }
            object { rounded_button() rotate -90*y translate <16, 0, 16> }
            object { rounded_button() rotate -90*y translate <24, 0, 16> }
            object { rounded_button() rotate -90*y translate <32, 0, 16> }
            object { rounded_button() rotate -90*y translate <8, 0, 24> }
            object { rounded_button() rotate -90*y translate <16, 0, 24> }
            object { rounded_button() rotate -90*y translate <24, 0, 24> }
            object { rounded_button() rotate -90*y translate <32, 0, 24> }
          #end
        }
        box { <-50, -10, -50> <0, 10, 50> rotate 26.6*y translate <-4, 0, 12> }
        box { <0, -10, -50> <50, 10, 50> rotate -26.6*y translate <44, 0, 12> }
        #if (setting > 1)
          difference {
            merge {
              box { <37.6, -1, -2.4> <42.4, 2, 26.4> }
              box { <4, -1, -2.4> <36, 2, 26.4> }
              box { <-2.4, -1, -2.4> <2.4, 2, 26.4> }
            }
            box { <0, -10, -50> <50, 10, 50> rotate -26.6*y translate <42.2, 0, 12> }
            box { <-50, -10, -50> <0, 10, 50> rotate 26.6*y translate <-2.2, 0, 12> }
          }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
        #end
        box { <-2, -1, -2.5> <1, 2.000001, 2.5> rotate 26.6*y translate <0, 0, 16> }
        box { <-1, -1, -2.5> <2, 2.000001, 2.5> rotate -26.6*y translate <40, 0, 16> }
        cylinder { -1*y, 2.*y, 2.4 translate <0, 0, 24> }
        cylinder { -1*y, 2*y, 2.4 translate <40, 0, 24> }
      }
      #if (setting > 1)
        object { pin(1) translate <0, 0, 4> }
        object { pin(1) translate <40, 0, 4> }
        box { <3.7, 0.1, -0.5> <5.6, 2.1, 0.5> }
        box { <3.7, 0.1, 7.5> <5.6, 2.1, 8.5> }
        box { <3.7, 0.1, 15.5> <5.6, 2.1, 16.5> }
        box { <3.7, 0.1, 23.5> <5.6, 2.1, 24.5> }
        box { <34.4, 0.1, -0.5> <36.3, 2.1, 0.5> }
        box { <34.4, 0.1, 7.5> <36.3, 2.1, 8.5> }
        box { <34.4, 0.1, 15.5> <36.3, 2.1, 16.5> }
        box { <34.4, 0.1, 23.5> <36.3, 2.1, 24.5> }
        box { <-0.8, 0.1, -0.8> <0.8, 2.1, 0.8> rotate 45*y translate <-2.6, 0, 8> }
        box { <-0.8, 0.1, -0.8> <0.8, 2.1, 0.8> rotate 45*y translate <42.6, 0, 8> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <28, 0, 12> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 20> }
        object { ring() translate <28, 0, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 4.9, 28> } }
    }
  #end
#end
#macro stwa_f_cover4_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <19.9, 3.1, 27.9> }
      box { <19.8, 0.1, -3.900005> <24, 5, 27.900005> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 3.1, 27.9> }
          box { <19.899995, 0.1, -3.900005> <24, 5, 27.900005> }
          cylinder { -3.900002*z, 27.900002*z, 2.5 translate <24, 2.5, 0> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
            object { rounded_button() rotate 180*y translate <16, 0, 0> }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <16, 0, 8> }
            object { rounded_button() rotate 180*y translate <0, 0, 16> }
            object { rounded_button() rotate 180*y translate <8, 0, 16> }
            object { rounded_button() rotate 180*y translate <16, 0, 16> }
            object { rounded_button() rotate 180*y translate <0, 0, 24> }
            object { rounded_button() rotate 180*y translate <8, 0, 24> }
            object { rounded_button() rotate 180*y translate <16, 0, 24> }
          #end
        }
        box { <19.900005, -1, -0.5> <28, 6, 0.5> }
        box { <19.900005, -1, 7.5> <28, 6, 8.5> }
        box { <19.900005, -1, 15.5> <28, 6, 16.5> }
        box { <19.900005, -1, 23.5> <28, 6, 24.5> }
        box { <19.900005, -1, 0.7> <28, 6, 7.3> }
        box { <19.900005, -1, 16.7> <28, 6, 23.3> }
        box { <0, 0, -5> <5, 5, 29> rotate 45*z translate <19.9, 3.1, 0> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <18.4, 2, 26.4> }
          cylinder { 1*y, 2.25*y, 8 translate <12, 0, 12> }
          box { <12, 1, 4> <19.900007, 2.250002, 20> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          box { <19.6, -1, -2.9> <24, 2, -1.7> }
          box { <19.6, -1, 25.7> <24, 2, 26.9> }
          box { <18, -1, 9.4> <24, 2, 14.6> }
          difference {
            box { <20.7, -1, 9.400005> <24.000005, 3, 14.600005> }
            box { <0, 0, 9> <5, 5, 15> rotate -45*z translate <20.7, 0, 0> }
          }
        #end
      }
      difference {
        merge {
          cylinder { -3.300007*z, 3.300007*z, 2.5 }
          box { <-4.2, -2.500005, -3.300005> <0, 2.500001, 3.300005> }
        }
        box { <0, 0, -5> <5, 5, 5> rotate 45*z translate <-4.1, 0.600001, 0> }
        box { <-5, -3, -1.5> <3, 3, 1.5> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
        translate <24, 2.5, 4>
      }
      difference {
        merge {
          cylinder { -3.300007*z, 3.300007*z, 2.5 }
          box { <-4.2, -2.500005, -3.300005> <0, 2.500001, 3.300005> }
        }
        box { <0, 0, -5> <5, 5, 5> rotate 45*z translate <-4.1, 0.600002, 0> }
        box { <-5, -3, -1.5> <3, 3, 1.5> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
        translate <24, 2.5, 20>
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        difference {
          object { ring() translate <4, 0, 12> }
          box { <3, -1, 8> <10, 3, 16> }
        }
        object { ring() translate <4, 0, 20> }
      #end
      cylinder { -3*z, -1.2*z, 1.5 translate <24, 2.5, 4> }
      cylinder { 1.2*z, 3*z, 1.5 translate <24, 2.5, 4> }
      cylinder { -3*z, -1.2*z, 1.5 translate <24, 2.5, 20> }
      cylinder { 1.2*z, 3*z, 1.5 translate <24, 2.5, 20> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <26.6, 5.1, 28> } }
    }
  #end
#end
#macro stwa_f_swivel(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 3.1, 11.9> }
      box { <3.8, 0.000005, 2.5> <10.5, 5.5, 5.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <3.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
          #else
            object { rounded_button() rotate -90*y }
            object { rounded_button() rotate -90*y translate <0, 0, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
        #end
      }
      difference {
        box { <3, 1.3, 0.7> <5.9, 3.7, 7.3> }
        box { <0, 0, -4> <5, 5, 4> rotate -10*z translate <3, 3.7, 4> }
        box { <0, -5, -4> <5, 0, 4> rotate 10*z translate <3, 1.3, 4> }
        box { <5, 2.25, 0> <6, 2.75, 4> }
        box { <-5, 0, -5> <5, 5, 5> rotate 45*z translate <3.9, 3.100002, 4> }
        box { <5.4, 0, 5.500001> <6, 4, 8> }
      }
      difference {
        merge {
          cylinder { -1*x, 8*x, 0.5 rotate -7*z translate <3.9, 5, 3> }
          cylinder { -1*x, 8*x, 0.5 rotate -7*z translate <3.9, 5, 5> }
          cylinder { -1*x, 8*x, 0.5 rotate 7*z translate <3.9, -0.5, 3> }
          cylinder { -1*x, 8*x, 0.5 rotate 7*z translate <3.9, -0.5, 5> }
          difference {
            box { <3, -1, 3.000001> <10.2, 5.5, 5.000001> }
            box { <-1, 0, -2> <20, 10, 2> rotate -7*z translate <3.9, 5.5, 5> }
            box { <-1, -10, -2> <20, 0, 2> rotate 7*z translate <3.9, -1, 5> }
          }
          difference {
            box { <3, -0.5, 2.500001> <10.200001, 5, 5.500001> }
            box { <-1, 0, -2> <20, 10, 2> rotate -7*z translate <3.9, 5, 4> }
            box { <-1, -10, -2> <20, 0, 2> rotate 7*z translate <3.9, -0.5, 4> }
          }
        }
        box { <2.5, 3.100005, -1> <3.900005, 10, 9> }
        box { <2, -5, -1> <12, 0.000001, 9> }
        cylinder { 8*x, 17*x, 1.5 translate <0, 2.5, 1.4> }
        cylinder { 4.3*z, 7*z, 0.75 translate <8, 2.5, 0> }
        cone { 4.5*z, 0.75, 5*z, 1.5 translate <8, 2.5, 0> }
        cylinder { 4.999995*z, 7*z, 1.5 translate <8, 2.5, 0> }
        cylinder { -3*z, -0.5*z, 0.75 translate <8, 2.5, 4> }
        cone { -2.6*z, 1.75, -0.499995*z, 0.75 translate <8, 2.5, 4> }
        box { <10.200005, -5, 0> <30, 10, 8> }
        box { <0, 0, -5> <5, 5, 5> rotate 45*z translate <3.9, 3.100001, 4> }
      }
      #if (setting > 1)
        object { pin(1) translate <0, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <18.6, 5.6, 12> } }
    }
  #end
#end
#macro stwa_f_swivel1(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      box { <11.8, 0.1, -3.3> <16, 5, 3.3> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          box { <11.8, 0.1, -3.300005> <16, 5, 3.300005> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
          #end
        }
        box { <0, 0, -5> <5, 5, 5> rotate 45*z translate <11.9, 3.1, 0> }
        box { <11.900005, -1, -1.500005> <20, 6, 1.500005> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      difference {
        cylinder { -3.3*z, 3.3*z, 2.5 }
        box { <-3, -3, -1.5> <3, 3, 1.5> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 0*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
        translate <16, 2.5, 0>
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
      #end
      cylinder { -3*z, -1.2*z, 1.5 translate <16, 2.5, 0> }
      cylinder { 1.2*z, 3*z, 1.5 translate <16, 2.5, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <18.6, 5.1, 4> } }
    }
  #end
#end
#macro stwa_f_swivel2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      box { <11.8, 0.000005, -1.5> <18.5, 5.5, 1.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
          #end
        }
        box { <0, 0, -5> <5, 5, 5> rotate 45*z translate <11.9, 3.1, 0> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      difference {
        box { <11, 1.3, -3.3> <13.9, 3.7, 3.3> }
        box { <0, 0, -4> <5, 5, 4> rotate -10*z translate <11, 3.7, 0> }
        box { <0, -5, -4> <5, 0, 4> rotate 10*z translate <11, 1.3, 0> }
        box { <13, 2.25, -4> <14, 2.75, 4> }
        box { <-5, 0, -5> <5, 5, 5> rotate 45*z translate <11.9, 3.100002, 0> }
      }
      difference {
        merge {
          cylinder { -1*x, 8*x, 0.5 rotate -7*z translate <11.9, 5, -1> }
          cylinder { -1*x, 8*x, 0.5 rotate -7*z translate <11.9, 5, 1> }
          cylinder { -1*x, 8*x, 0.5 rotate 7*z translate <11.9, -0.5, -1> }
          cylinder { -1*x, 8*x, 0.5 rotate 7*z translate <11.9, -0.5, 1> }
          difference {
            box { <11, -1, -1.000001> <18.2, 5.5, 1.000001> }
            box { <-1, 0, -2> <20, 10, 2> rotate -7*z translate <11.9, 5.5, 0> }
            box { <-1, -10, -2> <20, 0, 2> rotate 7*z translate <11.9, -1, 0> }
          }
          difference {
            box { <11, -0.5, -1.500001> <18.200001, 5, 1.500001> }
            box { <-1, 0, -2> <20, 10, 2> rotate -7*z translate <11.9, 5, 0> }
            box { <-1, -10, -2> <20, 0, 2> rotate 7*z translate <11.9, -0.5, 0> }
          }
        }
        box { <10.5, 3.100005, -5> <11.900005, 10, 5> }
        box { <10, -5, -5> <20, 0.000001, 5> }
        cylinder { 16*x, 25*x, 1.5 translate <0, 2.5, -2.6> }
        cylinder { 16*x, 25*x, 1.5 translate <0, 2.5, 2.6> }
        cylinder { -3*z, -0.5*z, 0.75 translate <16, 2.5, 0> }
        cylinder { 0.5*z, 3*z, 0.75 translate <16, 2.5, 0> }
        cone { -2.6*z, 1.75, -0.499995*z, 0.75 translate <16, 2.5, 0> }
        cone { 0.499995*z, 1.75, 2.6*z, 0.75 translate <16, 2.5, 0> }
        box { <18.200005, -5, -4> <30, 10, 4> }
        box { <0, 0, -5> <5, 5, 5> rotate 45*z translate <11.9, 3.100001, 0> }
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <18.6, 5.6, 4> } }
    }
  #end
#end
#macro stwa_f_swivel4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 3.1, 27.9> }
      box { <3.8, 0.000005, 2.5> <10.5, 5.5, 5.5> }
      box { <3.8, 0.000005, 18.5> <10.5, 5.5, 21.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <3.9, 3.1, 27.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
          #else
            object { rounded_button() rotate -90*y }
            object { rounded_button() rotate -90*y translate <0, 0, 8> }
            object { rounded_button() rotate -90*y translate <0, 0, 16> }
            object { rounded_button() rotate -90*y translate <0, 0, 24> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 2, 26.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
        #end
      }
      difference {
        box { <3, 1.3, 0.7> <5.9, 3.7, 7.3> }
        box { <0, 0, -4> <5, 5, 4> rotate -10*z translate <3, 3.7, 4> }
        box { <0, -5, -4> <5, 0, 4> rotate 10*z translate <3, 1.3, 4> }
        box { <5, 2.25, 0> <6, 2.75, 4> }
        box { <-5, 0, -5> <5, 5, 5> rotate 45*z translate <3.9, 3.100002, 4> }
        box { <5.4, 0, 5.500001> <6, 4, 8> }
      }
      difference {
        merge {
          cylinder { -1*x, 8*x, 0.5 rotate -7*z translate <3.9, 5, 3> }
          cylinder { -1*x, 8*x, 0.5 rotate -7*z translate <3.9, 5, 5> }
          cylinder { -1*x, 8*x, 0.5 rotate 7*z translate <3.9, -0.5, 3> }
          cylinder { -1*x, 8*x, 0.5 rotate 7*z translate <3.9, -0.5, 5> }
          difference {
            box { <3, -1, 3.000001> <10.2, 5.5, 5.000001> }
            box { <-1, 0, -2> <20, 10, 2> rotate -7*z translate <3.9, 5.5, 5> }
            box { <-1, -10, -2> <20, 0, 2> rotate 7*z translate <3.9, -1, 5> }
          }
          difference {
            box { <3, -0.5, 2.500001> <10.200001, 5, 5.500001> }
            box { <-1, 0, -2> <20, 10, 2> rotate -7*z translate <3.9, 5, 4> }
            box { <-1, -10, -2> <20, 0, 2> rotate 7*z translate <3.9, -0.5, 4> }
          }
        }
        box { <2.5, 3.100005, -1> <3.900005, 10, 9> }
        box { <2, -5, -1> <12, 0.000001, 9> }
        cylinder { 8*x, 17*x, 1.5 translate <0, 2.5, 1.4> }
        difference {
          box { <6.5, -1, 4.3> <9.5, 2.5, 6> }
          box { <0, 2.499995, -5> <5, -2, 0> rotate -45*y translate <8.75, 0, 4.5> }
          box { <-5, 2.499995, -5> <0, -2, 0> rotate 45*y translate <7.25, 0, 4.5> }
        }
        
        cylinder { 4.3*z, 7*z, 0.75 translate <8, 2.5, 0> }
        cone { 4.5*z, 0.75, 5*z, 1.5 translate <8, 2.5, 0> }
        cylinder { 4.999995*z, 7*z, 1.5 translate <8, 2.5, 0> }
        cylinder { -3*z, -0.5*z, 0.75 translate <8, 2.5, 4> }
        cone { -2.6*z, 1.75, -0.499995*z, 0.75 translate <8, 2.5, 4> }
        box { <10.200005, -5, 0> <30, 10, 8> }
        box { <0, 0, -5> <5, 5, 5> rotate 45*z translate <3.9, 3.100001, 4> }
      }
      difference {
        box { <3, 1.3, 16.7> <5.9, 3.7, 23.3> }
        box { <0, 0, -4> <5, 5, 4> rotate -10*z translate <3, 3.7, 20> }
        box { <0, -5, -4> <5, 0, 4> rotate 10*z translate <3, 1.3, 20> }
        box { <5, 2.25, 20> <6, 2.75, 24> }
        box { <-5, 0, -5> <5, 5, 5> rotate 45*z translate <3.9, 3.100002, 20> }
        box { <5.4, 0, 16> <6, 4, 18.500001> }
      }
      difference {
        merge {
          cylinder { -1*x, 8*x, 0.5 rotate -7*z translate <3.9, 5, 19> }
          cylinder { -1*x, 8*x, 0.5 rotate -7*z translate <3.9, 5, 21> }
          cylinder { -1*x, 8*x, 0.5 rotate 7*z translate <3.9, -0.5, 19> }
          cylinder { -1*x, 8*x, 0.5 rotate 7*z translate <3.9, -0.5, 21> }
          difference {
            box { <3, -1, 19.000001> <10.2, 5.5, 21.000001> }
            box { <-1, 0, -2> <20, 10, 2> rotate -7*z translate <3.9, 5.5, 21> }
            box { <-1, -10, -2> <20, 0, 2> rotate 7*z translate <3.9, -1, 21> }
          }
          difference {
            box { <3, -0.5, 18.500001> <10.200001, 5, 21.500001> }
            box { <-1, 0, -2> <20, 10, 2> rotate -7*z translate <3.9, 5, 20> }
            box { <-1, -10, -2> <20, 0, 2> rotate 7*z translate <3.9, -0.5, 20> }
          }
        }
        box { <2.5, 3.100005, 15> <3.900005, 10, 25> }
        box { <2, -5, 15> <12, 0.000001, 25> }
        difference {
          box { <6.5, 2.5, 18> <9.5, 10, 19.7> }
          box { <0, 2.499995, 0> <5, 9, 5> rotate 45*y translate <8.75, 0, 19.5> }
          box { <-5, 2.499995, 0> <0, 9, 5> rotate -45*y translate <7.25, 0, 19.5> }
        }
        
        cylinder { -4.3*z, -7*z, 0.75 translate <8, 2.5, 24> }
        cone { -4.5*z, 0.75, -5*z, 1.5 translate <8, 2.5, 24> }
        cylinder { -4.999995*z, -7*z, 1.5 translate <8, 2.5, 24> }
        cylinder { 8*x, 17*x, 1.5 translate <0, 2.5, 22.6> }
        cylinder { 0.5*z, 3*z, 0.75 translate <8, 2.5, 20> }
        cone { 0.499995*z, 0.75, 2.6*z, 1.75 translate <8, 2.5, 20> }
        box { <10.200005, -5, 16> <30, 10, 24> }
        box { <0, 0, -5> <5, 5, 5> rotate 45*z translate <3.9, 3.100001, 20> }
      }
      #if (setting > 1)
        object { pin(1) translate <0, 0, 12> }
        box { <-3, -0.000005, 2.4> <3, 2.1, 3.6> }
        box { <-0.5, 0.2, 3.5> <0.5, 2.1, 5.6> }
        box { <-3, -0.000005, 20.4> <3, 2.1, 21.6> }
        box { <-0.5, 0.2, 18.4> <0.5, 2.1, 20.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <18.6, 5.6, 28> } }
    }
  #end
#end
#macro stwa_f_winglet8_8(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 3.1, 59.9> }
      box { <-100, -10, 0> <100, 10, 100> rotate 45*y translate <31.9, 0, 31.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <59.9, 3.1, 59.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }           
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }      
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> } 
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }      
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
          #else
            object { rounded_button() rotate 180*y translate <0, 0, 0> }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <0, 0, 16> }
            object { rounded_button() rotate 180*y translate <0, 0, 24> }
            object { rounded_button() rotate 180*y translate <0, 0, 32> }
            object { rounded_button() rotate 180*y translate <0, 0, 40> }
            object { rounded_button() rotate 180*y translate <0, 0, 48> } 
            object { rounded_button() rotate 180*y translate <0, 0, 56> } 
            object { rounded_button() rotate 180*y translate <8, 0, 0> }           
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 16> }
            object { rounded_button() rotate 180*y translate <8, 0, 24> }
            object { rounded_button() rotate 180*y translate <8, 0, 32> }
            object { rounded_button() rotate 180*y translate <8, 0, 40> }
            object { rounded_button() rotate 180*y translate <8, 0, 48> }
            object { rounded_button() rotate 180*y translate <16, 0, 0> }      
            object { rounded_button() rotate 180*y translate <16, 0, 8> }
            object { rounded_button() rotate 180*y translate <16, 0, 16> }
            object { rounded_button() rotate 180*y translate <16, 0, 24> }
            object { rounded_button() rotate 180*y translate <16, 0, 32> }
            object { rounded_button() rotate 180*y translate <16, 0, 40> }             
            object { rounded_button() rotate 180*y translate <24, 0, 0> }      
            object { rounded_button() rotate 180*y translate <24, 0, 8> }
            object { rounded_button() rotate 180*y translate <24, 0, 16> }
            object { rounded_button() rotate 180*y translate <24, 0, 24> }
            object { rounded_button() rotate 180*y translate <24, 0, 32> }                   
            object { rounded_button() rotate 180*y translate <32, 0, 0> }
            object { rounded_button() rotate 180*y translate <32, 0, 8> }
            object { rounded_button() rotate 180*y translate <32, 0, 16> }
            object { rounded_button() rotate 180*y translate <32, 0, 24> }
            object { rounded_button() rotate 180*y translate <40, 0, 0> }
            object { rounded_button() rotate 180*y translate <40, 0, 8> }
            object { rounded_button() rotate 180*y translate <40, 0, 16> } 
            object { rounded_button() rotate 180*y translate <48, 0, 0> }
            object { rounded_button() rotate 180*y translate <48, 0, 8> }
            object { rounded_button() rotate 180*y translate <56, 0, 0> }             
          #end
        }
        box { <-100, -10, 0> <100, 10, 100> rotate 45*y translate <31.9, 0, 31.9> }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 56> }          
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 48> }         
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 40> }          
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }          
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }  
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }          
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }          
          difference {
            box { <-2.4, -1, -2.4> <58.4, 2, 58.4> }
            box { <-100, -10, 0> <100, 10, 100> rotate 45*y translate <30.9, 0, 30.9> }
            box { <-3, -2, -0.6> <0, 3, 0.6> rotate -45*y translate <12, 0, 52> }
            box { <-3, -2, -0.6> <0, 3, 0.6> rotate -45*y translate <20, 0, 44> }
            box { <-3, -2, -0.6> <0, 3, 0.6> rotate -45*y translate <28, 0, 36> }
            box { <-3, -2, -0.6> <0, 3, 0.6> rotate -45*y translate <36, 0, 28> }
            box { <-3, -2, -0.6> <0, 3, 0.6> rotate -45*y translate <44, 0, 20> }
            box { <-3, -2, -0.6> <0, 3, 0.6> rotate -45*y translate <52, 0, 12> }
          }
        #end
        box { <-2.5, -1, -5> <2.6, 2.000001, 5> rotate 45*y translate <8, 0, 56> }
        box { <-2.5, -1, -5> <2.6, 2.000001, 5> rotate 45*y translate <16, 0, 48> }
        box { <-2.5, -1, -5> <2.6, 2.000001, 5> rotate 45*y translate <24, 0, 40> }
        box { <-2.5, -1, -5> <2.6, 2.000001, 5> rotate 45*y translate <32, 0, 32> }
        box { <-2.5, -1, -5> <2.6, 2.000001, 5> rotate 45*y translate <40, 0, 24> }
        box { <-2.5, -1, -5> <2.6, 2.000001, 5> rotate 45*y translate <48 0, 16> }
        box { <-2.5, -1, -5> <2.6, 2.000001, 5> rotate 45*y translate <56, 0, 8> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <4, 0, 28> }
        object { ring() translate <4, 0, 36> }
        object { ring() translate <4, 0, 44> }
        object { ring() translate <4, 0, 52> }        
        object { ring() translate <12, 0, 4> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <12, 0, 28> }
        object { ring() translate <12, 0, 36> }
        object { ring() translate <12, 0, 44> }        
        object { ring() translate <20, 0, 4> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <20, 0, 20> }
        object { ring() translate <20, 0, 28> }
        object { ring() translate <20, 0, 36> }        
        object { ring() translate <28, 0, 4> }
        object { ring() translate <28, 0, 12> }
        object { ring() translate <28, 0, 20> }
        object { ring() translate <28, 0, 28> }        
        object { ring() translate <36, 0, 4> }
        object { ring() translate <36, 0, 12> }
        object { ring() translate <36, 0, 20> }
        object { ring() translate <44, 0, 4> }
        object { ring() translate <44, 0, 12> }
        object { ring() translate <52, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 60> } }
    }
  #end
#end
#macro stwa_hatch(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -7.9> <43.9, 3.1, 7.9> }
      box { <4.1, 3, -7.900001> <35.9, 6.3, 7.900001> }
      box { <4, 0.000001, -23.9> <36, 3.100001, 23.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, -4> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 4> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, -4> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 4> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 20> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, -20> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, -20> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 20> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, -4> }
            cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, -4> }
            cylinder { 6.2*y, 8*y, 2.4 translate <24, 0, -4> }
            cylinder { 6.2*y, 8*y, 2.4 translate <32, 0, -4> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 4> }
            cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, 4> }
            cylinder { 6.2*y, 8*y, 2.4 translate <24, 0, 4> }
            cylinder { 6.2*y, 8*y, 2.4 translate <32, 0, 4> }
          #else
            object { rounded_button() translate <0, 0, -4> }
            object { rounded_button() translate <0, 0, 4> }
            object { rounded_button() translate <40, 0, -4> }
            object { rounded_button() translate <40, 0, 4> }
            object { rounded_button() translate <16, 0, 20> }
            object { rounded_button() translate <16, 0, -20> }
            object { rounded_button() translate <24, 0, -20> }
            object { rounded_button() translate <24, 0, 20> }
            object { rounded_button() translate <8, 3.2, -4> }
            object { rounded_button() translate <16, 3.2, -4> }
            object { rounded_button() translate <24, 3.2, -4> }
            object { rounded_button() translate <32, 3.2, -4> }
            object { rounded_button() translate <8, 3.2, 4> }
            object { rounded_button() translate <16, 3.2, 4> }
            object { rounded_button() translate <24, 3.2, 4> }
            object { rounded_button() translate <32, 3.2, 4> }
          #end
          box { <-3.9, 0, -7.9> <43.9, 3.1, 7.9> }
          box { <4.1, 3, -7.900001> <35.9, 6.3, 7.900001> }
          difference {
            cylinder { -0.000001*y, 3.6*y, 16 scale <1.15, 1, 1> translate <20, 0, 0> }
            box { <0, 3.100001, -8> <4.100001, 10, 8> }
            box { <35.900001, 3.100001, -8> <40, 10, 8> }
          }
          difference {
            sphere { <0, 0, 0> 16 scale <2.3, 1.735, 2> translate <20, -20.5, 0> }
            box { <-500, -1000, -500> <500, 3.6, 500> }
            box { <0, 3.100002, -8> <4.100002, 10, 8> }
            box { <35.900002, 3.100002, -8> <40, 10, 8> }
            box { <-50, 6.300001, -7.9> <50, 50, 7.9> }
          }
          difference {
            box { <4, 0.000001, -23.9> <36, 3.100001, 23.9> }
            box { <-10, -1, -20> <0, 4, 20> rotate 18.4*y translate <12, 0, 23.9> }
            box { <-10, -1, -20> <0, 4, 20> rotate -18.4*y translate <12, 0, -23.9> }
            box { <0, -1, -20> <10, 4, 20> rotate -18.4*y translate <28, 0, 23.9> }
            box { <0, -1, -20> <10, 4, 20> rotate 18.4*y translate <28, 0, -23.9> }
          }
        }
        difference {
          sphere { <0, 0, 0> 15 scale <2.3, 1.735, 2> translate <20, -20.5, 0> }
          box { <0, -100, -8> <4.100002, 100, 8> }
          box { <0, -100, -7.899998> <40, 100, 7.899998> }
          box { <35.900002, -100, -8> <40, 100, 8> }
          difference {
            box { <-10, -100, -25> <50, 100, 25> }
            cylinder { -0.000001*y, 3.6*y, 15.25 scale <1.15, 1, 1> translate <20, 0, 0> }
          }
        }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, -4> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 4> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, -4> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 4> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, -20> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 20> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, -20> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 20> }
          box { <-2.4, -1, -6.4> <4, 2, 6.4> }
          box { <36, -1, -6.4> <42.4, 2, 6.4> }
          box { <5.6, -1, -6.4> <34.4, 5.4, 6.4> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, -4> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <16, 0, -4> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <24, 0, -4> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <32, 0, -4> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 4> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <16, 0, 4> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <24, 0, 4> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <32, 0, 4> }
          difference {
            box { <4, -1, -22.4> <36, 2, 22.4> }
            box { <-10, -2, -20> <0, 3, 20> rotate 18.4*y translate <13.3, 0, 23.9> }
            box { <-10, -2, -20> <0, 3, 20> rotate -18.4*y translate <13.3, 0, -23.9> }
            box { <0, -2, -20> <10, 3, 20> rotate -18.4*y translate <26.7, 0, 23.9> }
            box { <0, -2, -20> <10, 3, 20> rotate 18.4*y translate <26.7, 0, -23.9> }
            box { <0, -2, -7.899999> <40, 3, 7.899999> }
          }
        #end
        box { <-2.6, -1, -2.6> <2.6, 2.000001, 2.6> rotate 45*y translate <8, 0, -12> }
        box { <-2.6, -1, -2.6> <2.6, 2.000001, 2.6> rotate 45*y translate <8, 0, 12> }
        box { <-2.6, -1, -2.6> <2.6, 2.000001, 2.6> rotate 45*y translate <32, 0, -12> }
        box { <-2.6, -1, -2.6> <2.6, 2.000001, 2.6> rotate 45*y translate <32, 0, 12> }
      }
      #if (setting > 1)
        box { <15.5, 0.000003, -9.5> <16.5, 2.1, -7.8> }
        box { <15.5, 0.000003, 7.8> <16.5, 2.1, 9.5> }
        box { <23.5, 0.000003, -9.5> <24.5, 2.1, -7.8> }
        box { <23.5, 0.000003, 7.8> <24.5, 2.1, 9.5> }
        box { <10.4, 0.000003, -12.5> <13.6, 4.1, -11.5> }
        box { <26.4, 0.000003, -12.5> <29.2, 4.1, -11.5> }
        box { <10.4, 0.000003, 11.5> <13.6, 4.1, 12.5> }
        box { <26.4, 0.000003, 11.5> <29.2, 4.1, 12.5> }
        box { <12, 0.000003, -19.5> <13.6, 2.1, -20.5> }
        box { <12, 0.000003, 19.5> <13.6, 2.1, 20.5> }
        box { <26.4, 0.000003, -19.5> <28, 2.1, -20.5> }
        box { <26.4, 0.000003, 19.5> <28, 2.1, 20.5> }
        difference {
          cylinder { 0*y, 3.1*y, 3.2 }
          cylinder { -1*y, 3*y, 2.6 }
          translate <20, 0, -16>
        }
        difference {
          cylinder { 0*y, 3.1*y, 3.2 }
          cylinder { -1*y, 3*y, 2.6 }
          translate <20, 0, 16>
        }
        difference {
          cylinder { 0*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <12, 0, 0>
        }
        difference {
          cylinder { 0*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <20, 0, 0>
        }
        difference {
          cylinder { 0*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <28, 0, 0>
        }
        box { <2.4, 0.000001, -4.5> <4.1, 2.1, -3.5> }
        box { <2.4, 0.000001, 4.5> <4.1, 2.1, 3.5> }
        box { <35.9, 0.000001, -4.5> <37.6, 2.1, -3.5> }
        box { <35.9, 0.000001, 4.5> <37.6, 2.1, 3.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -24> <44, 8.1, 24> } }
    }
  #end
#end
#macro stwa_hatch2(color_tex)
  #if (setting = 0)
    merge {
      box { <-16.3, -3.5, -3.9> <-0.5, -0.5, 27.9> }
      box { <-7, -2.50001, 0.70001> <-4, 2.50001, 7.30001> }
      box { <-7, -2.50001, 16.70001> <-4, 2.50001, 23.30001> }
      texture { color_tex }
    }
  #else
    merge {
      merge {
        difference {
          merge {
            box { <-4.1, -2.5, -3.300005> <0, 2.5, 3.300005> }
            box { <-7, -2.50001, -3.30001> <-4, 2.50001, 3.30001> }
          }
          box { <-10, -4, -5> <-4.3, -1.50001, 5> }
          box { <-5, 0, -5> <5, 5, 5> rotate 60*z translate <-6.1, 0.6, 0> }
          box { <-4.10005, -3, -1.50005> <20, 3, 1.50005> }
          box { <-10, -3, -2.4> <-5.1, 3, 2.4> }
        }
        difference {
          cylinder { -3.3*z, 3.3*z, 2.5 }
          box { <-3, -3, -1.5> <3, 3, 1.5> }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 0*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
        }
        cylinder { -3*z, -1.2*z, 1.5 }
        cylinder { 1.2*z, 3*z, 1.5 }
        translate <0, 0, 4>
      }
      merge {
        difference {
          merge {
            box { <-4.1, -2.5, -3.300005> <0, 2.5, 3.300005> }
            box { <-7, -2.50001, -3.30001> <-4, 2.50001, 3.30001> }
          }
          box { <-10, -4, -5> <-4.3, -1.50001, 5> }
          box { <-5, 0, -5> <5, 5, 5> rotate 60*z translate <-6.1, 0.6, 0> }
          box { <-4.10005, -3, -1.50005> <20, 3, 1.50005> }
          box { <-10, -3, -2.4> <-5.1, 3, 2.4> }
        }
        difference {
          cylinder { -3.3*z, 3.3*z, 2.5 }
          box { <-3, -3, -1.5> <3, 3, 1.5> }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 0*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
          cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
        }
        cylinder { -3*z, -1.2*z, 1.5 }
        cylinder { 1.2*z, 3*z, 1.5 }
        translate <0, 0, 20>
      }
      difference {
        box { <-16.3, -3.5, -3.9> <-0.5, -0.5, 27.9> }
        box { <-4.2, -4, -0.75> <0, 0, 8.75> }
        box { <-4.2, -4, 15.25> <0, 0, 24.75> }
        box { <-14.8, -0.7, -2.4> <-13.9, 0, 26.4> }
        box { <-11.8, -0.7, -2.4> <-10.9, 0, 26.4> }
        box { <-8.8, -0.7, -2.4> <-7.9, 0, 26.4> }
        box { <-5.8, -0.7, -2.4> <-4.9, 0, -1.2> }
        box { <-5.8, -0.7, 25.2> <-4.9, 0, 26.4> }
        box { <-5.8, -0.7, 9> <-4.9, 0, 15> }
        cylinder { -0.70001*y, 0*y, 1 translate <-5.35, 0, 12> }
        box { <-2.8, -0.7, 9> <-1.9, 0, 15> }
        difference {
          box { <-14.8, -4, -2.4> <-2, -1.5, 26.4> }
          box { <-5.3, -5, -1.4> <0, 0, 10> }
          box { <-5.3, -5, 14> <0, 0, 25.4> }
          box { <-10, -5, -0.45> <0, 0, 0.45> }
          box { <-10, -5, 7.55> <0, 0, 8.45> }
          box { <-10, -5, 15.55> <0, 0, 16.45> }
          box { <-10, -5, 23.55> <0, 0, 24.45> }
        }
      }
      texture { color_tex }
      bounded_by { box { <-16.4, -3.6, -4> <2.6, 2.6, 28> } }
    }
  #end
#end
#macro stwa_helmet(color_tex)
  #if (setting = 0)
    sphere { <0, 1, 0> 7 rotate -5*z texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          difference {
            sphere { <0, 1, 0> 7 }
            box { <-7, -6, -7> <7, 1, 7> }
            box { <0, -6, -7> <7, 8, 7> }
          }
          difference {
            sphere { <0, 1.000001, 0> 6.5 }
            box { <-7, -6, -7> <-0.000001, 8, 7> }
          }
          difference {
            cylinder { -1.1*z, 1.1*z, 7.7 translate <0, 1, 0> }
            box { <-10, -10, -2> <0.000001, 0.999999, 2> }
          }
          difference {
            cylinder { -3*z, 3*z, 7.7 translate <0, 1, 0> }
            cylinder { -10*x, 10*x, 6 translate <0, 1, -7.1> }
            cylinder { -10*x, 10*x, 6 translate <0, 1, 7.1> }
            box { <-10, -10, -10> <0, 10, 10> }
            box { <-10, 0, -10> <10, 10, 10> }
          }
          difference {
            sphere { <-6.45, 1, 0> 1.5 scale <1, 1.5, 1.25> }
            box { <-10, -6, -3> <0, 1, 3> }
          }
          difference {
            sphere { <0, 0, 0> 1 scale <3.5, 4.5, 1.75> }
            box { <-10, -10, 0> <10, 0, 10> rotate 30*z rotate 17.5*y translate <0, -2, 1.5> }
            rotate 5*z
            translate <0, 0, 5.5>
          }
          difference {
            sphere { <0, 0, 0> 1 scale <3.5, 4.5, 2> }
            cone { -1*z, 2, 3*z, 4.25 scale <0.7, 1, 1> }
            box { <-10, -10, -5> <2, 0, 5> rotate 5*z translate <0, 0, 0> }
            box { <-2, -10, -5> <10, 0, 5> rotate 50*z translate <1, 0, 0> }
            rotate 5*z
            translate <0, 0, 6>
          }
          difference {
            sphere { <0, 0, 0> 1 scale <3.5, 4.5, 1.75> }
            box { <-10, -10, -10> <10, 0, 0> rotate 30*z rotate -17.5*y translate <0, -2, -1.5> }
            rotate 5*z
            translate <0, 0, -5.5>
          }
          difference {
            sphere { <0, 0, 0> 1 scale <3.5, 4.5, 2> }
            cone { 1*z, 2, -3*z, 4.25 scale <0.7, 1, 1> }
            box { <-10, -10, -5> <2, 0, 5> rotate 5*z translate <0, 0, 0> }
            box { <-2, -10, -5> <10, 0, 5> rotate 50*z translate <1, 0, 0> }
            rotate 5*z
            translate <0, 0, -6>
          }
          box { <0, 0, 0> <1.2, 1.2, -1> rotate 10*y rotate 20*z translate <-2, -2.5, -6.5> }
          box { <0, 0, 0> <1.2, 1.2, 1> rotate -10*y rotate 20*z translate <-2, -2.5, 6.5> }
          bounded_by { box { <-7.5, -8, -8.1> <7.8, 8.7, 8.1> } }
          rotate -5*z
        }
        cylinder { -1*y, 5.000001*y, 2.25 }
        cylinder { -9*y, 2*y, 4.9 }
        cone { 2.000001*y, 5, 4*y, 3 }
        merge {
          box { <4, -10, -7> <10, -3.25, 7> }
          box { <-10, -10, -7> <0, 0, 7> rotate 20*z translate <4, -3.25, 0> }
        }
      }
      #if (setting > 1)
        object { ring() translate <0, 3, 0> }
      #end
      texture { color_tex }
    }
  #end
#end
#macro stwa_hvswivel1(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      box { <-1.5, 9.4, -2.9> <1.5, 17.7, 2.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          box { <-3.900001, 8, -3.900001> <3.900001, 10, 3.900001> }
          box { <-3.900002, 10.2, -3.900002> <3.900002, 11.3, 3.900002> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() translate <8, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      difference {
        box { <-3.3, 10.8, -1.2> <3.3, 13.2, 1.2> }
        box { <-4, 12.3, -0.5> <4, 14, 0.5> }
        box { <-4, 0, -5> <4, 5, 0> rotate 10*x translate <0, 10.8, -1.2> }
        box { <-4, 0, 0> <4, 5, 5> rotate -10*x translate <0, 10.8, 1.2> }
      }
      difference {
        merge {
          cylinder { -1*y, 8*y, 0.5 rotate 7*x translate <-1, 11.3, -2.8> }
          cylinder { -1*y, 8*y, 0.5 rotate 7*x translate <1, 11.3, -2.8> }
          cylinder { -1*y, 8*y, 0.5 rotate -7*x translate <-1, 11.3, 2.8> }
          cylinder { -1*y, 8*y, 0.5 rotate -7*x translate <1, 11.3, 2.8> }
          difference {
            box { <-1.000001, 11.299999, -3.3> <1.000001, 17.7, 3.3> }
            box { <-2, 0, -10> <2, 10, 0> rotate 7*x translate <0, 11.3, -3.3> }
            box { <-2, 0, 0> <2, 10, 10> rotate -7*x translate <0, 11.3, 3.3> }
          }
          difference {
            box { <-1.500001, 11.299999, -2.8> <1.500001, 17.700001, 2.8> }
            box { <-2, 0, -10> <2, 10, 0> rotate 7*x translate <0, 11.3, -2.8> }
            box { <-2, 0, 0> <2, 10, 10> rotate -7*x translate <0, 11.3, 2.8> }
          }
        }
        cylinder { 15.3*y, 25*y, 1.5 translate <-2.6, 0, 0> }
        cylinder { 15.3*y, 25*y, 1.5 translate <2.6, 0, 0> }
        cylinder { -3*x, -0.5*x, 0.75 translate <0, 15.1, 0> }
        cylinder { 0.5*x, 3*x, 0.75 translate <0, 15.1, 0> }
        cone { -2.6*x, 1.75, -0.499995*x, 0.75 translate <0, 15.1, 0> }
        cone { 0.499995*x, 1.75, 2.6*x, 0.75 translate <0, 15.1, 0> }
        box { <-4, 17.700005, -4> <4, 30, 4> }
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 8.7*y, 1.5 }
          cylinder { -1*y, 2*y, 0.7 }
          translate <4, 0, 0>
        }
        box { <3.5, 2, -3> <4.5, 8.7, 3> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 17.8, 4> } }
    }
  #end
#end
#macro stwa_hwblock6_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 19.1, 43.9> }
      box { <11.9, 9.5, -4> <28.1, 20, 44> }
      box { <-4, 9.500001, 11.9> <44, 20, 28.1> }
      box { <-4, 0, -20> <44, 30, 0> rotate -23.75*x translate <0, 0, 4.1> }
      box { <-20, 0, -4> <0, 30, 44> rotate 23.75*z translate <4.1, 0, 0> }
      box { <0, 0, -4> <20, 30, 44> rotate -23.75*z translate <35.9, 0, 0> }
      box { <-4, 0, 0> <44, 30, 20> rotate 23.75*x translate <0, 0, 35.9> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <43.9, 19.1, 43.9> }
          box { <11.9, 9.5, -4> <28.1, 20, 44> }
          box { <-4, 9.500001, 11.9> <44, 20, 28.1> }
          box { <11.900001, -1, -4> <28.100001, 20, 4.1> }
          box { <11.900001, -1, 35.9> <28.100001, 20, 44> }
          box { <-4, -1, 11.900001> <4.1, 20, 28.100001> }
          box { <35.9, -1, 11.900001> <44, 20, 28.100001> }
          box { <-4, 0, -20> <44, 30, 0> rotate -23.75*x translate <0, 0, 4.1> texture { color_tex } normal { bumping } }
          box { <-20, 0, -4> <0, 30, 44> rotate 23.75*z translate <4.1, 0, 0> texture { color_tex } normal { bumping } }
          box { <0, 0, -4> <20, 30, 44> rotate -23.75*z translate <35.9, 0, 0> texture { color_tex } normal { bumping } }
          box { <-4, 0, 0> <44, 30, 20> rotate 23.75*x translate <0, 0, 35.9> texture { color_tex } normal { bumping } }
          difference {
            box { <-2.9, 2, -2.9> <42.9, 20, 42.9> }
            box { <4.6, -1, 4.6> <35.4, 9, 35.4> }
            box { <10.9, 1, -4> <29.1, 21, 44> }
            box { <-4, 1, 10.9> <44, 21, 29.1> } 
            box { <-4, 0, -20> <44, 30, 0> rotate -23.75*x translate <0, 1, 5.1> }
            box { <-20, 0, -4> <0, 30, 44> rotate 23.75*z translate <5.1, 1, 0> }
            box { <0, 0, -4> <20, 30, 44> rotate -23.75*z translate <34.9, 1, 0> }
            box { <-4, 0, 0> <44, 30, 20> rotate 23.75*x translate <0, 1, 34.9> }
          }
          #if (setting > 1)
            box { <5.6, -1, 5.6> <34.4, 8.6, 34.4> }
          #end
        }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 16> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 24> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 24> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 32> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 8> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 16> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 24> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 32> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 16> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <32, 0, 24> }
        #else
          object { rounded_button() translate <8, 6.4, 16> }
          object { rounded_button() translate <8, 6.4, 24> }
          object { rounded_button() translate <16, 6.4, 8> }
          object { rounded_button() translate <16, 6.4, 16> }
          object { rounded_button() translate <16, 6.4, 24> }
          object { rounded_button() translate <16, 6.4, 32> }
          object { rounded_button() translate <24, 6.4, 8> }
          object { rounded_button() translate <24, 6.4, 16> }
          object { rounded_button() translate <24, 6.4, 24> }
          object { rounded_button() translate <24, 6.4, 32> }
          object { rounded_button() translate <32, 6.4, 16> }
          object { rounded_button() translate <32, 6.4, 24> }
        #end
        #if (setting > 1)
          object { high_ring() translate <12, 0, 12> }
          object { high_ring() translate <12, 0, 28> }
          object { high_ring() translate <28, 0, 12> }
          object { high_ring() translate <28, 0, 28> }
          object { high_ring() translate <20, 0.75, 12> }
          object { high_ring() translate <12, 0.75, 20> }
          object { high_ring() translate <20, 0.75, 20> }
          object { high_ring() translate <28, 0.75, 20> }
          object { high_ring() translate <20, 0.75, 28> }
          box { <19.5, 0.750001, 5.5> <20.5, 9, 9.5> }
          box { <19.5, 0.750001, 14.5> <20.5, 9, 17.5> }
          box { <19.5, 0.750001, 22.5> <20.5, 9, 25.5> }
          box { <19.5, 0.750001, 30.5> <20.5, 9, 34.5> }
          box { <5.5, 0.750001, 19.5> <9.5, 9, 20.5> }
          box { <14.5, 0.750001, 19.5> <17.5, 9, 20.5> }
          box { <22.5, 0.750001, 19.5> <25.5, 9, 20.5> }
          box { <30.5, 0.750001, 19.5> <34.5, 9, 20.5> }
        #end
        difference {
          merge {
            object { open_rounded_button() translate <0, 16, 0> }
            object { open_rounded_button() translate <8, 16, 0> }
            object { open_rounded_button() translate <0, 16, 8> }
            object { open_rounded_button() translate <8, 16, 8> }
            object { open_rounded_button() translate <0, 16, 32> }
            object { open_rounded_button() translate <0, 16, 40> }
            object { open_rounded_button() translate <8, 16, 32> }
            object { open_rounded_button() translate <8, 16, 40> }
            object { open_rounded_button() translate <32, 16, 0> }
            object { open_rounded_button() translate <32, 16, 8> }
            object { open_rounded_button() translate <32, 16, 32> }
            object { open_rounded_button() translate <32, 16, 40> }
            object { open_rounded_button() translate <40, 16, 0> }
            object { open_rounded_button() translate <40, 16, 8> }
            object { open_rounded_button() translate <40, 16, 32> }
            object { open_rounded_button() translate <40, 16, 40> }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <8, 0, 0>
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <0, 0, 8>
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <8, 0, 8>
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <0, 0, 32>
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <8, 0, 32>
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <0, 0, 40>
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <8, 0, 40>
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <32, 0, 0>
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <32, 0, 8>
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <32, 0, 32>
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <32, 0, 40>
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <40, 0, 0>
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <40, 0, 8>
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <40, 0, 32>
            }
            difference {
              cylinder { 9*y, 19.000001*y, 2.400001 }
              cylinder { 8*y, 21*y, 1.600001 }
              translate <40, 0, 40>
            }
            box { <2, 9, -0.5> <6, 14.1, 0.5> }
            box { <2, 9, 7.5> <6, 14.1, 8.5> }
            box { <2, 9, 31.5> <6, 14.1, 32.5> }
            box { <2, 9, 39.5> <6, 14.1, 40.5> }
            box { <34, 9, -0.5> <38, 14.1, 0.5> }
            box { <34, 9, 7.5> <38, 14.1, 8.5> }
            box { <34, 9, 31.5> <38, 14.1, 32.5> }
            box { <34, 9, 39.5> <38, 14.1, 40.5> }
            box { <-0.5, 9, 2> <0.5, 14.1, 6> }
            box { <7.5, 9, 2> <8.5, 14.1, 6> }
            box { <31.5, 9, 2> <32.5, 14.1, 6> }
            box { <39.5, 9, 2> <40.5, 14.1, 6> }
            box { <-0.5, 9, 34> <0.5, 14.1, 38> }
            box { <7.5, 9, 34> <8.5, 14.1, 38> }
            box { <31.5, 9, 34> <32.5, 14.1, 38> }
            box { <39.50, 9, 34> <40.5, 14.1, 38> }
          }
          box { <-4, 0, -20> <44, 30, 0> rotate -23.75*x translate <0, 1, 5.1> }
          box { <-20, 0, -4> <0, 30, 44> rotate 23.75*z translate <5.1, 1, 0> }
          box { <0, 0, -4> <20, 30, 44> rotate -23.75*z translate <34.9, 1, 0> }
          box { <-4, 0, 0> <44, 30, 20> rotate 23.75*x translate <0, 1, 34.9> }
        }
      }
      cylinder { -1*y, 10*y, 2.600001 translate <20, 0, 12> }
      cylinder { -1*y, 10*y, 2.600001 translate <12, 0, 20> }
      cylinder { -1*y, 10*y, 2.600001 translate <20, 0, 20> }
      cylinder { -1*y, 10*y, 2.600001 translate <28, 0, 20> }
      cylinder { -1*y, 10*y, 2.600001 translate <20, 0, 28> }
      #if (setting > 1)
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 16> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 24> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 24> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 32> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 8> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 16> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 24> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 32> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 16> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 24> }
      #end
      cylinder { 9*y, 9.6*y, 3.1 translate <20, 0, 12> }
      cylinder { 9*y, 9.6*y, 3.1 translate <12, 0, 20> }
      cylinder { 9*y, 9.6*y, 3.1 translate <20, 0, 20> }
      cylinder { 9*y, 9.6*y, 3.1 translate <28, 0, 20> }
      cylinder { 9*y, 9.6*y, 3.1 translate <20, 0, 28> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 20.9, 44> } }
    }
  #end
#end
#macro stwa_h_swivel1(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      box { <11.8, 3.2, -3.300001> <16, 8.2, 3.300001> }
      cylinder { -3.3*z, 3.3*z, 2.5 translate <16, 5.6, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.3 }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <8, 0, 0> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        #end
        box { <0, 0, -4> <3, 3, 4> rotate -45*z translate <10, 0, 0> }
      }
      difference {
        box { <11, 3.200001, -3.300001> <16.000001, 8.200001, 3.300001> }
        box { <10, 3, -1.500001> <17, 9, 1.500001> }
        cylinder { -4*z, 4*z, 0.300001 translate <0, 2.5, 0> rotate 0*z translate <16, 5.6, 0> }
        cylinder { -4*z, 4*z, 0.300001 translate <0, 2.5, 0> rotate -180*z translate <16, 5.6, 0> }
      }
      difference {
        cylinder { -3.3*z, 3.3*z, 2.5 }
        box { <-3, -3, -1.5> <3, 3, 1.5> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 0*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
        translate <16, 5.6, 0>
      }
      #if (setting > 1)
       difference {
          cylinder { 0*y, 8.7*y, 1.5 }
          cylinder { -1*y, 2*y, 0.7 }
          translate <4, 0, 0>
        }
        box { <3.5, 2, -3> <4.5, 8.7, 3> }
        cylinder { -3*z, -1.2*z, 1.5 translate <16, 5.6, 0> }
        cylinder { 1.2*z, 3*z, 1.5 translate <16, 5.6, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <18.6, 11.3, 4> } }
    }
  #end
#end
#macro stwa_h_swivel2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      box { <11, 2.1, -1.5> <18.2, 8.6, 1.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 180*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <8, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        #end
        box { <0, 0, -4> <3, 3, 4> rotate -45*z translate <10, 0, 0> }
      }
      difference {
        box { <11, 4.4, -3.3> <13.9, 6.8, 3.3> }
        box { <0, 0, -4> <5, 5, 4> rotate -10*z translate <11, 6.8, 0> }
        box { <0, -5, -4> <5, 0, 4> rotate 10*z translate <11, 4.4, 0> }
        box { <13, 5.35, -4> <14, 5.85, 4> }
      }
      difference {
        merge {
          cylinder { -1*x, 8*x, 0.5 rotate -7*z translate <11.9, 8.1, -1> }
          cylinder { -1*x, 8*x, 0.5 rotate -7*z translate <11.9, 8.1, 1> }
          cylinder { -1*x, 8*x, 0.5 rotate 7*z translate <11.9, 2.6, -1> }
          cylinder { -1*x, 8*x, 0.5 rotate 7*z translate <11.9, 2.6, 1> }
          difference {
            box { <11, 2.1, -1.000001> <18.2, 8.6, 1.000001> }
            box { <-1, 0, -2> <20, 10, 2> rotate -7*z translate <11.9, 8.6, 0> }
            box { <-1, -10, -2> <20, 0, 2> rotate 7*z translate <11.9, 2.1, 0> }
          }
          difference {
            box { <11, 2.6, -1.500001> <18.200001, 8.1, 1.500001> }
            box { <-1, 0, -2> <20, 10, 2> rotate -7*z translate <11.9, 8.1, 0> }
            box { <-1, -10, -2> <20, 0, 2> rotate 7*z translate <11.9, 2.6, 0> }
          }
        }
        cylinder { 16*x, 25*x, 1.5 translate <0, 5.6, -2.6> }
        cylinder { 16*x, 25*x, 1.5 translate <0, 5.6, 2.6> }
        cylinder { -3*z, -0.5*z, 0.75 translate <16, 5.6, 0> }
        cylinder { 0.5*z, 3*z, 0.75 translate <16, 5.6, 0> }
        cone { -2.6*z, 1.75, -0.499995*z, 0.75 translate <16, 5.6, 0> }
        cone { 0.499995*z, 1.75, 2.6*z, 0.75 translate <16, 5.6, 0> }
        box { <18.200005, 0, -4> <30, 20, 4> }
      }
      difference {
        cylinder { 0*y, 8.7*y, 1.5 }
        cylinder { -1*y, 2*y, 0.7 }
        translate <4, 0, 0>
      }
      box { <3.5, 2, -3> <4.5, 8.7, 3> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <18.3, 11.3, 4> } }
    }
  #end
#end
#macro stwa_h_swivel3(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      box { <11.8, 2.300001, -2.5> <16, 8.9, 2.5> }
      cylinder { -3.3*y, 3.3*y, 2.5 translate <16, 5.6, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.3 }
            cylinder { 9.4*y, 11.2*y, 2.3 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 180*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <8, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      difference {
        box { <11, 2.300001, -2.5> <16.000001, 8.900001, 2.5> }
        box { <10, 4.100001, -3> <17, 7.100001, 3> }
        cylinder { -4*z, 4*z, 0.300001 translate <0, 2.5, 0> translate <16, 5.6, 0> }
        cylinder { -4*z, 4*z, 0.300001 translate <0, 2.5, 0> rotate -180*z translate <16, 5.6, 0> }
      }
      difference {
        cylinder { -3.3*z, 3.3*z, 2.5 }
        box { <-3, -3, -1.5> <3, 3, 1.5> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 0*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
        rotate 90*x translate <16, 5.6, 0>
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <4, 0, 0> }
        box { <3.5, 2, -3> <4.5, 8.7, 3> }
        cylinder { -3*y, -1.2*y, 1.5 translate <16, 5.6, 0> }
        cylinder { 1.2*y, 3*y, 1.5 translate <16, 5.6, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <18.6, 11.3, 4> } }
    }
  #end
#end
#macro stwa_h_swivel4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
      box { <11, 2.1, 2.5> <18.2, 8.6, 5.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() rotate 180*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 180*y translate <0, 6.4, 8> }
            object { rounded_button() rotate 180*y translate <8, 6.4, 8> }
          #end
        }
        object { axle_opening(10,2) rotate 90*z translate <4, 0, 4> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 10.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
        #end
        box { <0, 0, -4> <3, 3, 12> rotate -45*z translate <10, 0, 0> }
      }
      difference {
        box { <11, 4.4, 0.7> <13.9, 6.8, 7.3> }
        box { <0, 0, -4> <5, 5, 4> rotate -10*z translate <11, 6.8, 4> }
        box { <0, -5, -4> <5, 0, 4> rotate 10*z translate <11, 4.4, 4> }
        box { <13, 5.35, -0> <14, 5.85, 8> }
      }
      difference {
        merge {
          cylinder { -1*x, 8*x, 0.5 rotate -7*z translate <11.9, 8.1, 3> }
          cylinder { -1*x, 8*x, 0.5 rotate -7*z translate <11.9, 8.1, 5> }
          cylinder { -1*x, 8*x, 0.5 rotate 7*z translate <11.9, 2.6, 3> }
          cylinder { -1*x, 8*x, 0.5 rotate 7*z translate <11.9, 2.6, 5> }
          difference {
            box { <11, 2.1, 2.999999> <18.2, 8.6, 5.000001> }
            box { <-1, 0, -2> <20, 10, 2> rotate -7*z translate <11.9, 8.6, 4> }
            box { <-1, -10, -2> <20, 0, 2> rotate 7*z translate <11.9, 2.1, 4> }
          }
          difference {
            box { <11, 2.6, 2.499999> <18.200001, 8.1, 5.500001> }
            box { <-1, 0, -2> <20, 10, 2> rotate -7*z translate <11.9, 8.1, 4> }
            box { <-1, -10, -2> <20, 0, 2> rotate 7*z translate <11.9, 2.6, 4> }
          }
        }
        cylinder { 16*x, 25*x, 1.5 translate <0, 5.6, 1.4> }
        cylinder { 16*x, 25*x, 1.5 translate <0, 5.6, 6.6> }
        cylinder { -3*z, -0.5*z, 0.75 translate <16, 5.6, 4> }
        cylinder { 0.5*z, 3*z, 0.75 translate <16, 5.6, 4> }
        cone { -2.6*z, 1.75, -0.499995*z, 0.75 translate <16, 5.6, 4> }
        cone { 0.499995*z, 1.75, 2.6*z, 0.75 translate <16, 5.6, 4> }
        box { <18.200005, 0, 0> <30, 20, 8> }
      }
      #if (setting > 1)
        object { high_ring() translate <4, 0, 4> }
        box { <-2.5, 4, 3.75> <1, 8.7, 4.25> }
        box { <7, 4, 3.75> <10.5, 8.7, 4.25> }
        box { <3.75, 4, -2.5> <4.25, 8.7, 1> }
        box { <3.75, 4, 7> <4.25, 8.7, 10.5> }
        difference {
          cylinder { 3*y, 8.7*y, 2.7 }
          object { axle_opening(10,2) rotate 90*z }
          translate <4.000001, 0, 4.000001>
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <18.3, 11.3, 12> } }
    }
  #end
#end
#macro stwa_landspeeder_engine(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      cylinder { -11.9*x, 27.9*x, 6.7 translate <0, 18.5, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
      #end
      box { <-3.900001, 3, 3.25>, <11.900001, 13, 4.75> }
      difference {
        box { <-3.9, 4, -3.9> <11.9, 7, 3.9> }
        box { <-4, 0, -10> <12, 10, 0> rotate -30*x translate <0, 3.75, -1.65> }
        box { <-4, 0, 0> <12, 10, 10> rotate 30*x translate <0, 3.75, 1.65> }
        difference {
          box { <-3.4, 4.1, -2.9> <11.4, 8, 2.9> }
          box { <-4, 0, -10> <12, 10, 0> rotate -30*x translate <0, 3.75, -1.15> }
          box { <-4, 0, 0> <12, 10, 10> rotate 30*x translate <0, 3.75, 1.15> }
        }
        translate <0, 18.5, 4>
      }
      difference {
        merge {
          cone { -11.9*x, 3.75, -3.899999*x, 6.7 }
          cylinder { -3.900002*x, 11.900002*x, 6.7 }
          cone { 11.899999*x, 6.7, 27.9*x, 3.5 }
        }
        box { <-2.9, 3, -2> <10.9, 10, 2> }
        #local counter = 0;
        #while (counter <12)
          difference {
            box { <-12, 3.750001, -1.25> <28, 10, 1.25> }
            box { <-4.9, 0, -2> <-3.9, 11, 2> }
            box { <-13, 0, -10> <29, 10, 0> rotate -15*x translate <0, 3.75, -0.4> }
            box { <-13, 0, 0> <29, 10, 10> rotate 15*x translate <0, 3.75, 0.4> }
            rotate 15*x
            rotate (counter*30)*x
          }
          #local counter = counter + 1;
        #end
        cylinder { -12*x, 26*x, 2.4 }
        translate <0, 18.5, 4>
      }
      object { open_rounded_button() rotate -90*z translate <24.8, 18.5, 4> }
      object { open_rounded_button() translate <0, 22.4, 4> }
      object { open_rounded_button() translate <8, 22.4, 4> }
      difference {
        cylinder { 21.5*y, 25.400001*y, 2.400001 }
        cylinder { 25.2*y, 26*y, 1.600001 }
        cylinder { 20*y, 29*y, 1.4 }
        translate <0, 0, 4>
      }
      difference {
        cylinder { 21.5*y, 25.400001*y, 2.400001 }
        cylinder { 25.2*y, 26*y, 1.600001 }
        cylinder { 20*y, 29*y, 1.4 }
        translate <8, 0, 4>
      }
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <29.7, 27.3, 12> } }
    }
  #end
#end
#macro stwa_leftf_wing6_12(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <91.9, 3.1, 43.9> }
      box { <0, -1, -100> <100, 4, 0> rotate 18*y translate <-4, 0, 20> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <91.9, 3.1, 43.9> }
          #if (setting < 3)
            #local counter = 0;
            #while (counter < 12)
              cylinder { 3*y, 4.8*y, 2.4 translate <0+(counter*8), 0, 24> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0+(counter*8), 0, 32> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0+(counter*8), 0, 40> }
              #if (counter > 2)
                cylinder { 3*y, 4.8*y, 2.4 translate <0+(counter*8), 0, 16> }
              #end
              #if (counter > 5)
                cylinder { 3*y, 4.8*y, 2.4 translate <0+(counter*8), 0, 8> }
              #end
              #if (counter > 8)
                cylinder { 3*y, 4.8*y, 2.4 translate <0+(counter*8), 0, 0> }
              #end
              #local counter = counter + 1;
            #end
          #else
            #local counter = 0;
            #while (counter < 12)
              object { rounded_button() rotate -90*y translate <0+(counter*8), 0, 24> }
              object { rounded_button() rotate -90*y translate <0+(counter*8), 0, 32> }
              object { rounded_button() rotate -90*y translate <0+(counter*8), 0, 40> }
              #if (counter > 2)
                object { rounded_button() rotate -90*y translate <0+(counter*8), 0, 16> }
              #end
              #if (counter > 5)
                object { rounded_button() rotate -90*y translate <0+(counter*8), 0, 8> }
              #end
              #if (counter > 8)
                object { rounded_button() rotate -90*y translate <0+(counter*8), 0, 0> }
              #end
              #local counter = counter + 1;
            #end
          #end
        }
        box { <0, -1, -100> <100, 4, 0> rotate 18*y translate <-4, 0, 20> }
        box { <-2.4, -1, -4> <10.4, 2.000001, 4> rotate 18*y translate <8, 0, 16> }
        box { <-2.4, -1, -4> <10.4, 2.000001, 4> rotate 18*y translate <32, 0, 8> }
        box { <-2.4, -1, -4> <10.4, 2.000001, 4> rotate 18*y translate <56, 0, 0> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <90.4, 2, 42.4> }
            box { <0, -1, -100> <100, 4, 0> rotate 18*y translate <-4, 0, 21.5> }
          }
          #local counter = 0;
          #while (counter < 12)
            cylinder { 1*y, 4*y, 1.2 translate <0+(counter*8), 0, 24> }
            cylinder { 1*y, 4*y, 1.2 translate <0+(counter*8), 0, 32> }
            cylinder { 1*y, 4*y, 1.2 translate <0+(counter*8), 0, 40> }
            #if (counter > 2)
              cylinder { 1*y, 4*y, 1.2 translate <0+(counter*8), 0, 16> }
            #end
            #if (counter > 5)
              cylinder { 1*y, 4*y, 1.2 translate <0+(counter*8), 0, 8> }
            #end
            #if (counter > 8)
              cylinder { 1*y, 4*y, 1.2 translate <0+(counter*8), 0, 0> }
            #end
            #local counter = counter + 1;
          #end
        #end
      }
      box { <-0.5, 0.25, 19.5> <0.5, 2.1, 21.4> }
      box { <23.5, 0.25, 11.5> <24.5, 2.1, 13.4> }
      box { <47.5, 0.25, 3.5> <48.5, 2.1, 5.4> }
      box { <-2, 0.25, -0.5> <4, 2.1, 0.5> rotate -45*y translate <4, 0, 20> }
      box { <-2, 0.25, -0.5> <4, 2.1, 0.5> rotate -45*y translate <28, 0, 12> }
      box { <-2, 0.25, -0.5> <4, 2.1, 0.5> rotate -45*y translate <52, 0, 4> }
      #local counter = 0;
      #while ( counter < 11)
        object { ring() translate <4+(counter*8), 0, 28> }
        object { ring() translate <4+(counter*8), 0, 36> }
        #if (counter > 0)
          object { ring() translate <4+(counter*8), 0, 20> }
        #end
        #if (counter > 3)
          object { ring() translate <4+(counter*8), 0, 12> }
        #end
        #if (counter > 6)
          object { ring() translate <4+(counter*8), 0, 4> }
        #end
        #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <92, 4.9, 44> } }
    }
  #end
#end
#macro stwa_lightsaber(color_tex)
  #if (setting = 0)
    cylinder { -5.9*y, 9.5*y, 3 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -5*y, 7*y, 1.5 }
        cylinder { 3*y, 3.6*y, 2 }
        cylinder { 4.5*y, 5.1*y, 2 }
        cylinder { 6*y, 7.7*y, 2.75 }
        cylinder { 7*y, 9.5*y, 2.3 }
        cylinder { -5.9*y, -3*y, 2.3 }
        box { <-0.65, -2, 0> <0.65, 0, 3> rotate -32.5*x translate <0, -3, -3> }
        box { <-0.65, -2, 0> <0.65, 0, 3> rotate -32.5*x translate <0, -3, -3> rotate 90*y }
        box { <-0.65, -2, 0> <0.65, 0, 3> rotate -32.5*x translate <0, -3, -3> rotate 180*y }
        box { <-0.65, -2, 0> <0.65, 0, 3> rotate -32.5*x translate <0, -3, -3> rotate 270*y }
        box { <-0.650001, -4, -3.000001> <0.650001, -2.999999, -1.5> }
        box { <-0.650001, -4, -3.000001> <0.650001, -2.999999, -1.5> rotate 90*y }
        box { <-0.650001, -4, -3.000001> <0.650001, -2.999999, -1.5> rotate 180*y }
        box { <-0.650001, -4, -3.000001> <0.650001, -2.999999, -1.5> rotate 270*y }
      }
      cylinder { 7.7*y, 10*y, 1.6 }
      cylinder { -6*y, -3.1*y, 1.6 }
      texture { color_tex }
      bounded_by { cylinder { -6*y, 9.6*y, 3.1 } }
    }
  #end
#end
#macro stwa_lightsaber_beam(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 31.8*y, 1.55 texture { color_tex } }
  #else
    merge {
      torus { 1.35, 0.15 translate <0, 0.15, 0> }
      cylinder { 0.149999*y, 31.650001*y, 1.5 }
      cylinder { -0.000001*y, 31.800001*y, 1.350001 }
      torus { 1.35, 0.15 translate <0, 31.65, 0> }
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 31.9*y, 1.6 } }
    }
  #end
#end
#macro stwa_pivotplug(color_tex)
  #if (setting = 0)
    cylinder { -2.4*x, 18.5*x, 3.5 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { -12.1*x, -4.1*x, 3.5 }
        difference {
          merge {
            box { <-3, -4, -4> <-1.8, 4, 4> }
            box { <-0.6, -4, -4> <0.6, 4, 4> }
            box { <3, -4, -4> <1.8, 4, 4> }
          }
          box { <-3.1, -5, -0.6> <3.1, 5, 0.6> }
          box { <-3.1, -0.6, -5> <3.1, 0.6, 5> }
          translate <-8, 0, 0>
        }
        box { <-4, -2.5, -4> <10, -4, 4> }
        box { <-4, 2.5, -4> <10, 4, 4> }
        box { <-4, -4, -1.5> <10, 4, 1.5> }
        translate <16, 0, 0>
      }
      difference {
        cylinder { 2.1*x, 4*x, 3.500001 }
        box { <-5, 0, -4> <0, 5, 4> rotate 10*z translate <4, 1.2, 0> }
        box { <-5, -5, -4> <0, 0, 4> rotate -10*z translate <4, -1.2, 0> }
        box { <2, -0.25, -4> <2.6, 0.25, 4> }
      }
      difference {
        merge {
          torus { 2.249995, 0.3 rotate 90*z translate <19.600005, 0, 0> }
          cylinder { 11*x, 19.9*x, 2.25 }
          cylinder { 11.35*x, 12.65*x, 2.9 }
          cylinder { -8*x, 0*x, 0.5 rotate 7*z translate <4, 2.8, -1> }
          cylinder { -8*x, 0*x, 0.5 rotate 7*z translate <4, 2.8, 1> }
          cylinder { -8*x, 0*x, 0.5 rotate -7*z translate <4, -2.8, -1> }
          cylinder { -8*x, 0*x, 0.5 rotate -7*z translate <4, -2.8, 1> }
          difference {
            box { <-3.2, -3.3, -1.000001> <4, 3.3, 1.000001> }
            box { <-20, 0, -2> <1, 10, 2> rotate 7*z translate <4, 3.3, 0> }
            box { <-20, -10, -2> <1, 0, 2> rotate -7*z translate <4, -3.3, 0> }
          }
          difference {
            box { <-3.200001, -2.8, -1.500001> <4, 2.8, 1.500001> }
            box { <-20, 0, -2> <1, 10, 2> rotate 7*z translate <4, 2.8, 0> }
            box { <-20, -10, -2> <1, 0, 2> rotate -7*z translate <4, -2.8, 0> }
          }
        }
        box { <17.499999, -0.5, -4> <20, 0.5, 4> }
        cylinder { -4*z, 4*z, 0.5  translate <17.5, 0, 0> }
        cylinder { -8*x, 0*x, 1.5 translate <0, 0, -2.6> }
        cylinder { -8*x, 0*x, 1.5 translate <0, 0, 2.6> }
        cylinder { -3*z, -0.5*z, 0.75 }
        cylinder { 0.5*z, 3*z, 0.75 }
        cone { -2.6*z, 1.75, -0.499995*z, 0.75 }
        cone { 0.499995*z, 1.75, 2.6*z, 0.75 }
        box { <-10, -10, -4> <-2.4, 10, 4> }
      }
      texture { color_tex }
      bounded_by { cylinder { -2.5*x, 20*x, 3.6 } }
    }
  #end
#end
#macro stwa_podbrake(color_tex)
  #if (setting = 0)
    difference {
      box { <-68, -4, -8> <-4, -0.3, 8> }
      box { <-70, 0, -10> <0, 10, 0> rotate -40*x translate <0, -0.3, -3.8> }
      box { <-70, 0, 0> <0, 10, 10> rotate 40*x translate <0, -0.3, 3.8> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-67.9, -3.7, -7.9> <-4.2, 0.8, 7.9> }
          #if (setting < 3)
            cylinder { 0.7*y, 2.5*y, 2.4 translate <-8, 0, 0> }
            cylinder { 0.7*y, 2.5*y, 2.4 translate <-16, 0, 0> }
            cylinder { 0.7*y, 2.5*y, 2.4 translate <-24, 0, 0> }
            cylinder { 0.7*y, 2.5*y, 2.4 translate <-32, 0, 0> }
          #else
            object { rounded_button() translate <-8, -2.3, 0> }
            object { rounded_button() translate <-16, -2.3, 0> }
            object { rounded_button() translate <-24, -2.3, 0> }
            object { rounded_button() translate <-32, -2.3, 0> }
          #end
        }
        box { <-70, 0, -10> <0, 10, 0> rotate -40*x translate <0, 0.8, -3.8> }
        box { <-70, 0, 0> <0, 10, 10> rotate 40*x translate <0, 0.8, 3.8> }
        box { <-1, -10, -10> <20, 10, 0> rotate 14*y translate <-67.9, 0, -3.8> }
        box { <-1, -10, 0> <20, 10, 10> rotate -14*y translate <-67.9, 0, 3.8> }
        difference {
          box { <-68, -4, -8> <-4, -0.3, 8> }
          box { <-70, 0, -10> <0, 10, 0> rotate -40*x translate <0, -0.3, -3.8> }
          box { <-70, 0, 0> <0, 10, 10> rotate 40*x translate <0, -0.3, 3.8> }
          #if (setting > 1)
            difference {
              merge {
                cylinder { -2.5*y, 0*y, 1.5 translate <-44, 0, 0> }
                cylinder { -2.5*y, 0*y, 1.5 translate <-36, 0, 0> }
                cylinder { -2.5*y, 0*y, 1.5 translate <-28, 0, 0> }
                cylinder { -2.5*y, 0*y, 1.5 translate <-20, 0, 0> }
                cylinder { -2.5*y, 0*y, 1.5 translate <-12, 0, 0> }
              }
              cylinder { -3*y, -0.5*y, 0.7 translate <-44, 0, 0> }
              cylinder { -3*y, -0.5*y, 0.7 translate <-36, 0, 0> }
              cylinder { -3*y, -0.5*y, 0.7 translate <-28, 0, 0> }
              cylinder { -3*y, -0.5*y, 0.7 translate <-20, 0, 0> }
              cylinder { -3*y, -0.5*y, 0.7 translate <-12, 0, 0> }
            }
            difference {
              cylinder { -2.5*y, 0*y, 3.8 }
              cylinder { -3*y, 0.5*y, 2.4 }
              box { <0.000001, -3, -4> <4, 0.5, 4> }
              translate <-48, 0, 0>
            }
            box { <-48.000001, -2.500001, -3.800001> <-4.5, 0, -2.400001> }
            box { <-48.000001, -2.500001, 2.400001> <-4.5, 0, 3.800001> }
            box { <-5.3, -2.500002, -3.800002> <-4.200005, 0, 3.800002> }
          #end
        }
      }
      difference {
        merge {
          box { <-4.200005, -2.500001, -3.500001> <0.000001, 2.500001, -1.500001> }
          box { <-4.200005, -2.500001, 3.500001> <0.000001, 2.500001, 1.500001> }
          cylinder { -3.5*z, 3.5*z, 2.5 }
        }
        box { <-10, 0, -4> <0, 10, 4> rotate -45*z translate <-4.2, 0.8, 0> }
        box { <-3, -3, -1.5> <3, 3, 1.5> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 0*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
      }
      cylinder { -3*z, -1.2*z, 1.5 }
      cylinder { 1.2*z, 3*z, 1.5 }
      texture { color_tex }
      bounded_by { box { <-68, -3.8, -8> <18.6, 2.6, 8> } }
    }
  #end
#end
#macro stwa_r2d2_body(color_tex)
  #if (setting = 0)
    cylinder { -12*y, 4*y, 7.8 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { -12*y, 4*y, 7.8 }
          intersection {
            merge {
              object { open_rounded_button() translate <-4, 0.9, -4> }
              object { open_rounded_button() translate <4, 0.9, -4> }
              object { open_rounded_button() translate <-4, 0.9, 4> }
              object { open_rounded_button() translate <4, 0.9, 4> }
            }
            cylinder { 0*y, 6*y, 7.800001 }
          }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <-4, 4, -4> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <4, 4, -4> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <-4, 4, 4> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <4, 4, 4> }
          #end
        }
        #if (setting > 1)
          box { <-0.85, -3, -3.1> <0.85, 5, 3.1> }
          difference {
            cylinder { -13*y, 3.1*y, 6.3 }
            cylinder { -7*x, 7*x, 3.5 }
          }
        #end
        cylinder { 7.3*x, 10*x, 3.1 }
        cylinder { -10*x, 7.3*x, 3.1 }
        cylinder { -10*x, 10*x, 2.4 }
      }
      #if (setting > 1)
        difference {
          cylinder { -15.2*y, -3.6*y, 3.2 }
          cylinder { -16*y, 0*y, 2.6 }
        }
        difference {
          box { <2.75, -15, -0.4> <7, -3.5, 0.4> }
          box { <0, -5, -1> <5, 0, 1> rotate 31.5*z translate <3, -15, 0> }
        }
        difference {
          box { <-7, -15, -0.4> <-2.75, -3.5, 0.4> }
          box { <-5, -5, -1> <0, 0, 1> rotate -31.5*z translate <-3, -15, 0> }
        }
        box { <-0.4, -12.000001, -7> <0.4, 3.5, -2.75> }
        box { <-0.4, -12.000001, 2.75> <0.4, 3.5, 7> }
      #end
      texture { color_tex }
      bounded_by { cylinder { -15.3*y, 5.8*y, 7.9 } }
    }
  #end
#end
#macro stwa_r2d2_head(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 9.8*y, 7.8 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { 0*y, 2*y, 7.8 }
          sphere { <0, 1.999999, 0> 7.799999 }
        }
        box { <-10, 9.3, -10> <10, 20, 10> }
        box { <-10, -20, -10> <10, -0.000001, 10> }
        box { <-6.39, -1, -6.39> <6.39, 2, 6.39> }
        sphere { <0, 1.999999, 0> 6.3 }
        cylinder { 0*y, 20*y, 1.600001 }
      }
      intersection {
        merge {
          box { <-0.5, 3.5, -6.5> <0.5, 10, -2.75> }
          box { <-0.5, 3.5, 2.75> <0.5, 10, 6.5> }
          box { <2.75, 3.5, -0.5> <6.5, 10, 0.5> }
          box { <-6.5, 3.5, -0.5> <-2.75, 10, 0.5> }
        }
        sphere { <0, 1.999999, 0> 6.4 }
      }
      object { ring() scale <1, 2, 1> }
      object { open_rounded_button() translate <0, 6.2, 0> }
      box { <-0.5, 8.3, -1.75> <0.5, 9.300001, 0> }
      box { <-0.5, 8.3, -1.75> <0.5, 9.300002, 0> rotate 120*y }
      box { <-0.5, 8.3, -1.75> <0.5, 9.300003, 0> rotate 240*y }
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 11.1*y, 7.9 } }
    }
  #end
#end
#macro stwa_r2d2_leg(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.7> <3.9, 22.3, 3.7> }
      cylinder { -11.9*x, 0*x, 2.5 translate <0, 18.6, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        torus { 2.249995, 0.3 rotate 90*z translate <-11.600005, 0, 0> }
        cylinder { -11.9*x, -3*x, 2.25 }
        cylinder { -4.9*x, -3*x, 3 }
        cylinder { -3.9*x, 0.4*x, 3.7 }
        difference {
          box { <-3.900001, -4, -3.700001> <0.400001, 0.000001, 3.700001> }
          box { <-4, -2, -2> <1, 0, 0> rotate -45*x translate <0, -3, -3.7> }
          box { <-4, -2, 0> <1, 0, 2> rotate 45*x translate <0, -3, 3.7> }
        }
        box { <-3.5, -11, -2.8> <0.400002, -3.5, -1.1> }
        box { <-3.5, -11, 1.1> <0.400002, -3.5, 2.8> }
        box { <-2, -11, -1.2> <-0.1, -3.5, 1.2> }
        difference {
          box { <-3.500001, -18.6, -7.9> <4.3, -10.8, 7.9> }
          box { <0, -2, -10> <5, 5, 10> rotate 45*z translate <2.4, -12.8, 0> }
          box { <0, 0, -10> <5, 5, 10> rotate -64*z translate <2.4, -12.8, 0> }
          box { <-4, -7.5, -5> <5, 0, 0> rotate 45*x translate <0, -12.8, -3.8> }
          box { <-4, 0, -5> <5, 5, 0> rotate 29*x translate <0, -12.8, -3.8> }
          box { <-4, -7.5, 0> <5, 0, 5> rotate -45*x translate <0, -12.8, 3.8> }
          box { <-4, 0, 0> <5, 5, 5> rotate -29*x translate <0, -12.8, 3.8> }
          #if (setting > 1)
            difference {
              box { <-2, -19.6, -6.4> <2.8, -10, 6.4> }
              box { <0, -2, -10> <5, 5, 10> rotate 45*z translate <2.4, -13.8, 0> }
              box { <-4, -12.5, -5> <5, 5, 0> rotate 45*x translate <0, -13.8, -3.8> }
              box { <-4, -12.5, 0> <5, 5, 5> rotate -45*x translate <0, -13.8, 3.8> }
              difference {
                cylinder { 0.000001*y, 10*y, 1.5 }
                cylinder { -1*y, 2*y, 0.7 }
                translate <0.4, -18.6, 0>
              }
            }
          #end
          }
        translate <0, 18.6, 0>
      }
      box { <-12, -0.5, -4> <-8.499999, 0.5, 4> translate <0, 18.6, 0> }
      cylinder { -4*z, 4*z, 0.5 translate <-8.5, 18.6, 0> }
      cylinder { -12*x, -3.9*x, 1.6 translate <0, 18.6, 0> }
      cylinder { -2.1*x, 1*x, 2.6 translate <0, 18.6, 0> }
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -8> <4.4, 22.4, 8> } }
    }
  #end
#end
#macro stwa_rightf_wing6_12(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <91.9, 3.1, 43.9> }
      box { <0, -1, 0> <100, 4, 100> rotate -18*y translate <-4, 0, 20> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <91.9, 3.1, 43.9> }
          #if (setting < 3)
            #local counter = 0;
            #while (counter < 12)
              cylinder { 3*y, 4.8*y, 2.4 translate <0+(counter*8), 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0+(counter*8), 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0+(counter*8), 0, 16> }
              #if (counter > 2)
                cylinder { 3*y, 4.8*y, 2.4 translate <0+(counter*8), 0, 24> }
              #end
              #if (counter > 5)
                cylinder { 3*y, 4.8*y, 2.4 translate <0+(counter*8), 0, 32> }
              #end
              #if (counter > 8)
                cylinder { 3*y, 4.8*y, 2.4 translate <0+(counter*8), 0, 40> }
              #end
              #local counter = counter + 1;
            #end
          #else
            #local counter = 0;
            #while (counter < 12)
              object { rounded_button() rotate 90*y translate <0+(counter*8), 0, 0> }
              object { rounded_button() rotate 90*y translate <0+(counter*8), 0, 8> }
              object { rounded_button() rotate 90*y translate <0+(counter*8), 0, 16> }
              #if (counter > 2)
                object { rounded_button() rotate 90*y translate <0+(counter*8), 0, 24> }
              #end
              #if (counter > 5)
                object { rounded_button() rotate 90*y translate <0+(counter*8), 0, 32> }
              #end
              #if (counter > 8)
                object { rounded_button() rotate 90*y translate <0+(counter*8), 0, 40> }
              #end
              #local counter = counter + 1;
            #end
          #end
        }
        box { <0, -1, 0> <100, 4, 100> rotate -18*y translate <-4, 0, 20> }
        box { <-2.4, -1, -4> <10.4, 2.000001, 4> rotate -18*y translate <8, 0, 24> }
        box { <-2.4, -1, -4> <10.4, 2.000001, 4> rotate -18*y translate <32, 0, 32> }
        box { <-2.4, -1, -4> <10.4, 2.000001, 4> rotate -18*y translate <56, 0, 40> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <90.4, 2, 42.4> }
            box { <0, -1, 0> <100, 4, 100> rotate -18*y translate <-4, 0, 18.5> }
          }
          #local counter = 0;
          #while (counter < 12)
            cylinder { 1*y, 4*y, 1.2 translate <0+(counter*8), 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <0+(counter*8), 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <0+(counter*8), 0, 16> }
            #if (counter > 2)
              cylinder { 1*y, 4*y, 1.2 translate <0+(counter*8), 0, 24> }
            #end
            #if (counter > 5)
              cylinder { 1*y, 4*y, 1.2 translate <0+(counter*8), 0, 32> }
            #end
            #if (counter > 8)
              cylinder { 1*y, 4*y, 1.2 translate <0+(counter*8), 0, 40> }
            #end
            #local counter = counter + 1;
          #end
        #end
      }
      box { <-0.5, 0.25, 18.4> <0.5, 2.1, 20.3> }
      box { <23.5, 0.25, 26.4> <24.5, 2.1, 28.3> }
      box { <47.5, 0.25, 34.4> <48.5, 2.1, 36.3> }
      box { <-2, 0.25, -0.5> <4, 2.1, 0.5> rotate 45*y translate <4, 0, 20> }
      box { <-2, 0.25, -0.5> <4, 2.1, 0.5> rotate 45*y translate <28, 0, 28> }
      box { <-2, 0.25, -0.5> <4, 2.1, 0.5> rotate 45*y translate <52, 0, 36> }
      #local counter = 0;
      #while ( counter < 11)
        object { ring() translate <4+(counter*8), 0, 4> }
        object { ring() translate <4+(counter*8), 0, 12> }
        #if (counter > 0)
          object { ring() translate <4+(counter*8), 0, 20> }
        #end
        #if (counter > 3)
          object { ring() translate <4+(counter*8), 0, 28> }
        #end
        #if (counter > 6)
          object { ring() translate <4+(counter*8), 0, 36> }
        #end
        #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <92, 4.9, 44> } }
    }
  #end
#end
#macro stwa_socket2_2(color_tex)
  #if (setting = 0)
    difference {
      merge {
        box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
        sphere { <4, 15, 4> 13.2 }
      }
      box { <-10, 19.1, -10> <20, 50, 20> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          #end
        }
        #if (setting > 1)
          object { ring() translate <4, 0, 4> }
        #end
        difference {
          sphere { <4, 15, 4> 13.2 }
          box { <-10, 19.1, -10> <20, 50, 20> }
          box { <0, 0, 0> <8, 2.000005, 8> }
        }
        difference {
          cylinder { 3*y, 10*y, 7.9 }
          torus { 7.9, 0.65 translate <0, 3.75, 0> }
          translate <4, 0, 4>
        }
      }
      difference {
        sphere { <4, 15, 4> 12.1 }
        box { <0, 0, 0> <8, 3.100005, 8> }
      }
      cylinder { 3.1*y, 20*y, 5.6 translate <4, 0, 4> }
      merge {
        cylinder { 0*z, 20*z, 0.55 }
        box { <-0.55, -0.000001, 0> <0.55, 20, 20> }
        translate <4, 10, 4>
      }
      merge {
        cylinder { 0*z, 20*z, 0.55 }
        box { <-0.55, -0.000001, 0> <0.55, 20, 20> }
        rotate 120*y translate <4, 10, 4>
      }
      merge {
        cylinder { 0*z, 20*z, 0.55 }
        box { <-0.55, -0.000001, 0> <0.55, 20, 20> }
        rotate 240*y translate <4, 10, 4>
      }
      texture { color_tex }
      bounded_by { box { <-9.3, -0.1, -9.3> <17.3, 19.2, 17.3> } }
    }
  #end
#end
#macro stwa_square_winglet(color_tex)
  #if (setting = 0)
    box { <-7.9, 2.6, -7.9> <7.9, 3.8, 7.9> texture { color_tex } }
  #else
    merge {
      box { <-7.9, 2.6, -7.9> <7.9, 3.8, 7.9> }
      box { <-0.5, 1.6, -1.6> <0.5, 2.7, 1.6> }
      box { <-2.6, -0.5, -1.6> <-1.6, 2.7, 1.6> }
      cylinder { -1.600001*z, 1.600001*z, 0.6 translate <-2, -0.5, 0> }
      box { <1.6, -0.5, -1.6> <2.6, 2.7, 1.6> }
      cylinder { -1.600001*z, 1.600001*z, 0.6 translate <2, -0.5, 0> }
      texture { color_tex }
      bounded_by { box { <-8, -1.2, -8> <8, 3.9, 8> } }
    }
  #end
#end
#macro stwa_tie_canopy(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 38.3, 27.9> }
      box { <4, 9.6, -11.9> <11.900001, 38.300001, 35.9> }
      box { <4, 38.2, -3.9> <11.900002, 47.9, 27.9> }
      cylinder { -11.900001*x, 4.000001*x, 23.95 translate <0, 23.95, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 38.3, 27.9> }
          cylinder { -3.900001*x, 4.000001*x, 23.95 translate <0, 23.95, 12> }
          intersection {
            sphere { <40, 23.95, 12> 50 }
            cylinder { -50*x, 3.899999*x, 23.9500001 translate <0, 23.95, 12> }
          }
          box { <4, 9.6, -11.9> <11.900001, 38.300001, 35.9> }
          box { <4, 38.2, -3.9> <11.900002, 47.9, 27.9> }
          box { <-3.900005, 40, 4.1> <4.000003, 47.900001, 19.9> }
          cylinder { -11.9*x, -3.8*x, 3.25 translate <0, 5.6, 0> }
          cylinder { -11.9*x, -3.8*x, 3.25 translate <0, 5.6, 24> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 26.4> }
          box { <5.6, 0, -10.4> <10.4, 11.9, -3.900001> }
          box { <5.6, 0, 27.900001> <10.4, 11.9, 34.4> }
        #end
        difference {
          merge {
            box { <-2.5, 3.100001, -2.400005> <12, 20, 26.400005> }
            box { <4, 3.1, -2.4> <12, 47, 26.4> }
            cylinder { -3.900002*x, 13*x, 22.45 translate <0, 23.95, 12> }
            intersection {
              sphere { <40, 23.95, 12> 48.5 }
              cylinder { -50*x, 12*x, 22.450001 translate <0, 23.95, 12> }
            }
            box { <5.5, 12.7, -10.4> <12, 37.4, 34.4> }
            cylinder { -10.4*x, 0*x, 1.75 translate <0, 5.6, 0> }
            cylinder { -10.4*x, 0*x, 1.75 translate <0, 5.6, 24> }
          }
          box { <-20, -1, -2.4> <20, 3.100004, 26.4> }
          box { <-20, -1, -20> <20, 12.700001, -2.400004> }
          box { <-20, -1, 26.400004> <20, 12.700001, 60> }
          box { <-20, 37.400001, -20> <20, 50, -2.400004> }
          box { <-20, 37.400001, 26.400004> <20, 50, 60> }
        }
        box { <-10, 38.3, -12> <12, 50, -3.900001> }
        box { <-10, 38.3, 27.900001> <12, 50, 36> }
        box { <-10, -1, -12> <4, 11.6, -3.900001> }
        box { <-10, -1, 27.900001> <4, 11.6, 36> }
      }
      #if (setting > 1)
        box { <7.5, 9.600001, -5.6> <8.5, 12, -3.6> }
        box { <7.5, 9.600001, 27.6> <8.5, 12, 29.6> }
      #end
      object { ring() translate <4, 0, 4> }
      object { ring() translate <4, 0, 12> }
      object { ring() translate <4, 0, 20> }
      object { open_rounded_button() rotate 90*z translate <-8.8, 5.6, 0> }
      object { open_rounded_button() rotate 90*z translate <-8.8, 5.6, 24> }
      object { open_rounded_button() translate <8, 35.2, -8> }
      object { open_rounded_button() translate <8, 35.2, 32> }
      object { open_rounded_button() translate <8, 44.8, 0> }
      object { open_rounded_button() translate <8, 44.8, 8> }
      object { open_rounded_button() translate <8, 44.8, 16> }
      object { open_rounded_button() translate <8, 44.8, 24> }
      object { open_rounded_button() translate <0, 44.8, 8> }
      object { open_rounded_button() translate <0, 44.8, 16> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65 0.65> translate <8, 38.3, -8> }
        object { llogo() scale <0.65, 0.65 0.65> translate <8, 38.3, 32> }
        object { llogo() scale <0.65, 0.65 0.65> translate <8, 47.9, 0> }
        object { llogo() scale <0.65, 0.65 0.65> translate <8, 47.9, 8> }
        object { llogo() scale <0.65, 0.65 0.65> translate <8, 47.9, 16> }
        object { llogo() scale <0.65, 0.65 0.65> translate <8, 47.9, 24> }
        object { llogo() scale <0.65, 0.65 0.65> translate <0, 47.9, 8> }
        object { llogo() scale <0.65, 0.65 0.65> translate <0, 47.9, 16> }
        object { llogo() scale <0.65, 0.65 0.65> rotate 90*z rotate -90*x translate <-11.9, 5.6, 0> }
        object { llogo() scale <0.65, 0.65 0.65> rotate 90*z rotate -90*x translate <-11.9, 5.6, 24> }
      #end
      texture { color_tex }
      bounded_by { box { <-13.7, -0.1, -12> <12, 49.7, 36> } }
    }
  #end
#end
#macro stwa_turret2_2(color_tex)
  #if (setting = 0)
    difference {
      sphere { <0, 0, 0> 12 }
      box { <-13, -13, -13> <13, 0, 13> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        sphere { <0, 0, 0> 12 }
        box { <-13, -13, -13> <13, 0, 13> }
        box { <-10, 11, -10> <10, 15, 10> }
        #if (setting > 1)
          cylinder { 9*y, 13*y, 2.5 translate <0, 0, -5.6> }
          cylinder { 9*y, 13*y, 2.5 translate <0, 0, 5.6> }
          cylinder { 9*y, 13*y, 2.5 translate <-5.6, 0, 0> }
          cylinder { 9*y, 13*y, 2.5 translate <5.6, 0, 0> }
        #end
        difference {
          cylinder { 4*y, 12*y, 2.95 }
          difference {
            merge {
              box { <-1, 5, -4> <1, 13, 4> }
              box { <-4, 5, -1> <4, 13, 1> }
            }
            cylinder { 4*y, 14*y, 2.4 }
          }
        }
        difference {
          sphere { <0, 0, 0> 10.8 }
          cylinder { 8*y, 12*y, 3.5 translate <0, 0, -5.6> }
          cylinder { 8*y, 12*y, 3.5 translate <0, 0, 5.6> }
          cylinder { 8*y, 12*y, 3.5 translate <-5.6, 0, 0> }
          cylinder { 8*y, 12*y, 3.5 translate <5.6, 0, 0> }
        }
      }
      difference {
        cylinder { 3*y, 8.9*y, 3.9 }
        cylinder { 2*y, 91*y, 2.950001 }
      }
      cylinder { 3*y, 4*y, 1.75 }
      torus { 1.75, 0.5 translate <0, 3.5, 0> }
      cone { 2*x, 0.5, 3*x, 0.5 scale <1, 1, 2> rotate 45*y translate <0, 3.5, 0> }
      cone { 2*x, 0.5, 3*x, 0.5 scale <1, 1, 2> rotate 135*y translate <0, 3.5, 0> }
      cone { 2*x, 0.5, 3*x, 0.5 scale <1, 1, 2> rotate 215*y translate <0, 3.5, 0> }
      cone { 2*x, 0.5, 3*x, 0.5 scale <1, 1, 2> rotate 305*y translate <0, 3.5, 0> }
      texture { color_tex }
      bounded_by { box { <-12.1, -0.1, -12.1> <12.1, 11.1, 12.1> } }
    }
  #end
#end
#macro stwa_winglaser(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.899999*x, 11.899999*x, 3.899999 translate <0, 5.599999, 0> }
      cylinder { 11.8*x, 52.2*x, 1.55 translate <0, 5.6, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
        difference {
          box { <-4, 5.6, -4> <12, 10, 4> }
          cylinder { -3.899999*x, 11.899999*x, 3.899999 translate <0, 5.599999, 0> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 5.600001, 2.4> }
          cylinder { -2.400001*x, 10.400001*x, 2.399999 translate <0, 5.6, 0> }
          cylinder { -5*x, -2*x, 2.6 translate <0, 5.6, 0> }
        #end
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 8.7*y, 1.5 }
          cylinder { -1*y, 2*y, 0.7 }
          translate <4, 0, 0>
        }
      #end
      box { <3.5, 2, -2.5> <4.5, 5.6, 2.5> }
      difference {
        cone { 11.8*x, 3.2, 19.9*x, 1.85 translate <0, 5.6, 0> }
        difference {
          box { <11.900001, 0, -2.4> <18.4, 7, 2.4> }
          box { <0, -1, -10> <10, 10, 0> rotate -10*y translate <11.9, 0, -2> }
          box { <0, -1, 0> <10, 10, 10> rotate 10*y translate <11.9, 0, 2> }
        }
      }
      cylinder { 19.8*x, 52.2*x, 1.55 translate <0, 5.6, 0> }
      difference {
        cylinder { 52.1*x, 59.9*x, 3.9 }
        cylinder { 60*x, 53*x, 2.6 }
        translate <0, 5.6, 0>
      }
      difference {
        cylinder { 0*y, 3*y, 3.2 }
        cylinder { -1*y, 4*y, 2.6 }
        translate <56, 0, 0>
      }
      object { open_rounded_button() translate <0, 6.4, 0> }
      object { open_rounded_button() translate <8, 6.4, 0> }
      object { open_rounded_button() translate <56, 6.4, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.5, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <56, 9.5, 0> }
      #end
      cylinder { 8*y, 9.500001*y, 2.4 }
      cylinder { 8*y, 9.500001*y, 2.4 translate <8, 0, 0> }
      cylinder { 8*y, 9.500001*y, 2.4 translate <56, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 11.3, 12> } }
    }
  #end
#end
#macro stwa_winglet(color_tex)
  #if (setting = 0)
    difference {
      box { <-9.000001, 2.599999, -4.2> <9.000001, 3.800001, 10.5> }
      box { <-20, 2, -10> <-0.8, 4, 20> rotate 29.8*y translate <-8.2, 0, -4.2> }
      box { <0.8, 2, -10> <20, 4, 20> rotate -29.8*y translate <8.2, 0, -4.2> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-9.000001, 2.599999, -4.2> <9.000001, 3.800001, 10.5> }
        box { <-20, 2, -10> <-0.8, 4, 20> rotate 29.8*y translate <-8.2, 0, -4.2> }
        box { <0.8, 2, -10> <20, 4, 20> rotate -29.8*y translate <8.2, 0, -4.2> }
      }
      box { <-8.200002, 2.599998, -5> <8.200002, 3.800002, -4> }
      cylinder { 2.6*y, 3.8*y, 0.8 translate <0, 0, 10.2> }
      cylinder { 2.6*y, 3.8*y, 0.8 translate <-8.2, 0, -4.2> }
      cylinder { 2.6*y, 3.8*y, 0.8 translate <8.2, 0, -4.2> }
      box { <-0.5, 1.6, -1.6> <0.5, 2.7, 1.6> }
      box { <-2.6, -0.5, -1.6> <-1.6, 2.7, 1.6> }
      cylinder { -1.600001*z, 1.600001*z, 0.6 translate <-2, -0.5, 0> }
      box { <1.6, -0.5, -1.6> <2.6, 2.7, 1.6> }
      cylinder { -1.600001*z, 1.600001*z, 0.6 translate <2, -0.5, 0> }
      texture { color_tex }
      bounded_by { box { <-9.1, -1.2, -5.1> <9.1, 3.9, 11.1> } }
    }
  #end
#end
#macro stwa_xwingengine(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 43.9*x, 11.9 translate <0, 13.6, 0> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          merge {
            box { <-3.9, 0, -3.9> <43.9, 3.1, 3.9> }
            cylinder { -3.900001*x, 43.900001*x, 11.9 translate <0, 13.6, 0> }
            box { <4.1, 10, -3.9> <35.9, 25.5, 3.9> }
          }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
            box { <29.6, -1, -2.4> <42.4, 2, 2.4> }
            box { <11.9, -1, -14> <28.1, 9.6, 14> }
            box { <11.9, 15.9, -14> <28.1, 40, 14> }
          #end
          cylinder { -4*x, 10.4*x, 10.4 translate <0, 13.6, 0> }
          cylinder { 29.6*x, 44*x, 10.4 translate <0, 13.6, 0> }
          box { <41.9, -2.5, -13> <44, 2.5, 13> rotate 45*x translate <0, 13.6, 0> }
          box { <41.900001, -2.5, -13> <44, 2.5, 13> rotate -45*x translate <0, 13.6, 0> }
          difference {
            box { <11.900001, 5, -10.3> <28.100001, 15, 10.3> }
            box { <11, 9.600001, -8.5> <13.4, 16, -7.5> }
            box { <11, 9.600001, 8.5> <13.4, 16, 7.5> }
            box { <26.6, 9.600001, -8.5> <29, 16, -7.5> }
            box { <26.6, 9.600001, 8.5> <29, 16, 7.5> }
            box { <-1, 9.600002, -0.5> <4, 16, 0.5> rotate -45*y translate <12, 0, -4> }
            box { <-1, 9.600002, -0.5> <4, 16, 0.5> rotate 45*y translate <12, 0, 4> }
            box { <-4, 9.600002, -0.5> <1, 16, 0.5> rotate 45*y translate <28, 0, -4> }
            box { <-4, 9.600002, -0.5> <1, 16, 0.5> rotate -45*y translate <28, 0, 4> }
            difference {
              cylinder { 9.600003*y, 16*y, 3.2 }
              cylinder { 9*y, 17*y, 2.6 }
              translate <20, 0, -4>
            }
            difference {
              cylinder { 9.600003*y, 16*y, 3.2 }
              cylinder { 9*y, 17*y, 2.6 }
              translate <20, 0, 4>
            }
          }
        }
        #if (setting > 1)
          object { pin(2) translate <4, 0, 0> }
          object { pin(2) translate <36, 0, 0> }
        #end
        object { open_rounded_button() translate <8, 22.4, 0> }
        object { open_rounded_button() translate <16, 12.8, -8> }
        object { open_rounded_button() translate <16, 12.8, 0> }
        object { open_rounded_button() translate <16, 12.8, 8> }
        object { open_rounded_button() translate <24, 12.8, -8> }
        object { open_rounded_button() translate <24, 12.8, 0> }
        object { open_rounded_button() translate <24, 12.8, 8> }
        object { open_rounded_button() translate <32, 22.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 16, -8> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 16, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 16, 8> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 16, -8> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 16, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 16, 8> }
        #end
        difference {
          cylinder { 29*x, 43.8*x, 3.2 }
          cylinder { 28*x, 44*x, 2.6 }
          translate <0, 17.6, -4>
        }
        difference {
          cylinder { 29*x, 43.8*x, 3.2 }
          cylinder { 28*x, 44*x, 2.6 }
          translate <0, 17.6, 4>
        }
        difference {
          cylinder { 29*x, 43.8*x, 3.2 }
          cylinder { 28*x, 44*x, 2.6 }
          translate <0, 9.6, -4>
        }
        difference {
          cylinder { 29*x, 43.8*x, 3.2 }
          cylinder { 28*x, 44*x, 2.6 }
          translate <0, 9.6, 4>
        }
        box { <29, 12.5, -4.5> <36.9, 14.5, -3.5> }
        box { <29, 12.5, 3.5> <36.9, 14.5, 4.5> }
        box { <29, 17.1, -1> <36.9, 18.1, 1> }
        box { <29, 9.1, -1> <36.9, 10.1, 1> }
        difference {
          cylinder { 1.5*x, 11.5*x, 7.75 }
          cylinder { 1*x, 12*x, 6.75 }
          translate <0, 13.6, 0>
        }
        difference {
          cylinder { 1.5*x, 11.5*x, 4.75 }
          cylinder { 1*x, 12*x, 3.75 }
          translate <0, 13.6, 0>
        }
        object { open_rounded_button() rotate 90*z translate <4.6, 9.6, -4> }
        object { open_rounded_button() rotate 90*z translate <4.6, 9.6, 4> }
        object { open_rounded_button() rotate 90*z translate <4.6, 17.6, -4> }
        object { open_rounded_button() rotate 90*z translate <4.6, 17.6, 4> }
        difference {
          cylinder { 1.599999*x, 11.5*x, 2.4 }
          cylinder { -1*x, 12*x, 1.600001 }
          translate <0, 9.6, -4>
        }
        difference {
          cylinder { 1.599999*x, 11.5*x, 2.4 }
          cylinder { -1*x, 12*x, 1.600001 }
          translate <0, 9.6, 4>
        }
        difference {
          cylinder { 1.599999*x, 11.5*x, 2.4 }
          cylinder { -1*x, 12*x, 1.600001 }
          translate <0, 17.6, -4>
        }
        difference {
          cylinder { 1.599999*x, 11.5*x, 2.4 }
          cylinder { -1*x, 12*x, 1.600001 }
          translate <0, 17.6, 4>
        }
        box { <1.500001, 13.1, -11> <11.5, 14.1, -7.5> }
        box { <1.500001, 13.1, 7.5> <11.5, 14.1, 11> }
      }
      cylinder { -4*x, 44*x, 1.600001 translate <0, 17.6, -4> }
      cylinder { -4*x, 44*x, 1.600001 translate <0, 17.6, 4> }
      cylinder { -1*x, 11.5*x, 1.600001 translate <0, 17.6, -4> }
      cylinder { -1*x, 11.5*x, 1.600001 translate <0, 17.6, 4> }
      cylinder { -1*x, 11.5*x, 1.600001 translate <0, 9.6, -4> }
      cylinder { -1*x, 11.5*x, 1.600001 translate <0, 9.6, 4> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -12> <44, 27.3, 12> } }
    }
  #end
#end
#macro sub_canopy(color_tex)
  #if (setting = 0)
    difference {
      sphere { <-22.350001, 0, 12.000001> 23.900001 }
      box { <-50, -50, -50> <50, -1.549999, 50> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -3.900001*z, 27.900001*z, 1.55 }
        box { <-10, -1.550001, -3.9> <0, 1.550001, 27.9> }
        difference {
          sphere { <-22.350001, 0, 12.000001> 23.900001 }
          box { <-50, -50, -50> <50, -1.549999, 50> }
        }
      }
      box { <-12, -2, -2.4> <-3.25, 0.000001, 26.4> }
      box { <-2, -2, -5> <2, 2, -2.45> }
      box { <-2, -2, 3.2> <2, 2, 4.8> }
      box { <-2, -2, 11.2> <2, 2.55, 12.8> }
      box { <-2, -2, 19.2> <2, 2, 20.8> }
      box { <-2, -2, 26.45> <2, 2, 29> }
      box { <-5, -3, -1> <0, 0, 1.7> }
      box { <-5, -3, 6.3> <0, 0, 9.7> }
      box { <-5, -3, 14.3> <0, 0, 17.7> }
      box { <-5, -3, 22.3> <0, 0, 25> }
      difference {
        sphere { <-22.350001, 0, 12.000001> 22.5 }
        box { <-1.5, -2, 4.800001> <0, 20, 6.300001> }
        box { <-1.5, -2, 9.700001> <0, 20, 11.200001> }
        box { <-1.5, -2, 12.800001> <0, 20, 14.300001> }
        box { <-1.5, -2, 17.700001> <0, 20, 19.200001> }
      }
      texture { color_tex }
      bounded_by { box { <-46.35, -1.65, -12> <1.65, 24, 36> } }
    }
  #end
#end
#macro sub_corner3_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 28.7, 19.9> }
      box { <30, -1, -50> <-30, 30, 0> rotate -45*y translate <3.9, 0, -3.9> }
      box { <-4, -30, -50> <28, 0, 0> rotate 42.75*x translate <0, 28.7, 11.9> }
      box { <0, -30, -4> <50, 0, 28> rotate 42.75*z translate <3.9, 28.7, 0> }
      box { <-50, -30, -50> <50, 30, 0> rotate 33*x rotate -45*y translate <3.9, 28.7, 11.9>}
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <19.9, 28.7, 19.9> }
        box { <30, -1, -50> <-30, 30, 0> rotate -45*y translate <3.9, 0, -3.9> }
        box { <-4, 25.5, 11.9> <4, 29, 20> }
        box { <-4, -30, -50> <28, 0, 0> rotate 42.75*x translate <0, 28.7, 11.9> }
        box { <0, -30, -4> <50, 0, 28> rotate 42.75*z translate <3.9, 28.7, 0> }
        box { <-50, -30, -50> <50, 30, 0> rotate 33*x rotate -45*y translate <3.9, 28.7, 11.9>}
        box { <-2.5, -1, -2> <2.5, 2.000001, 1.6> rotate -45*y translate <16, 0, 8> }
        box { <-2.5, -1, -2> <2.5, 2.000001, 1.6> rotate -45*y translate <8, 0, 0> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <18.4, 2, 18.4> }
            box { <30, -1, -50> <-30, 30, 0> rotate -45*y translate <2.9, 0, -2.9> }
            box { <-4, -2, 2.4> <5.6, 3, 20> }
            box { <-4, -2, 10.4> <13.6, 3, 20> }
          }
        #end
        difference {
          box { <-4, 3.1, -2.4> <18.4, 24.5, 20> }
          box { <-4, -30, -50> <28, 0, 0> rotate 42.75*x translate <0, 26.7, 11.9> }
          box { <30, -1, -50> <-30, 30, 0> rotate -45*y translate <2.9, 0, -2.9> }
          box { <0, -30, -4> <50, 0, 28> rotate 42.75*z translate <3.9, 26.7, 0> }
          box { <-50, -30, -50> <50, 30, 0> rotate 33*x rotate -45*y translate <3.9, 26.7, 11.9> }
        }
        box { <-4, -1, 3.9> <4.1, 4, 20> }
        box { <-4, -1, 11.9> <12.1, 4, 20> }
        difference {
          box { <-4.9, 21, 18.9> <-2.9, 29, 20.9> }
          cylinder { 30*y, 20*y, 1 translate <-2.9, 0, 18.9> }
        }
      }
      box { <2.5, 0.1, -3> <3.5, 2.1, 3> }
      box { <13, 0.1, 12.5> <19, 2.1, 13.5> }
      box { <5, 0.1, 3.5> <11, 2.1, 4.5> }
      box { <11.5, 0.1, 5> <12.5, 2.1, 10.5> }
      box { <7.5, 0.100001, 4> <8.5, 2.1, 5.5> }
      box { <10.5, 0.100001, 7.5> <12, 2.1, 8.5> }
      object { open_rounded_button() translate <0, 22.4, 16> }
      #if (setting > 3)
        object { llogo() rotate -90*y scale <0.65, 0.65, 0.65> translate <0, 25.5, 16> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 28.8, 20> } }
    }
  #end
#end
#macro sub_panel(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 28.7, 19.9> }
      box { <-4, -30, -50> <28, 0, 0> rotate 42.75*x translate <0, 28.7, 11.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 28.7, 19.9> }
        box { <-4, 25.5, 11.9> <28, 29, 20> }
        box { <-4, -30, -50> <28, 0, 0> rotate 42.75*x translate <0, 28.7, 11.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
        #end
        difference {
          box { <-2.4, 3.1, -2.4> <26.4, 24.5, 20> }
          box { <-4, -30, -50> <28, 0, 0> rotate 42.75*x translate <0, 26.7, 11.9> }
          box { <-0.5, 21.999999, 0> <0.5, 28, 13.5> }
          box { <23.5, 21.999999, 0> <24.5, 28, 13.5> }
          box { <2.5, 21.999999, 0> <3.5, 28, 20.5> }
          box { <4.5, 21.999999, 0> <5.5, 28, 20.5> }
          box { <18.5, 21.999999, 0> <19.5, 28, 20.5> }
          box { <20.5, 21.999999, 0> <21.5, 28, 20.5> }
        }
        box { <-4, -1, 3.9> <28, 4, 20> }
        difference {
          box { <-4.9, 21, 18.9> <-2.9, 29, 20.9> }
          cylinder { 30*y, 20*y, 1 translate <-2.9, 0, 18.9> }
        }
        difference {
          box { <26.9, 21, 18.9> <28.9, 29, 20.9> }
          cylinder { 30*y, 20*y, 1 translate <26.9, 0, 18.9> }
        }
        difference {
          box { <-4, 3.100001, -1> <28, 21, 20> }
          box { <-4, -30, -50> <28, 0, 0> rotate 42.75*x translate <0, 23.499999, 11.9> }
        }
        cylinder { -5*y, 5*y, 7.5 rotate -45*x translate <12, 18.5, 3> }
      }
      difference {
        cylinder { -1*y, 0.75*y, 9 }
        cylinder { -5*y, 5*y, 7.500001 }
        rotate -45*x
        translate <12, 18.5, 3>
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
      #end
      object { open_rounded_button() translate <0, 22.4, 16> }
      object { open_rounded_button() translate <8, 22.4, 16> }
      object { open_rounded_button() translate <16, 22.4, 16> }
      object { open_rounded_button() translate <24, 22.4, 16> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <0, 25.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <8, 25.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <16, 25.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <24, 25.5, 16> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 28.8, 20> } }
    }
  #end
#end
#macro sub_panel_glass(color_tex)
  #if (setting = 0)
    cylinder { -2*y, 3.5*y, 9 rotate -45*x translate <12, 18.5, 3> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -2*y, 0*y, 9 }
        difference {
          sphere { <0, -9, 0> 12.5 }
          box { <-30, -30, -30> <30, -0.000001, 30> }
        }
      }
      merge {
        cylinder { -3*y, -1*y, 6.5 }
        difference {
          sphere { <0, -9, 0> 11.125 }
          box { <-30, -30, -30> <30, -1.000001, 30> }
        }
      }
      texture { color_tex }
      rotate -45*x
      translate <12, 18.5, 3>
    }
  #end
#end
#macro sub_pivotclaw(color_tex)
  #if (setting = 0)
    merge {
      sphere { <0, 0, 0> 2.8 }
      cylinder { 0*x, -8*x, 1.55 }
      cylinder { -1.550001*y, 1.550001*y, 3 translate <-8, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        sphere { <0, 0, 0> 2.8 }
        cylinder { 0*x, -8*x, 1.55 }
        cylinder { -1.550001*y, 1.550001*y, 3 translate <-8, 0, 0> }
      }
      cylinder { -2*y, 2*y, 1.6 translate <-8, 0, 0> }
      cylinder { -2*y, 2*y, 0.5 scale <2, 1, 1> translate <-6.5, 0, 0> }
      box { <-12, -2, -1.5> <-8, 2, 1.5> }
      #if (setting > 1)
        cylinder { -5*y, 5*y, 0.9 translate <0.75, 0, 0> }
        box { <0.749999, 1, -0.900001> <5, 5, 0.900001> }
        box { <0.749999, -5, -0.900001> <5, -1, 0.900001> }
      #end
      texture { color_tex }
      bounded_by { box { <-11.1, -2.9, -2.9> <2.9, 2.9, 2.9> } }
    }
  #end
#end
#macro sub_propellor(color_tex)
  #if (setting = 0)
    merge {
      box { <-5, 3, -0.5> <5, 10, 0.5> rotate -63*y translate <2, 0, 0> }
      box { <-5, 3, -0.5> <5, 10, 0.5> rotate -63*y translate <2, 0, 0> rotate 120*x }
      box { <-5, 3, -0.5> <5, 10, 0.5> rotate -63*y translate <2, 0, 0> rotate 240*x }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { -3.9*x, 5.9*x, 3.9 }
          #local counter = 0;
          #while (counter < 3)
            merge {
              torus { 2, 0.5 rotate 90*x translate <-3, 10, 0> }
              torus { 2, 0.5 rotate 90*x translate <3, 10, 0.000001> }
              cylinder { -3.000005*x, 3.000005*x, 0.500001 translate <0, 12.000001, 0> }
              cylinder { -0.500003*z, 0.500003*z, 2.000003 translate <-3, 10, 0> }
              cylinder { -0.500002*z, 0.500002*z, 2.000003 translate <3, 10, 0> }
              box { <-2.500001, 9.999999, -0.500004> <2.500001, 12.000004, 0.500004> }
              difference {
                box { <-5.000005, 3, -0.500006> <5.000005, 10, 0.500006> }
                box { <-10, -15, -1> <-2.000005, 10, 1> rotate 27.5*z translate <-3, 10, 0> }
                box { <2.000005, -15, -1> <10, 10, 1> rotate -27.5*z translate <3, 10, 0> }
              }
              cylinder { -7*y, 0*y, 0.500004 translate <-2, 0, 0> rotate 27.5*z translate <-3, 10, 0> }
              cylinder { -7*y, 0*y, 0.500004 translate <2, 0, 0> rotate -27.5*z translate <3, 10, 0> }
              rotate -63*y
              translate <2, 0, 0>
              rotate (counter*120)*x
            }
            #local counter = counter + 1;
          #end
        }
        cylinder { -4*x, 3.9*x, 3 }
        object { axle_opening(3,1) translate <3, 0, 0> }
      }
      difference {
        merge {
          box { <-3.25, -3.1, -1> <2.9, 3.1, 1> }
          box { <-3.25, -1, -3.1> <2.9, 1, 3.1> }
        }
        cylinder { -4*x, 3*x, 2.5 }
      }
      texture { color_tex }
      bounded_by { box { <-4, -15, -15> <6, 15, 15> } }
    }
  #end
#end
#macro sub_screw_protector(color_tex)
  #if (setting = 0)
    merge {
      box { <11.899999, 1.6, -15.9> <35.9, 3.4, 23.9> }
      box { <11.899999, 3, 3> <35.900001, 22.5, 5> }
      box { <-3.9, 0, -3.9> <11.9, 6.3, 11.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 6.3, 11.9> }
          #if (setting < 3)
            cylinder { 6.2*y, 8*y, 2.4 }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 0> }
            cylinder { 6.2*y, 8*y, 2.4 translate <0, 0, 8> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() translate <0, 3.2, 0> }
            object { rounded_button() translate <8, 3.2, 0> }
            object { rounded_button() translate <0, 3.2, 8> }
            object { rounded_button() translate <8, 3.2, 8> }
          #end
          difference {
            box { <11.899999, 1.6, -15.9> <35.9, 3.4, 23.9> }
            box { <0, 0, -30> <40, 5, 0> rotate 40*y translate <11.9, 0, -3.9> }
            box { <0, 0, 0> <40, 5, 30> rotate -40*y translate <11.9, 0, 11.9> }
            difference {
              box { <0, 1, -14.4> <34.4, 2.6, 22.4> }
              box { <0, 0, -30> <40, 5, 0> rotate 40*y translate <11.9, 0, -2.4> }
              box { <0, 0, 0> <40, 5, 30> rotate -40*y translate <11.9, 0, 10.4> }
            }
          }
          difference {
            box { <11.899999, 3, 3> <35.900001, 22.5, 5> }
            box { <0, 0, 0> <40, 40, 10> rotate 40*z translate <11.9, 10.5, 0> }
          }
          difference {
            box { <11.899998, -13, -11.5> <35.900002, 18, 19.5> }
            box { <10, 0, -30> <40, 30, 30> rotate -45*x translate <0, 8.5, -11.5> }
            box { <10, 0, -30> <40, 30, 30> rotate 45*x translate <0, 8.5, 19.5> }
            box { <10, -30, -30> <40, 0, 30> rotate 45*x translate <0, -3.7, -11.5> }
            box { <10, -30, -30> <40, 0, 30> rotate -45*x translate <0, -3.7, 19.5> }
            box { <-50, 0, -30> <50, 50, 30> rotate 22.5*z translate <29.9, 18, 0> }
            box { <-50, -50, -30> <50, 0, 30> rotate -22.5*z translate <29.9, -13, 0> }
            box { <-50, -30, -50> <50, 30, 0> rotate 22.5*y translate <29.9, 0, -11.5> }
            box { <-50, -30, 0> <50, 30, 50> rotate -22.5*y translate <29.9, 0, 19.5> }
            box { <-50, -50, -50> <50, 0, 50> rotate -22.5*z rotate 45*x translate <29.9, -3.7, -11.5> }
            box { <-50, 0, -50> <50, 30, 50> rotate 22.5*z rotate -45*x translate <29.9, 8.5, -11.5> }
            box { <-50, -50, -50> <50, 0, 50> rotate -22.5*z rotate -45*x translate <29.9, -3.7, 19.5> }
            box { <-50, 0, -50> <0, 30, 50> rotate 22.5*z rotate 45*x translate <29.9, 8.5, 19.5> }
          }
        }
        box { <12.9, 5.7, -30> <27, 30, 0.9> }
        box { <12.9, 5.7, 7.1> <27, 30, 30> }
        box { <12.9, -30, -30> <27, -0.5, 0.9> }
        box { <12.9, -30, 7.1> <27, -0.5, 30> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <12, 5.3, 10.4> }
          cylinder { 4.2*y, 7.2*y, 1.2 }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 0> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <0, 0, 8> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 8> }
          object { axle_section(3) rotate 90*z translate <4, 4, 4> }
        #end
        cylinder { 29.899995*x, 36*x, 14 translate <0, 2.5, 4> }
        difference {
          cone { 12.9*x, 6.75, 29.900001*x, 14.000001 translate <0, 2.5, 4> }
          box { <12.5, 5, 3.5> <23, 20, 4.5> }
          box { <12.5, -20, 3.5> <23, 0, 4.5> }
          box { <12.5, 2, -20> <23, 3, 1.5> }
          box { <12.5, 2, 6.5> <23, 3, 20> }
          difference {
            cylinder { 12.5*x, 24*x, 3 }
            cylinder { 22*x, 25*x, 2.25 }
            box { <12, -0.9, -2.25> <25, 0.9, 2.25> }
            box { <12, -2.25, -0.9> <25, 2.25, 0.9> }
            translate <0, 2.5, 4>
          }
        }
      }
      #if (setting > 1)
        box { <3.5, 2, -3> <4.5, 5.5, 1.5> }
        box { <3.5, 2, 6.5> <4.5, 5.5, 11> }
        difference {
          cylinder { 0*y, 5.4*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <4, 0, 4>
        }
        box { <10.4, 0, -0.5> <11.91, 5.4, 0.5> }
        box { <10.4, 0, 7.5> <11.91, 5.4, 8.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -13.1, -16> <36, 22.6, 24> } }
    }
  #end
#end
#macro suitcase_closed(color_tex)
  #if (setting = 0)
    merge {
      box { <-8, 0, -3> <8, 10, 3> }
      cylinder { -3.9*x, 3.9*x, 1.5 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-7.000001, 0.499999, -2.000002> <7.000001, 10.000001, 2.000002> }
          box { <-7.000002, 1.499998, -3.000001> <7.000002, 9.000002, 3.000001> }
          box { <-8.000002, 1.499997, -2.000003> <8.000002, 9.000003, 2.000003> }
          sphere { <-7, 1.5, -2> 1 }
          sphere { <-7, 1.5, 2> 1 }
          sphere { <7, 1.5, -2> 1 }
          sphere { <7, 1.5, 2> 1 }
          sphere { <-7, 9, -2> 1 }
          sphere { <-7, 9, 2> 1 }
          sphere { <7, 9, -2> 1 }
          sphere { <7, 9, 2> 1 }
          cylinder { 1.499999*y, 9.000001*y, 1.000001 translate <-7, 0, -2> }
          cylinder { 1.499999*y, 9.000001*y, 1.000001 translate <7, 0, -2> }
          cylinder { 1.499999*y, 9.000001*y, 1.000001 translate <-7, 0, 2> }
          cylinder { 1.499999*y, 9.000001*y, 1.000001 translate <7, 0, 2> }
          cylinder { -7.000001*x, 7.000001*x, 1.000001 translate <0, 1.5, -2> }
          cylinder { -7.000001*x, 7.000001*x, 1.000001 translate <0, 1.5, 2> }
          cylinder { -7.000001*x, 7.000001*x, 1.000001 translate <0, 9, -2> }
          cylinder { -7.000001*x, 7.000001*x, 1.000001 translate <0, 9, 2> }
          cylinder { -2.000001*z, 2.000001*z, 1.000001 translate <-7, 1.5, 0> }
          cylinder { -2.000001*z, 2.000001*z, 1.000001 translate <7, 1.5, 0> }
          cylinder { -2.000001*z, 2.000001*z, 1.000001 translate <-7, 9, 0> }
          cylinder { -2.000001*z, 2.000001*z, 1.000001 translate <7, 9, 0> }
          cylinder { -4*x, 4*x, 0.6 scale <1, 0.75, 1> translate <0, 0.5, 0> }
          cylinder { 0*z, 2*z, 0.45 translate <-6.5, 0.5, 0> }
          cylinder { 0*z, 2*z, 0.45 translate <6.5, 0.5, 0> }
          cylinder { -2*z, 0*z, 0.45 translate <-5.5, 0.5, 0> }
          cylinder { -2*z, 0*z, 0.45 translate <5.5, 0.5, 0> }
          box { <-4, 8, -1> <-2.5, 11.500001, 1> }
          box { <2.5, 8, -1> <4, 11.500001, 1> }
          difference {
            cylinder { -3.9*x, 3.9*x, 1.5 }
            box { <-4, -2, -2> <4, 0, 2> }
            translate <0, 11.5, 0>
          }
        }
        box { <-7, 1.5, -2> <7, 9, 2> }
        box { <-10, -5, -0.05> <10, 15, 0.05> }
        box { <-10, 0, -10> <0, 10, 10> rotate -12.5*z translate <-3.9, 10, 0> }
        box { <0, 0, -10> <10, 10, 10> rotate 12.5*z translate <3.9, 10, 0> }
      }
      box { <-7, 1.500001, -1.9> <-6.4, 8.999999, 2.1> }
      box { <6.4, 1.500001, -1.9> <7, 8.999999, 2.1> }
      texture { color_tex }
      bounded_by { box { <-8.1, -0.1, -3.1> <8.1, 13.1, 3.1> } }
    }
  #end
#end
#macro support1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 24.5> }
      cylinder { 24.45*z, 27.9*z, 3.2 translate <4, 2.3, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 24.5> }
          box { <0.75, 3, 23.5> <7.75, 4, 24.500001> }
          cylinder { 24.499999*z, 27.9*z, 3.2 translate <4, 2.300001, 0> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
          #end
        }
        box { <-10, -1, 0> <0, 7, 21.1> rotate 14*y translate <-3.9, 0, 4> }
        box { <0, -1, 0> <10, 7, 21.1> rotate -14*y translate <11.9, 0, 4> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 25.9*z, 28*z, 2.6 translate <4, 2.300001, 0> }
          cylinder { 23.999999*z, 26*z, 1.6 translate <4, 2.300002, 0> }
          sphere { <4, 2.3, 24> 1.600001 }
          difference {
            box { <-1.9, -1, 4> <9.9, 7, 24.500001> }
            box { <-2, 1, 3> <10, 2.1, 25> }
            box { <-2, -2, 11> <10, 4, 13> }
            box { <-2, -2, 19> <10, 4, 21> }
            box { <-10, -2, 0> <0, 4, 21.1> rotate 14*y translate <-1.9, 0, 4> }
            box { <0, -2, 0> <10, 4, 21.1> rotate -14*y translate <9.9, 0, 4> }
          }
          cylinder { -1*y, 4*y, 1.5 translate <2, 0, 5.5> }
          cylinder { -1*y, 4*y, 2 translate <3, 0, 9> }
          cylinder { -1*y, 4*y, 1.5 translate <6, 0, 5.5> }
          cylinder { -1*y, 4*y, 2 translate <5, 0, 9> }
          box { <2, -1, 4.000001> <6, 4, 7> }
          box { <0, -1, 0> <4, 4, 4> rotate 7*y translate <0.5, 0, 5.499999> }
          box { <-4, -1, 0> <0, 4, 4> rotate -7*y translate <7.5, 0, 5.499999> }
          box { <3, -1, 9> <5, 4, 10.999999> }
          cylinder { -1*y, 4*y, 1 translate <3.5, 0, 18> }
          cylinder { -1*y, 4*y, 1 translate <4.5, 0, 18> }
          cylinder { -1*y, 4*y, 1 translate <3, 0, 14> }
          cylinder { -1*y, 4*y, 1 translate <5, 0, 14> }
          box { <3.5, -1, 17> <4.5, 4, 19.000001> }
          box { <0, -1, 0> <2, 4, 4> rotate 7*y translate <2, 0, 13.999999> }
          box { <-2, -1, 0> <0, 4, 4> rotate -7*y translate <6, 0, 13.999999> }
          box { <3, -1, 13.000001> <5, 4, 15> }
          box { <0.5, 0, -1> <8, 1.4, 0> rotate 45*x translate <0, 3.1, 23.5> }
        #end
      }
      object { pin(1) translate <4, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.9, -4> <12, 5.5, 28> } }
    }
  #end
#end
#macro support2_2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 3.1*y, 7.8 }
      cylinder { 2.8*y, 18.2*y, 2.4 }
      cylinder { 18.1*y, 19.1*y, 7.8 }
      translate <4, 0, 4>
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          object { open_rounded_button() translate <0, 16, 0> }
          object { open_rounded_button() translate <8, 16, 0> }
          object { open_rounded_button() translate <0, 16, 8> }
          object { open_rounded_button() translate <8, 16, 8> }
          cylinder { 18.1*y, 19.1*y, 7.8 translate <4, 0, 4> }
          cylinder { 0*y, 3.1*y, 7.8 translate <4, 0, 4> }
          cylinder { 2.8*y, 9.5*y, 3.75 translate <4, 0, 4> }
          cylinder { 9*y, 18.2*y, 2.4 translate <4, 0, 4> }
        }
        box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
        cylinder { -1*y, 20*y, 1.6 translate <4, 0, 4> }
        box { <1.75, -1, 3.1> <6.25, 4, 4.9> }
        box { <3.1, -1, 1.75> <4.9, 4, 6.25> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 20.9, 12> } }
    }
  #end
#end
#macro support2_2_closed_girder(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 75.9, 11.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 75.9, 11.9> }
          difference {
            merge {
              box { <-0.35, 3.20001, -4> <8.35, 72.70001, 3.65> }
              box { <-0.35, 3.20001, 4.35> <8.35, 72.70001, 12> }
              box { <-2.75, 3.2, -4> <10.75, 72.7, 1.85> }
              box { <-2.75, 3.2, 6.15> <10.75, 72.7, 12> }
            }
            cylinder { -1*y, 8.8*y, 3.45 translate <4, 0, 4> }
            box { <-10, -0.55, -4> <1, 0.55, 12> rotate 45*z translate <2.2, 15.55, 0> }
            box { <-1, -0.55, -4> <10, 0.55, 12> rotate -45*z translate <5.8, 15.55, 0> }
            box { <-10, -0.55, -4> <1, 0.55, 12> rotate -45*z translate <2.2, 23.45, 0> }
            box { <-1, -0.55, -4> <10, 0.55, 12> rotate 45*z translate <5.8, 23.45, 0> }
            box { <-10, -0.55, -4> <1, 0.55, 12> rotate 45*z translate <2.2, 53.55, 0> }
            box { <-1, -0.55, -4> <10, 0.55, 12> rotate -45*z translate <5.8, 53.55, 0> }
            box { <-10, -0.55, -4> <1, 0.55, 12> rotate -45*z translate <2.2, 61.45, 0> }
            box { <-1, -0.55, -4> <10, 0.55, 12> rotate 45*z translate <5.8, 61.45, 0> }
          }
          box { <2.20001, 72, -4> <5.80001, 74.70001, 3.65001> }
          box { <2.20001, 72, 4.35001> <5.80001, 74.70001, 12> }
          cylinder { 72.7*y, 76*y, 1.60001 }
          cylinder { 72.7*y, 76*y, 1.60001 translate <8, 0, 0> }
          cylinder { 72.7*y, 76*y, 1.60001 translate <0, 0, 8> }
          cylinder { 72.7*y, 76*y, 1.60001 translate <8, 0, 8> }
          #if (setting > 1)
            cylinder { -1*y, 2*y, 2.4 }
            cylinder { -1*y, 2*y, 2.4 translate <8, 0, 0> }
            cylinder { -1*y, 2*y, 2.4 translate <0, 0, 8> }
            cylinder { -1*y, 2*y, 2.4 translate <8, 0, 8> }
            object { axle_opening(9,2) rotate 90*z translate <4, -1, 4> }
            box { <-2.4, -1, -2.4> <0, 2.00001, 0> }
            box { <8, -1, -2.4> <10.4, 2.00001, 0> }
            box { <-2.4, -1, 8> <0, 2.00001, 10.4> }
            box { <8, -1, 8> <10.4, 2.00001, 10.4> }
            box { <0, -1, 0> <8, 2.00002, 8> }
            sphere { <0, 0, 0> 1 scale <0.25, 1, 1> translate <-3.95, 4.2, -2.45> }
            sphere { <0, 0, 0> 1 scale <0.25, 1, 1> translate <-3.95, 4.2, 10.45> }
            sphere { <0, 0, 0> 1 scale <0.25, 1, 1> translate <11.95, 4.2, -2.45> }
            sphere { <0, 0, 0> 1 scale <0.25, 1, 1> translate <11.95, 4.2, 10.45> }
            sphere { <0, 0, 0> 1 scale <0.25, 1, 1> translate <-3.95, 71.7, -2.45> }
            sphere { <0, 0, 0> 1 scale <0.25, 1, 1> translate <-3.95, 71.7, 10.45> }
            sphere { <0, 0, 0> 1 scale <0.25, 1, 1> translate <11.95, 71.7, -2.45> }
            sphere { <0, 0, 0> 1 scale <0.25, 1, 1> translate <11.95, 71.7, 10.45> }
            cylinder { -4*z, -2.45*z, 1 scale <0.25, 1, 1> translate <-3.95, 4.2, 0> }
            cylinder { -4*z, -2.45*z, 1 scale <0.25, 1, 1> translate <11.95, 4.2, 0> }
            cylinder { -4*z, -2.45*z, 1 scale <0.25, 1, 1> translate <-3.95, 71.7, 0> }
            cylinder { -4*z, -2.45*z, 1 scale <0.25, 1, 1> translate <11.95, 71.7, 0> }
            cylinder { 12*z, 10.45*z, 1 scale <0.25, 1, 1> translate <-3.95, 4.2, 0> }
            cylinder { 12*z, 10.45*z, 1 scale <0.25, 1, 1> translate <11.95, 4.2, 0> }
            cylinder { 12*z, 10.45*z, 1 scale <0.25, 1, 1> translate <-3.95, 71.7, 0> }
            cylinder { 12*z, 10.45*z, 1 scale <0.25, 1, 1> translate <11.95, 71.7, 0> }
            cylinder { -4*x, -2.45*x, 1 scale <1, 1, 0.25> translate <0, 4.2, -3.95> }
            cylinder { -4*x, -2.45*x, 1 scale <1, 1, 0.25> translate <0, 4.2, 11.95> }
            cylinder { -4*x, -2.45*x, 1 scale <1, 1, 0.25> translate <0, 71.7, -3.95> }
            cylinder { -4*x, -2.45*x, 1 scale <1, 1, 0.25> translate <0, 71.7, 11.95> }
            cylinder { 12*x, 10.45*x, 1 scale <1, 1, 0.25> translate <0, 4.2, -3.95> }
            cylinder { 12*x, 10.45*x, 1 scale <1, 1, 0.25> translate <0, 4.2, 11.95> }
            cylinder { 12*x, 10.45*x, 1 scale <1, 1, 0.25> translate <0, 71.7, -3.95> }
            cylinder { 12*x, 10.45*x, 1 scale <1, 1, 0.25> translate <0, 71.7, 11.95> }
          #end
        }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 72.7, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 72.7, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 72.7, 8> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 72.7, 8> }
        #end
        object { open_rounded_button() translate <0, 72.8, 0> }
        object { open_rounded_button() translate <8, 72.8, 0> }
        object { open_rounded_button() translate <0, 72.8, 8> }
        object { open_rounded_button() translate <8, 72.8, 8> }
        cone { 75.89995*y, 2.6, 77.7*y, 1.55 translate <4, 0, 4> }
        torus { 1.05, 0.5 translate <4, 81.9, 4> }
        cylinder { 77*y, 81.9*y, 1.55 translate <4, 0, 4> }
        cylinder { 82.4*y, 80*y, 1.05 translate <4, 0, 4> }
        box { <1.1, 3, -3.90001> <2.20002, 75, 11.90001> }
        box { <5.79998, 3, -3.90001> <6.9, 75, 11.90001> }
        difference {
          cylinder { -3.90004*z, 11.90004*z, 3.5 }
          box { <-1.80007, -4, -4> <1.80007, 4, 12> }
          translate <4, 38.4, 0>
        }
        box { <-3, 37.85, -3.90003> <1, 38.95, 11.90003> }
        box { <7, 37.85, -3.90003> <11, 38.95, 11.90003> }
        box { <2, 14.45, -1.90003> <6, 15.55, 9.90003> }
        box { <2, 23.45, -1.90003> <6, 24.55, 9.90003> }
        box { <2, 52.45, -1.90003> <6, 53.55, 9.90003> }
        box { <2, 61.45, -1.90003> <6, 62.55, 9.905003> }
      }
      box { <-4, -1, 2.2> <-1.95, 76, 5.8> }
      box { <2.2, -1, -4> <5.8, 76, -1.95> }
      box { <9.95, -1, 2.2> <12, 76, 5.8> }
      box { <2.2, -1, 9.95> <5.8, 76, 12> }
      cylinder { -4*z, 3.65002*z, 2.4 translate <4, 38.4, 0> }
      cylinder { 4.35002*z, 12*z, 2.4 translate <4, 38.4, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 82.5, 12> } }
    }
  #end
#end
#macro support2_2_girder(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
      box { <-3.9, 86.4, -3.9> <11.9, 95.5, 11.9> }
      cylinder { 9.4*y, 86.5*y, 1.4 translate <-2.45, 0, -2.45> }
      cylinder { 9.4*y, 86.5*y, 1.4 translate <-2.45, 0, 10.45> }
      cylinder { 9.4*y, 86.5*y, 1.4 translate <10.45, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { 9.4*y, 86.5*y, 1.4 translate <-2.45, 0, -2.45> }
          cylinder { 9.4*y, 86.5*y, 1.4 translate <-2.45, 0, 10.45> }
        }
        box { <-1.05, 9, -4> <4, 87, 12> }
        box { <-4, 9, -1.05> <4, 87, 9.05> }
      }
      cylinder { 9.4*y, 86.5*y, 1.4 translate <10.45, 0, 4> }
      difference {
        box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
        box { <-2.4, -1, -2.4> <10.4, 8.6, 10.4> }
      }
      difference {
        cylinder { 0.000002*y, 8.7*y, 3.2 }
        cylinder { -1*y, 2*y, 2.6 }
        object { axle_opening(10,2) rotate 90*z }
        translate <4, 0, 4>
      }
      difference {
        box { <-3.9, 86.4, -3.9> <11.9, 95.5, 11.9> }
        box { <-2.4, 87.3, -2.9> <10.4, 96, 10.9> }
      }
      object { open_rounded_button() translate <0, 92.4, 0> }
      object { open_rounded_button() translate <8, 92.4, 0> }
      object { open_rounded_button() translate <0, 92.4, 8> }
      object { open_rounded_button() translate <8, 92.4, 8> }
      difference {
        cylinder { 87.2*y, 95.5*y, 2.400001 }
        cylinder { 87*y, 98*y, 1.600001 }
      }
      difference {
        cylinder { 87.2*y, 95.5*y, 2.400001 }
        cylinder { 87*y, 98*y, 1.600001 }
        translate <8, 0, 0>
      }
      difference {
        cylinder { 87.2*y, 95.5*y, 2.400001 }
        cylinder { 87*y, 98*y, 1.600001 }
        translate <0, 0, 8>
      }
      difference {
        cylinder { 87.2*y, 95.5*y, 2.400001 }
        cylinder { 87*y, 98*y, 1.600001 }
        translate <8, 0, 8>
      }
      difference {
        box { <-3, 9.4, -3.4> <10.2, 86.5, 11.4> }
        box { <-2, 9, -20> <20, 87, 0> rotate -27.5*y translate <-2.45, 0, -3.9> }
        box { <-2, 9, 0> <20, 87, 20> rotate 27.5*y translate <-2.45, 0, 11.9> }
        box { <-20, 0, -4> <0, 20, 12> rotate -37.5*z translate <-2.9, 72, 0> }
        difference {
          box { <-4, 41, -4> <20, 70, 12> }
          box { <0, -20, -5> <20, 0, 13> rotate 37.5*z translate <-2.9, 70, 0> }
          box { <0, 0, -5> <20, 20, 13> rotate -37.5*z translate <-2.9, 41, 0> }
        }
        difference {
          box { <-4, 10, -4> <20, 39, 12> }
          box { <0, -20, -5> <20, 0, 13> rotate 37.5*z translate <-2.9, 39, 0> }
          box { <0, 0, -5> <20, 20, 13> rotate -37.5*z translate <-2.9, 10, 0> }
        }
        difference {
          box { <-1.05, 25, -4> <20, 54, 12> }
          box { <-20, -20, -5> <0, 0, 13> rotate 37.5*z translate <-2.9, 40.8, 0> }
          box { <-20, 0, -5> <0, 20, 13> rotate -37.5*z translate <-2.9, 39.2, 0> }
        }
        difference {
          box { <-1.05, 56, -4> <20, 85, 12> }
          box { <-20, -20, -5> <0, 0, 13> rotate 37.5*z translate <-2.9, 71.8, 0> }
          box { <-20, 0, -5> <0, 20, 13> rotate -37.5*z translate <-2.9, 70.2, 0> }
        }
        difference {
          box { <-1.05, 9.500005, -4> <20, 23, 12> }
          box { <-20, 0, -5> <0, 20, 13> rotate -37.5*z translate <-2.9, 8.2, 0> }
        }
        #if (setting > 1)
          difference {
            box { <-3, 10, -1> <10.2, 86, 9> }
            box { <-2, 9, -20> <20, 87, 0> rotate -27.5*y translate <-2.45, 0, -1> }
            box { <-2, 9, 0> <20, 87, 20> rotate 27.5*y translate <-2.45, 0, 9> }
            box { <0.3, 0, -5> <20, 20, 13> rotate -37.5*z translate <-2.9, 72, 0> }
            box { <0.3, -20, -5> <20, 0, 13> rotate 37.5*z translate <-2.9, 70, 0> }
            box { <0.3, 0, -5> <20, 20, 13> rotate -37.5*z translate <-2.9, 41, 0> }
            box { <0.3, -20, -5> <20, 0, 13> rotate 37.5*z translate <-2.9, 39, 0> }
            box { <0.3, 0, -5> <20, 20, 13> rotate -37.5*z translate <-2.9, 10, 0> }
            box { <-4, 67.5, -1> <12, 74.5, 9> }
            box { <-4, 36.5, -1> <12, 43.5, 9> }
            box { <-4, 0, -1> <12, 12.5, 9> }
            texture { color_tex normal { bumping } }
          }
        #end
      }
      #if (setting > 1)
        box { <-2.5, 4.5, 3.65> <1.1, 8.7, 4.35> }
        box { <6.9, 4.5, 3.65> <10.5, 8.7, 4.35> }
        box { <3.65, 4.5, -2.5> <4.35, 8.7, 1.1> }
        box { <3.65, 4.5, 6.9> <4.35, 8.7, 10.5> }
      #end
      bounded_by { box { <-4, -0.1, -4> <12, 97.3, 12> } }
      texture { color_tex }
    }
  #end
#end
#macro support_wheels(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -2.75*z, -3.9*z, 2.5 translate <0, -4.95, 0> }
      cylinder { 10.75*z, 11.9*z, 2.5 translate <0, -4.95, 0> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { -2.75*z, -3.9*z, 2.5 translate <0, -4.95, 0> }
      cylinder { 10.75*z, 11.9*z, 2.5 translate <0, -4.95, 0> }
      box { <-1.749999, -4.5, -3.400001> <1.749999, 0, -2.35> }
      cylinder { -3.4*z, -2.350001*z, 1.75 }
      box { <-1.749999, -2.5, -0.55> <1.749999, 0, 0.55> }
      cylinder { -0.550001*z, 0.550001*z, 1.74 }
      box { <-1.749999, -2.5, 7.45> <1.749999, 0, 8.55> }
      cylinder { 7.450001*z, 8.550001*z, 1.74 }
      box { <-1.749999, -4.5, 11.400001> <1.749999, 0, 10.35> }
      cylinder { 11.4*z, 10.350001*z, 1.75 }
      cylinder { 10.350002*z, 11.400002*z, 1.75 translate <0, -4.5, 0> }
      cylinder { -2.350002*z, -3.400002*z, 1.75 translate <0, -4.5, 0> }
      box { <-1.75, -3, -3.4> <1.75, -2, 11.4> }
      box { <-0.5, 0, 0> <0.5, 1.5, -4> rotate 30*x translate <0, -5, 10.5> }
      box { <-0.5, 0, 4> <0.5, 1.5, 0> rotate -30*x translate <0, -5, -2.5> }
      texture { color_tex }
      bounded_by { box { <-3, -7.5, -4> <3, 1.75, 12> } }
    }
  #end
#end
#macro suspension_wheelbase2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-7.8, -6.3, 0.1> <15.8, -3.2, 7.9> }
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      cylinder { 22.7*x, -14.7*x, 1.5 translate <0, -5.35, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-7.8, -6.3, 0.1> <15.8, -3.2, 7.9> }
          intersection {
            box { <-8.900001, -6.3, 0.099998> <16.900001, -4.1, 7.900002> }
            union {
              box { <0, -6.299999, -4> <2, -4.200001, 0> rotate -25*y translate <-8.9, 0, 2> }
              box { <0, -6.299999, 0> <2, -4.200001, 4> rotate 25*y translate <-8.9, 0, 6> }
              box { <-2, -6.299999, -4> <0, -4.200001, 0> rotate 25*y translate <16.9, 0, 2> }
              box { <-2, -6.299999, 0> <0, -4.200001, 4> rotate -25*y translate <16.9, 0, 6> }
            }
          }
          difference {
            cylinder { -8.9*x, -3.8*x, 1.9 translate <0, -5.35, 4> }
            box { <-7.800001, -8, 0> <0, 0, 3.3> }
            box { <-7.800001, -8, 4.7> <0, 0, 8> }
          }
          difference {
            cylinder { 11.8*x, 16.9*x, 1.9 translate <0, -5.35, 4> }
            box { <8, -8, 0> <15.800001, 0, 3.3> }
            box { <8, -8, 4.7> < 15.800001, 0, 8> }
          }
          difference {
            box { <-3.9, -7.25, -0.9> <11.9, -3.200001, 8.9> }
            #if (setting > 1)
              difference {
                box { <-2.6, -8, 2.4> <10.6, -6.25, 5.6> }
                cylinder { -8*y, -6*y, 1 translate <-1, 0, 4> }
                cylinder { -8*y, -6*y, 1 translate <4, 0, 4> }
                cylinder { -8*y, -6*y, 1 translate <9, 0, 4> }
              }
            #end
          }
          difference {
            merge {
              cylinder { -8.8*x, -14.7*x, 1.5 }
              cylinder { -14.2*x, -14.799991*x, 1.75 }
            }
            box { <-15.8, -3, -0.4> <-12.299999, 3, 0.4> }
            cylinder { -3*y, 3*y, 0.4 translate <-12.3, 0, 0> }
            translate <0, -5.35, 4>
          }
          difference {
            merge {
              cylinder { 16.8*x, 22.7*x, 1.5 }
              cylinder { 22.2*x, 22.799991*x, 1.75 }
            }
            cylinder { -3*y, 3*y, 0.4 translate <20.3, 0, 0> }
            box { <20.299999, -3, -0.4> <23.8, 3, 0.4> }
            translate <0, -5.35, 4>
          }
        }
        box { <-1.8, -5.25, 2.4> <9.8, 10, 5.6> }
        cylinder { -5.3*y, 0*y, 2.65 translate <-4.5, 0, 4> }
        cylinder { -5.3*y, 0*y, 2.65 translate <12.5, 0, 4> }
        #if (setting > 1)
          cylinder { -7*y, -4.8*y, 0.65 translate <-6.8, 0, 1.2> }
          cylinder { -7*y, -4.8*y, 0.65 translate <-6.8, 0, 6.8> }
          cylinder { -7*y, -4.8*y, 0.65 translate <14.8, 0, 1.2> }
          cylinder { -7*y, -4.8*y, 0.65 translate <14.8, 0, 6.8> }
        #end
        cylinder { -8*y, -2*y, 0.85 translate <-1.75, 0, 0.9> }
        cylinder { -8*y, -2*y, 0.85 translate <-1.75, 0, 7.1> }
        cylinder { -8*y, -2*y, 0.85 translate <9.75, 0, 0.9> }
        cylinder { -8*y, -2*y, 0.85 translate <9.75, 0, 7.1> }
        box { <-1.750001, -8, 0.05> <9.750001, -2, 1.75> }
        box { <-1.750001, -8, 6.25> <9.750001, -2, 7.95> }
      }
      difference {
        merge {
          box { <-1.65, -6.6, 0.25> <9.65, 0.1, 1.55> }
          cylinder { -6.6*y, 0.1*y, 0.65 translate <-1.65, 0, 0.9> }
          cylinder { -6.6*y, 0.1*y, 0.65 translate <9.65, 0, 0.9> }
          sphere { <-1.65, -6.6, 0.9> 0.65 }
          sphere { <9.65, -6.6, 0.9> 0.65 }
          cylinder { -1.65*x, 9.65*x, 0.65 translate <0, -6.6, 0.9> }
          box { <-1.65, -6.6, 6.45> <9.65, 0.1, 7.75> }
          cylinder { -6.6*y, 0.1*y, 0.65 translate <-1.65, 0, 7.1> }
          cylinder { -6.6*y, 0.1*y, 0.65 translate <9.65, 0, 7.1> }
          sphere { <-1.65, -6.6, 7.1> 0.65 }
          sphere { <9.65, -6.6, 7.1> 0.65 }
          cylinder { -1.65*x, 9.65*x, 0.65 translate <0, -6.6, 7.1> }
        }
        box { <2, -4.15, 0> <6, 1, 8> }
        cylinder { -8*y, 0*y, 0.5 translate <2, 0, 1.55> }
        cylinder { -8*y, 0*y, 0.5 translate <6, 0, 1.55> }
        cylinder { -8*y, 0*y, 0.5 translate <2, 0, 6.45> }
        cylinder { -8*y, 0*y, 0.5 translate <6, 0, 6.45> }
        box { <1.999999, -8, 1.05> <6.000001, 0, 6.95> }
      }
      cylinder { -5.35*y, -2.2*y, 0.5 translate <4, 0, 4> }
      difference {
        box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
        box { <-2.9, 1, -2.9> <10.9, 4, 10.9> }
        cone { -0.000002*y, 2.849999, 2.600002*y, 2.149999 translate <-4.5, 0, 4> }
        cone { -0.000002*y, 2.849999, 2.600002*y, 2.149999 translate <12.5, 0, 4> }
        cylinder { -1*y, 1*y, 1.1 translate <4, 0, 4> }
      }
      difference {
        merge {
          box { <-1.6, -2.5, -0.3> <1.6, 2.7, 0.3> }
          box { <-0.3, -2.500001, -1.6> <0.3, 2.7, 1.6> }
        }
        box { <0, 0, -1> <5, 5, 1> rotate -45*z translate <0.3, -2.5, 0> }
        box { <0, 0, -1> <5, 5, 1> rotate -45*z translate <0.3, -2.5, 0> rotate 90*y }
        box { <0, 0, -1> <5, 5, 1> rotate -45*z translate <0.3, -2.5, 0> rotate 180*y }
        box { <0, 0, -1> <5, 5, 1> rotate -45*z translate <0.3, -2.5, 0> rotate 270*y }
        translate <-4.5, 0, 4>
      }
      difference {
        merge {
          box { <-1.6, -2.5, -0.3> <1.6, 2.7, 0.3> }
          box { <-0.3, -2.500001, -1.6> <0.3, 2.7, 1.6> }
        }
        box { <0, 0, -1> <5, 5, 1> rotate -45*z translate <0.3, -2.5, 0> }
        box { <0, 0, -1> <5, 5, 1> rotate -45*z translate <0.3, -2.5, 0> rotate 90*y }
        box { <0, 0, -1> <5, 5, 1> rotate -45*z translate <0.3, -2.5, 0> rotate 180*y }
        box { <0, 0, -1> <5, 5, 1> rotate -45*z translate <0.3, -2.5, 0> rotate 270*y }
        translate <12.5, 0, 4>
      }
      cylinder { 0.9*y, 3.1*y, 1.5 translate <4, 0, 4> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 1, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 1, 8> }
      #end
      object { open_rounded_button() }
      object { open_rounded_button() translate <8, 0, 0> }
      object { open_rounded_button() translate <0, 0, 8> }
      object { open_rounded_button() translate <8, 0, 8> }
      difference {
        cylinder { 0.9*y, 3.1*y, 2.400001 }
        cylinder { 0*y, 5*y, 1.600001 }
      }
      difference {
        cylinder { 0.9*y, 3.1*y, 2.400001 }
        cylinder { 0*y, 5*y, 1.600001 }
        translate <0, 0, 8>
      }
      difference {
        cylinder { 0.9*y, 3.1*y, 2.400001 }
        cylinder { 0*y, 5*y, 1.600001 }
        translate <8, 0, 8>
      }
      difference {
        cylinder { 0.9*y, 3.1*y, 2.400001 }
        cylinder { 0*y, 5*y, 1.600001 }
        translate <8, 0, 0>
      }
      difference {
        cone { 0.000001*y, 3.35, 3.099999*y, 2.65 }
        cone { -0.000001*y, 2.85, 2.6*y, 2.15 }
        box { <-5, -5, -5> <0, 5, 5> rotate -12.5*z translate <-2.9, 0, 0> }
        translate <-4.5, 0, 4> 
      }
      difference {
        cone { 0.000001*y, 3.35, 3.099999*y, 2.65 }
        cone { -0.000001*y, 2.85, 2.6*y, 2.15 }
        box { <-5, -5, -5> <0, 5, 5> rotate -12.5*z translate <-2.9, 0, 0> }
        rotate 180*y
        translate <12.5, 0, 4>
      }
      #local counter = 0;
      #while (counter < 7)
        difference {
          torus { 1.9, 0.1 }
          box { <-3, -1, 0.000001> <3, 1, 3> }
          translate <2, 0, 0>
          texture { chrome_tex }
          rotate 10*x
          translate <-6.55, 0.5-(counter*0.9), 4>
        }
        difference {
          torus { 1.9, 0.1 }
          box { <-3, -1, -0.000001> <3, 1, -3> }
          translate <2, 0, 0>
          texture { chrome_tex }
          rotate -10*x
          translate <-6.55, 0.5-(counter*0.9), 4>
        }
        difference {
          torus { 1.9, 0.1 }
          box { <-3, -1, 0.000001> <3, 1, 3> }
          translate <2, 0, 0>
          texture { chrome_tex }
          rotate 10*x
          translate <10.55, 0.5-(counter*0.9), 4>
        }
        difference {
          torus { 1.9, 0.1 }
          box { <-3, -1, -0.000001> <3, 1, -3> }
          translate <2, 0, 0>
          texture { chrome_tex }
          rotate -10*x
          translate <10.55, 0.5-(counter*0.9), 4>
        }
      #local counter = counter + 1;
      #end
      bounded_by { box { <-14.9, -7.35, -4> <22.9, 4.9, 12> } }
      texture { color_tex }
    }
  #end
#end
#macro sweeper_brush(color_tex)
  #if (setting = 0)
    cylinder { -9*z, 9*z, 12 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { -9*z, 9*z, 4 }
        cylinder { -10*z, 10*z, 2.35 }
      }
      #local brush_start = -8.525;
      #while (brush_start < 9)
        #local brush_counter = 0;
        #while (brush_counter < 24)
          cylinder { 3.5*y, 12*y, 0.25 rotate (brush_counter*15)*z translate <0, 0, brush_start> }
          #if (brush_start < 7)
            cylinder { 3.5*y, 12*y, 0.25 rotate (7.5+(brush_counter*15))*z translate <0, 0, brush_start+1.55> }
          #end
          #local brush_counter = brush_counter + 1;
        #end
        #local brush_start = brush_start + 3.1;
      #end
      texture { color_tex }
      bounded_by { cylinder { -9.1*z, 9.1*z, 12.1 } }
    }
  #end
#end
#macro swivelbase1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, -5.6, -3.9> <3.9, 3.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-3.9, -5.6, -3.9> <3.9, 3.1, 11.9> }
        difference {
          box { <-5, 0, -5> <0, 5, 13> }
          cylinder { -4*z, 12*z, 3 }
        }
        difference {
          box { <0, 0, -6> <2, 2, 14> }
          cylinder { -5*z, 13*z, 0.5 }
          translate <-2, 1.75, 0>
        }
        #if (setting > 1)
          box { <-2.4, -6, -2.4> <2.4, -3.5, 3.4> }
          box { <-2.4, -6, 4.6> <2.4, -3.5, 10.4> }
        #end
        box { <-5, -3.8, -5> <-2.999999, 4, 13> }
        box { <-4, -2.3, -2.4> <3, 4, 10.4> }
        cylinder { -5*z, -1.8*z, 1.6 }
        cylinder { 9.8*z, 13*z, 1.6 }
        box { <-1.25, 0, -5> <1.25, 4, 13> rotate -10*z }
        box { <-1.25, 0, -5> <1.25, 4, 13> rotate 10*z }
      }
      #if (setting > 1)
        box { <-0.5, -5.600001, 2.6> <0.5, -3.5, 5.4> }
        box { <-1, -2.5, 3> <1, 0.000001, 5> }
        cylinder { 3*z, 5*z, 1 }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -5.7, -4> <4, 3.2, 12> } }
    }
  #end
#end
#macro swiveltop1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, -6.1, -3.9> <3.9, 0, 11.9> texture { color_tex } }
  #else
    merge {
      object { open_rounded_button() translate <0, -3.1, 0> }
      object { open_rounded_button() translate <0, -3.1, 8> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 0, 8> }
      #end
      box { <-3.9, -0.8, -3.9> <3.9, 0, 11.9> }
      difference {
        box { <-0.6, -5.9, -2.499998> <0.6, 0.000001, 10.499998> }
        #if (setting > 1)
          box { <-1, -7, 3> <1, -3, 5> }
        #end
      }
      cylinder { -2.5*z, -1.6*z, 2.100001 translate <0, -4, 0> }
      cylinder { 9.6*z, 10.5*z, 2.100001 translate <0, -4, 0> }
      box { <-2.1, -4, -2.499999> <2.1, 0.000002, -1.600001> }
      box { <-2.1, -4, 9.600001> <2.1, 0.000002, 10.499999> }
      #if (setting > 1)
        difference {
          cylinder { -3.9*z, -2.4*z, 1.5 translate <0, -4, 0> }
          cylinder { -5*z, -2*z, 0.7 translate <0, -4, 0> }
        }
        difference {
          cylinder { 10.4*z, 11.9*z, 1.5 translate <0, -4, 0> }
          cylinder { 10*z, 13*z, 0.7 translate <0, -4, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -6.2, -4> <4, 1.9, 12> } }
    }
  #end
#end
#macro swiveltop2_2(color_tex)
  #if (setting = 0)
    box { <-3.9, -6.1, -3.9> <11.9, 0, 11.9> texture { color_tex } }
  #else
    merge {
      object { open_rounded_button() translate <0, -3.1, 0> }
      object { open_rounded_button() translate <0, -3.1, 8> }
      object { open_rounded_button() translate <8, -3.1, 0> }
      object { open_rounded_button() translate <8, -3.1, 8> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <0, 0, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 0, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 0, 8> }
      #end
      box { <-3.9, -0.8, -3.9> <11.9, 0, 11.9> }
      difference {
        box { <-0.6, -5.9, -2.499998> <0.6, 0.000001, 10.499998> }
        #if (setting > 1)
          box { <-1, -7, 1> <1, -1.9, 7> }
        #end
      }
      cylinder { -2.5*z, -1.6*z, 2.100001 translate <0, -4, 0> }
      cylinder { 9.6*z, 10.5*z, 2.100001 translate <0, -4, 0> }
      box { <-2.1, -4, -2.499999> <2.1, 0.000002, -1.600001> }
      box { <-2.1, -4, 9.600001> <2.1, 0.000002, 10.499999> }
      cylinder { 2*z, 3*z, 2.100001 translate <0, -4, 0> }
      cylinder { 5*z, 6*z, 2.100001 translate <0, -4, 0> }
      box { <-2.1, -4, 1.999999> <2.1, 0.000002, 3.000001> }
      box { <-2.1, -4, 4.999999> <2.1, 0.000002, 6.000001> }
      #if (setting > 1)
        difference {
          cylinder { -3.9*z, -2.4*z, 1.5 translate <0, -4, 0> }
          cylinder { -5*z, -2*z, 0.7 translate <0, -4, 0> }
        }
        difference {
          cylinder { 10.4*z, 11.9*z, 1.5 translate <0, -4, 0> }
          cylinder { 10*z, 13*z, 0.7 translate <0, -4, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -6.2, -4> <12, 1.9, 12> } }
    }
  #end
#end
#macro swivel_dh_fence1_3(color_tex, fence_angle)
  #if (setting = 0)
    union {
      box { <-3.9, 0, -3.9> <19.9, 3.1, 3.9> }
      merge {
        cylinder { 3.2*y, 19.1*y, 3.9 }
        box { <3.5, 3.19999, -1.2> <19.9, 19.1, 1.2> }
        rotate fence_angle*y
      }
      texture { color_tex }
    }
  #else
    union {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <19.9, 3.1, 3.9> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <18.4, 2, 2.4> }
          #end
        }
        difference {
          merge {
            cylinder { 3*y, 5.2*y, 2.6 }
            cylinder { 5.1*y, 13.1*y, 2.4 }
          }
          cylinder { 3.100001*y, 14*y, 1.45 }
        }
        #if (setting > 1)
          object { pin(1) translate <4, 0, 0> }
          object { pin(1) translate <12, 0, 0> }
        #end
        bounded_by { box { <-4, -0.1, -4> <20, 13.2, 4> } }
      }
      merge {
        difference {
          merge {
            cylinder { 3.2*y, 19.1*y, 3.9 }
            #if (setting < 3)
              cylinder { 19*y, 20.8*y, 2.4 }
            #else
              object { rounded_button() rotate 90*y translate <0, 16, 0> }
            #end
          }
          cylinder { 0*y, 18.2*y, 2.7 }
          cylinder { 17*y, 20*y, 1.2 }
        }
        box { <15.2, 19, -0.65> <18.4, 20.8, 0.65> }
        difference {
          box { <3.8, 3.19999, -1.2> <19.89999, 19.10001, 1.2> }
          box { <4.4, 4.6, -2> <18.4, 17.6, 2> }
        }
        intersection {
          merge {
            box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate 45*z translate <8, 11.1, 0.00001> }
            box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate 45*z translate <16, 11.1, 0.00002> }
            box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate 45*z translate <24, 11.1, 0.00003> }
            box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate -45*z translate <8, 11.1, 0.00005> }
            box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate -45*z translate <16, 11.1, 0.00006> }
            box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate -45*z translate <24, 11.1, 0.00007> }
          }
          box { <4, 4.2, -1.3> <19, 18, 1.3> }
        }
        bounded_by { box { <-4, 3.1, -4> <20, 20.9, 4> } }
        rotate fence_angle*y
      }
      texture { color_tex }
    }
  #end
#end
#macro swivel_dh_fence1_4(color_tex, fence_angle)
  #if (setting = 0)
    union {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
      merge {
        cylinder { 3.2*y, 19.1*y, 3.9 }
        box { <3.5, 3.199999, -1.2> <27.9, 19.1, 1.2> }
        rotate fence_angle*y
      }
      texture { color_tex }
    }
  #else
    union {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          #end
        }
        difference {
          merge {
            cylinder { 3*y, 5.2*y, 2.6 }
            cylinder { 5.1*y, 13.1*y, 2.4 }
          }
          cylinder { 3.100001*y, 14*y, 1.45 }
        }
        #if (setting > 1)
          object { pin(1) translate <4, 0, 0> }
          object { pin(1) translate <12, 0, 0> }
          object { pin(1) translate <20, 0, 0> }
        #end
        bounded_by { box { <-4, -0.1, -4> <28, 13.2, 4> } }
      }
      merge {
        difference {
          merge {
            cylinder { 3.2*y, 19.1*y, 3.9 }
            #if (setting < 3)
              cylinder { 19*y, 20.8*y, 2.4 }
            #else
              object { rounded_button() rotate 90*y translate <0, 16, 0> }
            #end
          }
          cylinder { 0*y, 18.2*y, 2.7 }
          cylinder { 17*y, 20*y, 1.2 }
        }
        box { <23.2, 19, -0.65> <26.4, 20.8, 0.65> }
        difference {
          box { <3.8, 3.199999, -1.2> <27.899999, 19.100001, 1.2> }
          box { <4.4, 4.6, -2> <26.4, 17.6, 2> }
        }
        intersection {
          merge {
            box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate 45*z translate <8, 11.1, 0.000001> }
            box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate 45*z translate <16, 11.1, 0.000002> }
            box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate 45*z translate <24, 11.1, 0.000003> }
            box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate -45*z translate <8, 11.1, 0.000005> }
            box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate -45*z translate <16, 11.1, 0.000006> }
            box { <-10, -0.4, -1.2> <10, 0.4, 1.2> rotate -45*z translate <24, 11.1, 0.000007> }
          }
          box { <4, 4.2, -1.3> <27, 18, 1.3> }
        }
        bounded_by { box { <-4, 3.1, -4> <28, 20.9, 4> } }
        rotate fence_angle*y
      }
      texture { color_tex }
    }
  #end
#end
#macro swivel_spoiler(color_tex)
  #if (setting = 0)
    box { <-23.9, 4, -11.1> <23.9, 6.7, 11.1> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-23.9, 4, -7.9> <23.9, 5.2, 7.9> }
        difference {
          box { <-23.5, 2, -7.900001> <23.5, 4.1, 7.900001> }
          box { <-24, 1, -6.4> <24, 5, 6.4> }
          box { <-10, -10, -10> <0, 0, 10> rotate -45*z translate <-21.4, 2, 0> }
          box { <0, -10, -10> <10, 0, 10> rotate 45*z translate <21.4, 2, 0> }
        }
        difference {
          box { <-23.900002, 4, -11.1> <23.900002, 6.7, -6.5> }
          box { <-24, 0, 0> <24, 10, 10> rotate 13.5*x translate <0, 6.7, -11.1> }
          box { <-24, -10, 0> <24, 0, 10> rotate 13.5*x translate <0, 4.8, -11.1> }
        }
        difference {
          box { <-23.900002, 4, 6.5> <23.900002, 6.7, 11.1> }
          box { <-24, 0, -10> <24, 10, 0> rotate -13.5*x translate <0, 6.7, 11.1> }
          box { <-24, -10, -10> <24, 0, 0> rotate -13.5*x translate <0, 4.8, 11.1> }
        }
        #if (setting > 1)
          object { ring() translate <-16, 2, 0> }
          object { ring() translate <16, 2, 0> }
        #end
        difference {
          box { <-8, -2.5, -7.900003> <8, 4.1, 7.900003> }
          box { <-9, -3, -6.400001> <9, 4.2, 6.400001> }
          cylinder { -10*z, 10*z, 1.6 }
          box { <-10, -10, -10> <0, 0, 10> rotate 36.75*z translate <8, 2, 0> }
          box { <0, -10, -10> <10, 0, 10> rotate -36.75*z translate <-8, 2, 0> }
          difference {
            box { <-2.6, -5, -8> <2.6, 0, 8> }
            box { <-3, -1.25, -9> <-1.65, 1, 9> }
            box { <1.65, -1.25, -9> <3, 1, 9> }
            cylinder { -9*z, 9*z, 0.75 translate <-2.2, -1.25, 0> }
            cylinder { -9*z, 9*z, 0.75 translate <2.2, -1.25, 0> }
          }
        }
        difference {
          box { <-8, -2.5, -0.6> <8, 4.1, 0.6> }
          box { <-10, -10, -1> <0, 0, 1> rotate 28*z translate <-8, 4, 0> }
          box { <0, -10, -1> <10, 0, 1> rotate -28*z translate <8, 4, 0> }
          box { <-10, -10, -1> <0, 0, 1> rotate -20*z translate <-1.7, -2.5, 0> }
          box { <0, -10, -1> <10, 0, 1> rotate 20*z translate <1.7, -2.5, 0> }
          box { <-1, -5, -1> <1, -0.1, 1> }
          box { <0, -3, -1> <1, 0, 1> rotate -15*z translate <-1, -0.1, 0> }
          box { <-1, -3, -1> <0, 0, 1> rotate 15*z translate <1, -0.1, 0> }
        }
        box { <-0.5, 2.5, -5.4> <0.5, 4.1, -6.5> }
        box { <-0.5, 2.5, 5.4> <0.5, 4.1, 6.5> }
      }
      difference {
        box { <-8, -0.5, -9> <8, 3.5, 9> }
        box { <-1.5, -1, -10> <1.5, 4, 10> }
        box { <-9, -1, -7.5> <9, 4, 7.5> }
        box { <-10, -10, -10> <2, 0, 10> rotate 36.75*z translate <7.7, 3, 0> }
        box { <-2, -10, -10> <10, 0, 10> rotate -36.75*z translate <-7.7, 3, 0> }
        cylinder { -10*z, 10*z, 2.65 }
      }
      cylinder { -10*z, -5*z, 0.6 translate <0, 1.6, 0> }
      cylinder { 5*z, 10*z, 0.6 translate <0, 1.6, 0> }
      texture { color_tex }
      bounded_by { box { <-24, -2.1, -11.2> <24, 6.8, 11.2> } }
    }
  #end
#end
#macro sword_1(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -2*y, 26.25*y, 1.5 }
      cylinder { -5.5*x, 5.5*x, 1.5 translate <0, 4, 0> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { 4*y, 24*y, 0.5 scale <4.5, 1, 1> }
      sphere { <0, 0, 0> 0.5 scale <4.5, 4.5, 1> translate <0, 23.999999, 0> }
      sphere { <0, -3.5, 0> 1.5 }
      cylinder { -2*y, 2.75*y, 1.5 }
      sphere { <0, 2.75, 0> 1.5 }
      sphere { <-0.75, 4, 0> 1.5 }
      sphere { <0.75, 4, 0> 1.5 }
      sphere { <0, 0, 0> 1.5 scale <0.66666667, 1, 1> translate <-4.5, 4, 0> }
      sphere { <0, 0, 0> 1.5 scale <0.66666667, 1, 1> translate <4.5, 4, 0> }
      cylinder { -3.5*x, -0.75*x, 1.5 translate <0, 4, 0> }
      cylinder { 3.5*x, 0.75*x, 1.5 translate <0, 4, 0> }
      texture { color_tex }
      bounded_by { box { <-5.5, -5.1, -1.6> <5.5, 28.6, 1.6> } }
    }
  #end
#end
#macro sword_2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -2*y, 35.25*y, 1.5 }
      cylinder { -6.5*x, 6.5*x, 1.5 translate <0, 4, 0> }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { 4*y, 33*y, 0.5 scale <4.5, 1, 1> }
      sphere { <0, 0, 0> 0.5 scale <4.5, 4.5, 1> translate <0, 32.999999, 0> }
      difference {
        box { <-5, 2, -1.5> <5, 5, 1.5> }
        box { <0, 1, -5> <10, 6, 0> rotate -12.5*y translate <0, 0, -1.5> }
        box { <0, 1, 0> <10, 6, 5> rotate 12.5*y translate <0, 0, 1.5> }
        box { <-10, 1, -5> <0, 6, 0> rotate 12.5*y translate <0, 0, -1.5> }
        box { <-10, 1, 0> <0, 6, 5> rotate -12.5*y translate <0, 0, 1.5> }
        box { <-10, -5, -2> <0, 0, 2> rotate -15*z translate <0, 2, 0> }
        box { <0, -5, -2> <10, 0, 2> rotate 15*z translate <0, 2, 0> }
      }
      difference {
        cylinder { -1.6*z, 1.6*z, 2.3 }
        cylinder { -2*z, -0.6*z, 1.6 }
        cylinder { 2*z, 0.6*z, 1.6 }
        translate <0, -7, 0>
      }
      cylinder { 1*y, 3*y, 1.5 }
      cylinder { 2*y, -5.5*y, 1.3 }
      cylinder { 0.6*y, 0.2*y, 1.5 }
      cylinder { -0.6*y, -0.2*y, 1.5 }
      cylinder { -1.4*y, -1*y, 1.5 }
      cylinder { -2.2*y, -1.8*y, 1.5 }
      cylinder { -3*y, -2.6*y, 1.5 }
      cylinder { -3.8*y, -3.4*y, 1.5 }
      cylinder { -5.5*y, -4.2*y, 1.5 }
      sphere { <-5, 4, 0> 1.5 }
      sphere { <5, 4, 0> 1.5 }
      texture { color_tex }
      bounded_by { box { <-6.6, -9.4, -1.7> <6.6, 37.6, 1.7> } }
    }
  #end
#end
#macro s_propellor2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, -3.2, -3.9> <11.9, 3.1, 11.9> }
      cylinder { 11*z, 17.9*z, 1.5 translate <4, 1.1, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, -3.2, -3.9> <11.9, 3.1, 11.9> }
            box { <-4, -4, -5> <12, 0, 4.1> }
          }
          cylinder { 11*z, 13*z, 2 translate <4, 1.099999, 0> }
          box { <-4, 0.000001, -2> <0, 2, 0> rotate -25*y translate <2, 0, 13> }
          box { <0, 0.000001, -2> <4, 2, 0> rotate 25*y translate <6, 0, 13> }
          box { <2, 0.000002, 11.899998> <6, 2.000001, 13.000001> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
          #end
          difference {
            merge {
              cylinder { 12*z, 17.9*z, 1.5 }
              cylinder { 17.4*z, 17.999991*z, 1.75 }
            }
            box { <-0.4, -3, 15.399999> <0.4, 3, 19> }
            cylinder { -3*y, 3*y, 0.4 translate <0, 0, 15.4> }
            translate <4, 1.1, 0>
          }
        }
        #if (setting > 1)
          box { <-2.4, -4, -2.4> <10.4, 2, 4.09999> }
          box { <-2.4, -4, 5.6> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 2.1*y, 1.5 translate <4, 0, 0> }
        cylinder { -3.2*y, 2.1*y, 1.5 translate <4, 0, 8> }
        box { <-0.5, 0.00001, 2.4> <0.5, 2.1, 4.5> }
        box { <7.5, 0.00001, 2.4> <8.5, 2.1, 4.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -3.3, -4> <12, 4.9, 18> } }
    }
  #end
#end
#macro s_saucer_bottomsection(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <75.9, 25.5, 75.9> }
      box { <-50, -1, 75.9> <50, 30, 150> rotate 45*y }
      texture { color_tex }
    }
  #else
    #if (setting > 1) difference { #end
      merge {
        difference {
          box { <-3.9, 0, -3.9> <75.9, 25.5, 75.9> }
          box { <40, 22.300001, -4> <80, 26, 4.1> }
          box { <-4, 22.300001, 40> <4.1, 26, 80> }
          difference {
            box { <71, 0, -2> <79, 2, 0> }
            cylinder { 70*x, 80*x, 1 }
            translate <0, 24.5, 5.1>
          }
          difference {
            box { <-2, 0, 71> <0, 2, 79> }
            cylinder { 70*z, 80*z, 1 }
            translate <5.1, 24.5, 0>
          }
          #if (setting > 1)
            box { <-2.4, 1, 53.6> <2.4, 11.6, 58.4> }
            box { <53.6, 1, -2.4> <58.4, 11.6, 2.4> }
            box { <29.6, 1, 29.6> <42.4, 11.6, 42.4> }
            box { <51.9, -1, -4> <60.1, 9.6, 4.1> }
            box { <27.9, -1, 27.9> <44.1, 9.6, 44.1> }
            box { <-4, -1, 51.9> <4.1, 9.6, 60.1> }
            difference {
              box { <-2.4, -1, -2.4> <42.4, 2, 42.4> }
              box { <-20, -2, 42.4> <20, 3, 60> rotate 12*y }
              box { <-20, -2, 42.4> <20, 3, 60> rotate 29*y }
              box { <-20, -2, 42.4> <20, 3, 60> rotate 45*y }
              box { <-20, -2, 42.4> <20, 3, 60> rotate 61*y }
              box { <-20, -2, 42.4> <20, 3, 60> rotate 78*y }
            }
          #end
          box { <-20, 0, 75.9> <20, 30, 150> rotate 12*y }
          box { <-20, 0, 75.9> <20, 30, 150> rotate 29*y }
          box { <-20, 0, 75.9> <20, 30, 150> rotate 45*y }
          box { <-20, 0, 75.9> <20, 30, 150> rotate 61*y }
          box { <-20, 0, 75.9> <20, 30, 150> rotate 78*y }
          difference {
            box { <45, 3.2, -4> <50.8, 11.8, 2.4> }
            box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 2, 44> rotate 90*y }
          }
          difference {
            box { <-4, 3.2, 45> <2.4, 11.8, 50.8> }
            box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 2, 44> }
          }
          difference {
            box { <61, 3.2, -4> <80, 21.4, 2.4> }
            box { <-20, -40, -10> <20, 0, 50> rotate -45.6*x translate <0, 11, 62> rotate 90*y }
          }
          difference {
            box { <-4, 3.2, 61> <2.4, 21.4, 80> }
            box { <-20, -40, -10> <20, 0, 50> rotate -45.6*x translate <0, 11, 62> }
          }
          box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 0, 44> }
          box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 0, 44> rotate 12*y }
          box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 0, 44> rotate 29*y }
          box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 0, 44> rotate 45*y }
          box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 0, 44> rotate 61*y }
          box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 0, 44> rotate 78*y }
          box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 0, 44> rotate 90*y }
          box { <-20, -40, 0> <20, 0, 50> rotate -45.6*x translate <0, 9, 62> }
          box { <-20, -40, 0> <20, 0, 50> rotate -45.6*x translate <0, 9, 62> rotate 12*y }
          box { <-20, -40, 0> <20, 0, 50> rotate -45.6*x translate <0, 9, 62> rotate 29*y }
          box { <-20, -40, 0> <20, 0, 50> rotate -45.6*x translate <0, 9, 62> rotate 45*y }
          box { <-20, -40, 0> <20, 0, 50> rotate -45.6*x translate <0, 9, 62> rotate 61*y }
          box { <-20, -40, 0> <20, 0, 50> rotate -45.6*x translate <0, 9, 62> rotate 78*y }
          box { <-20, -40, 0> <20, 0, 50> rotate -45.6*x translate <0, 9, 62> rotate 90*y }
          difference {
            box { <-4, 3.1, -4> <76, 26, 76> }
            box { <26.6, -1, 26.6> <45.4, 11.2, 45.4> }
            box { <28.1, -1, 28.1> <43.9, 12.7, 43.9> }
            box { <-5, 0, 44.1> <3.9, 12.7, 80> }
            box { <-5, 0, 60.1> <3.900001, 22.3, 80> }
            box { <-5, 0, 50.4> <5.6, 11.2, 80> }
            box { <44.1, 0, -5> <80, 12.7, 3.9> }
            box { <60.1, 0, -5> <80, 22.3, 3.9> }
            box { <50.4, 0, -5> <80, 11.2, 5.6> }
            box { <-20, 0, 74.4> <20, 30, 150> }
            box { <-20, 0, 74.4> <20, 30, 150> rotate 12*y }
            box { <-20, 0, 74.4> <20, 30, 150> rotate 29*y }
            box { <-20, 0, 74.4> <20, 30, 150> rotate 45*y }
            box { <-20, 0, 74.4> <20, 30, 150> rotate 61*y }
            box { <-20, 0, 74.4> <20, 30, 150> rotate 78*y }
            box { <-20, 0, 74.4> <20, 30, 150> rotate 90*y }
            box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 2, 44> }
            box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 2, 44> rotate 12*y }
            box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 2, 44> rotate 29*y }
            box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 2, 44> rotate 45*y }
            box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 2, 44> rotate 61*y }
            box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 2, 44> rotate 78*y }
            box { <-20, -40, 0> <20, 0, 50> rotate -26.6*x translate <0, 2, 44> rotate 90*y }
            box { <-20, -40, 0> <20, 0, 50> rotate -45.6*x translate <0, 11, 62> }
            box { <-20, -40, 0> <20, 0, 50> rotate -45.6*x translate <0, 11, 62> rotate 12*y }
            box { <-20, -40, 0> <20, 0, 50> rotate -45.6*x translate <0, 11, 62> rotate 29*y }
            box { <-20, -40, 0> <20, 0, 50> rotate -45.6*x translate <0, 11, 62> rotate 45*y }
            box { <-20, -40, 0> <20, 0, 50> rotate -45.6*x translate <0, 11, 62> rotate 61*y }
            box { <-20, -40, 0> <20, 0, 50> rotate -45.6*x translate <0, 11, 62> rotate 78*y }
            box { <-20, -40, 0> <20, 0, 50> rotate -45.6*x translate <0, 11, 62> rotate 90*y }
            #if (setting < 3)
              cylinder { 3*y, 4.8*y, 2.4 }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 32> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 40> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 40> }
              cylinder { 12.6*y, 14.4*y, 2.4 translate <32, 0, 32> }
              cylinder { 12.6*y, 14.4*y, 2.4 translate <32, 0, 40> }
              cylinder { 12.6*y, 14.4*y, 2.4 translate <40, 0, 32> }
              cylinder { 12.6*y, 14.4*y, 2.4 translate <40, 0, 40> }
            #else
              object { rounded_button() rotate 90*y }
              object { rounded_button() rotate 90*y translate <8, 0, 0> }
              object { rounded_button() rotate 90*y translate <16, 0, 0> }
              object { rounded_button() rotate 90*y translate <24, 0, 0> }
              object { rounded_button() rotate 90*y translate <32, 0, 0> }
              object { rounded_button() rotate 90*y translate <40, 0, 0> }
              object { rounded_button() rotate 90*y translate <0, 0, 8> }
              object { rounded_button() rotate 90*y translate <8, 0, 8> }
              object { rounded_button() rotate 90*y translate <16, 0, 8> }
              object { rounded_button() rotate 90*y translate <24, 0, 8> }
              object { rounded_button() rotate 90*y translate <32, 0, 8> }
              object { rounded_button() rotate 90*y translate <40, 0, 8> }
              object { rounded_button() rotate 90*y translate <0, 0, 16> }
              object { rounded_button() rotate 90*y translate <8, 0, 16> }
              object { rounded_button() rotate 90*y translate <16, 0, 16> }
              object { rounded_button() rotate 90*y translate <24, 0, 16> }
              object { rounded_button() rotate 90*y translate <32, 0, 16> }
              object { rounded_button() rotate 90*y translate <0, 0, 24> }
              object { rounded_button() rotate 90*y translate <8, 0, 24> }
              object { rounded_button() rotate 90*y translate <16, 0, 24> }
              object { rounded_button() rotate 90*y translate <0, 0, 32> }
              object { rounded_button() rotate 90*y translate <8, 0, 32> }
              object { rounded_button() rotate 90*y translate <16, 0, 32> }
              object { rounded_button() rotate 90*y translate <0, 0, 40> }
              object { rounded_button() rotate 90*y translate <8, 0, 40> }
              object { rounded_button() rotate 90*y translate <32, 9.6, 32> }
              object { rounded_button() rotate 90*y translate <32, 9.6, 40> }
              object { rounded_button() rotate 90*y translate <40, 9.6, 32> }
              object { rounded_button() rotate 90*y translate <40, 9.6, 40> }
            #end
          }
          #if (setting > 1)
            cylinder { -1*y, 2.000001*y, 2.5 translate <0, 0, 48> }
            cylinder { -1*y, 2.000001*y, 2.5 translate <8, 0, 48> }
            cylinder { -1*y, 2.000001*y, 2.5 translate <8, 0, 40> }
            cylinder { -1*y, 2.000001*y, 2.5 translate <16, 0, 40> }
            cylinder { -1*y, 2.000001*y, 2.5 translate <24, 0, 40> }
            cylinder { -1*y, 2.000001*y, 2.5 translate <24, 0, 32> }
            cylinder { -1*y, 2.000001*y, 2.5 translate <32, 0, 24> }
            cylinder { -1*y, 2.000001*y, 2.5 translate <40, 0, 24> }
            cylinder { -1*y, 2.000001*y, 2.5 translate <40, 0, 16> }
            cylinder { -1*y, 2.000001*y, 2.5 translate <40, 0, 8> }
            cylinder { -1*y, 2.000001*y, 2.5 translate <48, 0, 8> }
            cylinder { -1*y, 2.000001*y, 2.5 translate <48, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 40> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 40> }
          #end
        }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 12.8, 48> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 22.4, 64> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 22.4, 72> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <48, 12.8, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <64, 22.4, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <72, 22.4, 0> }
        #end
        object { open_rounded_button() translate <0, 9.6, 48> }
        object { open_rounded_button() translate <0, 9.6, 56> }
        object { open_rounded_button() translate <48, 9.6, 0> }
        object { open_rounded_button() translate <56, 9.6, 0> }
        object { open_rounded_button() translate <0, 19.2, 64> }
        object { open_rounded_button() translate <0, 19.2, 72> }
        object { open_rounded_button() translate <64, 19.2, 0> }
        object { open_rounded_button() translate <72, 19.2, 0> }
        #if (setting > 1)
          object { ring() translate <4, 0, 4> }
          object { ring() translate <12, 0, 4> }
          object { ring() translate <20, 0, 4> }
          object { ring() translate <28, 0, 4> }
          object { ring() translate <36, 0, 4> }
          object { ring() translate <4, 0, 12> }
          object { ring() translate <12, 0, 12> }
          object { ring() translate <20, 0, 12> }
          object { ring() translate <28, 0, 12> }
          object { ring() translate <4, 0, 20> }
          object { ring() translate <12, 0, 20> }
          object { ring() translate <20, 0, 20> }
          object { ring() translate <28, 0, 20> }
          object { ring() translate <4, 0, 28> }
          object { ring() translate <12, 0, 28> }
          object { ring() translate <20, 0, 28> }
          object { ring() translate <4, 0, 36> }
          object { ring() translate <36, 9.6, 36> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 20*y, 1.600001 translate <0, 0, 56> }
        cylinder { 0*y, 20*y, 1.600001 translate <56, 0, 0> }
        cylinder { 0*y, 20*y, 1.600001 translate <36, 0, 36> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 32> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 32> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <32, 0, 40> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <40, 0, 40> }
      #end
//      bounded_by { box { <-4, -0.1, -4> <76, 25.6, 76> } }
      texture { color_tex }
    #if (setting > 1) } #end
  #end
#end
#macro s_saucer_section(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -75.9> <75.9, 22.3, 3.9> }
      box { <-50, -1, -150> <50, 30, -75.9> rotate -45*y }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -75.9> <75.9, 22.3, 3.9> }
          #if (setting > 1)
            difference {
              box { <-4, -1, -74.4> <74.4, 21.3, 4> }
              box { <-30, -1, -150> <30, 30, -74.4> rotate -12*y }
              box { <-30, -1, -150> <30, 30, -74.4> rotate -29*y }
              box { <-30, -1, -150> <30, 30, -74.4> rotate -45*y }
              box { <-30, -1, -150> <30, 30, -74.4> rotate -61*y }
              box { <-30, -1, -150> <30, 30, -74.4> rotate -78*y }
              box { <-20, 0, -1> <20, 30, 40> rotate -28.125*x translate <0, 1.1, -75.9> }
              box { <-20, 0, -1> <20, 30, 40> rotate -28.125*x translate <0, 1.1, -75.9> rotate -12*y }
              box { <-20, 0, -1> <20, 30, 40> rotate -28.125*x translate <0, 1.1, -75.9> rotate -29*y }
              box { <-20, 0, -1> <20, 30, 40> rotate -28.125*x translate <0, 1.1, -75.9> rotate -45*y }
              box { <-20, 0, -1> <20, 30, 40> rotate -28.125*x translate <0, 1.1, -75.9> rotate -61*y }
              box { <-20, 0, -1> <20, 30, 40> rotate -28.125*x translate <0, 1.1, -75.9> rotate -78*y }
              box { <-20, 0, -1> <20, 30, 40> rotate -28.125*x translate <0, 1.1, -75.9> rotate -90*y }
              box { <-20, 0, -1> <20, 30, 40> rotate -15*x translate <0, 14, -52> }
              box { <-20, 0, -1> <20, 30, 40> rotate -15*x translate <0, 14, -52> rotate -12*y }
              box { <-20, 0, -1> <20, 30, 40> rotate -15*x translate <0, 14, -52> rotate -29*y }
              box { <-20, 0, -1> <20, 30, 40> rotate -15*x translate <0, 14, -52> rotate -45*y }
              box { <-20, 0, -1> <20, 30, 40> rotate -15*x translate <0, 14, -52> rotate -61*y }
              box { <-20, 0, -1> <20, 30, 40> rotate -15*x translate <0, 14, -52> rotate -78*y }
              box { <-20, 0, -1> <20, 30, 40> rotate -15*x translate <0, 14, -52> rotate -90*y }
              difference {
                cylinder { 16*y, 30*y, 3.2 }
                cylinder { 15*y, 31*y, 2.6 }
                translate <4, 0, -28>
              }
              difference {
                cylinder { 16*y, 30*y, 3.2 }
                cylinder { 15*y, 31*y, 2.6 }
                translate <12, 0, -28>
              }
              difference {
                cylinder { 16*y, 30*y, 3.2 }
                cylinder { 15*y, 31*y, 2.6 }
                translate <12, 0, -20>
              }
              difference {
                cylinder { 16*y, 30*y, 3.2 }
                cylinder { 15*y, 31*y, 2.6 }
                translate <20, 0, -20>
              }
              difference {
                cylinder { 16*y, 30*y, 3.2 }
                cylinder { 15*y, 31*y, 2.6 }
                translate <20, 0, -12>
              }
              difference {
                cylinder { 16*y, 30*y, 3.2 }
                cylinder { 15*y, 31*y, 2.6 }
                translate <28, 0, -12>
              }
              difference {
                cylinder { 16*y, 30*y, 3.2 }
                cylinder { 15*y, 31*y, 2.6 }
                translate <28, 0, -4>
              }
              difference {
                box { <-4, -1, -76> <4, 20, -68> }
                box { <-2.4, -2, -74.4> <2.4, 21, -69.6> }
              }
              difference {
                box { <-4.000001, 3.2, -68> <4.000002, 20, -60> }
                box { <-2.4, 2, -68.000001> <2.4, 21, -61.5> }
              }
              box { <-0.5, 3.2, -68.2> <0.5, 30, -66.5> }
              difference {
                box { <-4.000002, 6.4, -60.1> <4.000004, 20, -52> }
                box { <-2.4, 4, -58.4> <2.4, 8, -53.6> }
              }
              box { <-4, 8.6, -70> <5.6, 20, -50.25> }
              box { <-4, 0, -20> <-2.4, 10, 20> rotate -15*x translate <0, 12.5, -52> }
              box { <-4, 16, -40> <-2.4, 20, -19.9> }
              difference {
                box { <68, -1, -4> <76, 20, 4> }
                box { <69.6, -2, -2.4> <75.4, 21, 2.4> }
              }
              difference {
                box { <60, 3.2, -4.000001> <68.1, 20, 4> }
                box { <61.5, 2, -2.4> <68.000001, 21, 2.4> }
              }
              box { <66.5, 3.2, -0.5> <68.2, 30, 0.5> }
              difference {
                box { <52, 6.4, -4.000002> <60.1, 20, 4> }
                box { <53.6, 4, -2.4> <58.4, 8, 2.4> }
              }
              box { <50.25, 8.6, -5> <70, 20, 5.6> }
              box { <-20, 0, 2.4> <20, 10, 4> rotate -15*z translate <52, 12.5, 0> }
              box { <19.9, 16, 2.4> <40, 20, 4> }
              difference {
                box { <-4, -1, -20.000003> <4, 20, -12.000003> }
                box { <-2.4, -2, -18.4> <2.4, 21, -13.6> }
              }
              box { <3.9, -1, -13.6> <5.6, 30, -11.9> }
              difference {
                box { <4.000002, -1, -12.000004> <12, 20, -4.000004> }
                box { <5.6, -2, -10.4> <10.4, 21, -5.6> }
              }
              box { <11.9, -1, -5.6> <13.6, 30, -3.9> }
              difference {
                box { <12.000002, -1, -4.000005> <20, 20, 4.000005> }
                box { <13.6, -2, -2.4> <18.4, 21, 2.4> }
              }
              box { <19.9, 16, -0.5> <21.5, 30, 0.5> }
              box { <-0.5, 16, -21.5> <0.5, 30, -19.9> }
              box { <0, 16, -0.5> <3, 30, 0.5> rotate 45*y translate <4, 0, -20> }
              box { <0, 16, -0.5> <3, 30, 0.5> rotate 45*y translate <12, 0, -12> }
              box { <0, 16, -0.5> <3, 30, 0.5> rotate 45*y translate <20, 0, -4> }
              box { <34.4, 8.6, -45.6> <45.6, 30, -34.4> }
              difference {
                box { <36, 6.4, -44> <44, 8.7, -36> }
                box { <37.6, 5, -42.4> <42.4, 9, -37.6> }
              }
              difference {
                box { <-4, 17, -21.6> <21.6, 30, 4> }
                box { <0, 15, -20> <30, 22, 0> rotate -45*y translate <5.6, 0, -21.6> }
              }
              box { <-2.6, 16.000001, -36> <12, 30, -34.5> }
              box { <34.5, 16.000001, -12> <36, 30, 2.6> }
              difference {
                box { <0, 16.000002, 0> <34, 30, 1.5> rotate -45*y translate <12, 0, -36> }
                box { <-2.5, 15, -2> <2.5, 18, 2> rotate -45*y translate <16, 0, -32> }
                box { <-2.5, 15, -2> <2.5, 18, 2> rotate -45*y translate <24, 0, -24> }
                box { <-2.5, 15, -2> <2.5, 18, 2> rotate -45*y translate <32, 0, -16> }
              }
            }
          #end
          box { <-4, -1, -12> <4, 30, 4> }
          box { <-4, -1, -4> <12, 30, 4> }
          difference {
            box { <-4, 19.1, -20> <20, 25, 4> }
            box { <0, -19, -20> <30, 26, 0> rotate -45*y translate <4, 0, -20> }
          }
          box { <-4, 9.5, -60> <4, 30, -52> }
          box { <36, 9.5, -44> <44, 30, -36> }
          box { <52, 9.5, -4> <60, 30, 4> }
          box { <-30, -1, -150> <30, 30, -75.9> rotate -12*y }
          box { <-30, -1, -150> <30, 30, -75.9> rotate -29*y }
          box { <-30, -1, -150> <30, 30, -75.9> rotate -45*y }
          box { <-30, -1, -150> <30, 30, -75.9> rotate -61*y }
          box { <-30, -1, -150> <30, 30, -75.9> rotate -78*y }
          box { <-20, 0, -1> <20, 30, 40> rotate -28.125*x translate <0, 3.1, -75.9> }
          box { <-20, 0, -1> <20, 30, 40> rotate -28.125*x translate <0, 3.1, -75.9> rotate -12*y }
          box { <-20, 0, -1> <20, 30, 40> rotate -28.125*x translate <0, 3.1, -75.9> rotate -29*y }
          box { <-20, 0, -1> <20, 30, 40> rotate -28.125*x translate <0, 3.1, -75.9> rotate -45*y }
          box { <-20, 0, -1> <20, 30, 40> rotate -28.125*x translate <0, 3.1, -75.9> rotate -61*y }
          box { <-20, 0, -1> <20, 30, 40> rotate -28.125*x translate <0, 3.1, -75.9> rotate -78*y }
          box { <-20, 0, -1> <20, 30, 40> rotate -28.125*x translate <0, 3.1, -75.9> rotate -90*y }
          box { <-20, 0, -1> <20, 30, 40> rotate -15*x translate <0, 16, -52> }
          box { <-20, 0, -1> <20, 30, 40> rotate -15*x translate <0, 16, -52> rotate -12*y }
          box { <-20, 0, -1> <20, 30, 40> rotate -15*x translate <0, 16, -52> rotate -29*y }
          box { <-20, 0, -1> <20, 30, 40> rotate -15*x translate <0, 16, -52> rotate -45*y }
          box { <-20, 0, -1> <20, 30, 40> rotate -15*x translate <0, 16, -52> rotate -61*y }
          box { <-20, 0, -1> <20, 30, 40> rotate -15*x translate <0, 16, -52> rotate -78*y }
          box { <-20, 0, -1> <20, 30, 40> rotate -15*x translate <0, 16, -52> rotate -90*y }
        }
        #if (setting < 3)
          cylinder { 22.2*y, 24*y, 2.4 translate <0, 0, -24> }
          cylinder { 22.2*y, 24*y, 2.4 translate <24, 0, 0> }
        #else
          object { rounded_button() rotate 180*y translate <0, 19.2, -24> }
          object { rounded_button() rotate 180*y translate <24, 19.2, 0> }
        #end
        object { open_rounded_button() translate <0, 16, -16> }
        object { open_rounded_button() translate <8, 16, -8> }
        object { open_rounded_button() translate <16, 16, 0> }
        object { open_rounded_button() translate <0, 6.4, -56> }
        object { open_rounded_button() translate <40, 6.4, -40> }
        object { open_rounded_button() translate <56, 6.4, 0> }
      }
      #if (setting > 1)
        cylinder { 20.2*y, 23.2*y, 1.2 translate <0, 0, -24> }
        cylinder { 20.2*y, 23.2*y, 1.2 translate <24, 0, 0> }
        cylinder { 1*y, 30*y, 1.600001 translate <0, 0, -56> }
        cylinder { 1*y, 30*y, 1.600001 translate <40, 0, -40> }
        cylinder { 1*y, 30*y, 1.600001 translate <56, 0, 0> }
        cylinder { 1*y, 30*y, 1.600001 translate <0, 0, -16> }
        cylinder { 1*y, 30*y, 1.600001 translate <8, 0, -8> }
        cylinder { 1*y, 30*y, 1.600001 translate <16, 0, 0> }
      #end
      box { <-2.5, -1, -8> <2.5, 2, 8> rotate -12*y translate <16, 0, -76> }
      box { <-2.5, -1, -8> <2.5, 2, 8> rotate -12*y translate <24, 0, -76> }
      box { <-2.5, -1, -8> <2.5, 2, 8> rotate -29*y translate <32, 0, -68> }
      box { <-2.5, -1, -8> <2.5, 2, 8> rotate -29*y translate <40, 0, -68> }
      box { <0.5, -1, -8> <5.5, 2, 8> rotate -45*y translate <48, 0, -60> }
      box { <0.5, -1, -8> <5.5, 2, 8> rotate -45*y translate <56, 0, -52> }
      box { <-2.5, -1, -8> <2.5, 2, 8> rotate -61*y translate <68, 0, -40> }
      box { <-2.5, -1, -8> <2.5, 2, 8> rotate -61*y translate <68, 0, -32> }
      box { <-2.5, -1, -8> <2.5, 2, 8> rotate -78*y translate <76, 0, -24> }
      box { <-2.5, -1, -8> <2.5, 2, 8> rotate -78*y translate <76, 0, -16> }
      texture { color_tex }
      //bounded_by { box { <-4, -0.1, -76> <76, 24.1, 4> } }
    }
  #end
#end
#macro s_slope6_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 43.9> }
      box { <-20, 0, -10> <20, 20, 50> rotate 43.5*z translate <4, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 9.5, 43.9> }
            box { <4, 6.3, -4> <12, 10, 44> }
            box { <4, -1, -4> <12, 3.2, 4> }
            box { <4, -1, 36> <12, 3.2, 44> }
            box { <-20, 0, -10> <20, 20, 50> texture { color_tex normal { bumping } }
              rotate 43.5*z translate <4, 9.5, 0> }
            difference {
              box { <-5, 8.5, -4> <13, 10, -2.9> }
              cylinder { -4*x, 12*x, 1 translate <0, 8.5, -2.9> }
            }
            difference {
              box { <-5, 8.5, 42.9> <13, 10, 44> }
              cylinder { -4*x, 12*x, 1 translate <0, 8.5, 42.9> }
            }
          }
          #if (setting < 3)
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 0> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 8> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 16> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 24> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 32> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 40> }
          #else
            object { rounded_button() rotate 90*y translate <8, 3.2, 0> }
            object { rounded_button() rotate 90*y translate <8, 3.2, 8> }
            object { rounded_button() rotate 90*y translate <8, 3.2, 16> }
            object { rounded_button() rotate 90*y translate <8, 3.2, 24> }
            object { rounded_button() rotate 90*y translate <8, 3.2, 32> }
            object { rounded_button() rotate 90*y translate <8, 3.2, 40> }
          #end
        }
        #if (setting > 1)
          difference {
            merge {
              difference {
                box { <-2.4, -1, -2.4> <2.4, 8.6, 4> }
                box { <-0.5, -1, 2.4> <0.5, 9, 5> }
              }
              difference {
                box { <-2.4, -1, 5.6> <10.4, 8.6, 34.4> }
                box { <4, 5.4, 5> <11, 9, 35> }
              }
              difference {
                box { <-2.5, -1, 36> <2.5, 8.6, 42.5> }
                box { <-0.5, -1, 35> <0.5, 9, 37.4> }
              }
            }
            box { <-20, 0, -10> <20, 20, 50> rotate 43.5*z translate <4, 7.5, 0> }
          }
          difference {
            box { <4, 2, -2.4> <10.4, 5.4, 4> }
            box { <7.5, 1, 2.4> <8.5, 6, 5> }
            box { <3, 1, -0.5> <5.6, 6, 0.5> }
          }
          difference {
            box { <4, 2, 36> <10.5, 5.49, 42.4> }
            box { <7.5, 1, 35> <8.5, 6, 37.6> }
            box { <3, 1, 39.5> <5.6, 6, 40.5> }
          }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 0> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 8> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 16> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 24> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 32> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 40> }
          box { <-4, -1, 12> <-3.4, 0.5, 28> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            object { high_ring() translate <4, 0, 12> }
            object { high_ring() translate <4, 0, 20> }
            object { high_ring() translate <4, 0, 28> }
          }
          box { <-20, 0, -10> <20, 20, 50> rotate 43.5*z translate <4, 7.5, 0> }
          box { <4, 6.3, -4> <12, 10, 44> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 9.6, 44> } }
    }
  #end
#end
#macro tail_engine(color_tex)
  #if (setting = 0)
    merge {
      box { <11.9, 17.6, -3.9> <27.9, 19.1, 11.9> }
      cone { -3.90001*x, 2.30001, 33.90001*x, 7.9 translate <0, 11.25, 4> }
      box { <-3.9, 0, 0> <27.90002, 1.5, 7.8> }
      texture { color_tex }
    }
  #else
    merge {
      box { <11.9, 17.6, -3.9> <27.9, 19.1, 11.9> }
      object { open_rounded_button() translate <16, 16, 0> }
      object { open_rounded_button() translate <16, 16, 8> }
      object { open_rounded_button() translate <24, 16, 0> }
      object { open_rounded_button() translate <24, 16, 8> }
      #if (setting > 3)
        object { llogo() rotate -90*y translate <16, 19.1, 0> }
        object { llogo() rotate -90*y translate <16, 19.1, 8> }
        object { llogo() rotate -90*y translate <24, 19.1, 0> }
        object { llogo() rotate -90*y translate <24, 19.1, 8> }
      #end
      difference {
        box { <-3.9, 0.5, 3.25> <27.90001, 17.90001, 4.75> }
        box { <-15, -2, 2> <0, 24, 6> rotate -44.75*z translate <-3.9, 1.5, 0> }
        cylinder { -4*z, 12*z, 1.60003 translate <24, 11.25, 0> }
      }
      difference {
        box { <-3.90001, 0, 0> <27.90002, 1.5, 7.8> }
        box { <0, -1, -3> <4, 2, 0> rotate 13*y translate <-3.9, 0, 3> }
        box { <0, -1, 0> <4, 2, 3> rotate -13*y translate <-3.9, 0, 4.9> }
        difference {
          box { <-2.5, -0.5, -0.5> <2.5, 3, 2.5> }
          box { <-2, -1, 0> <0, 4, 3> rotate 28*y translate <-2.5, 0, 0> }
          box { <0, -1, 0> <2, 4, 3> rotate -28*y translate <2.5, 0, 0> }
        }
        difference {
          box { <-2.5, -0.5, -0.5> <2.5, 3, 2.5> }
          box { <-2, -1, 0> <0, 4, 3> rotate 28*y translate <-2.5, 0, 0> }
          box { <0, -1, 0> <2, 4, 3> rotate -28*y translate <2.5, 0, 0> }
          translate <8, 0, 0>
        }
        difference {
          box { <-2.5, -0.5, -0.5> <2.5, 3, 2.5> }
          box { <-2, -1, 0> <0, 4, 3> rotate 28*y translate <-2.5, 0, 0> }
          box { <0, -1, 0> <2, 4, 3> rotate -28*y translate <2.5, 0, 0> }
          translate <16, 0, 0>
        }
        difference {
          box { <-2.5, -0.5, -0.5> <2.5, 3, 2.5> }
          box { <-2, -1, 0> <0, 4, 3> rotate 28*y translate <-2.5, 0, 0> }
          box { <0, -1, 0> <2, 4, 3> rotate -28*y translate <2.5, 0, 0> }
          translate <24, 0, 0>
        }
        difference {
          box { <-2.5, -0.5, -0.5> <2.5, 3, 2.5> }
          box { <-2, -1, 0> <0, 4, 3> rotate 28*y translate <-2.5, 0, 0> }
          box { <0, -1, 0> <2, 4, 3> rotate -28*y translate <2.5, 0, 0> }
          rotate 180*y
          translate <0, 0, 7.8>
        }
        difference {
          box { <-2.5, -0.5, -0.5> <2.5, 3, 2.5> }
          box { <-2, -1, 0> <0, 4, 3> rotate 28*y translate <-2.5, 0, 0> }
          box { <0, -1, 0> <2, 4, 3> rotate -28*y translate <2.5, 0, 0> }
          rotate 180*y
          translate <8, 0, 7.8>
        }
        difference {
          box { <-2.5, -0.5, -0.5> <2.5, 3, 2.5> }
          box { <-2, -1, 0> <0, 4, 3> rotate 28*y translate <-2.5, 0, 0> }
          box { <0, -1, 0> <2, 4, 3> rotate -28*y translate <2.5, 0, 0> }
          rotate 180*y
          translate <16, 0, 7.8>
        }
        difference {
          box { <-2.5, -0.5, -0.5> <2.5, 3, 2.5> }
          box { <-2, -1, 0> <0, 4, 3> rotate 28*y translate <-2.5, 0, 0> }
          box { <0, -1, 0> <2, 4, 3> rotate -28*y translate <2.5, 0, 0> }
          rotate 180*y
          translate <24, 0, 7.8>
        }
      }
      difference {
        merge {
          object { open_rounded_button() rotate 90*z translate <-0.9, 0, 0> }
          cylinder { -3.90002*x, -3.9*x, 2.4 }
          cone { -3.90001*x, 2.40001, 33.90001*x, 7.9 }
          cylinder { 33.9*x, 35.9*x, 7.90001 }
          translate <0, 11.25, 4>
        }
        difference {
          merge {
            cylinder { -6*x, 37*x, 1.60007 }
            cylinder { 33.90002*x, 36*x, 6.40001 }
            cone { -3.90002*x, 0.8, 33.90003*x, 6.40002 }
            translate <0, 11.25, 4>
          }
          box { <0, 15.25, -4> <37, 20, -0.25> }
          box { <0, 15.25, 8.25> <37, 20, 12> }
          box { <0, 0, 7.99999> <37, 7, 12> }
          box { <0, 0, -4> <37, 7, 0.00001> }
          box { <0, 0, -4> <29, 19, 1.00001> }
          box { <0, 0, 6.99999> <29, 19, 12> }
        }
        box { <0, 0, -4> <28.1, 21, -0.25> }
        box { <0, 0, 8.25> <28.1, 21, 12> }
        box { <33.89999, 4.75, -2.5> <36, 17.75, 10.5> }
        #if (setting > 1)
          cylinder { -5*z, -0.85001*z, 0.75 translate <32, 5.75, 0> }
          cylinder { -5*z, -2.25001*z, 0.75 translate <32, 9.25, 0> }
          cylinder { -5*z, -2.25001*z, 0.75 translate <32, 13.25, 0> }
          cylinder { -5*z, -0.50001*z, 0.75 translate <32, 17.25, 0> }
          cylinder { -5*z, 0.50001*z, 0.75 translate <20, 9.25, 0> }
          cylinder { -5*z, 0.50001*z, 0.75 translate <20, 13.25, 0> }
          box { <0, 8.50001, -5> <20.00001, 10.00001, 0.5> }
          box { <0, 12.50001, -5> <20.00001, 14.00001, 0.5> }
          box { <0, 8.50001, -5> <32.00001, 10.00001, -2.25> }
          box { <0, 12.50001, -5> <32.00001, 14.00001, -2.25> }
          box { <0, 0, -5> <32.00001, 6.50001, -0.85> }
          box { <0, 16.50001, -5> <32.00001, 24, -0.5> }
          cylinder { 13*z, 8.85001*z, 0.75 translate <32, 5.75, 0> }
          cylinder { 13*z, 10.25001*z, 0.75 translate <32, 9.25, 0> }
          cylinder { 13*z, 10.25001*z, 0.75 translate <32, 13.25, 0> }
          cylinder { 13*z, 8.50001*z, 0.75 translate <32, 17.25, 0> }
          cylinder { 13*z, 7.50001*z, 0.75 translate <20, 9.25, 0> }
          cylinder { 13*z, 7.50001*z, 0.75 translate <20, 13.25, 0> }
          box { <0, 8.50001, 13> <20.00001, 10.00001, 7.5> }
          box { <0, 12.50001, 13> <20.00001, 14.00001, 7.5> }
          box { <0, 8.50001, 13> <32.00001, 10.00001, 10.25> }
          box { <0, 12.50001, 13> <32.00001, 14.00001, 10.25> }
          box { <0, 0, 13> <32.00001, 6.50001, 8.85> }
          box { <0, 16.50001, 13> <32.00001, 24, 8.5> }
          cylinder { -4*z, 12*z, 1.60001 translate <24, 11.25, 0> }
        #end
      }
      #if (setting > 1)
        object { open_rounded_button() rotate -90*x translate <24, 11.25, 2.75> }
        object { open_rounded_button() rotate 90*x translate <24, 11.25, 5.25> }
      #end
      difference {
        cylinder { 8*x, 35.8*x, 3.2 }
        cylinder { 7*x, 36*x, 2.6 }
        translate <0, 11.25, 4>
      }
      texture { color_tex }
      bounded_by { box { <-5.8, -0.1, -4> <36, 20.9, 12> } }
    }
  #end
#end
#macro tail_huge(color_tex)
  #if (setting = 0)
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
        box { <-10, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 9.5, 0> }
      }
      box { <-3.5, 0.000001, 11.25> <51.899999, 41.1, 12.75> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.5, 0.000001, 11.25> <51.899999, 41.1, 12.75> }
        box { <0, 0, 11> <30, 50, 13> rotate -33.4*z translate <27.9, 0, 0> }
        box { <36.099999, 37.900001, 11> <52, 50, 13> }
        box { <-50, -50, 11> <0, 0, 13> rotate -45*z translate <28.3, 41.1, 0> }
        box { <-4, -1, 11> <4, 8.7, 13> }
        box { <0, -10, 11> <40, 0, 13> rotate -17.25*z translate <4, 8.7, 0> }
      }
      difference {
        box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
        box { <-40, 0, -30> <40, 20, 30> texture { color_tex normal { bumping } }
          rotate -43.5*x translate <0, 9.5, 4> }
        box { <-40, 0, -30> <40, 20, 30> texture { color_tex normal { bumping } }
          rotate 43.5*x translate <0, 9.5, 20> }
        box { <-20, -10, -20> <40, 10, 0> rotate -18.4*y translate <16, 0, 0> }
        box { <-20, -10, 0> <40, 10, 20> rotate 18.4*y translate <16, 0, 24> }
        box { <-10, 0, -10> <40, 20, 30> texture { color_tex normal { bumping } }
          rotate -17.25*z translate <4, 9.5, 0> }
        box { <-10, 0, -20> <40, 20, 20> texture { color_tex normal { bumping } }
          rotate 41.75*x rotate -17.25*z translate <4, 9.5, 20> }
        box { <-10, 0, -20> <40, 20, 20> texture { color_tex normal { bumping } }
          rotate -41.75*x rotate -17.25*z translate <4, 9.5, 4> }
        #if (setting > 1)
          difference {
            box { <5.6, -1, -2.4> <26.4, 8.6, 26.4> }
            box { <5, -2, 2.9> <13.5, 9, 21.1> }
            box { <-40, 0, -30> <40, 20, 30> rotate -43.5*x translate <0, 7.5, 4> }
            box { <-40, 0, -30> <40, 20, 30> rotate 43.5*x translate <0, 7.5, 20> }
            box { <-10, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 7.5, 0> }
            box { <-10, 0, -20> <40, 20, 20> rotate 41.75*x rotate -17.25*z translate <4, 7.5, 18.5> }
            box { <-10, 0, -20> <40, 20, 20> rotate -41.75*x rotate -17.25*z translate <4, 7.5, 5.5> }
            box { <13.4, -1, 4.5> <24, 9, 5.2> }
            box { <23.3, -1, 3.5> <24, 9, 5> }
            box { <13.4, -1, 18.8> <24, 9, 19.5> }
            box { <23.3, -1, 19> <24, 9, 20.5> }
          }
          difference {
            box { <-2.4, -1, -2.4> <4, 8.6, 2.4> }
            box { <-40, 0, -30> <40, 20, 30> rotate -43.5*x translate <0, 7.5, 4> }
            box { <2.5, -2, -0.5> <4.1, 9, 0.5> }
          }
          difference {
            box { <-2.4, -1, 21.5> <4, 8.6, 26.4> }
            box { <-40, 0, -30> <40, 20, 30> rotate 43.5*x translate <0, 7.5, 20> }
            box { <2.5, -2, 23.5> <4.1, 9, 24.5> }
          }
          difference {
            box { < -5, -1, 3.9> <12.1, 8.6, 20.1> }
            box { <-10, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 7.5, 0> }
            box { <-4, 6.3, 3> <-2.4, 9, 21> }
            cylinder { 6.4*y, 9*y, 1.5 translate <0, 0, 12> }
            cylinder { 3.2*y, 9*y, 1.5 translate <8, 0, 12> }
            box { <4.1, 3.1, 3> <5.5, 9, 21> }
            box { <-0.5, 6.3, 3> <0.5, 9, 5.5> }
            box { <-0.5, 6.3, 18.5> <0.5, 9, 21> }
            box { <7.5, 3.1, 3> <8.5, 9, 5.5> }
            box { <7.5, 3.1, 18.5> <8.5, 9, 21> }
            box { <2.4, 6.3, 7.5> <5, 9, 8.5> }
            box { <2.4, 6.3, 15.5> <5, 9, 16.5> }
            box { <10.5, 3.1, 7.5> <13, 9, 8.5> }
            box { <10.5, 3.1, 15.5> <13, 9, 16.5> }
          }
        #end
      }
      #if (setting > 1)
        difference {
          object { high_ring() translate <20, 0, 12> }
          box { <-10, 0, -10> <40, 20, 30> rotate -17.25*z translate <4, 7.5, 0> }
        }
      #end
      box { <36.1, 36.4, 4.1> <51.9, 37.9, 19.9> }
      object { open_rounded_button() translate <40, 34.8, 8> }
      object { open_rounded_button() translate <48, 34.8, 8> }
      object { open_rounded_button() translate <40, 34.8, 16> }
      object { open_rounded_button() translate <48, 34.8, 16> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <40, 37.9, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <48, 37.9, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <40, 37.9, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <48, 37.9, 16> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <52, 41.2, 28> } }
    }
  #end
#end
#macro tail_l(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.900001, 0, -3.9> <35.900001, 28, 3.9> }
      box { <-20, -2, -4> <0, 40, 4> rotate -44.5*z translate <-3.9, 3.1, 0> }
      box { <0, -10, -4> <10, 30, 4> rotate -18.3*z translate <27.9, 3.1, 0> }
      texture { color_tex }
    }
  #else
    merge {
      box { <19.9, 27.3, -3.9> <35.9, 28.7, 3.9> }
      #if (setting > 1)
        object { open_rounded_button() translate <24, 25.6, 0> }
        object { open_rounded_button() translate <32, 25.6, 0> }
      #end
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <24, 28.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <32, 28.7, 0> }
      #end
      difference {
        box { <-3.900001, 0.5, -0.75> <35.900001, 28, 0.75> }
        box { <-20, -2, -4> <0, 40, 4> rotate -44.5*z translate <-3.9, 3.1, 0> }
        box { <0, -2, -4> <10, 30, 4> rotate -18.3*z translate <27.9, 3.1, 0> }
        box { <-10, -1, -4> <40, 2, 4> }
      }
      difference {
        box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
        #if (setting > 0)
          box { <-2.4, -1, -2.4> <26.4, 2.000001, 2.4> }
        #end
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
        object { pin(1) translate <12, 0, 0> }
        object { pin(1) translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <36, 30.5, 4> } }
    }
  #end
#end
#macro tail_m(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <19.9, 3.1, 11.9> }
      box { <-3.899999, 3, 3.4> <38.4, 35, 4.6> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <19.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <16, 0, 8> }
          #end
          box { <-3.899999, 3, 3.4> <38.4, 35, 4.6> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <18.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
        #end
        box { <19.900001, -1, 3> <39, 9.6, 5> }
        box { <0, -50, -10> <10, 50, 20> rotate -6*z translate <38.4, 31, 0> }
        box { <-50, 0, -10> <0, 50, 20> rotate -44*z translate <-3.9, 3.1, 0> }
        difference {
          box { <15, 30, 3> <34.4, 40, 5> }
          difference {
            cylinder { 3*z, 5*z, 18 translate <34.4, 17, 0> }
            box { <-50, -50, 2> <0, 50, 6> rotate 46*z translate <34.4, 17, 0> }
          }
        }
        difference {
          box { <34.399999, 30.999999, 3> <39, 36, 5> }
          cylinder { 3*z, 5*z, 4 translate <34.4, 31, 0> }
        }
      }
      #if (setting > 1)
        box { <-2.5, 0.000001, 3.5> <1.1, 2.1, 4.5> }
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <38.5, 35.1, 12> } }
    }
  #end
#end
#macro tail_mini(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 3.1, 11.9> }
      box { <-3.900005, 0.000005, 3.2> <19, 19.1, 4.8> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <3.9, 3.1, 11.9> }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <2.4, 2, 10.4> }
            object { pin(2) translate <0, 0.00005, 4> }
          }
        #end
      }
      difference {
        box { <-3.900005, 0.000005, 3.2> <19, 19.1, 4.8> }
        box { <-2.5, -1, 3> <2.5, 2.5, 5> }
        box { <0, -10, 3> <20, 0, 5> rotate 23*z translate <3.9, 0, 0> }
        box { <0, 0, 3> <30, 20, 5> rotate 45.25*z translate <-3.9, 3.1, 0> }
        difference {
          box { <0, 0, 2> <2, 2, 6> }
          cylinder { 3*z, 5*z, 1 }
          translate <18, 18.1, 0>
        }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <19.1, 19.2, 12> } }
    }
  #end
#end
#macro tail_pipe(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 51*y, 1.5 translate <7.9, 0, 0> texture { color_tex } }
  #else
    merge {
      cylinder { -3.9*x, 4.9*x, 1.5 }
      intersection {
        torus { 4, 1.7 rotate 90*x }
        box { <0, -6, -2> <6, 0, 2> }
        translate <3.899999, 4, 0>
      }
      difference {
        cylinder { 3.899999*y, 51*y, 1.5 translate <7.9, 0, 0> }
        box { <0, 0, -2> <6, 6, 2> rotate -45*z translate <6.4, 51, 0> }
      }
      cylinder { 10.5*y, 12.5*y, 3.5 translate <7.9, 0, 0> }
      torus { 3, 0.5 translate <7.9, 12.499999, 0> }
      torus { 3, 0.5 translate <7.9, 14.5, 0> }
      torus { 3, 0.5 translate <7.9, 16, 0> }
      torus { 3, 0.5 translate <7.9, 17.5, 0> }
      torus { 3, 0.5 translate <7.9, 19, 0> }
      torus { 3, 0.5 translate <7.9, 20.5, 0> }
      torus { 3, 0.5 translate <7.9, 22, 0> }
      torus { 3, 0.5 translate <7.9, 23.5, 0> }
      torus { 3, 0.5 translate <7.9, 25, 0> }
      torus { 3, 0.5 translate <7.9, 26.5, 0> }
      torus { 3, 0.5 translate <7.9, 28, 0> }
      torus { 3, 0.5 translate <7.9, 29.5, 0> }
      torus { 3, 0.5 translate <7.9, 31, 0> }
      torus { 3, 0.5 translate <7.9, 32.5, 0> }
      torus { 3, 0.5 translate <7.9, 34, 0> }
      torus { 3, 0.5 translate <7.9, 35.500001, 0> }
      cylinder { 12*y, 37*y, 2.999999 translate <7.9, 0, 0> }
      cylinder { 35.5*y, 38*y, 3.5 translate <7.9, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -1.8, -2> <11.5, 51.1, 2> } }
    }
  #end
#end
#macro tail_s(color_tex)
  #if (setting = 0)
    merge {
      box { <11.9, 17.6, -3.9> <27.9, 19.1, 11.9> }
      difference {
        box { <-3.9, 0.5, 0.1> <27.900001, 17.900001, 7.9> }
        box { <-15, -2, 0> <0, 24, 8> rotate -45*z translate <-3.9, 1.8, 0> }
        box { <0, -2, 0> <10, 18, 8> rotate -26.9*z translate <19.9, 1.8, 0> }
      }
      texture { color_tex }
    }
  #else
    merge {
      box { <11.9, 17.6, -3.9> <27.9, 19.1, 11.9> }
      object { open_rounded_button() translate <16, 16, 0> }
      object { open_rounded_button() translate <16, 16, 8> }
      object { open_rounded_button() translate <24, 16, 0> }
      object { open_rounded_button() translate <24, 16, 8> }
      #if (setting > 3)
        object { llogo() rotate -90*y translate <16, 19.1, 0> }
        object { llogo() rotate -90*y translate <16, 19.1, 8> }
        object { llogo() rotate -90*y translate <24, 19.1, 0> }
        object { llogo() rotate -90*y translate <24, 19.1, 8> }
      #end
      difference {
        box { <-3.9, 0.5, 3.25> <27.900001, 17.900001, 4.75> }
        box { <-15, -2, 2> <0, 24, 6> rotate -45*z translate <-3.9, 1.8, 0> }
        box { <0, -2, 2> <10, 18, 6> rotate -26.9*z translate <19.9, 1.8, 0> }
      }
      difference {
        box { <-3.9, 0, 0.1> <19.900002, 1.5, 7.9> }
        box { <0, -1, -3> <4, 2, 0> rotate 13*y translate <-3.9, 0, 3> }
        box { <0, -1, 0> <4, 2, 3> rotate -13*y translate <-3.9, 0, 5> }
        difference {
          box { <-2.5, -0.5, -0.5> <2.5, 3, 2.5> }
          box { <0, -1, 0> <2, 4, 3> rotate -28*y translate <2.5, 0, 0> }
          translate <0, 0, 0.1>
        }
        difference {
          box { <-2.5, -0.5, -0.5> <2.5, 3, 2.5> }
          box { <-2, -1, 0> <0, 4, 3> rotate 28*y translate <-2.5, 0, 0> }
          box { <0, -1, 0> <2, 4, 3> rotate -28*y translate <2.5, 0, 0> }
          translate <8, 0, 0.1>
        }
        difference {
          box { <-2.5, -0.5, -0.5> <2.5, 3, 2.5> }
          box { <-2, -1, 0> <0, 4, 3> rotate 28*y translate <-2.5, 0, 0> }
          box { <0, -1, 0> <2, 4, 3> rotate -28*y translate <2.5, 0, 0> }
          translate <16, 0, 0.1>
        }
        difference {
          box { <-2.5, -0.5, -0.5> <2.5, 3, 2.5> }
          box { <-2, -1, 0> <0, 4, 3> rotate 28*y translate <-2.5, 0, 0> }
          rotate 180*y
          translate <0, 0, 7.9>
        }
        difference {
          box { <-2.5, -0.5, -0.5> <2.5, 3, 2.5> }
          box { <-2, -1, 0> <0, 4, 3> rotate 28*y translate <-2.5, 0, 0> }
          box { <0, -1, 0> <2, 4, 3> rotate -28*y translate <2.5, 0, 0> }
          rotate 180*y
          translate <8, 0, 7.9>
        }
        difference {
          box { <-2.5, -0.5, -0.5> <2.5, 3, 2.5> }
          box { <-2, -1, 0> <0, 4, 3> rotate 28*y translate <-2.5, 0, 0> }
          box { <0, -1, 0> <2, 4, 3> rotate -28*y translate <2.5, 0, 0> }
          rotate 180*y
          translate <16, 0, 7.9>
        }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 20.9, 12> } }
    }
  #end
#end
#macro tail_shuttle(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.900001, 0, -3.9> <19.9, 3.1, 11.9> }
      box { <-3.9, 3.099998, 3.2> <43.9, 34.9, 4.8> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 3.099998, 3.2> <43.9, 34.9, 4.8> }
        box { <-50, 0, -10> <50, 50, 20> rotate 44.9*z translate <-3.9, 3.1, 0> }
        box { <-50, -30, -10> <50, 0, 20> rotate 59.9*z translate <43.9, 33.9, 0> }
        box { <-50, -30, -10> <50, 0, 20> rotate 22*z translate <19.9, 3.1, 0> }
        difference {
          box { <42.9, 33.9, 2> <50, 40, 6> }
          cylinder { 3*z, 5*z, 1 translate <42.9, 33.9, 0> }
        }
      }
      difference {
        box { <-3.900001, 0, -3.9> <19.9, 3.1, 11.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <18.4, 2, 10.4> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 35, 12> } }
    }
  #end
#end
#macro tail_wing(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.4, 0, -3.9> <27.9, 3.1, 59.9> }
      box { <-20, -10, -80> <0, 10, 80> rotate -30.25*y translate <-4.4, 0, 27.2> }
      box { <-20, -10, -80> <0, 10, 80> rotate 30.25*y translate <-4.4, 0, 28.8> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.4, 0, -3.9> <27.9, 3.1, 59.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 48> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 56> }
          #else
            object { rounded_button() translate <8, 0, 16> }
            object { rounded_button() translate <8, 0, 24> }
            object { rounded_button() translate <8, 0, 32> }
            object { rounded_button() translate <8, 0, 40> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <16, 0, 16> }
            object { rounded_button() translate <16, 0, 24> }
            object { rounded_button() translate <16, 0, 32> }
            object { rounded_button() translate <16, 0, 40> }
            object { rounded_button() translate <16, 0, 48> }
            object { rounded_button() translate <16, 0, 56> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <24, 0, 56> }
          #end
        }
        box { <-20, -10, -80> <0, 10, 80> rotate -30.25*y translate <-4.4, 0, 27.2> }
        box { <-20, -10, -80> <0, 10, 80> rotate 30.25*y translate <-4.4, 0, 28.8> }
        difference {
          box { <10, -1, -5> <16, 7, 10> }
          box { <-30, -10, 0> <30, 10, 20> rotate -30.25*y translate <16, 0, 0> }
          difference {
            cylinder { -1*y, 6*y, 3.9 translate <16, 0, 0> }
            box { <-30, -10, 0> <30, 10, 20> rotate -30.25*y translate <16, 0, 0> }
          }
        }
        difference {
          box { <10, -1, 56> <16, 7, 61> }
          box { <-30, -10, -20> <30, 10, 0> rotate 30.25*y translate <16, 0, 56> }
          difference {
            cylinder { -1*y, 6*y, 3.9 translate <16, 0, 56> }
            box { <-30, -10, -20> <30, 10, 0> rotate 30.25*y translate <16, 0, 56> }
          }
        }
        #if (setting > 1)
          box { <-4, -1, 27.2> <4.1, 4, 28.8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 48> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 56> }
          difference {
            merge {
              box { <5.5, -1, 3.9> <18.5, 2, 52.1> }
              box { <19.9, -1, 3.9> <28, 2, 52.1> }
              box { <12, -1, -2.5> <26.4, 2, 2.5> }
              box { <12, -1, 53.5> <26.4, 2, 58.5> }
              box { <-2.5, -1, 16> <4.1, 2, 26.2> }
              box { <-2.5, -1, 29.8> <4.1, 2, 40> }
            }
            box { <-20, -10, -80> <0, 10, 80> rotate -30.25*y translate <-2.4, 0, 26.2> }
            box { <-20, -10, -80> <0, 10, 80> rotate 30.25*y translate <-2.4, 0, 29.8> }
          }
        #end
        box { <0, -1, 0> <10, 4, 30> rotate 16*y translate <20, 0, 28> }
        box { <0, -1, -30> <10, 4, 0> rotate -16*y translate <20, 0, 28> }
      }
      #if (setting > 1)
        object { pin(1) translate <20, 0, 0> }
        object { pin(1) translate <20, 0, 56> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <12, 0, 28> }
        object { ring() translate <12, 0, 36> }
        object { ring() translate <12, 0, 44> }
        box { <15.5, 0.000001, 3.8> <16.5, 2.1, 5.5> }
        box { <15.5, 0.000001, 50.5> <16.5, 2.1, 52.2> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 4.9, 60> } }
    }
  #end
#end
#macro talky(color_tex)
  #if (setting = 0)
    merge {
      box { <2, -7.25, -1.4> <8.5, 7.25, 1.4> }
      cylinder { 8.6*y, 21.1*y, 1 translate <6.5, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { -3.000001*y, 3.000001*y, 1.500001 }
          torus { 3, 1.5 rotate 90*x translate <3, 3, 0> }
          torus { 3, 1.5 rotate 90*x translate <3, -3, 0> }
        }
        cylinder { -15*y, 15*y, 1.5 inverse }
      }
      difference {
        merge {
          box { <2, -7.25, -1.4> <8.5, 7.25, 1.4> }
          cylinder { 8.4*x, 9.3*x, 0.9 translate <0, 5.5, 0> }
          cylinder { 8.4*x, 9.3*x, 0.9 translate <0, 2, 0> }
          box { <8.4, -6, -0.5> <9, -2, 0.5> }
          cylinder { 7.249999*y, 8.75*y, 1.4 translate <6.5, 0, 0> }
          cylinder { 8.6*y, 21.1*y, 1 translate <6.5, 0, 0> }
          difference {
            sphere { <6.5, 21, 0> 1.5 }
            box { <1, 10, -5> <10, 21, 5> }
          }
          box { <1, -6, -1> <2, -3, 1> }
          box { <1, 3, -1> <2, 6, 1> }
          object { open_rounded_button() rotate 90*x translate <6, 4, -1.7> }
          object { open_rounded_button() rotate 90*x translate <6, -4, -1.7> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y rotate 90*x translate <6, 4, 1.4> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y rotate 90*x translate <6, -4, 1.4> }
          #end
        }
        #if (setting > 1)
          box { <1, -3, -2> <3.5, 3, 2> }
          box { <5, 0.25, -2> <7.5, 1, 1> }
          box { <5, 1.5, -2> <7.5, 2.25, 1> }
          box { <5, 2.75, -2> <7.5, 3.5, 1> }
          box { <5, 4.25, -2> <7.5, 5, 1> }
          box { <5, -1, -2> <7.5, -0.25, 1> }
          box { <5, -2.25, -2> <7.5, -1.5, 1> }
          box { <5, -3.5, -2> <7.5, -2.75, 1> }
          box { <5, -4.75, -2> <7.5, -4, 1> }
        #end
      }
      texture { color_tex }
      bounded_by { box { <-1.6, -7.35, -1.6> <10, 22.6, 3.2> } }
    }
  #end
#end
#macro techdhpblock1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 9.5, 11.9> }
      cylinder { -11.9*x, -3.8*x, 2.25 translate <0, 5.6, 0> }
      cylinder { -11.9*x, -3.8*x, 2.25 translate <0, 5.6, 8> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          torus { 2.249995, 0.3 rotate 90*z translate <-11.600005, 5.6, 0> }
          cylinder { -11.9*x, -3.7*x, 2.25 translate <0, 5.6, 0> }
          cylinder { -4.65*x, -3.8*x, 2.9 translate <0, 5.6, 0> }
          torus { 2.249995, 0.3 rotate 90*z translate <-11.600005, 5.6, 8> }
          cylinder { -11.9*x, -3.7*x, 2.25 translate <0, 5.6, 8> }
          cylinder { -4.65*x, -3.8*x, 2.9 translate <0, 5.6, 8> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
          #else
            object { rounded_button() rotate -90*y translate <0, 6.4, 0> }
            object { rounded_button() rotate -90*y translate <0, 6.4, 8> }
          #end
          box { <-3.9, 0, -3.9> <3.9, 9.5, 11.9> }
        }
        box { <-12, 2, -0.5> <-9.499999, 10, 0.5> }
        box { <-12, 2, 7.5> <-9.499999, 10, 8.5> }
        cylinder { 2*y, 10*y, 0.5 translate <-9.5, 0, 0> }
        cylinder { 2*y, 10*y, 0.5 translate <-9.5, 0, 8> }
        cylinder { -12*x, -4*x, 1.6 translate <0, 5.6, 0> }
        cylinder { -12*x, -4*x, 1.6 translate <0, 5.6, 8> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 8.6, 10.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
        #end
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 8.7*y, 1.5 }
          cylinder { -1*y, 1.5*y, 0.7 }
          translate <0, 0, 4>
        }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <4, 11.3, 12> } }
    }
  #end
#end
#macro techdhpblock2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
      cylinder { -11.9*x, 19.9*x, 2.25 translate <0, 5.6, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          torus { 2.249995, 0.3 rotate 90*z translate <-11.600005, 5.6, 4> }
          torus { 2.249995, 0.3 rotate 90*z translate <19.600005, 5.6, 4> }
          cylinder { -11.9*x, 19.9*x, 2.25 translate <0, 5.6, 4> }
          cylinder { -4.65*x, 12.65*x, 2.9 translate <0, 5.6, 4> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() rotate 90*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <0, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 8> }
          #end
          box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
        }
        box { <-12, 2, 3.5> <-9.499999, 8, 4.5> }
        cylinder { 2*y, 10*y, 0.5 translate <-9.5, 0, 4> }
        cylinder { 2*y, 10*y, 0.5 translate <17.5, 0, 4> }
        box { <17.499999, 2, 3.5> <20, 8, 4.5> }
        cylinder { -12*x, -4*x, 1.5 translate <0, 5.6, 4> }
        cylinder { 12*x, 20*x, 1.5 translate <0, 5.6, 4> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 10.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
        #end
        box { <1.75, -1, 3> <6.25, 10, 5> }
        box { <3, -1, 1.75> <5, 10, 6.25> }
      }
      #if (setting > 1)
        object { high_ring() translate <4, 0, 4> }
        box { <-3.5, 5, 3.75> <1.5, 8.9, 4.25> }
        box { <6.5, 5, 3.75> <11.5, 8.9, 4.25> }
        box { <3.75, 5, -3.5> <4.25, 8.9, 1.5> }
        box { <3.75, 5, 6.5> <4.25, 8.9, 11.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <20, 11.3, 12> } }
    }
  #end
#end
#macro techdhpblock2_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> }
      cylinder { -11.9*x, 35.9*x, 2.25 translate <0, 5.6, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          torus { 2.249995, 0.3 rotate 90*z translate <-11.600005, 5.6, 4> }
          torus { 2.249995, 0.3 rotate 90*z translate <35.600005, 5.6, 4> }
          cylinder { -11.9*x, 35.9*x, 2.25 translate <0, 5.6, 4> }
          cylinder { -4.65*x, 28.65*x, 3 translate <0, 5.6, 4> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 8> }
          #else
            object { rounded_button() rotate 90*y translate <0, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <0, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <16, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <24, 6.4, 8> }
          #end
          box { <-3.9, 0, -3.9> <27.9, 9.5, 11.9> }
        }
        box { <-12, 2, 3.5> <-9.499999, 10, 4.5> }
        box { <33.499999, 2, 3.5> <36, 10, 4.5> }
        cylinder { 2*y, 10*y, 0.5 translate <-9.5, 0, 4> }
        cylinder { 2*y, 10*y, 0.5 translate <33.5, 0, 4> }
        cylinder { -12*x, -4*x, 1.5 translate <0, 5.6, 4> }
        cylinder { 28*x, 36*x, 1.5 translate <0, 5.6, 4> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 8.6, 10.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { high_ring() translate <4, 0, 4> }
        object { high_ring() translate <12, 0, 4> }
        object { high_ring() translate <20, 0, 4> }
        box { <11.5, 2, -3> <12.5, 8.7, 1.1> }
        box { <11.5, 2, 6.9> <12.5, 8.7, 11> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <36, 11.3, 12> } }
    }
  #end
#end
#macro techidhblock1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      box { <0.3, -7, -3.900005> <7.7, 3, 3.900005> }
      cylinder { -3.90002*z, 3.900002*z, 3.7 translate <4, -7, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 1.9, -3.9> <11.9, 3.1, 3.9> }
        box { <-3.900005, 0, -3.900005> <-2.7, 3, 3.900005> }
        box { <11.900005, 0, -3.900005> <10.7, 3, 3.900005> }
        box { <-3, 0.5, -0.5> <0.5, 3, 0.5> }
        box { <7.5, 0.5, -0.5> <11, 3, 0.5> }
        object { open_rounded_button() }
        object { open_rounded_button() translate <8, 0, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 3.1, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 0> }
        #end
        box { <0.3, -7, -3.900004> <7.7, 3, 3.900004> }
        cylinder { -3.90002*z, 3.900002*z, 3.7 translate <4, -7, 0> }
      }
      cylinder { -4*z, 4*z, 2.4 translate <4, -7, 0> }
      cylinder { -4*z, -3.4*z, 3.1 translate <4, -7, 0> }
      cylinder { 3.4*z, 4*z, 3.1 translate <4, -7, 0> }
      difference {
        box { <1.3, -7, -4> <6.7, 1.5, -0.5> }
        cylinder { -5*z, 0*z, 3.6 translate <4, -7, 0> }
      }
      difference {
        box { <1.3, -7, 0.5> <6.7, 1.5, 4> }
        cylinder { 0*z, 5*z, 3.6 translate <4, -7, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -10.8, -4> <12, 4.9, 4> } }
    }
  #end
#end
#macro techidhblock1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      box { <0.3, -7, -3.900005> <7.7, 3, 3.900005> }
      cylinder { -3.90002*z, 3.900002*z, 3.7 translate <4, -7, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 1.9, -3.9> <11.9, 3.1, 3.9> }
        box { <-3.900005, 0, -3.900005> <-2.7, 3, 3.900005> }
        box { <11.900005, 0, -3.900005> <10.7, 3, 3.900005> }
        box { <-3, 0.5, -0.5> <0.5, 3, 0.5> }
        box { <7.5, 0.5, -0.5> <11, 3, 0.5> }
        object { open_rounded_button() }
        object { open_rounded_button() translate <8, 0, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 3.1, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 0> }
        #end
        box { <0.3, -7, -3.900004> <7.7, 3, 3.900004> }
        cylinder { -3.90002*z, 3.900002*z, 3.7 translate <4, -7, 0> }
      }
      cylinder { -4*z, 4*z, 2.4 translate <4, -7, 0> }
      cylinder { -4*z, -3.4*z, 3.1 translate <4, -7, 0> }
      cylinder { 3.4*z, 4*z, 3.1 translate <4, -7, 0> }
      difference {
        box { <1.3, -7, -4> <6.7, 1.5, -0.5> }
        cylinder { -5*z, 0*z, 3.6 translate <4, -7, 0> }
      }
      difference {
        box { <1.3, -7, 0.5> <6.7, 1.5, 4> }
        cylinder { 0*z, 5*z, 3.6 translate <4, -7, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -10.8, -4> <12, 4.9, 4> } }
    }
  #end
#end
#macro tech_angle_connect_1(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*z, 3.9*z, 3.75 }
      cylinder { 0*x, 11.9*x, 3.65 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { -3.9*z, 3.9*z, 3.75 }
        cylinder { -5*z, 5*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
      }
      difference {
        cylinder { 0*x, 11.9*x, 3.65 }
        cylinder { -1*x, 12*x, 2 translate <0, -3.65, -3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, 3.65, -3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, -3.65, 3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, 3.65, 3.65> }
        cylinder { -5*z, 5*z, 2.500001 }
        cylinder { -5*z, -3.400001*z, 3.100001 }
        cylinder { 3.400001*z, 5*z, 3.100001 }
        box { <-1, -4, -4> <13, 4, -3.5> }
        box { <-1, -4, 4> <13, 4, 3.5> }
        difference {
          cylinder { 0*x, 12*x, 2.5 }
          box { <-1, 1.5, -0.25> <11.8, 2.6, 0.25> rotate 45*x }
          box { <-1, -1.5, -0.25> <11.8, -2.6, 0.25> rotate 45*x }
          cylinder { -1*x, 11*x, 0.9 translate <0, 2.5, 0> rotate -45*x }
          cylinder { -1*x, 11*x, 0.9 translate <0, -2.5, 0> rotate -45*x }
          sphere { <11, 2.5, 0> 0.9 rotate -45*x }
          sphere { <11, -2.5, 0> 0.9 rotate -45*x }
        }
      }
      #if (setting > 1)
        cylinder { -3.75*z, -3.4*z, 0.2 translate <10.5, 0.5, 0> }
        box { <6.999999, 0.3, -3.750001> <10.500001, 0.7, -3.4> }
        cylinder { -3.75*z, -3.4*z, 0.2 translate <7, 0.5, 0> }
        merge {
          cylinder { -3.750002*z, -3.4*z, 0.2 translate <0, -1, 0> }
          box { <-0.2, -1, -3.750003> <0.2, 0, -3.4> }
          rotate 45*z
          translate <7, 0.5, 0>
        }
      #end
      texture { color_tex }
      bounded_by { box { <-3.85, -3.85, -4> <12, 3.85, 4> } }
    }
  #end
#end
#macro tech_angle_connect_2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*z, 3.9*z, 3.75 }
      cylinder { -11.9*x, 11.9*x, 3.65 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { -3.9*z, 3.9*z, 3.75 }
        cylinder { -5*z, 5*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
      }
      difference {
        cylinder { 0*x, 11.9*x, 3.65 }
        cylinder { -1*x, 12*x, 2 translate <0, -3.65, -3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, 3.65, -3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, -3.65, 3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, 3.65, 3.65> }
        cylinder { -5*z, 5*z, 2.500001 }
        cylinder { -5*z, -3.400001*z, 3.100001 }
        cylinder { 3.400001*z, 5*z, 3.100001 }
        box { <-1, -4, -4> <13, 4, -3.5> }
        box { <-1, -4, 4> <13, 4, 3.5> }
        difference {
          cylinder { 0*x, 12*x, 2.5 }
          box { <-1, 1.5, -0.25> <11.8, 2.6, 0.25> rotate 45*x }
          box { <-1, -1.5, -0.25> <11.8, -2.6, 0.25> rotate 45*x }
          cylinder { -1*x, 11*x, 0.9 translate <0, 2.5, 0> rotate -45*x }
          cylinder { -1*x, 11*x, 0.9 translate <0, -2.5, 0> rotate -45*x }
          sphere { <11, 2.5, 0> 0.9 rotate -45*x }
          sphere { <11, -2.5, 0> 0.9 rotate -45*x }
        }
      }
      difference {
        cylinder { 0*x, -11.9*x, 3.65 }
        cylinder { 1*x, -12*x, 2 translate <0, -3.65, -3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, 3.65, -3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, -3.65, 3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, 3.65, 3.65> }
        cylinder { -5*z, 5*z, 2.400002 }
        cylinder { -5*z, -3.400002*z, 3.100002 }
        cylinder { 3.400002*z, 5*z, 3.100002 }
        box { <1, -4, -4> <-13, 4, -3.5> }
        box { <1, -4, 4> <-13, 4, 3.5> }
        difference {
          cylinder { 0*x, -12*x, 2.5 }
          box { <1, 1.5, -0.25> <-11.8, 2.6, 0.25> rotate 45*x }
          box { <1, -1.5, -0.25> <-11.8, -2.6, 0.25> rotate 45*x }
          cylinder { 1*x, -11*x, 0.9 translate <0, 2.5, 0> rotate -45*x }
          cylinder { 1*x, -11*x, 0.9 translate <0, -2.5, 0> rotate -45*x }
          sphere { <-11, 2.5, 0> 0.9 rotate -45*x }
          sphere { <-11, -2.5, 0> 0.9 rotate -45*x }
        }
      }
      #if (setting > 1)
        merge {
          difference {
            cylinder { -3.750001*z, -3.4*z, 0.8 translate <8, 0, 0> }
            box { <-1, -2, -4> <1, 0, -3> rotate 65*z translate <8, 0, 0> }
            cylinder { -4*z, -3*z, 0.4 translate <8, 0, 0> }
          }
          box { <0, 0.4, -3.75> <2.75, 0.8, -3.4> rotate -25*z translate <8, 0, 0> }
          cylinder { -3.750003*z, -3.4*z, 0.2 translate <-0.6, 0, 0> rotate 65*z translate <8, 0, 0> }
          cylinder { -3.750004*z, -3.4*z, 0.2 translate <10.8, -0.6, 0> }
          cylinder { -3.750005*z, -3.4*z, 0.2 translate <10.8, 0.6, 0> }
          box { <10.6, -0.6, -3.750002> <11, 0.6, -3.4> }
        }
        merge {
          difference {
            cylinder { -3.750001*z, -3.4*z, 0.8 translate <8, 0, 0> }
            box { <-1, -2, -4> <1, 0, -3> rotate 65*z translate <8, 0, 0> }
            cylinder { -4*z, -3*z, 0.4 translate <8, 0, 0> }
          }
          box { <0, 0.4, -3.75> <2.75, 0.8, -3.4> rotate -25*z translate <8, 0, 0> }
          cylinder { -3.750003*z, -3.4*z, 0.2 translate <-0.6, 0, 0> rotate 65*z translate <8, 0, 0> }
          cylinder { -3.750004*z, -3.4*z, 0.2 translate <10.8, -0.6, 0> }
          cylinder { -3.750005*z, -3.4*z, 0.2 translate <10.8, 0.6, 0> }
          box { <10.6, -0.6, -3.750002> <11, 0.6, -3.4> }
          rotate 180*y
        }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -3.85, -4> <12, 3.85, 4> } }
    }
  #end
#end
#macro tech_angle_connect_3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*z, 3.9*z, 3.75 }
      cylinder { 0*x, 11.9*x, 3.65 }
      cylinder { 0*x, -11.9*x, 3.65 rotate -22.5*z }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { -3.9*z, 3.9*z, 3.75 }
        cylinder { -5*z, 5*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
      }
      difference {
        cylinder { 0*x, 11.9*x, 3.65 }
        cylinder { -1*x, 12*x, 2 translate <0, -3.65, -3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, 3.65, -3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, -3.65, 3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, 3.65, 3.65> }
        cylinder { -5*z, 5*z, 2.500001 }
        cylinder { -5*z, -3.400001*z, 3.100001 }
        cylinder { 3.400001*z, 5*z, 3.100001 }
        box { <-1, -4, -4> <13, 4, -3.5> }
        box { <-1, -4, 4> <13, 4, 3.5> }
        difference {
          cylinder { 0*x, 12*x, 2.5 }
          box { <-1, 1.5, -0.25> <11.8, 2.6, 0.25> rotate 45*x }
          box { <-1, -1.5, -0.25> <11.8, -2.6, 0.25> rotate 45*x }
          cylinder { -1*x, 11*x, 0.9 translate <0, 2.5, 0> rotate -45*x }
          cylinder { -1*x, 11*x, 0.9 translate <0, -2.5, 0> rotate -45*x }
          sphere { <11, 2.5, 0> 0.9 rotate -45*x }
          sphere { <11, -2.5, 0> 0.9 rotate -45*x }
        }
      }
      difference {
        cylinder { 0*x, -11.9*x, 3.65 }
        cylinder { 1*x, -12*x, 2 translate <0, -3.65, -3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, 3.65, -3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, -3.65, 3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, 3.65, 3.65> }
        cylinder { -5*z, 5*z, 2.400002 }
        cylinder { -5*z, -3.400002*z, 3.100002 }
        cylinder { 3.400002*z, 5*z, 3.100002 }
        box { <1, -4, -4> <-13, 4, -3.5> }
        box { <1, -4, 4> <-13, 4, 3.5> }
        difference {
          cylinder { 0*x, -12*x, 2.5 }
          box { <1, 1.5, -0.25> <-11.8, 2.6, 0.25> rotate 45*x }
          box { <1, -1.5, -0.25> <-11.8, -2.6, 0.25> rotate 45*x }
          cylinder { 1*x, -11*x, 0.9 translate <0, 2.5, 0> rotate -45*x }
          cylinder { 1*x, -11*x, 0.9 translate <0, -2.5, 0> rotate -45*x }
          sphere { <-11, 2.5, 0> 0.9 rotate -45*x }
          sphere { <-11, -2.5, 0> 0.9 rotate -45*x }
        }
        rotate -22.5*z
      }
      #if (setting > 1)
        difference {
          merge {
            cylinder { -3.75*z, -3.4*z, 1 translate <9.75, 0, 0> }
            cylinder { -3.750001*z, -3.4*z, 0.8 translate <8, 0, 0> }
          }
          cylinder { -4*z, -3*z, 0.8 translate <9.75, 0, 0> }
          cylinder { -4*z, -3*z, 0.4 translate <8, 0, 0> }
          box { <8, -2, -4> <9.75, 0, -3> }
          box { <-1, -2, -4> <0, 0, -3> rotate 55*z translate <8, 0, 0> }
          box { <0, -2, -4> <1, 0, -3> rotate -55*z translate <9.75, 0, 0> }
        }
        difference {
          merge {
            cylinder { 3.75*z, 3.4*z, 1 translate <-9.75, 0, 0> }
            cylinder { 3.750001*z, 3.4*z, 0.8 translate <-8, 0, 0> }
          }
          cylinder { 4*z, 3*z, 0.8 translate <-9.75, 0, 0> }
          cylinder { 4*z, 3*z, 0.4 translate <-8, 0, 0> }
          box { <-8, -2, 4> <-9.75, 0, 3> }
          box { <-1, -2, 4> <0, 0, 3> rotate 35*z translate <-8, 0, 0> }
          box { <0, -2, 4> <1, 0, 3> rotate -35*z translate <-9.75, 0, 0> }
          rotate -22.5*z
        }
      #end
      texture { color_tex }
      bounded_by { box { <-13, -3.85, -4> <12, 9, 4> } }
    }
  #end
#end
#macro tech_angle_connect_4(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*z, 3.9*z, 3.75 }
      cylinder { 0*x, 11.9*x, 3.65 }
      cylinder { 0*x, -11.9*x, 3.65 rotate -45*z }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { -3.9*z, 3.9*z, 3.75 }
        cylinder { -5*z, 5*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
      }
      difference {
        cylinder { 0*x, 11.9*x, 3.65 }
        cylinder { -1*x, 12*x, 2 translate <0, -3.65, -3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, 3.65, -3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, -3.65, 3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, 3.65, 3.65> }
        cylinder { -5*z, 5*z, 2.500001 }
        cylinder { -5*z, -3.400001*z, 3.100001 }
        cylinder { 3.400001*z, 5*z, 3.100001 }
        box { <-1, -4, -4> <13, 4, -3.5> }
        box { <-1, -4, 4> <13, 4, 3.5> }
        difference {
          cylinder { 0*x, 12*x, 2.5 }
          box { <-1, 1.5, -0.25> <11.8, 2.6, 0.25> rotate 45*x }
          box { <-1, -1.5, -0.25> <11.8, -2.6, 0.25> rotate 45*x }
          cylinder { -1*x, 11*x, 0.9 translate <0, 2.5, 0> rotate -45*x }
          cylinder { -1*x, 11*x, 0.9 translate <0, -2.5, 0> rotate -45*x }
          sphere { <11, 2.5, 0> 0.9 rotate -45*x }
          sphere { <11, -2.5, 0> 0.9 rotate -45*x }
        }
      }
      difference {
        cylinder { 0*x, -11.9*x, 3.65 }
        cylinder { 1*x, -12*x, 2 translate <0, -3.65, -3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, 3.65, -3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, -3.65, 3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, 3.65, 3.65> }
        cylinder { -5*z, 5*z, 2.400002 }
        cylinder { -5*z, -3.400002*z, 3.100002 }
        cylinder { 3.400002*z, 5*z, 3.100002 }
        box { <1, -4, -4> <-13, 4, -3.5> }
        box { <1, -4, 4> <-13, 4, 3.5> }
        difference {
          cylinder { 0*x, -12*x, 2.5 }
          box { <1, 1.5, -0.25> <-11.8, 2.6, 0.25> rotate 45*x }
          box { <1, -1.5, -0.25> <-11.8, -2.6, 0.25> rotate 45*x }
          cylinder { 1*x, -11*x, 0.9 translate <0, 2.5, 0> rotate -45*x }
          cylinder { 1*x, -11*x, 0.9 translate <0, -2.5, 0> rotate -45*x }
          sphere { <-11, 2.5, 0> 0.9 rotate -45*x }
          sphere { <-11, -2.5, 0> 0.9 rotate -45*x }
        }
        rotate -45*z
      }
      #if (setting > 1)
        merge {
          box { <10, -0.9, -3.75> <10.2, 0.9, -3> }
          box { <9.1, 0.4, -3.750001> <11, 0.6, -3> }
          box { <-3.2, 0, -3.750002> <0, 0.2, -3> rotate -20*z translate <10, -0.9, 0> }
        }
        merge {
          box { <-10, -0.9, 3.75> <-10.2, 0.9, 3> }
          box { <-9.1, 0.4, 3.750001> <-11, 0.6, 3> }
          box { <3.2, 0, 3.750002> <0, 0.2, 3> rotate 20*z translate <-10, -0.9, 0> }
          rotate -45*z
        }
      #end
      texture { color_tex }
      bounded_by { box { <-11, -3.85, -4> <12, 12, 4> } }
    }
  #end
#end
#macro tech_angle_connect_5(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*z, 3.9*z, 3.75 }
      cylinder { 0.9*x, 11.9*x, 3.65 }
      cylinder { 0*x, -11.9*x, 3.65 rotate -67.5*z }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { -3.9*z, 3.9*z, 3.75 }
        cylinder { -5*z, 5*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
      }
      difference {
        cylinder { 0*x, 11.9*x, 3.65 }
        cylinder { -1*x, 12*x, 2 translate <0, -3.65, -3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, 3.65, -3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, -3.65, 3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, 3.65, 3.65> }
        cylinder { -5*z, 5*z, 2.500001 }
        cylinder { -5*z, -3.400001*z, 3.100001 }
        cylinder { 3.400001*z, 5*z, 3.100001 }
        box { <-1, -4, -4> <13, 4, -3.5> }
        box { <-1, -4, 4> <13, 4, 3.5> }
        difference {
          cylinder { 0*x, 12*x, 2.5 }
          box { <-1, 1.5, -0.25> <11.8, 2.6, 0.25> rotate 45*x }
          box { <-1, -1.5, -0.25> <11.8, -2.6, 0.25> rotate 45*x }
          cylinder { -1*x, 11*x, 0.9 translate <0, 2.5, 0> rotate -45*x }
          cylinder { -1*x, 11*x, 0.9 translate <0, -2.5, 0> rotate -45*x }
          sphere { <11, 2.5, 0> 0.9 rotate -45*x }
          sphere { <11, -2.5, 0> 0.9 rotate -45*x }
        }
      }
      difference {
        cylinder { 0*x, -11.9*x, 3.65 }
        cylinder { 1*x, -12*x, 2 translate <0, -3.65, -3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, 3.65, -3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, -3.65, 3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, 3.65, 3.65> }
        cylinder { -5*z, 5*z, 2.400002 }
        cylinder { -5*z, -3.400002*z, 3.100002 }
        cylinder { 3.400002*z, 5*z, 3.100002 }
        box { <1, -4, -4> <-13, 4, -3.5> }
        box { <1, -4, 4> <-13, 4, 3.5> }
        difference {
          cylinder { 0*x, -12*x, 2.5 }
          box { <1, 1.5, -0.25> <-11.8, 2.6, 0.25> rotate 45*x }
          box { <1, -1.5, -0.25> <-11.8, -2.6, 0.25> rotate 45*x }
          cylinder { 1*x, -11*x, 0.9 translate <0, 2.5, 0> rotate -45*x }
          cylinder { 1*x, -11*x, 0.9 translate <0, -2.5, 0> rotate -45*x }
          sphere { <-11, 2.5, 0> 0.9 rotate -45*x }
          sphere { <-11, -2.5, 0> 0.9 rotate -45*x }
        }
        rotate -67.5*z
      }
      #if (setting > 1)
        merge {
          cylinder { -3.750005*z, -3.4*z, 0.2 translate <7.4, -0.8, 0> }
          cylinder { -3.750005*z, -3.4*z, 0.2 translate <7.4, 0.8, 0> }
          cylinder { -3.750005*z, -3.4*z, 0.2 translate <9, -0.8, 0> }
          box { <7.2, -0.8, -3.750002> <7.6, 0.8, -3.4> }
          box { <7.4, -1, -3.750003> <9, -0.6, -3.4> }
          cylinder { -3.750004*z, -3.4*z, 0.2 translate <10.8, -0.8, 0> }
          box { <8.8, -0.8, -3.750006> <9.2, 0, -3.4> }
          box { <10.6, -0.8, -3.750006> <11, 0, -3.4> }
          difference {
            cylinder { -3.750001*z, -3.4*z, 1.3 scale <0.8, 0.7, 1> }
            cylinder { -4*z, -3*z, 0.9 scale <0.8, 0.7, 1> }
            box { <-2, -2, -4> <2, 0, -2> }
            translate <9.9, 0, 0>
          }
        }
        merge {
          cylinder { -3.750005*z, -3.4*z, 0.2 translate <7.4, -0.8, 0> }
          cylinder { -3.750005*z, -3.4*z, 0.2 translate <7.4, 0.8, 0> }
          cylinder { -3.750005*z, -3.4*z, 0.2 translate <9, -0.8, 0> }
          box { <7.2, -0.8, -3.750002> <7.6, 0.8, -3.4> }
          box { <7.4, -1, -3.750003> <9, -0.6, -3.4> }
          cylinder { -3.750004*z, -3.4*z, 0.2 translate <10.8, -0.8, 0> }
          box { <8.8, -0.8, -3.750006> <9.2, 0, -3.4> }
          box { <10.6, -0.8, -3.750006> <11, 0, -3.4> }
          difference {
            cylinder { -3.750001*z, -3.4*z, 1.3 scale <0.8, 0.7, 1> }
            cylinder { -4*z, -3*z, 0.9 scale <0.8, 0.7, 1> }
            box { <-2, -2, -4> <2, 0, -2> }
            translate <9.9, 0, 0>
          }
          rotate 180*y rotate -67.5*z
        }
      #end
      texture { color_tex }
      bounded_by { box { <-8, -3.85, -4> <12, 11.5, 4> } }
    }
  #end
#end
#macro tech_angle_connect_6(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*z, 3.9*z, 3.75 }
      cylinder { 0.9*x, 11.9*x, 3.65 }
      cylinder { 0*x, -11.9*x, 3.65 rotate -90*z }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { -3.9*z, 3.9*z, 3.75 }
        cylinder { -5*z, 5*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
      }
      difference {
        cylinder { 0*x, 11.9*x, 3.65 }
        cylinder { -1*x, 12*x, 2 translate <0, -3.65, -3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, 3.65, -3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, -3.65, 3.65> }
        cylinder { -1*x, 12*x, 2 translate <0, 3.65, 3.65> }
        cylinder { -5*z, 5*z, 2.500001 }
        cylinder { -5*z, -3.400001*z, 3.100001 }
        cylinder { 3.400001*z, 5*z, 3.100001 }
        box { <-1, -4, -4> <13, 4, -3.5> }
        box { <-1, -4, 4> <13, 4, 3.5> }
        difference {
          cylinder { 0*x, 12*x, 2.5 }
          box { <-1, 1.5, -0.25> <11.8, 2.6, 0.25> rotate 45*x }
          box { <-1, -1.5, -0.25> <11.8, -2.6, 0.25> rotate 45*x }
          cylinder { -1*x, 11*x, 0.9 translate <0, 2.5, 0> rotate -45*x }
          cylinder { -1*x, 11*x, 0.9 translate <0, -2.5, 0> rotate -45*x }
          sphere { <11, 2.5, 0> 0.9 rotate -45*x }
          sphere { <11, -2.5, 0> 0.9 rotate -45*x }
        }
      }
      difference {
        cylinder { 0*x, -11.9*x, 3.65 }
        cylinder { 1*x, -12*x, 2 translate <0, -3.65, -3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, 3.65, -3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, -3.65, 3.65> }
        cylinder { 1*x, -12*x, 2 translate <0, 3.65, 3.65> }
        cylinder { -5*z, 5*z, 2.400002 }
        cylinder { -5*z, -3.400002*z, 3.100002 }
        cylinder { 3.400002*z, 5*z, 3.100002 }
        box { <1, -4, -4> <-13, 4, -3.5> }
        box { <1, -4, 4> <-13, 4, 3.5> }
        difference {
          cylinder { 0*x, -12*x, 2.5 }
          box { <1, 1.5, -0.25> <-11.8, 2.6, 0.25> rotate 45*x }
          box { <1, -1.5, -0.25> <-11.8, -2.6, 0.25> rotate 45*x }
          cylinder { 1*x, -11*x, 0.9 translate <0, 2.5, 0> rotate -45*x }
          cylinder { 1*x, -11*x, 0.9 translate <0, -2.5, 0> rotate -45*x }
          sphere { <-11, 2.5, 0> 0.9 rotate -45*x }
          sphere { <-11, -2.5, 0> 0.9 rotate -45*x }
        }
        rotate -90*z
      }
      #if (setting > 1)
        merge {
          difference {
            cylinder { -3.750004*z, -3.4*z, 1.3 }
            cylinder { -4*z, -3*z, 1.1 }
            box { <0, -5, -4> <5, 5, -3> }
            box { <-5, 0, -4> <5, 5, -3> }
            scale <2, 1.4, 1> translate <9.9, 0.91, 0>
          }
          difference {
            cylinder { -3.750001*z, -3.4*z, 1.3 scale <0.8, 0.7, 1> }
            cylinder { -4*z, -3*z, 0.9 scale <0.8, 0.7, 1> }
            translate <9.9, 0, 0>
          }
        }
        merge {
          difference {
            cylinder { -3.750004*z, -3.4*z, 1.3 }
            cylinder { -4*z, -3*z, 1.1 }
            box { <0, -5, -4> <5, 5, -3> }
            box { <-5, 0, -4> <5, 5, -3> }
            scale <2, 1.4, 1> translate <9.9, 0.91, 0>
          }
          difference {
            cylinder { -3.750001*z, -3.4*z, 1.3 scale <0.8, 0.7, 1> }
            cylinder { -4*z, -3*z, 0.9 scale <0.8, 0.7, 1> }
            translate <9.9, 0, 0>
          }
          rotate 180*y rotate -90*z
        }
      #end
      texture { color_tex }
      bounded_by { box { <-8, -3.85, -4> <12, 12, 4> } }
    }
  #end
#end
#macro tech_axle_10(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 75.9*x, 2.25 texture { color_tex } }
  #else
    merge {
      object { axle_section(78.3) translate <-3.15, 0, 0> }
      object { axle_ending(1) }
      object { axle_ending(2) rotate 180*z translate <72, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -2.35, -2.35> <76, 2.35, 2.35> } }
    }
  #end
#end
#macro tech_axle_12(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 91.9*x, 2.25 texture { color_tex } }
  #else
    merge {
      object { axle_section(94.3) translate <-3.15, 0, 0> }
      object { axle_ending(1) }
      object { axle_ending(2) rotate 180*z translate <88, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -2.35, -2.35> <92, 2.35, 2.35> } }
    }
  #end
#end
#macro tech_axle_2(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 11.9*x, 2.25 texture { color_tex } }
  #else
    merge {
      object { axle_section(14.3) translate <-3.15, 0, 0> }
      object { axle_ending(1) }
      object { axle_ending(2) rotate 180*z translate <8, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -2.35, -2.35> <12, 2.35, 2.35> } }
    }
  #end
#end
#macro tech_axle_2_notched(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 11.9*x, 2.25 texture { color_tex } }
  #else
    difference {
      merge {
        object { axle_section(14.3) translate <-3.15, 0, 0> }
        object { axle_ending(1) }
        object { axle_ending(2) rotate 180*z translate <8, 0, 0> }
      }
      difference {
        box { <-0.5, -3, -3> <0.5, 3, 3> }
        box { <-1, -1.7, -1.7> <1, 1.7, 1.7> }
      }
      difference {
        box { <7.5, -3, -3> <8.5, 3, 3> }
        box { <7, -1.7, -1.7> <9, 1.7, 1.7> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -2.35, -2.35> <12, 2.35, 2.35> } }
    }
  #end
#end
#macro tech_axle_3(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 19.9*x, 2.25 texture { color_tex } }
  #else
    merge {
      object { axle_section(22.3) translate <-3.15, 0, 0> }
      object { axle_ending(1) }
      object { axle_ending(2) rotate 180*z translate <16, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -2.35, -2.35> <20, 2.35, 2.35> } }
    }
  #end
#end
#macro tech_axle_3_button(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 19.7*x, 2.25 texture { color_tex } }
  #else
    merge {
      object { axle_section(22.25) translate <-3.15, 0, 0> }
      object { axle_ending(2) }
      cylinder { 19*x, 19.7*x, 2.9 }
      object { open_rounded_button() rotate -90*z translate <16.6, 0, 0> }
      #if (setting > 3)
        object { llogo() rotate -90*z translate <19.7, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { cylinder { -4*x, 21.4*x, 3 } }
    }
  #end
#end
#macro tech_axle_4(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 27.9*x, 2.25 texture { color_tex } }
  #else
    merge {
      object { axle_section(30.3) translate <-3.15, 0, 0> }
      object { axle_ending(1) }
      object { axle_ending(2) rotate 180*z translate <24, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -2.35, -2.35> <28, 2.35, 2.35> } }
    }
  #end
#end
#macro tech_axle_5(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 35.9*x, 2.25 texture { color_tex } }
  #else
    merge {
      object { axle_section(38.3) translate <-3.15, 0, 0> }
      object { axle_ending(1) }
      object { axle_ending(2) rotate 180*z translate <32, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -2.35, -2.35> <36, 2.35, 2.35> } }
    }
  #end
#end
#macro tech_axle_55_stop(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 59.9*x, 2.25 texture { color_tex } }
  #else
    merge {
      object { axle_section(42.3) translate <-3.15, 0, 0> }
      object { axle_ending(1) }
      object { axle_ending(2) rotate 180*z translate <36, 0, 0> }
      cylinder { 3.7*x, 7*x, 2.35001 }
      cylinder { 3*x, 3.8*x, 2.9 }
      texture { color_tex }
      bounded_by { box { <-4, -2.35, -2.35> <40, 2.35, 2.35> } }
    }
  #end
#end
#macro tech_axle_6(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 43.9*x, 2.25 texture { color_tex } }
  #else
    merge {
      object { axle_section(46.3) translate <-3.15, 0, 0> }
      object { axle_ending(1) }
      object { axle_ending(2) rotate 180*z translate <40, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -2.35, -2.35> <44, 2.35, 2.35> } }
    }
  #end
#end
#macro tech_axle_7(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 51.9*x, 2.25 texture { color_tex } }
  #else
    merge {
      object { axle_section(54.3) translate <-3.15, 0, 0> }
      object { axle_ending(1) }
      object { axle_ending(2) rotate 180*z translate <48, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -2.35, -2.35> <52, 2.35, 2.35> } }
    }
  #end
#end
#macro tech_axle_8(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 59.9*x, 2.25 texture { color_tex } }
  #else
    merge {
      object { axle_section(62.3) translate <-3.15, 0, 0> }
      object { axle_ending(1) }
      object { axle_ending(2) rotate 180*z translate <56, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -2.35, -2.35> <60, 2.35, 2.35> } }
    }
  #end
#end
#macro tech_axle_8_ended(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*x, 59.3*x, 2.25 }
      cylinder { 58.5*x, 59.3*x, 2.9 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        object { axle_section(62.3) translate <-3.15, 0, 0> }
        object { axle_ending(1) }
        cylinder { 58.5*x, 59.3*x, 2.9 }
      }
      sphere { <0, 0, 0> 1 scale <0.3, 1, 1> translate <59.3, 0, 0> }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 59.4*x, 3 } }
    }
  #end
#end
#macro tech_axle_connector(color_tex)
  #if (setting = 0)
    cylinder { -7.9*x, 7.9*x, 3.35 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { -7.9*x, 7.9*x, 3.35 }
          torus { 3.349999, 0.25 rotate 90*x rotate 90*y translate <-4, 0, 0> }
          torus { 3.349999, 0.25 rotate 90*x rotate 90*y }
          torus { 3.349999, 0.25 rotate 90*x rotate 90*y translate <4, 0, 0> }
        }
        object { axle_opening(16,1) translate <-8, 0, 0> }
        cylinder { -8*x, 8*x, 2.5 translate <0, -4, -4> }
        cylinder { -8*x, 8*x, 2.5 translate <0, 4, -4> }
        cylinder { -8*x, 8*x, 2.5 translate <0, -4, 4> }
        cylinder { -8*x, 8*x, 2.5 translate <0, 4, 4> }
      }
      box { <-0.1, -2.26, -0.9> <0.1, 2.26, 0.9> }
      texture { color_tex }
      bounded_by { cylinder { -8*x, 8*x, 3.75 } }
    }
  #end
#end
#macro tech_axle_cover_2(color_tex)
  #if (setting = 0)
    cylinder { 0*x, 14.9*x, 3.6 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { 0*x, 14.9*x, 2.9 }
        cylinder { 0.2*x, 1.9*x, 3.45 }
        cylinder { 0.35*x, 1.75*x, 3.6 }
        torus { 3.45, 0.15 rotate 90*z translate <0.35, 0, 0> }
        torus { 3.45, 0.15 rotate 90*z translate <1.75, 0, 0> }
        cylinder { 2.7*x, 4.4*x, 3.45 }
        cylinder { 2.85*x, 4.25*x, 3.6 }
        torus { 3.45, 0.15 rotate 90*z translate <2.85, 0, 0> }
        torus { 3.45, 0.15 rotate 90*z translate <4.25, 0, 0> }
        cylinder { 5.2*x, 6.9*x, 3.45 }
        cylinder { 5.35*x, 6.75*x, 3.6 }
        torus { 3.45, 0.15 rotate 90*z translate <5.35, 0, 0> }
        torus { 3.45, 0.15 rotate 90*z translate <6.75, 0, 0> }
        cylinder { 7.7*x, 9.4*x, 3.45 }
        cylinder { 7.85*x, 9.25*x, 3.6 }
        torus { 3.45, 0.15 rotate 90*z translate <7.85, 0, 0> }
        torus { 3.45, 0.15 rotate 90*z translate <9.25, 0, 0> }
        cylinder { 10.2*x, 11.9*x, 3.45 }
        cylinder { 10.35*x, 11.75*x, 3.6 }
        torus { 3.45, 0.15 rotate 90*z translate <10.35, 0, 0> }
        torus { 3.45, 0.15 rotate 90*z translate <11.75, 0, 0> }
        cylinder { 12.7*x, 14.4*x, 3.45 }
        cylinder { 12.85*x, 14.25*x, 3.6 }
        torus { 3.45, 0.15 rotate 90*z translate <12.85, 0, 0> }
        torus { 3.45, 0.15 rotate 90*z translate <14.25, 0, 0> }
      }
      cylinder { -1*x, 16*x, 2.5 }
      cylinder { 0.5*x, 1.6*x, 3.2 }
      cylinder { 3*x, 4.1*x, 3.2 }
      cylinder { 5.5*x, 6.6*x, 3.2 }
      cylinder { 8*x, 9.1*x, 3.2 }
      cylinder { 10.5*x, 11.6*x, 3.2 }
      cylinder { 13*x, 14.1*x, 3.2 }
      texture { color_tex }
      bounded_by { cylinder { -0.1*x, 15*x, 3.7 } }
    }
  #end
#end
#macro tech_axle_h_block1_2(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
        }
        object { open_rounded_button() translate <0, 6.4, 0> }
        object { open_rounded_button() translate <8, 6.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 5.6, 0> }
        box { <0.5, 5.599999, -3.8> <7.5, 8.7, 3.8> }
        #if (setting > 1)
          difference {
            box { <0, 0.2, -3.5> <2.5, 4, 3.5> }
            box { <-2.65, 0, -2.65> <2.65, 5, 2.65> rotate 45*y }
          }
          difference {
            box { <5.5, 0.2, -3.5> <8, 4, 3.5> }
            box { <-2.65, 0, -2.65> <2.65, 5, 2.65> rotate 45*y translate <8, 0, 0> }
          }
        #end
      }
      #if (setting > 1)
        object { axle_opening(8,age) rotate -90*y translate <4, 5.6, -4> }
        box { <0, 4.7, -2.400001> <8, 6.5, 2.400001> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 4> } }
    }
  #end
#end
#macro tech_axle_joiner1(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*y, 3.9*y, 3.65 }
      cylinder { -3.650003*z, 3.650003*z 3.9 translate <8, 0, 0> }
      box { <0, -3.900001, -3.65> <8, 3.900001, 3.65> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -3.8*y, 3.8*y, 2.8 }
        cylinder { -3.9*y, -2.9*y, 3.65 }
        cylinder { 2.9*y, 3.9*y, 3.65 }
        cone { -2.900001*y, 3.650001, -2.5*y, 2.75 }
        cone { 2.5*y, 2.75, 2.900001*y, 3.650001 }
        box { <0, -3.900001, -3.65> <8, -2.900002, 3.65> }
        box { <0, 3.900001, -3.65> <8, 2.900002, 3.65> }
        difference {
          box { <2.65, -3.5, -0.5> <8, 3.5, 0.5> }
          cylinder { -4*z, 4*z, 3.5 translate <8, 0, 0> }
        }
        cylinder { -3.650003*z, 3.650003*z 3.9 translate <8, 0, 0> }
      }
      box { <-0.5, -2.4, -4> <0.5, 2.4, 4> }
      object { axle_opening(8,1) rotate 90*z translate <0, -4, 0> }
      cylinder { -4*z, 4*z, 2.5 translate <8, 0, 0> }
      cylinder { -4*z, -3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 3.4*z, 4*z, 3.1 translate <8, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -4, -3.75> <12, 4, 3.75> } }
    }
  #end
#end
#macro tech_axle_joiner2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*x, 3.9*x, 3.9 }
      box { <-3.900001, 0, -3.900001> <3.900001, 16, 3.900001> }
      cylinder { -3.9*x, 3.9*x, 3.9 translate <0, 16, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -3.8*x, 3.8*x, 2.8 }
        cylinder { -3.75*x, -2.9*x, 3.65 }
        torus { 3.5, 0.15 rotate 90*z translate <-3.75, 0, 0> }
        torus { 3.5, 0.15 rotate 90*z translate <3.75, 0, 0> }
        cylinder { -3.9*x, -3*x, 3.5 }
        cylinder { 3.9*x, 3*x, 3.5 }
        cylinder { 2.9*x, 3.75*x, 3.65 }
        cone { -2.900001*x, 3.650001, -2.5*x, 2.75 }
        cone { 2.5*x, 2.75, 2.900001*x, 3.650001 }
        box { <-3.800005, 0, -3.65> <-2.9, 16, 3.65> }
        box { <3.800005, 0, -3.65> <2.9, 16, 3.65> }
        box { <-3, 0, -0.5> <3, 16, 0.5> }
        cylinder { -3.8*x, 3.8*x, 2.8 translate <0, 16, 0> }
        cylinder { -3.75*x, -2.9*x, 3.65 translate <0, 16, 0> }
        torus { 3.5, 0.15 rotate 90*z translate <-3.75, 16, 0> }
        torus { 3.5, 0.15 rotate 90*z translate <3.75, 16, 0> }
        cylinder { -3.9*x, -3*x, 3.5 translate <0, 16, 0> }
        cylinder { 3.9*x, 3*x, 3.5 translate <0, 16, 0> }
        cylinder { 2.9*x, 3.75*x, 3.65 translate <0, 16, 0> }
        cone { -2.900001*x, 3.650001, -2.5*x, 2.75 translate <0, 16, 0> }
        cone { 2.5*x, 2.75, 2.900001*x, 3.650001 translate <0, 16, 0> }
        cylinder { -3.9*z, 3.9*z, 3.7 translate <0, 8, 0> }
      }
      cylinder { -4*z, -3.4*z, 3.1 translate <0, 8, 0> }
      cylinder { -4*z, 4*z, 2.5 translate <0, 8, 0> }
      cylinder { 4*z, 3.4*z, 3.1 translate <0, 8, 0> }
      box { <-1.5, -0.5, -4> <1.5, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <-1.5, 0, 0> }
      cylinder { -4*z, 4*z, 0.5 translate <1.5, 0, 0> }
      box { <-1.5, 15.5, -4> <1.5, 16.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <-1.5, 16, 0> }
      cylinder { -4*z, 4*z, 0.5 translate <1.5, 16, 0> }
      object { axle_opening(8,1) translate <-4, 0, 0> }
      object { axle_opening(8,1) translate <-4, 16, 0> }
      cylinder { -4*x, -3.8*x, 2.6 }
      cylinder { 4*x, 3.8*x, 2.6 }
      cylinder { -4*x, -3.8*x, 2.6 translate <0, 16, 0> }
      cylinder { 4*x, 3.8*x, 2.6 translate <0, 16, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -4, -4> <4, 20, 4> } }
    }
  #end
#end
#macro tech_axle_joiner3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*x, 3.9*x, 3.9 }
      box { <-3.900001, 0, -3.900001> <3.900001, 16, 3.900001> }
      cylinder { -3.9*z, 3.9*z, 3.9 translate <0, 16, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -3.8*x, 3.8*x, 2.8 }
        cylinder { -3.75*x, -2.9*x, 3.65 }
        torus { 3.5, 0.15 rotate 90*z translate <-3.75, 0, 0> }
        torus { 3.5, 0.15 rotate 90*z translate <3.75, 0, 0> }
        cylinder { -3.9*x, -3*x, 3.5 }
        cylinder { 3.9*x, 3*x, 3.5 }
        cylinder { 2.9*x, 3.75*x, 3.65 }
        cone { -2.900001*x, 3.650001, -2.5*x, 2.75 }
        cone { 2.5*x, 2.75, 2.900001*x, 3.650001 }
        box { <-3.900005, 0, -3.65> <-2.9, 16, 3.65> }
        box { <3.900005, 0, -3.65> <2.9, 16, 3.65> }
        cylinder { -3.9*z, 3.9*z, 3.9 translate <0, 16, 0> }
        box { <-3, 0, -0.5> <3, 16, 0.5> }
        cylinder { -4*x, 4*x, 3.9 translate <0, 16, 0> }
        difference {
          cylinder { -5.05*x, 5.05*x, 2.2 }
          box { <-5.1, -3, -3> <-4.1, 3, -1> }
          box { <-5.1, -3, 3> <-4.1, 3, 1> }
          box { <5.1, -3, -3> <4.1, 3, -1> }
          box { <5.1, -3, 3> <4.1, 3, 1> }
          translate <0, 16, 0>
        }
      }
      cylinder { -4*z, -3.4*z, 3.1 translate <0, 16, 0> }
      cylinder { -4*z, 4*z, 2.5 translate <0, 16, 0> }
      cylinder { 4*z, 3.4*z, 3.1 translate <0, 16, 0> }
      box { <-1.5, -0.5, -4> <1.5, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <-1.5, 0, 0> }
      cylinder { -4*z, 4*z, 0.5 translate <1.5, 0, 0> }
      difference {
        object { axle_opening(8,1) translate <-4, 0, 0> }
        box { <-4, -2, -4> <4, 2, -2.4> }
        box { <-4, -2, 4> <4, 2, 2.4> }
      }
      texture { color_tex }
      bounded_by { box { <-5.15, -4, -4> <5.15, 20, 4> } }
    }
  #end
#end
#macro tech_connector(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*x, 8*x, 2.8 }
      cylinder { -3.9*y, 3.9*y, 2.8 translate <8, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -3.8*x, 3.8*x, 2.8 }
        cylinder { -3.75*x, -2.9*x, 3.65 }
        torus { 3.5, 0.15 rotate 90*z translate <-3.75, 0, 0> }
        torus { 3.5, 0.15 rotate 90*z translate <3.75, 0, 0> }
        cylinder { -3.9*x, -3*x, 3.5 }
        cylinder { 3.9*x, 3*x, 3.5 }
        cylinder { 2.9*x, 3.75*x, 3.65 }
        cone { -2.900001*x, 3.650001, -2.5*x, 2.75 }
        cone { 2.5*x, 2.75, 2.900001*x, 3.650001 }
        cylinder { -3.8*y, 3.8*y, 2.8 translate <8, 0, 0> }
        cylinder { -3.75*y, -2.9*y, 3.65translate <8, 0, 0> }
        torus { 3.5, 0.15 translate <8, -3.75, 0> }
        torus { 3.5, 0.15 translate <8, 3.75, 0> }
        cylinder { -3.9*y, -3*y, 3.5 translate <8, 0, 0> }
        cylinder { 3.9*y, 3*y, 3.5 translate <8, 0, 0> }
        cylinder { 2.9*y, 3.75*y, 3.65 translate <8, 0, 0> }
        cone { -2.900001*y, 3.650001, -2.5*y, 2.75 translate <8, 0, 0> }
        cone { 2.5*y, 2.75, 2.900001*y, 3.650001 translate <8, 0, 0> }
        box { <3, -2.8, -2.75> <6, -3.8, 2.75> }
        box { <3, 2.8, -2.75> <6, 3.8, 2.75> }
        box { <3.000001, 3.800001, -2.750002> <4, -3.800001, 2.750002> }
        box { <3.9, -3, -0.5> <6, 3, 0.5> }
        difference {
          cylinder { -2.750005*z, 2.750005*z, 3.9 scale <2, 2, 1> }
          box { <-7.4, -5, -5> <10, 5, 5> }
          box { <-10, 3.800002, -5> <10, 10, 5> }
          box { <-10, -3.800002, -5> <10, -10, 5> }
          translate <10.4, 0, 0>
        }
      }
      cylinder { -4*y, -2.9*y, 2.45 translate <8, 0, 0> }
      cylinder { 4*y, 2.9*y, 2.45 translate <8, 0, 0> }
      cylinder { 0*x, -4*x, 2.4 translate <0, -4, -4> }
      cylinder { 0*x, -4*x, 2.4 translate <0, 4, -4> }
      cylinder { 0*x, -4*x, 2.4 translate <0, -4, 4> }
      cylinder { 0*x, -4*x, 2.4 translate <0, 4, 4> }
      box { <-2.5, -0.5, -4> <2.5, 0.5, 4> }
      box { <7.5, -2.5, -4> <8.5, 2.5, 4> }
      box { <0, -4, -10> <5, 4, -2.750006> }
      box { <0, -4, 2.750006> <5, 4, 10> }
      object { axle_opening(8,1) translate <-4, 0, 0> }
      object { axle_opening(8,1) rotate 90*z translate <8, -4, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -4, -4> <12, 4, 4> } }
    }
  #end
#end
#macro tech_connector_ball_socket(color_tex)
  #if (setting = 0)
    difference {
      merge {
        cylinder { -3.9*x, 3.9*x, 2.8 }
        box { <-3.900005, 0, -2.800001> <3.900005, 5, 2.800001> }
        box { <-3.900004, 4, -7.9> <3.900004, 20, 7.9> }
      }
      box { <-4, 12, -4.4> <4, 24, 4.4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.700004, 4, -7.9> <3.700004, 16, 7.9> }
        cylinder { -7.8*z, 7.8*z, 3.7 translate <0, 16, 0> }
        cylinder { -3.8*x, 3.8*x, 2.8 }
        box { <-3.65, 0, -2.800001> <3.65, 5, 2.800001> }
        cylinder { -3.75*x, -2.9*x, 3.65 }
        torus { 3.5, 0.15 rotate 90*z translate <-3.75, 0, 0> }
        torus { 3.5, 0.15 rotate 90*z translate <3.75, 0, 0> }
        cylinder { -3.9*x, -3*x, 3.5 }
        cylinder { 3.9*x, 3*x, 3.5 }
        box { <-3.7, 0, -3.9> <-3.000001, 5, 3.9> }
        box { <3.7, 0, -3.9> <3.000001, 5, 3.9> }
        cylinder { 2.9*x, 3.75*x, 3.65 }
        cone { -2.900001*x, 3.650001, -2.5*x, 2.75 }
        cone { 2.5*x, 2.75, 2.900001*x, 3.650001 }
      }
      box { <-2.5, -0.5, -4> <2.5, 0.5, 4> }
      object { axle_opening(8,1) translate <-4, 0, 0> }
      object { axle_opening(16,1) rotate -90*y translate <0, 8, -8> }
      box { <-4, 7.5, -6.5> <4, 8.5, -0.7> }
      box { <-4, 7.5, 6.5> <4, 8.5, 0.7> }
      difference {
        box { <-5, -2.5, -6.5> <5, 2.5, 6.5> }
        cylinder { -8*z, 8*z, 2.8 }
        box { <-6, -3, -0.700005> <6, 3, 0.700005> }
        translate <0, 8, 0>
      }
      box { <-4, 0, -10> <4, 10, 0> rotate 12*x translate <0, 12, -7.9> }
      box { <-4, 0, 10> <4, 10, 0> rotate -12*x translate <0, 12, 7.9> }
      cylinder { -8*z, 8*z, 2.5 translate <0, 16, 0> }
      box { <-2.5, 11.9, -8> <2.5, 16, -6.2> }
      box { <-2.5, 11.9, 8> <2.5, 16, 6.2> }
      sphere { <0, 16, 0> 5.1 }
      difference {
        box { <-2.9, 11.9, -4.4> <2.9, 20, 4.4> }
        box { <-0.7, -5, -5> <0.7, 0, 0> rotate -45*x translate <0, 13.1, -4.4> }
        box { <-0.7, -5, 0> <0.7, 0, 5> rotate 45*x translate <0, 13.1, 4.4> }
      }
      cylinder { -5*y, 10*y, 2 rotate -45*x translate <0, 20.1, -2.75> }
      cylinder { -5*y, 10*y, 2 rotate 45*x translate <0, 20.1, 2.75> }
      sphere { <5.8, 12.9, -6.1> 2.5 }
      sphere { <-5.8, 12.9, 6.1> 2.5 }
      texture { color_tex }
      bounded_by { box { <-4, -4, -8> <4, 20, 8> } }
    }
  #end
#end
#macro tech_dhblock1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
      box { <0.3, 3, -3.900005> <7.7, 12.25, 3.900005> }
      cylinder { -3.90002*z, 3.900002*z, 3.7 translate <4, 12.25, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <11.9, 3.1, 3.9> }
        box { <0.3, 3, -3.900005> <7.7, 12.25, 3.900005> }
        cylinder { -3.90002*z, 3.900002*z, 3.7 translate <4, 12.25, 0> }
      }
      cylinder { -4*z, 4*z, 2.4 translate <4, 4.25, 0> }
      cylinder { -4*z, -3.4*z, 3.1 translate <4, 4.25, 0> }
      cylinder { 3.4*z, 4*z, 3.1 translate <4, 4.25, 0> }
      cylinder { -4*z, 4*z, 2.4 translate <4, 12.25, 0> }
      cylinder { -4*z, -3.4*z, 3.1 translate <4, 12.25, 0> }
      cylinder { 3.4*z, 4*z, 3.1 translate <4, 12.25, 0> }
      difference {
        box { <1.3, 4.25, -4> <6.7, 12.25, -0.5> }
        cylinder { -5*z, 0*z, 3.6 translate <4, 4.25, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <4, 12.25, 0> }
      }
      difference {
        box { <1.3, 4.25, 0.5> <6.7, 12.25, 4> }
        cylinder { 0*z, 5*z, 3.6 translate <4, 4.25, 0> }
        cylinder { 0*z, 5*z, 3.6 translate <4, 12.25, 0> }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
        box { <5.6, -1, -2.4> <10.4, 2, 2.4> }
        cylinder { -1*y, 1*y, 0.6 translate <4, 0, -1.5> }
        cylinder { -1*y, 1*y, 0.6 translate <4, 0, 1.5> }
        box { <3.4, -1, -1.500005> <4.6, 1.000005, 1.500005> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 16.05, 4> } }
    }
  #end
#end
#macro tech_engine_cylinder_head(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 19.1, 11.9> }
      cylinder { -3.900005*z, 11.900005*z, 3.7 translate <-3.9, 9, 0> }
      cylinder { -3.900005*z, 11.900005*z, 3.7 translate <11.9, 9, 0> }
      box { <-7.6, 3.2, -3.900004> <15.6, 9.000005, 11.900004> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <11.9, 12.7, 11.9> }
        cylinder { -3.900005*z, 11.900005*z, 3.7 translate <-3.9, 9, 0> }
        cylinder { -3.900005*z, 11.900005*z, 3.7 translate <11.9, 9, 0> }
        box { <-7.6, 3.2, -3.900004> <15.6, 9.000005, 11.900004> }
        box { <-3.9, 14.3, -3.9> <11.9, 15.9, 11.9> }
        box { <-3.9, 17.5, -3.9> <11.9, 19.1, 11.9> }
        cylinder { 12*y, 19*y, 6 translate <4, 0, 4> }
        object { open_rounded_button() translate <0, 16, 0> }
        object { open_rounded_button() translate <8, 16, 0> }
        object { open_rounded_button() translate <0, 16, 8> }
        object { open_rounded_button() translate <8, 16, 8> }
      }
      cylinder { -1*y, 25*y, 4.85 translate <4, 0, 4> }
      difference {
        box { <-2.9, 6.3, -4> <10.9, 11.1, 12> }
        box { <-3, 7.9, -5> <11, 9.5, 13> }
        cylinder { -5*z, 13*z, 3.700005 translate <-3.9, 9, 0> }
        cylinder { -5*z, 13*z, 3.700005 translate <11.9, 9, 0> }
        cylinder { 1*y, 12*y, 6.000005 translate <4, 0, 4> }
      }
      cylinder { -6*z, 14*z, 2.5 translate <-3.9, 9, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <-3.9, 9, 0> }
      cylinder { 11.4*z, 13*z, 3.1 translate <-3.9, 9, 0> }
      cylinder { -6*z, 14*z, 2.5 translate <11.9, 9, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <11.9, 9, 0> }
      cylinder { 11.4*z, 13*z, 3.1 translate <11.9, 9, 0> }
      box { <-2, 2, -5> <10, 5.6, -3.7> }
      box { <-2, 2, 11.7> <10, 5.6, 13> }
      box { <-10, -1, -2.4> <-3.900008, 5.2, 10.4> }
      box { <11.900008, -1, -2.4> <15, 5.2, 10.4> }
      box { <-10, -1, 3.1> <-3.900004, 20, 4.9> }
      box { <11.900004, -1, 3.1> <20, 20, 4.9> }
      cylinder { -10*z, 10*z, 8 translate <4, -7, 0> }
      cylinder { -10*x, 10*x, 8 translate <0, -7, 4> }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <10.4, 5.2, 10.4> }
          cylinder { 2.000005*y, 6*y, 6.000007 translate <4, 0, 4> }
          box { <3, 2.000008, -4> <5, 6, 12> }
          box { <-4, 2.000008, 3> <12, 6, 5> }
        }
      #end
    texture { color_tex }
    bounded_by { box { <-7.7, -0.1, -4> <15.7, 20.9, 12> } }
  }
  #end
#end
#macro tech_flat_liftarm2(color_tex)
  #if (setting = 0)
    box { <-3.7, -3.7, -1.9> <11.7, 3.7, 1.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <0, -3.7, -1.9> <8, 3.7, 1.9> }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 translate <8, 0, 0> }
      }
      object { axle_opening(10,1) rotate -90*y translate <8, 0, -5> }
      box { <4.55, -1.000001, -5> <8, 1.000001, 5> }
      object { axle_opening(10,1) rotate -90*y translate <0, 0, -5> }
      box { <3.45, -1.000001, -5> <0, 1.000001, 5> }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -2> <11.8, 3.8, 2> } }
    }
  #end
#end
#macro tech_flat_liftarm3(color_tex)
  #if (setting = 0)
    box { <-3.7, -3.7, -1.9> <19.7, 3.7, 1.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <0, -3.7, -1.9> <16, 3.7, 1.9> }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 translate <16, 0, 0> }
      }
      cylinder { -6*z, 6*z, 2.5 translate <8, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <8, 0, 0> }
      difference {
        box { <8, -2.7, -10> <16, 2.7, 10> }
        cylinder { -5*z, 5*z, 3.6 translate <8, 0, 0> }
        cylinder { -5*z, 5*z, 3.6 translate <16, 0, 0> }
      }
      object { axle_opening(10,1) rotate -90*y translate <16, 0, -5> }
      box { <11.9, -1.000001, -5> <16, 1.000001, 5> }
      difference {
        box { <0, -2.7, -10> <8, 2.7, 10> }
        cylinder { -5*z, 5*z, 3.6 }
        cylinder { -5*z, 5*z, 3.6 translate <8, 0, 0> }
      }
      object { axle_opening(10,1) rotate -90*y translate <0, 0, -5> }
      box { <3.9, -1.000001, -5> <0, 1.000001, 5> }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -2> <19.8, 3.8, 2> } }
    }
  #end
#end
#macro tech_flat_liftarm3_l_shape(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.7, -3.7, -1.9> <19.7, 3.7, 1.9> }
      box { <12.3, 0, -1.900001> <19.700001, 19.7, 1.900001> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, -3.7, -1.9> <16, 3.7, 1.9> }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 translate <16, 0, 0> }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 translate <16, 16, 0> }
        box { <12.3, 0, -1.900002> <19.700001, 16, 1.900002> }
      }
      cylinder { -6*z, 6*z, 2.5 translate <8, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <16, 8, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <16, 8, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <16, 8, 0> }
      difference {
        box { <8, -2.7, -10> <16, 2.7, 10> }
        cylinder { -5*z, 5*z, 3.6 translate <8, 0, 0> }
        cylinder { -5*z, 5*z, 3.6 translate <16, 0, 0> }
      }
      difference {
        box { <13.3, 8, -10> <18.7, 16, 10> }
        cylinder { -5*z, 5*z, 3.6 translate <16, 8, 0> }
        cylinder { -5*z, 5*z, 3.6 translate <16, 16, 0> }
      }
      object { axle_opening(10,1) rotate -90*y translate <16, 0, -5> }
      object { axle_opening(10,1) rotate -90*y translate <16, 16, -5> }
      box { <11.9, -1.000001, -5> <16, 1.000001, 5> }
      box { <14.999999, 11.9, -5> <17.000001, 16, 5> }
      difference {
        box { <0, -2.7, -10> <8, 2.7, 10> }
        cylinder { -5*z, 5*z, 3.6 }
        cylinder { -5*z, 5*z, 3.6 translate <8, 0, 0> }
      }
      difference {
        box { <13.3, 0, -10> <18.7, 8, 10> }
        cylinder { -5*z, 5*z, 3.6 translate <16, 0, 0> }
        cylinder { -5*z, 5*z, 3.6 translate <16, 8, 0> }
        box { <12, 0, -0.5> <20, 8, 0.5> }
        box { <0, -5, -9> <5, 0, 9> rotate -45*z translate <13.3, 3.7, 0> }
      }
      object { axle_opening(10,1) rotate -90*y translate <0, 0, -5> }
      box { <3.9, -1.000001, -5> <0, 1.000001, 5> }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -2> <19.8, 19.8, 2> } }
    }
  #end
#end
#macro tech_flat_liftarm4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.7, -3.7, -1.9> <27.7, 3.7, 1.9> }
      box { <-3.699999, -3.699999, -5.7> <3.7, 3.699999, -1.8> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, -3.7, -1.9> <24, 3.7, 1.9> }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 translate <24, 0, 0> }
        difference {
          cylinder { -5.7*z, -1.899995*z, 3.7 }
          cylinder { -6*z, -1*z, 2.5 }
          cylinder { -6*z, -1*z, 2.5 translate <-4, -4, 0> }
          cylinder { -6*z, -1*z, 2.5 translate <4, -4, 0> }
          cylinder { -6*z, -1*z, 2.5 translate <-4, 4, 0> }
          cylinder { -6*z, -1*z, 2.5 translate <4, 4, 0> }
        }
      }
      cylinder { -6*z, 6*z, 2.5 translate <8, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <16, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <16, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <16, 0, 0> }
      difference {
        box { <8, -2.7, -10> <24, 2.7, -0.5> }
        cylinder { -5*z, 5*z, 3.6 translate <8, 0, 0> }
        cylinder { -5*z, 5*z, 3.6 translate <16, 0, 0> }
        cylinder { -5*z, 5*z, 3.6 translate <24, 0, 0> }
      }
      difference {
        box { <8, -2.7, 0.5> <24, 2.7, 10> }
        cylinder { -5*z, 5*z, 3.6 translate <8, 0, 0> }
        cylinder { -5*z, 5*z, 3.6 translate <16, 0, 0> }
        cylinder { -5*z, 5*z, 3.6 translate <24, 0, 0> }
      }
      object { axle_opening(10,1) rotate -90*y translate <24, 0, -5> }
      box { <19.9, -1.000001, -5> <24, 1.000001, 5> }
      difference {
        box { <0, -2.7, -1.900001> <8, 2.7, 10> }
        cylinder { -2*z, 5*z, 3.6 }
        cylinder { -2*z, 5*z, 3.6 translate <8, 0, 0> }
      }
      box { <3.9, -1.000001, -1.900002> <-2.25, 1.000001, 5> }
      object { axle_opening(6.900002,1) rotate -90*y translate <0, 0, -1.900002> }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -5.8> <27.8, 3.8, 2> } }
    }
  #end
#end
#macro tech_flat_liftarm5(color_tex)
  #if (setting = 0)
    box { <-3.7, -3.7, -1.9> <35.7, 3.7, 1.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <0, -3.7, -1.9> <32, 3.7, 1.9> }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 translate <32, 0, 0> }
      }
      cylinder { -6*z, 6*z, 2.5 }
      cylinder { -5*z, -1.4*z, 3.1 }
      cylinder { 5*z, 1.4*z, 3.1 }
      cylinder { -6*z, 6*z, 2.5 translate <8, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <16, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <16, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <16, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <24, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <24, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <24, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <32, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <32, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <32, 0, 0> }
      difference {
        box { <0, -2.7, -10> <32, 2.7, -0.5> }
        cylinder { -5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <32, 0, 0> }
      }
      difference {
        box { <16, -2.7, 0.5> <32, 2.7, 10> }
        cylinder { 5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <32, 0, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -2> <35.8, 3.8, 2> } }
    }
  #end
#end
#macro tech_flat_liftarm6(color_tex)
  #if (setting = 0)
    box { <-3.7, -3.7, -1.9> <43.7, 3.7, 1.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <0, -3.7, -1.9> <40, 3.7, 1.9> }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 translate <40, 0, 0> }
      }
      cylinder { -6*z, 6*z, 2.5 }
      cylinder { -5*z, -1.4*z, 3.1 }
      cylinder { 5*z, 1.4*z, 3.1 }
      cylinder { -6*z, 6*z, 2.5 translate <8, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <16, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <16, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <16, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <24, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <24, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <24, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <32, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <32, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <32, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <40, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <40, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <40, 0, 0> }
      difference {
        box { <0, -2.7, -10> <40, 2.7, -0.5> }
        cylinder { -5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <32, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <40, 0, 0> }
      }
      difference {
        box { <16, -2.7, 0.5> <40, 2.7, 10> }
        cylinder { 5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <32, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <40, 0, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -2> <43.8, 3.8, 2> } }
    }
  #end
#end
#macro tech_flat_liftarm7(color_tex)
  #if (setting = 0)
    box { <-3.7, -3.7, -1.9> <51.7, 3.7, 1.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <0, -3.7, -1.9> <48, 3.7, 1.9> }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 }
        cylinder { -1.900001*z, 1.9000001*z, 3.7 translate <48, 0, 0> }
      }
      cylinder { -6*z, 6*z, 2.5 }
      cylinder { -5*z, -1.4*z, 3.1 }
      cylinder { 5*z, 1.4*z, 3.1 }
      cylinder { -6*z, 6*z, 2.5 translate <8, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <16, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <16, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <16, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <24, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <24, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <24, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <32, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <32, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <32, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <40, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <40, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <40, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <48, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <48, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <48, 0, 0> }
      difference {
        box { <0, -2.7, -10> <48, 2.7, -0.5> }
        cylinder { -5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <32, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <40, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <48, 0, 0> }
      }
      difference {
        box { <16, -2.7, 0.5> <48, 2.7, 10> }
        cylinder { 5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <32, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <40, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <48, 0, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -2> <51.8, 3.8, 2> } }
    }
  #end
#end
#macro tech_flat_triangle(color_tex)
  #if (setting = 0)
    merge {
      box { <-19.7, -3.7, -1.9> <19.7, 3.7, 1.9> }
      box { <0, -3.7, -1.900006> <18, 3.7, 1.900006> rotate 26.75*z translate <-16, 0, 0> }
      box { <-18, -3.7, -1.900007> <0, 3.7, 1.900007> rotate -26.75*z translate <16, 0, 0> }
      box { <-3.700005, 0, -1.900005> <3.700005, 19.7, 1.900005> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-16, -3.7, -1.9> <16, 3.7, 1.9> }
        box { <-3.700005, 0, -1.900005> <3.700005, 16, 1.900005> }
        cylinder { -1.900001*z, 1.900001*z, 3.7 translate <-16, 0, 0> }
        cylinder { -1.900002*z, 1.900002*z, 3.7 translate <16, 0, 0> }
        cylinder { -1.900003*z, 1.900003*z, 3.7 translate <0, 16, 0> }
        box { <0, -3.7, -1.900006> <18, 3.7, 1.900006> rotate 26.75*z translate <-16, 0, 0> }
        box { <-18, -3.7, -1.900007> <0, 3.7, 1.900007> rotate -26.75*z translate <16, 0, 0> }
      }
      box { <-16, -1.1, -3> <-12, 1.1, 3> }
      box { <16, -1.1, -3> <12, 1.1, 3> }
      difference {
        box { <-16, -2.25, -3> <-8, 2.25, 3> }
        cylinder { -2*z, 2*z, 3.600005 translate <-16, 0, 0> }
        cylinder { -2*z, 2*z, 3.600005 translate <-8, 0, 0> }
      }
      difference {
        box { <16, -2.25, -3> <8, 2.25, 3> }
        cylinder { -2*z, 2*z, 3.600005 translate <16, 0, 0> }
        cylinder { -2*z, 2*z, 3.600005 translate <8, 0, 0> }
      }
      difference {
        box { <-2.25, 8, -2> <2.25, 16, 2> }
        cylinder { -3*z, 3*z, 3.6 translate <0, 8, 0> }
        cylinder { -3*z, 3*z, 3.6 translate <0, 16, 0> }
        box { <-3, 7, -0.5> <3, 17, 0.5> }
      }
      object { axle_opening(4,1) rotate -90*y translate <-16, 0, -2> }
      object { axle_opening(4,1) rotate -90*y translate <16, 0, -2> }
      cylinder { -6*z, 6*z, 2.5 translate <-8, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <-8, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <-8, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 }
      cylinder { -5*z, -1.4*z, 3.1 }
      cylinder { 5*z, 1.4*z, 3.1 }
      cylinder { -6*z, 6*z, 2.5 translate <8, 0, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <0, 8, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <0, 8, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <0, 8, 0> }
      cylinder { -6*z, 6*z, 2.5 translate <0, 16, 0> }
      cylinder { -5*z, -1.4*z, 3.1 translate <0, 16, 0> }
      cylinder { 5*z, 1.4*z, 3.1 translate <0, 16, 0> }
      difference {
        box { <-16, -2.25, -4> <16, 10.25, -0.5> }
        cylinder { -5*z, 0*z, 3.6 translate <-16, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <-8, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 }
        cylinder { -5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <0, 8, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <0, 16, 0> }
        box { <0, 2.25, -5> <18, 10, 0> rotate 26.75*z translate <-16, 0, 0> }
        box { <-18, 2.25, -5> <0, 10, > rotate -26.75*z translate <16, 0, 0> }
      }
      difference {
        box { <-16, -2.25, 0.5> <16, 10.25, 4> }
        cylinder { 5*z, 0*z, 3.6 translate <-16, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <-8, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 }
        cylinder { 5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <0, 8, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <0, 16, 0> }
        box { <0, 2.25, 5> <18, 10, 0> rotate 26.75*z translate <-16, 0, 0> }
        box { <-18, 2.25, 5> <0, 10, 0> rotate -26.75*z translate <16, 0, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-19.8, -3.8, -2> <19.8, 19.8, 2> } }
    }
  #end
#end
#macro tech_f_block1_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-0.000001, -0.000001, -3.900001> <24.000001, 3.100001, 3.900001> }
        box { <-1, -1, -5> <4, 0.800001, 5> }
        box { <0, -1, -2.4> <4, 2, 2.4> }
        box { <20, -1, -2.4> <25, 2, 2.4> }
        box { <20, -1, -5> <29, 0.800001, 5> }
        #if (setting > 1)
          box { <5, -1, -2.4> <19, 2, 2.4> }
        #end
        cylinder { -1*y, 5*y, 2.500001 }
        cylinder { -1*y, 5*y, 2.500001 translate <24, 0, 0> }
      }
      difference {
        cylinder { 0*y, 3.1*y, 3.9 }
        #local counter = 0;
        #while (counter < 16)
          difference {
            box { <-0.4, -1, -4> <0.4, 0.8, 0> }
            box { <-1, -2, 0> <0, 1, 5> rotate 5*y translate <-0.4, 0, -4> }
            box { <0, -2, 0> <1, 1, 5> rotate -5*y translate <0.4, 0, -4> }
            rotate (5.625+(counter*22.5))*y
          }
          #local counter = counter + 1;
        #end
        cylinder { -1*y, 5*y, 2.5 }
      }
      difference {
        cylinder { 0*y, 3.1*y, 3.9 }
        #local counter = 0;
        #while (counter < 16)
          difference {
            box { <-0.4, -1, -4> <0.4, 0.8, 0> }
            box { <-1, -2, 0> <0, 1, 5> rotate 5*y translate <-0.4, 0, -4> }
            box { <0, -2, 0> <1, 1, 5> rotate -5*y translate <0.4, 0, -4> }
            rotate (5.625+(counter*22.5))*y
          }
          #local counter = counter + 1;
        #end
        cylinder { -1*y, 5*y, 2.5 }
        translate <24, 0, 0>
      }
      #if (setting > 1)
        object { pin(2) translate <12, 0, 0> }
      #end
      object { open_rounded_button() translate <8, 0, 0> }
      object { open_rounded_button() translate <16, 0, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <16, 3.1, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 4.9, 4> } }
    }
  #end
#end
#macro tech_f_block1_5(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <35.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-0.000001, -0.000001, -3.900001> <32.000001, 3.100001, 3.900001> }
        box { <-1, -1, -5> <5, 0.800001, 5> }
        box { <0, -1, -2.4> <5, 2, 2.4> }
        box { <27, -1, -2.4> <33, 2, 2.4> }
        box { <27, -1, -5> <33, 0.800001, 5> }
        #if (setting > 1)
          difference {
            box { <5.8, -1, -2.4> <26.2, 2, 2.4> }
            box { <10.8, -2, -3> <11.6, 3, 3> }
            box { <20.4, -2, -3> <21.2, 3, 3> }
            cylinder { -2*y, 3*y, 3.5 translate <16, 0, 0> }
          }
          object { axle_opening(5,1) rotate 90*z translate <16, -1, 0> }
        #end
        cylinder { -1*y, 4*y, 2.500001 }
        cylinder { -1*y, 4*y, 2.500001 translate <32, 0, 0> }
      }
      difference {
        cylinder { 0*y, 3.1*y, 3.9 }
        #local counter = 0;
        #while (counter < 16)
        difference {
          box { <-0.4, -1, -4> <0.4, 0.8, 0> }
          box { <-1, -2, 0> <0, 1, 5> rotate 5*y translate <-0.4, 0, -4> }
          box { <0, -2, 0> <1, 1, 5> rotate -5*y translate <0.4, 0, -4> }
          rotate (5.625+(counter*22.5))*y
        }
        #local counter = counter + 1;
        #end
        cylinder { -1*y, 5*y, 2.5 }
      }
      difference {
        cylinder { 0*y, 3.1*y, 3.9 }
        #local counter = 0;
        #while (counter < 16)
        difference {
          box { <-0.4, -1, -4> <0.4, 0.8, 0> }
          box { <-1, -2, 0> <0, 1, 5> rotate 5*y translate <-0.4, 0, -4> }
          box { <0, -2, 0> <1, 1, 5> rotate -5*y translate <0.4, 0, -4> }
          rotate (5.625+(counter*22.5))*y
        }
        #local counter = counter + 1;
        #end
        cylinder { -1*y, 5*y, 2.5 }
        translate <32, 0, 0>
      }
      object { open_rounded_button() translate <8, 0, 0> }
      object { open_rounded_button() translate <24, 0, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <24, 3.1, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <36, 4.9, 4> } }
    }
  #end
#end
#macro tech_f_block1_6(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-0.000001, -0.000001, -3.900001> <40.000001, 3.100001, 3.900001> }
        box { <-1, -1, -5> <4, 0.800001, 5> }
        box { <0, -1, -2.4> <4, 2, 2.4> }
        box { <36, -1, -2.4> <41, 2, 2.4> }
        box { <36, -1, -5> <45, 0.800001, 5> }
        #if (setting > 1)
          box { <5, -1, -2.4> <35, 2, 2.4> }
        #end
        cylinder { -1*y, 5*y, 2.500001 }
        cylinder { -1*y, 5*y, 2.500001 translate <40, 0, 0> }
      }
      difference {
        cylinder { 0*y, 3.1*y, 3.9 }
        #local counter = 0;
        #while (counter < 16)
        difference {
          box { <-0.4, -1, -4> <0.4, 0.8, 0> }
          box { <-1, -2, 0> <0, 1, 5> rotate 5*y translate <-0.4, 0, -4> }
          box { <0, -2, 0> <1, 1, 5> rotate -5*y translate <0.4, 0, -4> }
          rotate (5.625+(counter*22.5))*y
        }
        #local counter = counter + 1;
        #end
        cylinder { -1*y, 5*y, 2.5 }
      }
      difference {
        cylinder { 0*y, 3.1*y, 3.9 }
        #local counter = 0;
        #while (counter < 16)
        difference {
          box { <-0.4, -1, -4> <0.4, 0.8, 0> }
          box { <-1, -2, 0> <0, 1, 5> rotate 5*y translate <-0.4, 0, -4> }
          box { <0, -2, 0> <1, 1, 5> rotate -5*y translate <0.4, 0, -4> }
          rotate (5.625+(counter*22.5))*y
        }
        #local counter = counter + 1;
        #end
        cylinder { -1*y, 5*y, 2.5 }
        translate <40, 0, 0>
      }
      #if (setting > 1)
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
        object { pin(2) translate <28, 0, 0> }
      #end
      object { open_rounded_button() translate <8, 0, 0> }
      object { open_rounded_button() translate <16, 0, 0> }
      object { open_rounded_button() translate <24, 0, 0> }
      object { open_rounded_button() translate <32, 0, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <16, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <24, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <32, 3.1, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 4.9, 4> } }
    }
  #end
#end
#macro tech_f_block1_8(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-0.000001, -0.000001, -3.900001> <56.000001, 3.100001, 3.900001> }
        box { <-1, -1, -5> <4, 0.800001, 5> }
        box { <0, -1, -2.4> <4, 2, 2.4> }
        box { <52, -1, -2.4> <57, 2, 2.4> }
        box { <52, -1, -5> <61, 0.800001, 5> }
        #if (setting > 1)
          box { <5, -1, -2.4> <51, 2, 2.4> }
        #end
        cylinder { -1*y, 5*y, 2.500001 }
        cylinder { -1*y, 5*y, 2.500001 translate <56, 0, 0> }
      }
      difference {
        cylinder { 0*y, 3.1*y, 3.9 }
        #local counter = 0;
        #while (counter < 16)
        difference {
          box { <-0.4, -1, -4> <0.4, 0.8, 0> }
          box { <-1, -2, 0> <0, 1, 5> rotate 5*y translate <-0.4, 0, -4> }
          box { <0, -2, 0> <1, 1, 5> rotate -5*y translate <0.4, 0, -4> }
          rotate (5.625+(counter*22.5))*y
        }
        #local counter = counter + 1;
        #end
        cylinder { -1*y, 5*y, 2.5 }
      }
      difference {
        cylinder { 0*y, 3.1*y, 3.9 }
        #local counter = 0;
        #while (counter < 16)
        difference {
          box { <-0.4, -1, -4> <0.4, 0.8, 0> }
          box { <-1, -2, 0> <0, 1, 5> rotate 5*y translate <-0.4, 0, -4> }
          box { <0, -2, 0> <1, 1, 5> rotate -5*y translate <0.4, 0, -4> }
          rotate (5.625+(counter*22.5))*y
        }
        #local counter = counter + 1;
        #end
        cylinder { -1*y, 5*y, 2.5 }
        translate <56, 0, 0>
      }
      #if (setting > 1)
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
        object { pin(2) translate <28, 0, 0> }
        object { pin(2) translate <36, 0, 0> }
        object { pin(2) translate <44, 0, 0> }
      #end
      object { open_rounded_button() translate <8, 0, 0> }
      object { open_rounded_button() translate <16, 0, 0> }
      object { open_rounded_button() translate <24, 0, 0> }
      object { open_rounded_button() translate <32, 0, 0> }
      object { open_rounded_button() translate <40, 0, 0> }
      object { open_rounded_button() translate <48, 0, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <16, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <24, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <32, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <40, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <48, 3.1, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 4> } }
    }
  #end
#end
#macro tech_f_block1_10(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <75.9, 3.1, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-0.000001, -0.000001, -3.900001> <72.000001, 3.100001, 3.900001> }
        box { <-1, -1, -5> <4, 0.800001, 5> }
        box { <0, -1, -2.4> <4, 2, 2.4> }
        box { <68, -1, -2.4> <73, 2, 2.4> }
        box { <68, -1, -5> <77, 0.800001, 5> }
        #if (setting > 1)
          box { <5, -1, -2.4> <67, 2, 2.4> }
        #end
        cylinder { -1*y, 5*y, 2.500001 }
        cylinder { -1*y, 5*y, 2.500001 translate <72, 0, 0> }
      }
      difference {
        cylinder { 0*y, 3.1*y, 3.9 }
        #local counter = 0;
        #while (counter < 16)
        difference {
          box { <-0.4, -1, -4> <0.4, 0.8, 0> }
          box { <-1, -2, 0> <0, 1, 5> rotate 5*y translate <-0.4, 0, -4> }
          box { <0, -2, 0> <1, 1, 5> rotate -5*y translate <0.4, 0, -4> }
          rotate (5.625+(counter*22.5))*y
        }
        #local counter = counter + 1;
        #end
        cylinder { -1*y, 5*y, 2.5 }
      }
      difference {
        cylinder { 0*y, 3.1*y, 3.9 }
        #local counter = 0;
        #while (counter < 16)
        difference {
          box { <-0.4, -1, -4> <0.4, 0.8, 0> }
          box { <-1, -2, 0> <0, 1, 5> rotate 5*y translate <-0.4, 0, -4> }
          box { <0, -2, 0> <1, 1, 5> rotate -5*y translate <0.4, 0, -4> }
          rotate (5.625+(counter*22.5))*y
        }
        #local counter = counter + 1;
        #end
        cylinder { -1*y, 5*y, 2.5 }
        translate <72, 0, 0>
      }
      #if (setting > 1)
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
        object { pin(2) translate <28, 0, 0> }
        object { pin(2) translate <36, 0, 0> }
        object { pin(2) translate <44, 0, 0> }
        object { pin(2) translate <52, 0, 0> }
        object { pin(2) translate <60, 0, 0> }
      #end
      object { open_rounded_button() translate <8, 0, 0> }
      object { open_rounded_button() translate <16, 0, 0> }
      object { open_rounded_button() translate <24, 0, 0> }
      object { open_rounded_button() translate <32, 0, 0> }
      object { open_rounded_button() translate <40, 0, 0> }
      object { open_rounded_button() translate <48, 0, 0> }
      object { open_rounded_button() translate <56, 0, 0> }
      object { open_rounded_button() translate <64, 0, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <16, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <24, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <32, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <40, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <48, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <56, 3.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <64, 3.1, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 4.9, 4> } }
    }
  #end
#end
#macro tech_f_block2_10(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <75.9, 3.1, 11.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          merge {
            box { <-3.9, 0, -3.9> <75.9, 3.1, 11.9> }
            #if (setting < 3)
              cylinder { 3*y, 4.8*y, 2.4 }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <72, 0, 0> }
            #else
              object { rounded_button() }
              object { rounded_button() translate <8, 0, 0> }
              object { rounded_button() translate <16, 0, 0> }
              object { rounded_button() translate <24, 0, 0> }
              object { rounded_button() translate <32, 0, 0> }
              object { rounded_button() translate <40, 0, 0> }
              object { rounded_button() translate <48, 0, 0> }
              object { rounded_button() translate <56, 0, 0> }
              object { rounded_button() translate <64, 0, 0> }
              object { rounded_button() translate <72, 0, 0> }
              object { rounded_button() translate <0, 0, 8> }
              object { rounded_button() translate <8, 0, 8> }
              object { rounded_button() translate <16, 0, 8> }
              object { rounded_button() translate <24, 0, 8> }
              object { rounded_button() translate <32, 0, 8> }
              object { rounded_button() translate <40, 0, 8> }
              object { rounded_button() translate <48, 0, 8> }
              object { rounded_button() translate <56, 0, 8> }
              object { rounded_button() translate <64, 0, 8> }
              object { rounded_button() translate <72, 0, 8> }
            #end
          }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <74.4, 2, 10.4> }
            cylinder { 1*y, 4*y, 1.2 }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <64, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <72, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <64, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <72, 0, 8> }
          #end
        }
        #if (setting > 1)
          object { ring() translate <4, 0, 4> }
          object { ring() translate <12, 0, 4> }
          object { ring() translate <20, 0, 4> }
          object { ring() translate <28, 0, 4> }
          object { ring() translate <36, 0, 4> }
          object { ring() translate <44, 0, 4> }
          object { ring() translate <52, 0, 4> }
          object { ring() translate <60, 0, 4> }
          object { ring() translate <68, 0, 4> }
        #end
      }
      cylinder { -1*y, 4*y, 2.600001 translate <4, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <12, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <20, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <28, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <36, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <44, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <52, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <60, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <68, 0, 4> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 4.9, 12> } }
    }
  #end
#end
#macro tech_f_block2_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          merge {
            box { <-3.9, 0, -3.9> <27.9, 3.1, 11.9> }
            #if (setting < 3)
              cylinder { 3*y, 4.8*y, 2.4 }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            #else
              object { rounded_button() }
              object { rounded_button() translate <8, 0, 0> }
              object { rounded_button() translate <16, 0, 0> }
              object { rounded_button() translate <24, 0, 0> }
              object { rounded_button() translate <0, 0, 8> }
              object { rounded_button() translate <8, 0, 8> }
              object { rounded_button() translate <16, 0, 8> }
              object { rounded_button() translate <24, 0, 8> }
            #end
          }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <26.4, 2, 10.4> }
            cylinder { 1*y, 4*y, 1.2 }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          #end
        }
        #if (setting > 1)
          object { ring() translate <4, 0, 4> }
          object { ring() translate <12, 0, 4> }
          object { ring() translate <20, 0, 4> }
        #end
      }
      cylinder { -1*y, 4*y, 2.600001 translate <4, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <12, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <20, 0, 4> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 4.9, 12> } }
    }
  #end
#end
#macro tech_f_block2_6(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 3.1, 11.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          merge {
            box { <-3.9, 0, -3.9> <43.9, 3.1, 11.9> }
            #if (setting < 3)
              cylinder { 3*y, 4.8*y, 2.4 }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
            #else
              object { rounded_button() }
              object { rounded_button() translate <8, 0, 0> }
              object { rounded_button() translate <16, 0, 0> }
              object { rounded_button() translate <24, 0, 0> }
              object { rounded_button() translate <32, 0, 0> }
              object { rounded_button() translate <40, 0, 0> }
              object { rounded_button() translate <0, 0, 8> }
              object { rounded_button() translate <8, 0, 8> }
              object { rounded_button() translate <16, 0, 8> }
              object { rounded_button() translate <24, 0, 8> }
              object { rounded_button() translate <32, 0, 8> }
              object { rounded_button() translate <40, 0, 8> }
            #end
          }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <42.4, 2, 10.4> }
            cylinder { 1*y, 4*y, 1.2 }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
          #end
        }
        #if (setting > 1)
          object { ring() translate <4, 0, 4> }
          object { ring() translate <12, 0, 4> }
          object { ring() translate <20, 0, 4> }
          object { ring() translate <28, 0, 4> }
          object { ring() translate <36, 0, 4> }
        #end
      }
      cylinder { -1*y, 4*y, 2.600001 translate <4, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <12, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <20, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <28, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <36, 0, 4> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 4.9, 12> } }
    }
  #end
#end
#macro tech_f_block2_8(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 3.1, 11.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          merge {
            box { <-3.9, 0, -3.9> <59.9, 3.1, 11.9> }
            #if (setting < 3)
              cylinder { 3*y, 4.8*y, 2.4 }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <48, 0, 8> }
              cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 8> }
            #else
              object { rounded_button() }
              object { rounded_button() translate <8, 0, 0> }
              object { rounded_button() translate <16, 0, 0> }
              object { rounded_button() translate <24, 0, 0> }
              object { rounded_button() translate <32, 0, 0> }
              object { rounded_button() translate <40, 0, 0> }
              object { rounded_button() translate <48, 0, 0> }
              object { rounded_button() translate <56, 0, 0> }
              object { rounded_button() translate <0, 0, 8> }
              object { rounded_button() translate <8, 0, 8> }
              object { rounded_button() translate <16, 0, 8> }
              object { rounded_button() translate <24, 0, 8> }
              object { rounded_button() translate <32, 0, 8> }
              object { rounded_button() translate <40, 0, 8> }
              object { rounded_button() translate <48, 0, 8> }
              object { rounded_button() translate <56, 0, 8> }
            #end
          }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <58.4, 2, 10.4> }
            cylinder { 1*y, 4*y, 1.2 }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <48, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <40, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <48, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <56, 0, 8> }
          #end
        }
        #if (setting > 1)
          object { ring() translate <4, 0, 4> }
          object { ring() translate <12, 0, 4> }
          object { ring() translate <20, 0, 4> }
          object { ring() translate <28, 0, 4> }
          object { ring() translate <36, 0, 4> }
          object { ring() translate <44, 0, 4> }
          object { ring() translate <52, 0, 4> }
        #end
      }
      cylinder { -1*y, 4*y, 2.600001 translate <4, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <12, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <20, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <28, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <36, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <44, 0, 4> }
      cylinder { -1*y, 4*y, 2.600001 translate <52, 0, 4> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 4.9, 12> } }
    }
  #end
#end
#macro tech_gear_12_tooth(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 3.9*x, 6.5 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { -3.8*x, 3.8*x, 3.85 }
          cylinder { -3.9*x, 3.9*x, 2.8 }
          cylinder { -1.4*x, 1.4*x, 4.05 }
        }
        object { axle_opening(8,2) translate <-4, 0, 0> }
      }
      #local counter = 0;
      #while (counter < 12)
        difference {
          box { <-3.800001, 3, -0.65> <3.800001, 6.5, 0.65> }
          box { <-4, -5, -2> <4, 1, 0> rotate -8*x translate <0, 6, -0.65> }
          box { <-4, -1, -2> <4, 5, 0> rotate 8*x translate <0, 6, -0.65> }
          box { <-4, -5, 0> <4, 1, 2> rotate 8*x translate <0, 6, 0.65> }
          box { <-4, -1, 0> <4, 5, 2> rotate -8*x translate <0, 6, 0.65> }
          box { <0, 0, -5> <4, 4.5, 0> rotate 35*x rotate 47.5*z translate <-3.8, 4.05, -0.65> }
          box { <0, 0, 0> <4, 4.5, 5> rotate -35*x rotate 47.5*z translate <-3.8, 4.05, 0.65> }
          box { <0, 0, -5> <-4, 4.5, 0> rotate 35*x rotate -47.5*z translate <3.8, 4.05, -0.65> }
          box { <0, 0, 0> <-4, 4.5, 5> rotate -35*x rotate -47.5*z translate <3.8, 4.05, 0.65> }
          box { <0, 0, -1> <5, 5, 1> rotate 45*z translate <-3.8, 5.85, 0> }
          box { <0, 0, -1> <-5, 5, 1> rotate -45*z translate <3.8, 5.85, 0> }
          box { <-4, 6, -1> <-1.4, 8, 1> }
          box { <4, 6, -1> <1.4, 8, 1> }
          rotate (30 * counter)*x
        }
        #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { cylinder { -4*x, 4*x, 6.6 } }
    }
  #end
#end
#macro tech_gear_12_tooth_flat(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 0*x, 6.4 texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          merge {
            cylinder { -3.8*x, -1.000001*x, 3.85 }
            cylinder { -1.4*x, -1.000002*x, 6.5 }
            difference {
              cylinder { -1.5*x, 0*x, 4.5 }
              cylinder { -3*x, 1*x, 3.75 }
            }
          }
          object { axle_opening(8,1) translate <-4, 0, 0> }
          box { <-5, -3.35, -0.35> <1, 3.35, 0.35> }
          box { <-5, -0.35, -3.35> <1, 0.35, 3.35> }
        }
        #local counter = 0;
        #while (counter < 12)
          difference {
            box { <-3.800001, 3, -0.65> <-1, 6.5, 0.65> }
            box { <-4, -5, -2> <4, 1, 0> rotate -8*x translate <0, 6, -0.65> }
            box { <-4, -1, -2> <4, 5, 0> rotate 8*x translate <0, 6, -0.65> }
            box { <-4, -5, 0> <4, 1, 2> rotate 8*x translate <0, 6, 0.65> }
            box { <-4, -1, 0> <4, 5, 2> rotate -8*x translate <0, 6, 0.65> }
            box { <0, 0, -5> <4, 4.5, 0> rotate 35*x rotate 47.5*z translate <-3.8, 4.05, -0.65> }
            box { <0, 0, 0> <4, 4.5, 5> rotate -35*x rotate 47.5*z translate <-3.8, 4.05, 0.65> }
            box { <0, 0, -1> <5, 5, 1> rotate 45*z translate <-3.8, 5.85, 0> }
            rotate (30 * counter)*x
          }
          #local counter = counter + 1;
        #end
      }
      cylinder { -4*x, -1.400001*x, 0.45 translate <0, 3, 0> rotate 45*x }
      box { <-4, 3, -0.45> <-1.40002, 4, 0.45> rotate 45*x }
      cylinder { -4*x, -1.400001*x, 0.45 translate <0, 3, 0> rotate 135*x }
      box { <-4, 3, -0.45> <-1.40002, 4, 0.45> rotate 135*x }
      cylinder { -4*x, -1.400001*x, 0.45 translate <0, 3, 0> rotate 225*x }
      box { <-4, 3, -0.45> <-1.40002, 4, 0.45> rotate 225*x }
      cylinder { -4*x, -1.400001*x, 0.45 translate <0, 3, 0> rotate 315*x }
      box { <-4, 3, -0.45> <-1.40002, 4, 0.45> rotate 315*x }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 0*x, 6.5 } }
    }
  #end
#end
#macro tech_gear_14_tooth_bevel(color_tex)
  #if (setting = 0)
    cylinder { 0.8*x, 2.6*x, 7.9 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { 0*x, 0.9*x, 4.5 }
        cylinder { -1*x, 1*x, 3.4 }
      }
      difference {
        cone { 0.8*x, 5.3, 2.6*x, 4 }
        object { axle_opening(3,1) }
      }
      #local counter = 0;
      #while ( counter < 14 )
        difference {
          box { <0.800001, 3.9, -0.7> <2.59999, 7.9, 0.7> }
          box { <0, 0, -1> <2, 2, 1> rotate 40*z translate <2.6, 6.9, 0> }
          rotate (counter * 25.714285714 ) * x
        }
        #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*x, 2.7*x, 8 } }
    }
  #end
#end
#macro tech_gear_16_tooth(color_tex)
  #if (setting = 0)
    cylinder { -1.9*x, 1.9*x, 8.8 texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          cylinder { -1.899999*x, 1.899999*x, 6.5 }
          cylinder { -2*x, -0.899999*x, 5.7 }
          cylinder { 0.899999*x, 2*x, 5.7 }
        }
        #local counter = 0;
        #while (counter < 16)
          difference {
            box { <-1.9, 6.3, -0.75> <1.9, 8.8, 0.75> }
            box { <-2, 0, 0> <2, 2, 2> rotate -15*x translate <0, 7.8, 0.75> }
            box { <-2, 0, -2> <2, 2, 0> rotate 15*x translate <0, 7.8, -0.75> }
            rotate (22.5 * counter)*x
          }
          #local counter = counter + 1;
        #end
        cylinder { -1.900002*x, 1.900002 *x, 2.6 translate <0, 4, 0> }
        cylinder { -1.900002 *x, 1.900002 *x, 2.6 translate <0, -4, 0> }
        cylinder { -1.900002 *x, 1.900002 *x, 2.6 translate <0, 0, -4> }
        cylinder { -1.900002 *x, 1.900002 *x, 2.6 translate <0, 0, 4> }
        cylinder { -3.9*x, 3.9*x, 3.7 }
      }
      box { <-5, -1, -4> <5, 1, 4> }
      box { <-5, -4, -1> <5, 4, 1> }
      cylinder { -5*x, 5*x, 1.600001 translate <0, 4, 0> }
      cylinder { -5*x, 5*x, 1.600001 translate <0, -4, 0> }
      cylinder { -5*x, 5*x, 1.600001 translate <0, 0, -4> }
      cylinder { -5*x, 5*x, 1.600001 translate <0, 0, 4> }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 4*x, 8.9 } }
    }
  #end
#end
#macro tech_gear_20_tooth(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 3.9*x, 10.5 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { -3.9*x, 3.9*x, 2.8 }
        object { axle_opening(8,2) scale <1, 1.000001, 1.000001> translate <-4, 0, 0> }
      }
      difference {
        cylinder { -3.8*x, 3.8*x, 7.7 }
        cylinder { -4*x, 4*x, 6.5 }
      }
      difference {
        cylinder { -3.800005*x, 3.800005*x, 4.5 }
        object { axle_opening(8,2) translate <-4, 0, 0> }
        cylinder { -4*x, 4*x, 2.5 translate <0, 4, -4> }
        cylinder { -4*x, 4*x, 2.5 translate <0, 4, 4> }
        cylinder { -4*x, 4*x, 2.5 translate <0, -4, -4> }
        cylinder { -4*x, 4*x, 2.5 translate <0, -4, 4> }
      }
      box { <-3.800003, -0.55, -6.6> <3.800003, 0.55, -4.4> }
      box { <-3.800003, -0.55, 4.4> <3.800003, 0.55, 6.6> }
      box { <-3.800003, -6.6, -0.55> <3.800003, -4.4, 0.55> }
      box { <-3.800003, 4.4, -0.55> <3.800003, 6.6, 0.55> }
      box { <-0.6, -1.5, -6.6> <0.6, 1.5, -4.4> }
      box { <-0.6, -1.5, 4.4> <0.6, 1.5, 6.6> }
      box { <-0.6, -6.6, -1.5> <0.6, -4.4, 1.5> }
      box { <-0.6, 4.4, -1.5> <0.6, 6.6, 1.5> }
      #local counter = 0;
      #while (counter < 20)
        difference {
          box { <-3.800001, 7, -0.65> <3.800001, 10.5, 0.65> }
          box { <-4, -5, -2> <4, 1, 0> rotate -8*x translate <0, 10, -0.65> }
          box { <-4, -1, -2> <4, 5, 0> rotate 8*x translate <0, 10, -0.65> }
          box { <-4, -5, 0> <4, 1, 2> rotate 8*x translate <0, 10, 0.65> }
          box { <-4, -1, 0> <4, 5, 2> rotate -8*x translate <0, 10, 0.65> }
          box { <0, 0, -5> <4, 4.5, 0> rotate 35*x rotate 47.5*z translate <-3.8, 8.05, -0.65> }
          box { <0, 0, 0> <4, 4.5, 5> rotate -35*x rotate 47.5*z translate <-3.8, 8.05, 0.65> }
          box { <0, 0, -5> <-4, 4.5, 0> rotate 35*x rotate -47.5*z translate <3.8, 8.05, -0.65> }
          box { <0, 0, 0> <-4, 4.5, 5> rotate -35*x rotate -47.5*z translate <3.8, 8.05, 0.65> }
          box { <0, 0, -1> <5, 5, 1> rotate 45*z translate <-3.8, 9.85, 0> }
          box { <0, 0, -1> <-5, 5, 1> rotate -45*z translate <3.8, 9.85, 0> }
          box { <-4, 10, -1> <-1.4, 12, 1> }
          box { <4, 10, -1> <1.4, 12, 1> }
          rotate (18 * counter)*x
        }
        #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { cylinder { -4*x, 4*x, 10.6 } }
    }
  #end
#end
#macro tech_gear_20_tooth_flat(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 0*x, 10.4 texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          merge {
            cylinder { -3.8*x, -1.000001*x, 7.85 }
            cylinder { -1.4*x, -1.000002*x, 10.5 }
            difference {
              merge {
                cylinder { -1.5*x, 0*x, 4.5 }
                cylinder { -1.500001*x, 0.000001*x, 1.1 translate <0, 0, -4.5> }
                cylinder { -1.500001*x, 0.000001*x, 1.1 translate <0, 0, 4.5> }
              }
              cylinder { -3*x, 1*x, 3.75 }
            }
          }
          difference {
            cone { -2*x, 6.5, -0.999995*x, 8 }
            cylinder { -1.1*x, 0*x, 4.500001 }
            cylinder { -1.100001*x, 0.000001*x, 1.100001 translate <0, 0, -4.5> }
            cylinder { -1.100001*x, 0.000001*x, 1.100001 translate <0, 0, 4.5> }
          }
          object { axle_opening(8,1) translate <-4, 0, 0> }
          box { <-6, -0.35, -4> <2, 0.35, 4> }
          cylinder { -6*x, 2*x, 0.35 translate <0, 0, -4> }
          cylinder { -6*x, 2*x, 0.35 translate <0, 0, 4> }
        }
        #local counter = 0;
        #while (counter < 20)
          difference {
            box { <-3.800001, 7, -0.65> <-1, 10.5, 0.65> }
            box { <-4, -5, -2> <4, 1, 0> rotate -8*x translate <0, 10, -0.65> }
            box { <-4, -1, -2> <4, 5, 0> rotate 8*x translate <0, 10, -0.65> }
            box { <-4, -5, 0> <4, 1, 2> rotate 8*x translate <0, 10, 0.65> }
            box { <-4, -1, 0> <4, 5, 2> rotate -8*x translate <0, 10, 0.65> }
            box { <0, 0, -5> <4, 4.5, 0> rotate 35*x rotate 47.5*z translate <-3.8, 8.05, -0.65> }
            box { <0, 0, 0> <4, 4.5, 5> rotate -35*x rotate 47.5*z translate <-3.8, 8.05, 0.65> }
            box { <0, 0, -1> <5, 5, 1> rotate 45*z translate <-3.8, 9.85, 0> }
            rotate (18 * counter)*x
          }
          #local counter = counter + 1;
        #end
      }
      difference {
        cone { -2*x, 6.5, -0.999995*x, 8 }
        cylinder { -2.1*x, 0*x, 4.500001 }
        cylinder { -2.1*x, 0.000001*x, 1.100001 translate <0, 0, -4.5> }
        cylinder { -2.1*x, 0.000001*x, 1.100001 translate <0, 0, 4.5> }
      }
      cylinder { 1*x, -2.5*x, 0.6 translate <0, 5.5, -1.5> }
      cylinder { 1*x, -2.5*x, 0.6 translate <0, 5.5, 1.5> }
      cylinder { 1*x, -2.5*x, 0.6 translate <0, -5.5, -1.5> }
      cylinder { 1*x, -2.5*x, 0.6 translate <0, -5.5, 1.5> }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 0.1*x, 10.5 } }
    }
  #end
#end
#macro tech_gear_24_tooth(color_tex)
  #if (setting = 0)
    cylinder { -1.9*x, 1.9*x, 10.75 texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          cylinder { -1.899999*x, 1.899999*x, 10.75 }
          cylinder { -2*x, -0.899999*x, 9.8 }
          cylinder { 0.899999*x, 2*x, 9.8 }
        }
        #local counter = 0;
        #while (counter < 24)
          difference {
            box { <-1.9, 10.3, -0.75> <1.9, 12.8, 0.75> }
            box { <-2, 0, 0> <2, 2, 2> rotate -22.5*x translate <0, 11.8, 0.75> }
            box { <-2, 0, -2> <2, 2, 0> rotate 22.5*x translate <0, 11.8, -0.75> }
            rotate (15 * counter)*x
          }
          #local counter = counter + 1;
        #end
        cylinder { -3*x, 3*x, 3.2 translate <0, -4, -4> }
        cylinder { -3*x, 3*x, 3.2 translate <0, -4, 4> }
        cylinder { -3*x, 3*x, 3.2 translate <0, 4, -4> }
        cylinder { -3*x, 3*x, 3.2 translate <0, 4, 4> }
        box { <-3.900001, -4.8, -4> <3.900001, 4.8, 4> }
      }
      box { <-5, -1.000001, -6> <5, 1.000001, 6> }
      object { axle_opening(10,1) translate <-5, 0, 0> }
      cylinder { -5*x, -3.000002*x, 3.200001 translate <0, -4, -4> }
      cylinder { -5*x, -3.000002*x, 3.200001 translate <0, -4, 4> }
      cylinder { -5*x, -3.000002*x, 3.200001 translate <0, 4, -4> }
      cylinder { -5*x, -3.000002*x, 3.200001 translate <0, 4, 4> }
      cylinder { 5*x, 3.000002*x, 3.200001 translate <0, -4, -4> }
      cylinder { 5*x, 3.000002*x, 3.200001 translate <0, -4, 4> }
      cylinder { 5*x, 3.000002*x, 3.200001 translate <0, 4, -4> }
      cylinder { 5*x, 3.000002*x, 3.200001 translate <0, 4, 4> }
      cylinder { -4*x, 4*x, 2.6 translate <0, -4, -4> }
      cylinder { -4*x, 4*x, 2.6 translate <0, -4, 4> }
      cylinder { -4*x, 4*x, 2.6 translate <0, 4, -4> }
      cylinder { -4*x, 4*x, 2.6 translate <0, 4, 4> }
      box { <-4, -0.9, -2.5> <4, 0.9, 2.5> rotate -45*x translate <0, 0, -6> }
      box { <-4, -0.9, -2.5> <4, 0.9, 2.5> rotate 45*x translate <0, 0, -6> }
      box { <-4, -0.9, -2.5> <4, 0.9, 2.5> rotate -45*x translate <0, 0, 6> }
      box { <-4, -0.9, -2.5> <4, 0.9, 2.5> rotate 45*x translate <0, 0, 6> }
      box { <-4, -0.5, -4> <4, 0.5, 4> rotate -45*x translate <0, 0, -6> }
      box { <-4, -0.5, -4> <4, 0.5, 4> rotate 45*x translate <0, 0, -6> }
      box { <-4, -0.5, -4> <4, 0.5, 4> rotate -45*x translate <0, 0, 6> }
      box { <-4, -0.5, -4> <4, 0.5, 4> rotate 45*x translate <0, 0, 6> }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 4*x, 12.9 } }
    }
  #end
#end
#macro tech_gear_24_tooth_crown(color_tex)
  #if (setting = 0)
    cylinder { 1*x, 3.25*x, 12.7 texture { color_tex } }
  #else
    difference {
      merge {
        cone { -3.8*x, 3.25, -3.1*x, 3.7 }
        cylinder { -3.100001*x, 3.100001*x, 3.7 }
        cone { 3.1*x, 3.7, 3.8*x, 3.25 }
        difference {
         cylinder { 1*x, 3.25*x, 10.55 }
          difference {
            cylinder { 0*x, 4*x, 6.4 }
            box { <0, -2.55, -11> <4, 2.55, 11> }
            box { <0, -8, -0.5> <4, 8, 0.5> rotate 30*x }
            box { <0, -8, -0.5> <4, 8, 0.5> rotate -30*x }
          }
        }
        box { <0, 0, -0.500001> <1.5, 4, 0.500001> rotate -30*z translate <-0.9, 3.7, 0> rotate -30*x }
        box { <0, 0, -0.500001> <1.5, 4, 0.500001> rotate -30*z translate <-0.9, 3.7, 0> rotate 30*x }
        box { <0, 0, -0.500001> <1.5, -4, 0.500001> rotate 30*z translate <-0.9, 3.7, 0> rotate -30*x }
        box { <0, 0, -0.500001> <1.5, -4, 0.500001> rotate 30*z translate <-0.9, 3.7, 0> rotate 30*x }
        torus { 9, 1 rotate 90*z translate <3, 0, 0> }
        #local counter = 0;
        #while (counter < 24)
          merge {
            difference {
              cylinder { -0.85*z, 0.85*z, 2.25 }
              box { <-3, -3, -1> <0, 3, 1> }
              box { <-1, 0, -1> <3, 3, 0> rotate 15*x translate <0, 0.5, -1> }
              box { <-1, 0, 0> <3, 3, 1> rotate -15*x translate <0, 0.5, 1> }
              translate <1, 10.55, 0>
            }
            cone { -0.6*x, 0.400001, 1.000001*x, 0.75 translate <0, 12.1, 0> }
            sphere { <-0.6, 12.1, 0> 0.4 }
            cylinder { 0*y, -4*y, 0.41 rotate 35*z translate <-0.6, 12.1, 0> }
            difference {
              box { <-0.61, 5, -2> <1.1, 12.1, 2> }
              box { <-10, -10, -1> <0, 0, 1> rotate 35*z translate <-0.600005, 12.1, 0> }
              box { <0, -10, -5> <10, 10, 0> rotate 10.5*y rotate -7.5*x translate <-0.6, 12.1, -0.415> }
              box { <0, -10, 5> <10, 10, 0> rotate -10.5*y rotate 7.5*x translate <-0.6, 12.1, 0.415> }
              box { <-1, 12.1, -2> <2, 20, 2> }
            }
            rotate (15 * counter)*x
          }
          #local counter = counter + 1;
        #end
      }
      object { axle_opening(10,1) translate <-5, 0, 0> }
      box { <-4, -0.45, -5.35> <4, 0.45, 5.35> }
      texture { color_tex }
      bounded_by { cylinder { -3.9*x, 3.9*x, 12.8 } }
    }
  #end
#end
#macro tech_gear_8_teeth(color_tex)
  #if (setting = 0)
    cylinder { -3.9*z, 3.9*z, 7.8 texture { color_tex } }
  #else
    merge {
      #local counter = 0;
      #while (counter < 8)
        box { <-0.6, 3.55, -3.900001> <0.6, 7, 3.900001> rotate (counter*45)*z }
        cylinder { -3.900002*z, 3.900002*z, 0.5 scale <0.5, 1, 1>
          translate <-1.4, 7.3, 0> rotate (counter*45)*z }
        cylinder { -3.900002*z, 3.900002*z, 0.5 scale <0.5, 1, 1>
          translate <1.4, 7.3, 0> rotate (counter*45)*z }
        box { <-1.400005, 6.800005, -3.900007> <1.400005, 7.799995, 3.900007> rotate (counter*45)*z }
        #local counter = counter + 1;
      #end
      difference {
        cylinder { -3.9*z, 3.9*z, 3.65 }
        object { axle_opening(8,1) rotate -90*y translate <0, 0, -4> }
      }
      texture { color_tex }
      bounded_by { cylinder { -4*z, 4*z, 7.9 } }
    }
  #end
#end
#macro tech_gear_8_tooth(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 3.9*x, 2.8 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { -3.9*x, 3.9*x, 2.8 }
        object { axle_opening(8,1) translate <-4, 0, 0> }
      }
      #local counter = 0;
      #while (counter < 8)
        difference {
          box { <-1.9, 2.7, -0.75> <1.9, 4.8, 0.75> }
          box { <-2, 0, 0> <2, 2, 2> rotate -22.5*x translate <0, 3.8, 0.75> }
          box { <-2, 0, -2> <2, 2, 0> rotate 22.5*x translate <0, 3.8, -0.75> }
          box { <-2, -2, 0> <2, 0, 2> rotate 15*x translate <0, 3.8, 0.75> }
          box { <-2, -2, -2> <2, 0, 0> rotate -15*x translate <0, 3.8, -0.75> }
          rotate (45 * counter)*x
        }
        #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { cylinder { -4*x, 4*x, 4.9 } }
    }
  #end
#end
#macro tech_gear_block1_4(color_tex, age)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 5.8, 3.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
          #local counter = 0;
          #while (counter < 10)
            difference {
              box { <-1.15, 3.099995, -3.900001> <1.15, 5.8, 3.900001> }
              box { <-2, -2, -4> <0, 4, 4> rotate -16.5*z translate <-1.15, 3.1, 0> }
              box { <0, -2, -4> <2, 4, 4> rotate 16.5*z translate <1.15, 3.1, 0> }            
              translate <-2.15+(counter*3.15), 0, 0>
            }
            #local counter = counter + 1;
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
        #end
        #if (age > 1)
          #local counter = 0;
          #while (counter < 10)
            box { <-0.5, 1.999995, -2.399995> <0.5, 3, 2.399995> translate <-2.15+(counter*3.15), 0, 0> }
            #local counter = counter + 1;
          #end
        #end
      }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
        object { pin(age) translate <12, 0, 0> }
        object { pin(age) translate <20, 0, 0> }
      #end
      #if (age > 1)
        cylinder { 1.999994*y, 3.000004*y, 1.500005 translate <4, 0, 0> }
        cylinder { 1.999994*y, 3.000004*y, 1.500005 translate <12, 0, 0> }
        cylinder { 1.999994*y, 3.000004*y, 1.500005 translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 5.9, 4> } }
    }
  #end
#end
#macro tech_gear_differential(color_tex)
  #if (setting = 0)
    merge {
      difference {
        cylinder { -1.9*x, 22.1*x, 9.8 }
        box { <3.8, -10, -10> <20.2, 10, -3.9> }
        box { <3.8, -10, 3.9> <20.2, 10, 10> }
        box { <3.800001, -8, -10> <20.200001, 8, 10> }
      }
      cylinder { 22*x, 25.9*x, 12.8 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          cylinder { 2*x, 22*x, 9.8 }
          box { <3.8, -10, -10> <20.2, 10, -3.9> }
          box { <3.8, -10, 3.9> <20.2, 10, 10> }
          box { <3.800001, -8, -10> <20.200001, 8, 10> }
        }
        difference {
          cylinder { -3.9*x, 2.1*x, 6.8 }
          cylinder { -4*x, 3*x, 5.9 }
        }
        difference {
          cylinder { -3.9*x, 2.1*x, 3.2 }
          cylinder { -4*x, 50*x, 2.499999 }
        }
        box { <-3.5, -0.5, -6> <2.1, 0.5, -5> }
        box { <-3.5, -6, -0.5> <2.1, -5, 0.5> }
        box { <-3.5, -0.5, 5> <2.1, 0.5, 6> }
        box { <-3.5, 5, -0.5> <2.1, 6, 0.5> }
        difference {
          cylinder { 21.9*x, 27.9*x, 6.8 }
          cylinder { 20*x, 30*x, 5.9 }
        }
        difference {
          cylinder { 21.9*x, 27.9*x, 3.2 }
          cylinder { 20*x, 50*x, 2.499999 }
        }
        box { <21.9, -0.5, -6> <27.5, 0.5, -5> }
        box { <21.9, -6, -0.5> <27.5, -5, 0.5> }
        box { <21.9, -0.5, 5> <27.5, 0.5, 6> }
        box { <21.9, 5, -0.5> <27.5, 6, 0.5> }
        cylinder { -8.1*y, -4.5*y, 1.4 translate <12, 0, 0> }
        difference {
          cylinder { 21.999999*x, 25.899999*x, 10.75 }
          difference {
            cone { 22*x, 8.75, 26*x, 9.75 }
            box { <21, -11, -0.5> <25.7, -6.5, 0.5> }
            box { <21, -0.5, -11> <25.7, 0.5, -6.5> }
            box { <21, 6.5, -0.5> <25.7, 11, 0.5> }
            box { <21, -0.5, 6.5> <25.7, 0.5, 11> }
          }
        }
        #local counter = 0;
        #while (counter < 16)
          difference {
            box { <-1.9, 6.5, -0.75> <2.1, 9, 0.75> }
            box { <-2, 0, 0> <3, 2, 2> rotate -15*x translate <0, 8, 0.75> }
            box { <-2, 0, -2> <3, 2, 0> rotate 15*x translate <0, 8, -0.75> }
            rotate (22.5 * counter)*x
          }
          #local counter = counter + 1;
        #end
        #local counter = 0;
        #while (counter < 24)
          difference {
            box { <22, 10.3, -0.75> <25.9, 12.8, 0.75> }
            box { <21, 0, 0> <26, 2, 2> rotate -15*x translate <0, 11.8, 0.75> }
            box { <21, 0, -2> <26, 2, 0> rotate 15*x translate <0, 11.8, -0.75> }
            rotate (15 * counter)*x
          }
          #local counter = counter + 1;
        #end
      }
      cylinder { -4*x, 40*x, 2.5 }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 28*x, 12.9 } }
    }
  #end
#end
#macro tech_hdblock1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
        }
        object { open_rounded_button() translate <0, 6.4, 0> }
        object { open_rounded_button() translate <8, 6.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <0, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <8, 5.6, 0> }
        box { <-0.6, 0.25, -0.6> <0.6, 8.7, 0.6> rotate 45*y translate <2, 0, -2.4> }
        box { <-0.6, 0.25, -0.6> <0.6, 8.7, 0.6> rotate 45*y translate <2, 0, 2.4> }
        box { <-0.6, 0.25, -0.6> <0.6, 8.7, 0.6> rotate 45*y translate <6, 0, -2.4> }
        box { <-0.6, 0.25, -0.6> <0.6, 8.7, 0.6> rotate 45*y translate <6, 0, 2.4> }
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <0, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <8, 5.6, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 4> } }
    }
  #end
#end
#macro tech_hpblock1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 9.5, 11.9> }
      cylinder { -11.9*x, -3.8*x, 2.25 translate <0, 5.6, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          torus { 2.249995, 0.3 rotate 90*z translate <-11.600005, 5.6, 4> }
          cylinder { -11.9*x, -3.7*x, 2.25 translate <0, 5.6, 4> }
          cylinder { -4.65*x, -3.8*x, 2.9 translate <0, 5.6, 4> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <0, 6.4, 8> }
          #end
          box { <-3.9, 0, -3.9> <3.9, 9.5, 11.9> }
        }
        box { <-12, 2, 3.5> <-9.499999, 10, 4.5> }
        cylinder { 2*y, 10*y, 0.5 translate <-9.5, 0, 4> }
        cylinder { -12*x, -4*x, 1.6 translate <0, 5.6, 4> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 8.6, 10.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
        #end
      }
      #if (setting > 1)
        cylinder { 0*y, 8.7*y, 1.5 translate <0, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <4, 11.3, 12> } }
    }
  #end
#end
#macro tech_hpblock2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
      cylinder { -11.9*x, -3.8*x, 2.25 translate <0, 5.6, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          torus { 2.249995, 0.3 rotate 90*z translate <-11.600005, 5.6, 4> }
          cylinder { -11.9*x, -3.7*x, 2.25 translate <0, 5.6, 4> }
          cylinder { -4.65*x, -3.8*x, 3 translate <0, 5.6, 4> }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() translate <0, 6.4, 0> }
            object { rounded_button() translate <0, 6.4, 8> }
            object { rounded_button() translate <8, 6.4, 0> }
            object { rounded_button() translate <8, 6.4, 8> }
          #end
          box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
        }
        box { <-12, 2, 3.5> <-9.499999, 10, 4.5> }
        cylinder { 2*y, 10*y, 0.5 translate <-9.5, 0, 4> }
        cylinder { -12*x, -4*x, 1.6 translate <0, 5.6, 4> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 8.6, 10.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { ring() scale <1, 2.9, 1> translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <12, 11.3, 12> } }
    }
  #end
#end
#macro tech_hslopeblock1_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 15.9, 3.9> }
      box { <-10, 0, -10> <50, 20, 10> rotate -22.2*z translate <13, 15.9, 0> }
      box { <0, -10, -10> <50, 0, 10> rotate 12.5*z translate <13, 0, 0> }
      box { <-4, -1, -4> <12, 3.2, 4> }
      box { <-4, 12.7, -4> <12, 16, 4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <0, 12.7, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <8, 12.7, 0> }
        #end
        object { open_rounded_button() translate <0, 9.6, 0> }
        object { open_rounded_button() translate <8, 9.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 8.8, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <12, 8.8, 0> }
        difference {
          box { <-3.9, 0, -3.9> <27.9, 15.9, 3.9> }
          box { <-10, 0, -10> <50, 20, 10> rotate -22.2*z translate <13, 15.9, 0> }
          box { <0, -10, -10> <50, 0, 10> rotate 12.5*z translate <13, 0, 0> }
          box { <-2.4, -1, -2.4> <12, 11.8, 2.4> }
          #if (setting > 1)
            difference {
              box { <13.5, -1, -2.4> <26.4, 15, 2.4> }
              box { <-10, 0, -10> <50, 20, 10> rotate -22.2*z translate <13, 13.9, 0> }
              cylinder { -3.8*z, 3.8*z, 3.500001 translate <12, 8.8, 0> }
              box { <13, 1.2, -0.5> <15, 8, 0.5> }
              box { <19.2, 0, -3> <20.5, 16, 3> }
              box { <24.9, 0, -0.5> <27, 16, 0.5> }
            }
          #end
          box { <-4, -1, -4> <12, 3.2, 4> }
          box { <-4, 12.7, -4> <12, 16, 4> }
        }
        #if (setting > 1)
          object { pin(1) translate <4, 3.2, 0> }
          box { <10.4, 3.2, -0.5> <12.2, 5.6, 0.5> }
        #end
      }
      merge {
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 translate <8, 0, 0> }
        cylinder { 3.4*z, 5*z, 3.1 translate <8, 0, 0> }
        cylinder { -6*z, 6*z, 2.5 translate <8, 0, 0> }
        translate <4, 8.8, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 16, 4> } }
    }
  #end
#end
#macro tech_hslopeblock1_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 15.9, 3.9> }
      box { <-10, 0, -10> <50, 20, 10> rotate -22.2*z translate <13, 15.9, 0> }
      box { <-4, -1, -4> <12, 3.2, 4> }
      box { <-4, 12.7, -4> <12, 16, 4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        object { open_rounded_button() translate <0, 9.6, 0> }
        object { open_rounded_button() translate <8, 9.6, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <0, 12.7, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <8, 12.7, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 8.8, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <12, 8.8, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <20, 8.8, 0> }
        difference {
          box { <-3.9, 0, -3.9> <43.9, 15.9, 3.9> }
          box { <-10, 0, -10> <50, 20, 10> rotate -22.2*z translate <13, 15.9, 0> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <12, 11.8, 2.4> }
            difference {
              box { <13.5, -1, -2.4> <42.5, 15, 2.4> }
              box { <-10, 0, -10> <50, 20, 10> rotate -22.2*z translate <13, 13.9, 0> }
            }
          #end
          box { <-4, -1, -4> <12, 3.2, 4> }
          box { <-4, 12.7, -4> <12, 16, 4> }
        }
        #if (setting > 1)
          cylinder { 3.2*y, 5.5*y, 1.5 translate <4, 0, 0> }
          box { <10.4, 3.2, -0.5> <12.2, 5.5, 0.5> }
          cylinder { 0*y, 5.5*y, 1.5 translate <20, 0, 0> }
          difference {
            merge {
              cylinder { 0*y, 8.7*y, 1.5 translate <28, 0, 0> }
              cylinder { 0*y, 8.7*y, 1.5 translate <36, 0, 0> }
              box { <27.5, 0.000001, -3> <28.5, 15.1, 3> }
              box { <35.5, 0.000001, -3> <36.5, 15.1, 3> }
            }
            box { <-10, 0, -10> <50, 20, 10> rotate -22.2*z translate <13, 13.9, 0> }
          }
        #end
      }
      merge {
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 translate <8, 0, 0> }
        cylinder { 3.4*z, 5*z, 3.1 translate <8, 0, 0> }
        cylinder { -6*z, 6*z, 2.5 translate <8, 0, 0> }
        cylinder { -5*z, -3.4*z, 3.1 translate <16, 0, 0> }
        cylinder { 3.4*z, 5*z, 3.1 translate <16, 0, 0> }
        cylinder { -6*z, 6*z, 2.5 translate <16, 0, 0> }
        translate <4, 8.8, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 16, 4> } }
    }
  #end
#end
#macro tech_h_block1_1(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <3.9, 9.5, 3.9> }
          box { <-2.4, -1, -2.4> <2.4, 8.6, 2.4> }
        }
        object { open_rounded_button() translate <0, 6.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.5, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <0, 5.6, 0> }
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <0, 5.6, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <4, 11.3, 4> } }
    }
  #end
#end
#macro tech_h_block1_10(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <75.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <75.9, 9.5, 3.9> }
          box { <-2.4, -1, -2.4> <74.4, 8.6, 2.4> }
        }
        object { open_rounded_button() translate <0, 6.4, 0> }
        object { open_rounded_button() translate <8, 6.4, 0> }
        object { open_rounded_button() translate <16, 6.4, 0> }
        object { open_rounded_button() translate <24, 6.4, 0> }
        object { open_rounded_button() translate <32, 6.4, 0> }
        object { open_rounded_button() translate <40, 6.4, 0> }
        object { open_rounded_button() translate <48, 6.4, 0> }
        object { open_rounded_button() translate <56, 6.4, 0> }
        object { open_rounded_button() translate <64, 6.4, 0> }
        object { open_rounded_button() translate <72, 6.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <16, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <24, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <32, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <40, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <48, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <56, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <64, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <72, 9.5, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <12, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <20, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <28, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <36, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <44, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <52, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <60, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <68, 5.6, 0> }
        #if (setting > 1)
          object { pin(1) scale <1, 1.285714, 1> translate <4, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <12, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <20, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <28, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <36, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <44, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <52, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <60, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <68, 0, 0> }
        #end
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <4, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <12, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <20, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <28, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <36, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <44, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <52, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <60, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <68, 5.6, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <76, 11.3, 4> } }
    }
  #end
#end
#macro tech_h_block1_12(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <91.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <91.9, 9.5, 3.9> }
          box { <-2.4, -1, -2.4> <90.4, 8.6, 2.4> }
        }
        object { open_rounded_button() translate <0, 6.4, 0> }
        object { open_rounded_button() translate <8, 6.4, 0> }
        object { open_rounded_button() translate <16, 6.4, 0> }
        object { open_rounded_button() translate <24, 6.4, 0> }
        object { open_rounded_button() translate <32, 6.4, 0> }
        object { open_rounded_button() translate <40, 6.4, 0> }
        object { open_rounded_button() translate <48, 6.4, 0> }
        object { open_rounded_button() translate <56, 6.4, 0> }
        object { open_rounded_button() translate <64, 6.4, 0> }
        object { open_rounded_button() translate <72, 6.4, 0> }
        object { open_rounded_button() translate <80, 6.4, 0> }
        object { open_rounded_button() translate <88, 6.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <16, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <24, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <32, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <40, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <48, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <56, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <64, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <72, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <80, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <88, 9.5, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <12, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <20, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <28, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <36, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <44, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <52, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <60, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <68, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <76, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <84, 5.6, 0> }
        #if (setting > 1)
          object { pin(1) scale <1, 1.285714, 1> translate <4, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <12, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <20, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <28, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <36, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <44, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <52, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <60, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <68, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <76, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <84, 0, 0> }
        #end
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <4, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <12, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <20, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <28, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <36, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <44, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <52, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <60, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <68, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <76, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <84, 5.6, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <92, 11.3, 4> } }
    }
  #end
#end
#macro tech_h_block1_14(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <107.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <107.9, 9.5, 3.9> }
          box { <-2.4, -1, -2.4> <106.4, 8.6, 2.4> }
        }
        object { open_rounded_button() translate <0, 6.4, 0> }
        object { open_rounded_button() translate <8, 6.4, 0> }
        object { open_rounded_button() translate <16, 6.4, 0> }
        object { open_rounded_button() translate <24, 6.4, 0> }
        object { open_rounded_button() translate <32, 6.4, 0> }
        object { open_rounded_button() translate <40, 6.4, 0> }
        object { open_rounded_button() translate <48, 6.4, 0> }
        object { open_rounded_button() translate <56, 6.4, 0> }
        object { open_rounded_button() translate <64, 6.4, 0> }
        object { open_rounded_button() translate <72, 6.4, 0> }
        object { open_rounded_button() translate <80, 6.4, 0> }
        object { open_rounded_button() translate <88, 6.4, 0> }
        object { open_rounded_button() translate <96, 6.4, 0> }
        object { open_rounded_button() translate <104, 6.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <16, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <24, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <32, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <40, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <48, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <56, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <64, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <72, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <80, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <88, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <96, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <104, 9.5, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <12, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <20, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <28, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <36, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <44, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <52, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <60, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <68, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <76, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <84, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <92, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <100, 5.6, 0> }
        #if (setting > 1)
          object { pin(1) scale <1, 1.285714, 1> translate <4, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <12, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <20, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <28, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <36, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <44, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <52, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <60, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <68, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <76, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <84, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <92, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <100, 0, 0> }
        #end
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <4, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <12, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <20, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <28, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <36, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <44, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <52, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <60, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <68, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <76, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <84, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <92, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <100, 5.6, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <108, 11.3, 4> } }
    }
  #end
#end
#macro tech_h_block1_16(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <123.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <123.9, 9.5, 3.9> }
          box { <-2.4, -1, -2.4> <122.4, 8.6, 2.4> }
        }
        object { open_rounded_button() translate <0, 6.4, 0> }
        object { open_rounded_button() translate <8, 6.4, 0> }
        object { open_rounded_button() translate <16, 6.4, 0> }
        object { open_rounded_button() translate <24, 6.4, 0> }
        object { open_rounded_button() translate <32, 6.4, 0> }
        object { open_rounded_button() translate <40, 6.4, 0> }
        object { open_rounded_button() translate <48, 6.4, 0> }
        object { open_rounded_button() translate <56, 6.4, 0> }
        object { open_rounded_button() translate <64, 6.4, 0> }
        object { open_rounded_button() translate <72, 6.4, 0> }
        object { open_rounded_button() translate <80, 6.4, 0> }
        object { open_rounded_button() translate <88, 6.4, 0> }
        object { open_rounded_button() translate <96, 6.4, 0> }
        object { open_rounded_button() translate <104, 6.4, 0> }
        object { open_rounded_button() translate <112, 6.4, 0> }
        object { open_rounded_button() translate <120, 6.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <16, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <24, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <32, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <40, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <48, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <56, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <64, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <72, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <80, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <88, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <96, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <104, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <112, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <120, 9.5, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <12, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <20, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <28, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <36, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <44, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <52, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <60, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <68, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <76, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <84, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <92, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <100, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <108, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <116, 5.6, 0> }
        #if (setting > 1)
          object { pin(1) scale <1, 1.285714, 1> translate <4, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <12, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <20, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <28, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <36, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <44, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <52, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <60, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <68, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <76, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <84, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <92, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <100, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <108, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <116, 0, 0> }
        #end
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <4, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <12, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <20, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <28, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <36, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <44, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <52, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <60, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <68, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <76, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <84, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <92, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <100, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <108, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <116, 5.6, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <124, 11.3, 4> } }
    }
  #end
#end
#macro tech_h_block1_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
        }
        object { open_rounded_button() translate <0, 6.4, 0> }
        object { open_rounded_button() translate <8, 6.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 5.6, 0> }
        #if (setting > 1)
          object { pin(1) scale <1, 1.285714, 1> translate <4, 0, 0> }
        #end
      }
      merge {
        cylinder { -6*z, 6*z, 2.5 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <4, 5.6, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 4> } }
    }
  #end
#end
#macro tech_h_block1_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> }
          box { <-2.4, -1, -2.4> <26.4, 8.6, 2.4> }
        }
        object { open_rounded_button() translate <0, 6.4, 0> }
        object { open_rounded_button() translate <8, 6.4, 0> }
        object { open_rounded_button() translate <16, 6.4, 0> }
        object { open_rounded_button() translate <24, 6.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <16, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <24, 9.5, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <12, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <20, 5.6, 0> }
        #if (setting > 1)
          object { pin(1) scale <1, 1.285714, 1> translate <4, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <12, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <20, 0, 0> }
        #end
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <4, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <12, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <20, 5.6, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 4> } }
    }
  #end
#end
#macro tech_h_block1_6(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <43.9, 9.5, 3.9> }
          box { <-2.4, -1, -2.4> <42.4, 8.6, 2.4> }
        }
        object { open_rounded_button() translate <0, 6.4, 0> }
        object { open_rounded_button() translate <8, 6.4, 0> }
        object { open_rounded_button() translate <16, 6.4, 0> }
        object { open_rounded_button() translate <24, 6.4, 0> }
        object { open_rounded_button() translate <32, 6.4, 0> }
        object { open_rounded_button() translate <40, 6.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <16, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <24, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <32, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <40, 9.5, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <12, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <20, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <28, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <36, 5.6, 0> }
        #if (setting > 1)
          object { pin(1) scale <1, 1.285714, 1> translate <4, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <12, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <20, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <28, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <36, 0, 0> }
        #end
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <4, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <12, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <20, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <28, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <36, 5.6, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 11.3, 4> } }
    }
  #end
#end
#macro tech_h_block1_8(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <59.9, 9.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <59.9, 9.5, 3.9> }
          box { <-2.4, -1, -2.4> <58.4, 8.6, 2.4> }
        }
        object { open_rounded_button() translate <0, 6.4, 0> }
        object { open_rounded_button() translate <8, 6.4, 0> }
        object { open_rounded_button() translate <16, 6.4, 0> }
        object { open_rounded_button() translate <24, 6.4, 0> }
        object { open_rounded_button() translate <32, 6.4, 0> }
        object { open_rounded_button() translate <40, 6.4, 0> }
        object { open_rounded_button() translate <48, 6.4, 0> }
        object { open_rounded_button() translate <56, 6.4, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <16, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <24, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <32, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <40, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <48, 9.5, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <56, 9.5, 0> }
        #end
        cylinder { -3.8*z, 3.8*z, 3.5 translate <4, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <12, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <20, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <28, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <36, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <44, 5.6, 0> }
        cylinder { -3.8*z, 3.8*z, 3.5 translate <52, 5.6, 0> }
        #if (setting > 1)
          object { pin(1) scale <1, 1.285714, 1> translate <4, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <12, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <20, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <28, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <36, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <44, 0, 0> }
          object { pin(1) scale <1, 1.285714, 1> translate <52, 0, 0> }
        #end
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <4, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <12, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <20, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <28, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <36, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <44, 5.6, 0>
      }
      merge {
        cylinder { -6*z, 6*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        translate <52, 5.6, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 11.3, 4> } }
    }
  #end
#end
#macro tech_h_blockpivotconnect2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -7.9> <3.9, 9.5, 7.9> }
      cylinder { 4*x, 13*x, 3.9 translate <0, 5.6, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -7.9> <3.9, 9.5, 7.9> }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, -4> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 4> }
        #else
          object { rounded_button() rotate 90*y translate <0, 6.4, -4> }
          object { rounded_button() rotate 90*y translate <0, 6.4, 4> }
        #end
        box { <3, 0.000001, -3> <5.5, 5.6, 3> }
        cylinder { 3.25*x, 4.75*x, 3 translate <0, 5.6, 0> }
        cylinder { 4*x, 13*x, 3.9 translate <0, 5.6, 0> }
      }
      box { <3.9, 9.500001, -3> <14, 15, 3> }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -6.4> <2.4, 8.6, 6.4> }
          cylinder { 0.000001*y, 8.7*y, 1.5 }
        }
        box { <2.399999, -1, -2> <3.900001, 8.600001, 2> }
      #end
      difference {
        box { <9.1, -5, -5> <14, 11, 5> }
        cylinder { -6*y, 6*y, 3.900001 translate <9.100001, 5.6, 0> }
      }
      box { <5.5, 7.85, -6> <14, 15, 6> }
      box { <5.5, 4.85, -6> <14, 6.35, 6> }
      box { <5.5, -1, -6> <14, 3.35, 6> }
      cylinder { 7.35*y, 9*y, 1 translate <9.1, 0, 0> }
      cylinder { 0*y, 3.85*y, 1 translate <9.1, 0, 0> }
      cylinder { 7.6*y, 9*y, 1.4 translate <9.1, 0, 0> }
      cylinder { 0*y, 3.6*y, 1.4 translate <9.1, 0, 0> }
      box { <9.1, 7.6, -1.4> <14, 9, 1.4> }
      box { <9.1, 0, -1.4> <14, 3.6, 1.4> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -8> <13.1, 11.3, 8> } }
    }
  #end
#end
#macro tech_liftarm_11_double_bent(color_tex)
merge {
  difference {
    merge {
      box { <0, -3.7, -3.9> <48, 3.7, 3.9> }
      cylinder { -3.90001*z, 3.90001*z, 3.7 }
      cylinder { -3.90001*z, 3.90001*z, 3.7 translate <48, 0, 0> }
    }
    cylinder { -6*z, 6*z, 2.5 }
    cylinder { -5*z, -3.4*z, 3.1 }
    cylinder { 5*z, 3.4*z, 3.1 }
    cylinder { -6*z, 6*z, 2.5 translate <8, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <8, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <8, 0, 0> }
    cylinder { -6*z, 6*z, 2.5 translate <16, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <16, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <16, 0, 0> }
    cylinder { -6*z, 6*z, 2.5 translate <24, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <24, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <24, 0, 0> }
    cylinder { -6*z, 6*z, 2.5 translate <32, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <32, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <32, 0, 0> }
    cylinder { -6*z, 6*z, 2.5 translate <40, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <40, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <40, 0, 0> }
    difference {
      box { <0, -2.7, -10> <40.00001, 2.7, -0.5> }
      cylinder { -5*z, 0*z, 3.6 }
      cylinder { -5*z, 0*z, 3.6 translate <8, 0, 0> }
      cylinder { -5*z, 0*z, 3.6 translate <16, 0, 0> }
      cylinder { -5*z, 0*z, 3.6 translate <24, 0, 0> }
      cylinder { -5*z, 0*z, 3.6 translate <32, 0, 0> }
      cylinder { -5*z, 0*z, 3.6 translate <40, 0, 0> }
    }
    difference {
      box { <0, -2.7, 10> <40.00001, 2.7, 0.5> }
      cylinder { 5*z, 0*z, 3.6 }
      cylinder { 5*z, 0*z, 3.6 translate <8, 0, 0> }
      cylinder { 5*z, 0*z, 3.6 translate <16, 0, 0> }
      cylinder { 5*z, 0*z, 3.6 translate <24, 0, 0> }
      cylinder { 5*z, 0*z, 3.6 translate <32, 0, 0> }
      cylinder { 5*z, 0*z, 3.6 translate <40, 0, 0> }
    }
    difference {
      box { <40, -2.7, -10> <48, 2.7, 10> }
      cylinder { -5*z, 5*z, 3.6 translate <40, 0, 0> }
      cylinder { -5*z, 5*z, 3.6 translate <48, 0, 0> }
    }
    box { <43.9, -1.00001, -5> <48, 1.00001, 5> }
    object { axle_opening(10,1) rotate -90*y translate <48, 0, -5> }
  }
  difference {
    merge {
      box { <-19.7, 16, -3.9> <-12.3, 32, 3.9> }
      cylinder { -3.90002*z, 3.90002*z, 3.7 translate <-16, 16, 0> }
      cylinder { -3.90002*z, 3.90002*z, 3.7 translate <-16, 32, 0> }
    }
    cylinder { -6*z, 6*z, 2.5 translate <-16, 16, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <-16, 16, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <-16, 16, 0> }
    cylinder { -6*z, 6*z, 2.5 translate <-16, 24, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <-16, 24, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <-16, 24, 0> }
    difference {
      box { <-18.7, 24, -10> <-13.3, 16, -0.5> }
      cylinder { -5*z, 0*z, 3.59999 translate <-16, 16, 0> }
      cylinder { -5*z, 0*z, 3.59999 translate <-16, 24, 0> }
    }
    difference {
      box { <-18.7, 24, 10> <-13.3, 16, 0.5> }
      cylinder { 5*z, 0*z, 3.59999 translate <-16, 16, 0> }
      cylinder { 5*z, 0*z, 3.59999 translate <-16, 24, 0> }
    }
    difference {
      box { <-18.7, 24, -10> <-13.3, 32, 10> }
      cylinder { -5*z, 5*z, 3.6 translate <-16, 24, 0> }
      cylinder { -5*z, 5*z, 3.6 translate <-16, 32, 0> }
    }
    box { <-17.00001, 27.9, -5> <-15.99999, 32, 5> }
    object { axle_opening(10,1) rotate -90*y translate <-16, 32, -5> }
  }
  difference {
    box { <0, -3.7, -3.90003> <22.62741, 3.7, 3.90003> }
    cylinder { -6*z, 6*z, 2.50002 }
    cylinder { -5*z, -3.40002*z, 3.10002 }
    cylinder { 5*z, 3.40002*z, 3.10002 }
    cylinder { -6*z, 6*z, 2.50002 translate <22.62741, 0, 0> }
    cylinder { -5*z, -3.40002*z, 3.10002 translate <22.62741, 0, 0> }
    cylinder { 5*z, 3.40002*z, 3.10002 translate <22.62741, 0, 0> }
    cylinder { -6*z, 6*z, 2.5 translate <8, 0, 0> }
    cylinder { -5*z, -3.40002*z, 3.1 translate <8, 0, 0> }
    cylinder { 5*z, 3.40002*z, 3.1 translate <8, 0, 0> }
    cylinder { -6*z, 6*z, 2.5 translate <14.62741, 0, 0> }
    cylinder { -5*z, -3.40002*z, 3.1 translate <14.62741, 0, 0> }
    cylinder { 5*z, 3.40002*z, 3.1 translate <14.62741, 0, 0> }
    box { <7.99999, -3.1, -5> <14.62742, 3.1, -3.40002> }
    box { <7.99999, -3.1, 5> <14.62742, 3.1, 3.40002> }
    box { <7.99999, -2.5, -5> <14.62742, 2.5, 5> }
    difference {
      box { <-0.000001, -2.7, -10> <22.62742, 2.7, -0.50002> }
      cylinder { -5*z, 0*z, 3.59998 }
      cylinder { -5*z, 0*z, 3.59998 translate <8, 0, 0> }
      box { <8, -3.59998, -5> <14.62741, 3.59998, 0> }
      cylinder { -5*z, 0*z, 3.59998 translate <14.62741, 0, 0> }
      cylinder { -5*z, 0*z, 3.59998 translate <22.62742, 0, 0> }
    }
    difference {
      box { <-0.000001, -2.7, 10> <22.62742, 2.7, 0.50002> }
      cylinder { 5*z, 0*z, 3.59998 }
      cylinder { 5*z, 0*z, 3.59998 translate <8, 0, 0> }
      box { <8, -3.59998, 5> <14.62741, 3.59998, 0> }
      cylinder { 5*z, 0*z, 3.59998 translate <14.62741, 0, 0> }
      cylinder { 5*z, 0*z, 3.59998 translate <22.62742, 0, 0> }
    }
    rotate -45*z translate <-16, 16, 0>
  }
  texture { color_tex }
  bounded_by { box { <-19.8, -3.8, -4> <51.8, 35.8, 4> } }
}
#end
#macro tech_liftarm_15(color_tex)
  #if (setting = 0)
    merge {
      box { <0, -3.7, -3.9> <112, 3.7, 3.9> }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <112, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, -3.7, -3.9> <112, 3.7, 3.9> }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <112, 0, 0> }
      }
      #local counter = 0;
      #while (counter < 15)
        cylinder { -6*z, 6*z, 2.4 translate <(counter*8), 0, 0> }
        cylinder { -5*z, -3.4*z, 3.1 translate <(counter*8), 0, 0> }
        cylinder { 5*z, 3.4*z, 3.1 translate <(counter*8), 0, 0> }
        #local counter = counter + 1;
      #end
      difference {
        box { <0, -2.7, -10> <112, 2.7, 10> }
        box { <-1, -3, -0.5> <113, 3, 0.5> }
        #local counter = 0;
        #while (counter < 15)
          cylinder { -5*z, 0*z, 3.6 translate <(counter*8), 0, 0> }
          cylinder { 5*z, 0*z, 3.6 translate <(counter*8), 0, 0> }
          #local counter = counter + 1;
        #end
      }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -4> <115.8, 3.8, 4> } }
    }
  #end
#end
#macro tech_liftarm_2(color_tex)
  #if (setting = 0)
    merge {
      box { <0, -3.7, -3.9> <8, 3.7, 3.9> }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <8, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, -3.7, -3.9> <8, 3.7, 3.9> }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <8, 0, 0> }
      }
      cylinder { -6*z, 6*z, 2.4 }
      cylinder { -5*z, -3.4*z, 3.1 }
      cylinder { 5*z, 3.4*z, 3.1 }
      cylinder { -6*z, 6*z, 2.4 translate <8, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <8, 0, 0> }
      difference {
        box { <0, -2.7, -10> <8, 2.7, -0.5> }
        cylinder { -5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <8, 0, 0> }
      }
      difference {
        box { <0, -2.7, 0.5> <8, 2.7, 10> }
        cylinder { 5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <8, 0, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -4> <11.8, 3.8, 4> } }
    }
  #end
#end
#macro tech_liftarm_3(color_tex)
  #if (setting = 0)
    merge {
      box { <0, -3.7, -3.9> <16, 3.7, 3.9> }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <16, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, -3.7, -3.9> <16, 3.7, 3.9> }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <16, 0, 0> }
      }
      cylinder { -6*z, 6*z, 2.4 }
      cylinder { -5*z, -3.4*z, 3.1 }
      cylinder { 5*z, 3.4*z, 3.1 }
      cylinder { -6*z, 6*z, 2.4 translate <8, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <16, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <16, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <16, 0, 0> }
      difference {
        box { <0, -2.7, -10> <16, 2.7, -0.5> }
        cylinder { -5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <16, 0, 0> }
      }
      difference {
        box { <0, -2.7, 0.5> <16, 2.7, 10> }
        cylinder { 5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <16, 0, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -4> <19.8, 3.8, 4> } }
    }
  #end
#end
#macro tech_liftarm_4_corner(color_tex)
  #if (setting = 0)
    merge {
      box { <0, -3.7, -3.9> <24, 3.7, 3.9> }
      box { <20.3, 0, -3.900004> <27.7, 8, 3.900004> }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <24, 0, 0> }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <24, 8, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, -3.7, -3.9> <24, 3.7, 3.9> }
        box { <20.3, 0, -3.900004> <27.7, 8, 3.900004> }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <24, 0, 0> }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <24, 8, 0> }
      }
      cylinder { -6*z, 6*z, 2.4 }
      cylinder { -5*z, -3.4*z, 3.1 }
      cylinder { 5*z, 3.4*z, 3.1 }
      cylinder { -6*z, 6*z, 2.4 translate <8, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <16, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <16, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <16, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <24, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <24, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <24, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <24, 8, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <24, 8, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <24, 8, 0> }
      difference {
        merge {
          box { <0, -2.7, -10> <24, 2.7, -0.5> }
          box { <21.3, 0, -10> <26.7, 8, -0.500001> }
        }
        cylinder { -5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <24, 8, 0> }
      }
      difference {
        merge {
          box { <0, -2.7, 0.5> <24, 2.7, 10> }
          box { <21.3, 0, 10> <26.7, 8, 0.500001> }
        }
        cylinder { 5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <24, 8, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -4> <27.8, 11.8, 4> } }
    }
  #end
#end
#macro tech_liftarm_5(color_tex)
  #if (setting = 0)
    merge {
      box { <0, -3.7, -3.9> <32, 3.7, 3.9> }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <32, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, -3.7, -3.9> <32, 3.7, 3.9> }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <32, 0, 0> }
      }
      cylinder { -6*z, 6*z, 2.4 }
      cylinder { -5*z, -3.4*z, 3.1 }
      cylinder { 5*z, 3.4*z, 3.1 }
      cylinder { -6*z, 6*z, 2.4 translate <8, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <16, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <16, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <16, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <24, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <24, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <24, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <32, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <32, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <32, 0, 0> }
      difference {
        box { <0, -2.7, -10> <32, 2.7, -0.5> }
        cylinder { -5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <32, 0, 0> }
      }
      difference {
        box { <0, -2.7, 0.5> <32, 2.7, 10> }
        cylinder { 5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <32, 0, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -4> <35.8, 3.8, 4> } }
    }
  #end
#end
#macro tech_liftarm_6(color_tex)
  #if (setting = 0)
    merge {
      box { <0, -3.7, -3.9> <40, 3.7, 3.9> }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <40, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, -3.7, -3.9> <40, 3.7, 3.9> }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <40, 0, 0> }
      }
      cylinder { -6*z, 6*z, 2.4 }
      cylinder { -5*z, -3.4*z, 3.1 }
      cylinder { 5*z, 3.4*z, 3.1 }
      cylinder { -6*z, 6*z, 2.4 translate <8, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <16, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <16, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <16, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <24, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <24, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <24, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <32, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <32, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <32, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <40, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <40, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <40, 0, 0> }
      difference {
        box { <0, -2.7, -10> <40, 2.7, -0.5> }
        cylinder { -5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <32, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <40, 0, 0> }
      }
      difference {
        box { <0, -2.7, 0.5> <40, 2.7, 10> }
        cylinder { 5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <32, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <40, 0, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -4> <43.8, 3.8, 4> } }
    }
  #end
#end
#macro tech_liftarm_7(color_tex)
  #if (setting = 0)
    merge {
      box { <0, -3.7, -3.9> <48, 3.7, 3.9> }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <48, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, -3.7, -3.9> <48, 3.7, 3.9> }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <48, 0, 0> }
      }
      cylinder { -6*z, 6*z, 2.4 }
      cylinder { -5*z, -3.4*z, 3.1 }
      cylinder { 5*z, 3.4*z, 3.1 }
      cylinder { -6*z, 6*z, 2.4 translate <8, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <16, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <16, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <16, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <24, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <24, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <24, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <32, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <32, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <32, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <40, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <40, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <40, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <48, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <48, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <48, 0, 0> }
      difference {
        box { <0, -2.7, -10> <48, 2.7, -0.5> }
        cylinder { -5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <32, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <40, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <48, 0, 0> }
      }
      difference {
        box { <0, -2.7, 0.5> <48, 2.7, 10> }
        cylinder { 5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <32, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <40, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <48, 0, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -4> <51.8, 3.8, 4> } }
    }
  #end
#end
#macro tech_liftarm_7_bent(color_tex)
merge {
  difference {
    merge {
      box { <0, -3.7, -3.9> <24, 3.7, 3.9> }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <24, 0, 0> }
    }
    cylinder { -6*z, 6*z, 2.5 }
    cylinder { -5*z, -3.4*z, 3.1 }
    cylinder { 5*z, 3.4*z, 3.1 }
    cylinder { -6*z, 6*z, 2.5 translate <8, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <8, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <8, 0, 0> }
    cylinder { -6*z, 6*z, 2.5 translate <16, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <16, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <16, 0, 0> }
    difference {
      box { <0, -2.7, -10> <16.000001, 2.7, -0.5> }
      cylinder { -5*z, 0*z, 3.6 translate <0, 0, 0> }
      cylinder { -5*z, 0*z, 3.6 translate <8, 0, 0> }
      cylinder { -5*z, 0*z, 3.6 translate <16, 0, 0> }
    }
    difference {
      box { <0, -2.7, 10> <16.000001, 2.7, 0.5> }
      cylinder { 5*z, 0*z, 3.6 translate <0, 0, 0> }
      cylinder { 5*z, 0*z, 3.6 translate <8, 0, 0> }
      cylinder { 5*z, 0*z, 3.6 translate <16, 0, 0> }
    }
    difference {
      box { <16, -2.7, -10> <24, 2.7, 10> }
      cylinder { -5*z, 5*z, 3.6 translate <16, 0, 0> }
      cylinder { -5*z, 5*z, 3.6 translate <24, 0, 0> }
    }
    box { <19.9, -1.000001, -5> <24, 1.000001, 5> }
    object { axle_opening(10,1) rotate -90*y translate <24, 0, -5> }
  }
  difference {
    merge {
      box { <-24, -3.7, -3.9> <0, 3.7, 3.9> }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <-24, 0, 0> }
    }
    cylinder { -6*z, 6*z, 2.5 }
    cylinder { -5*z, -3.4*z, 3.1 }
    cylinder { 5*z, 3.4*z, 3.1 }
    cylinder { -6*z, 6*z, 2.5 translate <-8, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <-8, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <-8, 0, 0> }
    cylinder { -6*z, 6*z, 2.5 translate <-16, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <-16, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <-16, 0, 0> }
    difference {
      box { <-16.000001, -2.7, -10> <0, 2.7, -0.5> }
      cylinder { -5*z, 0*z, 3.6 }
      cylinder { -5*z, 0*z, 3.6 translate <-8, 0, 0> }
      cylinder { -5*z, 0*z, 3.6 translate <-16, 0, 0> }
      cylinder { -5*z, 0*z, 3.6 translate <-24, 0, 0> }
    }
    difference {
      box { <-16.000001, -2.7, 10> <0, 2.7, 0.5> }
      cylinder { 5*z, 0*z, 3.6 }
      cylinder { 5*z, 0*z, 3.6 translate <-8, 0, 0> }
      cylinder { 5*z, 0*z, 3.6 translate <-16, 0, 0> }
      cylinder { 5*z, 0*z, 3.6 translate <-24, 0, 0> }
    }
    difference {
      box { <-16, -2.7, -10> <-24, 2.7, 10> }
      cylinder { -5*z, 5*z, 3.6 translate <-16, 0, 0> }
      cylinder { -5*z, 5*z, 3.6 translate <-24, 0, 0> }
    }
    box { <-19.9, -1.000001, -5> <-24, 1.000001, 5> }
    object { axle_opening(10,1) rotate -90*y translate <-24, 0, -5> }
    translate <-0.000001, -0.000001, -0.000001>
    rotate -53*z
  }
  texture { color_tex }
  bounded_by { box { <-19, -3.8, -4> <27.8, 24, 4> } }
}
#end
#macro tech_liftarm_9(color_tex)
  #if (setting = 0)
    merge {
      box { <0, -3.7, -3.9> <64, 3.7, 3.9> }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <64, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, -3.7, -3.9> <64, 3.7, 3.9> }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 }
        cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <64, 0, 0> }
      }
      cylinder { -6*z, 6*z, 2.4 }
      cylinder { -5*z, -3.4*z, 3.1 }
      cylinder { 5*z, 3.4*z, 3.1 }
      cylinder { -6*z, 6*z, 2.4 translate <8, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <16, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <16, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <16, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <24, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <24, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <24, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <32, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <32, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <32, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <40, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <40, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <40, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <48, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <48, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <48, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <56, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <56, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <56, 0, 0> }
      cylinder { -6*z, 6*z, 2.4 translate <64, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <64, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <64, 0, 0> }
      difference {
        box { <0, -2.7, -10> <64, 2.7, -0.5> }
        cylinder { -5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <32, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <40, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <48, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <56, 0, 0> }
        cylinder { -5*z, 0*z, 3.6 translate <64, 0, 0> }
      }
      difference {
        box { <0, -2.7, 0.5> <64, 2.7, 10> }
        cylinder { 5*z, 0*z, 3.6 translate <0, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <8, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <16, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <24, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <32, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <40, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <48, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <56, 0, 0> }
        cylinder { 5*z, 0*z, 3.6 translate <64, 0, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-3.8, -3.8, -4> <67.8, 3.8, 4> } }
    }
  #end
#end
#macro tech_liftarm_9_bent(color_tex)
merge {
  difference {
    merge {
      box { <0, -3.7, -3.9> <40, 3.7, 3.9> }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <40, 0, 0> }
    }
    cylinder { -6*z, 6*z, 2.5 }
    cylinder { -5*z, -3.4*z, 3.1 }
    cylinder { 5*z, 3.4*z, 3.1 }
    cylinder { -6*z, 6*z, 2.5 translate <8, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <8, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <8, 0, 0> }
    cylinder { -6*z, 6*z, 2.5 translate <16, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <16, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <16, 0, 0> }
    cylinder { -6*z, 6*z, 2.5 translate <24, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <24, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <24, 0, 0> }
    cylinder { -6*z, 6*z, 2.5 translate <32, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <32, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <32, 0, 0> }
    difference {
      box { <0, -2.7, -10> <32.000001, 2.7, -0.5> }
      cylinder { -5*z, 0*z, 3.6 translate <0, 0, 0> }
      cylinder { -5*z, 0*z, 3.6 translate <8, 0, 0> }
      cylinder { -5*z, 0*z, 3.6 translate <16, 0, 0> }
      cylinder { -5*z, 0*z, 3.6 translate <24, 0, 0> }
      cylinder { -5*z, 0*z, 3.6 translate <32, 0, 0> }
    }
    difference {
      box { <0, -2.7, 10> <32.000001, 2.7, 0.5> }
      cylinder { 5*z, 0*z, 3.6 translate <0, 0, 0> }
      cylinder { 5*z, 0*z, 3.6 translate <8, 0, 0> }
      cylinder { 5*z, 0*z, 3.6 translate <16, 0, 0> }
      cylinder { 5*z, 0*z, 3.6 translate <24, 0, 0> }
      cylinder { 5*z, 0*z, 3.6 translate <32, 0, 0> }
    }
    difference {
      box { <32, -2.7, -10> <40, 2.7, 10> }
      cylinder { -5*z, 5*z, 3.6 translate <32, 0, 0> }
      cylinder { -5*z, 5*z, 3.6 translate <40, 0, 0> }
    }
    box { <35.9, -1.000001, -5> <40, 1.000001, 5> }
    object { axle_opening(10,1) rotate -90*y translate <40, 0, -5> }
  }
  difference {
    merge {
      box { <-24, -3.7, -3.9> <0, 3.7, 3.9> }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 }
      cylinder { -3.900001*z, 3.9000001*z, 3.7 translate <-24, 0, 0> }
    }
    cylinder { -6*z, 6*z, 2.5 }
    cylinder { -5*z, -3.4*z, 3.1 }
    cylinder { 5*z, 3.4*z, 3.1 }
    cylinder { -6*z, 6*z, 2.5 translate <-8, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <-8, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <-8, 0, 0> }
    cylinder { -6*z, 6*z, 2.5 translate <-16, 0, 0> }
    cylinder { -5*z, -3.4*z, 3.1 translate <-16, 0, 0> }
    cylinder { 5*z, 3.4*z, 3.1 translate <-16, 0, 0> }
    difference {
      box { <-16.000001, -2.7, -10> <0, 2.7, -0.5> }
      cylinder { -5*z, 0*z, 3.6 }
      cylinder { -5*z, 0*z, 3.6 translate <-8, 0, 0> }
      cylinder { -5*z, 0*z, 3.6 translate <-16, 0, 0> }
      cylinder { -5*z, 0*z, 3.6 translate <-24, 0, 0> }
    }
    difference {
      box { <-16.000001, -2.7, 10> <0, 2.7, 0.5> }
      cylinder { 5*z, 0*z, 3.6 }
      cylinder { 5*z, 0*z, 3.6 translate <-8, 0, 0> }
      cylinder { 5*z, 0*z, 3.6 translate <-16, 0, 0> }
      cylinder { 5*z, 0*z, 3.6 translate <-24, 0, 0> }
    }
    difference {
      box { <-16, -2.7, -10> <-24, 2.7, 10> }
      cylinder { -5*z, 5*z, 3.6 translate <-16, 0, 0> }
      cylinder { -5*z, 5*z, 3.6 translate <-24, 0, 0> }
    }
    box { <-19.9, -1.000001, -5> <-24, 1.000001, 5> }
    object { axle_opening(10,1) rotate -90*y translate <-24, 0, -5> }
    translate <-0.000001, -0.000001, -0.000001>
    rotate -53*z
  }
  texture { color_tex }
  bounded_by { box { <-19, -3.8, -4> <43.8, 24, 4> } }
}
#end
#macro tech_link_chain(color_tex)
  difference {
    merge {
      cylinder { -3.9*z, 3.9*z, 0.5 }
      cylinder { -2.25*z, 2.25*z, 0.8 }
      cylinder { -2.65*z, -1.95*z, 1.9 }
      cylinder { 2.65*z, 1.95*z, 1.9 }
      box { <-4.1, -1.9, -2.650001> <0, 1.9, -1.950001> }
      box { <-4.1, -1.9, 2.650001> <0, 1.9, 1.950001> }
      box { <-6.5, -1.900001, -3.9> <-3.4, 1.900001, -3.100001> }
      box { <-6.5, -1.900001, 3.9> <-3.4, 1.900001, 3.100001> }
      box { <-4.100001, -1.900002, -3.8> <-3.400001, 1.900002, -1.950002> }
      box { <-4.100001, -1.900002, 3.8> <-3.400001, 1.900002, 1.950002> }
      cylinder { -2.25*z, 2.25*z, 0.5 translate <-3.1, 0, 0> }
      cylinder { -3.9*z, -3.1*z, 1.9 translate <-6.5, 0, 0> }
      cylinder { 3.9*z, 3.1*z, 1.9 translate <-6.5, 0, 0> }
    }
    cylinder { -4*z, 4*z, 0.6 translate <-6.5, 0, 0> }
    box { <-0.35, -3, -4> <0.45, 0, 4> rotate 17.5*z translate <-6.5, 0, 0> }
    box { <-0.45, -3, -4> <0.35, 0, 4> rotate -7.5*z translate <-6.5, 0, 0> }
    difference {
      box { <-1, -2, -5> <1, 0, 5> }
      cylinder { -4*z, 4*z, 0.65 }
      translate <-1.25, 0, 0> rotate 27.5*z translate <-6.5, 0, 0>
    }
    texture { color_tex }
    bounded_by { box { <-8.5, -2, -4> <2, 2, 4> } }
  }
#end
#macro tech_link_tread(color_tex)
  difference {
    merge {
      cylinder { -3.9*z, 3.9*z, 0.5 }
      cylinder { -2.25*z, 2.25*z, 0.8 }
      cylinder { -2.65*z, -1.95*z, 1.9 }
      cylinder { 2.65*z, 1.95*z, 1.9 }
      box { <-4.1, -1.9, -2.650001> <0, 1.9, -1.950001> }
      box { <-4.1, -1.9, 2.650001> <0, 1.9, 1.950001> }
      box { <-6.5, -1.900001, -3.9> <-3.4, 1.900001, -3.100001> }
      box { <-6.5, -1.900001, 3.9> <-3.4, 1.900001, 3.100001> }
      box { <-4.100001, -1.900002, -3.8> <-3.400001, 1.900002, -1.950002> }
      box { <-4.100001, -1.900002, 3.8> <-3.400001, 1.900002, 1.950002> }
      cylinder { -2.25*z, 2.25*z, 0.5 translate <-3.1, 0, 0> }
      cylinder { -3.9*z, -3.1*z, 1.9 translate <-6.5, 0, 0> }
      cylinder { 3.9*z, 3.1*z, 1.9 translate <-6.5, 0, 0> }
      difference {
        box { <-6.7, 0.8, -10.1> <-2.2, 2.9, 10.1> }
        box { <-5.6, 0, -11> <-3.2, 1.9, 11> }
        cylinder { 1.899995*y, 3*y, 1.55 translate <-4.45, 0, -8> }
        cylinder { 1.899995*y, 3*y, 1.55 translate <-4.45, 0, -4> }
        cylinder { 1.899995*y, 3*y, 1.55 translate <-4.45, 0, 0> }
        cylinder { 1.899995*y, 3*y, 1.55 translate <-4.45, 0, 4> }
        cylinder { 1.899995*y, 3*y, 1.55 translate <-4.45, 0, 8> }
      }
    }
    cylinder { -4*z, 4*z, 0.6 translate <-6.5, 0, 0> }
    box { <-0.35, -3, -4> <0.45, 0, 4> rotate 17.5*z translate <-6.5, 0, 0> }
    box { <-0.45, -3, -4> <0.35, 0, 4> rotate -7.5*z translate <-6.5, 0, 0> }
    difference {
      box { <-1, -2, -5> <1, 0, 5> }
      cylinder { -4*z, 4*z, 0.65 }
      translate <-1.25, 0, 0> rotate 27.5*z translate <-6.5, 0, 0>
    }
    texture { color_tex }
    bounded_by { box { <-8.5, -2, -10.2> <2, 3, 10.2> } }
  }
#end
#macro tech_locker_full(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 3.9*x, 2.8 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -3.8*x, 3.8*x, 2.8 }
        cylinder { -3.75*x, -2.9*x, 3.65 }
        torus { 3.5, 0.15 rotate 90*z translate <-3.75, 0, 0> }
        torus { 3.5, 0.15 rotate 90*z translate <3.75, 0, 0> }
        cylinder { -3.9*x, -3*x, 3.5 }
        cylinder { 3.9*x, 3*x, 3.5 }
        cylinder { 2.9*x, 3.75*x, 3.65 }
        cone { -2.900001*x, 3.650001, -2.5*x, 2.75 }
        cone { 2.5*x, 2.75, 2.900001*x, 3.650001 }
      }
      cylinder { 0*x, 4*x, 2.4 translate <0, -4, -4> }
      cylinder { 0*x, 4*x, 2.4 translate <0, 4, -4> }
      cylinder { 0*x, 4*x, 2.4 translate <0, -4, 4> }
      cylinder { 0*x, 4*x, 2.4 translate <0, 4, 4> }
      box { <-2.5, -0.5, -4> <2.5, 0.5, 4> }
      object { axle_opening(8,1) translate <-4, 0, 0> }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 4*x, 4 } }
    }
  #end
#end
#macro tech_locker_thin(color_tex, age)
  #if (setting = 0)
    cylinder { -2.3*x, 1.5*x, 3.75 texture { color_tex } }
  #else
    difference {
      merge {
        torus { 3.6, 0.15 rotate 90*z translate <1.35, 0, 0> }
        cylinder { -2.3*x, 1.35*x, 3.75 }
        cylinder { 0*x, 1.5*x, 3.6 }
      }
      #local counter = 0;
      #while (counter < 16)
        difference {
          box { <-3, -0.4, -4> <-1.5, 0.4, 0> }
          box { <-3.5, 0, 0> <-1, 1, 5> rotate 5*x translate <0, 0.4, -4> }
          box { <-3.5, -1, 0> <0, 0, 5> rotate -5*x translate <0, -0.4, -4> }
          rotate (5.625+(counter*22.5))*x
        }
        #local counter = counter + 1;
      #end
      #if (age = 3)
        difference {
          cylinder { -1.000001*x, 1.6*x, 2.500005 }
          cylinder { -2*x, 2*x, 0.5 translate <0, 1.25, -1.25> }
          cylinder { -2*x, 2*x, 0.5 translate <0, -1.25, 1.25> }
          box { <-2, -3, 1.249999> <2, -0.75, 3> }
          box { <-2, -3, 0.75> <2, -1.25, 3> }
          box { <-2, 0.75, -3> <2, 3, -1.249999> }
          box { <-2, 1.25, -3> <2, 3, -0.75> }
        }
      #else
        object { axle_opening(6,age) translate <-3, 0, 0> }
      #end
      cylinder { -4*x, -1*x, 2.5 }
      torus { 3.75, 0.75 rotate 90*z translate <-0.2, 0, 0> }
      texture { color_tex }
      bounded_by { cylinder { -2.4*x, 1.6*x, 3.85 } }
    }
  #end
#end
#macro tech_micromotor_pulley(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*x, 3*x, 3.65 }
      cylinder { -0.5*x, 3.9*x, 5.6 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        cylinder { 0.91*x, 3.9*x, 3.79 }
        cylinder { 0*x, 4*x, 2.35 }
        texture { t_white_tex finish { reflection 0 } } interior { ior 1.5 }
      }
      difference {
        merge {
          cylinder { -3.9*x, 3.9*x, 3.65 }
          cylinder { -0.500001*x, 0*x, 5.6 }
          cone { -0.000002*x, 5.6, 0.5*x, 5 }
          cone { 2.9*x, 5, 3.400002*x, 5.6 }
          cylinder { 3.4*x, 3.9*x, 5.6 }
          cylinder { 0.4*x, 3.5*x, 4.8 }
        }
        cylinder { -0.5*x, -4*x, 2.4 translate <0, -4, -4> }
        cylinder { -0.5*x, -4*x, 2.4 translate <0, 4, -4> }
        cylinder { -0.5*x, -4*x, 2.4 translate <0, -4, 4> }
        cylinder { -0.5*x, -4*x, 2.4 translate <0, 4, 4> }
        #if (setting > 1)
          object { axle_opening(8,1) translate <-4, 0, 0> }
          box { <-3, -0.5, -4> <-0.5, 0.5, 4> }
          cylinder { 0.9*x, 4*x, 3.8 }
        #end
      }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 4*x, 5.7 } }
    }
  #end
#end
#macro tech_pipe(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 11.9*x, 3.9 texture { color_tex } }
  #else
    difference {
      cylinder { -3.9*x, 11.9*x, 3.9 }
      cylinder { -4*x, 12*x, 2.3 }
      cylinder { -4*x, -3*x, 3.1 }
      cylinder { 11*x, 12*x, 3.1 }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 12*x, 4 } }
    }
  #end
#end
#macro tech_pipe_elbow(color_tex)
  #if (setting = 0)
    difference {
      torus { 11.9, 3.9 translate <0, 0, 11.9> }
      box { <-16, -4, 11.9> <16, 4, 28> }
      box { <-16, -4, -4> <0, 4, 28> }
      texture { color_tex }
    }
  #else
    difference {
      torus { 11.9, 3.9  translate <0, 0, 11.9>}
      box { <-16, -4, 11.9> <16, 4, 28> }
      box { <-16, -4, -4> <0, 4, 28> }
      #if (setting > 1)
        torus { 11.9, 1.5 translate <0, 0, 11.9> }
        difference {
          torus { 11.9, 2.5 translate <0, 0, 11.9> }
          box { <5, -4, -4> <16, 4, 6.9> }
        }
      #end
      texture { color_tex }
      bounded_by { cylinder { -4*y, 4*y, 15.9 translate <0, 0, 11.9> } }
    }
  #end
#end
#macro tech_piston(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*x, 3.8*x, 2.8 }
      cylinder { -3.900001*z, 3.900001*z, 4.5 translate <8, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -3.8*x, 3.8*x, 2.8 }
        cylinder { -3.9*x, -2.9*x, 3.65 }
        cylinder { 2.9*x, 8*x, 3.9 }
        cone { -2.900001*x, 3.650001, -2.5*x, 2.75 }
        cone { 2.5*x, 2.75, 2.900001*x, 3.900001 }
        cylinder { 3.8*y, 5.45*y, 2.4 translate <8, 0, 0> }
        cylinder { -3.8*y, -5.45*y, 2.4 translate <8, 0, 0> }
        cylinder { -4*y, -5.6*y, 2.25 translate <8, 0, 0> }
        cylinder { 4*y, 5.6*y, 2.25 translate <8, 0, 0> }
        torus { 2.25, 0.15 translate <8, 5.45, 0> }
        torus { 2.25, 0.15 translate <8, -5.45, 0> }
        difference {
          cylinder { -3.900001*z, 3.900001*z, 4.5 translate <8, 0, 0> }
          box { <4, 3.9, -5> <12, 10, 5> }
          box { <4, -3.9, -5> <12, -10, 5> }
        }
      }
      difference {
        box { <10.3, -5, -5> <15, 5, 5> }
        cylinder { -6*z, 6*z, 3.75 translate <8, 0, 0> }
      }
      cylinder { -5*z, 5*z, 2.5 translate <8, 0, 0> }
      cylinder { -5*z, -3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -4*x, 0*x, 2.5 translate <0, -4, -4> }
      cylinder { -4*x, 0*x, 2.5 translate <0, 4, -4> }
      cylinder { -4*x, 0*x, 2.5 translate <0, -4, 4> }
      cylinder { -4*x, 0*x, 2.5 translate <0, 4, 4> }
      box { <-2.5, -0.5, -4> <2.5, 0.5, 4> }
      object { axle_opening(8,1) translate <-4, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -5.7, -4> <12, 5.7, 4> } }
    }
  #end
#end
#macro tech_piston2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*x, 3.8*x, 2.8 }
      cylinder { 0*z, 3.900001*z, 4.5 translate <8, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -3.8*x, 3.8*x, 2.8 }
        cylinder { -3.9*x, -2.8*x, 3.65 }
        cylinder { 2.9*x, 8*x, 3.9 }
        cone { -2.800001*x, 3.650001, -2.5*x, 2.75 }
        cone { 2.5*x, 2.75, 2.900001*x, 3.900001 }
        cylinder { -0.4*z, 3.9*z, 3.9 translate <8, 0, 0> }
      }
      #local counter = 0;
      #while (counter < 16)
        difference {
          box { <-4, -0.4, -4> <-3.1, 0.4, 0> }
          box { <-5, 0, 0> <-2, 1, 5> rotate 5*x translate <0, 0.4, -4> }
          box { <-5, -1, 0> <0, 0, 5> rotate -5*x translate <0, -0.4, -4> }
          rotate (5.625+(counter*22.5))*x
        }
        #local counter = counter + 1;
      #end
      #local counter = 0;
      #while (counter < 16)
        difference {
          box { <-4, -0.4, -1> <0, 0.4, 0.5> }
          box { <0, 0, -2> <5, 1, 1> rotate 5*z translate <-4, 0.4, 0> }
          box { <0, -1, -2> <5, 0, 1> rotate -5*z translate <-4, -0.4, 0> }
          rotate (counter*22.5)*z translate <8, 0, 0>
        }
        #local counter = counter + 1;
      #end
      difference {
        box { <3.9, -5, -5> <12, 5, 0.050001> }
        cylinder { -0.500001*z, 3.9*z, 3.899999 translate <8, 0, 0> }
      }
      cylinder { -5*z, 5*z, 2.5 translate <8, 0, 0> }
      cylinder { -5*z, 0.5*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -4*x, 4*x, 2.5 translate <0, -4, -4> }
      cylinder { -4*x, 4*x, 2.5 translate <0, 4, -4> }
      cylinder { -4*x, 0*x, 2.5 translate <0, -4, 4> }
      cylinder { -4*x, 0*x, 2.5 translate <0, 4, 4> }
      box { <-2.5, -0.5, -4> <2.5, 0.5, 4> }
      cylinder { -4*x, -2.9*x, 2.3 }
      object { axle_opening(8.000005,1) translate <-4.1, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -5.7, -4> <12, 5.7, 4> } }
    }
  #end
#end
#macro tech_piston3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*x, 3.8*x, 2.8 }
      cylinder { 0.05*z, 3.90001*z, 3.9 translate <8, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -3.8*x, 3.8*x, 2.8 }
        cylinder { -3.9*x, -2.8*x, 3.65 }
        cylinder { 2.9*x, 8*x, 3.9 }
        cone { -2.80001*x, 3.65001, -2.5*x, 2.75 }
        cone { 2.5*x, 2.75, 2.90001*x, 3.90001 }
        cylinder { 0.05*z, 3.9*z, 3.9 translate <8, 0, 0> }
      }
      difference {
        box { <3.9, -5, -5> <12, 5, 0.05002> }
        cylinder { 0.05001*z, 3.9*z, 3.89999 translate <8, 0, 0> }
      }
      cylinder { -5*z, 5*z, 2.5 translate <8, 0, 0> }
      cylinder { -5*z, 0.5*z, 3.1 translate <8, 0, 0> }
      cylinder { 5*z, 3.4*z, 3.1 translate <8, 0, 0> }
      cylinder { -4*x, 4*x, 2.5 translate <0, -4, -4> }
      cylinder { -4*x, 4*x, 2.5 translate <0, 4, -4> }
      cylinder { -4*x, 0*x, 2.5 translate <0, -4, 4> }
      cylinder { -4*x, 0*x, 2.5 translate <0, 4, 4> }
      box { <-2.5, -0.5, -4> <2.5, 0.5, 4> }
      cylinder { -4*x, -2.9*x, 2.3 }
      object { axle_opening(8.00005,1) translate <-4.1, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -5.7, -4> <12, 5.7, 4> } }
    }
  #end
#end
#macro tech_pivotconnect2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*x, 4.1*x, 2.25 }
      cylinder { 4*x, 13*x, 3.9 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        torus { 2.249995, 0.3 rotate 90*z translate <-3.600005, 0, 0> }
        cylinder { -3.9*x, 4.1*x, 2.25 }
        cylinder { 3.25*x, 4.75*x, 2.9 }
        cylinder { 4*x, 13*x, 3.9 }
      }
      difference {
        box { <9.1, -5, -5> <14, 5, 5> }
        cylinder { -6*y, 6*y, 3.900001 translate <9.100001, 0, 0> }
      }
      cylinder { -4*z, 4*z, 0.5 translate <-1.000001, 0, 0> }
      box { <-4, -0.5, -4> <-1.499999, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <-1.5, 0, 0> }
      box { <5.5, 2.25, -6> <14, 5, 6> }
      box { <5.5, 0.75, -6> <14, -0.75, 6> }
      box { <5.5, -5, -6> <14, -2.25, 6> }
      cylinder { 2*y, 4*y, 1 translate <9.1, 0, 0> }
      cylinder { -2*y, -4*y, 1 translate <9.1, 0, 0> }
      cylinder { -4*x, 3.5*x, 1.6 }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 13.1*x, 4 } }
    }
  #end
#end
#macro tech_pivotconnect3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*x, 4.1*x, 2.25 }
      cylinder { 4*x, 13*x, 3.9 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          torus { 2.249995, 0.3 rotate 90*z translate <-3.600005, 0, 0> }
          cylinder { -3.9*x, 4.1*x, 2.25 }
          cylinder { 3.25*x, 4.75*x, 2.9 }
          cylinder { 4*x, 13*x, 3.9 }
        }
        difference {
          box { <9.1, -5, -5> <14, 5, 5> }
          cylinder { -6*y, 6*y, 3.900001 translate <9.100001, 0, 0> }
        }
        cylinder { -4*z, 4*z, 0.5 translate <-1.000001, 0, 0> }
        box { <-4, -0.5, -4> <-1.499999, 0.5, 4> }
        cylinder { -4*z, 4*z, 0.5 translate <-1.5, 0, 0> }
        box { <5.5, 2.35, -6> <14, 0.65, 6> }
        box { <5.5, -2.35, -6> <14, -0.65, 6> }
        cylinder { -4*x, 3.5*x, 1.6 }
      }
      cylinder { 2.1*y, 2.4*y, 0.9 translate <9.1, 0, 0> }
      cylinder { -2.1*y, -2.4*y, 0.9 translate <9.1, 0, 0> }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 13.1*x, 4 } }
    }
  #end
#end
#macro tech_pivotpipe(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 11*x, 3.9 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          torus { 2.9, 1 rotate 90*z translate <-2.9, 0, 0> }
          cylinder { -2.900001*x, 11*x, 3.9 }
        }
        difference {
          box { <7.1, -5, -5> <12, 5, 5> }
          cylinder { -6*y, 6*y, 3.900001 translate <7.100001, 0, 0> }
        }
        cylinder { -5*z, 5*z, 0.5 }
        box { <-10, -0.5, -5> <0, 0.5, 5> rotate 4*z }
        box { <-10, -0.5, -5> <0, 0.5, 5> rotate -4*z }
        box { <3.5, 2.35, -6> <12, 0.65, 6> }
        box { <3.5, -2.35, -6> <12, -0.65, 6> }
        cylinder { -4*x, 2*x, 2.8 }
      }
      cylinder { 2.1*y, 2.4*y, 0.9 translate <7.1, 0, 0> }
      cylinder { -2.1*y, -2.4*y, 0.9 translate <7.1, 0, 0> }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 11.1*x, 4 } }
    }
  #end
#end
#macro tech_plug1(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 11.9*x, 2.25 texture { color_tex } }
  #else
    difference {
      merge {
        torus { 2.249995, 0.3 rotate 90*z translate <-3.600005, 0, 0> }
        torus { 2.249995, 0.3 rotate 90*z translate <11.600005, 0, 0> }
        cylinder { -3.9*x, 11.9*x, 2.25 }
        cylinder { 3.35*x, 4.65*x, 2.9 }
      }
      box { <-4, -0.5, -4> <-1.499999, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <-1.5, 0, 0> }
      box { <9.499999, -0.5, -4> <12, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <9.5, 0, 0> }
      box { <0.5, -4, -0.5> <7.5, 4, 0.5> }
      cylinder { -4*y, 4*y, 0.5 translate <0.499999, 0, 0> }
      cylinder { -4*y, 4*y, 0.5 translate <7.500001, 0, 0> }
      cylinder { -4*x, 12*x, 1.6 }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 12*x, 3.1 } }
    }
  #end
#end
#macro tech_plug2(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 5.8*x, 2.25 texture { color_tex } }
  #else
    difference {
      merge {
        torus { 2.249995, 0.3 rotate 90*z translate <-3.600005, 0, 0> }
        cylinder { -3.9*x, 3.9*x, 2.25 }
        cylinder { 3.35*x, 4*x, 2.9 }
        object { open_rounded_button() rotate -90*z translate <1, 0, 0> }
      }
      box { <-4, -0.5, -4> <-1.499999, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <-1.5, 0, 0> }
      cylinder { -4*x, 6*x, 1.600001 }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 5.9*x, 3.1 } }
    }
  #end
#end
#macro tech_plug3(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 11.9*x, 2.25 texture { color_tex } }
  #else
    difference {
      merge {
        torus { 2.249995, 0.3 rotate 90*z translate <-3.600005, 0, 0> }
        object { axle_section(7.15) translate <4, 0, 0> }
        object { axle_ending(2) rotate 180*z translate <8, 0, 0> }
        cylinder { -3.9*x, 4*x, 2.25 }
        cylinder { 3.35*x, 4.65*x, 2.9 }
      }
      box { <-4, -0.5, -4> <-1.499999, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <-1.5, 0, 0> }
      cylinder { -4*x, 3.5*x, 1.6 }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 12*x, 3.1 } }
    }
  #end
#end
#macro tech_plug4(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 19.9*x, 2.25 texture { color_tex } }
  #else
    difference {
      merge {
        torus { 2.249995, 0.3 rotate 90*z translate <-3.600005, 0, 0> }
        torus { 2.249995, 0.3 rotate 90*z translate <19.600005, 0, 0> }
        cylinder { -3.9*x, 19.9*x, 2.25 }
        cylinder { 3.35*x, 4.65*x, 2.9 }
        torus { 1.6, 0.65 rotate 90*z scale <1.5, 1, 1.1> translate <12, 0, 0> }
      }
      box { <-4, -0.5, -4> <-1.499999, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <-1.5, 0, 0> }
      box { <17.499999, -0.5, -4> <20, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <17.5, 0, 0> }
      box { <1, -4, -0.5> <7, 4, 0.5> }
      cylinder { -4*y, 4*y, 0.5 translate <0.999999, 0, 0> }
      cylinder { -4*y, 4*y, 0.5 translate <7.000001, 0, 0> }
      box { <9, -4, -0.5> <15, 4, 0.5> }
      cylinder { -4*y, 4*y, 0.5 translate <8.999999, 0, 0> }
      cylinder { -4*y, 4*y, 0.5 translate <15.000001, 0, 0> }
      cylinder { -4*x, 20*x, 1.6 }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 20*x, 3.1 } }
    }
  #end
#end
#macro tech_plug5(color_tex)
  #if (setting = 0)
    cylinder { -3.9*x, 7.9*x, 2.25 texture { color_tex } }
  #else
    difference {
      merge {
        torus { 2.249995, 0.3 rotate 90*z translate <-3.600005, 0, 0> }
        torus { 2.249995, 0.3 rotate 90*z translate <7.600005, 0, 0> }
        cylinder { -3.9*x, 7.9*x, 2.25 }
        cylinder { 3.35*x, 5.05*x, 2.9 }
      }
      box { <-4, -0.5, -4> <-1.499999, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <-1.5, 0, 0> }
      box { <8, -0.5, -4> <5.999999, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <6, 0, 0> }
      cylinder { -4*x, 8*x, 1.600001 }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 8*x, 3.1 } }
    }
  #end
#end
#macro tech_plug_dual3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*x, 19.9*x, 2.25 }
      cylinder { -3.9*x, 19.9*x, 2.25 translate <0, 8, 0> }
      box { <4, 0, -2.25> <12, 8, 2.25> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        torus { 2.249995, 0.3 rotate 90*z translate <-3.600005, 0, 0> }
        torus { 2.249995, 0.3 rotate 90*z translate <-3.600005, 8, 0> }
        torus { 2.249995, 0.3 rotate 90*z translate <19.600005, 0, 0> }
        torus { 2.249995, 0.3 rotate 90*z translate <19.600005, 8, 0> }
        cylinder { -3.9*x, 19.9*x, 2.25 }
        cylinder { -3.9*x, 19.9*x, 2.25 translate <0, 8, 0> }
        cylinder { 3.35*x, 4.65*x, 2.9 }
        cylinder { 3.35*x, 4.65*x, 2.9 translate <0, 8, 0> }
        cylinder { 11.35*x, 12.65*x, 2.9 }
        cylinder { 11.35*x, 12.65*x, 2.9 translate <0, 8, 0> }
        cylinder { 4*x, 4.8*x, 3.65 }
        cylinder { 4*x, 4.8*x, 3.65 translate <0, 8, 0> }
        cylinder { 11.2*x, 12*x, 3.65 }
        cylinder { 11.2*x, 12*x, 3.65 translate <0, 8, 0> }
        cylinder { 4.1*x, 11.9*x, 2.9 }
        cylinder { 4.1*x, 11.9*x, 2.9 translate <0, 8, 0> }
        box { <4.1, 0, -2.9> <11.9, 8, 2.9> }
        box { <4.000005, 0, -3.650005> <4.799995, 8, 3.650005> }
        box { <11.200005, 0, -3.650005> <11.999995, 8, 3.650005> }
        cylinder { -3.650005*z, 3.650005*z, 3.7 translate <8, 4, 0> }
        cylinder { -3.650007*z, 3.650007*z, 1 translate <8, 0.35, 0> }
        cylinder { -3.650007*z, 3.650007*z, 1 translate <8, 7.65, 0> }
      }
      box { <-4, -0.5, -4> <-1.499999, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <-1.5, 0, 0> }
      box { <17.499999, -0.5, -4> <20, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <17.5, 0, 0> }
      box { <-4, 7.5, -4> <-1.499999, 8.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <-1.5, 8, 0> }
      box { <17.499999, 7.5, -4> <20, 8.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <17.5, 8, 0> }
      object { axle_opening(8,1) rotate -90*y translate <8, 4, -4> }
      box { <2, 3.000007, -4> <18, 5.000007, -3.45> }
      box { <2, 3.000007, 4> <18, 5.000007, 3.45> }
      cylinder { -4*z, 4*z, 0.500001 translate <8, 0.35, 0> }
      cylinder { -4*z, 4*z, 0.500001 translate <8, 7.65, 0> }
      box { <7.5, 0.35, -4> <8.5, 7.65, 4> }
      cylinder { -4*x, 3.4*x, 1.6 }
      cylinder { -4*x, 3.4*x, 1.6 translate <0, 8, 0> }
      cylinder { 20*x, 11.6*x, 1.6 }
      cylinder { 20*x, 11.6*x, 1.6 translate <0, 8, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -4, -3.75> <20, 12, 3.75> } }
    }
  #end
#end
#macro tech_plug_locker(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3*x, 19.9*x, 2.25 }
      cylinder { -3.9*x, 3.9*x, 2.8 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -3.8*x, 3.8*x, 2.8 }
        cylinder { -3.75*x, -2.9*x, 3.65 }
        torus { 3.5, 0.15 rotate 90*z translate <-3.75, 0, 0> }
        torus { 3.5, 0.15 rotate 90*z translate <3.75, 0, 0> }
        cylinder { -3.9*x, -3*x, 3.5 }
        cylinder { 3.9*x, 3*x, 3.5 }
        cylinder { 2.9*x, 3.75*x, 3.65 }
        cone { -2.900001*x, 3.650001, -2.5*x, 2.75 }
        cone { 2.5*x, 2.75, 2.900001*x, 3.650001 }
        torus { 2.249995, 0.3 rotate 90*z translate <19.600005, 0, 0> }
        cylinder { -3.8*x, 19.9*x, 2.25 }
        cylinder { 3.35*x, 4.65*x, 2.9 }
        torus { 1.6, 0.65 rotate 90*z scale <1.5, 1, 1.1> translate <12, 0, 0> }
      }
      box { <-2, -0.5, -4> <2, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <-2, 0, 0> }
      cylinder { -4*z, 4*z, 0.5 translate <2, 0, 0> }
      object { axle_opening(8.000002,1) translate <-4, 0, 0> }
      cylinder { -4*x, -2.9*x, 2.4 }
      box { <17.499999, -4, -0.5> <20, 4, 0.5> }
      cylinder { -4*y, 4*y, 0.5 translate <17.5, 0, 0> }
      box { <4.650001, -0.5, -4> <7, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <7, 0, 0> }
      box { <9, -0.5, -4> <15, 0.5, 4> }
      cylinder { -4*z, 4*z, 0.5 translate <9, 0, 0> }
      cylinder { -4*z, 4*z, 0.5 translate <15, 0, 0> }
      difference {
        cylinder { 3.999999*x, 20*x, 1.7 }
        box { <3, -4, -2> <21, -1, 2> }
        box { <3, 1, -2> <21, 4, 2> }
      }
      texture { color_tex }
      bounded_by { cylinder { -4*x, 20*x, 3.8 } }
    }
  #end
#end
#macro tech_pneumatic_t_piece(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -6.6*x, 6.6*x, 1.5 }
      cylinder { -8.4*y, 0*y, 1.5 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        sphere { <0, 0, 0> 2.15 }
        cylinder { -6*x, 6*x, 1.5 }
        cylinder { -7.8*y, 0*y, 1.5 }
        cone { -6.6*x, 1.1, -5.999999*x, 1.5 }
        cone { 5.999999*x, 1.5, 6.6*x, 1.1 }
        cone { -8.4*y, 1.1, -7.799999*y, 1.5 }
      }
      cylinder { -10*x, 10*x, 0.6 }
      cylinder { -10*y, 0*y, 0.6 }
      texture { color_tex }
      bounded_by { box { <-6.7, -8.5, -2.25> <6.7, 2.25, 2.25> } }
    }
  #end
#end
#macro tech_pole_reverser_handle(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.9*x, 3.9*x, 2.8 }
      cylinder { 0*y, 19.5*y, 2.25 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -3.8*x, 3.8*x, 2.8 }
        cylinder { -3.75*x, -2.9*x, 3.65 }
        torus { 3.5, 0.15 rotate 90*z translate <-3.75, 0, 0> }
        torus { 3.5, 0.15 rotate 90*z translate <3.75, 0, 0> }
        cylinder { -3.9*x, -3*x, 3.5 }
        cylinder { 3.9*x, 3*x, 3.5 }
        cylinder { 2.9*x, 3.75*x, 3.65 }
        cone { -2.900001*x, 3.650001, -2.5*x, 2.75 }
        cone { 2.5*x, 2.75, 2.900001*x, 3.650001 }
        box { <-3.900005, 2, -2.35> <-3.000005, 8, 2.35> }
        box { <3.900005, 2, -2.35> <3.000005, 8, 2.35> }
        box { <-0.45, 1, -2.35> <0.45, 8, 2.35> }
        box { <-3, 1, -1> <3, 7.5, 1> }
        box { <-3.900003, 7.1, -2.350005> <3.900003, 8.000005, 2.350005> }
        cylinder { -2.350007*z, 2.350007*z, 1.25 translate <0, 5, 0> }
        object { axle_section(10.85) rotate 90*z translate <0, 8, 0> }
        object { axle_ending(1) rotate -90*z translate <0, 15.7, 0> }
      }
      box { <-2.4, -0.5, -4> <2.4, 0.5, 4> }
      object { axle_opening(8,1) translate <-4, 0, 0> }
      cylinder { -4*x, -3.7*x, 2.35 }
      cylinder { 4*x, 3.7*x, 2.35 }
      texture { color_tex }
      bounded_by { box { <-4, -4, -4> <4, 19.6, 4> } }
    }
  #end
#end
#macro tech_pulley_large(color_tex)
  #if (setting = 0)
    merge {
      torus { 17, 2.5 rotate 90*x }
      cylinder { -16*x, 16*x, 2.5 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -3.9*z, 3.9*z, 3.8 }
        difference {
          cylinder { -16*x, 16*x, 2.5 }
          box { <-20, -20, -2.300005> <20, 20, -3> }
          box { <-20, -20, 2.300005> <20, 20, 3> }
        }
        difference {
          torus { 17, 2.5 rotate 90*x }
          box { <-20, -20, -2.300003> <20, 20, -3> }
          box { <-20, -20, 2.300003> <20, 20, 3> }
        }
        intersection {
          torus { 4.5, 2.5 rotate 90*x }
          box { <0, 4.6, -2.300004> <4.6, 0, 2.300004> }
          translate <12, -4.499995, 0> rotate -2*z
        }
        intersection {
          torus { 4.5, 2.5 rotate 90*x }
          box { <0, -4.6, -2.300004> <4.6, 0, 2.300004> }
          translate <12, 4.499995, 0> rotate 2*z
        }
        intersection {
          torus { 4.5, 2.5 rotate 90*x }
          box { <0, 4.6, -2.300004> <-4.6, 0, 2.300004> }
          translate <-12, -4.499995, 0> rotate 2*z
        }
        intersection {
          torus { 4.5, 2.5 rotate 90*x }
          box { <0, -4.6, -2.300004> <-4.6, 0, 2.300004> }
          translate <-12, 4.499995, 0> rotate -2*z
        }
        cylinder { -3*z, 3*z, 3.1 translate <-12, 0, 0> }
        cylinder { -3*z, 3*z, 3.1 translate <12, 0, 0> }
        box { <13, -1.5, -2.300009> <17, 1.5, 2.300009> }
        box { <-13, -1.5, -2.300009> <-17, 1.5, 2.30009> }
      }
      difference {
        cylinder { -1*z, 1*z, 19.5 }
        cone { -0.000005*z, 18, 1.000005*z, 19.500005 }
        cone { 1.000005*z, 19.500005, 0.000005*z, 18 }
        cylinder { -3*z, 3*z, 16.999995 }
      }
      object { axle_opening(10,1) rotate 90*y translate <0, 0, 5> }
      cylinder { -3*z, 3*z, 0.5 translate <-6.4, 0, 0> }
      box { <-6.4, -0.5, -4> <6.4, 0.5, 4> }
      cylinder { -3*z, 3*z, 0.5 translate <6.4, 0, 0> }
      cylinder { -4*z, 4*z, 2.5 translate <-12, 0, 0> }
      cylinder { -4*z, 4*z, 2.5 translate <12, 0, 0> }
      texture { color_tex }
      bounded_by { cylinder { -4*z, 4*z, 19.6 } }
    }
  #end
#end
#macro tech_round_protector(color_tex)
  #if (setting = 0)
    cylinder { -7.9*z, 7.9*z, 16 texture { color_tex } }
  #else
    merge {
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y rotate 90*x translate <-12, 0, 3.9> }
      #end
      difference {
        merge {
          cylinder { -15*x, 15*x, 3.9 }
          box { <-15, -3.9, -0.000005> <15, 3.9, 3.900005> }
          cylinder { -3.9*z, 0.000005*z, 3.9 }
        }
        cylinder { -5*z, 5*z, 2.4 }
        cylinder { -5*z, -3.4*z, 3.1 }
        cylinder { 3.4*z, 5*z, 3.1 }
        cylinder { 8*x, 20*x, 2.4 }
        cylinder { -8*x, -20*x, 2.4 }
        #if (setting > 1)
          difference {
            merge {
              cylinder { -8.8*x, -6.8*x, 3.1 }
              cylinder { -17*x, 17*x, 2.4 }
              cylinder { 8.8*x, 6.8*x, 3.1 }
              box { <-8.800005, -3.1, -0.000005> <-6.800005, 3.1, 5> }
              box { <-7, -2.4, -0.000005> <7, 2.4, 5> }
              box { <6.800005, -3.1, -0.000005> <8.800005, 3.1, 5> }
            }
            cylinder { -6*z, 6*z, 4.1 }
          }
        #end
      }
      difference {
        merge {
          cylinder { -3.75*z, 3.75*z, 16 }
          cone { -7.9*z, 15.4, -3.749999*z, 16 }
          cone { 3.749999*z, 16, 7.9*z, 15.4 }
        }
        difference {
          cylinder { -17*x, 17*x, 2.400005 }
          cylinder { -6*z, 6*z, 4.100005 }
        }
        cylinder { -10*z, 10*z, 14.55 }
        box { <15.000005, -10, -3.1> <20, 10, 3.1> }
        box { <-15.000005, -10, -3.1> <-20, 10, 3.1> }
      }
      texture { color_tex }
      bounded_by { cylinder { -8*z, 8*z, 16.1 } }
    }
  #end
#end
#macro tech_wheel_thin(color_tex)
  #if (setting = 0)
    cylinder { -1.6*x, 1.6*x, 12 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -1.1*x, 1.1*x, 12 }
        cylinder { -1.6*x, 1.6*x, 11.5 }
        torus { 11.5, 0.5 rotate 90*z translate <-1.1, 0, 0> }
        torus { 11.5, 0.5 rotate 90*z translate <1.1, 0, 0> }
      }
      cylinder { -2*x, 2*x, 2.5 translate <0, 0, 8> rotate 30*x }
      cylinder { -2*x, 2*x, 2.5 translate <0, 0, 8> rotate 90*x }
      cylinder { -2*x, 2*x, 2.5 translate <0, 0, 8> rotate 150*x }
      cylinder { -2*x, 2*x, 2.5 translate <0, 0, 8> rotate 210*x }
      cylinder { -2*x, 2*x, 2.5 translate <0, 0, 8> rotate 270*x }
      cylinder { -2*x, 2*x, 2.5 translate <0, 0, 8> rotate 330*x }
      cylinder { 1.3*x, 2*x, 3 translate <0, 0, 8> rotate 30*x }
      cylinder { 1.3*x, 2*x, 3 translate <0, 0, 8> rotate 90*x }
      cylinder { 1.3*x, 2*x, 3 translate <0, 0, 8> rotate 150*x }
      cylinder { 1.3*x, 2*x, 3 translate <0, 0, 8> rotate 210*x }
      cylinder { 1.3*x, 2*x, 3 translate <0, 0, 8> rotate 270*x }
      cylinder { 1.3*x, 2*x, 3 translate <0, 0, 8> rotate 330*x }
      cylinder { -2*x, -1.3*x, 3 translate <0, 0, 8> rotate 30*x }
      cylinder { -2*x, -1.3*x, 3 translate <0, 0, 8> rotate 90*x }
      cylinder { -2*x, -1.3*x, 3 translate <0, 0, 8> rotate 150*x }
      cylinder { -2*x, -1.3*x, 3 translate <0, 0, 8> rotate 210*x }
      cylinder { -2*x, -1.3*x, 3 translate <0, 0, 8> rotate 270*x }
      cylinder { -2*x, -1.3*x, 3 translate <0, 0, 8> rotate 330*x }
      difference {
        merge {
          cone { 1.3*x, 9, 2*x, 12 }
          cone { -2*x, 12, -1.3*x, 9 }
        }
        cylinder { -3*x, 3*x, 3.75 }
      }
      cylinder { -2*x, 2*x, 0.500001 translate <0, 0, -4.399999> }
      cylinder { -2*x, 2*x, 0.500001 translate <0, 0, 4.399999> }
      box { <-2, -0.5, -4.4> <2, 0.5, 4.4> }
      object { axle_opening(4,1) translate <-2, 0, 0> }
      torus { 12, 0.65 rotate 90*z }
      texture { color_tex }
      bounded_by { cylinder { -1.7*x, 1.7*x, 12.1 } }
    }
  #end
#end
#macro tech_wheel_thin_tyre(color_tex)
  #if (setting = 0)
    difference {
      cylinder { -1.75*z, 1.75*z, 15.15 }
      cylinder { -2*z, 2*z, 12.2 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        torus { 13.4, 1.75 rotate 90*x }
        cylinder { -3*z, 3*z, 12.2 }
      }
      torus { 12, 1 rotate 90*x scale <1, 1, 0.8> }
      texture { color_tex }
      bounded_by { cylinder { -1.85*z, 1.85*z, 15.25 } }
    }
  #end
#end
#macro terminal(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 3.1, 11.9> }
      box { <-8.9, 3, 0.1> <3.9, 17.5, 7.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <3.9, 3.1, 11.9> }
          box { <-8.9, 3.099999, 0.1> <3.900001, 17.5, 7.9> }
          object { open_rounded_button() rotate -90*x translate <0, 13, 3.2> }
          object { open_rounded_button() rotate 90*x translate <0, 13, 4.8> }
        }
        #if (setting > 1)
          cylinder { -2*z, 10*z, 1.600001 translate <0, 13, 0> }
          box { <-2.4, -1, -2.4> <2.4, 2, 10.4> }
        #end
        cylinder { 0*z, 8*z, 4.75 translate <-6.15, 7.25, 0> }
        box { <-9, 0, 0> <-6.15, 12.000001, 8> }
        box { <-9, 3.100001, 1.6> <2.400001, 12.8, 6.4> }
        box { <-2.400001, 1, 1.600001> <2.400002, 4, 6.399999> }
        box { <0, 0, -1> <10, 10, 9> rotate 32*z translate <3.9, 12.8, 0> }
        box { <0, 0, -1> <15, 10, 9> rotate 19*z translate <-8.9, 14, 0> }
        box { <1, 6.5, 1.600002> <4, 11.3, 6.399998> }
      }
      #if (setting > 1)
        cylinder { -0.1*y, 1.4*y, 1 translate <1.75, 0, -2> rotate 19*z translate <-8.9, 14, 4> }
        cylinder { -0.1*y, 1.4*y, 1 translate <1.75, 0, 2> rotate 19*z translate <-8.9, 14, 4> }
      #end
      object { open_rounded_button() translate <7.25, -3.1, 0> rotate 19*z translate <-8.9, 14, 4> }
      #if (setting > 3)
        object { llogo() rotate 180*y scale <0.65, 0.65, 0.65> translate <7.25, 0, 0>
          rotate 19*z translate <-8.9, 14, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-9, -0.1, -4> <4, 20, 12> } }
    }
  #end
#end
#macro terrain_wheel(color_tex)
  #if (setting = 0)
    cylinder { 0.1*z, 22.9*z, 11.5 texture { color_tex } }
  #else
    difference {
      merge { 
        cone { 0.1*z, 9.6, 11.8*z, 10.5 }
        cone { 11.199999*z, 10.5, 22.9*z, 9.6 }
        cylinder { 10.5*z, 12.5*z, 11.5 }
        #local counter = 0;
        #while (counter < 10)
          difference {
            merge {
              box { <-1.5, -1, -10.5> <1.5, 1, 0.5> }
              box { <-1.25, -1, 0> <0, 1.000001, 1.75> rotate 30*y translate <1.499999, 0, -1.5> }
            }
            difference {
              box { <-2, -1, -2> <2, 2, 0> }
              cylinder { -2*x, 2*x, 1 }
              translate <0, 0, -9.6>
            }
            rotate -5.000001*x
            translate <0, 10.5, 10.5>
            rotate (36*counter)*z
          }
          #local counter = counter + 1;
        #end
        #local counter = 0;
        #while (counter < 10)
          difference {
            merge {
              box { <-1.5, -1, -0.75> <1.5, 1, 11> }
              box { <0, -1, -1.75> <1.25, 1.000001, 0> rotate 30*y translate <-1.499999, 0, 1.5> }
              difference {
                box { <-1.500001, -6.8, 10.25> <1.500001, 0, 11.000001> rotate -5*x }
                box { <-2, -7, 10> <-0.5, -1, 12> }
                box { <-2.000001, -10, 9.999999> <-0.500001, 0, 12.000001> }
              }
            }
            box { <-15, -0.000005, -2> <0.000005, 15, 16> rotate 45*z translate <-0.5, 0, 0> }
            box { <-2, -10, -2> <-0.499995, -0.000005, 16> }
            difference {
              box { <-3, 0, 0> <3, 2, 2> }
              cylinder { -3*x, 3*x, 1 }
              translate <0, 0, 10.1>
            }
            rotate 5.000001*x
            translate <0, 10.5, 12.5>
            rotate (18+(36*counter))*z
          }
          #local counter = counter + 1;
        #end
        difference {
          cylinder { 22.8*z, 23.5*z, 4 }
          cylinder { 22.7*z, 24*z, 3.250001 }
        }
      }
      cylinder { -1*z, 3*z, 2.5 }
      cylinder { 2.9*z, 25*z, 3.25 }
      #if (setting > 1)
        difference {
          cylinder { -0.5*z, 21.6*z, 8.7 }
          cylinder { -1*z, 5*z, 4 }
          cylinder { 4.999999*z, 22*z, 4.75 }
        }
      #end
      cylinder { -1*z, 24*z, 11.500001 inverse }
      texture { color_tex }
      bounded_by { cylinder { -0.6*z, 23.6*z, 11.6 } }
    }
  #end
#end
#macro tilted_frame(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 28.7, 27.9> }
      box { <-10, -50, -50> <30, 0, 50> rotate -49*x translate <0, 0, 4> }
      box { <-10, 0, -50> <30, 60, 50> rotate -49*x translate <0, 3.100001, -4.00001> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <27.9, 28.7, 27.9> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          #end
          box { <-10, -50, -50> <30, 0, 50> rotate -49*x translate <0, 0, 4> }
          box { <-10, 0, -50> <30, 60, 50> rotate -49*x translate <0, 3.100001, -4.00001> }
          difference {
            box { <-2.4, -1, -2.9> <26.4, 27.2, 28> }
            box { <-3, -2, -4> <27, 3.1, 3.9> }
          }
          box { <-2.400002, 3.099999, -4> <26.400002, 27.200002, 28> }
        }
        #if (setting < 3)
          cylinder { 28.6*y, 30.4*y, 2.4 translate <0, 0, 24> }
          cylinder { 28.6*y, 30.4*y, 2.4 translate <8, 0, 24> }
          cylinder { 28.6*y, 30.4*y, 2.4 translate <16, 0, 24> }
          cylinder { 28.6*y, 30.4*y, 2.4 translate <24, 0, 24> }
        #else
          object { rounded_button() translate <0, 25.6, 24> }
          object { rounded_button() translate <8, 25.6, 24> }
          object { rounded_button() translate <16, 25.6, 24> }
          object { rounded_button() translate <24, 25.6, 24> }
        #end
        #if (setting > 1)
          object { pin(1) translate <4, 0, 0> }
          object { pin(1) translate <12, 0, 0> }
          object { pin(1) translate <20, 0, 0> }
        #end
      }
      #if (setting > 1)
        cylinder { 26.6*y, 29.6*y, 1.2 translate <0, 0, 24> }
        cylinder { 26.6*y, 29.6*y, 1.2 translate <8, 0, 24> }
        cylinder { 26.6*y, 29.6*y, 1.2 translate <16, 0, 24> }
        cylinder { 26.6*y, 29.6*y, 1.2 translate <24, 0, 24> }
      #end
      cylinder { -4*x, 28*x, 0.9 translate <0, 15, 10> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 30.5, 28> } }
    }
  #end
#end
#macro tilted_window(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 28.7, 27.9> }
      box { <-10, -50, -50> <30, 0, 50> rotate -48.65*x translate <0, 0, 4> }
      box { <-10, 0, -50> <30, 50, 50> rotate -48.65*x translate <0, 28.7, 20> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 28.7, 27.9> }
        box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
        box { <-10, -50, -50> <30, 0, 50> rotate -48.65*x translate <0, 0, 4> }
        box { <-10, 0, -50> <30, 50, 50> rotate -48.65*x translate <0, 28.7, 20> }
        difference {
          box { <-2.9, -1, -2.9> <26.9, 27.2, 28> }
          box { <-3, -2, -4> <27, 3.100001, 3.9> }
          box { <-10, 0, -50> <30, 50, 50> rotate -48.65*x translate <0, 28.7, 21.4> }
        }
        box { <-1.5, -2, 0> <25.5, 1, 13.75> rotate -48.65*x translate <0, 4.8, -1.5> }
        box { <-1.5, -2, 0> <25.5, 1, 13.75> rotate -48.65*x translate <0, 17, 9> }
      }
      object { open_rounded_button() translate <0, 25.6, 24> }
      object { open_rounded_button() translate <8, 25.6, 24> }
      object { open_rounded_button() translate <16, 25.6, 24> }
      object { open_rounded_button() translate <24, 25.6, 24> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 28.7, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 28.7, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 28.7, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 28.7, 24> }
      #end
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 30.5, 28> } }
    }
  #end
#end
#macro tilted_window_glass(color_tex)
  difference {
    box { <-2.8, 3.2, -2.8> <26.8, 27.1, 28> }
    box { <-10, 0, -50> <30, 50, 50> rotate -48.65*x translate <0, 28.7, 21.5> }
    box { <-10, -50, -50> <30, 0, 50> rotate -48.65*x translate <0, 28.7, 23> }
    texture { color_tex }
  }
#end
#macro tilting_glass(color_tex)
  #if (setting = 0)
    box { <-2, -1, -16> <26, 1, 16> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-2, -1, -16> <26, 1, 16> }
        box { <-3, 0, -5> <28, 2, 5> rotate -45*x translate <0, 0, -15.5> }
        box { <-3, -2, -5> <28, 0, 5> rotate 45*x translate <0, 0, -15.5> }
        box { <-3, -2, -5> <28, 0, 5> rotate -45*x translate <0, 0, 15.5> }
        box { <-3, 0, -5> <28, 2, 5> rotate 45*x translate <0, 0, 15.5> }
      }
      box { <-2.3, -1.000001, -2.4> <26.3, 1.000001, 2.4> }
      #if (setting > 1)
        sphere { <-2, 0, 0> 0.7 }
        sphere { <26, 0, 0> 0.7 }
      #end
      texture { color_tex }
      bounded_by { box { <-2.8, -1.1, -15.6> <26.8, 1.1, 15.6> } }
    }
  #end
#end
#macro tool_driver1(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 9*y, 1.5 }
      cylinder { 1*y, 13*y, 0.8 }
      cylinder { -1.5*z, 1.5*z, 3 translate <0, 15.5, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 2*y, 1.5 }
        cylinder { 2.4*y, 2.8*y, 1.5 }
        cylinder { 3.2*y, 3.6*y, 1.5 }
        cylinder { 4*y, 4.4*y, 1.5 }
        cylinder { 4.8*y, 5.2*y, 1.5 }
        cylinder { 5.6*y, 6*y, 1.5 }
        cylinder { 6.4*y, 6.8*y, 1.5 }
        cylinder { 7.2*y, 9*y, 1.5 }
        cylinder { 1*y, 8*y, 1.3 }
        cone { 8.999999*y, 1.5, 10*y, 0.9 }
        cylinder { 9.5*y, 13*y, 0.8 }
        cylinder { -1.5*z, 1.5*z, 3 translate <0, 15.5, 0> }
      }
      box { <-1.2, -2.3, -2> <1.2, 2.3, 2> rotate 90*z translate <0, 15.5, 0> }
      box { <-1.2, -2.3, -2> <1.2, 2.3, 2> rotate 30*z translate <0, 15.5, 0> }
      box { <-1.2, -2.3, -2> <1.2, 2.3, 2> rotate 150*z translate <0, 15.5, 0> }
      texture { color_tex }
      bounded_by { box { <-3.25, -0.25, -2> <3.25, 18.75, 2> } }
    }
  #end
#end
#macro tool_driver2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 9*y, 1.5 }
      cylinder { 1*y, 13*y, 0.8 }
      cylinder { -1.5*z, 1.5*z, 3 translate <0, 15.5, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 2*y, 1.5 }
        cylinder { 2.4*y, 2.8*y, 1.5 }
        cylinder { 3.2*y, 3.6*y, 1.5 }
        cylinder { 4*y, 4.4*y, 1.5 }
        cylinder { 4.8*y, 5.2*y, 1.5 }
        cylinder { 5.6*y, 6*y, 1.5 }
        cylinder { 6.4*y, 6.8*y, 1.5 }
        cylinder { 7.2*y, 9*y, 1.5 }
        cylinder { 1*y, 8*y, 1.3 }
        cone { 8.999999*y, 1.5, 10*y, 0.9 }
        cylinder { 9.5*y, 13*y, 0.8 }
        cylinder { -1.5*z, 1.5*z, 3 translate <0, 16, 0> }
      }
      box { <-1.1, -1.9, -2> <8, 1.9, 2> rotate 75*z translate <0, 16, 0> }
      box { <-1.1, -1.9, -2> <1.1, 1.9, 2> rotate 15*z translate <0, 16, 0> }
      box { <-1.1, -1.9, -2> <1.1, 1.9, 2> rotate 135*z translate <0, 16, 0> }
      texture { color_tex }
      bounded_by { box { <-3.25, -0.25, -2> <3.25, 18.75, 2> } }
    }
  #end
#end
#macro tool_grappling_hook(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -1.5*y, 14.5*y, 1.5 }
      box { <0, -0.3, -1.2> <8, 0.3, 1.2> rotate -45*z translate <0.5, 15, 0> }
      box { <0, -0.3, -1.2> <8, 0.3, 1.2> rotate -45*z translate <0.5, 15, 0> rotate 120*y }
      box { <0, -0.3, -1.2> <8, 0.3, 1.2> rotate -45*z translate <0.5, 15, 0> rotate 240*y }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        sphere { <0, 0, 0> 1.5 }
        cylinder { 0*y, 13*y, 1.5 }
        sphere { <0, 13, 0> 1.5 }
        #local counter = 0;
        #while (counter < 3)
          merge {
            difference {
              torus { 2.5, 1.25 rotate 90*x }
              box { <-10, -10, -2> <10, 0, 2> }
              box { <0, -10, -2> <10, 10, 2> rotate -10*z }
            }
             cone { -0.000005*x, 1.25, 2.500005*x, 1.2 translate <0, 2.5, 0> rotate -10*z }
            sphere { <0, 0, 0> 1.2 scale <1.75, 1, 1> translate <2.5, 2.5, 0> rotate -10*z }
            cylinder { -0.3*y, 0.3*y, 0.3 translate <-2, 0, 0.3> rotate 30*y translate <4.4, 2.5, 0> rotate -10*z }
            cylinder { -0.3*y, 0.3*y, 0.3 translate <-2, 0, -0.3> rotate -30*y translate <4.4, 2.5, 0> rotate -10*z }
            cylinder { -0.3*y, 0.3*y, 0.6 translate <4.4, 2.5, 0> rotate -10*z }
            box { <-2, -0.300001, -0.3> <0, 0.300001, 0.6> rotate 30*y translate <4.4, 2.5, 0> rotate -10*z }
            box { <-2, -0.300002, -0.6> <0, 0.300002, 0.3> rotate -30*y translate <4.4, 2.5, 0> rotate -10*z }
            translate <2, 0, 0> rotate -45*z translate <0.5, 13.5, 0> rotate (counter*120)*y
          }
          #local counter = counter + 1;
        #end
      }
      cylinder { -2*x, 2*x, 0.65 }
      box { <-2, -2, -2> <-1, 0, 2> }
      box { <1, -2, 2> <2, 0, 2> }
      texture { color_tex }
      bounded_by { box { <-5, -1.6, -8> <8, 14.5, 8> } }
    }
  #end
#end
#macro tool_hammer(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 11*y, 1.5 }
      cylinder { 1*y, 17.6*y, 0.8 }
      box { <-3, 15.7, -1.05> <4, 17.7, 1.05> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 2*y, 1.5 }
        cylinder { 2.4*y, 2.8*y, 1.5 }
        cylinder { 3.2*y, 3.6*y, 1.5 }
        cylinder { 4*y, 4.4*y, 1.5 }
        cylinder { 4.8*y, 5.2*y, 1.5 }
        cylinder { 5.6*y, 6*y, 1.5 }
        cylinder { 6.4*y, 6.8*y, 1.5 }
        cylinder { 7.2*y, 11*y, 1.5 }
        cylinder { 1*y, 10*y, 1.3 }
        cone { 10.999999*y, 1.5, 12*y, 0.9 }
        cylinder { 9.5*y, 17.6*y, 0.8 }
        box { <-3, 15.7, -1.05> <4, 17.7, 1.05> }
      }
      difference {
        box { <0, -2, -3> <2, 0, 3> }
        cylinder { -2*z, 2*z, 0.5 }
        translate <3.5, 16.2, 0>
      }
      box { <0, 0, -2> <10, 10, 2> rotate 55*z translate <4, 16.7, 0> }
      texture { color_tex }
      bounded_by { box { <-3.25, -0.25, -1.75> <4.25, 18, 1.75> } }
    }
  #end
#end
#macro tool_oilcan(color_tex)
  #if (setting = 0)
    merge {
      cone { -11*y, 3.85, -3.5*y, 2.5 translate <-5, 0, 0> }
      cylinder { <-7, -2.25, 0>, <-13, 0, 0>, 0.65 }
      difference {
        cylinder { 0*y, -9*y, 1.5 rotate 12*z }
        box { <-3, -11, -3> <6, -8.000001, 3> }
        box { <-3, -1.500001, -3> <6, 5, 3> }
      }
      texture { color_tex }
      rotate -12*z
      translate <-1, -6, 0>
    }
  #else
    merge {
      difference {
        cylinder { 0*y, -9*y, 1.5 rotate 12*z }
        box { <-3, -11, -3> <6, -8.000001, 3> }
        box { <-3, -1.500001, -3> <6, 5, 3> }
      }
      box { <-3, -3.5, -1.499999> <1, -1.5, 1.499999> }
      cylinder { -3.500001*y, -1.500001*y, 3 translate <-5, 0, 0> }
      cone { -8.825*y, 3.85, -3.5*y, 2.5 translate <-5, 0, 0> }
      torus { 3.15, 0.7 translate <-5, -9, 0> }
      cylinder { -11.5*y, -9*y, 3 translate <-5, 0, 0> }
      cylinder { <-7, -2.25, 0>, <-13, 0, 0>, 0.65 }
      sphere { <-13, 0, 0> 0.649999 }
      cylinder { -16*x, -12.999999*x, 0.650001 }
      sphere { <-16, 0, 0> 1 }
      cylinder { -16*x, -15*x, 0.999999 }
      difference {
        sphere { <-5, -6, 0> 3 scale <1, 0.25, 1> }
        cylinder { -2*y, 7*y, 6 rotate 12*z }
      }
      box { <-3, -0.15, -1.2> <1, 1, 1.2> }
      box { <-5, -1.15, -1.200001> <0, 0, 1.200001> rotate 40*z translate <-3, 1, 0> }
      texture { color_tex }
      bounded_by { box { <-17.25, -11.75, -4> <4, 1.5, 4> } }
      rotate -12*z
      translate <-1, -6, 0>
    }
  #end
#end
#macro tool_powerdrill(color_tex)
  #if (setting = 0)
    merge {
      difference {
        cylinder { 0*y, -9*y, 1.5 rotate 12*z }
        box { <-3, -11, -3> <6, -8.000001, 3> }
      }
      cylinder { -15*x, -11*x, 0.75 }
      box { <-12, -3.5, -2.200001> <1, 2.200001, 2.200001> }
      texture { color_tex }
      rotate -12*z
      translate <0, -6, 0>
    }
  #else
    merge {
      difference {
        cylinder { 0*y, -9*y, 1.5 rotate 12*z }
        box { <-3, -11, -3> <6, -8.000001, 3> }
      }
      sphere { <-15, 0, 0> 0.749999 }
      cylinder { -15*x, -12*x, 0.75 }
      cone { -12.7*x, 0.9, -11.6*x, 1.5 }
      cylinder { -11.600001*x, -10*x, 1.500001 }
      cylinder { -10.000001*x, -7.5*x, 2.2 }
      difference {
        box { <-7.500001, -3.5, -2.200001> <1, 2.200001, 2.200001> }
        difference {
          box { <-8, -4, -3> <-6.75, -2.75, 3> }
          cylinder { -3*z, 3*z, 0.75 translate <-6.75, -2.75, 0> }
        }
        difference {
          box { <-10, -4, -3> <2, -3, -1.7> }
          cylinder { -9*x, 2*x, 0.5 translate <0, -3, -1.7> }
        }
        difference {
          box { <-10, -4, 1.7> <2, -3, 3> }
          cylinder { -9*x, 2*x, 0.5 translate <0, -3, 1.7> }
        }
        difference {
          box { <-10, 1.7, -3> <2, 3, -1.7> }
          cylinder { -9*x, 2*x, 0.5 translate <0, 1.7, -1.7> }
        }
        difference {
          box { <-10, 1.7, 1.7> <2, 3, 3> }
          cylinder { -9*x, 2*x, 0.5 translate <0, 1.7, 1.7> }
        }
        difference {
          box { <0.5, -3, -3> <2, 3, -1.7> }
          cylinder { -3*y, 3*y, 0.5 translate <0.5, 0, -1.7> }
        }
        difference {
          box { <0.5, -3, 1.7> <2, 3, 3> }
          cylinder { -3*y, 3*y, 0.5 translate <0.5, 0, 1.7> }
        }
        #if (setting > 1)
          cylinder { -1.7*z, -3*z, 0.4 translate <-6, -0.6, 0> }
          box { <-6.000001, -1, -3> <-2.499999, -0.2, -1.8> }
          cylinder { -1.8*z, -3*z, 0.4 translate <-6, 0.6, 0> }
          cylinder { -1.8*z, -3*z, 0.4 translate <-2.5, -0.6, 0> }
          box { <-6.000001, 0.2, -3> <-2.499999, 1, -1.8> }
          cylinder { -1.8*z, -3*z, 0.4 translate <-2.5, 0.6, 0> }
          cylinder { 1.8*z, 3*z, 0.4 translate <-6, -0.6, 0> }
          box { <-6.000001, -1, 1.8> <-2.499999, -0.2, 3> }
          cylinder { 1.8*z, 3*z, 0.4 translate <-6, 0.6, 0> }
          cylinder { 1.8*z, 3*z, 0.4 translate <-2.5, -0.6, 0> }
          box { <-6.000001, 0.2, 1.8> <-2.499999, 1, 3> }
          cylinder { 1.8*z, 3*z, 0.4 translate <-2.5, 0.6, 0> }
        #end
      }
      texture { color_tex }
      bounded_by { box { <-16.5, -9.5, -2.5> <4, 2.5, 2.5> } }
      rotate -12*z
      translate <0, -6, 0>
    }
  #end
#end
#macro tool_screwdriver(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 9*y, 1.5 }
      cylinder { 1*y, 18.7*y, 0.8 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 2*y, 1.5 }
        cylinder { 2.4*y, 2.8*y, 1.5 }
        cylinder { 3.2*y, 3.6*y, 1.5 }
        cylinder { 4*y, 4.4*y, 1.5 }
        cylinder { 4.8*y, 5.2*y, 1.5 }
        cylinder { 5.6*y, 6*y, 1.5 }
        cylinder { 6.4*y, 6.8*y, 1.5 }
        cylinder { 7.2*y, 9*y, 1.5 }
        cylinder { 1*y, 8*y, 1.3 }
        cone { 8.999999*y, 1.5, 10*y, 0.9 }
        cylinder { 9.5*y, 18.7*y, 0.8 }
        box { <-0.8, 17, -2> <0.8, 18.699999, 2> }
      }
      box { <-2, 0, -5> <2, 10, 0> rotate 4*x translate <0, 14.45, -0.8> }
      box { <-2, 0, 0> <2, 10, 5> rotate -4*x translate <0, 14.45, 0.8> }
      texture { color_tex }
      bounded_by { cylinder { -0.25*y, 19*y, 2 } }
    }
  #end
#end
#macro tool_zip_line_handle(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -3.8*y, 3.8*y, 1.55 }
      cylinder { 0.7*y, 1.4*y, 3 translate <10.5, 0, 0> }
      cylinder { -0.7*y, -1.4*y, 3 translate <10.5, 0, 0> }
      box { <0, 0.8, -1.5> <10.5, 2, 1.5>  }
      texture { color_tex }
    }
  #else
    merge {
      cylinder { -3.8*y, -1.8*y, 1.55 }
      cylinder { -0.2*y, -0.6*y, 1.55 }
      cylinder { -1*y, -1.4*y, 1.55 }
      cylinder { 0.2*y, 0.6*y, 1.55 }
      cylinder { 1*y, 1.4*y, 1.55 }
      cylinder { 3.8*y, 1.8*y, 1.55 }
      cylinder { -3.5*y, 3.5*y, 1.3 }
      box { <0, 2.4, -1.5> <4, 3.800005, 1.5> }
      box { <0, -2.4, -1.5> <4, -3.800005, 1.5> }
      box { <0, -1, -1.500005> <4, 0, 1.500005> rotate -45*z translate <4, 3.8, 0> }
      box { <0, 1, -1.500004> <4, 0, 1.500004> rotate 45*z translate <4, -3.8, 0> }
      box { <5, -2.3, -1.500003> <7, 2.3, 1.500003> }
      box { <6, 1.3, -1.500002> <10.5, 2.300002, 1.500002> }
      cylinder { 1.300002*y, 2.3*y, 1.5 translate <10.5, 0, 0> }
      cylinder { 0.7*y, 1.4*y, 3 translate <10.5, 0, 0> }
      cylinder { -0.7*y, -1.4*y, 3 translate <10.5, 0, 0> }
      difference {
        cylinder { -0.8*y, 0.8*y, 2.25 }
        torus { 2.25, 0.7 }
        translate <10.5, 0, 0>
      }
      box { <6, 0.8, -0.5> <10.5, 2, 0.5> }
      cylinder { -1.6*y, -1.3*y, 1.4 translate <10.5, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-1.65, -3.9, -3.1> <13.6, 3.9, 3.1> } }
    }
  #end
#end
#macro train_12v_motor(color_tex, zheelangle, age, rubbertyres)
  #if (setting = 0)
    union {
      cylinder { -24.5*z, -17.4*z, 11 translate <-23.9, 8.1, 0> }
      cylinder { 24.5*z, 17.4*z, 11 translate <-23.9, 8.1, 0> }
      cylinder { -24.5*z, -17.4*z, 11 translate <23.9, 8.1, 0> }
      cylinder { 24.5*z, 17.4*z, 11 translate <23.9, 8.1, 0> }
      box { <-39.9, 3.1, -15.9> <39.9, 24.6, 15.9> }
      texture { color_tex }
    }
  #else
    union {
      cylinder { -17*z, 17*z, 1.6 texture { chrome_tex } translate <-23.9, 8.1, 0> }
      cylinder { -17*z, 17*z, 1.6 texture { chrome_tex } translate <23.9, 8.1, 0> }
      merge {
        difference {
          merge {
            cone { -1.4*z, 11.2, -2.4*z, 11 }
            cone { -2.399999*z, 11, -3.4*z, 7.7 }
            cylinder { -3*z, -0.6*z, 2.8 }
          }
          cylinder { -10*z, 1*z, 1.700001 translate <0, 4.6, 0> }
          difference {
            cylinder { -1.3*z, -2.4*z, 6 }
            cylinder { -3*z, -0.6*z, 2.800001 }
            box { <-0.5, -7, -3> <0.5, 7, -0.6> }
            box { <-7, -0.5, -3> <7, 0.5, -0.6> }
          }
        }
        difference {
          cylinder { -8.5*z, 0*z, 2.4 }
          cylinder { -10*z, 1*z, 1.7 }
          translate <0, 4.6, 0>
        }
        object { rounded_button() rotate 90*y rotate -90*x translate <0, 0, -3.5> }
        cylinder { -6.5*z, -4*z, 2.3 }
        difference {
          cone { -8.5*z, 8.25, -3.3*z, 7.25 }
          cone { -8.500001*z, 7.2, -7.5*z, 6.2 }
          cylinder { -8.6*z, -5.35*z, 6.2 }
        }
        box { <-0.5, -6.5, -6.6> <0.5, 0, -3> }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 36*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 72*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 108*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 144*z }
        texture { color_tex }
        rotate zheelangle*z
        translate <-23.9, 8.1, -16>
      }
      #if (age = 2)
        cylinder { -17*z, 17*z, 1.6 texture { chrome_tex } translate <0, 8.1, 0> }
        merge {
          difference {
            merge {
              cone { -1.4*z, 11.2, -2.4*z, 11 }
              cone { -2.399999*z, 11, -3.4*z, 7.7 }
              cylinder { -3*z, -0.6*z, 2.8 }
            }
            cylinder { -10*z, 1*z, 1.700001 translate <0, 4.6, 0> }
            difference {
              cylinder { -1.3*z, -2.4*z, 6 }
              cylinder { -3*z, -0.6*z, 2.800001 }
              box { <-0.5, -7, -3> <0.5, 7, -0.6> }
              box { <-7, -0.5, -3> <7, 0.5, -0.6> }
            }
          }
          difference {
            cylinder { -8.5*z, 0*z, 2.4 }
            cylinder { -10*z, 1*z, 1.7 }
            translate <0, 4.6, 0>
          }
          object { rounded_button() rotate 90*y rotate -90*x translate <0, 0, -3.5> }
          cylinder { -6.5*z, -4*z, 2.3 }
          difference {
            cone { -8.5*z, 8.25, -3.3*z, 7.25 }
            cone { -8.500001*z, 7.2, -7.5*z, 6.2 }
            cylinder { -8.6*z, -5.35*z, 6.2 }
          }
          box { <-0.5, -6.5, -6.6> <0.5, 0, -3> }
          box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 36*z }
          box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 72*z }
          box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 108*z }
          box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 144*z }
          texture { color_tex }
          rotate zheelangle*z
          translate <0, 8.1, -16>
        }
        merge {
          difference {
            merge {
              cone { -1.4*z, 11.2, -2.4*z, 11 }
              cone { -2.399999*z, 11, -3.4*z, 7.7 }
              cylinder { -3*z, -0.6*z, 2.8 }
            }
            cylinder { -10*z, 1*z, 1.700001 translate <0, 4.6, 0> }
            difference {
              cylinder { -1.3*z, -2.4*z, 6 }
              cylinder { -3*z, -0.6*z, 2.800001 }
              box { <-0.5, -7, -3> <0.5, 7, -0.6> }
              box { <-7, -0.5, -3> <7, 0.5, -0.6> }
            }
          }
          difference {
            cylinder { -8.5*z, 0*z, 2.4 }
            cylinder { -10*z, 1*z, 1.7 }
            translate <0, 4.6, 0>
          }
          object { rounded_button() rotate 90*y rotate -90*x translate <0, 0, -3.5> }
          cylinder { -6.5*z, -4*z, 2.3 }
          difference {
            cone { -8.5*z, 8.25, -3.3*z, 7.25 }
            cone { -8.500001*z, 7.2, -7.5*z, 6.2 }
            cylinder { -8.6*z, -5.35*z, 6.2 }
          }
          box { <-0.5, -6.5, -6.6> <0.5, 0, -3> }
          box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 36*z }
          box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 72*z }
          box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 108*z }
          box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 144*z }
          texture { color_tex }
          rotate -zheelangle*z
          rotate 180*y
          translate <0, 8.1, 16>
        }
      #end
      merge {
        difference {
          merge {
            cone { -1.4*z, 11.2, -2.4*z, 11 }
            cone { -2.399999*z, 11, -3.4*z, 7.7 }
            cylinder { -3*z, -0.6*z, 2.8 }
          }
          cylinder { -10*z, 1*z, 1.700001 translate <0, 4.6, 0> }
          difference {
            cylinder { -1.3*z, -2.4*z, 6 }
            cylinder { -3*z, -0.6*z, 2.800001 }
            box { <-0.5, -7, -3> <0.5, 7, -0.6> }
            box { <-7, -0.5, -3> <7, 0.5, -0.6> }
          }
        }
        difference {
          cylinder { -8.5*z, 0*z, 2.4 }
          cylinder { -10*z, 1*z, 1.7 }
          translate <0, 4.6, 0>
        }
        object { rounded_button() rotate 90*y rotate -90*x translate <0, 0, -3.5> }
        cylinder { -6.5*z, -4*z, 2.3 }
        difference {
          cone { -8.5*z, 8.25, -3.3*z, 7.25 }
          cone { -8.500001*z, 7.2, -7.5*z, 6.2 }
          cylinder { -8.6*z, -5.35*z, 6.2 }
        }
        box { <-0.5, -6.5, -6.6> <0.5, 0, -3> }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 36*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 72*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 108*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 144*z }
        texture { color_tex }
        rotate zheelangle*z
        translate <23.9, 8.1, -16>
      }
      merge {
        difference {
          merge {
            cone { -1.4*z, 11.2, -2.4*z, 11 }
            cone { -2.399999*z, 11, -3.4*z, 7.7 }
            cylinder { -3*z, -0.6*z, 2.8 }
          }
          cylinder { -10*z, 1*z, 1.700001 translate <0, 4.6, 0> }
          difference {
            cylinder { -1.3*z, -2.4*z, 6 }
            cylinder { -3*z, -0.6*z, 2.800001 }
            box { <-0.5, -7, -3> <0.5, 7, -0.6> }
            box { <-7, -0.5, -3> <7, 0.5, -0.6> }
          }
        }
        difference {
          cylinder { -8.5*z, 0*z, 2.4 }
          cylinder { -10*z, 1*z, 1.7 }
          translate <0, 4.6, 0>
        }
        object { rounded_button() rotate 90*y rotate -90*x translate <0, 0, -3.5> }
        cylinder { -6.5*z, -4*z, 2.3 }
        difference {
          cone { -8.5*z, 8.25, -3.3*z, 7.25 }
          cone { -8.500001*z, 7.2, -7.5*z, 6.2 }
          cylinder { -8.6*z, -5.35*z, 6.2 }
        }
        box { <-0.5, -6.5, -6.6> <0.5, 0, -3> }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 36*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 72*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 108*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 144*z }
        texture { color_tex }
        rotate -zheelangle*z
        rotate 180*y
        translate <-23.9, 8.1, 16>
      }
      merge {
        difference {
          merge {
            cone { -1.4*z, 11.2, -2.4*z, 11 }
            cone { -2.399999*z, 11, -3.4*z, 7.7 }
            cylinder { -3*z, -0.6*z, 2.8 }
          }
          cylinder { -10*z, 1*z, 1.700001 translate <0, 4.6, 0> }
          difference {
            cylinder { -1.3*z, -2.4*z, 6 }
            cylinder { -3*z, -0.6*z, 2.800001 }
            box { <-0.5, -7, -3> <0.5, 7, -0.6> }
            box { <-7, -0.5, -3> <7, 0.5, -0.6> }
          }
        }
        difference {
          cylinder { -8.5*z, 0*z, 2.4 }
          cylinder { -10*z, 1*z, 1.7 }
          translate <0, 4.6, 0>
        }
        object { rounded_button() rotate 90*y rotate -90*x translate <0, 0, -3.5> }
        cylinder { -6.5*z, -4*z, 2.3 }
        difference {
          cone { -8.5*z, 8.25, -3.3*z, 7.25 }
          cone { -8.500001*z, 7.2, -7.5*z, 6.2 }
          cylinder { -8.6*z, -5.35*z, 6.2 }
        }
        box { <-0.5, -6.5, -6.6> <0.5, 0, -3> }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 36*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 72*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 108*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3> rotate 144*z }
        texture { color_tex }
        rotate -zheelangle*z
        rotate 180*y
        translate <23.9, 8.1, 16>
      }
      #if (rubbertyres = 1)
        difference {
          cone { -8.4*z, 8.65, -3.4*z, 7.65 }
          cone { -8.5*z, 8.25, -3.3*z, 7.25 }
          texture { r_grey_tex }
          translate <-23.9, 8.1, -16>
        }
        difference {
          cone { -8.4*z, 8.65, -3.4*z, 7.65 }
          cone { -8.5*z, 8.25, -3.3*z, 7.25 }
          texture { r_grey_tex }
          rotate 180*y
          translate <-23.9, 8.1, 16>
        }
        difference {
          cone { -8.4*z, 8.65, -3.4*z, 7.65 }
          cone { -8.5*z, 8.25, -3.3*z, 7.25 }
          texture { r_grey_tex }
          translate <23.9, 8.1, -16>
        }
        difference {
          cone { -8.4*z, 8.65, -3.4*z, 7.65 }
          cone { -8.5*z, 8.25, -3.3*z, 7.25 }
          texture { r_grey_tex }
          rotate 180*y
          translate <23.9, 8.1, 16>
        }
        #if (age = 2)
          difference {
            cone { -8.4*z, 8.65, -3.4*z, 7.65 }
            cone { -8.5*z, 8.25, -3.3*z, 7.25 }
            texture { r_grey_tex }
            translate <0, 8.1, -16>
          }
          difference {
            cone { -8.4*z, 8.65, -3.4*z, 7.65 }
            cone { -8.5*z, 8.25, -3.3*z, 7.25 }
            texture { r_grey_tex }
            rotate 180*y
            translate <0, 8.1, 16>
          }
        #end
      #end
      merge {
        cylinder { 0.75*y, 10*y, 3.4 }
        sphere { <0, 0, 0> 3.4 scale <1, 0.1, 1> translate <0, 0.75, 0> }
        texture { copperish_tex }
        translate <-32.1, 0, -4.6>
      }
      merge {
        cylinder { 0.75*y, 10*y, 3.4 }
        sphere { <0, 0, 0> 3.4 scale <1, 0.1, 1> translate <0, 0.75, 0> }
        texture { copperish_tex }
        translate <-32.1, 0, 4.6>
      }
      merge {
        cylinder { 0.75*y, 10*y, 3.4 }
        sphere { <0, 0, 0> 3.4 scale <1, 0.1, 1> translate <0, 0.75, 0> }
        texture { copperish_tex }
        translate <32.1, 0, -4.6>
      }
      merge {
        cylinder { 0.75*y, 10*y, 3.4 }
        sphere { <0, 0, 0> 3.4 scale <1, 0.1, 1> translate <0, 0.75, 0> }
        texture { copperish_tex }
        translate <32.1, 0, 4.6>
      }
      merge {
        difference {
          merge {
            box { <-39.9, 3.1, -15.9> <39.9, 24.6, 15.9> }
            box { <-42.9, 3.100001, -14.6> <42.9, 6.2, -9.8> }
            box { <-42.9, 3.100002, 14.6> <42.9, 6.2, 9.8> }
            cylinder { -2.4*z, 2.4*z, 0.7 translate <-42.2, 8.1, -12.2> }
            cylinder { -2.4*z, 2.4*z, 0.7 translate <42.2, 8.1, -12.2> }
            cylinder { -2.4*z, 2.4*z, 0.7 translate <-42.2, 8.1, 12.2> }
            cylinder { -2.4*z, 2.4*z, 0.7 translate <42.2, 8.1, 12.2> }
            box { <-42.900001, 6, -14.600001> <-41.5, 8.100001, -9.799999> }
            box { <-42.900001, 6, 14.600001> <-41.5, 8.100001, 9.799999> }
            box { <42.900001, 6, -14.600001> <41.5, 8.100001, -9.799999> }
            box { <42.900001, 6, 14.600001> <41.5, 8.100001, 9.799999> }
          }
          #if (setting > 1)
            cylinder { 15*y, 30*y, 1.600001 translate <-36, 0, -4> }
            cylinder { 15*y, 30*y, 1.600001 translate <-36, 0, 4> }
            box { <-41.4, 0, -13.1> <-39.900001, 5.5, -11.3> }
            box { <-41.4, 0, 13.1> <-39.900001, 5.5, 11.3> }
            box { <41.4, 0, -13.1> <39.900001, 5.5, -11.3> }
            box { <41.4, 0, 13.1> <39.900001, 5.5, 11.3> }
            cylinder { -16*z, -12.7*z, 1.75 translate <0, 8.1, 0> }
            box { <-1.75, 8.1, -16> <1.75, 11.1, -12.7> }
            cylinder { -16*z, -12.7*z, 1.75 translate <0, 11.1, 0> }
            cylinder { -16*z, -12.7*z, 2.5 translate <0, 15, 0> }
            cylinder { 16*z, 12.7*z, 1.75 translate <0, 8.1, 0> }
            box { <-1.75, 8.1, 16> <1.75, 11.1, 12.7> }
            cylinder { 16*z, 12.7*z, 1.75 translate <0, 11.1, 0> }
            cylinder { 16*z, 12.7*z, 2.5 translate <0, 15, 0> }
            box { <-4, 11.5, -16> <-3, 14.5, -13.4> }
            cylinder { -16*z, -13.4*z, 0.5 translate <-3.5, 11.5, 0> }
            cylinder { -16*z, -13.4*z, 0.5 translate <-3.5, 14.5, 0> }
            box { <4, 11.5, -16> <3, 14.5, -13.4> }
            cylinder { -16*z, -13.4*z, 0.5 translate <3.5, 11.5, 0> }
            cylinder { -16*z, -13.4*z, 0.5 translate <3.5, 14.5, 0> }
            box { <-4, 11.5, 16> <-3, 14.5, 13.4> }
            cylinder { 16*z, 13.4*z, 0.5 translate <-3.5, 11.5, 0> }
            cylinder { 16*z, 13.4*z, 0.5 translate <-3.5, 14.5, 0> }
            box { <4, 11.5, 16> <3, 14.5, 13.4> }
            cylinder { 16*z, 13.4*z, 0.5 translate <3.5, 11.5, 0> }
            cylinder { 16*z, 13.4*z, 0.5 translate <3.5, 14.5, 0> }
            cylinder { 0*y, 2.6*y, 2 }
            cylinder { 15*y, 30*y, 1.6 translate <-36, 0, 0> }
            cylinder { 35*x, 40*x, 1.6 translate <0, 15.5, -4> }
            cylinder { 35*x, 40*x, 1.6 translate <0, 15.5, 0> }
            cylinder { 35*x, 40*x, 1.6 translate <0, 15.5, 4> }
            box { <-18.9, 0, -5.5> <-16.7, 12.6, 5.5> }
            box { <16.7, 0, -5.5> <18.9, 12.6, 5.5> }
            cylinder { 2*y, 3.6*y, 2 translate <-23.9, 0, -8> }
            cylinder { 2*y, 3.6*y, 2 translate <23.9, 0, 8> }
          #end
          cylinder { 0*y, 12*y, 3.5 translate <-32.1, 0, -4.6> }
          cylinder { 0*y, 12*y, 3.5 translate <-32.1, 0, 4.6> }
          cylinder { 0*y, 12*y, 3.5 translate <32.1, 0, -4.6> }
          cylinder { 0*y, 12*y, 3.5 translate <32.1, 0, 4.6> }
          box { <-40, 18.1, -20> <-23.9, 25, 20> }
          box { <-10, 0, -20> <0, 10, 20> rotate 5*z translate <-19.4, 24.6, 0> }
          box { <40, 18.1, -20> <23.9, 25, 20> }
          box { <0, 0, -20> <10, 10, 20> rotate -5*z translate <19.4, 24.6, 0> }
          box { <-25, 0, -10> <25, 10, 0> rotate -5*x translate <0, 24.6, -11.4> }
          box { <-25, 0, 0> <25, 10, 10> rotate 5*x translate <0, 24.6, 11.4> }
          cylinder { -20*z, -15*z, 2.5 translate <-23.9, 8.1, 0> }
          cylinder { -20*z, -15*z, 2.5 translate <23.9, 8.1, 0> }
          cylinder { 20*z, 15*z, 2.5 translate <-23.9, 8.1, 0> }
          cylinder { 20*z, 15*z, 2.5 translate <23.9, 8.1, 0> }
        }
        #if (setting < 3)
          cylinder { 18*y, 19.8*y, 2.4 translate <-36, 0, -12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-36, 0, -4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-36, 0, 4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-36, 0, 12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-28, 0, -12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-28, 0, -4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-28, 0, 4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-28, 0, 12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <36, 0, -12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <36, 0, -4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <36, 0, 4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <36, 0, 12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <28, 0, -12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <28, 0, -4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <28, 0, 4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <28, 0, 12> }
        #else
          object { rounded_button() rotate 180*y translate <-36, 15, -12> }
          object { open_rounded_button() translate <-36, 15, -4> }
          object { open_rounded_button() translate <-36, 15, 4> }
          object { rounded_button() rotate 180*y translate <-36, 15, 12> }
          object { rounded_button() rotate 180*y translate <-28, 15, -12> }
          object { rounded_button() rotate 180*y translate <-28, 15, -4> }
          object { rounded_button() rotate 180*y translate <-28, 15, 4> }
          object { rounded_button() rotate 180*y translate <-28, 15, 12> }
          object { rounded_button() rotate 180*y translate <36, 15, -12> }
          object { rounded_button() rotate 180*y translate <36, 15, -4> }
          object { rounded_button() rotate 180*y translate <36, 15, 4> }
          object { rounded_button() rotate 180*y translate <36, 15, 12> }
          object { rounded_button() rotate 180*y translate <28, 15, -12> }
          object { rounded_button() rotate 180*y translate <28, 15, -4> }
          object { rounded_button() rotate 180*y translate <28, 15, 4> }
          object { rounded_button() rotate 180*y translate <28, 15, 12> }
        #end
        difference {
          merge {
            cylinder { 23.9*y, 32.2*y, 2.25 }
            cylinder { 32.1*y, 32.6*y, 2.5 }
          }
          box { <-4, 29.9, -0.5> <4, 33.6, 0.5> }
          cylinder { 24.6*y, 32.7*y, 1.6 }
        }
      }
      #if (rubbertyres = 1)
        translate <0, 0.4, 0>
      #end
      texture { color_tex }
      bounded_by { box { <-43, -3.4, -24.6> <43, 32.7, 24.6> } }
    }
  #end
#end
#macro train_12v_powerrail_straight()
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <123.9, 4, 11.9> texture { grey_tex } }
  #else
    merge {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <123.9, 4, 11.9> }
          box { <-4, 2.7, -2.8> <124, 5, 10.8> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <122.4, 2, 10.4> }
          #end
          box { <10.25, 0, 0.3> <13.75, 4, 0.8> }
          box { <10.25, 0, 7.2> <13.75, 4, 7.7> }
          box { <34.25, 0, 0.3> <37.75, 4, 0.8> }
          box { <34.25, 0, 7.2> <37.75, 4, 7.7> }
          box { <82.25, 0, 0.3> <85.75, 4, 0.8> }
          box { <82.25, 0, 7.2> <85.75, 4, 7.7> }
          box { <106.25, 0, 0.3> <109.75, 4, 0.8> }
          box { <106.25, 0, 7.2> <109.75, 4, 7.7> }
        }
        #if (setting > 1)
          object { ring() translate <4, 0, 4> }
          object { ring() translate <20, 0, 4> }
          object { ring() translate <28, 0, 4> }
          object { ring() translate <52, 0, 4> }
          object { ring() translate <60, 0, 4> }
          object { ring() translate <68, 0, 4> }
          object { ring() translate <92, 0, 4> }
          object { ring() translate <100, 0, 4> }
          object { ring() translate <116, 0, 4> }
          box { <-3, 1.7, 3.1> <1, 2.1, 4.9> }
          box { <7, 1.7, 3.1> <17, 2.1, 4.9> }
          box { <23, 1.7, 3.1> <25, 2.1, 4.9> }
          box { <31, 1.7, 3.1> <49, 2.1, 4.9> }
          box { <55, 1.7, 3.1> <57, 2.1, 4.9> }
          box { <63, 1.7, 3.1> <65, 2.1, 4.9> }
          box { <71, 1.7, 3.1> <89, 2.1, 4.9> }
          box { <95, 1.7, 3.1> <97, 2.1, 4.9> }
          box { <103, 1.7, 3.1> <113, 2.1, 4.9> }
          box { <119, 1.7, 3.1> <123, 2.1, 4.9> }
        #end
        box { <-3.900005, 2.6, 0.1> <50, 3.2, -2.3> }
        difference {
          box { <-6.8, 3.199999, 0.100001> <50, 5.6, -2.300001> }
          difference {
            box { <-2, -2, -2.35> <0, 0, 0.15> }
            cylinder { -2.4*z, 0.2*z, 1 }
            translate <-5.8, 4.2, 0>
          }
        }
        box { <50, 2.6, 7.9> <123.900005, 3.2, 10.3> }
        difference {
          box { <50, 3.199999, 7.900001> <126.8, 5.6, 10.300001> }
          difference {
            box { <0, -2, 7.85> <2, 0, 10.35> }
            cylinder { 7.8*z, 10.4*z, 1 }
            translate <125.8, 4.2, 0>
          }
        }
        texture { grey_tex }
      }
      difference {
        merge {
          cylinder { -3.9*x, 123.9*x, 0.4 translate <0, 5.6, 10.3> }
          cylinder { -3.9*x, 123.9*x, 0.4 translate <0, 5.6, 7.9> }
          box { <-3.900001, 2.8, 7.5> <123.900001, 5.6, 10.7> }
          box { <-3.900002, 5, 7.9> <123.900002, 6, 10.3> }
          cylinder { 126.9*x, 123*x, 0.4 translate <0, 5.4, 10.1> }
          cylinder { 126.9*x, 123*x, 0.4 translate <0, 5.4, 8.1> }
          box { <126.900001, 2.800001, 8.1> <0, 5.8, 10.1> }
          box { <126.900002, 2.800002, 7.7> <0, 5.4, 10.5> }
        }
        box { <-4, -1, 7.8> <123.900001, 5.7, 10.4> }
        box { <120, -1, 8> <127, 5.5, 10.2> }
        difference {
          box { <0, -2, 4> <2, 0, 12> }
          cylinder { 3*z, 13*z, 1 }
          translate <125.9, 3.8, 0>
        }
        texture { chrome_tex }
      }
      difference {
        merge {
          cylinder { -3.9*x, 123.9*x, 0.4 translate <0, 5.6, 0.1> }
          cylinder { -3.9*x, 123.9*x, 0.4 translate <0, 5.6, -2.3> }
          box { <-3.900001, 2.8, -2.7> <123.900001, 5.6, 0.5> }
          box { <-3.900002, 5, -2.3> <123.900002, 6, 0.1> }
          cylinder { -6.9*x, -3*x, 0.4 translate <0, 5.4, -0.1> }
          cylinder { -6.9*x, -3*x, 0.4 translate <0, 5.4, -2.1> }
          box { <-6.900001, 2.800001, -2.1> <0, 5.8, -0.1> }
          box { <-6.900002, 2.800002, -2.5> <0, 5.4, 0.3> }
        }
        box { <-3.900001, -1, 0.2> <124, 5.7, -2.4> }
        box { <-7, -1, 0> <0, 5.5, -2.2> }
        difference {
          box { <-2, -2, -4> <0, 0, 4> }
          cylinder { -5*z, 5*z, 1 }
          translate <-5.9, 3.8, 0>
        }
        texture { chrome_tex }
      }
      merge {
        box { <10.35, 1.7, 0.4> <13.65, 2.800001, 0.7> }
        box { <10.35, 1.7, 7.3> <13.65, 2.800001, 7.6> }
        box { <34.35, 1.7, 0.4> <37.65, 2.800001, 0.7> }
        box { <34.35, 1.7, 7.3> <37.65, 2.800001, 7.6> }
        box { <82.35, 1.7, 0.4> <85.65, 2.800001, 0.7> }
        box { <82.35, 1.7, 7.3> <85.65, 2.800001, 7.6> }
        box { <106.35, 1.7, 0.4> <109.65, 2.800001, 0.7> }
        box { <106.35, 1.7, 7.3> <109.65, 2.800001, 7.6> }
        difference {
          cylinder { 1.7*y, 2*y, 1.65 }
          box { <-2, 1, 0.000001> <2, 3, 2> }
          translate <12, 0, 0.4>
        }
        difference {
          cylinder { 1.7*y, 2*y, 1.65 }
          box { <-2, 1, 0.000001> <2, 3, 2> }
          translate <36, 0, 0.4>
        }
        difference {
          cylinder { 1.7*y, 2*y, 1.65 }
          box { <-2, 1, 0.000001> <2, 3, 2> }
          translate <84, 0, 0.4>
        }
        difference {
          cylinder { 1.7*y, 2*y, 1.65 }
          box { <-2, 1, 0.000001> <2, 3, 2> }
          translate <108, 0, 0.4>
        }
        difference {
          cylinder { 1.7*y, 2*y, 1.65 }
          box { <-2, 1, 0.000001> <2, 3, 2> }
          rotate 180*y translate <12, 0, 7.6>
        }
        difference {
          cylinder { 1.7*y, 2*y, 1.65 }
          box { <-2, 1, 0.000001> <2, 3, 2> }
          rotate 180*y translate <36, 0, 7.6>
        }
        difference {
          cylinder { 1.7*y, 2*y, 1.65 }
          box { <-2, 1, 0.000001> <2, 3, 2> }
          rotate 180*y translate <84, 0, 7.6>
        }
        difference {
          cylinder { 1.7*y, 2*y, 1.65 }
          box { <-2, 1, 0.000001> <2, 3, 2> }
          rotate 180*y translate <108, 0, 7.6>
        }
        texture { chrome_tex }
      }
      bounded_by { box { <-7, -0.1, -4> <127, 6.1, 12> } }
    }
  #end
#end
#macro train_12v_rails_sleeper(cut)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 3.1, 59.9> texture { grey_tex } }
  #else
    difference {
      merge {
        difference {
          merge {
            box { <-3.9, 0, -3.9> <11.9, 3.1, 59.9> }
            #if (setting < 3)
              cylinder { 3*y, 4.8*y, 2.4 }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 32> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 40> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 40> }
              cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 56> }
              cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 56> }
            #else
              object { rounded_button() rotate 90*y }
              object { rounded_button() rotate 90*y translate <8, 0, 0> }
              object { rounded_button() rotate 90*y translate <0, 0, 16> }
              object { rounded_button() rotate 90*y translate <8, 0, 16> }
              object { rounded_button() rotate 90*y translate <0, 0, 24> }
              object { rounded_button() rotate 90*y translate <8, 0, 24> }
              object { rounded_button() rotate 90*y translate <0, 0, 32> }
              object { rounded_button() rotate 90*y translate <8, 0, 32> }
              object { rounded_button() rotate 90*y translate <0, 0, 40> }
              object { rounded_button() rotate 90*y translate <8, 0, 40> }
              object { rounded_button() rotate 90*y translate <0, 0, 56> }
              object { rounded_button() rotate 90*y translate <8, 0, 56> }
            #end
            box { <-2.4, 3, 5.6> <2.4, 6.8, 10.4> }
            box { <5.6, 3, 5.6> <10.4, 6.8, 10.4> }
            box { <-2.4, 3, 45.6> <2.4, 6.8, 50.4> }
            box { <5.6, 3, 45.6> <10.4, 6.8, 50.4> }
          }
          box { <-3, 4.8, 4> <11, 6.3, 6.5> }
          box { <-3, 6, 4> <11, 7, 6.3> }
          box { <-3, 4.8, 11> <11, 6.3, 9.5> }
          box { <-3, 6, 11> <11, 7, 9.3> }
          cylinder { -3*x, 11*x, 0.35 translate <0, 3.65, 8> }
          box { <-3, 3.649999, 7.65> <11, 7, 8.35> }
          box { <-3, 4.8, 44> <11, 6.3, 46.5> }
          box { <-3, 6, 44> <11, 7, 46.3> }
          box { <-3, 4.8, 51> <11, 6.3, 49.5> }
          box { <-3, 6, 51> <11, 7, 49.3> }
          cylinder { -3*x, 11*x, 0.35 translate <0, 3.65, 48> }
          box { <-3, 3.649999, 47.65> <11, 7, 48.35> }
          #if (setting > 1)
            cylinder { 1*y, 4*y, 1.2 }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
            cylinder { 1*y, 3*y, 1.2 translate <0, 0, 8> }
            cylinder { 1*y, 3*y, 1.2 translate <8, 0, 8> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 40> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 40> }
            cylinder { 1*y, 3*y, 1.2 translate <0, 0, 48> }
            cylinder { 1*y, 3*y, 1.2 translate <8, 0, 48> }
            cylinder { 1*y, 4*y, 1.2 translate <0, 0, 56> }
            cylinder { 1*y, 4*y, 1.2 translate <8, 0, 56> }
            box { <-2.4, -1, 12> <10.4, 2, 44> }
            box { <-2.400001, -1, -2.4> <10.400001, 1.7, 58.4> }
          #end
          box { <-4, -1, 12> <12, 0.5, 44> }
        }
        #if (setting > 1)
          object { ring() translate <4, 0, 4> }
          object { ring() translate <4, 0, 12> }
          object { ring() translate <4, 0, 20> }
          cylinder { 0*y, 2.1*y, 3.2 translate <4, 0, 28> }
          object { ring() translate <4, 0, 36> }
          object { ring() translate <4, 0, 44> }
          object { ring() translate <4, 0, 52> }
        #end
      }
      cylinder { 2.8*y, 3.2*y, 2.5 translate <4, 0, 28> }
      cone { 1.8*y, 1.5, 2.800001*y, 2.5 translate <4, 0, 28> }
      cylinder { -1*y, 2*y, 1.5 translate <4, 0, 28> }
      #if (cut = 1)
        box { <-4, -1, 2.5> <12, 1.5, 5.5> }
        box { <-4, -1, 50.5> <12, 1.5, 53.5> }
      #end
      texture { grey_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 6.9, 60> } }
    }
  #end
#end
#macro train_12v_rail_straight(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <123.9, 3.1, 3.9> }
      box { <-3.900001, 3, -1.1> <123.900001, 6.3, 1.1> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <123.9, 3.1, 3.9> }
          box { <-3.900001, 3, -1.1> <123.900001, 6.3, 1.1> }
        }
        #if (setting > 1)
          box { <5.2, -1, -2.4> <114.8, 2, 2.4> }
          difference {
            box { <-2.5, -1, -2.4> <2.5, 4, 2.4> }
            box { <-4, -5, -5> <4, 0, 0> rotate 45*x translate <0, 3.1, -1.6> }
            box { <-4, -5, 0> <4, 0, 5> rotate -45*x translate <0, 3.1, 1.6> }
          }
          difference {
            box { <-2.5, -1, -2.4> <2.5, 4, 2.4> }
            box { <-4, -5, -5> <4, 0, 0> rotate 45*x translate <0, 3.1, -1.6> }
            box { <-4, -5, 0> <4, 0, 5> rotate -45*x translate <0, 3.1, 1.6> }
            translate <56, 0, 0>
          }
          difference {
            box { <-2.5, -1, -2.4> <2.5, 4, 2.4> }
            box { <-4, -5, -5> <4, 0, 0> rotate 45*x translate <0, 3.1, -1.6> }
            box { <-4, -5, 0> <4, 0, 5> rotate -45*x translate <0, 3.1, 1.6> }
            translate <64, 0, 0>
          }
          difference {
            box { <-2.5, -1, -2.4> <2.5, 4, 2.4> }
            box { <-4, -5, -5> <4, 0, 0> rotate 45*x translate <0, 3.1, -1.6> }
            box { <-4, -5, 0> <4, 0, 5> rotate -45*x translate <0, 3.1, 1.6> }
            translate <120, 0, 0>
          }
          #local counter = 0;
          #while ( counter < 113)
            box { <-2, 0, -2> <0.1, 2, 2> rotate -45*z translate <-2+(counter*1.106), 5.915, 0> }
            #local counter = counter + 1;
          #end
        #end
        box { <-4, 0, -10> <124, 10, 0> rotate 1.5*x translate <0, 3.1, -1.1> }
        box { <-4, 0, 0> <124, 10, 10> rotate -1.5*x translate <0, 3.1, 1.1> }
        box { <-5, 0, -2> <0, 2, 2> rotate 15*z translate <-2, 6.3, 0> }
        box { <0, 0, -2> <5, 2, 2> rotate -15*z translate <122, 6.3, 0> }
      }
      #if (setting > 1)
        #local counter = 0;
        #while (counter < 13)
          object { pin(1) translate <12+(counter*8), 0, 0> }
          #local counter = counter + 1;
        #end
      #end
      texture { color_tex }
    }
  #end
#end
#macro train_12v_wheelconnector(color_tex)
  #if (setting = 0)
    box { <-26.9, -3, -2> <26.9, 3, 0> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -2*z, 0*z, 3 translate <-23.9, 0, 0> }
        cylinder { -2*z, 0*z, 3 translate <23.9, 0, 0> }
        #if (setting > 3)
          object { llogo() rotate 90*y rotate -90*x translate <-23.9, 0, -2> }
          object { llogo() rotate 90*y rotate -90*x translate <23.9, 0, -2> }
        #end
        cylinder { -2.5*z, 0*z, 3 }
        box { <-23.9, -1.5, -2.000005> <23.9, 1.5, 0.000005> }
        cylinder { -0.5*z, 0.5*z, 1.85 translate <-23.9, 0, 0> }
        cylinder { -0.5*z, 0.5*z, 1.85 translate <23.9, 0, 0> }
        cylinder { 0*z, 3*z, 1.5 translate <-23.9, 0, 0> }
        cylinder { 0*z, 3*z, 1.5 translate <23.9, 0, 0> }
        cylinder { 2.6*z, 3.1*z, 1.7 translate <-23.9, 0, 0> }
        cylinder { 2.6*z, 3.1*z, 1.7 translate <23.9, 0, 0> }
      }
      box { <-21, -0.3, -3> <-5, 0.3, -1.7> }
      box { <5, -0.3, -3> <21, 0.3, -1.7> }
      box { <-21, -0.3, -0.3> <-5, 0.3, 1> }
      box { <5, -0.3, -0.3> <21, 0.3, 1> }
      cylinder { -3*z, -1.7*z, 2 }
      cylinder { -3*z, 4*z, 1.6 }
      cylinder { 0.000005*z, 4*z, 0.7 translate <-23.9, 0, 0> }
      cylinder { 0.000005*z, 4*z, 0.7 translate <23.9, 0, 0> }
      box { <-24.4, -3, 1.8> <-23.4, 3, 4> }
      box { <23.4, -3, 1.8> <24.4, 3, 4> }
      cylinder { -3*y, 3*y, 0.5 translate <-23.9, 0, 1.799999> }
      cylinder { -3*y, 3*y, 0.5 translate <23.9, 0, 1.799999> }
      texture { color_tex }
      bounded_by { box { <-27, -3.1, -2.2> <27, 3.1, 3.2> } }
    }
  #end
#end
#macro train_9v_motor(zheelangle)
  #if (setting = 0)
    union {
      cylinder { -4.4*z, -1.4*z, 11.4 texture { chrome_tex } translate <-23.9, 8.1, -16> }
      cylinder { -4.4*z, -1.4*z, 11.4 texture { chrome_tex } rotate 180*y translate <-23.9, 8.1, 16> }
      cylinder { -4.4*z, -1.4*z, 11.4 texture { chrome_tex } translate <23.9, 8.1, -16> }
      cylinder { -4.4*z, -1.4*z, 11.4 texture { chrome_tex } rotate 180*y translate <23.9, 8.1, 16> }
      box { <-39.9, 1.1, -15.9> <39.9, 24.6, 15.9> texture { black_tex } }
    }
  #else
    union {
      union {
        difference {
          merge {
            cylinder { -1.5*z, 2*z, 4 }
            cone { -1.4*z, 11.4, -2.4*z, 11.2 }
            cone { -2.399999*z, 11.2, -2.9*z, 8.1 }
          }
          cylinder { -1*z, -2.4*z, 9.4 }
          cone { -4.500001*z, 7.2, -2.8*z, 5.7 }
        }
        torus { 7.5, 0.6 texture { r_black_tex } rotate 90*x translate <0, 0, -3.5> }
        merge {
          difference {
            cylinder { -4.4*z, -2.5*z, 8.1 }
            cone { -4.400001*z, 7.1, -2.9*z, 5.6 }
            difference {
              box { <-10, -10, -4.1> <10, 10, -2.9> }
              cylinder { -4.2*z, -2.8*z, 7.5 }
            }
          }
          object { rounded_button() rotate -90*x translate <0, 0.2, 0> }
          texture { black_tex }
        }
        texture { chrome_tex }
        rotate zheelangle*z
        translate <-23.9, 8.1, -16>
      }
      union {
        difference {
          merge {
            cylinder { -1.5*z, 2*z, 4 }
            cone { -1.4*z, 11.4, -2.4*z, 11.2 }
            cone { -2.399999*z, 11.2, -2.9*z, 8.1 }
          }
          cylinder { -1*z, -2.4*z, 9.4 }
          cone { -4.500001*z, 7.2, -2.8*z, 5.7 }
        }
        torus { 7.5, 0.6 texture { r_black_tex } rotate 90*x translate <0, 0, -3.5> }
        merge {
          difference {
            cylinder { -4.4*z, -2.5*z, 8.1 }
            cone { -4.400001*z, 7.1, -2.9*z, 5.6 }
            difference {
              box { <-10, -10, -4.1> <10, 10, -2.9> }
              cylinder { -4.2*z, -2.8*z, 7.5 }
            }
          }
          object { rounded_button() rotate -90*x translate <0, 0.2, 0> }
          texture { black_tex }
        }
        texture { chrome_tex }
        rotate zheelangle*z
        translate <23.9, 8.1, -16>
      }
      union {
        difference {
          merge {
            cylinder { -1.5*z, 2*z, 4 }
            cone { -1.4*z, 11.4, -2.4*z, 11.2 }
            cone { -2.399999*z, 11.2, -2.9*z, 8.1 }
          }
          cylinder { -1*z, -2.4*z, 9.4 }
          cone { -4.500001*z, 7.2, -2.8*z, 5.7 }
        }
        torus { 7.5, 0.6 texture { r_black_tex } rotate 90*x translate <0, 0, -3.5> }
        merge {
          difference {
            cylinder { -4.4*z, -2.5*z, 8.1 }
            cone { -4.400001*z, 7.1, -2.9*z, 5.6 }
            difference {
              box { <-10, -10, -4.1> <10, 10, -2.9> }
              cylinder { -4.2*z, -2.8*z, 7.5 }
            }
          }
          object { rounded_button() rotate -90*x translate <0, 0.2, 0> }
          texture { black_tex }
        }
        texture { chrome_tex }
        rotate -zheelangle*z
        rotate 180*y
        translate <-23.9, 8.1, 16>
      }
      union {
        difference {
          merge {
            cylinder { -1.5*z, 2*z, 4 }
            cone { -1.4*z, 11.4, -2.4*z, 11.2 }
            cone { -2.399999*z, 11.2, -2.9*z, 8.1 }
          }
          cylinder { -1*z, -2.4*z, 9.4 }
          cone { -4.500001*z, 7.2, -2.8*z, 5.7 }
        }
        torus { 7.5, 0.6 texture { r_black_tex } rotate 90*x translate <0, 0, -3.5> }
        merge {
          difference {
            cylinder { -4.4*z, -2.5*z, 8.1 }
            cone { -4.400001*z, 7.1, -2.9*z, 5.6 }
            difference {
              box { <-10, -10, -4.1> <10, 10, -2.9> }
              cylinder { -4.2*z, -2.8*z, 7.5 }
            }
          }
          object { rounded_button() rotate -90*x translate <0, 0.2, 0> }
          texture { black_tex }
        }
        texture { chrome_tex }
        rotate -zheelangle*z
        rotate 180*y
        translate <23.9, 8.1, 16>
      }
      merge {
        #if (setting > 1)
          difference {
            box { <-2, 0, 0> <2, 1, 1> }
            cylinder { -2.1*x, 2.1*x, 0.8 translate <0, 0, 1> }
            translate <-8, 1, -14.2>
          }
          difference {
            box { <-2, 0, 0> <2, 1, 1> }
            cylinder { -2.1*x, 2.1*x, 0.8 translate <0, 0, 1> }
            translate <-16, 1, -14.2>
          }
          difference {
            box { <-2, 0, 0> <2, 1, 1> }
            cylinder { -2.1*x, 2.1*x, 0.8 translate <0, 0, 1> }
            translate <-32, 1, -14.2>
          }
          difference {
            box { <-2, 0, 0> <2, 1, 1> }
            cylinder { -2.1*x, 2.1*x, 0.8 translate <0, 0, 1> }
            translate <8, 1, -14.2>
          }
          difference {
            box { <-2, 0, 0> <2, 1, 1> }
            cylinder { -2.1*x, 2.1*x, 0.8 translate <0, 0, 1> }
            translate <16, 1, -14.2>
          }
          difference {
            box { <-2, 0, 0> <2, 1, 1> }
            cylinder { -2.1*x, 2.1*x, 0.8 translate <0, 0, 1> }
            translate <32, 1, -14.2>
          }
          difference {
            box { <-2, 0, 0> <2, 1, 1> }
            cylinder { -2.1*x, 2.1*x, 0.8 translate <0, 0, 1> }
            rotate 180*y
            translate <-8, 1, 14.2>
          }
          difference {
            box { <-2, 0, 0> <2, 1, 1> }
            cylinder { -2.1*x, 2.1*x, 0.8 translate <0, 0, 1> }
            rotate 180*y
            translate <-16, 1, 14.2>
          }
          difference {
            box { <-2, 0, 0> <2, 1, 1> }
            cylinder { -2.1*x, 2.1*x, 0.8 translate <0, 0, 1> }
            rotate 180*y
            translate <-32, 1, 14.2>
          }
          difference {
            box { <-2, 0, 0> <2, 1, 1> }
            cylinder { -2.1*x, 2.1*x, 0.8 translate <0, 0, 1> }
            rotate 180*y
            translate <8, 1, 14.2>
          }
          difference {
            box { <-2, 0, 0> <2, 1, 1> }
            cylinder { -2.1*x, 2.1*x, 0.8 translate <0, 0, 1> }
            rotate 180*y
            translate <16, 1, 14.2>
          }
          difference {
            box { <-2, 0, 0> <2, 1, 1> }
            cylinder { -2.1*x, 2.1*x, 0.8 translate <0, 0, 1> }
            rotate 180*y
            translate <32, 1, 14.2>
          }
        #end
        difference {
          merge {
            box { <-39.9, 1.1, -15.9> <39.9, 24.6, 15.9> }
            box { <-42.9, 4.1, -14.6> <42.9, 6.2, -9.8> }
            box { <-42.9, 4.1, 14.6> <42.9, 6.2, 9.8> }
            cylinder { -2.4*z, 2.4*z, 0.7 translate <-42.2, 7.6, -12.2> }
            cylinder { -2.4*z, 2.4*z, 0.7 translate <42.2, 7.6, -12.2> }
            cylinder { -2.4*z, 2.4*z, 0.7 translate <-42.2, 7.6, 12.2> }
            cylinder { -2.4*z, 2.4*z, 0.7 translate <42.2, 7.6, 12.2> }
            box { <-42.900001, 6, -14.600001> <-41.5, 7.600001, -9.799999> }
            box { <-42.900001, 6, 14.600001> <-41.5, 7.600001, 9.799999> }
            box { <42.900001, 6, -14.600001> <41.5, 7.600001, -9.799999> }
            box { <42.900001, 6, 14.600001> <41.5, 7.600001, 9.799999> }
          }
          #if (setting > 1)
            box { <-38.4, 0, -14.4> <38.4, 2.1, 14.4> }
            cylinder { -16*z, -12.7*z, 2.5 translate <0, 8.75, 0> }
            cylinder { -16*z, -12.700001*z, 3.4 scale <0.6, 1, 1> translate <0, 8.75, 0> }
            cylinder { 16*z, 12.7*z, 2.5 translate <0, 8.75, 0> }
            cylinder { 16*z, 12.700001*z, 3.4 scale <0.6, 1, 1> translate <0, 8.75, 0> }
            box { <-41.4, 4, -13.1> <-39.900001, 5.5, -11.3> }
            box { <-41.4, 4, 13.1> <-39.900001, 5.5, 11.3> }
            box { <41.4, 4, -13.1> <39.900001, 5.5, -11.3> }
            box { <41.4, 4, 13.1> <39.900001, 5.5, 11.3> }
            box { <-4, 7, -16> <-3, 10.5, -13.4> }
            cylinder { -16*z, -13.4*z, 0.5 translate <-3.5, 7, 0> }
            cylinder { -16*z, -13.4*z, 0.5 translate <-3.5, 10.5, 0> }
            box { <4, 7, -16> <3, 10.5, -13.4> }
            cylinder { -16*z, -13.4*z, 0.5 translate <3.5, 7, 0> }
            cylinder { -16*z, -13.4*z, 0.5 translate <3.5, 10.5, 0> }
            box { <-4, 7, 16> <-3, 10.5, 13.4> }
            cylinder { 16*z, 13.4*z, 0.5 translate <-3.5, 7, 0> }
            cylinder { 16*z, 13.4*z, 0.5 translate <-3.5, 10.5, 0> }
            box { <4, 7, 16> <3, 10.5, 13.4> }
            cylinder { 16*z, 13.4*z, 0.5 translate <3.5, 7, 0> }
            cylinder { 16*z, 13.4*z, 0.5 translate <3.5, 10.5, 0> }
            cylinder { 0*y, 2.6*y, 2 }
          #end
          box { <-2.7, 0, -11.5> <2.7, 12.6, -14.400001> }
          box { <-2.7, 0, 11.5> <2.7, 12.6, 14.400001> }
          box { <-40, 18.1, -20> <-23.9, 25, 20> }
          box { <-10, 0, -20> <0, 10, 20> rotate 5*z translate <-19.4, 24.6, 0> }
          box { <40, 18.1, -20> <23.9, 25, 20> }
          box { <0, 0, -20> <10, 10, 20> rotate -5*z translate <19.4, 24.6, 0> }
          box { <-25, 0, -10> <25, 10, 0> rotate -5*x translate <0, 24.6, -11.4> }
          box { <-25, 0, 0> <25, 10, 10> rotate 5*x translate <0, 24.6, 11.4> }
          cylinder { -20*z, -15*z, 4.1 translate <-23.9, 8.1, 0> }
          cylinder { -20*z, -15*z, 4.1 translate <23.9, 8.1, 0> }
          cylinder { 20*z, 15*z, 4.1 translate <-23.9, 8.1, 0> }
          cylinder { 20*z, 15*z, 4.1 translate <23.9, 8.1, 0> }
        }
        #if (setting < 3)
          cylinder { 18*y, 19.8*y, 2.4 translate <-36, 0, -12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-36, 0, -4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-36, 0, 4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-36, 0, 12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-28, 0, -12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-28, 0, -4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-28, 0, 4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-28, 0, 12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <36, 0, -12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <36, 0, 12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <28, 0, -12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <28, 0, 12> }
        #else
          object { rounded_button() translate <-36, 15, -12> }
          object { rounded_button() translate <-36, 15, -4> }
          object { rounded_button() translate <-36, 15, 4> }
          object { rounded_button() translate <-36, 15, 12> }
          object { rounded_button() translate <-28, 15, -12> }
          object { rounded_button() translate <-28, 15, -4> }
          object { rounded_button() translate <-28, 15, 4> }
          object { rounded_button() translate <-28, 15, 12> }
          object { rounded_button() translate <36, 15, -12> }
          object { rounded_button() translate <36, 15, 12> }
          object { rounded_button() translate <28, 15, -12> }
          object { rounded_button() translate <28, 15, 12> }
        #end
        object { conductive_button() rotate 90*y translate <28, 15, -4> }
        object { conductive_button() rotate 90*y translate <36, 15, -4> }
        object { conductive_button() rotate -90*y translate <28, 15, 4> }
        object { conductive_button() rotate -90*y translate <36, 15, 4> }
        difference {
          merge {
            cylinder { 23.9*y, 30.7*y, 2.25 }
            cylinder { 30.6*y, 31.1*y, 2.5 }
          }
          box { <-4, 28.4, -0.5> <4, 32.1, 0.5> }
          cylinder { 23.1*y, 32.1*y, 1.6 }
        }
      }
      texture { black_tex }
      bounded_by { box { <-43, -3.4, -20.5> <43, 31.2, 20.5> } }
    }
  #end
#end
#macro train_9v_motor_ornaments(color_tex,age)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -5> <75.9, 19.1, 11.9> }
      box { <20, 15.999999, -10> <52, 20, 20> }
      box { <-4, -1, 3.9> <76, 16, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.900001, 3.1, -4.2> <75.900001, 19.1, 4.100001> }
        cylinder { 3*y, 20*y, 1.6 translate <-3.9, 0, 2.5> }
        cylinder { 3*y, 20*y, 1.6 translate <75.9, 0, 2.5> }
        box { <-4, 0, -5> <-2.3, 20, 2.5> } 
        box { <74.3, 0, -5> <77, 20, 2.5> }
        box { <-4, 0, -5> <-2.3, 16, 5> }
        box { <74.3, 0, -5> <77, 16, 5> }
        cylinder { 3*y, 20*y, 1.6 translate <5.6, 0, 2.5> }
        cylinder { 3*y, 20*y, 1.6 translate <5.6, 0, -0.4> }
        difference {
          box { <5.599999, 3, -2.000001> <24, 20, 4.100002> }
          box { <0, 2, 0> <10, 21, 10> rotate 35*y translate <20, 0, -2> }
        }
        box { <4, 3, -0.400001> <13, 20, 2.500001> }
        cylinder { 3*y, 20*y, 1.6 translate <66.4, 0, 2.5> }
        cylinder { 3*y, 20*y, 1.6 translate <66.4, 0, -0.4> }
        difference {
          box { <48, 3, -2.000001> <66.400001, 20, 4.100002> }
          box { <-10, 2, 0> <0, 21, 10> rotate -35*y translate <52, 0, -2> }
        }
        box { <25.6, 14, -2.4> <30.4, 17, 2.4> }
        box { <33.6, 14, -2.4> <38.4, 17, 2.4> }
        box { <41.6, 14, -2.4> <46.4, 17, 2.4> }
        box { <59, 3, -0.400001> <68, 20, 2.500001> }
        box { <-4.000005, 16, -10> <76.000005, 20, -2> }
        box { <20, 16.000001, -10> <52, 20, 20> }
        box { <-4, 0, 0> <76, 10, 10> rotate -24*x translate <0, 16, -2> }
        box { <-4.000006, 0, -5> <0.1, 20, -2> }
        box { <-10, 0, 0> <0, 20, 5> rotate -28*y translate <0.1, 0, -2> }
        box { <71.9000006, 0, -5> <76, 20, -2> }
        box { <0, 0, 0> <10, 20, 5> rotate 28*y translate <71.9, 0, -2> }
        difference {
          box { <19.9, 0, -5> <52.1, 12.8, 10> }
          box { <20, 0, 0> <23.9, 10, 10> rotate -23*x translate <0, 9.6, -4.2> }
          box { <48.1, 0, 0> <66, 10, 10> rotate -23*x translate <0, 9.6, -4.2> }
          box { <19, 0, -6> <23.900005, 13, -2.000003> }
          box { <48.100005, 0, -6> <66, 13, -2.000003> }
        }
        box { <0, -10, -10> <20, 0, -1.999999> rotate -40*z translate <0, 9.6, 0> }
        box { <-20, -10, -10> <0, 0, -1.999999> rotate 40*z translate <24, 9.6, 0> }
        box { <0, -10, -10> <20, 0, -1.999999> rotate -40*z translate <48, 9.6, 0> }
        box { <-20, -10, -10> <0, 0, -1.999999> rotate 40*z translate <72, 9.6, 0> }
        difference {
          box { <-1, 0, 4.100009> <20.000001, 19, -2.000005> }
          box { <-10, 0, 0> <0, 20, 5> rotate -28*y translate <1.6, 0, -2> }
          box { <-4, 0, 0> <76, 10, 10> rotate -24*x translate <0, 15, -2> }
          box { <2.4, 0, 0> <4.000004, 10, 10> rotate -24*x translate <0, 12.8, -2> }
        }
        difference {
          box { <51.999999, 0, 4.100009> <73, 19, -2.000005> }
          box { <0, 0, 0> <10, 20, 5> rotate 28*y translate <70.4, 0, -2> }
          box { <-4, 0, 0> <76, 10, 10> rotate -24*x translate <0, 15, -2> }
          box { <68.000004, 0, 0> <69.6, 10, 10> rotate -24*x translate <0, 12.8, -2> }
        }
        box { <-4.000007, 0, -2.000008> <76.000007, 9.6, 10> }
        box { <-4.000008, 0, -6> <76.000008, 5.4, -3.5> }
        #if (setting > 1)
          difference {
            box { <1, 5.399999, -6> <22.9, 12.8, -3.500001> }
            torus { 3.5, 0.5 translate <7.8, 10, -0.2125> }
            torus { 3.5, 0.5 translate <7.8, 8.9, -0.2125> }
            torus { 3.5, 0.5 translate <7.8, 7.8, -0.2125> }
            torus { 3.5, 0.5 translate <7.8, 6.7, -0.2125> }
            torus { 3.5, 0.5 translate <16.2, 10, -0.2125> }
            torus { 3.5, 0.5 translate <16.2, 8.9, -0.2125> }
            torus { 3.5, 0.5 translate <16.2, 7.8, -0.2125> }
            torus { 3.5, 0.5 translate <16.2, 6.7, -0.2125> }
            box { <0, -10, -10> <20, 0, -1.999999> rotate -40*z translate <0, 10.6, 0> }
            box { <-20, -10, -10> <0, 0, -1.999999> rotate 40*z translate <24, 10.6, 0> }
            box { <0, 5.4, -7> <7.8, 6.4, -3> }
            box { <16.2, 5.4, -7> <24, 6.4, -3> }
            cylinder { 5.399999*y, 6.400001*y, 1 translate <7.8, 0, -3.2> }
            cylinder { 5.399999*y, 6.400001*y, 1 translate <16.2, 0, -3.2> }
            box { <6.5, 10.5, -7> <17.5, 13, -3> }
            difference {
              box { <4.7, 11, -7> <19.3, 13, -3> }
              cylinder { -8*z, -2*z, 1.8 translate <4.7, 11, 0> }
              cylinder { -8*z, -2*z, 1.8 translate <19.3, 11, 0> }
            }
          }
          difference {
            box { <49, 5.399999, -6> <70.9, 12.8, -3.500001> }
            torus { 3.5, 0.5 translate <55.8, 10, -0.2125> }
            torus { 3.5, 0.5 translate <55.8, 8.9, -0.2125> }
            torus { 3.5, 0.5 translate <55.8, 7.8, -0.2125> }
            torus { 3.5, 0.5 translate <55.8, 6.7, -0.2125> }
            torus { 3.5, 0.5 translate <64.2, 10, -0.2125> }
            torus { 3.5, 0.5 translate <64.2, 8.9, -0.2125> }
            torus { 3.5, 0.5 translate <64.2, 7.8, -0.2125> }
            torus { 3.5, 0.5 translate <64.2, 6.7, -0.2125> }
            box { <0, -10, -10> <20, 0, -1.999999> rotate -40*z translate <48, 10.6, 0> }
            box { <-20, -10, -10> <0, 0, -1.999999> rotate 40*z translate <72, 10.6, 0> }
            box { <48, 5.4, -7> <55.8, 6.4, -3> }
            box { <64.2, 5.4, -7> <72, 6.4, -3> }
            cylinder { 5.399999*y, 6.400001*y, 1 translate <55.8, 0, -3.2> }
            cylinder { 5.399999*y, 6.400001*y, 1 translate <64.2, 0, -3.2> }
            box { <54.5, 10.5, -7> <65.5, 13, -3> }
            difference {
              box { <52.7, 11, -7> <67.3, 13, -3> }
              cylinder { -8*z, -2*z, 1.8 translate <52.7, 11, 0> }
              cylinder { -8*z, -2*z, 1.8 translate <67.3, 11, 0> }
            }
          }
        #end
        cylinder { -3.5*z, 0*z, 0.9 translate <12, 5.4, 0> }
        cylinder { -3.5*z, 0*z, 0.9 translate <60, 5.4, 0> }
        difference {
          box { <4.1, 12.8, -5> <19.9, 20, -1.999994> }
          box { <0, -10, -10> <20, 0, -1.999999> rotate -40*z translate <0, 19.6, 0> }
          box { <-20, -10, -10> <0, 0, -1.999999> rotate 40*z translate <24, 19.6, 0> }
        }
        difference {
          box { <52.1, 12.8, -5> <67.9, 20, -1.999994> }
          box { <0, -10, -10> <20, 0, -1.999999> rotate -40*z translate <48, 19.6, 0> }
          box { <-20, -10, -10> <0, 0, -1.999999> rotate 40*z translate <72, 19.6, 0> }
        }
      }
      #if (setting < 3)
        cylinder { -4.2*z, -2.4*z, 2.4 translate <12, 5.4, 0> }
        cylinder { -4.2*z, -2.4*z, 2.4 translate <60, 5.4, 0> }
      #else
        object { rounded_button() rotate 90*y rotate -90*x translate <12, 5.4, 0.6> }
        object { rounded_button() rotate 90*y rotate -90*x translate <60, 5.4, 0.6> }
      #end
      difference {
        box { <-3.9, 16, 4.1> <11.9, 19.1, 11.9> }
        box { <-4, 0, -10> <12, 10, 0> rotate -10*x translate <0, 19.1, 5.9> }
        box { <-4, 0, 0> <12, 10, 10> rotate 10*x translate <0, 19.1, 10.1> }
        box { <-10, 0, 0> <0, 10, 12> rotate 10*z translate <-2.1, 19.1, 0> }
        box { <0, 0, 0> <10, 10, 12> rotate -10*z translate <10.1, 19.1, 0> }
        box { <-2.4, 15, 5.6> <10.4, 18, 10.4> }
      }
      difference {
        box { <60.1, 16, 4.1> <75.9, 19.1, 11.9> }
        box { <60, 0, -10> <76, 10, 0> rotate -10*x translate <0, 19.1, 5.9> }
        box { <60, 0, 0> <76, 10, 10> rotate 10*x translate <0, 19.1, 10.1> }
        box { <-10, 0, 0> <0, 10, 12> rotate 10*z translate <61.9, 19.1, 0> }
        box { <0, 0, 0> <10, 10, 12> rotate -10*z translate <74.1, 19.1, 0> }
        box { <61.6, 15, 5.6> <74.4, 18, 10.4> }
      }
      object { pin(age) translate <4, 16, 8> }
      object { pin(age) translate <68, 16, 8> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <32, 16, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <40, 16, 0> }
      #end
      object { open_rounded_button() translate <32, 13, 0> }
      object { open_rounded_button() translate <40, 13, 0> }
      difference {
        cylinder { 16.000002*y, 13.9*y, 2.400001 }
        cylinder {13*y, 17*y, 1.600001 }
        translate <32, 0, 0>
      }
      difference {
        cylinder { 16.000002*y, 13.9*y, 2.400001 }
        cylinder {13*y, 17*y, 1.600001 }
        translate <40, 0, 0>
      }
      difference {
        merge {
          cylinder { 9.4*y, 12.9*y, 4 }
          torus { 3, 2 translate <0, 10.7, 0> }
          cylinder { 0*z, 5*z, 2 translate <-3, 10.7, 0> }
          cylinder { 0*z, 5*z, 2 translate <3, 10.7, 0> }
          cylinder { 6.2*y, 10.7*y, 5 }
          cylinder { 5.2*y, 12.7*y, 3 }
          torus { 3, 2 translate <0, 6.2, 0> }
          cylinder { 0*z, 5*z, 2 translate <-3, 6.2, 0> }
          cylinder { 0*z, 5*z, 2 translate <3, 6.2, 0> }
          box { <-5, 6.2, 0> <5, 10.7, 5> }
          box { <-3, 4.2, 0> <3, 12.7, 5> }
          cylinder { 3.1*y, 4.2*y, 3.25 }
          box { <-3.9, 0, -4.2> <3.9, 3.1, 4.100008> }
          box { <-4, 9.4, 0> <4, 12.9, 5> }
          box { <-3.25, 3.1, 0> <3.25, 4.2, 5> }
        }
        box { <-6, -1, 4.100009> <6, 15, 10> }
        box { <-2, 5.200001, -2.9> <2, 15, 5> }
        torus { 3, 1 translate <0, 10.7, 0> }
        torus { 3, 1 translate <0, 6.2, 0> }
        cylinder { -0.000001*z, 5*z, 1 translate <-3, 10.7, 0> }
        cylinder { -0.000001*z, 5*z, 1 translate <3, 10.7, 0> }
        cylinder { -0.000001*z, 5*z, 1 translate <-3, 6.2, 0> }
        cylinder { -0.000001*z, 5*z, 1 translate <3, 6.2, 0> }
        box { <-4, 6.2, -0.000001> <4, 10.7, 5> }
        box { <-3, 5.2, -0.000001> <3, 11.7, 5> }
        box { <-2.4, -1, -2.9> <2.4, 2, 2.4> }
        cylinder { 0*y, 4*y, 2.1 }
        box { <-2.1, 0, 0> <2.1, 4.000001, 2.400001> }
        translate <36, 0, 0>
      }
      difference {
        merge {
          cylinder { 4.1*z, 5.9*z, 1.9 translate <36, 4, 0> }
          box { <35.5, 5.1, -3.5> <36.5, 6.2, 5.8> }
        }
        box { <30, 0, 0> <42, 10, 10> rotate -50*x translate <0, 4, 5.9> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -5.1> <76, 19.2, 12> } }
    }
  #end
#end
#macro train_bogie_plate(color_tex)
  #if (setting = 0)
    merge {
      box { <-23.9, 0, -15.9> <23.9, 3.1, 15.9> }
      cylinder { 1*y, 10.2*y, 2.5 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-23.9, 0.5, -15.9> <23.9, 3.1, 15.9> }
          box { <-23.4, 0, -15.4> <23.4, 0.55, 15.4> }
        }
        box { <-10, 0, -20> <0, 10, 20> rotate 5*z translate <-19.4, 3.1, 0> }
        box { <0, 0, -20> <10, 10, 20> rotate -5*z translate <19.4, 3.1, 0> }
        box { <-25, 0, -10> <25, 10, 0> rotate -5*x translate <0, 3.1, -11.4> }
        box { <-25, 0, 0> <25, 10, 10> rotate 5*x translate <0, 3.1, 11.4> }
        #if (setting > 1)
          box { <-22.4, -1, -14.4> <22.4, 2, 14.4> }
        #end
        cylinder { -1*y, 11*y, 1.600001 }
      }
      #if (setting > 1)
        object { ring() translate <-16, 0, -8> }
        object { ring() translate <-8, 0, -8> }
        object { ring() translate <0, 0, -8> }
        object { ring() translate <8, 0, -8> }
        object { ring() translate <16, 0, -8> }
        object { ring() translate <-16, 0, 0> }
        object { ring() translate <-8, 0, 0> }
        object { ring() translate <0, 0, 0> }
        object { ring() translate <8, 0, 0> }
        object { ring() translate <16, 0, 0> }
        object { ring() translate <-16, 0, 8> }
        object { ring() translate <-8, 0, 8> }
        object { ring() translate <0, 0, 8> }
        object { ring() translate <8, 0, 8> }
        object { ring() translate <16, 0, 8> }
      #end
      difference {
        merge {
          cylinder { 3*y, 9.8*y, 2.25 }
          cylinder { 9.7*y, 10.2*y, 2.5 }
        }
        box { <-0.5, 7.5, -4> <0.5, 11, 4> }
        cylinder { -1*y, 11*y, 1.6 }
      }
      texture { color_tex }
      bounded_by { box { <-24, -0.1, -16> <24, 10.3, 16> } }
    }
  #end
#end
#macro train_bottom6_16(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <123.9, 3.1, 43.9> }
      cylinder { -9.75*x, 129.75*x, 3 translate <0, -6.3, 0> }
      cylinder { -9.752*x, 129.75*x, 3 translate <0, -6.3, 40> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <123.9, 3.1, 43.9> }
          box { <-3.900001, -12.8, -3.900001> <123.900001, 0.000001, 43.900001> }
          difference {
            sphere { <0, 0, 0> 5.9 scale <0.45, 1, 1> translate <-7.1, -6.3, 0> }
            box { <-7.1, -20, -30> <0, 20, 30> }
          }
          difference {
            sphere { <0, 0, 0> 5.9 scale <0.45, 1, 1> translate <-7.1, -6.3, 40> }
            box { <-7.1, -20, 10> <0, 20, 50> }
          }
          cylinder { -7.2*x, -1.7*x, 3 translate <0, -6.3, 0> }
          cylinder { -7.2*x, -1.7*x, 3 translate <0, -6.3, 40> }
          box { <-7.2, -9.3, -3> <-1.7, -6.3, 3> }
          box { <-7.2, -9.3, 37> <-1.7, -6.3, 43> }
          difference {
            sphere { <0, 0, 0> 5.9 scale <0.45, 1, 1> translate <127.1, -6.3, 0> }
            box { <127.1, -20, -30> <0, 20, 30> }
          }
          difference {
            sphere { <0, 0, 0> 5.9 scale <0.45, 1, 1> translate <127.1, -6.3, 40> }
            box { <127.1, -20, 10> <0, 20, 50> }
          }
          cylinder { 127.2*x, 121.7*x, 3 translate <0, -6.3, 0> }
          cylinder { 127.2*x, 121.7*x, 3 translate <0, -6.3, 40> }
          box { <127.2, -9.3, -3> <121.7, -6.3, 3> }
          box { <127.2, -9.3, 37> <121.7, -6.3, 43> }
          #local teller2 = 0;
          #while (teller2 < 6)
            #local teller = 0;
            #while (teller < 16)
              #if (setting < 3)
                cylinder { 3*y, 4.8*y, 2.4 translate <(teller*8), 0, 0> }
                cylinder { 3*y, 4.8*y, 2.4 translate <(teller*8), 0, 40> }
              #else
                object { rounded_button() translate <(teller*8), 0, 0> }
                object { rounded_button() translate <(teller*8), 0, 40> }
              #end
              #local teller = teller + 1;
            #end
            #local teller2 = teller2 + 1;
          #end
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <112, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <120, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <112, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <120, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <112, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <112, 0, 24> }
          #else
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <24, 0, 8> }
            object { rounded_button() translate <0, 0, 32> }
            object { rounded_button() translate <8, 0, 32> }
            object { rounded_button() translate <16, 0, 32> }
            object { rounded_button() translate <24, 0, 32> }
            object { rounded_button() translate <8, 0, 16> }
            object { rounded_button() translate <8, 0, 24> }
            object { rounded_button() translate <16, 0, 16> }
            object { rounded_button() translate <16, 0, 24> }
            object { rounded_button() translate <96, 0, 8> }
            object { rounded_button() translate <104, 0, 8> }
            object { rounded_button() translate <112, 0, 8> }
            object { rounded_button() translate <120, 0, 8> }
            object { rounded_button() translate <96, 0, 32> }
            object { rounded_button() translate <104, 0, 32> }
            object { rounded_button() translate <112, 0, 32> }
            object { rounded_button() translate <120, 0, 32> }
            object { rounded_button() translate <104, 0, 16> }
            object { rounded_button() translate <104, 0, 24> }
            object { rounded_button() translate <112, 0, 16> }
            object { rounded_button() translate <112, 0, 24> }
          #end
        }
        box { <3.900001, -20, -4> <115.899999, 0.000002, 44> }
        box { <-4, -20, -4> <124, -9.299999, 3> }
        box { <-4, -20, 37> <124, -9.299999, 44> }
        box { <-10, -20, 13.7> <2.4, 4, 26.3> }
        box { <117.6, -20, 13.7> <140, 4, 26.3> }
        cylinder { -7.1*x, 2.400001*x, 2.1 translate <0, -6.3, 0> }
        cylinder { -7.1*x, 2.400001*x, 2.1 translate <0, -6.3, 40> }
        box { <-7.100001, -10, -2.1> <2.400002, -6.299999, 2.1> }
        box { <-7.100001, -10, 37.9> <2.400002, -6.299999, 42.1> }
        cylinder { 127.1*x, 117.6*x, 2.1 translate <0, -6.3, 0> }
        cylinder { 127.1*x, 117.6*x, 2.1 translate <0, -6.3, 40> }
        box { <127.100001, -10, -2.1> <117.600001, -6.299999, 2.1> }
        box { <127.100001, -10, 37.9> <117.600002, -6.299999, 42.1> }
        box { <-4, -20, 0> <124, 0, 20> rotate 18.5*x translate <0, -9.3, 3> }
        box { <-4, -20, -10> <124, -9.3, 3.000001> }
        box { <-4, -20, -20> <124, 0, 0> rotate -18.5*x translate <0, -9.3, 37> }
        box { <-4, -20, 36.999999> <124, -9.3, 50> }
        box { <-4, -20, -4> <2.400001, -9.300001, 44> }
        box { <117.599999, -20, -4> <124, -9.300001, 44> }
        box { <-4, -20, 6> <2.400002, -5.3, 34> }
        box { <117.599998, -20, 6> <124, -5.3, 34> }
        difference {
          merge {
            box { <-2.4, -20, -2.4> <2.400003, 2, 12.8> }
            box { <-2.4, -20, 27.2> <2.400003, 2, 42.4> }
          }
          box { <-10, 0, 10.4> <0, 10, 29.6> rotate 27.5*z translate <2.4, -1, 0> }
        }
        difference {
          box { <-10, -20, 11.9> <2.400004, 4, 28.1> }
          box { <-10, -20, 10> <0, 0, 30> rotate 27.5*z translate <2.4, 0, 0> }
        }
        box { <-10, -9.600001, 16.5> <4.1, 4, 23.5> }
        difference {
          merge {
            box { <117.599996, -20, -2.4> <122.4, 2, 12.8> }
            box { <117.599996, -20, 27.2> <122.4, 2, 42.4> }
          }
          box { <0, 0, 10.4> <10, 10, 29.6> rotate -27.5*z translate <117.6, -1, 0> }
        }
        difference {
          box { <117.599995, -20, 11.9> <130, 4, 28.1> }
          box { <0, -20, 10> <10, 0, 30> rotate -27.5*z translate <117.6, 0, 0> }
        }
        box { <115.9, -9.600001, 16.5> <130, 4, 23.5> }
        #if (setting > 1)
          #local teller2 = 0;
          #while (teller2 < 6)
            #local teller = 0;
            #while (teller < 16)
              cylinder { 1*y, 4*y, 1.2 translate <(teller*8), 0, 0> }
              cylinder { 1*y, 4*y, 1.2 translate <(teller*8), 0, 40> }
              #local teller = teller + 1;
            #end
            #local teller2 = teller2 + 1;
          #end
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <112, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <120, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <112, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <120, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <112, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <112, 0, 24> }
        #end
        box { <19.9, -1, 11.9> <100.1, 6, 28.1> }
        box { <27.9, -1, 3.9> <92.1, 6, 36.1> }
        difference {
          box { <3.9, -1, -2.4> <116.1, 2, 42.4> }
          box { <18.4, -1, 10.4> <101.6, 6, 29.6> }
          box { <26.4, -1, 2.4> <93.6, 6, 37.6> }
        }
      }
      #if (setting > 1)
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <12, 0, 28> }
        object { ring() translate <12, 0, 36> }
        object { ring() translate <20, 0, 36> }
        object { ring() translate <108, 0, 4> }
        object { ring() translate <100, 0, 4> }
        object { ring() translate <108, 0, 12> }
        object { ring() translate <108, 0, 20> }
        object { ring() translate <108, 0, 28> }
        object { ring() translate <108, 0, 36> }
        object { ring() translate <100, 0, 36> }
        object { pin(1) translate <28, 0, 0> }
        object { pin(1) translate <36, 0, 0> }
        object { pin(1) translate <44, 0, 0> }
        object { pin(1) translate <52, 0, 0> }
        object { pin(1) translate <60, 0, 0> }
        object { pin(1) translate <68, 0, 0> }
        object { pin(1) translate <76, 0, 0> }
        object { pin(1) translate <84, 0, 0> }
        object { pin(1) translate <92, 0, 0> }
        object { pin(1) translate <28, 0, 40> }
        object { pin(1) translate <36, 0, 40> }
        object { pin(1) translate <44, 0, 40> }
        object { pin(1) translate <52, 0, 40> }
        object { pin(1) translate <60, 0, 40> }
        object { pin(1) translate <68, 0, 40> }
        object { pin(1) translate <76, 0, 40> }
        object { pin(1) translate <84, 0, 40> }
        object { pin(1) translate <92, 0, 40> }
        box { <3.5, 0, -0.5> <5.6, 2.1, 0.5> }
        box { <3.5, 0, 7.5> <5.6, 2.1, 8.5> }
        box { <3.5, 0, 15.5> <5.6, 2.1, 16.5> }
        box { <3.5, 0, 23.5> <5.6, 2.1, 24.5> }
        box { <3.5, 0, 31.5> <5.6, 2.1, 32.5> }
        box { <3.5, 0, 39.5> <5.6, 2.1, 40.5> }
        box { <114.4, 0, -0.5> <116.5, 2.1, 0.5> }
        box { <114.4, 0, 7.5> <116.5, 2.1, 8.5> }
        box { <114.4, 0, 15.5> <116.5, 2.1, 16.5> }
        box { <114.4, 0, 23.5> <116.5, 2.1, 24.5> }
        box { <114.4, 0, 31.5> <116.5, 2.1, 32.5> }
        box { <114.4, 0, 39.5> <116.5, 2.1, 40.5> }
        box { <3.8, 0, -0.5> <5.6, 2.1, 0.5> }
        box { <3.8, 0, 7.5> <5.6, 2.1, 8.5> }
        box { <3.8, 0, 15.5> <5.6, 2.1, 16.5> }
        box { <3.8, 0, 23.5> <5.6, 2.1, 24.5> }
        box { <3.8, 0, 31.5> <5.6, 2.1, 32.5> }
        box { <3.8, 0, 39.5> <5.6, 2.1, 40.5> }
        box { <114.4, 0, -0.5> <118.2, 2.1, 0.5> }
        box { <114.4, 0, 7.5> <118.2, 2.1, 8.5> }
        box { <114.4, 0, 15.5> <118.2, 2.1, 16.5> }
        box { <114.4, 0, 23.5> <118.2, 2.1, 24.5> }
        box { <114.4, 0, 31.5> <118.2, 2.1, 32.5> }
        box { <114.4, 0, 39.5> <118.2, 2.1, 40.5> }
      #end
      difference {
        cylinder { -12.8*y, -9.6*y, 6 translate <2.5, 0, 0> }
        cylinder { -13*y, -7*y, 2.5 }
        difference {
          cylinder { -13*y, -10.5*y, 5.2 translate <2.5, 0, 0> }
          cylinder { -14*y, -10*y, 3.9 }
          box { <-20, -14, -10> <-1, -5, 10> }
        }
        box { <3.900009, -15, -10> <13, -6, 10> }
        translate <0, 0, 20>
      }
      difference {
        cylinder { -12.8*y, -9.6*y, 6 translate <-2.5, 0, 0> }
        cylinder { -13*y, -7*y, 2.5 }
        difference {
          cylinder { -13*y, -10.5*y, 5.2 translate <-2.5, 0, 0> }
          cylinder { -14*y, -10*y, 3.9 }
          box { <1, -14, -10> <20, -5, 10> }
        }
        box { <-3.900009, -15, -10> <-13, -6, 10> }
        translate <120, 0, 20>
      }
      bounded_by { box { <-9.85, -12.9, -6> <129.85, 4.9, 46> } }
      texture { color_tex }
    }
  #end
#end
#macro train_bottom6_24(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <187.9, 6.3, 43.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <187.9, 6.3, 43.9> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <186.4, 5.4, 42.4> }
            cylinder { -1*y, 7*y, 2.600001 translate <28, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <36, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <44, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <140, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <148, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <156, 0, 20> }
          #end
        }
        #local teller2 = 0;
        #while (teller2 < 6)
          #local teller = 0;
          #while (teller < 24)
            #if (setting < 3)
              cylinder { 6.2*y, 8*y, 2.4 translate <(teller*8), 0, (teller2*8)> }
            #else
              object { rounded_button() translate <(teller*8), 3.2, (teller2*8)> }
            #end
            #local teller = teller + 1;
          #end
          #local teller2 = teller2 + 1;
        #end
        #if (setting > 1)
          difference {
            box { <74.9, 3.200001, 10.9> <85.1, 5.5, 29.1> }
            box { <75.900001, -1, 11.900001> <84.100001, 6, 28.100001> }
          }
          difference {
            box { <98.9, 3.200001, 10.9> <109.1, 5.5, 29.1> }
            box { <99.900001, -1, 11.900001> <108.100001, 6, 28.100001> }
          }
          difference {
            box { <84.6, 3.200003, 4.6> <99.4, 5.5, 35.4> }
            box { <85.6, -1, 5.6> <98.4, 6, 34.4> }
          }
        #end
        box { <58, 3.200002, 6.5> <59, 5.5, 33.5> }
        box { <125, 3.200002, 6.5> <126, 5.5, 33.5> }
        #local teller2 = 0;
        #while (teller2 < 5)
          #local teller = 0;
          #while (teller < 23)
            object { ring() translate <(teller*8)+4, 3.2, (teller2*8)+4> }
            #local teller = teller + 1;
            #if (teller = 7)
              #local teller = 16;
            #end
          #end
          #local teller2 = teller2 + 1;
        #end
        object { ring() translate <60, 0, 4> }
        object { ring() translate <60, 0, 36> }
        object { ring() translate <124, 0, 4> }
        object { ring() translate <124, 0, 36> }
        object { ring() translate <92, 0, 12> }
        object { ring() translate <92, 0, 20> }
        object { ring() translate <92, 0, 28> }
      }
      #if (setting > 1)
        #local teller2 = 0;
        #while (teller2 < 6)
          #local teller = 0;
          #while (teller < 24)
            cylinder { 4.2*y, 7.2*y, 1.2 translate <(teller*8), 0, (teller2*8)> }
            #local teller = teller + 1;
          #end
          #local teller2 = teller2 + 1;
        #end
      #end
      box { <75.9, -1, 11.9> <84.1, 15, 28.1> }
      box { <99.9, -1, 11.9> <108.1, 15, 28.1> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <188, 8.1, 44> } }
    }
  #end
#end
#macro train_bottom6_28(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <219.9, 6.3, 43.9> texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <219.9, 6.3, 43.9> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <218.4, 5.4, 42.4> }
            cylinder { -1*y, 7*y, 2.600001 translate <28, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <36, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <44, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <172, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <180, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <188, 0, 20> }
          #end
        }
        #local teller2 = 0;
        #while (teller2 < 6)
          #local teller = 0;
          #while (teller < 28)
            #if (setting < 3)
              cylinder { 6.2*y, 8*y, 2.4 translate <(teller*8), 0, (teller2*8)> }
            #else
              object { rounded_button() translate <(teller*8), 3.2, (teller2*8)> }
            #end
            #local teller = teller + 1;
          #end
          #local teller2 = teller2 + 1;
        #end
        #if (setting > 1)
          difference {
            box { <90.9, 3.200001, 10.9> <101.1, 5.5, 29.1> }
            box { <91.900001, -1, 11.900001> <100.100001, 6, 28.100001> }
          }
          difference {
            box { <114.9, 3.200001, 10.9> <125.1, 5.5, 29.1> }
            box { <115.900001, -1, 11.900001> <124.100001, 6, 28.100001> }
          }
        #end
        #local teller2 = 0;
        #while (teller2 < 5)
          #local teller = 0;
          #while (teller < 27)
            object { ring() translate <(teller*8)+4, 3.2, (teller2*8)+4> }
            #local teller = teller + 1;
            #if (teller = 7)
              #local teller = 20;
            #end
          #end
          #local teller2 = teller2 + 1;
        #end
        object { ring() translate <92, 3.2, 4> }
        object { ring() translate <100, 3.2, 4> }
        object { ring() translate <108, 3.2, 4> }
        object { ring() translate <116, 3.2, 4> }
        object { ring() translate <124, 3.2, 4> }
        object { ring() translate <92, 3.2, 36> }
        object { ring() translate <100, 3.2, 36> }
        object { ring() translate <108, 3.2, 36> }
        object { ring() translate <116, 3.2, 36> }
        object { ring() translate <124, 3.2, 36> }
        object { ring() translate <108, 3.2, 12> }
        object { ring() translate <108, 3.2, 20> }
        object { ring() translate <108, 3.2, 28> }
      }
      #if (setting > 1)
        #local teller2 = 0;
        #while (teller2 < 6)
          #local teller = 0;
          #while (teller < 28)
            cylinder { 4.2*y, 7.2*y, 1.2 translate <(teller*8), 0, (teller2*8)> }
            #local teller = teller + 1;
          #end
          #local teller2 = teller2 + 1;
        #end
      #end
      box { <91.9, -1, 11.9> <100.1, 15, 28.1> }
      box { <115.9, -1, 11.9> <124.1, 15, 28.1> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <220, 8.1, 44> } }
    }
  #end
#end
#macro train_bottom6_34(color_tex, age)
  #if (setting = 0)
    difference {
      box { <-3.9, -19.1, -3.9> <267.9, 6.3, 43.9> }
      box { <59.9, -12.8, -4> <204.1, 9, 44> }
      box { <-10, -20, -4> <52.5, 0, 44> }
      box { <211.5, -20, -4> <280, 0, 44> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, -19.1, -3.9> <267.9, 6.3, 43.9> }
        #local teller2 = 0;
        #while (teller2 < 6)
          #local teller = 0;
          #while (teller < 34)
            #if (setting < 3)
              cylinder { 6.2*y, 8*y, 2.4 translate <(teller*8), 0, (teller2*8)> }
            #else
              object { rounded_button() translate <(teller*8), 3.2, (teller2*8)> }
            #end
            #local teller = teller + 1;
            #if (teller = 8)
              #local teller = 26;
            #end
          #end
          #local teller2 = teller2 + 1;
        #end
      }
      difference {
        box { <59.9, -12.8, -4> <204.1, 9, 44> }
        #local teller2 = 0;
        #while (teller2 < 6)
          #local teller = 8;
          #while (teller < 26)
            #if (setting < 3)
              cylinder { -12.7*y, -10.9*y, 2.4 translate <(teller*8), 0, (teller2*8)> }
            #else
              object { rounded_button() translate <(teller*8), -15.7, (teller2*8)> }
            #end
            #local teller = teller + 1;
          #end
          #local teller2 = teller2 + 1;
        #end
        box { <50, -13, 4.1> <67.9, -9.5, 11.9> }
        box { <50, -13, 28.1> <67.9, -9.5, 35.9> }
        box { <196.1, -13, 4.1> <210, -9.5, 11.9> }
        box { <196.1, -13, 28.1> <210, -9.5, 35.9> }
        box { <-10, -30, 4.100001> <0, 0, 5.6> rotate 19*z translate <59.9, 6.3, 0> }
        box { <0, -30, 4.100001> <10, 0, 5.6> rotate -19*z translate <204.1, 6.3, 0> }
        box { <-10, -30, 10.4> <0, 0, 11.900001> rotate 19*z translate <59.9, 6.3, 0> }
        box { <0, -30, 10.4> <10, 0, 11.900001> rotate -19*z translate <204.1, 6.3, 0> }
        box { <-10, -30, 28.100001> <0, 0, 29.6> rotate 19*z translate <59.9, 6.3, 0> }
        box { <0, -30, 28.100001> <10, 0, 29.6> rotate -19*z translate <204.1, 6.3, 0> }
        box { <-10, -30, 34.4> <0, 0, 35.900001> rotate 19*z translate <59.9, 6.3, 0> }
        box { <0, -30, 34.4> <10, 0, 35.900001> rotate -19*z translate <204.1, 6.3, 0> }
      }
      #local teller2 = 0;
      #while (teller2 < 6)
        #local teller = 0;
        #while (teller < 34)
          cylinder { 4.2*y, 7.2*y, 1.2 translate <(teller*8), 0, (teller2*8)> }
          #local teller = teller + 1;
          #if (teller = 8)
          #  local teller = 26;
          #end
        #end
        #local teller2 = teller2 + 1;
      #end
      #local teller2 = 0;
      #while (teller2 < 6)
        #local teller = 8;
        #while (teller < 26)
          cylinder { -14.6*y, -11.6*y, 1.2 translate <(teller*8), 0, (teller2*8)> }
          #local teller = teller + 1;
        #end
        #local teller2 = teller2 + 1;
      #end
      box { <-50, -17, -4> <0, 0, 44> rotate 19*z translate <52.5, 0, 0> }
      box { <-10, -20, -4> <52.5, 0, 44> }
      box { <-10, -20, -4> <58.400001, -16, 44> }
      box { <0, -17, -4> <50, 0, 44> rotate -19*z translate <211.5, 0, 0> }
      box { <211.5, -20, -4> <280, 0, 44> }
      box { <205.600001, -20, -4> <280, -16, 44> }
      box { <57, -6.4, 11.900002> <64, 10, 28.100002> }
      box { <202, -6.4, 11.900002> <207, 10, 28.100002> }
      difference {
        box { <-4, -20, -4> <268, -16, 4> }
        box { <-4, 0, -15> <268, 10, 0> rotate 27.5*x translate <0, -19.1, 4> }
      }
      difference {
        box { <-4, -20, 36> <268, -16, 44> }
        box { <-4, 0, 0> <268, 10, 15> rotate -27.5*x translate <0, -19.1, 36> }
      }
      #if (setting > 1)
        difference {
          box { <-2.4, -20, -2.4> <58.4, 5.4, 42.4> }
          box { <-1, -12.8, 10.9> <1, 0, 11.9> rotate 3.5*z translate <57.4, 5.4, 0> }
          box { <-1, -12.8, 28.1> <1, 0, 29.1> rotate 3.5*z translate <57.4, 5.4, 0> }
          #local teller2 = 0;
          #while (teller2 < 5)
            #local teller = 0;
            #while (teller < 7)
              difference {
                cylinder { 3.2*y, 6*y, 3.2 }
                cylinder { 3*y, 7*y, 2.6 }
                translate <4+(teller*8), 0, 4+(teller2*8)>
              }
              #local teller = teller + 1;
            #end
            #local teller2 = teller2 + 1;
          #end
        }
        difference {
          box { <205.6, -20, -2.4> <266.4, 5.4, 42.4> }
          box { <-1, -12.8, 10.9> <1, 0, 11.9> rotate -3.5*z translate <206.6, 5.4, 0> }
          box { <-1, -12.8, 28.1> <1, 0, 29.1> rotate -3.5*z translate <206.6, 5.4, 0> }
          #local teller2 = 0;
          #while (teller2 < 5)
            #local teller = 26;
            #while (teller < 33)
              object { ring() translate <4+(teller*8), 3.2, 4+(teller2*8)> }
              #local teller = teller + 1;
            #end
            #local teller2 = teller2 + 1;
          #end
        }
        difference {
          box { <60, -20, -2.4> <204, -13.9, 4> }
          object { pin(age) translate <68, -15.999999, 0> }
          object { pin(age) translate <76, -15.999999, 0> }
          object { pin(age) translate <84, -15.999999, 0> }
          object { pin(age) translate <92, -15.999999, 0> }
          object { pin(age) translate <100, -15.999999, 0> }
          object { pin(age) translate <108, -15.999999, 0> }
          object { pin(age) translate <116, -15.999999, 0> }
          object { pin(age) translate <124, -15.999999, 0> }
          object { pin(age) translate <132, -15.999999, 0> }
          object { pin(age) translate <140, -15.999999, 0> }
          object { pin(age) translate <148, -15.999999, 0> }
          object { pin(age) translate <156, -15.999999, 0> }
          object { pin(age) translate <164, -15.999999, 0> }
          object { pin(age) translate <172, -15.999999, 0> }
          object { pin(age) translate <180, -15.999999, 0> }
          object { pin(age) translate <188, -15.999999, 0> }
          object { pin(age) translate <196, -15.999999, 0> }
          box { <59, -15.999999, -0.5> <61.6, -13, 0.5> }
          box { <202.4, -15.999999, -0.5> <205, -13, 0.5> }
          box { <63.5, -15.999999, 2.4> <64.5, -13, 4.1> }
          box { <71.5, -15.999999, 2.4> <72.5, -13, 4.1> }
          box { <79.5, -15.999999, 2.4> <80.5, -13, 4.1> }
          box { <87.5, -15.999999, 2.4> <88.5, -13, 4.1> }
          box { <95.5, -15.999999, 2.4> <96.5, -13, 4.1> }
          box { <103.5, -15.999999, 2.4> <104.5, -13, 4.1> }
          box { <111.5, -15.999999, 2.4> <112.5, -13, 4.1> }
          box { <119.5, -15.999999, 2.4> <120.5, -13, 4.1> }
          box { <127.5, -15.999999, 2.4> <128.5, -13, 4.1> }
          box { <135.5, -15.999999, 2.4> <136.5, -13, 4.1> }
          box { <143.5, -15.999999, 2.4> <144.5, -13, 4.1> }
          box { <151.5, -15.999999, 2.4> <152.5, -13, 4.1> }
          box { <159.5, -15.999999, 2.4> <160.5, -13, 4.1> }
          box { <167.5, -15.999999, 2.4> <168.5, -13, 4.1> }
          box { <175.5, -15.999999, 2.4> <176.5, -13, 4.1> }
          box { <183.5, -15.999999, 2.4> <184.5, -13, 4.1> }
          box { <191.5, -15.999999, 2.4> <192.5, -13, 4.1> }
          box { <199.5, -15.999999, 2.4> <200.5, -13, 4.1> }
        }
        difference {
          box { <60, -20, 36> <204, -13.9, 42.4> }
          object { pin(age) translate <68, -15.999999, 40> }
          object { pin(age) translate <76, -15.999999, 40> }
          object { pin(age) translate <84, -15.999999, 40> }
          object { pin(age) translate <92, -15.999999, 40> }
          object { pin(age) translate <100, -15.999999, 40> }
          object { pin(age) translate <108, -15.999999, 40> }
          object { pin(age) translate <116, -15.999999, 40> }
          object { pin(age) translate <124, -15.999999, 40> }
          object { pin(age) translate <132, -15.999999, 40> }
          object { pin(age) translate <140, -15.999999, 40> }
          object { pin(age) translate <148, -15.999999, 40> }
          object { pin(age) translate <156, -15.999999, 40> }
          object { pin(age) translate <164, -15.999999, 40> }
          object { pin(age) translate <172, -15.999999, 40> }
          object { pin(age) translate <180, -15.999999, 40> }
          object { pin(age) translate <188, -15.999999, 40> }
          object { pin(age) translate <196, -15.999999, 40> }
          box { <63.5, -15.999999, 35.9> <64.5, -13, 37.6> }
          box { <71.5, -15.999999, 35.9> <72.5, -13, 37.6> }
          box { <79.5, -15.999999, 35.9> <80.5, -13, 37.6> }
          box { <87.5, -15.999999, 35.9> <88.5, -13, 37.6> }
          box { <95.5, -15.999999, 35.9> <96.5, -13, 37.6> }
          box { <103.5, -15.999999, 35.9> <104.5, -13, 37.6> }
          box { <111.5, -15.999999, 35.9> <112.5, -13, 37.6> }
          box { <119.5, -15.999999, 35.9> <120.5, -13, 37.6> }
          box { <127.5, -15.999999, 35.9> <128.5, -13, 37.6> }
          box { <135.5, -15.999999, 35.9> <136.5, -13, 37.6> }
          box { <143.5, -15.999999, 35.9> <144.5, -13, 37.6> }
          box { <151.5, -15.999999, 35.9> <152.5, -13, 37.6> }
          box { <159.5, -15.999999, 35.9> <160.5, -13, 37.6> }
          box { <167.5, -15.999999, 35.9> <168.5, -13, 37.6> }
          box { <175.5, -15.999999, 35.9> <176.5, -13, 37.6> }
          box { <183.5, -15.999999, 35.9> <184.5, -13, 37.6> }
          box { <191.5, -15.999999, 35.9> <192.5, -13, 37.6> }
          box { <199.5, -15.999999, 35.9> <200.5, -13, 37.6> }
          box { <59, -15.99999, 39.5> <61.6, -13, 40.5> }
          box { <202.4, -15.99999, 39.5> <205, -13, 40.5> }
        }
        difference {
          box { <60, -20, 5.6> <204, -13.9, 34.4> }
          box { <59, -19.099999, 7.5> <61.6, -13, 8.5> }
          box { <59, -19.099999, 15.5> <61.6, -13, 16.5> }
          box { <59, -19.099999, 23.5> <61.6, -13, 24.5> }
          box { <59, -19.099999, 31.5> <61.6, -13, 328.5> }
          cylinder { -19.099998*y, -13*y, 1.5 translate <64, 0, 12> }
          cylinder { -19.099998*y, -13*y, 1.5 translate <64, 0, 28> }
          cylinder { -19.099998*y, -13*y, 1.5 translate <200, 0, 12> }
          cylinder { -19.099998*y, -13*y, 1.5 translate <200, 0, 28> }
          box { <202.4, -19.099999, 7.5> <205, -13, 8.5> }
          box { <202.4, -19.099999, 15.5> <205, -13, 16.5> }
          box { <202.4, -19.099999, 23.5> <205, -13, 24.5> }
          box { <202.4, -19.099999, 31.5> <205, -13, 32.5> }
          box { <63.5, -19.099997, 18.5> <64.5, -13, 21.5> }
          box { <71.5, -19.099997, 18.5> <72.5, -13, 21.5> }
          box { <79.5, -19.099997, 18.5> <80.5, -13, 21.5> }
          box { <87.5, -19.099997, 18.5> <88.5, -13, 21.5> }
          box { <95.5, -19.099997, 18.5> <96.5, -13, 21.5> }
          box { <119.5, -19.099997, 18.5> <120.5, -13, 21.5> }
          box { <127.5, -19.099997, 18.5> <128.5, -13, 21.5> }
          box { <135.5, -19.099997, 18.5> <136.5, -13, 21.5> }
          box { <143.5, -19.099997, 18.5> <144.5, -13, 21.5> }
          box { <167.5, -19.099997, 18.5> <168.5, -13, 21.5> }
          box { <175.5, -19.099997, 18.5> <176.5, -13, 21.5> }
          box { <183.5, -19.099997, 18.5> <184.5, -13, 21.5> }
          box { <191.5, -19.099997, 18.5> <192.5, -13, 21.5> }
          box { <199.5, -19.099997, 18.5> <200.5, -13, 21.5> }
          difference {
            cylinder { -19.099996*y, -13*y, 3.2 }
            cylinder { -20*y, -12*y, 2.6 }
            translate <76, 0, 12>
          }
          difference {
            cylinder { -19.099996*y, -13*y, 3.2 }
            cylinder { -20*y, -12*y, 2.6 }
            translate <76, 0, 28>
          }
          difference {
            cylinder { -19.099996*y, -13*y, 3.2 }
            cylinder { -20*y, -12*y, 2.6 }
            translate <92, 0, 12>
          }
          difference {
            cylinder { -19.099996*y, -13*y, 3.2 }
            cylinder { -20*y, -12*y, 2.6 }
            translate <92, 0, 28>
          }
          difference {
            cylinder { -19.099996*y, -13*y, 3.2 }
            cylinder { -20*y, -12*y, 2.6 }
            translate <124, 0, 12>
          }
          difference {
            cylinder { -19.099996*y, -13*y, 3.2 }
            cylinder { -20*y, -12*y, 2.6 }
            translate <124, 0, 28>
          }
          difference {
            cylinder { -19.099996*y, -13*y, 3.2 }
            cylinder { -20*y, -12*y, 2.6 }
            translate <140, 0, 12>
          }
          difference {
            cylinder { -19.099996*y, -13*y, 3.2 }
            cylinder { -20*y, -12*y, 2.6 }
            translate <140, 0, 28>
          }
          difference {
            cylinder { -19.099996*y, -13*y, 3.2 }
            cylinder { -20*y, -12*y, 2.6 }
            translate <172, 0, 12>
          }
          difference {
            cylinder { -19.099996*y, -13*y, 3.2 }
            cylinder { -20*y, -12*y, 2.6 }
            translate <172, 0, 28>
          }
          difference {
            cylinder { -19.099996*y, -13*y, 3.2 }
            cylinder { -20*y, -12*y, 2.6 }
            translate <188, 0, 12>
          }
          difference {
            cylinder { -19.099996*y, -13*y, 3.2 }
            cylinder { -20*y, -12*y, 2.6 }
            translate <188, 0, 28>
          }
          box { <67.5, -19.099995, 6> <68.5, -13, 35> }
          box { <83.5, -19.099995, 6> <84.5, -13, 35> }
          box { <99.5, -19.099995, 6> <100.5, -13, 35> }
          box { <115.5, -19.099995, 6> <116.5, -13, 35> }
          box { <131.5, -19.099995, 6> <132.5, -13, 35> }
          box { <147.5, -19.099995, 6> <148.5, -13, 35> }
          box { <163.5, -19.099995, 6> <164.5, -13, 35> }
          box { <179.5, -19.099995, 6> <180.5, -13, 35> }
          box { <195.5, -19.099995, 6> <196.5, -13, 35> }
          box { <0, -19.099994, 19.5> <300, -13, 20.5> }
          box { <66.5, -19.099999, 7.5> <69.5, -13, 8.5> }
          box { <66.5, -19.099999, 15.5> <69.5, -13, 16.5> }
          box { <66.5, -19.099999, 23.5> <69.5, -13, 24.5> }
          box { <66.5, -19.099999, 31.5> <69.5, -13, 328.5> }
          box { <82.5, -19.099999, 7.5> <85.5, -13, 8.5> }
          box { <82.5, -19.099999, 15.5> <85.5, -13, 16.5> }
          box { <82.5, -19.099999, 23.5> <85.5, -13, 24.5> }
          box { <82.5, -19.099999, 31.5> <85.5, -13, 328.5> }
          box { <98.5, -19.099999, 7.5> <100, -13, 8.5> }
          box { <98.5, -19.099999, 15.5> <100, -13, 16.5> }
          box { <98.5, -19.099999, 23.5> <100, -13, 24.5> }
          box { <98.5, -19.099999, 31.5> <100, -13, 328.5> }
          box { <116, -19.099999, 7.5> <117.5, -13, 8.5> }
          box { <116, -19.099999, 15.5> <117.5, -13, 16.5> }
          box { <116, -19.099999, 23.5> <117.5, -13, 24.5> }
          box { <116, -19.099999, 31.5> <117.5, -13, 328.5> }
          box { <130.5, -19.099999, 7.5> <133.5, -13, 8.5> }
          box { <130.5, -19.099999, 15.5> <133.5, -13, 16.5> }
          box { <130.5, -19.099999, 23.5> <133.5, -13, 24.5> }
          box { <130.5, -19.099999, 31.5> <133.5, -13, 328.5> }
          box { <146.5, -19.099999, 7.5> <148, -13, 8.5> }
          box { <146.5, -19.099999, 15.5> <148, -13, 16.5> }
          box { <146.5, -19.099999, 23.5> <148, -13, 24.5> }
          box { <146.5, -19.099999, 31.5> <148, -13, 328.5> }
          box { <164, -19.099999, 7.5> <165.5, -13, 8.5> }
          box { <164, -19.099999, 15.5> <165.5, -13, 16.5> }
          box { <164, -19.099999, 23.5> <165.5, -13, 24.5> }
          box { <164, -19.099999, 31.5> <165.5, -13, 328.5> }
          box { <178.5, -19.099999, 7.5> <181.5, -13, 8.5> }
          box { <178.5, -19.099999, 15.5> <181.5, -13, 16.5> }
          box { <178.5, -19.099999, 23.5> <181.5, -13, 24.5> }
          box { <178.5, -19.099999, 31.5> <181.5, -13, 328.5> }
          box { <194.5, -19.099999, 7.5> <197.5, -13, 8.5> }
          box { <194.5, -19.099999, 15.5> <197.5, -13, 16.5> }
          box { <194.5, -19.099999, 23.5> <197.5, -13, 24.5> }
          box { <194.5, -19.099999, 31.5> <197.5, -13, 328.5> }
        }
      #end
      cylinder { -10*y, 10*y, 2.600001 translate <28, 0, 20> }
      cylinder { -10*y, 10*y, 2.600001 translate <236, 0, 20> }
      texture { color_tex }
      bounded_by { box { <-4, -19.2, -4> <268, 8.1, 44> } }
    }
  #end
#end
#macro train_buffers(color_tex)
  #if (setting = 0)
    merge {
      box { <-9.800008, 0, -7.9> <11.9, 3.1, 7.9> }
      box { <-9.800006, -6.1, -23.5> <-3.900007, -0.5, 23.5> }
      cylinder { -15.2*x, -3.9*x, 3 translate <0, -3.1, -20> }
      cylinder { -15.2*x, -3.9*x, 3 translate <0, -3.1, 20> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            sphere { <0, 0, 0> 5.9 scale <0.45, 1, 1> translate <-15.1, -3.1, -20> }
            box { <-15.1, -20, -30> <0, 20, 30> }
          }
          difference {
            sphere { <0, 0, 0> 5.9 scale <0.45, 1, 1> translate <-15.1, -3.1, 20> }
            box { <-15.1, -20, -30> <0, 20, 30> }
          }
          #if (setting > 1)
            object { ring() translate <4, 0, 0> }
          #end
          cylinder { -15.2*x, -9.7*x, 3 translate <0, -3.1, -20> }
          cylinder { -15.2*x, -9.7*x, 3 translate <0, -3.1, 20> }
          box { <-15.2, -6.1, -23> <-9.7, -3.1, -17> }
          box { <-15.2, -6.1, 23> <-9.7, -3.1, 17> }
          box { <-9.8, -6.100001, -23.5> <-3.9, 0.000001, 23.5> }
          difference {
            box { <-9.800008, -0.000001, -7.9> <11.9, 3.1, 7.9> }
            box { <-4.000001, -1, -6.4> <10.4, 2, 6.4> }
          }
          box { <-5.500006, -12.05, -15.900003> <-3.900007, -0.5, 15.900003> }
          cylinder { -15.9*z, 15.9*z, 0.75 translate <-4.65, -12.05, 0> }
        }
        cylinder { -15.1*x, 0*x, 2.1 translate <0, -3.1, -20> }
        cylinder { -15.1*x, 0*x, 2.1 translate <0, -3.1, 20> }
        box { <-15.100001, -10, -22.1> <0, -3.099999, -17.9> }
        box { <-15.100001, -10, 22.1> <0, -3.099999, 17.9> }
        box { <-8, -10, -22.6> <-3, -1, -15.9> }
        box { <-8, -10, 22.6> <-3, -1, 15.9> }
        box { <-8, -10, -14.4> <-5.5, -1, -7.9> }
        box { <-8, -10, 14.4> <-5.5, -1, 7.9> }
        box { <-10, -10, -13.8> <-5.500001, -2.1, 13.8> }
        box { <0, 0, -10> <10, 10, 10> rotate 40*z translate <-9.8, 0, 0> }
        box { <-20, -6.3, -3.500001> <-3.899999, 4, 3.500001> }
        box { <-10, -2.100001, -6.4> <-5.5, 4, 6.4> }
        box { <-6, -15, -8> <-3, -9.6, 8> }
      }
      cylinder { -2.1*y, -0.6*y, 1.5 translate <-11, 0, -20> }
      cylinder { -2.1*y, -0.6*y, 1.5 translate <-11, 0, 20> }
      #if (setting > 1)
        box { <-3.900001, 0, -4.5> <-2.4, 2.1, -3.5> }
        box { <-3.900001, 0, 4.5> <-2.4, 2.1, 3.5> }
      #end
      difference {
        merge {
          box { <-7.5, -1, -1.5> <-4.8, 8, 0> rotate -5*x translate <0, -9.6, -5.9> }
          box { <-7.5, 0, 0> <-4.8, 8, 1.5> rotate 5*x translate <0, -9.6, 5.9> }
        }
        box { <-10, -12, -7.9> <0, -9.600002, 7.9> }
        box { <0, -3.100005, 0> <0, 0, 0> }
      }
      difference {
        cylinder { -9.6*y, -6.3*y, 6 translate <-5.5, 0, 0> }
        cylinder { -10*y, -6*y, 2.5 translate <-8, 0, 0> }
        difference {
          cylinder { -10*y, -7.3*y, 5.2 translate <-5.5, 0, 0> }
          cylinder { -11*y, -7*y, 3.9 translate <-8, 0, 0> }
          box { <-20, -11, -10> <-9, -5, 10> }
        }
        box { <-3.900009, -15, -10> <5, -6, 10> }
      }
      texture { color_tex }
      bounded_by { box { <-17.8, -12.9, -26> <12, 3.2, 26> } }
    }
  #end
#end
#macro train_buffers2(color_tex)
  #if (setting = 0)
    merge {
      box { <-9.800008, 0, -7.9> <11.9, 3.1, 7.9> }
      box { <-9.800006, -18.1, -23.5> <-3.900007, -0.5, 23.5> }
      cylinder { -15.2*x, -3.9*x, 3 translate <0, -3.1, -20> }
      cylinder { -15.2*x, -3.9*x, 3 translate <0, -3.1, 20> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-14, -18.1, -23.900001> <-3.900005, -6.299999, 23.900001> }
        box { <-6.4, -20, -14.700005> <-5.100004, -7.200003, -10> }
        box { <-6.4, -20, 10> <-5.100004, -7.200003, 14.700005> }
        box { <-10, -10, -50> <0, -6, 0.5> rotate -8.3*y translate <-13.2, 0, 0> }
        box { <-10, -10, -0.5> <0, -6, 50> rotate 8.3*y translate <-13.2, 0, 0> }
        box { <-10, -20, -50> <0, -9, 0.5> rotate -15*y translate <-13.4, 0, 0> }
        box { <-10, -20, -0.5> <0, -9, 50> rotate 15*y translate <-13.4, 0, 0> }
        cone { 0.5*z, 4.5, -25*z, 7.5 rotate -4.5*y translate <-14.6, -13, 0> }
        cone { -0.5*z, 4.5, 25*z, 7.5 rotate 4.5*y translate <-14.6, -13, 0> }
        cylinder { -10*y, 0*y, 2.6 translate <-8, 0, 0> }
        difference {
          box { <-13, -19, -24> <0, 0, 24> }
          cone { 0.5*z, 4.5, -25*z, 7.5 rotate -4.5*y translate <-13.4, -13, 0> }
          cone { -0.5*z, 4.5, 25*z, 7.5 rotate 4.5*y translate <-13.4, -13, 0> }
          box { <-10, -13.5, -30> <0, -6.300004, 0> rotate -15*y translate <-8.4, 0, 0> }
          box { <-10, -13.5, 0> <0, -6.300004, 30> rotate 15*y translate <-8.4, 0, 0> }
          box { <-5.1, -12.7, -7.9> <0, 0, -15.9> }
          box { <-5.1, -12.7, 7.9> <0, 0, 15.9> }
          box { <-10, -12.7, -14.7> <-5.100005, 0, -15.9> }
          box { <-10, -12.7, 14.7> <-5.100005, 0, 15.9> }
          difference {
            box { <-10, -9.5, -7.900005> <-3.900007, 0, 7.900005> }
            box { <-11, -10, -6.8> <-5.1, 0, 6.8> }
          }
          difference {
            cylinder { -9.500005*y, 0*y, 3.2 }
            cylinder { -10*y, 0*y, 2.600003 }
            translate <-8, 0, 0>
          }
          box { <-14, -7.2, -25> <1, 1, 25> }
        }
      }
      difference {
        merge {
          difference {
            intersection {
              sphere { <9.7, 0, 0> 11.8 }
              cylinder { -10*x, 10*x, 5.9 }
              translate <-15.1, -3.1, -20>
            }
            box { <-15.1, -20, -30> <0, 20, 30> }
            box { <-20, 0.000005, -30> <20, 20, 30> }
            box { <-20, -20, -30> <20, -6.2, 30> }
          }
          difference {
            intersection {
              sphere { <9.7, 0, 0> 11.8 }
              cylinder { -10*x, 10*x, 5.9 }
              translate <-15.1, -3.1, 20>
            }
            box { <-15.1, -20, -30> <0, 20, 30> }
            box { <-20, 0.000005, -30> <20, 20, 30> }
            box { <-20, -20, -30> <20, -6.2, 30> }
          }
          #if (setting > 1)
            object { ring() translate <4, 0, 0> }
          #end
          cylinder { -15.2*x, -9.7*x, 3 translate <0, -3.1, -20> }
          cylinder { -15.2*x, -9.7*x, 3 translate <0, -3.1, 20> }
          box { <-15.2, -6.3, -23> <-9.7, -3.1, -17> }
          box { <-15.2, -6.3, 23> <-9.7, -3.1, 17> }
          box { <-9.8, -6.300001, -23.9> <-3.9, 0.000001, 23.9> }
          difference {
            box { <-9.800008, -0.000001, -7.9> <11.9, 3.1, 7.9> }
            box { <-2.400001, -1, -6.4> <10.4, 2, 6.4> }
          }
        }
        #if (setting > 1)
          box { <-8.000005, -4.9, -20> <-1, -1.4, -8> }
          box { <-8.000005, -4.9, 20> <-1, -1.4, 8> }
          box { <-15.100004, -4.9, -22> <-1, -3.399995, -18> }
          box { <-15.100004, -4.9, 22> <-1, -3.399995, 18> }
          difference {
            merge {
              cylinder { -15.1*x, -1*x, 2 translate <0, 0, -20> }
              cylinder { -15.1*x, -1*x, 2 translate <0, 0, 20> }
            }
            box { <-16, -10, -30> <0, 0, 30> }
            translate <0, -3.4, 0>
          }
          #local counter = 0;
          #while (counter < 5)
            box { <-10, -2, -2> <10, 0, 0> rotate 45*x rotate 90*z translate <-10.25, 0, -15+(counter*1.58)> }
            box { <-10, -2, -2> <10, 0, 0> rotate 45*x rotate 90*z translate <-10.25, 0, 17-(counter*1.58)> }
            #local counter = counter + 1;
          #end
        #end
        cylinder { -1*y, 4*y, 2.600005 translate <4, 0, 0> }
        box { <0, 0, -10> <10, 10, 10> rotate 40*z translate <-9.8, 0, 0> }
        difference {
          box { <-20, -6.4, -4.800001> <-3.899999, 4, 4.800001> }
          box { <-19, -10, -10> <0, 0, 0> rotate -7.5*x translate <0, 3.1, -4.8> }
          box { <-19, -10, 0> <0, 0, 10> rotate 7.5*x translate <0, 3.1, 4.8> }
        }
        box { <-10, -6.400001, -6.4> <-5.5, 4, 6.4> }
      }
      texture { color_tex }
      bounded_by { box { <-17.8, -18.2, -27> <12, 3.2, 27> } }
    }
  #end
#end
#macro train_cabine_new(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 38.3, 43.9> }
      box { <-30, 0, -10> <10, 20, 50> rotate 25*z translate <20, 38.3, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <27.8, 35.1, 16.699995> <32, 40.1, 23.300005> }
        box { <0, 0, -5> <5, 5, 5> rotate 45*z translate <27.9, 38.3, 20> }
        box { <27.900005, 30, 18.500005> <36, 45, 21.500005> }
      }
      difference {
        cylinder { -3.3*z, 3.3*z, 2.5 }
        box { <-3, -3, -1.5> <3, 3, 1.5> }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate 0*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -20*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -40*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -60*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -80*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -100*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -120*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -140*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -160*z }
        cylinder { -4*z, 4*z, 0.3 translate <0, 2.5, 0> rotate -180*z }
        translate <32, 37.6, 20>
      }
      cylinder { -3*z, -1.2*z, 1.5 translate <32, 37.6, 20> }
      cylinder { 1.2*z, 3*z, 1.5 translate <32, 37.6, 20> }
    object { open_rounded_button() translate <24, 35.2, 8> }
    object { open_rounded_button() translate <24, 35.2, 16> }
    object { open_rounded_button() translate <24, 35.2, 24> }
    object { open_rounded_button() translate <24, 35.2, 32> }
    #if (setting > 3)
      object { llogo() scale <0.65, 0.65, 0.65> translate <23, 38.3, 8> }
      object { llogo() scale <0.65, 0.65, 0.65> translate <23, 38.3, 16> }
      object { llogo() scale <0.65, 0.65, 0.65> translate <23, 38.3, 24> }
      object { llogo() scale <0.65, 0.65, 0.65> translate <23, 38.3, 32> }
    #end
    difference {
      box { <-3.9, 0, -3.9> <27.9, 38.3, 43.9> }
      #if (setting > 1)
        box { <-4, 12.8, 8.4> <-2.9, 20, 17.5> }
        box { <-4, 12.8, 22.5> <-2.9, 20, 31.6> }
        box { <-2.5, -1, -4> <3.5, 2, 4> rotate 45*y }
        box { <-2.5, -1, -4> <3.5, 2, 4> rotate -45*y translate <0, 0, 40> }
      #end
      box { <-30, 0, -10> <10, 20, 50> rotate 25*z translate <20, 38.3, 0> }
      box { <-30, 0, -50> <20, 20, 30> rotate 43.5*z rotate -90*y translate <8, 38.3, 4> }
      box { <-30, 0, -50> <20, 20, 30> rotate -43.5*z rotate -90*y translate <8, 38.3, 36> }
      box { <-40, 0, -30> <10, 20, 30> rotate -33.5*x rotate 44*y translate <20, 38.3, 4.1> }
      box { <-40, 0, -30> <10, 20, 30> rotate 33.5*x rotate -44*y translate <20, 38.3, 36> }
      box { <0, 28, -4> <4.1, 31.8, 44> }
      box { <-20, 28.999999, -10> <0, 31.8, 0> rotate 45*y translate <12, 0, -4> }
      box { <-20, 28.999999, 0> <0, 31.8, 10> rotate -45*y translate <12, 0, 44> }
      difference {
        merge {
          box { <-20, 0, -4> <0, 25, 44> rotate -25*z translate <-4, 11.6, 0> }
          box { <-20, -10, -20> <0, 25, 0> rotate 47*y rotate -25*z translate <4, 11.6, -4> }
          box { <-20, -10, 0> <0, 25, 20> rotate -47*y rotate -25*z translate <4, 11.6, 44> }
        }
        box { <-4, 29.000001, -4> <20, 35, 44> }
      }
      box { <-4, -1, 3.9> <28, 9.6, 36.1> }
      box { <-20, -1, -10> <0, 16, 0> rotate 45*y translate <4, 0, -4> }
      box { <-20, -1, 0> <0, 16, 10> rotate -45*y translate <4, 0, 44> }
      difference {
        box { <-2.6, -1, -2.6> <28, 37, 42.6> }
        box { <24.3, 36.8, 14> <28, 38, 26> }
        box { <26.4, 35.1, 15.7> <28, 38, 24.3> }
        box { <26.400001, 0, -5> <28.000001, 5, 0> rotate 45*x translate <0, 35.1, 15.7> }
        box { <26.400001, 0, 0> <28.000001, 5, 5> rotate -45*x translate <0, 35.1, 24.3> }
        box { <-30, 0, -10> <10, 20, 50> rotate 25*z translate <20, 36.3, 0> }
        box { <-30, 0, -50> <20, 20, 30> rotate 43.5*z rotate -90*y translate <8, 36.3, 4> }
        box { <-30, 0, -50> <20, 20, 30> rotate -43.5*z rotate -90*y translate <8, 36.3, 36> }
        box { <-40, 0, -30> <10, 20, 30> rotate -33.5*x rotate 44*y translate <20, 36.3, 4.1> }
        box { <-40, 0, -30> <10, 20, 30> rotate 33.5*x rotate -44*y translate <20, 36.3, 36> }
        box { <-20, -1, -10> <0, 16, 0> rotate 45*y translate <6, 0, -4> }
        box { <-20, -1, 0> <0, 16, 10> rotate -45*y translate <6, 0, 44> }
        difference {
          merge {
            box { <-20, 0, -4> <0, 25, 44> rotate -25*z translate <-2, 11.6, 0> }
            box { <-20, -10, -20> <0, 25, 0> rotate 47*y rotate -25*z translate <6, 11.6, -4> }
            box { <-20, -10, 0> <0, 25, 20> rotate -47*y rotate -25*z translate <6, 11.6, 44> }
          }
          box { <-4, 14.8, -4> <20, 35, 44> }
        }
        difference {
          merge {
            cylinder { 11.6*y, 31.1*y, 1 translate <26.9, 0, -1.4> }
            cylinder { 11.6*y, 31.1*y, 1 translate <26.9, 0, 41.4> }
            box { <0, 11.600001, -4> <27.899999, 31.100001, -1.4> }
            box { <0, 11.600002, -4> <26.9, 31.100002, -0.4> }
            box { <0, 11.600001, 40.4> <27.899999, 31.100001, 44> }
            box { <0, 11.600002, 41.4> <26.9, 31.100002, 44> }
          }
          box { <-4, 12.7, -4> <28, 30, 44> }
        }
      }
      box { <-4, 28, -4> <11.500001, 28.999999, 44> }
      cylinder { -4*z, 44*z, 0.5 translate <11.25, 28.5, 0> }
      box { <-1, -14.5, -4> <0.5, 0, 44> rotate -25*z translate <11.25, 28.5, 0> }
      cylinder { -4*z, 44*z, 0.5 translate <5, 15.3, 0> }
      box { <-4, 14.799999, -4> <5.25, 20, 44> }
      cylinder { -4*z, 44*z, 1 translate <12, 15.8, 0> }
      cylinder { -4*z, 44*z, 1 translate <23.9, 15.8, 0> }
      cylinder { -4*z, 44*z, 1 translate <15, 28, 0> }
      cylinder { -4*z, 44*z, 1 translate <23.9, 28, 0> }
      box { <15, 27, -4> <23.9, 29, 44> }
      box { <12, 14.8, -4> <23.9, 15.8, 44> }
      box { <15, 15.799999, -4> <24.9, 28.000001, 44> }
      difference {
        box { <-1, -13, -4> <4, 0, 44> rotate -14.5*z translate <15, 28, 0> }
        box { <-4, 0, -5> <20, 14.799999, 45> }
      }
      difference {
        box { <0, -2, 0> <2, 0, 44> }
        cylinder { -4*z, 44*z, 1 }
        translate <26.9, 1, 0>
      }
    }
    texture { color_tex }
    bounded_by { box { <-4, -0.1, -4> <34.6, 40.1, 44> } }
  }
  #end
#end
#macro train_cabine_new_glass(color_tex)
  #if (setting = 0)
    box { <-1, 12.8, -2.5> <27.8, 29.9, 42.5> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-1, 12.8, -2.5> <27.8, 29.9, 42.5> }
        difference {
          merge {
            box { <-20, 0, -4> <0, 25, 44> rotate -25*z translate <-3, 11.6, 0> }
            box { <-20, -10, -20> <0, 25, 0> rotate 47*y rotate -25*z translate <5, 11.6, -4> }
            box { <-20, -10, 0> <0, 25, 20> rotate -47*y rotate -25*z translate <5, 11.6, 44> }
          }
        }
        difference {
          box { <0, 12, -1.4> <28, 30, 41.4> }
          merge {
            box { <-20, 0, -4> <0, 25, 44> rotate -25*z translate <-0.5, 11.6, 0> }
            box { <-20, -10, -20> <0, 25, 0> rotate 47*y rotate -25*z translate <7.5, 11.6, -4> }
            box { <-20, -10, 0> <0, 25, 20> rotate -47*y rotate -25*z translate <7.5, 11.6, 44> }
          }
        }
        box { <-10, 12, 0> <-0.1, 14.8, 40> }
        box { <-10, 12, -10> <10, 14.800001, 0> rotate 45*y translate <-0.1, 0, 4> }
        box { <-10, 12, 0> <10, 14.800001, 10> rotate -45*y translate <-0.1, 0, 36> }
        box { <-10, 32, 0> <6.1, 28.1, 40> }
        box { <-10, 32, -10> <10, 28.100001, 0> rotate 45*y translate <6.1, 0, 4> }
        box { <-10, 32, 0> <10, 28.100001, 10> rotate -45*y translate <6.1, 0, 36> }
      }
      difference {
        merge {
          cylinder { -3.5*z, 43.5*z, 0.9 translate <12, 15.8, 0> }
          cylinder { -3.5*z, 43.5*z, 0.9 translate <23.9, 15.8, 0> }
          cylinder { -3.5*z, 43.5*z, 0.9 translate <15, 28, 0> }
          cylinder { -3.5*z, 43.5*z, 0.9 translate <23.9, 28, 0> }
          box { <15, 27.1, -3.500001> <23.9, 28.9, 43.500001> }
          box { <12, 14.9, -3.500002> <23.8, 16.9, 43.500002> }
          box { <15, 15.799999, -3.500003> <24.8, 28.000001, 43.500003> }
          difference {
            box { <-0.9, -13, -3.500004> <4, 0, 43.500004> rotate -14.5*z translate <15, 28, 0> }
            box { <-4, 0, -5> <20, 14.899999, 45> }
          }
        }
        box { <-4, 0, -2> <28, 30, 42> }
      }
      box { <-0.100001, 11.6, 8> <1.2, 14.5, 32> }
      box { <-0.100002, 9.6, 18.6> <1.200001, 12, 21.4> }
      texture { color_tex }
      bounded_by { box { <-1.1, 9.5, -4> <27.9, 30, 44> } }
    }
  #end
#end
#macro train_cabine_old(color_tex, color2_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 51.1, 43.9> }
      box { <-20, -1, -20> <0, 60, 0> rotate 45*y translate <4, 0, -4> }
      box { <-20, -1, 0> <0, 60, 20> rotate -45*y translate <4, 0, 44> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 51.1, 43.9> }
        box { <-20, -1, -20> <0, 60, 0> rotate 45*y translate <4, 0, -4> }
        box { <-20, -1, 0> <0, 60, 20> rotate -45*y translate <4, 0, 44> }
        box { <-4, -1, 3.7> <12, 28.8, 36.1> }
        box { <-4, -1, -2.4> <10.4, 2, 2.4> }
        box { <-4, -1, 37.6> <10.4, 2, 42.4> }
        box { <-4, 47.9, 3.7> <12, 51.2, 36.1> }
        box { <-2.4, 25, 3.700001> <2.4, 30.8, 36.099999> }
        box { <3.900001, -1, 3.700002> <12, 60, 36.099998> }
        box { <-2.4, 46, 3.700001> <2.4, 60, 36.099999> }
        box { <3.9, 46, -3> <10.4, 60, 3> }
        box { <3.9, 46, 37> <10.4, 60, 43> }
        box { <3.899999, 47.9, -4> <12, 60, 44> }
        cylinder { -4*x, 12*x, 1 translate <0, 33, 5> }
        cylinder { -4*x, 12*x, 1 translate <0, 33, 17> }
        cylinder { -4*x, 12*x, 1 translate <0, 33, 23> }
        cylinder { -4*x, 12*x, 1 translate <0, 33, 35> }
        cylinder { -4*x, 12*x, 1 translate <0, 43.8, 5> }
        cylinder { -4*x, 12*x, 1 translate <0, 43.8, 17> }
        cylinder { -4*x, 12*x, 1 translate <0, 43.8, 23> }
        cylinder { -4*x, 12*x, 1 translate <0, 43.8, 35> }
        cylinder { -4*x, 12*x, 1 translate <0, 33, 1> }
        cylinder { -4*x, 12*x, 1 translate <0, 43.8, 1> }
        cylinder { -4*x, 12*x, 1 translate <0, 33, 39> }
        cylinder { -4*x, 12*x, 1 translate <0, 43.8, 39> }
        cylinder { -4*z, 44*z, 1 translate <8.9, 33, 0> }
        cylinder { -4*z, 44*z, 1 translate <8.9, 43.8, 0> }
        box { <-4, 32, 5> <12, 44.8, 17> }
        box { <-4, 32, 23> <12, 44.8, 35> }
        box { <-4, 33, 4> <12, 43.8, 18> }
        box { <-4, 33, 22> <12, 43.8, 36> }
        box { <-4, 32, -4> <5, 44.8, 1> }
        box { <-4, 33, -4> <5.000001, 43.8, 2> }
        box { <-4, 32, 39> <5, 44.8, 44> }
        box { <-4, 33, 38> <5.000001, 43.8, 44> }
        box { <4, 32.000001, -4> <8.9, 44.800001, 44> }
        box { <4, 33, -4> <9.900006, 43.8, 44> }
        difference {
          box { <-2.4, 46, -2.4> <2.4, 60, 42.4> }
          box { <-4, 45, 2.4> <4, 61, 37.6> }
          box { <-20, 45, -20> <0, 60, 1.1> rotate 45*y translate <4, 0, -4> }
          box { <-20, 45, -1.1> <0, 60, 20> rotate -45*y translate <4, 0, 44> }
        }
        difference {
          box { <-2.4, 3.100001, -2.4> <12, 44.700001, 42.4> }
          box { <-20, 2, -20> <0, 45, 1.1> rotate 45*y translate <4, 0, -4> }
          box { <-20, 2, -1.1> <0, 45, 20> rotate -45*y translate <4, 0, 44> }
          box { <-2.5, 28.799999, -4> <3.900005, 31.999999, 44> }
          box { <-4, 2, 2.7> <3.9, 29, 3.900004> }
          box { <-4, 2, 36.100004> <3.9, 29, 37.3> }
          box { <-4, 30.7, -4> <13, 32.000007, 4> }
          box { <-4, 30.7, 36> <13, 32.000007, 44> }
        }
      }
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
        object { pin(1) translate <4, 0, 40> }
        object { pin(1) translate <0, 28.8, 12> }
        object { pin(1) translate <0, 28.8, 20> }
        object { pin(1) translate <0, 28.8, 28> }
        box { <-0.5, 28.8, 3.8> <0.5, 30.9, 5.6> }
        box { <-0.5, 28.8, 36.2> <0.5, 30.9, 34.4> }
      #end
      object { open_rounded_button() translate <0, 45, 8> }
      object { open_rounded_button() translate <0, 45, 16> }
      object { open_rounded_button() translate <0, 45, 24> }
      object { open_rounded_button() translate <0, 45, 32> }
      object { open_rounded_button() translate <8, 45, 0> }
      object { open_rounded_button() translate <8, 45, 40> }
      difference {
        cylinder { 45.9*y, 48.000001*y, 2.4 }
        cylinder { 45*y, 50*y, 1.600001 }
        translate <0, 0, 8>
      }
      difference {
        cylinder { 45.9*y, 48.000001*y, 2.4 }
        cylinder { 45*y, 50*y, 1.600001 }
        translate <0, 0, 16>
      }
      difference {
        cylinder { 45.9*y, 48.000001*y, 2.4 }
        cylinder { 45*y, 50*y, 1.6 }
        translate <0, 0, 24>
      }
      difference {
        cylinder { 45.9*y, 48.000001*y, 2.4 }
        cylinder { 45*y, 50*y, 1.6 }
        translate <0, 0, 32>
      }
      difference {
        cylinder { 45.9*y, 48.000001*y, 2.4 }
        cylinder { 45*y, 50*y, 1.6 }
        translate <8, 0, 0>
      }
      difference {
        cylinder { 45.9*y, 48.000001*y, 2.4 }
        cylinder { 45*y, 50*y, 1.6 }
        translate <8, 0, 40>
      }
      difference {
        merge {
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 33, 1> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 43.8, 1> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 33, 39> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 43.8, 39> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 33, 5> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 33, 17> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 33, 23> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 33, 35> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 43.8, 5> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 43.8, 17> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 43.8, 23> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 43.8, 35> }
          box { <-3.900001, 32, 5.000001> <8.900001, 44.8, 17.000001> }
          box { <-3.900002, 33, 4.000001> <8.900002, 43.8, 18.000001> }
          box { <-3.900001, 32, 23.000001> <8.900001, 44.8, 35.000001> }
          box { <-3.900002, 33, 22.000001> <8.900002, 43.8, 36.000001> }
          box { <-2.9, 32, -4> <8.900003, 44.8, 44> }
          cylinder { -3.9*z, 43.9*z, 1 translate <8.9, 33, 0> }
          cylinder { -3.9*z, 43.9*z, 1 translate <8.9, 43.8, 0> }
          box { <8.8, 33, -3.900008> <9.9, 43.8, 43.900008> }
        }
        box { <-20, -1, -20> <0, 60, 0.000001> rotate 45*y translate <4, 0, -4> }
        box { <-20, -1, 0.000001> <0, 60, 20> rotate -45*y translate <4, 0, 44> }
        difference {
          box { <-5, 31, 37> <0, 45.8, 39> }
          cylinder { -4*x, 0*x, 1 translate <0, 33, 39> }
          cylinder { -4*x, 0*x, 1 translate <0, 43.8, 39> }
          box { <-4, 33, 38> <0, 43.8, 40> }
        }
        difference {
          box { <-1.900007, 30, -2.4> <12, 45, 42.4> }
          box { <-20, -1, -20> <0, 60, 1.100001> rotate 45*y translate <4, 0, -4> }
          box { <-20, -1, -1.100001> <0, 60, 20> rotate -45*y translate <4, 0, 44> }
        }
        box { <-2.9, 33.6, 5.1> <0, 43.2, 16.9> }
        box { <-2.9, 33.6, 23.1> <0, 43.2, 34.9> }
        texture { color2_tex } interior { ior 1.5 }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 51.2, 44> } }
    }
  #end
#end
#macro train_cabine_old2(color_tex, color2_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 51.1, 43.9> }
      box { <-20, -1, -20> <0, 60, 0> rotate 45*y translate <4, 0, -4> }
      box { <-20, -1, 0> <0, 60, 20> rotate -45*y translate <4, 0, 44> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 51.1, 43.9> }
        box { <-20, -1, -20> <0, 60, 0> rotate 45*y translate <4, 0, -4> }
        box { <-20, -1, 0> <0, 60, 20> rotate -45*y translate <4, 0, 44> }
        box { <-4, -1, 3.7> <12, 19.2, 36.1> }
        box { <-4, -1, -2.4> <10.4, 2, 2.4> }
        box { <-4, -1, 37.6> <10.4, 2, 42.4> }
        box { <-4, 47.9, 3.7> <12, 51.2, 36.1> }
        box { <-2.4, 15, 3.70001> <2.4, 21.2, 36.09999> }
        box { <3.90001, -1, 3.70002> <12, 60, 36.09998> }
        box { <-2.4, 46, 3.70001> <2.4, 60, 36.09999> }
        box { <3.9, 46, -3> <10.4, 60, 3> }
        box { <3.9, 46, 37> <10.4, 60, 43> }
        box { <3.89999, 47.9, -4> <12, 60, 44> }
        cylinder { -4*x, 12*x, 1 translate <0, 33, 5> }
        cylinder { -4*x, 12*x, 1 translate <0, 33, 17> }
        cylinder { -4*x, 12*x, 1 translate <0, 33, 23> }
        cylinder { -4*x, 12*x, 1 translate <0, 33, 35> }
        cylinder { -4*x, 12*x, 1 translate <0, 43.8, 5> }
        cylinder { -4*x, 12*x, 1 translate <0, 43.8, 17> }
        cylinder { -4*x, 12*x, 1 translate <0, 43.8, 23> }
        cylinder { -4*x, 12*x, 1 translate <0, 43.8, 35> }
        cylinder { -4*x, 12*x, 1 translate <0, 33, 1> }
        cylinder { -4*x, 12*x, 1 translate <0, 43.8, 1> }
        cylinder { -4*x, 12*x, 1 translate <0, 33, 39> }
        cylinder { -4*x, 12*x, 1 translate <0, 43.8, 39> }
        cylinder { -4*z, 44*z, 1 translate <8.9, 33, 0> }
        cylinder { -4*z, 44*z, 1 translate <8.9, 43.8, 0> }
        box { <-4, 32, 5> <12, 44.8, 17> }
        box { <-4, 32, 23> <12, 44.8, 35> }
        box { <-4, 33, 4> <12, 43.8, 18> }
        box { <-4, 33, 22> <12, 43.8, 36> }
        box { <-4, 32, -4> <5, 44.8, 1> }
        box { <-4, 33, -4> <5.00001, 43.8, 2> }
        box { <-4, 32, 39> <5, 44.8, 44> }
        box { <-4, 33, 38> <5.00001, 43.8, 44> }
        box { <4, 32.00001, -4> <8.9, 44.80001, 44> }
        box { <4, 33, -4> <9.90006, 43.8, 44> }
        difference {
          box { <-2.4, 46, -2.4> <2.4, 60, 42.4> }
          box { <-4, 45, 2.4> <4, 61, 37.6> }
          box { <-20, 45, -20> <0, 60, 1.1> rotate 45*y translate <4, 0, -4> }
          box { <-20, 45, -1.1> <0, 60, 20> rotate -45*y translate <4, 0, 44> }
        }
        difference {
          box { <-2.4, 3.10001, -2.4> <12, 44.70001, 42.4> }
          box { <-20, 2, -20> <0, 45, 1.1> rotate 45*y translate <4, 0, -4> }
          box { <-20, 2, -1.1> <0, 45, 20> rotate -45*y translate <4, 0, 44> }
          box { <-2.5, 19.19999, 3> <3.90005, 22.39999, 37> }
          box { <-4, 30.70001, 3> <3.9, 32.00009, 37> }
          box { <-4, 2, 2.7> <3.9, 32, 3.90004> }
          box { <-4, 2, 36.10004> <3.9, 32, 37.3> }
          box { <-4, 30.7, -4> <13, 32.00007, 4> }
          box { <-4, 30.7, 36> <13, 32.00007, 44> }
        }
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <4, 0, 40> }
        object { pin(2) translate <0, 19.2, 12> }
        object { pin(2) translate <0, 19.2, 20> }
        object { pin(2) translate <0, 19.2, 28> }
        box { <-0.5, 19.2, 3.8> <0.5, 21.3, 5.6> }
        box { <-0.5, 19.2, 36.2> <0.5, 21.3, 34.4> }
      #end
      object { open_rounded_button() translate <0, 45, 8> }
      object { open_rounded_button() translate <0, 45, 16> }
      object { open_rounded_button() translate <0, 45, 24> }
      object { open_rounded_button() translate <0, 45, 32> }
      object { open_rounded_button() translate <8, 45, 0> }
      object { open_rounded_button() translate <8, 45, 40> }
      difference {
        cylinder { 45.9*y, 48.000001*y, 2.4 }
        cylinder { 45*y, 50*y, 1.600001 }
        translate <0, 0, 8>
      }
      difference {
        cylinder { 45.9*y, 48.000001*y, 2.4 }
        cylinder { 45*y, 50*y, 1.600001 }
        translate <0, 0, 16>
      }
      difference {
        cylinder { 45.9*y, 48.000001*y, 2.4 }
        cylinder { 45*y, 50*y, 1.6 }
        translate <0, 0, 24>
      }
      difference {
        cylinder { 45.9*y, 48.000001*y, 2.4 }
        cylinder { 45*y, 50*y, 1.6 }
        translate <0, 0, 32>
      }
      difference {
        cylinder { 45.9*y, 48.000001*y, 2.4 }
        cylinder { 45*y, 50*y, 1.6 }
        translate <8, 0, 0>
      }
      difference {
        cylinder { 45.9*y, 48.000001*y, 2.4 }
        cylinder { 45*y, 50*y, 1.6 }
        translate <8, 0, 40>
      }
      difference {
        merge {
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 33, 1> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 43.8, 1> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 33, 39> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 43.8, 39> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 33, 5> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 33, 17> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 33, 23> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 33, 35> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 43.8, 5> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 43.8, 17> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 43.8, 23> }
          cylinder { -3.9*x, 8.9*x, 1 translate <0, 43.8, 35> }
          box { <-3.900001, 32, 5.000001> <8.900001, 44.8, 17.000001> }
          box { <-3.900002, 33, 4.000001> <8.900002, 43.8, 18.000001> }
          box { <-3.900001, 32, 23.000001> <8.900001, 44.8, 35.000001> }
          box { <-3.900002, 33, 22.000001> <8.900002, 43.8, 36.000001> }
          box { <-2.9, 32, -4> <8.900003, 44.8, 44> }
          cylinder { -3.9*z, 43.9*z, 1 translate <8.9, 33, 0> }
          cylinder { -3.9*z, 43.9*z, 1 translate <8.9, 43.8, 0> }
          box { <8.8, 33, -3.900008> <9.9, 43.8, 43.900008> }
        }
        box { <-20, -1, -20> <0, 60, 0.000001> rotate 45*y translate <4, 0, -4> }
        box { <-20, -1, 0.000001> <0, 60, 20> rotate -45*y translate <4, 0, 44> }
        difference {
          box { <-5, 31, 37> <0, 45.8, 39> }
          cylinder { -4*x, 0*x, 1 translate <0, 33, 39> }
          cylinder { -4*x, 0*x, 1 translate <0, 43.8, 39> }
          box { <-4, 33, 38> <0, 43.8, 40> }
        }
        difference {
          box { <-1.900007, 30, -2.4> <12, 45, 42.4> }
          box { <-20, -1, -20> <0, 60, 1.100001> rotate 45*y translate <4, 0, -4> }
          box { <-20, -1, -1.100001> <0, 60, 20> rotate -45*y translate <4, 0, 44> }
        }
        box { <-2.9, 33.6, 5.1> <0, 43.2, 16.9> }
        box { <-2.9, 33.6, 23.1> <0, 43.2, 34.9> }
        texture { color2_tex } interior { ior 1.5 }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 51.2, 44> } }
    }
  #end
#end
#macro train_cabine_window(color_tex, color2_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 19.1, 43.9> }
      box { <-60, 0, -10> <60, 50, 50> rotate 63.75*z translate <4, 19.1, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 3.100007, -3.899999> <11.899999, 18.2, 43.899999> }
        box { <-60, 0, -10> <60, 50, 50> rotate 63.75*z translate <4.000001, 19.1, 0> }
        difference {
          box { <-2.8, 0, -1.3> <12, 18.200001, 41.3> }
          box { <-60, 0, -10> <60, 50, 50> rotate 63.75*z translate <7, 19.1, 0> }
        }
        difference {
          box { <-2.8, 4.1, -1.300001> <12, 15, 41.300001> }
          box { <-10, 0, 18> <20, 20, 22> }
          box { <-60, 0, -10> <60, 50, 50> rotate 63.75*z translate <5.9, 19.1, 0> }
        }
        texture { color2_tex } interior { ior 1.5 }
      }
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 19.1, 43.9> }
            box { <-60, 0, -10> <60, 50, 50> rotate 63.75*z translate <4, 19.1, 0> }
          }
          object { open_rounded_button() translate <8, 16, 0> }
          object { open_rounded_button() translate <8, 16, 40> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <8, 19.1, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <8, 19.1, 40> }
          #end
        }
        cylinder { -4*z, 44*z, 1 translate <9.4, 4.1, 0> }
        cylinder { -4*z, 44*z, 1 translate <9.4, 15, 0> }
        cylinder { -4*z, 44*z, 1 translate <4.6, 15, 0> }
        cylinder { -4*z, 44*z, 1.5 translate <0, 4.6, 0> }
        box { <4, 4.1, -4> <10.4, 15, 44> }
        box { <4.6, 14, -4> <9.4, 16, 44> }
        box { <0, 3.100001, -4> <9.4, 6, 44> }
        box { <-1.5, 0, -4> <3.5, 11.5, 44> rotate -26.25*z translate <0, 4.6, 0> }
        difference {
          box { <6.6, 18.199999, 0> <12, 20, 40> }
          cylinder { 18*y, 21*y, 4 translate <8, 0, 0> }
          box { <4, 18, -1> <8.000001, 21, 4> }
          box { <4, 18, -1> <8.000001, 21, 4> }
          cylinder { 18*y, 21*y, 4 translate <8, 0, 40> }
        }
        difference {
          box { <-2.4, 3.1, -2.4> <12, 18.2, 42.4> }
          box { <-60, 0, -10> <60, 50, 50> rotate 63.75*z translate <4, 17.1, 0> }
        }
        cylinder { -1*y, 4*y, 3.8 translate <11.9, 0, 3.9> }
        cylinder { -1*y, 4*y, 3.8 translate <11.9, 0, 36.1> }
        #if (setting > 1)
          box { <3.9, -1, 3.9> <12, 4, 36.1> }
          box { <-2.4, -1, -2.4> <2.4, 2, 42.4> }
          box { <0, -1, -2.400001> <10.4, 2.000001, 2.4> }
          box { <0, -1, 37.600001> <10.4, 2.000001, 42.4> }
        #end
        cylinder { -4*x, 10*x, 1 translate <0, 4.1, -1.4> }
        cylinder { -4*x, 10*x, 1 translate <0, 4.1, 18.3> }
        cylinder { -4*x, 10*x, 1 translate <0, 4.1, 21.7> }
        cylinder { -4*x, 10*x, 1 translate <0, 4.1, 41.4> }
        cylinder { -4*x, 10*x, 1 translate <0, 15, -1.4> }
        cylinder { -4*x, 10*x, 1 translate <0, 15, 18.3> }
        cylinder { -4*x, 10*x, 1 translate <0, 15, 21.7> }
        cylinder { -4*x, 10*x, 1 translate <0, 15, 41.4> }
        box { <-4, 3.100007, -1.4> <10, 16.000007, 18.3> }
        box { <-4, 4.1, -2.400007> <10, 15, 19.3> }
        box { <-4, 3.100007, 21.7> <10, 16.000007, 41.4> }
        box { <-4, 4.1, 20.7> <10, 15, 42.400007> }
      }
      object { pin(2) translate <4, 0, 0> }
      object { pin(2) translate <0, 0, 4> }
      object { pin(2) translate <0, 0, 12> }
      object { pin(2) translate <0, 0, 20> }
      object { pin(2) translate <0, 0, 28> }
      object { pin(2) translate <0, 0, 36> }
      object { pin(2) translate <4, 0, 40> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 20.9, 44> } }
    }
  #end
#end
#macro train_cargo_door(color_tex)
  #if (setting = 0)
    box { <0, 0, 0.1> <57.4, 46.6, 2.1> texture { color_tex } }
  #else
    difference {
      merge {
        box { <0, 0, 0.1> <57.4, 46.6, 2.1> }
        cylinder { 0.000001*y, 46.600001*y, 1.4 translate <1.4, 0, -0.7> }
        box { <0.000001, 0.000002, -0.7> <2.8, 46.000002, 0.2> }
        sphere { <56.8, 23.3, 0.1> 0.5 }
      }
      sphere { <55.2, 23.3, 0.1> 0.6 }
      box { <-1, 45.4, -3> <58, 48, -1> }
      box { <-1, 45.4, 3> <58, 48, 1> }
      box { <-1, -1, -3> <58, 1.2, -1> }
      box { <-1, -1, 3> <58, 1.2, 1> }
      cylinder { -2*z, 0.6*z, 0.5 translate <4.5, 5.1, 0> }
      cylinder { -2*z, 0.6*z, 0.5 translate <4.5, 15.8, 0> }
      cylinder { -2*z, 0.6*z, 0.5 translate <4.5, 18, 0> }
      cylinder { -2*z, 0.6*z, 0.5 translate <4.5, 28.7, 0> }
      cylinder { -2*z, 0.6*z, 0.5 translate <4.5, 30.9, 0> }
      cylinder { -2*z, 0.6*z, 0.5 translate <4.5, 41.5, 0> }
      cylinder { -2*z, 0.6*z, 0.5 translate <52.5, 5.1, 0> }
      cylinder { -2*z, 0.6*z, 0.5 translate <52.5, 15.8, 0> }
      cylinder { -2*z, 0.6*z, 0.5 translate <52.5, 18, 0> }
      cylinder { -2*z, 0.6*z, 0.5 translate <52.5, 28.7, 0> }
      cylinder { -2*z, 0.6*z, 0.5 translate <52.5, 30.9, 0> }
      cylinder { -2*z, 0.6*z, 0.5 translate <52.5, 41.5, 0> }
      box { <53.5, 4.6, -2> <56.9, 18.5, 0.3> }
      box { <53.5, 28, -2> <56.9, 42.1, 0.3> }
      box { <4.5, 4.6, -2> <52.5, 16.3, 0.600001> }
      box { <4, 5.1, -2> <53, 15.8, 0.600002> }
      box { <4.5, 17.5, -2> <52.5, 29.2, 0.600001> }
      box { <4, 18, -2> <53, 28.7, 0.600002> }
      box { <4.5, 30.4, -2> <52.5, 42.1, 0.600001> }
      box { <4, 30.9, -2> <53, 41.5, 0.600002> }
      cylinder { 1.6*z, 3*z, 0.5 translate <1.5, 5.1, 0> }
      cylinder { 1.6*z, 3*z, 0.5 translate <1.5, 15.8, 0> }
      cylinder { 1.6*z, 3*z, 0.5 translate <1.5, 18, 0> }
      cylinder { 1.6*z, 3*z, 0.5 translate <1.5, 28.7, 0> }
      cylinder { 1.6*z, 3*z, 0.5 translate <1.5, 30.9, 0> }
      cylinder { 1.6*z, 3*z, 0.5 translate <1.5, 41.5, 0> }
      cylinder { 1.6*z, 3*z, 0.5 translate <55.9, 5.1, 0> }
      cylinder { 1.6*z, 3*z, 0.5 translate <55.9, 15.8, 0> }
      cylinder { 1.6*z, 3*z, 0.5 translate <55.9, 18, 0> }
      cylinder { 1.6*z, 3*z, 0.5 translate <55.9, 28.7, 0> }
      cylinder { 1.6*z, 3*z, 0.5 translate <55.9, 30.9, 0> }
      cylinder { 1.6*z, 3*z, 0.5 translate <55.9, 41.5, 0> }
      box { <1.5, 4.6, 3> <55.9, 16.3, 1.600001> }
      box { <1, 5.1, 3> <56.4, 15.8, 1.600002> }
      box { <1.5, 17.5, 3> <55.9, 29.2, 1.600001> }
      box { <1, 18, 3> <56.4, 28.7, 1.600002> }
      box { <1.5, 30.4, 3> <55.9, 42.1, 1.600001> }
      box { <1, 30.9, 3> <56.4, 41.5, 1.600002> }
      bounded_by { box { <-0.1, -0.1, -2.2> <57.5, 46.7, 2.2> } }
      texture { color_tex }
    }
  #end
#end
#macro train_cargo_door2(color_tex)
  #if (setting = 0)
    box { <0, 0, 0.1> <51.7, 49.7, 1.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <0, 0, 0.1> <51.7, 1.9, 1.9> }
          box { <0, 47.8, 0.1> <51.7, 49.7, 1.9> }
          box { <0.000001, 1, 0.5> <51.6999999, 49, 1.5> }
          box { <48.6, 1, 0.3> <51.6999998, 49, 1.7> }
          box { <42.1, 1, 0.3> <45.2, 49, 1.7> }
          box { <35.6, 1, 0.3> <38.7, 49, 1.7> }
          box { <29.1, 1, 0.3> <32.2, 49, 1.7> }
          box { <22.6, 1, 0.3> <25.7, 49, 1.7> }
          box { <16.1, 1, 0.3> <19.2, 49, 1.7> }
          box { <9.6, 1, 0.3> <12.7, 49, 1.7> }
          box { <3.1, 1, 0.3> <6.2, 49, 1.7> }
          box { <0.000002, 1, 1> <3.099999, 4.8, 1.900005> }
          box { <0.000002, 45, 1> <3.099999, 49, 1.900005> }
          #if (setting > 1)
            sphere { <0, 0, 0> 1 scale <1, 1, 0.5> translate <1.5, 3.3, 1.9> }
            sphere { <0, 0, 0> 1 scale <1, 1, 0.5> translate <1.5, 46.5, 1.9> }
            box { <8, 3.2, 1> <9.4, 6.1, 3.3> }
            box { <8, 43.6, 1> <9.4, 46.5, 3.3> }
          #end
        }
        sphere { <0, 0, 0> 1 scale <1, 1, 0.5> translate <1.5, 23, 1> }
        difference {
          box { <0, 17, -4> <3.8, 32.5, 1> }
          cylinder { -5*z, 2*z, 3 translate <3, 32.5, 0> }
          cylinder { -5*z, 2*z, 3 translate <3, 17, 0> }
        }
      }
      intersection {
        torus { 1.5, 1.5 }
        box { <-0.000001, -2, -4> <4, 2, 0.000001> }
        rotate -90*x
        translate <3, 20, -0.9>
      }
      intersection {
        torus { 1.5, 1.5 }
        box { <-0.000001, -2, -0.000001> <4, 2, 4> }
        rotate -90*x
        translate <3, 30, -0.9>
      }
      intersection {
        torus { 1.5, 1.5 }
        box { <-4, -2, -0.000001> <0.000001, 2, 4> }
        rotate -90*x
        translate <3, 17, -0.9>
      }
      intersection {
        torus { 1.5, 1.5 }
        box { <-4, -2, -4> <0.000001, 2, 0.000001> }
        rotate -90*x
        translate <3, 33, -0.9>
      }
      cylinder { 19.999999*y, 30.000001*y, 1.5 translate <4.5, 0, -0.9> }
      cylinder { 2.05*y, 17.000005*y, 1.5 translate <1.5, 0, -0.9> }
      cylinder { 1.9*y, 3*y, 1.35 translate <1.5, 0, -0.9> }
      cylinder { 46*y, 47.8*y, 1.35 translate <1.5, 0, -0.9> }
      torus { 1.35, 0.15 translate <1.5, 2.05, -0.9> }
      cylinder { 32.999999*y, 47.65*y, 1.5 translate <1.5, 0, -0.9> }
      torus { 1.35, 0.15 translate <1.5, 47.65, -0.9> }
      cylinder { -0.9*z, 1*z, 0.15 translate <0.15, 2.05, 0> }
      cylinder { -0.9*z, 1*z, 0.15 translate <2.85, 2.05, 0> }
      cylinder { -0.9*z, 1*z, 0.15 translate <0.15, 47.65, 0> }
      cylinder { -0.9*z, 1*z, 0.15 translate <2.85, 47.65, 0> }
      box { <0.15, 1.9, -0.9> <2.85, 2.05, 1> }
      box { <0.000005, 2.0499999, -0.9> <2.999995, 17.000005, 1> }
      box { <0.15, 47.65, -0.9> <2.85, 47.8, 1> }
      box { <0.000005, 32.999995, -0.9> <2.999995, 47.650005, 1> }
      intersection {
        cylinder { 0.000002*y, -2*y, 3 }
        box { <-4, 0.000006, -0.000001> <0.000001, -2.000005, 4> }
        rotate -90*x
        translate <3, 17, -0.9>
      }
      intersection {
        cylinder { 0.000003*y, -2*y, 3 }
        box { <-0.000001, 0.000007, -4> <4, -2.000005, 0.000001> }
        rotate -90*x
        translate <3, 20, -0.9>
      }
      intersection {
        cylinder { 0.000004*y, -2*y, 3 }
        box { <-0.000001, 0.000008, -0.000001> <4, -2.000005, 4> }
        rotate -90*x
        translate <3, 30, -0.9>
      }
      intersection {
        cylinder { 0.000007*y, -2*y, 3 }
        box { <-4, 0.000009, -4> <0.000001, -2.000005, 0.000001> }
        rotate -90*x
        translate <3, 33, -0.9>
      }
      box { <-2, 25.3, -0.5> <5, 28.3, 1.000005> }
      cylinder { -0.5*z, 1.000006*z, 1.5 translate <-2, 26.8, 0> }
      sphere { <0, 0, 0> 1 scale <1, 1, 0.5> translate <-2, 26.8, 1> }
      box { <3.000005, 19.999995, -0.9> <5.999995, 30.000005, 1> }
      #if (setting > 3)
        object { llogo() rotate -90*x translate <14.5, 25, 0.5> }
      #end
      bounded_by { box { <-3.6, -0.1, -2.5> <51.8, 49.8, 3.4> } }
      texture { color_tex }
    }
  #end
#end
#macro train_coupling(color_tex)
  #if (setting = 0)
    box { <-15.4, -2.05, -7.9> <3.5, 5.15, 7.9> texture { color_tex } }
  #else
    difference {
      merge {
        torus { 2.249995, 0.3 translate <0, -6.8, 0> }
        cylinder { 0.1*y, -7.1*y, 2.25 }
        cylinder { 0*y, 3.1*y, 3.5 }
        box { <-4.1, 0.000001, -3.500001> <0, 3.100001, 3.500001> }
        difference {
          box { <-15.5, -2.05, -7.9> <0, 5.15, 7.9> }
          box { <-6, 3.100002, -8> <1, 6, 8> }
          box { <-6, -3, -8> <1, 0.000002, 8> }
          box { <-10, 0, -10> <0, 10, 10> rotate -12.5*z translate <-6, 3.1, 0> }
          box { <-10, -10, -10> <0, 0, 10> rotate 12.5*z translate <-6, 0, 0> }
          difference {
            cylinder { -10*y, 10*y, 12 translate <-17, 0, 0> }
            box { <-50, -11, -6.3> <50, 11, -20> }
            box { <-50, -11, 6.3> <50, 11, 20> }
          }
          difference {
            box { <-6, -11, -10> <20, 11, 10> }
            cylinder { -10*y, 10*y, 15 translate <-17, 0, 0> }
          }
          cylinder { -8*z, 8*z, 1 translate <-12.5, 1.55, 0> }
          cylinder { -8*z, 8*z, 1 translate <-14.25, 1.55, 0> }
          box { <-16, 0.55, -8> <-14.25, 2.55, 8> }
        }
      }
      box { <-0.5, -4.8, -4> <0.5, -10, 4> }
      cylinder { -8*y, 8*y, 1.600001 }
      cylinder { 1.5*y, 4*y, 2.5 }
      box { <-1, 1.500001, -2.5> <0.000001, 4, 2.5> }
      texture { color_tex }
      bounded_by { box { <-15.5, -7.2, -8> <3.6, 5.25, 8> } }
    }
  #end
#end
#macro train_coupling_old(color_tex)
  #if (setting = 0)
    merge {
      box { <-15.4, -2.05, -7.9> <3.5, 5.15, 7.9> }
      cylinder { -8*y, 10*y, 1.6 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        torus { 2.249995, 0.3 translate <0, -6.8, 0> }
        cylinder { 0.1*y, -7.1*y, 2.25 }
        cylinder { 0*y, 3.1*y, 3.5 }
        box { <-4.1, 0.000001, -3.500001> <0, 3.100001, 3.500001> }
        difference {
          box { <-15.5, -2.05, -7.9> <0, 5.15, 7.9> }
          box { <-6, 3.100002, -8> <1, 6, 8> }
          box { <-6, -3, -8> <1, 0.000002, 8> }
          box { <-10, 0, -10> <0, 10, 10> rotate -12.5*z translate <-6, 3.1, 0> }
          box { <-10, -10, -10> <0, 0, 10> rotate 12.5*z translate <-6, 0, 0> }
          difference {
            cylinder { -10*y, 10*y, 12 translate <-17, 0, 0> }
            box { <-50, -11, -6.3> <50, 11, -20> }
            box { <-50, -11, 6.3> <50, 11, 20> }
          }
          difference {
            box { <-6, -11, -10> <20, 11, 10> }
            cylinder { -10*y, 10*y, 15 translate <-17, 0, 0> }
          }
          cylinder { -8*z, 8*z, 1 translate <-12.5, 1.55, 0> }
          cylinder { -8*z, 8*z, 1 translate <-14.25, 1.55, 0> }
          box { <-16, 0.55, -8> <-14.25, 2.55, 8> }
        }
        difference {
          merge {
            cylinder { 3.65*y, -8.45*y, 1.55 }
            cone { -8.35*y, 1.55, -9.35*y, 2.5 }
            translate <-8, 0, -8>
          }
          box { <-10, 0, -10> <0, 10, 10> rotate -12.5*z translate <-6, 3.100001, 0> }
        }
      }
      box { <-0.5, -4.8, -4> <0.5, -10, 4> }
      cylinder { -8*y, 10*y, 1.6 }
      texture { color_tex }
      bounded_by { box { <-15.5, -9.45, -10.6> <3.6, 5.25, 8> } }
    }
  #end
#end
#macro train_cylinder_curved(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -8.6> <11.9, 3.1, 3.9> }
      box { <-3.900001, -16, -10.6> <11.900001, 3.100001, -4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -8.6> <11.9, 3.1, 3.9> }
        cylinder { -3.900001*x, 11.900001*x, 2 translate <0, 1.1, -8.6> }
        cylinder { -3.900001*x, 11.900001*x, 2 translate <0, -14, -8.6> }
        difference {
          cylinder { -3.900003*x, 11.900003*x, 4.6 }
          box { <-4, -5, -5> <12, 5, 0> }
          translate <0, -11.4, -8.6>
        }
        box { <-3.900002, -14.000001, -10.6> <11.900002, 1.100001, -8.599999> }
        box { <-3.900004, -11.200001, -8.599998> <11.900004, 1.100002, -4> }
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 }
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
        #else
          object { rounded_button() rotate 90*y }
          object { rounded_button() rotate 90*y translate <8, 0, 0> }
        #end
      }
      box { <-4, -11.9, -8> <12, -8.4, 0> }
      box { <-4, -12.1, -8.8> <12, -8.2, 0> }
      difference {
        merge {
          cylinder { -4*x, 12*x, 1.4 translate <0, 1, -8> }
          cylinder { -4*x, 12*x, 1.4 translate <0, -13, -8> }
          box { <-4, -13.000001, -9.4> <12, 1, -6.6> }
          box { <-4, -6.7, -8> <12, 1.9, -5.2> }
        }
        box { <-4, -1.3, -6> <12, -0.3, 0> }
        box { <-4, -4.4, -6> <12, -3.4, 0> }
        cylinder { -4*x, 12*x, 0.5 translate <0, -0.8, -6> }
        cylinder { -4*x, 12*x, 0.5 translate <0, -3.9, -6> }
        box { <3.5, -9.6, -12> <4.5, 0, 4> }
      }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          object { pin(1) translate <4, 0.000002, 0> }
        }
        cylinder { 1*y, 4*y, 1.2 }
        cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -16.1, -10.7> <12, 4.9, 4> } }
    }
  #end
#end
#macro train_doorleft(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 47.9, 3.9> }
      box { <4, 22, -4> <20, 44.3, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { 0*y, 47.9*y, 3.9 }
          object { open_rounded_button() translate <0, 44.8, 0> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 47.9, 0> }
          #end
          box { <0, 0.3, -3.9> <24, 47.6, 0> }
          cylinder { 0.300001*y, 47.600001*y, 3.9 translate <24, 0, 0> }
          box { <22.1, 22.1, -3.8> <24, 26.8, -5.9> }
        }
        cylinder { 45*y, 50*y, 0.800008 translate <12, 0, -1.2> }
        box { <22, 22, 0> <22.8, 26.9, -5> }
        cylinder { -4*z, 2*z, 2 translate <6, 24, 0> }
        cylinder { -4*z, 2*z, 2 translate <6, 42.3, 0> }
        cylinder { -4*z, 2*z, 2 translate <18, 24, 0> }
        cylinder { -4*z, 2*z, 2 translate <18, 42.3, 0> }
        box { <4, 24, -4> <20, 42.3, 2> }
        box { <6, 22.000001, -4> <18, 44.3, 2> }
        box { <10, 0, 4> <30, 50, -0.000001> }
        cylinder { -1*y, 2*y, 2.5 }
        cylinder { -1*y, 2.5*y, 2.7 translate <24.2, 0, 0> }
        difference {
          cylinder { 0*y, 46.7*y, 2.7 translate <24, 0, 0> }
          box { <20, 19, -10> <30, 20.5, 10> }
        }
        difference {
          box { <-0.100001, 0, 10> <24.000001, 46.700001, -2.700001> }
          box { <-1, 19.000001, 0.000002> <30, 20.500001, -10> }
          cylinder { -1*y, 1.8*y, 3.900007 }
        }
      }
      difference {
        cylinder { 46.700008*y, 47.600001*y, 1.6 translate <12, 0, -1.2> }
        cylinder { 45*y, 50*y, 0.8 translate <12, 0, -1.2> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, 4> <28, 49.7, -6> } }
    }
  #end
#end
#macro train_doorleft_glass(color_tex)
  #if (setting = 0)
    box { <4, 22, -4> <20, 44.3, 4> texture { color_tex } }
  #else
    difference {
      merge {
        box { <4.1, 20.5, -2.6> <19.9, 46.7, -0.8> }
        sphere { <8, 20.5, -1.55> 0.75 }
        sphere { <16, 20.5, -1.55> 0.75 }
        sphere { <12, 46.7, -1.55> 0.75 }
        cylinder { -3.9*z, -1*z, 1.9 translate <6, 24, 0> }
        cylinder { -3.9*z, -1*z, 1.9 translate <6, 42.3, 0> }
        cylinder { -3.9*z, -1*z, 1.9 translate <18, 24, 0> }
        cylinder { -3.9*z, -1*z, 1.9 translate <18, 42.3, 0> }
        box { <4.10001, 24.1, -3.90004> <19.89999, 42.2, -1.00004> }
        box { <6.2, 22.00001, -3.90003> <17.9, 44.2, -1.00003> }
      }
      cylinder { -2*z, 2*z, 0.9 translate <6, 24, 0> }
      cylinder { -2*z, 2*z, 0.9 translate <6, 42.3, 0> }
      cylinder { -2*z, 2*z, 0.9 translate <18, 24, 0> }
      cylinder { -2*z, 2*z, 0.9 translate <18, 42.3, 0> }
      box { <5.99999, 23.1, -2.00001> <18.00001, 43.2, 2> }
      box { <5.1, 23.99999, -2.00002> <18.9, 42.30001, 2> }
      cylinder { -5*z, -3.2*z, 0.9 translate <6, 24, 0> }
      cylinder { -5*z, -3.2*z, 0.9 translate <6, 42.3, 0> }
      cylinder { -5*z, -3.2*z, 0.9 translate <18, 24, 0> }
      cylinder { -5*z, -3.2*z, 0.9 translate <18, 42.3, 0> }
      box { <5.99999, 23.1, -5><18.00001, 34.1, -3.19999> }
      box { <5.09999, 23.99999, -5> <18.90001, 34.80001, -3.19998> }
      box { <5.99999, 38.8, -5><18.00001, 43.2, -3.19997> }
      box { <5.09999, 35.9, -5><18.90001, 42.30001, -3.19996> }
      texture { color_tex }
      bounded_by { box { <4, 19.65, -4> <20, 47.55, 4> } }
    }
  #end
#end
#macro train_doorright(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 47.9, 3.9> }
      box { <4, 22, -4> <20, 44.3, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { 0*y, 47.9*y, 3.9 }
          object { open_rounded_button() translate <0, 44.8, 0> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 47.9, 0> }
          #end
          box { <0, 0.3, 0> <24, 47.6, 3.9> }
          cylinder { 0.300001*y, 47.600001*y, 3.9 translate <24, 0, 0> }
          box { <22.1, 22.1, 3.8> <24, 26.8, 5.9> }
        }
        cylinder { 45*y, 50*y, 0.800008 translate <12, 0, 1.2> }
        box { <22, 22, 0> <22.8, 26.9, 5> }
        cylinder { 4*z, -2*z, 2 translate <6, 24, 0> }
        cylinder { 4*z, -2*z, 2 translate <6, 42.3, 0> }
        cylinder { 4*z, -2*z, 2 translate <18, 24, 0> }
        cylinder { 4*z, -2*z, 2 translate <18, 42.3, 0> }
        box { <4, 24, 4> <20, 42.3, -2> }
        box { <6, 22.000001, 4> <18, 44.3, -2> }
        box { <10, 0, -4> <30, 50, 0.000001> }
        cylinder { -1*y, 2*y, 2.5 }
        cylinder { -1*y, 2.5*y, 2.7 translate <24.2, 0, 0> }
        difference {
          cylinder { 0*y, 46.7*y, 2.7 translate <24, 0, 0> }
          box { <20, 19, -10> <30, 20.5, 10> }
        }
        difference {
          box { <-0.100001, 0, -10> <24.000001, 46.700001, 2.700001> }
          box { <-1, 19.000001, -0.000002> <30, 20.500001, 10> }
          cylinder { -1*y, 1.8*y, 3.900007 }
        }
      }
      difference {
        cylinder { 46.700008*y, 47.600001*y, 1.6 translate <12, 0, 1.2> }
        cylinder { 45*y, 50*y, 0.8 translate <12, 0, 1.2> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 49.7, 6> } }
    }
  #end
#end
#macro train_doorright_glass(color_tex)
  #if (setting = 0)
    box { <4, 22, -4> <20, 44.3, 4> texture { color_tex } }
  #else
    difference {
      merge {
        box { <4.1, 20.5, 2.6> <19.9, 46.7, 0.8> }
        sphere { <8, 20.5, 1.55> 0.75 }
        sphere { <16, 20.5, 1.55> 0.75 }
        sphere { <12, 46.7, 1.55> 0.75 }
        cylinder { 3.9*z, 1*z, 1.9 translate <6, 24, 0> }
        cylinder { 3.9*z, 1*z, 1.9 translate <6, 42.3, 0> }
        cylinder { 3.9*z, 1*z, 1.9 translate <18, 24, 0> }
        cylinder { 3.9*z, 1*z, 1.9 translate <18, 42.3, 0> }
        box { <4.10001, 24.1, 3.90004> <19.89999, 42.2, 1.00004> }
        box { <6.2, 22.00001, 3.90003> <17.9, 44.2, 1.00003> }
      }
      cylinder { -2*z, 2*z, 0.9 translate <6, 24, 0> }
      cylinder { -2*z, 2*z, 0.9 translate <6, 42.3, 0> }
      cylinder { -2*z, 2*z, 0.9 translate <18, 24, 0> }
      cylinder { -2*z, 2*z, 0.9 translate <18, 42.3, 0> }
      box { <5.99999, 23.1, 2.00001> <18.00001, 43.2, -2> }
      box { <5.1, 23.99999, 2.00002> <18.9, 42.30001, -2> }
      cylinder { 5*z, 3.2*z, 0.9 translate <6, 24, 0> }
      cylinder { 5*z, 3.2*z, 0.9 translate <6, 42.3, 0> }
      cylinder { 5*z, 3.2*z, 0.9 translate <18, 24, 0> }
      cylinder { 5*z, 3.2*z, 0.9 translate <18, 42.3, 0> }
      box { <5.99999, 23.1, 5><18.00001, 34.1, 3.19999> }
      box { <5.09999, 23.99999, 5> <18.90001, 34.80001, 3.19998> }
      box { <5.99999, 38.8, 5><18.00001, 43.2, 3.19999> }
      box { <5.09999, 35.9, 5><18.90001, 42.30001, 3.19998> }
      texture { color_tex }
      bounded_by { box { <4, 19.65, -4> <20, 47.55, 4> } }
    }
  #end
#end
#macro train_f_block6_16(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <123.9, 3.1, 43.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <123.9, 3.1, 43.9> }
          #if (setting < 3)
            #local counter = 0;
            #while (counter < 16)
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, 0> }
              cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 0, 40> }
              #local counter = counter + 1;
            #end
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <112, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <120, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <112, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <120, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <112, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <120, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <104, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <112, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <120, 0, 32> }
          #else
            #local counter = 0;
            #while (counter < 16)
              object { rounded_button() translate <(counter*8), 0, 0> }
              object { rounded_button() translate <(counter*8), 0, 40> }
              #local counter = counter + 1;
            #end
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <24, 0, 8> }
            object { rounded_button() translate <96, 0, 8> }
            object { rounded_button() translate <104, 0, 8> }
            object { rounded_button() translate <112, 0, 8> }
            object { rounded_button() translate <120, 0, 8> }
            object { rounded_button() translate <0, 0, 16> }
            object { rounded_button() translate <8, 0, 16> }
            object { rounded_button() translate <16, 0, 16> }
            object { rounded_button() translate <104, 0, 16> }
            object { rounded_button() translate <112, 0, 16> }
            object { rounded_button() translate <120, 0, 16> }
            object { rounded_button() translate <0, 0, 24> }
            object { rounded_button() translate <8, 0, 24> }
            object { rounded_button() translate <16, 0, 24> }
            object { rounded_button() translate <104, 0, 24> }
            object { rounded_button() translate <112, 0, 24> }
            object { rounded_button() translate <120, 0, 24> }
            object { rounded_button() translate <0, 0, 32> }
            object { rounded_button() translate <8, 0, 32> }
            object { rounded_button() translate <16, 0, 32> }
            object { rounded_button() translate <24, 0, 32> }
            object { rounded_button() translate <96, 0, 32> }
            object { rounded_button() translate <104, 0, 32> }
            object { rounded_button() translate <112, 0, 32> }
            object { rounded_button() translate <120, 0, 32> }
          #end
        }
        box { <19.9, -1, 11.9> <100.1, 5, 28.1> }
        box { <27.9, -1, 3.9> <92.1, 5, 36.1> }
        difference {
          box { <-2.5, -1, -2.5> <122.5, 2, 42.5> }
          box { <18.4, -2, 10.4> <101.6, 3, 29.6> }
          box { <26.4, -2, 2.4> <93.6, 3, 37.6> }
        }
        #if (setting > 1)
            #local counter = 0;
            #while (counter < 16)
              cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, 0> }
              cylinder { 1*y, 4*y, 1.2 translate <(counter*8), 0, 40> }
              #local counter = counter + 1;
            #end
         cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <112, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <120, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <112, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <120, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <112, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <120, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <104, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <112, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <120, 0, 32> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <4, 0, 28> }
        object { ring() translate <4, 0, 36> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <12, 0, 28> }
        object { ring() translate <12, 0, 36> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <20, 0, 36> }
        object { ring() translate <100, 0, 4> }
        object { ring() translate <100, 0, 36> }
        object { ring() translate <108, 0, 4> }
        object { ring() translate <108, 0, 12> }
        object { ring() translate <108, 0, 20> }
        object { ring() translate <108, 0, 28> }
        object { ring() translate <108, 0, 36> }
        object { ring() translate <116, 0, 4> }
        object { ring() translate <116, 0, 12> }
        object { ring() translate <116, 0, 20> }
        object { ring() translate <116, 0, 28> }
        object { ring() translate <116, 0, 36> }
        object { pin(1) translate <28, 0, 0> }
        object { pin(1) translate <36, 0, 0> }
        object { pin(1) translate <44, 0, 0> }
        object { pin(1) translate <52, 0, 0> }
        object { pin(1) translate <60, 0, 0> }
        object { pin(1) translate <68, 0, 0> }
        object { pin(1) translate <76, 0, 0> }
        object { pin(1) translate <84, 0, 0> }
        object { pin(1) translate <92, 0, 0> }
        object { pin(1) translate <28, 0, 40> }
        object { pin(1) translate <36, 0, 40> }
        object { pin(1) translate <44, 0, 40> }
        object { pin(1) translate <52, 0, 40> }
        object { pin(1) translate <60, 0, 40> }
        object { pin(1) translate <68, 0, 40> }
        object { pin(1) translate <76, 0, 40> }
        object { pin(1) translate <84, 0, 40> }
        object { pin(1) translate <92, 0, 40> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <124, 4.9, 44> } }
    }
  #end
#end
#macro train_hwwindow1_2(color_tex, age)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 28.7, 3.9> }
      box { <0, 3.1, -4> <8, 25.5, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 28.7, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
        #end
        box { <-2.4, 3.1, -2.4> <10.4, 27.2, 4> }
        cylinder { -4*z, 2*z, 2 translate <2, 5.2, 0> }
        cylinder { -4*z, 2*z, 2 translate <2, 23.5, 0> }
        cylinder { -4*z, 2*z, 2 translate <6, 5.2, 0> }
        cylinder { -4*z, 2*z, 2 translate <6, 23.5, 0> }
        box { <0, 5.2, -4> <8, 23.5, 2> }
        box { <2, 3.100001, -4> <6, 25.5, 2> }
        cylinder { -2.8*x, 10.8*x, 0.75 translate <0, 13.5, -1.5> }
      }
      object { open_rounded_button() translate <0, 25.6, 0> }
      object { open_rounded_button() translate <8, 25.6, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 28.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 28.7, 0> }
      #end
      #if (age = 1 & setting > 1)
        object { pin(1) translate <4, 0, 0> }
      #end
      #if (age = 2 & setting > 1)
        object { pin(2) translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 30.5, 4> } }
    }
  #end
#end
#macro train_hwwindow1_2_glass(color_tex)
  #if (setting = 0)
    box { <0, 3.1, -3.9> <8, 25.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-2.3, 3.2, -2.3> <10.3, 27.1, -0.8> }
        sphere { <-2.3, 13.5, -1.55> 0.75 }
        sphere { <10.3, 13.5, -1.55> 0.75 }
        cylinder { -3.9*z, -1*z, 1.9 translate <2, 5.2, 0> }
        cylinder { -3.9*z, -1*z, 1.9 translate <2, 23.5 0> }
        cylinder { -3.9*z, -1*z, 1.9 translate <6, 5.2, 0> }
        cylinder { -3.9*z, -1*z, 1.9 translate <6, 23.5, 0> }
        box { <0.1, 5.3, -3.900004> <7.9, 23.4, -1.000004> }
        box { <2.2, 3.200001, -3.900003> <5.9, 25.4, -1.000003> }
      }
      cylinder { -2*z, 2*z, 0.9 translate <2, 5.2, 0> }
      cylinder { -2*z, 2*z, 0.9 translate <2, 23.5, 0> }
      cylinder { -2*z, 2*z, 0.9 translate <6, 5.2, 0> }
      cylinder { -2*z, 2*z, 0.9 translate <6, 23.5, 0> }
      box { <1.999999, 4.3, -2.000001> <6.000001, 24.4, 2> }
      box { <1.1, 5.199999, -2.000002> <6.9, 23.500001, 2> }
      cylinder { -5*z, -3.2*z, 0.9 translate <2, 5.2, 0> }
      cylinder { -5*z, -3.2*z, 0.9 translate <2, 23.5, 0> }
      cylinder { -5*z, -3.2*z, 0.9 translate <6, 5.2, 0> }
      cylinder { -5*z, -3.2*z, 0.9 translate <6, 23.5, 0> }
      box { <1.999999, 4.3, -5><6.000001, 16, -3.199999> }
      box { <1.099999, 5.199999, -5><6.900001, 16.000001, -3.199998> }
      box { <1.999999, 20, -5> <6.000001, 24.4, -3.199999> }
      box { <1.099999, 17.1, -5> <6.900001, 23.500001, -3.199998> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 30.5, 4> } }
    }
  #end
#end
#macro train_h_window1_4(color_tex, age)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 28.7, 3.9> }
      box { <0, 3.1, -4> <24, 25.5, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 28.7, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
        #end
        box { <-2.4, 3.1, -2.4> <26.4, 27.2, 4> }
        cylinder { -4*z, 2*z, 2 translate <2, 5.2, 0> }
        cylinder { -4*z, 2*z, 2 translate <2, 23.5, 0> }
        cylinder { -4*z, 2*z, 2 translate <22, 5.2, 0> }
        cylinder { -4*z, 2*z, 2 translate <22, 23.5, 0> }
        box { <0, 5.2, -4> <24, 23.5, 2> }
        box { <2, 3.100001, -4> <22, 25.5, 2> }
        cylinder { -2.8*x, 26.8*x, 0.75 translate <0, 13.5, -1.5> }
      }
      object { open_rounded_button() translate <0, 25.6, 0> }
      object { open_rounded_button() translate <8, 25.6, 0> }
      object { open_rounded_button() translate <16, 25.6, 0> }
      object { open_rounded_button() translate <24, 25.6, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 28.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 28.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 28.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 28.7, 0> }
      #end
      #if (age = 1 & setting > 1)
        object { pin(1) translate <4, 0, 0> }
        object { pin(1) translate <12, 0, 0> }
        object { pin(1) translate <20, 0, 0> }
      #end
      #if (age = 2 & setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 30.5, 4> } }
    }
  #end
#end
#macro train_h_window1_4_glass(color_tex)
  #if (setting = 0)
    box { <0, 3.1, -3.9> <24, 25.5, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-2.3, 3.2, -2.3> <26.3, 27.1, -0.8> }
        sphere { <-2.3, 13.5, -1.55> 0.75 }
        sphere { <26.3, 13.5, -1.55> 0.75 }
        cylinder { -3.9*z, -1*z, 1.9 translate <2, 5.2, 0> }
        cylinder { -3.9*z, -1*z, 1.9 translate <2, 23.5 0> }
        cylinder { -3.9*z, -1*z, 1.9 translate <22, 5.2, 0> }
        cylinder { -3.9*z, -1*z, 1.9 translate <22, 23.5, 0> }
        box { <0.1, 5.3, -3.900004> <23.9, 23.4, -1.000004> }
        box { <2.2, 3.200001, -3.900003> <21.9, 25.4, -1.000003> }
      }
      cylinder { -2*z, 2*z, 0.9 translate <2, 5.2, 0> }
      cylinder { -2*z, 2*z, 0.9 translate <2, 23.5, 0> }
      cylinder { -2*z, 2*z, 0.9 translate <22, 5.2, 0> }
      cylinder { -2*z, 2*z, 0.9 translate <22, 23.5, 0> }
      box { <1.999999, 4.3, -2.000001> <22.000001, 24.4, 2> }
      box { <1.1, 5.199999, -2.000002> <22.9, 23.500001, 2> }
      cylinder { -5*z, -3.2*z, 0.9 translate <2, 5.2, 0> }
      cylinder { -5*z, -3.2*z, 0.9 translate <2, 23.5, 0> }
      cylinder { -5*z, -3.2*z, 0.9 translate <22, 5.2, 0> }
      cylinder { -5*z, -3.2*z, 0.9 translate <22, 23.5, 0> }
      box { <1.999999, 4.3, -5><22.000001, 16, -3.199999> }
      box { <1.099999, 5.199999, -5><22.900001, 16.000001, -3.199998> }
      box { <1.999999, 20, -5> <22.000001, 24.4, -3.199999> }
      box { <1.099999, 17.1, -5> <22.900001, 23.500001, -3.199998> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 30.5, 4> } }
    }
  #end
#end
#macro train_lightbrick2_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> }
      box { <4.1, 0.000001, 3.8> <19.9, 9.500001, 11.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 9.5, 3.9> }
          box { <4.1, 0.000001, 3.8> <19.9, 9.500001, 11.9> }
          object { open_rounded_button() translate <0, 6.4, 0> }
          object { open_rounded_button() translate <8, 6.4, 0> }
          object { open_rounded_button() translate <8, 6.4, 8> }
          object { open_rounded_button() translate <16, 6.4, 0> }
          object { open_rounded_button() translate <16, 6.4, 8> }
          object { open_rounded_button() translate <24, 6.4, 0> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> translate <0, 9.5, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <16, 9.5, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <16, 9.5, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <24, 9.5, 0> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          box { <5.6, -1, 0> <18.4, 2.000001, 10.4> }
        #end
        box { <-2.9, 3, -4> <3.9, 8, 0> }
        box { <20.1, 3, -4> <26.9, 8, 0> }
        box { <-2.900001, 3, -2.9> <26.900001, 8.6, 12> }
        cylinder { -1*y, 4*y, 2.6 translate <12, 0, 8> }
        box { <9.4, -1, 7.999999> <14.6, 4, 12> }
      }
      object { pin(1) translate <4, 0, 0> }
      object { pin(1) translate <20, 0, 0> }
      difference {
        object { ring() }
        cylinder { -1*y, 4*y, 2.600001 translate <0, 0, 4> }
        translate <12, 0, 4>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 12> } }
    }
  #end
#end
#macro train_lightconductor(color_tex)
  #if (setting = 0)
    difference {
      merge {
        cylinder { -2*z, 18*z, 2.5 rotate 47.5*y translate <0.5, 5.5, -3> }
        cylinder { -2*z, 18*z, 2.5 rotate -47.5*y translate <23.5, 5.5, -3> }
      }
      box { <-4, 2, -10> <32, 9, -3.25> }
      texture { color_tex }
    }
  #else
    merge {
      #if (setting > 1)
        #local teller = 0;
        #while ( teller < 7)
          #local counter = 0;
          #while ( counter < 5)
            box { <-0.4, -0.4, -0.4> <0.4, 0.4, 0.4> rotate 45*x rotate 45*y translate <-2.4+(teller), 7.5-counter, -3.5> }
            box { <-0.4, -0.4, -0.4> <0.4, 0.4, 0.4> rotate 45*x rotate 45*y translate <20.6+(teller), 7.5-counter, -3.5> }
            #local counter = counter + 1;
          #end
          #local teller = teller + 1;
        #end
        box { <4, 5.1, -2> <7.3, 5.9, 1> }
        box { <16.7, 5.1, -2> <20, 5.9, 1> }
      #end
      box { <-2.9, 3, -3.5> <3.9, 8, -3> }
      box { <20.1, 3, -3.5> <26.9, 8, -3> }
      difference {
        box { <0.5, 3.000001, -3.1> <3.900001, 8.000001, 0> }
        box { <-10, 0, -5> <-0.000001, 10, 10> rotate 47.5*y translate <0.5, 0, -3> }
      }
      difference {
        box { <20.100001, 3.000001, -3.1> <23.5, 8.000001, 0> }
        box { <0.000001, 0, -5> <10, 10, 10> rotate -47.5*y translate <23.5, 0, -3> }
      }
      difference {
        merge {
          cylinder { -2*z, 18*z, 2.5 rotate 47.5*y translate <0.5, 5.5, -3> }
          cylinder { -2*z, 18*z, 2.5 rotate -47.5*y translate <23.5, 5.5, -3> }
          sphere { <9, 5.5, 10> 2.5 }
          sphere { <15, 5.5, 10> 2.5 }
          cylinder { 10.000001*z, 5.5*z, 2.5 translate <9, 5.5, 0> }
          cylinder { 10.000001*z, 5.5*z, 2.5 translate <15, 5.5, 0> }
          cylinder { 10*x, 14*x, 2.5 translate <0, 5.5, 5.75> }
          box { <8.999999, 3.000002, 5.5> <15.000001, 8.000002, 10.000002> }
        }
        box { <-4, 2, -10> <32, 9, -3.25> }
        cylinder { 0*y, 10*y, 2.5 translate <12, 0, 8> }
        box { <9.5, 0, 7.999999> <14.5, 10, 16> }
      }
      texture { color_tex } interior { ior 1.5 }
      bounded_by { box { <-3, 2.9, -4> <27, 8.1, 12.6> } }
    }
  #end
#end
#macro train_locomotive_bottom(color_tex)
  #if (setting = 0)
    difference {
      box { <-19.9, -15.9, -3.9> <91.9, 6.3, 43.9> }
      box { <-20, -30, -4> <0, 0, 44> rotate 38.25*z translate <-19.9, 0, 0> }
      box { <-4, -16, -4> <92, 0, 44> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-19.9, -15.9, -3.9> <91.9, 6.3, 43.9> }
          #local teller = 0;
          #while ( teller < 6)
            #if (teller > 1 & teller < 4)
              #local counter = 8;
            #else
              #local counter = 0;
            #end
            #while (counter < 12)
              #if (setting < 3)
                cylinder { 3*y, 4.8*y, 2.4 translate <(counter*8), 3.2, (teller*8)> }
              #else
                object { rounded_button() translate <(counter*8), 3.2, (teller*8)> }
              #end
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        }
        box { <-20, -20, -10> <0, 10, 0> rotate 26.6*y translate <-4, 0, -4> }
        box { <-20, -20, 0> <0, 10, 10> rotate -26.6*y translate <-4, 0, 44> }
        difference {
          box { <-20, -30, -4> <0, 0, 44> rotate 38.25*z translate <-19.9, 0, 0> }
          cylinder { 1*y, -6.3*y, 3.7 translate <-16, 0, 20> }
        }
        box { <-20, -30, -15> <10, 10, 0> rotate -19.5*x rotate 26.6*y translate <-4, 0, -4> }
        box { <-20, -30, 0> <10, 10, 15> rotate 19.5*x rotate -26.6*y translate <-4, 0, 44> }
        #if (setting > 1)
          cylinder { -6.300001*y, -20*y, 3.700001 translate <-16, 0, 20> }
          difference {
            box { <-18.4, -13.8, -2.4> <-5.599999, 10, 42.4> }
            box { <-20, -20, -10> <0, 10, 0> rotate 26.6*y translate <-4, 0, -2.2> }
            box { <-20, -20, 0> <0, 10, 10> rotate -26.6*y translate <-4, 0, 42.2> }
            box { <-20, -30, -15> <10, 10, 0> rotate -19.5*x rotate 26.6*y translate <-4, 0, -2.2> }
            box { <-20, -30, 0> <10, 10, 15> rotate 19.5*x rotate -26.6*y translate <-4, 0, 42.2> }
            box { <-20, -30, -4> <0, 0, 44> rotate 38.25*z translate <-18.4, 0, 0> }
            box { <-20, -20, -5> <-17.4, 0, 45> }
            box { <-20, -20, 2.9> <0, 10, 3.9> }
            box { <-20, -20, 36.1> <0, 10, 37.1> }
            box { <-20, -20, 7.5> <-7.300002, 0.000002, 8.5> }
            box { <-20, -20, 31.5> <-7.300002, 0.000002, 32.5> }
            box { <-20, -20, 13.75> <0, 0.000002, 14.75> }
            box { <-20, -20, 25.25> <0, 0.000002, 26.25> }
            box { <-20, -20, 0> <-15, -3.100008, 40> }
            cylinder { -20*y, -3.100009*y, 3.9 translate <-16, 0, 20> }
            cylinder { -20*y, -5.1*y, 5.4 translate <-16, 0, 20> }
          }
          difference {
            box { <-2.4, -1, -2.4> <90.4, 5.4, 42.4> }
            box { <-6, -2, 2.4> <61.4, 6, 37.6> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <4, 0, 0> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <12, 0, 0> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <20, 0, 0> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <28, 0, 0> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <36, 0, 0> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <44, 0, 0> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <52, 0, 0> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <60, 0, 0> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <4, 0, 40> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <12, 0, 40> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <20, 0, 40> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <28, 0, 40> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <36, 0, 40> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <44, 0, 40> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <52, 0, 40> }
            cylinder { 0.000001*y, 5.5*y, 1.5 translate <60, 0, 40> }
            box { <19.75, 2, -2.5> <20.25, 6, 2.5> }
            box { <35.75, 2, -2.5> <36.25, 6, 2.5> }
            box { <51.75, 2, -2.5> <52.25, 6, 2.5> }
            box { <19.75, 2, 37.5> <20.25, 6, 42.5> }
            box { <35.75, 2, 37.5> <36.25, 6, 42.5> }
            box { <51.75, 2, 37.5> <52.25, 6, 42.5> }
          }
          difference {
            box { <-4.000003, -1, 3.9> <60.100001, 5.4, 10.4> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <4, 0, 8> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <12, 0, 8> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <20, 0, 8> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <28, 0, 8> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <36, 0, 8> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <44, 0, 8> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <52, 0, 8> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <60, 0, 8> }
            box { <-0.75, 3.200002, 3.5> <0.75, 5.5, 5.6> }
            box { <7.25, 3.200002, 3.5> <8.75, 5.5, 5.6> }
            box { <15.25, 3.200002, 3.5> <16.75, 5.5, 5.6> }
            box { <23.25, 3.200002, 3.5> <24.75, 5.5, 5.6> }
            box { <31.25, 3.200002, 3.5> <32.75, 5.5, 5.6> }
            box { <39.25, 3.200002, 3.5> <40.75, 5.5, 5.6> }
            box { <47.25, 3.200002, 3.5> <48.75, 5.5, 5.6> }
            box { <55.25, 3.200002, 3.5> <56.75, 5.5, 5.6> }
          }
          difference {
            box { <-4.000003, -1, 29.6> <60.100001, 5.4, 36.100001> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <4, 0, 32> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <12, 0, 32> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <20, 0, 32> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <28, 0, 32> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <36, 0, 32> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <44, 0, 32> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <52, 0, 32> }
            cylinder { 3.200001*y, 5.5*y, 1.5 translate <60, 0, 32> }
            box { <-0.75, 3.200002, 34.4> <0.75, 5.5, 36.5> }
            box { <7.25, 3.200002, 34.4> <8.75, 5.5, 36.5> }
            box { <15.25, 3.200002, 34.4> <16.75, 5.5, 36.5> }
            box { <23.25, 3.200002, 34.4> <24.75, 5.5, 36.5> }
            box { <31.25, 3.200002, 34.4> <32.75, 5.5, 36.5> }
            box { <39.25, 3.200002, 34.4> <40.75, 5.5, 36.5> }
            box { <47.25, 3.200002, 34.4> <48.75, 5.5, 36.5> }
            box { <55.25, 3.200002, 34.4> <56.75, 5.5, 36.5> }
          }
          #local teller = 0;
          #while ( teller < 6)
            #if (teller > 1 & teller < 4)
              #local counter = 8;
            #else
              #local counter = 0;
            #end
            #while (counter < 12)
              cylinder { 4.2*y, 7.2*y, 1.2 translate <(counter*8), 0, (teller*8)> }
              #local counter = counter + 1;
            #end
            #local teller = teller + 1;
          #end
        #end
        box { <-4, -16, -4> <92, 0, 44> }
        box { <-6, -0.000001, 11.9> <60.1, 7, 28.1> }
        box { <-4.000005, -0.000001, 3.9> <60.1, 3.100001, 36.1> }
        box { <-7.3, -20, 5.4> <-5.600004, 10, 10.2> }
        box { <-7.3, -20, 34.6> <-5.600004, 10, 29.8> }
        cylinder { -20*y, 10*y, 2.600003 translate <-16, 0, 20> }
        box { <-20, 0.000007, 5> <-15, 4.9, 11.5> }
        box { <-20, 0.000007, 28.5> <-15, 4.9, 35> }
      }
      #if (setting > 1)
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <68, 0, 4>
        }
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <76, 0, 4>
        }
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <84, 0, 4>
        }
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <68, 0, 12>
        }
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <76, 0, 12>
        }
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <84, 0, 12>
        }
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <68, 0, 20>
        }
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <76, 0, 20>
        }
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <84, 0, 20>
        }
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <68, 0, 28>
        }
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <76, 0, 28>
        }
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <84, 0, 28>
        }
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <68, 0, 36>
        }
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <76, 0, 36>
        }
        difference {
          cylinder { 0.000005*y, 5.5*y, 3.2 }
          cylinder { -1*y, 6*y, 2.6 }
          translate <84, 0, 36>
        }
      #end
      texture { color_tex }
      bounded_by { box { <-20, -16, -4> <92, 8.1, 44> } }
    }
  #end
#end
#macro train_lowernose(color_tex)
  #if (setting = 0)
    difference {
      box { <-19.9, -15.9, -3.9> <11.9, 9.5, 43.9> }
      box { <-20, -20, -4> <0, 0, 44> rotate -32.5*z translate <-5, -15.9, 0> }
      box { <-40, 0, -4> <0, 20, 44> rotate 53.5*z translate <-12, 9.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-19.9, -15.9, -3.9> <11.9, 9.5, 43.9> }
        box { <-4, -16, -4> <12, 0.000001, 44> }
        box { <-4.000001, -1, 3.9> <12, 10, 36.1> }
        box { <-20, -20, -4> <0, 0, 44> rotate -32.5*z translate <-5, -15.9, 0> }
        box { <-20, -20, -20> <0, 10, 0> rotate 45*y translate <-12, 0, -3.9> }
        box { <-20, -20, 0> <0, 10, 20> rotate -45*y translate <-12, 0, 43.9> }
        box { <-40, 0, -4> <0, 20, 44> rotate 53.5*z translate <-12, 9.5, 0> }
        box { <0, 0, -20> <20, 20, 0> rotate 62*z rotate -45*y translate <-19.9, -1.1, 3.9> }
        box { <0, 0, 0> <20, 20, 20> rotate 62*z rotate 45*y translate <-19.9, -1.1, 36.1> }
        #if (setting > 1)
          box { <-20, -6.2, 5> <20, -1.3, 11.5> }
          box { <-20, -6.2, 28.5> <20, -1.3, 35> }
          difference {
            box { <-18.4, -14.4, -2.4> <12, 8, 42.4> }
            box { <-20, -20, -4> <0, 0, 44> rotate -32.5*z translate <-4.5, -14.4, 0> }
            box { <-20, -20, -20> <0, 10, 0> rotate 45*y translate <-12, 0, -2.4> }
            box { <-20, -20, 0> <0, 10, 20> rotate -45*y translate <-12, 0, 42.4> }
            box { <-40, 0, -4> <0, 20, 44> rotate 53.5*z translate <-12, 8, 0> }
            box { <0, 0, -20> <20, 20, 0> rotate 62*z rotate -45*y translate <-18.4, -1.1, 3.9> }
            box { <0, 0, 0> <20, 20, 20> rotate 62*z rotate 45*y translate <-18.4, -1.1, 36.1> }
            box { <-19, -7.5, -3> <-3.999999, -6.200001, 43> }
            box { <-19, -6.5, 4> <-3.999998, -1, 5> }
            box { <-19, -6.5, 35> <-3.999998, -1, 36> }
            difference {
              box { <-19, -1.5, 2.4> <-3.999997, 0.000001, 37.6> }
              cylinder { -2*y, 2*y, 2.5 translate <-12, 0, 20> }
              box { <-12.000001, -2, 17.500001> <0, 2, 22.500001> }
            }
            box { <-20, -6.5, 16.5> <-16, -0.75, 17.5> }
            box { <-20, -6.5, 22.5> <-16, -0.75, 23.5> }
            box { <-20, 2, -4> <11.899998, 3.2, 3.899998> }
            box { <-20, 0, 2.4> <11.899997, 3, 3.899997> }
            box { <-20, 2, 36.100002> <11.899998, 3.2, 44> }
            box { <-20, 0, 36.100003> <11.899997, 3, 37.6> }
          }
        #end
      }
      object { open_rounded_button() translate <0, 6.4, 0> }
      object { open_rounded_button() translate <8, 6.4, 0> }
      object { open_rounded_button() translate <-8, 6.4, 8> }
      object { open_rounded_button() translate <-8, 6.4, 16> }
      object { open_rounded_button() translate <-8, 6.4, 24> }
      object { open_rounded_button() translate <-8, 6.4, 32> }
      object { open_rounded_button() translate <0, 6.4, 40> }
      object { open_rounded_button() translate <8, 6.4, 40> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <0, 9.5, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <8, 9.5, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <-8, 9.5, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <-8, 9.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <-8, 9.5, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <-8, 9.5, 32> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <0, 9.5, 40> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <8, 9.5, 40> }
      #end
      texture { color_tex }
      bounded_by { box { <-20, -16, -4> <12, 11.3, 44> } }
    }
  #end
#end
#macro train_pantograph(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -15.75*x, 15.75*x, 1.55 translate <0, 6, -3.25> }
      cylinder { -15.75*x, 15.75*x, 1.55 translate <0, 6, 3.25> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.900001, -0.000001, -1.55> <-2.35, 6, 1.55> }
          cylinder { -3.900002*x, -2.349999*x, 1.55 }
          box { <-0.55, -0.000001, -1.55> <0.55, 6, 1.55> }
          cylinder { -0.550001*x, 0.549999*x, 1.55 }
          box { <2.35, -0.000001, -1.55> <3.899999, 6, 1.55> }
          cylinder { 2.350001*x, 3.899998*x, 1.55 }
          cylinder { -3.9*x, 3.9*x, 1.55 translate <0, 4.100000, 0> }
          box { <-3.900003, 4.099999, -1.550003> <3.900003, 5.9, 1.550003> }
        }
        box { <-2.35, 3.5, -4> <2.35, 4.450001, -0.55> }
        box { <-2.35, 3.5, 4> <2.35, 4.450001, 0.55> }
      }
      box { <-3.900002, 4.45, -3.25> <3.900002, 6.000001, 3.25> }
      cylinder { -10.2*x, 10.2*x, 1.55 translate <0, 6, -3.25> }
      cylinder { -10.2*x, 10.2*x, 1.55 translate <0, 6, 3.25> }
      difference {
        torus { 4, 1.55 rotate 90*x }
        box { <0.000001, -10, -2> <10, 10, 2> }
        box { <-10, -10, -2> <10, -0.000001, 2> }
        translate <-10.2, 2, -3.25>
      }
      difference {
        torus { 4, 1.55 rotate 90*x }
        box { <0.000001, -10, -2> <10, 10, 2> }
        box { <-10, -10, -2> <10, -0.000001, 2> }
        translate <-10.2, 2, 3.25>
      }
      difference {
        torus { 4, 1.55 rotate 90*x }
        box { <-10, -10, -2> <-0.000001, 10, 2> }
        box { <-10, -10, -2> <10, -0.000001, 2> }
        translate <10.2, 2, -3.25>
      }
      difference {
        torus { 4, 1.55 rotate 90*x }
        box { <-10, -10, -2> <-0.000001, 10, 2> }
        box { <-10, -10, -2> <10, -0.000001, 2> }
        translate <10.2, 2, 3.25>
      }
      sphere { <-14.2, 2, -3.25> 1.55 }
      sphere { <-14.2, 2, 3.25> 1.55 }
      sphere { <14.2, 2, -3.25> 1.55 }
      sphere { <14.2, 2, 3.25> 1.55 }
      texture { color_tex }
      bounded_by { box { <-15.85, -1.65, -4.9> <15.85, 7.65, 4.9> } }
    }
  #end
#end
#macro train_pantograph2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -15.75*x, 15.75*x, 1.55 translate <0, 6, -3.25> }
      cylinder { -15.75*x, 15.75*x, 1.55 translate <0, 6, 3.25> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -2.5> <3.9, 8, 2.5> }
          cylinder { -3.90001*x, 3.90001*x, 2.5 }
        }
        cylinder { -4*x, 4*x, 0.3 translate <0, 0, 2.5> }
        cylinder { -4*x, 4*x, 0.3 translate <0, 0, 2.5> rotate 20*x }
        cylinder { -4*x, 4*x, 0.3 translate <0, 0, 2.5> rotate 40*x }
        cylinder { -4*x, 4*x, 0.3 translate <0, 0, 2.5> rotate 60*x }
        cylinder { -4*x, 4*x, 0.3 translate <0, 0, 2.5> rotate 80*x }
        cylinder { -4*x, 4*x, 0.3 translate <0, 0, 2.5> rotate 100*x }
        cylinder { -4*x, 4*x, 0.3 translate <0, 0, 2.5> rotate 120*x }
        cylinder { -4*x, 4*x, 0.3 translate <0, 0, 2.5> rotate 140*x }
        cylinder { -4*x, 4*x, 0.3 translate <0, 0, 2.5> rotate 160*x }
        cylinder { -4*x, 4*x, 0.3 translate <0, 0, 2.5> rotate 180*x }
        difference {
          box { <0, 0, -3> <2, 10, 3> rotate -10*z translate <-2.2, 2, 0> }
          box { <-4, 6.45, -4> <4, 20, 4> }
        }
        difference {
          box { <-2, 0, -3> <0, 10, 3> rotate 10*z translate <2.2, 2, 0> }
          box { <-4, 6.45, -4> <4, 20, 4> }
        }
        box { <0, 0, -3> <2, 2, 3> rotate -60*z translate <-2.2, 2, 0> }
        box { <-2, 0, -3> <0, 2, 3> rotate 60*z translate <2.2, 2, 0> }
        box { <-1.5, -4, -4> <1.5, 6.45001, 4> }
      }
      cylinder { -3*x, -1.2*x, 1.5 }
      cylinder { 1.2*x, 3*x, 1.5 }
      cylinder { -10.2*x, 10.2*x, 1.55 translate <0, 8, -3.25> }
      cylinder { -10.2*x, 10.2*x, 1.55 translate <0, 8, 3.25> }
      difference {
        torus { 4, 1.55 rotate 90*x }
        box { <0.00001, -10, -2> <10, 10, 2> }
        box { <-10, -10, -2> <10, -0.00001, 2> }
        translate <-10.2, 4, -3.25>
      }
      difference {
        torus { 4, 1.55 rotate 90*x }
        box { <0.00001, -10, -2> <10, 10, 2> }
        box { <-10, -10, -2> <10, -0.00001, 2> }
        translate <-10.2, 4, 3.25>
      }
      difference {
        torus { 4, 1.55 rotate 90*x }
        box { <-10, -10, -2> <-0.00001, 10, 2> }
        box { <-10, -10, -2> <10, -0.00001, 2> }
        translate <10.2, 4, -3.25>
      }
      difference {
        torus { 4, 1.55 rotate 90*x }
        box { <-10, -10, -2> <-0.00001, 10, 2> }
        box { <-10, -10, -2> <10, -0.00001, 2> }
        translate <10.2, 4, 3.25>
      }
      sphere { <-14.2, 4, -3.25> 1.55 }
      sphere { <-14.2, 4, 3.25> 1.55 }
      sphere { <14.2, 4, -3.25> 1.55 }
      sphere { <14.2, 4, 3.25> 1.55 }
      texture { color_tex }
      bounded_by { box { <-15.85, -1.65, -4.9> <15.85, 9.65, 4.9> } }
    }
  #end
#end
#macro train_railing(color_tex,age)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <43.9, 3.1, 3.9> }
      box { <-3.900001, 17.6, 3.800001> <43.900001, 19.1, 7.899999> }
      box { <-3.900002, 0.000002, 3.800002> <-2.4, 19.05, 7.899998> }
      box { <42.4, 0.000002, 3.800002> <43.900002, 19.05, 7.899998> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <40, 0, 0> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <24, 0, 0> }
            object { rounded_button() translate <32, 0, 0> }
            object { rounded_button() translate <40, 0, 0> }
          #end
          box { <-3.900001, 0.000001, 3.8> <-2.4, 11.5, 7.9> }
          box { <42.4, 0.000001, 3.8> <43.900001, 11.5, 7.9> }
          box { <4, 17.6, 3.800001> <36, 19.1, 7.899999> }
          box { <12, 0.000002, 3.800002> <13.5, 19.05, 7.899998> }
          box { <26.5, 0.000002, 3.800002> <28, 19.05, 7.899998> }
          box { <0, 0, 3.800003> <1.5, 10.890363, 7.899997> rotate -45*z translate <-3.9, 11.499999, 0> }
          box { <-1.5, 0, 3.800003> <0, 10.890363, 7.899997> rotate 45*z translate <43.9, 11.499999, 0> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <42.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <40, 0, 0> }
        #end
        difference {
          box { <-5, -1, 6.9> <45, 1, 10> }
          cylinder { -4*x, 44*x, 1 translate <0, 1, 6.9> }
        }
      }
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
        object { pin(age) translate <12, 0, 0> }
        object { pin(age) translate <20, 0, 0> }
        object { pin(age) translate <28, 0, 0> }
        object { pin(age) translate <36, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 19.2, 8> } }
    }
  #end
#end
#macro train_rails_straight_moved()
  object { train_rails_straight() translate <0, 0, -28> }
#end
#macro train_rails_straight()
  #if (setting = 0)
    merge {
      box { <-7.7, 0, 4> <127.7, 9.51, 12> }
      box { <-7.7, 0, 44> <127.7, 9.51, 52> }
      texture { grey2_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <3.9, 3.1, 59.9> }
          box { <20.1, 0, -3.9> <35.9, 3.1, 59.9> }
          box { <52.1, 0, -3.9> <67.9, 3.1, 59.9> }
          box { <84.1, 0, -3.9> <99.9, 3.1, 59.9> }
          box { <116.1, 0, -3.9> <123.9, 3.1, 59.9> }
          box { <-3.900001, 0.000001, 4.1> <123.900001, 3.099999, 11.9> }
          box { <-3.900001, 0.000001, 44.1> <123.900001, 3.099999, 51.9> }
          difference {
            box { <-7.7, 1.999999, 4.9> <127.7, 9.5, 11.1> }
            box { <-10, 3.100006, 0> <0, 10, 7.8> }
            difference {
              box { <-1, 2, 0> <120, 10, 6.7> }
              box { <-2, -10, -10> <121, 0, 0> rotate -10*x translate <0, 4.2, 6.7> }
            }
            difference {
              box { <-1, 2, 9.3> <120, 10, 16> }
              box { <-2, -10, 0> <121, 0, 10> rotate 10*x translate <0, 4.2, 9.3> }
            }
          }
          difference {
            box { <-7.7, 1.999999, 44.9> <127.7, 9.5, 51.1> }
            box { <120, 3.100006, 48.2> <130, 10, 56> }
            difference {
              box { <-1, 2, 40> <120, 10, 46.7> }
              box { <-2, -10, -10> <121, 0, 0> rotate -10*x translate <0, 4.2, 46.7> }
            }
            difference {
              box { <-1, 2, 49.3> <120, 10, 56> }
              box { <-2, -10, 0> <121, 0, 10> rotate 10*x translate <0, 4.2, 49.3> }
            }
          }
          box { <-2.6, 0.000002, -2.6> <2.6, 3.100002, 2.6> rotate 45*y translate <-3.9, 0, 20> }
          box { <-2.6, 0.000002, -2.6> <2.6, 3.100002, 2.6> rotate 45*y translate <123.9, 0, 36> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <120, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <56, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <64, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <88, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <96, 0, 56> }
            cylinder { 3*y, 4.8*y, 2.4 translate <120, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <120, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <120, 0, 32> }
            cylinder { 3*y, 4.8*y, 2.4 translate <120, 0, 40> }
            cylinder { 3*y, 4.8*y, 2.4 translate <120, 0, 56> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <24, 0, 0> }
            object { rounded_button() rotate 90*y translate <32, 0, 0> }
            object { rounded_button() rotate 90*y translate <56, 0, 0> }
            object { rounded_button() rotate 90*y translate <64, 0, 0> }
            object { rounded_button() rotate 90*y translate <88, 0, 0> }
            object { rounded_button() rotate 90*y translate <96, 0, 0> }
            object { rounded_button() rotate 90*y translate <120, 0, 0> }
            object { rounded_button() rotate 90*y translate <0, 0, 16> }
            object { rounded_button() rotate 90*y translate <0, 0, 24> }
            object { rounded_button() rotate 90*y translate <0, 0, 32> }
            object { rounded_button() rotate 90*y translate <0, 0, 40> }
            object { rounded_button() rotate 90*y translate <0, 0, 56> }
            object { rounded_button() rotate 90*y translate <24, 0, 16> }
            object { rounded_button() rotate 90*y translate <24, 0, 24> }
            object { rounded_button() rotate 90*y translate <24, 0, 32> }
            object { rounded_button() rotate 90*y translate <24, 0, 40> }
            object { rounded_button() rotate 90*y translate <24, 0, 56> }
            object { rounded_button() rotate 90*y translate <32, 0, 16> }
            object { rounded_button() rotate 90*y translate <32, 0, 24> }
            object { rounded_button() rotate 90*y translate <32, 0, 32> }
            object { rounded_button() rotate 90*y translate <32, 0, 40> }
            object { rounded_button() rotate 90*y translate <32, 0, 56> }
            object { rounded_button() rotate 90*y translate <56, 0, 16> }
            object { rounded_button() rotate 90*y translate <56, 0, 24> }
            object { rounded_button() rotate 90*y translate <56, 0, 32> }
            object { rounded_button() rotate 90*y translate <56, 0, 40> }
            object { rounded_button() rotate 90*y translate <56, 0, 56> }
            object { rounded_button() rotate 90*y translate <64, 0, 16> }
            object { rounded_button() rotate 90*y translate <64, 0, 24> }
            object { rounded_button() rotate 90*y translate <64, 0, 32> }
            object { rounded_button() rotate 90*y translate <64, 0, 40> }
            object { rounded_button() rotate 90*y translate <64, 0, 56> }
            object { rounded_button() rotate 90*y translate <88, 0, 16> }
            object { rounded_button() rotate 90*y translate <88, 0, 24> }
            object { rounded_button() rotate 90*y translate <88, 0, 32> }
            object { rounded_button() rotate 90*y translate <88, 0, 40> }
            object { rounded_button() rotate 90*y translate <88, 0, 56> }
            object { rounded_button() rotate 90*y translate <96, 0, 16> }
            object { rounded_button() rotate 90*y translate <96, 0, 24> }
            object { rounded_button() rotate 90*y translate <96, 0, 32> }
            object { rounded_button() rotate 90*y translate <96, 0, 40> }
            object { rounded_button() rotate 90*y translate <96, 0, 56> }
            object { rounded_button() rotate 90*y translate <120, 0, 16> }
            object { rounded_button() rotate 90*y translate <120, 0, 24> }
            object { rounded_button() rotate 90*y translate <120, 0, 32> }
            object { rounded_button() rotate 90*y translate <120, 0, 40> }
            object { rounded_button() rotate 90*y translate <120, 0, 56> }
          #end
        }
        box { <-10, -1, 45.6> <2.4, 2.000001, 50.4> }
        box { <117.6, -1, 45.6> <130, 2.000001, 50.4> }
        box { <10.3, -1, 0> <13.7, 2, 60> }
        difference {
          box { <-4, -1, 32> <-2.41, 3.2, 40> }
          box { <0, -2, -5> <5, 4, 0> rotate -45*y translate <-4, 0, 32> }
          box { <0, -2, 0> <5, 4, 5> rotate 45*y translate <-4, 0, 40> }
        }
        difference {
          box { <122.41, -1, 16> <124, 3.2, 24> }
          box { <-5, -2, -5> <0, 4, 0> rotate 45*y translate <124, 0, 16> }
          box { <-5, -2, 0> <0, 4, 5> rotate -45*y translate <124, 0, 24> }
        }
        box { <-2.4, -1, -2.4> <2.4, 2, 4.1> }
        difference {
          box { <-2.4, -1, 11.9> <2.4, 2, 44.1> }
          cylinder { -2*y, 3*y, 3.1 translate <-3.9, 0, 20> }
          difference {
            box { <-3, -2, 32> <-1.4, 3, 40> }
            box { <0, -2, -5> <5, 4, 0> rotate -45*y translate <-4, 0, 32> }
            box { <0, -2, 0> <5, 4, 5> rotate 45*y translate <-4, 0, 40> }
          }
        }
        box { <-2.4, -1, 51.9> <2.4, 2, 58.4> }
        box { <117.6, -1, -2.4> <122.4, 2, 4.1> }
        difference {
          box { <117.6, -1, 11.9> <122.4, 2, 44.1> }
          cylinder { -2*y, 3*y, 3.1 translate <123.9, 0, 36> }
          difference {
            box { <121.4, -2, 16> <123, 3, 24> }
            box { <-5, -2, -5> <0, 4, 0> rotate 45*y translate <124, 0, 16> }
            box { <-5, -2, 0> <0, 4, 5> rotate -45*y translate <124, 0, 24> }
          }
        }
        difference {
          box { <-10, 0, 4> <-3.9, 10, 12> }
          cylinder { -1*y, 11*y, 1.2 translate <-6.5, 0, 6.9> }
          cylinder { -1*y, 11*y, 1.2 translate <-6.5, 0, 9.9> }
          box { <-7.700002, 1, 6.9> <-3.900005, 11, 9.9> }
          box { <-6.5, 1, 5.699999> <-3.900005, 11, 11.200001> }
        }
        difference {
          box { <-10, -0.5, 44> <-3.9, 10, 52> }
          cylinder { -1*y, 11*y, 1.2 translate <-6.5, 0, 49.9> }
          box { <-7.700001, 1, 48.000005> <-3.900005, 11, 49.9> }
          box { <-6.500001, 1, 49.899999> <-3.900005, 11, 51.100005> }
        }
        difference {
          box { <126.5, -0.5, 4> <130, 10, 12> }
          cylinder { -1*y, 11*y, 1.2 translate <126.5, 0, 6.1> }
          box { <123.900005, 1, 6.1> <127.700001, 11, 8.000001> }
          box { <123.900005, 1, 4.900005> <126.500001, 11, 8.000001> }
        }
        difference {
          box { <123.9, 0, 44> <130, 10, 52> }
          cylinder { -1*y, 11*y, 1.2 translate <126.5, 0, 46.1> }
          cylinder { -1*y, 11*y, 1.2 translate <126.5, 0, 49.1> }
          box { <123.900005, 1, 46.1> <127.700002, 11, 49.1> }
          box { <123.900005, 1, 44.899999> <126.5, 11, 50.300001> }
        }
        box { <-10, 0, 0> <1, 10, 5> rotate -23.5*x translate <0, 4.2, 11.1> }
        box { <-10, 0, 0> <1, 10, 5> rotate -23.5*x translate <0, 4.2, 51.1> }
        box { <119, 0, -5> <130, 10, 0> rotate 23.5*x translate <0, 4.2, 4.9> }
        box { <119, 0, -5> <130, 10, 0> rotate 23.5*x translate <0, 4.2, 44.9> }
        box { <3.9, -1, 5.1> <116.1, 2.000005, 10.9> }
        box { <3.9, -1, 44.899999> <116.1, 2.000007, 48.000001> }
        difference {
          box { <3.900008, -1, 6> <116.099998, 5, 10> }
          box { <2, 0, -5> <118, 10, 0> rotate -10*x translate <0, 3.7, 8> }
          box { <2, 0, 0> <118, 10, 5> rotate 10*x translate <0, 3.7, 8> }
        }
        difference {
          box { <3.900008, -1, 46> <116.099998, 5, 50> }
          box { <2, 0, -5> <118, 10, 0> rotate -10*x translate <0, 3.7, 48> }
          box { <2, 0, 0> <118, 10, 5> rotate 10*x translate <0, 3.7, 48> }
        }
        box { <6.5, -1, 6.6> <12.5, 8.5, 9.4> }
        box { <6.5, -1, 46.6> <12.5, 8.5, 49.4> }
        box { <41, -1, 6.6> <47, 8.5, 9.4> }
        box { <41, -1, 46.6> <47, 8.5, 49.4> }
        box { <73, -1, 6.6> <79, 8.5, 9.4> }
        box { <73, -1, 46.6> <79, 8.5, 49.4> }
        box { <107.5, -1, 6.6> <113.5, 8.5, 9.4> }
        box { <107.5, -1, 46.6> <113.5, 8.5, 49.4> }
        box { <-10, -1, 5.1> <2.400001, 2.000005, 10.9> }
        box { <-10, -1, 44.899999> <0.000001, 10, 48.000001> }
        box { <117.600001, -1, 5.1> <130, 2.000005, 10.9> }
        box { <119.999999, -1, 8> <130, 10, 11.100001> }
        box { <25, 4.2, 6.6> <31, 8.5, 8> }
        box { <25, 4.2, 48> <31, 8.5, 50> }
        box { <117.6, -1, 51.9> <122.4, 2, 58.4> }
        box { <21.6, -1, -2.4> <34.4, 2, 4.1> }
        box { <21.6, -1, 51.9> <34.4, 2, 58.4> }
        box { <53.6, -1, -2.4> <66.4, 2, 4.1> }
        box { <53.6, -1, 51.9> <66.4, 2, 58.4> }
        box { <85.6, -1, -2.4> <98.4, 2, 4.1> }
        box { <85.6, -1, 51.9> <98.4, 2, 58.4> }
        box { <21.6, -1, 11.9> <34.4, 2, 44.1> }
        difference {
          box { <53.6, -1, 11.9> <66.4, 2, 44.1> }
          cylinder { -2*y, 3*y, 3 translate <60, 0, 28> }
        }
        box { <85.6, -1, 11.9> <98.4, 2, 44.1> }
        cylinder { -1*y, 4*y, 2 translate <-3.9, 0, 20> }
        cylinder { -1*y, 4*y, 2 translate <123.9, 0, 36> }
        box { <-10, -1, 16> <-5.5, 4, 24> }
        box { <125.5, -1, 32> <140, 4, 40> }
        box { <-10, -1, 18.2> <-3.9, 4, 21.8> }
        box { <123.9, -1, 34.2> <140, 4, 37.8> }
        #if (setting > 1)
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <120, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <56, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <64, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <88, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <96, 0, 56> }
          cylinder { 1*y, 4*y, 1.2 translate <120, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <120, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <120, 0, 32> }
          cylinder { 1*y, 4*y, 1.2 translate <120, 0, 40> }
          cylinder { 1*y, 4*y, 1.2 translate <120, 0, 56> }
        #end
        cylinder { -1*y, 5*y, 1.6 translate <60, 0, 28> }
        cone { 1.5*y, 1.6, 2.9*y, 2.4 translate <60, 0, 28> }
        cylinder { 2.899999*y, 4*y, 2.4 translate <60, 0, 28> }
      }
      #if (setting > 1)
        box { <-0.5, 0.000001, 2.4> <0.5, 2.1, 4.2> }
        box { <23.5, 0.000001, 2.4> <24.5, 2.1, 4.2> }
        box { <31.5, 0.000001, 2.4> <32.5, 2.1, 4.2> }
        box { <55.5, 0.000001, 2.4> <56.5, 2.1, 4.2> }
        box { <63.5, 0.000001, 2.4> <64.5, 2.1, 4.2> }
        box { <87.5, 0.000001, 2.4> <88.5, 2.1, 4.2> }
        box { <95.5, 0.000001, 2.4> <96.5, 2.1, 4.2> }
        box { <119.5, 0.000001, 2.4> <120.5, 2.1, 4.2> }
        box { <-0.5, 0.000001, 51.8> <0.5, 2.1, 53.6> }
        box { <23.5, 0.000001, 51.8> <24.5, 2.1, 53.6> }
        box { <31.5, 0.000001, 51.8> <32.5, 2.1, 53.6> }
        box { <55.5, 0.000001, 51.8> <56.5, 2.1, 53.6> }
        box { <63.5, 0.000001, 51.8> <64.5, 2.1, 53.6> }
        box { <87.5, 0.000001, 51.8> <88.5, 2.1, 53.6> }
        box { <95.5, 0.000001, 51.8> <96.5, 2.1, 53.6> }
        box { <119.5, 0.000001, 51.8> <120.5, 2.1, 53.6> }
        box { <23.5, 0.000001, 11.8> <24.5, 2.1, 13.6> }
        box { <23.5, 0.000001, 42.4> <24.5, 2.1, 44.2> }
        box { <31.5, 0.000001, 11.8> <32.5, 2.1, 13.6> }
        box { <31.5, 0.000001, 42.4> <32.5, 2.1, 44.2> }
        box { <55.5, 0.000001, 11.8> <56.5, 2.1, 13.6> }
        box { <55.5, 0.000001, 42.4> <56.5, 2.1, 44.2> }
        box { <63.5, 0.000001, 11.8> <64.5, 2.1, 13.6> }
        box { <63.5, 0.000001, 42.4> <64.5, 2.1, 44.2> }
        box { <87.5, 0.000001, 11.8> <88.5, 2.1, 13.6> }
        box { <87.5, 0.000001, 42.4> <88.5, 2.1, 44.2> }
        box { <95.5, 0.000001, 11.8> <96.5, 2.1, 13.6> }
        box { <95.5, 0.000001, 42.4> <96.5, 2.1, 44.2> }
        object { pin(2) translate <28, 0, 0> }
        object { pin(2) translate <60, 0, 0> }
        object { pin(2) translate <92, 0, 0> }
        object { pin(2) translate <28, 0, 56> }
        object { pin(2) translate <60, 0, 56> }
        object { pin(2) translate <92, 0, 56> }
        difference {
          cylinder { 0.000002*y, 3.100002*y, 1.9 }
          cylinder { -1*y, 4*y, 0.7 }
          translate <-3.9, 0, 36>
        }
        difference {
          cylinder { 0.000002*y, 3.100002*y, 1.9 }
          cylinder { -1*y, 4*y, 0.7 }
          translate <123.9, 0, 20>
        }
        box { <27.6, 0.000005, 5> <28.4, 3.5, 11> }
        box { <59.6, 0.000005, 5> <60.4, 3.5, 11> }
        box { <91.6, 0.000005, 5> <92.4, 3.5, 11> }
        box { <27.6, 0.000005, 45> <28.4, 3.5, 51> }
        box { <59.6, 0.000005, 45> <60.4, 3.5, 51> }
        box { <91.6, 0.000005, 45> <92.4, 3.5, 51> }
        object { ring() translate <28, 0, 20> }
        object { ring() translate <28, 0, 28> }
        object { ring() translate <28, 0, 36> }
        object { ring() translate <60, 0, 20> }
        object { ring() translate <60, 0, 36> }
        object { ring() translate <92, 0, 20> }
        object { ring() translate <92, 0, 28> }
        object { ring() translate <92, 0, 36> }
      #end
      merge {
        box { <1, 7.7, 6.69> <119, 9.51, 9.32> }
        box { <-6.7, 7.7, 8.1> <1.1, 9.510001, 9.320001> }
        box { <-6.7, 6.7, 7.75> <-0.1, 9.510002, 8.05> }
        box { <118.9, 7.7, 6.679999> <126.7, 9.510001, 7.9> }
        box { <118.9, 6.7, 7.95> <126.7, 9.510002, 8.25> }
        sphere { <-3, 7.8, 7.75> 0.5 }
        sphere { <123, 7.8, 8.25> 0.5 }
        cylinder { 6.6*x, 12.4*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 7.1> }
        cylinder { 6.6*x, 12.4*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 8.9> }
        cylinder { 41.1*x, 46.9*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 7.1> }
        cylinder { 41.1*x, 46.9*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 8.9> }
        cylinder { 73.1*x, 78.9*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 7.1> }
        cylinder { 73.1*x, 78.9*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 8.9> }
        cylinder { 107.6*x, 113.4*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 7.1> }
        cylinder { 107.6*x, 13.4*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 8.9> }
        box { <1, 7.7, 46.69> <119, 9.51, 49.32> }
        box { <-6.7, 7.7, 48.1> <1.1, 9.510001, 49.320001> }
        box { <-6.7, 6.7, 47.75> <-0.1, 9.510002, 48.05> }
        box { <118.9, 7.7, 46.679999> <126.7, 9.510001, 47.9> }
        box { <118.9, 6.7, 47.95> <126.7, 9.510002, 48.25> }
        sphere { <-3, 7.8, 47.75> 0.5 }
        sphere { <123, 7.8, 48.25> 0.5 }
        cylinder { 6.6*x, 12.4*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 47.1> }
        cylinder { 6.6*x, 12.4*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 48.9> }
        cylinder { 41.1*x, 46.9*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 47.1> }
        cylinder { 41.1*x, 46.9*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 48.9> }
        cylinder { 73.1*x, 78.9*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 47.1> }
        cylinder { 73.1*x, 78.9*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 48.9> }
        cylinder { 107.6*x, 113.4*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 47.1> }
        cylinder { 107.6*x, 13.4*x, 0.5 scale <1, 0.5, 1> translate <0, 7.7, 48.9> }
        texture { chrome_tex }
      }
      texture { grey2_tex }
      bounded_by { box { <-7.8, -0.1, -4> <127.8, 9.61, 60> } }
    }
  #end
#end
#macro train_rc_battery_bottom6_30(color_tex, licht)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <235.9, 6.3, 43.9> }
      box { <76.1, 6.1, 4.1> <155.9, 38.3, 35.9> }
      cylinder { 84.1*x, 147.9*x, 9 translate <0, -10.4, 5.3> }
      cylinder { 84.1*x, 147.9*x, 9 translate <0, -10.4, 34.7> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <44, 3.20001, 0.8> <79, 5.5, 1.8> }
        box { <44, 3.20001, 38.2> <79, 5.5, 39.2> }
        box { <153, 3.20001, 0.8> <188, 5.5, 1.8> }
        box { <153, 3.20001, 38.2> <188, 5.5, 39.2> }
        cylinder { 84.1*x, 147.9*x, 9 translate <0, -10.4, 5.3> }
        cylinder { 84.1*x, 147.9*x, 9 translate <0, -10.4, 34.7> }
        box { <84.10001, -10.4, -3.7> <147.89999, 5.5, 43.7> }
        box { <84.10002, -19.4, 5.3> <147.89998, 5.5, 34.7> }
        box { <100.1, 6.2, -3.90005> <131.9, 9.5, 43.90005> }
        box { <144.1, 30, 18> <146.1, 35.6, 20> }
        difference {
          box { <108.8, -10, -8.9> <123.2, -7.2, 48.9> }
          box { <0, -10, -10> <10, -5, 0> rotate 15*y translate <108.8, 0, -8.2> }
          box { <-10, -10, -10> <0, -5, 0> rotate -15*y translate <123.2, 0, -8.2> }
          box { <0, -10, 0> <10, -5, 10> rotate -15*y translate <108.8, 0, 48.2> }
          box { <-10, -10, 0> <0, -5, 10> rotate 15*y translate <123.2, 0, 48.2> }
          box { <108, -11, -15> <124, -8.2, -7.9> }
          box { <108, -11, 47.9> <124, -8.2, 55> }
          box { <108, -11, -6.7> <124, -7, 46.7> }
          box { <108, -10, -10> <124, 0, 0> rotate -45*x translate <0, -8.2, -7.9> }
          box { <108, -10, 0> <124, 0, 10> rotate 45*x translate <0, -8.2, 47.9> }
        }
        difference {
          box { <76.1, 6.1, 4.1> <155.9, 38.3, 35.9> }
          box { <76, 31.9, 11.9> <92.1, 40, 28.1> }
          box { <139.9, 35.1, 11.9> <156, 40, 28.1> }
          box { <142.6, 32, 17> <146.9, 40, 23> }
          box { <147.1, 34.9, 17> <150.8, 40, 18.8> }
          box { <147.1, 34.9, 19> <150.8, 40, 21> }
          box { <147.1, 34.9, 21.2> <150.8, 40, 23> }
        }
        difference {
          box { <100.10001, -11.20007, -7.9> <131.90001, 9.50004, 47.9> }
          box { <100, 0, -10> <132, 10, 0> rotate 32*x translate <0, 4, -7.9> }
          box { <100, 0, 0> <132, 10, 10> rotate -32*x translate <0, 4, 47.9> }
          box { <0, -0.00001, -10> <10, 10, 0> rotate 26.4*y translate <100.1, 0, -3.9> }
          box { <-10, -0.00001, -10> <0, 10, 0> rotate -26.4*y translate <131.9, 0, -3.9> }
          box { <0, -0.00001, 0> <10, 10, 10> rotate -26.4*y translate <100.1, 0, 43.9> }
          box { <-10, -0.00001, 0> <0, 10, 10> rotate 26.4*y translate <131.9, 0, 43.9> }
          box { <0, -20, -10> <10, 0.00001, 0> rotate 26.4*y translate <100.1, 0, -3.7> }
          box { <-10, -20, -10> <0, 0.00001, 0> rotate -26.4*y translate <131.9, 0, -3.7> }
          box { <0, -20, 0> <10, 0.00001, 10> rotate -26.4*y translate <100.1, 0, 43.7> }
          box { <-10, -20, 0> <0, 0.00001, 10> rotate 26.4*y translate <131.9, 0, 43.7> }
          box { <100, -20, -10> <132, 0.00002, -7.7> }
          box { <100, -20, 50> <132, 0.00002, 47.7> }
          box { <100, -10, -10> <132, 0, 0> rotate -55*x translate <0, -8, -7.9> }
          box { <100, -10, 0> <132, 0, 10> rotate 55*x translate <0, -8, 47.9> }
          box { <108.6, -12, -8> <123.4, -7, 48> }
          difference {
            box { <100, 4.3, 44.6> <116, 10, 50> }
            box { <0, 4, 0> <10, 11, 10> rotate 45*y translate <111, 0, 44.6> }
          }
          box { <106.4, 4.7, 44.5> <109.6, 6.3, 50> }
          merge {
            cylinder { -1*y, -0.49999*y, 2.1 }
            cone { -0.5*y, 2.1, 0.5*y, 3.1 }
            rotate -58*x
            translate <116, 6.3, -5.9>
          }
          merge {
            cylinder { -1*y, -0.49999*y, 2.1 }
            cone { -0.5*y, 2.1, 0.5*y, 3.1 }
            rotate 58*x
            translate <116, 6.3, 45.9>
          }
        }
        merge {
          sphere { <0, 0, 0> 1.75 texture { black_tex } }
          torus { 1.75, 0.25 rotate 90*x rotate 45*y texture { silverish_tex } }
          torus { 1.75, 0.25 rotate 90*x rotate -45*y texture { silverish_tex } }
          translate <0, -0.75, 0> rotate -58*x translate <116, 6.3, -5.9>
        }
        merge {
          sphere { <0, 0, 0> 1.75 texture { black_tex } }
          torus { 1.75, 0.25 rotate 90*x rotate 45*y texture { silverish_tex } }
          torus { 1.75, 0.25 rotate 90*x rotate -45*y texture { silverish_tex } }
          translate <0, -0.75, 0> rotate 58*x translate <116, 6.3, 45.9>
        }
        box { <106.5, 4.8, 44> <109.5, 6.2, 45.9> texture { lt_grey_tex } }
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 translate <104, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <112, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <120, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <128, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <104, 0, 40> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <112, 0, 40> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <120, 0, 40> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <128, 0, 40> }
          cylinder { 38.2*y, 40*y, 2.4 translate <80, 0, 8> }
          cylinder { 38.2*y, 40*y, 2.4 translate <88, 0, 8> }
          cylinder { 38.2*y, 40*y, 2.4 translate <96, 0, 8> }
          cylinder { 38.2*y, 40*y, 2.4 translate <104, 0, 8> }
          cylinder { 38.2*y, 40*y, 2.4 translate <112, 0, 8> }
          cylinder { 38.2*y, 40*y, 2.4 translate <120, 0, 8> }
          cylinder { 38.2*y, 40*y, 2.4 translate <128, 0, 8> }
          cylinder { 38.2*y, 40*y, 2.4 translate <136, 0, 8> }
          cylinder { 38.2*y, 40*y, 2.4 translate <144, 0, 8> }
          cylinder { 38.2*y, 40*y, 2.4 translate <152, 0, 8> }
          cylinder { 38.2*y, 40*y, 2.4 translate <96, 0, 16> }
          cylinder { 38.2*y, 40*y, 2.4 translate <104, 0, 16> }
          cylinder { 38.2*y, 40*y, 2.4 translate <112, 0, 16> }
          cylinder { 38.2*y, 40*y, 2.4 translate <120, 0, 16> }
          cylinder { 38.2*y, 40*y, 2.4 translate <128, 0, 16> }
          cylinder { 38.2*y, 40*y, 2.4 translate <136, 0, 16> }
          cylinder { 38.2*y, 40*y, 2.4 translate <96, 0, 24> }
          cylinder { 38.2*y, 40*y, 2.4 translate <104, 0, 24> }
          cylinder { 38.2*y, 40*y, 2.4 translate <112, 0, 24> }
          cylinder { 38.2*y, 40*y, 2.4 translate <120, 0, 24> }
          cylinder { 38.2*y, 40*y, 2.4 translate <128, 0, 24> }
          cylinder { 38.2*y, 40*y, 2.4 translate <136, 0, 24> }
          cylinder { 38.2*y, 40*y, 2.4 translate <80, 0, 32> }
          cylinder { 38.2*y, 40*y, 2.4 translate <88, 0, 32> }
          cylinder { 38.2*y, 40*y, 2.4 translate <96, 0, 32> }
          cylinder { 38.2*y, 40*y, 2.4 translate <104, 0, 32> }
          cylinder { 38.2*y, 40*y, 2.4 translate <112, 0, 32> }
          cylinder { 38.2*y, 40*y, 2.4 translate <120, 0, 32> }
          cylinder { 38.2*y, 40*y, 2.4 translate <128, 0, 32> }
          cylinder { 38.2*y, 40*y, 2.4 translate <136, 0, 32> }
          cylinder { 38.2*y, 40*y, 2.4 translate <144, 0, 32> }
          cylinder { 38.2*y, 40*y, 2.4 translate <152, 0, 32> }
          cylinder { 35*y, 36.8*y, 2.4 translate <152, 0, 24> }
          cylinder { 35*y, 36.8*y, 2.4 translate <152, 0, 16> }
        #else
          object { rounded_button() translate <104, 6.4, 0> }
          object { rounded_button() translate <112, 6.4, 0> }
          object { rounded_button() translate <120, 6.4, 0> }
          object { rounded_button() translate <128, 6.4, 0> }
          object { rounded_button() translate <104, 6.4, 40> }
          object { rounded_button() translate <112, 6.4, 40> }
          object { rounded_button() translate <120, 6.4, 40> }
          object { rounded_button() translate <128, 6.4, 40> }
          object { rounded_button() translate <80, 35.2, 8> }
          object { rounded_button() translate <88, 35.2, 8> }
          object { rounded_button() translate <96, 35.2, 8> }
          object { rounded_button() translate <104, 35.2, 8> }
          object { rounded_button() translate <112, 35.2, 8> }
          object { rounded_button() translate <120, 35.2, 8> }
          object { rounded_button() translate <128, 35.2, 8> }
          object { rounded_button() translate <136, 35.2, 8> }
          object { rounded_button() translate <144, 35.2, 8> }
          object { rounded_button() translate <152, 35.2, 8> }
          object { rounded_button() translate <96, 35.2, 16> }
          object { rounded_button() translate <104, 35.2, 16> }
          object { rounded_button() translate <112, 35.2, 16> }
          object { rounded_button() translate <120, 35.2, 16> }
          object { rounded_button() translate <128, 35.2, 16> }
          object { rounded_button() translate <136, 35.2, 16> }
          object { rounded_button() translate <96, 35.2, 24> }
          object { rounded_button() translate <104, 35.2, 24> }
          object { rounded_button() translate <112, 35.2, 24> }
          object { rounded_button() translate <120, 35.2, 24> }
          object { rounded_button() translate <128, 35.2, 24> }
          object { rounded_button() translate <136, 35.2, 24> }
          object { rounded_button() translate <80, 35.2, 32> }
          object { rounded_button() translate <88, 35.2, 32> }
          object { rounded_button() translate <96, 35.2, 32> }
          object { rounded_button() translate <104, 35.2, 32> }
          object { rounded_button() translate <112, 35.2, 32> }
          object { rounded_button() translate <120, 35.2, 32> }
          object { rounded_button() translate <128, 35.2, 32> }
          object { rounded_button() translate <136, 35.2, 32> }
          object { rounded_button() translate <144, 35.2, 32> }
          object { rounded_button() translate <152, 35.2, 32> }
          object { rounded_button() translate <152, 32, 24> }
          object { rounded_button() translate <152, 32, 16> }
        #end
        object { conductive_button() rotate 90*y translate <80, 28.8, 16> }
        object { conductive_button() rotate 90*y translate <88, 28.8, 16> }
        object { conductive_button() rotate -90*y translate <80, 28.8, 24> }
        object { conductive_button() rotate -90*y translate <88, 28.8, 24> }
        difference {
          box { <-3.9, 0, -3.9> <235.9, 6.3, 43.9> }
          cylinder { 5*y, 6*y, 1 translate <152, 0, 15> }
          #if (setting > 1)
            #local teller2 = 0;
            #while (teller2 < 6)
              #local teller = 0;
              #while (teller < 30)
                cylinder { 4.2*y, 7.2*y, 1.2 translate <(teller*8), 0, (teller2*8)> }
                #local teller = teller + 1;
              #end
            #local teller2 = teller2 + 1;
            #end
            box { <155.9, -1, 11.9> <164.1, 15, 28.1> }
            box { <-2.4, -1, -2.4> <234.4, 5.4, 42.4> }
            cylinder { -1*y, 7*y, 2.600001 translate <28, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <36, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <44, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <52, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <180, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <188, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <196, 0, 20> }
            cylinder { -1*y, 7*y, 2.600001 translate <204, 0, 20> }
          #end
        }
        #local teller2 = 0;
        #while (teller2 < 6)
          #local teller = 0;
          #while (teller < 30)
            #if (setting < 3)
              cylinder { 6.2*y, 8*y, 2.4 translate <(teller*8), 0, (teller2*8)> }
            #else
              object { rounded_button() translate <(teller*8), 3.2, (teller2*8)> }
            #end
            #local teller = teller + 1;
          #end
          #local teller2 = teller2 + 1;
        #end
        #if (setting > 1)
          #local teller2 = 0;
          #while (teller2 < 5)
            #local teller = 0;
            #while (teller < 29)
              #if (teller = 2)
                #local teller = 27;
              #end
              object { ring() translate <(teller*8)+4, 3.2, (teller2*8)+4> }
              #local teller = teller + 1;
            #end
            #local teller2 = teller2 + 1;
          #end
          object { ring() translate <28, 3.20001, 20> }
          object { ring() translate <36, 3.20001, 20> }
          object { ring() translate <44, 3.20001, 20> }
          object { ring() translate <52, 3.20001, 20> }
          object { ring() translate <180, 3.20001, 20> }
          object { ring() translate <188, 3.20001, 20> }
          object { ring() translate <196, 3.20001, 20> }
          object { ring() translate <204, 3.20001, 20> }
          box { <19.5, 3.2, -2.5> <20.5, 5.5, 42.5> }
          box { <211.5, 3.2, -2.5> <212.5, 5.5, 42.5> }
          box { <27.5, 3.2, -2.5> <28.5, 5.5, 17> }
          box { <27.5, 3.2, 23> <28.5, 5.5, 42.5> }
          box { <35.5, 3.2, -2.5> <36.5, 5.5, 17> }
          box { <35.5, 3.2, 23> <36.5, 5.5, 42.5> }
          box { <43.5, 3.2, -2.5> <44.5, 5.5, 17> }
          box { <43.5, 3.2, 23> <44.5, 5.5, 42.5> }
          box { <187.5, 3.2, -2.5> <188.5, 5.5, 17> }
          box { <187.5, 3.2, 23> <188.5, 5.5, 42.5> }
          box { <195.5, 3.2, -2.5> <196.5, 5.5, 17> }
          box { <195.5, 3.2, 23> <196.5, 5.5, 42.5> }
          box { <203.5, 3.2, -2.5> <204.5, 5.5, 17> }
          box { <203.5, 3.2, 23> <204.5, 5.5, 42.5> }
          #if (licht = 1)
            light_source { <152, 5.4, 15> color (_red / 4) }
          #end
        #end
      }
      difference {
        merge {
          box { <111, -4.7, -8> <121, -3.7, 48> }
          cylinder { -8*z, 48*z, 0.5 translate <111, -4.2, 0> }
          cylinder { -8*z, 48*z, 0.5 translate <121, -4.2, 0> }
        }
        box { <110, -5, -7.7> <122, -3, 47.7> }
        cylinder { -9*z, 49*z, 0.3 translate <111, -4.2, 0> }
        cylinder { -9*z, 49*z, 0.3 translate <121, -4.2, 0> }
        box { <111, -4.5, -9> <121, -3.9, 49> }
      }
      box { <85.3, -20, -4> <86.8, 0.00001, -3.5> }
      box { <88.3, -20, -4> <89.8, 0.00001, -3.5> }
      box { <91.3, -20, -4> <92.8, 0.00001, -3.5> }
      box { <94.3, -20, -4> <95.8, 0.00001, -3.5> }
      box { <85.3, -20, 44> <86.8, 0.00001, 43.5> }
      box { <88.3, -20, 44> <89.8, 0.00001, 43.5> }
      box { <91.3, -20, 44> <92.8, 0.00001, 43.5> }
      box { <94.3, -20, 44> <95.8, 0.00001, 43.5> }
      box { <136.3, -20, -4> <137.8, 0.00001, -3.5> }
      box { <139.3, -20, -4> <140.8, 0.00001, -3.5> }
      box { <142.3, -20, -4> <143.8, 0.00001, -3.5> }
      box { <145.3, -20, -4> <146.8, 0.00001, -3.5> }
      box { <136.3, -20, 44> <137.8, 0.00001, 43.5> }
      box { <139.3, -20, 44> <140.8, 0.00001, 43.5> }
      box { <142.3, -20, 44> <143.8, 0.00001, 43.5> }
      box { <145.3, -20, 44> <146.8, 0.00001, 43.5> }
      box { <84, -11.3, -20> <108, -11.2, -2.8> }
      box { <84, -11.3, 42.8> <108, -11.2, 60> }
      box { <124, -11.3, -20> <148, -11.2, -2.8> }
      box { <124, -11.3, 42.8> <148, -11.2, 60> }
      cylinder { 0*y, 16*y, 8 translate <76, 0, 13.8> }
      cylinder { 0*y, 16*y, 8 translate <76, 0, 26.2> }
      box { <68, 0, 13.8> <84.10001, 16.00002, 26.2> }
      box { <76, 0, 5.8> <84.10005, 16.00003, 34.2> }
      box { <69, 6.30005, 5> <75, 10, 11> }
      box { <69, 6.30005, 29> <75, 10, 35> }
      box { <157, 5, 13> <163, 10, 19> }
      box { <157, 5, 21> <163, 10, 27> }
      texture { color_tex }
      bounded_by { box { <-4, -19.5, -9> <236, 40.1, 49> } }
    }
  #end
#end
#macro train_rc_motor(color_tex)
  #if (setting = 0)
    box { <-39.9, 3.1, -15.9> <39.9, 24.6, 15.9> texture { color_tex } }
  #else
    union {
      difference {
        cylinder { -15.9*z, 15.9*z, 2.9 }
        cylinder { -16*z, 16*z, 2.4 }
        translate <-23.9, 8.5, 0>
        texture { white_tex }
      }
      difference {
        cylinder { -15.9*z, 15.9*z, 2.9 }
        cylinder { -16*z, 16*z, 2.4 }
        translate <23.9, 8.5, 0>
        texture { white_tex }
      }
      merge {
        difference {
          merge {
            box { <-39.9, 3.1, -15.9> <39.9, 24.6, 15.9> }
            box { <-42.9, 3.10001, -14.4> <42.9, 6.2, -9.6> }
            box { <-42.9, 3.10002, 14.4> <42.9, 6.2, 9.6> }
            cylinder { -2.4*z, 2.4*z, 0.7 translate <-42.2, 8.1, -12> }
            cylinder { -2.4*z, 2.4*z, 0.7 translate <42.2, 8.1, -12> }
            cylinder { -2.4*z, 2.4*z, 0.7 translate <-42.2, 8.1, 12> }
            cylinder { -2.4*z, 2.4*z, 0.7 translate <42.2, 8.1, 12> }
            box { <-42.900001, 6, -14.40001> <-41.5, 8.100001, -9.59999> }
            box { <-42.900001, 6, 14.40001> <-41.5, 8.100001, 9.59999> }
            box { <42.900001, 6, -14.40001> <41.5, 8.100001, -9.59999> }
            box { <42.900001, 6, 14.40001> <41.5, 8.100001, 9.59999> }
            difference {
              cylinder { 24.5*y, 25.8*y, 4.3 }
              cylinder { 24*y, 26*y, 3.5 }
              box { <-2.5, 24, 2> <0, 26, 5.5> rotate 30*y }
              box { <2.5, 24, 2> <0, 26, 5.5> rotate -30*y }
              box { <-2.5, 24, -2> <0, 26, -5.5> rotate -30*y }
              box { <2.5, 24, -2> <0, 26, -5.5> rotate 30*y }
            }
            cylinder { 24.5*y, 25.80001*y, 0.4 translate <3.9, 0, 0> rotate -60*y }
            cylinder { 24.5*y, 25.80001*y, 0.4 translate <3.9, 0, 0> rotate -120*y }
            cylinder { 24.5*y, 25.80001*y, 0.4 translate <3.9, 0, 0> rotate 60*y }
            cylinder { 24.5*y, 25.80001*y, 0.4 translate <3.9, 0, 0> rotate 120*y }
          }
          box { <-50, 0, -16> <-31.9, 4.1, 16> }
          box { <50, 0, -16> <31.9, 4.1, 16> }
          difference {
            box { <-38.4, 0, -14.4> <-33.6, 6.1, 14.4> }
            object { pin(2) translate <-36, 4.10001, -8> }
            object { pin(2) translate <-36, 4.10001, 0> }
            object { pin(2) translate <-36, 4.10001, 8> }
          }
          difference {
            box { <38.4, 0, -14.4> <33.6, 6.1, 14.4> }
            object { pin(2) translate <36, 4.10001, -8> }
            object { pin(2) translate <36, 4.10001, 0> }
            object { pin(2) translate <36, 4.10001, 8> }
          }
          cylinder { 24.1*y, 26*y, 2 translate <16, 0, -9> }
          cylinder { 24.1*y, 26*y, 2 translate <-16, 0, 9> }
          #if (setting > 1)
            box { <-50, 0, -13.8> <-39.900001, 5.5, -10.2> }
            box { <-50, 0, 13.8> <-39.900001, 5.5, 10.2> }
            box { <50, 0, -13.8> <39.900001, 5.5, -10.2> }
            box { <50, 0, 13.8> <39.900001, 5.5, 10.2> }
            box { <-50, 0, -16> <-42.2, 5.50001, 16> }
            box { <42.2, 0, 0> <50, 5.50001, 0> }
            cylinder { -16*z, -15.4*z, 3.1 translate <0, 8.5, 0> }
            cylinder { -16*z, -12.4*z, 2.5 translate <0, 8.5, 0> }
            cylinder { 16*z, -5.4*z, 3.1 translate <0, 8.5, 0> }
            cylinder { 16*z, 12.4*z, 2.5 translate <0, 8.5, 0> }
            cylinder { 2*y, 7*y, 1.6 translate <-15.5, 0, 11.5> }
            cylinder { 2*y, 7*y, 1.6 translate <15.5, 0, -11.5> }
            cylinder { 2*y, 7*y, 1.6 translate <-36, 0, 12> }
            cylinder { 2*y, 7*y, 1.6 translate <36, 0, 12> }
            cylinder { 2*y, 7*y, 1.6 translate <-36, 0, -12> }
            cylinder { 2*y, 7*y, 1.6 translate <36, 0, -12> }
            box { <-19.1, 0, -15.2> <19.1, 4.1, -14.2> }
            box { <-19.1, 0, 14.2> <19.1, 4.1, 15.2> }
            box { <-3.2, 0, -15.20001> <3.2, 6.1, -12.8> }
            box { <-3.2, 0, 12.8> <3.2, 6.1, 15.20001> }
          #end
          box { <-40, 18.1, -20> <-23.9, 25, 20> }
          box { <-10, 0, -20> <0, 10, 20> rotate 5*z translate <-19.4, 24.6, 0> }
          box { <40, 18.1, -20> <23.9, 25, 20> }
          box { <0, 0, -20> <10, 10, 20> rotate -5*z translate <19.4, 24.6, 0> }
          box { <-25, 0, -10> <25, 10, 0> rotate -5*x translate <0, 24.6, -11.4> }
          box { <-25, 0, 0> <25, 10, 10> rotate 5*x translate <0, 24.6, 11.4> }
          cylinder { -20*z, 20*z, 3 translate <-23.9, 8.5, 0> }
          cylinder { -20*z, 20*z, 3 translate <23.9, 8.5, 0> }
        }
        #if (setting < 3)
          cylinder { 18*y, 19.8*y, 2.4 translate <-36, 0, -12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-36, 0, -4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-36, 0, 4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-36, 0, 12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-28, 0, -12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-28, 0, -4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-28, 0, 4> }
          cylinder { 18*y, 19.8*y, 2.4 translate <-28, 0, 12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <36, 0, -12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <36, 0, 12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <28, 0, -12> }
          cylinder { 18*y, 19.8*y, 2.4 translate <28, 0, 12> }
        #else
          object { rounded_button() rotate 180*y translate <-36, 15, -12> }
          object { rounded_button() rotate 180*y translate <-36, 15, -4> }
          object { rounded_button() rotate 180*y translate <-36, 15, 4> }
          object { rounded_button() rotate 180*y translate <-36, 15, 12> }
          object { rounded_button() rotate 180*y translate <-28, 15, -12> }
          object { rounded_button() rotate 180*y translate <-28, 15, -4> }
          object { rounded_button() rotate 180*y translate <-28, 15, 4> }
          object { rounded_button() rotate 180*y translate <-28, 15, 12> }
          object { rounded_button() rotate 180*y translate <36, 15, -12> }
          object { rounded_button() rotate 180*y translate <36, 15, 12> }
          object { rounded_button() rotate 180*y translate <28, 15, -12> }
          object { rounded_button() rotate 180*y translate <28, 15, 12> }
        #end
        object { conductive_button() rotate 90*y translate <28, 15, -4> }
        object { conductive_button() rotate 90*y translate <36, 15, -4> }
        object { conductive_button() rotate -90*y translate <28, 15, 4> }
        object { conductive_button() rotate -90*y translate <36, 15, 4> }
        difference {
          merge {
            cylinder { 23.9*y, 30.7*y, 2.25 }
            cylinder { 30.6*y, 31.1*y, 2.5 }
          }
          box { <-4, 28.4, -0.5> <4, 32.1, 0.5> }
          cylinder { 23.1*y, 32.1*y, 1.6 }
        }
      }
      texture { color_tex }
      bounded_by { box { <-43, -3.4, -24.6> <43, 31.2, 24.6> } }
    }
  #end
#end
#macro train_rc_motor_ornaments(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -5> <75.9, 19.1, 11.9> }
      box { <20, 15.999999, -10> <52, 20, 20> }
      box { <-4, -1, 3.9> <76, 16, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.900001, 3.1, -4.2> <75.900001, 19.1, 4.100001> }
        cylinder { 3*y, 20*y, 1.6 translate <-3.9, 0, 2.5> }
        cylinder { 3*y, 20*y, 1.6 translate <75.9, 0, 2.5> }
        box { <-4, 0, -5> <-2.3, 20, 2.5> } 
        box { <74.3, 0, -5> <77, 20, 2.5> }
        box { <-4, 0, -5> <-2.3, 16, 5> }
        box { <74.3, 0, -5> <77, 16, 5> }
        cylinder { 3*y, 20*y, 1.6 translate <5.6, 0, 2.5> }
        cylinder { 3*y, 20*y, 1.6 translate <5.6, 0, -0.4> }
        difference {
          box { <5.599999, 3, -2.000001> <24, 20, 4.100002> }
          box { <0, 2, 0> <10, 21, 10> rotate 35*y translate <20, 0, -2> }
        }
        box { <4, 3, -0.400001> <13, 20, 2.500001> }
        cylinder { 3*y, 20*y, 1.6 translate <66.4, 0, 2.5> }
        cylinder { 3*y, 20*y, 1.6 translate <66.4, 0, -0.4> }
        difference {
          box { <48, 3, -2.000001> <66.400001, 20, 4.100002> }
          box { <-10, 2, 0> <0, 21, 10> rotate -35*y translate <52, 0, -2> }
        }
        box { <25.6, 14, -2.4> <30.4, 17, 2.4> }
        box { <33.6, 14, -2.4> <38.4, 17, 2.4> }
        box { <41.6, 14, -2.4> <46.4, 17, 2.4> }
        box { <59, 3, -0.400001> <68, 20, 2.500001> }
        box { <-4.000005, 16, -10> <76.000005, 20, -2> }
        box { <20, 16.000001, -10> <52, 20, 20> }
        box { <-4, 0, 0> <76, 10, 10> rotate -24*x translate <0, 16, -2> }
        box { <-4.000006, 0, -5> <0.1, 20, -2> }
        box { <-10, 0, 0> <0, 20, 5> rotate -28*y translate <0.1, 0, -2> }
        box { <71.9000006, 0, -5> <76, 20, -2> }
        box { <0, 0, 0> <10, 20, 5> rotate 28*y translate <71.9, 0, -2> }
        difference {
          box { <19.9, 0, -5> <52.1, 12.8, 10> }
          box { <20, 0, 0> <23.9, 10, 10> rotate -23*x translate <0, 9.6, -4.2> }
          box { <48.1, 0, 0> <66, 10, 10> rotate -23*x translate <0, 9.6, -4.2> }
          box { <19, 0, -6> <23.900005, 13, -2.000003> }
          box { <48.100005, 0, -6> <66, 13, -2.000003> }
        }
        box { <0, -10, -10> <20, 0, -1.999999> rotate -40*z translate <0, 9.6, 0> }
        box { <-20, -10, -10> <0, 0, -1.999999> rotate 40*z translate <24, 9.6, 0> }
        box { <0, -10, -10> <20, 0, -1.999999> rotate -40*z translate <48, 9.6, 0> }
        box { <-20, -10, -10> <0, 0, -1.999999> rotate 40*z translate <72, 9.6, 0> }
        difference {
          box { <-1, 0, 4.100009> <20.000001, 19, -2.000005> }
          box { <-10, 0, 0> <0, 20, 5> rotate -28*y translate <1.6, 0, -2> }
          box { <-4, 0, 0> <76, 10, 10> rotate -24*x translate <0, 15, -2> }
          box { <2.4, 0, 0> <4.000004, 10, 10> rotate -24*x translate <0, 12.8, -2> }
        }
        difference {
          box { <51.999999, 0, 4.100009> <73, 19, -2.000005> }
          box { <0, 0, 0> <10, 20, 5> rotate 28*y translate <70.4, 0, -2> }
          box { <-4, 0, 0> <76, 10, 10> rotate -24*x translate <0, 15, -2> }
          box { <68.000004, 0, 0> <69.6, 10, 10> rotate -24*x translate <0, 12.8, -2> }
        }
        box { <-4.000007, 0, -2.000008> <76.000007, 9.6, 10> }
        box { <-4.000008, 0, -6> <76.000008, 5.4, -3.5> }
        #if (setting > 1)
          difference {
            box { <1, 5.399999, -6> <22.9, 12.8, -3.500001> }
            torus { 3.5, 0.5 translate <7.8, 10, -0.2125> }
            torus { 3.5, 0.5 translate <7.8, 8.9, -0.2125> }
            torus { 3.5, 0.5 translate <7.8, 7.8, -0.2125> }
            torus { 3.5, 0.5 translate <7.8, 6.7, -0.2125> }
            torus { 3.5, 0.5 translate <16.2, 10, -0.2125> }
            torus { 3.5, 0.5 translate <16.2, 8.9, -0.2125> }
            torus { 3.5, 0.5 translate <16.2, 7.8, -0.2125> }
            torus { 3.5, 0.5 translate <16.2, 6.7, -0.2125> }
            box { <0, -10, -10> <20, 0, -1.999999> rotate -40*z translate <0, 10.6, 0> }
            box { <-20, -10, -10> <0, 0, -1.999999> rotate 40*z translate <24, 10.6, 0> }
            box { <0, 5.4, -7> <7.8, 6.4, -3> }
            box { <16.2, 5.4, -7> <24, 6.4, -3> }
            cylinder { 5.399999*y, 6.400001*y, 1 translate <7.8, 0, -3.2> }
            cylinder { 5.399999*y, 6.400001*y, 1 translate <16.2, 0, -3.2> }
            box { <6.5, 10.5, -7> <17.5, 13, -3> }
            difference {
              box { <4.7, 11, -7> <19.3, 13, -3> }
              cylinder { -8*z, -2*z, 1.8 translate <4.7, 11, 0> }
              cylinder { -8*z, -2*z, 1.8 translate <19.3, 11, 0> }
            }
          }
          difference {
            box { <49, 5.399999, -6> <70.9, 12.8, -3.500001> }
            torus { 3.5, 0.5 translate <55.8, 10, -0.2125> }
            torus { 3.5, 0.5 translate <55.8, 8.9, -0.2125> }
            torus { 3.5, 0.5 translate <55.8, 7.8, -0.2125> }
            torus { 3.5, 0.5 translate <55.8, 6.7, -0.2125> }
            torus { 3.5, 0.5 translate <64.2, 10, -0.2125> }
            torus { 3.5, 0.5 translate <64.2, 8.9, -0.2125> }
            torus { 3.5, 0.5 translate <64.2, 7.8, -0.2125> }
            torus { 3.5, 0.5 translate <64.2, 6.7, -0.2125> }
            box { <0, -10, -10> <20, 0, -1.999999> rotate -40*z translate <48, 10.6, 0> }
            box { <-20, -10, -10> <0, 0, -1.999999> rotate 40*z translate <72, 10.6, 0> }
            box { <48, 5.4, -7> <55.8, 6.4, -3> }
            box { <64.2, 5.4, -7> <72, 6.4, -3> }
            cylinder { 5.399999*y, 6.400001*y, 1 translate <55.8, 0, -3.2> }
            cylinder { 5.399999*y, 6.400001*y, 1 translate <64.2, 0, -3.2> }
            box { <54.5, 10.5, -7> <65.5, 13, -3> }
            difference {
              box { <52.7, 11, -7> <67.3, 13, -3> }
              cylinder { -8*z, -2*z, 1.8 translate <52.7, 11, 0> }
              cylinder { -8*z, -2*z, 1.8 translate <67.3, 11, 0> }
            }
          }
        #end
        cylinder { -5*z, 0*z, 2.5 translate <12, 5.4, 0> }
        cylinder { -5*z, 0*z, 2.5 translate <60, 5.4, 0> }
        box { <9.5, 0, -5> <14.5, 5.4, 0> }
        box { <57.5, 0, -5> <62.5, 5.4, 0> }
        difference {
          box { <4.1, 12.8, -5> <19.9, 20, -1.999994> }
          box { <0, -10, -10> <20, 0, -1.999999> rotate -40*z translate <0, 19.6, 0> }
          box { <-20, -10, -10> <0, 0, -1.999999> rotate 40*z translate <24, 19.6, 0> }
        }
        difference {
          box { <52.1, 12.8, -5> <67.9, 20, -1.999994> }
          box { <0, -10, -10> <20, 0, -1.999999> rotate -40*z translate <48, 19.6, 0> }
          box { <-20, -10, -10> <0, 0, -1.999999> rotate 40*z translate <72, 19.6, 0> }
        }
      }
      difference {
        box { <-3.9, 16, 4.1> <11.9, 19.1, 11.9> }
        box { <-4, 0, -10> <12, 10, 0> rotate -10*x translate <0, 19.1, 5.9> }
        box { <-4, 0, 0> <12, 10, 10> rotate 10*x translate <0, 19.1, 10.1> }
        box { <-10, 0, 0> <0, 10, 12> rotate 10*z translate <-2.1, 19.1, 0> }
        box { <0, 0, 0> <10, 10, 12> rotate -10*z translate <10.1, 19.1, 0> }
        box { <-2.4, 15, 5.6> <10.4, 18, 10.4> }
      }
      difference {
        box { <60.1, 16, 4.1> <75.9, 19.1, 11.9> }
        box { <60, 0, -10> <76, 10, 0> rotate -10*x translate <0, 19.1, 5.9> }
        box { <60, 0, 0> <76, 10, 10> rotate 10*x translate <0, 19.1, 10.1> }
        box { <-10, 0, 0> <0, 10, 12> rotate 10*z translate <61.9, 19.1, 0> }
        box { <0, 0, 0> <10, 10, 12> rotate -10*z translate <74.1, 19.1, 0> }
        box { <61.6, 15, 5.6> <74.4, 18, 10.4> }
      }
      object { pin(2) translate <4, 16, 8> }
      object { pin(2) translate <68, 16, 8> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <32, 16, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <40, 16, 0> }
      #end
      object { open_rounded_button() translate <32, 13, 0> }
      object { open_rounded_button() translate <40, 13, 0> }
      difference {
        cylinder { 16.000002*y, 13.9*y, 2.400001 }
        cylinder {13*y, 17*y, 1.600001 }
        translate <32, 0, 0>
      }
      difference {
        cylinder { 16.000002*y, 13.9*y, 2.400001 }
        cylinder {13*y, 17*y, 1.600001 }
        translate <40, 0, 0>
      }
      difference {
        merge {
          cylinder { 9.4*y, 12.9*y, 4 }
          torus { 3, 2 translate <0, 10.7, 0> }
          cylinder { 0*z, 5*z, 2 translate <-3, 10.7, 0> }
          cylinder { 0*z, 5*z, 2 translate <3, 10.7, 0> }
          cylinder { 6.2*y, 10.7*y, 5 }
          cylinder { 5.2*y, 12.7*y, 3 }
          torus { 3, 2 translate <0, 6.2, 0> }
          cylinder { 0*z, 5*z, 2 translate <-3, 6.2, 0> }
          cylinder { 0*z, 5*z, 2 translate <3, 6.2, 0> }
          box { <-5, 6.2, 0> <5, 10.7, 5> }
          box { <-3, 4.2, 0> <3, 12.7, 5> }
          cylinder { 3.1*y, 4.2*y, 3.25 }
          box { <-3.9, 0, -4.2> <3.9, 3.1, 4.100008> }
          box { <-4, 9.4, 0> <4, 12.9, 5> }
          box { <-3.25, 3.1, 0> <3.25, 4.2, 5> }
        }
        box { <-6, -1, 4.100009> <6, 15, 10> }
        box { <-2, 5.200001, -2.9> <2, 15, 5> }
        torus { 3, 1 translate <0, 10.7, 0> }
        torus { 3, 1 translate <0, 6.2, 0> }
        cylinder { -0.000001*z, 5*z, 1 translate <-3, 10.7, 0> }
        cylinder { -0.000001*z, 5*z, 1 translate <3, 10.7, 0> }
        cylinder { -0.000001*z, 5*z, 1 translate <-3, 6.2, 0> }
        cylinder { -0.000001*z, 5*z, 1 translate <3, 6.2, 0> }
        box { <-4, 6.2, -0.000001> <4, 10.7, 5> }
        box { <-3, 5.2, -0.000001> <3, 11.7, 5> }
        box { <-2.4, -1, -2.9> <2.4, 2, 2.4> }
        cylinder { 0*y, 4*y, 2.1 }
        box { <-2.1, 0, 0> <2.1, 4.000001, 2.400001> }
        translate <36, 0, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -5.1> <76, 19.2, 12> } }
    }
  #end
#end
#macro train_rc_wheels()
  #if (setting = 0)
  #else
    difference {
      merge {
        torus { 8.5, 0.5 texture { r_grey_tex } rotate 90*x translate <0, 0, -2.5> }
        difference {
          merge {
            cone { -0.5*z, 11.85, -1.5*z, 11.65 }
            cone { -1.49999*z, 11.65, -2.5*z, 8.5 }
            cylinder { 0*z, -0.6*z, 3.3 }
          }
        }
        difference {
          cylinder { -4.9*z, -3.9*z, 8.5 }
          difference {
            cone { -5*z, 7, -4*z, 6 }
            cylinder { -6*z, -2*z, 3.3 }
            box { <-0.4, -8, -4.7> <0.4, 8, -2> rotate 15*z }
            box { <-0.4, -8, -4.7> <0.4, 8, -2> rotate 45*z }
            box { <-0.4, -8, -4.7> <0.4, 8, -2> rotate 75*z }
            box { <-0.4, -8, -4.7> <0.4, 8, -2> rotate 105*z }
            box { <-0.4, -8, -4.7> <0.4, 8, -2> rotate 135*z }
            box { <-0.4, -8, -4.7> <0.4, 8, -2> rotate 165*z }
          }
        }
      }
      difference {
        merge {
          cone { -2.4*z, 7.35, -0.49995*z, 10.55 }
          cylinder { -2.8*z, -2.3*z, 6 }
        }
        cylinder { -4*z, 0*z, 3.3 }
        box { <-0.4, 0, -0.50003> <0.4, 15, -4> rotate 15*z }
        box { <-0.4, 0, -0.50003> <0.4, 15, -4> rotate 135*z }
        box { <-0.4, 0, -0.50003> <0.4, 15, -4> rotate 255*z }
      }
      object { axle_opening(8,1) rotate -90*y translate <0, 0, -5> }
      texture { black_tex }
      bounded_by { cylinder { -5*z, 0*z, 11.95 } }
    }
  #end
#end
#macro train_roof(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 9.5, 43.9> }
      box { <-20, 0, -10> <10, 10, 50> rotate 24.5*z translate <12, 9.5, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <43.9, 9.5, 43.9> }
          box { <-20, 0, -10> <10, 10, 50> texture { color_tex normal { bumping } }
            rotate 25*z translate <12, 9.5, 0> }
          box { <-20, 0, -50> <20, 20, 20> texture { color_tex normal { bumping } }
            rotate 43.5*z rotate -90*y translate <0, 9.5, 4> }
          box { <-20, 0, -50> <20, 20, 20> texture { color_tex normal { bumping } }
            rotate -43.5*z rotate -90*y translate <0, 9.5, 36> }
          box { <-30, 0, -20> <10, 20, 20> texture { color_tex normal { bumping } }
            rotate -33.5*x rotate 44*y translate <12, 9.5, 4.1> }
          box { <-30, 0, -20> <10, 20, 20> texture { color_tex normal { bumping } }
            rotate 33.5*x rotate -44*y translate <12, 9.5, 36> }
          box { <11.9, 6.3, 3.9> <44, 10, 36.1> }
          box { <3.9, -1, 3.9> <44, 3.2, 36.1> }
          box { <11.900001, 0, 11.9> <44, 10, 28.1> }
          box { <19.900001, 0, 3.900007> <36.1, 10, 36.100007> }
          box { <-20, -1, -20> <0, 10, 0> rotate 45*y translate <4, 0, -3.9> }
          box { <-20, -1, 0> <0, 10, 20> rotate -45*y translate <4, 0, 43.9> }
        }
        #if (setting < 3)
          cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, 8> }
          cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, 32> }
          cylinder { 6.2*y, 8*y, 2.4 translate <40, 0, 8> }
          cylinder { 6.2*y, 8*y, 2.4 translate <40, 0, 32> }
        #else
          object { rounded_button() translate <16, 3.2, 8> }
          object { rounded_button() translate <16, 3.2, 32> }
          object { rounded_button() translate <40, 3.2, 8> }
          object { rounded_button() translate <40, 3.2, 32> }
        #end
      }
      #if (setting > 1)
        cylinder { 4.2*y, 7.2*y, 1.2 translate <16, 0, 8> }
        cylinder { 4.2*y, 7.2*y, 1.2 translate <16, 0, 32> }
        cylinder { 4.2*y, 7.2*y, 1.2 translate <40, 0, 8> }
        cylinder { 4.2*y, 7.2*y, 1.2 translate <40, 0, 32> }
        difference {
          box { <-2.4, -1, -2.4> <42.4, 8.6, 42.4> }
          box { <-20, 0, -10> <10, 10, 50> rotate 25*z translate <12, 7.5, 0> }
          box { <-20, 0, -50> <20, 20, 20> rotate 43.5*z rotate -90*y translate <0, 7.5, 4> }
          box { <-20, 0, -50> <20, 20, 20> rotate -43.5*z rotate -90*y translate <0, 7.5, 36> }
          box { <-30, 0, -20> <10, 20, 20> rotate -34*x rotate 41*y translate <12, 7.5, 4> }
          box { <-30, 0, -20> <10, 20, 20> rotate 34*x rotate -41*y translate <12, 7.5, 36> }
          box { <2.4, -2, 2.4> <44, 9, 37.6> }
          box { <-20, -1, -20> <0, 10, 1.1> rotate 45*y translate <4, 0, -3.9> }
          box { <-20, -1, -1.1> <0, 10, 20> rotate -45*y translate <4, 0, 43.9> }
          box { <0, 0.25, -0.5> <5.6, 9, 0.5> }
          box { <0, 0.25, 39.5> <5.6, 9, 40.5> }
          cylinder { 0.000001*y, 9*y, 1.5 translate <12, 0, 0> }
          cylinder { 0.000001*y, 9*y, 1.5 translate <20, 0, 0> }
          cylinder { 0.000001*y, 9*y, 1.5 translate <28, 0, 0> }
          cylinder { 0.000001*y, 9*y, 1.5 translate <36, 0, 0> }
          cylinder { 0.000001*y, 9*y, 1.5 translate <12, 0, 40> }
          cylinder { 0.000001*y, 9*y, 1.5 translate <20, 0, 40> }
          cylinder { 0.000001*y, 9*y, 1.5 translate <28, 0, 40> }
          cylinder { 0.000001*y, 9*y, 1.5 translate <36, 0, 40> }
          box { <11.6, 0.1, 1.4> <12.4, 9, 3.5> }
          box { <19.6, 0.1, 1.4> <20.4, 9, 3.5> }
          box { <27.6, 0.1, 1.4> <28.4, 9, 3.5> }
          box { <35.6, 0.1, 1.4> <36.4, 9, 3.5> }
          box { <11.6, 0.1, 36.5> <12.4, 9, 38.6> }
          box { <19.6, 0.1, 36.5> <20.4, 9, 38.6> }
          box { <27.6, 0.1, 36.5> <28.4, 9, 38.6> }
          box { <35.6, 0.1, 36.5> <36.4, 9, 38.6> }
          box { <-4, 0.000002, 2.400001> <4, 9, 3.900005> }
          box { <-4, 0.000002, 37.600001> <4, 9, 36.100005> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <0, 0, 12> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <0, 0, 20> }
          cylinder { 0.000002*y, 9*y, 1.5 translate <0, 0, 28> }
          box { <-0.5, 0.1, 3.8> <0.5, 9, 5.6> }
          box { <-0.5, 0.1, 34.4> <0.5, 9, 36.2> }
        }
        difference {
          box { <4, -1, 3.900007> <10.4, 8.6, 36.100007> }
          box { <-20, 0, -10> <10, 10, 50> rotate 25*z translate <12, 7.5, 0> }
          cylinder { 3.100002*y, 9*y, 1.5 translate <8, 0, 12> }
          cylinder { 3.100002*y, 9*y, 1.5 translate <8, 0, 20> }
          cylinder { 3.100002*y, 9*y, 1.5 translate <8, 0, 28> }
          box { <7.5, 3.200001, 3.8> <8.5, 5.3, 5.6> }
          box { <7.5, 3.200001, 34.4> <8.5, 5.3, 36.2> }
          box { <3.8, 3.200005, 7.5> <5.6, 5.3, 8.5> }
          box { <3.8, 3.200005, 15.5> <5.6, 5.3, 16.5> }
          box { <3.8, 3.200005, 23.5> <5.6, 5.3, 24.5> }
          box { <3.8, 3.200005, 31.5> <5.6, 5.3, 32.5> }
        }
        difference {
          box { <12, 0, 3.900001> <18.4, 5.2, 10.4> }
          box { <15.5, 3.200001, 3.8> <16.5, 5.3, 5.6> }
          box { <11, 3.200002, 7.5> <13.6, 5.3, 8.5> }
        }
        difference {
          box { <12, 0, 29.6> <18.4, 5.2, 36.100001> }
          box { <15.5, 3.200001, 34.4> <16.5, 5.3, 36.2> }
          box { <11, 3.200002, 31.5> <13.6, 5.3, 32.5> }
        }
        difference {
          box { <37.6, 0, 3.900001> <42.4, 5.2, 10.4> }
          box { <39.5, 3.200001, 3.8> <40.5, 5.3, 5.6> }
        }
        difference {
          box { <37.6, 0, 29.6> <42.4, 5.2, 36.100001> }
          box { <39.5, 3.200001, 34.4> <40.5, 5.3, 36.2> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 9.6, 44> } }
    }
  #end
#end
#macro train_uppernose(color_tex, age)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 31.9, 43.9> }
      box { <-50, 0, -10> <0, 50, 45> rotate -37.25*z translate <-2.4, 0.5, 0> }
      box { <0, 12.8, 6.5> <44, 25.8, 33.5> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <43.9, 31.9, 43.9> }
        difference {
          box { <-3, -1, -2.6> <44, 35, 42.6> }
          box { <-50, 0, -10> <0, 50, 45> rotate -37.25*z translate <-2.4, 0.5, 0> }
          box { <-1, -1, -15> <15, 50, 0> rotate 50*y rotate -37.25*z translate <-2.5, 0.5, 4> }
          box { <-1, -1, 0> <15, 50, 15> rotate -50*y rotate -37.25*z translate <-2.5, 0.5,36> }
          box { <0, 30.7, -4> <27.9, 32, 44> }
          box { <0, -1, -4> <44, 3.100001, 3.900001> }
          box { <-4, -1, -4> <3.900001, 3.100002, 44> }
          box { <0, -1, 36.100001> <44, 3.100001, 44> }
          box { <0, 27.3, -4> <50, 40, 3.900001> }
          box { <0, 27.3, 36.100001> <50, 40, 44> }
          box { <0, 9.5, -4> <44, 10.6, -0.4> }
          box { <0, 9.5, 40.4> <44, 10.6, 44> }
        }
        difference {
          box { <21.6, 28.7, -2.4> <26.4, 60, 42.4> }
          box { <20, 25, 2.4> <28, 61, 37.6> }
          box { <-20, 25, -20> <0, 60, 1.1> rotate 45*y translate <28, 0, -4> }
          box { <-20, 25, -1.1> <0, 60, 20> rotate -45*y translate <28, 0, 44> }
        }
        #if (setting > 1)
          box { <-2.4, -1, 3.9> <2.4, 2, 36.1> }
          box { <3.9, -1, -2.4> <42.4, 2, 2.4> }
          box { <3.9, -1, 37.6> <42.4, 2, 42.4> }
          box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
          box { <-2.4, -1, 37.6> <2.4, 2, 42.4> }
        #end
        box { <3.9, -1, 3.9> <44, 4, 36.1> }
        box { <-1, -1, -15> <15, 40, 0> rotate 45*y translate <-4, 0, 4> }
        box { <-1, -1, 0> <15, 40, 15> rotate -45*y translate <-4, 0, 36> }
        box { <-50, 0, -10> <0, 50, 45> rotate -37.25*z translate <-3.9, 0.5, 0> }
        box { <-1, -1, -15> <15, 50, 0> rotate 50*y rotate -37.25*z translate <-4, 0.5, 4> }
        box { <-1, -1, 0> <15, 50, 15> rotate -50*y rotate -37.25*z translate <-4, 0.5,36> }
        box { <35.9, 28.7, -4> <44, 40, 44> }
        box { <27.9, 28.7, -2.9> <34.9, 40, 2.9> }
        box { <27.9, 28.7, 37.1> <34.9, 40, 42.9> }
        cylinder { 0*x, 44*x, 1.5 translate <0, 14.3, 8> }
        cylinder { 0*x, 44*x, 1.5 translate <0, 24.3, 8> }
        cylinder { 0*x, 44*x, 1.5 translate <0, 14.3, 32> }
        cylinder { 0*x, 44*x, 1.5 translate <0, 24.3, 32> }
        box { <0, 12.8, 8> <44, 25.8, 32> }
        box { <0, 14.3, 6.5> <44, 24.3, 33.5> }
        cylinder { 0*x, 44*x, 1.5 translate <0, 14.3, -0.5> }
        cylinder { 0*x, 44*x, 1.5 translate <0, 24.3, -0.5> }
        cylinder { 0*x, 44*x, 1.5 translate <0, 14.3, 1> }
        cylinder { 0*x, 44*x, 1.5 translate <0, 24.3, 1> }
        box { <0, 12.800001, -0.5> <44, 25.800001, 1> }
        box { <0, 14.3, -2> <44, 24.3, 2.5> }
        cylinder { 0*x, 44*x, 1.5 translate <0, 14.3, 40.5> }
        cylinder { 0*x, 44*x, 1.5 translate <0, 24.3, 40.5> }
        cylinder { 0*x, 44*x, 1.5 translate <0, 14.3, 39> }
        cylinder { 0*x, 44*x, 1.5 translate <0, 24.3, 39> }
        box { <0, 12.800002, 40.5> <44, 25.800002, 39> }
        box { <0, 14.3, 42> <44, 24.3, 37.5> }
        cylinder { -4*z, 44*z, 1.5 translate <19, 14.3, 0> }
        cylinder { -4*z, 44*z, 1.5 translate <38.5, 14.3, 0> }
        cylinder { -4*z, 44*z, 1.5 translate <26.55, 24.3, 0> }
        cylinder { -4*z, 44*z, 1.5 translate <38.5, 24.3, 0> }
        box { <26.55, 12.800003, -4> <38.5, 25.800003, 44> }
        box { <35, 14.3, -4> <40, 24.3, 44> }
        box { <19, 12.8, -4> <27.5, 15.8, 44> }
        box { <0, -1.5, -4> <12, 1.5, 44> rotate 52.75*z translate <19, 14.3, 0> }
        box { <2.5, -5.5, -4> <12, 0, 44> rotate 52.75*z translate <19, 14.3, 0> }
      }
      #if (setting > 1)
        box { <-0.5, 0.000005, 3.5> <0.5, 2.1, 5.6> }
        box { <-0.5, 0.000005, 34.4> <0.5, 2.1, 36.5> }
        object { pin(age) translate <12, 0, 0> }
        object { pin(age) translate <20, 0, 0> }
        object { pin(age) translate <28, 0, 0> }
        object { pin(age) translate <36, 0, 0> }
        object { pin(age) translate <12, 0, 40> }
        object { pin(age) translate <20, 0, 40> }
        object { pin(age) translate <28, 0, 40> }
        object { pin(age) translate <36, 0, 40> }
      #end
      object { open_rounded_button() translate <32, 28.8, 0> }
      object { open_rounded_button() translate <32, 28.8, 40> }
      object { open_rounded_button() translate <40, 25.6, 0> }
      object { open_rounded_button() translate <40, 25.6, 40> }
      difference {
        cylinder { 27.6*y, 31.8000001*y, 2.4 }
        cylinder { 28*y, 32*y, 1.600001 }
        translate <32, 0, 0>
      }
      difference {
        cylinder { 27.6*y, 31.8000001*y, 2.4 }
        cylinder { 28*y, 32*y, 1.600001 }
        translate <32, 0, 40>
      }
      object { open_rounded_button() translate <24, 28.8, 8> }
      object { open_rounded_button() translate <24, 28.8, 16> }
      object { open_rounded_button() translate <24, 28.8, 24> }
      object { open_rounded_button() translate <24, 28.8, 32> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <24, 31.9, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <24, 31.9, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <24, 31.9, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <24, 31.9, 32> }
      #end 
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 33.7, 44> } }
    }
  #end
#end
#macro train_uppernose_glass(color_tex)
  #if (setting = 0)
    difference {
      box { <0, 12.8, 6.5> <43.9, 25.8, 33.5> }
      box { <-50, 0, -10> <0, 50, 45> rotate -37.25*z translate <-2.4, 0.5, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { 0*x, 40*x, 1.4 translate <0, 14.3, 8> }
          cylinder { 0*x, 40*x, 1.4 translate <0, 24.3, 8> }
          cylinder { 0*x, 40*x, 1.4 translate <0, 14.3, 32> }
          cylinder { 0*x, 40*x, 1.4 translate <0, 24.3, 32> }
          box { <0, 12.9, 8> <40, 25.7, 32> }
          box { <0, 14.3, 6.6> <40, 24.3, 33.4> }
          cylinder { 0*x, 40*x, 1.4 translate <0, 14.3, -0.5> }
          cylinder { 0*x, 40*x, 1.4 translate <0, 24.3, -0.5> }
          cylinder { 0*x, 40*x, 1.4 translate <0, 14.3, 1> }
          cylinder { 0*x, 40*x, 1.4 translate <0, 24.3, 1> }
          box { <0, 12.9, -0.5> <40, 25.7, 1> }
          box { <0, 14.3, -1.9> <40, 24.3, 2.4> }
          cylinder { 0*x, 40*x, 1.4 translate <0, 14.3, 40.5> }
          cylinder { 0*x, 40*x, 1.4 translate <0, 24.3, 40.5> }
          cylinder { 0*x, 40*x, 1.4 translate <0, 14.3, 39> }
          cylinder { 0*x, 40*x, 1.4 translate <0, 24.3, 39> }
          box { <0, 12.9, 40.5> <40, 25.7, 39> }
          box { <0, 14.3, 41.9> <40, 24.3, 37.4> }
          cylinder { -3.9*z, 43.9*z, 1.4 translate <19, 14.3, 0> }
          cylinder { -3.9*z, 43.9*z, 1.4 translate <38.5, 14.3, 0> }
          cylinder { -3.9*z, 43.9*z, 1.4 translate <26.55, 24.3, 0> }
          cylinder { -3.9*z, 43.9*z, 1.4 translate <38.5, 24.3, 0> }
          box { <26.55, 12.9, -3.9> <38.5, 25.7, 43.9> }
          box { <35, 14.3, -3.900001> <39.9, 24.3, 43.900001> }
          box { <19, 12.900001, -3.900002> <27.5, 15.8, 43.900002> }
          box { <0, -1.5, -3.900003> <12, 1.4, 43.900003> rotate 52.75*z translate <19, 14.3, 0> }
          box { <2.5, -5.5, -3.900004> <12, 0, 43.900004> rotate 52.75*z translate <19, 14.3, 0> }
        }
        difference {
          box { <3.5, 0, -1.100001> <44, 38, 41.100001> }
          box { <-50, 0, -10> <0, 50, 45> rotate -37.25*z translate <-0.600001, 0.5, 0> }
          box { <-1, -1, -15> <15, 50, 0> rotate 50*y rotate -37.25*z translate <0.100001, 0.5, 4> }
          box { <-1, -1, 0> <15, 50, 15> rotate -50*y rotate -37.25*z translate <0.100001, 0.5, 36> }
        }
        box { <-50, 0, -10> <0, 50, 45> rotate -37.25*z translate <-3.9, 0.5, 0> }
        box { <-1, -1, -15> <15, 50, 0> rotate 50*y rotate -37.25*z translate <-4, 0.5, 4> }
        box { <-1, -1, 0> <15, 50, 15> rotate -50*y rotate -37.25*z translate <-4, 0.5, 36> }
      }
      difference {
        box { <2, 3.2, -2.5> <40.9, 27.2, 42.5> }
        difference {
          box { <3.500001, 0, -1.1> <44, 38, 41.1> }
          box { <-50, 0, -10> <0, 50, 45> rotate -37.25*z translate <-0.6, 0.5, 0> }
          box { <-1, -1, -15> <15, 50, 0> rotate 50*y rotate -37.25*z translate <0.1, 0.5, 4> }
          box { <-1, -1, 0> <15, 50, 15> rotate -50*y rotate -37.25*z translate <0.1, 0.5, 36> }
        }
        box { <-50, 0, -10> <0, 50, 45> rotate -37.25*z translate <-2.4, 0.5, 0> }
        box { <-1, -1, -15> <15, 50, 0> rotate 50*y rotate -37.25*z translate <-2.4, 0.5, 4> }
        box { <-1, -1, 0> <15, 50, 15> rotate -50*y rotate -37.25*z translate <-2.4, 0.5, 36> }
        difference {
          box { <0, 0, -5> <4, 4, 45> }
          cylinder { -4*z, 44*z, 3 }
          translate <38.5, 24.3, 0>
        }
        difference {
          box { <0, -4, -5> <4, 0, 45> }
          cylinder { -4*z, 44*z, 3 }
          translate <38.5, 14.3, 0>
        }
        box { <-2, 0, -5> <44, 11.3, 7.5> }
        box { <-2, 0, 32.5> <44, 11.3, 45> }
        difference {
          box { <-5, -3, -3> <11, 0, 0> }
          cylinder { -4*x, 10*x, 1.5 }
          translate <0, 4.7, 9>
        }
        difference {
          box { <-5, -3, 0> <11, 0, 3> }
          cylinder { -4*x, 10*x, 1.5 }
          translate <0, 4.7, 31>
        }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 33.7, 44> } }
    }
  #end
#end
#macro train_weight2_6(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <43.9, 19.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <43.9, 19.1, 11.9> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> translate <0, 19.1, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <8, 19.1, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <16, 19.1, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <24, 19.1, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <32, 19.1, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <40, 19.1, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <0, 19.1, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <8, 19.1, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <16, 19.1, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <24, 19.1, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <32, 19.1, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <40, 19.1, 8> }
          #end
          object { open_rounded_button() translate <0, 16, 0> }
          object { open_rounded_button() translate <8, 16 0> }
          object { open_rounded_button() translate <16, 16, 0> }
          object { open_rounded_button() translate <24, 16, 0> }
          object { open_rounded_button() translate <32, 16, 0> }
          object { open_rounded_button() translate <40, 16, 0> }
          object { open_rounded_button() translate <0, 16, 8> }
          object { open_rounded_button() translate <8, 16, 8> }
          object { open_rounded_button() translate <16, 16, 8> }
          object { open_rounded_button() translate <24, 16, 8> }
          object { open_rounded_button() translate <32, 16, 8> }
          object { open_rounded_button() translate <40, 16, 8> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <42.4, 2, 10.4> }
          difference {
            box { <-4, 3.1, -3.2> <0, 18.4, 11.2> }
            box { <-5, 3.2, -3.1> <1, 18.3, 11.1> }
          }
          cylinder { -4*x, -3.4*x, 2.4 translate <0, 10.8, 4> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <28, 0, 4> }
        object { ring() translate <36, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 20.9, 12> } }
    }
  #end
#end
#macro train_wheels(color_tex)
  #if (setting = 0)
    union {
      cylinder { -6*z, 38*z, 0.75 texture { chrome_tex } translate <0, 8.1, -16> }
      cylinder { -4.5*z, -1.4*z, 11.4 texture { black_tex } translate <0, 8.1, -16> }
      cylinder { -4.5*z, -1.4*z, 11.4 texture { black_tex } rotate 180*y translate <0, 8.1, 16> }
      box { <-11.9, 5.4, -23.8> <11.9, 21.4, 23.8> texture { color_tex } }
    }
  #else
    union {
      merge {
        cone { -6*z, 0, -5.2*z, 0.75 }
        cylinder { -5.200001*z, 37.200001*z, 0.75 }
        cone { 37.2*z, 0.75, 38*z, 0 }
        translate <0, 8.1, -16>
        texture { chrome_tex }
      }
      merge {
        difference {
          merge {
            cone { -1.4*z, 11.4, -2.4*z, 11.2 }
            cone { -2.399999*z, 11.2, -2.9*z, 8.1 }
          }
          cylinder { -1*z, -2.4*z, 9.4 }
          cone { -4.500001*z, 7.2, -2.8*z, 5.7 }
        }
        cylinder { -2.8*z, -4.5*z, 2.3 }
        cylinder { -1.5*z, -2.4*z, 2.3 }
        difference {
          cylinder { -4.4*z, -2.5*z, 8.1 }
          cone { -4.400001*z, 7.1, -2.9*z, 5.6 }
        }
        texture { black_tex }
        translate <0, 8.1, -16>
      }
      merge {
        difference {
          merge {
            cone { -1.4*z, 11.4, -2.4*z, 11.2 }
            cone { -2.399999*z, 11.2, -2.9*z, 8.1 }
          }
          cylinder { -1*z, -2.4*z, 9.4 }
          cone { -4.500001*z, 7.2, -2.8*z, 5.7 }
        }
        cylinder { -2.8*z, -4.5*z, 2.3 }
        cylinder { -1.5*z, -2.4*z, 2.3 }
        difference {
          cylinder { -4.4*z, -2.5*z, 8.1 }
          cone { -4.400001*z, 7.1, -2.9*z, 5.6 }
        }
        rotate 180*y
        translate <0, 8.1, 16>
        texture { black_tex }
      }
      merge {
        difference {
          box { <-11.9, 5.4, -23.8> <11.9, 21.4, 23.8> }
          box { <-12, 0, 0> <12, 10, 10> rotate -24*x translate <0, 18.3, -21.6> }
          box { <-12, 0, -10> <12, 10, 0> rotate 24*x translate <0, 18.3, 21.6> }
          box { <-12, 18.3, -24> <12, 22, -21.6> }
          box { <-12, 18.3, 24> <12, 22, 21.6> }
          box { <0, -10, -30> <20, 0, -21.399999> rotate -40*z translate <-12, 11.8, 0> }
          box { <-20, -10, -30> <0, 0, -21.399999> rotate 40*z translate <12, 11.8, 0> }
          box { <0, -10, 30> <20, 0, 21.399999> rotate -40*z translate <-12, 11.8, 0> }
          box { <-20, -10, 30> <0, 0, 21.399999> rotate 40*z translate <12, 11.8, 0> }
          box { <-12, 14.9, -7.9> <12, 22, 7.9> }
          difference {
            box { <-12, 0, -21.6> <12, 11.8, 21.6> }
            box { <-3.9, 5.399997, -15.9> <3.9, 12, 15.9> }
          }
          box { <-2.5, 8, -2.5> <2.5, 20, 2.5> }
          box { <-1.1, 0, -12> <1.1, 8.9, -16> }
          box { <-1.1, 0, 12> <1.1, 8.9, 16> }
          box { <-1, 0, -1> <1, 8.4, 1> rotate 45*y translate <0, 0, -21.4> }
          box { <-1, 0, -1> <1, 8.4, 1> rotate 45*y translate <0, 0, 21.4> }
          difference {
            box { <-2.500001, 0, -14.4> <2.500001, 20.5, 14.4> }
            box { <-3, 13.8, -9.5> <3, 21, 9.5> }
            box { <-3, 8.4, -8> <3, 21, -9.5> }
            box { <-3, 8.4, -2.500002> <3, 21, -3.500002> }
            box { <-3, 8.4, 2.500002> <3, 21, 3.500002> }
            box { <-3, 8.4, 8> <3, 21, 9.5> }
            box { <-3, 0, -2> <-1, 12.8, 2> }
            box { <3, 0, -2> <1, 12.8, 2> }
          }
          #if (setting > 1)
            cylinder { 12.8*y, 15.8*y, 1.2 translate <-8, 0, -4> }
            cylinder { 12.8*y, 15.8*y, 1.2 translate <8, 0, -4> }
            cylinder { 12.8*y, 15.8*y, 1.2 translate <-8, 0, 4> }
            cylinder { 12.8*y, 15.8*y, 1.2 translate <8, 0, 4> }
            cylinder { 19.2*y, 22.2*y, 1.2 translate <-8, 0, -12> }
            cylinder { 19.2*y, 22.2*y, 1.2 translate <0, 0, -12> }
            cylinder { 19.2*y, 22.2*y, 1.2 translate <8, 0, -12> }
            cylinder { 19.2*y, 22.2*y, 1.2 translate <-8, 0, 12> }
            cylinder { 19.2*y, 22.2*y, 1.2 translate <0, 0, 12> }
            cylinder { 19.2*y, 22.2*y, 1.2 translate <8, 0, 12> }
          #end
          difference {
            box { <-10.4, 11, -14.4> <-3.900001, 20.5, 14.4> }
            box { <-11, 13.8, -9.5> <-3, 21, 9.5> }
            #if (setting > 1)
              difference {
                cylinder { 10*y, 14.9*y, 1.5 }
                cylinder { 9*y, 14.8*y, 0.7 }
                translate <-8, 0, -8>
              }
              difference {
                cylinder { 10*y, 14.9*y, 1.5 }
                cylinder { 9*y, 14.8*y, 0.7 }
                translate <-8, 0, 0>
              }
              difference {
                cylinder { 10*y, 14.9*y, 1.5 }
                cylinder { 9*y, 14.8*y, 0.7 }
                translate <-8, 0, 8>
              }
              box { <-5.6, 10, -11.5> <-3.5, 21, -12.5> }
              box { <-5.6, 10, -3.5> <-3.5, 21, -4.5> }
              box { <-5.6, 10, 3.5> <-3.5, 21, 4.5> }
              box { <-5.6, 10, 11.5> <-3.5, 21, 12.5> }
            #end
          }
          difference {
            box { <10.4, 11, -14.4> <3.900001, 20.5, 14.4> }
            box { <11, 13.8, -9.5> <3, 21, 9.5> }
            #if (setting > 1)
              difference {
                cylinder { 10*y, 14.9*y, 1.5 }
                cylinder { 9*y, 14.8*y, 0.7 }
                translate <8, 0, -8>
              }
              difference {
                cylinder { 10*y, 14.9*y, 1.5 }
                cylinder { 9*y, 14.8*y, 0.7 }
                translate <8, 0, 0>
              }
              difference {
                cylinder { 10*y, 14.9*y, 1.5 }
                cylinder { 9*y, 14.8*y, 0.7 }
                translate <8, 0, 8>
              }
              box { <5.6, 10, -11.5> <3.5, 21, -12.5> }
              box { <5.6, 10, -3.5> <3.5, 21, -4.5> }
              box { <5.6, 10, 3.5> <3.5, 21, 4.5> }
              box { <5.6, 10, 11.5> <3.5, 21, 12.5> }
            #end
          }
          difference {
            box { <-7.9, 14.9, -24> <7.9, 30, -21.599999> }
            box { <-20, -10, -25> <20, 0, -20> rotate -40*z translate <-3.9, 14.9, 0>}
            box { <0, -10, -25> <20, 0, -20> rotate 40*z translate <3.9, 14.9, 0> }
          }
          difference {
            box { <-7.9, 14.9, 24> <7.9, 30, 21.599999> }
            box { <-20, -10, 25> <20, 0, 20> rotate -40*z translate <-3.9, 14.9, 0> }
            box { <0, -10, 35> <20, 0, 20> rotate 40*z translate <3.9, 14.9, 0> }
          }
          difference {
            box { <-10, 0, -21.600004> <10, 22, -15.900001> }
            difference {
              box { <-12, 0, 0> <12, 10, 10> rotate -24*x translate <0, 17.3, -21.6> }
              box { <0, 0, -10> <10, 30, 10> rotate -22*y translate <-8, 0, -21.6> }
              box { <-10, 0, -10> <0, 30, 10> rotate 22*y translate <8, 0, -21.6> }
            }
          }
          difference {
            box { <-10, 0, 21.600004> <10, 22, 15.900001> }
            difference {
              box { <-12, 0, -10> <12, 10, 0> rotate 24*x translate <0, 17.3, 21.6> }
              box { <0, 0, -10> <10, 30, 10> rotate 22*y translate <-8, 0, 21.6> }
              box { <-10, 0, -10> <0, 30, 10> rotate -22*y translate <8, 0, 21.6> }
            }
          }
          box { <-12, 0, -24> <12, 8, -22.7> }
          #if (setting > 1)
            difference {
              box { <-11, 5.399999, -24> <11, 14.8, -22.700001> }
              torus { 3.5, 0.5 translate <-4.2, 12.35, -19.4125> }
              torus { 3.5, 0.5 translate <-4.2, 11.3, -19.4125> }
              torus { 3.5, 0.5 translate <-4.2, 10.25, -19.4125> }
              torus { 3.5, 0.5 translate <-4.2, 9.2, -19.4125> }
              torus { 3.5, 0.5 translate <4.2, 12.35, -19.4125> }
              torus { 3.5, 0.5 translate <4.2, 11.3, -19.4125> }
              torus { 3.5, 0.5 translate <4.2, 10.25, -19.4125> }
              torus { 3.5, 0.5 translate <4.2, 9.2, -19.4125> }
              box { <0, -10, -30> <20, 0, -21.199999> rotate -40*z translate <-12, 12.8, 0> }
              box { <-20, -10, -30> <0, 0, -21.199999> rotate 40*z translate <12, 12.8, 0> }
              box { <-12, 7.9, -30> <-4.2, 8.9, -20> }
              box { <4.2, 7.9, -30> <12, 8.9, -20> }
              cylinder { 7.899999*y, 8.900001*y, 1 translate <-4.2, 0, -22.8> }
              cylinder { 7.899999*y, 8.900001*y, 1 translate <4.2, 0, -22.8> }
              difference {
                box { <-7.3, 12.9, -30> <7.3, 14.9, -21.2> }
                cylinder { -31*z, -20*z, 1.8 translate <-7.3, 12.9, 0> }
                cylinder { -31*z, -20*z, 1.8 translate <7.3, 12.9, 0> }
              }
            }
          #end
          box { <-12, 0, 24> <12, 8, 22.7> }
          #if (setting > 1)
            difference {
              box { <-11, 5.399999, 24> <11, 14.8, 22.700001> }
              torus { 3.5, 0.5 translate <-4.2, 12.3, 19.4125> }
              torus { 3.5, 0.5 translate <-4.2, 11.25, 19.4125> }
              torus { 3.5, 0.5 translate <-4.2, 10.2, 19.4125> }
              torus { 3.5, 0.5 translate <-4.2, 9.15, 19.4125> }
              torus { 3.5, 0.5 translate <4.2, 12.3, 19.4125> }
              torus { 3.5, 0.5 translate <4.2, 11.25, 19.4125> }
              torus { 3.5, 0.5 translate <4.2, 10.2, 19.4125> }
              torus { 3.5, 0.5 translate <4.2, 9.15, 19.4125> }
              box { <0, -10, 30> <20, 0, 21.199999> rotate -40*z translate <-12, 12.8, 0> }
              box { <-20, -10, 30> <0, 0, 21.199999> rotate 40*z translate <12, 12.8, 0> }
              box { <-12, 7.9, 30> <-4.2, 8.9, 20> }
              box { <4.2, 7.9, 30> <12, 8.9, 20> }
              cylinder { 7.899999*y, 8.900001*y, 1 translate <-4.2, 0, 22.8> }
              cylinder { 7.899999*y, 8.900001*y, 1 translate <4.2, 0, 22.8> }
              difference {
                box { <-7.3, 12.9, 30> <7.3, 14.9, 21.2> }
                cylinder { 31*z, 20*z, 1.8 translate <-7.3, 12.9, 0> }
                cylinder { 31*z, 20*z, 1.8 translate <7.3, 12.9, 0> }
              }
            }
          #end
        }
        #if (setting < 3)
          cylinder { -23.8*z, -22.6*z, 2.4 translate <0, 8.1, 0> }
          cylinder { 23.8*z, 22.6*z, 2.4 translate <0, 8.1, 0> }
          cylinder { 21.3*y, 23.1*y, 2.4 translate <-8, 0, -12> }
          cylinder { 21.3*y, 23.1*y, 2.4 translate <0, 0, -12> }
          cylinder { 21.3*y, 23.1*y, 2.4 translate <8, 0, -12> }
          cylinder { 21.3*y, 23.1*y, 2.4 translate <-8, 0, 12> }
          cylinder { 21.3*y, 23.1*y, 2.4 translate <0, 0, 12> }
          cylinder { 21.3*y, 23.1*y, 2.4 translate <8, 0, 12> }
          cylinder { 14.8*y, 16.6*y, 2.4 translate <-8, 0, -4> }
          cylinder { 14.8*y, 16.6*y, 2.4 translate <8, 0, -4> }
          cylinder { 14.8*y, 16.6*y, 2.4 translate <-8, 0, 4> }
          cylinder { 14.8*y, 16.6*y, 2.4 translate <8, 0, 4> }
        #else
          object { rounded_button() rotate 90*y rotate -90*x translate <0, 8.1, -19> }
          object { rounded_button() rotate -90*y rotate 90*x translate <0, 8.1, 19> }
          object { rounded_button() translate <-8, 18.3, -12> }
          object { rounded_button() translate <0, 18.3, -12> }
          object { rounded_button() translate <8, 18.3, -12> }
          object { rounded_button() translate <-8, 18.3, 12> }
          object { rounded_button() translate <0, 18.3, 12> }
          object { rounded_button() translate <8, 18.3, 12> }
          object { rounded_button() translate <-8, 11.8, -4> }
          object { rounded_button() translate <8, 11.8, -4> }
          object { rounded_button() translate <-8, 11.8, 4> }
          object { rounded_button() translate <8, 11.8, 4> }
        #end
      }
      texture { color_tex }
      bounded_by { box { <-12, -3.2, -23.9> <12, 23.2, 23.9> } }
    }
  #end
#end
#macro train_wheels_old(color_tex, wheel_angle)
  #if (setting = 0)
    union {
      cylinder { -24.5*z, -17.4*z, 11 texture { color_tex } }
      cylinder { 24.5*z, 17.4*z, 11 texture { color_tex } }
      box { <-7.9, -5.75, -15.9> <7.9, 3.75, 15.9> texture { black_tex } }
      cylinder { -24*z, 24*z, 1.4 texture { gold_tex } }
      translate <0, 5.6, 0>
    }
  #else
    union {
      merge {
        object { rounded_button() rotate 90*y rotate -90*x translate <0, 0, -19.8> texture { color_tex } }
        object { rounded_button() rotate 90*y rotate 90*x translate <0, 0, 19.8> texture { color_tex } }
        cylinder { -24*z, 24*z, 1.4 texture { gold_tex } }
        translate <0, 5.6, 0>
      }
      merge {
        difference {
          merge {
            cone { -1.4*z, 11.2, -2.4*z, 11 }
            cone { -2.399999*z, 11, -3.4*z, 7.7 }
            cylinder { -3*z, -0.6*z, 2.8 }
          }
          difference {
            cylinder { -1.3*z, -5.6*z, 6 }
            cylinder { -3*z, -0.6*z, 2.800001 }
            box { <-0.5, -7, -3> <0.5, 7, -0.6> }
            box { <-7, -0.5, -3> <7, 0.5, -0.6> }
          }
        }
        cylinder { -6.5*z, -4*z, 2.4 }
        difference {
          cylinder { -8.5*z, -3.3*z, 7.7 }
          cone { -8.500001*z, 7.2, -7.5*z, 6.2 }
          cylinder { -8.6*z, -5.35*z, 6.2 }
        }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3.5> }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3.5> rotate 36*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3.5> rotate 72*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3.5> rotate 108*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3.5> rotate 144*z }
        texture { color_tex }
        rotate wheel_angle*z
        translate <0, 5.6, -16>
      }
      merge {
        difference {
          merge {
            cone { -1.4*z, 11.2, -2.4*z, 11 }
            cone { -2.399999*z, 11, -3.4*z, 7.7 }
            cylinder { -3*z, -0.6*z, 2.8 }
          }
          difference {
            cylinder { -1.3*z, -5.6*z, 6 }
            cylinder { -3*z, -0.6*z, 2.800001 }
            box { <-0.5, -7, -3> <0.5, 7, -0.6> }
            box { <-7, -0.5, -3> <7, 0.5, -0.6> }
          }
        }
        cylinder { -6.5*z, -4*z, 2.4 }
        difference {
          cylinder { -8.5*z, -3.3*z, 7.7 }
          cone { -8.500001*z, 7.2, -7.5*z, 6.2 }
          cylinder { -8.6*z, -5.35*z, 6.2 }
        }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3.5> }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3.5> rotate 36*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3.5> rotate 72*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3.5> rotate 108*z }
        box { <-0.5, -6.5, -6.6> <0.5, 6.5, -3.5> rotate 144*z }
        texture { color_tex }
        rotate 180*y
        rotate wheel_angle*z
        translate <0, 5.6, 16>
      }
      merge {
        difference {
          merge {
            box { <-7.9, 1.95, -15.9> <7.9, 11.45, 15.9> }
            #if (setting < 3)
              cylinder { 11.35*y, 13.15*y, 2.4 translate <-4, 0, -12> }
              cylinder { 11.35*y, 13.15*y, 2.4 translate <-4, 0, -4> }
              cylinder { 11.35*y, 13.15*y, 2.4 translate <-4, 0, 4> }
              cylinder { 11.35*y, 13.15*y, 2.4 translate <-4, 0, 12> }
              cylinder { 11.35*y, 13.15*y, 2.4 translate <4, 0, -12> }
              cylinder { 11.35*y, 13.15*y, 2.4 translate <4, 0, -4> }
              cylinder { 11.35*y, 13.15*y, 2.4 translate <4, 0, 4> }
              cylinder { 11.35*y, 13.15*y, 2.4 translate <4, 0, 12> }
            #else
              object { rounded_button() rotate 90*y translate <-4, 8.35, -12> }
              object { rounded_button() rotate 90*y translate <-4, 8.35, -4> }
              object { rounded_button() rotate 90*y translate <-4, 8.35, 4> }
              object { rounded_button() rotate 90*y translate <-4, 8.35, 12> }
              object { rounded_button() rotate 90*y translate <4, 8.35, -12> }
              object { rounded_button() rotate 90*y translate <4, 8.35, -4> }
              object { rounded_button() rotate 90*y translate <4, 8.35, 4> }
              object { rounded_button() rotate 90*y translate <4, 8.35, 12> }
            #end
          }
          #if (setting > 1)
            box{ <-6.4, 1, -14.4> <6.4, 3.95, 14.4> }
            cylinder { -16*z, 16*z, 1.5 translate <0, 5.6, 0> }
          #end
        }
        #if (setting > 1)
          object { ring() translate <0, 1.95, -8> }
          object { ring() translate <0, 1.95, 0> }
          object { ring() translate <0, 1.95, 8> }
        #end
      }
      texture { black_tex }
      bounded_by { box { <-11.3, -3.6, -24.6> <11.3, 19, 24.6> } }
    }
  #end
#end
  
#macro train_wheels_old_large(color_tex, wheel_angle)
  #if (setting = 0)
    union {
      cylinder { -24.5*z, -17.4*z, 14.1 texture { color_tex } }
      cylinder { 24.5*z, 17.4*z, 14.1 texture { color_tex } }
      box { <-7.9, -5.75, -15.9> <7.9, 3.75, 15.9> texture { black_tex } }
      cylinder { -24*z, 24*z, 1.4 texture { gold_tex } }
      translate <0, 8.8, 0>
    }
  #else
    union {
      merge {
        object { rounded_button() rotate 90*y rotate -90*x translate <0, 0, -19.8> texture { color_tex } }
        object { rounded_button() rotate 90*y rotate 90*x translate <0, 0, 19.8> texture { color_tex } }
        cylinder { -24*z, 24*z, 1.4 texture { gold_tex } }
        translate <0, 8.8, 0>
      }
      merge {
        difference {
          merge {
            cone { -1.4*z, 14.3, -2.4*z, 14.1 }
            cone { -2.399999*z, 14.1, -3.4*z, 10.9 }
            cylinder { -3*z, -0.6*z, 2.8 }
          }
          difference {
            cylinder { -1.3*z, -5.6*z, 9.2 }
            cylinder { -3*z, -0.6*z, 2.800001 }
            box { <-0.5, -10, -3> <0.5, 10, -0.6> }
            box { <-10, -0.5, -3> <10, 0.5, -0.6> }
          }
        }
        cylinder { -6.5*z, -4*z, 2.4 }
        difference {
          cylinder { -8.5*z, -3.3*z, 10.9 }
          cone { -8.500001*z, 10.4, -7.5*z, 9.4 }
          cylinder { -8.6*z, -5.35*z, 9.4 }
        }
        box { <-0.5, -10, -6.6> <0.5, 10, -3.5> }
        box { <-0.5, -10, -6.6> <0.5, 10, -3.5> rotate 36*z }
        box { <-0.5, -10, -6.6> <0.5, 10, -3.5> rotate 72*z }
        box { <-0.5, -10, -6.6> <0.5, 10, -3.5> rotate 108*z }
        box { <-0.5, -10, -6.6> <0.5, 10, -3.5> rotate 144*z }
        texture { color_tex }
        rotate wheel_angle*z
        translate <0, 8.8, -16>
      }
      merge {
        difference {
          merge {
            cone { -1.4*z, 14.3, -2.4*z, 14.1 }
            cone { -2.399999*z, 14.1, -3.4*z, 10.9 }
            cylinder { -3*z, -0.6*z, 2.8 }
          }
          difference {
            cylinder { -1.3*z, -5.6*z, 9.2 }
            cylinder { -3*z, -0.6*z, 2.800001 }
            box { <-0.5, -10, -3> <0.5, 10, -0.6> }
            box { <-10, -0.5, -3> <10, 0.5, -0.6> }
          }
        }
        cylinder { -6.5*z, -4*z, 2.4 }
        difference {
          cylinder { -8.5*z, -3.3*z, 10.9 }
          cone { -8.500001*z, 10.4, -7.5*z, 9.4 }
          cylinder { -8.6*z, -5.35*z, 9.4 }
        }
        box { <-0.5, -10, -6.6> <0.5, 10, -3.5> }
        box { <-0.5, -10, -6.6> <0.5, 10, -3.5> rotate 36*z }
        box { <-0.5, -10, -6.6> <0.5, 10, -3.5> rotate 72*z }
        box { <-0.5, -10, -6.6> <0.5, 10, -3.5> rotate 108*z }
        box { <-0.5, -10, -6.6> <0.5, 10, -3.5> rotate 144*z }
        texture { color_tex }
        rotate 180*y
        rotate wheel_angle*z
        translate <0, 10.9, 16>
      }
      merge {
        difference {
          merge {
            box { <-7.9, 5.15, -15.9> <7.9, 14.65, 15.9> }
            #if (setting < 3)
              cylinder { 14.55*y, 16.35*y, 2.4 translate <-4, 0, -12> }
              cylinder { 14.55*y, 16.35*y, 2.4 translate <-4, 0, -4> }
              cylinder { 14.55*y, 16.35*y, 2.4 translate <-4, 0, 4> }
              cylinder { 14.55*y, 16.35*y, 2.4 translate <-4, 0, 12> }
              cylinder { 14.55*y, 16.35*y, 2.4 translate <4, 0, -12> }
              cylinder { 14.55*y, 16.35*y, 2.4 translate <4, 0, -4> }
              cylinder { 14.55*y, 16.35*y, 2.4 translate <4, 0, 4> }
              cylinder { 14.55*y, 16.35*y, 2.4 translate <4, 0, 12> }
            #else
              object { rounded_button() rotate 90*y translate <-4, 11.55, -12> }
              object { rounded_button() rotate 90*y translate <-4, 11.55, -4> }
              object { rounded_button() rotate 90*y translate <-4, 11.55, 4> }
              object { rounded_button() rotate 90*y translate <-4, 11.55, 12> }
              object { rounded_button() rotate 90*y translate <4, 11.55, -12> }
              object { rounded_button() rotate 90*y translate <4, 11.55, -4> }
              object { rounded_button() rotate 90*y translate <4, 11.55, 4> }
              object { rounded_button() rotate 90*y translate <4, 11.55, 12> }
            #end
          }
          #if (setting > 1)
            box{ <-6.4, 4.2, -14.4> <6.4, 7.15, 14.4> }
            cylinder { -16*z, 16*z, 1.5 translate <0, 8.8, 0> }
          #end
        }
        #if (setting > 1)
          object { ring() translate <0, 5.15, -8> }
          object { ring() translate <0, 5.15, 0> }
          object { ring() translate <0, 5.15, 8> }
        #end
      }
      texture { black_tex }
      bounded_by { box { <-14.4, -3.6, -24.6> <14.4, 25.4, 24.6> } }
    }
  #end
#end
  
#macro train_wheels_small(color_tex)
  #if (setting = 0)
    cylinder { -5*z, 0*z, 7.1 texture { color_tex } }
  #else
    difference {
      merge {
        cone { -1*z, 6.9, -0*z, 7.1 }
        cone { -2*z, 4.05, -0.999999*z, 6.9 }
        cylinder { -5*z, -1.9*z, 4.05 }
      }
      difference {
        cone { -1*z, 2.6, 0.000001*z, 5.9 }
        cylinder { -2*z, 1*z, 2.6 }
      }
      cylinder { -1*z, 1*z, 2.1 }
      cylinder { -6*z, 2*z, 1.6 }
      cone { -5.000001*z, 3.5, -3.75*z, 2.75 }
      texture { color_tex }
      bounded_by { cylinder { -5.1*z, 0.1*z, 7.2 } }
    }
  #end
#end
#macro transparent_door(color_tex)
  #if (setting = 0)
    box { <-0.9, 0, -0.9> <27.5, 53.6, 0.9> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { 0*y, 53.6*y, 0.9 }
        box { <-0.000001, -0.000001, -0.9000001> <27.5, 53.600001, 0.900001> }
        box { <27.4, 22.4, -0.899999> <27.8, 28.2, 0.899999> }
        cylinder { -3.9*z, 3.9*z, 1 translate <23.5, 23.4, 0> }
        cylinder { -3.9*z, 3.9*z, 1 translate <23.5, 27.2, 0> }
        box { <22.500001, 23.399999, -3.900001> <24.499999, 27.199999, 3.900001> }
      }
      box { <23.5, 22, -3> <25, 29, -1.000001> }
      box { <23.5, 22, 1.000001> <25, 29, 3> }
      box { <-2, 15, -2> <2, 17.3, 2> }
      box { <-2, 33, -2> <2, 35.3, 2> }
      box { <1.999999, -1, -1> <2.9, 54, -0.5> }
      box { <4.8, -1, -1> <5.6, 54, -0.5> }
      box { <7.5, -1, -1> <8.3, 54, -0.5> }
      box { <10.2, -1, -1> <11, 54, -0.5> }
      box { <12.9, -1, -1> <13.7, 54, -0.5> }
      box { <15.6, -1, -1> <16.4, 54, -0.5> }
      box { <18.3, -1, -1> <19.1, 54, -0.5> }
      box { <21, -1, -1> <21.8, 20.4, -0.5> }
      box { <23.7, -1, -1> <24.5, 20.4, -0.5> }
      box { <21, 33.2, -1> <21.8, 54, -0.5> }
      box { <23.7, 33.2, -1> <24.5, 54, -0.5> }
      box { <1.999999, -1, 0.5> <2.9, 54, 1> }
      box { <4.8, -1, 0.5> <5.6, 54, 1> }
      box { <7.5, -1, 0.5> <8.3, 54, 1> }
      box { <10.2, -1, 0.5> <11, 54, 1> }
      box { <12.9, -1, 0.5> <13.7, 54, 1> }
      box { <15.6, -1, 0.5> <16.4, 54, 1> }
      box { <18.3, -1, 0.5> <19.1, 54, 1> }
      box { <21, -1, 0.5> <21.8, 20.4, 1> }
      box { <23.7, -1, 0.5> <24.5, 20.4, 1> }
      box { <21, 30.2, 0.5> <21.8, 54, 1> }
      box { <23.7, 30.2, 0.5> <24.5, 54, 1> }
      texture { color_tex }
      bounded_by { box { <-1, -0.1, -4> <27.9, 53.7, 4> } }
    }
  #end
#end
#macro treasure_chest_bottom(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 12.3, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-3.4, 0, -3.4> <27.4, 0.6, 11.4> }
        #if (setting > 1)
          box { <-2.400005, -1, -2.400005> <26.400005, 1, 10.400005> }
        #end
      }
      difference {
        box { <-3.9, 0.5, -3.9> <27.9, 12.3, 11.9> }
        difference {
          box { <-4, 10.8, 10.4> <28, 15, 13> }
          cylinder { -5*x, 29*x, 1.5 translate <0, 10.8, 10.4> }
        }
        cylinder { -4*x, 28*x, 0.6 translate <0, 10.8, 10.4> }
        #if (setting > 1)
          box { <-2.400001, -1, -2.400001> <26.400001, 2, 10.400001> }
        #end
        box { <-2.400002, 3.1, -2.400002> <26.400002, 13, 10.400002> }
        box { <-2.400003, 9.8, 0> <26.400003, 13, 12> }
        box { <-2.400004, 3.100001, 0> <-1.4, 13, 12> }
        box { <25.4, 3.100001, 0> <26.400004, 13, 12> }
        box { <-1.9, 2.5, -4> <5.6, 11.2, -3.4> texture { color_tex finish { reflection 0.05 } } }
        box { <18.4, 2.5, -4> <25.9, 11.2, -3.4> texture { color_tex finish { reflection 0.05 } } }
        box { <-1.9, 2.5, 11.4> <5.6, 11.2, 12> texture { color_tex finish { reflection 0.05 } } }
        box { <18.4, 2.5, 11.4> <25.9, 11.2, 12> texture { color_tex finish { reflection 0.05 } } }
        box { <7.6, 2.5, 11.4> <16.4, 11.2, 12> texture { color_tex finish { reflection 0.05 } } }
        difference {
          box { <7.6, 2.5, -4> <16.4, 11.2, -3.4> }
          difference {
            box { <10, 8, -5> <14, 11.3, -3> }
            box { <-2, -2, -5> <0, 0, -3.00002> rotate -45*z translate <11, 8, 0> }
            box { <0, -2, -5> <2, 0, -3.000003> rotate 45*z translate <13, 8, 0> }
            cylinder { -5*z, -3*z, 0.75 translate <12, 10.6, 0> }
            box { <11.750001, 9.249999, -5> <12.250001, 10.600001, -3.000001> }
            cylinder { -5*z, -3*z, 0.25 translate <12, 9.25, 0> }
          }
          texture { color_tex finish { reflection 0.05 }
          }
        }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
      #end
      difference {
        box { <-3.4, 12.2, -3.4> <27.4, 12.8, 11.4> }
        box { <-2.4, 12, -2.4> <26.4, 13, 12> }
        difference {
          box { <-4, 10.800001, 10.4> <28, 15, 13> }
          cylinder { -5*x, 29*x, 1.5 translate <0, 10.800001, 10.4> }
        }
      }
      cylinder { 1*z, 7*z, 1.55 translate <31.5, 11.9, 0> }
      cylinder { 1*z, 7*z, 1.55 translate <-7.5, 11.9, 0> }
      difference {
        box { <26.9, 11, -0.5> <31.5, 12.8, 8.5> }
        box { <0, 10, 0> <10, 13, 10> rotate 10*y translate <26.9, 0, 8.5> }
        box { <0, 10, -10> <10, 13, 0> rotate -10*y translate <26.9, 0, -0.5> }
        box { <26, 10, 1.5> <31, 13, 6.5> }
      }
      difference {
        box { <-7.5, 11, -0.5> <-2.9, 12.8, 8.5> }
        box { <-10, 10, 0> <0, 13, 10> rotate -10*y translate <-2.9, 0, 8.5> }
        box { <-10, 10, -10> <0, 13, 0> rotate 10*y translate <-2.9, 0, -0.5> }
        box { <-7, 10, 1.5> <-2, 13, 6.5> }
      }
      texture { color_tex }
      bounded_by { box { <-9.15, -0.1, -4> <33.15, 13.55, 12> } }
    }
  #end
#end
#macro treasure_chest_cover(color_tex)
  #if (setting = 0)
    difference {
      merge {
        cylinder { -3.900001*x, 27.900001*x, 6.3 translate <0, 1.4, -4.9> }
        cylinder { -3.900002*x, 27.900002*x, 6.3 translate <0, 1.4, -8.1> }
        box { <-3.900003, 1.4, -8.100001> <27.900003, 7.7, -4.899999> }
      }
      box { <-4, -20, -20> <28, 1.400001, 10> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <11.3, -2.5, -13> <12.7, 7.7, -10> }
        box { <10, 0, -5> <14, 4, 0> rotate -15*x translate <0, -2.5, -12.5> }
        box { <10, 0, -10> <14, 10, 0> rotate 32.5*x translate <0, 2, -13> }
      }
      cylinder { -2.7*x, -2*x, 0.5 }
      cylinder { 26*x, 26.7*x, 0.5 }
      difference {
        box { <-2.4, -1.4, -1.4> <26.4, 1.400005, 1.4> }
        box { <-1.4, -2, -2> <25.4, 2, 0> }
        difference {
          box { <-3, -3, 0> <27, 0, 3> }
          cylinder { -2.5*x, 26.5*x, 1.4 }
        }
      }
      difference {
        merge {
          difference {
            merge {
              cylinder { -3.900001*x, 27.900001*x, 6.3 translate <0, 1.4, -4.9> }
              cylinder { -3.900002*x, 27.900002*x, 6.3 translate <0, 1.4, -8.1> }
              box { <-3.900003, 1.4, -8.100001> <27.900003, 7.7, -4.899999> }
            }
            box { <-4, -20, -20> <28, 1.400001, 10> }
            cylinder { -2.4*x, 26.4*x, 4.9 translate <0, 1.4, -4.9> }
            cylinder { -2.400001*x, 26.400001*x, 4.9 translate <0, 1.4, -8.1> }
            box { <-2.400002, -10, -8.100002> <26.400002, 6.300001, -4.899999> }
            difference {
              box { <-1.9, 2.7, -15> <25.9, 10, 2> }
              cylinder { 5.6*x, 7.6*x, 6.300001 translate <0, 1.4, -4.9> }
              cylinder { 5.6*x, 7.6*x, 6.300001 translate <0, 1.4, -8.1> }
              cylinder { 16.4*x, 18.4*x, 6.300001 translate <0, 1.4, -4.9> }
              cylinder { 16.4*x, 18.4*x, 6.300001 translate <0, 1.4, -8.1> }
              cylinder { -2.5*x, 26.5*x, 5.8 texture { color_tex finish { reflection 0.05 } } translate <0, 1.4, -4.9> }
              cylinder { -2.5*x, 26.5*x, 5.8 texture { color_tex finish { reflection 0.05 } } translate <0, 1.4, -8.1> }
              intersection {
                cylinder { -3.5*x, 27.5*x, 6.300001 translate <0, 1.4, -8.1> }
                box { <-4, 0, -1> <28, 7, 1> rotate -25*x translate <0, 1.4, -8.1> }
              }
              intersection {
                cylinder { -3.5*x, 27.5*x, 6.300001 translate <0, 1.4, -4.9> }
                box { <-4, 0, -1> <28, 7, 1> rotate 25*x translate <0, 1.4, -4.9> }
              }
            }
            difference {
              merge {
                cylinder { -4*x, -3.7*x, 4.5 translate <0, 1.4, -4.9> }
                cylinder { -4*x, -3.700001*x, 4.5 translate <0, 1.4, -8.1> }
                box { <-4, 2.6, -8.100001> <-3.700002, 5.9, -4.900001> }
              }
              box { <-5, -10, -20> <-3, 2.600001, 10> }
              texture { color_tex finish { reflection 0.05 } }
            }
            difference {
              merge {
                cylinder { 28*x, 27.7*x, 4.5 translate <0, 1.4, -4.9> }
                cylinder { 28*x, 27.700001*x, 4.5 translate <0, 1.4, -8.1> }
                box { <28, 2.6, -8.100001> <27.700002, 5.9, -4.900001> }
              }
              box { <29, -10, -20> <-27, 2.600001, 10> }
              texture { color_tex finish { reflection 0.05 } }
            }
          }
          #if (setting < 3)
            cylinder { 6.6*y, 9.4*y, 2.4 translate <0, 0, -6.5> }
            cylinder { 6.6*y, 9.4*y, 2.4 translate <8, 0, -6.5> }
            cylinder { 6.6*y, 9.4*y, 2.4 translate <16, 0, -6.5> }
            cylinder { 6.6*y, 9.4*y, 2.4 translate <24, 0, -6.5> }
          #else
            cylinder { 6.6*y, 7.7*y, 2.400001 translate <0, 0, -6.5> }
            cylinder { 6.6*y, 7.7*y, 2.400001 translate <8, 0, -6.5> }
            cylinder { 6.6*y, 7.7*y, 2.400001 translate <16, 0, -6.5> }
            cylinder { 6.6*y, 7.7*y, 2.400001 translate <24, 0, -6.5> }
            object { rounded_button() translate <0, 4.6, -6.5> }
            object { rounded_button() translate <8, 4.6, -6.5> }
            object { rounded_button() translate <16, 4.6, -6.5> }
            object { rounded_button() translate <24, 4.6, -6.5> }
          #end
        }
        #if (setting > 1)
          cylinder { 5.6*y, 8.6*y, 1.2 translate <0, 0, -6.5> }
          cylinder { 5.6*y, 8.6*y, 1.2 translate <8, 0, -6.5> }
          cylinder { 5.6*y, 8.6*y, 1.2 translate <16, 0, -6.5> }
          cylinder { 5.6*y, 8.6*y, 1.2 translate <24, 0, -6.5> }
        #end
      }
      texture { color_tex }
      bounded_by { box { <-4, -1.1, -14.5> <28, 9.55, 1.5> } }
    }
  #end
#end
#macro tree_1(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 2.1*y, 19*y, 2 }
      cylinder { 0*y, 3.9*y, 10.000001 }
      cone { 7.5*y, 12.5, 39*y, 2 }
      texture { color_tex }
    }
  #else
    merge {
      sphere { <0, 39, 0> 2.4 }
      cylinder { 37.5*y, 39.000001*y, 2.400001 }
      cylinder { 2.1*y, 39*y, 2 }
      difference {
        cone { 7.5*y, 12.5, 39*y, 2 }
        box { <-13, 34.5, -13> <13, 40, 13> }
        box { <-13, 29.5, -13> <13, 32.5, 13> }
        box { <-13, 24.5, -13> <13, 27.5, 13> }
        box { <-13, 19.5, -13> <13, 22.5, 13> }
        box { <-13, 14.5, -13> <13, 17.5, 13> }
        box { <-13, 9.5, -13> <13, 12.5, 13> }
        box { <-1.4, -5, -10> <1.4, 30, 0> rotate 3*x translate <0, 7.5, -3.9> }
        box { <-1.4, -5, 0> <1.4, 30, 10> rotate -3*x translate <0, 7.5, 3.9> }
        box { <4.6, -5, -10> <7.5, 30, 0> rotate 3*x translate <0, 7.5, -2.9> }
        box { <4.6, -5, 0> <7.5, 30, 10> rotate -3*x translate <0, 7.5, 2.9> }
        box { <-4.6, -5, -10> <-7.5, 30, 0> rotate 3*x translate <0, 7.5, -2.9> }
        box { <-4.6, -5, 0> <-7.5, 30, 10> rotate -3*x translate <0, 7.5, 2.9> }
        box { <11, 0, -10> <15, 30, -1.5> }
        box { <11, 0, 1.5> <15, 30, 10> }
        box { <-11, 0, -10> <-15, 30, -1.5> }
        box { <-11, 0, 1.5> <-15, 30, 10> }
      }
      difference {
        merge {
          torus { 8, 2 translate <0, 1.9, 0> }
          cylinder { 0.000001*y, 1.900001*y, 10.000001 }
          cylinder { 1.899999*y, 3.900001*y, 8.000001 }
        }
        #if (setting > 1)
          cylinder { -1*y, 2*y, 8 }
        #end
        box { <-13, -1, -13> <13, 0, 13> }
      }
      #if (setting > 1)
        object { ring() }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 41.5*y, 13 } }
    }
  #end
#end
#macro tree_2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 2.1*y, 19*y, 2 }
      cylinder { 0*y, 3.9*y, 10.000001 }
      cone { 15.5*y, 17.4, 61*y, 2 }
      texture { color_tex }
    }
  #else
    merge {
      sphere { <0, 61, 0> 2.4 }
      cylinder { 59.5*y, 61.000001*y, 2.400001 }
      cylinder { 2.1*y, 61*y, 2 }
      difference {
        cone { 15.5*y, 17.4, 61*y, 2 }
        box { <-18, 17.5, -18> <18, 20.5, 18> }
        box { <-18, 22.5, -18> <18, 25.5, 18> }
        box { <-18, 27.5, -18> <18, 30.5, 18> }
        box { <-18, 32.5, -18> <18, 35.5, 18> }
        box { <-18, 37.5, -18> <18, 40.5, 18> }
        box { <-18, 42.5, -18> <18, 45.5, 18> }
        box { <-18, 47.5, -18> <18, 50.5, 18> }
        box { <-18, 52.5, -18> <18, 55.5, 18> }
        box { <-18, 57.5, -18> <18, 63, 18> }
        box { <-1.4, -5, -20> <1.4, 50, 0> rotate 3*x translate <0, 15.5, -3.9> }
        box { <-1.4, -5, 0> <1.4, 50, 20> rotate -3*x translate <0, 7.5, 3.9> }
        box { <4.6, -5, -20> <7.5, 50, 0> rotate 3*x translate <0, 7.5, -2.9> }
        box { <4.6, -5, 0> <7.5, 50, 20> rotate -3*x translate <0, 7.5, 2.9> }
        box { <10.7, -5, -20> <13.6, 50, 0> rotate 3*x translate <0, 7.5, -2.9> }
        box { <10.7, -5, 0> <13.6, 50, 20> rotate -3*x translate <0, 7.5, 2.9> }
        box { <-4.6, -5, -20> <-7.5, 50, 0> rotate 3*x translate <0, 7.5, -2.9> }
        box { <-4.6, -5, 0> <-7.5, 50, 20> rotate -3*x translate <0, 7.5, 2.9> }
        box { <-10.7, -5, -20> <-13.6, 50, 0> rotate 3*x translate <0, 7.5, -2.9> }
        box { <-10.7, -5, 0> <-13.6, 50, 20> rotate -3*x translate <0, 7.5, 2.9> }
      }
      difference {
        merge {
          torus { 8, 2 translate <0, 1.9, 0> }
          cylinder { 0.000001*y, 1.900001*y, 10.000001 }
          cylinder { 1.899999*y, 3.900001*y, 8.000001 }
        }
        #if (setting > 1)
          cylinder { -1*y, 2*y, 8 }
        #end
        box { <-13, -1, -13> <13, 0, 13> }
      }
      #if (setting > 1)
        object { ring() }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 63.5*y, 17.5 } }
    }
  #end
#end
#macro tree_3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 2.1*y, 19*y, 2 }
      cylinder { 0*y, 3.9*y, 10.000001 }
      sphere { <0, 0, 0> 17.500001 scale <1, 1.1857142857, 0.95> translate <0, 39.25, 0> }
      texture { color_tex }
    }
  #else
    merge {
      cone { 18.999999*y, 2, 58*y, 1.5 }
      cylinder { 2.1*y, 19*y, 2 }
      difference {
        sphere { <0, 0, 0> 17.500001 scale <1, 1.1857142857, 0.95> translate <0, 39.25, 0> }
        box { <-20, 0, -20> <20, 100, -0.5> }
        box { <-20, 0, 0.5> <20, 100, 20> }
      }
      difference {
        sphere { <0, 0, 0> 17.5 scale <1, 1.1857142857, 0.95> translate <0, 39.25, 0> }
        box { <-18, 20.5, -18> <18, 23.5, 18> }
        box { <-18, 25.5, -18> <18, 28.5, 18> }
        box { <-18, 30.5, -18> <18, 33.5, 18> }
        box { <-18, 35.5, -18> <18, 38.5, 18> }
        box { <-18, 40.5, -18> <18, 43.5, 18> }
        box { <-18, 45.5, -18> <18, 48.5, 18> }
        box { <-18, 50.5, -18> <18, 53.5, 18> }
        box { <-18, 55.5, -18> <18, 58.5, 18> }
        box { <-1.4, -5, -20> <1.4, 60, 0> translate <0, 15.5, -3.9> }
        box { <-1.4, -5, 0> <1.4, 60, 20> translate <0, 7.5, 3.9> }
        box { <4.6, -5, -20> <7.5, 60, 0> translate <0, 7.5, -2.9> }
        box { <4.6, -5, 0> <7.5, 60, 20> translate <0, 7.5, 2.9> }
        box { <10.7, -5, -20> <13.6, 60, 0> translate <0, 7.5, -1.9> }
        box { <10.7, -5, 0> <13.6, 60, 20> translate <0, 7.5, 1.9> }
        box { <-4.6, -5, -20> <-7.5, 60, 0> translate <0, 7.5, -2.9> }
        box { <-4.6, -5, 0> <-7.5, 60, 20> translate <0, 7.5, 2.9> }
        box { <-10.7, -5, -20> <-13.6, 60, 0> translate <0, 7.5, -1.9> }
        box { <-10.7, -5, 0> <-13.6, 60, 20> translate <0, 7.5, 1.9> }
        box { <-1.4, 57, -10> <1.4, 70, -2.5> }
        box { <-1.4, 57, 2.5> <1.4, 70, 10> }
        box { <-7.5, 57, -10> <-4.6, 70, -1.5> }
        box { <-7.5, 57, 10> <-4.6, 70, 1.5> }
        box { <7.5, 57, -10> <4.6, 70, -1.5> }
        box { <7.5, 57, 10> <4.6, 70, 1.5> }
      }
      difference {
        merge {
          torus { 8, 2 translate <0, 1.9, 0> }
          cylinder { 0.000001*y, 1.900001*y, 10.000001 }
          cylinder { 1.899999*y, 3.900001*y, 8.000001 }
        }
        #if (setting > 1)
          cylinder { -1*y, 2*y, 8 }
        #end
        box { <-13, -1, -13> <13, 0, 13> }
      }
      #if (setting > 1)
        object { ring() }
      #end
      texture { color_tex }
      bounded_by { cylinder { -0.1*y, 63.5*y, 17.5 } }
    }
  #end
#end
#macro trih_block2_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 28.7, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 28.6*y, 30.4*y, 2.4  }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <8, 0, 0> }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <0, 0, 8> }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() translate <0, 25.6, 0> }
            object { rounded_button() translate <8, 25.6, 0> }
            object { rounded_button() translate <0, 25.6, 8> }
            object { rounded_button() translate <8, 25.6, 8> }
          #end
          box { <-3.9, 0, -3.9> <11.9, 28.7, 11.9> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 27.8, 10.4> }
          cylinder { 26.6*y, 29.6*y, 1.2 }
          cylinder { 26.6*y, 29.6*y, 1.2 translate <8, 0, 0> }
          cylinder { 26.6*y, 29.6*y, 1.2 translate <0, 0, 8> }
          cylinder { 26.6*y, 29.6*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { high_ring() scale <1, 3.2, 1> translate <4, 0, 4> }
        box { <-2.5, 9, -0.25> <0.9, 27.9, 0.25> }
        box { <7.9, 9, -0.25> <10.5, 27.9, 0.25> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 30.5, 12> } }
    }
  #end
#end
#macro tri_rotor_piece(color_tex)
  #if (setting = 0)
    merge {
      box { <0, 0, -3.9> <19.9, 3.1, 3.9> }
      box { <0, 0.000001, -3.9> <19.9, 3.100001, 3.9> rotate 120*y }
      box { <0, 0.000002, -3.9> <19.9, 3.100002, 3.9> rotate 240*y }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 3.1*y, 3.9 translate <16, 0, 0> }
        cylinder { 0*y, 3.1*y, 3.9 translate <16, 0, 0> rotate 120*y }
        cylinder { 0*y, 3.1*y, 3.9 translate <16, 0, 0> rotate 240*y }
        box { <0, 0.000001, -3.9> <16, 3.1000001, 3.9> }
        box { <0, 0.000003, -3.9> <16, 3.1000003, 3.9> rotate 120*y }
        box { <0, 0.000004, -3.9> <16, 3.1000004, 3.9> rotate 240*y }
        object { open_rounded_button() translate <8, 0, 0> }
        object { open_rounded_button() translate <16, 0, 0> }
        object { open_rounded_button() translate <8, 0, 0> rotate 120*y }
        object { open_rounded_button() translate <16, 0, 0> rotate 120*y }
        object { open_rounded_button() translate <8, 0, 0> rotate 240*y }
        object { open_rounded_button() translate <16, 0, 0> rotate 240*y }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <16, 3.1, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 0> rotate 120*y }
          object { llogo() scale <0.65, 0.65, 0.65> translate <16, 3.1, 0> rotate 120*y }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 3.1, 0> rotate 240*y }
          object { llogo() scale <0.65, 0.65, 0.65> translate <16, 3.1, 0> rotate 240*y }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            cylinder { -1*y, 2*y, 2.4 translate <16, 0, 0> }
            cylinder { -1*y, 2*y, 2.4 translate <16, 0, 0> rotate 120*y }
            cylinder { -1*y, 2*y, 2.4 translate <16, 0, 0> rotate 240*y }
            box { <-0.000005, -1, -2.4> <16, 2.000001, 2.4> }
            box { <-0.000005, -1, -2.4> <16, 2.000001, 2.4> rotate 120*y }
            box { <-0.000005, -1, -2.4> <16, 2.000001, 2.4> rotate 240*y }
          }
          object { pin(2) translate <12, 0.000007, 0> }
          object { pin(2) translate <12, 0.000007, 0> rotate 120*y }
          object { pin(2) translate <12, 0.000007, 0> rotate 240*y }
          box { <4.3, -2, -3> <5.75, 3, 3> }
          box { <4.3, -2, -3> <5.75, 3, 3> rotate 120*y }
          box { <4.3, -2, -3> <5.75, 3, 3> rotate 240*y }
          cylinder { 0.000005*y, 2.1*y, 3.4 }
        }
        object { axle_opening(5,1) rotate 90*z translate <0, -1, 0> }
        box { <0, -1, -0.5> <4.000001, 4, 0.5> }
        cylinder { -1*y, 4*y, 0.5 translate <4, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-13, -0.1, -18> <20, 4.9, 18> } }
    }
  #end
#end
#macro trolley(color_tex)
  #if (setting = 0)
    merge {
      box { <-9.5, -2.000001, -14.9> <9.5, -0.3, -4> }
      cylinder { <-5.3, 0, -3.5> <-10.25, 25.3, -3.5> 1.5 }
      cylinder { <5.3, 0, -3.5> <10.25, 25.3, -3.5> 1.5 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { -6.7*x, -5.3*x, 2.5 }
        box { <-6.700001, -2.500001, -4.9> <-5.300001, 2.500001, 0.000001> }
        cylinder { 5.3*x, 6.7*x, 2.5 }
        box { <5.300001, -2.500001, -4.9> <6.700001, 2.500001, 0.000001> }
        #if (setting > 3)
          object { llogo() rotate 90*y rotate -90*x translate <0, 12, -5.000001> }
        #end
        cylinder { <-5.3, 0, -3.5> <-10.25, 25.3, -3.5> 1.5 }
        cylinder { <5.3, 0, -3.5> <10.25, 25.3, -3.5> 1.5 }
        sphere { <-10.25, 25.3, -3.5> 1.500001 }
        sphere { <10.25, 25.3, -3.5> 1.500001 }
        cylinder { <-9.25, 23.75, -3.5> <-9.25, 23.75, 3.75> 1.5 }
        cylinder { <9.25, 23.75, -3.5> <9.25, 23.75, 3.75> 1.5 }
        cylinder { <-9.25, 23.75, 0> <-9.25, 23.75, 3.9> 1.35 }
        cylinder { <9.25, 23.75, 0> <9.25, 23.75, 3.9> 1.35 }
        torus { 1.35, 0.15 rotate 90*x translate <-9.25, 23.75, 3.75> }
        torus { 1.35, 0.15 rotate 90*x translate <9.25, 23.75, 3.75> }
        cylinder { <-10.250001, 25.299995, -3.500001> <-10.250001, 31.15, -2.5> 1.5 }
        cylinder { <10.250001, 25.299995, -3.500001> <10.250001, 31.15, -2.5> 1.5 }
        cylinder { <-10.250001, 25.299995, -3.500001> <-10.250001, 31.35, -2.5> 1.35 }
        cylinder { <10.250001, 25.299995, -3.500001> <10.250001, 31.35, -2.5> 1.35 }
        torus { 1.35, 0.15 translate <-10.25, 31.15, -2.5> }
        torus { 1.35, 0.15 translate <10.25, 31.15, -2.5> }
        box { <-9, 16.5, -5.000001> <9, 19.5, -3.5> }
        box { <-7.5, 10.5, -5.000001> <7.5, 13.5, -3.5> }
        box { <-6.5, 4.5, -5.000001> <6.5, 7.5, -3.5> }
        box { <-6.5, -1, -5.000001> <6.5, 1.5, -3.5> }
        difference {
          box { <-9.5, -2.000001, -14.9> <9.5, 10.25, -4> }
          box { <-10, -0.3, -15> <10, 20, -8.3> }
          box { <-8, -0.300001, -15> <8, 20, 0> }
          box { <0, -10, -10> <10, 0, 10> rotate 15*y translate <9.5, 0, -8.3> }
          box { <-10, -10, -10> <0, 0, 10> rotate -15*y translate <-9.5, 0, -8.3> }
          box { <-10, 0, -10> <10, 10, 0> rotate 32.5*x translate <0, 6, -8.3> }
        }
        box { <5.3, 0, -5.000002> <8.1, 6, -4.000001> }
        box { <-8.1, 0, -5.000002> <-5.3, 6, -4.000001> }
      }
      box { <-20, 31.3, -20> <20, 50, 20> }
      cylinder { -8*x, 8*x, 1 }
      box { <-8, -0.8, 0> <8, 0.8, 5> }
      box { <-8, -10, -20> <8, -2, 20> }
      cylinder { -10*x, -6.7*x, 4.7 }
      cylinder { 6.7*x, 10*x, 4.7 }
      box { <-10, -10, -4.700001> <-6.700001, 0, 0> }
      box { <6.700001, -10, -4.700001> <10, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-11.85, -2.1, -15> <11.85, 31.4, 4> } }
    }
  #end
#end
#macro trolley_wheels(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -9.2*x, -7.2*x, 4 }
      cylinder { 7.2*x, 9.2*x, 4 }
      cylinder { -8*x, 8*x, 0.9 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { -2.8*x, 2.8*x, 1.5 }
          cylinder { -8*x, 8*x, 0.9 }
          cylinder { -9.2*x, -7.2*x, 4 }
          cylinder { 7.2*x, 9.2*x, 4 }
        }
        cylinder { -10*x, -8.7*x, 2 }
        cylinder { 8.7*x, 10*x, 2 }
      }
      #if (setting > 3)
        object { llogo() scale <0.75, 0.75, 0.75> rotate 90*z rotate 180*x translate <-8.7, 0, 0> }
        object { llogo() scale <0.75, 0.75, 0.75> rotate -90*z translate <8.7, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { cylinder { -9.3*x, 9.3*x, 4.1 } }
    }
  #end
#end
#macro turn_base_l(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, .5, -3.9> <27.9, 3.1, 27.9> }
          box { <-3.5, 0, -3.5> <27.5, .55, 27.5> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 26.4> }
        #end
        cylinder { -1*y, 4*y, 4.5 translate <12, 0, 12> }
      }
      difference {
        cylinder { 3.09*y, 8.3*y, 5.5 }
        cylinder { 2*y, 9*y, 4 }
        translate <12, 0, 12>
      }
      difference {
        cylinder { 3.09*y, 6.7*y, 12.9 }
        cylinder { 2*y, 7*y, 11.4 }
        translate <12, 0, 12>
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <20, 0, 12> }
        object { ring() translate <4, 0, 20> }
        object { ring() translate <12, 0, 20> }
        object { ring() translate <20, 0, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 8.43, 28> } }
    }
  #end
#end
#macro turn_base_s(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, .5, -3.9> <11.9, 3.1, 11.9> }
          box { <-3.5, 0, -3.5> <11.5, .55, 11.5> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1.999999*y, 4*y, 7.5 translate <4, 0, 4> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            box { <-3, 0.5, 2.6> <11, 2, 5.4> }
            box { <2.6, 0.000001, -3> <5.4, 2.000001, 11> }
            cylinder { 2.000002*y, 0*y, 3.2 translate <4, 0, 4> }
          }
          cylinder { -1*y, 3*y, 1.5 translate <4, 0, 4> }
          cylinder { -1*y, 1.5*y, 2.6 translate <4, 0, 4> }
          bounded_by { box { <-4, -0.1, -4> <12, 3.2, 12> } }
        }
      #end
      texture { color_tex }
    }
  #end
#end
#macro turn_disc_l(color_tex)
  #if (setting = 0)
    cylinder { 3.2*y, 9.5*y, 15.9 texture { color_tex } }
  #else
    merge {
      #if (setting < 3)
        cylinder { 9.4*y, 11.2*y, 2.4 translate <-12, 0, -4> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <-4, 0, -4> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <4, 0, -4> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <12, 0, -4> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <-12, 0, 4> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <-4, 0, 4> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <4, 0, 4> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <12, 0, 4> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <-4, 0, -12> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <4, 0, -12> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <-4, 0, 12> }
        cylinder { 9.4*y, 11.2*y, 2.4 translate <4, 0, 12> }
      #else
        object { rounded_button() translate <-12, 6.4, -4> }
        object { rounded_button() translate <-4, 6.4, -4> }
        object { rounded_button() translate <4, 6.4, -4> }
        object { rounded_button() translate <12, 6.4, -4> }
        object { rounded_button() translate <-12, 6.4, 4> }
        object { rounded_button() translate <-4, 6.4, 4> }
        object { rounded_button() translate <4, 6.4, 4> }
        object { rounded_button() translate <12, 6.4, 4> }
        object { rounded_button() translate <-4, 6.4, -12> }
        object { rounded_button() translate <4, 6.4, -12> }
        object { rounded_button() translate <-4, 6.4, 12> }
        object { rounded_button() translate <4, 6.4, 12> }
      #end
      difference {
        cylinder { 3.2*y, 9.5*y, 15.9 }
        cylinder { 2*y, 8.6*y, 14.4 }
        cylinder { 1*y, 10*y, 2.5 }
      }
      difference {
        merge {
          cylinder { 3*y, 8.8*y, 3.7 }
          torus { 3.7, 0.7 translate <0, 4.3, 0> }
        }
        cylinder { 1*y, 10*y, 2.500001 }
        box { <-8, 1, -0.5> <8, 6, 0.5> }
        box { <-0.5, 1, -8> <0.5, 6, 8> }
      }
      texture { color_tex }
    }
  #end
#end
#macro turn_disc_s(color_tex)
  #if (setting = 0)
    cylinder { 2.1*y, 3.1*y, 7 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { 2.1*y, 3.1*y, 7 }
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 translate <-4, 0, -4> }
          cylinder { 3*y, 4.8*y, 2.4 translate <-4, 0, 4> }
          cylinder { 3*y, 4.8*y, 2.4 translate <4, 0, -4> }
          cylinder { 3*y, 4.8*y, 2.4 translate <4, 0, 4> }
        #else
          object { rounded_button() translate <-4, 0, -4> }
          object { rounded_button() translate <-4, 0, 4> }
          object { rounded_button() translate <4, 0, -4> }
          object { rounded_button() translate <4, 0, 4> }
        #end
        cylinder { 2.2*y, 0*y, 1.25 }
        torus { 1.25, 0.25 translate <0, 0.25, 0> }
      }
      #if (setting > 1)
        intersection {
          merge {
            cylinder { 1*y, 4*y, 1.2 translate <-4, 0, -4> }
            cylinder { 1*y, 4*y, 1.2 translate <-4, 0, 4> }
            cylinder { 1*y, 4*y, 1.2 translate <4, 0, -4> }
            cylinder { 1*y, 4*y, 1.2 translate <4, 0, 4> }
          }
          cylinder { 2*y, 5*y, 6.5 }
        }
        box { <-4, -1, -0.25> <4, 1.5, 0.25> }
        cylinder { -1*y, 2.1*y, 0.625 }
      #end
      texture { color_tex }
    }
  #end
#end
#macro twoi_slope2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
      box { <-20, -20, -20> <20, 0, 20> rotate 46*z translate <4, 0, 0> }
      box { <-20, -20, -20> <20, 0, 20> rotate -46*x translate <0, 0, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
            box { <-20, -20, -20> <20, 0, 20> texture { color_tex normal { bumping } }
              rotate 46*z translate <4, 0, 0> }
            box { <-20, -20, -20> <20, 0, 20> texture { color_tex normal { bumping } }
              rotate -46*x translate <0, 0, 4> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 }
          #else
            object { rounded_button() rotate 180*y translate <0, 6.4, 0> }
          #end
          object { open_rounded_button() translate <8, 6.4, 0> }
          object { open_rounded_button() translate <0, 6.4, 8> }
          object { open_rounded_button() translate <8, 6.4, 8> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, 1, -2.4> <10.4, 9.500002, 10.4> }
            box { <-4, 0, -4> <4, 11, 4> }
            box { <-20, -20, -20> <20, 0, 20> rotate 46*z translate <4, 2, 0> }
            box { <-20, -20, -20> <20, 0, 20> rotate -46*x translate <0, 2, 4> }
          }
          box { <-2.4, -1, -2.4> <2.4, 8.6, 2.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
        #end
      }
      difference {
        merge {
          difference {
            cylinder { 0*y, 9.500001*y, 2.4 }
            cylinder { -1*y, 10*y, 1.600001 }
            translate <8, 0, 0>
          }
          difference {
            cylinder { 0*y, 9.500001*y, 2.4 }
            cylinder { -1*y, 10*y, 1.600001 }
            translate <8, 0, 8>
          }
          difference {
            cylinder { 0*y, 9.500001*y, 2.4 }
            cylinder { -1*y, 10*y, 1.600001 }
            translate <0, 0, 8>
          }
        }
        box { <-20, -20, -20> <20, 0, 20> rotate 46*z translate <4, 2, 0> }
        box { <-20, -20, -20> <20, 0, 20> rotate -46*x translate <0, 2, 4> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 12> } }
    }
  #end
#end
#macro two_slope2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
      box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <4, 9.5, 0> }
      box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z rotate 90*y translate <0, 9.5, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 9.5, 11.9> }
            box { <-20, 0, -10> <20, 20, 20> texture { color_tex normal { bumping } }
              rotate 43.5*z translate <4, 9.5, 0> }
            box { <-20, 0, -10> <20, 20, 20> texture { color_tex normal { bumping } }
              rotate 43.5*z rotate 90*y translate <0, 9.5, 4> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 180*y translate <8, 6.4, 0> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 8.6, 10.4> }
            box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <4, 7.5, 0> }
            box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z rotate 90*y translate <0, 7.5, 4> }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      #if (setting > 1)
        difference {
          object { high_ring() translate <4, 0, 4> }
          box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z translate <4, 7.5, 0> }
          box { <-20, 0, -10> <20, 20, 20> rotate 43.5*z rotate 90*y translate <0, 7.5, 4> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 12> } }
    }
  #end
#end
#macro two_slope3_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 9.5, 19.9> }
      box { <-30, 0, -30> <30, 10, 30> rotate 24.5*z translate <12, 9.5, 0> }
      box { <-30, 0, -30> <30, 10, 30> rotate -24.5*x translate <0, 9.5, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <19.9, 9.5, 19.9> }
            box { <-30, 0, -30> <30, 10, 30> texture { color_tex normal { bumping } }
              rotate 24.5*z translate <12, 9.5, 0> }
            box { <-30, 0, -30> <30, 10, 30> texture { color_tex normal { bumping } }
              rotate -24.5*x translate <0, 9.5, 12> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 16> }
          #else
            object { rounded_button() rotate 90*y translate <16, 6.4, 16> }
          #end
        }
        #if (setting > 1)
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 16> }
          difference {
            box { <-2.4, -1, -2.4> <18.4, 8.6, 18.4> }
            box { <-30, 0, -30> <30, 10, 30> rotate 24.5*z translate <12, 7.5, 0> }
             box { <-30, 0, -30> <30, 10, 30> rotate -24.5*x translate <0, 7.5, 12> }
          }
        #end
      }
      difference {
        merge {
          object { high_ring() translate <4, 0, 4> }
          object { high_ring() translate <12, 0, 4> }
          object { high_ring() translate <4, 0, 12> }
          object { high_ring() translate <12, 0, 12> }
        }
        box { <-30, 0, -30> <30, 10, 30> rotate 24.5*z translate <12, 7.5, 0> }
        box { <-30, 0, -30> <30, 10, 30> rotate -24.5*x translate <0, 7.5, 12> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 11.3, 20> } }
    }
  #end
#end
#macro tyre_balloon(color_tex)
  difference {
    merge {
      torus { 6.2, 3.9 rotate 90*x scale <1, 1, 1.71794> }
      cylinder { -6.7*z, 6.7*z, 6.2 }
      #if (setting > 0)
        difference {
          cylinder { -6.725*z, 6.725*z, 6.2 }
          cylinder { -7*z, 7*z, 6.1 }
        }
      #end
    }
    #if (setting > 0)
      #local counter = 0;
      #while (counter < 15)
        difference {
          box { <-1, 6.2, -15> <1, 11, -0.4> }
          box { <-2, -1, -16> <0, 5, 1> rotate 7.5*z translate <-0.4, 6.2, 0> }
          box { <0, -1, -16> <2, 5, 1> rotate -7.5*z translate <0.4, 6.2, 0> }
          cylinder { -2*x, 2*x, 1 scale <1, 2.75, 6.7> translate <0, 6.2, 0> }
          rotate (12+(counter*24))*z
        }
        difference {
          box { <-1, 6.2, 0.4> <1, 11, 15> }
          box { <-2, -1, 16> <0, 5, -1> rotate 7.5*z translate <-0.4, 6.2, 0> }
          box { <0, -1, 16> <2, 5, -1> rotate -7.5*z translate <0.4, 6.2, 0> }
          cylinder { -2*x, 2*x, 1 scale <1, 2.75, 6.7> translate <0, 6.2, 0> }
          rotate (counter*24)*z
        }
        #local counter = counter + 1;
      #end
      difference {
        cylinder { -7*z, -6.5*z, 6 }
        cylinder { -8*z, -6*z, 3.85 }
        box { <0, 0, -8> <8, 8, -6> rotate -12*z }
        box { <-8, 0, -8> <0, 8, -6> rotate 48*z }
        box { <-8, -8, -8> <0, 0, -6> rotate -12*z }
        box { <0, -8, -8> <8, 0, -6> rotate 48*z }
      }
      cylinder { 1.1*z, 10*z, 4 }
      cylinder { -1.6*z, 10*z, 2.65 }
    #end
    #if (setting > 1)
      object { axle_opening(16,1) rotate -90*y translate <0, 0, -8> }
    #end
    texture { color_tex }
    bounded_by { cylinder { -6.825*z, 6.825*z, 10.2 } }
  }
#end
#macro tyre_large_1(color_tex)
  #if (setting = 0)
    cylinder { -5*z, 3*z, 10.25 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { -5*z, 3*z, 10.25 }
        cylinder { -6*z, 4*z, 4 }
        cone { -6*z, 6, -2*z, 2 }
        #local counter = 0;
        #while (counter < 18)
        difference {
          box { <-11, -1, -6> <-8.5, 1, -1> }
          box { <-10, -20, -7> <0, 0, 0> rotate 10*z translate <-8.5, -0.6, 0> }
          box { <-10, 0, -7> <0, 20, 0> rotate -10*z translate <-8.5, 0.6, 0> }
          rotate (counter*20)*z
        }
        difference {
          box { <-11, -1, -1> <-8.5, 1, 4> }
          box { <-10, -20, -2> <0, 0, 5> rotate 10*z translate <-8.5, -0.6, 0> }
          box { <-10, 0, -2> <0, 20, 5> rotate -10*z translate <-8.5, 0.6, 0> }
          rotate (10+(counter*20))*z
        }
        #local counter = counter + 1;
        #end
      }
      difference {
        cylinder { 2.9*z, 3.5*z, 5 }
        cylinder { 2*z, 4*z, 4.5 }
      }
      texture { color_tex }
      bounded_by { cylinder { -5.1*z, 3.1*z, 10.35 } }
    }
  #end
#end
#macro tyre_large_2(color_tex)
  #if (setting = 0)
    cylinder { -9*z, 3*z, 10.25 texture { color_tex } }
  #else
    difference {
      cylinder { -9*z, 3*z, 10.25 }
      cylinder { -10*z, 4*z, 5.5 }
      difference {
        cylinder { -7.76*z, -9.49*z, 11 }
        cone { -7.75*z, 10.25, -9.5*z, 8 }
      } 
      difference {
        cylinder { 1.76*z, 3.49*z, 11 }
        cone { 1.75*z, 10.25, 3.5*z, 8 }
      }
      #local counter = 0;
      #while (counter < 18)
      difference {
        box { <-11, -1, -10> <-8.5, 1, -3> }
        box { <-10, -20, -11> <0, 0, -2> rotate 10*z translate <-8.5, -0.7, 0> }
        box { <-10, 0, -11> <0, 20, -2> rotate -10*z translate <-8.5, 0.7, 0> }
        rotate (counter*20)*z
      }
      difference {
        box { <-11, -1, -3> <-8.5, 1, 4> }
        box { <-10, -20, -10> <0, 0, 10> rotate 10*z translate <-8.5, -0.7, 0> }
        box { <-10, 0, -10> <0, 20, 10> rotate -10*z translate <-8.5, 0.7, 0> }
        rotate (10+(counter*20))*z
      }
      #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { cylinder { -9.1*z, 3.1*z, 10.35 } }
    }
  #end
#end
#macro tyre_large_3(color_tex)
  #if (setting = 0)
    cylinder { -7.3*z, 3.6*z, 15 texture { color_tex } }
  #else
    difference {
      cylinder { -7.3*z, 3.6*z, 15 }
      cylinder { -8*z, 4*z, 8.8 }
      cone { -7.4*z, 10.2, -2.3*z, 8.500001 }
      #local counter = 0;
      #while (counter < 20)
        difference {
          box { <-16, -2.5, -8> <-13, 2.5, -2> }
          box { <-5, -10, -9> <5, 0, -1> rotate 9*z translate <-13, -0.9, 0> }
          box { <-5, 0, -9> <5, 10, -1> rotate -9*z translate <-13, 0.9, 0>  }
          rotate (counter*18)*z
        }
        difference {
          box { <-16, -2.5, -2> <-13, 2.5, 4> }
          box { <-5, -10, -3> <5, 0, 5> rotate 9*z translate <-13, -0.9, 0> }
          box { <-5, 0, -3> <5, 10, 5> rotate -9*z translate <-13, 0.9, 0>  }
          rotate (9+(counter*18))*z
        }
        #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { cylinder { -7.4*z, 3.7*z, 15.1 } }
    }
  #end
#end
#macro tyre_large_4(color_tex)
  #if (setting = 0)
    cylinder { -3.5*z, 3.5*z, 12.25 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { -3.5*z, 3.5*z, 12.25 }
        cylinder { -4*z, 4*z, 8.4 }
        #local counter = 0;
        #while (counter < 22)
          difference {
            box { <-13, -0.6, -4> <-10, 0.6, 0.000001> }
            box { <-15, -25, -7> <0, 0, 0> rotate 5*z translate <-10, -0.75, 0> }
            box { <-15, 0, -7> <0, 25, 0> rotate -5*z translate <-10, 0.75, 0> }
            rotate (counter*16.363636)*z
          }
          difference {
            box { <-13, -0.6, -0.000001> <-10, 0.6, 4> }
            box { <-15, -25, -2> <0, 0, 5> rotate 5*z translate <-10, -0.75, 0> }
            box { <-15, 0, -2> <0, 25, 5> rotate -5*z translate <-10, 0.75, 0> }
            rotate (8.181818+(counter*16.363636))*z
          }
          #local counter = counter + 1;
        #end
      }
      difference {
        cylinder { -2*z, 2*z, 9 }
        cylinder { -3*z, 3*z, 7.9 }
      }
      #local counter = 0;
      #while (counter < 8)
        cylinder { 7.4*y, 9*y, 0.5 translate <0, 0, -1.5> rotate (counter*45)*z }
        box { <-0.500001, 7.4, -1.500001> <0.500001, 9.000001, 1.500001> rotate (counter*45)*z }
        cylinder { 7.4*y, 9*y, 0.5 translate <0, 0, 1.5> rotate (counter*45)*z }
        #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { cylinder { -3.6*z, 3.6*z, 12.35 } }
    }
  #end
#end
#macro tyre_large_5(color_tex)
  #if (setting = 0)
    cylinder { -14.8*z, -1*z, 12.1 texture { color_tex }
  #else
    difference {
      merge {
        torus { 11.6, 0.5 rotate 90*x translate <0, 0, -1.5> }
        torus { 11.6, 0.5 rotate 90*x translate <0, 0, -14.3> }
        cylinder { -14.3*z, -1.5*z, 12.1 }
        cylinder { -14.8*z, -1*z, 11.6 }
      }
      cylinder { -15*z, 0*z, 7.1 }
      cone { -5.75*z, 8.5, -7.15*z, 7.1 }
      cone { -10.05*z, 7.7, -8.65*z, 7.1 }
      cylinder { -15*z, -10.04999*z, 8.5 }
      cylinder { -5.75001*z, 0*z, 8.5 }
      #local counter = 0;
      #while (counter < 20)
        difference {
          box { <-0.9, 11.3, -15> <0.9, 12.5, -7.9> }
          box { <-1, 0, -14.30001> <1, 11.8, 7> }
          cylinder { -1*x, 1*x, 0.5 translate <0, 11.3, -14.3> }
          rotate (counter*18)*z
        }
        difference {
          box { <-0.9, 11.3, -7.90001> <0.9, 12.5, 0> }
          box { <-1, 0, -1.50001> <1, 11.8, -15> }
          cylinder { -1*x, 1*x, 0.5 translate <0, 11.3, -1.5> }
          rotate (9+(counter*18))*z
        }
        #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { cylinder { -14.9*z, -0.9*z, 12.2 } }
    }
  #end
#end
#macro tyre_small_1(color_tex)
  #if (setting = 0)
    cylinder { -2.3*z, 2.3*z, 7.2 texture { color_tex } }
  #else
    merge {
      difference {
        sphere { <0, 0, 0> 7.2 }
        cylinder { -4*z, -1.5*z, 4 }
        cylinder { 1.5*z, 4*z, 4 }
        cylinder { -4*z, 4*z, 3.2 }
        box { <-10, -10, 2> <10, 10, 50> }
        box { <-10, -10, -50> <10, 10, -2> }
      }
      #if (setting > 1)
        difference {
          cylinder { -2.3*z, 2.3*z, 5.3 }
          cylinder { -3*z, 3*z, 5 }
        }
        difference {
          cylinder { -2.3*z, 2.3*z, 6.5 }
          cylinder { -3*z, 3*z, 6.2 }
        }
      #end
      texture { color_tex }
      bounded_by { cylinder { -2.4*z, 2.4*z, 7.3 } }
    }
  #end
#end
#macro tyre_small_2(color_tex)
  #if (setting = 0)
    cylinder { -3*z, 3*z, 7.25 texture { color_tex } }
  #else
    difference {
      cylinder { -3*z, 3*z, 7.25 }
      cylinder { -4*z, 4*z, 4 }
      #local counter = 0;
      #while (counter < 16)
      difference {
        box { <-11, -1, -4> <-6, 1, 0> }
        box { <-12, -20, -5> <0, 0, 1> rotate 11.25*z translate <-6, -0.5, 0> }
        box { <-12, 0, -5> <0, 20, 1> rotate -11.25*z translate <-6, 0.5, 0> }
        rotate (22.5*counter)*z
      }
      difference {
        box { <-11, -1, 0> <-6, 1, 4> }
        box { <-12, -20, -1> <0, 0, 5> rotate 11.25*z translate <-6, -0.5, 0> }
        box { <-12, 0, -1> <0, 20, 5> rotate -11.25*z translate <-6, 0.5, 0> }
        rotate (11.25+(22.5*counter))*z
      }
      #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { cylinder { -3.1*z, 3.1*z, 7.35 } }
    }
  #end
#end
#macro tyre_small_3(color_tex)
  #if (setting = 0)
    cylinder { -4.5*z, 4.5*z, 6.7 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -4.000001*z, 4.000001*z, 6.700001 }
        cylinder { -4.500001*z, 4.500001*z, 6.200001 }
        torus { 6.2, 0.5 rotate 90*x translate <0, 0, -4> }
        torus { 6.2, 0.5 rotate 90*x translate <0, 0, 4> }
      }
      cylinder { -5*z, 5*z, 4.1 }
      texture { color_tex }
      bounded_by { cylinder { -4.6*z, 4.6*z, 6.8 } }
    }
  #end
#end
#macro ugly_claw(color_tex)
  #if (setting = 0)
    box { <-15, -3.8, 0> <0, 3.8, 3> rotate -15*y translate <-5.5, 0, 2> texture { color_tex } }
  #else
    difference {
      prism {
        bezier_spline
        -3.8, 3.8, 64,
        <0, 3>, <1, 3>, <2.3, 2.1>, <2.3, 1.3>,
        <2.3, 1.3>, <2.3, 1.3>, <2.1, 1>, <2.1, 1>,
        <2.1, 1>, <2.1, 1>, <0.9, 0.6>, <0.9, 0.6>,
        <0.9, 0.6>, <0.9, 0.6>, <0.5, 1.1>, <0, 1.1>,
        <0, 1.1>, <-1.5, 1.1>, <-1.5, -1.1>, <0, -1.1>,
        <0, -1.1>, <0.5, -1.1>, <0.9, -0.6>, <0.9, -0.6>,
        <0.9, -0.6> <0.9, -0.6>, <2.1, -1>, <2.1, -1>,
        <2.1, -1>, <2.1, -1>, <2.3, -1.3>, <2.3, -1.3>,
        <2.3, -1.3>, <2.3, -2.1>, <1, -3>, <0, -3>,
        <0, -3>, <-1, -3>, <-2.3, -2.1>, <-2.3, -2.1>,
        <-2.3, -2.1>, <-2.3, -2.1>, <-6.0056, 0.6731>, <-7.5, 1>,
        <-7.5, 1>, <-10.7, 1.7>, <-16.5, -1.3>, <-16.5, -1.3>,
        <-16.5, -1.3>, <-16.5, -1.3>, <-17.5, 0.5>, <-20.5, -1.8>,
        <-20.5, -1.8>, <-20.5, -1.8>, <-20.5, 0>, <-20.5, 0>,
        <-20.5, 0>, <-20.5, 0>, <-13.6276, 2.9092>, <-6, 3.7>,
        <-6, 3.7>, <-3.9407, 3.9135>, <-2.1, 3.3>, <0, 3>
        sturm
      }
      cylinder { 1.3*y, 4*y, 0.65 translate <-5.5, 0, 2> }
      cylinder { -4*y, -2.5*y, 0.65 translate <-5.5, 0, 2> }
      difference {
        box { <-5.5, -4, -4> <5, 4, 5> }
        cylinder { -5*y, 5*y, 1.75 translate <-5.5, 0, 2> }
        box { <-6, 0.5, -5> <6, 1.6, 6> }
        box { <-6, -2.8, -5> <6, -1.7, 6> }
      }
      box { <0, -2.3, -10> <13, 2.3, 0> rotate -15*y translate <-20.500001, 0, -0.5> }
      box { <12.5, -1.700001, -10> <14.75, 0.500001, 0> rotate -15*y translate <-20.500001, 0, -0.500001> }
      texture { color_tex }
      bounded_by { box { <-20.6, -3.9, -3.1> <2.4, 3.9, 3.8> } }
    }
  #end
#end
#macro very_h_doorleft1_5(color_tex)
  #if (setting = 0)
    merge {
      box { <0, 0.000002, -3.9> <35.9, 38.3, -2.4> }
      cylinder { 0*y, 38.2*y, 3.9 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, 0.000002, -3.899998> <35.9, 38.299998, -2.4> }
        #if (setting < 3)
          cylinder { 38.2*y, 40*y, 2.4 }
        #else
          object { rounded_button() rotate 180*y translate <0, 35.2, 0> }
        #end
        cylinder { 0*y, 38.3*y, 3.9 }
        box { <0, 0.000001, -3.899999> <3.9, 38.289999, 0> }
        cylinder { -5.899999*z, -3.5*z, 0.8 translate <32, 17.45, 0> }
        cylinder { -5.899999*z, -3.5*z, 0.8 translate <32, 20.85, 0> }
        box { <31.2, 17.449999, -5.9> <32.8, 20.850001, -3.5> }
      }
      #if (setting > 1)
        cylinder { -1*y, 37.3*y, 2.5 }
        cylinder { 36.1*y, 39.1*y, 1.2 }
        difference {
          merge {
            cylinder { -4.8*z, -2*z, 0.9 translate <32, 17.45, 0> }
            cylinder { -4.8*z, -2*z, 0.9 translate <32, 20.85, 0> }
            box { <31.25, 17.449999, -4.800001> <32.75, 20.850001, -2> }
          }
          box { <32, 5, -5> <34, 23, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -6> <36, 40.1, 4> } }
    }
  #end
#end
#macro very_h_doorright1_5(color_tex)
  #if (setting = 0)
    merge {
      box { <0, 0.000002, 3.9> <35.9, 38.3, 2.4> }
      cylinder { 0*y, 38.2*y, 3.9 }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, 0.000002, 2.4> <35.9, 38.299998, 3.899998> }
        #if (setting < 3)
          cylinder { 38.2*y, 40*y, 2.4 }
        #else
          object { rounded_button() rotate 180*y translate <0, 35.2, 0> }
        #end
        cylinder { 0*y, 38.3*y, 3.9 }
        box { <0, 0.000001, 0> <3.9, 38.299999, 3.899999> }
        cylinder { 3.5*z, 5.899999*z, 0.8 translate <32, 17.45, 0> }
        cylinder { 3.5*z, 5.899999*z, 0.8 translate <32, 20.85, 0> }
        box { <31.25, 17.449999, 3.5> <32.75, 20.850001, 5.9> }
      }
      #if (setting > 1)
        cylinder { -1*y, 37.3*y, 2.5 }
        cylinder { 36.1*y, 39.1*y, 1.2 }
        difference {
          merge {
            cylinder { 2*z, 4.8*z, 0.9 translate <32, 17.45, 0> }
            cylinder { 2*z, 4.8*z, 0.9 translate <32, 20.85, 0> }
            box { <31.25, 17.449999, 2> <32.75, 20.850001, 4.800001> }
          }
          box { <32, 5, 0> <34, 23, 5> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <36, 40.1, 6> } }
    }
  #end
#end
#macro very_large_support(color_tex)
  #if (setting = 0)
    difference {
      box { <0, 0.000001, -3.9> <70, 115.100001, 3.9> rotate -45*y }
      box { <-75, -20, -10> <0, 150, 10> rotate -37*z rotate -45*y translate <0, 48, 0> }
      difference {
        box { <0, 0, -10> <75, 100, 10> rotate -37*z translate <15, 42.5, 0> rotate -45*y }
        box { <0, 111.999999, 0> <100, 200, 100> }
      }
      box { <0, -50, -10> <75, 0, 10> rotate -2*z translate <15, 42.5, 0> rotate -45*y }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
          difference {
            box { <35.9, 112, 35.9> <59.9, 115.1, 59.9> }
            #if (setting > 1)
              box { <37.4, 110, 37.4> <58.4, 114.2, 58.4> }
            #end
          }
          #if (setting < 3)
            cylinder { 115*y, 116.8*y, 2.4 translate <40, 0, 40> }
            cylinder { 115*y, 116.8*y, 2.4 translate <48, 0, 40> }
            cylinder { 115*y, 116.8*y, 2.4 translate <56, 0, 40> }
            cylinder { 115*y, 116.8*y, 2.4 translate <40, 0, 48> }
            cylinder { 115*y, 116.8*y, 2.4 translate <48, 0, 48> }
            cylinder { 115*y, 116.8*y, 2.4 translate <56, 0, 48> }
            cylinder { 115*y, 116.8*y, 2.4 translate <40, 0, 56> }
            cylinder { 115*y, 116.8*y, 2.4 translate <48, 0, 56> }
            cylinder { 115*y, 116.8*y, 2.4 translate <56, 0, 56> }
          #else
            object { rounded_button() rotate -90*y translate <40, 112, 40> }
            object { rounded_button() rotate -90*y translate <48, 112, 40> }
            object { rounded_button() rotate -90*y translate <56, 112, 40> }
            object { rounded_button() rotate -90*y translate <40, 112, 48> }
            object { rounded_button() rotate -90*y translate <48, 112, 48> }
            object { rounded_button() rotate -90*y translate <56, 112, 48> }
            object { rounded_button() rotate -90*y translate <40, 112, 56> }
            object { rounded_button() rotate -90*y translate <48, 112, 56> }
            object { rounded_button() rotate -90*y translate <56, 112, 56> }
          #end
          box { <0, 0.000001, -3.9> <70, 115.100001, 3.9> rotate -45*y }
        }
        #if (setting > 1)
          cylinder { 113*y, 116*y, 1.2 translate <40, 0, 40> }
          cylinder { 113*y, 116*y, 1.2 translate <48, 0, 40> }
          cylinder { 113*y, 116*y, 1.2 translate <56, 0, 40> }
          cylinder { 113*y, 116*y, 1.2 translate <40, 0, 48> }
          cylinder { 113*y, 116*y, 1.2 translate <48, 0, 48> }
          cylinder { 113*y, 116*y, 1.2 translate <56, 0, 48> }
          cylinder { 113*y, 116*y, 1.2 translate <40, 0, 56> }
          cylinder { 113*y, 116*y, 1.2 translate <48, 0, 56> }
          cylinder { 113*y, 116*y, 1.2 translate <56, 0, 56> }
        #end
        box { <-75, -20, -10> <0, 150, 10> rotate -37*z rotate -45*y translate <0, 48, 0> }
        difference {
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          box { <-5, -2, -3.900005> <20, 3, 3.900005> rotate -45*y }
        }
        difference {
          box { <-10, -1, -2.4> <20, 2.00005, 2.4> rotate -45*y }
          box { <-10, -2, -10> <20, 3, -2.400001> }
          box { <-10, -2, -10> <-2.400001, 3, 20> }
        }
        difference {
          box { <0, 0, -10> <75, 100, 10> rotate -37*z translate <15, 42.5, 0> rotate -45*y }
          box { <0, 111.999999, 0> <100, 200, 100> }
        }
        box { <0, -50, -10> <75, 0, 10> rotate -2*z translate <15, 42.5, 0> rotate -45*y }
        difference {
          box { <0.5, -1, -2.4> <80, 114.200001, 2.4> }
          box { <-75, 0, -3> <0, 100, 3> rotate -37*z translate <0, 47, 0> }
          box { <11, 35, -3> <12, 110, 3> }
          box { <29, 72, -3> <30, 110, 3> }
          box { <45, 101, -3> <46, 110, 3> }
          rotate -45*y
        }
        cylinder { -1*y, 2.000001*y, 2.5 translate <8, 0, 0> }
        cylinder { -1*y, 2.000001*y, 2.5 translate <0, 0, 8> }
      }
      #if (setting > 1)
        box { <37.3, 112.000001, 52> <53.5, 114.3, 53.5> }
        box { <52, 112.000003, 37.300001> <53.500001, 114.3, 53.500005> }
        box { <42.4, 112.000004, 55.5> <45.6, 114.3, 56.5> }
        box { <50.4, 112.000005, 55.5> <53.6, 114.3, 56.5> }
        box { <55.5, 112.000006, 42.4> <56.5, 114.3, 45.6> }
        box { <55.5, 112.000007, 50.4> <56.5, 114.3, 53.6> }
        box { <43, 112.000008, 52.5> <44.5, 114.3, 58.5> }
        box { <51, 112.000009, 52.5> <52.5, 114.3, 58.5> }
        box { <52.5, 112.000010, 43> <58.5, 114.3, 44.5> }
        box { <52.5, 112.000011, 51> <58.5, 114.3, 52.5> }
        box { <0, 112.000012, -0.5> <15, 114.3, 0.5> rotate 45*y translate <36, 0, 48> }
        box { <0, 112.000013, -0.5> <10, 114.3, 0.5> rotate 45*y translate <36, 0, 56> }
        box { <16, 112.000013, -0.5> <26, 114.3, 0.5> rotate 45*y translate <36, 0, 56> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 116.9, 60> } }
    }
  #end
#end
#macro very_large_support2(color_tex)
  #if (setting = 0)
    merge {
      box { <28.1, 150.400003, 12.1> <91.9, 153.500001, 27.9> }
      difference {
        box { <-3.899999, 0, -3.899999> <123.899999, 153.5, 19.9> }
        box { <-4, -100, -20> <124, 0, 0> rotate 13.25*x translate <0, 153.5, 11.9> }
        box { <-50, 0, -4> <0, 200, 40> rotate -12.5*z translate <-3.9, 9.5, 0> }
        box { <0, 0, -4> <50, 200, 40> rotate 12.5*z translate <123.9, 9.5, 0> }
        difference {
          box { <11.9, 0, -4> <108.1, 76.8, 28> }
          box { <-50, 0, -4> <0, 200, 40> rotate -12.5*z translate <11.9, 9.5, 0> }
          box { <0, 0, -4> <50, 200, 40> rotate 12.5*z translate <108.1, 9.5, 0> }
        }
        difference {
          box { <11.9, 86.3, -4> <108.1, 160, 12.1> }
          box { <-50, 0, -4> <0, 200, 40> rotate -12.5*z translate <11.9, 9.5, 0> }
          box { <0, 0, -4> <50, 200, 40> rotate 12.5*z translate <108.1, 9.5, 0> }
        }
        difference {
          box { <11.9, 86.300001, 12.099999> <108.1, 152.600001, 32> }
          box { <-50, 0, -4> <0, 200, 40> rotate -12.5*z translate <11.900001, 9.5, 0> }
          box { <0, 0, -4> <50, 200, 40> rotate 12.5*z translate <108.100001, 9.5, 0> }
        }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
          box { <108.1, 0, -3.9> <123.9, 3.1, 11.9> }
          box { <28.1, 150.400003, 12.1> <91.9, 153.500001, 27.9> }
          difference {
            box { <-3.899999, 3.099999, -3.899999> <123.899999, 153.5, 19.9> }
            box { <-4, -100, -20> <124, 0, 0> rotate 13.25*x translate <0, 153.5, 11.9> }
            box { <-50, 0, -4> <0, 200, 40> rotate -12.5*z translate <-3.9, 9.5, 0> }
            box { <0, 0, -4> <50, 200, 40> rotate 12.5*z translate <123.9, 9.5, 0> }
            difference {
              box { <11.9, 0, -4> <108.1, 76.8, 28> }
              box { <-50, 0, -4> <0, 200, 40> rotate -12.5*z translate <11.9, 9.5, 0> }
              box { <0, 0, -4> <50, 200, 40> rotate 12.5*z translate <108.1, 9.5, 0> }
            }
            difference {
              box { <11.9, 86.3, -4> <108.1, 160, 12.1> }
              box { <-50, 0, -4> <0, 200, 40> rotate -12.5*z translate <11.9, 9.5, 0> }
              box { <0, 0, -4> <50, 200, 40> rotate 12.5*z translate <108.1, 9.5, 0> }
            }
            difference {
              box { <11.9, 86.300001, 12.099999> <108.1, 152.600001, 32> }
              box { <-50, 0, -4> <0, 200, 40> rotate -12.5*z translate <11.900001, 9.5, 0> }
              box { <0, 0, -4> <50, 200, 40> rotate 12.5*z translate <108.100001, 9.5, 0> }
            }
            #if (setting > 1)
              difference {
                box { <11.9, 70, -2.4> <108.1, 85.4, 2.4> }
                box { <-50, 0, -4> <0, 200, 40> rotate -12.5*z translate <11.900005, 9.5, 0> }
                box { <0, 0, -4> <50, 200, 40> rotate 12.5*z translate <108.100005, 9.5, 0> }
                cylinder { 76.800001*y, 86*y, 1.5 translate <36, 0, 0> }
                cylinder { 76.800001*y, 86*y, 1.5 translate <44, 0, 0> }
                cylinder { 76.800001*y, 86*y, 1.5 translate <52, 0, 0> }
                cylinder { 76.800001*y, 86*y, 1.5 translate <60, 0, 0> }
                cylinder { 76.800001*y, 86*y, 1.5 translate <68, 0, 0> }
                cylinder { 76.800001*y, 86*y, 1.5 translate <76, 0, 0> }
                cylinder { 76.800001*y, 86*y, 1.5 translate <84, 0, 0> }
                box { <43.6, 76.9, -2.5> <44.4, 86, 2.5> }
                box { <59.6, 76.9, -2.5> <60.4, 86, 2.5> }
                box { <75.6, 76.9, -2.5> <75.4, 86, 2.5> }
                box { <0, 76.9, -0.5> <29.6, 86, 0.5> }
                box { <90.4, 76.9, -0.5> <120, 86, 0.5> }
              }
            #end
            difference {
              box { <11.9, 50, 3.999998> <108.1, 125, 32> }
              box { <-50, 0, -4> <0, 200, 40> rotate -12.5*z translate <11.900002, 9.5, 0> }
              box { <0, 0, -4> <50, 200, 40> rotate 12.5*z translate <108.100002, 9.5, 0> }
            }
            box { <-4, 0, 3.9> <130, 50, 40> }
            difference {
              cylinder { -4*x, 130*x, 307 translate <0, 50, 310.9> }
              box { <-4, 123.5, -500> <124, 500, 500> }
            }
            difference {
              box { <-10, 140, 10> <130, 160, 40> }
              box { <-4, -40, -100> <124, 100, 0> rotate 13.25*x translate <0, 153.5, 19.900001> }
            }
            difference {
              box { <-4, -40, 0> <124, 100, 100> rotate 13.25*x translate <0, 153.5, 19.9> }
              box { <-4, 150.400001, -500> <124, 500, 500> }
              box { <28.100001, 150.400002, 12.100001> <91.900001, 155, 27.900001> }
            }
            cylinder { -5*z, -3.4*z, 2 translate <20, 81.5, 0> }
            cylinder { -5*z, -3.4*z, 2 translate <100, 81.5, 0> }
            difference {
              box { <-2.4, 9.6, -2.4> <122.4, 150.400007, 30> }
              box { <-4, -100, -20> <124, 0, 0> rotate 13.25*x translate <0, 153.5, 13.4> }
              difference {
                box { <10.4, 0, -4> <109.6, 150.400003, 40> }
                box { <-50, 0, -4> <0, 200, 40> rotate -12.5*z translate <10.4, 9.5, 0> }
                box { <0, 0, -4> <50, 200, 40> rotate 12.5*z translate <109.6, 9.5, 0> }
              }
              box { <-50, 0, -4> <0, 200, 40> rotate -12.5*z translate <-2.4, 9.5, 0> }
              box { <0, 0, -4> <50, 200, 40> rotate 12.5*z translate <122.4, 9.5, 0> }
            }
          }
          cylinder { 143.900001*y, 153*y, 1.5 translate <52, 0, 16> }
          cylinder { 143.900001*y, 153*y, 1.5 translate <60, 0, 16> }
          cylinder { 143.900001*y, 153*y, 1.5 translate <68, 0, 16> }
          difference {
            merge {
              box { <40, 143.900002, 18.4> <80, 153, 19.9> }
              box { <40, 143.900002, 12.100001> <80, 153, 13.6> }
              box { <40, 143.900001, 15.5> <45.6, 153, 16.5> }
              box { <74.4, 143.900001, 15.5> <80, 153, 16.5> }
            }
            box { <-50, 0, -4> <0, 200, 40> rotate -12.5*z translate <11.900007, 9.5, 0> }
            box { <0, 0, -4> <50, 200, 40> rotate 12.5*z translate <108.100007, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 86.2*y, 88*y, 2.4 translate <40, 0, 0> }
            cylinder { 86.2*y, 88*y, 2.4 translate <48, 0, 0> }
            cylinder { 86.2*y, 88*y, 2.4 translate <56, 0, 0> }
            cylinder { 86.2*y, 88*y, 2.4 translate <64, 0, 0> }
            cylinder { 86.2*y, 88*y, 2.4 translate <72, 0, 0> }
            cylinder { 86.2*y, 88*y, 2.4 translate <80, 0, 0> }
            cylinder { 153.4*y, 155.2*y, 2.4 translate <48, 0, 16> }
            cylinder { 153.4*y, 155.2*y, 2.4 translate <56, 0, 16> }
            cylinder { 153.4*y, 155.2*y, 2.4 translate <64, 0, 16> }
            cylinder { 153.4*y, 155.2*y, 2.4 translate <72, 0, 16> }
            cylinder { 153.4*y, 155.2*y, 2.4 translate <48, 0, 24> }
            cylinder { 153.4*y, 155.2*y, 2.4 translate <56, 0, 24> }
            cylinder { 153.4*y, 155.2*y, 2.4 translate <64, 0, 24> }
            cylinder { 153.4*y, 155.2*y, 2.4 translate <72, 0, 24> }
          #else
            object { rounded_button() translate <40, 83.2, 0> }
            object { rounded_button() translate <48, 83.2, 0> }
            object { rounded_button() translate <56, 83.2, 0> }
            object { rounded_button() translate <64, 83.2, 0> }
            object { rounded_button() translate <72, 83.2, 0> }
            object { rounded_button() translate <80, 83.2, 0> }
            object { rounded_button() translate <48, 150.4, 16> }
            object { rounded_button() translate <56, 150.4, 16> }
            object { rounded_button() translate <64, 150.4, 16> }
            object { rounded_button() translate <72, 150.4, 16> }
            object { rounded_button() translate <48, 150.4, 24> }
            object { rounded_button() translate <56, 150.4, 24> }
            object { rounded_button() translate <64, 150.4, 24> }
            object { rounded_button() translate <72, 150.4, 24> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <44.1, 140, 19.900005> <75.9, 152.600008, 26.4> }
            box { <40, 141, 23.5> <45.6, 153, 24.5> }
            box { <74.4, 141, 23.5> <80, 153, 24.5> }
            box { <47.5, 141, 18> <48.5, 153, 21.6> }
            box { <55.5, 141, 18> <56.5, 153, 21.6> }
            box { <63.5, 141, 18> <64.5, 153, 21.6> }
            box { <71.5, 141, 18> <72.5, 153, 21.6> }
            cylinder { 141*y, 153*y, 1.5 translate <52, 0, 24> }
            cylinder { 141*y, 153*y, 1.5 translate <60, 0, 24> }
            cylinder { 141*y, 153*y, 1.5 translate <68, 0, 24> }
          }
          cylinder { 151.4*y, 154.4*y, 1.2 translate <48, 0, 16> }
          cylinder { 151.4*y, 154.4*y, 1.2 translate <56, 0, 16> }
          cylinder { 151.4*y, 154.4*y, 1.2 translate <64, 0, 16> }
          cylinder { 151.4*y, 154.4*y, 1.2 translate <72, 0, 16> }
          cylinder { 151.4*y, 154.4*y, 1.2 translate <48, 0, 24> }
          cylinder { 151.4*y, 154.4*y, 1.2 translate <56, 0, 24> }
          cylinder { 151.4*y, 154.4*y, 1.2 translate <64, 0, 24> }
          cylinder { 151.4*y, 154.4*y, 1.2 translate <72, 0, 24> }
          cylinder { 84.2*y, 87.2*y, 1.2 translate <40, 0, 0> }
          cylinder { 84.2*y, 87.2*y, 1.2 translate <48, 0, 0> }
          cylinder { 84.2*y, 87.2*y, 1.2 translate <56, 0, 0> }
          cylinder { 84.2*y, 87.2*y, 1.2 translate <64, 0, 0> }
          cylinder { 84.2*y, 87.2*y, 1.2 translate <72, 0, 0> }
          cylinder { 84.2*y, 87.2*y, 1.2 translate <80, 0, 0> }
          difference {
            box { <-2.4, -10, -2.4> <10.4, 8.6, 3.2> }
            cylinder { 0.000001*y, 9*y, 1.5 translate <4, 0, 0> }
            box { <-0.5, 0.000002, 2.4> <0.5, 9, 3.5> }
            box { <7.5, 0.000002, 2.4> <8.5, 9, 3.5> }
            box { <-3, 2, 2.4> <11, 9, 3.5> }
          }
          difference {
            box { <109.6, -10, -2.4> <122.4, 8.6, 3.2> }
            cylinder { 0.000001*y, 9*y, 1.5 translate <116, 0, 0> }
            box { <119.5, 0.000002, 2.4> <120.5, 9, 3.5> }
            box { <111.5, 0.000002, 2.4> <112.5, 9, 3.5> }
            box { <-3, 2, 2.4> <123, 9, 3.5> }
          }
          difference {
            box { <-2.4, -10, 4.5> <10.4, 2, 10.4> }
            box { <-0.5, 0.000002, 2.4> <0.5, 3, 5.6> }
            box { <7.5, 0.000002, 2.4> <8.5, 3, 5.6> }
            difference {
              cylinder { 0.000003*y, 2.1*y, 1.5 }
              cylinder { -1*y, 3*y, 0.6 }
              translate <4, 0, 8>
            }
            box { <3.5, 0.000004, 4> <4.5, 2.1, 6.6> }
            box { <3.5, 0.000004, 9.4> <4.5, 2.1, 11> }
          }
          difference {
            box { <109.6, -10, 4.5> <122.4, 2, 10.4> }
            box { <111.5, 0.000002, 2.4> <112.5, 3, 5.6> }
            box { <119.5, 0.000002, 2.4> <120.5, 3, 5.6> }
            difference {
              cylinder { 0.000003*y, 2.1*y, 1.5 }
              cylinder { -1*y, 3*y, 0.6 }
              translate <116, 0, 8>
            }
            box { <115.5, 0.000004, 4> <116.5, 2.1, 6.6> }
            box { <115.5, 0.000004, 9.4> <116.5, 2.1, 11> }
          }
        #end
        box { <29, 151.5, 13> <43, 154, 27> }
        box { <77, 151.5, 13> <91, 154, 27> }
      }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <32, 151.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <40, 151.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <80, 151.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <88, 151.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <32, 151.5, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <40, 151.5, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <80, 151.5, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <88, 151.5, 24> }
      #end
      object { open_rounded_button() translate <32, 150.4, 16> }
      object { open_rounded_button() translate <40, 150.4, 16> }
      object { open_rounded_button() translate <80, 150.4, 16> }
      object { open_rounded_button() translate <88, 150.4, 16> }
      object { open_rounded_button() translate <32, 150.4, 24> }
      object { open_rounded_button() translate <40, 150.4, 24> }
      object { open_rounded_button() translate <80, 150.4, 24> }
      object { open_rounded_button() translate <88, 150.4, 24> }
      difference {
        cylinder { 150.7*y, 153.400001*y, 2.400001 }
        cylinder { 150*y, 156*y, 1.600001 }
        translate <32, 0, 16>
      }
      difference {
        cylinder { 150.7*y, 153.400001*y, 2.400001 }
        cylinder { 150*y, 156*y, 1.600001 }
        translate <40, 0, 16>
      }
      difference {
        cylinder { 150.7*y, 153.400001*y, 2.400001 }
        cylinder { 150*y, 156*y, 1.600001 }
        translate <80, 0, 16>
      }
      difference {
        cylinder { 150.7*y, 153.400001*y, 2.400001 }
        cylinder { 150*y, 156*y, 1.600001 }
        translate <88, 0, 16>
      }
      difference {
        cylinder { 150.7*y, 153.400001*y, 2.400001 }
        cylinder { 150*y, 156*y, 1.600001 }
        translate <32, 0, 24>
      }
      difference {
        cylinder { 150.7*y, 153.400001*y, 2.400001 }
        cylinder { 150*y, 156*y, 1.600001 }
        translate <40, 0, 24>
      }
      difference {
        cylinder { 150.7*y, 153.400001*y, 2.400001 }
        cylinder { 150*y, 156*y, 1.600001 }
        translate <80, 0, 24>
      }
      difference {
        cylinder { 150.7*y, 153.400001*y, 2.400001 }
        cylinder { 150*y, 156*y, 1.600001 }
        translate <88, 0, 24>
      }
      difference {
        cylinder { 150.7*y, 153.500001*y, 2.9 }
        cylinder { 150*y, 156*y, 0.9 }
        translate <36, 0, 20>
      }
      difference {
        cylinder { 150.7*y, 153.500001*y, 2.9 }
        cylinder { 150*y, 156*y, 0.9 }
        translate <84, 0, 20>
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <124, 155.3, 28> } }
    }
  #end
#end
#macro vhislope1_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 28.7, 3.9> }
      box { <-80, -50, -10> <80, 0, 10> rotate 73.85*z translate <4, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <11.9, 28.7, 3.9> }
          box { <-80, -50, -10> <80, 0, 10> rotate 73.85*z texture { color_tex normal { bumping } }
            translate <4, 0, 0> }
          difference {
            box { <-4, 6.4, -2.4> <12, 27.2, 2.4> }
            box { <0, 0, -4> <10, 50, 4> rotate -16.15*z translate <4.5, 6.5, 0> }
          }
        }
        object { open_rounded_button() translate <0, 25.6, 0> }
        object { open_rounded_button() translate <8, 25.6, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <0, 28.7, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <8, 28.7, 0> }
        #end
        difference {
          merge {
            cylinder { -3.9*x, 10*x, 1.5 translate <0, 20.8, 0> }
            cylinder { -3.9*x, 10*x, 1.5 translate <0, 12.8, 0> }
            box { <-3, 20.3, -3> <11, 21.3, 3> }
            box { <-3, 12.3, -3> <11, 13.3, 3> }
          }
          box { <0, 0, -4> <10, 50, 4> rotate -16.15*z translate <4.5, 6.5, 0> }
        }
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 5.5, 2.4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 30.5, 4> } }
    }
  #end
#end
#macro vhi_arch1_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <35.9, 38.3, 3.9> }
      cylinder { -4*z, 4*z, 32 translate <35.9, 38.3, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <35.9, 38.3, 3.9> }
          box { <-4, -1, -4> <4.1, 19.2, 4> }
          box { <-4, -1, -4> <12.1, 9.6, 4> }
          box { <27.9, 3.1, -4> <40, 40, 4> }
          cylinder { -4*z, 4*z, 32 translate <35.9, 38.3, 0> }
          #if (setting > 1)
            difference {
              box { <-2.4, -1, -2.4> <34.4, 37.4, 2.4> }
              cylinder { -4*z, 4*z, 33.5 translate <35.9, 38.3, 0> }
              box { <26.5, 2, -4> <35, 30, 4> }
              box { <12.100005, -2, -4> <13.1, 30, 4> }
              box { <4.100005, -2, -4> <5.1, 30, 4> }
              object { pin(2) translate <28, 0.000005, 0> }
              object { pin(2) translate <20, 0.1, 0> }
              cylinder { 2.199995*y, 30*y, 1.500005 translate <20, 0, 0> }
              box { <19.7, 0.100005, -3> <20.3, 30, -1.4> }
              box { <19.7, 0.100005, 3> <20.3, 30, 1.4> }
              box { <2.4, 9.600005, -0.5> <4.2, 30, 0.5> }
              box { <10.4, 9.600005, -0.5> <12.2, 30, 0.5> }
            }
          #end
        }
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
          cylinder { 38.2*y, 40*y, 2.4 }
        #else
          object { rounded_button() translate <0, 35.2, 0> }
          object { rounded_button() translate <32, 0, 0> }
        #end
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <36, 40.1, 4> } }
    }
  #end
#end
#macro vhside3_2(color_tex, age)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -19.9> <11.9, 57.5, 3.9> }
      box { <-10, -30, -50> <20, 30, 0> rotate 43*x translate <0, 57.5, -4> }
      box { <-10, -30, -50> <20, 30, 0> rotate -41.5*x translate <0, 0, -4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -19.9> <11.9, 57.5, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -3.4> <10.4, 2, 2.4> }
        #end
        box { <-4, 54.3, -4.1> <12, 58, 4> }
        box { <-10, -30, -50> <20, 30, 0> rotate 43*x translate <0, 57.5, -4> }
        box { <-10, -30, -50> <20, 30, 0> rotate -41.5*x translate <0, 0, -4> }
        difference {
          box { <-4, 3.100002, -18.5> <12, 53.30002, 4> }
          box { <-2.500001, -30, -50> <10.500001, 30, 0> rotate 43*x translate <0, 51.1, -8> }
          box { <-10, -30, -50> <20, 30, 0> rotate -41.5*x translate <0, 3.1, -5> }
          box { <-5, 0, -20> <-2.5, 51.1, -16.9> }
          box { <10.5, 0, -20> <13, 51.1, -16.9> }
          box { <-5, 51.1, -20> <-2.5, 54, 4> }
          box { <10.5, 51.1, -20> <13, 54, 4> }
          box { <-0.5, 52.1, -20> <0.5, 54, -2.5> }
          box { <7.5, 52.1, -20> <8.5, 54, -2.5> }
          #if (setting > 1)
            box { <2.5, 51.1, -20> <3.5, 54, 4> }
            box { <4.5, 51.1, -20> <5.5, 54, 4> }
          #end
          box { <-5, 0, -2> <-2.5, 30, 0> rotate -41.5*x translate <0, 3.100001, -2.5> }
          box { <10.5, 0, -2> <13, 30, 0> rotate -41.5*x translate <0, 3.100001, -2.5> }
          box { <-5, -30, -5> <-2.5, 0, 0> rotate 43*x translate <0, 55.000001, -2.5> }
          box { <10.5, -30, -5> <13, 0, 0> rotate 43*x translate <0, 55.000001, -2.5> }
        }
      }
      object { open_rounded_button() translate <0, 51.2, 0> }
      object { open_rounded_button() translate <8, 51.2, 0> }
      #if (setting > 3)
        object { llogo() rotate 90*y translate <0, 54.3, 0> }
        object { llogo() rotate 90*y translate <8, 54.3, 0> }
      #end
      #if (setting > 1)
        object { pin(age) translate <4, 0, 0> }
        box { <-0.5, 0.000001, -3.8> <0.5, 2.1, -2.5> }
        box { <7.5, 0.000001, -3.8> <8.5, 2.1, -2.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -20> <12, 57.6, 4> } }
    }
  #end
#end
#macro vhside3_2_concave(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -27.9> <27.9, 57.5, 3.9> }
      difference {
        box { <-4, 35, -28> <20, 60, -4> }
        box { <-10, -30, 0> <28, 30, 50> rotate 43*x translate <0, 57.5, -4> }
        box { <-28, -30, 0> <28, 30, 50> rotate 43*x rotate 90*y translate <20, 57.5, -28> }
      }
      difference {
        box { <-4, -1, -28> <20, 25, -4> }
        box { <-28, -30, 0> <28, 30, 50> rotate -41.5*x rotate 90*y translate <20, 0, -28> }
        box { <-10, -30, 0> <28, 30, 50> rotate -41.5*x translate <0, 0, -4> }
      }
      box { <-4, -1, -28> <4.1, 60, -19.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -27.9> <27.9, 57.5, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -3.4> <26.4, 2, 2.4> }
          box { <20.6, -1, -26.4> <26.400001, 2.000001, 2.400001> }
        #end
        box { <-4, 54.3, -4.1> <28, 58, 4> }
        box { <19.9, 54.300001, -28> <28, 58, 4> }
        box { <-4, -1, -28> <4.1, 60, -19.9> }
        difference {
          box { <-4, 35, -28> <20, 60, -4> }
          box { <-10, -30, 0> <28, 30, 50> rotate 43*x translate <0, 57.5, -4> }
          box { <-28, -30, 0> <28, 30, 50> rotate 43*x rotate 90*y translate <20, 57.5, -28> }
        }
        difference {
          box { <-4, -1, -28> <20, 25, -4> }
          box { <-28, -30, 0> <28, 30, 50> rotate -41.5*x rotate 90*y translate <20, 0, -28> }
          box { <-10, -30, 0> <28, 30, 50> rotate -41.5*x translate <0, 0, -4> }
        }
        difference {
          box { <-4, 3.100002, -28> <28, 53.30002, 4> }
          box { <-5, -30, -5> <-2.500001, 0, 0> rotate 43*x translate <0, 55.000001, -2.5> }
          box { <-5, 0, -5> <-2.500001, 30, 0> rotate -41.5*x translate <0, 3.100001, -2.5> }
          box { <-5, 0, -20> <-2.5, 51.1, -16.9> }
          box { <-5, 51.1, -20> <-2.5, 54, 4> }
          box { <4, 0, -28> <7.1, 51.1, -26.5> }
          box { <-4, 51.1, -28> <28, 54, -26.5> }
          box { <-4, -1, -28> <5.6, 60, -18.4> }
          box { <-5, -30, -5> <-2.500001, 0, 0> rotate 43*x rotate 90*y translate <21.5, 55.000001, -32> }
          box { <-5, 0, -5> <-2.500001, 30, 0> rotate -41.5*x rotate 90*y translate <21.5, 3.100001, -32> }
          difference {
            box { <-4, 35, -28> <20, 60, -4> }
            box { <-10, -30, 0> <28, 30, 50> rotate 43*x translate <0, 57.5, -2.5> }
            box { <-28, -30, 0> <28, 30, 50> rotate 43*x rotate 90*y translate <21.5, 57.5, -28> }
          }
          difference {
            box { <-4, -1, -28> <20, 25, -4> }
            box { <-28, -30, 0> <28, 30, 50> rotate -41.5*x rotate 90*y translate <21.5, 0, -28> }
            box { <-10, -30, 0> <28, 30, 50> rotate -41.5*x translate <0, 0, -2.5> }
          }
        }
      }
      object { open_rounded_button() translate <0, 51.2, 0> }
      object { open_rounded_button() translate <8, 51.2, 0> }
      object { open_rounded_button() translate <16, 51.2, 0> }
      object { open_rounded_button() translate <24, 51.2, 0> }
      object { open_rounded_button() translate <24, 51.2, -8> }
      object { open_rounded_button() translate <24, 51.2, -16> }
      object { open_rounded_button() translate <24, 51.2, -24> }
      #if (setting > 3)
        object { llogo() rotate 90*y translate <0, 54.3, 0> }
        object { llogo() rotate 90*y translate <8, 54.3, 0> }
        object { llogo() rotate 90*y translate <16, 54.3, 0> }
        object { llogo() rotate 90*y translate <24, 54.3, 0> }
        object { llogo() rotate 90*y translate <24, 54.3, -8> }
        object { llogo() rotate 90*y translate <24, 54.3, -16> }
        object { llogo() rotate 90*y translate <24, 54.3, -24> }
      #end
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
        object { pin(2) translate <24, 0, -4> }
        object { pin(2) translate <24, 0, -12> }
        object { pin(2) translate <24, 0, -20> }
        box { <-0.5, 0.1, -3.8> <0.5, 2.1, -2.5> }
        box { <7.5, 0.1, -3.8> <8.5, 2.1, -2.5> }
        box { <15.5, 0.1, -3.8> <16.5, 2.1, -2.5> }
        box { <20.2, 0.1, -7.5> <21.5, 2.1, -8.5> }
        box { <20.2, 0.1, -15.5> <21.5, 2.1, -16.5> }
        box { <20.2, 0.1, -23.5> <21.5, 2.1, -24.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -28> <28, 57.6, 4> } }
    }
  #end
#end
#macro vhside3_2_corner(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -19.9> <19.9, 57.5, 3.9> }
      box { <-10, -1, -50> <30, 60, 0> rotate -45*y translate <4, 0, -19.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -19.9> <19.9, 57.5, 3.9> }
        #if (setting > 1)
          box { <-2.4, -1, -3.4> <3.4, 2, 2.4> }
        #end
        box { <-4, 54.3, -4.1> <4.1, 58, 4> }
        box { <-10, -30, -50> <20, 30, 0> rotate 43*x translate <0, 57.5, -4> }
        box { <-10, -30, -50> <20, 30, 0> rotate 43*x rotate -90*y translate <4, 57.5, 0> }
        box { <-20, -30, -50> <20, 30, 0> rotate 33.35*x rotate -45*y translate <4, 57.5, -4> }
        box { <-20, -10, -50> <30, 30, 0> rotate -41.5*x translate <0, 0, -4> }
        box { <-20, -10, -50> <30, 30, 0> rotate -41.5*x rotate -90*y translate <4, 0, 0> }
        box { <-20, -10, -50> <20, 30, 0> rotate -32.1*x rotate -45*y translate <4, 0, -4> }
        box { <-10, -1, -50> <30, 60, 0> rotate -45*y translate <4, 0, -19.9> }
        difference {
          box { <-4, 3.100002, -18.5> <18.5, 53.30002, 4> }
          box { <-5, -30, -50> <13, 30, 0> rotate 43*x translate <0, 51.1, -8> }
          box { <-5, -30, -50> <13, 30, 0> rotate 43*x rotate -90*y translate <8, 51.1, 0> }
          box { <-10, -30, -50> <20, 30, 0> rotate -41.5*x translate <0, 3.1, -5> }
          box { <-10, -30, -50> <20, 30, 0> rotate -41.5*x rotate -90*y translate <5, 3.1, 0> }
          box { <-20, -30, -50> <20, 30, 0> rotate 33.35*x rotate -45*y translate <4.75, 54.4, -4.75> }
          box { <-10, 10, -50> <30, 50, 0> rotate -45*y translate <5, 0, -18> }
          box { <-20, -10, -50> <20, 30, 0> rotate -32.1*x rotate -45*y translate <4.75, 3.1, -4.75> }
        }
      }
      object { open_rounded_button() translate <0, 51.2, 0> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <0, 54.3, 0> }
      #end
      #if (setting > 1)
        box { <-0.5, 0.000001, -3.8> <0.5, 2.1, -2.5> }
        box { <2.5, 0.000001, -0.5> <3.8, 2.1, 0.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -20> <20, 57.6, 4> } }
    }
  #end
#end
#macro vhslope1_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 28.7, 3.9> }
      box { <-30, 0, -10> <0, 50, 10> rotate -16.75*z translate <-4, 2, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 28.7, 3.9> }
            box { <-30, 0, -10> <0, 50, 10> texture { color_tex normal { bumping } }
              rotate -16.75*z translate <-4, 2, 0> }
          }
          object { open_rounded_button() translate <8, 25.6, 0> }
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 27.8, 2.4> }
            box { <-30, 0, -10> <0, 50, 10> rotate -16.75*z translate <-2.4, 2, 0> }
          }
        #end
        cylinder { 10*y, 35*y, 1.600001 translate <8, 0, 0> }
      }
      #if (setting > 1)
        box { <-0.5, 0.1, -0.5> <0.5, 15, 0.5> rotate 45*y translate <2.25, 0, -2.4> }
        box { <-0.5, 0.1, -0.5> <0.5, 15, 0.5> rotate 45*y translate <2.25, 0, 2.4> }
        box { <-0.5, 0.1, -0.5> <0.5, 15, 0.5> rotate 45*y translate <5.75, 0, -2.4> }
        box { <-0.5, 0.1, -0.5> <0.5, 15, 0.5> rotate 45*y translate <5.75, 0, 2.4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 30.5, 4> } }
    }
  #end
#end
#macro vhslope2_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 28.7, 11.9> }
      box { <-30, 0, -10> <0, 50, 20> rotate -16.75*z translate <-4, 2, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 28.7, 11.9> }
            box { <-30, 0, -10> <0, 50, 20> texture { color_tex normal { bumping } }
              rotate -16.75*z translate <-4, 2, 0> }
          }
          object { open_rounded_button() translate <8, 25.6, 0> }
          object { open_rounded_button() translate <8, 25.6, 8> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 29.7, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 29.7, 8> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 27.8, 10.4> }
            box { <-30, 0, -10> <0, 50, 20> rotate -16.75*z translate <-2.4, 2, 0> }
          }
        #end
      }
      #if (setting > 1)
        difference {
          cylinder { 0*y, 28*y, 3.2 translate <4, 0, 4> }
          cylinder { -1*y, 30*y, 2.6 translate <4, 0, 4> }
          box { <-30, 0, -10> <0, 50, 20> rotate -16.75*z translate <-2.5, 2.1, 0> }
        }
        box { <7, 5, 3.75> <10.6, 28, 4.25> }
        difference {
          box { <-2.6, 5, 3.75> <1, 28, 4.25> }
          box { <-30, 0, -10> <0, 50, 20> rotate -16.75*z translate <-2.5, 2.1, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 30.5, 12> } }
    }
  #end
#end
#macro vh_arch1_4(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <35.9, 38.3, 3.9> }
      cylinder { -4*z, 4*z, 32 translate <35.9, 0, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        difference {
          box { <-3.9, 0, -3.9> <35.9, 38.3, 3.9> }
          box { <-4, 19.1, -4> <4.1, 40, 4> }
          box { <-4, 28.7, -4> <12.1, 40, 4> }
          box { <19.9, 35.1, -4> <40, 40, 4> }
          cylinder { -4*z, 4*z, 32 translate <35.9, 0, 0> }
          #if (setting > 1)
            box { <-2.4, -1, -2.4> <2.4, 18.2, 2.4> }
            difference {
              box { <4.000001, -1, -2.4> <34.4, 37.4, 2.4> }
              box { <3, 18.2, -3> <5.6, 40, 3> }
              box { <4, 27.8, -3> <11.5, 28.8, 3> }
              box { <11, 27.8, -3> <13.6, 40, 3> }
              box { <18.4, 34.2, -3> <41, 40, 3> }
              box { <10.9, 22.5, -3> <11.9, 40, 3> }
              box { <18.9, 30, -3> <19.9, 40, 3> }
            }
          #end
        }
        #if (setting < 3)
          cylinder { 19*y, 20.8*y, 2.4 }
          cylinder { 28.6*y, 30.4*y, 2.4 translate <8, 0, 0> }
          cylinder { 38.2*y, 40*y, 2.4 translate <16, 0, 0> }
          cylinder { 35*y, 36.8*y, 2.4 translate <24, 0, 0> }
          cylinder { 35*y, 36.8*y, 2.4 translate <32, 0, 0> }
        #else
          object { rounded_button() translate <0, 16, 0> }
          object { rounded_button() translate <8, 25.6, 0> }
          object { rounded_button() translate <16, 35.2, 0> }
          object { rounded_button() translate <24, 32, 0> }
          object { rounded_button() translate <32, 32, 0> }
        #end
      }
      #if (setting > 1)
        cylinder { 17*y, 20*y, 1.2 }
        cylinder { 26.6*y, 29.6*y, 1.2 translate <8, 0, 0> }
        cylinder { 36.2*y, 39.2*y, 1.2 translate <16, 0, 0> }
        cylinder { 33*y, 36*y, 1.2 translate <24, 0, 0> }
        cylinder { 33*y, 36*y, 1.2 translate <32, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <36, 40.1, 4> } }
    }
  #end
#end
#macro vh_block2_4(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 28.7, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          #if (setting < 3)
            cylinder { 28.6*y, 30.4*y, 2.4 }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <8, 0, 0> }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <16, 0, 0> }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <24, 0, 0> }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <0, 0, 8> }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <8, 0, 8> }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <16, 0, 8> }
            cylinder { 28.6*y, 30.4*y, 2.4 translate <24, 0, 8> }
          #else
            object { rounded_button() translate <0, 25.6, 0> }
            object { rounded_button() translate <8, 25.6, 0> }
            object { rounded_button() translate <16, 25.6, 0> }
            object { rounded_button() translate <24, 25.6, 0> }
            object { rounded_button() translate <0, 25.6, 8> }
            object { rounded_button() translate <8, 25.6, 8> }
            object { rounded_button() translate <16, 25.6, 8> }
            object { rounded_button() translate <24, 25.6, 8> }
          #end
          box { <-3.9, 0, -3.9> <27.9, 28.7, 11.9> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 27.8, 10.4> }
          cylinder { 7.4*y, 10.4*y, 1.2 }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { high_ring() scale <1, 3.2, 1> translate <4, 0, 4> }
        object { high_ring() scale <1, 3.2, 1> translate <12, 0, 4> }
        object { high_ring() scale <1, 3.2, 1> translate <20, 0, 4> }
        box { <11.75, 9.6, -3> <12.25, 27.9, 1.1> }
        box { <11.75, 9.6, 6.9> <12.25, 27.9, 11> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 30.2, 12> } }
    }
  #end
#end
#macro vh_connect5_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-19.9, 19.2, -3.9> <3.899999, 22.3, 11.9> }
      box { <-3.9, 0.000001, -3.899999> <3.9, 22.299999, 11.899999> }
      box { <-3.899999, 0, -3.9> <19.9, 3.1, 11.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-19.9, 19.2, -3.9> <3.899999, 22.3, 11.9> }
          box { <-3.9, 0.000001, -3.899999> <3.9, 22.299999, 11.899999> }
          box { <-3.899999, 0, -3.9> <19.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 8> }
            cylinder { 22.2*y, 24*y, 2.4 }
            cylinder { 22.2*y, 24*y, 2.4 translate <0, 0, 8> }
            cylinder { 22.2*y, 24*y, 2.4 translate <-8, 0, 0> }
            cylinder { 22.2*y, 24*y, 2.4 translate <-8, 0, 8> }
            cylinder { 22.2*y, 24*y, 2.4 translate <-16, 0, 0> }
            cylinder { 22.2*y, 24*y, 2.4 translate <-16, 0, 8> }
          #else
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <8, 0, 8> }
            object { rounded_button() translate <16, 0, 0> }
            object { rounded_button() translate <16, 0, 8> }
            object { rounded_button() translate <0, 19.2, 0> }
            object { rounded_button() translate <0, 19.2, 8> }
            object { rounded_button() translate <-8, 19.2, 0> }
            object { rounded_button() translate <-8, 19.2, 8> }
            object { rounded_button() translate <-16, 19.2, 0> }
            object { rounded_button() translate <-16, 19.2, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 21.4, 10.4> }
          cylinder { 20.2*y, 23.2*y, 1.2 }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <0, 0, 8> }
          box { <3.900001, -1, -2.4> <18.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 8> }
          box { <-18.4, 17, -2.4> <-3.900001, 21.4, 10.4> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <-8, 0, 0> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <-8, 0, 8> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <-16, 0, 0> }
          cylinder { 20.2*y, 23.2*y, 1.2 translate <-16, 0, 8> }
        #end
        cylinder { 16*y, 25*y, 2.600001 translate <-12, 0, 4> }
        cylinder { -2*y, 5*y, 2.600001 translate <12, 0, 4> }
      }
      #if (setting > 1)
        box { <-3, 10, -0.5> <3, 21.5, 0.5> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <-12, 19.2, 4> }
        box { <3.8, 0.000001, -0.5> <5.6, 2.1, 0.5> }
        box { <3.8, 0.000001, 7.5> <5.6, 2.1, 8.5> }
        box { <-5.6, 19.2, -0.5> <-3.8, 21.5, 0.5> }
        box { <-5.6, 19.2, 7.5> <-3.8, 21.5, 8.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-20, -0.1, -4> <20, 24.1, 12> } }
    }
  #end
#end
#macro vh_doorleft1_3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 19.1*y, 3.9 }
      box { <0, 0.000002, -3.9> <19.9, 19.100001, -2.4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, 0.000002, -3.899998> <19.9, 19.099998, -2.4> }
        #if (setting < 3)
          cylinder { 19*y, 20.8*y, 2.4 }
        #else
          object { rounded_button() translate <0, 16, 0> }
        #end
        cylinder { 0*y, 19.1*y, 3.9 }
        box { <0, 0.000001, -3.899999> <3.9, 19.099999, 0> }
        cylinder { -5.899999*z, -3.5*z, 0.8 translate <16, 7.8, 0> }
        cylinder { -5.899999*z, -3.5*z, 0.8 translate <16, 11.2, 0> }
        box { <15.2, 7.799999, -5.9> <16.8, 11.200001, -3.5> }
      }
      #if (setting > 1)
        cylinder { -1*y, 18.1*y, 2.6 }
        cylinder { 16.9*y, 19.9*y, 1.2 }
      #end
      difference {
        merge {
          cylinder { -4.8*z, -2*z, 0.9 translate <16, 7.8, 0> }
          cylinder { -4.8*z, -2*z, 0.9 translate <16, 11.2, 0> }
          box { <15.25, 7.799999, -4.800001> <16.75, 11.200001, -2> }
        }
        box { <16, 2.5, -5> <18, 16.5, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -6> <20, 20.9, 4> } }
    }
  #end
#end
#macro vh_doorright1_3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 19.1*y, 3.9 }
      box { <0, 0.000002, 2.4> <19.9, 19.100001, 3.9> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, 0.000002, 2.4> <19.9, 19.099998, 3.899998> }
        #if (setting < 3)
          cylinder { 19*y, 20.8*y, 2.4 }
        #else
          object { rounded_button() translate <0, 16, 0> }
        #end
        cylinder { 0*y, 19.1*y, 3.9 }
        box { <0, 0.000001, 0> <3.9, 19.099999, 3.899999> }
        cylinder { 3.5*z, 5.899999*z, 0.8 translate <16, 7.8, 0> }
        cylinder { 3.5*z, 5.899999*z, 0.8 translate <16, 11.2, 0> }
        box { <15.25, 7.799999, 3.5> <16.75, 11.200001, 5.9> }
      }
      #if (setting > 1)
        cylinder { -1*y, 18.1*y, 2.6 }
        cylinder { 16.9*y, 19.9*y, 1.2 }
      #end
      difference {
        merge {
          cylinder { 2*z, 4.8*z, 0.9 translate <16, 7.8, 0> }
          cylinder { 2*z, 4.8*z, 0.9 translate <16, 11.2, 0> }
          box { <15.25, 7.799999, 2> <16.75, 11.200001, 4.800001> }
        }
        box { <16, 2.5, 0> <18, 16.5, 5> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 20.9, 6> } }
    }
  #end
#end
#macro vh_quarter_panel4_4(color_tex)
  #if (setting = 0)
    intersection {
      box { <-3.9, 0, -3.9> <27.9, 57.500001, 27.9> }
      cylinder { -1*y, 58*y, 31.8 translate <-3.9, 0, -3.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          intersection {
            box { <-3.9, 0, -3.9> <27.9, 57.500001, 27.9> }
            cylinder { -1*y, 58*y, 31.8 translate <-3.9, 0, -3.9> }
          }
          object { open_rounded_button() translate <0, 54.4, 24> }
          object { open_rounded_button() translate <16, 54.4, 16> }
          object { open_rounded_button() translate <24, 54.4, 0> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 57.5, 24> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 57.5, 16> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 57.5, 0> }
          #end
        }
        cylinder { -1*y, 60*y, 24.1 translate <-3.9, 0, -3.9> }
        cylinder { 3.1*y, 56.4*y, 30.3 translate <-3.9, 0, -3.9> }
        #if (setting > 1)
          intersection {
            box { <-2.4, -1, -2.4> <26.4, 2, 26.4> }
            cylinder { -1*y, 4*y, 30.3 translate <-3.9, 0, -3.9> }
            cylinder { -1*y, 4*y, 25.5 translate <-3.9, 0, -3.9> inverse }
          }
          cylinder { -1*y, 2.000001*y, 2.400001 translate <0, 0, 24> }
          cylinder { -1*y, 2.000001*y, 2.400001 translate <24, 0, 0> }
          cylinder { -1*y, 2.000001*y, 2.400001 translate <16, 0, 16> }
          box { <8, -1, -2.5> <22, 2.000003, 2.5> rotate -26.5*y }
          box { <8, -1, -2.5> <22, 2.000003, 2.5> rotate -63.5*y }
          box { <24, -1, -2.5> <40, 2.000003, 2.5> rotate -18.5*y }
          box { <24, -1, -2.5> <40, 2.000003, 2.5> rotate -71.5*y }
        #end
        box { <26, -1, -10> <30, 4, 10> rotate -45*y }
      }
      #if (setting > 1)
        box { <2.4, 0.2, 20> <3.4, 2.1, 26> }
        box { <20, 0.2, 2.4> <26, 2.1, 3.4> }
        box { <20, 0.2, -3.4> <25.5, 2.1, -2.4> rotate -45*y }
        box { <20, 0.2, 3.4> <25.5, 2.1, 2.4> rotate -45*y }
        box { <-0.5, 0.2, 20> <0.5, 2.1, 21.6> }
        box { <20, 0.2, -0.5> <21.6, 2.1, 0.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 59.3, 28> } }
    }
  #end
#end
#macro vh_slope1_3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <18.9, 30.8, 3.9> }
      box { <-4, -1, -4> <4.1, 9.6, 4> }
      box { <0, -5, -4> <20, 40, 4> rotate 36.25*z translate <18.9, 0.9, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <18.9, 30.8, 3.9> }
        box { <-4, -1, -4> <4.1, 9.6, 4> }
        box { <0, -5, -4> <20, 40, 4> rotate 36.25*z translate <18.9, 0.9, 0> }
        #if (setting > 1)
          difference {
            box { <-2.4, 0, -2.4> <4.100001, 29.9, 2.4> }
            box { <2.4, 9.600001, -0.5> <5, 30, 0.5> }
            box { <0, -5, -4> <20, 40, 4> rotate 36.25*z translate <17.5, 0, 0> }
          }
          difference {
            box { <5.6, -1, -2.4> <18.1, 29.9, 2.4> }
            box { <11.75, 2, -3> <12.25, 30, 3> }
            cylinder { 0.000001*y, 30*y, 1.5 translate <12, 0, 0> }
            box { <0, 1, -4> <20, 40, 4> rotate 36.25*z translate <17.5, 0, 0> }
            box { <16.8, 2, -4> <20, 30, 4> }
          }
        #end
      }
      merge {
        object { open_rounded_button() translate <-2.3, -3.1, 0> }
        object { open_rounded_button() translate <-10.3, -3.1, 0> }
        object { open_rounded_button() translate <-18.3, -3.1, 0> }
        object { open_rounded_button() translate <-26.3, -3.1, 0> }
        object { open_rounded_button() translate <-34.3, -3.1, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> translate <-2.3, 0, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <-10.3, 0, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <-18.3, 0, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <-26.3, 0, 0> }
          object { llogo() scale <0.65, 0.65, 0.65> translate <-34.3, 0, 0> }
        #end
        rotate -53.75*z
        translate <18.9, 0.9, 0>
      }
      texture { color_tex }
    }
  #end
#end
#macro vizor_1(color_tex)
  #if (setting = 0)
    difference {
      cylinder { 2*y, -5.9*y, 6.5 scale <1.07, 1, 1> }
      box { <0.000001, -11, -7> <7, 3, 7> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            cylinder { 2*y, -10*y, 6.5 scale <1.07, 1, 1> }
            box { <0.000001, -11, -7> <7, 3, 7> }
          }
          difference {
            cylinder { -6.499999*z, 6.499999*z, 1.999999 scale <1.07, 1, 1> }
            box { <-5, -3, -7> <0, 3, 7> }
          }
        }
        cylinder { 3*y, -11*y, 5.5 scale <1.07, 1, 1> }
        box { <-0.000001, -11, -5.500001> <7, 3, 5.500001> }
        box { <-20, -10, -20> <20, 0, 20> rotate 19*z translate <0, -2, 0> }
      }
      #if (setting > 1)
        sphere { <0, 0, -5.7> 0.7 }
        sphere { <0, 0, 5.7> 0.7 }
      #end
      texture { color_tex }
      bounded_by { box { <-8, -6, -6.75> <2.25, 2.25, 6.75> } }
    }
  #end
#end
#macro vizor_2(color_tex)
  #if (setting = 0)
    difference {
      cylinder { 2*y, -5.9*y, 6.5 scale <1.07, 1, 1> }
      box { <0.000001, -11, -7> <7, 3, 7> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            cylinder { 2*y, -10*y, 6.5 scale <1.07, 1, 1> }
            box { <0.000001, -11, -7> <7, 3, 7> }
          }
          difference {
            cylinder { -6.499999*z, 6.499999*z, 1.999999 scale <1.07, 1, 1> }
            box { <-5, -3, -7> <0, 3, 7> }
          }
          difference {
            box { <-9.5, -3, -6.500001> <0, 2, 6.500001> }
            box { <-5, -20, -7> <20, 0, 7> rotate -20*z translate <-9.5, -1, 0> }
            box { <-20, -5, -20> <0, 5, 0> rotate 10*y translate <0, 0, -6.5> }
            box { <-20, -5, 0> <0, 5, 20> rotate -10*y translate <0, 0, 6.5> }
            box { <-10, -10, -3.75> <1, 0, 3.75> }
            box { <-5, 0, -7> <20, 20, 7> rotate 15*z translate <-9.5, 1, 0> }
          }
          difference {
            cylinder { 0*y, -2*y, 7.25 scale <1.15, 1, 1> }
            box { <-10, -3, -10> <10, 1, 2.5> }
            box { <0, -3, -10> <10, 1, 10> }
            box { <-20, -3, 4> <-6, 1, 10> }
            box { <-20, -3, 3> <-7, 1, 10> }
            rotate 19*z
          }
        }
        cylinder { 3*y, -11*y, 5.5 scale <1.07, 1, 1> }
        box { <-0.000001, -11, -5.500001> <7, 3, 5.500001> }
        box { <-20, -10, -20> <20, 0, 20> rotate 19*z translate <0, -2, 0> }
        box { <-10, -1, -3.749999> <1, -0.000001, 3.749999> }
      }
      #if (setting > 1)
        sphere { <0, 0, -5.7> 0.7 }
        sphere { <0, 0, 5.7> 0.7 }
      #end
      cylinder { -7.25*z, -6.25*z, 1 }
      cylinder { 6.25*z, 7.25*z, 1 }
      cylinder { 0.75*y, 6*y, 0.8 rotate -5*z translate <0, 0, -6.45> }
      sphere { <0.5, 6, -6.45> 1.25 }
      texture { color_tex }
      bounded_by { box { <-10, -6, -7.8> <2.25, 7.35, 7.35> } }
    }
  #end
#end
#macro vizor_3(color_tex)
  #if (setting = 0)
    difference {
      merge {
        sphere { <0, 0, 0> 6.955 translate <0, 0, 0> }
        cylinder { -10*y, 0.000005*y, 6.955 rotate 6*z }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          sphere { <0, 0, 0> 6.955 translate <0, 0, 0> }
          cylinder { -10*y, 0.000005*y, 6.955 rotate 6*z }
        }
        difference {
          box { <0, -3, -8> <3, 0, 8> }
          cylinder { -7*z, 7*z, 2 }
          rotate 19*z
        }
        merge {
          sphere { <0, 0, 0> 5.955 translate <0, 0, 0> }
          cylinder { 2.000005*y, -11*y, 5.5 }
          box { <0, -11.5, -5.500003> <10, 2.000007, 5.500003> }
        }
        box { <-20, -10, -20> <20, 0, 20> rotate 19*z translate <0, -2, 0> }
        box { <2.6, -10, -20> <20, 20, 20> rotate 19*z translate <0, -2, 0> }
      }
      #if (setting > 1)
        sphere { <0, 0, -5.7> 0.7 }
        sphere { <0, 0, 5.7> 0.7 }
      #end
      texture { color_tex }
      bounded_by { box { <-8, -6, -6.75> <2.25, 6.25, 6.75> } }
    }
  #end
#end
#macro vizor_4(color_tex)
  #if (setting = 0)
    difference {
      cylinder { 2*y, -5.9*y, 6.5 scale <1.07, 1, 1> }
      box { <0.000001, -11, -7> <7, 3, 7> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            cylinder { 1.500007*y, -1.500007*y, 7.25 scale <1.07, 1, 1> }
            box { <0.000001, -11, -8> <8, 3, 8> }
            box { <-10, -10, -2> <10, 10, 2> }
          }
          difference {
            cylinder { -7.249999*z, 7.249999*z, 1.499999 scale <1.4266667, 1, 1> }
            box { <-5, -3, -8> <0, 3, 8> }
          }
          prism {
            bezier_spline
            -8.2, 0, 68,
            <0, -0.1>, <0, -0.1>, <0.2, -0.1>, <0.2, -0.1>,
            <0.2, -0.1>, <0.8, -1.4>, <1, -1.8>, <2, -2>,
            <2, -2>, <2.5, -2>, <4, -2.1>, <4.4, -2>,
            <4.4, -2>, <5, -2>, <5.6, -1.3>, <5.6, 0>,
            <5.6, 0>, <5.6, 0>, <5.6, 1>, <5.5, 1.5>,
            <5.5, 1.5>, <5.5, 1.6>, <5, 1.9>, <4, 2>,
            <4, 2>, <3.5, 2>, <1.2, 2>, <1, 2>,
            <1, 2>, <0.8, 1.9>, <0.2, 1.6>, <0.2, 1.6>,
            
            <0.2, 1.6>, <0.2, 1.6>, <-0.2, 1.6>, <-0.2, 1.6>,
            <-0.2, 1.6>, <-0.2, 1.6>, <-0.8, 1.9>, <-1, 2>,
            <-1, 2>, <-1.2, 2>, <-3.5, 2>, <-4, 2>,
            <-4, 2>, <-5, 1.9>, <-5.5, 1.6>, <-5.5, 1.5>,
            <-5.5, 1.5>, <-5.6, 1>, <-5.6, 0>, <-5.6, 0>,
            <-5.6, 0> <-5.6, -1.3>, <-5, -2>, <-4.4, -2>,
            <-4.4, -2>, <-4, -2.1>, <-2.5, -2>, <-2, -2>,
            <-2, -2>, <-1, -1.8>, <-0.8, -1.4>, <-0.2, -0.1>,
            <-0.2, -0.1>, <-0.2, -0.1>,
            <0, -0.1>, <0, -0.1>
            rotate -90*z rotate -90*x
          }
        }
        prism {
          bezier_spline
          -10, -7.7, 20
          <2, 1.5>, <2.6, 1.4>, <4.1, 1.7>, <4.8, 1.3>,
          <4.8, 1.3>, <5.1, 0.9>, <5.1, -0.9>, <4.6, -1.4>,
          <4.6, -1.4>, <4.1, -1.7>, <2.6, -1.5>, <2, -1.4>,
          <2, -1.4>, <1.1, -1.2>, <0.7, -2>, <0.7, 0.3>,
          <0.7, 0.3> <0.7, 1>, <1.4, 1.6>, <2, 1.5>
          rotate -90*z rotate -90*x
        }
        prism {
          bezier_spline
          -10, -4, 20
          <2.1, 1.2>, <2.6, 1.2>, <3.9, 1.3>, <4.4, 1>,
          <4.4, 1>, <4.7, 0.8>, <4.7, -0.7>, <4.2, -1.1>,
          <4.2, -1.1>, <3.8, -1.3>, <2.6, -1.2>, <2.1, -1.1>,
          <2.1, -1.1>, <1.4, -0.9>, <1.1, -0.1>, <1.1, 0.2>,
          <1.1, 0.2> <1.1, 0.8>, <1.6, 1.2>, <2.1, 1.2>
          rotate -90*z rotate -90*x
        }
        prism {
          bezier_spline
          -10, -7.7, 20
          <-2, 1.5>, <-2.6, 1.4>, <-4.1, 1.7>, <-4.8, 1.3>,
          <-4.8, 1.3>, <-5.1, 0.9>, <-5.1, -0.9>, <-4.6, -1.4>,
          <-4.6, -1.4>, <-4.1, -1.7>, <-2.6, -1.5>, <-2, -1.4>,
          <-2, -1.4>, <-1.1, -1.2>, <-0.7, -2>, <-0.7, 0.3>,
          <-0.7, 0.3> <-0.7, 1>, <-1.4, 1.6>, <-2, 1.5>
          rotate -90*z rotate -90*x
        }
        prism {
          bezier_spline
          -10, -4, 20
          <-2.1, 1.2>, <-2.6, 1.2>, <-3.9, 1.3>, <-4.4, 1>,
          <-4.4, 1>, <-4.7, 0.8>, <-4.7, -0.7>, <-4.2, -1.1>,
          <-4.2, -1.1>, <-3.8, -1.3>, <-2.6, -1.2>, <-2.1, -1.1>,
          <-2.1, -1.1>, <-1.4, -0.9>, <-1.1, -0.1>, <-1.1, 0.2>,
          <-1.1, 0.2> <-1.1, 0.8>, <-1.6, 1.2>, <-2.1, 1.2>
          rotate -90*z rotate -90*x
        }
        cylinder { 3*y, -11*y, 5.5 scale <1.07, 1, 1> }
      }
      sphere { <0, 0, -5.7> 0.7 }
      sphere { <0, 0, 5.7> 0.7 }
      texture { color_tex }
      bounded_by { box { <-8.3, -2.2, -7.35> <5, 2.2, 7.35> } }
    }
  #end
#end
#macro vth_doorleft1_3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 28.7*y, 3.9 }
      box { <0, 0.000002, -3.899998> <19.9, 28.699998, -2.4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, 0.000002, -3.899998> <19.9, 28.699998, -2.4> }
        #if (setting < 3)
          cylinder { 28.6*y, 30.4*y, 2.4 }
        #else
          object { rounded_button() translate <0, 25.6, 0> }
        #end
        cylinder { 0*y, 28.7*y, 3.9 }
        box { <0, 0.000001, -3.899999> <3.9, 28.689999, 0> }
        cylinder { -5.899999*z, -3.5*z, 0.8 translate <16, 12.65, 0> }
        cylinder { -5.899999*z, -3.5*z, 0.8 translate <16, 16.05, 0> }
        box { <15.2, 12.649999, -5.9> <16.8, 16.050001, -3.5> }
      }
      #if (setting > 1)
        cylinder { -1*y, 27.7*y, 2.6 }
        cylinder { 26.5*y, 29.5*y, 1.2 }
      #end
      difference {
        merge {
          cylinder { -4.8*z, -2*z, 0.9 translate <16, 12.65, 0> }
          cylinder { -4.8*z, -2*z, 0.9 translate <16, 16.05, 0> }
          box { <15.25, 12.649999, -4.800001> <16.75, 16.050001, -2> }
        }
        box { <16, 5, -5> <18, 20, 0> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -6> <20, 30.5, 4> } }
    }
  #end
#end
#macro vth_doorright1_3(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 28.7*y, 3.9 }
      box { <0, 0.000002, 3.899998> <19.9, 28.699998, 2.4> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <0, 0.000002, 2.4> <19.9, 28.699998, 3.899998> }
        #if (setting < 3)
          cylinder { 28.6*y, 30.4*y, 2.4 }
        #else
          object { rounded_button() translate <0, 25.6, 0> }
        #end
        cylinder { 0*y, 28.7*y, 3.9 }
        box { <0, 0.000001, 0> <3.9, 28.699999, 3.899999> }
        cylinder { 3.5*z, 5.899999*z, 0.8 translate <16, 12.65, 0> }
        cylinder { 3.5*z, 5.899999*z, 0.8 translate <16, 16.05, 0> }
        box { <15.25, 12.649999, 3.5> <16.75, 16.050001, 5.9> }
      }
      #if (setting > 1)
        cylinder { -1*y, 27.7*y, 2.6 }
        cylinder { 26.5*y, 29.5*y, 1.2 }
      #end
      difference {
        merge {
          cylinder { 2*z, 4.8*z, 0.9 translate <16, 12.65, 0> }
          cylinder { 2*z, 4.8*z, 0.9 translate <16, 16.05, 0> }
          box { <15.25, 12.649999, 2> <16.75, 16.050001, 4.800001> }
        }
        box { <16, 5, 0> <18, 20, 5> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 30.5, 6> } }
    }
  #end
#end
#macro v_magneet_holder(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      box { <-3.900001, 3.0, 0.4> <11.900001, 7.7, 7.6> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, .5, -3.9> <11.9, 3.1, 11.9> }
          box { <-3.5, 0, -3.5> <11.5, .55, 11.5> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1.999999*y, 4*y, 6.5 translate <4, 0, 4> }
        #end
      }
      #if (setting > 1)
        difference {
          merge {
            box { <-3, 0.5, 2.6> <11, 2, 5.4> }
            box { <2.6, 0.500001, -3> <5.4, 2.000001, 11> }
            cylinder { 2.000002*y, 0*y, 3.2 translate <4, 0, 4> }
          }
          cylinder { -1*y, 3*y, 2.6 translate <4, 0, 4> }
        }
      #end
      difference {
        box { <-3.900001, 3.099999, 0.4> <11.900001, 7.7, 7.6> }
        box { <-2.100001, 3.099998, 0> <10.1, 10, 8> }
        #if (setting > 1)
          cylinder { -9*x, 9*x, 0.95 translate <4, 5.6, 4> }
          box { <-4, 0, 0> <12, 4, 1> rotate -5*x translate <0, 5.6, 4> }
          box { <-4, 0, -1> <12, 4, 0> rotate 5*x translate <0, 5.6, 4> }
        #end
        box { <-4, -10, -5> <12, 10, 0> rotate 30*x translate <0, 5.1, 0.55> }
        box { <-4, -10, 0> <12, 10, 5> rotate -30*x translate <0, 5.1, 7.45> }
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 7.8, 12> } }
    }
  #end
#end
#macro wall_segment3_6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 57.5, 19.9> }
      box { <-10, 0, -50> <50, 50, 50> rotate -49*x translate <0, 57.5, 12> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { -7.9*z, -2.5*z, 3.2 translate <4.8, 26.4, 0> }
          cylinder { -7.9*z, -2.5*z, 3.2 translate <35.2, 26.4, 0> }
          cylinder { -7.9*z, -2.5*z, 3.2 translate <4.8, 36.2, 0> }
          cylinder { -7.9*z, -2.5*z, 3.2 translate <35.2, 36.2, 0> }
          box { <1.6, 26.4, -7.900001> <38.4, 36.2, -2.5> }
          box { <4.8, 23.2, -7.900002> <35.2, 39.4, -2.5> }
        }
        cylinder { -8*z, 0*z, 1.7 translate <4.8, 26.4, 0> }
        cylinder { -8*z, 0*z, 1.7 translate <35.2, 26.4, 0> }
        cylinder { -8*z, 0*z, 1.7 translate <4.8, 36.2, 0> }
        cylinder { -8*z, 0*z, 1.7 translate <35.2, 36.2, 0> }
        box { <3.1, 26.4, -8> <36.9, 36.2, 1> }
        box { <4.8, 24.7, -8> <35.2, 37.9, 1> }
        box { <2.7, 27.8, -5.9> <37.3, 34.8, -3.900007> }
      }
      object { open_rounded_button() translate <0, 51.3, 16> }
      object { open_rounded_button() translate <8, 51.3, 16> }
      object { open_rounded_button() translate <16, 51.3, 16> }
      object { open_rounded_button() translate <24, 51.3, 16> }
      object { open_rounded_button() translate <32, 51.3, 16> }
      object { open_rounded_button() translate <40, 51.3, 16> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 54.3, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 54.3, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <16, 54.3, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 54.3, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <32, 54.3, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <40, 54.3, 16> }
      #end
      difference {
        box { <-3.9, 0, -3.9> <43.9, 57.5, 19.9> }
        #local counter = 0;
        #while (counter < 6)
          box { <-10, 0, -2> <50, 2, 0> rotate -45*x translate <4, (counter*1.58), -3.2> }
          #local counter = counter + 1;
        #end
        box { <3.9, -1, 3.9> <36.1, 4, 20> }
        difference {
          box { <-2.4, 3.1, -2.4> <42.4, 50, 20> }
          box { <-10, 0, -50> <50, 50, 50> rotate -49*x translate <0, 56, 12> }
        }
        box { <-10, 0, -50> <50, 50, 50> rotate -49*x translate <0, 57.5, 12> }
        box { <-4, 54.3, 11.9> <44, 60, 20> }
        box { <-4, 3.100005, 11.9> <44, 51.2, 20> }
        difference {
          merge {
            box { <-2.400003, 40, 0> <2.4, 53.2, 20> }
            box { <5.6, 40, 0> <10.4, 53.2, 20> }
            box { <13.6, 40, 0> <18.4, 53.2, 20> }
            box { <21.6, 40, 0> <26.4, 53.2, 20> }
            box { <29.6, 40, 0> <34.4, 53.2, 20> }
            box { <37.6, 40, 0> <42.400003, 53.2, 20> }
            box { <3.5, 40, 0> <4.5, 53.2, 20> }
            box { <11.5, 40, 0> <12.5, 53.2, 20> }
            box { <19.5, 40, 0> <20.5, 53.2, 20> }
            box { <27.5, 40, 0> <28.5, 53.2, 20> }
            box { <35.5, 40, 0> <36.5, 53.2, 20> }
            box { <-0.4, 52.2, 8> <0.4, 54, 13.6> }
          }
          box { <-10, 0, -50> <50, 50, 50> rotate -46.5*x translate <0, 56.000001, 12> }
        }
        difference {
          box { <-5, -2, 0> <45, 0, 2> }
          cylinder { -4*x, 44*x, 1.000001 }
          translate <0, 52.2, 18.9>
        }
        cylinder { -4*z, 4*z, 0.8 translate <4.8, 26.4, 0> }
        cylinder { -4*z, 4*z, 0.8 translate <35.2, 26.4, 0> }
        cylinder { -4*z, 4*z, 0.8 translate <4.8, 36.2, 0> }
        cylinder { -4*z, 4*z, 0.8 translate <35.2, 36.2, 0> }
        box { <4.8, 25.6, -4> <35.2, 37, 4> }
        box { <4, 26.4, -4> <36, 36.2, 4> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <42.4, 2, 2.4> }
          box { <-2.400001, -1, -2.400001> <2.4, 2.000005, 18.4> }
          box { <37.6, -1, -2.400001> <42.400001, 2.000007, 18.4> }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
        object { pin(2) translate <28, 0, 0> }
        object { pin(2) translate <36, 0, 0> }
        object { pin(2) translate <0, 0, 4> }
        object { pin(2) translate <0, 0, 12> }
        object { pin(2) translate <40, 0, 4> }
        object { pin(2) translate <40, 0, 12> }
        difference {
          merge {
            box { <-0.4, 52.2, 8> <0.4, 54, 13.6> }
            box { <7.6, 52.2, 8> <8.4, 54, 13.6> }
            box { <15.4, 52.2, 8> <16.4, 54, 13.6> }
            box { <23.4, 52.2, 8> <24.4, 54, 13.6> }
            box { <31.4, 52.2, 8> <32.4, 54, 13.6> }
            box { <39.4, 52.2, 8> <40.4, 54, 13.6> }
          }
          box { <-10, 0, -50> <50, 50, 50> rotate -46.5*x translate <0, 56.1, 12> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -8> <44, 57.6, 20> } }
    }
  #end
#end
#macro wall_segment_glass(color_tex)
  #if (setting = 0)
    box { <3.1, 24.7, -5.2> <36.9, 37.9, -4> texture { color_tex } }
  #else
    merge {
      cylinder { -5.2*z, -4*z, 1.7 translate <4.8, 26.4, 0> }
      cylinder { -5.2*z, -4*z, 1.7 translate <35.2, 26.4, 0> }
      cylinder { -5.2*z, -4*z, 1.7 translate <4.8, 36.2, 0> }
      cylinder { -5.2*z, -4*z, 1.7 translate <35.2, 36.2, 0> }
      box { <3.1, 26.4, -5.200001> <36.9, 36.2, -4.000002> }
      box { <4.8, 24.7, -5.200002> <35.2, 37.9, -4.000001> }
      box { <2.8, 27.9, -5.1> <37.2, 34.7, -4.1> }
      texture { color_tex }
      bounded_by { box { <3, 24.6, -5.3> <37, 38, -3.9> } }
    }
  #end
#end
#macro water_tab(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 4.7, 11.9> texture { color_tex } }
      cylinder { <0, 4, 4> <-9, 10, 4> 1.5 texture { grey_tex } }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <3.9, 4.7, 11.9> }
        box { <-5, 0, -5> <0, 5, 15> rotate -45*z translate <-3.9, 3.1, 0> }
        box { <0, 0, -5> <5, 5, 15> rotate 45*z translate <3.9, 3.1, 0> }
        box { <-5, 0, -5> <5, 5, 0> rotate 45*x translate <0, 3.1, -3.9> }
        box { <-5, 0, 0> <5, 5, 5> rotate -45*x translate <0, 3.1, 11.9> }
        #if (setting > 1)
          cylinder { -1*y, 3.799999*y, 2.5 }
          cylinder { -1*y, 3.799999*y, 2.5 translate <0, 0, 8> }
          difference {
            box { <-2.4, -1, -2.4> <2.4, 3.8, 10.4> }
            box { <-5, 0, -5> <0, 5, 15> rotate -45*z translate <-2.4, 3.1, 0> }
            box { <0, 0, -5> <5, 5, 15> rotate 45*z translate <2.4, 3.1, 0> }
            box { <-5, 0, -5> <5, 5, 0> rotate 45*x translate <0, 3.1, -2.4> }
            box { <-5, 0, 0> <5, 5, 5> rotate -45*x translate <0, 3.1, 10.4> }
          }
        #end
        cylinder { 0*y, 6*y, 1.6 translate <0, 0, 2.4> }
        cylinder { 0*y, 6*y, 1.6 translate <0, 0, 5.6> }
        box { <-1.600001, 0, 2.399999> <1.600001, 6, 5.600001> } 
      }
      merge {
        cylinder { 2*y, 6*y, 1.5 translate <0, 0, 2.4> }
        cylinder { 2*y, 6*y, 1.5 translate <0, 0, 5.6> }
        box { <-1.500001, 2.000001, 2.399999> <1.500001, 6, 5.600001> } 
        sphere { <-2, 11, 4> 1.5 }
        cylinder { <-2, 11, 4>, <0.5, 5, 4>, 1.5 }
        difference {
          cylinder { 11.5*y, 13.7*y, 1.75 }
          #local counter = 0;
          #while (counter < 8)
            cylinder { 11*y, 14*y, 1 translate <2.5, 0, 0> rotate (22.5+(counter*45))*y }
            #local counter = counter + 1;
          #end
          translate <-2, 0, 4>
        }
        cylinder { 13*y, 14.2*y, 1 translate <-2, 0, 4> }
        difference {
          prism {
            bezier_spline
            -6, 6, 24
            <-2, 0>, <-2, 1>, <-1.6, 3>, <2.2, 4.5>,
            <2.2, 4.5>, <4.0322, 5.2232>, <7.9, 6.5>, <8.2, 6.5>,
            <8.2, 6.5>, <8.5, 6.5>, <9.2, 5.8>, <9.2, 5.5>,
            <9.2, 5.5>, <9.2, 5.2>, <5.1, 3.7>, <4, 3>,
            <4, 3>, <2.2917, 1.929>, <2, 0>, <2, 0>,
            <2, 0>, <2, 0>, <-2, 0>, <-2, 0>
            rotate -90*x
            rotate 180*y
            translate <0, 4.7, 4>
          }
          cylinder { -10*x, 10*x, 6 translate <0, 11.2, -3> }
          cylinder { -10*x, 10*x, 6 translate <0, 11.2, 11> }
        }
        cylinder { -0.5*y, 1*y, 0.75 rotate -35*z translate <-8.25, 9.5, 4> }
        texture { grey_tex }
      }
      texture { color_tex }
      bounded_by { box { <-9.3, -0.1, -4> <4, 14.3, 12> } }
    }
  #end
#end
#macro water_tab2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 3.1, 11.9> }
      cylinder { 3*y, 11.85*y, 3.25 translate <0, 0, 4> }
      cylinder { -9.9*x, 0*x, 1.55 translate <0, 9, 4> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <3.9, 3.1, 11.9> }
          cylinder { 3*y, 3.55*y, 3.75 translate <0, 0, 4> }
          cone { 3.5*y, 3.45, 8.650001*y, 3.25 translate <0, 0, 4> }
          sphere { <0, 8.65, 0> 3.25 translate <0, 0, 4> }
        }
        #if (setting > 1)
          sphere { <0, 8.65, 0> 2.4 translate <0, 0, 4> }
          cylinder { -1*y, 8.650001*y, 2.4 translate <0, 0, 4> }
          box { <-2.4, -1, -2.4> <2.4, 2, 10.4> }
        #end
      }
      difference {
        cylinder { -9.9*x, 0*x, 1.55 }
        box { <-5, -5, -2> <0, 0, 2> rotate 35*z translate <-9.9, 1.55, 0> }
        translate <0, 9, 4>
      }
      #if (setting > 1)
        difference {
          box { <3, 0.1, 1.5> <1.5, 2.1, 6.5> }
          box { <4, -1, 2.4> <0, 3, 5.6> }
          box { <-5, -1, 0> <0, 3, 5> texture { blue_tex } rotate -45*y translate <2.4, 0, 6.6> }
          box { <-5, -1, -5> <0, 3, 0> rotate 45*y translate <2.4, 0, 1.4> }
        }
      #end
      cone { -1*y, 1.25, 0*y, 1.45 translate <-1.45, 0, 0> rotate -27.5*z translate <-7.25, 8.75, 4> }
      merge {
        cylinder { 2.7*y, 5.1*y, 1.5 }
        cylinder { 5*y, 6.5*y, 2.1 }
        torus { 1.45, 0.65 translate <0, 6.5, 0> }
        cylinder { 6*y, 7.15*y, 1.6 }
        sphere { <0, 6.75, 0> 1 }
        difference {
          merge {
            cone { 2*x, 0.7, 4*x, 0.9 }
            sphere { <4, 0, 0> 0.9 }
            cone { -2*z, 0.7, -4*z, 0.9 }
            sphere { <0, 0, -4> 0.9 }
            cone { -2*x, 0.7, -4*x, 0.9 }
            sphere { <-4, 0, 0> 0.9 }
            cone { 2*z, 0.7, 4*z, 0.9 }
            sphere { <0, 0, 4> 0.9 }
            scale <1, 1.5, 1>
            translate <0, 5.5, 0>
          }
          box { <-10, -10, -10> <10, 5, 10> }
          rotate 45*y
        }
        rotate -62*x
        translate <0, 8.65, 4>
      }
      merge {
        cylinder { 2.7*y, 5.1*y, 1.5 }
        cylinder { 5*y, 6.5*y, 2.1 }
        torus { 1.45, 0.65 translate <0, 6.5, 0> }
        cylinder { 6*y, 7.15*y, 1.6 }
        sphere { <0, 6.75, 0> 1 }
        difference {
          merge {
            cone { 2*x, 0.7, 4*x, 0.9 }
            sphere { <4, 0, 0> 0.9 }
            cone { -2*z, 0.7, -4*z, 0.9 }
            sphere { <0, 0, -4> 0.9 }
            cone { -2*x, 0.7, -4*x, 0.9 }
            sphere { <-4, 0, 0> 0.9 }
            cone { 2*z, 0.7, 4*z, 0.9 }
            sphere { <0, 0, 4> 0.9 }
            scale <1, 1.5, 1>
            translate <0, 5.5, 0>
          }
          box { <-10, -10, -10> <10, 5, 10> }
          rotate 45*y
        }
        rotate 62*x
        translate <0, 8.65, 4>
      }
      texture { color_tex }
      bounded_by { box { <-10, -0.1, -4> <4, 15.5, 12> } }
    }
  #end
#end
#macro waving_flag(color_tex)
  #if (setting = 0)
    merge {
      box { <0, 2.2, -0.5> <29, 9.5, 0.5> }
      cylinder { 0*y, 11.5*y, 3.1 }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        prism {
          bezier_spline
          2, 9.8, 48,
          <2.2, 0.5>, <4.572, 0.5>, <5.7081, 0.6489>, <7.2749, 1.7734>,
          <7.2749, 1.7734>, <7.9889, 2.2859>, <8.5843, 2.5>, <9.5, 2.5>,
          <9.5, 2.5>, <13.044, 2.5>, <13.3067, -1>, <16, -1>,
          <16, -1>, <19.4304, -1>, <18.9017, 3.5>, <23, 3.5>,
          <23, 3.5>, <25.0269, 3.5>, <25.5456, 3.1835>, <27.0848, 2.2676>,
          <27.0848, 2.2676>, <27.693, 1.9057>, <28.284, 1.8>, <29, 1.8>,
          <29, 1.8>, <29.6667, 1.8>, <29.6667, 0.8>, <29, 0.8>,
          <29, 0.8>, <26.09, 0.8>, <26.3801, 2.5>, <23, 2.5>,
          <23, 2.5>, <19.5616, 2.5>, <20.1014, -2>, <16, -2>,
          <16, -2>, <12.7399, -2>, <12.5021, 1.5>, <9.5, 1.5>,
          <9.5, 1.5>, <7.3926, 1.5>, <7.555, -0.5>, <2.2, -0.5>,
          <2.2, -0.5>, <2.2, -0.5>, <2.2, 0.5>, <2.2, 0.5>
          sturm
        }
        prism {
          bezier_spline
          -10, 10, 56,
          <9.9, 9.8>, <9.9, 9.8>, <9.9, 10.9>, <9.9, 10.9>,
          <9.9, 10.9>, <9.9, 10.9>, <35, 10.9>, <35, 10.9>,
          <35, 10.9>, <35, 10.9>, <35, 0.9>, <35, 0.9>,
          <35, 0.9>, <35, 0.9>, <9.9, 0.9>, <9.9, 0.9>,
          <9.9, 0.9>, <9.9, 0.9>, <9.9, 2>, <9.9, 2>,
          <9.9, 2>, <9.9, 2>, <27.5, 2>, <27.5, 2>,
          <27.5, 2>, <27.9, 2>, <28, 2.5>, <28, 2.5>,
          <28, 2.5>, <28, 2.9>, <27.5, 3> <27.5, 3>,
          <27.5, 3>, <27.5, 3>, <16, 5.4>, <16, 5.4>,
          <16, 5.4>, <15.3, 5.5>, <15.3, 6.3>, <16, 6.4>,
          <16, 6.4>, <16, 6.4>, <27.5, 8.8>, <27.5, 8.8>,
          <27.5, 8.8>, <27.5, 8.8>, <28, 8.9>, <28, 9.3>,
          <28, 9.3>, <28, 9.3>, <27.9, 9.8>, <27.5, 9.8>,
          <27.5, 9.8>, <27.5, 9.8>, <9.9, 9.8>, <9.9, 9.8>
          sturm
          rotate -90*x
          translate <0, 0.000001, 0>
        }
      }
      difference {
        merge {
          cylinder { 0*y, 3.1*y, 3.1 }
          cylinder { 1*y, 9.699999*y, 2.4 }
          object { open_rounded_button() translate <0, 6.7, 0> }
        }
        #if (setting > 1)
          cylinder { -1*y, 20*y, 1.600001 }
          cylinder { -1*y, 2*y, 2.6 }
        #end
      }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <29.1, 11.6, 4> } }
    }
  #end
#end
#macro wheelaxle_old()
  cylinder { -5.9*z, 13.9*z, 1 texture { chrome_tex }
    bounded_by { cylinder { -6*z, z*14, 1.1 } } }
#end
#macro wheelbase1_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <3.9, 3.1, 29.9> }
      cylinder { -10*z, 34*z, 1.5 translate <0, 0.95, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <3.9, 3.1, 27.900001> }
          cylinder { 27.899999*z, 29*z, 1.9 translate <0, 0.95, 0> }
          cylinder { -3.899999*z, -5*z, 1.9 translate <0, 0.95, 0> }
          intersection {
            merge {
              box { <-4, 0.000001, 0> <1, 2, 2> rotate 27.5*y translate <-1.8, 0, -5> }
              box { <-4, 0.000001, -2> <1, 2, 0> rotate -27.5*y translate <-1.8, 0, 29> }
              box { <-1, 0.000001, 0> <4, 2, 2> rotate -27.5*y translate <1.8, 0, -5> }
              box { <-1, 0.000001, -2> <4, 2, 0> rotate 27.5*y translate <1.8, 0, 29> }
            }
            box { <-3.900001, 0, -5> <3.900001, 2.1, 29> }
          }
          object { open_rounded_button() }
          object { open_rounded_button() translate <0, 0, 8> }
          object { open_rounded_button() translate <0, 0, 16> }
          object { open_rounded_button() translate <0, 0, 24> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> translate <0, 3.1, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <0, 3.1, 8> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <0, 3.1, 16> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <0, 3.1, 24> }
          #end
          difference {
            merge {
              cylinder { 28*z, 33.9*z, 1.5 }
              cylinder { 33.4*z, 33.999991*z, 1.75 }
            }
            cylinder { -3*y, 3*y, 0.4 translate <0, 0, 31.4> }
            box { <-0.4, -3, 31.4> <0.4, 3, 35> }
            translate <0, 0.95, 0>
          }
          difference {
            merge {
              cylinder { -4*z, -9.9*z, 1.5 }
              cylinder { -9.4*z, -9.999991*z, 1.75 }
            }
            cylinder { -3*y, 3*y, 0.4 translate <0, 0, -7.4> }
            box { <-0.4, -3, -7.39999> <0.4, 3, -11> }
            translate <0, 0.95, 0>
          }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <2.4, 2, 26.4> }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <0, 0, 4> }
        object { pin(2) translate <0, 0, 12> }
        object { pin(2) translate <0, 0, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -1.05, -10.1> <4, 4.5, 34.1> } }
    }
  #end
#end
#macro wheelbase2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
      cylinder { -10*z, 18*z, 1.5 translate <4, 0.95, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.900001, 3.1, 11.900001> }
          cylinder { 11.899999*z, 13*z, 1.9 translate <4, 0.95, 0> }
          cylinder { -3.899999*z, -5*z, 1.9 translate <4, 0.95, 0> }
          box { <-4, 0.000001, 0> <0, 2, 2> rotate 25*y translate <2, 0, -5> }
          box { <-4, 0.000001, -2> <0, 2, 0> rotate -25*y translate <2, 0, 13> }
          box { <0, 0.000001, 0> <4, 2, 2> rotate -25*y translate <6, 0, -5> }
          box { <0, 0.000001, -2> <4, 2, 0> rotate 25*y translate <6, 0, 13> }
          box { <2, 0.000002, -5.000001> <6, 2.000001, -3.8> }
          box { <2, 0.000002, 11.899998> <6, 2.000001, 13.000001> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
          #end
          difference {
            merge {
              cylinder { 12*z, 17.9*z, 1.5 }
              cylinder { 17.4*z, 17.999991*z, 1.75 }
            }
            cylinder { -3*y, 3*y, 0.4 translate <0, 0, 15.4> }
            box { <-0.4, -3, 15.399999> <0.4, 3, 19> }
            translate <4, 0.95, 0>
          }
          difference {
            merge {
              cylinder { -4*z, -9.9*z, 1.5 }
              cylinder { -9.4*z, -9.999991*z, 1.75 }
            }
            cylinder { -3*y, 3*y, 0.4 translate <0, 0, -7.4> }
            box { <-0.4, -3, -7.399999> <0.4, 3, -11> }
            translate <4, 0.95, 0>
          }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        box { <3.5, 0.000001, -3> <4.5, 2.1, 1> }
        box { <3.5, 0.000001, 7> <4.5, 2.1, 11> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -1.05, -10.1> <12, 4.9, 18.1> } }
    }
  #end
#end
#macro wheelbase_old2_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.900001, 3.1, 11.900001> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
          #end
          cylinder { -4.9*z, -3.899999*z, 2.4 translate <4, 1.8, 0> }
          cylinder { 10.899999*z, 12.9*z, 2.4 translate <4, 1.8, 0> }
          box { <1.600001, 1.799999, -4.900001> <6.400001, 3.089998, -3.899998> }
          box { <1.600001, 1.799999, 10.899998> <6.400001, 3.089998, 12.900001> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        #end
        box { <1, 3.089999, -6> <7, 6, -2.4> }
        box { <1, 3.089999, 10.4> <7, 6, 14> }
        cylinder { -6*z, 14*z, 1.1 translate <4, 1.8, 0> }
        box { <2.899999, 1.799999, -6> <5.100001, 6, -3.8> }
        box { <2.899999, 1.799999, 11.8> <5.100001, 6, 14> }
      }
      #if (setting > 1)
        difference {
          object { ring() }
          box { <-1.35, -1, -4> <1.35, 2.999999, 4> }
          translate <4, 0, 4>
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.7, -5> <12, 4.9, 13> } }
    }
  #end
#end
#macro wheelcover2_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -11.9> <11.9, 6.3, 19.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <11.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 8> }
          #end
          difference {
            merge {
              box { <-3.899999, 0.000001, -3.899999> <11.899999, 6.3, -11.9> }
              box { <-3.899999, 0.000001, 11.899999> <11.899999, 6.3, 19.9> }
            }
            box { <-10, -10, -20> <0, 10, 30> rotate -37.5*z translate <-2.4, 3.2, 0> }
            box { <0, -10, -20> <10, 10, 30> rotate 37.5*z translate <10.4, 3.2, 0> }
            difference {
              box { <-8, -1, -13> <8, 4.5, -4> }
              box { <-10, -10, -20> <0, 10, 0> rotate -40*z translate <-6.4, 0, 0> }
              box { <0, -10, -20> <10, 10, 0> rotate 40*z translate <6.4, 0, 0> }
              translate <4, 0, 0>
            }
            difference {
              box { <-8, -1, -13> <8, 4.5, -4> }
              box { <-10, -10, -20> <0, 10, 0> rotate -40*z translate <-6.4, 0, 0> }
              box { <0, -10, -20> <10, 10, 0> rotate 40*z translate <6.4, 0, 0> }
              rotate 180*y translate <4, 0, 8>
            }
          }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -12> <12, 6.4, 20> } }
    }
  #end
#end
#macro wheel_cover2_2(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -11.9> <11.9, 6.3, 19.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -11.9> <11.9, 6.3, 19.9> }
            box { <-4, 3.1, -4.1> <12, 7, 12.1> }
          }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 6.2*y, 8*y, 2.4 translate <0, 0, -8> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, -8> }
            cylinder { 6.2*y, 8*y, 2.4 translate <0, 0, 16> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 16> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <8, 0, 0> }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <0, 3.2, -8> }
            object { rounded_button() rotate 180*y translate <8, 3.2, -8> }
            object { rounded_button() rotate 180*y translate <0, 3.2, 16> }
            object { rounded_button() rotate 180*y translate <8, 3.2, 16> }
          #end
        }
        difference {
          box { <-8, -1, -13> <8, 4.5, -4> }
          box { <-10, -10, -20> <0, 10, 0> rotate -40*z translate <-6.4, 0, 0> }
          box { <0, -10, -20> <10, 10, 0> rotate 40*z translate <6.4, 0, 0> }
          translate <4, 0, -1>
        }
        difference {
          box { <-8, -1, -13> <8, 4.5, -4> }
          box { <-10, -10, -20> <0, 10, 0> rotate -40*z translate <-6.4, 0, 0> }
          box { <0, -10, -20> <10, 10, 0> rotate 40*z translate <6.4, 0, 0> }
          rotate 180*y translate <4, 0, 9>
        }
        difference {
          box { <-6.4, -1, -10.4> <6.4, 5.1, -4> }
          box { <-10, -10, 10> <10, 10, -4.5> rotate -10*x }
          translate <4, 0, 0.5>
        }
        difference {
          box { <-6.4, -1, -10.4> <6.4, 5.1, -4> }
          box { <-10, -10, 10> <10, 10, -4.5> rotate -10*x }
          rotate 180*y translate <4, 0, 7.5>
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <0, 0, -8> } 
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, -8> } 
          cylinder { 4.2*y, 7.2*y, 1.2 translate <0, 0, 16> } 
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 16> } 
        #end
      }
      object { ring() translate <4, 0, 4> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -12> <12, 8.1, 20> } }
    }
  #end
#end
#macro wheel_cover4_5(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <35.9, 3.1, 27.9> }
      box { <4.1, 3, -3.900001> <19.9, 6.3, 3.900001> }
      box { <4.1, 3, 20.100001> <19.9, 6.3, 27.9000001> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <35.9, 3.1, 27.9> }
            box { <11.9, -1, 3.9> <28.1, 6, 20.1> }
          }
          box { <4.100001, 3, -3.9000001> <19.900001, 6.3, 3.900001> }
          box { <4.100001, 3, 20.100001> <19.900001, 6.3, 27.9000001> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 16> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 0> }
            cylinder { 6.2*y, 8*y, 2.4 translate <8, 0, 24> }
            cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, 0> }
            cylinder { 6.2*y, 8*y, 2.4 translate <16, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 24> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 16> }
            cylinder { 3*y, 4.8*y, 2.4 translate <32, 0, 24> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
            object { rounded_button() rotate 180*y translate <0, 0, 16> }
            object { rounded_button() rotate 180*y translate <0, 0, 24> }
            object { rounded_button() rotate 180*y translate <8, 0, 8> }
            object { rounded_button() rotate 180*y translate <8, 0, 16> }
            object { rounded_button() rotate 180*y translate <8, 3.2, 0> }
            object { rounded_button() rotate 180*y translate <8, 3.2, 24> }
            object { rounded_button() rotate 180*y translate <16, 3.2, 0> }
            object { rounded_button() rotate 180*y translate <16, 3.2, 24> }
            object { rounded_button() rotate 180*y translate <24, 0, 0> }
            object { rounded_button() rotate 180*y translate <24, 0, 24> }
            object { rounded_button() rotate 180*y translate <32, 0, 0> }
            object { rounded_button() rotate 180*y translate <32, 0, 8> }
            object { rounded_button() rotate 180*y translate <32, 0, 16> }
            object { rounded_button() rotate 180*y translate <32, 0, 24> }
          #end
        }
        difference {
          box { <-8, -1, -13> <8, 4.5, -4> }
          box { <-10, -10, -20> <0, 10, 0> rotate -40*z translate <-6.4, 0, 0> }
          box { <0, -10, -20> <10, 10, 0> rotate 40*z translate <6.4, 0, 0> }
          translate <12, 0, 7>
        }
        difference {
          box { <-8, -1, -13> <8, 4.5, -4> }
          box { <-10, -10, -20> <0, 10, 0> rotate -40*z translate <-6.4, 0, 0> }
          box { <0, -10, -20> <10, 10, 0> rotate 40*z translate <6.4, 0, 0> }
          rotate 180*y translate <12, 0, 17>
        }
        difference {
          box { <-7.8, -1, -10.4> <7.8, 5.1, -4> }
          box { <-10, -10, 10> <10, 10, -4.5> rotate -10*x }
          translate <12, 0, 8.3>
        }
        difference {
          box { <-7.8, -1, -10.4> <7.8, 5.1, -4> }
          box { <-10, -10, 10> <10, 10, -4.5> rotate -10*x }
          rotate 180*y translate <12, 0, 15.7>
        }
        #if (setting > 1)
          box { <-2.4, -1, 5.6> <10.4, 2, 18.4> }
          box { <-2.4, -1, -2.4> <2.4, 2.000001, 26.4> }
          box { <21.6, -1, -2.4> <34.399999, 2.000002, 2.4> }
          box { <21.6, -1, 21.6> <34.399999, 2.000003, 26.4> }
          box { <29.6, -1, -2.4> <34.4, 2.000004, 26.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 24> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 16> }
          cylinder { 1*y, 4*y, 1.2 translate <32, 0, 24> }
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 0> } 
          cylinder { 4.2*y, 7.2*y, 1.2 translate <16, 0, 0> } 
          cylinder { 4.2*y, 7.2*y, 1.2 translate <8, 0, 24> } 
          cylinder { 4.2*y, 7.2*y, 1.2 translate <16, 0, 24> } 
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 12> }
        object { pin(1) translate <0, 0, 4> }
        object { pin(1) translate <0, 0, 20> }
        object { pin(1) translate <32, 0, 4> }
        object { pin(1) translate <32, 0, 12> }
        object { pin(1) translate <32, 0, 20> }
        object { pin(1) translate <28, 0, 0> }
        object { pin(1) translate <28, 0, 24> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <36, 8.1, 28> } }
    }
  #end
#end
#macro wheel_hard(color_tex)
  #if (setting = 0)
    merge {
      difference {
        sphere { <0, 0, 0> 1 scale <21.4, 21.4, 25> translate <0, 0, -3> }
        box { <-25, -25, -3> <25, 25, 50> }
        box { <-25, -25, -50> <25, 25, -19.30005> }
      }
      difference {
        sphere { <0, 0, 0> 1 scale <21.4, 21.4, 27.5> translate <0, 0, -3> }
        box { <-25, -25, 7.9> <25, 25, 50> }
        box { <-25, -25, -50> <25, 25, -3.00001> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          cylinder { -16*z, -19.3*z, 15.8 }
          cylinder { -19.3*z, 0.00002*z, 13.5 }
          difference {
            sphere { <0, 0, 0> 1 scale <21.4, 21.4, 25> translate <0, 0, -3> }
            box { <-25, -25, -3> <25, 25, 50> }
            box { <-25, -25, -50> <25, 25, -19.30005> }
          }
          difference {
            sphere { <0, 0, 0> 1 scale <21.4, 21.4, 27.5> translate <0, 0, -3> }
            box { <-25, -25, 7.9> <25, 25, 50> }
            box { <-25, -25, -50> <25, 25, -3.00001> }
          }
          #local counter = 0;
          #while (counter < 10)
            difference {
              box { <-2, 15, -19> <2, 21.3, 7.85> }
              box { <-3, 0, -10> <3, 10, 0> rotate -45*x translate <0, 21.3, -15.9> }
              box { <-3, 0, 0> <3, 10, 10> rotate 25*x translate <0, 21.3, 4.8> }
              rotate (18+(counter*36))*z
            }
            #local counter = counter + 1;
          #end
        }
        #local counter = 0;
        #while (counter < 10)
          difference {
            box { <-0.8, 15, -17> <0.8, 20.8, -3> }
            box { <-1, 0, -20> <1, 10, 0> rotate -25*x translate <0, 20.8, -7.5> }
            rotate (18+(counter*36))*z
          }
          #local counter = counter + 1;
        #end
        difference {
          merge {
            sphere { <0, 0, 0> 19.3 translate <0, 0, -3> }
            cylinder { -3.00001*z, 10*z, 19.3 }
          }
          cone { -19.30007*z, 15.50002, -15.00002*z, 13.50002 }
          cylinder { -28*z, 8*z, 13 }
          box { <-0.5, 13, -20> <0.5, 25, -0.5> rotate -36*z }
          box { <-0.5, 13, -20> <0.5, 25, -0.5> rotate 36*z }
          box { <-0.5, -13, -20> <0.5, -25, -0.5> rotate -36*z }
          box { <-0.5, -13, -20> <0.5, -25, -0.5> rotate 36*z }
          cylinder { 13*y, 25*y, 0.5 rotate -36*z translate <0, 0, -0.5> }
          cylinder { 13*y, 25*y, 0.5 rotate 36*z translate <0, 0, -0.5> }
          cylinder { -13*y, -25*y, 0.5 rotate -36*z translate <0, 0, -0.5> }
          cylinder { -13*y, -25*y, 0.5 rotate 36*z translate <0, 0, -0.5> }
        }
        cone { -19.30007*z, 14.00002, -15.00002*z, 12.00002 }
        cylinder { -28*z, 8*z, 12 }
        cylinder { -0.00001*z, 8*z, 19.3 }
      }
      torus { 19.3, 0.25 rotate 90*x scale <1, 1, 2> translate <0, 0, -4> }
      torus { 19.3, 0.25 rotate 90*x scale <1, 1, 2> translate <0, 0, -6> }
      difference {
        merge {
          cylinder { -17.85*z, 0*z, 4.8 }
          torus { 4.65, 0.15 rotate 90*x translate <0, 0, -17.85> }
          cylinder { -18*z, -10*z, 4.65 }
          box { <-0.55, 4, -14.5> <0.55, 12.5, 0.00001> }
          cylinder { 4*y, 12.5*y, 0.55 translate <0, 0, -14.5> }
          box { <-0.55, 4, -14.5> <0.55, 12.5, 0.00001> rotate 120*z }
          cylinder { 4*y, 12.5*y, 0.55 translate <0, 0, -14.5> rotate 120*z }
          box { <-0.55, 4, -14.5> <0.55, 12.5, 0.00001> rotate 240*z }
          cylinder { 4*y, 12.5*y, 0.55 translate <0, 0, -14.5> rotate 240*z }
        }
        cylinder { -19*z, 1*z, 2.5 }
        cylinder { -1*z, 1*z, 3.1 }
        cylinder { -19*z, -8.65*z, 3.1 }
        difference {
          cylinder { -18*z, -16.6*z, 3.8 }
          cylinder { -20*z, -15*z, 2.5 translate <-4, -4, 0> rotate -9*z }
          cylinder { -20*z, -15*z, 2.5 translate <4, -4, 0> rotate -9*z }
          cylinder { -20*z, -15*z, 2.5 translate <-4, 4, 0> rotate -9*z}
          cylinder { -20*z, -15*z, 2.5 translate <4, 4, 0> rotate -9*z }
        }
      }
      texture { color_tex finish { lego_finish reflection 0 } }
      bounded_by { cylinder { -19.4*z, 8*z, 21.5 } }
    }
  #end
#end
#macro wheel_inside(color_tex)
  #if (setting = 0)
    cylinder { -2.9*z, 2.9*z, 4 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { -2.9*z, 2.9*z, 4 }
        #if (setting > 1)
          cylinder { -4*z, 4*z, 1.6 }
          box { <-0.5, -2.5, -1> <0.5, 2.5, 4> }
          box { <-2.5, -0.5, -1.000001> <2.5, 0.5, 4> }
          cylinder { -2*z, -1*z, 2 }
          cone { -4*z, 4, -1*z, 1 }
        #end
        difference {
          cylinder { -1*z, 1*z, 5 }
          cylinder { -2*z, 2*z, 3 }
        }
      }
      box { <-0.5, -2.9, -2.900001> <0.5, 2.9, -2.000001> }
      box { <-2.9, -0.5, -2.900002> <2.9, 0.5, -2.000002> }
      cylinder { -2.900003*z, -2*z, 1.5 }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*x translate <0, 0, -2.9> }
      #end
      texture { color_tex }
      bounded_by { cylinder { -3*z, 3*z, 4.1 } }
    }
  #end
#end
#macro wheel_inside10(color_tex)
  #if (setting = 0)
    cylinder { -14.8*z, -1*z, 8.9 texture { color_tex } }
  #else
    difference {
      merge {
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate -90*x translate <0, 0, -11.5> }
        #end
        difference {
          cylinder { -0.1*z, -11.5*z, 3.9 }
          cylinder { 1*z, -0.9*z, 3.1 }
          cylinder { 1*z, -8*z, 2.3 }
        }
        difference {
          cylinder { -1*z, -6.2*z, 8.9 }
          cylinder { 0*z, -6.1*z, 7.6 }
        }
        cone { -6.19999*z, 8.90001, -6.7*z, 6.9 }
        cone { -9.60001*z, 8.90001, -9.1*z, 6.9 }
        difference {
          cylinder { -14.8*z, -9.6*z, 8.9 }
          difference {
            merge {
              cylinder { -15*z, -11.5*z, 7.6 }
              cone { -11.50001*z, 7.6, -9.1*z, 4.9 }
            }
            box { <-10, -0.7, -11.30001> <10, 0.7, 0> }
            box { <-0.7, -10, -11.30002> <0.7, 10, 0> }
          }
        }
      }
      box { <-2.7, 0, -8.0001> <2.7, 10, -6.50001> }
      texture { color_tex }
      bounded_by { cylinder { -14.9*z, 0*z, 9 } }
    }
  #end
#end
#macro wheel_inside2(color_tex)
  #if (setting = 0)
    cylinder { -9*z, 3*z, 5.4 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          cylinder { -2*z, 3*z, 5.4 }
          cylinder { -9*z, -4*z, 5.4 }
          cylinder { -5*z, -1*z, 4.4 }
        }
        cone { -6.01*z, 5, -4.5*z, 4.5 }
        cylinder { 4*z, -10*z, 1.5 }
        #if (setting > 1)
          box { <-6, -2.4, -3> <6, 2.4, -0.5> rotate 45*z }
          difference {
            cylinder { 0*z, 4*z, 4.5 }
            cylinder { -1*z, 5*z, 3 }
          }
        #end
        cylinder { -10*z, -5*z, 4.5 }
      }
      box { <-5.25, -0.7, -6.000001> <5.25, 0.7, -5.2500001> }
      box { <-0.7, -5.25, -6.000002> <0.7, 5.25, -5.2500002> }
      cylinder { -6*z, -5.25*z, 2.25 }
      #if (setting > 3)
        object { llogo() rotate -90*x translate <0, 0, -6> }
      #end
      texture { color_tex }
      bounded_by { cylinder { -9.1*z, 3.1*z, 5.5 } }
    }
  #end
#end
#macro wheel_inside3(color_tex)
  #if (setting = 0)
    cylinder { -1.75*z, 1.75*z, 4 texture { color_tex } }
  #else
    merge {
      cylinder { -4.5*z, 4.5*z, 0.75 }
      cylinder { -3*z, 3*z, 2.25 }
      difference {
        cylinder { -1.75*z, 1.75*z, 4 }
        torus { 4, 1 rotate 90*x }
      }
      texture { color_tex }
      bounded_by { cylinder { -4.6*z, 4.6*z, 4.1 } }
    }
  #end
#end
#macro wheel_inside4(color_tex)
  #if (setting = 0)
    cylinder { -3.6*z, 3.6*z, 8.5 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -3.6*z, 3.6*z, 7.5 }
        cylinder { -3.8*z, 3.8*z, 3.999999 }
        cone { -2.6*z, 8.500001, -1.75*z, 7.500001 }
        cylinder { -3.600001*z, -2.599999*z, 8.5 }
        cone { 2.6*z, 8.500001, 1.75*z, 7.500001 }
        cylinder { 2.599999*z, 3.600001*z, 8.5 }
      }
      object { axle_opening(8,1) rotate -90*y translate <0, 0, -4> }
      box { <-5, -0.900001, -4> <5, 0.900001, 4> }
      difference {
        cylinder { -4*z, 4*z, 6 }
        cylinder { -5*z, 5*z, 4 }
        difference {
          box { <-2.475, 4.1, -4> <2.475, 8, 4> }
          cylinder { -5*z, 5*z, 1.000001 translate <0, 5, 0> rotate 20*z }
          cylinder { -5*z, 5*z, 1.000001 translate <0, 5, 0> rotate -20*z }
        }
        difference {
          box { <-2.475, -8, -4> <2.475, -4.1, 4> }
          cylinder { -5*z, 5*z, 1.000001 translate <0, -5, 0> rotate 20*z }
          cylinder { -5*z, 5*z, 1.000001 translate <0, -5, 0> rotate -20*z }
        }
      }
      texture { color_tex }
      bounded_by { cylinder { -3.7*z, 3.7*z, 8.6 } }
    }
  #end
#end
#macro wheel_inside5(color_tex)
  #if (setting = 0)
    cylinder { -8.9*z, -0.1*z, 4.2 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { -8.9*z, -0.1*z, 4.2 }
        cylinder { -10*z, 1*z, 1.6 }
        box { <-6, -2, -5> <6, 2, -4> rotate 45*z }
        cylinder { -10*z, -5.999999*z, 3.4 }
        cone { -6*z, 3.400001, -4.999999*z, 2.4 }
        difference {
          cylinder { -3*z, 1*z, 3.4 }
          cylinder { -4*z, 2*z, 2.5 }
        }
        difference {
          cylinder { -5.5*z, -3*z, 5 }
          cone { -3.75*z, 3.5, -2.75*z, 4.700001 }
          cone { -4.75*z, 3.5, -5.75*z, 4.700001 }
          cylinder { -3.749999*z, -4.750001*z, 3.500001 }
        }
      }
      cylinder { -6*z, -5*z, 1.6 }
      box { <-0.65, -4, -6.000001> <0.65, 4, -5.000001> }
      box { <-4, -0.65, -6.000002> <4, 0.65, -5.000002> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*x translate <0, 0, -6> }
      #end
      texture { color_tex }
      bounded_by { cylinder { -9*z, 0*z, 4.3 } }
    }
  #end
#end
#macro wheel_inside6(color_tex)
  #if (setting = 0)
    cylinder { -2*z, 3*z, 4 texture { color_tex } }
  #else
    merge {
      object { rounded_button() rotate -90*x translate <0, 0, 1.1> }
      difference {
        cylinder { -2*z, 2*z, 4 }
        torus { 4, 1 rotate 90*x }
      }
      difference {
        cone { 1.999999*z, 3.999999, 3*z, 3 }
        cylinder { 2*z, 4*z, 1.1 }
      }
      texture { color_tex }
      bounded_by { cylinder { -3.8*z, 3.1*z, 4.1 } }
    }
  #end
#end
#macro wheel_inside7(color_tex)
  #if (setting = 0)
    cylinder { -3*z, 3*z, 8.4 texture { color_tex } }
  #else
    merge {
      difference {
        cylinder { -3*z, 3*z, 3 }
        cylinder { -4*z, 4*z, 2.4 }
      }
      difference {
        merge {
          cylinder { -1.7*z, 1.7*z, 7.25 }
          cone { -2.500001*z, 8.400001, -1.65*z, 7.25 }
          cylinder { -3*z, -2.5*z, 8.4 }
          cone { 2.500001*z, 8.400001, 1.65*z, 7.25 }
          cylinder { 3*z, 2.5*z, 8.4 }
        }
        cylinder { -4*z, 4*z, 5.8 }
        cone { -2*z, 5.8, -3.000001*z, 6.8 }
        cone { 2*z, 5.8, 3.000001*z, 6.8 }
      }
      #local counter = 0;
      #while (counter < 12)
        box { <-0.45, 2.9, -2> <0.45, 6, 2> rotate (counter*30)*z }
        #local counter = counter + 1;
      #end
      texture { color_tex }
      bounded_by { cylinder { -3.1*z, 3.1*z, 8.5 } }
    }
  #end
#end
#macro wheel_inside8(color_tex)
  #if (setting = 0)
    cylinder { -3.6*z, 3.6*z, 8.5 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -3.6*z, 3.6*z, 7.5 }
        cone { -2.6*z, 8.500001, -1.75*z, 7.500001 }
        cylinder { -3.600001*z, -2.599999*z, 8.5 }
        cone { 2.6*z, 8.500001, 1.75*z, 7.500001 }
        cylinder { 2.599999*z, 3.600001*z, 8.5 }
        #if (setting < 3)
          cylinder { -3.5*z, -5.3*z, 2.4 translate <-4, -4, 0> }
          cylinder { -3.5*z, -5.3*z, 2.4 translate <-4, 4, 0> }
          cylinder { -3.5*z, -5.3*z, 2.4 translate <4, -4, 0> }
          cylinder { -3.5*z, -5.3*z, 2.4 translate <4, 4, 0> }
        #else
          object { rounded_button() rotate 90*y rotate -90*x translate <-4, -4, -0.5> }
          object { rounded_button() rotate 90*y rotate -90*x translate <-4, 4, -0.5> }
          object { rounded_button() rotate 90*y rotate -90*x translate <4, -4, -0.5> }
          object { rounded_button() rotate 90*y rotate -90*x translate <4, 4, -0.5> }
        #end
      }
      cylinder { -4*z, -3.1*z, 3.1 }
      cylinder { -4*z, 4*z, 2.5 }
      cylinder { 4*z, 3.1*z, 3.1 }
      #if (setting > 1)
        difference {
          cylinder { 3.7*z, -3.2*z, 6 }
          cylinder { 4*z, -4*z, 3.9 }
          box { <-0.5, -10, -4> <0.5, 10, -2.2> }
          box { <-10, -0.5, -4> <10, 0.5, -2.2> }
        }
        difference {
          cone { 3.7*z, 6.75, 2.8*z, 5.999999 }
          cylinder { 4*z, -4*z, 3.9 }
        }
      #end
      texture { color_tex }
      bounded_by { cylinder { -5.4*z, 3.7*z, 8.6 } }
    }
  #end
#end
#macro wheel_inside9(color_tex)
  #if (setting = 0)
    cylinder { -3.9*z, 3.9*z, 5.6 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -3.9*z, 3.9*z, 3.7 }
        cylinder { -3.1*z, -1.3*z, 5.6 }
        cylinder { 3.1*z, 1.3*z, 5.6 }
        cone { -0.3*z, 3.7, -1.300005*z, 5.6 }
        cone { 0.3*z, 3.7, 1.300005*z, 5.6 }
      }
      cylinder { -5*z, -3.4*z, 3.1 }
      cylinder { 5*z, 3.4*z, 3.1 }
      cylinder { -6*z, 6*z, 2.4 }
      difference {
        cylinder { -3.2*z, 3.2*z, 4.7 }
        box { <-0.55, -5, -3> <0.55, 5, 3> }
        box { <-5, -0.55, -3> <5, 0.55, 3> }
        cylinder { -4*z, 4*z, 3.6 }
        box { <-5, -5, -2> <5, 5, 2> }
      }
      texture { color_tex }
      bounded_by { cylinder { -4*z, 4*z, 5.7 } }
    }
  #end
#end
#macro wheel_inside_large(color_tex)
  #if (setting = 0)
    cylinder { -20*x, 0*x, 15.1 texture { color_tex } }
  #else
    difference {
      merge {
        difference {
          cylinder { -20*x, 0*x, 15.1 }
          cylinder { -4.000001*x, 1*x, 14 }
          cone { -5.500003*x, 12.500001, -3.999999*x, 14.000002 }
          cylinder { -21*x, 1*x, 4 }
          cylinder { -13.000003*x, -6.999999*x, 12.500001 }
          cylinder { -21*x, -14.5*x, 14 }
          cone { -14.500003*x, 14.000001, -13*x, 12.5 }
        }
        cylinder { -7.000001*x, -0.5*x, 3.2 translate <0, 0, 8> rotate 30*x }
        cylinder { -7.000001*x, -0.5*x, 3.2 translate <0, 0, 8> rotate 90*x }
        cylinder { -7.000001*x, -0.5*x, 3.2 translate <0, 0, 8> rotate 150*x }
        cylinder { -7.000001*x, -0.5*x, 3.2 translate <0, 0, 8> rotate 210*x }
        cylinder { -7.000001*x, -0.5*x, 3.2 translate <0, 0, 8> rotate 270*x }
        cylinder { -7.000001*x, -0.5*x, 3.2 translate <0, 0, 8> rotate 330*x }
        cylinder { -13*x, -7*x, 3 }
        cylinder { -13.000001*x, -7.000002*x, 1.5 translate <0, 0, -3.5> }
        cylinder { -13.000001*x, -7.000002*x, 1.5 translate <0, 0, 3.5> }
        box { <-13.000004, -1.500001, -3.500001> <-7.000004, 1.500001, 3.500001> }
        #local counter = 0;
        #while (counter < 6)
          difference {
            box { <-13.000002, -0.5, -7.5> <-7.000005, 0.5, -2.9> }
            box { <-10, -10, -10> <0, 10, 10> rotate -40*y translate <-9, 0, -9.75> }
            rotate (counter * 60)*x
          }
          #local counter = counter + 1;
        #end
      }
      #local counter = 0;
      #while (counter < 6)
        difference {
          box { <-8, -2, -14> <1, 2, -5.2> }
          box { <-10, -10, 0> <10, 10, 20> rotate -81*x translate <0, 2, -14> }
          box { <-10, -10, 0> <10, 10, 20> rotate 81*x translate <0, -2, -14> }
          box { <-9, -2, -9> <-5.5, 2, -5> }
          cylinder { -10*x, -1*x, 7.7 }
          cylinder { -9*x, 2*x, 13.999999 inverse }
          rotate (counter * 60)*x
        }
        #local counter = counter + 1;
      #end
      #local counter = 0;
      #while (counter < 6)
        difference {
          box { <-6.4, -4, -14> <-1, 4, -7.75> }
          box { <-10, -10, 0> <10, 10, 20> rotate -72*x translate <0, 4, -14> }
          box { <-10, -10, 0> <10, 10, 20> rotate 72*x translate <0, -4, -14> }
          cylinder { -7*x, -1*x, 14 inverse }
          cylinder { -7*x, -1*x, 3 translate <0, 0, -8> }
          rotate (30 + (counter * 60))*x
        }
        #local counter = counter + 1;
      #end
      cylinder { -10*x, 2*x, 2.4 translate <0, 0, 8> rotate 30*x }
      cylinder { -10*x, 2*x, 2.4 translate <0, 0, 8> rotate 90*x }
      cylinder { -10*x, 2*x, 2.4 translate <0, 0, 8> rotate 150*x }
      cylinder { -10*x, 2*x, 2.4 translate <0, 0, 8> rotate 210*x }
      cylinder { -10*x, 2*x, 2.4 translate <0, 0, 8> rotate 270*x }
      cylinder { -10*x, 2*x, 2.4 translate <0, 0, 8> rotate 330*x }
      intersection {
        box { <-14, -0.5, -4.4> <-5.5, 0.5, 4.4> }
        cylinder { -15*x, -5*x, 4.000001 }
      }
      object { axle_opening(8,1) translate <-14, 0, 0> }
      texture { color_tex }
      bounded_by { cylinder { -20.1*x, 0.1*x, 15.2 } }
    }
  #end
#end
#macro wheel_inside_large2(color_tex)
  #if (setting = 0)
    cylinder { -24*x, 0*x, 21.5 texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          difference {
            cylinder { -24*x, 0*x, 21.5 }
            cone { -6.500003*x, 18.900001, -5.5*x, 20.3 }
            cylinder { -5.50000*x, 1*x, 20.3 }
            cylinder { -20*x, 1*x, 18.900001 }
            cylinder { -25*x, -16.7*x, 20.3 }
            cone { -16.700003*x, 20.300001, -15.2*x, 18.9 }
          }
          cylinder { -7.000001*x, -0.5*x, 3.2 translate <0, 0, 16> }
          cylinder { -7.000001*x, -0.5*x, 3.2 translate <0, 0, 16> rotate 60*x }
          cylinder { -7.000001*x, -0.5*x, 3.2 translate <0, 0, 16> rotate 120*x }
          cylinder { -7.000001*x, -0.5*x, 3.2 translate <0, 0, 16> rotate 180*x }
          cylinder { -7.000001*x, -0.5*x, 3.2 translate <0, 0, 16> rotate 240*x }
          cylinder { -7.000001*x, -0.5*x, 3.2 translate <0, 0, 16> rotate 300*x }
          difference {
            cylinder { -5*x, -4*x, 12.5 }
            cylinder { -21*x, -2*x, 8.750001 }
          }
          difference {
            cylinder { -20*x, -3*x, 10 }
            difference {
              cylinder { -21*x, -2*x, 8.75 }
              cylinder { -22*x, -1*x, 3.8 }
              box { <-22, -2.5, -10> <-1, 2.5, 10> }
            }
          }
          #local counter = 0;
          #while (counter < 6)
          difference {
            box { <-12, -6, -21> <-3.5, 6, -9.5> }
            box { <-13, -10, -25> <-3, 0, 0> rotate -14*x }
            box { <-13, 0, -25> <-3, 10, 0> rotate 14*x }
            difference {
              box { <-4, -6, -22> <0, 6, -9> }
              box { <-13, -10, -25> <-3, 1, 0> rotate -14*x }
              box { <-13, -1, -25> <-3, 10, 0> rotate 14*x }
              box { <-5, -7, -13.5> <-3, 7, -17.3> }
            }
            difference {
              box { <-13, -6, -22> <-7, 6, -9> }
              box { <-14, -10, -25> <-6, 1, 0> rotate -14*x }
              box { <-14, -1, -25> <-6, 10, 0> rotate 14*x }
            }
            cylinder { -20*x, -3*x, 9.999999 }
            cylinder { -25*x, 1*x, 21.500001 inverse }
            rotate (counter * 60)*x
          }
          #local counter = counter + 1;
          #end
        }
        cylinder { -20*x, 2*x, 2.6 translate <0, 0, 16> }
        cylinder { -20*x, 2*x, 2.6 translate <0, 0, 16> rotate 60*x }
        cylinder { -20*x, 2*x, 2.6 translate <0, 0, 16> rotate 120*x }
        cylinder { -20*x, 2*x, 2.6 translate <0, 0, 16> rotate 180*x }
        cylinder { -20*x, 2*x, 2.6 translate <0, 0, 16> rotate 240*x }
        cylinder { -20*x, 2*x, 2.6 translate <0, 0, 16> rotate 300*x }
        cylinder { -24*x, -1*x, 0.500001 translate <0, 0, -8.099999> }
        cylinder { -24*x, -1*x, 0.500001 translate <0, 0, 8.099999> }
        box { <-24, -0.5, -8.1> <-1, 0.5, 8.1> }
        object { axle_opening(23,1) translate <-24, 0, 0> }
      }
      #if (setting > 3)
        object { llogo() scale <0.85, 0.85, 0.85> rotate -90*z rotate 90*x translate <-4, 0, 11.75> }
        object { llogo() scale <0.85, 0.85, 0.85> rotate -90*z rotate 90*x translate <-4, 0, 11.75> rotate 60*x }
        object { llogo() scale <0.85, 0.85, 0.85> rotate -90*z rotate 90*x translate <-4, 0, 11.75> rotate 120*x }
        object { llogo() scale <0.85, 0.85, 0.85> rotate -90*z rotate 90*x translate <-4, 0, 11.75> rotate 180*x }
        object { llogo() scale <0.85, 0.85, 0.85> rotate -90*z rotate 90*x translate <-4, 0, 11.75> rotate 240*x }
        object { llogo() scale <0.85, 0.85, 0.85> rotate -90*z rotate 90*x translate <-4, 0, 11.75> rotate 300*x }
      #end
      texture { color_tex }
      bounded_by { cylinder { -24.1*x, 0.1*x, 21.6 } }
    }
  #end
#end
#macro wheel_mudguard(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
      box { <-3.90001, 6.4, -12> <11.90001, 9.50001, -3.8> }
      difference {
        cylinder { -12.2*z, -15.4*z, 15.9 }
        box { <-20, -20, -16> <20, 0, 0> }
        translate <4, -3.2, 0>
      }
      texture { color_tex } 
    }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <11.9, 9.5, 3.9> }
        box { <-3.90001, 6.4, -12.3> <11.90001, 9.50001, -3.8> }
        object { rounded_button() rotate -90*y translate <0, 6.4, 0> }
        object { rounded_button() rotate -90*y translate <8, 6.4, 0> }
        object { rounded_button() rotate -90*y translate <0, 6.4, -8> }
        object { rounded_button() rotate -90*y translate <8, 6.4, -8> }
        difference {
          merge {
            cone { -15.4*z, 12.5, -13.19999*z, 15.9 }
            cylinder { -12.2*z, -13.2*z, 15.9 }
          }
          box { <-20, -20, -16> <20, 0, 0> }
          translate <4, -3.2, 0>
        }
        box { <-11.9, -6.3, -15.40001> <19.9, -3.20001, -12.20001> }
      }
      box { <0, -7, -5> <5, 1, 0> rotate 33.05*y translate <-11.9, 0, -13.2> }
      box { <-5, -7, -5> <0, 1, 0> rotate -33.05*y translate <19.9, 0, -13.2> }
      cylinder { -16*z, -3.90005*z, 11.1 translate <4, -3.2, 0> }
      box { <-7.1, -7, -16> <15.1, -3.21999, -3> }
      #if (setting > 1)
        difference {
          merge {
            cone { -14.4*z, 12, -13.6*z, 13.34001 }
            cylinder { -13.2*z, -13.60001*z, 13.34 }
            box { <-13.34, -7, -13.20001> <13.34, 0.00001, -13.60002> }
            translate <4, -3.2, 0>
          }
          box { <0, -7, -5> <5, 1, 0> rotate 33.05*y translate <-9.34, 0, -12.8> }
          box { <-5, -7, -5> <0, 1, 0> rotate -33.05*y translate <17.34, 0, -12.8> }
          box { <-2.7, 0, -16> <-3.9, 10, -12> }
          box { <11.9, 0, -16> <10.7, 10, -12> }
        }
        box { <-2.9, -1, -3.90004> <10.9, 8.6, -12.19999> }
        difference {
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          cylinder { 0.00005*y, 9*y, 1.5 translate <4, 0, 0> }
          box { <3.75, 2, -3> <4.25, 9, 3> }
        }
        cylinder { 7.4*y, 10.4*y, 1.2 }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, -8> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, -8> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -6.4, -15.5> <20, 12.8, 4> } }
    }
  #end
#end
#macro wildwest_fence1_4(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
      cylinder { 3*y, 19.1*y, 1.5 }
      cylinder { 3*y, 19.1*y, 1.5 translate <8, 0, 0> }
      cylinder { 3*y, 19.1*y, 1.5 translate <16, 0, 0> }
      cylinder { 3*y, 19.1*y, 1.5 translate <24, 0, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 3.9> }
          cylinder { 3*y, 4.8*y, 2.4 }
          cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 0> }
          cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
          cylinder { 4*y, 18*y, 1.5 }
          cylinder { 4*y, 18*y, 1.5 translate <8, 0, 0> }
          cylinder { 4*y, 18*y, 1.5 translate <16, 0, 0> }
          cylinder { 4*y, 18*y, 1.5 translate <24, 0, 0> }
          box { <-3.9, 17.6, -3.9> <27.9, 19.1, 3.9> }
          object { open_rounded_button() translate <0, 16, 0> }
          object { open_rounded_button() translate <24, 16, 0> }
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> translate <0, 19.1, 0> }
            object { llogo() scale <0.65, 0.65, 0.65> translate <24, 19.1, 0> }
          #end
        }
        difference {
          box { <-5, 15, -5> <29, 20, 5> }
          cylinder { 14.999999*y, 20.000001*y, 0.9 translate <-3, 0, -3> }
          cylinder { 14.999999*y, 20.000001*y, 0.9 translate <27, 0, -3> }
          cylinder { 14.999999*y, 20.000001*y, 0.9 translate <-3, 0, 3> }
          cylinder { 14.999999*y, 20.000001*y, 0.9 translate <27, 0, 3> }
          box { <-3, 14.999999, -3.900001> <27, 20.000001, 3.900001> }
          box { <-3.900001, 14.999999, -3> <27.900001, 20.000001, 3> }
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <16, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
          sphere { <0, 0, 0> 1.5 scale <1, 0.75, 1> translate <8, 19.1, 0> }
          sphere { <0, 0, 0> 1.5 scale <1, 0.75, 1> translate <16, 19.1, 0> }
        #end
      }
      #if (setting > 1)
        object { pin(2) translate <4, 0, 0> }
        object { pin(2) translate <12, 0, 0> }
        object { pin(2) translate <20, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.4, -4> <28, 20.9, 4> } }
    }
  #end
#end
#macro wildwest_round_fence4_4(color_tex)
  #if (setting = 0)
    difference {
      merge {
        intersection {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> }
          cylinder { -1*y, 4*y, 31.8 translate <-3.9, 0, -3.9> }
        }
        cylinder { 3*y, 19.1*y, 1.5 translate <0, 0, 24> }
        cylinder { 3*y, 19.1*y, 1.5 translate <8.5, 0, 21.5> }
        cylinder { 3*y, 19.1*y, 1.5 translate <16, 0, 16> }
        cylinder { 3*y, 19.1*y, 1.5 translate <21.5, 0, 8.5> }
        cylinder { 3*y, 19.1*y, 1.5 translate <24, 0, 0> }
      }
      cylinder { -1*y, 4*y, 24.1 translate <-3.9, 0, -3.9> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        intersection {
          box { <-3.9, 0, -3.9> <27.9, 3.1, 27.9> }
          cylinder { -1*y, 4*y, 31.8 translate <-3.9, 0, -3.9> }
        }
        cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 24> }
        cylinder { 3*y, 4.8*y, 2.4 translate <8.5, 0, 21.5> }
        cylinder { 3*y, 4.8*y, 2.4 translate <16, 0, 16> }
        cylinder { 3*y, 4.8*y, 2.4 translate <21.5, 0, 8.5> }
        cylinder { 3*y, 4.8*y, 2.4 translate <24, 0, 0> }
        cylinder { 4*y, 18*y, 1.5 translate <0, 0, 24> }
        cylinder { 4*y, 18*y, 1.5 translate <8.5, 0, 21.5> }
        cylinder { 4*y, 18*y, 1.5 translate <16, 0, 16> }
        cylinder { 4*y, 18*y, 1.5 translate <21.5, 0, 8.5> }
        cylinder { 4*y, 18*y, 1.5 translate <24, 0, 0> }
        intersection {
          box { <-3.9, 17.6, -3.9> <27.9, 19.1, 27.9> }
          cylinder { 17*y, 20*y, 31.8 translate <-3.9, 0, -3.9> }
        }
        object { open_rounded_button() translate <0, 16, 24> }
        object { open_rounded_button() translate <24, 16, 0> }
        #if (setting > 3)
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 24> }
          object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <24, 19.1, 0> }
        #end
      }
      cylinder { -1*y, 20*y, 24.1 translate <-3.9, 0, -3.9> }
      difference {
        box { <26.9, 10, -4> <28, 20, -3> }
        cylinder { 10*y, 20*y, 0.9 translate <26.9, 0, -3> }
      }
      difference {
        box { <20, 10, -4> <21.1, 20, -3> }
        cylinder { 10*y, 20*y, 0.9 translate <21.1, 0, -3> }
      }
      difference {
        box { <-4, 10, 27> <-2.9, 20, 28> }
        cylinder { 10*y, 20*y, 0.9 translate <-3, 0, 27> }
      }
      difference {
        box { <-4, 10, 20> <-3, 20, 21.1> }
        cylinder { 10*y, 20*y, 0.9 translate <-3, 0, 21.1> }
      }
      #if (setting > 1)
        box { <8, -1, -2.5> <22, 2.000005, 2.5> rotate -26.5*y }
        box { <8, -1, -2.5> <22, 2.000005, 2.5> rotate -63.5*y }
        box { <22, -1, -2.5> <30, 2.000006, 2.5> rotate -18.5*y }
        box { <22, -1, -2.5> <30, 2.000006, 2.5> rotate -71.5*y }
        intersection {
          box { <-2.4, -1, -2.4> <26.4, 2, 26.4> }
          cylinder { -1*y, 4*y, 30.3 translate <-3.9, 0, -3.9> }
          cylinder { -1*y, 4*y, 25.5 translate <-3.9, 0, -3.9> inverse }
        }
        cylinder { 1*y, 4*y, 1.2 translate <0, 0, 24> }
        cylinder { 1*y, 4*y, 1.2 translate <8.5, 0, 21.5> }
        cylinder { 1*y, 4*y, 1.2 translate <16, 0, 16> }
        cylinder { 1*y, 4*y, 1.2 translate <21.5, 0, 8.5> }
        cylinder { 1*y, 4*y, 1.2 translate <24, 0, 0> }
        sphere { <0, 0, 0> 1.5 scale <1, 0.75, 1> translate <8.5, 19.1, 21.5> }
        sphere { <0, 0, 0> 1.5 scale <1, 0.75, 1> translate <16, 19.1, 16> }
        sphere { <0, 0, 0> 1.5 scale <1, 0.75, 1> translate <21.5, 19.1, 8.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.4, -4> <28, 20.9, 28> } }
    }
  #end
#end
#macro window_bay3_8(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 57.5, 19.9> }
      box { <-30, -1, -20> <0, 60, 0> rotate 45*y translate <12, 0, -3.9> }
      box { <0, -1, -20> <30, 60, 0> rotate -45*y translate <44, 0, -3.9> }
      difference {
        box { <-2.8, 3.1, -2.8> <58.8, 56.2, 20> }
        box { <-30, -1, -20> <0, 60, 0> rotate 45*y translate <12, 0, -2.8> }
        box { <0, -1, -20> <30, 60, 0> rotate -45*y translate <44, 0, -2.8> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <59.9, 57.5, 19.9> }
        box { <-30, -1, -20> <0, 60, 0> rotate 45*y translate <12, 0, -3.9> }
        box { <0, -1, -20> <30, 60, 0> rotate -45*y translate <44, 0, -3.9> }
        difference {
          box { <-2.8, 3.1, -2.8> <58.8, 56.2, 20> }
          box { <-30, -1, -20> <0, 60, 0> rotate 45*y translate <12, 0, -2.8> }
          box { <0, -1, -20> <30, 60, 0> rotate -45*y translate <44, 0, -2.8> }
        }
        box { <-20.9, 4.8, -10> <-1.8, 19.6, 10> rotate 45*y translate <12, 0, -3.9> }
        box { <-20.9, 22.1, -10> <-1.8, 36.6, 10> rotate 45*y translate <12, 0, -3.9> }
        box { <-20.9, 39.1, -10> <-1.8, 53.6, 10> rotate 45*y translate <12, 0, -3.9> }
        box { <20.9, 4.8, -10> <1.8, 19.6, 10> rotate -45*y translate <44, 0, -3.9> }
        box { <20.9, 22.1, -10> <1.8, 36.6, 10> rotate -45*y translate <44, 0, -3.9> }
        box { <20.9, 39.1, -10> <1.8, 53.6, 10> rotate -45*y translate <44, 0, -3.9> }
        box { <13.8, 4.8, -10> <42.2, 19.6, 10> }
        box { <13.8, 22.1, -10> <42.2, 36.6, 10> }
        box { <13.8, 39.1, -10> <42.2, 53.6, 10> }
        difference {
          box { <3.9, -1, 3.9> <52.1, 59, 20> }
          box { <-30, -2, -20> <0, 60, 0> rotate 45*y translate <12, 0, 3.9> }
          box { <0, -2, -20> <30, 60, 0> rotate -45*y translate <44, 0, 3.9> }
        }
        box { <-2.5, -1, -3> <2.5, 2.000001, 2> rotate 45*y translate <0, 0, 8> }
        box { <-2.5, -1, -3> <2.5, 2.000001, 2> rotate 45*y translate <8, 0, 8> }
        box { <-2.5, -1, -3> <2.5, 2.000001, 2> rotate 45*y translate <8, 0, 0> }
        box { <-2.5, -1, -3> <2.5, 2.000001, 2> rotate -45*y translate <48, 0, 8> }
        box { <-2.5, -1, -3> <2.5, 2.000001, 2> rotate -45*y translate <56, 0, 8> }
        box { <-2.5, -1, -3> <2.5, 2.000001, 2> rotate -45*y translate <48, 0, 0> }
        difference {
          box { <-20, -1, -1.2> <1, 2.000005, 1.2> rotate 45*y translate <12, 0, 0> }
          box { <12, -2, -10> <20, 3, 20> }
          box { <-4, -2, 12> <12, 3, 20> }
        }
        difference {
          box { <20, -1, -1.2> <-1, 2.000005, 1.2> rotate -45*y translate <44, 0, 0> }
          box { <36, -2, -10> <44, 3, 20> }
          box { <44, -2, 12> <60, 3, 20> }
        }
        #if (setting > 1)
          box { <13.6, -1, -2.4> <42.4, 2, 2.4> }
          box { <-2.4, -1, 13.6> <2.4, 2, 18.4> }
          box { <53.6, -1, 13.6> <58.4, 2, 18.4> }
          cylinder { -4*z, -3.4*z, 1.4 translate <14.5, 3, 0> }
          cylinder { -4*z, -3.4*z, 1.4 translate <41.5 3, 0> }
        #end
        difference {
          box { <0, 51, 0> <2, 60, 2> }
          cylinder { 50*y, 61*y, 1.5 }
          translate <2.4, 0, 18.4>
        }
        difference {
          box { <0, 51, 0> <-2, 60, 2> }
          cylinder { 50*y, 61*y, 1.5 }
          translate <53.6, 0, 18.4>
        }
      }
      #if (setting > 1)
        object { pin(1) translate <20, 0, 0> }
        object { pin(1) translate <28, 0, 0> }
        object { pin(1) translate <36, 0, 0> }
      #end
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <0, 57.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <16, 57.5, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <24, 57.5, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <32, 57.5, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <40, 57.5, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*y translate <56, 57.5, 16> }
      #end
      object { open_rounded_button() translate <0, 54.4, 16> }
      object { open_rounded_button() translate <16, 54.4, 0> }
      object { open_rounded_button() translate <24, 54.4, 0> }
      object { open_rounded_button() translate <32, 54.4, 0> }
      object { open_rounded_button() translate <40, 54.4, 0> }
      object { open_rounded_button() translate <56, 54.4, 16> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 59.3, 20> } }
    }
  #end
#end
#macro window_bay3_8_glass(color_tex)
  #if (setting = 0)
    difference {
      box { <-2.7, 3.5, -2.7> <58.7, 55.7, 13.7> }
      box { <-30, -1, -20> <0, 60, 0> rotate 45*y translate <13.5, 0, -2.7> }
      box { <0, -1, -20> <30, 60, 0> rotate -45*y translate <42.5, 0, -2.7> }
      difference {
        box { <-1.7, 3, -1.5> <57.7, 56, 15> }
        box { <-30, -1, -20> <0, 60, 0> rotate 45*y translate <13.5, 0, -1.5> }
        box { <0, -1, -20> <30, 60, 0> rotate -45*y translate <42.5, 0, -1.5> }
      }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-2.7, 3.5, -2.7> <58.7, 55.7, 13.7> }
        box { <-30, -1, -20> <0, 60, 0> rotate 45*y translate <13.5, 0, -2.7> }
        box { <0, -1, -20> <30, 60, 0> rotate -45*y translate <42.5, 0, -2.7> }
        difference {
          box { <-1.7, 3, -1.5> <57.7, 56, 15> }
          box { <-30, -1, -20> <0, 60, 0> rotate 45*y translate <13.5, 0, -1.5> }
          box { <0, -1, -20> <30, 60, 0> rotate -45*y translate <42.5, 0, -1.5> }
        }
      }
      #if (setting > 1)
        cylinder { -2*z, -0.5*z, 0.5 translate <16, 21, 0> }
        cylinder { -2*z, -0.5*z, 0.5 translate <16, 38.75, 0> }
        cylinder { -2*z, -0.5*z, 0.5 translate <40, 21, 0> }
        cylinder { -2*z, -0.5*z, 0.5 translate <40, 38.75, 0> }
        sphere { <16, 21, -0.5> 0.25 }
        sphere { <16, 38.75, -0.5> 0.25 }
        sphere { <40, 21, -0.5> 0.25 }
        sphere { <40, 38.75, -0.5> 0.25 }
      #end
      texture { color_tex }
      bounded_by { box { <-2.8, 3.4, -2.8> <58.8, 55.8, 13.8> } }
    }
  #end
#end
#macro window_glass1_2(color_tex)
  #if (setting = 0)
    box { <-1, 6.5, -3.9> <9, 17.6, 4> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -3.89999*z, -2.40002*z, 1.4 translate <0.5, 8, 0> }
        cylinder { -3.89999*z, -2.40002*z, 1.4 translate <7.5, 8, 0> }
        cylinder { -3.89999*z, -2.40002*z, 1.4 translate <0.5, 16.1, 0> }
        cylinder { -3.89999*z, -2.40002*z, 1.4 translate <7.5, 16.1, 0> }
        box { <0.49999, 6.59999, -3.89999> <7.50001, 17.50001, -2.40001> }
        box { <-0.90001, 7.99999, -3.89998> <8.90001, 16.00001, -2.4> }
        box { <-2.9, 4.2, -2.40002> <10.9, 17.5, -1.2> }
        box { <-1.9, 3.2, -2.39999> <9.9, 18.5, -1.20001> }
        cylinder { -1.19999*z, -2.45003*z, 1 translate <-1.9, 4.2, 0> }
        cylinder { -1.19999*z, -2.45003*z, 1 translate <9.9, 4.2, 0> }
        cylinder { -1.19999*z, -2.45003*z, 1 translate <-1.9, 17.5, 0> }
        cylinder { -1.19999*z, -2.45003*z, 1 translate <9.9, 17.5, 0> }
        #if (setting > 1)
          sphere { <4, 18.5, -1.8> 0.7 }
          sphere { <1.5, 3.2, -1.8> 0.7 }
          sphere { <6.5, 3.2, -1.8> 0.7 }
        #end
      }
      box { <-4, 0, -1.19998> <12, 10, 0> }
      cylinder { -2.25002*z, 0*z, 0.5 translate <0.5, 8, 0> }
      cylinder { -2.25002*z, 0*z, 0.5 translate <7.5, 8, 0> }
      cylinder { -2.25002*z, 0*z, 0.5 translate <0.5, 16.1, 0> }
      cylinder { -2.25002*z, 0*z, 0.5 translate <7.5, 16.1, 0> }
      box { <-0.00001, 7.99999, -2.25001> <8.00001, 16.10001, 0> }
      box { <0.5, 7.5, -2.25> <7.5, 16.6, 0> }
      texture { color_tex }
      bounded_by { box { <-4, 2, -4> <12, 19.3, 0> } }
    }
  #end
#end
#macro window_shield(color_tex)
  #if (setting = 0)
    difference {
      box { <-26.4, -39.95, -3.9> <0, 1.55, 27.9> }
      box { <-15, -100, -6> <3.5, 100, 30> rotate 45*z translate <-29.90001, -31.7, 0.00001> }
      box { <-15, -100, -6> <3.5, 100, 30> rotate -27.5*z translate <-29.90001, -22, 0.00003> }
      box { <-15, -100, -6> <3.5, 100, 30> rotate -68.5*z translate <-1.55001, 1.55, 0.00004> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-29.9, -39.95, -3.9> <0, 1.55, 27.9> }
          box { <0, 0.55001, -2.39998> <1.25, 1.55003, 26.39998> }
        }
        box { <-14.1, -40, -4> <3, -33, 28> }
        box { <-21.5, -40, 4> <-13, -33, 20> }
        box { <-2.00001, -3, -1.50001> <5, 0, 10.19999> }
        box { <-2.00001, -3, 13.80001> <5, 0, 25.49999> }
        #if (setting > 1)
          box { <-19.00001, -40, -2.4> <-15.6, -37.95, 2.4> }
          box { <-19.00001, -40, 21.6> <-15.6, -37.95, 26.4> }
          cylinder { -40*y, -37.95*y, 2.4 translate <-19, 0, 0> }
          cylinder { -40*y, -37.95*y, 2.4 translate <-19, 0, 24> }
          box { <-21.40001, -40, -0.00001> <-18.99999, -37.95, 2.40001> }
          box { <-21.40001, -40, 21.60001> <-18.99999, -37.95, 24.00001> }
        #end
        box { <-2.00001, -35, -5> <5, -1.55, 29> }
        difference {
          box { <0, -2, -4> <5, 2, 28> }
          cylinder { -5*z, 29*z, 1.55 }
        }
        box { <-1.55, -3, -5> <5, 5, -2.39997> }
        box { <-1.55, -3, 3.2> <5, 5, 4.8> }
        box { <-1.55, -3, 11.2> <5, 5, 12.8> }
        box { <-1.55, -3, 19.2> <5, 5, 20.8> }
        box { <-1.55, -3, 26.39997> <5, 5, 29> }
        difference {
          box { <-15, -100, -6> <3.5, 100, 30> }
          box { <0, -101, -0.4> <4, 101, 24.4> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.40001> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.40001> }
          rotate 45*z
          translate <-29.90001, -31.7, 0.00001>
        }
        difference {
          box { <-15, -100, -6> <3.5, 100, 30> }
          box { <0, -101, -0.4> <4, 101, 24.4> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.40001> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.40001> }
          translate <-29.90001, -30, 0.00002>
        }
        difference {
          box { <-15, -100, -6> <3.5, 100, 30> }
          box { <0, -101, -0.4> <4, 101, 24.4> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.40001> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.40001> }
          rotate -27.5*z
          translate <-29.90001, -22, 0.00003>
        }
        difference {
          box { <-15, -100, -6> <3.5, 100, 30> }
          box { <0, -101, -0.4> <4, 101, 24.4> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.40001> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.40001> }
          rotate -68.5*z
          translate <-1.55001, 1.55, 0.00004>
        }
        difference {
          box { <-29.9, -36.85, -4> <10, 0.55, 28> }
          difference {
            box { <-20, -100, -6> <2.5, 100, 30> }
            box { <0, -101, -0.4> <4, 101, 24.4> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, -0.40001> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, 24.40001> }
            rotate 45*z
            translate <-28.90001, -31.7, 0.00005>
          }
          difference {
            box { <-20, -100, -6> <2.5, 100, 30> }
            box { <0, -101, -0.4> <4, 101, 24.4> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, -0.40001> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, 24.40001> }
            translate <-28.90001, -30, 0.00006>
          }
          difference {
            box { <-20, -100, -6> <2.5, 100, 30> rotate 2*z }
            box { <0, -101, -0.4> <4, 101, 24.4> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, -0.40001> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, 24.40001> }
            rotate -27.5*z
            translate <-28.90001, -22, 0.00007>
          }
          difference {
            box { <-20, -100, -6> <2.5, 100, 30> }
            box { <0, -101, -0.4> <4, 101, 24.4> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, -0.40001> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, 24.40001> }
            rotate -68.5*z
            translate <-0.55001, 1.55, 0.00004>
          }
        }
      }
      #if (setting > 1)
        box { <-21.45, -39.950001, -0.5> <-20.5, -37.9, 0.5> }
        box { <-21.45, -39.950001, 23.5> <-20.5, -37.9, 24.5> }
      #end
      difference {
        merge {
          box { <-10, -1.54999, -2.99999> <0, 1.6, -2.00001> }
          box { <-10, -1.54999, 10.20001> <0, 1.6, 11.19999> }
          box { <-10, -1.54999, 12.80001> <0, 1.6, 13.79999> }
          box { <-10, -1.54999, 26.00001> <0, 1.6, 26.99999> }
          cylinder { -3*z, -2*z, 1.54999 }
          cylinder { 10.2*z, 11.2*z, 1.54999 }
          cylinder { 12.8*z, 13.8*z, 1.54999 }
          cylinder { 26*z, 27*z, 1.54999 }
        }
        box { <-50, 0, -10> <50, 20, 30> rotate 20*z translate <0, 1.5, 0> }
        difference {
          box { <-15, -100, -6> <3.5, 100, 30> }
          box { <0, -101, -0.4> <4, 101, 24.4> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.40001> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.40001> }
          rotate -68.5*z
          translate <-1.55001, 1.55, 0.00004>
        }
      }
      texture { color_tex }
      bounded_by { box { <-31, -40.05, -4> <2, 1.65, 28> } }
    }
  #end
#end
#macro window_shield10(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 19.1, 27.9> }
      box { <3.9, -1, 3.9> <13, 20, 20.1> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 19.1, 27.9> }
        box { <-2.9, 3.1, -2.4> <12, 17.6, 26.4> }
        difference {
          box { <-15, -100, -6> <3.5, 100, 30> }
          box { <0, -101, -0.4> <4, 101, 24.4> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.400001> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.400001> }
          translate <-3.900001, 0, 0>
        }
        box { <3.9, -1, 3.9> <13, 4, 20.1> }
        cylinder { -1*y, 4*y, 4 translate <11.9, 0, 4> }
        cylinder { -1*y, 4*y, 4 translate <11.9, 0, 20> }
        #if (setting > 1)
          cylinder { -1*y, 2*y, 1.4 translate <-1, 0, -1> }
          cylinder { -1*y, 2*y, 1.4 translate <-1, 0, 25> }
          box { <-1, -2, -2.4> <10.4, 2.000001, 2.4> }
          box { <-1, -2, 21.6> <10.4, 2.000002, 26.4> }
          box { <-2.4, -1, -1> <2.4, 2, 25> }
        #end
        difference {
          box { <4, 16, -2.4> <15, 20, 26.4> }
          cylinder { 15*y, 20*y, 5 translate <7.25, 0, -2> }
          cylinder { 15*y, 20*y, 5 translate <7.25, 0, 26> }
          box { <3, 15, -5> <7.25, 20, 3> }
          box { <3, 15, 21> <7.25, 20, 33> }
        }
      }
      object { open_rounded_button() translate <0, 16, 0> }
      object { open_rounded_button() translate <0, 16, 8> }
      object { open_rounded_button() translate <0, 16, 16> }
      object { open_rounded_button() translate <0, 16, 24> }
      object { open_rounded_button() translate <8, 16, 0> }
      object { open_rounded_button() translate <8, 16, 24> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 24> }
      #end
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
        object { pin(1) translate <0, 0, 4> }
        object { pin(1) translate <0, 0, 12> }
        object { pin(1) translate <0, 0, 20> }
        object { pin(1) translate <4, 0, 24> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 20.9, 28> } }
    }
  #end
#end
#macro window_shield11(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 38.3, 27.9> }
      box { <0, -50, -10> <20, 0, 30> rotate -22.8*z translate <19.9, 37.1, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <19.9, 38.3, 27.9> }
        box { <-4, 34, 4> <12, 39, 20> }
        box { <-4, -1, 4> <4, 4, 20> }
        box { <0, -50, -10> <20, 0, 30> rotate -22.8*z translate <19.9, 37.1, 0> }
        difference {
          box { <-4, 2, -2.4> <18.5, 36.8, 26.4> }
          box { <0, -50, -10> <20, 0, 30> rotate -22.8*z translate <18.4, 35.6, 0> }
        }
        #if (setting > 1)
          cylinder { -1*y, 3*y, 2.5 }
          cylinder { -1*y, 3*y, 2.5 translate <0, 0, 24> }
        #end
      }
      object { open_rounded_button() translate <0, 35.2, 0> }
      object { open_rounded_button() translate <8, 35.2, 0> }
      object { open_rounded_button() translate <0, 35.2, 24> }
      object { open_rounded_button() translate <8, 35.2, 24> }
      object { open_rounded_button() translate <16, 35.2, 0> }
      object { open_rounded_button() translate <16, 35.2, 8> }
      object { open_rounded_button() translate <16, 35.2, 16> }
      object { open_rounded_button() translate <16, 35.2, 24> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <0, 38.3, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <8, 38.3, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <0, 38.3, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <8, 38.3, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <16, 38.3, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <16, 38.3, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <16, 38.3, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <16, 38.3, 24> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 40.1, 28> } }
    }
  #end
#end
#macro window_shield12(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 19.1, 43.9> }
      box { <-20, -100, -6> <0, 100, 50> rotate -26.5*z translate <-3.9, 3.1, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 19.1, 43.9> }
        difference {
          box { <-3, 3.1, -2.4> <12, 17.8, 42.4> }
          difference {
            box { <-20, -100, -6> <3.5, 100, 46> }
            box { <0, -101, -0.4> <4, 101, 40.4> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, -0.400001> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, 40.400001> }
            rotate -26.5*z
            translate <-2.9, 3.1, 0>
          }
        }
        difference {
          box { <-15, -100, -6> <3.5, 100, 46> }
          box { <0, -101, -0.4> <4, 101, 40.4> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.400001> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 40.400001> }
          translate <-3.900001, 5, 0>
        }
        difference {
          difference {
            box { <-15, -100, -6> <3.5, 100, 46> }
            box { <0, -101, -0.4> <4, 101, 40.4> }
            cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.400001> }
            cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 40.400001> }
            rotate -26.5*z
            translate <-3.9, 3.1, 0.000001>
          }
          box { <-4, -1, -4> <20, 2.00001, 28> }
        }
        box { <3.9, -1, 3.9> <13, 4, 36.1> }
        #if (setting > 1)
          cylinder { -1*y, 2*y, 1.5 translate <-1, 0, -1> }
          cylinder { -1*y, 2*y, 1.5 translate <-1, 0, 41> }
          box { <-1, -2, -2.4> <10.5, 2.000001, 2.4> }
          box { <-1, -2, 37.6> <10.5, 2.000002, 42.4> }
          box { <-2.4, -1, -1> <2.4, 2, 41> }
        #end
      }
      object { open_rounded_button() translate <8, 16, 0> }
      object { open_rounded_button() translate <8, 16, 8> }
      object { open_rounded_button() translate <8, 16, 16> }
      object { open_rounded_button() translate <8, 16, 24> }
      object { open_rounded_button() translate <8, 16, 32> }
      object { open_rounded_button() translate <8, 16, 40> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 32> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 40> }
      #end
      #if (setting > 1)
        object { pin(1) translate <0, 0, 4> }
        object { pin(1) translate <0, 0, 12> }
        object { pin(1) translate <0, 0, 20> }
        object { pin(1) translate <0, 0, 28> }
        object { pin(1) translate <0, 0, 36> }
        object { pin(1) translate <4, 0, 0> }
        object { pin(1) translate <4, 0, 40> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 20.9, 44> } }
    }
  #end
#end
#macro window_shield13(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 19.1, 27.9> }
      box { <-20, -100, -6> <0, 100, 30> rotate 21*z translate <-3.9, 19.1, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 19.1, 27.9> }
        difference {
          box { <-3, 1.5, -2.4> <12, 18.2, 26.4> }
          difference {
            box { <-20, -100, -6> <3.5, 100, 30> }
            box { <0, -101, -0.4> <4, 101, 24.4> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, -0.400001> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, 24.400001> }
            rotate 21*z
            translate <-2.9, 18.2, 0>
          }
        }
        difference {
          box { <-15, -100, -6> <3.5, 100, 30> }
          box { <0, -101, -0.4> <4, 101, 24.4> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.400001> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.400001> }
          translate <-3.900001, 5, 0>
        }
        difference {
          box { <-15, -100, -6> <3.5, 100, 30> }
          box { <0, -101, -0.4> <4, 101, 24.4> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.400001> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.400001> }
          rotate 21*z
          translate <-3.9, 18.2, 0.000001>
        }
        box { <3.9, -1, 3.9> <13, 4, 20.1> }
        #if (setting > 1)
          cylinder { -1*y, 4*y, 2.5 translate <8, 0, 0> }
          cylinder { -1*y, 4*y, 2.5 translate <8, 0, 24> }
        #end
        difference {
          box { <3.9, 16, -2.5> <15, 20, 26.5> }
          cylinder { 15*y, 21*y, 5 translate <7.25, 0, -2.3> }
          cylinder { 15*y, 21*y, 5 translate <7.25, 0, 26.3> }
          box { <3, 15, -5> <7.250001, 21, 2.7> }
          box { <3, 15, 21.3> <7.250001, 21, 33> }
        }
      }
      object { open_rounded_button() translate <0, 16, 0> }
      object { open_rounded_button() translate <0, 16, 8> }
      object { open_rounded_button() translate <0, 16, 16> }
      object { open_rounded_button() translate <0, 16, 24> }
      object { open_rounded_button() translate <8, 16, 0> }
      object { open_rounded_button() translate <8, 16, 24> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 19.1, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <8, 19.1, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 20.9, 28> } }
    }
  #end
#end
#macro window_shield14(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <59.9, 28.7, 43.9> }
      box { <-70, 0, -10> <0, 30, 44> rotate 25.5*z translate <52, 28.7, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <59.9, 28.7, 43.9> }
        box { <-50, -10, -50> <0, 30, 0> rotate 26.6*y translate <12, 0, -4> }
        box { <-50, -10, 0> <0, 30, 50> rotate -26.6*y translate <12, 0, 44> }
        box { <-4, 0, -20> <60, 20, 20> rotate -43.5*x translate <0, 28.7, 4> }
        box { <-4, 0, -20> <60, 20, 20> rotate 43.5*x translate <0, 28.7, 36> }
        box { <-70, 0, -20> <0, 20, 20> rotate -41*x rotate 25.5*z translate <52, 28.7, 4> }
        box { <-70, 0, -20> <0, 20, 20> rotate 41*x rotate 25.5*z translate <52, 28.7, 36> }
        box { <-70, 0, -10> <0, 30, 44> rotate 25.5*z translate <52, 28.7, 0> }
        cylinder { -1*y, 2*y, 2.4 }
        cylinder { -1*y, 2*y, 2.4 translate <0, 0, 40> }
        box { <-2.5, -1, -3> <2.5, 2.000001, 1> rotate 26.6*y translate <8, 0, 0> }
        box { <-2.5, -1, -1> <2.5, 2.000001, 3> rotate -26.6*y translate <8, 0, 40> }
        difference {
          box { <58.9, -1, -5> <61, 1, 45> }
          cylinder { -4*z, 44*z, 1 translate <58.9, 1, 0> }
        }
        difference {
          box { <-2.4, -1, -2.4> <60, 27.2, 42.4> }
          box { <-50, -10, -50> <0, 30, 0> rotate 26.6*y translate <12, 0, -2.5> }
          box { <-50, -10, 0> <0, 30, 50> rotate -26.6*y translate <12, 0, 42.5> }
          box { <-4, 0, -20> <60, 20, 20> rotate -43.5*x translate <0, 27.2, 4> }
          box { <-4, 0, -20> <60, 20, 20> rotate 43.5*x translate <0, 27.2, 36> }
          box { <-70, 0, -20> <0, 20, 20> rotate -41*x rotate 25.5*z translate <52, 27.2, 4> }
          box { <-70, 0, -20> <0, 20, 20> rotate 41*x rotate 25.5*z translate <52, 27.2, 36> }
          box { <-70, 0, -10> <0, 30, 44> rotate 25.5*z translate <52, 27.2, 0> }
          difference {
            box { <-4, -1, -4> <20, 3.1, 44> }
            cylinder { -2*y, 4*y, 3 translate <6.5, 0, 6.5> }
            cylinder { -2*y, 4*y, 3 translate <6.5, 0, 33.5> }
            box { <3.5, -2, 6.5> <21, 4, 33.5> }
            box { <6.5, -2, 3.5> <21, 4, 36.5> }
            difference {
              box { <17, -2, 0.5> <21, 4, 4> }
              cylinder { -3*y, 4*y, 3 translate <17, 0, 0.5> }
            }
            difference {
              box { <17, -2, 36> <21, 4, 39.5> }
              cylinder { -3*y, 4*y, 3 translate <17, 0, 39.5> }
            }
            #if (setting > 1)
              cylinder { -2*y, 1.999998*y, 1.8 translate <17, 0, 0.5> }
              cylinder { -2*y, 1.999998*y, 1.8 translate <17, 0, 39.5> }
              box { <-5, -2, -5> <17, 1.999999, 2.3> }
              box { <-5, -2, -5> <18.8, 2.000002, 0.5> }
              box { <-5, -2, 37.7> <17, 1.999999, 44> }
              box { <-5, -2, 39.5> <18.8, 2.000002, 44> }
              difference {
                box { <-5, -2, 0> <6.5, 2.000001, 40> }
                cylinder { -3*y, 4*y, 4.2 translate <6.5, 0, 6.5> }
                cylinder { -3*y, 4*y, 4.2 translate <6.5, 0, 33.5> }
                box { <2.3, -3, 6.5> <7, 4, 33.5> }
              }
            #end
          }
        }
      }
      object { open_rounded_button() translate <56, 25.6, 8> }
      object { open_rounded_button() translate <56, 25.6, 16> }
      object { open_rounded_button() translate <56, 25.6, 24> }
      object { open_rounded_button() translate <56, 25.6, 32> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <56, 28.7, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <56, 28.7, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <56, 28.7, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <56, 28.7, 32> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <60, 30.5, 44> } }
    }
  #end
#end
#macro window_shield16(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 12.7, 27.9> }
      box { <-20, -100, -6> <0, 100, 30> rotate -39*z translate <-3.9, 3.1, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <19.9, 12.7, 27.9> }
        difference {
          box { <-3, 3.1, -2.4> <20, 11.4, 26.4> }
          difference {
            box { <-20, -100, -6> <3.5, 100, 30> }
            box { <0, -101, -0.4> <4, 101, 24.4> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, -0.400001> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, 24.400001> }
            rotate -54.25*z
            translate <-2.9, 2, 0>
          }
        }
        difference {
          box { <-15, -100, -6> <3.5, 100, 30> }
          box { <0, -101, -0.4> <4, 101, 24.4> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.400001> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.400001> }
          translate <-3.900001, 5, 0>
        }
        difference {
          difference {
            box { <-15, -100, -6> <3.5, 100, 30> }
            box { <0, -101, -0.4> <4, 101, 24.4> }
            cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.400001> }
            cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.400001> }
            rotate -54.25*z
            translate <-3.9, 2, 0.000001>
          }
          box { <-4, -1, -4> <20, 2.00001, 28> }
        }
        box { <4, -1, -2.400001> <29, 4, 26.400001> }
        #if (setting > 1)
          cylinder { -1*y, 2*y, 1.5 translate <-1, 0, -1> }
          cylinder { -1*y, 2*y, 1.5 translate <-1, 0, 25> }
          box { <-1.000001, -1, -2.4> <2.4, 2, 26.4> }
          box { <-2.4, -1, -1.000001> <2.4, 2.000001, 25.000001> }
        #end
        difference {
          box { <11.9, 10, -2.400002> <23, 13, 26.400002> }
          cylinder { 9*y, 14*y, 5 translate <15.25, 0, -2.3> }
          cylinder { 9*y, 14*y, 5 translate <15.25, 0, 26.3> }
          box { <4, 9, -5> <15.250001, 14, 2.7> }
          box { <4, 9, 21.3> <15.250001, 14, 33> }
        }
        difference {
          box { <18.9, -1, -5> <21, 1, 29> }
          cylinder { -6*z, 30*z, 1 translate <18.9, 1, 0> }
        }
      }
      object { open_rounded_button() translate <16, 9.6, 0> }
      object { open_rounded_button() translate <16, 9.6, 24> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <16, 12.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <16, 12.7, 24> }
      #end
      #if (setting > 1)
        object { pin(1) translate <0, 0, 4> }
        object { pin(1) translate <0, 0, 12> }
        object { pin(1) translate <0, 0, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 14.5, 28> } }
    }
  #end
#end
#macro window_shield2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 19.1, 27.9> }
      box { <-20, -100, -6> <0, 100, 30> rotate -26.5*z translate <-3.9, 3.1, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <11.9, 19.1, 27.9> }
        difference {
          box { <-3, 3.1, -2.4> <12, 17.8, 26.4> }
          difference {
            box { <-20, -100, -6> <3.5, 100, 30> }
            box { <0, -101, -0.4> <4, 101, 24.4> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, -0.400001> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, 24.400001> }
            rotate -26.5*z
            translate <-2.9, 3.1, 0>
          }
        }
        difference {
          box { <-15, -100, -6> <3.5, 100, 30> }
          box { <0, -101, -0.4> <4, 101, 24.4> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.400001> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.400001> }
          translate <-3.900001, 5, 0>
        }
        difference {
          difference {
            box { <-15, -100, -6> <3.5, 100, 30> }
            box { <0, -101, -0.4> <4, 101, 24.4> }
            cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.400001> }
            cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.400001> }
            rotate -26.5*z
            translate <-3.9, 3.1, 0.000001>
          }
          box { <-4, -1, -4> <12, 2.00001, 28> }
        }
        box { <3.9, -1, 3.9> <13, 4, 20.1> }
        cylinder { -1*y, 4*y, 4 translate <11.9, 0, 4> }
        cylinder { -1*y, 4*y, 4 translate <11.9, 0, 20> }
        #if (setting > 1)
          cylinder { -1*y, 2*y, 1.5 translate <-1, 0, -1> }
          cylinder { -1*y, 2*y, 1.5 translate <-1, 0, 25> }
          box { <-1, -1, -2.4> <10.5, 2.000001, 2.4> }
          box { <-1, -1, 21.6> <10.5, 2.000002, 26.4> }
          box { <-2.4, -1, -1> <2.4, 2, 25> }
        #end
        difference {
          box { <4.9, 16, -2.5> <15, 20, 26.5> }
          cylinder { 15*y, 21*y, 5 translate <7.25, 0, -2.3> }
          cylinder { 15*y, 21*y, 5 translate <7.25, 0, 26.3> }
          box { <4, 15, -5> <7.250001, 21, 2.7> }
          box { <4, 15, 21.3> <7.250001, 21, 33> }
        }
      }
      object { open_rounded_button() translate <8, 16, 0> }
      object { open_rounded_button() translate <8, 16, 24> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 19.1, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 19.1, 24> }
      #end
      #if (setting > 1)
        object { pin(1) translate <4, 0, 0> }
        object { pin(1) translate <0, 0, 4> }
        object { pin(1) translate <0, 0, 12> }
        object { pin(1) translate <0, 0, 20> }
        object { pin(1) translate <4, 0, 24> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 20.9, 28> } }
    }
  #end
#end
#macro window_shield3(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <19.9, 12.7, 27.9> }
      box { <-20, -100, -6> <0, 100, 30> rotate -39*z translate <-3.9, 3.1, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <19.9, 12.7, 27.9> }
        difference {
          box { <-3, 3.1, -2.4> <20, 11.4, 26.4> }
          difference {
            box { <-20, -100, -6> <3.5, 100, 30> }
            box { <0, -101, -0.4> <4, 101, 24.4> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, -0.400001> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, 24.400001> }
            rotate -39*z
            translate <-2.9, 3.1, 0>
          }
        }
        difference {
          box { <-15, -100, -6> <3.5, 100, 30> }
          box { <0, -101, -0.4> <4, 101, 24.4> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.400001> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.400001> }
          translate <-3.900001, 5, 0>
        }
        difference {
          difference {
            box { <-15, -100, -6> <3.5, 100, 30> }
            box { <0, -101, -0.4> <4, 101, 24.4> }
            cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.400001> }
            cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.400001> }
            rotate -39*z
            translate <-3.9, 3.1, 0.000001>
          }
          box { <-4, -1, -4> <20, 2.00001, 28> }
        }
        box { <4, -1, -2.400001> <29, 4, 26.400001> }
        #if (setting > 1)
          cylinder { -1*y, 2*y, 1.5 translate <-1, 0, -1> }
          cylinder { -1*y, 2*y, 1.5 translate <-1, 0, 25> }
          box { <-1.000001, -1, -2.4> <2.4, 2, 26.4> }
          box { <-2.4, -1, -1.000001> <2.4, 2.000001, 25.000001> }
        #end
        difference {
          box { <4.9, 10, -2.400002> <23, 13, 26.400002> }
          cylinder { 9*y, 14*y, 5 translate <7.25, 0, -2.3> }
          cylinder { 9*y, 14*y, 5 translate <7.25, 0, 26.3> }
          box { <4, 9, -5> <7.250001, 14, 2.7> }
          box { <4, 9, 21.3> <7.250001, 14, 33> }
        }
        difference {
          box { <18.9, -1, -5> <21, 1, 29> }
          cylinder { -6*z, 30*z, 1 translate <18.9, 1, 0> }
        }
        difference {
          box { <18.9, 11.7, -5> <21, 12.9, 29> }
          cylinder { -6*z, 30*z, 1 translate <18.9, 11.7, 0> }
        }
      }
      object { open_rounded_button() translate <8, 9.6, 0> }
      object { open_rounded_button() translate <8, 9.6, 24> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 12.7, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 12.7, 24> }
      #end
      #if (setting > 1)
        object { pin(1) translate <0, 0, 4> }
        object { pin(1) translate <0, 0, 12> }
        object { pin(1) translate <0, 0, 20> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <20, 14.5, 28> } }
    }
  #end
#end
#macro window_shield4(color_tex)
  #if (setting = 0)
    difference {
      box { <-30.3, -27.15, -3.9> <1.55, 1.55, 27.9> }
      box { <-50, 0, -10> <50, 50, 50> rotate 49*z translate <-30.3, -24.05, 0> }
      box { <-50, -50, -10> <0, 50, 50> rotate -65*z translate <0, 1.55, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-30.3, -27.15, -3.9> <1.55, 1.55, 27.9> }
        box { <-50, 0, -10> <50, 50, 50> rotate 49*z translate <-30.3, -24.05, 0> }
        box { <-50, -50, -10> <0, 50, 50> rotate -65*z translate <0, 1.55, 0> }
        difference {
          box { <-28.8, -28, -2.4> <2, 0, 26.4> }
          box { <-50, 0, -10> <50, 50, 50> rotate 49*z translate <-28.8, -25.1, 0> }
          box { <-50, -50, -10> <0, 50, 50> rotate -65*z translate <0, 0.5, 0> }
        }
        difference {
          box { <0, 0, -4> <2, 2, 28> }
          cylinder { -5*z, 29*z, 1.55 }
        }
        difference {
          box { <0.55, -28, -4> <2, -26.15, 28> }
          cylinder { -5*z, 29*z, 1 translate <0.55, -26.15, 0> }
        }
        cylinder { -5*z, -2.45*z, 1.55 }
        box { <0, -1.55, -5> <2, 2, -2.45> }
        box { <-1.5, 0, -5> <1.75, 2, -2.45> rotate 25*z }
        box { <-1.5, -2, 3.2> <1.75, 2, 4.8> rotate 25*z }
        box { <-1.5, -2, 11.2> <1.75, 2, 12.8> rotate 25*z }
        box { <-1.5, -2, 19.2> <1.75, 2, 20.8> rotate 25*z }
        box { <-1.5, 0, 26.45> <1.75, 2, 29> rotate 25*z }
        box { <0, -1.55, 26.45> <2, 2, 29> }
        cylinder { 26.45*z, 29*z, 1.55 }
      }
      difference {
        merge {
          cylinder { -2.45*z, -1.5*z, 1.549999 }
          cylinder { 10.2*z, 11.2*z, 1.549999 }
          cylinder { 12.8*z, 13.8*z, 1.549999 }
          cylinder { 25.5*z, 26.45*z, 1.549999 }
        }
        box { <-50, -50, -10> <0, 50, 50> rotate -65*z translate <0, 1.35, 0> }
      }
      box { <-2, -1.549999, -2.499999> <0, 1.399999, -1.500001> rotate 25*z }
      box { <-2, -1.549999, 10.200001> <0, 1.399999, 11.199999> rotate 25*z }
      box { <-2, -1.549999, 12.800001> <0, 1.399999, 13.799999> rotate 25*z }
      box { <-2, -1.549999, 25.500001> <0, 1.399999, 26.449999> rotate 25*z }
      texture { color_tex }
      bounded_by { box { <-30.7, -27.25, -4> <1.65, 1.65, 28> } }
    }
  #end
#end
#macro window_shield5(color_tex)
  #if (setting = 0)
    difference {
      box { <-46.3, -17.55, -3.9> <1.55, 1.55, 27.9> }
      box { <-50, 0, -10> <50, 50, 30> rotate 27.6*z translate <-14, 1.55, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-46.3, -17.55, -3.9> <1.55, 1.55, 27.9> }
        #if (setting > 3)
          object { llogo() rotate 180*y translate <-2, 1.55, 0> }
          object { llogo() rotate 180*y translate <-2, 1.55, 8> }
          object { llogo() rotate 180*y translate <-2, 1.55, 16> }
          object { llogo() rotate 180*y translate <-2, 1.55, 24> }
        #end
      }
      box { <-50, 0, -10> <50, 50, 30> rotate 27.6*z translate <-14, 1.55, 0> }
      difference {
        box { <-44.8, -18, -2.4> <-3, 0, 26.4> }
        box { <-50, 0, -10> <50, 50, 30> rotate 27.6*z translate <-14, 0.5, 0> }
      }
      box { <-44.800001, -18, -2.399999> <2, -15.55, 26.399999> }
      box { <-3.500001, -17, -2.400002> <2, -1.55, 26.400002> }
      difference {
        box { <0, -1.550001, -4.000001> <2, 1.550001, 28.000001> }
        cylinder { -2.4*z, 26.4*z, 1.550001 }
      }
      difference {
        box { <0, -18, -6> <2, -16, 30> }
        cylinder { -5*z, 29*z, 1.55 translate <0, -16, 0> }
      }
      #if (setting > 1)
        box { <-2, -1.55, -4> <2, 2, -2.400001> }
        box { <-2, -1.55, 26.400001> <2, 2, 28> }
        box { <-1.5, -2, 3.2> <1.6, 2, 4.8> }
        box { <-1.5, -2, 11.2> <1.6, 2, 12.8> }
        box { <-1.5, -2, 19.2> <1.6, 2, 20.8> }
        box { <-4.000001, -5, -1> <0, 0, 1.7> }
        box { <-4.000001, -5, 6.3> <0, 0, 9.7> }
        box { <-4.000001, -5, 14.3> <0, 0, 17.7> }
        box { <-4.000001, -5, 22.3> <0, 0, 25> }
      #end
      texture { color_tex }
      bounded_by { box { <-46.4, -17.65, -4> <1.65, 1.65, 28> } }
    }
  #end
#end
#macro window_shield6(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <43.9, 12.7, 27.9> }
      box { <-50, 0, -10> <50, 50, 30> rotate 24.5*z translate <20, 12.7, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        difference {
          box { <-3.9, 0, -3.9> <43.9, 12.7, 27.9> }
          box { <-50, 0, -10> <50, 50, 30> rotate 24.5*z translate <20, 12.7, 0> }
          box { <-50, -10, -20> <50, 20, 0> rotate 18.4*y translate <20, 0, -4> }
          box { <-50, -10, 0> <50, 20, 20> rotate -18.4*y translate <20, 0, 28> }
          box { <-80, 0, -40> <80, 50, 40> rotate -51.25*x rotate 24.5*z translate <44, 12.7, -4> }
          box { <-80, 0, -40> <80, 50, 40> rotate 51.25*x rotate 24.5*z translate <44, 12.7, 28> }
        }
        #if (setting > 1)
          cylinder { -1*y, 2*y, 2.5 translate <24, 0, 0> }
          cylinder { -1*y, 2*y, 2.5 translate <24, 0, 24> }
          cylinder { -1*y, 2*y, 2.5 translate <0, 0, 8> }
          cylinder { -1*y, 2*y, 2.5 translate <0, 0, 16> }
        #end
        difference {
          box { <0, -1, -2.4> <44, 11.8, 26.4> }
          box { <-50, 0, -10> <50, 50, 30> rotate 24.5*z translate <20, 10.7, 0> }
          box { <-50, -10, -20> <50, 20, 0> rotate 18.4*y translate <20, 0, -2.7> }
          box { <-50, -10, 0> <50, 20, 20> rotate -18.4*y translate <20, 0, 26.7> }
          box { <-80, 0, -40> <80, 50, 40> rotate -51.25*x rotate 24.5*z translate <44, 10.7, -4> }
          box { <-80, 0, -40> <80, 50, 40> rotate 51.25*x rotate 24.5*z translate <44, 10.7, 28> }
          box { <0, -2, -4> <24.000001, 1.9, 4> }
          box { <0, -2, 0> <4, 1.9, 24> }
          cylinder { -2*y, 1.9*y, 4 translate <24, 0, 0> }
          box { <23.999999, -2, -4> <28, 1.9, 0> }
          box { <0, -2, 20> <24, 1.9, 28> }
          cylinder { -2*y, 1.9*y, 4 translate <24, 0, 24> }
          box { <23.999999, -2, 24> <28, 1.9, 28> }
        }
        box { <28.000001, 10, 5.5> <45, 13, 18.5> }
        cylinder { 10*y, 13*y, 4 translate <32, 0, 5.500001> }
        cylinder { 10*y, 13*y, 4 translate <32, 0, 18.500001> }
        difference {
          box { <30.5, 10, -4> <45, 13, 8> }
          box { <20, 9, -5> <50, 14, -2.399997> }
          box { <-50, -10, -20> <50, 20, 0> rotate 18.4*y translate <44, 0, -2.7> }
        }
        difference {
          box { <30.5, 10, 16> <45, 13, 28> }
          box { <20, 9, 26.399997> <50, 14, 29> }
          box { <-50, -10, 0> <50, 20, 20> rotate -18.4*y translate <44, 0, 26.7> }
        }
      }
      object { open_rounded_button() translate <24, 9.6, 8> }
      object { open_rounded_button() translate <24, 9.6, 16> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <24, 12.7, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 180*y translate <24, 12.7, 16> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <44, 14.5, 28> } }
    }
  #end
#end
#macro window_shield7(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
      box { <-20, -100, -6> <0, 100, 30> rotate -46*z translate <-3.9, 3.1, 0> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 9.5, 27.9> }
        difference {
          box { <-3, 1.899999, -2.4> <28, 8, 26.4> }
          difference {
            box { <-20, -100, -6> <3.5, 100, 30> }
            box { <0, -101, -0.4> <4, 101, 24.4> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, -0.400001> }
            cylinder { -101*y, 101*y, 2.5 translate <2.5, 0, 24.400001> }
            rotate -46*z
            translate <-2.9, 0.9, 0>
          }
        }
        difference {
          box { <-15, -100, -6> <3.5, 100, 30> }
          box { <0, -101, -0.4> <4, 101, 24.4> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.400001> }
          cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.400001> }
          translate <-3.900001, 5, 0>
        }
        difference {
          difference {
            box { <-15, -100, -6> <3.5, 100, 30> }
            box { <0, -101, -0.4> <4, 101, 24.4> }
            cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, -0.400001> }
            cylinder { -101*y, 101*y, 3.5 translate <3.5, 0, 24.400001> }
            rotate -46*z
            translate <-3.9, 1.9, 0.000001>
          }
          box { <-4, -1, -4> <28, 1.35, 28> }
        }
        box { <4, -1, -2.399999> <28, 4, 26.399999> }
        cylinder { -1*y, 1.9*y, 2.5 }
        cylinder { -1*y, 1.9*y, 2.5 translate <0, 0, 8> }
        cylinder { -1*y, 1.9*y, 2.5 translate <0, 0, 16> }
        cylinder { -1*y, 1.9*y, 2.5 translate <0, 0, 24> }
        difference {
          box { <11.9, 5, -2.399998> <28, 10, 26.399998> }
          difference {
            box { <11, 3, -3> <17, 12, 1.6> }
            cylinder { 4*y, 11*y, 4 translate <15.9, 0, 1.6> }
          }
          difference {
            box { <11, 3, 22.4> <17, 12, 27> }
            cylinder { 4*y, 11*y, 4 translate <15.9, 0, 22.4> }
          }
        }
        difference {
          box { <26.9, -1, -5> <28.9, 1, 29> }
          cylinder { -6*z, 30*z, 1 translate <26.4, 1, 0> }
        }
        difference {
          box { <26.9, 8.5, -5> <28.9, 10, 29> }
          cylinder { -6*z, 30*z, 1 translate <26.4, 8.5, 0> }
        }
      }
      object { open_rounded_button() translate <8, 6.4, 0> }
      object { open_rounded_button() translate <8, 6.4, 8> }
      object { open_rounded_button() translate <8, 6.4, 16> }
      object { open_rounded_button() translate <8, 6.4, 24> }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> translate <8, 9.5, 24> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.15, -4> <28, 11.3, 28> } }
    }
  #end
#end
#macro window_shield8(color_tex)
  #if (setting = 0)
    difference {
      box { <-78.3, -20.75, -3.9> <1.55, 1.55, 27.9> }
      box { <-100, 0, -10> <50, 50, 30> rotate 22.7*z translate <-30, 1.55, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        box { <-78.3, -20.75, -3.9> <1.55, 1.55, 27.9> }
        #if (setting > 3)
          object { llogo() rotate 180*y translate <-2, 1.55, 0> }
          object { llogo() rotate 180*y translate <-2, 1.55, 8> }
          object { llogo() rotate 180*y translate <-2, 1.55, 16> }
          object { llogo() rotate 180*y translate <-2, 1.55, 24> }
        #end
      }
      box { <-100, -30, -50> <20, 10, 0> rotate 18.4*y translate <-54.3, 0, -4> }
      box { <-100, -30, 0> <20, 10, 50> rotate -18.4*y translate <-54.3, 0, 28> }
      box { <-100, 0, -10> <50, 50, 30> rotate 22.7*z translate <-30, 1.55, 0> }
      box { <-100, 0, -50> <50, 50, 50> rotate -49*x rotate 22.7*z translate <-6, 1.55, -4> }
      box { <-100, 0, -50> <50, 50, 50> rotate 49*x rotate 22.7*z translate <-6, 1.55, 28> }
      difference {
        box { <-76.8, -21, -2.4> <-3, 0, 26.4> }
        box { <-74.9, -30, 0> <-73.9, 0, 5.3> }
        box { <-74.9, -30, 18.7> <-73.9, 0, 24> }
        box { <-100, -30, -50> <20, 10, 0> rotate 18.4*y translate <-54.3, 0, -2.7> }
        box { <-100, -30, 0> <20, 10, 50> rotate -18.4*y translate <-54.3, 0, 26.7> }
        box { <-100, 0, -10> <50, 50, 30> rotate 22.7*z translate <-30, -0.45, 0> }
        box { <-100, 0, -50> <50, 50, 50> rotate -49*x rotate 22.7*z translate <-6, -0.45, -3.5> }
        box { <-100, 0, -50> <50, 50, 50> rotate 49*x rotate 22.7*z translate <-6, -0.45, 27.5> }
        box { <-3.50002, -1.55, -2.5> <2, 0.45, 26.5> }
      }
      box { <-3.500001, -30, -2.39999> <2, -1.55, 26.39999> }
      #if (setting > 1)
        box { <-2.5, -21, -3> <2.5, -18.75, 3> rotate 18.4*y translate <-58.4, 0, 0> }
        box { <-2.5, -21, -3> <2.5, -18.75, 3> rotate -18.4*y translate <-58.4, 0, 24> }
        box { <-2.5, -21, -3> <2.5, -18.75, 3> rotate 18.4*y translate <-66.4, 0, 0> }
        box { <-2.5, -21, -3> <2.5, -18.75, 3> rotate -18.4*y translate <-66.4, 0, 24> }
        box { <-2, -1.55, -4> <2, 2, -2.39997> }
        box { <-2, -1.55, 26.39997> <2, 2, 28> }
        box { <-1.5, -2, 3.2> <1.6, 2, 4.8> }
        box { <-1.5, -2, 11.2> <1.6, 2, 12.8> }
        box { <-1.5, -2, 19.2> <1.6, 2, 20.8> }
        box { <-4.00001, -5, -1> <0, 0.00001, 1.7> }
        box { <-4.00001, -5, 6.3> <0, 0.00001, 9.7> }
        box { <-4.00001, -5, 14.3> <0, 0.00001, 17.7> }
        box { <-4.00001, -5, 22.3> <0, 0.00001, 25> }
        difference {
          box { <0, -1.55001, -4.00001> <2, 1.55001, 28.00001> }
          cylinder { -2.4*z, 26.4*z, 1.55001 }
        }
        difference {
          box { <0, -24, -4> <2, -19.2, 28> }
          cylinder { -5*z, 29*z, 1.55 translate <0.1, -19.2, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-78.4, -20.85, -4> <1.65, 1.65, 28> } }
    }
  #end
#end
#macro window_shield9(color_tex, age)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <35.9, 15.9, 11.9> }
      box { <-10, 0, -10> <30, 50, 20> rotate 41.5*z translate <-4, 1.9, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        #if (setting < 3)
          cylinder { 15.8*y, 17.6*y, 2.4 translate <32, 0, 0> }
          cylinder { 15.8*y, 17.6*y, 2.4 translate <32, 0, 8> }
        #else
          object { rounded_button() rotate 180*y translate <32, 12.8, 0> }
          object { rounded_button() rotate 180*y translate <32, 12.8, 8> }
        #end
        box { <-3.9, 0, -3.9> <35.9, 15.9, 11.9> }
      }
      difference {
        box { <-2.4, -1, -4> <36, 15, 12> }
        box { <-10, 0, -10> <30, 50, 20> rotate 41.5*z translate <-2.4, 1.9, 0> }
        box { <-4, -2, -5> <3.900001, 10, -2.4> }
        box { <-4, -2, 10.4> <3.900001, 10, 13> }
        #if (setting > 1)
          object { pin(age) translate <32, 12.800007, 4> }
        #end
        box { <-4, 12.8, -5> <37, 16, -2.4> }
        box { <-4, 12.800001, 10.4> <37, 16, 13> }
        box { <0, 0, -5> <20, 20, -2.400001> rotate 41.5*z translate <3.9, 3.9, 0> }
        box { <0, 0, 10.399999> <20, 20, 13> rotate 41.5*z translate <3.9, 3.9, 0> }
        box { <34.4, 12.800002, -5> <37, 16, 13> }
        box { <28, 12.800003, -5> <29.6, 16, 13> }
      }
      box { <-10, 0, -10> <30, 50, 20> rotate 41.5*z translate <-4, 1.9, 0> }
      #if (setting > 1)
        cylinder { 13.8*y, 16.8*y, 1.2 translate <32, 0, 0> }
        cylinder { 13.8*y, 16.8*y, 1.2 translate <32, 0, 8> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <36, 17.7, 12> } }
    }
  #end
#end
#macro windshield_foldable(var,color_tex)
  #if (setting = 0)
    box { <-11.3, -1.55, -3.9> <1.55, 1.55, 27.9> texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -3.900001*z, 27.900001*z, 1.55 }
        box { <-1.65, -1.550001, -3.9> <0, 1.550001, 27.9> }
        box { <-11.3, -0.7, -3.9> <-1.64, 0.7, 27.9> }
        #if (var = 1)
          difference {
            box { <-11.2, -0.699999, -3.8> <-1.54, -0.700005, 27.8> }
            cylinder { -1*y, 0*y, 0.45 translate <-9, 0, 25> }
            difference {
              merge {
                cylinder { 0*y, -1*y, 7.5 scale <1, 1, 1.05> translate <-2.64, 0, 4.2> }
                cylinder { 0*y, -1*y, 7.5 scale <1, 1, 1.05> translate <-2.64, 0, 19.8> }
              }
              box { <-2.74, -1, -5> <20, 2, 29> }
            }
            texture {
              pigment { color beige filter 0.75 }
              finish { t_lego_finish }
            }
          }
          merge {
            difference {
              cylinder { -0.700006*y, -0.700005*y, 0.75 }
              cylinder { -1*y, 0*y, 0.45 }
              translate <-9, 0, 25>
            }
            merge {
              box { <0.6, -0.700006, -0.15> <1.3, -0.700005, 0.15> }
              box { <1.299999, -0.700006, -0.5> <1.6, -0.700005, 0.5> }
              box { <1.6, -0.700007, -0.5> <2.3, -0.700008, -0.2> }
              box { <0, -0.700008, 0> <0.4, -0.700009, 0.3> rotate -30*y translate <2.3, 0, -0.5> }
              box { <1.6, -0.700007, 0.2> <2.3, -0.700008, 0.5> }
              box { <2, -0.700007, 0.5> <2.3, -0.700008, 0.9> }
              box { <-0.15, -0.700006, -0.6> <0.15, -0.700005, -1.3> }
              box { <-0.9, -0.700006, -1.3> <0.9, -0.700005, -1> }
              box { <0, -0.700006, -0.55> <0.3, -0.700005, 0> rotate -15*y translate <-0.9, 0, -1.3> }
              box { <-0.3, -0.700006, -0.15> <0, -0.700005, 0> rotate -15*y translate <0.9, 0, -1.3> }
              merge {
                box { <-1.3, -0.700006, -0.15> <-0.7, -0.700005, 0.15> }
                box { <-1.3, -0.700006, -0.3> <-1, -0.700005, 0.3> }
                rotate 15*y
              }
              merge {
                box { <-0.15, -0.700006, 0.7> <0.15, -0.700005, 1.2> }
                box { <-0.3, -0.700006, 0> <0, -0.700005, 0.9> rotate -45*y translate <0, 0, 1.2> }
                box { <-0.6, -0.700006, -0.3> <0, -0.700005, 0> rotate -45*y translate <-0.8, 0, 1.8> }
                rotate -15*y
              }
              merge {
                box { <0.4, -0.700006, 0.5> <0.7, -0.700005, 1.5> }
                box { <0.4, -0.700006, 1.2> <0.9, -0.700005, 1.5> }
                rotate -10*y
              }
              rotate 15*y
              translate <-9, 0, 25>
            }
            box { <-5, -0.700006, -2.5> <-4.7, -0.700005, 5> }
            box { <-5, -0.700006, 13.5> <-4.7, -0.700005, 21> }
            box { <-1.2, -0.700006, 0> <0, -0.700005, 0.3> rotate -10*y translate <-3.8, 0, 0.5> }
            box { <-1.2, -0.700006, 0> <0, -0.700005, 0.3> rotate -10*y translate <-3.8, 0, 16.5> }
            box { <-0.3, -0.700006, 0> <0, -0.700005, 5.5> rotate 10*y translate <-3.8, 0, 0.5> }
            box { <-0.3, -0.700006, 0> <0, -0.700005, 5.5> rotate 10*y translate <-3.8, 0, 16.5> }
            texture { black_tex }
          }
        #end
      }
      box { <-1.8, -2, -5> <2, 2, -2.45> }
      box { <-1.8, -2, 3.2> <2, 2, 4.8> }
      box { <-1.8, -2, 11.2> <2, 2, 12.8> }
      box { <-1.8, -2, 19.2> <2, 2, 20.8> }
      box { <-1.8, -2, 26.45> <2, 2, 29> }
      box { <-1.8, -0.5, -1> <0, 3, 1.75> }
      box { <-1.8, -0.5, 6.25> <0, 3, 9.75> }
      box { <-1.8, -0.5, 14.25> <0, 3, 17.75> }
      box { <-1.8, -0.5, 22.25> <0, 3, 25> }
      #if (var = 0)
        texture { color_tex }
      #else
        texture { t_white_tex }
        interior { ior 1.5 }
      #end
      bounded_by { box { <-11.4, -1.65, -4> <1.65, 1.65, 28> } }
    }
  #end
#end
#macro wi_block1_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -5.5> <11.9, 3.1, 3.9> }
      box { <-3.899999, -12.7, -5.499998> <11.899999, 3.099999, -3.999998> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -5.5> <11.9, 3.1, 3.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
          #else
            object { rounded_button() rotate 90*y }
            object { rounded_button() rotate 90*y translate <8, 0, 0> }
          #end
          object { open_rounded_button() rotate -90*x translate <0, -0.8, -2.4> }
          object { open_rounded_button() rotate -90*x translate <8, -0.8, -2.4> }
          object { open_rounded_button() rotate -90*x translate <0, -8.8, -2.4> }
          object { open_rounded_button() rotate -90*x translate <8, -8.8, -2.4> } 
          #if (setting > 3)
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <0, -0.8, -5.5> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <8, -0.8, -5.5> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <0, -8.8, -5.5> }
            object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y rotate -90*x translate <8, -8.8, -5.5> }
          #end
          box { <-3.899999, -12.7, -5.499999> <11.899999, 3.099999, -3.999999> }
        }
        difference {
          box { <-1, -1, -6> <0, 0, -3> }
          cylinder { -7*z, -2*z, 0.8 }
          translate <-3.1, -11.9, 0>
        }
        difference {
          box { <0, -1, -6> <1, 0, -3> }
          cylinder { -7*z, -2*z, 0.8 }
          translate <11.1, -11.9, 0>
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 2.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
        #end
      }
      object { pin(2) translate <4, 0, 0> }
      texture { color_tex }
      bounded_by { box { <-4, -12.8, -7.3> <12, 4.9, 4> } }
    }
  #end
#end
#macro woodblock1_2(color_tex)
  #if (setting = 0)
    intersection {
      merge {
        cylinder { 0*y, 9.5*y, 3.75 scale <1.5, 1, 1> }
        cylinder { 0*y, 9.5*y, 3.75 scale <1.5, 1, 1> translate <8, 0, 0> }
      }
      box { <-3.9, 0.000001, -3.9> <11.9, 9.499999, 3.9> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
        #else
          object { rounded_button() translate <0, 6.4, 0> }
          object { rounded_button() translate <8, 6.4, 0> }
        #end
        cylinder { 0*y, 9.5*y, 3.75 scale <1.5, 1, 1> }
        cylinder { 0*y, 9.5*y, 3.75 scale <1.5, 1, 1> translate <8, 0, 0> }
      }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <10.4, 8.6, 2.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <4, 0, -1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <2, 0, -1.8> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <6, 0, -1.8> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <4, 0, 1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <2, 0, 1.8> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <6, 0, 1.8> }
        }
        box { <-10, -1, -4> <-3.9, 10, 4> }
        box { <11.9, -1, -4> <20, 10, 4> }
        cylinder { 7.4*y, 10.4*y, 1.2 }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 4> } }
    }
  #end
#end
#macro woodblock1_4(color_tex)
  #if (setting = 0)
    intersection {
      merge {
        cylinder { 0*y, 9.5*y, 3.75 scale <1.5, 1, 1> }
        cylinder { 0*y, 9.5*y, 3.75 scale <1.5, 1, 1> translate <8, 0, 0> }
        cylinder { 0*y, 9.5*y, 3.75 scale <1.5, 1, 1> translate <16, 0, 0> }
        cylinder { 0*y, 9.5*y, 3.75 scale <1.5, 1, 1> translate <24, 0, 0> }
      }
      box { <-3.9, 0.000001, -3.9> <27.9, 9.499999, 3.9> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <16, 0, 0> }
          cylinder { 9.4*y, 11.2*y, 2.4 translate <24, 0, 0> }
        #else
          object { rounded_button() translate <0, 6.4, 0> }
          object { rounded_button() translate <8, 6.4, 0> }
          object { rounded_button() translate <16, 6.4, 0> }
          object { rounded_button() translate <24, 6.4, 0> }
        #end
        cylinder { 0*y, 9.5*y, 3.75 scale <1.5, 1, 1> }
        cylinder { 0*y, 9.5*y, 3.75 scale <1.5, 1, 1> translate <8, 0, 0> }
        cylinder { 0*y, 9.5*y, 3.75 scale <1.5, 1, 1> translate <16, 0, 0> }
        cylinder { 0*y, 9.5*y, 3.75 scale <1.5, 1, 1> translate <24, 0, 0> }
      }
      #if (setting > 1)
        difference {
          box { <-2.4, -1, -2.4> <26.4, 8.6, 2.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <4, 0, -1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <2, 0, -1.8> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <6, 0, -1.8> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <4, 0, 1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <2, 0, 1.8> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <6, 0, 1.8> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <12, 0, -1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <10, 0, -1.8> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <14, 0, -1.8> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <12, 0, 1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <10, 0, 1.8> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <14, 0, 1.8> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <20, 0, -1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <18, 0, -1.8> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 135*y translate <22, 0, -1.8> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <20, 0, 1.4> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <18, 0, 1.8> }
          box { <0, 0.25, 0> <2, 9, 2> rotate 315*y translate <22, 0, 1.8> }
          box { <11.5, 2, -3> <12.5, 8.7, 3> }
        }
        box { <-10, -1, -4> <-3.9, 10, 4> }
        box { <27.9, -1, -4> <40, 10, 4> }
        cylinder { 7.4*y, 10.4*y, 1.2 }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <16, 0, 0> }
        cylinder { 7.4*y, 10.4*y, 1.2 translate <24, 0, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 11.3, 4> } }
    }
  #end
#end
#macro wooden_crate(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <27.9, 15.9, 19.9> texture { color_tex } }
  #else
    merge {
      difference {
        box { <-3.9, 0, -3.9> <27.9, 15.9, 19.9> }
        box { <3.9, -1, -4> <20.1, 5.3, -3.3> }
        box { <3.9, 5.299999, -4> <20.1, 10.6, -3.5> }
        box { <3.9, 10.599999, -4> <20.1, 16, -3.7> }
        box { <3.9, -1, 19.3> <20.1, 5.3, 20> }
        box { <3.9, 5.299999, 19.5> <20.1, 10.6, 20> }
        box { <3.9, 10.599999, 19.7> <20.1, 16, 20> }
        box { <-4, 9.5, 3> <28, 12.7, 13> }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <26.4, 2, 18.4> }
          cylinder { 1*y, 4*y, 1.55 translate <4, 0, 4> }
          cylinder { 1*y, 4*y, 1.55 translate <12, 0, 4> }
          cylinder { 1*y, 4*y, 1.55 translate <20, 0, 4> }
          cylinder { 1*y, 4*y, 1.55 translate <4, 0, 12> }
          cylinder { 1*y, 4*y, 1.55 translate <12, 0, 12> }
          cylinder { 1*y, 4*y, 1.55 translate <20, 0, 12> }
        #end
        difference {
          box { <-2.4, 3.1, -2.4> <26.4, 16, 18.4> }
          object { rounded_button() translate <4, 0, 4> }
          object { rounded_button() translate <12, 0, 4> }
          object { rounded_button() translate <20, 0, 4> }
          object { rounded_button() translate <4, 0, 12> }
          object { rounded_button() translate <12, 0, 12> }
          object { rounded_button() translate <20, 0, 12> }
        }
        cylinder { -1*y, 20*y, 1.55 translate <8, 0, 8> }
        cylinder { -1*y, 20*y, 1.55 translate <16, 0, 8> }
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
        object { ring() translate <20, 0, 4> }
        object { ring() translate <4, 0, 12> }
        object { ring() translate <12, 0, 12> }
        object { ring() translate <20, 0, 12> }
      #end
      box { <-2.400001, 2.5, -2.400001> <2.4, 17.7, -1.3> }
      box { <5.6, 2.5, -2.400001> <10.4, 17.7, -1.3> }
      box { <13.6, 2.5, -2.400001> <18.4, 17.7, -1.3> }
      box { <21.6, 2.5, -2.400001> <26.400001, 17.7, -1.3> }
      box { <-2.400001, 2.5, 17.3> <2.4, 17.7, 18.400001> }
      box { <5.6, 2.5, 17.3> <10.4, 17.7, 18.400001> }
      box { <13.6, 2.5, 17.3> <18.4, 17.7, 18.400001> }
      box { <21.6, 2.5, 17.3> <26.400001, 17.7, 18.400001> }
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <28, 17.8, 20> } }
    }
  #end
#end
#macro woodpanel1_6(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <27.9, 57.5, 3.9> }
      box { <-11.9, 9.5, -3.900001> <35.9, 47.9, 3.900001> }
      box { <-3.899998, 50.9, 0> <27.899998, 54.3, 11.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.900001, -0.000001, 0> <27.900001, 57.500001, 3.9> }
          box { <-11.900001, 9.500002, 0> <35.900001, 47.900001, 3.900001> }
          cylinder { 9.6*y, 47.9*y, 3.75 scale <1.5, 1, 1> translate <-8, 0, 0> }
          cylinder { 0*y, 57.5*y, 3.75 scale <1.5, 1, 1> }
          cylinder { 0*y, 57.5*y, 3.75 scale <1.5, 1, 1> translate <8, 0, 0> }
          cylinder { 0*y, 57.5*y, 3.75 scale <1.5, 1, 1> translate <16, 0, 0> }
          cylinder { 0*y, 57.5*y, 3.75 scale <1.5, 1, 1> translate <24, 0, 0> }
          cylinder { 9.6*y, 47.9*y, 3.75 scale <1.5, 1, 1> translate <32, 0, 0> }
          box { <-3.899998, 50.9, 0> <27.899998, 54.3, 11.9> }
        }
        box { <-2.900001, 54.300001, 0> <26.899999, 60, 2.799999> }
        difference {
          merge {
            cylinder { 54.3*y, 60*y, 2.9 scale <1.5, 1, 1> }
            cylinder { 54.3*y, 60*y, 2.9 scale <1.5, 1, 1> translate <8, 0, 0> }
            cylinder { 54.3*y, 60*y, 2.9 scale <1.5, 1, 1> translate <16, 0, 0> }
            cylinder { 54.3*y, 60*y, 2.9 scale <1.5, 1, 1> translate <24, 0, 0> }
          }
          box { <-20, 48, -4> <-2.9, 61, 4> }
          box { <26.9, 48, -4> <40, 61, 4> }
        }
        #if (setting > 1)
          box { <-2.4, 3.1, -2.6> <26.4, 53, 12> }
          box { <-10.4, 12.7, -2.600001> <34.4, 46.4, 12> }
          intersection {
            box { <-10.4, 5, -2.4> <-3.900005, 11.6, 2.4> }
            cylinder { 4*y, 12*y, 2.9 scale <1.5, 1, 1> translate <-8, 0, 0> }
          }
          box { <-8, 5, 0> <-3.900006, 11.600001, 2.400005> }
          intersection {
            box { <27.899995, 5, -2.4> <34.4, 11.6, 2.4> }
            cylinder { 4*y, 12*y, 2.9 scale <1.5, 1, 1> translate <32, 0, 0> }
          }
          box { <27.8999994, 5, 0> <32, 11.600001, 2.400005> }
          difference {
            box { <-2.4, -1, -2.4> <26.4, 2, 2.4> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 135*y translate <4, 0, -1.4> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 135*y translate <2, 0, -1.8> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 135*y translate <6, 0, -1.8> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 315*y translate <4, 0, 1.4> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 315*y translate <2, 0, 1.8> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 315*y translate <6, 0, 1.8> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 135*y translate <12, 0, -1.4> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 135*y translate <10, 0, -1.8> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 135*y translate <14, 0, -1.8> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 315*y translate <12, 0, 1.4> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 315*y translate <10, 0, 1.8> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 315*y translate <14, 0, 1.8> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 135*y translate <20, 0, -1.4> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 135*y translate <18, 0, -1.8> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 135*y translate <22, 0, -1.8> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 315*y translate <20, 0, 1.4> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 315*y translate <18, 0, 1.8> }
            box { <0, 0.25, 0> <2, 2.1, 2> rotate 315*y translate <22, 0, 1.8> }
          }
        #end
        box { <-20, -1, -4> <-3.9, 9.599999, 4> }
        box { <27.9, -1, -4> <50, 9.599999, 4> }
        box { <-20, -1, -4> <-11.9, 60, 4> }
        box { <-20, 47.900002, -4> <-3.9, 60, 4> }
        box { <35.9, -1, -4> <50, 60, 4> }
        box { <27.9, 47.900002, -4> <50, 60, 4> }
      }
      #if (setting > 1)
        box { <-5.6, 9.600003, -0.5> <-3.8, 12, 0.5> }
        box { <27.8, 9.600003, -0.5> <29.6, 12, 0.5> }
        difference {
          merge {
            cylinder { 10*y, 43.5*y, 3.75 scale <1.5, 1, 1> translate <-12, 0, -4.75> }
            cylinder { 3*y, 53.5*y, 3.75 scale <1.5, 1, 1> translate <-4, 0, -4.75> }
            cylinder { 3*y, 53.5*y, 3.75 scale <1.5, 1, 1> translate <4, 0, -4.75> }
            cylinder { 3*y, 53.5*y, 3.75 scale <1.5, 1, 1> translate <12, 0, -4.75> }
            cylinder { 3*y, 53.5*y, 3.75 scale <1.5, 1, 1> translate <20, 0, -4.75> }
            cylinder { 3*y, 53.5*y, 3.75 scale <1.5, 1, 1> translate <28, 0, -4.75> }
            cylinder { 10*y, 43.5*y, 3.75 scale <1.5, 1, 1> translate <36, 0, -4.75> }
          }
          box { <-20, -1, -20> <40, 70, -2.5> }
          box { <-30, -1, -40> <-11, 60, 4> }
          box { <35, -1, -40> <50, 60, 4> }
          box { <-20, -1, -40> <-4, 10, 4> }
          box { <-20, 47.5, -40> <-4, 60, 4> }
          box { <28, -1, -40> <50, 10, 4> }
          box { <28, 47.5, -40> <50, 60, 4> }
        }
      #end
      object { open_rounded_button() translate <-8, 44.8, 0> }
      object { open_rounded_button() translate <32, 44.8, 0> }
      object { open_rounded_button() translate <0, 51.2, 8> }
      object { open_rounded_button() translate <8, 51.2, 8> }
      object { open_rounded_button() translate <16, 51.2, 8> }
      object { open_rounded_button() translate <24, 51.2, 8> }
      object { open_rounded_button() translate <0, 54.4, 0> }
      object { open_rounded_button() translate <8, 54.4, 0> }
      object { open_rounded_button() translate <16, 54.4, 0> }
      object { open_rounded_button() translate <24, 54.4, 0> }
      difference {
        cylinder { 54.1*y, 57.5*y, 2.400001 }
        cylinder { 54*y, 60*y, 1.600001 }
      }
      difference {
        cylinder { 54.1*y, 57.5*y, 2.400001 }
        cylinder { 54*y, 60*y, 1.600001 }
        translate <8, 0, 0>
      }
      difference {
        cylinder { 54.1*y, 57.5*y, 2.400001 }
        cylinder { 54*y, 60*y, 1.600001 }
        translate <16, 0, 0>
      }
      difference {
        cylinder { 54.1*y, 57.5*y, 2.400001 }
        cylinder { 54*y, 60*y, 1.600001 }
        translate <24, 0, 0>
      }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <-8, 47.9, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <32, 47.9, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 54.3, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 54.3, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 54.3, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 54.3, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 54.3, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 54.3, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 54.3, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate 90*y translate <0, 54.3, 0> }
      #end
      texture { color_tex }
      bounded_by { box { <-12, -0.1, -4> <36, 59.2, 12> } }
    }
  #end
#end
#macro wrench(color_tex)
  #if (setting = 0)
    merge {
      cylinder { 0*y, 21*y, 1.5 }
      cylinder { -1.5*z, 1.5*z, 4.35 translate <0, 24.5, 0> }
      texture { color_tex }
    }
  #else
    difference {
      merge {
        cylinder { 0*y, 21*y, 1.5 }
        cylinder { -1.5*z, 1.5*z, 4.35 translate <0, 24.5, 0> }
        box { <-3, 16.75, -1.500001> <3, 22, 1.500001> }
      }
      difference {
        cylinder { -2*z, 2*z, 8 }
        torus { 8, 1.500001 rotate 90*x }
        box { <-20, 0, -20> <20, 20, 20> rotate -70*z }
        translate <8, 16.75, 0>
      }
      difference {
        cylinder { -2*z, 2*z, 8 }
        torus { 8, 1.500002 rotate 90*x }
        box { <-20, 0, -20> <20, 20, 20> rotate -70*z }
        rotate 180*y translate <-8, 16.75, 0>
      }
      difference {
        box { <-4, -10, -2> <0, 10, 2> }
        cylinder { -3*z, 3*z, 2 scale <0.9, 2, 1> }
        rotate -45*z translate <-1.25, 25.75, 0>
      }
      cylinder { -2*z, 2*z, 2.4 translate <-1, 25.5, 0> }
      box { <-4, -2.2, -2> <0, 2, 2> rotate -45*z translate <-1, 25.5, 0> }
      #if (setting > 1)
        box { <-2, -5, -1> <2, 5, 1> rotate -6*x translate <0, 4, -2> }
        box { <-2, -5, -1> <2, 5, 2> rotate 6*x translate <0, 4, 2> }
      #end
      texture { color_tex }
      bounded_by { box { <-4.45, -0.1, -1.6> <4.45, 28.95, 1.6> } }
    }
  #end
#end
#macro w_block1_4(color_tex, age)
  #if (setting = 0)
    merge {
      box { <-4.2, 0, -3.9> <3.9, 3.1, 11.9> }
      box { <-5.5, -4.7, -11.9> <-4, 3.100001, 19.9> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-4.2, 0, -3.9> <3.9, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
          #else
            object { rounded_button() rotate 180*y }
            object { rounded_button() rotate 180*y translate <0, 0, 8> }
          #end
        }
        #if (setting > 1)
          box { <-3.999999, -1, -2.4> <2.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
        #end
      }
      box { <-5.5, -4.7, -11.9> <-4, 3.100001, 19.9> }
      object { open_rounded_button() rotate 90*z translate <-2.4, -0.8, -8> }
      object { open_rounded_button() rotate 90*z translate <-2.4, -0.8, 0> }
      object { open_rounded_button() rotate 90*z translate <-2.4, -0.8, 8> }
      object { open_rounded_button() rotate 90*z translate <-2.4, -0.8, 16> }
      #if (setting > 1)
        object { pin(age) translate <0, 0, 4> }
        box { <-5, 0, 7.5> <-2.4, 2.1, 8.5> }
        box { <-5, 0, -0.5> <-2.4, 2.1, 0.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-7.3, -4.8, -12> <4, 4.9, 20> } }
    }
  #end
#end
#macro w_block2_2(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <15.1, 3.1, 11.9> }
      box { <12, 2.1, -3.900001> <15.100001, 19.1, 11.900001> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <15.1, 3.1, 11.9> }
          box { <12, 2.1, -3.900001> <15.100001, 19.1, 11.900001> }
          #if (setting < 3)
            cylinder { 15*x, 16.8*x, 2.4 translate <0, 7.1, 0> }
            cylinder { 15*x, 16.8*x, 2.4 translate <0, 15.1, 0> }
            cylinder { 15*x, 16.8*x, 2.4 translate <0, 7.1, 8> }
            cylinder { 15*x, 16.8*x, 2.4 translate <0, 15.1, 8> }
          #else
            object { rounded_button() rotate -90*z translate <12, 7.1, 0> }
            object { rounded_button() rotate -90*z translate <12, 15.1, 0> }
            object { rounded_button() rotate -90*z translate <12, 7.1, 8> }
            object { rounded_button() rotate -90*z translate <12, 15.1, 8> }
          #end
        }
        #if (setting > 1)
          box { <-2.4, -1, -2.4> <10.4, 2, 10.4> }
          box { <11, 3.100001, -2.4> <14, 17.5, 10.4> }
          box { <11.9, -1, -2.4> <16, 2, 2.6> }
          box { <11.9, -1, 5.4> <16, 2, 10.4> }
          cylinder{ -1*y, 4*y, 2.600001 translate <4, 0, 4> }
          cylinder { 12.8*x, 15.8*x, 1.2 translate <0, 7.1, 0> }
          cylinder { 12.8*x, 15.8*x, 1.2 translate <0, 15.1, 0> }
          cylinder { 12.8*x, 15.8*x, 1.2 translate <0, 7.1, 8> }
          cylinder { 12.8*x, 15.8*x, 1.2 translate <0, 15.1, 8> }
          cylinder { 16*x, 11*x, 2.600001 translate <0, 11.1, 4> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, 0, 4> }
        object { ring() rotate -90*z translate <12.000001, 11.1, 4> }
        box { <12.00001, 2.1, -0.5> <14.1, 4.6, 0.5> }
        box { <12.00001, 2.1, 7.5> <14.1, 4.6, 8.5> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <16.9, 19.2, 12> } }
    }
  #end
#end
#macro w_block2_3(color_tex)
  #if (setting = 0)
    merge {
      box { <-3.9, 0, -3.9> <23.1, 3.1, 11.9> }
      box { <19.9, 2.1, -3.900001> <23.100001, 19.1, 11.900001> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, 0, -3.9> <23.1, 3.1, 11.9> }
          #if (setting < 3)
            cylinder { 3*y, 4.8*y, 2.4 }
            cylinder { 3*y, 4.8*y, 2.4 translate <0, 0, 8> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 0> }
            cylinder { 3*y, 4.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() }
            object { rounded_button() translate <0, 0, 8> }
            object { rounded_button() translate <8, 0, 0> }
            object { rounded_button() translate <8, 0, 8> }
          #end
          box { <11.999999, 3, -3.900001> <23.100001, 19.1, 11.900001> }
        }
        box { <-1, -5, -4> <10, 0, 12> rotate 45*z translate <19.9, 0, 0> }
        box { <11, 3.100001, -0.3> <19.899999, 9.6, 8.3> }
        box { <10, 9.599999, -2.4> <19.899998, 20, 10.4> }
        cylinder { -4*z, 12*z, 1.6 translate <16, 5.6, 0> }
        box { <13.5, 3.1, -4> <18.5, 8.1, -2.4> }
        box { <13.5, 3.1, 10.4> <18.5, 8.1, 12> }
        #if (setting > 1)
          box { <21.1, 4.8, -2.4> <24, 17.6, 10.4> }
          box { <-2.4, -1, -2.4> <18.4, 2, 10.4> }
          cylinder { 1*y, 4*y, 1.2 }
          cylinder { 1*y, 4*y, 1.2 translate <0, 0, 8> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 0> }
          cylinder { 1*y, 4*y, 1.2 translate <8, 0, 8> }
        #end
        difference {
          box { <19.900002, -1, -2.4> <24, 3.1, 10.4> }
          box { <-1, 0, -4> <10, 5, 12> rotate 45*z translate <19.9, 2, 0> }
          box { <19, -2, 3.25> <25, 3, 4.75> }
        }
        box { <-10, -1, -4> <0, 20, 12> rotate -40.5*z translate <11.9, 9.6, 0> }
        difference {
          box { <13.5, 9.6, -4> <18.5, 16, 12> }
          box { <13, 9, -2.9> <19, 17, 10.9> }
          box { <-10, -10, -5> <0, 10, 13> rotate -40.5*z translate <14, 9.6, 0> }
        }
      }
      object { open_rounded_button() translate <16, 0, 4> }
      #if (setting > 1)
        object { ring() rotate 90*z translate <23.1, 11.2, 4> }
        object { ring() translate <4, 0, 4> }
        object { ring() translate <12, 0, 4> }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <23.2, 19.2, 12> } }
    }
  #end
#end
#macro w_block2_4(color_tex)
  #if (setting = 0)
    box { <-3.9, -6.2, -3.9> <3.9, 9.5, 27.9> texture { color_tex } }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, -6.3, -3.9> <3.9, 9.5, 27.9> }
            box { <-4, 1.6, -4> <-0.9, 10, 4.1> }
            box { <-4, 1.6, 19.9> <-0.9, 10, 28> }
            box { <-4, -7, 3.9> <4, 0.00001, 20.1> }
            box { <0.9, -7, -4> <4, -2.4, 28> }
            cylinder { -4*z, 0*z, 12 translate <12.9, -2.4, 0> }
            cylinder { 24*z, 28*z, 12 translate <12.9, -2.4, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <0, 0, 16> }
            cylinder { -2.6*x, -0.8*x, 2.4 translate <0, 5.6, 0> }
            cylinder { -5.6*x, -3.8*x, 2.4 translate <0, 5.6, 8> }
            cylinder { -5.6*x, -3.8*x, 2.4 translate <0, 5.6, 16> }
            cylinder { -2.6*x, -0.8*x, 2.4 translate <0, 5.6, 24> }
            cylinder { -5.6*x, -3.8*x, 2.4 translate <0, -2.4, 0> }
            cylinder { -5.6*x, -3.8*x, 2.4 translate <0, -2.4, 24> }
          #else
            object { rounded_button() rotate 180*y translate <0, 6.4, 8> }
            object { rounded_button() rotate 180*y translate <0, 6.4, 16> }
            object { open_rounded_button() rotate 90*z translate <2.2, 5.6, 0> }
            object { open_rounded_button() rotate 90*z translate <-0.8, 5.6, 8> }
            object { open_rounded_button() rotate 90*z translate <-0.8, 5.6, 16> }
            object { open_rounded_button() rotate 90*z translate <2.2, 5.6, 24> }
            object { open_rounded_button() rotate 90*z translate <-0.8, -2.4, 0> }
            object { open_rounded_button() rotate 90*z translate <-0.8, -2.4, 24> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, 5.6> <2.4, 8.6, 18.4> }
            cylinder { 0.00004*y, 9*y, 1.5 translate <0, 0, 12> }
            box { <-3, 2, 11.7> <3, 9, 12.3> }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <0, 0, 16> }
          box { <-2.4, -7, -2.4> <4, 0, 2.4> }
          box { <-2.4, -7, 21.6> <4, 0, 26.4> }
          box { <0.90001, -2.40005, -2.40001> <4, 8.2, 3.90002> }
          box { <0.90001, -2.40005, 20.00001> <4, 8.2, 26.40001> }
          difference {
            box { <-0.1, -1, -2.40005> <2, 1, 26.40005> }
            cylinder { -3*z, 27*z, 1 translate <-0.1, 1, 0> }
            box { <-1, -2, 2.40006> <3, 2, 21.60006> }
          }
        #end
      }
      #if (setting > 3)
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z rotate 180*y translate <-0.9, 5.6, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z rotate 180*y translate <-0.9, 5.6, 24> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z rotate 180*y translate <-3.9, 5.6, 8> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z rotate 180*y translate <-3.9, 5.6, 16> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z rotate 180*y translate <-3.9, -2.4, 0> }
        object { llogo() scale <0.65, 0.65, 0.65> rotate -90*z rotate 180*y translate <-3.9, -2.4, 24> }
      #end
      texture { color_tex }
      bounded_by { box { <-5.7, -6.4, -4> <4, 11.3, 28> } }
    }
  #end
#end
#macro w_pulley(color_tex)
  #if (setting = 0)
    cylinder { -2.5*z, 26.5*z, 3 texture { color_tex } }
  #else
    difference {
      merge {
        cylinder { -2.5*z, 26.5*z, 3 }
        cone { -2.500001*z, 6.2, -1.7*z, 7.000001 }
        cylinder { -1.700001*z, -0.3*z, 7 }
        cone { 25.7*z, 7.000001, 26.500001*z, 6.2 }
        cylinder { 24.3*z, 25.700001*z, 7 }
      }
      cylinder { -4*y, 4*y, 1.25 translate <0, 0, 1> }
      #local counter = 0;
      #while (counter < 46)
        box { <-0.5, -0.5, -4> <0.5, 2, 29> rotate 45*z translate <0, 7.5, 0> rotate (counter*8)*z }
        #local counter = counter + 1;
      #end
      cylinder { -4*x, 4*x, 0.9 translate <0, 0, 2> }
      cylinder { -4*x, 4*x, 0.9 translate <0, 0, 22> }
      cylinder { -4*z, 28*z, 1.75 }
      texture { color_tex }
      bounded_by { cylinder { -2.6*z, 26.6*z, 7.1 } }
    }
  #end
#end
#macro w_wheelbase2_2(color_tex)
  #if (setting = 0)
    merge {
      cylinder { -14*z, 22*z, 1.5 translate <4, 0.95, 0> }
      box { <-3.9, -3.2, -8> <11.900001, 3.1, 16> }
      texture { color_tex }
    }
  #else
    merge {
      difference {
        merge {
          box { <-3.9, -3.2, -3.900003> <11.900001, -0.1, 11.900003> }
          cylinder { 15.899999*z, 17*z, 2 translate <4, 0.95, 0> }
          cylinder { -7.899999*z, -9*z, 2 translate <4, 0.95, 0> }
          box { <2.000001, -1.049999, 15.899998> <5.99999, 1.050001, 16.999999> }
          box { <2.000001, -1.049999, -8.999999> <5.99999, 1.050001, -7.899998> }
          #if (setting < 3)
            cylinder { -0.1*y, 1.8*y, 2.4 }
            cylinder { -0.1*y, 1.8*y, 2.4 translate <8, 0, 0> }
            cylinder { -0.1*y, 1.8*y, 2.4 translate <0, 0, 8> }
            cylinder { -0.1*y, 1.8*y, 2.4 translate <8, 0, 8> }
          #else
            object { rounded_button() translate <0, -2.9, 0> }
            object { rounded_button() translate <8, -2.9, 0> }
            object { rounded_button() translate <0, -2.9, 8> }
            object { rounded_button() translate <8, -2.9, 8> }
          #end
          difference {
            box { <-3.899999, -3.199999, -7.9> <11.899999, 3.1, -3.9> }
            box { <-10, -10, -20> <20, 20, 0> rotate -25*y translate <11.9, 0, -4.9> }
            box { <-10, -10, -20> <20, 20, 0> rotate 25*y translate <-3.9, 0, -4.9> }
            box { <-10, -10, -20> <20, 20, 0> rotate -55*x translate <0, -3, -4.9> }
            difference {
              box { <-2.899999, 1.5, -6.9> <10.899999, 4, -2> }
              box { <-10, -10, -20> <20, 20, 0> rotate -25*y translate <11.9, 0, -3.9> }
              box { <-10, -10, -20> <20, 20, 0> rotate 25*y translate <-3.9, 0, -3.9> }
            }
            difference {
              box { <-2.899999, -4, -6.9> <10.899999, 0.9, -4.1> }
              box { <-10, -10, -20> <20, 20, 0> rotate -25*y translate <11.9, 0, -3.9> }
              box { <-10, -10, -20> <20, 20, 0> rotate 25*y translate <-3.9, 0, -3.9> }
            }
          }
          difference {
            box { <-3.899999, -3.199999, 11.9> <11.899999, 3.1, 15.9> }
            box { <-10, -10, 0> <20, 20, 20> rotate 25*y translate <11.9, 0, 12.9> }
            box { <-10, -10, 0> <20, 20, 20> rotate -25*y translate <-3.9, 0, 12.9> }
            box { <-10, -10, 0> <20, 20, 20> rotate 55*x translate <0, -3, 12.9> }
            difference {
              box { <-2.899999, -4, 12.1> <10.899999, 0.9, 14.9> }
              box { <-10, -10, 0> <20, 20, 20> rotate 25*y translate <11.9, 0, 11.9> }
              box { <-10, -10, 0> <20, 20, 20> rotate -25*y translate <-3.9, 0, 11.9> }
            }
            difference {
              box { <-2.899999, 1.5, 10> <10.899999, 4, 14.9> }
              box { <-10, -10, 0> <20, 20, 20> rotate 25*y translate <11.9, 0, 11.9> }
              box { <-10, -10, 0> <20, 20, 20> rotate -25*y translate <-3.9, 0, 11.9> }
            }
          }
        }
        box { <-10, -10, -10> <10, 0, 20> rotate 28*z translate <11.9, -1.1, 0> }
        box { <-10, -10, -10> <10, 0, 20> rotate -28*z translate <-3.9, -1.1, 0> }
        #if (setting > 1)
          box { <-5, -4, -2.4> <13, -1.1, 10.4> }
          cylinder { -4*y, 1*y, 2.600001 translate <4, 0, 4> }
          cylinder { -5*y, 1*y, 1.2 }
          cylinder { -5*y, 1*y, 1.2 translate <8, 0, 0> }
          cylinder { -5*y, 1*y, 1.2 translate <0, 0, 8> }
          cylinder { -5*y, 1*y, 1.2 translate <8, 0, 8> }
        #end
      }
      #if (setting > 1)
        object { ring() translate <4, -3.2, 4> }
        box { <3.5, -3.200001, -3> <4.5, -0.9, 1> }
        box { <3.5, -3.200001, 7> <4.5, -0.9, 11> }
      #end
      difference {
        merge {
          cylinder { 12*z, 21.9*z, 1.5 }
          cylinder { 21*z, 21.999991*z, 1.75 }
        }
        box { <-0.4, -3, 18.999999> <0.4, 3, 23> }
        cylinder { -3*y, 3*y, 0.4 translate <0, 0, 19> }
        translate <4, 0.95, 0>
      }
      difference {
        merge {
          cylinder { -4*z, -13.9*z, 1.5 }
          cylinder { -13.3*z, -13.999991*z, 1.75 }
        }
        box { <-0.4, -3, -10.999999> <0.4, 3, -15> }
        cylinder { -3*y, 3*y, 0.4 translate <0, 0, -11> }
        translate <4, 0.95, 0>
      }
      texture { color_tex }
      bounded_by { box { <-4, -3.3, -14.1> <12, 3.2, 22.1> } }
    }
  #end
#end
